/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00hf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|hf) integrals */

void d12hrr_order_00hf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][8][11] = int_stack + 0;
 Libderiv->deriv_classes[0][8][10] = int_stack + 45;
 Libderiv->deriv_classes[0][8][9] = int_stack + 90;
 Libderiv->deriv_classes[0][8][8] = int_stack + 135;
 Libderiv->deriv_classes[0][8][7] = int_stack + 180;
 Libderiv->dvrr_classes[0][7] = int_stack + 225;
 Libderiv->deriv_classes[0][8][6] = int_stack + 261;
 Libderiv->deriv_classes[0][8][2] = int_stack + 306;
 Libderiv->deriv_classes[0][8][1] = int_stack + 351;
 Libderiv->deriv_classes[0][8][0] = int_stack + 396;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 441;
 Libderiv->deriv2_classes[0][6][143] = int_stack + 462;
 Libderiv->deriv2_classes[0][7][143] = int_stack + 490;
 Libderiv->deriv2_classes[0][8][143] = int_stack + 526;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 571;
 Libderiv->deriv2_classes[0][6][131] = int_stack + 592;
 Libderiv->deriv2_classes[0][7][131] = int_stack + 620;
 Libderiv->deriv2_classes[0][8][131] = int_stack + 656;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 701;
 Libderiv->deriv2_classes[0][6][130] = int_stack + 722;
 Libderiv->deriv2_classes[0][7][130] = int_stack + 750;
 Libderiv->deriv2_classes[0][8][130] = int_stack + 786;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 831;
 Libderiv->deriv2_classes[0][6][119] = int_stack + 852;
 Libderiv->deriv2_classes[0][7][119] = int_stack + 880;
 Libderiv->deriv2_classes[0][8][119] = int_stack + 916;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 961;
 Libderiv->deriv2_classes[0][6][118] = int_stack + 982;
 Libderiv->deriv2_classes[0][7][118] = int_stack + 1010;
 Libderiv->deriv2_classes[0][8][118] = int_stack + 1046;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 1091;
 Libderiv->deriv2_classes[0][6][117] = int_stack + 1112;
 Libderiv->deriv2_classes[0][7][117] = int_stack + 1140;
 Libderiv->deriv2_classes[0][8][117] = int_stack + 1176;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 1221;
 Libderiv->deriv2_classes[0][6][107] = int_stack + 1242;
 Libderiv->deriv2_classes[0][7][107] = int_stack + 1270;
 Libderiv->deriv2_classes[0][8][107] = int_stack + 1306;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 1351;
 Libderiv->deriv2_classes[0][6][106] = int_stack + 1372;
 Libderiv->deriv2_classes[0][7][106] = int_stack + 1400;
 Libderiv->deriv2_classes[0][8][106] = int_stack + 1436;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 1481;
 Libderiv->deriv2_classes[0][6][105] = int_stack + 1502;
 Libderiv->deriv2_classes[0][7][105] = int_stack + 1530;
 Libderiv->deriv2_classes[0][8][105] = int_stack + 1566;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 1611;
 Libderiv->deriv2_classes[0][6][104] = int_stack + 1632;
 Libderiv->deriv2_classes[0][7][104] = int_stack + 1660;
 Libderiv->deriv2_classes[0][8][104] = int_stack + 1696;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 1741;
 Libderiv->deriv2_classes[0][6][95] = int_stack + 1762;
 Libderiv->deriv2_classes[0][7][95] = int_stack + 1790;
 Libderiv->deriv2_classes[0][8][95] = int_stack + 1826;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 1871;
 Libderiv->deriv2_classes[0][6][94] = int_stack + 1892;
 Libderiv->deriv2_classes[0][7][94] = int_stack + 1920;
 Libderiv->deriv2_classes[0][8][94] = int_stack + 1956;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 2001;
 Libderiv->deriv2_classes[0][6][93] = int_stack + 2022;
 Libderiv->deriv2_classes[0][7][93] = int_stack + 2050;
 Libderiv->deriv2_classes[0][8][93] = int_stack + 2086;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 2131;
 Libderiv->deriv2_classes[0][6][92] = int_stack + 2152;
 Libderiv->deriv2_classes[0][7][92] = int_stack + 2180;
 Libderiv->deriv2_classes[0][8][92] = int_stack + 2216;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 2261;
 Libderiv->deriv2_classes[0][6][91] = int_stack + 2282;
 Libderiv->deriv2_classes[0][7][91] = int_stack + 2310;
 Libderiv->deriv2_classes[0][8][91] = int_stack + 2346;
 Libderiv->deriv_classes[0][5][11] = int_stack + 2391;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 2412;
 Libderiv->deriv_classes[0][6][11] = int_stack + 2433;
 Libderiv->deriv2_classes[0][6][83] = int_stack + 2461;
 Libderiv->deriv_classes[0][7][11] = int_stack + 2489;
 Libderiv->deriv2_classes[0][7][83] = int_stack + 2525;
 Libderiv->deriv2_classes[0][8][83] = int_stack + 2561;
 Libderiv->deriv_classes[0][5][10] = int_stack + 2606;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 2627;
 Libderiv->deriv_classes[0][6][10] = int_stack + 2648;
 Libderiv->deriv2_classes[0][6][82] = int_stack + 2676;
 Libderiv->deriv_classes[0][7][10] = int_stack + 2704;
 Libderiv->deriv2_classes[0][7][82] = int_stack + 2740;
 Libderiv->deriv2_classes[0][8][82] = int_stack + 2776;
 Libderiv->deriv_classes[0][5][9] = int_stack + 2821;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 2842;
 Libderiv->deriv_classes[0][6][9] = int_stack + 2863;
 Libderiv->deriv2_classes[0][6][81] = int_stack + 2891;
 Libderiv->deriv_classes[0][7][9] = int_stack + 2919;
 Libderiv->deriv2_classes[0][7][81] = int_stack + 2955;
 Libderiv->deriv2_classes[0][8][81] = int_stack + 2991;
 Libderiv->deriv_classes[0][5][8] = int_stack + 3036;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 3057;
 Libderiv->deriv_classes[0][6][8] = int_stack + 3078;
 Libderiv->deriv2_classes[0][6][80] = int_stack + 3106;
 Libderiv->deriv_classes[0][7][8] = int_stack + 3134;
 Libderiv->deriv2_classes[0][7][80] = int_stack + 3170;
 Libderiv->deriv2_classes[0][8][80] = int_stack + 3206;
 Libderiv->deriv_classes[0][5][7] = int_stack + 3251;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 3272;
 Libderiv->deriv_classes[0][6][7] = int_stack + 3293;
 Libderiv->deriv2_classes[0][6][79] = int_stack + 3321;
 Libderiv->deriv_classes[0][7][7] = int_stack + 3349;
 Libderiv->deriv2_classes[0][7][79] = int_stack + 3385;
 Libderiv->deriv2_classes[0][8][79] = int_stack + 3421;
 Libderiv->dvrr_classes[0][5] = int_stack + 3466;
 Libderiv->deriv_classes[0][5][6] = int_stack + 3487;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 3508;
 Libderiv->dvrr_classes[0][6] = int_stack + 3529;
 Libderiv->deriv_classes[0][6][6] = int_stack + 3557;
 Libderiv->deriv2_classes[0][6][78] = int_stack + 3585;
 Libderiv->deriv_classes[0][7][6] = int_stack + 3613;
 Libderiv->deriv2_classes[0][7][78] = int_stack + 3649;
 Libderiv->deriv2_classes[0][8][78] = int_stack + 3685;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 3730;
 Libderiv->deriv2_classes[0][6][35] = int_stack + 3751;
 Libderiv->deriv2_classes[0][7][35] = int_stack + 3779;
 Libderiv->deriv2_classes[0][8][35] = int_stack + 3815;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 3860;
 Libderiv->deriv2_classes[0][6][34] = int_stack + 3881;
 Libderiv->deriv2_classes[0][7][34] = int_stack + 3909;
 Libderiv->deriv2_classes[0][8][34] = int_stack + 3945;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 3990;
 Libderiv->deriv2_classes[0][6][33] = int_stack + 4011;
 Libderiv->deriv2_classes[0][7][33] = int_stack + 4039;
 Libderiv->deriv2_classes[0][8][33] = int_stack + 4075;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 4120;
 Libderiv->deriv2_classes[0][6][32] = int_stack + 4141;
 Libderiv->deriv2_classes[0][7][32] = int_stack + 4169;
 Libderiv->deriv2_classes[0][8][32] = int_stack + 4205;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 4250;
 Libderiv->deriv2_classes[0][6][31] = int_stack + 4271;
 Libderiv->deriv2_classes[0][7][31] = int_stack + 4299;
 Libderiv->deriv2_classes[0][8][31] = int_stack + 4335;
 Libderiv->deriv_classes[0][5][2] = int_stack + 4380;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 4401;
 Libderiv->deriv_classes[0][6][2] = int_stack + 4422;
 Libderiv->deriv2_classes[0][6][30] = int_stack + 4450;
 Libderiv->deriv_classes[0][7][2] = int_stack + 4478;
 Libderiv->deriv2_classes[0][7][30] = int_stack + 4514;
 Libderiv->deriv2_classes[0][8][30] = int_stack + 4550;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 4595;
 Libderiv->deriv2_classes[0][6][26] = int_stack + 4616;
 Libderiv->deriv2_classes[0][7][26] = int_stack + 4644;
 Libderiv->deriv2_classes[0][8][26] = int_stack + 4680;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 4725;
 Libderiv->deriv2_classes[0][6][23] = int_stack + 4746;
 Libderiv->deriv2_classes[0][7][23] = int_stack + 4774;
 Libderiv->deriv2_classes[0][8][23] = int_stack + 4810;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 4855;
 Libderiv->deriv2_classes[0][6][22] = int_stack + 4876;
 Libderiv->deriv2_classes[0][7][22] = int_stack + 4904;
 Libderiv->deriv2_classes[0][8][22] = int_stack + 4940;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 4985;
 Libderiv->deriv2_classes[0][6][21] = int_stack + 5006;
 Libderiv->deriv2_classes[0][7][21] = int_stack + 5034;
 Libderiv->deriv2_classes[0][8][21] = int_stack + 5070;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 5115;
 Libderiv->deriv2_classes[0][6][20] = int_stack + 5136;
 Libderiv->deriv2_classes[0][7][20] = int_stack + 5164;
 Libderiv->deriv2_classes[0][8][20] = int_stack + 5200;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 5245;
 Libderiv->deriv2_classes[0][6][19] = int_stack + 5266;
 Libderiv->deriv2_classes[0][7][19] = int_stack + 5294;
 Libderiv->deriv2_classes[0][8][19] = int_stack + 5330;
 Libderiv->deriv_classes[0][5][1] = int_stack + 5375;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 5396;
 Libderiv->deriv_classes[0][6][1] = int_stack + 5417;
 Libderiv->deriv2_classes[0][6][18] = int_stack + 5445;
 Libderiv->deriv_classes[0][7][1] = int_stack + 5473;
 Libderiv->deriv2_classes[0][7][18] = int_stack + 5509;
 Libderiv->deriv2_classes[0][8][18] = int_stack + 5545;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 5590;
 Libderiv->deriv2_classes[0][6][14] = int_stack + 5611;
 Libderiv->deriv2_classes[0][7][14] = int_stack + 5639;
 Libderiv->deriv2_classes[0][8][14] = int_stack + 5675;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 5720;
 Libderiv->deriv2_classes[0][6][13] = int_stack + 5741;
 Libderiv->deriv2_classes[0][7][13] = int_stack + 5769;
 Libderiv->deriv2_classes[0][8][13] = int_stack + 5805;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 5850;
 Libderiv->deriv2_classes[0][6][11] = int_stack + 5871;
 Libderiv->deriv2_classes[0][7][11] = int_stack + 5899;
 Libderiv->deriv2_classes[0][8][11] = int_stack + 5935;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 5980;
 Libderiv->deriv2_classes[0][6][10] = int_stack + 6001;
 Libderiv->deriv2_classes[0][7][10] = int_stack + 6029;
 Libderiv->deriv2_classes[0][8][10] = int_stack + 6065;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 6110;
 Libderiv->deriv2_classes[0][6][9] = int_stack + 6131;
 Libderiv->deriv2_classes[0][7][9] = int_stack + 6159;
 Libderiv->deriv2_classes[0][8][9] = int_stack + 6195;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 6240;
 Libderiv->deriv2_classes[0][6][8] = int_stack + 6261;
 Libderiv->deriv2_classes[0][7][8] = int_stack + 6289;
 Libderiv->deriv2_classes[0][8][8] = int_stack + 6325;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 6370;
 Libderiv->deriv2_classes[0][6][7] = int_stack + 6391;
 Libderiv->deriv2_classes[0][7][7] = int_stack + 6419;
 Libderiv->deriv2_classes[0][8][7] = int_stack + 6455;
 Libderiv->deriv_classes[0][5][0] = int_stack + 6500;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 6521;
 Libderiv->deriv_classes[0][6][0] = int_stack + 6542;
 Libderiv->deriv2_classes[0][6][6] = int_stack + 6570;
 Libderiv->deriv_classes[0][7][0] = int_stack + 6598;
 Libderiv->deriv2_classes[0][7][6] = int_stack + 6634;
 Libderiv->deriv2_classes[0][8][6] = int_stack + 6670;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 6715;
 Libderiv->deriv2_classes[0][6][2] = int_stack + 6736;
 Libderiv->deriv2_classes[0][7][2] = int_stack + 6764;
 Libderiv->deriv2_classes[0][8][2] = int_stack + 6800;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 6845;
 Libderiv->deriv2_classes[0][6][1] = int_stack + 6866;
 Libderiv->deriv2_classes[0][7][1] = int_stack + 6894;
 Libderiv->deriv2_classes[0][8][1] = int_stack + 6930;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 6975;
 Libderiv->deriv2_classes[0][6][0] = int_stack + 6996;
 Libderiv->deriv2_classes[0][7][0] = int_stack + 7024;
 Libderiv->deriv2_classes[0][8][0] = int_stack + 7060;
 memset(int_stack,0,56840);

 Libderiv->dvrr_stack = int_stack + 17719;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00hf(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7105,int_stack+3529,int_stack+3466,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7168,int_stack+225,int_stack+3529,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7252,int_stack+7168,int_stack+7105,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7378,int_stack+2433,int_stack+2391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3466,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7441,int_stack+2489,int_stack+2433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3529,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7525,int_stack+7441,int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7651,int_stack+0,int_stack+2489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7759,int_stack+7651,int_stack+7441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7168,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7651,int_stack+2648,int_stack+2606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3466, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7927,int_stack+2704,int_stack+2648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3529, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8011,int_stack+7927,int_stack+7651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8137,int_stack+45,int_stack+2704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8245,int_stack+8137,int_stack+7927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7168, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8137,int_stack+2863,int_stack+2821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3466, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2919,int_stack+2863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3529, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8413,int_stack+0,int_stack+8137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8539,int_stack+90,int_stack+2919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8647,int_stack+8539,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7168, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8539,int_stack+3078,int_stack+3036, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+3134,int_stack+3078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8899,int_stack+8815,int_stack+8539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9025,int_stack+135,int_stack+3134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9133,int_stack+9025,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9025,int_stack+3293,int_stack+3251, 0.0, zero_stack, 1.0, int_stack+3466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84,int_stack+3349,int_stack+3293, 0.0, zero_stack, 1.0, int_stack+3529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9301,int_stack+84,int_stack+9025, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+180,int_stack+3349, 0.0, zero_stack, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9535,int_stack+9427,int_stack+84, 0.0, zero_stack, 1.0, int_stack+7168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9427,int_stack+3557,int_stack+3487, 1.0, int_stack+3466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+3613,int_stack+3557, 1.0, int_stack+3529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9787,int_stack+9703,int_stack+9427, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+261,int_stack+3613, 1.0, int_stack+225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10021,int_stack+9913,int_stack+9703, 1.0, int_stack+7168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9913,int_stack+4422,int_stack+4380,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7105,int_stack+4478,int_stack+4422,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+168,int_stack+7105,int_stack+9913,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+306,int_stack+4478,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+10297,int_stack+10189,int_stack+7105,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7189,int_stack+5417,int_stack+5375,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10189,int_stack+5473,int_stack+5417,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+10465,int_stack+10189,int_stack+7189,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10591,int_stack+351,int_stack+5473,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+10699,int_stack+10591,int_stack+10189,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+10591,int_stack+6542,int_stack+6500,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+294,int_stack+6598,int_stack+6542,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+10867,int_stack+294,int_stack+10591,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+396,int_stack+6598,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+11101,int_stack+10993,int_stack+294,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+462,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2391,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+490,int_stack+462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2433,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11269,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7378,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+378,int_stack+526,int_stack+490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2489,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11395,int_stack+378,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7441,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+592,int_stack+571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2391, 1.0, int_stack+2606,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+620,int_stack+592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2433, 1.0, int_stack+2648,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+462,int_stack+378,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378, 1.0, int_stack+7651,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+656,int_stack+620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2489, 1.0, int_stack+2704,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11563,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7441, 1.0, int_stack+7927,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+722,int_stack+701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2606, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+750,int_stack+722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2648, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7651, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+786,int_stack+750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2704, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+11839,int_stack+11731,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7927, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+852,int_stack+831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2391, 0.0, zero_stack, 1.0, int_stack+2821,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+880,int_stack+852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2433, 0.0, zero_stack, 1.0, int_stack+2863,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+714,int_stack+378,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack, 1.0, int_stack+8137,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+916,int_stack+880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2489, 0.0, zero_stack, 1.0, int_stack+2919,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12007,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7441, 0.0, zero_stack, 1.0, int_stack+0,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+982,int_stack+961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2606, 1.0, int_stack+2821, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+1010,int_stack+982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2648, 1.0, int_stack+2863, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+840,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7651, 1.0, int_stack+8137, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+1046,int_stack+1010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2704, 1.0, int_stack+2919, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12175,int_stack+11731,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7927, 1.0, int_stack+0, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+1112,int_stack+1091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2821, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+1140,int_stack+1112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2863, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+966,int_stack+378,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8137, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+1176,int_stack+1140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2919, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12343,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+1242,int_stack+1221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2391, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3036,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+1270,int_stack+1242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3078,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1092,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8539,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+1306,int_stack+1270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3134,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12511,int_stack+11731,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8815,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+1372,int_stack+1351, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2606, 0.0, zero_stack, 1.0, int_stack+3036, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+1400,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2648, 0.0, zero_stack, 1.0, int_stack+3078, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1218,int_stack+378,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7651, 0.0, zero_stack, 1.0, int_stack+8539, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+1436,int_stack+1400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2704, 0.0, zero_stack, 1.0, int_stack+3134, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12679,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7927, 0.0, zero_stack, 1.0, int_stack+8815, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+1502,int_stack+1481, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2821, 1.0, int_stack+3036, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+1530,int_stack+1502, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2863, 1.0, int_stack+3078, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1344,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8137, 1.0, int_stack+8539, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+1566,int_stack+1530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2919, 1.0, int_stack+3134, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12847,int_stack+11731,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+8815, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+1632,int_stack+1611, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+1660,int_stack+1632, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1470,int_stack+378,int_stack+10993, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+1696,int_stack+1660, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13015,int_stack+10993,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+1762,int_stack+1741, 0.0, zero_stack, 1.0, int_stack+2391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3251,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+1790,int_stack+1762, 0.0, zero_stack, 1.0, int_stack+2433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3293,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1596,int_stack+10993,int_stack+378, 0.0, zero_stack, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9025,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+1826,int_stack+1790, 0.0, zero_stack, 1.0, int_stack+2489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3349,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13183,int_stack+11731,int_stack+10993, 0.0, zero_stack, 1.0, int_stack+7441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+1892,int_stack+1871, 0.0, zero_stack, 1.0, int_stack+2606, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3251, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+1920,int_stack+1892, 0.0, zero_stack, 1.0, int_stack+2648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3293, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1722,int_stack+378,int_stack+10993, 0.0, zero_stack, 1.0, int_stack+7651, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9025, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+1956,int_stack+1920, 0.0, zero_stack, 1.0, int_stack+2704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3349, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13351,int_stack+10993,int_stack+378, 0.0, zero_stack, 1.0, int_stack+7927, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+2022,int_stack+2001, 0.0, zero_stack, 1.0, int_stack+2821, 0.0, zero_stack, 1.0, int_stack+3251, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+2050,int_stack+2022, 0.0, zero_stack, 1.0, int_stack+2863, 0.0, zero_stack, 1.0, int_stack+3293, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1848,int_stack+10993,int_stack+378, 0.0, zero_stack, 1.0, int_stack+8137, 0.0, zero_stack, 1.0, int_stack+9025, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+2086,int_stack+2050, 0.0, zero_stack, 1.0, int_stack+2919, 0.0, zero_stack, 1.0, int_stack+3349, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13519,int_stack+11731,int_stack+10993, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+84, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+2152,int_stack+2131, 0.0, zero_stack, 1.0, int_stack+3036, 1.0, int_stack+3251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+2180,int_stack+2152, 0.0, zero_stack, 1.0, int_stack+3078, 1.0, int_stack+3293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1974,int_stack+378,int_stack+10993, 0.0, zero_stack, 1.0, int_stack+8539, 1.0, int_stack+9025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+2216,int_stack+2180, 0.0, zero_stack, 1.0, int_stack+3134, 1.0, int_stack+3349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13687,int_stack+10993,int_stack+378, 0.0, zero_stack, 1.0, int_stack+8815, 1.0, int_stack+84, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+2282,int_stack+2261, 0.0, zero_stack, 2.0, int_stack+3251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+2310,int_stack+2282, 0.0, zero_stack, 2.0, int_stack+3293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2100,int_stack+10993,int_stack+378, 0.0, zero_stack, 2.0, int_stack+9025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+11731,int_stack+2346,int_stack+2310, 0.0, zero_stack, 2.0, int_stack+3349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13855,int_stack+11731,int_stack+10993, 0.0, zero_stack, 2.0, int_stack+84, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10993,int_stack+2461,int_stack+2412, 1.0, int_stack+2391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3487,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+2525,int_stack+2461, 1.0, int_stack+2433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3557,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2226,int_stack+378,int_stack+10993, 1.0, int_stack+7378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9427,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10993,int_stack+2561,int_stack+2525, 1.0, int_stack+2489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3613,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2352,int_stack+10993,int_stack+378, 1.0, int_stack+7441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9703,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+2676,int_stack+2627, 1.0, int_stack+2606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3487, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10993,int_stack+2740,int_stack+2676, 1.0, int_stack+2648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3557, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7378,int_stack+10993,int_stack+378, 1.0, int_stack+7651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9427, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7651,int_stack+2776,int_stack+2740, 1.0, int_stack+2704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3613, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2520,int_stack+7651,int_stack+10993, 1.0, int_stack+7927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9703, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7927,int_stack+2891,int_stack+2842, 1.0, int_stack+2821, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3487, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+2955,int_stack+2891, 1.0, int_stack+2863, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3557, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2688,int_stack+378,int_stack+7927, 1.0, int_stack+8137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9427, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8137,int_stack+2991,int_stack+2955, 1.0, int_stack+2919, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3613, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2814,int_stack+8137,int_stack+378, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9703, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+3106,int_stack+3057, 1.0, int_stack+3036, 0.0, zero_stack, 1.0, int_stack+3487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+3170,int_stack+3106, 1.0, int_stack+3078, 0.0, zero_stack, 1.0, int_stack+3557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2982,int_stack+378,int_stack+0, 1.0, int_stack+8539, 0.0, zero_stack, 1.0, int_stack+9427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8539,int_stack+3206,int_stack+3170, 1.0, int_stack+3134, 0.0, zero_stack, 1.0, int_stack+3613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14023,int_stack+8539,int_stack+378, 1.0, int_stack+8815, 0.0, zero_stack, 1.0, int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+3321,int_stack+3272, 1.0, int_stack+3251, 1.0, int_stack+3487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+378,int_stack+3385,int_stack+3321, 1.0, int_stack+3293, 1.0, int_stack+3557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3108,int_stack+378,int_stack+8815, 1.0, int_stack+9025, 1.0, int_stack+9427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9025,int_stack+3421,int_stack+3385, 1.0, int_stack+3349, 1.0, int_stack+3613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3234,int_stack+9025,int_stack+378, 1.0, int_stack+84, 1.0, int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+3585,int_stack+3508, 2.0, int_stack+3487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+3649,int_stack+3585, 2.0, int_stack+3557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+8815,int_stack+378, 2.0, int_stack+9427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+3685,int_stack+3649, 2.0, int_stack+3613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3402,int_stack+9427,int_stack+8815, 2.0, int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+3751,int_stack+3730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4380,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+3779,int_stack+3751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4422,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3570,int_stack+8815,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9913,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+3815,int_stack+3779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4478,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14191,int_stack+9427,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+3881,int_stack+3860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4380, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+3909,int_stack+3881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4422, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3696,int_stack+9703,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9913, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+3945,int_stack+3909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4478, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3822,int_stack+9427,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+4011,int_stack+3990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+4039,int_stack+4011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4422, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14359,int_stack+8815,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9913, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+4075,int_stack+4039, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4478, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14485,int_stack+9427,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+4141,int_stack+4120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+4169,int_stack+4141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3990,int_stack+9703,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+4205,int_stack+4169, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14653,int_stack+9427,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+4271,int_stack+4250, 0.0, zero_stack, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+4299,int_stack+4271, 0.0, zero_stack, 1.0, int_stack+4422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4116,int_stack+8815,int_stack+9703, 0.0, zero_stack, 1.0, int_stack+9913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9427,int_stack+4335,int_stack+4299, 0.0, zero_stack, 1.0, int_stack+4478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14821,int_stack+9427,int_stack+8815, 0.0, zero_stack, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+4450,int_stack+4401, 1.0, int_stack+4380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+4514,int_stack+4450, 1.0, int_stack+4422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4242,int_stack+9703,int_stack+8815, 1.0, int_stack+9913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+4550,int_stack+4514, 1.0, int_stack+4478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4368,int_stack+9913,int_stack+9703, 1.0, int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7105,int_stack+4616,int_stack+4595,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+4644,int_stack+4616,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+14989,int_stack+9703,int_stack+7105,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+4680,int_stack+4644,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4536,int_stack+9913,int_stack+9703,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+4746,int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5375,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7105,int_stack+4774,int_stack+4746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5417,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15115,int_stack+7105,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7189,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+4810,int_stack+4774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15241,int_stack+9913,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10189,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7105,int_stack+4876,int_stack+4855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5375, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+4904,int_stack+4876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5417, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4704,int_stack+9703,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7189, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+4940,int_stack+4904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15409,int_stack+9913,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10189, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+5006,int_stack+4985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5375, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7105,int_stack+5034,int_stack+5006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5417, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4830,int_stack+7105,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7189, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+5070,int_stack+5034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15577,int_stack+9913,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10189, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7105,int_stack+5136,int_stack+5115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+5164,int_stack+5136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4956,int_stack+9703,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+5200,int_stack+5164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15745,int_stack+9913,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+5266,int_stack+5245, 0.0, zero_stack, 1.0, int_stack+5375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7105,int_stack+5294,int_stack+5266, 0.0, zero_stack, 1.0, int_stack+5417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5082,int_stack+7105,int_stack+9703, 0.0, zero_stack, 1.0, int_stack+7189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+5330,int_stack+5294, 0.0, zero_stack, 1.0, int_stack+5473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15913,int_stack+9913,int_stack+7105, 0.0, zero_stack, 1.0, int_stack+10189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7105,int_stack+5445,int_stack+5396, 1.0, int_stack+5375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+5509,int_stack+5445, 1.0, int_stack+5417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5208,int_stack+9703,int_stack+7105, 1.0, int_stack+7189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9913,int_stack+5545,int_stack+5509, 1.0, int_stack+5473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5334,int_stack+9913,int_stack+9703, 1.0, int_stack+10189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+10189,int_stack+5611,int_stack+5590,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+5639,int_stack+5611,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7105,int_stack+9703,int_stack+10189,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+5675,int_stack+5639,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5502,int_stack+10189,int_stack+9703,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+5741,int_stack+5720,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+5769,int_stack+5741,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+16081,int_stack+8815,int_stack+9703,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+5805,int_stack+5769,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5670,int_stack+10189,int_stack+8815,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+5871,int_stack+5850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6500,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+5899,int_stack+5871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6542,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+16207,int_stack+9703,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10591,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+5935,int_stack+5899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6598,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16333,int_stack+10189,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+6001,int_stack+5980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6500, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+6029,int_stack+6001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6542, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5838,int_stack+8815,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10591, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+6065,int_stack+6029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6598, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16501,int_stack+10189,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+6131,int_stack+6110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6500, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+6159,int_stack+6131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6542, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5964,int_stack+9703,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10591, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+6195,int_stack+6159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6598, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16669,int_stack+10189,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+6261,int_stack+6240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+6289,int_stack+6261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6090,int_stack+8815,int_stack+9703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+6325,int_stack+6289, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16837,int_stack+10189,int_stack+8815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+6391,int_stack+6370, 0.0, zero_stack, 1.0, int_stack+6500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+6419,int_stack+6391, 0.0, zero_stack, 1.0, int_stack+6542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6216,int_stack+9703,int_stack+8815, 0.0, zero_stack, 1.0, int_stack+10591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10189,int_stack+6455,int_stack+6419, 0.0, zero_stack, 1.0, int_stack+6598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17005,int_stack+10189,int_stack+9703, 0.0, zero_stack, 1.0, int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+6570,int_stack+6521, 1.0, int_stack+6500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+6634,int_stack+6570, 1.0, int_stack+6542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6342,int_stack+8815,int_stack+9703, 1.0, int_stack+10591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10591,int_stack+6670,int_stack+6634, 1.0, int_stack+6598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6468,int_stack+10591,int_stack+8815, 1.0, int_stack+294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+294,int_stack+6736,int_stack+6715,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+6764,int_stack+6736,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6636,int_stack+8815,int_stack+294,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10591,int_stack+6800,int_stack+6764,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+294,int_stack+10591,int_stack+8815,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8815,int_stack+6866,int_stack+6845,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9703,int_stack+6894,int_stack+6866,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6762,int_stack+9703,int_stack+8815,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10591,int_stack+6930,int_stack+6894,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+17173,int_stack+10591,int_stack+9703,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9703,int_stack+6996,int_stack+6975,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8815,int_stack+7024,int_stack+6996,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6888,int_stack+8815,int_stack+9703,1);
 /*--- compute (00|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10591,int_stack+7060,int_stack+7024,1);
 /*--- compute (00|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+17341,int_stack+10591,int_stack+8815,1);
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17509,int_stack+7759,int_stack+7525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7252,1);
     Libderiv->ABCD[11] = int_stack + 17509;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7651,int_stack+8245,int_stack+8011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7252, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 7651;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8137,int_stack+8647,int_stack+8413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7252, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 8137;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+8539,int_stack+9133,int_stack+8899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 8539;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9025,int_stack+9535,int_stack+9301, 0.0, zero_stack, 1.0, int_stack+7252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 9025;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9427,int_stack+10021,int_stack+9787, 1.0, int_stack+7252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 9427;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+9913,int_stack+10297,int_stack+168,1);
     Libderiv->ABCD[2] = int_stack + 9913;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+10123,int_stack+10699,int_stack+10465,1);
     Libderiv->ABCD[1] = int_stack + 10123;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+10591,int_stack+11101,int_stack+10867,1);
     Libderiv->ABCD[0] = int_stack + 10591;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10993,int_stack+11395,int_stack+11269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7525,1);
     Libderiv->ABCD[155] = int_stack + 10993;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11203,int_stack+11563,int_stack+462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7525, 1.0, int_stack+8011,1);
     Libderiv->ABCD[143] = int_stack + 11203;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11413,int_stack+11839,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8011, 0.0, zero_stack,1);
     Libderiv->ABCD[142] = int_stack + 11413;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+462,int_stack+12007,int_stack+714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7525, 0.0, zero_stack, 1.0, int_stack+8413,1);
     Libderiv->ABCD[131] = int_stack + 462;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11623,int_stack+12175,int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8011, 1.0, int_stack+8413, 0.0, zero_stack,1);
     Libderiv->ABCD[130] = int_stack + 11623;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+672,int_stack+12343,int_stack+966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8413, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[129] = int_stack + 672;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+882,int_stack+12511,int_stack+1092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8899,1);
     Libderiv->ABCD[119] = int_stack + 882;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11833,int_stack+12679,int_stack+1218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8011, 0.0, zero_stack, 1.0, int_stack+8899, 0.0, zero_stack,1);
     Libderiv->ABCD[118] = int_stack + 11833;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1092,int_stack+12847,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8413, 1.0, int_stack+8899, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[117] = int_stack + 1092;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12043,int_stack+13015,int_stack+1470, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[116] = int_stack + 12043;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1302,int_stack+13183,int_stack+1596, 0.0, zero_stack, 1.0, int_stack+7525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9301,1);
     Libderiv->ABCD[107] = int_stack + 1302;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1512,int_stack+13351,int_stack+1722, 0.0, zero_stack, 1.0, int_stack+8011, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9301, 0.0, zero_stack,1);
     Libderiv->ABCD[106] = int_stack + 1512;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12253,int_stack+13519,int_stack+1848, 0.0, zero_stack, 1.0, int_stack+8413, 0.0, zero_stack, 1.0, int_stack+9301, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[105] = int_stack + 12253;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1722,int_stack+13687,int_stack+1974, 0.0, zero_stack, 1.0, int_stack+8899, 1.0, int_stack+9301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[104] = int_stack + 1722;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12463,int_stack+13855,int_stack+2100, 0.0, zero_stack, 2.0, int_stack+9301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[103] = int_stack + 12463;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1932,int_stack+2352,int_stack+2226, 1.0, int_stack+7525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9787,1);
     Libderiv->ABCD[95] = int_stack + 1932;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2142,int_stack+2520,int_stack+7378, 1.0, int_stack+8011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9787, 0.0, zero_stack,1);
     Libderiv->ABCD[94] = int_stack + 2142;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2352,int_stack+2814,int_stack+2688, 1.0, int_stack+8413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9787, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[93] = int_stack + 2352;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2562,int_stack+14023,int_stack+2982, 1.0, int_stack+8899, 0.0, zero_stack, 1.0, int_stack+9787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[92] = int_stack + 2562;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2772,int_stack+3234,int_stack+3108, 1.0, int_stack+9301, 1.0, int_stack+9787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[91] = int_stack + 2772;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2982,int_stack+3402,int_stack+0, 2.0, int_stack+9787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[90] = int_stack + 2982;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3192,int_stack+14191,int_stack+3570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168,1);
     Libderiv->ABCD[47] = int_stack + 3192;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3402,int_stack+3822,int_stack+3696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168, 0.0, zero_stack,1);
     Libderiv->ABCD[46] = int_stack + 3402;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3612,int_stack+14485,int_stack+14359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[45] = int_stack + 3612;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7231,int_stack+14653,int_stack+3990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[44] = int_stack + 7231;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7441,int_stack+14821,int_stack+4116, 0.0, zero_stack, 1.0, int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[43] = int_stack + 7441;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+3822,int_stack+4368,int_stack+4242, 1.0, int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[42] = int_stack + 3822;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+4536,int_stack+14989,1);
     Libderiv->ABCD[38] = int_stack + 0;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4032,int_stack+15241,int_stack+15115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10465,1);
     Libderiv->ABCD[35] = int_stack + 4032;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4242,int_stack+15409,int_stack+4704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10465, 0.0, zero_stack,1);
     Libderiv->ABCD[34] = int_stack + 4242;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4452,int_stack+15577,int_stack+4830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10465, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[33] = int_stack + 4452;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4662,int_stack+15745,int_stack+4956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[32] = int_stack + 4662;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4872,int_stack+15913,int_stack+5082, 0.0, zero_stack, 1.0, int_stack+10465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[31] = int_stack + 4872;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+9637,int_stack+5334,int_stack+5208, 1.0, int_stack+10465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[30] = int_stack + 9637;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5082,int_stack+5502,int_stack+7105,1);
     Libderiv->ABCD[26] = int_stack + 5082;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5292,int_stack+5670,int_stack+16081,1);
     Libderiv->ABCD[25] = int_stack + 5292;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5502,int_stack+16333,int_stack+16207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10867,1);
     Libderiv->ABCD[23] = int_stack + 5502;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+10333,int_stack+16501,int_stack+5838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10867, 0.0, zero_stack,1);
     Libderiv->ABCD[22] = int_stack + 10333;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5712,int_stack+16669,int_stack+5964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10867, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[21] = int_stack + 5712;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7014,int_stack+16837,int_stack+6090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[20] = int_stack + 7014;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+5922,int_stack+17005,int_stack+6216, 0.0, zero_stack, 1.0, int_stack+10867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[19] = int_stack + 5922;
 /*--- compute (00|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+6132,int_stack+6468,int_stack+6342, 1.0, int_stack+10867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[18] = int_stack + 6132;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6342,int_stack+294,int_stack+6636,1);
     Libderiv->ABCD[14] = int_stack + 6342;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+6552,int_stack+17173,int_stack+6762,1);
     Libderiv->ABCD[13] = int_stack + 6552;
 /*--- compute (00|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+210,int_stack+17341,int_stack+6888,1);
     Libderiv->ABCD[12] = int_stack + 210;

}
