/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_h0h0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|h0) integrals */

void d12hrr_order_h0h0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][10] = int_stack + 441;
 Libderiv->deriv_classes[5][5][9] = int_stack + 882;
 Libderiv->deriv_classes[5][5][8] = int_stack + 1323;
 Libderiv->deriv_classes[5][5][7] = int_stack + 1764;
 Libderiv->deriv_classes[5][5][6] = int_stack + 2205;
 Libderiv->deriv_classes[5][5][2] = int_stack + 2646;
 Libderiv->deriv_classes[5][5][1] = int_stack + 3087;
 Libderiv->deriv_classes[5][5][0] = int_stack + 3528;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 3969;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 4410;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 4851;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 5292;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 5733;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 6174;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 6615;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 7056;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 7497;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 7938;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 8379;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 8820;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 9261;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 9702;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 10143;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 10584;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 11025;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 11466;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 11907;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 12348;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 12789;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 13230;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 13671;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 14112;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 14553;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 14994;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 15435;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 15876;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 16317;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 16758;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 17199;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 17640;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 18081;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 18522;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 18963;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 19404;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 19845;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 20286;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 20727;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 21168;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 21609;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 22050;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 22491;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 22932;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 23373;
 memset(int_stack,0,190512);

 Libderiv->dvrr_stack = int_stack + 23814;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_h0h0(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[11] = int_stack + 0;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[10] = int_stack + 441;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[9] = int_stack + 882;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[8] = int_stack + 1323;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[7] = int_stack + 1764;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[6] = int_stack + 2205;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[2] = int_stack + 2646;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[1] = int_stack + 3087;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[0] = int_stack + 3528;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[155] = int_stack + 3969;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[143] = int_stack + 4410;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[142] = int_stack + 4851;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[131] = int_stack + 5292;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[130] = int_stack + 5733;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[129] = int_stack + 6174;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[119] = int_stack + 6615;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[118] = int_stack + 7056;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[117] = int_stack + 7497;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[116] = int_stack + 7938;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[107] = int_stack + 8379;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[106] = int_stack + 8820;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[105] = int_stack + 9261;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[104] = int_stack + 9702;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[103] = int_stack + 10143;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[95] = int_stack + 10584;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[94] = int_stack + 11025;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[93] = int_stack + 11466;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[92] = int_stack + 11907;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[91] = int_stack + 12348;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[90] = int_stack + 12789;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[47] = int_stack + 13230;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[46] = int_stack + 13671;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[45] = int_stack + 14112;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[44] = int_stack + 14553;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[43] = int_stack + 14994;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[42] = int_stack + 15435;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[38] = int_stack + 15876;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[35] = int_stack + 16317;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[34] = int_stack + 16758;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[33] = int_stack + 17199;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[32] = int_stack + 17640;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[31] = int_stack + 18081;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[30] = int_stack + 18522;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[26] = int_stack + 18963;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[25] = int_stack + 19404;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[23] = int_stack + 19845;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[22] = int_stack + 20286;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[21] = int_stack + 20727;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[20] = int_stack + 21168;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[19] = int_stack + 21609;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[18] = int_stack + 22050;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[14] = int_stack + 22491;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[13] = int_stack + 22932;
 /*--- compute (h0|h0) ---*/
     Libderiv->ABCD[12] = int_stack + 23373;

}
