/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_d0ip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|ip) integrals */

void d1hrr_order_d0ip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][11] = int_stack + 168;
 Libderiv->deriv_classes[2][6][10] = int_stack + 384;
 Libderiv->deriv_classes[2][7][10] = int_stack + 552;
 Libderiv->deriv_classes[2][6][9] = int_stack + 768;
 Libderiv->deriv_classes[2][7][9] = int_stack + 936;
 Libderiv->deriv_classes[2][6][8] = int_stack + 1152;
 Libderiv->deriv_classes[2][7][8] = int_stack + 1320;
 Libderiv->deriv_classes[2][6][7] = int_stack + 1536;
 Libderiv->deriv_classes[2][7][7] = int_stack + 1704;
 Libderiv->dvrr_classes[2][6] = int_stack + 1920;
 Libderiv->deriv_classes[2][6][6] = int_stack + 2088;
 Libderiv->deriv_classes[2][7][6] = int_stack + 2256;
 Libderiv->deriv_classes[2][6][2] = int_stack + 2472;
 Libderiv->deriv_classes[2][7][2] = int_stack + 2640;
 Libderiv->deriv_classes[2][6][1] = int_stack + 2856;
 Libderiv->deriv_classes[2][7][1] = int_stack + 3024;
 Libderiv->deriv_classes[2][6][0] = int_stack + 3240;
 Libderiv->deriv_classes[2][7][0] = int_stack + 3408;
 memset(int_stack,0,28992);

 Libderiv->dvrr_stack = int_stack + 5136;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_d0ip(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3624,int_stack+168,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1920,6);
     Libderiv->ABCD[11] = int_stack + 3624;
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4128,int_stack+552,int_stack+384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1920, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 4128;
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+936,int_stack+768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1920, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+504,int_stack+1320,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 504;
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1008,int_stack+1704,int_stack+1536, 0.0, zero_stack, 1.0, int_stack+1920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 1008;
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4632,int_stack+2256,int_stack+2088, 1.0, int_stack+1920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 4632;
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1512,int_stack+2640,int_stack+2472,6);
     Libderiv->ABCD[2] = int_stack + 1512;
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2016,int_stack+3024,int_stack+2856,6);
     Libderiv->ABCD[1] = int_stack + 2016;
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2520,int_stack+3408,int_stack+3240,6);
     Libderiv->ABCD[0] = int_stack + 2520;

}
