/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_g0id(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|id) integrals */

void d1hrr_order_g0id(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][6][11] = int_stack + 0;
 Libderiv->deriv_classes[4][7][11] = int_stack + 420;
 Libderiv->deriv_classes[4][8][11] = int_stack + 960;
 Libderiv->deriv_classes[4][6][10] = int_stack + 1635;
 Libderiv->deriv_classes[4][7][10] = int_stack + 2055;
 Libderiv->deriv_classes[4][8][10] = int_stack + 2595;
 Libderiv->deriv_classes[4][6][9] = int_stack + 3270;
 Libderiv->deriv_classes[4][7][9] = int_stack + 3690;
 Libderiv->deriv_classes[4][8][9] = int_stack + 4230;
 Libderiv->deriv_classes[4][6][8] = int_stack + 4905;
 Libderiv->deriv_classes[4][7][8] = int_stack + 5325;
 Libderiv->deriv_classes[4][8][8] = int_stack + 5865;
 Libderiv->deriv_classes[4][6][7] = int_stack + 6540;
 Libderiv->deriv_classes[4][7][7] = int_stack + 6960;
 Libderiv->deriv_classes[4][8][7] = int_stack + 7500;
 Libderiv->dvrr_classes[4][6] = int_stack + 8175;
 Libderiv->deriv_classes[4][6][6] = int_stack + 8595;
 Libderiv->dvrr_classes[4][7] = int_stack + 9015;
 Libderiv->deriv_classes[4][7][6] = int_stack + 9555;
 Libderiv->deriv_classes[4][8][6] = int_stack + 10095;
 Libderiv->deriv_classes[4][6][2] = int_stack + 10770;
 Libderiv->deriv_classes[4][7][2] = int_stack + 11190;
 Libderiv->deriv_classes[4][8][2] = int_stack + 11730;
 Libderiv->deriv_classes[4][6][1] = int_stack + 12405;
 Libderiv->deriv_classes[4][7][1] = int_stack + 12825;
 Libderiv->deriv_classes[4][8][1] = int_stack + 13365;
 Libderiv->deriv_classes[4][6][0] = int_stack + 14040;
 Libderiv->deriv_classes[4][7][0] = int_stack + 14460;
 Libderiv->deriv_classes[4][8][0] = int_stack + 15000;
 memset(int_stack,0,125400);

 Libderiv->dvrr_stack = int_stack + 34575;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_g0id(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+15675,int_stack+9015,int_stack+8175,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16935,int_stack+420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8175,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+18195,int_stack+960,int_stack+420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9015,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2055,int_stack+1635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8175, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19815,int_stack+2595,int_stack+2055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9015, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1260,int_stack+3690,int_stack+3270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8175, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21435,int_stack+4230,int_stack+3690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9015, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2520,int_stack+5325,int_stack+4905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23055,int_stack+5865,int_stack+5325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3780,int_stack+6960,int_stack+6540, 0.0, zero_stack, 1.0, int_stack+8175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5040,int_stack+7500,int_stack+6960, 0.0, zero_stack, 1.0, int_stack+9015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6660,int_stack+9555,int_stack+8595, 1.0, int_stack+8175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+24675,int_stack+10095,int_stack+9555, 1.0, int_stack+9015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7920,int_stack+11190,int_stack+10770,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+9180,int_stack+11730,int_stack+11190,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10800,int_stack+12825,int_stack+12405,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+26295,int_stack+13365,int_stack+12825,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12060,int_stack+14460,int_stack+14040,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+27915,int_stack+15000,int_stack+14460,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29535,int_stack+18195,int_stack+16935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15675,15);
     Libderiv->ABCD[11] = int_stack + 29535;
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16935,int_stack+19815,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15675, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 16935;
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32055,int_stack+21435,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15675, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 32055;
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+23055,int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19455,int_stack+5040,int_stack+3780, 0.0, zero_stack, 1.0, int_stack+15675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 19455;
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2520,int_stack+24675,int_stack+6660, 1.0, int_stack+15675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 2520;
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5040,int_stack+9180,int_stack+7920,15);
     Libderiv->ABCD[2] = int_stack + 5040;
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7560,int_stack+26295,int_stack+10800,15);
     Libderiv->ABCD[1] = int_stack + 7560;
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+21975,int_stack+27915,int_stack+12060,15);
     Libderiv->ABCD[0] = int_stack + 21975;

}
