/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_gdi0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gd|i0) integrals */

void d1hrr_order_gdi0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][11] = int_stack + 420;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1008;
 Libderiv->deriv_classes[4][6][10] = int_stack + 1792;
 Libderiv->deriv_classes[5][6][10] = int_stack + 2212;
 Libderiv->deriv_classes[6][6][10] = int_stack + 2800;
 Libderiv->deriv_classes[4][6][9] = int_stack + 3584;
 Libderiv->deriv_classes[5][6][9] = int_stack + 4004;
 Libderiv->deriv_classes[6][6][9] = int_stack + 4592;
 Libderiv->deriv_classes[4][6][8] = int_stack + 5376;
 Libderiv->deriv_classes[5][6][8] = int_stack + 5796;
 Libderiv->deriv_classes[6][6][8] = int_stack + 6384;
 Libderiv->deriv_classes[4][6][7] = int_stack + 7168;
 Libderiv->deriv_classes[5][6][7] = int_stack + 7588;
 Libderiv->deriv_classes[6][6][7] = int_stack + 8176;
 Libderiv->deriv_classes[4][6][6] = int_stack + 8960;
 Libderiv->deriv_classes[5][6][6] = int_stack + 9380;
 Libderiv->deriv_classes[6][6][6] = int_stack + 9968;
 Libderiv->deriv_classes[4][6][2] = int_stack + 10752;
 Libderiv->deriv_classes[5][6][2] = int_stack + 11172;
 Libderiv->deriv_classes[6][6][2] = int_stack + 11760;
 Libderiv->deriv_classes[4][6][1] = int_stack + 12544;
 Libderiv->deriv_classes[5][6][1] = int_stack + 12964;
 Libderiv->deriv_classes[6][6][1] = int_stack + 13552;
 Libderiv->dvrr_classes[4][6] = int_stack + 14336;
 Libderiv->deriv_classes[4][6][0] = int_stack + 14756;
 Libderiv->dvrr_classes[5][6] = int_stack + 15176;
 Libderiv->deriv_classes[5][6][0] = int_stack + 15764;
 Libderiv->deriv_classes[6][6][0] = int_stack + 16352;
 memset(int_stack,0,137088);

 Libderiv->dvrr_stack = int_stack + 33264;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_gdi0(Libderiv, Data);
   Data++;
 }

 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+17136,int_stack+420,int_stack+0,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+18396,int_stack+1008,int_stack+420,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+0,int_stack+2212,int_stack+1792,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+20160,int_stack+2800,int_stack+2212,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1260,int_stack+4004,int_stack+3584,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+21924,int_stack+4592,int_stack+4004,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2520,int_stack+5796,int_stack+5376,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+3780,int_stack+6384,int_stack+5796,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+5544,int_stack+7588,int_stack+7168,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+23688,int_stack+8176,int_stack+7588,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+6804,int_stack+9380,int_stack+8960,28);
 /*--- compute (hp|i0) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+25452,int_stack+9968,int_stack+9380,28);
 /*--- compute (gp|i0) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+8064,int_stack+15176,int_stack+14336,28);
 /*--- compute (gp|i0) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+9324,int_stack+11172,int_stack+10752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|i0) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+27216,int_stack+11760,int_stack+11172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gp|i0) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+10584,int_stack+12964,int_stack+12544, 0.0, zero_stack, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|i0) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+28980,int_stack+13552,int_stack+12964, 0.0, zero_stack, 1.0, int_stack+15176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gp|i0) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+11844,int_stack+15764,int_stack+14756, 1.0, int_stack+14336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|i0) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+13104,int_stack+16352,int_stack+15764, 1.0, int_stack+15176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+30744,int_stack+18396,int_stack+17136,28);
     Libderiv->ABCD[11] = int_stack + 30744;
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+14868,int_stack+20160,int_stack+0,28);
     Libderiv->ABCD[10] = int_stack + 14868;
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+17388,int_stack+21924,int_stack+1260,28);
     Libderiv->ABCD[9] = int_stack + 17388;
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+0,int_stack+3780,int_stack+2520,28);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2520,int_stack+23688,int_stack+5544,28);
     Libderiv->ABCD[7] = int_stack + 2520;
 /*--- compute (gd|i0) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+19908,int_stack+25452,int_stack+6804,28);
     Libderiv->ABCD[6] = int_stack + 19908;
 /*--- compute (gd|i0) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+5040,int_stack+27216,int_stack+9324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[2] = int_stack + 5040;
 /*--- compute (gd|i0) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+22428,int_stack+28980,int_stack+10584, 0.0, zero_stack, 1.0, int_stack+8064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[1] = int_stack + 22428;
 /*--- compute (gd|i0) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+9324,int_stack+13104,int_stack+11844, 1.0, int_stack+8064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[0] = int_stack + 9324;

}
