/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hdig(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hd|ig) integrals */

void d1hrr_order_hdig(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3444;
 Libderiv->deriv_classes[6][6][11] = int_stack + 4830;
 Libderiv->deriv_classes[6][7][11] = int_stack + 5614;
 Libderiv->deriv_classes[6][8][11] = int_stack + 6622;
 Libderiv->deriv_classes[6][9][11] = int_stack + 7882;
 Libderiv->deriv_classes[6][10][11] = int_stack + 9422;
 Libderiv->deriv_classes[7][6][11] = int_stack + 11270;
 Libderiv->deriv_classes[7][7][11] = int_stack + 12278;
 Libderiv->deriv_classes[7][8][11] = int_stack + 13574;
 Libderiv->deriv_classes[7][9][11] = int_stack + 15194;
 Libderiv->deriv_classes[7][10][11] = int_stack + 17174;
 Libderiv->deriv_classes[5][6][10] = int_stack + 19550;
 Libderiv->deriv_classes[5][7][10] = int_stack + 20138;
 Libderiv->deriv_classes[5][8][10] = int_stack + 20894;
 Libderiv->deriv_classes[5][9][10] = int_stack + 21839;
 Libderiv->deriv_classes[5][10][10] = int_stack + 22994;
 Libderiv->deriv_classes[6][6][10] = int_stack + 24380;
 Libderiv->deriv_classes[6][7][10] = int_stack + 25164;
 Libderiv->deriv_classes[6][8][10] = int_stack + 26172;
 Libderiv->deriv_classes[6][9][10] = int_stack + 27432;
 Libderiv->deriv_classes[6][10][10] = int_stack + 28972;
 Libderiv->deriv_classes[7][6][10] = int_stack + 30820;
 Libderiv->deriv_classes[7][7][10] = int_stack + 31828;
 Libderiv->deriv_classes[7][8][10] = int_stack + 33124;
 Libderiv->deriv_classes[7][9][10] = int_stack + 34744;
 Libderiv->deriv_classes[7][10][10] = int_stack + 36724;
 Libderiv->deriv_classes[5][6][9] = int_stack + 39100;
 Libderiv->deriv_classes[5][7][9] = int_stack + 39688;
 Libderiv->deriv_classes[5][8][9] = int_stack + 40444;
 Libderiv->deriv_classes[5][9][9] = int_stack + 41389;
 Libderiv->deriv_classes[5][10][9] = int_stack + 42544;
 Libderiv->deriv_classes[6][6][9] = int_stack + 43930;
 Libderiv->deriv_classes[6][7][9] = int_stack + 44714;
 Libderiv->deriv_classes[6][8][9] = int_stack + 45722;
 Libderiv->deriv_classes[6][9][9] = int_stack + 46982;
 Libderiv->deriv_classes[6][10][9] = int_stack + 48522;
 Libderiv->deriv_classes[7][6][9] = int_stack + 50370;
 Libderiv->deriv_classes[7][7][9] = int_stack + 51378;
 Libderiv->deriv_classes[7][8][9] = int_stack + 52674;
 Libderiv->deriv_classes[7][9][9] = int_stack + 54294;
 Libderiv->deriv_classes[7][10][9] = int_stack + 56274;
 Libderiv->deriv_classes[5][6][8] = int_stack + 58650;
 Libderiv->deriv_classes[5][7][8] = int_stack + 59238;
 Libderiv->deriv_classes[5][8][8] = int_stack + 59994;
 Libderiv->deriv_classes[5][9][8] = int_stack + 60939;
 Libderiv->deriv_classes[5][10][8] = int_stack + 62094;
 Libderiv->deriv_classes[6][6][8] = int_stack + 63480;
 Libderiv->deriv_classes[6][7][8] = int_stack + 64264;
 Libderiv->deriv_classes[6][8][8] = int_stack + 65272;
 Libderiv->deriv_classes[6][9][8] = int_stack + 66532;
 Libderiv->deriv_classes[6][10][8] = int_stack + 68072;
 Libderiv->deriv_classes[7][6][8] = int_stack + 69920;
 Libderiv->deriv_classes[7][7][8] = int_stack + 70928;
 Libderiv->deriv_classes[7][8][8] = int_stack + 72224;
 Libderiv->deriv_classes[7][9][8] = int_stack + 73844;
 Libderiv->deriv_classes[7][10][8] = int_stack + 75824;
 Libderiv->deriv_classes[5][6][7] = int_stack + 78200;
 Libderiv->deriv_classes[5][7][7] = int_stack + 78788;
 Libderiv->deriv_classes[5][8][7] = int_stack + 79544;
 Libderiv->deriv_classes[5][9][7] = int_stack + 80489;
 Libderiv->deriv_classes[5][10][7] = int_stack + 81644;
 Libderiv->deriv_classes[6][6][7] = int_stack + 83030;
 Libderiv->deriv_classes[6][7][7] = int_stack + 83814;
 Libderiv->deriv_classes[6][8][7] = int_stack + 84822;
 Libderiv->deriv_classes[6][9][7] = int_stack + 86082;
 Libderiv->deriv_classes[6][10][7] = int_stack + 87622;
 Libderiv->deriv_classes[7][6][7] = int_stack + 89470;
 Libderiv->deriv_classes[7][7][7] = int_stack + 90478;
 Libderiv->deriv_classes[7][8][7] = int_stack + 91774;
 Libderiv->deriv_classes[7][9][7] = int_stack + 93394;
 Libderiv->deriv_classes[7][10][7] = int_stack + 95374;
 Libderiv->deriv_classes[5][6][6] = int_stack + 97750;
 Libderiv->deriv_classes[5][7][6] = int_stack + 98338;
 Libderiv->deriv_classes[5][8][6] = int_stack + 99094;
 Libderiv->deriv_classes[5][9][6] = int_stack + 100039;
 Libderiv->deriv_classes[5][10][6] = int_stack + 101194;
 Libderiv->deriv_classes[6][6][6] = int_stack + 102580;
 Libderiv->deriv_classes[6][7][6] = int_stack + 103364;
 Libderiv->deriv_classes[6][8][6] = int_stack + 104372;
 Libderiv->deriv_classes[6][9][6] = int_stack + 105632;
 Libderiv->deriv_classes[6][10][6] = int_stack + 107172;
 Libderiv->dvrr_classes[7][6] = int_stack + 109020;
 Libderiv->deriv_classes[7][6][6] = int_stack + 110028;
 Libderiv->dvrr_classes[7][7] = int_stack + 111036;
 Libderiv->deriv_classes[7][7][6] = int_stack + 112332;
 Libderiv->dvrr_classes[7][8] = int_stack + 113628;
 Libderiv->deriv_classes[7][8][6] = int_stack + 115248;
 Libderiv->dvrr_classes[7][9] = int_stack + 116868;
 Libderiv->deriv_classes[7][9][6] = int_stack + 118848;
 Libderiv->deriv_classes[7][10][6] = int_stack + 120828;
 Libderiv->deriv_classes[5][6][2] = int_stack + 123204;
 Libderiv->deriv_classes[5][7][2] = int_stack + 123792;
 Libderiv->deriv_classes[5][8][2] = int_stack + 124548;
 Libderiv->deriv_classes[5][9][2] = int_stack + 125493;
 Libderiv->deriv_classes[5][10][2] = int_stack + 126648;
 Libderiv->deriv_classes[6][6][2] = int_stack + 128034;
 Libderiv->deriv_classes[6][7][2] = int_stack + 128818;
 Libderiv->deriv_classes[6][8][2] = int_stack + 129826;
 Libderiv->deriv_classes[6][9][2] = int_stack + 131086;
 Libderiv->deriv_classes[6][10][2] = int_stack + 132626;
 Libderiv->deriv_classes[7][6][2] = int_stack + 134474;
 Libderiv->deriv_classes[7][7][2] = int_stack + 135482;
 Libderiv->deriv_classes[7][8][2] = int_stack + 136778;
 Libderiv->deriv_classes[7][9][2] = int_stack + 138398;
 Libderiv->deriv_classes[7][10][2] = int_stack + 140378;
 Libderiv->deriv_classes[5][6][1] = int_stack + 142754;
 Libderiv->deriv_classes[5][7][1] = int_stack + 143342;
 Libderiv->deriv_classes[5][8][1] = int_stack + 144098;
 Libderiv->deriv_classes[5][9][1] = int_stack + 145043;
 Libderiv->deriv_classes[5][10][1] = int_stack + 146198;
 Libderiv->deriv_classes[6][6][1] = int_stack + 147584;
 Libderiv->deriv_classes[6][7][1] = int_stack + 148368;
 Libderiv->deriv_classes[6][8][1] = int_stack + 149376;
 Libderiv->deriv_classes[6][9][1] = int_stack + 150636;
 Libderiv->deriv_classes[6][10][1] = int_stack + 152176;
 Libderiv->deriv_classes[7][6][1] = int_stack + 154024;
 Libderiv->deriv_classes[7][7][1] = int_stack + 155032;
 Libderiv->deriv_classes[7][8][1] = int_stack + 156328;
 Libderiv->deriv_classes[7][9][1] = int_stack + 157948;
 Libderiv->deriv_classes[7][10][1] = int_stack + 159928;
 Libderiv->dvrr_classes[5][6] = int_stack + 162304;
 Libderiv->dvrr_classes[5][7] = int_stack + 162892;
 Libderiv->dvrr_classes[5][8] = int_stack + 163648;
 Libderiv->dvrr_classes[5][9] = int_stack + 164593;
 Libderiv->dvrr_classes[5][10] = int_stack + 165748;
 Libderiv->deriv_classes[5][6][0] = int_stack + 167134;
 Libderiv->deriv_classes[5][7][0] = int_stack + 167722;
 Libderiv->deriv_classes[5][8][0] = int_stack + 168478;
 Libderiv->deriv_classes[5][9][0] = int_stack + 169423;
 Libderiv->deriv_classes[5][10][0] = int_stack + 170578;
 Libderiv->dvrr_classes[6][6] = int_stack + 171964;
 Libderiv->dvrr_classes[6][7] = int_stack + 172748;
 Libderiv->dvrr_classes[6][8] = int_stack + 173756;
 Libderiv->dvrr_classes[6][9] = int_stack + 175016;
 Libderiv->dvrr_classes[6][10] = int_stack + 176556;
 Libderiv->deriv_classes[6][6][0] = int_stack + 178404;
 Libderiv->deriv_classes[6][7][0] = int_stack + 179188;
 Libderiv->deriv_classes[6][8][0] = int_stack + 180196;
 Libderiv->deriv_classes[6][9][0] = int_stack + 181456;
 Libderiv->deriv_classes[6][10][0] = int_stack + 182996;
 Libderiv->deriv_classes[7][6][0] = int_stack + 184844;
 Libderiv->deriv_classes[7][7][0] = int_stack + 185852;
 Libderiv->deriv_classes[7][8][0] = int_stack + 187148;
 Libderiv->deriv_classes[7][9][0] = int_stack + 188768;
 Libderiv->deriv_classes[7][10][0] = int_stack + 190748;
 memset(int_stack,0,1544992);

 Libderiv->dvrr_stack = int_stack + 733182;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hdig(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+162892,int_stack+162304,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+194888,int_stack+163648,int_stack+162892,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+197156,int_stack+194888,int_stack+193124,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+200684,int_stack+164593,int_stack+163648,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+203519,int_stack+200684,int_stack+194888,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+208055,int_stack+203519,int_stack+197156,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+213935,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162304,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+215699,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162892,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+217967,int_stack+215699,int_stack+213935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193124,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+221495,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163648,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+224330,int_stack+221495,int_stack+215699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194888,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+228866,int_stack+224330,int_stack+217967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197156,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+213935,int_stack+3444,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164593,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+234746,int_stack+213935,int_stack+221495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200684,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+213935,int_stack+234746,int_stack+224330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203519,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+234746,int_stack+213935,int_stack+228866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208055,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+213935,int_stack+172748,int_stack+171964,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+216287,int_stack+173756,int_stack+172748,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+219311,int_stack+216287,int_stack+213935,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+224015,int_stack+175016,int_stack+173756,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+227795,int_stack+224015,int_stack+216287,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+243566,int_stack+227795,int_stack+219311,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+5614,int_stack+4830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171964,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2352,int_stack+6622,int_stack+5614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172748,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+251406,int_stack+2352,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213935,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+256110,int_stack+7882,int_stack+6622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173756,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+259890,int_stack+256110,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216287,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+259890,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219311,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+9422,int_stack+7882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175016,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+265938,int_stack+251406,int_stack+256110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224015,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+273498,int_stack+265938,int_stack+259890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227795,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+251406,int_stack+273498,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243566,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+263166,int_stack+251406,int_stack+234746,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+111036,int_stack+109020,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3024,int_stack+113628,int_stack+111036,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+233843,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+289626,int_stack+116868,int_stack+113628,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+294486,int_stack+289626,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+302262,int_stack+294486,int_stack+233843,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6912,int_stack+12278,int_stack+11270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109020,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+312342,int_stack+13574,int_stack+12278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111036,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+316230,int_stack+312342,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6912,int_stack+15194,int_stack+13574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113628,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+322278,int_stack+6912,int_stack+312342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+330054,int_stack+322278,int_stack+316230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233843,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+312342,int_stack+17174,int_stack+15194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116868,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+340134,int_stack+312342,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289626,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+349854,int_stack+340134,int_stack+322278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294486,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+312342,int_stack+349854,int_stack+330054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302262,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+327462,int_stack+312342,int_stack+251406,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251406,int_stack+20138,int_stack+19550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162304, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253170,int_stack+20894,int_stack+20138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162892, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+255438,int_stack+253170,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193124, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+258966,int_stack+21839,int_stack+20894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163648, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+312342,int_stack+258966,int_stack+253170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194888, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+316878,int_stack+312342,int_stack+255438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197156, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+22994,int_stack+21839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164593, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6912,int_stack+251406,int_stack+258966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200684, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+251406,int_stack+6912,int_stack+312342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203519, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6912,int_stack+251406,int_stack+316878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208055, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251406,int_stack+25164,int_stack+24380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171964, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253758,int_stack+26172,int_stack+25164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172748, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+256782,int_stack+253758,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213935, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+312342,int_stack+27432,int_stack+26172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173756, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+316122,int_stack+312342,int_stack+253758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216287, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15732,int_stack+316122,int_stack+256782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219311, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+28972,int_stack+27432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175016, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+362742,int_stack+251406,int_stack+312342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224015, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+251406,int_stack+362742,int_stack+316122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227795, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+312342,int_stack+251406,int_stack+15732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243566, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+362742,int_stack+312342,int_stack+6912,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6912,int_stack+31828,int_stack+30820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109020, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9936,int_stack+33124,int_stack+31828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111036, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13824,int_stack+9936,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19872,int_stack+34744,int_stack+33124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113628, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24732,int_stack+19872,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+251406,int_stack+24732,int_stack+13824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233843, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6912,int_stack+36724,int_stack+34744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116868, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+389202,int_stack+6912,int_stack+19872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289626, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6912,int_stack+389202,int_stack+24732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294486, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19872,int_stack+6912,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302262, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+389202,int_stack+19872,int_stack+312342,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+312342,int_stack+39688,int_stack+39100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162304, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314106,int_stack+40444,int_stack+39688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162892, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+316374,int_stack+314106,int_stack+312342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193124, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+319902,int_stack+41389,int_stack+40444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163648, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+322737,int_stack+319902,int_stack+314106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194888, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+251406,int_stack+322737,int_stack+316374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197156, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+312342,int_stack+42544,int_stack+41389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164593, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+257286,int_stack+312342,int_stack+319902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200684, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+312342,int_stack+257286,int_stack+322737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203519, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6912,int_stack+312342,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208055, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251406,int_stack+44714,int_stack+43930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171964, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253758,int_stack+45722,int_stack+44714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172748, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+256782,int_stack+253758,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213935, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+312342,int_stack+46982,int_stack+45722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173756, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+316122,int_stack+312342,int_stack+253758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216287, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15732,int_stack+316122,int_stack+256782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219311, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+48522,int_stack+46982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175016, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+23572,int_stack+251406,int_stack+312342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224015, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+251406,int_stack+23572,int_stack+316122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227795, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+23572,int_stack+251406,int_stack+15732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243566, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+424482,int_stack+23572,int_stack+6912,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6912,int_stack+51378,int_stack+50370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109020, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9936,int_stack+52674,int_stack+51378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111036, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13824,int_stack+9936,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+251406,int_stack+54294,int_stack+52674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113628, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35332,int_stack+251406,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+43108,int_stack+35332,int_stack+13824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233843, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6912,int_stack+56274,int_stack+54294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116868, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+12852,int_stack+6912,int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+312342,int_stack+12852,int_stack+35332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294486, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6912,int_stack+312342,int_stack+43108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302262, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+450942,int_stack+6912,int_stack+23572,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6912,int_stack+59238,int_stack+58650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8676,int_stack+59994,int_stack+59238, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10944,int_stack+8676,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14472,int_stack+60939,int_stack+59994, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+17307,int_stack+14472,int_stack+8676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21843,int_stack+17307,int_stack+10944, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6912,int_stack+62094,int_stack+60939, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+27723,int_stack+6912,int_stack+14472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6912,int_stack+27723,int_stack+17307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+27723,int_stack+6912,int_stack+21843, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6912,int_stack+64264,int_stack+63480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9264,int_stack+65272,int_stack+64264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+172748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12288,int_stack+9264,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16992,int_stack+66532,int_stack+65272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+173756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20772,int_stack+16992,int_stack+9264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+36543,int_stack+20772,int_stack+12288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6912,int_stack+68072,int_stack+66532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+175016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+44383,int_stack+6912,int_stack+16992, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6912,int_stack+44383,int_stack+20772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+251406,int_stack+6912,int_stack+36543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+36543,int_stack+251406,int_stack+27723,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63003,int_stack+70928,int_stack+69920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+66027,int_stack+72224,int_stack+70928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6912,int_stack+66027,int_stack+63003, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+12960,int_stack+73844,int_stack+72224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+17820,int_stack+12960,int_stack+66027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+63003,int_stack+17820,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6912,int_stack+75824,int_stack+73844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+25596,int_stack+6912,int_stack+12960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+312342,int_stack+25596,int_stack+17820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6912,int_stack+312342,int_stack+63003, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+486222,int_stack+6912,int_stack+251406,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251406,int_stack+78788,int_stack+78200, 0.0, zero_stack, 1.0, int_stack+162304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253170,int_stack+79544,int_stack+78788, 0.0, zero_stack, 1.0, int_stack+162892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+255438,int_stack+253170,int_stack+251406, 0.0, zero_stack, 1.0, int_stack+193124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+258966,int_stack+80489,int_stack+79544, 0.0, zero_stack, 1.0, int_stack+163648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6912,int_stack+258966,int_stack+253170, 0.0, zero_stack, 1.0, int_stack+194888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+11448,int_stack+6912,int_stack+255438, 0.0, zero_stack, 1.0, int_stack+197156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+81644,int_stack+80489, 0.0, zero_stack, 1.0, int_stack+164593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+17328,int_stack+251406,int_stack+258966, 0.0, zero_stack, 1.0, int_stack+200684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+251406,int_stack+17328,int_stack+6912, 0.0, zero_stack, 1.0, int_stack+203519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+17328,int_stack+251406,int_stack+11448, 0.0, zero_stack, 1.0, int_stack+208055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251406,int_stack+83814,int_stack+83030, 0.0, zero_stack, 1.0, int_stack+171964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253758,int_stack+84822,int_stack+83814, 0.0, zero_stack, 1.0, int_stack+172748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+256782,int_stack+253758,int_stack+251406, 0.0, zero_stack, 1.0, int_stack+213935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6912,int_stack+86082,int_stack+84822, 0.0, zero_stack, 1.0, int_stack+173756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+10692,int_stack+6912,int_stack+253758, 0.0, zero_stack, 1.0, int_stack+216287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+26148,int_stack+10692,int_stack+256782, 0.0, zero_stack, 1.0, int_stack+219311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+87622,int_stack+86082, 0.0, zero_stack, 1.0, int_stack+175016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+63003,int_stack+251406,int_stack+6912, 0.0, zero_stack, 1.0, int_stack+224015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+251406,int_stack+63003,int_stack+10692, 0.0, zero_stack, 1.0, int_stack+227795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+63003,int_stack+251406,int_stack+26148, 0.0, zero_stack, 1.0, int_stack+243566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+521502,int_stack+63003,int_stack+17328,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+251406,int_stack+90478,int_stack+89470, 0.0, zero_stack, 1.0, int_stack+109020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+254430,int_stack+91774,int_stack+90478, 0.0, zero_stack, 1.0, int_stack+111036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+74763,int_stack+254430,int_stack+251406, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+80811,int_stack+93394,int_stack+91774, 0.0, zero_stack, 1.0, int_stack+113628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6912,int_stack+80811,int_stack+254430, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+251406,int_stack+6912,int_stack+74763, 0.0, zero_stack, 1.0, int_stack+233843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+74763,int_stack+95374,int_stack+93394, 0.0, zero_stack, 1.0, int_stack+116868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+85671,int_stack+74763,int_stack+80811, 0.0, zero_stack, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+14688,int_stack+85671,int_stack+6912, 0.0, zero_stack, 1.0, int_stack+294486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+312342,int_stack+14688,int_stack+251406, 0.0, zero_stack, 1.0, int_stack+302262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+547962,int_stack+312342,int_stack+63003,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63003,int_stack+98338,int_stack+97750, 1.0, int_stack+162304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+64767,int_stack+99094,int_stack+98338, 1.0, int_stack+162892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+67035,int_stack+64767,int_stack+63003, 1.0, int_stack+193124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+70563,int_stack+100039,int_stack+99094, 1.0, int_stack+163648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+73398,int_stack+70563,int_stack+64767, 1.0, int_stack+194888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+77934,int_stack+73398,int_stack+67035, 1.0, int_stack+197156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+193124,int_stack+101194,int_stack+100039, 1.0, int_stack+164593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+63003,int_stack+193124,int_stack+70563, 1.0, int_stack+200684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+193124,int_stack+63003,int_stack+73398, 1.0, int_stack+203519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+63003,int_stack+193124,int_stack+77934, 1.0, int_stack+208055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+103364,int_stack+102580, 1.0, int_stack+171964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195476,int_stack+104372,int_stack+103364, 1.0, int_stack+172748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+71823,int_stack+195476,int_stack+193124, 1.0, int_stack+213935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+76527,int_stack+105632,int_stack+104372, 1.0, int_stack+173756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+80307,int_stack+76527,int_stack+195476, 1.0, int_stack+216287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+86355,int_stack+80307,int_stack+71823, 1.0, int_stack+219311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+71823,int_stack+107172,int_stack+105632, 1.0, int_stack+175016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+193124,int_stack+71823,int_stack+76527, 1.0, int_stack+224015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+213935,int_stack+193124,int_stack+80307, 1.0, int_stack+227795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+251406,int_stack+213935,int_stack+86355, 1.0, int_stack+243566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+71823,int_stack+251406,int_stack+63003,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63003,int_stack+112332,int_stack+110028, 1.0, int_stack+109020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+66027,int_stack+115248,int_stack+112332, 1.0, int_stack+111036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+213935,int_stack+66027,int_stack+63003, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+193124,int_stack+118848,int_stack+115248, 1.0, int_stack+113628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+98283,int_stack+193124,int_stack+66027, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+98283,int_stack+213935, 1.0, int_stack+233843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+233843,int_stack+120828,int_stack+118848, 1.0, int_stack+116868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+213935,int_stack+233843,int_stack+193124, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+10080,int_stack+213935,int_stack+98283, 1.0, int_stack+294486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+312342,int_stack+10080,int_stack+0, 1.0, int_stack+302262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+0,int_stack+312342,int_stack+251406,420);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+251406,int_stack+165748,int_stack+164593,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+254871,int_stack+251406,int_stack+200684,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+98283,int_stack+254871,int_stack+203519,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+63003,int_stack+98283,int_stack+208055,21);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+98283,int_stack+176556,int_stack+175016,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+102903,int_stack+98283,int_stack+224015,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+110463,int_stack+102903,int_stack+227795,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+251406,int_stack+110463,int_stack+243566,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+289626,int_stack+251406,int_stack+63003,420);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+98283,int_stack+123792,int_stack+123204,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+100047,int_stack+124548,int_stack+123792,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+102315,int_stack+100047,int_stack+98283,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+105843,int_stack+125493,int_stack+124548,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+108678,int_stack+105843,int_stack+100047,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+113214,int_stack+108678,int_stack+102315,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+98283,int_stack+126648,int_stack+125493,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+119094,int_stack+98283,int_stack+105843,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+98283,int_stack+119094,int_stack+108678,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+119094,int_stack+98283,int_stack+113214,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+98283,int_stack+128818,int_stack+128034,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+100635,int_stack+129826,int_stack+128818,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+103659,int_stack+100635,int_stack+98283,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+108363,int_stack+131086,int_stack+129826,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+112143,int_stack+108363,int_stack+100635,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+316086,int_stack+112143,int_stack+103659,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+98283,int_stack+132626,int_stack+131086,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+193124,int_stack+98283,int_stack+108363,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+98283,int_stack+193124,int_stack+112143,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+193124,int_stack+98283,int_stack+316086,28);
 /*--- compute (hp|ig) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+204884,int_stack+193124,int_stack+119094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+316086,int_stack+135482,int_stack+134474,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+319110,int_stack+136778,int_stack+135482,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+98283,int_stack+319110,int_stack+316086,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+104331,int_stack+138398,int_stack+136778,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+109191,int_stack+104331,int_stack+319110,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+316086,int_stack+109191,int_stack+98283,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+98283,int_stack+140378,int_stack+138398,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+116967,int_stack+98283,int_stack+104331,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+126687,int_stack+116967,int_stack+109191,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+98283,int_stack+126687,int_stack+316086,36);
 /*--- compute (ip|ig) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+583242,int_stack+98283,int_stack+193124, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+143342,int_stack+142754,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+194888,int_stack+144098,int_stack+143342,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+197156,int_stack+194888,int_stack+193124,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+200684,int_stack+145043,int_stack+144098,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+98283,int_stack+200684,int_stack+194888,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+102819,int_stack+98283,int_stack+197156,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+193124,int_stack+146198,int_stack+145043,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+108699,int_stack+193124,int_stack+200684,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+193124,int_stack+108699,int_stack+98283,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+108699,int_stack+193124,int_stack+102819,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+148368,int_stack+147584,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+195476,int_stack+149376,int_stack+148368,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+198500,int_stack+195476,int_stack+193124,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+98283,int_stack+150636,int_stack+149376,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+102063,int_stack+98283,int_stack+195476,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+117519,int_stack+102063,int_stack+198500,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+193124,int_stack+152176,int_stack+150636,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+125359,int_stack+193124,int_stack+98283,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+193124,int_stack+125359,int_stack+102063,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+125359,int_stack+193124,int_stack+117519,28);
 /*--- compute (hp|ig) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+618522,int_stack+125359,int_stack+108699, 0.0, zero_stack, 1.0, int_stack+63003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+155032,int_stack+154024,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+196148,int_stack+156328,int_stack+155032,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+137119,int_stack+196148,int_stack+193124,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+143167,int_stack+157948,int_stack+156328,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+148027,int_stack+143167,int_stack+196148,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+193124,int_stack+148027,int_stack+137119,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+137119,int_stack+159928,int_stack+157948,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+155803,int_stack+137119,int_stack+143167,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+98283,int_stack+155803,int_stack+148027,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+137119,int_stack+98283,int_stack+193124,36);
 /*--- compute (ip|ig) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+644982,int_stack+137119,int_stack+125359, 0.0, zero_stack, 1.0, int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+167722,int_stack+167134,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+194888,int_stack+168478,int_stack+167722,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+197156,int_stack+194888,int_stack+193124,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+200684,int_stack+169423,int_stack+168478,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+98283,int_stack+200684,int_stack+194888,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+102819,int_stack+98283,int_stack+197156,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+193124,int_stack+170578,int_stack+169423,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+108699,int_stack+193124,int_stack+200684,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+193124,int_stack+108699,int_stack+98283,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+108699,int_stack+193124,int_stack+102819,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+193124,int_stack+179188,int_stack+178404,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+195476,int_stack+180196,int_stack+179188,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+198500,int_stack+195476,int_stack+193124,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+98283,int_stack+181456,int_stack+180196,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+102063,int_stack+98283,int_stack+195476,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+117519,int_stack+102063,int_stack+198500,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+193124,int_stack+182996,int_stack+181456,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+125359,int_stack+193124,int_stack+98283,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+193124,int_stack+125359,int_stack+102063,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+125359,int_stack+193124,int_stack+117519,28);
 /*--- compute (hp|ig) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+137119,int_stack+125359,int_stack+108699, 1.0, int_stack+63003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+63003,int_stack+185852,int_stack+184844,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+66027,int_stack+187148,int_stack+185852,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+193124,int_stack+66027,int_stack+63003,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+199172,int_stack+188768,int_stack+187148,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+163579,int_stack+199172,int_stack+66027,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+171355,int_stack+163579,int_stack+193124,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+193124,int_stack+190748,int_stack+188768,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+181435,int_stack+193124,int_stack+199172,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+191155,int_stack+181435,int_stack+163579,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+98283,int_stack+191155,int_stack+171355,36);
 /*--- compute (ip|ig) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+163579,int_stack+98283,int_stack+125359, 1.0, int_stack+251406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+680262,int_stack+327462,int_stack+263166,420);
     Libderiv->ABCD[11] = int_stack + 680262;
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+231344,int_stack+389202,int_stack+362742,420);
     Libderiv->ABCD[10] = int_stack + 231344;
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+316086,int_stack+450942,int_stack+424482,420);
     Libderiv->ABCD[9] = int_stack + 316086;
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+369006,int_stack+486222,int_stack+36543,420);
     Libderiv->ABCD[8] = int_stack + 369006;
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+421926,int_stack+547962,int_stack+521502,420);
     Libderiv->ABCD[7] = int_stack + 421926;
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+474846,int_stack+0,int_stack+71823,420);
     Libderiv->ABCD[6] = int_stack + 474846;
 /*--- compute (hd|ig) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+0,int_stack+583242,int_stack+204884, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
     Libderiv->ABCD[2] = int_stack + 0;
 /*--- compute (hd|ig) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+52920,int_stack+644982,int_stack+618522, 0.0, zero_stack, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
     Libderiv->ABCD[1] = int_stack + 52920;
 /*--- compute (hd|ig) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+527766,int_stack+163579,int_stack+137119, 1.0, int_stack+289626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
     Libderiv->ABCD[0] = int_stack + 527766;

}
