/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hdip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hd|ip) integrals */

void d1hrr_order_hdip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[6][6][11] = int_stack + 1344;
 Libderiv->deriv_classes[6][7][11] = int_stack + 2128;
 Libderiv->deriv_classes[7][6][11] = int_stack + 3136;
 Libderiv->deriv_classes[7][7][11] = int_stack + 4144;
 Libderiv->deriv_classes[5][6][10] = int_stack + 5440;
 Libderiv->deriv_classes[5][7][10] = int_stack + 6028;
 Libderiv->deriv_classes[6][6][10] = int_stack + 6784;
 Libderiv->deriv_classes[6][7][10] = int_stack + 7568;
 Libderiv->deriv_classes[7][6][10] = int_stack + 8576;
 Libderiv->deriv_classes[7][7][10] = int_stack + 9584;
 Libderiv->deriv_classes[5][6][9] = int_stack + 10880;
 Libderiv->deriv_classes[5][7][9] = int_stack + 11468;
 Libderiv->deriv_classes[6][6][9] = int_stack + 12224;
 Libderiv->deriv_classes[6][7][9] = int_stack + 13008;
 Libderiv->deriv_classes[7][6][9] = int_stack + 14016;
 Libderiv->deriv_classes[7][7][9] = int_stack + 15024;
 Libderiv->deriv_classes[5][6][8] = int_stack + 16320;
 Libderiv->deriv_classes[5][7][8] = int_stack + 16908;
 Libderiv->deriv_classes[6][6][8] = int_stack + 17664;
 Libderiv->deriv_classes[6][7][8] = int_stack + 18448;
 Libderiv->deriv_classes[7][6][8] = int_stack + 19456;
 Libderiv->deriv_classes[7][7][8] = int_stack + 20464;
 Libderiv->deriv_classes[5][6][7] = int_stack + 21760;
 Libderiv->deriv_classes[5][7][7] = int_stack + 22348;
 Libderiv->deriv_classes[6][6][7] = int_stack + 23104;
 Libderiv->deriv_classes[6][7][7] = int_stack + 23888;
 Libderiv->deriv_classes[7][6][7] = int_stack + 24896;
 Libderiv->deriv_classes[7][7][7] = int_stack + 25904;
 Libderiv->deriv_classes[5][6][6] = int_stack + 27200;
 Libderiv->deriv_classes[5][7][6] = int_stack + 27788;
 Libderiv->deriv_classes[6][6][6] = int_stack + 28544;
 Libderiv->deriv_classes[6][7][6] = int_stack + 29328;
 Libderiv->dvrr_classes[7][6] = int_stack + 30336;
 Libderiv->deriv_classes[7][6][6] = int_stack + 31344;
 Libderiv->deriv_classes[7][7][6] = int_stack + 32352;
 Libderiv->deriv_classes[5][6][2] = int_stack + 33648;
 Libderiv->deriv_classes[5][7][2] = int_stack + 34236;
 Libderiv->deriv_classes[6][6][2] = int_stack + 34992;
 Libderiv->deriv_classes[6][7][2] = int_stack + 35776;
 Libderiv->deriv_classes[7][6][2] = int_stack + 36784;
 Libderiv->deriv_classes[7][7][2] = int_stack + 37792;
 Libderiv->deriv_classes[5][6][1] = int_stack + 39088;
 Libderiv->deriv_classes[5][7][1] = int_stack + 39676;
 Libderiv->deriv_classes[6][6][1] = int_stack + 40432;
 Libderiv->deriv_classes[6][7][1] = int_stack + 41216;
 Libderiv->deriv_classes[7][6][1] = int_stack + 42224;
 Libderiv->deriv_classes[7][7][1] = int_stack + 43232;
 Libderiv->dvrr_classes[5][6] = int_stack + 44528;
 Libderiv->dvrr_classes[5][7] = int_stack + 45116;
 Libderiv->deriv_classes[5][6][0] = int_stack + 45872;
 Libderiv->deriv_classes[5][7][0] = int_stack + 46460;
 Libderiv->dvrr_classes[6][6] = int_stack + 47216;
 Libderiv->dvrr_classes[6][7] = int_stack + 48000;
 Libderiv->deriv_classes[6][6][0] = int_stack + 49008;
 Libderiv->deriv_classes[6][7][0] = int_stack + 49792;
 Libderiv->deriv_classes[7][6][0] = int_stack + 50800;
 Libderiv->deriv_classes[7][7][0] = int_stack + 51808;
 memset(int_stack,0,424832);

 Libderiv->dvrr_stack = int_stack + 140128;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hdip(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+53104,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44528,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54868,int_stack+2128,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47216,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+57220,int_stack+54868,int_stack+53104,84);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+4144,int_stack+3136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30336,36);
 /*--- compute (ip|ip) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+62512,int_stack+0,int_stack+54868,84);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+6028,int_stack+5440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44528, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+7568,int_stack+6784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47216, 0.0, zero_stack,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+69568,int_stack+1764,int_stack+0,84);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4116,int_stack+9584,int_stack+8576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30336, 0.0, zero_stack,36);
 /*--- compute (ip|ip) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+74860,int_stack+4116,int_stack+1764,84);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+11468,int_stack+10880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44528, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+13008,int_stack+12224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47216, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+4116,int_stack+1764,int_stack+0,84);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+15024,int_stack+14016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30336, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ip) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+81916,int_stack+9408,int_stack+1764,84);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+16908,int_stack+16320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11172,int_stack+18448,int_stack+17664, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+13524,int_stack+11172,int_stack+9408,84);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+20464,int_stack+19456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ip) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+88972,int_stack+0,int_stack+11172,84);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+22348,int_stack+21760, 0.0, zero_stack, 1.0, int_stack+44528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+23888,int_stack+23104, 0.0, zero_stack, 1.0, int_stack+47216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+18816,int_stack+1764,int_stack+0,84);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+25904,int_stack+24896, 0.0, zero_stack, 1.0, int_stack+30336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ip) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+96028,int_stack+9408,int_stack+1764,84);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+27788,int_stack+27200, 1.0, int_stack+44528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11172,int_stack+29328,int_stack+28544, 1.0, int_stack+47216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+24108,int_stack+11172,int_stack+9408,84);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+32352,int_stack+31344, 1.0, int_stack+30336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ip) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+103084,int_stack+0,int_stack+11172,84);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+45116,int_stack+44528,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+48000,int_stack+47216,28);
 /*--- compute (hp|ip) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+110140,int_stack+1764,int_stack+0,84);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+47216,int_stack+34236,int_stack+33648,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+35776,int_stack+34992,28);
 /*--- compute (hp|ip) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+29400,int_stack+9408,int_stack+47216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+53104,int_stack+37792,int_stack+36784,36);
 /*--- compute (ip|ip) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+115432,int_stack+53104,int_stack+9408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+39676,int_stack+39088,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11172,int_stack+41216,int_stack+40432,28);
 /*--- compute (hp|ip) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+34692,int_stack+11172,int_stack+9408, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+53104,int_stack+43232,int_stack+42224,36);
 /*--- compute (ip|ip) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+122488,int_stack+53104,int_stack+11172, 0.0, zero_stack, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+53104,int_stack+46460,int_stack+45872,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+54868,int_stack+49792,int_stack+49008,28);
 /*--- compute (hp|ip) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+39984,int_stack+54868,int_stack+53104, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+51808,int_stack+50800,36);
 /*--- compute (ip|ip) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+45276,int_stack+9408,int_stack+54868, 1.0, int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
 /*--- compute (hd|ip) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+129544,int_stack+62512,int_stack+57220,84);
     Libderiv->ABCD[11] = int_stack + 129544;
 /*--- compute (hd|ip) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+52332,int_stack+74860,int_stack+69568,84);
     Libderiv->ABCD[10] = int_stack + 52332;
 /*--- compute (hd|ip) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+62916,int_stack+81916,int_stack+4116,84);
     Libderiv->ABCD[9] = int_stack + 62916;
 /*--- compute (hd|ip) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+0,int_stack+88972,int_stack+13524,84);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (hd|ip) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+73500,int_stack+96028,int_stack+18816,84);
     Libderiv->ABCD[7] = int_stack + 73500;
 /*--- compute (hd|ip) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+10584,int_stack+103084,int_stack+24108,84);
     Libderiv->ABCD[6] = int_stack + 10584;
 /*--- compute (hd|ip) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+84084,int_stack+115432,int_stack+29400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[2] = int_stack + 84084;
 /*--- compute (hd|ip) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+21168,int_stack+122488,int_stack+34692, 0.0, zero_stack, 1.0, int_stack+110140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[1] = int_stack + 21168;
 /*--- compute (hd|ip) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+115432,int_stack+45276,int_stack+39984, 1.0, int_stack+110140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,84);
     Libderiv->ABCD[0] = int_stack + 115432;

}
