/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hfgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hf|gg) integrals */

void d1hrr_order_hfgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][4][11] = int_stack + 0;
 Libderiv->deriv_classes[5][5][11] = int_stack + 315;
 Libderiv->deriv_classes[5][6][11] = int_stack + 756;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][8][11] = int_stack + 2100;
 Libderiv->deriv_classes[6][4][11] = int_stack + 3045;
 Libderiv->deriv_classes[6][5][11] = int_stack + 3465;
 Libderiv->deriv_classes[6][6][11] = int_stack + 4053;
 Libderiv->deriv_classes[6][7][11] = int_stack + 4837;
 Libderiv->deriv_classes[6][8][11] = int_stack + 5845;
 Libderiv->deriv_classes[7][4][11] = int_stack + 7105;
 Libderiv->deriv_classes[7][5][11] = int_stack + 7645;
 Libderiv->deriv_classes[7][6][11] = int_stack + 8401;
 Libderiv->deriv_classes[7][7][11] = int_stack + 9409;
 Libderiv->deriv_classes[7][8][11] = int_stack + 10705;
 Libderiv->deriv_classes[8][4][11] = int_stack + 12325;
 Libderiv->deriv_classes[8][5][11] = int_stack + 13000;
 Libderiv->deriv_classes[8][6][11] = int_stack + 13945;
 Libderiv->deriv_classes[8][7][11] = int_stack + 15205;
 Libderiv->deriv_classes[8][8][11] = int_stack + 16825;
 Libderiv->deriv_classes[5][4][10] = int_stack + 18850;
 Libderiv->deriv_classes[5][5][10] = int_stack + 19165;
 Libderiv->deriv_classes[5][6][10] = int_stack + 19606;
 Libderiv->deriv_classes[5][7][10] = int_stack + 20194;
 Libderiv->deriv_classes[5][8][10] = int_stack + 20950;
 Libderiv->deriv_classes[6][4][10] = int_stack + 21895;
 Libderiv->deriv_classes[6][5][10] = int_stack + 22315;
 Libderiv->deriv_classes[6][6][10] = int_stack + 22903;
 Libderiv->deriv_classes[6][7][10] = int_stack + 23687;
 Libderiv->deriv_classes[6][8][10] = int_stack + 24695;
 Libderiv->deriv_classes[7][4][10] = int_stack + 25955;
 Libderiv->deriv_classes[7][5][10] = int_stack + 26495;
 Libderiv->deriv_classes[7][6][10] = int_stack + 27251;
 Libderiv->deriv_classes[7][7][10] = int_stack + 28259;
 Libderiv->deriv_classes[7][8][10] = int_stack + 29555;
 Libderiv->deriv_classes[8][4][10] = int_stack + 31175;
 Libderiv->deriv_classes[8][5][10] = int_stack + 31850;
 Libderiv->deriv_classes[8][6][10] = int_stack + 32795;
 Libderiv->deriv_classes[8][7][10] = int_stack + 34055;
 Libderiv->deriv_classes[8][8][10] = int_stack + 35675;
 Libderiv->deriv_classes[5][4][9] = int_stack + 37700;
 Libderiv->deriv_classes[5][5][9] = int_stack + 38015;
 Libderiv->deriv_classes[5][6][9] = int_stack + 38456;
 Libderiv->deriv_classes[5][7][9] = int_stack + 39044;
 Libderiv->deriv_classes[5][8][9] = int_stack + 39800;
 Libderiv->deriv_classes[6][4][9] = int_stack + 40745;
 Libderiv->deriv_classes[6][5][9] = int_stack + 41165;
 Libderiv->deriv_classes[6][6][9] = int_stack + 41753;
 Libderiv->deriv_classes[6][7][9] = int_stack + 42537;
 Libderiv->deriv_classes[6][8][9] = int_stack + 43545;
 Libderiv->deriv_classes[7][4][9] = int_stack + 44805;
 Libderiv->deriv_classes[7][5][9] = int_stack + 45345;
 Libderiv->deriv_classes[7][6][9] = int_stack + 46101;
 Libderiv->deriv_classes[7][7][9] = int_stack + 47109;
 Libderiv->deriv_classes[7][8][9] = int_stack + 48405;
 Libderiv->deriv_classes[8][4][9] = int_stack + 50025;
 Libderiv->deriv_classes[8][5][9] = int_stack + 50700;
 Libderiv->deriv_classes[8][6][9] = int_stack + 51645;
 Libderiv->deriv_classes[8][7][9] = int_stack + 52905;
 Libderiv->deriv_classes[8][8][9] = int_stack + 54525;
 Libderiv->deriv_classes[5][4][8] = int_stack + 56550;
 Libderiv->deriv_classes[5][5][8] = int_stack + 56865;
 Libderiv->deriv_classes[5][6][8] = int_stack + 57306;
 Libderiv->deriv_classes[5][7][8] = int_stack + 57894;
 Libderiv->deriv_classes[5][8][8] = int_stack + 58650;
 Libderiv->deriv_classes[6][4][8] = int_stack + 59595;
 Libderiv->deriv_classes[6][5][8] = int_stack + 60015;
 Libderiv->deriv_classes[6][6][8] = int_stack + 60603;
 Libderiv->deriv_classes[6][7][8] = int_stack + 61387;
 Libderiv->deriv_classes[6][8][8] = int_stack + 62395;
 Libderiv->deriv_classes[7][4][8] = int_stack + 63655;
 Libderiv->deriv_classes[7][5][8] = int_stack + 64195;
 Libderiv->deriv_classes[7][6][8] = int_stack + 64951;
 Libderiv->deriv_classes[7][7][8] = int_stack + 65959;
 Libderiv->deriv_classes[7][8][8] = int_stack + 67255;
 Libderiv->deriv_classes[8][4][8] = int_stack + 68875;
 Libderiv->deriv_classes[8][5][8] = int_stack + 69550;
 Libderiv->deriv_classes[8][6][8] = int_stack + 70495;
 Libderiv->deriv_classes[8][7][8] = int_stack + 71755;
 Libderiv->deriv_classes[8][8][8] = int_stack + 73375;
 Libderiv->deriv_classes[5][4][7] = int_stack + 75400;
 Libderiv->deriv_classes[5][5][7] = int_stack + 75715;
 Libderiv->deriv_classes[5][6][7] = int_stack + 76156;
 Libderiv->deriv_classes[5][7][7] = int_stack + 76744;
 Libderiv->deriv_classes[5][8][7] = int_stack + 77500;
 Libderiv->deriv_classes[6][4][7] = int_stack + 78445;
 Libderiv->deriv_classes[6][5][7] = int_stack + 78865;
 Libderiv->deriv_classes[6][6][7] = int_stack + 79453;
 Libderiv->deriv_classes[6][7][7] = int_stack + 80237;
 Libderiv->deriv_classes[6][8][7] = int_stack + 81245;
 Libderiv->deriv_classes[7][4][7] = int_stack + 82505;
 Libderiv->deriv_classes[7][5][7] = int_stack + 83045;
 Libderiv->deriv_classes[7][6][7] = int_stack + 83801;
 Libderiv->deriv_classes[7][7][7] = int_stack + 84809;
 Libderiv->deriv_classes[7][8][7] = int_stack + 86105;
 Libderiv->deriv_classes[8][4][7] = int_stack + 87725;
 Libderiv->deriv_classes[8][5][7] = int_stack + 88400;
 Libderiv->deriv_classes[8][6][7] = int_stack + 89345;
 Libderiv->deriv_classes[8][7][7] = int_stack + 90605;
 Libderiv->deriv_classes[8][8][7] = int_stack + 92225;
 Libderiv->deriv_classes[5][4][6] = int_stack + 94250;
 Libderiv->deriv_classes[5][5][6] = int_stack + 94565;
 Libderiv->deriv_classes[5][6][6] = int_stack + 95006;
 Libderiv->deriv_classes[5][7][6] = int_stack + 95594;
 Libderiv->deriv_classes[5][8][6] = int_stack + 96350;
 Libderiv->deriv_classes[6][4][6] = int_stack + 97295;
 Libderiv->deriv_classes[6][5][6] = int_stack + 97715;
 Libderiv->deriv_classes[6][6][6] = int_stack + 98303;
 Libderiv->deriv_classes[6][7][6] = int_stack + 99087;
 Libderiv->deriv_classes[6][8][6] = int_stack + 100095;
 Libderiv->deriv_classes[7][4][6] = int_stack + 101355;
 Libderiv->deriv_classes[7][5][6] = int_stack + 101895;
 Libderiv->deriv_classes[7][6][6] = int_stack + 102651;
 Libderiv->deriv_classes[7][7][6] = int_stack + 103659;
 Libderiv->deriv_classes[7][8][6] = int_stack + 104955;
 Libderiv->dvrr_classes[8][4] = int_stack + 106575;
 Libderiv->deriv_classes[8][4][6] = int_stack + 107250;
 Libderiv->dvrr_classes[8][5] = int_stack + 107925;
 Libderiv->deriv_classes[8][5][6] = int_stack + 108870;
 Libderiv->dvrr_classes[8][6] = int_stack + 109815;
 Libderiv->deriv_classes[8][6][6] = int_stack + 111075;
 Libderiv->dvrr_classes[8][7] = int_stack + 112335;
 Libderiv->deriv_classes[8][7][6] = int_stack + 113955;
 Libderiv->deriv_classes[8][8][6] = int_stack + 115575;
 Libderiv->deriv_classes[5][4][2] = int_stack + 117600;
 Libderiv->deriv_classes[5][5][2] = int_stack + 117915;
 Libderiv->deriv_classes[5][6][2] = int_stack + 118356;
 Libderiv->deriv_classes[5][7][2] = int_stack + 118944;
 Libderiv->deriv_classes[5][8][2] = int_stack + 119700;
 Libderiv->deriv_classes[6][4][2] = int_stack + 120645;
 Libderiv->deriv_classes[6][5][2] = int_stack + 121065;
 Libderiv->deriv_classes[6][6][2] = int_stack + 121653;
 Libderiv->deriv_classes[6][7][2] = int_stack + 122437;
 Libderiv->deriv_classes[6][8][2] = int_stack + 123445;
 Libderiv->deriv_classes[7][4][2] = int_stack + 124705;
 Libderiv->deriv_classes[7][5][2] = int_stack + 125245;
 Libderiv->deriv_classes[7][6][2] = int_stack + 126001;
 Libderiv->deriv_classes[7][7][2] = int_stack + 127009;
 Libderiv->deriv_classes[7][8][2] = int_stack + 128305;
 Libderiv->deriv_classes[8][4][2] = int_stack + 129925;
 Libderiv->deriv_classes[8][5][2] = int_stack + 130600;
 Libderiv->deriv_classes[8][6][2] = int_stack + 131545;
 Libderiv->deriv_classes[8][7][2] = int_stack + 132805;
 Libderiv->deriv_classes[8][8][2] = int_stack + 134425;
 Libderiv->deriv_classes[5][4][1] = int_stack + 136450;
 Libderiv->deriv_classes[5][5][1] = int_stack + 136765;
 Libderiv->deriv_classes[5][6][1] = int_stack + 137206;
 Libderiv->deriv_classes[5][7][1] = int_stack + 137794;
 Libderiv->deriv_classes[5][8][1] = int_stack + 138550;
 Libderiv->deriv_classes[6][4][1] = int_stack + 139495;
 Libderiv->deriv_classes[6][5][1] = int_stack + 139915;
 Libderiv->deriv_classes[6][6][1] = int_stack + 140503;
 Libderiv->deriv_classes[6][7][1] = int_stack + 141287;
 Libderiv->deriv_classes[6][8][1] = int_stack + 142295;
 Libderiv->deriv_classes[7][4][1] = int_stack + 143555;
 Libderiv->deriv_classes[7][5][1] = int_stack + 144095;
 Libderiv->deriv_classes[7][6][1] = int_stack + 144851;
 Libderiv->deriv_classes[7][7][1] = int_stack + 145859;
 Libderiv->deriv_classes[7][8][1] = int_stack + 147155;
 Libderiv->deriv_classes[8][4][1] = int_stack + 148775;
 Libderiv->deriv_classes[8][5][1] = int_stack + 149450;
 Libderiv->deriv_classes[8][6][1] = int_stack + 150395;
 Libderiv->deriv_classes[8][7][1] = int_stack + 151655;
 Libderiv->deriv_classes[8][8][1] = int_stack + 153275;
 Libderiv->dvrr_classes[5][4] = int_stack + 155300;
 Libderiv->dvrr_classes[5][5] = int_stack + 155615;
 Libderiv->dvrr_classes[5][6] = int_stack + 156056;
 Libderiv->dvrr_classes[5][7] = int_stack + 156644;
 Libderiv->dvrr_classes[5][8] = int_stack + 157400;
 Libderiv->deriv_classes[5][4][0] = int_stack + 158345;
 Libderiv->deriv_classes[5][5][0] = int_stack + 158660;
 Libderiv->deriv_classes[5][6][0] = int_stack + 159101;
 Libderiv->deriv_classes[5][7][0] = int_stack + 159689;
 Libderiv->deriv_classes[5][8][0] = int_stack + 160445;
 Libderiv->dvrr_classes[6][4] = int_stack + 161390;
 Libderiv->dvrr_classes[6][5] = int_stack + 161810;
 Libderiv->dvrr_classes[6][6] = int_stack + 162398;
 Libderiv->dvrr_classes[6][7] = int_stack + 163182;
 Libderiv->dvrr_classes[6][8] = int_stack + 164190;
 Libderiv->deriv_classes[6][4][0] = int_stack + 165450;
 Libderiv->deriv_classes[6][5][0] = int_stack + 165870;
 Libderiv->deriv_classes[6][6][0] = int_stack + 166458;
 Libderiv->deriv_classes[6][7][0] = int_stack + 167242;
 Libderiv->deriv_classes[6][8][0] = int_stack + 168250;
 Libderiv->dvrr_classes[7][4] = int_stack + 169510;
 Libderiv->dvrr_classes[7][5] = int_stack + 170050;
 Libderiv->dvrr_classes[7][6] = int_stack + 170806;
 Libderiv->dvrr_classes[7][7] = int_stack + 171814;
 Libderiv->dvrr_classes[7][8] = int_stack + 173110;
 Libderiv->deriv_classes[7][4][0] = int_stack + 174730;
 Libderiv->deriv_classes[7][5][0] = int_stack + 175270;
 Libderiv->deriv_classes[7][6][0] = int_stack + 176026;
 Libderiv->deriv_classes[7][7][0] = int_stack + 177034;
 Libderiv->deriv_classes[7][8][0] = int_stack + 178330;
 Libderiv->deriv_classes[8][4][0] = int_stack + 179950;
 Libderiv->deriv_classes[8][5][0] = int_stack + 180625;
 Libderiv->deriv_classes[8][6][0] = int_stack + 181570;
 Libderiv->deriv_classes[8][7][0] = int_stack + 182830;
 Libderiv->deriv_classes[8][8][0] = int_stack + 184450;
 memset(int_stack,0,1491800);

 Libderiv->dvrr_stack = int_stack + 866215;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hfgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+186475,int_stack+155615,int_stack+155300,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+187420,int_stack+156056,int_stack+155615,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+188743,int_stack+187420,int_stack+186475,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+190633,int_stack+156644,int_stack+156056,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+192397,int_stack+190633,int_stack+187420,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+195043,int_stack+192397,int_stack+188743,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+198193,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155300,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+199138,int_stack+756,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155615,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+200461,int_stack+199138,int_stack+198193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186475,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+202351,int_stack+1344,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156056,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+204115,int_stack+202351,int_stack+199138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187420,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+206761,int_stack+204115,int_stack+200461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188743,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+198193,int_stack+2100,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156644,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+209911,int_stack+198193,int_stack+202351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190633,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+198193,int_stack+209911,int_stack+204115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192397,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+209911,int_stack+198193,int_stack+206761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195043,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+198193,int_stack+161810,int_stack+161390,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+199453,int_stack+162398,int_stack+161810,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+201217,int_stack+199453,int_stack+198193,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+203737,int_stack+163182,int_stack+162398,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+206089,int_stack+203737,int_stack+199453,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+214636,int_stack+206089,int_stack+201217,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+3465,int_stack+3045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161390,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+4053,int_stack+3465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161810,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+218836,int_stack+1260,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198193,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+221356,int_stack+4837,int_stack+4053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162398,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+223708,int_stack+221356,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199453,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+223708,int_stack+218836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201217,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+227236,int_stack+5845,int_stack+4837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163182,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+230260,int_stack+227236,int_stack+221356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203737,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+234964,int_stack+230260,int_stack+223708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206089,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+218836,int_stack+234964,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214636,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+225136,int_stack+218836,int_stack+209911,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+170050,int_stack+169510,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1620,int_stack+170806,int_stack+170050,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+209617,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3888,int_stack+171814,int_stack+170806,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+239311,int_stack+3888,int_stack+1620,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+243847,int_stack+239311,int_stack+209617,36);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+212857,int_stack+7645,int_stack+7105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169510,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+249247,int_stack+8401,int_stack+7645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170050,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+251515,int_stack+249247,int_stack+212857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+254755,int_stack+9409,int_stack+8401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170806,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+257779,int_stack+254755,int_stack+249247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+262315,int_stack+257779,int_stack+251515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209617,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+249247,int_stack+10705,int_stack+9409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171814,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+267715,int_stack+249247,int_stack+254755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+249247,int_stack+267715,int_stack+257779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239311,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+267715,int_stack+249247,int_stack+262315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243847,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+275815,int_stack+267715,int_stack+218836,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+294715,int_stack+275815,int_stack+225136,225);
 /*--- compute (l0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+218836,int_stack+107925,int_stack+106575,45);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+220861,int_stack+109815,int_stack+107925,45);
 /*--- compute (l0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+223696,int_stack+220861,int_stack+218836,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+227746,int_stack+112335,int_stack+109815,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+231526,int_stack+227746,int_stack+220861,45);
 /*--- compute (l0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+249247,int_stack+231526,int_stack+223696,45);
 /*--- compute (l0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+237196,int_stack+13000,int_stack+12325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106575,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+255997,int_stack+13945,int_stack+13000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107925,45);
 /*--- compute (l0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+258832,int_stack+255997,int_stack+237196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218836,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+262882,int_stack+15205,int_stack+13945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109815,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6912,int_stack+262882,int_stack+255997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220861,45);
 /*--- compute (l0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+323065,int_stack+6912,int_stack+258832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223696,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+255997,int_stack+16825,int_stack+15205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112335,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+329815,int_stack+255997,int_stack+262882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227746,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+255997,int_stack+329815,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231526,45);
 /*--- compute (l0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+6912,int_stack+255997,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249247,45);
 /*--- compute (kp|gg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+323065,int_stack+6912,int_stack+267715,225);
 /*--- compute (id|gg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+347365,int_stack+323065,int_stack+275815,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+19165,int_stack+18850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155300, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324010,int_stack+19606,int_stack+19165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155615, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+325333,int_stack+324010,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186475, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327223,int_stack+20194,int_stack+19606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156056, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328987,int_stack+327223,int_stack+324010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187420, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+331633,int_stack+328987,int_stack+325333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188743, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+20950,int_stack+20194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156644, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+327223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190633, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+334783,int_stack+328987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192397, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+331633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195043, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+22315,int_stack+21895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161390, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324325,int_stack+22903,int_stack+22315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161810, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326089,int_stack+324325,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198193, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+328609,int_stack+23687,int_stack+22903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162398, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+330961,int_stack+328609,int_stack+324325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199453, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+339508,int_stack+330961,int_stack+326089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201217, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+24695,int_stack+23687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163182, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6912,int_stack+323065,int_stack+328609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203737, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+6912,int_stack+330961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206089, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+6912,int_stack+323065,int_stack+339508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214636, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+255997,int_stack+6912,int_stack+334783,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+26495,int_stack+25955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169510, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324685,int_stack+27251,int_stack+26495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170050, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326953,int_stack+324685,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+330193,int_stack+28259,int_stack+27251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170806, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333217,int_stack+330193,int_stack+324685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+337753,int_stack+333217,int_stack+326953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209617, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+29555,int_stack+28259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171814, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13212,int_stack+323065,int_stack+330193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+13212,int_stack+333217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239311, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+13212,int_stack+323065,int_stack+337753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243847, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+323065,int_stack+13212,int_stack+6912,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+385165,int_stack+323065,int_stack+255997,225);
 /*--- compute (l0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+255997,int_stack+31850,int_stack+31175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106575, 0.0, zero_stack,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+258022,int_stack+32795,int_stack+31850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107925, 0.0, zero_stack,45);
 /*--- compute (l0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+260857,int_stack+258022,int_stack+255997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218836, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+264907,int_stack+34055,int_stack+32795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109815, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+268687,int_stack+264907,int_stack+258022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220861, 0.0, zero_stack,45);
 /*--- compute (l0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+274357,int_stack+268687,int_stack+260857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223696, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+255997,int_stack+35675,int_stack+34055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112335, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281107,int_stack+255997,int_stack+264907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227746, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+255997,int_stack+281107,int_stack+268687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231526, 0.0, zero_stack,45);
 /*--- compute (l0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+281107,int_stack+255997,int_stack+274357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249247, 0.0, zero_stack,45);
 /*--- compute (kp|gg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+255997,int_stack+281107,int_stack+13212,225);
 /*--- compute (id|gg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+413515,int_stack+255997,int_stack+323065,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+38015,int_stack+37700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155300, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324010,int_stack+38456,int_stack+38015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155615, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+325333,int_stack+324010,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327223,int_stack+39044,int_stack+38456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156056, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328987,int_stack+327223,int_stack+324010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187420, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+331633,int_stack+328987,int_stack+325333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188743, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+39800,int_stack+39044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156644, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+327223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190633, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+334783,int_stack+328987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192397, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+331633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195043, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+41165,int_stack+40745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161390, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324325,int_stack+41753,int_stack+41165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161810, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326089,int_stack+324325,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198193, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+328609,int_stack+42537,int_stack+41753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162398, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+330961,int_stack+328609,int_stack+324325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199453, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+339508,int_stack+330961,int_stack+326089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201217, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+43545,int_stack+42537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163182, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+255997,int_stack+323065,int_stack+328609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203737, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+255997,int_stack+330961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206089, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+255997,int_stack+323065,int_stack+339508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214636, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+262297,int_stack+255997,int_stack+334783,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+45345,int_stack+44805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169510, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324685,int_stack+46101,int_stack+45345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170050, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326953,int_stack+324685,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+330193,int_stack+47109,int_stack+46101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170806, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333217,int_stack+330193,int_stack+324685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+337753,int_stack+333217,int_stack+326953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209617, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+48405,int_stack+47109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171814, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+276472,int_stack+323065,int_stack+330193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+276472,int_stack+333217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239311, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+276472,int_stack+323065,int_stack+337753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243847, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+323065,int_stack+276472,int_stack+255997,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+6912,int_stack+323065,int_stack+262297,225);
 /*--- compute (l0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+255997,int_stack+50700,int_stack+50025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106575, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+258022,int_stack+51645,int_stack+50700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107925, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+260857,int_stack+258022,int_stack+255997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218836, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+264907,int_stack+52905,int_stack+51645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109815, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+268687,int_stack+264907,int_stack+258022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220861, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+284572,int_stack+268687,int_stack+260857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223696, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+255997,int_stack+54525,int_stack+52905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112335, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35262,int_stack+255997,int_stack+264907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227746, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+255997,int_stack+35262,int_stack+268687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231526, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+35262,int_stack+255997,int_stack+284572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249247, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|gg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+451315,int_stack+35262,int_stack+276472,225);
 /*--- compute (id|gg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+255997,int_stack+451315,int_stack+323065,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+56865,int_stack+56550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324010,int_stack+57306,int_stack+56865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+325333,int_stack+324010,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327223,int_stack+57894,int_stack+57306, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328987,int_stack+327223,int_stack+324010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+187420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+331633,int_stack+328987,int_stack+325333, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+188743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+58650,int_stack+57894, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+156644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+327223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+334783,int_stack+328987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+331633, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+60015,int_stack+59595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324325,int_stack+60603,int_stack+60015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326089,int_stack+324325,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+328609,int_stack+61387,int_stack+60603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+330961,int_stack+328609,int_stack+324325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+339508,int_stack+330961,int_stack+326089, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+62395,int_stack+61387, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+451315,int_stack+323065,int_stack+328609, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+203737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+451315,int_stack+330961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+451315,int_stack+323065,int_stack+339508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+457615,int_stack+451315,int_stack+334783,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+64195,int_stack+63655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324685,int_stack+64951,int_stack+64195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326953,int_stack+324685,int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+330193,int_stack+65959,int_stack+64951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333217,int_stack+330193,int_stack+324685, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+337753,int_stack+333217,int_stack+326953, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+67255,int_stack+65959, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35262,int_stack+323065,int_stack+330193, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+35262,int_stack+333217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+35262,int_stack+323065,int_stack+337753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+323065,int_stack+35262,int_stack+451315,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+471790,int_stack+323065,int_stack+457615,225);
 /*--- compute (l0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+451315,int_stack+69550,int_stack+68875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+453340,int_stack+70495,int_stack+69550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+456175,int_stack+453340,int_stack+451315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+460225,int_stack+71755,int_stack+70495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+464005,int_stack+460225,int_stack+453340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+43362,int_stack+464005,int_stack+456175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+451315,int_stack+73375,int_stack+71755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+50112,int_stack+451315,int_stack+460225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+451315,int_stack+50112,int_stack+464005, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+50112,int_stack+451315,int_stack+43362, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|gg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+500140,int_stack+50112,int_stack+35262,225);
 /*--- compute (id|gg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+35262,int_stack+500140,int_stack+323065,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+75715,int_stack+75400, 0.0, zero_stack, 1.0, int_stack+155300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324010,int_stack+76156,int_stack+75715, 0.0, zero_stack, 1.0, int_stack+155615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+325333,int_stack+324010,int_stack+323065, 0.0, zero_stack, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327223,int_stack+76744,int_stack+76156, 0.0, zero_stack, 1.0, int_stack+156056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328987,int_stack+327223,int_stack+324010, 0.0, zero_stack, 1.0, int_stack+187420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+331633,int_stack+328987,int_stack+325333, 0.0, zero_stack, 1.0, int_stack+188743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+77500,int_stack+76744, 0.0, zero_stack, 1.0, int_stack+156644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+327223, 0.0, zero_stack, 1.0, int_stack+190633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+334783,int_stack+328987, 0.0, zero_stack, 1.0, int_stack+192397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+331633, 0.0, zero_stack, 1.0, int_stack+195043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+78865,int_stack+78445, 0.0, zero_stack, 1.0, int_stack+161390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324325,int_stack+79453,int_stack+78865, 0.0, zero_stack, 1.0, int_stack+161810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326089,int_stack+324325,int_stack+323065, 0.0, zero_stack, 1.0, int_stack+198193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+328609,int_stack+80237,int_stack+79453, 0.0, zero_stack, 1.0, int_stack+162398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+330961,int_stack+328609,int_stack+324325, 0.0, zero_stack, 1.0, int_stack+199453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+339508,int_stack+330961,int_stack+326089, 0.0, zero_stack, 1.0, int_stack+201217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+81245,int_stack+80237, 0.0, zero_stack, 1.0, int_stack+163182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+500140,int_stack+323065,int_stack+328609, 0.0, zero_stack, 1.0, int_stack+203737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+500140,int_stack+330961, 0.0, zero_stack, 1.0, int_stack+206089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+500140,int_stack+323065,int_stack+339508, 0.0, zero_stack, 1.0, int_stack+214636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+506440,int_stack+500140,int_stack+334783,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+83045,int_stack+82505, 0.0, zero_stack, 1.0, int_stack+169510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324685,int_stack+83801,int_stack+83045, 0.0, zero_stack, 1.0, int_stack+170050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+326953,int_stack+324685,int_stack+323065, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+330193,int_stack+84809,int_stack+83801, 0.0, zero_stack, 1.0, int_stack+170806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333217,int_stack+330193,int_stack+324685, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+337753,int_stack+333217,int_stack+326953, 0.0, zero_stack, 1.0, int_stack+209617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+86105,int_stack+84809, 0.0, zero_stack, 1.0, int_stack+171814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+73062,int_stack+323065,int_stack+330193, 0.0, zero_stack, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323065,int_stack+73062,int_stack+333217, 0.0, zero_stack, 1.0, int_stack+239311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+73062,int_stack+323065,int_stack+337753, 0.0, zero_stack, 1.0, int_stack+243847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+323065,int_stack+73062,int_stack+500140,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+520615,int_stack+323065,int_stack+506440,225);
 /*--- compute (l0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+500140,int_stack+88400,int_stack+87725, 0.0, zero_stack, 1.0, int_stack+106575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+502165,int_stack+89345,int_stack+88400, 0.0, zero_stack, 1.0, int_stack+107925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+505000,int_stack+502165,int_stack+500140, 0.0, zero_stack, 1.0, int_stack+218836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+509050,int_stack+90605,int_stack+89345, 0.0, zero_stack, 1.0, int_stack+109815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+512830,int_stack+509050,int_stack+502165, 0.0, zero_stack, 1.0, int_stack+220861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+81162,int_stack+512830,int_stack+505000, 0.0, zero_stack, 1.0, int_stack+223696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500140,int_stack+92225,int_stack+90605, 0.0, zero_stack, 1.0, int_stack+112335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+451315,int_stack+500140,int_stack+509050, 0.0, zero_stack, 1.0, int_stack+227746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500140,int_stack+451315,int_stack+512830, 0.0, zero_stack, 1.0, int_stack+231526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+451315,int_stack+500140,int_stack+81162, 0.0, zero_stack, 1.0, int_stack+249247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|gg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+548965,int_stack+451315,int_stack+73062,225);
 /*--- compute (id|gg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+573265,int_stack+548965,int_stack+323065,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+94565,int_stack+94250, 1.0, int_stack+155300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324010,int_stack+95006,int_stack+94565, 1.0, int_stack+155615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+325333,int_stack+324010,int_stack+323065, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327223,int_stack+95594,int_stack+95006, 1.0, int_stack+156056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+328987,int_stack+327223,int_stack+324010, 1.0, int_stack+187420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+331633,int_stack+328987,int_stack+325333, 1.0, int_stack+188743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+186475,int_stack+96350,int_stack+95594, 1.0, int_stack+156644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+323065,int_stack+186475,int_stack+327223, 1.0, int_stack+190633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+334783,int_stack+323065,int_stack+328987, 1.0, int_stack+192397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+323065,int_stack+334783,int_stack+331633, 1.0, int_stack+195043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+327790,int_stack+97715,int_stack+97295, 1.0, int_stack+161390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+329050,int_stack+98303,int_stack+97715, 1.0, int_stack+161810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+330814,int_stack+329050,int_stack+327790, 1.0, int_stack+198193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+333334,int_stack+99087,int_stack+98303, 1.0, int_stack+162398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+335686,int_stack+333334,int_stack+329050, 1.0, int_stack+199453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+339214,int_stack+335686,int_stack+330814, 1.0, int_stack+201217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+198193,int_stack+100095,int_stack+99087, 1.0, int_stack+163182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+327790,int_stack+198193,int_stack+333334, 1.0, int_stack+203737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+548965,int_stack+327790,int_stack+335686, 1.0, int_stack+206089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+327790,int_stack+548965,int_stack+339214, 1.0, int_stack+214636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+548965,int_stack+327790,int_stack+323065,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+101895,int_stack+101355, 1.0, int_stack+169510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+324685,int_stack+102651,int_stack+101895, 1.0, int_stack+170050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+563140,int_stack+324685,int_stack+323065, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+566380,int_stack+103659,int_stack+102651, 1.0, int_stack+170806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+334090,int_stack+566380,int_stack+324685, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+338626,int_stack+334090,int_stack+563140, 1.0, int_stack+209617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+104955,int_stack+103659, 1.0, int_stack+171814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+73062,int_stack+0,int_stack+566380, 1.0, int_stack+3888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+563140,int_stack+73062,int_stack+334090, 1.0, int_stack+239311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+73062,int_stack+563140,int_stack+338626, 1.0, int_stack+243847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+81162,int_stack+73062,int_stack+327790,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+611065,int_stack+81162,int_stack+548965,225);
 /*--- compute (l0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+548965,int_stack+108870,int_stack+107250, 1.0, int_stack+106575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+550990,int_stack+111075,int_stack+108870, 1.0, int_stack+107925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553825,int_stack+550990,int_stack+548965, 1.0, int_stack+218836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557875,int_stack+113955,int_stack+111075, 1.0, int_stack+109815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+561655,int_stack+557875,int_stack+550990, 1.0, int_stack+220861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+100062,int_stack+561655,int_stack+553825, 1.0, int_stack+223696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+218836,int_stack+115575,int_stack+113955, 1.0, int_stack+112335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+548965,int_stack+218836,int_stack+557875, 1.0, int_stack+227746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+218836,int_stack+548965,int_stack+561655, 1.0, int_stack+231526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+548965,int_stack+218836,int_stack+100062, 1.0, int_stack+249247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|gg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+323065,int_stack+548965,int_stack+73062,225);
 /*--- compute (id|gg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+639415,int_stack+323065,int_stack+81162,225);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+157400,int_stack+156644,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+325333,int_stack+323065,int_stack+190633,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+328861,int_stack+325333,int_stack+192397,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+323065,int_stack+328861,int_stack+195043,21);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+327790,int_stack+164190,int_stack+163182,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+330814,int_stack+327790,int_stack+203737,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+335518,int_stack+330814,int_stack+206089,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+327790,int_stack+335518,int_stack+214636,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+73062,int_stack+327790,int_stack+323065,225);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+173110,int_stack+171814,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+334090,int_stack+0,int_stack+3888,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+87237,int_stack+334090,int_stack+239311,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+334090,int_stack+87237,int_stack+243847,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+87237,int_stack+334090,int_stack+327790,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+186475,int_stack+87237,int_stack+73062,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+106137,int_stack+117915,int_stack+117600,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+107082,int_stack+118356,int_stack+117915,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+108405,int_stack+107082,int_stack+106137,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+110295,int_stack+118944,int_stack+118356,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+112059,int_stack+110295,int_stack+107082,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+114705,int_stack+112059,int_stack+108405,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+106137,int_stack+119700,int_stack+118944,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+342190,int_stack+106137,int_stack+110295,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+106137,int_stack+342190,int_stack+112059,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+342190,int_stack+106137,int_stack+114705,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+106137,int_stack+121065,int_stack+120645,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+107397,int_stack+121653,int_stack+121065,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+109161,int_stack+107397,int_stack+106137,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+111681,int_stack+122437,int_stack+121653,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+114033,int_stack+111681,int_stack+107397,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+117561,int_stack+114033,int_stack+109161,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+106137,int_stack+123445,int_stack+122437,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+106137,int_stack+111681,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+106137,int_stack+0,int_stack+114033,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+106137,int_stack+117561,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+106137,int_stack+0,int_stack+342190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+342190,int_stack+125245,int_stack+124705,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+343810,int_stack+126001,int_stack+125245,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+120312,int_stack+343810,int_stack+342190,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+548965,int_stack+127009,int_stack+126001,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+551989,int_stack+548965,int_stack+343810,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+556525,int_stack+551989,int_stack+120312,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+120312,int_stack+128305,int_stack+127009,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+561925,int_stack+120312,int_stack+548965,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+120312,int_stack+561925,int_stack+551989,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+561925,int_stack+120312,int_stack+556525,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+214825,int_stack+561925,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+677215,int_stack+214825,int_stack+106137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (l0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+106137,int_stack+130600,int_stack+129925,45);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+108162,int_stack+131545,int_stack+130600,45);
 /*--- compute (l0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+110997,int_stack+108162,int_stack+106137,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+115047,int_stack+132805,int_stack+131545,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+118827,int_stack+115047,int_stack+108162,45);
 /*--- compute (l0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+124497,int_stack+118827,int_stack+110997,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+106137,int_stack+134425,int_stack+132805,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+548965,int_stack+106137,int_stack+115047,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+106137,int_stack+548965,int_stack+118827,45);
 /*--- compute (l0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+548965,int_stack+106137,int_stack+124497,45);
 /*--- compute (kp|gg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+106137,int_stack+548965,int_stack+561925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (id|gg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+705565,int_stack+106137,int_stack+214825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214825,int_stack+136765,int_stack+136450,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+215770,int_stack+137206,int_stack+136765,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+217093,int_stack+215770,int_stack+214825,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+218983,int_stack+137794,int_stack+137206,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+220747,int_stack+218983,int_stack+215770,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+223393,int_stack+220747,int_stack+217093,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214825,int_stack+138550,int_stack+137794,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+226543,int_stack+214825,int_stack+218983,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214825,int_stack+226543,int_stack+220747,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+226543,int_stack+214825,int_stack+223393,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214825,int_stack+139915,int_stack+139495,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+216085,int_stack+140503,int_stack+139915,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+217849,int_stack+216085,int_stack+214825,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+220369,int_stack+141287,int_stack+140503,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+222721,int_stack+220369,int_stack+216085,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+231268,int_stack+222721,int_stack+217849,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214825,int_stack+142295,int_stack+141287,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+235468,int_stack+214825,int_stack+220369,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214825,int_stack+235468,int_stack+222721,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+235468,int_stack+214825,int_stack+231268,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+241768,int_stack+235468,int_stack+226543, 0.0, zero_stack, 1.0, int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214825,int_stack+144095,int_stack+143555,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+216445,int_stack+144851,int_stack+144095,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+218713,int_stack+216445,int_stack+214825,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+221953,int_stack+145859,int_stack+144851,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+224977,int_stack+221953,int_stack+216445,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+229513,int_stack+224977,int_stack+218713,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214825,int_stack+147155,int_stack+145859,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+106137,int_stack+214825,int_stack+221953,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214825,int_stack+106137,int_stack+224977,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+106137,int_stack+214825,int_stack+229513,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+214825,int_stack+106137,int_stack+235468, 0.0, zero_stack, 1.0, int_stack+327790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+114237,int_stack+214825,int_stack+241768, 0.0, zero_stack, 1.0, int_stack+73062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (l0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+233725,int_stack+149450,int_stack+148775,45);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+235750,int_stack+150395,int_stack+149450,45);
 /*--- compute (l0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+238585,int_stack+235750,int_stack+233725,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+242635,int_stack+151655,int_stack+150395,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+246415,int_stack+242635,int_stack+235750,45);
 /*--- compute (l0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+142587,int_stack+246415,int_stack+238585,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+233725,int_stack+153275,int_stack+151655,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+149337,int_stack+233725,int_stack+242635,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+233725,int_stack+149337,int_stack+246415,45);
 /*--- compute (l0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+243175,int_stack+233725,int_stack+142587,45);
 /*--- compute (kp|gg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+548965,int_stack+243175,int_stack+106137, 0.0, zero_stack, 1.0, int_stack+334090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (id|gg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+743365,int_stack+548965,int_stack+214825, 0.0, zero_stack, 1.0, int_stack+87237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214825,int_stack+158660,int_stack+158345,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+215770,int_stack+159101,int_stack+158660,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+217093,int_stack+215770,int_stack+214825,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+218983,int_stack+159689,int_stack+159101,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+220747,int_stack+218983,int_stack+215770,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+223393,int_stack+220747,int_stack+217093,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214825,int_stack+160445,int_stack+159689,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+226543,int_stack+214825,int_stack+218983,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214825,int_stack+226543,int_stack+220747,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+226543,int_stack+214825,int_stack+223393,21);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+214825,int_stack+165870,int_stack+165450,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+216085,int_stack+166458,int_stack+165870,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+217849,int_stack+216085,int_stack+214825,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+220369,int_stack+167242,int_stack+166458,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+222721,int_stack+220369,int_stack+216085,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+231268,int_stack+222721,int_stack+217849,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+214825,int_stack+168250,int_stack+167242,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+235468,int_stack+214825,int_stack+220369,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+214825,int_stack+235468,int_stack+222721,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+235468,int_stack+214825,int_stack+231268,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+241768,int_stack+235468,int_stack+226543, 1.0, int_stack+323065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+323065,int_stack+175270,int_stack+174730,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+324685,int_stack+176026,int_stack+175270,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+214825,int_stack+324685,int_stack+323065,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+218065,int_stack+177034,int_stack+176026,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+221089,int_stack+218065,int_stack+324685,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+225625,int_stack+221089,int_stack+214825,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+323065,int_stack+178330,int_stack+177034,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+548965,int_stack+323065,int_stack+218065,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+555013,int_stack+548965,int_stack+221089,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+106137,int_stack+555013,int_stack+225625,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+548965,int_stack+106137,int_stack+235468, 1.0, int_stack+327790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+142587,int_stack+548965,int_stack+241768, 1.0, int_stack+73062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (l0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+73062,int_stack+180625,int_stack+179950,45);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+75087,int_stack+181570,int_stack+180625,45);
 /*--- compute (l0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+77922,int_stack+75087,int_stack+73062,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+81972,int_stack+182830,int_stack+181570,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+323065,int_stack+81972,int_stack+75087,45);
 /*--- compute (l0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+214825,int_stack+323065,int_stack+77922,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+73062,int_stack+184450,int_stack+182830,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+221575,int_stack+73062,int_stack+81972,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+73062,int_stack+221575,int_stack+323065,45);
 /*--- compute (l0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+323065,int_stack+73062,int_stack+214825,45);
 /*--- compute (kp|gg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+214825,int_stack+323065,int_stack+106137, 1.0, int_stack+334090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (id|gg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+781165,int_stack+214825,int_stack+548965, 1.0, int_stack+87237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hf|gg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+818965,int_stack+347365,int_stack+294715,225);
     Libderiv->ABCD[11] = int_stack + 818965;
 /*--- compute (hf|gg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+293797,int_stack+413515,int_stack+385165,225);
     Libderiv->ABCD[10] = int_stack + 293797;
 /*--- compute (hf|gg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+341047,int_stack+255997,int_stack+6912,225);
     Libderiv->ABCD[9] = int_stack + 341047;
 /*--- compute (hf|gg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+214825,int_stack+35262,int_stack+471790,225);
     Libderiv->ABCD[8] = int_stack + 214825;
 /*--- compute (hf|gg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+0,int_stack+573265,int_stack+520615,225);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (hf|gg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+47250,int_stack+639415,int_stack+611065,225);
     Libderiv->ABCD[6] = int_stack + 47250;
 /*--- compute (hf|gg) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+388297,int_stack+705565,int_stack+677215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 388297;
 /*--- compute (hf|gg) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+435547,int_stack+743365,int_stack+114237, 0.0, zero_stack, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 435547;
 /*--- compute (hf|gg) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+94500,int_stack+781165,int_stack+142587, 1.0, int_stack+186475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 94500;

}
