/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hfig(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hf|ig) integrals */

void d1hrr_order_hfig(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3444;
 Libderiv->deriv_classes[6][6][11] = int_stack + 4830;
 Libderiv->deriv_classes[6][7][11] = int_stack + 5614;
 Libderiv->deriv_classes[6][8][11] = int_stack + 6622;
 Libderiv->deriv_classes[6][9][11] = int_stack + 7882;
 Libderiv->deriv_classes[6][10][11] = int_stack + 9422;
 Libderiv->deriv_classes[7][6][11] = int_stack + 11270;
 Libderiv->deriv_classes[7][7][11] = int_stack + 12278;
 Libderiv->deriv_classes[7][8][11] = int_stack + 13574;
 Libderiv->deriv_classes[7][9][11] = int_stack + 15194;
 Libderiv->deriv_classes[7][10][11] = int_stack + 17174;
 Libderiv->deriv_classes[8][6][11] = int_stack + 19550;
 Libderiv->deriv_classes[8][7][11] = int_stack + 20810;
 Libderiv->deriv_classes[8][8][11] = int_stack + 22430;
 Libderiv->deriv_classes[8][9][11] = int_stack + 24455;
 Libderiv->deriv_classes[8][10][11] = int_stack + 26930;
 Libderiv->deriv_classes[5][6][10] = int_stack + 29900;
 Libderiv->deriv_classes[5][7][10] = int_stack + 30488;
 Libderiv->deriv_classes[5][8][10] = int_stack + 31244;
 Libderiv->deriv_classes[5][9][10] = int_stack + 32189;
 Libderiv->deriv_classes[5][10][10] = int_stack + 33344;
 Libderiv->deriv_classes[6][6][10] = int_stack + 34730;
 Libderiv->deriv_classes[6][7][10] = int_stack + 35514;
 Libderiv->deriv_classes[6][8][10] = int_stack + 36522;
 Libderiv->deriv_classes[6][9][10] = int_stack + 37782;
 Libderiv->deriv_classes[6][10][10] = int_stack + 39322;
 Libderiv->deriv_classes[7][6][10] = int_stack + 41170;
 Libderiv->deriv_classes[7][7][10] = int_stack + 42178;
 Libderiv->deriv_classes[7][8][10] = int_stack + 43474;
 Libderiv->deriv_classes[7][9][10] = int_stack + 45094;
 Libderiv->deriv_classes[7][10][10] = int_stack + 47074;
 Libderiv->deriv_classes[8][6][10] = int_stack + 49450;
 Libderiv->deriv_classes[8][7][10] = int_stack + 50710;
 Libderiv->deriv_classes[8][8][10] = int_stack + 52330;
 Libderiv->deriv_classes[8][9][10] = int_stack + 54355;
 Libderiv->deriv_classes[8][10][10] = int_stack + 56830;
 Libderiv->deriv_classes[5][6][9] = int_stack + 59800;
 Libderiv->deriv_classes[5][7][9] = int_stack + 60388;
 Libderiv->deriv_classes[5][8][9] = int_stack + 61144;
 Libderiv->deriv_classes[5][9][9] = int_stack + 62089;
 Libderiv->deriv_classes[5][10][9] = int_stack + 63244;
 Libderiv->deriv_classes[6][6][9] = int_stack + 64630;
 Libderiv->deriv_classes[6][7][9] = int_stack + 65414;
 Libderiv->deriv_classes[6][8][9] = int_stack + 66422;
 Libderiv->deriv_classes[6][9][9] = int_stack + 67682;
 Libderiv->deriv_classes[6][10][9] = int_stack + 69222;
 Libderiv->deriv_classes[7][6][9] = int_stack + 71070;
 Libderiv->deriv_classes[7][7][9] = int_stack + 72078;
 Libderiv->deriv_classes[7][8][9] = int_stack + 73374;
 Libderiv->deriv_classes[7][9][9] = int_stack + 74994;
 Libderiv->deriv_classes[7][10][9] = int_stack + 76974;
 Libderiv->deriv_classes[8][6][9] = int_stack + 79350;
 Libderiv->deriv_classes[8][7][9] = int_stack + 80610;
 Libderiv->deriv_classes[8][8][9] = int_stack + 82230;
 Libderiv->deriv_classes[8][9][9] = int_stack + 84255;
 Libderiv->deriv_classes[8][10][9] = int_stack + 86730;
 Libderiv->deriv_classes[5][6][8] = int_stack + 89700;
 Libderiv->deriv_classes[5][7][8] = int_stack + 90288;
 Libderiv->deriv_classes[5][8][8] = int_stack + 91044;
 Libderiv->deriv_classes[5][9][8] = int_stack + 91989;
 Libderiv->deriv_classes[5][10][8] = int_stack + 93144;
 Libderiv->deriv_classes[6][6][8] = int_stack + 94530;
 Libderiv->deriv_classes[6][7][8] = int_stack + 95314;
 Libderiv->deriv_classes[6][8][8] = int_stack + 96322;
 Libderiv->deriv_classes[6][9][8] = int_stack + 97582;
 Libderiv->deriv_classes[6][10][8] = int_stack + 99122;
 Libderiv->deriv_classes[7][6][8] = int_stack + 100970;
 Libderiv->deriv_classes[7][7][8] = int_stack + 101978;
 Libderiv->deriv_classes[7][8][8] = int_stack + 103274;
 Libderiv->deriv_classes[7][9][8] = int_stack + 104894;
 Libderiv->deriv_classes[7][10][8] = int_stack + 106874;
 Libderiv->deriv_classes[8][6][8] = int_stack + 109250;
 Libderiv->deriv_classes[8][7][8] = int_stack + 110510;
 Libderiv->deriv_classes[8][8][8] = int_stack + 112130;
 Libderiv->deriv_classes[8][9][8] = int_stack + 114155;
 Libderiv->deriv_classes[8][10][8] = int_stack + 116630;
 Libderiv->deriv_classes[5][6][7] = int_stack + 119600;
 Libderiv->deriv_classes[5][7][7] = int_stack + 120188;
 Libderiv->deriv_classes[5][8][7] = int_stack + 120944;
 Libderiv->deriv_classes[5][9][7] = int_stack + 121889;
 Libderiv->deriv_classes[5][10][7] = int_stack + 123044;
 Libderiv->deriv_classes[6][6][7] = int_stack + 124430;
 Libderiv->deriv_classes[6][7][7] = int_stack + 125214;
 Libderiv->deriv_classes[6][8][7] = int_stack + 126222;
 Libderiv->deriv_classes[6][9][7] = int_stack + 127482;
 Libderiv->deriv_classes[6][10][7] = int_stack + 129022;
 Libderiv->deriv_classes[7][6][7] = int_stack + 130870;
 Libderiv->deriv_classes[7][7][7] = int_stack + 131878;
 Libderiv->deriv_classes[7][8][7] = int_stack + 133174;
 Libderiv->deriv_classes[7][9][7] = int_stack + 134794;
 Libderiv->deriv_classes[7][10][7] = int_stack + 136774;
 Libderiv->deriv_classes[8][6][7] = int_stack + 139150;
 Libderiv->deriv_classes[8][7][7] = int_stack + 140410;
 Libderiv->deriv_classes[8][8][7] = int_stack + 142030;
 Libderiv->deriv_classes[8][9][7] = int_stack + 144055;
 Libderiv->deriv_classes[8][10][7] = int_stack + 146530;
 Libderiv->deriv_classes[5][6][6] = int_stack + 149500;
 Libderiv->deriv_classes[5][7][6] = int_stack + 150088;
 Libderiv->deriv_classes[5][8][6] = int_stack + 150844;
 Libderiv->deriv_classes[5][9][6] = int_stack + 151789;
 Libderiv->deriv_classes[5][10][6] = int_stack + 152944;
 Libderiv->deriv_classes[6][6][6] = int_stack + 154330;
 Libderiv->deriv_classes[6][7][6] = int_stack + 155114;
 Libderiv->deriv_classes[6][8][6] = int_stack + 156122;
 Libderiv->deriv_classes[6][9][6] = int_stack + 157382;
 Libderiv->deriv_classes[6][10][6] = int_stack + 158922;
 Libderiv->deriv_classes[7][6][6] = int_stack + 160770;
 Libderiv->deriv_classes[7][7][6] = int_stack + 161778;
 Libderiv->deriv_classes[7][8][6] = int_stack + 163074;
 Libderiv->deriv_classes[7][9][6] = int_stack + 164694;
 Libderiv->deriv_classes[7][10][6] = int_stack + 166674;
 Libderiv->dvrr_classes[8][6] = int_stack + 169050;
 Libderiv->deriv_classes[8][6][6] = int_stack + 170310;
 Libderiv->dvrr_classes[8][7] = int_stack + 171570;
 Libderiv->deriv_classes[8][7][6] = int_stack + 173190;
 Libderiv->dvrr_classes[8][8] = int_stack + 174810;
 Libderiv->deriv_classes[8][8][6] = int_stack + 176835;
 Libderiv->dvrr_classes[8][9] = int_stack + 178860;
 Libderiv->deriv_classes[8][9][6] = int_stack + 181335;
 Libderiv->deriv_classes[8][10][6] = int_stack + 183810;
 Libderiv->deriv_classes[5][6][2] = int_stack + 186780;
 Libderiv->deriv_classes[5][7][2] = int_stack + 187368;
 Libderiv->deriv_classes[5][8][2] = int_stack + 188124;
 Libderiv->deriv_classes[5][9][2] = int_stack + 189069;
 Libderiv->deriv_classes[5][10][2] = int_stack + 190224;
 Libderiv->deriv_classes[6][6][2] = int_stack + 191610;
 Libderiv->deriv_classes[6][7][2] = int_stack + 192394;
 Libderiv->deriv_classes[6][8][2] = int_stack + 193402;
 Libderiv->deriv_classes[6][9][2] = int_stack + 194662;
 Libderiv->deriv_classes[6][10][2] = int_stack + 196202;
 Libderiv->deriv_classes[7][6][2] = int_stack + 198050;
 Libderiv->deriv_classes[7][7][2] = int_stack + 199058;
 Libderiv->deriv_classes[7][8][2] = int_stack + 200354;
 Libderiv->deriv_classes[7][9][2] = int_stack + 201974;
 Libderiv->deriv_classes[7][10][2] = int_stack + 203954;
 Libderiv->deriv_classes[8][6][2] = int_stack + 206330;
 Libderiv->deriv_classes[8][7][2] = int_stack + 207590;
 Libderiv->deriv_classes[8][8][2] = int_stack + 209210;
 Libderiv->deriv_classes[8][9][2] = int_stack + 211235;
 Libderiv->deriv_classes[8][10][2] = int_stack + 213710;
 Libderiv->deriv_classes[5][6][1] = int_stack + 216680;
 Libderiv->deriv_classes[5][7][1] = int_stack + 217268;
 Libderiv->deriv_classes[5][8][1] = int_stack + 218024;
 Libderiv->deriv_classes[5][9][1] = int_stack + 218969;
 Libderiv->deriv_classes[5][10][1] = int_stack + 220124;
 Libderiv->deriv_classes[6][6][1] = int_stack + 221510;
 Libderiv->deriv_classes[6][7][1] = int_stack + 222294;
 Libderiv->deriv_classes[6][8][1] = int_stack + 223302;
 Libderiv->deriv_classes[6][9][1] = int_stack + 224562;
 Libderiv->deriv_classes[6][10][1] = int_stack + 226102;
 Libderiv->deriv_classes[7][6][1] = int_stack + 227950;
 Libderiv->deriv_classes[7][7][1] = int_stack + 228958;
 Libderiv->deriv_classes[7][8][1] = int_stack + 230254;
 Libderiv->deriv_classes[7][9][1] = int_stack + 231874;
 Libderiv->deriv_classes[7][10][1] = int_stack + 233854;
 Libderiv->deriv_classes[8][6][1] = int_stack + 236230;
 Libderiv->deriv_classes[8][7][1] = int_stack + 237490;
 Libderiv->deriv_classes[8][8][1] = int_stack + 239110;
 Libderiv->deriv_classes[8][9][1] = int_stack + 241135;
 Libderiv->deriv_classes[8][10][1] = int_stack + 243610;
 Libderiv->dvrr_classes[5][6] = int_stack + 246580;
 Libderiv->dvrr_classes[5][7] = int_stack + 247168;
 Libderiv->dvrr_classes[5][8] = int_stack + 247924;
 Libderiv->dvrr_classes[5][9] = int_stack + 248869;
 Libderiv->dvrr_classes[5][10] = int_stack + 250024;
 Libderiv->deriv_classes[5][6][0] = int_stack + 251410;
 Libderiv->deriv_classes[5][7][0] = int_stack + 251998;
 Libderiv->deriv_classes[5][8][0] = int_stack + 252754;
 Libderiv->deriv_classes[5][9][0] = int_stack + 253699;
 Libderiv->deriv_classes[5][10][0] = int_stack + 254854;
 Libderiv->dvrr_classes[6][6] = int_stack + 256240;
 Libderiv->dvrr_classes[6][7] = int_stack + 257024;
 Libderiv->dvrr_classes[6][8] = int_stack + 258032;
 Libderiv->dvrr_classes[6][9] = int_stack + 259292;
 Libderiv->dvrr_classes[6][10] = int_stack + 260832;
 Libderiv->deriv_classes[6][6][0] = int_stack + 262680;
 Libderiv->deriv_classes[6][7][0] = int_stack + 263464;
 Libderiv->deriv_classes[6][8][0] = int_stack + 264472;
 Libderiv->deriv_classes[6][9][0] = int_stack + 265732;
 Libderiv->deriv_classes[6][10][0] = int_stack + 267272;
 Libderiv->dvrr_classes[7][6] = int_stack + 269120;
 Libderiv->dvrr_classes[7][7] = int_stack + 270128;
 Libderiv->dvrr_classes[7][8] = int_stack + 271424;
 Libderiv->dvrr_classes[7][9] = int_stack + 273044;
 Libderiv->dvrr_classes[7][10] = int_stack + 275024;
 Libderiv->deriv_classes[7][6][0] = int_stack + 277400;
 Libderiv->deriv_classes[7][7][0] = int_stack + 278408;
 Libderiv->deriv_classes[7][8][0] = int_stack + 279704;
 Libderiv->deriv_classes[7][9][0] = int_stack + 281324;
 Libderiv->deriv_classes[7][10][0] = int_stack + 283304;
 Libderiv->deriv_classes[8][6][0] = int_stack + 285680;
 Libderiv->deriv_classes[8][7][0] = int_stack + 286940;
 Libderiv->deriv_classes[8][8][0] = int_stack + 288560;
 Libderiv->deriv_classes[8][9][0] = int_stack + 290585;
 Libderiv->deriv_classes[8][10][0] = int_stack + 293060;
 memset(int_stack,0,2368240);

 Libderiv->dvrr_stack = int_stack + 1583268;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hfig(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+296030,int_stack+247168,int_stack+246580,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+297794,int_stack+247924,int_stack+247168,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+300062,int_stack+297794,int_stack+296030,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+303590,int_stack+248869,int_stack+247924,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+306425,int_stack+303590,int_stack+297794,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+310961,int_stack+306425,int_stack+300062,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+316841,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246580,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+318605,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247168,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+320873,int_stack+318605,int_stack+316841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296030,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+324401,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247924,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+327236,int_stack+324401,int_stack+318605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297794,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+331772,int_stack+327236,int_stack+320873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300062,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+316841,int_stack+3444,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248869,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+337652,int_stack+316841,int_stack+324401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303590,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+316841,int_stack+337652,int_stack+327236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306425,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+337652,int_stack+316841,int_stack+331772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310961,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+316841,int_stack+257024,int_stack+256240,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+319193,int_stack+258032,int_stack+257024,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+322217,int_stack+319193,int_stack+316841,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+326921,int_stack+259292,int_stack+258032,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+330701,int_stack+326921,int_stack+319193,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+346472,int_stack+330701,int_stack+322217,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+5614,int_stack+4830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256240,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2352,int_stack+6622,int_stack+5614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257024,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+354312,int_stack+2352,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316841,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+359016,int_stack+7882,int_stack+6622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258032,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+362796,int_stack+359016,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319193,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+362796,int_stack+354312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322217,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+354312,int_stack+9422,int_stack+7882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259292,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+368844,int_stack+354312,int_stack+359016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326921,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+376404,int_stack+368844,int_stack+362796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330701,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+354312,int_stack+376404,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346472,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+366072,int_stack+354312,int_stack+337652,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+270128,int_stack+269120,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3024,int_stack+271424,int_stack+270128,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+336749,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+392532,int_stack+273044,int_stack+271424,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+397392,int_stack+392532,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+405168,int_stack+397392,int_stack+336749,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6912,int_stack+12278,int_stack+11270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269120,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+415248,int_stack+13574,int_stack+12278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270128,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+419136,int_stack+415248,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6912,int_stack+15194,int_stack+13574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271424,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425184,int_stack+6912,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+432960,int_stack+425184,int_stack+419136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336749,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+17174,int_stack+15194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273044,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+443040,int_stack+415248,int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392532,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+452760,int_stack+443040,int_stack+425184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397392,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+415248,int_stack+452760,int_stack+432960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405168,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+430368,int_stack+415248,int_stack+354312,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+465648,int_stack+430368,int_stack+366072,420);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+354312,int_stack+171570,int_stack+169050,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+358092,int_stack+174810,int_stack+171570,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+362952,int_stack+358092,int_stack+354312,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+370512,int_stack+178860,int_stack+174810,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+376587,int_stack+370512,int_stack+358092,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+6912,int_stack+376587,int_stack+362952,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+386307,int_stack+20810,int_stack+19550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169050,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+518568,int_stack+22430,int_stack+20810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171570,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+523428,int_stack+518568,int_stack+386307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354312,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+386307,int_stack+24455,int_stack+22430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174810,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+530988,int_stack+386307,int_stack+518568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358092,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+540708,int_stack+530988,int_stack+523428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362952,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+518568,int_stack+26930,int_stack+24455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178860,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+553308,int_stack+518568,int_stack+386307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370512,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+565458,int_stack+553308,int_stack+530988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376587,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+518568,int_stack+565458,int_stack+540708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6912,45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+537468,int_stack+518568,int_stack+415248,420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+582828,int_stack+537468,int_stack+430368,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+30488,int_stack+29900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246580, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417012,int_stack+31244,int_stack+30488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247168, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+419280,int_stack+417012,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296030, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+422808,int_stack+32189,int_stack+31244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247924, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425643,int_stack+422808,int_stack+417012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297794, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+430179,int_stack+425643,int_stack+419280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300062, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+33344,int_stack+32189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248869, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+422808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303590, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+436059,int_stack+425643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306425, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+430179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310961, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+35514,int_stack+34730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256240, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417600,int_stack+36522,int_stack+35514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257024, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420624,int_stack+417600,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316841, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+425328,int_stack+37782,int_stack+36522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258032, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+429108,int_stack+425328,int_stack+417600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319193, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+444879,int_stack+429108,int_stack+420624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322217, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+39322,int_stack+37782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259292, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+425328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326921, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+452719,int_stack+429108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330701, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+444879, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346472, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+518568,int_stack+452719,int_stack+436059,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+42178,int_stack+41170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269120, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+418272,int_stack+43474,int_stack+42178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270128, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+422160,int_stack+418272,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+428208,int_stack+45094,int_stack+43474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271424, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+433068,int_stack+428208,int_stack+418272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+440844,int_stack+433068,int_stack+422160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336749, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+47074,int_stack+45094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273044, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+545028,int_stack+415248,int_stack+428208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392532, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+545028,int_stack+433068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397392, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+545028,int_stack+415248,int_stack+440844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405168, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+415248,int_stack+545028,int_stack+452719,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+653388,int_stack+415248,int_stack+518568,420);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+518568,int_stack+50710,int_stack+49450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169050, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+522348,int_stack+52330,int_stack+50710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171570, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+527208,int_stack+522348,int_stack+518568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354312, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+534768,int_stack+54355,int_stack+52330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174810, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+450528,int_stack+534768,int_stack+522348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358092, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+560148,int_stack+450528,int_stack+527208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362952, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+518568,int_stack+56830,int_stack+54355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178860, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+19512,int_stack+518568,int_stack+534768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370512, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+518568,int_stack+19512,int_stack+450528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376587, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+19512,int_stack+518568,int_stack+560148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6912, 0.0, zero_stack,45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+706308,int_stack+19512,int_stack+545028,420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+751668,int_stack+706308,int_stack+415248,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+60388,int_stack+59800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246580, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417012,int_stack+61144,int_stack+60388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247168, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+419280,int_stack+417012,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+422808,int_stack+62089,int_stack+61144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247924, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425643,int_stack+422808,int_stack+417012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297794, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+430179,int_stack+425643,int_stack+419280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300062, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+63244,int_stack+62089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248869, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+422808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303590, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+436059,int_stack+425643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306425, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+430179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310961, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+65414,int_stack+64630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256240, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417600,int_stack+66422,int_stack+65414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257024, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420624,int_stack+417600,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316841, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+425328,int_stack+67682,int_stack+66422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258032, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+429108,int_stack+425328,int_stack+417600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319193, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+444879,int_stack+429108,int_stack+420624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322217, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+69222,int_stack+67682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259292, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+425328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326921, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+452719,int_stack+429108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330701, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+444879, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346472, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+706308,int_stack+452719,int_stack+436059,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+72078,int_stack+71070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269120, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+418272,int_stack+73374,int_stack+72078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270128, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+422160,int_stack+418272,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+428208,int_stack+74994,int_stack+73374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271424, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+433068,int_stack+428208,int_stack+418272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+440844,int_stack+433068,int_stack+422160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336749, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+76974,int_stack+74994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273044, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+732768,int_stack+415248,int_stack+428208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392532, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+732768,int_stack+433068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397392, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+732768,int_stack+415248,int_stack+440844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405168, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+415248,int_stack+732768,int_stack+452719,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+19512,int_stack+415248,int_stack+706308,420);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+747888,int_stack+80610,int_stack+79350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169050, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+706308,int_stack+82230,int_stack+80610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171570, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+711168,int_stack+706308,int_stack+747888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354312, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+718728,int_stack+84255,int_stack+82230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174810, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+450528,int_stack+718728,int_stack+706308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358092, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+518568,int_stack+450528,int_stack+711168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362952, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+706308,int_stack+86730,int_stack+84255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178860, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+72432,int_stack+706308,int_stack+718728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370512, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+706308,int_stack+72432,int_stack+450528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376587, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+531168,int_stack+706308,int_stack+518568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6912, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+822228,int_stack+531168,int_stack+732768,420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+867588,int_stack+822228,int_stack+415248,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+90288,int_stack+89700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417012,int_stack+91044,int_stack+90288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+419280,int_stack+417012,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+422808,int_stack+91989,int_stack+91044, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425643,int_stack+422808,int_stack+417012, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+430179,int_stack+425643,int_stack+419280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+93144,int_stack+91989, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+422808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+436059,int_stack+425643, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+430179, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+95314,int_stack+94530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417600,int_stack+96322,int_stack+95314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420624,int_stack+417600,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+425328,int_stack+97582,int_stack+96322, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+429108,int_stack+425328,int_stack+417600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+444879,int_stack+429108,int_stack+420624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+322217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+99122,int_stack+97582, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+425328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+452719,int_stack+429108, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+444879, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+822228,int_stack+452719,int_stack+436059,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+101978,int_stack+100970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+418272,int_stack+103274,int_stack+101978, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+422160,int_stack+418272,int_stack+415248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+428208,int_stack+104894,int_stack+103274, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+433068,int_stack+428208,int_stack+418272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+440844,int_stack+433068,int_stack+422160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+106874,int_stack+104894, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+848688,int_stack+415248,int_stack+428208, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+848688,int_stack+433068, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+848688,int_stack+415248,int_stack+440844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+415248,int_stack+848688,int_stack+452719,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+518568,int_stack+415248,int_stack+822228,420);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+863808,int_stack+110510,int_stack+109250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+169050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+822228,int_stack+112130,int_stack+110510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+827088,int_stack+822228,int_stack+863808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+834648,int_stack+114155,int_stack+112130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+450528,int_stack+834648,int_stack+822228, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+706308,int_stack+450528,int_stack+827088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+362952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+822228,int_stack+116630,int_stack+114155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+718908,int_stack+822228,int_stack+834648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+822228,int_stack+718908,int_stack+450528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+718908,int_stack+822228,int_stack+706308, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+72432,int_stack+718908,int_stack+848688,420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+938148,int_stack+72432,int_stack+415248,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+120188,int_stack+119600, 0.0, zero_stack, 1.0, int_stack+246580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417012,int_stack+120944,int_stack+120188, 0.0, zero_stack, 1.0, int_stack+247168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+419280,int_stack+417012,int_stack+415248, 0.0, zero_stack, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+422808,int_stack+121889,int_stack+120944, 0.0, zero_stack, 1.0, int_stack+247924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425643,int_stack+422808,int_stack+417012, 0.0, zero_stack, 1.0, int_stack+297794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+430179,int_stack+425643,int_stack+419280, 0.0, zero_stack, 1.0, int_stack+300062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+123044,int_stack+121889, 0.0, zero_stack, 1.0, int_stack+248869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+422808, 0.0, zero_stack, 1.0, int_stack+303590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+436059,int_stack+425643, 0.0, zero_stack, 1.0, int_stack+306425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+436059,int_stack+415248,int_stack+430179, 0.0, zero_stack, 1.0, int_stack+310961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+125214,int_stack+124430, 0.0, zero_stack, 1.0, int_stack+256240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417600,int_stack+126222,int_stack+125214, 0.0, zero_stack, 1.0, int_stack+257024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420624,int_stack+417600,int_stack+415248, 0.0, zero_stack, 1.0, int_stack+316841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+425328,int_stack+127482,int_stack+126222, 0.0, zero_stack, 1.0, int_stack+258032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+429108,int_stack+425328,int_stack+417600, 0.0, zero_stack, 1.0, int_stack+319193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+444879,int_stack+429108,int_stack+420624, 0.0, zero_stack, 1.0, int_stack+322217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+129022,int_stack+127482, 0.0, zero_stack, 1.0, int_stack+259292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+425328, 0.0, zero_stack, 1.0, int_stack+326921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+452719,int_stack+429108, 0.0, zero_stack, 1.0, int_stack+330701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+452719,int_stack+415248,int_stack+444879, 0.0, zero_stack, 1.0, int_stack+346472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+72432,int_stack+452719,int_stack+436059,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+131878,int_stack+130870, 0.0, zero_stack, 1.0, int_stack+269120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+418272,int_stack+133174,int_stack+131878, 0.0, zero_stack, 1.0, int_stack+270128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+422160,int_stack+418272,int_stack+415248, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+428208,int_stack+134794,int_stack+133174, 0.0, zero_stack, 1.0, int_stack+271424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+433068,int_stack+428208,int_stack+418272, 0.0, zero_stack, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+440844,int_stack+433068,int_stack+422160, 0.0, zero_stack, 1.0, int_stack+336749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+415248,int_stack+136774,int_stack+134794, 0.0, zero_stack, 1.0, int_stack+273044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+98892,int_stack+415248,int_stack+428208, 0.0, zero_stack, 1.0, int_stack+392532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+415248,int_stack+98892,int_stack+433068, 0.0, zero_stack, 1.0, int_stack+397392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+98892,int_stack+415248,int_stack+440844, 0.0, zero_stack, 1.0, int_stack+405168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+415248,int_stack+98892,int_stack+452719,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1008708,int_stack+415248,int_stack+72432,420);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+72432,int_stack+140410,int_stack+139150, 0.0, zero_stack, 1.0, int_stack+169050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+76212,int_stack+142030,int_stack+140410, 0.0, zero_stack, 1.0, int_stack+171570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+81072,int_stack+76212,int_stack+72432, 0.0, zero_stack, 1.0, int_stack+354312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+88632,int_stack+144055,int_stack+142030, 0.0, zero_stack, 1.0, int_stack+174810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+450528,int_stack+88632,int_stack+76212, 0.0, zero_stack, 1.0, int_stack+358092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+114012,int_stack+450528,int_stack+81072, 0.0, zero_stack, 1.0, int_stack+362952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+72432,int_stack+146530,int_stack+144055, 0.0, zero_stack, 1.0, int_stack+178860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+126612,int_stack+72432,int_stack+88632, 0.0, zero_stack, 1.0, int_stack+370512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+72432,int_stack+126612,int_stack+450528, 0.0, zero_stack, 1.0, int_stack+376587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+126612,int_stack+72432,int_stack+114012, 0.0, zero_stack, 1.0, int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+706308,int_stack+126612,int_stack+98892,420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+72432,int_stack+706308,int_stack+415248,420);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+150088,int_stack+149500, 1.0, int_stack+246580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+417012,int_stack+150844,int_stack+150088, 1.0, int_stack+247168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+419280,int_stack+417012,int_stack+415248, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+422808,int_stack+151789,int_stack+150844, 1.0, int_stack+247924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425643,int_stack+422808,int_stack+417012, 1.0, int_stack+297794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+430179,int_stack+425643,int_stack+419280, 1.0, int_stack+300062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+296030,int_stack+152944,int_stack+151789, 1.0, int_stack+248869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+415248,int_stack+296030,int_stack+422808, 1.0, int_stack+303590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+296030,int_stack+415248,int_stack+425643, 1.0, int_stack+306425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+415248,int_stack+296030,int_stack+430179, 1.0, int_stack+310961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+296030,int_stack+155114,int_stack+154330, 1.0, int_stack+256240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+298382,int_stack+156122,int_stack+155114, 1.0, int_stack+257024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+424068,int_stack+298382,int_stack+296030, 1.0, int_stack+316841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+428772,int_stack+157382,int_stack+156122, 1.0, int_stack+258032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+432552,int_stack+428772,int_stack+298382, 1.0, int_stack+319193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+438600,int_stack+432552,int_stack+424068, 1.0, int_stack+322217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+424068,int_stack+158922,int_stack+157382, 1.0, int_stack+259292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+296030,int_stack+424068,int_stack+428772, 1.0, int_stack+326921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+316841,int_stack+296030,int_stack+432552, 1.0, int_stack+330701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+424068,int_stack+316841,int_stack+438600, 1.0, int_stack+346472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+435828,int_stack+424068,int_stack+415248,420);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+415248,int_stack+161778,int_stack+160770, 1.0, int_stack+269120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+418272,int_stack+163074,int_stack+161778, 1.0, int_stack+270128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+316841,int_stack+418272,int_stack+415248, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+296030,int_stack+164694,int_stack+163074, 1.0, int_stack+271424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+706308,int_stack+296030,int_stack+418272, 1.0, int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+714084,int_stack+706308,int_stack+316841, 1.0, int_stack+336749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+336749,int_stack+166674,int_stack+164694, 1.0, int_stack+273044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+316841,int_stack+336749,int_stack+296030, 1.0, int_stack+392532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+724164,int_stack+316841,int_stack+706308, 1.0, int_stack+397392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+142992,int_stack+724164,int_stack+714084, 1.0, int_stack+405168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+706308,int_stack+142992,int_stack+424068,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1061628,int_stack+706308,int_stack+435828,420);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+741588,int_stack+173190,int_stack+170310, 1.0, int_stack+169050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+745368,int_stack+176835,int_stack+173190, 1.0, int_stack+171570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+296030,int_stack+745368,int_stack+741588, 1.0, int_stack+354312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+316841,int_stack+181335,int_stack+176835, 1.0, int_stack+174810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+336749,int_stack+316841,int_stack+745368, 1.0, int_stack+358092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+415248,int_stack+336749,int_stack+296030, 1.0, int_stack+362952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+296030,int_stack+183810,int_stack+181335, 1.0, int_stack+178860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+354312,int_stack+296030,int_stack+316841, 1.0, int_stack+370512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+427848,int_stack+354312,int_stack+336749, 1.0, int_stack+376587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+354312,int_stack+427848,int_stack+415248, 1.0, int_stack+6912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+822228,int_stack+354312,int_stack+142992,420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1114548,int_stack+822228,int_stack+706308,420);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+706308,int_stack+250024,int_stack+248869,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+709773,int_stack+706308,int_stack+303590,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+715443,int_stack+709773,int_stack+306425,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+706308,int_stack+715443,int_stack+310961,21);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+715128,int_stack+260832,int_stack+259292,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+719748,int_stack+715128,int_stack+326921,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+727308,int_stack+719748,int_stack+330701,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+715128,int_stack+727308,int_stack+346472,28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+822228,int_stack+715128,int_stack+706308,420);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+726888,int_stack+275024,int_stack+273044,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+732828,int_stack+726888,int_stack+392532,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+848688,int_stack+732828,int_stack+397392,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+726888,int_stack+848688,int_stack+405168,36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+142992,int_stack+726888,int_stack+715128,420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+296030,int_stack+142992,int_stack+822228,420);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+848688,int_stack+187368,int_stack+186780,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+850452,int_stack+188124,int_stack+187368,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+852720,int_stack+850452,int_stack+848688,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+856248,int_stack+189069,int_stack+188124,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+859083,int_stack+856248,int_stack+850452,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+742008,int_stack+859083,int_stack+852720,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+848688,int_stack+190224,int_stack+189069,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+178272,int_stack+848688,int_stack+856248,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+848688,int_stack+178272,int_stack+859083,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+178272,int_stack+848688,int_stack+742008,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+742008,int_stack+192394,int_stack+191610,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+744360,int_stack+193402,int_stack+192394,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+848688,int_stack+744360,int_stack+742008,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+747384,int_stack+194662,int_stack+193402,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+853392,int_stack+747384,int_stack+744360,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+859440,int_stack+853392,int_stack+848688,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+848688,int_stack+196202,int_stack+194662,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+187092,int_stack+848688,int_stack+747384,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+348950,int_stack+187092,int_stack+853392,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+359030,int_stack+348950,int_stack+859440,28);
 /*--- compute (hp|ig) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+370790,int_stack+359030,int_stack+178272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+706308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+178272,int_stack+199058,int_stack+198050,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+181296,int_stack+200354,int_stack+199058,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+185184,int_stack+181296,int_stack+178272,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+191232,int_stack+201974,int_stack+200354,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+348950,int_stack+191232,int_stack+181296,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+848688,int_stack+348950,int_stack+185184,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+178272,int_stack+203954,int_stack+201974,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+196092,int_stack+178272,int_stack+191232,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+178272,int_stack+196092,int_stack+348950,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+397250,int_stack+178272,int_stack+848688,36);
 /*--- compute (ip|ig) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+412370,int_stack+397250,int_stack+359030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+715128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (hd|ig) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1185108,int_stack+412370,int_stack+370790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+848688,int_stack+207590,int_stack+206330,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+852468,int_stack+209210,int_stack+207590,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+857328,int_stack+852468,int_stack+848688,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+178272,int_stack+211235,int_stack+209210,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+184347,int_stack+178272,int_stack+852468,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+194067,int_stack+184347,int_stack+857328,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+848688,int_stack+213710,int_stack+211235,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+348950,int_stack+848688,int_stack+178272,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+848688,int_stack+348950,int_stack+184347,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+348950,int_stack+848688,int_stack+194067,45);
 /*--- compute (kp|ig) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+1238028,int_stack+348950,int_stack+397250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (id|ig) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1283388,int_stack+1238028,int_stack+412370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1238028,int_stack+217268,int_stack+216680,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1239792,int_stack+218024,int_stack+217268,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1242060,int_stack+1239792,int_stack+1238028,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1245588,int_stack+218969,int_stack+218024,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1248423,int_stack+1245588,int_stack+1239792,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1252959,int_stack+1248423,int_stack+1242060,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1238028,int_stack+220124,int_stack+218969,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1258839,int_stack+1238028,int_stack+1245588,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1238028,int_stack+1258839,int_stack+1248423,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1258839,int_stack+1238028,int_stack+1252959,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1238028,int_stack+222294,int_stack+221510,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1240380,int_stack+223302,int_stack+222294,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1243404,int_stack+1240380,int_stack+1238028,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1248108,int_stack+224562,int_stack+223302,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1251888,int_stack+1248108,int_stack+1240380,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1267659,int_stack+1251888,int_stack+1243404,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1238028,int_stack+226102,int_stack+224562,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1275499,int_stack+1238028,int_stack+1248108,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1238028,int_stack+1275499,int_stack+1251888,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+348950,int_stack+1238028,int_stack+1267659,28);
 /*--- compute (hp|ig) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+360710,int_stack+348950,int_stack+1258839, 0.0, zero_stack, 1.0, int_stack+706308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1238028,int_stack+228958,int_stack+227950,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1241052,int_stack+230254,int_stack+228958,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1244940,int_stack+1241052,int_stack+1238028,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1250988,int_stack+231874,int_stack+230254,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1255848,int_stack+1250988,int_stack+1241052,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1263624,int_stack+1255848,int_stack+1244940,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1238028,int_stack+233854,int_stack+231874,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+387170,int_stack+1238028,int_stack+1250988,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1238028,int_stack+387170,int_stack+1255848,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+387170,int_stack+1238028,int_stack+1263624,36);
 /*--- compute (ip|ig) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+1238028,int_stack+387170,int_stack+348950, 0.0, zero_stack, 1.0, int_stack+715128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (hd|ig) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+402290,int_stack+1238028,int_stack+360710, 0.0, zero_stack, 1.0, int_stack+822228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+348950,int_stack+237490,int_stack+236230,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+352730,int_stack+239110,int_stack+237490,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+357590,int_stack+352730,int_stack+348950,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+365150,int_stack+241135,int_stack+239110,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+371225,int_stack+365150,int_stack+352730,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+848688,int_stack+371225,int_stack+357590,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+348950,int_stack+243610,int_stack+241135,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+178272,int_stack+348950,int_stack+365150,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+348950,int_stack+178272,int_stack+371225,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+178272,int_stack+348950,int_stack+848688,45);
 /*--- compute (kp|ig) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+197172,int_stack+178272,int_stack+387170, 0.0, zero_stack, 1.0, int_stack+726888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (id|ig) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1353948,int_stack+197172,int_stack+1238028, 0.0, zero_stack, 1.0, int_stack+142992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1238028,int_stack+251998,int_stack+251410,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1239792,int_stack+252754,int_stack+251998,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1242060,int_stack+1239792,int_stack+1238028,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1245588,int_stack+253699,int_stack+252754,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1248423,int_stack+1245588,int_stack+1239792,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1252959,int_stack+1248423,int_stack+1242060,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1238028,int_stack+254854,int_stack+253699,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1258839,int_stack+1238028,int_stack+1245588,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1238028,int_stack+1258839,int_stack+1248423,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1258839,int_stack+1238028,int_stack+1252959,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1238028,int_stack+263464,int_stack+262680,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1240380,int_stack+264472,int_stack+263464,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1243404,int_stack+1240380,int_stack+1238028,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1248108,int_stack+265732,int_stack+264472,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1251888,int_stack+1248108,int_stack+1240380,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1267659,int_stack+1251888,int_stack+1243404,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1238028,int_stack+267272,int_stack+265732,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1275499,int_stack+1238028,int_stack+1248108,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1238028,int_stack+1275499,int_stack+1251888,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+178272,int_stack+1238028,int_stack+1267659,28);
 /*--- compute (hp|ig) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+190032,int_stack+178272,int_stack+1258839, 1.0, int_stack+706308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+706308,int_stack+278408,int_stack+277400,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+709332,int_stack+279704,int_stack+278408,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1238028,int_stack+709332,int_stack+706308,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1244076,int_stack+281324,int_stack+279704,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1248936,int_stack+1244076,int_stack+709332,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1256712,int_stack+1248936,int_stack+1238028,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1238028,int_stack+283304,int_stack+281324,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1266792,int_stack+1238028,int_stack+1244076,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+216492,int_stack+1266792,int_stack+1248936,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1266792,int_stack+216492,int_stack+1256712,36);
 /*--- compute (ip|ig) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+216492,int_stack+1266792,int_stack+178272, 1.0, int_stack+715128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (hd|ig) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+348950,int_stack+216492,int_stack+190032, 1.0, int_stack+822228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+822228,int_stack+286940,int_stack+285680,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+826008,int_stack+288560,int_stack+286940,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+830868,int_stack+826008,int_stack+822228,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+838428,int_stack+290585,int_stack+288560,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+844503,int_stack+838428,int_stack+826008,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+854223,int_stack+844503,int_stack+830868,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+822228,int_stack+293060,int_stack+290585,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+178272,int_stack+822228,int_stack+838428,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+822228,int_stack+178272,int_stack+844503,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+178272,int_stack+822228,int_stack+854223,45);
 /*--- compute (kp|ig) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+822228,int_stack+178272,int_stack+1266792, 1.0, int_stack+726888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (id|ig) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1424508,int_stack+822228,int_stack+216492, 1.0, int_stack+142992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+142992,int_stack+582828,int_stack+465648,420);
     Libderiv->ABCD[11] = int_stack + 142992;
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1495068,int_stack+751668,int_stack+653388,420);
     Libderiv->ABCD[10] = int_stack + 1495068;
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+571488,int_stack+867588,int_stack+19512,420);
     Libderiv->ABCD[9] = int_stack + 571488;
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+659688,int_stack+938148,int_stack+518568,420);
     Libderiv->ABCD[8] = int_stack + 659688;
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+455210,int_stack+72432,int_stack+1008708,420);
     Libderiv->ABCD[7] = int_stack + 455210;
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+0,int_stack+1114548,int_stack+1061628,420);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (hf|ig) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+747888,int_stack+1283388,int_stack+1185108, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
     Libderiv->ABCD[2] = int_stack + 747888;
 /*--- compute (hf|ig) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+836088,int_stack+1353948,int_stack+402290, 0.0, zero_stack, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
     Libderiv->ABCD[1] = int_stack + 836088;
 /*--- compute (hf|ig) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+924288,int_stack+1424508,int_stack+348950, 1.0, int_stack+296030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,420);
     Libderiv->ABCD[0] = int_stack + 924288;

}
