/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_p0if(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|if) integrals */

void d1hrr_order_p0if(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][6][11] = int_stack + 0;
 Libderiv->deriv_classes[1][7][11] = int_stack + 84;
 Libderiv->deriv_classes[1][8][11] = int_stack + 192;
 Libderiv->deriv_classes[1][9][11] = int_stack + 327;
 Libderiv->deriv_classes[1][6][10] = int_stack + 492;
 Libderiv->deriv_classes[1][7][10] = int_stack + 576;
 Libderiv->deriv_classes[1][8][10] = int_stack + 684;
 Libderiv->deriv_classes[1][9][10] = int_stack + 819;
 Libderiv->deriv_classes[1][6][9] = int_stack + 984;
 Libderiv->deriv_classes[1][7][9] = int_stack + 1068;
 Libderiv->deriv_classes[1][8][9] = int_stack + 1176;
 Libderiv->deriv_classes[1][9][9] = int_stack + 1311;
 Libderiv->deriv_classes[1][6][8] = int_stack + 1476;
 Libderiv->deriv_classes[1][7][8] = int_stack + 1560;
 Libderiv->deriv_classes[1][8][8] = int_stack + 1668;
 Libderiv->deriv_classes[1][9][8] = int_stack + 1803;
 Libderiv->deriv_classes[1][6][7] = int_stack + 1968;
 Libderiv->deriv_classes[1][7][7] = int_stack + 2052;
 Libderiv->deriv_classes[1][8][7] = int_stack + 2160;
 Libderiv->deriv_classes[1][9][7] = int_stack + 2295;
 Libderiv->dvrr_classes[1][6] = int_stack + 2460;
 Libderiv->deriv_classes[1][6][6] = int_stack + 2544;
 Libderiv->dvrr_classes[1][7] = int_stack + 2628;
 Libderiv->deriv_classes[1][7][6] = int_stack + 2736;
 Libderiv->dvrr_classes[1][8] = int_stack + 2844;
 Libderiv->deriv_classes[1][8][6] = int_stack + 2979;
 Libderiv->deriv_classes[1][9][6] = int_stack + 3114;
 Libderiv->deriv_classes[1][6][2] = int_stack + 3279;
 Libderiv->deriv_classes[1][7][2] = int_stack + 3363;
 Libderiv->deriv_classes[1][8][2] = int_stack + 3471;
 Libderiv->deriv_classes[1][9][2] = int_stack + 3606;
 Libderiv->deriv_classes[1][6][1] = int_stack + 3771;
 Libderiv->deriv_classes[1][7][1] = int_stack + 3855;
 Libderiv->deriv_classes[1][8][1] = int_stack + 3963;
 Libderiv->deriv_classes[1][9][1] = int_stack + 4098;
 Libderiv->deriv_classes[1][6][0] = int_stack + 4263;
 Libderiv->deriv_classes[1][7][0] = int_stack + 4347;
 Libderiv->deriv_classes[1][8][0] = int_stack + 4455;
 Libderiv->deriv_classes[1][9][0] = int_stack + 4590;
 memset(int_stack,0,38040);

 Libderiv->dvrr_stack = int_stack + 13344;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_p0if(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4755,int_stack+2628,int_stack+2460,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5007,int_stack+2844,int_stack+2628,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5331,int_stack+5007,int_stack+4755,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5835,int_stack+84,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2460,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6087,int_stack+192,int_stack+84, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2628,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6411,int_stack+6087,int_stack+5835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4755,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+327,int_stack+192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2844,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7320,int_stack+6915,int_stack+6087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5007,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6915,int_stack+576,int_stack+492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2460, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5835,int_stack+684,int_stack+576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2628, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+5835,int_stack+6915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4755, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+819,int_stack+684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2844, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+7968,int_stack+6915,int_stack+5835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5007, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5835,int_stack+1068,int_stack+984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2460, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6087,int_stack+1176,int_stack+1068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2628, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504,int_stack+6087,int_stack+5835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4755, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+1311,int_stack+1176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2844, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8616,int_stack+6915,int_stack+6087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5007, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6915,int_stack+1560,int_stack+1476, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5835,int_stack+1668,int_stack+1560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1008,int_stack+5835,int_stack+6915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+1803,int_stack+1668, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9264,int_stack+6915,int_stack+5835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5835,int_stack+2052,int_stack+1968, 0.0, zero_stack, 1.0, int_stack+2460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6087,int_stack+2160,int_stack+2052, 0.0, zero_stack, 1.0, int_stack+2628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1512,int_stack+6087,int_stack+5835, 0.0, zero_stack, 1.0, int_stack+4755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+2295,int_stack+2160, 0.0, zero_stack, 1.0, int_stack+2844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9912,int_stack+6915,int_stack+6087, 0.0, zero_stack, 1.0, int_stack+5007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6915,int_stack+2736,int_stack+2544, 1.0, int_stack+2460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5835,int_stack+2979,int_stack+2736, 1.0, int_stack+2628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2016,int_stack+5835,int_stack+6915, 1.0, int_stack+4755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+3114,int_stack+2979, 1.0, int_stack+2844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2520,int_stack+6915,int_stack+5835, 1.0, int_stack+5007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5835,int_stack+3363,int_stack+3279,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6087,int_stack+3471,int_stack+3363,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4755,int_stack+6087,int_stack+5835,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+3606,int_stack+3471,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+10560,int_stack+6915,int_stack+6087,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6915,int_stack+3855,int_stack+3771,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5835,int_stack+3963,int_stack+3855,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3168,int_stack+5835,int_stack+6915,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+4098,int_stack+3963,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+11208,int_stack+6915,int_stack+5835,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5835,int_stack+4347,int_stack+4263,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6087,int_stack+4455,int_stack+4347,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3672,int_stack+6087,int_stack+5835,3);
 /*--- compute (p0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+6915,int_stack+4590,int_stack+4455,3);
 /*--- compute (p0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+11856,int_stack+6915,int_stack+6087,3);
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+12504,int_stack+7320,int_stack+6411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5331,3);
     Libderiv->ABCD[11] = int_stack + 12504;
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5835,int_stack+7968,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5331, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 5835;
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6675,int_stack+8616,int_stack+504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5331, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 6675;
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+9264,int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+7515,int_stack+9912,int_stack+1512, 0.0, zero_stack, 1.0, int_stack+5331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 7515;
 /*--- compute (p0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+840,int_stack+2520,int_stack+2016, 1.0, int_stack+5331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 840;
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1680,int_stack+10560,int_stack+4755,3);
     Libderiv->ABCD[2] = int_stack + 1680;
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+8355,int_stack+11208,int_stack+3168,3);
     Libderiv->ABCD[1] = int_stack + 8355;
 /*--- compute (p0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2520,int_stack+11856,int_stack+3672,3);
     Libderiv->ABCD[0] = int_stack + 2520;

}
