/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00ld(Libint_t*, prim_data*);

  /* Computes quartets of (00|ld) integrals */

REALTYPE *hrr_order_00ld(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][8] = int_stack + 0;
 Libint->vrr_classes[0][9] = int_stack + 45;
 Libint->vrr_classes[0][10] = int_stack + 100;
 memset(int_stack,0,166*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 166;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00ld(Libint, Data);
   Data++;
 }
 /*--- compute (00|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+166,int_stack+45,int_stack+0,1);
 /*--- compute (00|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+301,int_stack+100,int_stack+45,1);
 /*--- compute (00|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+466,int_stack+301,int_stack+166,1);
 return int_stack+466;}
