/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00lg(Libint_t*, prim_data*);

  /* Computes quartets of (00|lg) integrals */

REALTYPE *hrr_order_00lg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][8] = int_stack + 0;
 Libint->vrr_classes[0][9] = int_stack + 45;
 Libint->vrr_classes[0][10] = int_stack + 100;
 Libint->vrr_classes[0][11] = int_stack + 166;
 Libint->vrr_classes[0][12] = int_stack + 244;
 memset(int_stack,0,335*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 335;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00lg(Libint, Data);
   Data++;
 }
 /*--- compute (00|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+335,int_stack+45,int_stack+0,1);
 /*--- compute (00|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+470,int_stack+100,int_stack+45,1);
 /*--- compute (00|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+635,int_stack+470,int_stack+335,1);
 /*--- compute (00|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+905,int_stack+166,int_stack+100,1);
 /*--- compute (00|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1103,int_stack+905,int_stack+470,1);
 /*--- compute (00|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1433,int_stack+1103,int_stack+635,1);
 /*--- compute (00|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+335,int_stack+244,int_stack+166,1);
 /*--- compute (00|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1883,int_stack+335,int_stack+905,1);
 /*--- compute (00|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+1883,int_stack+1103,1);
 /*--- compute (00|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+1883,int_stack+0,int_stack+1433,1);
 return int_stack+1883;}
