/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00mg(Libint_t*, prim_data*);

  /* Computes quartets of (00|mg) integrals */

REALTYPE *hrr_order_00mg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][9] = int_stack + 0;
 Libint->vrr_classes[0][10] = int_stack + 55;
 Libint->vrr_classes[0][11] = int_stack + 121;
 Libint->vrr_classes[0][12] = int_stack + 199;
 Libint->vrr_classes[0][13] = int_stack + 290;
 memset(int_stack,0,395*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 395;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00mg(Libint, Data);
   Data++;
 }
 /*--- compute (00|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+395,int_stack+55,int_stack+0,1);
 /*--- compute (00|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+560,int_stack+121,int_stack+55,1);
 /*--- compute (00|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+758,int_stack+560,int_stack+395,1);
 /*--- compute (00|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1088,int_stack+199,int_stack+121,1);
 /*--- compute (00|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1322,int_stack+1088,int_stack+560,1);
 /*--- compute (00|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1718,int_stack+1322,int_stack+758,1);
 /*--- compute (00|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+395,int_stack+290,int_stack+199,1);
 /*--- compute (00|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2268,int_stack+395,int_stack+1088,1);
 /*--- compute (00|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+2268,int_stack+1322,1);
 /*--- compute (00|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+660,int_stack+0,int_stack+1718,1);
 return int_stack+660;}
