/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddgp(Libint_t*, prim_data*);

  /* Computes quartets of (dd|gp) integrals */

REALTYPE *hrr_order_ddgp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][4] = int_stack + 0;
 Libint->vrr_classes[2][5] = int_stack + 90;
 Libint->vrr_classes[3][4] = int_stack + 216;
 Libint->vrr_classes[3][5] = int_stack + 366;
 Libint->vrr_classes[4][4] = int_stack + 576;
 Libint->vrr_classes[4][5] = int_stack + 801;
 memset(int_stack,0,1116*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1116;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddgp(Libint, Data);
   Data++;
 }
 /*--- compute (d0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+1116,int_stack+90,int_stack+0,6);
 /*--- compute (f0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+1386,int_stack+366,int_stack+216,10);
 /*--- compute (dp|gp) ---*/
 hrr1_build_dp(Libint->AB,int_stack+1836,int_stack+1386,int_stack+1116,45);
 /*--- compute (g0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+2646,int_stack+801,int_stack+576,15);
 /*--- compute (fp|gp) ---*/
 hrr1_build_fp(Libint->AB,int_stack+0,int_stack+2646,int_stack+1386,45);
 /*--- compute (dd|gp) ---*/
 hrr1_build_dd(Libint->AB,int_stack+2646,int_stack+0,int_stack+1836,45);
 return int_stack+2646;}
