/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpdd(Libint_t*, prim_data*);

  /* Computes quartets of (dp|dd) integrals */

REALTYPE *hrr_order_dpdd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][2] = int_stack + 0;
 Libint->vrr_classes[2][3] = int_stack + 36;
 Libint->vrr_classes[2][4] = int_stack + 96;
 Libint->vrr_classes[3][2] = int_stack + 186;
 Libint->vrr_classes[3][3] = int_stack + 246;
 Libint->vrr_classes[3][4] = int_stack + 346;
 memset(int_stack,0,496*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 496;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpdd(Libint, Data);
   Data++;
 }
 /*--- compute (d0|dp) ---*/
 hrr3_build_dp(Libint->CD,int_stack+496,int_stack+36,int_stack+0,6);
 /*--- compute (d0|fp) ---*/
 hrr3_build_fp(Libint->CD,int_stack+604,int_stack+96,int_stack+36,6);
 /*--- compute (d0|dd) ---*/
 hrr3_build_dd(Libint->CD,int_stack+784,int_stack+604,int_stack+496,6);
 /*--- compute (f0|dp) ---*/
 hrr3_build_dp(Libint->CD,int_stack+496,int_stack+246,int_stack+186,10);
 /*--- compute (f0|fp) ---*/
 hrr3_build_fp(Libint->CD,int_stack+1000,int_stack+346,int_stack+246,10);
 /*--- compute (f0|dd) ---*/
 hrr3_build_dd(Libint->CD,int_stack+0,int_stack+1000,int_stack+496,10);
 /*--- compute (dp|dd) ---*/
 hrr1_build_dp(Libint->AB,int_stack+1000,int_stack+0,int_stack+784,36);
 return int_stack+1000;}
