/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_dpnm(Libint_t*, prim_data*);

  /* Computes quartets of (dp|nm) integrals */

REALTYPE *hrr_order_dpnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][10] = int_stack + 0;
 Libint->vrr_classes[2][11] = int_stack + 396;
 Libint->vrr_classes[2][12] = int_stack + 864;
 Libint->vrr_classes[2][13] = int_stack + 1410;
 Libint->vrr_classes[2][14] = int_stack + 2040;
 Libint->vrr_classes[2][15] = int_stack + 2760;
 Libint->vrr_classes[2][16] = int_stack + 3576;
 Libint->vrr_classes[2][17] = int_stack + 4494;
 Libint->vrr_classes[2][18] = int_stack + 5520;
 Libint->vrr_classes[2][19] = int_stack + 6660;
 Libint->vrr_classes[3][10] = int_stack + 7920;
 Libint->vrr_classes[3][11] = int_stack + 8580;
 Libint->vrr_classes[3][12] = int_stack + 9360;
 Libint->vrr_classes[3][13] = int_stack + 10270;
 Libint->vrr_classes[3][14] = int_stack + 11320;
 Libint->vrr_classes[3][15] = int_stack + 12520;
 Libint->vrr_classes[3][16] = int_stack + 13880;
 Libint->vrr_classes[3][17] = int_stack + 15410;
 Libint->vrr_classes[3][18] = int_stack + 17120;
 Libint->vrr_classes[3][19] = int_stack + 19020;
 memset(int_stack,0,21120*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21120;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_dpnm(Libint, Data);
   Data++;
 }
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21120,int_stack+396,int_stack+0,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+22308,int_stack+864,int_stack+396,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23712,int_stack+22308,int_stack+21120,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+26088,int_stack+1410,int_stack+864,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+27726,int_stack+26088,int_stack+22308,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30534,int_stack+27726,int_stack+23712,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+21120,int_stack+2040,int_stack+1410,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+34494,int_stack+21120,int_stack+26088,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+23010,int_stack+34494,int_stack+27726,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+37770,int_stack+23010,int_stack+30534,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+27690,int_stack+2760,int_stack+2040,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+29850,int_stack+27690,int_stack+21120,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+43710,int_stack+29850,int_stack+34494,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+49170,int_stack+43710,int_stack+23010,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+56190,int_stack+49170,int_stack+37770,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+21120,int_stack+3576,int_stack+2760,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+33630,int_stack+21120,int_stack+27690,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+64506,int_stack+33630,int_stack+29850,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+23568,int_stack+64506,int_stack+43710,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+37950,int_stack+23568,int_stack+49170,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+70806,int_stack+37950,int_stack+56190,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+47778,int_stack+4494,int_stack+3576,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+50532,int_stack+47778,int_stack+21120,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+55428,int_stack+50532,int_stack+33630,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+81894,int_stack+55428,int_stack+64506,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+91344,int_stack+81894,int_stack+23568,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+21120,int_stack+91344,int_stack+37950,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+102810,int_stack+21120,int_stack+70806,6);
 /*--- compute (d0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+34224,int_stack+5520,int_stack+4494,6);
 /*--- compute (d0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+37302,int_stack+34224,int_stack+47778,6);
 /*--- compute (d0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+62628,int_stack+37302,int_stack+50532,6);
 /*--- compute (d0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+42810,int_stack+62628,int_stack+55428,6);
 /*--- compute (d0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+117066,int_stack+42810,int_stack+81894,6);
 /*--- compute (d0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+70788,int_stack+117066,int_stack+91344,6);
 /*--- compute (d0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+130296,int_stack+70788,int_stack+21120,6);
 /*--- compute (d0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+147144,int_stack+130296,int_stack+102810,6);
 /*--- compute (d0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+21120,int_stack+6660,int_stack+5520,6);
 /*--- compute (d0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+24540,int_stack+21120,int_stack+34224,6);
 /*--- compute (d0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+86076,int_stack+24540,int_stack+37302,6);
 /*--- compute (d0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+21120,int_stack+86076,int_stack+62628,6);
 /*--- compute (d0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+86076,int_stack+21120,int_stack+42810,6);
 /*--- compute (d0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+21120,int_stack+86076,int_stack+117066,6);
 /*--- compute (d0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+86076,int_stack+21120,int_stack+70788,6);
 /*--- compute (d0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+21120,int_stack+86076,int_stack+130296,6);
 /*--- compute (d0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+42180,int_stack+21120,int_stack+147144,6);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21120,int_stack+8580,int_stack+7920,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23100,int_stack+9360,int_stack+8580,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+25440,int_stack+23100,int_stack+21120,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29400,int_stack+10270,int_stack+9360,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+32130,int_stack+29400,int_stack+23100,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+63960,int_stack+32130,int_stack+25440,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+21120,int_stack+11320,int_stack+10270,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+70560,int_stack+21120,int_stack+29400,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24270,int_stack+70560,int_stack+32130,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+32070,int_stack+24270,int_stack+63960,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+63960,int_stack+12520,int_stack+11320,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+76020,int_stack+63960,int_stack+21120,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+82320,int_stack+76020,int_stack+70560,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+91420,int_stack+82320,int_stack+24270,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+103120,int_stack+91420,int_stack+32070,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+21120,int_stack+13880,int_stack+12520,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+25200,int_stack+21120,int_stack+63960,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+63960,int_stack+25200,int_stack+76020,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+116980,int_stack+63960,int_stack+82320,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+74460,int_stack+116980,int_stack+91420,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+130630,int_stack+74460,int_stack+103120,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+90840,int_stack+15410,int_stack+13880,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+95430,int_stack+90840,int_stack+21120,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+103590,int_stack+95430,int_stack+25200,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+21120,int_stack+103590,int_stack+63960,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+149110,int_stack+21120,int_stack+116980,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+168220,int_stack+149110,int_stack+74460,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+63960,int_stack+168220,int_stack+130630,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+36870,int_stack+17120,int_stack+15410,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+115590,int_stack+36870,int_stack+90840,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+124770,int_stack+115590,int_stack+95430,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+190060,int_stack+124770,int_stack+103590,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+87720,int_stack+190060,int_stack+21120,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+208060,int_stack+87720,int_stack+149110,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+138370,int_stack+208060,int_stack+168220,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+233540,int_stack+138370,int_stack+63960,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+63960,int_stack+19020,int_stack+17120,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+69660,int_stack+63960,int_stack+36870,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+166450,int_stack+69660,int_stack+115590,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+63960,int_stack+166450,int_stack+124770,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+109770,int_stack+63960,int_stack+190060,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+166450,int_stack+109770,int_stack+87720,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+63960,int_stack+166450,int_stack+208060,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+166450,int_stack+63960,int_stack+138370,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+63960,int_stack+166450,int_stack+233540,10);
 /*--- compute (dp|nm) ---*/
 hrr1_build_dp(Libint->AB,int_stack+100260,int_stack+63960,int_stack+42180,3630);
 return int_stack+100260;}
