/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdi0(Libint_t*, prim_data*);

  /* Computes quartets of (fd|i0) integrals */

REALTYPE *hrr_order_fdi0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[4][6] = int_stack + 280;
 Libint->vrr_classes[5][6] = int_stack + 700;
 memset(int_stack,0,1288*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1288;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdi0(Libint, Data);
   Data++;
 }
 /*--- compute (fp|i0) ---*/
 hrr1_build_fp(Libint->AB,int_stack+1288,int_stack+280,int_stack+0,28);
 /*--- compute (gp|i0) ---*/
 hrr1_build_gp(Libint->AB,int_stack+2128,int_stack+700,int_stack+280,28);
 /*--- compute (fd|i0) ---*/
 hrr1_build_fd(Libint->AB,int_stack+3388,int_stack+2128,int_stack+1288,28);
 return int_stack+3388;}
