/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdlh(Libint_t*, prim_data*);

  /* Computes quartets of (fd|lh) integrals */

REALTYPE *hrr_order_fdlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[4][8] = int_stack + 4400;
 Libint->vrr_classes[4][9] = int_stack + 5075;
 Libint->vrr_classes[4][10] = int_stack + 5900;
 Libint->vrr_classes[4][11] = int_stack + 6890;
 Libint->vrr_classes[4][12] = int_stack + 8060;
 Libint->vrr_classes[4][13] = int_stack + 9425;
 Libint->vrr_classes[5][8] = int_stack + 11000;
 Libint->vrr_classes[5][9] = int_stack + 11945;
 Libint->vrr_classes[5][10] = int_stack + 13100;
 Libint->vrr_classes[5][11] = int_stack + 14486;
 Libint->vrr_classes[5][12] = int_stack + 16124;
 Libint->vrr_classes[5][13] = int_stack + 18035;
 memset(int_stack,0,20240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdlh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20240,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+21590,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23240,int_stack+21590,int_stack+20240,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25940,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27920,int_stack+25940,int_stack+21590,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+31220,int_stack+27920,int_stack+23240,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20240,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35720,int_stack+20240,int_stack+25940,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+39680,int_stack+35720,int_stack+27920,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+22580,int_stack+39680,int_stack+31220,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29330,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+45180,int_stack+29330,int_stack+20240,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49860,int_stack+45180,int_stack+35720,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+29330,int_stack+49860,int_stack+39680,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+37580,int_stack+29330,int_stack+22580,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20240,int_stack+5075,int_stack+4400,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+22265,int_stack+5900,int_stack+5075,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+24740,int_stack+22265,int_stack+20240,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+28790,int_stack+6890,int_stack+5900,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31760,int_stack+28790,int_stack+22265,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+47030,int_stack+31760,int_stack+24740,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20240,int_stack+8060,int_stack+6890,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+20240,int_stack+28790,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+53780,int_stack+0,int_stack+31760,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+23750,int_stack+53780,int_stack+47030,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+47030,int_stack+9425,int_stack+8060,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+62030,int_stack+47030,int_stack+20240,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+69050,int_stack+62030,int_stack+0,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+78950,int_stack+69050,int_stack+53780,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+47030,int_stack+78950,int_stack+23750,15);
 /*--- compute (fp|lh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+61205,int_stack+47030,int_stack+37580,945);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+11945,int_stack+11000,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2835,int_stack+13100,int_stack+11945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+6300,int_stack+2835,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20240,int_stack+14486,int_stack+13100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24398,int_stack+20240,int_stack+2835,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+31328,int_stack+24398,int_stack+6300,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+16124,int_stack+14486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4914,int_stack+0,int_stack+20240,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+89555,int_stack+4914,int_stack+24398,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+101105,int_stack+89555,int_stack+31328,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+20240,int_stack+18035,int_stack+16124,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+25973,int_stack+20240,int_stack+0,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+115280,int_stack+25973,int_stack+4914,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+115280,int_stack+89555,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+17325,int_stack+0,int_stack+101105,21);
 /*--- compute (gp|lh) ---*/
 hrr1_build_gp(Libint->AB,int_stack+89555,int_stack+17325,int_stack+47030,945);
 /*--- compute (fd|lh) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+89555,int_stack+61205,945);
 return int_stack+0;}
