/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdmk(Libint_t*, prim_data*);

  /* Computes quartets of (fd|mk) integrals */

REALTYPE *hrr_order_fdmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[3][16] = int_stack + 6510;
 Libint->vrr_classes[4][9] = int_stack + 8040;
 Libint->vrr_classes[4][10] = int_stack + 8865;
 Libint->vrr_classes[4][11] = int_stack + 9855;
 Libint->vrr_classes[4][12] = int_stack + 11025;
 Libint->vrr_classes[4][13] = int_stack + 12390;
 Libint->vrr_classes[4][14] = int_stack + 13965;
 Libint->vrr_classes[4][15] = int_stack + 15765;
 Libint->vrr_classes[4][16] = int_stack + 17805;
 Libint->vrr_classes[5][9] = int_stack + 20100;
 Libint->vrr_classes[5][10] = int_stack + 21255;
 Libint->vrr_classes[5][11] = int_stack + 22641;
 Libint->vrr_classes[5][12] = int_stack + 24279;
 Libint->vrr_classes[5][13] = int_stack + 26190;
 Libint->vrr_classes[5][14] = int_stack + 28395;
 Libint->vrr_classes[5][15] = int_stack + 30915;
 Libint->vrr_classes[5][16] = int_stack + 33771;
 memset(int_stack,0,36984*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 36984;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdmk(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36984,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38634,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+40614,int_stack+38634,int_stack+36984,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43914,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+46254,int_stack+43914,int_stack+38634,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+50214,int_stack+46254,int_stack+40614,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+36984,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+55714,int_stack+36984,int_stack+43914,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+60394,int_stack+55714,int_stack+46254,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+39714,int_stack+60394,int_stack+50214,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+47964,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+66994,int_stack+47964,int_stack+36984,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+72454,int_stack+66994,int_stack+55714,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+80254,int_stack+72454,int_stack+60394,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+51114,int_stack+80254,int_stack+39714,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+36984,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+40584,int_stack+36984,int_stack+47964,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+90154,int_stack+40584,int_stack+66994,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+99254,int_stack+90154,int_stack+72454,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+62664,int_stack+99254,int_stack+80254,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+110954,int_stack+62664,int_stack+51114,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+46884,int_stack+6510,int_stack+5150,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+50964,int_stack+46884,int_stack+36984,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+76524,int_stack+50964,int_stack+40584,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+36984,int_stack+76524,int_stack+90154,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+76524,int_stack+36984,int_stack+99254,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+36984,int_stack+76524,int_stack+62664,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+55464,int_stack+36984,int_stack+110954,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36984,int_stack+8865,int_stack+8040,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39459,int_stack+9855,int_stack+8865,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42429,int_stack+39459,int_stack+36984,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+47379,int_stack+11025,int_stack+9855,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75264,int_stack+47379,int_stack+39459,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+81204,int_stack+75264,int_stack+42429,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+36984,int_stack+12390,int_stack+11025,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+89454,int_stack+36984,int_stack+47379,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+41079,int_stack+89454,int_stack+75264,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+96474,int_stack+41079,int_stack+81204,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+75264,int_stack+13965,int_stack+12390,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+79989,int_stack+75264,int_stack+36984,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+108849,int_stack+79989,int_stack+89454,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+120549,int_stack+108849,int_stack+41079,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+36984,int_stack+120549,int_stack+96474,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+88179,int_stack+15765,int_stack+13965,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+93579,int_stack+88179,int_stack+75264,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+93579,int_stack+79989,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+135399,int_stack+0,int_stack+108849,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+152949,int_stack+135399,int_stack+120549,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103029,int_stack+152949,int_stack+36984,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+36984,int_stack+17805,int_stack+15765,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+43104,int_stack+36984,int_stack+88179,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+75264,int_stack+43104,int_stack+93579,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+173739,int_stack+75264,int_stack+0,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+75264,int_stack+173739,int_stack+135399,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+173739,int_stack+75264,int_stack+152949,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+126129,int_stack+173739,int_stack+103029,15);
 /*--- compute (fp|mk) ---*/
 hrr1_build_fp(Libint->AB,int_stack+155829,int_stack+126129,int_stack+55464,1980);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+21255,int_stack+20100,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3465,int_stack+22641,int_stack+21255,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7623,int_stack+3465,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14553,int_stack+24279,int_stack+22641,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+36984,int_stack+14553,int_stack+3465,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+45300,int_stack+36984,int_stack+7623,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+26190,int_stack+24279,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+56850,int_stack+0,int_stack+14553,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5733,int_stack+56850,int_stack+36984,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+66678,int_stack+5733,int_stack+45300,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+36984,int_stack+28395,int_stack+26190,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+43599,int_stack+36984,int_stack+0,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+84003,int_stack+43599,int_stack+56850,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+100383,int_stack+84003,int_stack+5733,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+100383,int_stack+66678,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+55065,int_stack+30915,int_stack+28395,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+62625,int_stack+55065,int_stack+36984,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+215229,int_stack+62625,int_stack+43599,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+234339,int_stack+215229,int_stack+84003,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+258909,int_stack+234339,int_stack+100383,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+75855,int_stack+258909,int_stack+0,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+33771,int_stack+30915,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+8568,int_stack+0,int_stack+55065,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+23688,int_stack+8568,int_stack+62625,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+45738,int_stack+23688,int_stack+215229,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+45738,int_stack+234339,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+215229,int_stack+0,int_stack+258909,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+215229,int_stack+75855,21);
 /*--- compute (gp|mk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+215229,int_stack+0,int_stack+126129,1980);
 /*--- compute (fd|mk) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+215229,int_stack+155829,1980);
 return int_stack+0;}
