/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fflf(Libint_t*, prim_data*);

  /* Computes quartets of (ff|lf) integrals */

REALTYPE *hrr_order_fflf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[4][8] = int_stack + 2440;
 Libint->vrr_classes[4][9] = int_stack + 3115;
 Libint->vrr_classes[4][10] = int_stack + 3940;
 Libint->vrr_classes[4][11] = int_stack + 4930;
 Libint->vrr_classes[5][8] = int_stack + 6100;
 Libint->vrr_classes[5][9] = int_stack + 7045;
 Libint->vrr_classes[5][10] = int_stack + 8200;
 Libint->vrr_classes[5][11] = int_stack + 9586;
 Libint->vrr_classes[6][8] = int_stack + 11224;
 Libint->vrr_classes[6][9] = int_stack + 12484;
 Libint->vrr_classes[6][10] = int_stack + 14024;
 Libint->vrr_classes[6][11] = int_stack + 15872;
 memset(int_stack,0,18056*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 18056;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fflf(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18056,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19406,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+21056,int_stack+19406,int_stack+18056,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23756,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+25736,int_stack+23756,int_stack+19406,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+29036,int_stack+25736,int_stack+21056,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18056,int_stack+3115,int_stack+2440,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+20081,int_stack+3940,int_stack+3115,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+22556,int_stack+20081,int_stack+18056,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+4930,int_stack+3940,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33536,int_stack+0,int_stack+20081,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+38486,int_stack+33536,int_stack+22556,15);
 /*--- compute (fp|lf) ---*/
 hrr1_build_fp(Libint->AB,int_stack+45236,int_stack+38486,int_stack+29036,450);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+7045,int_stack+6100,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2835,int_stack+8200,int_stack+7045,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18056,int_stack+2835,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+23726,int_stack+9586,int_stack+8200,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27884,int_stack+23726,int_stack+2835,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+27884,int_stack+18056,21);
 /*--- compute (gp|lf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+18056,int_stack+0,int_stack+38486,450);
 /*--- compute (fd|lf) ---*/
 hrr1_build_fd(Libint->AB,int_stack+58736,int_stack+18056,int_stack+45236,450);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38306,int_stack+12484,int_stack+11224,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42086,int_stack+14024,int_stack+12484,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+46706,int_stack+42086,int_stack+38306,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+85736,int_stack+15872,int_stack+14024,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+91280,int_stack+85736,int_stack+42086,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+100520,int_stack+91280,int_stack+46706,28);
 /*--- compute (hp|lf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+113120,int_stack+100520,int_stack+0,450);
 /*--- compute (gd|lf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+141470,int_stack+113120,int_stack+18056,450);
 /*--- compute (ff|lf) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+141470,int_stack+58736,450);
 return int_stack+0;}
