/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fflp(Libint_t*, prim_data*);

  /* Computes quartets of (ff|lp) integrals */

REALTYPE *hrr_order_fflp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[4][8] = int_stack + 1000;
 Libint->vrr_classes[4][9] = int_stack + 1675;
 Libint->vrr_classes[5][8] = int_stack + 2500;
 Libint->vrr_classes[5][9] = int_stack + 3445;
 Libint->vrr_classes[6][8] = int_stack + 4600;
 Libint->vrr_classes[6][9] = int_stack + 5860;
 memset(int_stack,0,7400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fflp(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7400,int_stack+450,int_stack+0,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8750,int_stack+1675,int_stack+1000,15);
 /*--- compute (fp|lp) ---*/
 hrr1_build_fp(Libint->AB,int_stack+10775,int_stack+8750,int_stack+7400,135);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+14825,int_stack+3445,int_stack+2500,21);
 /*--- compute (gp|lp) ---*/
 hrr1_build_gp(Libint->AB,int_stack+17660,int_stack+14825,int_stack+8750,135);
 /*--- compute (fd|lp) ---*/
 hrr1_build_fd(Libint->AB,int_stack+23735,int_stack+17660,int_stack+10775,135);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7400,int_stack+5860,int_stack+4600,28);
 /*--- compute (hp|lp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+31835,int_stack+7400,int_stack+14825,135);
 /*--- compute (gd|lp) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+31835,int_stack+17660,135);
 /*--- compute (ff|lp) ---*/
 hrr1_build_ff(Libint->AB,int_stack+31835,int_stack+0,int_stack+23735,135);
 return int_stack+31835;}
