/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffmg(Libint_t*, prim_data*);

  /* Computes quartets of (ff|mg) integrals */

REALTYPE *hrr_order_ffmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[4][9] = int_stack + 3950;
 Libint->vrr_classes[4][10] = int_stack + 4775;
 Libint->vrr_classes[4][11] = int_stack + 5765;
 Libint->vrr_classes[4][12] = int_stack + 6935;
 Libint->vrr_classes[4][13] = int_stack + 8300;
 Libint->vrr_classes[5][9] = int_stack + 9875;
 Libint->vrr_classes[5][10] = int_stack + 11030;
 Libint->vrr_classes[5][11] = int_stack + 12416;
 Libint->vrr_classes[5][12] = int_stack + 14054;
 Libint->vrr_classes[5][13] = int_stack + 15965;
 Libint->vrr_classes[6][9] = int_stack + 18170;
 Libint->vrr_classes[6][10] = int_stack + 19710;
 Libint->vrr_classes[6][11] = int_stack + 21558;
 Libint->vrr_classes[6][12] = int_stack + 23742;
 Libint->vrr_classes[6][13] = int_stack + 26290;
 memset(int_stack,0,29230*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 29230;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffmg(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29230,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+30880,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+32860,int_stack+30880,int_stack+29230,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36160,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+38500,int_stack+36160,int_stack+30880,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+42460,int_stack+38500,int_stack+32860,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29230,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+47960,int_stack+29230,int_stack+36160,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+29230,int_stack+47960,int_stack+38500,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+47960,int_stack+29230,int_stack+42460,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29230,int_stack+4775,int_stack+3950,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31705,int_stack+5765,int_stack+4775,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+34675,int_stack+31705,int_stack+29230,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39625,int_stack+6935,int_stack+5765,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+39625,int_stack+31705,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+56210,int_stack+0,int_stack+34675,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29230,int_stack+8300,int_stack+6935,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+64460,int_stack+29230,int_stack+39625,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+29230,int_stack+64460,int_stack+0,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+64460,int_stack+29230,int_stack+56210,15);
 /*--- compute (fp|mg) ---*/
 hrr1_build_fp(Libint->AB,int_stack+76835,int_stack+64460,int_stack+47960,825);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29230,int_stack+11030,int_stack+9875,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32695,int_stack+12416,int_stack+11030,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36853,int_stack+32695,int_stack+29230,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43783,int_stack+14054,int_stack+12416,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48697,int_stack+43783,int_stack+32695,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+48697,int_stack+36853,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29230,int_stack+15965,int_stack+14054,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+101585,int_stack+29230,int_stack+43783,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+29230,int_stack+101585,int_stack+48697,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+43090,int_stack+29230,int_stack+0,21);
 /*--- compute (gp|mg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+101585,int_stack+43090,int_stack+64460,825);
 /*--- compute (fd|mg) ---*/
 hrr1_build_fd(Libint->AB,int_stack+138710,int_stack+101585,int_stack+76835,825);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+19710,int_stack+18170,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4620,int_stack+21558,int_stack+19710,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10164,int_stack+4620,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29230,int_stack+23742,int_stack+21558,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+60415,int_stack+29230,int_stack+4620,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71503,int_stack+60415,int_stack+10164,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+26290,int_stack+23742,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7644,int_stack+0,int_stack+29230,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+20748,int_stack+7644,int_stack+60415,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+188210,int_stack+20748,int_stack+71503,28);
 /*--- compute (hp|mg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+211310,int_stack+188210,int_stack+43090,825);
 /*--- compute (gd|mg) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+211310,int_stack+101585,825);
 /*--- compute (ff|mg) ---*/
 hrr1_build_ff(Libint->AB,int_stack+188210,int_stack+0,int_stack+138710,825);
 return int_stack+188210;}
