/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffn0(Libint_t*, prim_data*);

  /* Computes quartets of (ff|n0) integrals */

REALTYPE *hrr_order_ffn0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 660;
 Libint->vrr_classes[5][10] = int_stack + 1650;
 Libint->vrr_classes[6][10] = int_stack + 3036;
 memset(int_stack,0,4884*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4884;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffn0(Libint, Data);
   Data++;
 }
 /*--- compute (fp|n0) ---*/
 hrr1_build_fp(Libint->AB,int_stack+4884,int_stack+660,int_stack+0,66);
 /*--- compute (gp|n0) ---*/
 hrr1_build_gp(Libint->AB,int_stack+6864,int_stack+1650,int_stack+660,66);
 /*--- compute (fd|n0) ---*/
 hrr1_build_fd(Libint->AB,int_stack+9834,int_stack+6864,int_stack+4884,66);
 /*--- compute (hp|n0) ---*/
 hrr1_build_hp(Libint->AB,int_stack+13794,int_stack+3036,int_stack+1650,66);
 /*--- compute (gd|n0) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+13794,int_stack+6864,66);
 /*--- compute (ff|n0) ---*/
 hrr1_build_ff(Libint->AB,int_stack+13794,int_stack+0,int_stack+9834,66);
 return int_stack+13794;}
