/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpki(Libint_t*, prim_data*);

  /* Computes quartets of (fp|ki) integrals */

REALTYPE *hrr_order_fpki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[3][13] = int_stack + 3710;
 Libint->vrr_classes[4][7] = int_stack + 4760;
 Libint->vrr_classes[4][8] = int_stack + 5300;
 Libint->vrr_classes[4][9] = int_stack + 5975;
 Libint->vrr_classes[4][10] = int_stack + 6800;
 Libint->vrr_classes[4][11] = int_stack + 7790;
 Libint->vrr_classes[4][12] = int_stack + 8960;
 Libint->vrr_classes[4][13] = int_stack + 10325;
 memset(int_stack,0,11900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpki(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11900,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12980,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+14330,int_stack+12980,int_stack+11900,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16490,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18140,int_stack+16490,int_stack+12980,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+20840,int_stack+18140,int_stack+14330,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11900,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+24440,int_stack+11900,int_stack+16490,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+27740,int_stack+24440,int_stack+18140,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13880,int_stack+27740,int_stack+20840,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+19280,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32240,int_stack+19280,int_stack+11900,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36200,int_stack+32240,int_stack+24440,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+41700,int_stack+36200,int_stack+27740,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+21620,int_stack+41700,int_stack+13880,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+11900,int_stack+3710,int_stack+2800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+11900,int_stack+19280,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+11900,int_stack+0,int_stack+32240,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+48450,int_stack+11900,int_stack+36200,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+11900,int_stack+48450,int_stack+41700,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+29180,int_stack+11900,int_stack+21620,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11900,int_stack+5300,int_stack+4760,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13520,int_stack+5975,int_stack+5300,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+15545,int_stack+13520,int_stack+11900,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+18785,int_stack+6800,int_stack+5975,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+21260,int_stack+18785,int_stack+13520,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+21260,int_stack+15545,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11900,int_stack+7790,int_stack+6800,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+39260,int_stack+11900,int_stack+18785,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+44210,int_stack+39260,int_stack+21260,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+14870,int_stack+44210,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+8960,int_stack+7790,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+22970,int_stack+0,int_stack+11900,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+50960,int_stack+22970,int_stack+39260,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+59210,int_stack+50960,int_stack+44210,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+39260,int_stack+59210,int_stack+14870,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+11900,int_stack+10325,int_stack+8960,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3510,int_stack+11900,int_stack+0,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10530,int_stack+3510,int_stack+22970,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+69335,int_stack+10530,int_stack+50960,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+69335,int_stack+59210,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+50600,int_stack+0,int_stack+39260,15);
 /*--- compute (fp|ki) ---*/
 hrr1_build_fp(Libint->AB,int_stack+65720,int_stack+50600,int_stack+29180,1008);
 return int_stack+65720;}
