/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpli(Libint_t*, prim_data*);

  /* Computes quartets of (fp|li) integrals */

REALTYPE *hrr_order_fpli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[3][14] = int_stack + 4400;
 Libint->vrr_classes[4][8] = int_stack + 5600;
 Libint->vrr_classes[4][9] = int_stack + 6275;
 Libint->vrr_classes[4][10] = int_stack + 7100;
 Libint->vrr_classes[4][11] = int_stack + 8090;
 Libint->vrr_classes[4][12] = int_stack + 9260;
 Libint->vrr_classes[4][13] = int_stack + 10625;
 Libint->vrr_classes[4][14] = int_stack + 12200;
 memset(int_stack,0,14000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpli(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+14000,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+15350,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+17000,int_stack+15350,int_stack+14000,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19700,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+21680,int_stack+19700,int_stack+15350,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+24980,int_stack+21680,int_stack+17000,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14000,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+29480,int_stack+14000,int_stack+19700,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+33440,int_stack+29480,int_stack+21680,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+16340,int_stack+33440,int_stack+24980,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23090,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+38940,int_stack+23090,int_stack+14000,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+43620,int_stack+38940,int_stack+29480,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+50220,int_stack+43620,int_stack+33440,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+25820,int_stack+50220,int_stack+16340,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+14000,int_stack+4400,int_stack+3350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17150,int_stack+14000,int_stack+23090,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+58470,int_stack+17150,int_stack+38940,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+14000,int_stack+58470,int_stack+43620,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+35270,int_stack+14000,int_stack+50220,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+46820,int_stack+35270,int_stack+25820,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+14000,int_stack+6275,int_stack+5600,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+16025,int_stack+7100,int_stack+6275,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18500,int_stack+16025,int_stack+14000,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+22550,int_stack+8090,int_stack+7100,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+25520,int_stack+22550,int_stack+16025,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+30470,int_stack+25520,int_stack+18500,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14000,int_stack+9260,int_stack+8090,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+37220,int_stack+14000,int_stack+22550,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+37220,int_stack+25520,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+17510,int_stack+0,int_stack+30470,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27635,int_stack+10625,int_stack+9260,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+59420,int_stack+27635,int_stack+14000,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+66440,int_stack+59420,int_stack+37220,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+31730,int_stack+66440,int_stack+0,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+76340,int_stack+31730,int_stack+17510,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+12200,int_stack+10625,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4725,int_stack+0,int_stack+27635,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+12915,int_stack+4725,int_stack+59420,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+90515,int_stack+12915,int_stack+66440,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+90515,int_stack+31730,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+17325,int_stack+0,int_stack+76340,15);
 /*--- compute (fp|li) ---*/
 hrr1_build_fp(Libint->AB,int_stack+59420,int_stack+17325,int_stack+46820,1260);
 return int_stack+59420;}
