/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_g0nd(Libint_t*, prim_data*);

  /* Computes quartets of (g0|nd) integrals */

REALTYPE *hrr_order_g0nd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 memset(int_stack,0,3525*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3525;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_g0nd(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3525,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6495,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10005,int_stack+6495,int_stack+3525,15);
 return int_stack+10005;}
