/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdid(Libint_t*, prim_data*);

  /* Computes quartets of (gd|id) integrals */

REALTYPE *hrr_order_gdid(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[5][6] = int_stack + 1635;
 Libint->vrr_classes[5][7] = int_stack + 2223;
 Libint->vrr_classes[5][8] = int_stack + 2979;
 Libint->vrr_classes[6][6] = int_stack + 3924;
 Libint->vrr_classes[6][7] = int_stack + 4708;
 Libint->vrr_classes[6][8] = int_stack + 5716;
 memset(int_stack,0,6976*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6976;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdid(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+6976,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8236,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+9856,int_stack+8236,int_stack+6976,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+6976,int_stack+2223,int_stack+1635,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12376,int_stack+2979,int_stack+2223,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+0,int_stack+12376,int_stack+6976,21);
 /*--- compute (gp|id) ---*/
 hrr1_build_gp(Libint->AB,int_stack+12376,int_stack+0,int_stack+9856,168);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+6976,int_stack+4708,int_stack+3924,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+9328,int_stack+5716,int_stack+4708,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+19936,int_stack+9328,int_stack+6976,28);
 /*--- compute (hp|id) ---*/
 hrr1_build_hp(Libint->AB,int_stack+24640,int_stack+19936,int_stack+0,168);
 /*--- compute (gd|id) ---*/
 hrr1_build_gd(Libint->AB,int_stack+35224,int_stack+24640,int_stack+12376,168);
 return int_stack+35224;}
