/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdli(Libint_t*, prim_data*);

  /* Computes quartets of (gd|li) integrals */

REALTYPE *hrr_order_gdli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[5][8] = int_stack + 8400;
 Libint->vrr_classes[5][9] = int_stack + 9345;
 Libint->vrr_classes[5][10] = int_stack + 10500;
 Libint->vrr_classes[5][11] = int_stack + 11886;
 Libint->vrr_classes[5][12] = int_stack + 13524;
 Libint->vrr_classes[5][13] = int_stack + 15435;
 Libint->vrr_classes[5][14] = int_stack + 17640;
 Libint->vrr_classes[6][8] = int_stack + 20160;
 Libint->vrr_classes[6][9] = int_stack + 21420;
 Libint->vrr_classes[6][10] = int_stack + 22960;
 Libint->vrr_classes[6][11] = int_stack + 24808;
 Libint->vrr_classes[6][12] = int_stack + 26992;
 Libint->vrr_classes[6][13] = int_stack + 29540;
 Libint->vrr_classes[6][14] = int_stack + 32480;
 memset(int_stack,0,35840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 35840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdli(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35840,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+37865,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+40340,int_stack+37865,int_stack+35840,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44390,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47360,int_stack+44390,int_stack+37865,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+52310,int_stack+47360,int_stack+40340,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+35840,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+59060,int_stack+35840,int_stack+44390,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+65000,int_stack+59060,int_stack+47360,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+39350,int_stack+65000,int_stack+52310,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49475,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+73250,int_stack+49475,int_stack+35840,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+80270,int_stack+73250,int_stack+59060,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+90170,int_stack+80270,int_stack+65000,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+53570,int_stack+90170,int_stack+39350,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35840,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+40565,int_stack+35840,int_stack+49475,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+102545,int_stack+40565,int_stack+73250,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+35840,int_stack+102545,int_stack+80270,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+67745,int_stack+35840,int_stack+90170,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+85070,int_stack+67745,int_stack+53570,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35840,int_stack+9345,int_stack+8400,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38675,int_stack+10500,int_stack+9345,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+42140,int_stack+38675,int_stack+35840,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+47810,int_stack+11886,int_stack+10500,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+51968,int_stack+47810,int_stack+38675,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+58898,int_stack+51968,int_stack+42140,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+35840,int_stack+13524,int_stack+11886,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+68348,int_stack+35840,int_stack+47810,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+68348,int_stack+51968,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+40754,int_stack+0,int_stack+58898,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54929,int_stack+15435,int_stack+13524,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+103970,int_stack+54929,int_stack+35840,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+113798,int_stack+103970,int_stack+68348,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+60662,int_stack+113798,int_stack+0,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+127658,int_stack+60662,int_stack+40754,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+17640,int_stack+15435,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+54929,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+35840,int_stack+6615,int_stack+103970,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+147503,int_stack+35840,int_stack+113798,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+35840,int_stack+147503,int_stack+60662,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+147503,int_stack+35840,int_stack+127658,21);
 /*--- compute (gp|li) ---*/
 hrr1_build_gp(Libint->AB,int_stack+173963,int_stack+147503,int_stack+85070,1260);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+35840,int_stack+21420,int_stack+20160,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+39620,int_stack+22960,int_stack+21420,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44240,int_stack+39620,int_stack+35840,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51800,int_stack+24808,int_stack+22960,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57344,int_stack+51800,int_stack+39620,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+66584,int_stack+57344,int_stack+44240,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+35840,int_stack+26992,int_stack+24808,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79184,int_stack+35840,int_stack+51800,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+90272,int_stack+79184,int_stack+57344,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+42392,int_stack+90272,int_stack+66584,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+61292,int_stack+29540,int_stack+26992,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+105672,int_stack+61292,int_stack+35840,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+118776,int_stack+105672,int_stack+79184,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+118776,int_stack+90272,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+68936,int_stack+0,int_stack+42392,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+35840,int_stack+32480,int_stack+29540,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+44660,int_stack+35840,int_stack+61292,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+230663,int_stack+44660,int_stack+105672,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+23100,int_stack+230663,int_stack+118776,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+95396,int_stack+23100,int_stack+0,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+95396,int_stack+68936,28);
 /*--- compute (hp|li) ---*/
 hrr1_build_hp(Libint->AB,int_stack+35280,int_stack+0,int_stack+147503,1260);
 /*--- compute (gd|li) ---*/
 hrr1_build_gd(Libint->AB,int_stack+230663,int_stack+35280,int_stack+173963,1260);
 return int_stack+230663;}
