/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdnn(Libint_t*, prim_data*);

  /* Computes quartets of (gd|nn) integrals */

REALTYPE *hrr_order_gdnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[4][18] = int_stack + 13800;
 Libint->vrr_classes[4][19] = int_stack + 16650;
 Libint->vrr_classes[4][20] = int_stack + 19800;
 Libint->vrr_classes[5][10] = int_stack + 23265;
 Libint->vrr_classes[5][11] = int_stack + 24651;
 Libint->vrr_classes[5][12] = int_stack + 26289;
 Libint->vrr_classes[5][13] = int_stack + 28200;
 Libint->vrr_classes[5][14] = int_stack + 30405;
 Libint->vrr_classes[5][15] = int_stack + 32925;
 Libint->vrr_classes[5][16] = int_stack + 35781;
 Libint->vrr_classes[5][17] = int_stack + 38994;
 Libint->vrr_classes[5][18] = int_stack + 42585;
 Libint->vrr_classes[5][19] = int_stack + 46575;
 Libint->vrr_classes[5][20] = int_stack + 50985;
 Libint->vrr_classes[6][10] = int_stack + 55836;
 Libint->vrr_classes[6][11] = int_stack + 57684;
 Libint->vrr_classes[6][12] = int_stack + 59868;
 Libint->vrr_classes[6][13] = int_stack + 62416;
 Libint->vrr_classes[6][14] = int_stack + 65356;
 Libint->vrr_classes[6][15] = int_stack + 68716;
 Libint->vrr_classes[6][16] = int_stack + 72524;
 Libint->vrr_classes[6][17] = int_stack + 76808;
 Libint->vrr_classes[6][18] = int_stack + 81596;
 Libint->vrr_classes[6][19] = int_stack + 86916;
 Libint->vrr_classes[6][20] = int_stack + 92796;
 memset(int_stack,0,99264*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 99264;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdnn(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+99264,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+102234,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+105744,int_stack+102234,int_stack+99264,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+111684,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115779,int_stack+111684,int_stack+102234,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122799,int_stack+115779,int_stack+105744,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99264,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+132699,int_stack+99264,int_stack+111684,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+103989,int_stack+132699,int_stack+115779,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+140889,int_stack+103989,int_stack+122799,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+115689,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+121089,int_stack+115689,int_stack+99264,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+155739,int_stack+121089,int_stack+132699,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+169389,int_stack+155739,int_stack+103989,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+186939,int_stack+169389,int_stack+140889,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+99264,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+130539,int_stack+99264,int_stack+115689,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+207729,int_stack+130539,int_stack+121089,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+105384,int_stack+207729,int_stack+155739,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+141339,int_stack+105384,int_stack+169389,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+223479,int_stack+141339,int_stack+186939,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+165909,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+172794,int_stack+165909,int_stack+99264,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+185034,int_stack+172794,int_stack+130539,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+251199,int_stack+185034,int_stack+207729,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+274824,int_stack+251199,int_stack+105384,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+99264,int_stack+274824,int_stack+141339,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+303489,int_stack+99264,int_stack+223479,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+132024,int_stack+13800,int_stack+11235,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+139719,int_stack+132024,int_stack+165909,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+203034,int_stack+139719,int_stack+172794,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+153489,int_stack+203034,int_stack+185034,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+339129,int_stack+153489,int_stack+251199,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+223434,int_stack+339129,int_stack+274824,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+372204,int_stack+223434,int_stack+99264,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+414324,int_stack+372204,int_stack+303489,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+99264,int_stack+16650,int_stack+13800,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+107814,int_stack+99264,int_stack+132024,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+261654,int_stack+107814,int_stack+139719,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+284604,int_stack+261654,int_stack+203034,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+180489,int_stack+284604,int_stack+153489,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+123204,int_stack+180489,int_stack+339129,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+315204,int_stack+123204,int_stack+223434,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+458874,int_stack+315204,int_stack+372204,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+511524,int_stack+458874,int_stack+414324,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+167304,int_stack+19800,int_stack+16650,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+218289,int_stack+167304,int_stack+99264,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+235389,int_stack+218289,int_stack+107814,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+364344,int_stack+235389,int_stack+261654,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+218289,int_stack+364344,int_stack+284604,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+364344,int_stack+218289,int_stack+180489,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+167304,int_stack+364344,int_stack+123204,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+364344,int_stack+167304,int_stack+315204,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+99264,int_stack+364344,int_stack+458874,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+163614,int_stack+99264,int_stack+511524,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+99264,int_stack+24651,int_stack+23265,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103422,int_stack+26289,int_stack+24651,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108336,int_stack+103422,int_stack+99264,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+116652,int_stack+28200,int_stack+26289,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+122385,int_stack+116652,int_stack+103422,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+132213,int_stack+122385,int_stack+108336,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99264,int_stack+30405,int_stack+28200,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+146073,int_stack+99264,int_stack+116652,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+105879,int_stack+146073,int_stack+122385,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228954,int_stack+105879,int_stack+132213,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+122259,int_stack+32925,int_stack+30405,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+129819,int_stack+122259,int_stack+99264,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+249744,int_stack+129819,int_stack+146073,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+268854,int_stack+249744,int_stack+105879,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+293424,int_stack+268854,int_stack+228954,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+228954,int_stack+35781,int_stack+32925,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+99264,int_stack+228954,int_stack+122259,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+322530,int_stack+99264,int_stack+129819,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+114384,int_stack+322530,int_stack+249744,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+344580,int_stack+114384,int_stack+268854,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+237522,int_stack+344580,int_stack+293424,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+276330,int_stack+38994,int_stack+35781,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+285969,int_stack+276330,int_stack+228954,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+378978,int_stack+285969,int_stack+99264,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+404178,int_stack+378978,int_stack+322530,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+303105,int_stack+404178,int_stack+114384,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+99264,int_stack+303105,int_stack+344580,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+437253,int_stack+99264,int_stack+237522,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+145128,int_stack+42585,int_stack+38994,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+228954,int_stack+145128,int_stack+276330,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+248232,int_stack+228954,int_stack+285969,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+487149,int_stack+248232,int_stack+378978,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+343236,int_stack+487149,int_stack+404178,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+524949,int_stack+343236,int_stack+303105,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+276792,int_stack+524949,int_stack+99264,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+578457,int_stack+276792,int_stack+437253,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+99264,int_stack+46575,int_stack+42585,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+111234,int_stack+99264,int_stack+145128,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+389541,int_stack+111234,int_stack+228954,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+421671,int_stack+389541,int_stack+248232,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+640827,int_stack+421671,int_stack+487149,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+693747,int_stack+640827,int_stack+343236,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+755487,int_stack+693747,int_stack+524949,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+464511,int_stack+755487,int_stack+276792,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+228954,int_stack+464511,int_stack+578457,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+305184,int_stack+50985,int_stack+46575,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+318414,int_stack+305184,int_stack+99264,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+342354,int_stack+318414,int_stack+111234,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+99264,int_stack+342354,int_stack+389541,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+305184,int_stack+99264,int_stack+421671,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+365160,int_stack+305184,int_stack+640827,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+538221,int_stack+365160,int_stack+693747,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+305184,int_stack+538221,int_stack+755487,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+538221,int_stack+305184,int_stack+464511,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+305184,int_stack+538221,int_stack+228954,21);
 /*--- compute (gp|nn) ---*/
 hrr1_build_gp(Libint->AB,int_stack+396660,int_stack+305184,int_stack+163614,4356);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+592680,int_stack+57684,int_stack+55836,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+598224,int_stack+59868,int_stack+57684,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+604776,int_stack+598224,int_stack+592680,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+615864,int_stack+62416,int_stack+59868,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+623508,int_stack+615864,int_stack+598224,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+636612,int_stack+623508,int_stack+604776,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+592680,int_stack+65356,int_stack+62416,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+655092,int_stack+592680,int_stack+615864,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+601500,int_stack+655092,int_stack+623508,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+670380,int_stack+601500,int_stack+636612,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+623340,int_stack+68716,int_stack+65356,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+633420,int_stack+623340,int_stack+592680,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+698100,int_stack+633420,int_stack+655092,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+723580,int_stack+698100,int_stack+601500,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+756340,int_stack+723580,int_stack+670380,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+592680,int_stack+72524,int_stack+68716,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+651060,int_stack+592680,int_stack+623340,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+795148,int_stack+651060,int_stack+633420,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+604104,int_stack+795148,int_stack+698100,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+671220,int_stack+604104,int_stack+723580,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+99264,int_stack+671220,int_stack+756340,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+717084,int_stack+76808,int_stack+72524,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+729936,int_stack+717084,int_stack+592680,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+752784,int_stack+729936,int_stack+651060,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+151008,int_stack+752784,int_stack+795148,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+195108,int_stack+151008,int_stack+604104,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+592680,int_stack+195108,int_stack+671220,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+592680,int_stack+99264,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+99264,int_stack+81596,int_stack+76808,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+113628,int_stack+99264,int_stack+717084,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+653832,int_stack+113628,int_stack+729936,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+691912,int_stack+653832,int_stack+752784,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+742312,int_stack+691912,int_stack+151008,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+804052,int_stack+742312,int_stack+195108,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+139332,int_stack+804052,int_stack+592680,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+217956,int_stack+139332,int_stack+0,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+86916,int_stack+81596,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+15960,int_stack+0,int_stack+99264,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+592680,int_stack+15960,int_stack+113628,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+875396,int_stack+592680,int_stack+653832,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+932516,int_stack+875396,int_stack+691912,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+635520,int_stack+932516,int_stack+742312,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1003076,int_stack+635520,int_stack+804052,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+717840,int_stack+1003076,int_stack+139332,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+99264,int_stack+717840,int_stack+217956,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+200904,int_stack+92796,int_stack+86916,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+218544,int_stack+200904,int_stack+0,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+250464,int_stack+218544,int_stack+15960,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+0,int_stack+250464,int_stack+592680,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+200904,int_stack+0,int_stack+875396,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+200904,int_stack+932516,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+816120,int_stack+0,int_stack+635520,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+592680,int_stack+816120,int_stack+1003076,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+816120,int_stack+592680,int_stack+717840,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+592680,int_stack+816120,int_stack+99264,28);
 /*--- compute (hp|nn) ---*/
 hrr1_build_hp(Libint->AB,int_stack+714648,int_stack+592680,int_stack+305184,4356);
 /*--- compute (gd|nn) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+714648,int_stack+396660,4356);
 return int_stack+0;}
