/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfkf(Libint_t*, prim_data*);

  /* Computes quartets of (gf|kf) integrals */

REALTYPE *hrr_order_gfkf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[5][7] = int_stack + 3030;
 Libint->vrr_classes[5][8] = int_stack + 3786;
 Libint->vrr_classes[5][9] = int_stack + 4731;
 Libint->vrr_classes[5][10] = int_stack + 5886;
 Libint->vrr_classes[6][7] = int_stack + 7272;
 Libint->vrr_classes[6][8] = int_stack + 8280;
 Libint->vrr_classes[6][9] = int_stack + 9540;
 Libint->vrr_classes[6][10] = int_stack + 11080;
 Libint->vrr_classes[7][7] = int_stack + 12928;
 Libint->vrr_classes[7][8] = int_stack + 14224;
 Libint->vrr_classes[7][9] = int_stack + 15844;
 Libint->vrr_classes[7][10] = int_stack + 17824;
 memset(int_stack,0,20200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 20200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfkf(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+20200,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+21820,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+23845,int_stack+21820,int_stack+20200,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27085,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+29560,int_stack+27085,int_stack+21820,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+33610,int_stack+29560,int_stack+23845,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+20200,int_stack+3786,int_stack+3030,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+22468,int_stack+4731,int_stack+3786,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25303,int_stack+22468,int_stack+20200,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+29839,int_stack+5886,int_stack+4731,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+29839,int_stack+22468,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+39010,int_stack+0,int_stack+25303,21);
 /*--- compute (gp|kf) ---*/
 hrr1_build_gp(Libint->AB,int_stack+46570,int_stack+39010,int_stack+33610,360);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+8280,int_stack+7272,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3024,int_stack+9540,int_stack+8280,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+20200,int_stack+3024,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+26248,int_stack+11080,int_stack+9540,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30868,int_stack+26248,int_stack+3024,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+30868,int_stack+20200,28);
 /*--- compute (hp|kf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+62770,int_stack+0,int_stack+39010,360);
 /*--- compute (gd|kf) ---*/
 hrr1_build_gd(Libint->AB,int_stack+85450,int_stack+62770,int_stack+46570,360);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+20200,int_stack+14224,int_stack+12928,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+24088,int_stack+15844,int_stack+14224,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+28948,int_stack+24088,int_stack+20200,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+36724,int_stack+17824,int_stack+15844,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+42664,int_stack+36724,int_stack+24088,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+10080,int_stack+42664,int_stack+28948,36);
 /*--- compute (ip|kf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+23040,int_stack+10080,int_stack+0,360);
 /*--- compute (hd|kf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+117850,int_stack+23040,int_stack+62770,360);
 /*--- compute (gf|kf) ---*/
 hrr1_build_gf(Libint->AB,int_stack+0,int_stack+117850,int_stack+85450,360);
 return int_stack+0;}
