/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gfkp(Libint_t*, prim_data*);

  /* Computes quartets of (gf|kp) integrals */

REALTYPE *hrr_order_gfkp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[5][7] = int_stack + 1215;
 Libint->vrr_classes[5][8] = int_stack + 1971;
 Libint->vrr_classes[6][7] = int_stack + 2916;
 Libint->vrr_classes[6][8] = int_stack + 3924;
 Libint->vrr_classes[7][7] = int_stack + 5184;
 Libint->vrr_classes[7][8] = int_stack + 6480;
 memset(int_stack,0,8100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gfkp(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8100,int_stack+540,int_stack+0,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+9720,int_stack+1971,int_stack+1215,21);
 /*--- compute (gp|kp) ---*/
 hrr1_build_gp(Libint->AB,int_stack+11988,int_stack+9720,int_stack+8100,108);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+16848,int_stack+3924,int_stack+2916,28);
 /*--- compute (hp|kp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+19872,int_stack+16848,int_stack+9720,108);
 /*--- compute (gd|kp) ---*/
 hrr1_build_gd(Libint->AB,int_stack+26676,int_stack+19872,int_stack+11988,108);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8100,int_stack+6480,int_stack+5184,36);
 /*--- compute (ip|kp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+36396,int_stack+8100,int_stack+16848,108);
 /*--- compute (hd|kp) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+36396,int_stack+19872,108);
 /*--- compute (gf|kp) ---*/
 hrr1_build_gf(Libint->AB,int_stack+36396,int_stack+0,int_stack+26676,108);
 return int_stack+36396;}
