/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gplg(Libint_t*, prim_data*);

  /* Computes quartets of (gp|lg) integrals */

REALTYPE *hrr_order_gplg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[5][8] = int_stack + 5025;
 Libint->vrr_classes[5][9] = int_stack + 5970;
 Libint->vrr_classes[5][10] = int_stack + 7125;
 Libint->vrr_classes[5][11] = int_stack + 8511;
 Libint->vrr_classes[5][12] = int_stack + 10149;
 memset(int_stack,0,12060*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 12060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gplg(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12060,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14085,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16560,int_stack+14085,int_stack+12060,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+20610,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23580,int_stack+20610,int_stack+14085,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+28530,int_stack+23580,int_stack+16560,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12060,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35280,int_stack+12060,int_stack+20610,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+12060,int_stack+35280,int_stack+23580,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+35280,int_stack+12060,int_stack+28530,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12060,int_stack+5970,int_stack+5025,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14895,int_stack+7125,int_stack+5970,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18360,int_stack+14895,int_stack+12060,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+24030,int_stack+8511,int_stack+7125,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28188,int_stack+24030,int_stack+14895,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+45405,int_stack+28188,int_stack+18360,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12060,int_stack+10149,int_stack+8511,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+12060,int_stack+24030,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+8316,int_stack+0,int_stack+28188,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+19866,int_stack+8316,int_stack+45405,21);
 /*--- compute (gp|lg) ---*/
 hrr1_build_gp(Libint->AB,int_stack+45405,int_stack+19866,int_stack+35280,675);
 return int_stack+45405;}
