/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdkh(Libint_t*, prim_data*);

  /* Computes quartets of (hd|kh) integrals */

REALTYPE *hrr_order_hdkh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[6][7] = int_stack + 7791;
 Libint->vrr_classes[6][8] = int_stack + 8799;
 Libint->vrr_classes[6][9] = int_stack + 10059;
 Libint->vrr_classes[6][10] = int_stack + 11599;
 Libint->vrr_classes[6][11] = int_stack + 13447;
 Libint->vrr_classes[6][12] = int_stack + 15631;
 Libint->vrr_classes[7][7] = int_stack + 18179;
 Libint->vrr_classes[7][8] = int_stack + 19475;
 Libint->vrr_classes[7][9] = int_stack + 21095;
 Libint->vrr_classes[7][10] = int_stack + 23075;
 Libint->vrr_classes[7][11] = int_stack + 25451;
 Libint->vrr_classes[7][12] = int_stack + 28259;
 memset(int_stack,0,31535*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 31535;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdkh(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+31535,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+33803,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+36638,int_stack+33803,int_stack+31535,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41174,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44639,int_stack+41174,int_stack+33803,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+50309,int_stack+44639,int_stack+36638,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31535,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57869,int_stack+31535,int_stack+41174,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+64799,int_stack+57869,int_stack+44639,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+35693,int_stack+64799,int_stack+50309,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+47033,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+74249,int_stack+47033,int_stack+31535,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+82565,int_stack+74249,int_stack+57869,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+47033,int_stack+82565,int_stack+64799,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+61208,int_stack+47033,int_stack+35693,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+31535,int_stack+8799,int_stack+7791,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+34559,int_stack+10059,int_stack+8799,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+38339,int_stack+34559,int_stack+31535,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44387,int_stack+11599,int_stack+10059,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49007,int_stack+44387,int_stack+34559,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+77084,int_stack+49007,int_stack+38339,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31535,int_stack+13447,int_stack+11599,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+31535,int_stack+44387,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+87164,int_stack+0,int_stack+49007,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+37079,int_stack+87164,int_stack+77084,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+77084,int_stack+15631,int_stack+13447,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+99764,int_stack+77084,int_stack+31535,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+110852,int_stack+99764,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+126252,int_stack+110852,int_stack+87164,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+77084,int_stack+126252,int_stack+37079,28);
 /*--- compute (hp|kh) ---*/
 hrr1_build_hp(Libint->AB,int_stack+98252,int_stack+77084,int_stack+61208,756);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+19475,int_stack+18179,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3888,int_stack+21095,int_stack+19475,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+8748,int_stack+3888,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31535,int_stack+23075,int_stack+21095,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+37475,int_stack+31535,int_stack+3888,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+47195,int_stack+37475,int_stack+8748,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+25451,int_stack+23075,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7128,int_stack+0,int_stack+31535,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+60155,int_stack+7128,int_stack+37475,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+145880,int_stack+60155,int_stack+47195,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31535,int_stack+28259,int_stack+25451,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39959,int_stack+31535,int_stack+0,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+19008,int_stack+39959,int_stack+7128,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+165320,int_stack+19008,int_stack+60155,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+165320,int_stack+145880,36);
 /*--- compute (ip|kh) ---*/
 hrr1_build_ip(Libint->AB,int_stack+145880,int_stack+0,int_stack+77084,756);
 /*--- compute (hd|kh) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+145880,int_stack+98252,756);
 return int_stack+0;}
