/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdki(Libint_t*, prim_data*);

  /* Computes quartets of (hd|ki) integrals */

REALTYPE *hrr_order_hdki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[6][7] = int_stack + 9996;
 Libint->vrr_classes[6][8] = int_stack + 11004;
 Libint->vrr_classes[6][9] = int_stack + 12264;
 Libint->vrr_classes[6][10] = int_stack + 13804;
 Libint->vrr_classes[6][11] = int_stack + 15652;
 Libint->vrr_classes[6][12] = int_stack + 17836;
 Libint->vrr_classes[6][13] = int_stack + 20384;
 Libint->vrr_classes[7][7] = int_stack + 23324;
 Libint->vrr_classes[7][8] = int_stack + 24620;
 Libint->vrr_classes[7][9] = int_stack + 26240;
 Libint->vrr_classes[7][10] = int_stack + 28220;
 Libint->vrr_classes[7][11] = int_stack + 30596;
 Libint->vrr_classes[7][12] = int_stack + 33404;
 Libint->vrr_classes[7][13] = int_stack + 36680;
 memset(int_stack,0,40460*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40460;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdki(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40460,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+42728,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+45563,int_stack+42728,int_stack+40460,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50099,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+53564,int_stack+50099,int_stack+42728,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59234,int_stack+53564,int_stack+45563,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40460,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66794,int_stack+40460,int_stack+50099,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+73724,int_stack+66794,int_stack+53564,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+44618,int_stack+73724,int_stack+59234,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+55958,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+83174,int_stack+55958,int_stack+40460,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+91490,int_stack+83174,int_stack+66794,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+103040,int_stack+91490,int_stack+73724,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+60872,int_stack+103040,int_stack+44618,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+40460,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+40460,int_stack+55958,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+40460,int_stack+0,int_stack+83174,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+117215,int_stack+40460,int_stack+91490,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+40460,int_stack+117215,int_stack+103040,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+76748,int_stack+40460,int_stack+60872,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40460,int_stack+11004,int_stack+9996,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43484,int_stack+12264,int_stack+11004,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47264,int_stack+43484,int_stack+40460,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+53312,int_stack+13804,int_stack+12264,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+57932,int_stack+53312,int_stack+43484,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+65492,int_stack+57932,int_stack+47264,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40460,int_stack+15652,int_stack+13804,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+40460,int_stack+53312,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+97916,int_stack+0,int_stack+57932,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+46004,int_stack+97916,int_stack+65492,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61124,int_stack+17836,int_stack+15652,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110516,int_stack+61124,int_stack+40460,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+121604,int_stack+110516,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+137004,int_stack+121604,int_stack+97916,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+155904,int_stack+137004,int_stack+46004,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+97916,int_stack+20384,int_stack+17836,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+97916,int_stack+61124,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+40460,int_stack+0,int_stack+110516,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+40460,int_stack+121604,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+40460,int_stack+0,int_stack+137004,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+97916,int_stack+40460,int_stack+155904,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+126140,int_stack+97916,int_stack+76748,1008);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40460,int_stack+24620,int_stack+23324,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+44348,int_stack+26240,int_stack+24620,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+49208,int_stack+44348,int_stack+40460,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+56984,int_stack+28220,int_stack+26240,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+62924,int_stack+56984,int_stack+44348,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+72644,int_stack+62924,int_stack+49208,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40460,int_stack+30596,int_stack+28220,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+85604,int_stack+40460,int_stack+56984,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+85604,int_stack+62924,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+47588,int_stack+0,int_stack+72644,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67028,int_stack+33404,int_stack+30596,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16200,int_stack+67028,int_stack+40460,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+189644,int_stack+16200,int_stack+85604,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+209444,int_stack+189644,int_stack+0,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+233744,int_stack+209444,int_stack+47588,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+36680,int_stack+33404,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+75452,int_stack+0,int_stack+67028,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30456,int_stack+75452,int_stack+16200,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+30456,int_stack+189644,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+29700,int_stack+0,int_stack+209444,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+189644,int_stack+29700,int_stack+233744,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+189644,int_stack+97916,1008);
 /*--- compute (hd|ki) ---*/
 hrr1_build_hd(Libint->AB,int_stack+189644,int_stack+0,int_stack+126140,1008);
 return int_stack+189644;}
