/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdml(Libint_t*, prim_data*);

  /* Computes quartets of (hd|ml) integrals */

REALTYPE *hrr_order_hdml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[6][9] = int_stack + 20475;
 Libint->vrr_classes[6][10] = int_stack + 22015;
 Libint->vrr_classes[6][11] = int_stack + 23863;
 Libint->vrr_classes[6][12] = int_stack + 26047;
 Libint->vrr_classes[6][13] = int_stack + 28595;
 Libint->vrr_classes[6][14] = int_stack + 31535;
 Libint->vrr_classes[6][15] = int_stack + 34895;
 Libint->vrr_classes[6][16] = int_stack + 38703;
 Libint->vrr_classes[6][17] = int_stack + 42987;
 Libint->vrr_classes[7][9] = int_stack + 47775;
 Libint->vrr_classes[7][10] = int_stack + 49755;
 Libint->vrr_classes[7][11] = int_stack + 52131;
 Libint->vrr_classes[7][12] = int_stack + 54939;
 Libint->vrr_classes[7][13] = int_stack + 58215;
 Libint->vrr_classes[7][14] = int_stack + 61995;
 Libint->vrr_classes[7][15] = int_stack + 66315;
 Libint->vrr_classes[7][16] = int_stack + 71211;
 Libint->vrr_classes[7][17] = int_stack + 76719;
 memset(int_stack,0,82875*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 82875;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdml(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+82875,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86340,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+90498,int_stack+86340,int_stack+82875,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+97428,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+102342,int_stack+97428,int_stack+86340,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+110658,int_stack+102342,int_stack+90498,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82875,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+122208,int_stack+82875,int_stack+97428,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+132036,int_stack+122208,int_stack+102342,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+88608,int_stack+132036,int_stack+110658,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+105933,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+145896,int_stack+105933,int_stack+82875,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+157362,int_stack+145896,int_stack+122208,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+173742,int_stack+157362,int_stack+132036,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+112548,int_stack+173742,int_stack+88608,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+82875,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90435,int_stack+82875,int_stack+105933,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+194532,int_stack+90435,int_stack+145896,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+213642,int_stack+194532,int_stack+157362,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+136803,int_stack+213642,int_stack+173742,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+238212,int_stack+136803,int_stack+112548,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+103665,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+112233,int_stack+103665,int_stack+82875,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+165909,int_stack+112233,int_stack+90435,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+270552,int_stack+165909,int_stack+194532,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+299217,int_stack+270552,int_stack+213642,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+187959,int_stack+299217,int_stack+136803,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+333615,int_stack+187959,int_stack+238212,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+82875,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+127353,int_stack+82875,int_stack+103665,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+82875,int_stack+127353,int_stack+112233,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+108075,int_stack+82875,int_stack+165909,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+141150,int_stack+108075,int_stack+270552,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+82875,int_stack+141150,int_stack+299217,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+128739,int_stack+82875,int_stack+187959,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+178635,int_stack+128739,int_stack+333615,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+82875,int_stack+22015,int_stack+20475,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87495,int_stack+23863,int_stack+22015,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+93039,int_stack+87495,int_stack+82875,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+102279,int_stack+26047,int_stack+23863,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108831,int_stack+102279,int_stack+87495,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+119919,int_stack+108831,int_stack+93039,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82875,int_stack+28595,int_stack+26047,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+135319,int_stack+82875,int_stack+102279,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+148423,int_stack+135319,int_stack+108831,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+90519,int_stack+148423,int_stack+119919,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+113619,int_stack+31535,int_stack+28595,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+230610,int_stack+113619,int_stack+82875,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+245898,int_stack+230610,int_stack+135319,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+267738,int_stack+245898,int_stack+148423,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+122439,int_stack+267738,int_stack+90519,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+82875,int_stack+34895,int_stack+31535,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+92955,int_stack+82875,int_stack+113619,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+295458,int_stack+92955,int_stack+230610,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+320938,int_stack+295458,int_stack+245898,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+353698,int_stack+320938,int_stack+267738,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+230610,int_stack+353698,int_stack+122439,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+273730,int_stack+38703,int_stack+34895,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+110595,int_stack+273730,int_stack+82875,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+130755,int_stack+110595,int_stack+92955,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+130755,int_stack+295458,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+392506,int_stack+0,int_stack+320938,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+285154,int_stack+392506,int_stack+353698,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+336898,int_stack+285154,int_stack+230610,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+230610,int_stack+42987,int_stack+38703,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+243462,int_stack+230610,int_stack+273730,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+438370,int_stack+243462,int_stack+110595,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+230610,int_stack+438370,int_stack+130755,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+82875,int_stack+230610,int_stack+0,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+438370,int_stack+82875,int_stack+392506,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+82875,int_stack+438370,int_stack+285154,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+230610,int_stack+82875,int_stack+336898,28);
 /*--- compute (hp|ml) ---*/
 hrr1_build_hp(Libint->AB,int_stack+299910,int_stack+230610,int_stack+178635,2475);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+82875,int_stack+49755,int_stack+47775,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88815,int_stack+52131,int_stack+49755,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+95943,int_stack+88815,int_stack+82875,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+107823,int_stack+54939,int_stack+52131,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+116247,int_stack+107823,int_stack+88815,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+130503,int_stack+116247,int_stack+95943,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+82875,int_stack+58215,int_stack+54939,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+150303,int_stack+82875,int_stack+107823,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+167151,int_stack+150303,int_stack+116247,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92703,int_stack+167151,int_stack+130503,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+122403,int_stack+61995,int_stack+58215,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+190911,int_stack+122403,int_stack+82875,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+190911,int_stack+150303,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+455835,int_stack+0,int_stack+167151,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+133743,int_stack+455835,int_stack+92703,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+82875,int_stack+66315,int_stack+61995,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+95835,int_stack+82875,int_stack+122403,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+28080,int_stack+95835,int_stack+190911,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+175323,int_stack+28080,int_stack+0,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+491475,int_stack+175323,int_stack+455835,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+541371,int_stack+491475,int_stack+133743,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+455835,int_stack+71211,int_stack+66315,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+455835,int_stack+82875,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+118515,int_stack+0,int_stack+95835,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+596811,int_stack+118515,int_stack+28080,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+645951,int_stack+596811,int_stack+175323,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+156315,int_stack+645951,int_stack+491475,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+704919,int_stack+156315,int_stack+541371,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+82875,int_stack+76719,int_stack+71211,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+470523,int_stack+82875,int_stack+455835,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+499899,int_stack+470523,int_stack+0,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+499899,int_stack+118515,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+56700,int_stack+0,int_stack+596811,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+455835,int_stack+56700,int_stack+645951,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+455835,int_stack+156315,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+455835,int_stack+0,int_stack+704919,36);
 /*--- compute (ip|ml) ---*/
 hrr1_build_ip(Libint->AB,int_stack+0,int_stack+455835,int_stack+230610,2475);
 /*--- compute (hd|ml) ---*/
 hrr1_build_hd(Libint->AB,int_stack+455835,int_stack+0,int_stack+299910,2475);
 return int_stack+455835;}
