/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfkp(Libint_t*, prim_data*);

  /* Computes quartets of (hf|kp) integrals */

REALTYPE *hrr_order_hfkp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[6][7] = int_stack + 1701;
 Libint->vrr_classes[6][8] = int_stack + 2709;
 Libint->vrr_classes[7][7] = int_stack + 3969;
 Libint->vrr_classes[7][8] = int_stack + 5265;
 Libint->vrr_classes[8][7] = int_stack + 6885;
 Libint->vrr_classes[8][8] = int_stack + 8505;
 memset(int_stack,0,10530*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10530;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfkp(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10530,int_stack+756,int_stack+0,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12798,int_stack+2709,int_stack+1701,28);
 /*--- compute (hp|kp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+15822,int_stack+12798,int_stack+10530,108);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+5265,int_stack+3969,36);
 /*--- compute (ip|kp) ---*/
 hrr1_build_ip(Libint->AB,int_stack+22626,int_stack+0,int_stack+12798,108);
 /*--- compute (hd|kp) ---*/
 hrr1_build_hd(Libint->AB,int_stack+31698,int_stack+22626,int_stack+15822,108);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+10530,int_stack+8505,int_stack+6885,45);
 /*--- compute (kp|kp) ---*/
 hrr1_build_kp(Libint->AB,int_stack+45306,int_stack+10530,int_stack+0,108);
 /*--- compute (id|kp) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+45306,int_stack+22626,108);
 /*--- compute (hf|kp) ---*/
 hrr1_build_hf(Libint->AB,int_stack+45306,int_stack+0,int_stack+31698,108);
 return int_stack+45306;}
