/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hglg(Libint_t*, prim_data*);

  /* Computes quartets of (hg|lg) integrals */

REALTYPE *hrr_order_hglg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[6][8] = int_stack + 7035;
 Libint->vrr_classes[6][9] = int_stack + 8295;
 Libint->vrr_classes[6][10] = int_stack + 9835;
 Libint->vrr_classes[6][11] = int_stack + 11683;
 Libint->vrr_classes[6][12] = int_stack + 13867;
 Libint->vrr_classes[7][8] = int_stack + 16415;
 Libint->vrr_classes[7][9] = int_stack + 18035;
 Libint->vrr_classes[7][10] = int_stack + 20015;
 Libint->vrr_classes[7][11] = int_stack + 22391;
 Libint->vrr_classes[7][12] = int_stack + 25199;
 Libint->vrr_classes[8][8] = int_stack + 28475;
 Libint->vrr_classes[8][9] = int_stack + 30500;
 Libint->vrr_classes[8][10] = int_stack + 32975;
 Libint->vrr_classes[8][11] = int_stack + 35945;
 Libint->vrr_classes[8][12] = int_stack + 39455;
 Libint->vrr_classes[9][8] = int_stack + 43550;
 Libint->vrr_classes[9][9] = int_stack + 46025;
 Libint->vrr_classes[9][10] = int_stack + 49050;
 Libint->vrr_classes[9][11] = int_stack + 52680;
 Libint->vrr_classes[9][12] = int_stack + 56970;
 memset(int_stack,0,61975*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 61975;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hglg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+61975,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+64810,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+68275,int_stack+64810,int_stack+61975,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+73945,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+78103,int_stack+73945,int_stack+64810,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85033,int_stack+78103,int_stack+68275,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61975,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+94483,int_stack+61975,int_stack+73945,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61975,int_stack+94483,int_stack+78103,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+94483,int_stack+61975,int_stack+85033,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+61975,int_stack+8295,int_stack+7035,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+65755,int_stack+9835,int_stack+8295,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+70375,int_stack+65755,int_stack+61975,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77935,int_stack+11683,int_stack+9835,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+83479,int_stack+77935,int_stack+65755,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+108658,int_stack+83479,int_stack+70375,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61975,int_stack+13867,int_stack+11683,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+61975,int_stack+77935,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61975,int_stack+0,int_stack+83479,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+121258,int_stack+61975,int_stack+108658,28);
 /*--- compute (hp|lg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+140158,int_stack+121258,int_stack+94483,675);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+61975,int_stack+18035,int_stack+16415,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66835,int_stack+20015,int_stack+18035,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+72775,int_stack+66835,int_stack+61975,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82495,int_stack+22391,int_stack+20015,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+89623,int_stack+82495,int_stack+66835,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+101503,int_stack+89623,int_stack+72775,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61975,int_stack+25199,int_stack+22391,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+61975,int_stack+82495,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+61975,int_stack+0,int_stack+89623,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+61975,int_stack+101503,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+61975,int_stack+0,int_stack+121258,675);
 /*--- compute (hd|lg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+182683,int_stack+61975,int_stack+140158,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+118675,int_stack+30500,int_stack+28475,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+124750,int_stack+32975,int_stack+30500,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+132175,int_stack+124750,int_stack+118675,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+144325,int_stack+35945,int_stack+32975,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+153235,int_stack+144325,int_stack+124750,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+267733,int_stack+153235,int_stack+132175,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+118675,int_stack+39455,int_stack+35945,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24300,int_stack+118675,int_stack+144325,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+118675,int_stack+24300,int_stack+153235,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+143425,int_stack+118675,int_stack+267733,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+267733,int_stack+143425,int_stack+0,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+340633,int_stack+267733,int_stack+61975,675);
 /*--- compute (hf|lg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+454033,int_stack+340633,int_stack+182683,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+61975,int_stack+46025,int_stack+43550,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+69400,int_stack+49050,int_stack+46025,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+78475,int_stack+69400,int_stack+61975,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+93325,int_stack+52680,int_stack+49050,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+104215,int_stack+93325,int_stack+69400,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+104215,int_stack+78475,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61975,int_stack+56970,int_stack+52680,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24750,int_stack+61975,int_stack+93325,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+46530,int_stack+24750,int_stack+104215,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+76780,int_stack+46530,int_stack+0,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+173800,int_stack+76780,int_stack+143425,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+173800,int_stack+267733,675);
 /*--- compute (if|lg) ---*/
 hrr1_build_if(Libint->AB,int_stack+145800,int_stack+0,int_stack+340633,675);
 /*--- compute (hg|lg) ---*/
 hrr1_build_hg(Libint->AB,int_stack+595783,int_stack+145800,int_stack+454033,675);
 return int_stack+595783;}
