/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgnl(Libint_t*, prim_data*);

  /* Computes quartets of (hg|nl) integrals */

REALTYPE *hrr_order_hgnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[5][18] = int_stack + 19320;
 Libint->vrr_classes[6][10] = int_stack + 23310;
 Libint->vrr_classes[6][11] = int_stack + 25158;
 Libint->vrr_classes[6][12] = int_stack + 27342;
 Libint->vrr_classes[6][13] = int_stack + 29890;
 Libint->vrr_classes[6][14] = int_stack + 32830;
 Libint->vrr_classes[6][15] = int_stack + 36190;
 Libint->vrr_classes[6][16] = int_stack + 39998;
 Libint->vrr_classes[6][17] = int_stack + 44282;
 Libint->vrr_classes[6][18] = int_stack + 49070;
 Libint->vrr_classes[7][10] = int_stack + 54390;
 Libint->vrr_classes[7][11] = int_stack + 56766;
 Libint->vrr_classes[7][12] = int_stack + 59574;
 Libint->vrr_classes[7][13] = int_stack + 62850;
 Libint->vrr_classes[7][14] = int_stack + 66630;
 Libint->vrr_classes[7][15] = int_stack + 70950;
 Libint->vrr_classes[7][16] = int_stack + 75846;
 Libint->vrr_classes[7][17] = int_stack + 81354;
 Libint->vrr_classes[7][18] = int_stack + 87510;
 Libint->vrr_classes[8][10] = int_stack + 94350;
 Libint->vrr_classes[8][11] = int_stack + 97320;
 Libint->vrr_classes[8][12] = int_stack + 100830;
 Libint->vrr_classes[8][13] = int_stack + 104925;
 Libint->vrr_classes[8][14] = int_stack + 109650;
 Libint->vrr_classes[8][15] = int_stack + 115050;
 Libint->vrr_classes[8][16] = int_stack + 121170;
 Libint->vrr_classes[8][17] = int_stack + 128055;
 Libint->vrr_classes[8][18] = int_stack + 135750;
 Libint->vrr_classes[9][10] = int_stack + 144300;
 Libint->vrr_classes[9][11] = int_stack + 147930;
 Libint->vrr_classes[9][12] = int_stack + 152220;
 Libint->vrr_classes[9][13] = int_stack + 157225;
 Libint->vrr_classes[9][14] = int_stack + 163000;
 Libint->vrr_classes[9][15] = int_stack + 169600;
 Libint->vrr_classes[9][16] = int_stack + 177080;
 Libint->vrr_classes[9][17] = int_stack + 185495;
 Libint->vrr_classes[9][18] = int_stack + 194900;
 memset(int_stack,0,205350*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 205350;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgnl(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+205350,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+209508,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+214422,int_stack+209508,int_stack+205350,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+222738,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+228471,int_stack+222738,int_stack+209508,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+238299,int_stack+228471,int_stack+214422,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+205350,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+252159,int_stack+205350,int_stack+222738,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+211965,int_stack+252159,int_stack+228471,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+263625,int_stack+211965,int_stack+238299,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+228345,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+235905,int_stack+228345,int_stack+205350,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+284415,int_stack+235905,int_stack+252159,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+303525,int_stack+284415,int_stack+211965,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+328095,int_stack+303525,int_stack+263625,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+205350,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+249135,int_stack+205350,int_stack+228345,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+357201,int_stack+249135,int_stack+235905,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+213918,int_stack+357201,int_stack+284415,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+264255,int_stack+213918,int_stack+303525,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+379251,int_stack+264255,int_stack+328095,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+298653,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+308292,int_stack+298653,int_stack+205350,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+325428,int_stack+308292,int_stack+249135,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+418059,int_stack+325428,int_stack+357201,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+451134,int_stack+418059,int_stack+213918,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+205350,int_stack+451134,int_stack+264255,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+491265,int_stack+205350,int_stack+379251,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+251214,int_stack+19320,int_stack+15729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+261987,int_stack+251214,int_stack+298653,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+350628,int_stack+261987,int_stack+308292,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+251214,int_stack+350628,int_stack+325428,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+289014,int_stack+251214,int_stack+418059,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+335319,int_stack+289014,int_stack+451134,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+251214,int_stack+335319,int_stack+205350,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+310182,int_stack+251214,int_stack+491265,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+205350,int_stack+25158,int_stack+23310,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+210894,int_stack+27342,int_stack+25158,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+217446,int_stack+210894,int_stack+205350,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+228534,int_stack+29890,int_stack+27342,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+236178,int_stack+228534,int_stack+210894,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+249282,int_stack+236178,int_stack+217446,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+205350,int_stack+32830,int_stack+29890,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267762,int_stack+205350,int_stack+228534,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+214170,int_stack+267762,int_stack+236178,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+372552,int_stack+214170,int_stack+249282,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+236010,int_stack+36190,int_stack+32830,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+246090,int_stack+236010,int_stack+205350,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+283050,int_stack+246090,int_stack+267762,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+400272,int_stack+283050,int_stack+214170,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+433032,int_stack+400272,int_stack+372552,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+372552,int_stack+39998,int_stack+36190,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+205350,int_stack+372552,int_stack+236010,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+471840,int_stack+205350,int_stack+246090,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+225510,int_stack+471840,int_stack+283050,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+263730,int_stack+225510,int_stack+400272,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+501240,int_stack+263730,int_stack+433032,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+383976,int_stack+44282,int_stack+39998,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+396828,int_stack+383976,int_stack+372552,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+419676,int_stack+396828,int_stack+205350,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+419676,int_stack+471840,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+552984,int_stack+0,int_stack+225510,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+606492,int_stack+552984,int_stack+263730,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+205350,int_stack+606492,int_stack+501240,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+271878,int_stack+49070,int_stack+44282,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+453276,int_stack+271878,int_stack+383976,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+271878,int_stack+453276,int_stack+396828,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+453276,int_stack+271878,int_stack+419676,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+372552,int_stack+453276,int_stack+0,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+434292,int_stack+372552,int_stack+552984,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+505636,int_stack+434292,int_stack+606492,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+372552,int_stack+505636,int_stack+205350,28);
 /*--- compute (hp|nl) ---*/
 hrr1_build_hp(Libint->AB,int_stack+455712,int_stack+372552,int_stack+310182,2970);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+205350,int_stack+56766,int_stack+54390,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+212478,int_stack+59574,int_stack+56766,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+220902,int_stack+212478,int_stack+205350,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+235158,int_stack+62850,int_stack+59574,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+244986,int_stack+235158,int_stack+212478,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+261834,int_stack+244986,int_stack+220902,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+205350,int_stack+66630,int_stack+62850,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+285594,int_stack+205350,int_stack+235158,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+216690,int_stack+285594,int_stack+244986,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+305250,int_stack+216690,int_stack+261834,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+244770,int_stack+70950,int_stack+66630,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+257730,int_stack+244770,int_stack+205350,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+257730,int_stack+285594,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+642822,int_stack+0,int_stack+216690,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+684942,int_stack+642822,int_stack+305250,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+205350,int_stack+75846,int_stack+70950,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+280410,int_stack+205350,int_stack+244770,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+306330,int_stack+280410,int_stack+257730,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+220038,int_stack+306330,int_stack+0,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+220038,int_stack+642822,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+734838,int_stack+0,int_stack+684942,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+642822,int_stack+81354,int_stack+75846,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+659346,int_stack+642822,int_stack+205350,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+688722,int_stack+659346,int_stack+280410,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+801366,int_stack+688722,int_stack+306330,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+269178,int_stack+801366,int_stack+220038,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+858066,int_stack+269178,int_stack+0,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+936690,int_stack+858066,int_stack+734838,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+87510,int_stack+81354,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+18468,int_stack+0,int_stack+642822,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+205350,int_stack+18468,int_stack+659346,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+205350,int_stack+688722,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+642822,int_stack+0,int_stack+801366,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+642822,int_stack+269178,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+642822,int_stack+0,int_stack+858066,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+743910,int_stack+642822,int_stack+936690,36);
 /*--- compute (ip|nl) ---*/
 hrr1_build_ip(Libint->AB,int_stack+850830,int_stack+743910,int_stack+372552,2970);
 /*--- compute (hd|nl) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1100310,int_stack+850830,int_stack+455712,2970);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+97320,int_stack+94350,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+100830,int_stack+97320,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+104925,int_stack+100830,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49545,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+70605,int_stack+49545,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+109650,int_stack+104925,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+205350,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+205350,int_stack+49545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+229920,int_stack+14175,int_stack+70605,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+49275,int_stack+115050,int_stack+109650,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+65475,int_stack+49275,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+274470,int_stack+65475,int_stack+205350,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+315420,int_stack+274470,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+368070,int_stack+315420,int_stack+229920,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+205350,int_stack+121170,int_stack+115050,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+223710,int_stack+205350,int_stack+49275,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+223710,int_stack+65475,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+47250,int_stack+0,int_stack+274470,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+430440,int_stack+47250,int_stack+315420,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+256110,int_stack+430440,int_stack+368070,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+339270,int_stack+128055,int_stack+121170,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+359925,int_stack+339270,int_stack+205350,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+504150,int_stack+359925,int_stack+223710,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+558150,int_stack+504150,int_stack+0,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+629025,int_stack+558150,int_stack+47250,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+629025,int_stack+430440,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+396645,int_stack+0,int_stack+256110,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+98280,int_stack+135750,int_stack+128055,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+205350,int_stack+98280,int_stack+339270,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+246660,int_stack+205350,int_stack+359925,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+307860,int_stack+246660,int_stack+504150,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+205350,int_stack+307860,int_stack+558150,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+503565,int_stack+205350,int_stack+629025,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+205350,int_stack+503565,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+205350,int_stack+396645,45);
 /*--- compute (kp|nl) ---*/
 hrr1_build_kp(Libint->AB,int_stack+205350,int_stack+0,int_stack+743910,2970);
 /*--- compute (id|nl) ---*/
 hrr1_build_id(Libint->AB,int_stack+1474530,int_stack+205350,int_stack+850830,2970);
 /*--- compute (hf|nl) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1973490,int_stack+1474530,int_stack+1100310,2970);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+526110,int_stack+147930,int_stack+144300,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+537000,int_stack+152220,int_stack+147930,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+549870,int_stack+537000,int_stack+526110,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+571650,int_stack+157225,int_stack+152220,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+586665,int_stack+571650,int_stack+537000,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+612405,int_stack+586665,int_stack+549870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+526110,int_stack+163000,int_stack+157225,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+648705,int_stack+526110,int_stack+571650,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+543435,int_stack+648705,int_stack+586665,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+678735,int_stack+543435,int_stack+612405,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+586335,int_stack+169600,int_stack+163000,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+606135,int_stack+586335,int_stack+526110,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+733185,int_stack+606135,int_stack+648705,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+783235,int_stack+733185,int_stack+543435,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+847585,int_stack+783235,int_stack+678735,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+526110,int_stack+177080,int_stack+169600,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+640785,int_stack+526110,int_stack+586335,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+923815,int_stack+640785,int_stack+606135,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+548550,int_stack+923815,int_stack+733185,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+680385,int_stack+548550,int_stack+783235,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+981565,int_stack+680385,int_stack+847585,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+770475,int_stack+185495,int_stack+177080,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+795720,int_stack+770475,int_stack+526110,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+840600,int_stack+795720,int_stack+640785,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1083205,int_stack+840600,int_stack+923815,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1169830,int_stack+1083205,int_stack+548550,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+526110,int_stack+1169830,int_stack+680385,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1274935,int_stack+526110,int_stack+981565,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+646230,int_stack+194900,int_stack+185495,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+674445,int_stack+646230,int_stack+770475,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+906600,int_stack+674445,int_stack+795720,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+646230,int_stack+906600,int_stack+840600,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+745230,int_stack+646230,int_stack+1083205,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+866505,int_stack+745230,int_stack+1169830,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+646230,int_stack+866505,int_stack+526110,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+800670,int_stack+646230,int_stack+1274935,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+964020,int_stack+800670,int_stack+0,2970);
 /*--- compute (kd|nl) ---*/
 hrr1_build_kd(Libint->AB,int_stack+2597190,int_stack+964020,int_stack+205350,2970);
 /*--- compute (if|nl) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+2597190,int_stack+1474530,2970);
 /*--- compute (hg|nl) ---*/
 hrr1_build_hg(Libint->AB,int_stack+831600,int_stack+0,int_stack+1973490,2970);
 return int_stack+831600;}
