/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpmi(Libint_t*, prim_data*);

  /* Computes quartets of (hp|mi) integrals */

REALTYPE *hrr_order_hpmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[6][9] = int_stack + 13671;
 Libint->vrr_classes[6][10] = int_stack + 15211;
 Libint->vrr_classes[6][11] = int_stack + 17059;
 Libint->vrr_classes[6][12] = int_stack + 19243;
 Libint->vrr_classes[6][13] = int_stack + 21791;
 Libint->vrr_classes[6][14] = int_stack + 24731;
 Libint->vrr_classes[6][15] = int_stack + 28091;
 memset(int_stack,0,31899*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 31899;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpmi(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31899,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+35364,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+39522,int_stack+35364,int_stack+31899,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+46452,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51366,int_stack+46452,int_stack+35364,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59682,int_stack+51366,int_stack+39522,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+31899,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+71232,int_stack+31899,int_stack+46452,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+81060,int_stack+71232,int_stack+51366,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+37632,int_stack+81060,int_stack+59682,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+54957,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+94920,int_stack+54957,int_stack+31899,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+106386,int_stack+94920,int_stack+71232,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+122766,int_stack+106386,int_stack+81060,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+61572,int_stack+122766,int_stack+37632,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+31899,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+39459,int_stack+31899,int_stack+54957,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+143556,int_stack+39459,int_stack+94920,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+31899,int_stack+143556,int_stack+106386,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+85827,int_stack+31899,int_stack+122766,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+114933,int_stack+85827,int_stack+61572,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31899,int_stack+15211,int_stack+13671,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36519,int_stack+17059,int_stack+15211,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42063,int_stack+36519,int_stack+31899,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51303,int_stack+19243,int_stack+17059,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+57855,int_stack+51303,int_stack+36519,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+68943,int_stack+57855,int_stack+42063,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+31899,int_stack+21791,int_stack+19243,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+84343,int_stack+31899,int_stack+51303,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+84343,int_stack+57855,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+39543,int_stack+0,int_stack+68943,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+62643,int_stack+24731,int_stack+21791,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+97447,int_stack+62643,int_stack+31899,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+147273,int_stack+97447,int_stack+84343,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+169113,int_stack+147273,int_stack+0,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+196833,int_stack+169113,int_stack+39543,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+28091,int_stack+24731,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10080,int_stack+0,int_stack+62643,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+27720,int_stack+10080,int_stack+97447,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+53200,int_stack+27720,int_stack+147273,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+53200,int_stack+169113,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+147273,int_stack+0,int_stack+196833,28);
 /*--- compute (hp|mi) ---*/
 hrr1_build_hp(Libint->AB,int_stack+0,int_stack+147273,int_stack+114933,1540);
 return int_stack+0;}
