/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpmp(Libint_t*, prim_data*);

  /* Computes quartets of (hp|mp) integrals */

REALTYPE *hrr_order_hpmp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[6][9] = int_stack + 2541;
 Libint->vrr_classes[6][10] = int_stack + 4081;
 memset(int_stack,0,5929*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5929;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpmp(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5929,int_stack+1155,int_stack+0,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9394,int_stack+4081,int_stack+2541,28);
 /*--- compute (hp|mp) ---*/
 hrr1_build_hp(Libint->AB,int_stack+14014,int_stack+9394,int_stack+5929,165);
 return int_stack+14014;}
