/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idlg(Libint_t*, prim_data*);

  /* Computes quartets of (id|lg) integrals */

REALTYPE *hrr_order_idlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[7][8] = int_stack + 9380;
 Libint->vrr_classes[7][9] = int_stack + 11000;
 Libint->vrr_classes[7][10] = int_stack + 12980;
 Libint->vrr_classes[7][11] = int_stack + 15356;
 Libint->vrr_classes[7][12] = int_stack + 18164;
 Libint->vrr_classes[8][8] = int_stack + 21440;
 Libint->vrr_classes[8][9] = int_stack + 23465;
 Libint->vrr_classes[8][10] = int_stack + 25940;
 Libint->vrr_classes[8][11] = int_stack + 28910;
 Libint->vrr_classes[8][12] = int_stack + 32420;
 memset(int_stack,0,36515*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 36515;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idlg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+36515,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+40295,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+44915,int_stack+40295,int_stack+36515,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+52475,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+58019,int_stack+52475,int_stack+40295,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+67259,int_stack+58019,int_stack+44915,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36515,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+79859,int_stack+36515,int_stack+52475,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36515,int_stack+79859,int_stack+58019,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+79859,int_stack+36515,int_stack+67259,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+36515,int_stack+11000,int_stack+9380,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41375,int_stack+12980,int_stack+11000,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47315,int_stack+41375,int_stack+36515,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57035,int_stack+15356,int_stack+12980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+64163,int_stack+57035,int_stack+41375,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+98759,int_stack+64163,int_stack+47315,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36515,int_stack+18164,int_stack+15356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+36515,int_stack+57035,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36515,int_stack+0,int_stack+64163,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+114959,int_stack+36515,int_stack+98759,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+139259,int_stack+114959,int_stack+79859,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+36515,int_stack+23465,int_stack+21440,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+42590,int_stack+25940,int_stack+23465,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50015,int_stack+42590,int_stack+36515,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62165,int_stack+28910,int_stack+25940,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+71075,int_stack+62165,int_stack+42590,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85925,int_stack+71075,int_stack+50015,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+36515,int_stack+32420,int_stack+28910,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+36515,int_stack+62165,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+17820,int_stack+0,int_stack+71075,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+42570,int_stack+17820,int_stack+85925,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+195959,int_stack+42570,int_stack+114959,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+195959,int_stack+139259,675);
 return int_stack+0;}
