/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifhg(Libint_t*, prim_data*);

  /* Computes quartets of (if|hg) integrals */

REALTYPE *hrr_order_ifhg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][5] = int_stack + 0;
 Libint->vrr_classes[6][6] = int_stack + 588;
 Libint->vrr_classes[6][7] = int_stack + 1372;
 Libint->vrr_classes[6][8] = int_stack + 2380;
 Libint->vrr_classes[6][9] = int_stack + 3640;
 Libint->vrr_classes[7][5] = int_stack + 5180;
 Libint->vrr_classes[7][6] = int_stack + 5936;
 Libint->vrr_classes[7][7] = int_stack + 6944;
 Libint->vrr_classes[7][8] = int_stack + 8240;
 Libint->vrr_classes[7][9] = int_stack + 9860;
 Libint->vrr_classes[8][5] = int_stack + 11840;
 Libint->vrr_classes[8][6] = int_stack + 12785;
 Libint->vrr_classes[8][7] = int_stack + 14045;
 Libint->vrr_classes[8][8] = int_stack + 15665;
 Libint->vrr_classes[8][9] = int_stack + 17690;
 Libint->vrr_classes[9][5] = int_stack + 20165;
 Libint->vrr_classes[9][6] = int_stack + 21320;
 Libint->vrr_classes[9][7] = int_stack + 22860;
 Libint->vrr_classes[9][8] = int_stack + 24840;
 Libint->vrr_classes[9][9] = int_stack + 27315;
 memset(int_stack,0,30340*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 30340;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifhg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+30340,int_stack+588,int_stack+0,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+32104,int_stack+1372,int_stack+588,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+34456,int_stack+32104,int_stack+30340,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+37984,int_stack+2380,int_stack+1372,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+41008,int_stack+37984,int_stack+32104,28);
 /*--- compute (i0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+45712,int_stack+41008,int_stack+34456,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30340,int_stack+3640,int_stack+2380,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+51592,int_stack+30340,int_stack+37984,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+30340,int_stack+51592,int_stack+41008,28);
 /*--- compute (i0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+51592,int_stack+30340,int_stack+45712,28);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+30340,int_stack+5936,int_stack+5180,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+32608,int_stack+6944,int_stack+5936,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+35632,int_stack+32608,int_stack+30340,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40168,int_stack+8240,int_stack+6944,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+44056,int_stack+40168,int_stack+32608,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+0,int_stack+44056,int_stack+35632,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30340,int_stack+9860,int_stack+8240,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+60412,int_stack+30340,int_stack+40168,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+30340,int_stack+60412,int_stack+44056,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+60412,int_stack+30340,int_stack+0,36);
 /*--- compute (ip|hg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+71752,int_stack+60412,int_stack+51592,315);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+0,int_stack+12785,int_stack+11840,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+2835,int_stack+14045,int_stack+12785,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+6615,int_stack+2835,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+30340,int_stack+15665,int_stack+14045,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+35200,int_stack+30340,int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+42760,int_stack+35200,int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+17690,int_stack+15665,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+6075,int_stack+0,int_stack+30340,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+98212,int_stack+6075,int_stack+35200,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+0,int_stack+98212,int_stack+42760,45);
 /*--- compute (kp|hg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+98212,int_stack+0,int_stack+60412,315);
 /*--- compute (id|hg) ---*/
 hrr1_build_id(Libint->AB,int_stack+132232,int_stack+98212,int_stack+71752,315);
 /*--- compute (m0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+30340,int_stack+21320,int_stack+20165,55);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33805,int_stack+22860,int_stack+21320,55);
 /*--- compute (m0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+38425,int_stack+33805,int_stack+30340,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45355,int_stack+24840,int_stack+22860,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+51295,int_stack+45355,int_stack+33805,55);
 /*--- compute (m0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+60535,int_stack+51295,int_stack+38425,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+30340,int_stack+27315,int_stack+24840,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+72085,int_stack+30340,int_stack+45355,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+14175,int_stack+72085,int_stack+51295,55);
 /*--- compute (m0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+72085,int_stack+14175,int_stack+60535,55);
 /*--- compute (lp|hg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+14175,int_stack+72085,int_stack+0,315);
 /*--- compute (kd|hg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+185152,int_stack+14175,int_stack+98212,315);
 /*--- compute (if|hg) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+185152,int_stack+132232,315);
 return int_stack+0;}
