/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iflf(Libint_t*, prim_data*);

  /* Computes quartets of (if|lf) integrals */

REALTYPE *hrr_order_iflf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[7][8] = int_stack + 6832;
 Libint->vrr_classes[7][9] = int_stack + 8452;
 Libint->vrr_classes[7][10] = int_stack + 10432;
 Libint->vrr_classes[7][11] = int_stack + 12808;
 Libint->vrr_classes[8][8] = int_stack + 15616;
 Libint->vrr_classes[8][9] = int_stack + 17641;
 Libint->vrr_classes[8][10] = int_stack + 20116;
 Libint->vrr_classes[8][11] = int_stack + 23086;
 Libint->vrr_classes[9][8] = int_stack + 26596;
 Libint->vrr_classes[9][9] = int_stack + 29071;
 Libint->vrr_classes[9][10] = int_stack + 32096;
 Libint->vrr_classes[9][11] = int_stack + 35726;
 memset(int_stack,0,40016*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 40016;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iflf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40016,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+43796,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+48416,int_stack+43796,int_stack+40016,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55976,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61520,int_stack+55976,int_stack+43796,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+70760,int_stack+61520,int_stack+48416,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40016,int_stack+8452,int_stack+6832,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44876,int_stack+10432,int_stack+8452,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+50816,int_stack+44876,int_stack+40016,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+60536,int_stack+12808,int_stack+10432,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+60536,int_stack+44876,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83360,int_stack+0,int_stack+50816,36);
 /*--- compute (ip|lf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+99560,int_stack+83360,int_stack+70760,450);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+17641,int_stack+15616,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+20116,int_stack+17641,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+40016,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+52166,int_stack+23086,int_stack+20116,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+61076,int_stack+52166,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+61076,int_stack+40016,45);
 /*--- compute (kp|lf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+137360,int_stack+0,int_stack+83360,450);
 /*--- compute (id|lf) ---*/
 hrr1_build_id(Libint->AB,int_stack+185960,int_stack+137360,int_stack+99560,450);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+40016,int_stack+29071,int_stack+26596,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47441,int_stack+32096,int_stack+29071,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+56516,int_stack+47441,int_stack+40016,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71366,int_stack+35726,int_stack+32096,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+82256,int_stack+71366,int_stack+47441,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+100406,int_stack+82256,int_stack+56516,55);
 /*--- compute (lp|lf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+20250,int_stack+100406,int_stack+0,450);
 /*--- compute (kd|lf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+261560,int_stack+20250,int_stack+137360,450);
 /*--- compute (if|lf) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+261560,int_stack+185960,450);
 return int_stack+0;}
