/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iflk(Libint_t*, prim_data*);

  /* Computes quartets of (if|lk) integrals */

REALTYPE *hrr_order_iflk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[7][8] = int_stack + 19488;
 Libint->vrr_classes[7][9] = int_stack + 21108;
 Libint->vrr_classes[7][10] = int_stack + 23088;
 Libint->vrr_classes[7][11] = int_stack + 25464;
 Libint->vrr_classes[7][12] = int_stack + 28272;
 Libint->vrr_classes[7][13] = int_stack + 31548;
 Libint->vrr_classes[7][14] = int_stack + 35328;
 Libint->vrr_classes[7][15] = int_stack + 39648;
 Libint->vrr_classes[8][8] = int_stack + 44544;
 Libint->vrr_classes[8][9] = int_stack + 46569;
 Libint->vrr_classes[8][10] = int_stack + 49044;
 Libint->vrr_classes[8][11] = int_stack + 52014;
 Libint->vrr_classes[8][12] = int_stack + 55524;
 Libint->vrr_classes[8][13] = int_stack + 59619;
 Libint->vrr_classes[8][14] = int_stack + 64344;
 Libint->vrr_classes[8][15] = int_stack + 69744;
 Libint->vrr_classes[9][8] = int_stack + 75864;
 Libint->vrr_classes[9][9] = int_stack + 78339;
 Libint->vrr_classes[9][10] = int_stack + 81364;
 Libint->vrr_classes[9][11] = int_stack + 84994;
 Libint->vrr_classes[9][12] = int_stack + 89284;
 Libint->vrr_classes[9][13] = int_stack + 94289;
 Libint->vrr_classes[9][14] = int_stack + 100064;
 Libint->vrr_classes[9][15] = int_stack + 106664;
 memset(int_stack,0,114144*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 114144;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iflk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+114144,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+117924,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122544,int_stack+117924,int_stack+114144,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+130104,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+135648,int_stack+130104,int_stack+117924,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+144888,int_stack+135648,int_stack+122544,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+114144,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+157488,int_stack+114144,int_stack+130104,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+168576,int_stack+157488,int_stack+135648,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+120696,int_stack+168576,int_stack+144888,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+139596,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+183976,int_stack+139596,int_stack+114144,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+197080,int_stack+183976,int_stack+157488,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+215560,int_stack+197080,int_stack+168576,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+147240,int_stack+215560,int_stack+120696,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+114144,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122964,int_stack+114144,int_stack+139596,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+238660,int_stack+122964,int_stack+183976,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+260500,int_stack+238660,int_stack+197080,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+173700,int_stack+260500,int_stack+215560,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+288220,int_stack+173700,int_stack+147240,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+138252,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+148332,int_stack+138252,int_stack+114144,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+206040,int_stack+148332,int_stack+122964,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+114144,int_stack+206040,int_stack+238660,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+206040,int_stack+114144,int_stack+260500,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+114144,int_stack+206040,int_stack+173700,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+157264,int_stack+114144,int_stack+288220,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+114144,int_stack+21108,int_stack+19488,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+119004,int_stack+23088,int_stack+21108,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+124944,int_stack+119004,int_stack+114144,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+134664,int_stack+25464,int_stack+23088,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+141792,int_stack+134664,int_stack+119004,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+202624,int_stack+141792,int_stack+124944,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+114144,int_stack+28272,int_stack+25464,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+218824,int_stack+114144,int_stack+134664,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+233080,int_stack+218824,int_stack+141792,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+122568,int_stack+233080,int_stack+202624,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+202624,int_stack+31548,int_stack+28272,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+252880,int_stack+202624,int_stack+114144,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+269728,int_stack+252880,int_stack+218824,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+293488,int_stack+269728,int_stack+233080,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+212452,int_stack+293488,int_stack+122568,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+114144,int_stack+35328,int_stack+31548,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+125484,int_stack+114144,int_stack+202624,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+125484,int_stack+252880,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+323188,int_stack+0,int_stack+269728,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+246472,int_stack+323188,int_stack+293488,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+358828,int_stack+246472,int_stack+212452,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+202624,int_stack+39648,int_stack+35328,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+215584,int_stack+202624,int_stack+114144,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+288052,int_stack+215584,int_stack+125484,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+114144,int_stack+288052,int_stack+0,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+404188,int_stack+114144,int_stack+323188,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+288052,int_stack+404188,int_stack+246472,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+202624,int_stack+288052,int_stack+358828,36);
 /*--- compute (ip|lk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+260944,int_stack+202624,int_stack+157264,1620);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+114144,int_stack+46569,int_stack+44544,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+120219,int_stack+49044,int_stack+46569,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+127644,int_stack+120219,int_stack+114144,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+139794,int_stack+52014,int_stack+49044,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148704,int_stack+139794,int_stack+120219,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+163554,int_stack+148704,int_stack+127644,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+114144,int_stack+55524,int_stack+52014,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+183804,int_stack+114144,int_stack+139794,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+183804,int_stack+148704,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+124674,int_stack+0,int_stack+163554,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+155049,int_stack+59619,int_stack+55524,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+24750,int_stack+155049,int_stack+114144,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+397024,int_stack+24750,int_stack+183804,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+426724,int_stack+397024,int_stack+0,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+463849,int_stack+426724,int_stack+124674,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+64344,int_stack+59619,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+114144,int_stack+0,int_stack+155049,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+138714,int_stack+114144,int_stack+24750,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+14175,int_stack+138714,int_stack+397024,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+506374,int_stack+14175,int_stack+426724,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+397024,int_stack+506374,int_stack+463849,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+453724,int_stack+69744,int_stack+64344,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+469924,int_stack+453724,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+558349,int_stack+469924,int_stack+114144,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+453724,int_stack+558349,int_stack+138714,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+114144,int_stack+453724,int_stack+14175,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+114144,int_stack+506374,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+114144,int_stack+0,int_stack+397024,45);
 /*--- compute (kp|lk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+397024,int_stack+114144,int_stack+202624,1620);
 /*--- compute (id|lk) ---*/
 hrr1_build_id(Libint->AB,int_stack+571984,int_stack+397024,int_stack+260944,1620);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+78339,int_stack+75864,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+81364,int_stack+78339,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+84994,int_stack+81364,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42240,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+187044,int_stack+42240,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+89284,int_stack+84994,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+60390,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+211794,int_stack+60390,int_stack+42240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12870,int_stack+211794,int_stack+187044,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+187044,int_stack+94289,int_stack+89284,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+242044,int_stack+187044,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+267784,int_stack+242044,int_stack+60390,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+304084,int_stack+267784,int_stack+211794,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+844144,int_stack+304084,int_stack+12870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+100064,int_stack+94289,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+187044,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+187044,int_stack+17325,int_stack+242044,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+896119,int_stack+187044,int_stack+267784,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+229944,int_stack+896119,int_stack+304084,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+293469,int_stack+229944,int_stack+844144,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+844144,int_stack+106664,int_stack+100064,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+47355,int_stack+844144,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+844144,int_stack+47355,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+844144,int_stack+187044,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+950569,int_stack+0,int_stack+896119,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+950569,int_stack+229944,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+187044,int_stack+0,int_stack+293469,55);
 /*--- compute (lp|lk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+844144,int_stack+187044,int_stack+114144,1620);
 /*--- compute (kd|lk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+844144,int_stack+397024,1620);
 /*--- compute (if|lk) ---*/
 hrr1_build_if(Libint->AB,int_stack+844144,int_stack+0,int_stack+571984,1620);
 return int_stack+844144;}
