/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifng(Libint_t*, prim_data*);

  /* Computes quartets of (if|ng) integrals */

REALTYPE *hrr_order_ifng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[7][10] = int_stack + 12880;
 Libint->vrr_classes[7][11] = int_stack + 15256;
 Libint->vrr_classes[7][12] = int_stack + 18064;
 Libint->vrr_classes[7][13] = int_stack + 21340;
 Libint->vrr_classes[7][14] = int_stack + 25120;
 Libint->vrr_classes[8][10] = int_stack + 29440;
 Libint->vrr_classes[8][11] = int_stack + 32410;
 Libint->vrr_classes[8][12] = int_stack + 35920;
 Libint->vrr_classes[8][13] = int_stack + 40015;
 Libint->vrr_classes[8][14] = int_stack + 44740;
 Libint->vrr_classes[9][10] = int_stack + 50140;
 Libint->vrr_classes[9][11] = int_stack + 53770;
 Libint->vrr_classes[9][12] = int_stack + 58060;
 Libint->vrr_classes[9][13] = int_stack + 63065;
 Libint->vrr_classes[9][14] = int_stack + 68840;
 memset(int_stack,0,75440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 75440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifng(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75440,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+80984,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+87536,int_stack+80984,int_stack+75440,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+98624,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+106268,int_stack+98624,int_stack+80984,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119372,int_stack+106268,int_stack+87536,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+75440,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+137852,int_stack+75440,int_stack+98624,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+75440,int_stack+137852,int_stack+106268,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+137852,int_stack+75440,int_stack+119372,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75440,int_stack+15256,int_stack+12880,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+82568,int_stack+18064,int_stack+15256,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+90992,int_stack+82568,int_stack+75440,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+105248,int_stack+21340,int_stack+18064,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115076,int_stack+105248,int_stack+82568,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+165572,int_stack+115076,int_stack+90992,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+75440,int_stack+25120,int_stack+21340,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+75440,int_stack+105248,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+75440,int_stack+0,int_stack+115076,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+189332,int_stack+75440,int_stack+165572,36);
 /*--- compute (ip|ng) ---*/
 hrr1_build_ip(Libint->AB,int_stack+224972,int_stack+189332,int_stack+137852,990);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75440,int_stack+32410,int_stack+29440,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84350,int_stack+35920,int_stack+32410,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+94880,int_stack+84350,int_stack+75440,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112700,int_stack+40015,int_stack+35920,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+124985,int_stack+112700,int_stack+84350,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146045,int_stack+124985,int_stack+94880,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+75440,int_stack+44740,int_stack+40015,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+75440,int_stack+112700,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+75440,int_stack+0,int_stack+124985,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+75440,int_stack+146045,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+75440,int_stack+0,int_stack+189332,990);
 /*--- compute (id|ng) ---*/
 hrr1_build_id(Libint->AB,int_stack+308132,int_stack+75440,int_stack+224972,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+182360,int_stack+53770,int_stack+50140,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+193250,int_stack+58060,int_stack+53770,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+206120,int_stack+193250,int_stack+182360,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+227900,int_stack+63065,int_stack+58060,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+242915,int_stack+227900,int_stack+193250,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+268655,int_stack+242915,int_stack+206120,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+182360,int_stack+68840,int_stack+63065,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+44550,int_stack+182360,int_stack+227900,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+182360,int_stack+44550,int_stack+242915,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+474452,int_stack+182360,int_stack+268655,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+528902,int_stack+474452,int_stack+0,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+662552,int_stack+528902,int_stack+75440,990);
 /*--- compute (if|ng) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+662552,int_stack+308132,990);
 return int_stack+0;}
