/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igmg(Libint_t*, prim_data*);

  /* Computes quartets of (ig|mg) integrals */

REALTYPE *hrr_order_igmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[7][9] = int_stack + 11060;
 Libint->vrr_classes[7][10] = int_stack + 13040;
 Libint->vrr_classes[7][11] = int_stack + 15416;
 Libint->vrr_classes[7][12] = int_stack + 18224;
 Libint->vrr_classes[7][13] = int_stack + 21500;
 Libint->vrr_classes[8][9] = int_stack + 25280;
 Libint->vrr_classes[8][10] = int_stack + 27755;
 Libint->vrr_classes[8][11] = int_stack + 30725;
 Libint->vrr_classes[8][12] = int_stack + 34235;
 Libint->vrr_classes[8][13] = int_stack + 38330;
 Libint->vrr_classes[9][9] = int_stack + 43055;
 Libint->vrr_classes[9][10] = int_stack + 46080;
 Libint->vrr_classes[9][11] = int_stack + 49710;
 Libint->vrr_classes[9][12] = int_stack + 54000;
 Libint->vrr_classes[9][13] = int_stack + 59005;
 Libint->vrr_classes[10][9] = int_stack + 64780;
 Libint->vrr_classes[10][10] = int_stack + 68410;
 Libint->vrr_classes[10][11] = int_stack + 72766;
 Libint->vrr_classes[10][12] = int_stack + 77914;
 Libint->vrr_classes[10][13] = int_stack + 83920;
 memset(int_stack,0,90850*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 90850;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igmg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90850,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95470,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+101014,int_stack+95470,int_stack+90850,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+110254,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+116806,int_stack+110254,int_stack+95470,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+127894,int_stack+116806,int_stack+101014,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90850,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+143294,int_stack+90850,int_stack+110254,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+90850,int_stack+143294,int_stack+116806,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+143294,int_stack+90850,int_stack+127894,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90850,int_stack+13040,int_stack+11060,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+96790,int_stack+15416,int_stack+13040,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+103918,int_stack+96790,int_stack+90850,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+115798,int_stack+18224,int_stack+15416,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+124222,int_stack+115798,int_stack+96790,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+166394,int_stack+124222,int_stack+103918,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90850,int_stack+21500,int_stack+18224,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+90850,int_stack+115798,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+90850,int_stack+0,int_stack+124222,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+186194,int_stack+90850,int_stack+166394,36);
 /*--- compute (ip|mg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+215894,int_stack+186194,int_stack+143294,825);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90850,int_stack+27755,int_stack+25280,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98275,int_stack+30725,int_stack+27755,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+107185,int_stack+98275,int_stack+90850,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+122035,int_stack+34235,int_stack+30725,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+132565,int_stack+122035,int_stack+98275,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+150385,int_stack+132565,int_stack+107185,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90850,int_stack+38330,int_stack+34235,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+90850,int_stack+122035,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+90850,int_stack+0,int_stack+132565,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+90850,int_stack+150385,45);
 /*--- compute (kp|mg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+90850,int_stack+0,int_stack+186194,825);
 /*--- compute (id|mg) ---*/
 hrr1_build_id(Libint->AB,int_stack+285194,int_stack+90850,int_stack+215894,825);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+179950,int_stack+46080,int_stack+43055,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+189025,int_stack+49710,int_stack+46080,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+199915,int_stack+189025,int_stack+179950,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+218065,int_stack+54000,int_stack+49710,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+230935,int_stack+218065,int_stack+189025,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+252715,int_stack+230935,int_stack+199915,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+179950,int_stack+59005,int_stack+54000,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+37125,int_stack+179950,int_stack+218065,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+179950,int_stack+37125,int_stack+230935,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+423794,int_stack+179950,int_stack+252715,55);
 /*--- compute (lp|mg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+469169,int_stack+423794,int_stack+0,825);
 /*--- compute (kd|mg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+580544,int_stack+469169,int_stack+90850,825);
 /*--- compute (if|mg) ---*/
 hrr1_build_if(Libint->AB,int_stack+758744,int_stack+580544,int_stack+285194,825);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90850,int_stack+68410,int_stack+64780,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+101740,int_stack+72766,int_stack+68410,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114808,int_stack+101740,int_stack+90850,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+136588,int_stack+77914,int_stack+72766,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+152032,int_stack+136588,int_stack+101740,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+178168,int_stack+152032,int_stack+114808,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90850,int_stack+83920,int_stack+77914,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+214468,int_stack+90850,int_stack+136588,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245356,int_stack+214468,int_stack+152032,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+288916,int_stack+245356,int_stack+178168,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+288916,int_stack+423794,825);
 /*--- compute (ld|mg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+136125,int_stack+0,int_stack+469169,825);
 /*--- compute (kf|mg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+989744,int_stack+136125,int_stack+580544,825);
 /*--- compute (ig|mg) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+989744,int_stack+758744,825);
 return int_stack+0;}
