/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ignl(Libint_t*, prim_data*);

  /* Computes quartets of (ig|nl) integrals */

REALTYPE *hrr_order_ignl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[7][10] = int_stack + 31080;
 Libint->vrr_classes[7][11] = int_stack + 33456;
 Libint->vrr_classes[7][12] = int_stack + 36264;
 Libint->vrr_classes[7][13] = int_stack + 39540;
 Libint->vrr_classes[7][14] = int_stack + 43320;
 Libint->vrr_classes[7][15] = int_stack + 47640;
 Libint->vrr_classes[7][16] = int_stack + 52536;
 Libint->vrr_classes[7][17] = int_stack + 58044;
 Libint->vrr_classes[7][18] = int_stack + 64200;
 Libint->vrr_classes[8][10] = int_stack + 71040;
 Libint->vrr_classes[8][11] = int_stack + 74010;
 Libint->vrr_classes[8][12] = int_stack + 77520;
 Libint->vrr_classes[8][13] = int_stack + 81615;
 Libint->vrr_classes[8][14] = int_stack + 86340;
 Libint->vrr_classes[8][15] = int_stack + 91740;
 Libint->vrr_classes[8][16] = int_stack + 97860;
 Libint->vrr_classes[8][17] = int_stack + 104745;
 Libint->vrr_classes[8][18] = int_stack + 112440;
 Libint->vrr_classes[9][10] = int_stack + 120990;
 Libint->vrr_classes[9][11] = int_stack + 124620;
 Libint->vrr_classes[9][12] = int_stack + 128910;
 Libint->vrr_classes[9][13] = int_stack + 133915;
 Libint->vrr_classes[9][14] = int_stack + 139690;
 Libint->vrr_classes[9][15] = int_stack + 146290;
 Libint->vrr_classes[9][16] = int_stack + 153770;
 Libint->vrr_classes[9][17] = int_stack + 162185;
 Libint->vrr_classes[9][18] = int_stack + 171590;
 Libint->vrr_classes[10][10] = int_stack + 182040;
 Libint->vrr_classes[10][11] = int_stack + 186396;
 Libint->vrr_classes[10][12] = int_stack + 191544;
 Libint->vrr_classes[10][13] = int_stack + 197550;
 Libint->vrr_classes[10][14] = int_stack + 204480;
 Libint->vrr_classes[10][15] = int_stack + 212400;
 Libint->vrr_classes[10][16] = int_stack + 221376;
 Libint->vrr_classes[10][17] = int_stack + 231474;
 Libint->vrr_classes[10][18] = int_stack + 242760;
 memset(int_stack,0,255300*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 255300;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ignl(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+255300,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+260844,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+267396,int_stack+260844,int_stack+255300,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+278484,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+286128,int_stack+278484,int_stack+260844,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+299232,int_stack+286128,int_stack+267396,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+255300,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+317712,int_stack+255300,int_stack+278484,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+264120,int_stack+317712,int_stack+286128,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333000,int_stack+264120,int_stack+299232,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+285960,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+296040,int_stack+285960,int_stack+255300,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+360720,int_stack+296040,int_stack+317712,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+386200,int_stack+360720,int_stack+264120,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+418960,int_stack+386200,int_stack+333000,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+255300,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+313680,int_stack+255300,int_stack+285960,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+457768,int_stack+313680,int_stack+296040,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+266724,int_stack+457768,int_stack+360720,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+333840,int_stack+266724,int_stack+386200,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+487168,int_stack+333840,int_stack+418960,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+379704,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+392556,int_stack+379704,int_stack+255300,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+415404,int_stack+392556,int_stack+313680,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+538912,int_stack+415404,int_stack+457768,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+583012,int_stack+538912,int_stack+266724,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+255300,int_stack+583012,int_stack+333840,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+636520,int_stack+255300,int_stack+487168,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+316452,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+330816,int_stack+316452,int_stack+379704,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+449004,int_stack+330816,int_stack+392556,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+316452,int_stack+449004,int_stack+415404,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+366852,int_stack+316452,int_stack+538912,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+428592,int_stack+366852,int_stack+583012,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+316452,int_stack+428592,int_stack+255300,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+395076,int_stack+316452,int_stack+636520,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+255300,int_stack+33456,int_stack+31080,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+262428,int_stack+36264,int_stack+33456,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+270852,int_stack+262428,int_stack+255300,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+285108,int_stack+39540,int_stack+36264,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+294936,int_stack+285108,int_stack+262428,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+311784,int_stack+294936,int_stack+270852,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+255300,int_stack+43320,int_stack+39540,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+335544,int_stack+255300,int_stack+285108,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+266640,int_stack+335544,int_stack+294936,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+355200,int_stack+266640,int_stack+311784,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+294720,int_stack+47640,int_stack+43320,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+307680,int_stack+294720,int_stack+255300,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+478236,int_stack+307680,int_stack+335544,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+510996,int_stack+478236,int_stack+266640,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+553116,int_stack+510996,int_stack+355200,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+255300,int_stack+52536,int_stack+47640,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+330360,int_stack+255300,int_stack+294720,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+356280,int_stack+330360,int_stack+307680,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+269988,int_stack+356280,int_stack+478236,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+603012,int_stack+269988,int_stack+510996,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+478236,int_stack+603012,int_stack+553116,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+544764,int_stack+58044,int_stack+52536,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+561288,int_stack+544764,int_stack+255300,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+561288,int_stack+330360,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+661980,int_stack+0,int_stack+356280,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+319128,int_stack+661980,int_stack+269988,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+718680,int_stack+319128,int_stack+603012,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+797304,int_stack+718680,int_stack+478236,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+478236,int_stack+64200,int_stack+58044,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+496704,int_stack+478236,int_stack+544764,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+255300,int_stack+496704,int_stack+561288,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+478236,int_stack+255300,int_stack+0,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+543036,int_stack+478236,int_stack+661980,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+622416,int_stack+543036,int_stack+319128,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+478236,int_stack+622416,int_stack+718680,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+579324,int_stack+478236,int_stack+797304,36);
 /*--- compute (ip|nl) ---*/
 hrr1_build_ip(Libint->AB,int_stack+686244,int_stack+579324,int_stack+395076,2970);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+74010,int_stack+71040,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8910,int_stack+77520,int_stack+74010,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19440,int_stack+8910,int_stack+0,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37260,int_stack+81615,int_stack+77520,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+49545,int_stack+37260,int_stack+8910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+255300,int_stack+49545,int_stack+19440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+86340,int_stack+81615,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+285000,int_stack+0,int_stack+37260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+14175,int_stack+285000,int_stack+49545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+309570,int_stack+14175,int_stack+255300,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+255300,int_stack+91740,int_stack+86340,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+49275,int_stack+255300,int_stack+0,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+354120,int_stack+49275,int_stack+285000,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+395070,int_stack+354120,int_stack+14175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+447720,int_stack+395070,int_stack+309570,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+97860,int_stack+91740,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+271500,int_stack+0,int_stack+255300,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+303900,int_stack+271500,int_stack+49275,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+18360,int_stack+303900,int_stack+354120,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+935724,int_stack+18360,int_stack+395070,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+351150,int_stack+935724,int_stack+447720,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+434310,int_stack+104745,int_stack+97860,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+454965,int_stack+434310,int_stack+0,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+491685,int_stack+454965,int_stack+271500,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1009434,int_stack+491685,int_stack+303900,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+255300,int_stack+1009434,int_stack+18360,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+255300,int_stack+935724,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1080309,int_stack+0,int_stack+351150,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+935724,int_stack+112440,int_stack+104745,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+958809,int_stack+935724,int_stack+434310,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+341295,int_stack+958809,int_stack+454965,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+402495,int_stack+341295,int_stack+491685,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1187229,int_stack+402495,int_stack+1009434,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+341295,int_stack+1187229,int_stack+255300,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+935724,int_stack+341295,int_stack+0,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+255300,int_stack+935724,int_stack+1080309,45);
 /*--- compute (kp|nl) ---*/
 hrr1_build_kp(Libint->AB,int_stack+935724,int_stack+255300,int_stack+579324,2970);
 /*--- compute (id|nl) ---*/
 hrr1_build_id(Libint->AB,int_stack+1256484,int_stack+935724,int_stack+686244,2970);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+124620,int_stack+120990,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+128910,int_stack+124620,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+45540,int_stack+133915,int_stack+128910,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+60555,int_stack+45540,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+86295,int_stack+60555,int_stack+23760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+139690,int_stack+133915,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+388950,int_stack+0,int_stack+45540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+17325,int_stack+388950,int_stack+60555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+418980,int_stack+17325,int_stack+86295,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+60225,int_stack+146290,int_stack+139690,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+80025,int_stack+60225,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+473430,int_stack+80025,int_stack+388950,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+523480,int_stack+473430,int_stack+17325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+587830,int_stack+523480,int_stack+418980,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+388950,int_stack+153770,int_stack+146290,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+411390,int_stack+388950,int_stack+60225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+411390,int_stack+80025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+57750,int_stack+0,int_stack+473430,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+664060,int_stack+57750,int_stack+523480,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+450990,int_stack+664060,int_stack+587830,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+552630,int_stack+162185,int_stack+153770,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+577875,int_stack+552630,int_stack+388950,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+754150,int_stack+577875,int_stack+411390,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+820150,int_stack+754150,int_stack+0,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1755444,int_stack+820150,int_stack+57750,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1755444,int_stack+664060,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+622755,int_stack+0,int_stack+450990,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+120120,int_stack+171590,int_stack+162185,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+388950,int_stack+120120,int_stack+552630,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+439440,int_stack+388950,int_stack+577875,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+514240,int_stack+439440,int_stack+754150,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+388950,int_stack+514240,int_stack+820150,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+753435,int_stack+388950,int_stack+1755444,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+388950,int_stack+753435,int_stack+0,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+388950,int_stack+622755,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+388950,int_stack+0,int_stack+255300,2970);
 /*--- compute (kd|nl) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1755444,int_stack+388950,int_stack+935724,2970);
 /*--- compute (if|nl) ---*/
 hrr1_build_if(Libint->AB,int_stack+2396964,int_stack+1755444,int_stack+1256484,2970);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+255300,int_stack+186396,int_stack+182040,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+268368,int_stack+191544,int_stack+186396,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+283812,int_stack+268368,int_stack+255300,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+309948,int_stack+197550,int_stack+191544,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+327966,int_stack+309948,int_stack+268368,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+789900,int_stack+327966,int_stack+283812,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+255300,int_stack+204480,int_stack+197550,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+833460,int_stack+255300,int_stack+309948,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+276090,int_stack+833460,int_stack+327966,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+869496,int_stack+276090,int_stack+789900,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+789900,int_stack+212400,int_stack+204480,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+327570,int_stack+789900,int_stack+255300,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+934836,int_stack+327570,int_stack+833460,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+994896,int_stack+934836,int_stack+276090,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1072116,int_stack+994896,int_stack+869496,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+255300,int_stack+221376,int_stack+212400,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+813660,int_stack+255300,int_stack+789900,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+861180,int_stack+813660,int_stack+327570,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+282228,int_stack+861180,int_stack+934836,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1163592,int_stack+282228,int_stack+994896,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+930480,int_stack+1163592,int_stack+1072116,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1052448,int_stack+231474,int_stack+221376,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1082742,int_stack+1052448,int_stack+255300,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1271700,int_stack+1082742,int_stack+813660,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1350900,int_stack+1271700,int_stack+861180,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+789900,int_stack+1350900,int_stack+282228,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1454850,int_stack+789900,int_stack+1163592,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3228564,int_stack+1454850,int_stack+930480,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+255300,int_stack+242760,int_stack+231474,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+289158,int_stack+255300,int_stack+1052448,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+916026,int_stack+289158,int_stack+1082742,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1005786,int_stack+916026,int_stack+1271700,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1124586,int_stack+1005786,int_stack+1350900,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+916026,int_stack+1124586,int_stack+789900,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1084194,int_stack+916026,int_stack+1454850,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+789900,int_stack+1084194,int_stack+3228564,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+985920,int_stack+789900,int_stack+0,2970);
 /*--- compute (ld|nl) ---*/
 hrr1_build_ld(Libint->AB,int_stack+3228564,int_stack+985920,int_stack+388950,2970);
 /*--- compute (kf|nl) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+3228564,int_stack+1755444,2970);
 /*--- compute (ig|nl) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1069200,int_stack+0,int_stack+2396964,2970);
 return int_stack+1069200;}
