/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihlf(Libint_t*, prim_data*);

  /* Computes quartets of (ih|lf) integrals */

REALTYPE *hrr_order_ihlf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[7][8] = int_stack + 6832;
 Libint->vrr_classes[7][9] = int_stack + 8452;
 Libint->vrr_classes[7][10] = int_stack + 10432;
 Libint->vrr_classes[7][11] = int_stack + 12808;
 Libint->vrr_classes[8][8] = int_stack + 15616;
 Libint->vrr_classes[8][9] = int_stack + 17641;
 Libint->vrr_classes[8][10] = int_stack + 20116;
 Libint->vrr_classes[8][11] = int_stack + 23086;
 Libint->vrr_classes[9][8] = int_stack + 26596;
 Libint->vrr_classes[9][9] = int_stack + 29071;
 Libint->vrr_classes[9][10] = int_stack + 32096;
 Libint->vrr_classes[9][11] = int_stack + 35726;
 Libint->vrr_classes[10][8] = int_stack + 40016;
 Libint->vrr_classes[10][9] = int_stack + 42986;
 Libint->vrr_classes[10][10] = int_stack + 46616;
 Libint->vrr_classes[10][11] = int_stack + 50972;
 Libint->vrr_classes[11][8] = int_stack + 56120;
 Libint->vrr_classes[11][9] = int_stack + 59630;
 Libint->vrr_classes[11][10] = int_stack + 63920;
 Libint->vrr_classes[11][11] = int_stack + 69068;
 memset(int_stack,0,75152*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 75152;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihlf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+75152,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78932,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+83552,int_stack+78932,int_stack+75152,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+91112,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96656,int_stack+91112,int_stack+78932,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+105896,int_stack+96656,int_stack+83552,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+75152,int_stack+8452,int_stack+6832,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+80012,int_stack+10432,int_stack+8452,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+85952,int_stack+80012,int_stack+75152,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+95672,int_stack+12808,int_stack+10432,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+95672,int_stack+80012,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+118496,int_stack+0,int_stack+85952,36);
 /*--- compute (ip|lf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+134696,int_stack+118496,int_stack+105896,450);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+17641,int_stack+15616,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+6075,int_stack+20116,int_stack+17641,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+75152,int_stack+6075,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87302,int_stack+23086,int_stack+20116,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96212,int_stack+87302,int_stack+6075,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+96212,int_stack+75152,45);
 /*--- compute (kp|lf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+172496,int_stack+0,int_stack+118496,450);
 /*--- compute (id|lf) ---*/
 hrr1_build_id(Libint->AB,int_stack+221096,int_stack+172496,int_stack+134696,450);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+75152,int_stack+29071,int_stack+26596,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+82577,int_stack+32096,int_stack+29071,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+91652,int_stack+82577,int_stack+75152,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+106502,int_stack+35726,int_stack+32096,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+117392,int_stack+106502,int_stack+82577,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+135542,int_stack+117392,int_stack+91652,55);
 /*--- compute (lp|lf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+296696,int_stack+135542,int_stack+0,450);
 /*--- compute (kd|lf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+357446,int_stack+296696,int_stack+172496,450);
 /*--- compute (if|lf) ---*/
 hrr1_build_if(Libint->AB,int_stack+454646,int_stack+357446,int_stack+221096,450);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+42986,int_stack+40016,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+46616,int_stack+42986,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+75152,int_stack+50972,int_stack+46616,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+88220,int_stack+75152,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+160292,int_stack+88220,int_stack+19800,66);
 /*--- compute (mp|lf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+189992,int_stack+160292,int_stack+135542,450);
 /*--- compute (ld|lf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+580646,int_stack+189992,int_stack+296696,450);
 /*--- compute (kf|lf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+702146,int_stack+580646,int_stack+357446,450);
 /*--- compute (ig|lf) ---*/
 hrr1_build_ig(Libint->AB,int_stack+264242,int_stack+702146,int_stack+454646,450);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+75152,int_stack+59630,int_stack+56120,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+85682,int_stack+63920,int_stack+59630,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+98552,int_stack+85682,int_stack+75152,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119612,int_stack+69068,int_stack+63920,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+119612,int_stack+85682,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+119612,int_stack+0,int_stack+98552,78);
 /*--- compute (np|lf) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+119612,int_stack+160292,450);
 /*--- compute (md|lf) ---*/
 hrr1_build_md(Libint->AB,int_stack+864146,int_stack+0,int_stack+189992,450);
 /*--- compute (lf|lf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+864146,int_stack+580646,450);
 /*--- compute (kg|lf) ---*/
 hrr1_build_kg(Libint->AB,int_stack+453242,int_stack+0,int_stack+702146,450);
 /*--- compute (ih|lf) ---*/
 hrr1_build_ih(Libint->AB,int_stack+696242,int_stack+453242,int_stack+264242,450);
 return int_stack+696242;}
