/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihlg(Libint_t*, prim_data*);

  /* Computes quartets of (ih|lg) integrals */

REALTYPE *hrr_order_ihlg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[7][8] = int_stack + 9380;
 Libint->vrr_classes[7][9] = int_stack + 11000;
 Libint->vrr_classes[7][10] = int_stack + 12980;
 Libint->vrr_classes[7][11] = int_stack + 15356;
 Libint->vrr_classes[7][12] = int_stack + 18164;
 Libint->vrr_classes[8][8] = int_stack + 21440;
 Libint->vrr_classes[8][9] = int_stack + 23465;
 Libint->vrr_classes[8][10] = int_stack + 25940;
 Libint->vrr_classes[8][11] = int_stack + 28910;
 Libint->vrr_classes[8][12] = int_stack + 32420;
 Libint->vrr_classes[9][8] = int_stack + 36515;
 Libint->vrr_classes[9][9] = int_stack + 38990;
 Libint->vrr_classes[9][10] = int_stack + 42015;
 Libint->vrr_classes[9][11] = int_stack + 45645;
 Libint->vrr_classes[9][12] = int_stack + 49935;
 Libint->vrr_classes[10][8] = int_stack + 54940;
 Libint->vrr_classes[10][9] = int_stack + 57910;
 Libint->vrr_classes[10][10] = int_stack + 61540;
 Libint->vrr_classes[10][11] = int_stack + 65896;
 Libint->vrr_classes[10][12] = int_stack + 71044;
 Libint->vrr_classes[11][8] = int_stack + 77050;
 Libint->vrr_classes[11][9] = int_stack + 80560;
 Libint->vrr_classes[11][10] = int_stack + 84850;
 Libint->vrr_classes[11][11] = int_stack + 89998;
 Libint->vrr_classes[11][12] = int_stack + 96082;
 memset(int_stack,0,103180*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 103180;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihlg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103180,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+106960,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+111580,int_stack+106960,int_stack+103180,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+119140,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+124684,int_stack+119140,int_stack+106960,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+133924,int_stack+124684,int_stack+111580,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103180,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+146524,int_stack+103180,int_stack+119140,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103180,int_stack+146524,int_stack+124684,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+146524,int_stack+103180,int_stack+133924,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103180,int_stack+11000,int_stack+9380,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+108040,int_stack+12980,int_stack+11000,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+113980,int_stack+108040,int_stack+103180,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+123700,int_stack+15356,int_stack+12980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+130828,int_stack+123700,int_stack+108040,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+165424,int_stack+130828,int_stack+113980,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103180,int_stack+18164,int_stack+15356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+103180,int_stack+123700,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103180,int_stack+0,int_stack+130828,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+181624,int_stack+103180,int_stack+165424,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+205924,int_stack+181624,int_stack+146524,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103180,int_stack+23465,int_stack+21440,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+109255,int_stack+25940,int_stack+23465,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116680,int_stack+109255,int_stack+103180,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128830,int_stack+28910,int_stack+25940,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+137740,int_stack+128830,int_stack+109255,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+152590,int_stack+137740,int_stack+116680,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103180,int_stack+32420,int_stack+28910,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+103180,int_stack+128830,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103180,int_stack+0,int_stack+137740,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+103180,int_stack+152590,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+103180,int_stack+0,int_stack+181624,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+262624,int_stack+103180,int_stack+205924,675);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+176080,int_stack+38990,int_stack+36515,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+183505,int_stack+42015,int_stack+38990,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+192580,int_stack+183505,int_stack+176080,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+207430,int_stack+45645,int_stack+42015,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+218320,int_stack+207430,int_stack+183505,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+236470,int_stack+218320,int_stack+192580,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+176080,int_stack+49935,int_stack+45645,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+30375,int_stack+176080,int_stack+207430,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+176080,int_stack+30375,int_stack+218320,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+376024,int_stack+176080,int_stack+236470,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+413149,int_stack+376024,int_stack+0,675);
 /*--- compute (kd|lg) ---*/
 hrr1_build_kd(Libint->AB,int_stack+504274,int_stack+413149,int_stack+103180,675);
 /*--- compute (if|lg) ---*/
 hrr1_build_if(Libint->AB,int_stack+650074,int_stack+504274,int_stack+262624,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103180,int_stack+57910,int_stack+54940,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+112090,int_stack+61540,int_stack+57910,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122980,int_stack+112090,int_stack+103180,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140800,int_stack+65896,int_stack+61540,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+153868,int_stack+140800,int_stack+112090,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+175648,int_stack+153868,int_stack+122980,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103180,int_stack+71044,int_stack+65896,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+205348,int_stack+103180,int_stack+140800,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103180,int_stack+205348,int_stack+153868,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+205348,int_stack+103180,int_stack+175648,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+249898,int_stack+205348,int_stack+376024,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+839074,int_stack+249898,int_stack+413149,675);
 /*--- compute (kf|lg) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1021324,int_stack+839074,int_stack+504274,675);
 /*--- compute (ig|lg) ---*/
 hrr1_build_ig(Libint->AB,int_stack+361273,int_stack+1021324,int_stack+650074,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+103180,int_stack+80560,int_stack+77050,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+113710,int_stack+84850,int_stack+80560,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+126580,int_stack+113710,int_stack+103180,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+147640,int_stack+89998,int_stack+84850,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+163084,int_stack+147640,int_stack+113710,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+644773,int_stack+163084,int_stack+126580,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+103180,int_stack+96082,int_stack+89998,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+679873,int_stack+103180,int_stack+147640,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+710761,int_stack+679873,int_stack+163084,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+753661,int_stack+710761,int_stack+644773,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+753661,int_stack+205348,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+1264324,int_stack+0,int_stack+249898,675);
 /*--- compute (lf|lg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1264324,int_stack+839074,675);
 /*--- compute (kg|lg) ---*/
 hrr1_build_kg(Libint->AB,int_stack+644773,int_stack+0,int_stack+1021324,675);
 /*--- compute (ih|lg) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1009273,int_stack+644773,int_stack+361273,675);
 return int_stack+1009273;}
