/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihnp(Libint_t*, prim_data*);

  /* Computes quartets of (ih|np) integrals */

REALTYPE *hrr_order_ihnp(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[7][10] = int_stack + 4032;
 Libint->vrr_classes[7][11] = int_stack + 6408;
 Libint->vrr_classes[8][10] = int_stack + 9216;
 Libint->vrr_classes[8][11] = int_stack + 12186;
 Libint->vrr_classes[9][10] = int_stack + 15696;
 Libint->vrr_classes[9][11] = int_stack + 19326;
 Libint->vrr_classes[10][10] = int_stack + 23616;
 Libint->vrr_classes[10][11] = int_stack + 27972;
 Libint->vrr_classes[11][10] = int_stack + 33120;
 Libint->vrr_classes[11][11] = int_stack + 38268;
 memset(int_stack,0,44352*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 44352;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihnp(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44352,int_stack+1848,int_stack+0,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+49896,int_stack+6408,int_stack+4032,36);
 /*--- compute (ip|np) ---*/
 hrr1_build_ip(Libint->AB,int_stack+57024,int_stack+49896,int_stack+44352,198);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+12186,int_stack+9216,45);
 /*--- compute (kp|np) ---*/
 hrr1_build_kp(Libint->AB,int_stack+73656,int_stack+0,int_stack+49896,198);
 /*--- compute (id|np) ---*/
 hrr1_build_id(Libint->AB,int_stack+95040,int_stack+73656,int_stack+57024,198);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44352,int_stack+19326,int_stack+15696,55);
 /*--- compute (lp|np) ---*/
 hrr1_build_lp(Libint->AB,int_stack+128304,int_stack+44352,int_stack+0,198);
 /*--- compute (kd|np) ---*/
 hrr1_build_kd(Libint->AB,int_stack+155034,int_stack+128304,int_stack+73656,198);
 /*--- compute (if|np) ---*/
 hrr1_build_if(Libint->AB,int_stack+197802,int_stack+155034,int_stack+95040,198);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+27972,int_stack+23616,66);
 /*--- compute (mp|np) ---*/
 hrr1_build_mp(Libint->AB,int_stack+55242,int_stack+0,int_stack+44352,198);
 /*--- compute (ld|np) ---*/
 hrr1_build_ld(Libint->AB,int_stack+253242,int_stack+55242,int_stack+128304,198);
 /*--- compute (kf|np) ---*/
 hrr1_build_kf(Libint->AB,int_stack+306702,int_stack+253242,int_stack+155034,198);
 /*--- compute (ig|np) ---*/
 hrr1_build_ig(Libint->AB,int_stack+87912,int_stack+306702,int_stack+197802,198);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+13068,int_stack+38268,int_stack+33120,78);
 /*--- compute (np|np) ---*/
 hrr1_build_np(Libint->AB,int_stack+171072,int_stack+13068,int_stack+0,198);
 /*--- compute (md|np) ---*/
 hrr1_build_md(Libint->AB,int_stack+377982,int_stack+171072,int_stack+55242,198);
 /*--- compute (lf|np) ---*/
 hrr1_build_lf(Libint->AB,int_stack+443322,int_stack+377982,int_stack+253242,198);
 /*--- compute (kg|np) ---*/
 hrr1_build_kg(Libint->AB,int_stack+171072,int_stack+443322,int_stack+306702,198);
 /*--- compute (ih|np) ---*/
 hrr1_build_ih(Libint->AB,int_stack+277992,int_stack+171072,int_stack+87912,198);
 return int_stack+277992;}
