/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_iimf(Libint_t*, prim_data*);

  /* Computes quartets of (ii|mf) integrals */

REALTYPE *hrr_order_iimf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[7][9] = int_stack + 8120;
 Libint->vrr_classes[7][10] = int_stack + 10100;
 Libint->vrr_classes[7][11] = int_stack + 12476;
 Libint->vrr_classes[7][12] = int_stack + 15284;
 Libint->vrr_classes[8][9] = int_stack + 18560;
 Libint->vrr_classes[8][10] = int_stack + 21035;
 Libint->vrr_classes[8][11] = int_stack + 24005;
 Libint->vrr_classes[8][12] = int_stack + 27515;
 Libint->vrr_classes[9][9] = int_stack + 31610;
 Libint->vrr_classes[9][10] = int_stack + 34635;
 Libint->vrr_classes[9][11] = int_stack + 38265;
 Libint->vrr_classes[9][12] = int_stack + 42555;
 Libint->vrr_classes[10][9] = int_stack + 47560;
 Libint->vrr_classes[10][10] = int_stack + 51190;
 Libint->vrr_classes[10][11] = int_stack + 55546;
 Libint->vrr_classes[10][12] = int_stack + 60694;
 Libint->vrr_classes[11][9] = int_stack + 66700;
 Libint->vrr_classes[11][10] = int_stack + 70990;
 Libint->vrr_classes[11][11] = int_stack + 76138;
 Libint->vrr_classes[11][12] = int_stack + 82222;
 Libint->vrr_classes[12][9] = int_stack + 89320;
 Libint->vrr_classes[12][10] = int_stack + 94325;
 Libint->vrr_classes[12][11] = int_stack + 100331;
 Libint->vrr_classes[12][12] = int_stack + 107429;
 memset(int_stack,0,115710*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 115710;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_iimf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115710,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+120330,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+125874,int_stack+120330,int_stack+115710,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+135114,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+141666,int_stack+135114,int_stack+120330,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+152754,int_stack+141666,int_stack+125874,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115710,int_stack+10100,int_stack+8120,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+121650,int_stack+12476,int_stack+10100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+128778,int_stack+121650,int_stack+115710,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+140658,int_stack+15284,int_stack+12476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+140658,int_stack+121650,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+168154,int_stack+0,int_stack+128778,36);
 /*--- compute (ip|mf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+187954,int_stack+168154,int_stack+152754,550);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+21035,int_stack+18560,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+24005,int_stack+21035,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+115710,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+130560,int_stack+27515,int_stack+24005,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+141090,int_stack+130560,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+141090,int_stack+115710,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+234154,int_stack+0,int_stack+168154,550);
 /*--- compute (id|mf) ---*/
 hrr1_build_id(Libint->AB,int_stack+293554,int_stack+234154,int_stack+187954,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115710,int_stack+34635,int_stack+31610,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+124785,int_stack+38265,int_stack+34635,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+135675,int_stack+124785,int_stack+115710,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+153825,int_stack+42555,int_stack+38265,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166695,int_stack+153825,int_stack+124785,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+188475,int_stack+166695,int_stack+135675,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+385954,int_stack+188475,int_stack+0,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+460204,int_stack+385954,int_stack+234154,550);
 /*--- compute (if|mf) ---*/
 hrr1_build_if(Libint->AB,int_stack+579004,int_stack+460204,int_stack+293554,550);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+51190,int_stack+47560,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+55546,int_stack+51190,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+115710,int_stack+60694,int_stack+55546,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+131154,int_stack+115710,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+218725,int_stack+131154,int_stack+23958,66);
 /*--- compute (mp|mf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+255025,int_stack+218725,int_stack+188475,550);
 /*--- compute (ld|mf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+733004,int_stack+255025,int_stack+385954,550);
 /*--- compute (kf|mf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+881504,int_stack+733004,int_stack+460204,550);
 /*--- compute (ig|mf) ---*/
 hrr1_build_ig(Libint->AB,int_stack+345775,int_stack+881504,int_stack+579004,550);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115710,int_stack+70990,int_stack+66700,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128580,int_stack+76138,int_stack+70990,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144024,int_stack+128580,int_stack+115710,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+169764,int_stack+82222,int_stack+76138,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+169764,int_stack+128580,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+169764,int_stack+0,int_stack+144024,78);
 /*--- compute (np|mf) ---*/
 hrr1_build_np(Libint->AB,int_stack+576775,int_stack+169764,int_stack+218725,550);
 /*--- compute (md|mf) ---*/
 hrr1_build_md(Libint->AB,int_stack+1079504,int_stack+576775,int_stack+255025,550);
 /*--- compute (lf|mf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1261004,int_stack+1079504,int_stack+733004,550);
 /*--- compute (kg|mf) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1508504,int_stack+1261004,int_stack+881504,550);
 /*--- compute (ih|mf) ---*/
 hrr1_build_ih(Libint->AB,int_stack+685675,int_stack+1508504,int_stack+345775,550);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+94325,int_stack+89320,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+100331,int_stack+94325,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+107429,int_stack+100331,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+212664,int_stack+84357,int_stack+33033,91);
 /*--- compute (op|mf) ---*/
 hrr1_build_op(Libint->AB,int_stack+0,int_stack+212664,int_stack+169764,550);
 /*--- compute (nd|mf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+128700,int_stack+0,int_stack+576775,550);
 /*--- compute (mf|mf) ---*/
 hrr1_build_mf(Libint->AB,int_stack+346500,int_stack+128700,int_stack+1079504,550);
 /*--- compute (lg|mf) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1805504,int_stack+346500,int_stack+1261004,550);
 /*--- compute (kh|mf) ---*/
 hrr1_build_kh(Libint->AB,int_stack+0,int_stack+1805504,int_stack+1508504,550);
 /*--- compute (ii|mf) ---*/
 hrr1_build_ii(Libint->AB,int_stack+1009075,int_stack+0,int_stack+685675,550);
 return int_stack+1009075;}
