/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipml(Libint_t*, prim_data*);

  /* Computes quartets of (ip|ml) integrals */

REALTYPE *hrr_order_ipml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[6][17] = int_stack + 22512;
 Libint->vrr_classes[7][9] = int_stack + 27300;
 Libint->vrr_classes[7][10] = int_stack + 29280;
 Libint->vrr_classes[7][11] = int_stack + 31656;
 Libint->vrr_classes[7][12] = int_stack + 34464;
 Libint->vrr_classes[7][13] = int_stack + 37740;
 Libint->vrr_classes[7][14] = int_stack + 41520;
 Libint->vrr_classes[7][15] = int_stack + 45840;
 Libint->vrr_classes[7][16] = int_stack + 50736;
 Libint->vrr_classes[7][17] = int_stack + 56244;
 memset(int_stack,0,62400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 62400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipml(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62400,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+67020,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+72564,int_stack+67020,int_stack+62400,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+81804,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+88356,int_stack+81804,int_stack+67020,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+99444,int_stack+88356,int_stack+72564,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62400,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+114844,int_stack+62400,int_stack+81804,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+127948,int_stack+114844,int_stack+88356,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+70044,int_stack+127948,int_stack+99444,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+93144,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+146428,int_stack+93144,int_stack+62400,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+161716,int_stack+146428,int_stack+114844,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+183556,int_stack+161716,int_stack+127948,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+101964,int_stack+183556,int_stack+70044,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+62400,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72480,int_stack+62400,int_stack+93144,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+211276,int_stack+72480,int_stack+146428,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+236756,int_stack+211276,int_stack+161716,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+134304,int_stack+236756,int_stack+183556,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+269516,int_stack+134304,int_stack+101964,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+90120,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+101544,int_stack+90120,int_stack+62400,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+173112,int_stack+101544,int_stack+72480,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+312636,int_stack+173112,int_stack+211276,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+350856,int_stack+312636,int_stack+236756,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+202512,int_stack+350856,int_stack+134304,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+396720,int_stack+202512,int_stack+269516,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+62400,int_stack+22512,int_stack+18228,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+121704,int_stack+62400,int_stack+90120,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+62400,int_stack+121704,int_stack+101544,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+96000,int_stack+62400,int_stack+173112,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+140100,int_stack+96000,int_stack+312636,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+62400,int_stack+140100,int_stack+350856,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+123552,int_stack+62400,int_stack+202512,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+190080,int_stack+123552,int_stack+396720,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+62400,int_stack+29280,int_stack+27300,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68340,int_stack+31656,int_stack+29280,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+75468,int_stack+68340,int_stack+62400,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87348,int_stack+34464,int_stack+31656,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95772,int_stack+87348,int_stack+68340,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+110028,int_stack+95772,int_stack+75468,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62400,int_stack+37740,int_stack+34464,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+129828,int_stack+62400,int_stack+87348,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146676,int_stack+129828,int_stack+95772,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+72228,int_stack+146676,int_stack+110028,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+101928,int_stack+41520,int_stack+37740,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+259380,int_stack+101928,int_stack+62400,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+279036,int_stack+259380,int_stack+129828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+307116,int_stack+279036,int_stack+146676,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+113268,int_stack+307116,int_stack+72228,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+62400,int_stack+45840,int_stack+41520,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+75360,int_stack+62400,int_stack+101928,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+154848,int_stack+75360,int_stack+259380,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+342756,int_stack+154848,int_stack+279036,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+384876,int_stack+342756,int_stack+307116,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+259380,int_stack+384876,int_stack+113268,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+314820,int_stack+50736,int_stack+45840,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+98040,int_stack+314820,int_stack+62400,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+98040,int_stack+75360,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+434772,int_stack+0,int_stack+154848,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+123960,int_stack+434772,int_stack+342756,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+483912,int_stack+123960,int_stack+384876,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+329508,int_stack+483912,int_stack+259380,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+259380,int_stack+56244,int_stack+50736,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+275904,int_stack+259380,int_stack+314820,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+37800,int_stack+275904,int_stack+98040,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+259380,int_stack+37800,int_stack+0,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+259380,int_stack+434772,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+400788,int_stack+0,int_stack+123960,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+400788,int_stack+483912,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+400788,int_stack+0,int_stack+329508,36);
 /*--- compute (ip|ml) ---*/
 hrr1_build_ip(Libint->AB,int_stack+489888,int_stack+400788,int_stack+190080,2475);
 return int_stack+489888;}
