/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdhh(Libint_t*, prim_data*);

  /* Computes quartets of (kd|hh) integrals */

REALTYPE *hrr_order_kdhh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][5] = int_stack + 0;
 Libint->vrr_classes[7][6] = int_stack + 756;
 Libint->vrr_classes[7][7] = int_stack + 1764;
 Libint->vrr_classes[7][8] = int_stack + 3060;
 Libint->vrr_classes[7][9] = int_stack + 4680;
 Libint->vrr_classes[7][10] = int_stack + 6660;
 Libint->vrr_classes[8][5] = int_stack + 9036;
 Libint->vrr_classes[8][6] = int_stack + 9981;
 Libint->vrr_classes[8][7] = int_stack + 11241;
 Libint->vrr_classes[8][8] = int_stack + 12861;
 Libint->vrr_classes[8][9] = int_stack + 14886;
 Libint->vrr_classes[8][10] = int_stack + 17361;
 Libint->vrr_classes[9][5] = int_stack + 20331;
 Libint->vrr_classes[9][6] = int_stack + 21486;
 Libint->vrr_classes[9][7] = int_stack + 23026;
 Libint->vrr_classes[9][8] = int_stack + 25006;
 Libint->vrr_classes[9][9] = int_stack + 27481;
 Libint->vrr_classes[9][10] = int_stack + 30506;
 memset(int_stack,0,34136*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 34136;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdhh(Libint, Data);
   Data++;
 }
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+34136,int_stack+756,int_stack+0,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+36404,int_stack+1764,int_stack+756,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+39428,int_stack+36404,int_stack+34136,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+43964,int_stack+3060,int_stack+1764,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+47852,int_stack+43964,int_stack+36404,36);
 /*--- compute (k0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+53900,int_stack+47852,int_stack+39428,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+34136,int_stack+4680,int_stack+3060,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+61460,int_stack+34136,int_stack+43964,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+69236,int_stack+61460,int_stack+47852,36);
 /*--- compute (k0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+38996,int_stack+69236,int_stack+53900,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50336,int_stack+6660,int_stack+4680,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+79316,int_stack+50336,int_stack+34136,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+89036,int_stack+79316,int_stack+61460,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+50336,int_stack+89036,int_stack+69236,36);
 /*--- compute (k0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+65456,int_stack+50336,int_stack+38996,36);
 /*--- compute (l0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+34136,int_stack+9981,int_stack+9036,45);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+36971,int_stack+11241,int_stack+9981,45);
 /*--- compute (l0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+40751,int_stack+36971,int_stack+34136,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+46421,int_stack+12861,int_stack+11241,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+51281,int_stack+46421,int_stack+36971,45);
 /*--- compute (l0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+81332,int_stack+51281,int_stack+40751,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+34136,int_stack+14886,int_stack+12861,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+90782,int_stack+34136,int_stack+46421,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+90782,int_stack+51281,45);
 /*--- compute (l0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+40211,int_stack+0,int_stack+81332,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+81332,int_stack+17361,int_stack+14886,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+100502,int_stack+81332,int_stack+34136,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+112652,int_stack+100502,int_stack+90782,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+81332,int_stack+112652,int_stack+0,45);
 /*--- compute (l0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+0,int_stack+81332,int_stack+40211,45);
 /*--- compute (kp|hh) ---*/
 hrr1_build_kp(Libint->AB,int_stack+81332,int_stack+0,int_stack+65456,441);
 /*--- compute (m0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+34136,int_stack+21486,int_stack+20331,55);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+37601,int_stack+23026,int_stack+21486,55);
 /*--- compute (m0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+42221,int_stack+37601,int_stack+34136,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+49151,int_stack+25006,int_stack+23026,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+55091,int_stack+49151,int_stack+37601,55);
 /*--- compute (m0|hf) ---*/
 hrr3_build_hf(Libint->CD,int_stack+64331,int_stack+55091,int_stack+42221,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+34136,int_stack+27481,int_stack+25006,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+128960,int_stack+34136,int_stack+49151,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+140840,int_stack+128960,int_stack+55091,55);
 /*--- compute (m0|hg) ---*/
 hrr3_build_hg(Libint->CD,int_stack+41561,int_stack+140840,int_stack+64331,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58886,int_stack+30506,int_stack+27481,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+156240,int_stack+58886,int_stack+34136,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+58886,int_stack+156240,int_stack+128960,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+156240,int_stack+58886,int_stack+140840,55);
 /*--- compute (m0|hh) ---*/
 hrr3_build_hh(Libint->CD,int_stack+128960,int_stack+156240,int_stack+41561,55);
 /*--- compute (lp|hh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+19845,int_stack+128960,int_stack+0,441);
 /*--- compute (kd|hh) ---*/
 hrr1_build_kd(Libint->AB,int_stack+128960,int_stack+19845,int_stack+81332,441);
 return int_stack+128960;}
