/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdkk(Libint_t*, prim_data*);

  /* Computes quartets of (kd|kk) integrals */

REALTYPE *hrr_order_kdkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[7][13] = int_stack + 13356;
 Libint->vrr_classes[7][14] = int_stack + 17136;
 Libint->vrr_classes[8][7] = int_stack + 21456;
 Libint->vrr_classes[8][8] = int_stack + 23076;
 Libint->vrr_classes[8][9] = int_stack + 25101;
 Libint->vrr_classes[8][10] = int_stack + 27576;
 Libint->vrr_classes[8][11] = int_stack + 30546;
 Libint->vrr_classes[8][12] = int_stack + 34056;
 Libint->vrr_classes[8][13] = int_stack + 38151;
 Libint->vrr_classes[8][14] = int_stack + 42876;
 Libint->vrr_classes[9][7] = int_stack + 48276;
 Libint->vrr_classes[9][8] = int_stack + 50256;
 Libint->vrr_classes[9][9] = int_stack + 52731;
 Libint->vrr_classes[9][10] = int_stack + 55756;
 Libint->vrr_classes[9][11] = int_stack + 59386;
 Libint->vrr_classes[9][12] = int_stack + 63676;
 Libint->vrr_classes[9][13] = int_stack + 68681;
 Libint->vrr_classes[9][14] = int_stack + 74456;
 memset(int_stack,0,81056*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 81056;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdkk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+81056,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84944,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+89804,int_stack+84944,int_stack+81056,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+97580,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+103520,int_stack+97580,int_stack+84944,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+113240,int_stack+103520,int_stack+89804,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+81056,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126200,int_stack+81056,int_stack+97580,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+138080,int_stack+126200,int_stack+103520,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+88184,int_stack+138080,int_stack+113240,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+107624,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+154280,int_stack+107624,int_stack+81056,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+168536,int_stack+154280,int_stack+126200,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+188336,int_stack+168536,int_stack+138080,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+116048,int_stack+188336,int_stack+88184,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+81056,int_stack+13356,int_stack+10080,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+212636,int_stack+81056,int_stack+107624,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+90884,int_stack+212636,int_stack+154280,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+229484,int_stack+90884,int_stack+168536,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+143264,int_stack+229484,int_stack+188336,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+259184,int_stack+143264,int_stack+116048,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+114644,int_stack+17136,int_stack+13356,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+177284,int_stack+114644,int_stack+81056,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+114644,int_stack+177284,int_stack+212636,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+177284,int_stack+114644,int_stack+90884,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+81056,int_stack+177284,int_stack+229484,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+177284,int_stack+81056,int_stack+143264,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+81056,int_stack+177284,int_stack+259184,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+127712,int_stack+23076,int_stack+21456,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+132572,int_stack+25101,int_stack+23076,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+138647,int_stack+132572,int_stack+127712,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+148367,int_stack+27576,int_stack+25101,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+155792,int_stack+148367,int_stack+132572,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+167942,int_stack+155792,int_stack+138647,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+127712,int_stack+30546,int_stack+27576,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+184142,int_stack+127712,int_stack+148367,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+198992,int_stack+184142,int_stack+155792,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+136622,int_stack+198992,int_stack+167942,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+160922,int_stack+34056,int_stack+30546,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+219242,int_stack+160922,int_stack+127712,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+237062,int_stack+219242,int_stack+184142,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+261812,int_stack+237062,int_stack+198992,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+171452,int_stack+261812,int_stack+136622,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+127712,int_stack+38151,int_stack+34056,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+127712,int_stack+160922,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+139997,int_stack+0,int_stack+219242,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+292187,int_stack+139997,int_stack+237062,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+205472,int_stack+292187,int_stack+261812,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+329312,int_stack+205472,int_stack+171452,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+169697,int_stack+42876,int_stack+38151,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+247997,int_stack+169697,int_stack+127712,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+169697,int_stack+247997,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+169697,int_stack+139997,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+127712,int_stack+0,int_stack+292187,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+247997,int_stack+127712,int_stack+205472,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+127712,int_stack+247997,int_stack+329312,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+186032,int_stack+127712,int_stack+81056,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+81056,int_stack+50256,int_stack+48276,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+86996,int_stack+52731,int_stack+50256,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+94421,int_stack+86996,int_stack+81056,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+106301,int_stack+55756,int_stack+52731,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+326000,int_stack+106301,int_stack+86996,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+340850,int_stack+326000,int_stack+94421,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+81056,int_stack+59386,int_stack+55756,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+81056,int_stack+106301,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+91946,int_stack+0,int_stack+326000,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18150,int_stack+91946,int_stack+340850,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+326000,int_stack+63676,int_stack+59386,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+338870,int_stack+326000,int_stack+81056,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+360650,int_stack+338870,int_stack+0,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+390900,int_stack+360650,int_stack+91946,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+81056,int_stack+390900,int_stack+18150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+68681,int_stack+63676,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15015,int_stack+0,int_stack+326000,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+428025,int_stack+15015,int_stack+338870,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+464325,int_stack+428025,int_stack+360650,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+326000,int_stack+464325,int_stack+390900,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+509700,int_stack+326000,int_stack+81056,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+81056,int_stack+74456,int_stack+68681,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+377975,int_stack+81056,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+40755,int_stack+377975,int_stack+15015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+565140,int_stack+40755,int_stack+428025,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+377975,int_stack+565140,int_stack+464325,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+377975,int_stack+326000,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+326000,int_stack+0,int_stack+509700,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+397280,int_stack+326000,int_stack+127712,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+572240,int_stack+397280,int_stack+186032,1296);
 return int_stack+572240;}
