/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kdml(Libint_t*, prim_data*);

  /* Computes quartets of (kd|ml) integrals */

REALTYPE *hrr_order_kdml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 Libint->vrr_classes[8][9] = int_stack + 35100;
 Libint->vrr_classes[8][10] = int_stack + 37575;
 Libint->vrr_classes[8][11] = int_stack + 40545;
 Libint->vrr_classes[8][12] = int_stack + 44055;
 Libint->vrr_classes[8][13] = int_stack + 48150;
 Libint->vrr_classes[8][14] = int_stack + 52875;
 Libint->vrr_classes[8][15] = int_stack + 58275;
 Libint->vrr_classes[8][16] = int_stack + 64395;
 Libint->vrr_classes[8][17] = int_stack + 71280;
 Libint->vrr_classes[9][9] = int_stack + 78975;
 Libint->vrr_classes[9][10] = int_stack + 82000;
 Libint->vrr_classes[9][11] = int_stack + 85630;
 Libint->vrr_classes[9][12] = int_stack + 89920;
 Libint->vrr_classes[9][13] = int_stack + 94925;
 Libint->vrr_classes[9][14] = int_stack + 100700;
 Libint->vrr_classes[9][15] = int_stack + 107300;
 Libint->vrr_classes[9][16] = int_stack + 114780;
 Libint->vrr_classes[9][17] = int_stack + 123195;
 memset(int_stack,0,132600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 132600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kdml(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+132600,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+138540,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+145668,int_stack+138540,int_stack+132600,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+157548,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+165972,int_stack+157548,int_stack+138540,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+180228,int_stack+165972,int_stack+145668,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+132600,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+200028,int_stack+132600,int_stack+157548,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+216876,int_stack+200028,int_stack+165972,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+142428,int_stack+216876,int_stack+180228,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+172128,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+240636,int_stack+172128,int_stack+132600,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+260292,int_stack+240636,int_stack+200028,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+288372,int_stack+260292,int_stack+216876,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+183468,int_stack+288372,int_stack+142428,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+132600,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+145560,int_stack+132600,int_stack+172128,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+324012,int_stack+145560,int_stack+240636,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+356772,int_stack+324012,int_stack+260292,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+225048,int_stack+356772,int_stack+288372,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+398892,int_stack+225048,int_stack+183468,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+168240,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+182928,int_stack+168240,int_stack+132600,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+274944,int_stack+182928,int_stack+145560,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+454332,int_stack+274944,int_stack+324012,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+503472,int_stack+454332,int_stack+356772,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+312744,int_stack+503472,int_stack+225048,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+562440,int_stack+312744,int_stack+398892,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+132600,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+208848,int_stack+132600,int_stack+168240,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+132600,int_stack+208848,int_stack+182928,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+175800,int_stack+132600,int_stack+274944,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+232500,int_stack+175800,int_stack+454332,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+132600,int_stack+232500,int_stack+503472,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+211224,int_stack+132600,int_stack+312744,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+296760,int_stack+211224,int_stack+562440,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+132600,int_stack+37575,int_stack+35100,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+140025,int_stack+40545,int_stack+37575,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+148935,int_stack+140025,int_stack+132600,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+163785,int_stack+44055,int_stack+40545,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+174315,int_stack+163785,int_stack+140025,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+192135,int_stack+174315,int_stack+148935,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+132600,int_stack+48150,int_stack+44055,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+216885,int_stack+132600,int_stack+163785,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+237945,int_stack+216885,int_stack+174315,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+144885,int_stack+237945,int_stack+192135,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+182010,int_stack+52875,int_stack+48150,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267645,int_stack+182010,int_stack+132600,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+385860,int_stack+267645,int_stack+216885,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+420960,int_stack+385860,int_stack+237945,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+196185,int_stack+420960,int_stack+144885,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+132600,int_stack+58275,int_stack+52875,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+148800,int_stack+132600,int_stack+182010,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+465510,int_stack+148800,int_stack+267645,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+506460,int_stack+465510,int_stack+385860,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+559110,int_stack+506460,int_stack+420960,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+385860,int_stack+559110,int_stack+196185,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+177150,int_stack+64395,int_stack+58275,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+195510,int_stack+177150,int_stack+132600,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+227910,int_stack+195510,int_stack+148800,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+227910,int_stack+465510,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+621480,int_stack+0,int_stack+506460,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+455160,int_stack+621480,int_stack+559110,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+695190,int_stack+455160,int_stack+385860,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+385860,int_stack+71280,int_stack+64395,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+406515,int_stack+385860,int_stack+177150,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+132600,int_stack+406515,int_stack+195510,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+538320,int_stack+132600,int_stack+227910,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+132600,int_stack+538320,int_stack+0,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+784290,int_stack+132600,int_stack+621480,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+132600,int_stack+784290,int_stack+455160,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+385860,int_stack+132600,int_stack+695190,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+497235,int_stack+385860,int_stack+296760,2475);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+132600,int_stack+82000,int_stack+78975,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141675,int_stack+85630,int_stack+82000,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+152565,int_stack+141675,int_stack+132600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+170715,int_stack+89920,int_stack+85630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+183585,int_stack+170715,int_stack+141675,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+205365,int_stack+183585,int_stack+152565,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+132600,int_stack+94925,int_stack+89920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+235615,int_stack+132600,int_stack+170715,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+261355,int_stack+235615,int_stack+183585,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+147615,int_stack+261355,int_stack+205365,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+192990,int_stack+100700,int_stack+94925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+297655,int_stack+192990,int_stack+132600,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+327685,int_stack+297655,int_stack+235615,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+327685,int_stack+261355,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+210315,int_stack+0,int_stack+147615,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+132600,int_stack+107300,int_stack+100700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152400,int_stack+132600,int_stack+192990,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+54450,int_stack+152400,int_stack+297655,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+764535,int_stack+54450,int_stack+327685,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+273840,int_stack+764535,int_stack+0,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+828885,int_stack+273840,int_stack+210315,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+114780,int_stack+107300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+187050,int_stack+0,int_stack+132600,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+913585,int_stack+187050,int_stack+152400,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+971335,int_stack+913585,int_stack+54450,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+22440,int_stack+971335,int_stack+764535,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1046410,int_stack+22440,int_stack+273840,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+226650,int_stack+1046410,int_stack+828885,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+764535,int_stack+123195,int_stack+114780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+789780,int_stack+764535,int_stack+0,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+834660,int_stack+789780,int_stack+187050,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+112530,int_stack+834660,int_stack+913585,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+764535,int_stack+112530,int_stack+971335,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+869640,int_stack+764535,int_stack+22440,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+869640,int_stack+1046410,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+764535,int_stack+0,int_stack+226650,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+0,int_stack+764535,int_stack+385860,2475);
 /*--- compute (kd|ml) ---*/
 hrr1_build_kd(Libint->AB,int_stack+764535,int_stack+0,int_stack+497235,2475);
 return int_stack+764535;}
