/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfkk(Libint_t*, prim_data*);

  /* Computes quartets of (kf|kk) integrals */

REALTYPE *hrr_order_kfkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][7] = int_stack + 0;
 Libint->vrr_classes[7][8] = int_stack + 1296;
 Libint->vrr_classes[7][9] = int_stack + 2916;
 Libint->vrr_classes[7][10] = int_stack + 4896;
 Libint->vrr_classes[7][11] = int_stack + 7272;
 Libint->vrr_classes[7][12] = int_stack + 10080;
 Libint->vrr_classes[7][13] = int_stack + 13356;
 Libint->vrr_classes[7][14] = int_stack + 17136;
 Libint->vrr_classes[8][7] = int_stack + 21456;
 Libint->vrr_classes[8][8] = int_stack + 23076;
 Libint->vrr_classes[8][9] = int_stack + 25101;
 Libint->vrr_classes[8][10] = int_stack + 27576;
 Libint->vrr_classes[8][11] = int_stack + 30546;
 Libint->vrr_classes[8][12] = int_stack + 34056;
 Libint->vrr_classes[8][13] = int_stack + 38151;
 Libint->vrr_classes[8][14] = int_stack + 42876;
 Libint->vrr_classes[9][7] = int_stack + 48276;
 Libint->vrr_classes[9][8] = int_stack + 50256;
 Libint->vrr_classes[9][9] = int_stack + 52731;
 Libint->vrr_classes[9][10] = int_stack + 55756;
 Libint->vrr_classes[9][11] = int_stack + 59386;
 Libint->vrr_classes[9][12] = int_stack + 63676;
 Libint->vrr_classes[9][13] = int_stack + 68681;
 Libint->vrr_classes[9][14] = int_stack + 74456;
 Libint->vrr_classes[10][7] = int_stack + 81056;
 Libint->vrr_classes[10][8] = int_stack + 83432;
 Libint->vrr_classes[10][9] = int_stack + 86402;
 Libint->vrr_classes[10][10] = int_stack + 90032;
 Libint->vrr_classes[10][11] = int_stack + 94388;
 Libint->vrr_classes[10][12] = int_stack + 99536;
 Libint->vrr_classes[10][13] = int_stack + 105542;
 Libint->vrr_classes[10][14] = int_stack + 112472;
 memset(int_stack,0,120392*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 120392;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfkk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+120392,int_stack+1296,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+124280,int_stack+2916,int_stack+1296,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+129140,int_stack+124280,int_stack+120392,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+136916,int_stack+4896,int_stack+2916,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+142856,int_stack+136916,int_stack+124280,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+152576,int_stack+142856,int_stack+129140,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+120392,int_stack+7272,int_stack+4896,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+165536,int_stack+120392,int_stack+136916,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+177416,int_stack+165536,int_stack+142856,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+127520,int_stack+177416,int_stack+152576,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+146960,int_stack+10080,int_stack+7272,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+193616,int_stack+146960,int_stack+120392,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+207872,int_stack+193616,int_stack+165536,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+227672,int_stack+207872,int_stack+177416,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+155384,int_stack+227672,int_stack+127520,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+120392,int_stack+13356,int_stack+10080,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+251972,int_stack+120392,int_stack+146960,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+130220,int_stack+251972,int_stack+193616,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+268820,int_stack+130220,int_stack+207872,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+182600,int_stack+268820,int_stack+227672,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+298520,int_stack+182600,int_stack+155384,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+153980,int_stack+17136,int_stack+13356,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+216620,int_stack+153980,int_stack+120392,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+153980,int_stack+216620,int_stack+251972,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+216620,int_stack+153980,int_stack+130220,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+120392,int_stack+216620,int_stack+268820,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+216620,int_stack+120392,int_stack+182600,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+120392,int_stack+216620,int_stack+298520,36);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+167048,int_stack+23076,int_stack+21456,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+171908,int_stack+25101,int_stack+23076,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+177983,int_stack+171908,int_stack+167048,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+187703,int_stack+27576,int_stack+25101,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+195128,int_stack+187703,int_stack+171908,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+207278,int_stack+195128,int_stack+177983,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+167048,int_stack+30546,int_stack+27576,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+223478,int_stack+167048,int_stack+187703,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+238328,int_stack+223478,int_stack+195128,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+175958,int_stack+238328,int_stack+207278,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+200258,int_stack+34056,int_stack+30546,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+258578,int_stack+200258,int_stack+167048,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+276398,int_stack+258578,int_stack+223478,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+301148,int_stack+276398,int_stack+238328,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+210788,int_stack+301148,int_stack+175958,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+167048,int_stack+38151,int_stack+34056,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+167048,int_stack+200258,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+179333,int_stack+0,int_stack+258578,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+331523,int_stack+179333,int_stack+276398,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+244808,int_stack+331523,int_stack+301148,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+368648,int_stack+244808,int_stack+210788,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+209033,int_stack+42876,int_stack+38151,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+287333,int_stack+209033,int_stack+167048,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+209033,int_stack+287333,int_stack+0,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+209033,int_stack+179333,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+167048,int_stack+0,int_stack+331523,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+287333,int_stack+167048,int_stack+244808,45);
 /*--- compute (l0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+167048,int_stack+287333,int_stack+368648,45);
 /*--- compute (kp|kk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+225368,int_stack+167048,int_stack+120392,1296);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+120392,int_stack+50256,int_stack+48276,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+126332,int_stack+52731,int_stack+50256,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+133757,int_stack+126332,int_stack+120392,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+145637,int_stack+55756,int_stack+52731,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+365336,int_stack+145637,int_stack+126332,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+380186,int_stack+365336,int_stack+133757,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+120392,int_stack+59386,int_stack+55756,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+120392,int_stack+145637,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+131282,int_stack+0,int_stack+365336,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+18150,int_stack+131282,int_stack+380186,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+365336,int_stack+63676,int_stack+59386,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+378206,int_stack+365336,int_stack+120392,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+399986,int_stack+378206,int_stack+0,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+430236,int_stack+399986,int_stack+131282,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+120392,int_stack+430236,int_stack+18150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+68681,int_stack+63676,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+15015,int_stack+0,int_stack+365336,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+467361,int_stack+15015,int_stack+378206,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+503661,int_stack+467361,int_stack+399986,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+365336,int_stack+503661,int_stack+430236,55);
 /*--- compute (m0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+549036,int_stack+365336,int_stack+120392,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+120392,int_stack+74456,int_stack+68681,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+417311,int_stack+120392,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+120392,int_stack+417311,int_stack+15015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+120392,int_stack+467361,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+417311,int_stack+0,int_stack+503661,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+417311,int_stack+365336,55);
 /*--- compute (m0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+365336,int_stack+0,int_stack+549036,55);
 /*--- compute (lp|kk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+436616,int_stack+365336,int_stack+167048,1296);
 /*--- compute (kd|kk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+611576,int_stack+436616,int_stack+225368,1296);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+83432,int_stack+81056,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+86402,int_stack+83432,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+30294,int_stack+90032,int_stack+86402,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+41184,int_stack+30294,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+59004,int_stack+41184,int_stack+16038,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+94388,int_stack+90032,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+120392,int_stack+0,int_stack+30294,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+142172,int_stack+120392,int_stack+41184,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+13068,int_stack+142172,int_stack+59004,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48708,int_stack+99536,int_stack+94388,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+64152,int_stack+48708,int_stack+0,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+171872,int_stack+64152,int_stack+120392,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+208172,int_stack+171872,int_stack+142172,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+120392,int_stack+208172,int_stack+13068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+105542,int_stack+99536,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+252722,int_stack+0,int_stack+48708,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+18018,int_stack+252722,int_stack+64152,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+283610,int_stack+18018,int_stack+171872,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+891512,int_stack+283610,int_stack+208172,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+170288,int_stack+891512,int_stack+120392,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+120392,int_stack+112472,int_stack+105542,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+61578,int_stack+120392,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+97614,int_stack+61578,int_stack+252722,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+953882,int_stack+97614,int_stack+18018,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+953882,int_stack+283610,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+76230,int_stack+0,int_stack+891512,66);
 /*--- compute (n0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+891512,int_stack+76230,int_stack+170288,66);
 /*--- compute (mp|kk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+891512,int_stack+365336,1296);
 /*--- compute (ld|kk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+891512,int_stack+0,int_stack+436616,1296);
 /*--- compute (kf|kk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+891512,int_stack+611576,1296);
 return int_stack+0;}
