/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kfmf(Libint_t*, prim_data*);

  /* Computes quartets of (kf|mf) integrals */

REALTYPE *hrr_order_kfmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[8][9] = int_stack + 10440;
 Libint->vrr_classes[8][10] = int_stack + 12915;
 Libint->vrr_classes[8][11] = int_stack + 15885;
 Libint->vrr_classes[8][12] = int_stack + 19395;
 Libint->vrr_classes[9][9] = int_stack + 23490;
 Libint->vrr_classes[9][10] = int_stack + 26515;
 Libint->vrr_classes[9][11] = int_stack + 30145;
 Libint->vrr_classes[9][12] = int_stack + 34435;
 Libint->vrr_classes[10][9] = int_stack + 39440;
 Libint->vrr_classes[10][10] = int_stack + 43070;
 Libint->vrr_classes[10][11] = int_stack + 47426;
 Libint->vrr_classes[10][12] = int_stack + 52574;
 memset(int_stack,0,58580*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 58580;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kfmf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58580,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64520,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+71648,int_stack+64520,int_stack+58580,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83528,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91952,int_stack+83528,int_stack+64520,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+106208,int_stack+91952,int_stack+71648,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58580,int_stack+12915,int_stack+10440,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+66005,int_stack+15885,int_stack+12915,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+74915,int_stack+66005,int_stack+58580,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+89765,int_stack+19395,int_stack+15885,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+89765,int_stack+66005,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+126008,int_stack+0,int_stack+74915,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+150758,int_stack+126008,int_stack+106208,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+26515,int_stack+23490,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+30145,int_stack+26515,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+58580,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+76730,int_stack+34435,int_stack+30145,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+89600,int_stack+76730,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+89600,int_stack+58580,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+210158,int_stack+0,int_stack+126008,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+284408,int_stack+210158,int_stack+150758,550);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+58580,int_stack+43070,int_stack+39440,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69470,int_stack+47426,int_stack+43070,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+82538,int_stack+69470,int_stack+58580,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104318,int_stack+52574,int_stack+47426,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+119762,int_stack+104318,int_stack+69470,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+145898,int_stack+119762,int_stack+82538,66);
 /*--- compute (mp|mf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+30250,int_stack+145898,int_stack+0,550);
 /*--- compute (ld|mf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+403208,int_stack+30250,int_stack+210158,550);
 /*--- compute (kf|mf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+403208,int_stack+284408,550);
 return int_stack+0;}
