/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kgih(Libint_t*, prim_data*);

  /* Computes quartets of (kg|ih) integrals */

REALTYPE *hrr_order_kgih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][6] = int_stack + 0;
 Libint->vrr_classes[7][7] = int_stack + 1008;
 Libint->vrr_classes[7][8] = int_stack + 2304;
 Libint->vrr_classes[7][9] = int_stack + 3924;
 Libint->vrr_classes[7][10] = int_stack + 5904;
 Libint->vrr_classes[7][11] = int_stack + 8280;
 Libint->vrr_classes[8][6] = int_stack + 11088;
 Libint->vrr_classes[8][7] = int_stack + 12348;
 Libint->vrr_classes[8][8] = int_stack + 13968;
 Libint->vrr_classes[8][9] = int_stack + 15993;
 Libint->vrr_classes[8][10] = int_stack + 18468;
 Libint->vrr_classes[8][11] = int_stack + 21438;
 Libint->vrr_classes[9][6] = int_stack + 24948;
 Libint->vrr_classes[9][7] = int_stack + 26488;
 Libint->vrr_classes[9][8] = int_stack + 28468;
 Libint->vrr_classes[9][9] = int_stack + 30943;
 Libint->vrr_classes[9][10] = int_stack + 33968;
 Libint->vrr_classes[9][11] = int_stack + 37598;
 Libint->vrr_classes[10][6] = int_stack + 41888;
 Libint->vrr_classes[10][7] = int_stack + 43736;
 Libint->vrr_classes[10][8] = int_stack + 46112;
 Libint->vrr_classes[10][9] = int_stack + 49082;
 Libint->vrr_classes[10][10] = int_stack + 52712;
 Libint->vrr_classes[10][11] = int_stack + 57068;
 Libint->vrr_classes[11][6] = int_stack + 62216;
 Libint->vrr_classes[11][7] = int_stack + 64400;
 Libint->vrr_classes[11][8] = int_stack + 67208;
 Libint->vrr_classes[11][9] = int_stack + 70718;
 Libint->vrr_classes[11][10] = int_stack + 75008;
 Libint->vrr_classes[11][11] = int_stack + 80156;
 memset(int_stack,0,86240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 86240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kgih(Libint, Data);
   Data++;
 }
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+86240,int_stack+1008,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+89264,int_stack+2304,int_stack+1008,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+93152,int_stack+89264,int_stack+86240,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+99200,int_stack+3924,int_stack+2304,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+104060,int_stack+99200,int_stack+89264,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+111836,int_stack+104060,int_stack+93152,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86240,int_stack+5904,int_stack+3924,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+121916,int_stack+86240,int_stack+99200,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+131636,int_stack+121916,int_stack+104060,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+92180,int_stack+131636,int_stack+111836,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+107300,int_stack+8280,int_stack+5904,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144596,int_stack+107300,int_stack+86240,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+156476,int_stack+144596,int_stack+121916,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+107300,int_stack+156476,int_stack+131636,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+126740,int_stack+107300,int_stack+92180,36);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+86240,int_stack+12348,int_stack+11088,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+90020,int_stack+13968,int_stack+12348,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+94880,int_stack+90020,int_stack+86240,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+102440,int_stack+15993,int_stack+13968,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+108515,int_stack+102440,int_stack+90020,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+147908,int_stack+108515,int_stack+94880,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86240,int_stack+18468,int_stack+15993,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+160508,int_stack+86240,int_stack+102440,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+160508,int_stack+108515,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+93665,int_stack+0,int_stack+147908,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+147908,int_stack+21438,int_stack+18468,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172658,int_stack+147908,int_stack+86240,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+187508,int_stack+172658,int_stack+160508,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+147908,int_stack+187508,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+172208,int_stack+147908,int_stack+93665,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+198668,int_stack+172208,int_stack+126740,588);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+26488,int_stack+24948,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+28468,int_stack+26488,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19800,int_stack+30943,int_stack+28468,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+86240,int_stack+19800,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+98120,int_stack+86240,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+33968,int_stack+30943,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+113520,int_stack+0,int_stack+19800,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+9075,int_stack+113520,int_stack+86240,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+128370,int_stack+9075,int_stack+98120,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+86240,int_stack+37598,int_stack+33968,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+151470,int_stack+86240,int_stack+0,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+86240,int_stack+151470,int_stack+113520,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+262172,int_stack+86240,int_stack+9075,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+86240,int_stack+262172,int_stack+128370,55);
 /*--- compute (lp|ih) ---*/
 hrr1_build_lp(Libint->AB,int_stack+262172,int_stack+86240,int_stack+172208,588);
 /*--- compute (kd|ih) ---*/
 hrr1_build_kd(Libint->AB,int_stack+341552,int_stack+262172,int_stack+198668,588);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+118580,int_stack+43736,int_stack+41888,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+124124,int_stack+46112,int_stack+43736,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+131252,int_stack+124124,int_stack+118580,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+142340,int_stack+49082,int_stack+46112,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+151250,int_stack+142340,int_stack+124124,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+165506,int_stack+151250,int_stack+131252,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+118580,int_stack+52712,int_stack+49082,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+183986,int_stack+118580,int_stack+142340,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+201806,int_stack+183986,int_stack+151250,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+129470,int_stack+201806,int_stack+165506,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+157190,int_stack+57068,int_stack+52712,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+225566,int_stack+157190,int_stack+118580,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+225566,int_stack+183986,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+225566,int_stack+0,int_stack+201806,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+225566,int_stack+129470,66);
 /*--- compute (mp|ih) ---*/
 hrr1_build_mp(Libint->AB,int_stack+118580,int_stack+0,int_stack+86240,588);
 /*--- compute (ld|ih) ---*/
 hrr1_build_ld(Libint->AB,int_stack+468560,int_stack+118580,int_stack+262172,588);
 /*--- compute (kf|ih) ---*/
 hrr1_build_kf(Libint->AB,int_stack+627320,int_stack+468560,int_stack+341552,588);
 /*--- compute (o0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+86240,int_stack+64400,int_stack+62216,78);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+92792,int_stack+67208,int_stack+64400,78);
 /*--- compute (o0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+101216,int_stack+92792,int_stack+86240,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38808,int_stack+70718,int_stack+67208,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+49338,int_stack+38808,int_stack+92792,78);
 /*--- compute (o0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+215600,int_stack+49338,int_stack+101216,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86240,int_stack+75008,int_stack+70718,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+237440,int_stack+86240,int_stack+38808,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+258500,int_stack+237440,int_stack+49338,78);
 /*--- compute (o0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+38808,int_stack+258500,int_stack+215600,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+215600,int_stack+80156,int_stack+75008,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+286580,int_stack+215600,int_stack+86240,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+71568,int_stack+286580,int_stack+237440,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+286580,int_stack+71568,int_stack+258500,78);
 /*--- compute (o0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+71568,int_stack+286580,int_stack+38808,78);
 /*--- compute (np|ih) ---*/
 hrr1_build_np(Libint->AB,int_stack+215600,int_stack+71568,int_stack+0,588);
 /*--- compute (md|ih) ---*/
 hrr1_build_md(Libint->AB,int_stack+839000,int_stack+215600,int_stack+118580,588);
 /*--- compute (lf|ih) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+839000,int_stack+468560,588);
 /*--- compute (kg|ih) ---*/
 hrr1_build_kg(Libint->AB,int_stack+264600,int_stack+0,int_stack+627320,588);
 return int_stack+264600;}
