/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khmf(Libint_t*, prim_data*);

  /* Computes quartets of (kh|mf) integrals */

REALTYPE *hrr_order_khmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[8][9] = int_stack + 10440;
 Libint->vrr_classes[8][10] = int_stack + 12915;
 Libint->vrr_classes[8][11] = int_stack + 15885;
 Libint->vrr_classes[8][12] = int_stack + 19395;
 Libint->vrr_classes[9][9] = int_stack + 23490;
 Libint->vrr_classes[9][10] = int_stack + 26515;
 Libint->vrr_classes[9][11] = int_stack + 30145;
 Libint->vrr_classes[9][12] = int_stack + 34435;
 Libint->vrr_classes[10][9] = int_stack + 39440;
 Libint->vrr_classes[10][10] = int_stack + 43070;
 Libint->vrr_classes[10][11] = int_stack + 47426;
 Libint->vrr_classes[10][12] = int_stack + 52574;
 Libint->vrr_classes[11][9] = int_stack + 58580;
 Libint->vrr_classes[11][10] = int_stack + 62870;
 Libint->vrr_classes[11][11] = int_stack + 68018;
 Libint->vrr_classes[11][12] = int_stack + 74102;
 Libint->vrr_classes[12][9] = int_stack + 81200;
 Libint->vrr_classes[12][10] = int_stack + 86205;
 Libint->vrr_classes[12][11] = int_stack + 92211;
 Libint->vrr_classes[12][12] = int_stack + 99309;
 memset(int_stack,0,107590*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 107590;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khmf(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+107590,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+113530,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+120658,int_stack+113530,int_stack+107590,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+132538,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+140962,int_stack+132538,int_stack+113530,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+155218,int_stack+140962,int_stack+120658,36);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+107590,int_stack+12915,int_stack+10440,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115015,int_stack+15885,int_stack+12915,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+123925,int_stack+115015,int_stack+107590,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+138775,int_stack+19395,int_stack+15885,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+138775,int_stack+115015,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+175018,int_stack+0,int_stack+123925,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+199768,int_stack+175018,int_stack+155218,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+26515,int_stack+23490,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+30145,int_stack+26515,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+107590,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+125740,int_stack+34435,int_stack+30145,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+138610,int_stack+125740,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+138610,int_stack+107590,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+259168,int_stack+0,int_stack+175018,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+333418,int_stack+259168,int_stack+199768,550);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+107590,int_stack+43070,int_stack+39440,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118480,int_stack+47426,int_stack+43070,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+131548,int_stack+118480,int_stack+107590,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+153328,int_stack+52574,int_stack+47426,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+168772,int_stack+153328,int_stack+118480,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+194908,int_stack+168772,int_stack+131548,66);
 /*--- compute (mp|mf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+452218,int_stack+194908,int_stack+0,550);
 /*--- compute (ld|mf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+542968,int_stack+452218,int_stack+259168,550);
 /*--- compute (kf|mf) ---*/
 hrr1_build_kf(Libint->AB,int_stack+691468,int_stack+542968,int_stack+333418,550);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+62870,int_stack+58580,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+68018,int_stack+62870,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+107590,int_stack+74102,int_stack+68018,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+125842,int_stack+107590,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+231208,int_stack+125842,int_stack+28314,78);
 /*--- compute (np|mf) ---*/
 hrr1_build_np(Libint->AB,int_stack+274108,int_stack+231208,int_stack+194908,550);
 /*--- compute (md|mf) ---*/
 hrr1_build_md(Libint->AB,int_stack+889468,int_stack+274108,int_stack+452218,550);
 /*--- compute (lf|mf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1070968,int_stack+889468,int_stack+542968,550);
 /*--- compute (kg|mf) ---*/
 hrr1_build_kg(Libint->AB,int_stack+383008,int_stack+1070968,int_stack+691468,550);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+107590,int_stack+86205,int_stack+81200,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+122605,int_stack+92211,int_stack+86205,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+140623,int_stack+122605,int_stack+107590,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+170653,int_stack+99309,int_stack+92211,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+191947,int_stack+170653,int_stack+122605,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+191947,int_stack+140623,91);
 /*--- compute (op|mf) ---*/
 hrr1_build_op(Libint->AB,int_stack+50050,int_stack+0,int_stack+231208,550);
 /*--- compute (nd|mf) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1318468,int_stack+50050,int_stack+274108,550);
 /*--- compute (mf|mf) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1318468,int_stack+889468,550);
 /*--- compute (lg|mf) ---*/
 hrr1_build_lg(Libint->AB,int_stack+680008,int_stack+0,int_stack+1070968,550);
 /*--- compute (kh|mf) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1051258,int_stack+680008,int_stack+383008,550);
 return int_stack+1051258;}
