/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkli(Libint_t*, prim_data*);

  /* Computes quartets of (kk|li) integrals */

REALTYPE *hrr_order_kkli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[8][8] = int_stack + 20160;
 Libint->vrr_classes[8][9] = int_stack + 22185;
 Libint->vrr_classes[8][10] = int_stack + 24660;
 Libint->vrr_classes[8][11] = int_stack + 27630;
 Libint->vrr_classes[8][12] = int_stack + 31140;
 Libint->vrr_classes[8][13] = int_stack + 35235;
 Libint->vrr_classes[8][14] = int_stack + 39960;
 Libint->vrr_classes[9][8] = int_stack + 45360;
 Libint->vrr_classes[9][9] = int_stack + 47835;
 Libint->vrr_classes[9][10] = int_stack + 50860;
 Libint->vrr_classes[9][11] = int_stack + 54490;
 Libint->vrr_classes[9][12] = int_stack + 58780;
 Libint->vrr_classes[9][13] = int_stack + 63785;
 Libint->vrr_classes[9][14] = int_stack + 69560;
 Libint->vrr_classes[10][8] = int_stack + 76160;
 Libint->vrr_classes[10][9] = int_stack + 79130;
 Libint->vrr_classes[10][10] = int_stack + 82760;
 Libint->vrr_classes[10][11] = int_stack + 87116;
 Libint->vrr_classes[10][12] = int_stack + 92264;
 Libint->vrr_classes[10][13] = int_stack + 98270;
 Libint->vrr_classes[10][14] = int_stack + 105200;
 Libint->vrr_classes[11][8] = int_stack + 113120;
 Libint->vrr_classes[11][9] = int_stack + 116630;
 Libint->vrr_classes[11][10] = int_stack + 120920;
 Libint->vrr_classes[11][11] = int_stack + 126068;
 Libint->vrr_classes[11][12] = int_stack + 132152;
 Libint->vrr_classes[11][13] = int_stack + 139250;
 Libint->vrr_classes[11][14] = int_stack + 147440;
 Libint->vrr_classes[12][8] = int_stack + 156800;
 Libint->vrr_classes[12][9] = int_stack + 160895;
 Libint->vrr_classes[12][10] = int_stack + 165900;
 Libint->vrr_classes[12][11] = int_stack + 171906;
 Libint->vrr_classes[12][12] = int_stack + 179004;
 Libint->vrr_classes[12][13] = int_stack + 187285;
 Libint->vrr_classes[12][14] = int_stack + 196840;
 Libint->vrr_classes[13][8] = int_stack + 207760;
 Libint->vrr_classes[13][9] = int_stack + 212485;
 Libint->vrr_classes[13][10] = int_stack + 218260;
 Libint->vrr_classes[13][11] = int_stack + 225190;
 Libint->vrr_classes[13][12] = int_stack + 233380;
 Libint->vrr_classes[13][13] = int_stack + 242935;
 Libint->vrr_classes[13][14] = int_stack + 253960;
 Libint->vrr_classes[14][8] = int_stack + 266560;
 Libint->vrr_classes[14][9] = int_stack + 271960;
 Libint->vrr_classes[14][10] = int_stack + 278560;
 Libint->vrr_classes[14][11] = int_stack + 286480;
 Libint->vrr_classes[14][12] = int_stack + 295840;
 Libint->vrr_classes[14][13] = int_stack + 306760;
 Libint->vrr_classes[14][14] = int_stack + 319360;
 memset(int_stack,0,333760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 333760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkli(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+333760,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+338620,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+344560,int_stack+338620,int_stack+333760,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+354280,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+361408,int_stack+354280,int_stack+338620,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+373288,int_stack+361408,int_stack+344560,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+333760,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+389488,int_stack+333760,int_stack+354280,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+403744,int_stack+389488,int_stack+361408,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+342184,int_stack+403744,int_stack+373288,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+366484,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+423544,int_stack+366484,int_stack+333760,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+440392,int_stack+423544,int_stack+389488,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+464152,int_stack+440392,int_stack+403744,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+376312,int_stack+464152,int_stack+342184,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+345100,int_stack+333760,int_stack+366484,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+493852,int_stack+345100,int_stack+423544,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333760,int_stack+493852,int_stack+440392,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+410332,int_stack+333760,int_stack+464152,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+451912,int_stack+410332,int_stack+376312,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+333760,int_stack+22185,int_stack+20160,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+339835,int_stack+24660,int_stack+22185,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+347260,int_stack+339835,int_stack+333760,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+359410,int_stack+27630,int_stack+24660,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+368320,int_stack+359410,int_stack+339835,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+383170,int_stack+368320,int_stack+347260,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+333760,int_stack+31140,int_stack+27630,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+403420,int_stack+333760,int_stack+359410,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+421240,int_stack+403420,int_stack+368320,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+344290,int_stack+421240,int_stack+383170,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+374665,int_stack+35235,int_stack+31140,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+497272,int_stack+374665,int_stack+333760,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+497272,int_stack+403420,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+518332,int_stack+0,int_stack+421240,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+386950,int_stack+518332,int_stack+344290,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+39960,int_stack+35235,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+347935,int_stack+333760,int_stack+374665,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+555457,int_stack+347935,int_stack+497272,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333760,int_stack+555457,int_stack+0,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+555457,int_stack+333760,int_stack+518332,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+497272,int_stack+555457,int_stack+386950,45);
 /*--- compute (kp|li) ---*/
 hrr1_build_kp(Libint->AB,int_stack+553972,int_stack+497272,int_stack+451912,1260);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+333760,int_stack+47835,int_stack+45360,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+341185,int_stack+50860,int_stack+47835,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+350260,int_stack+341185,int_stack+333760,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+365110,int_stack+54490,int_stack+50860,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+376000,int_stack+365110,int_stack+341185,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+394150,int_stack+376000,int_stack+350260,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+333760,int_stack+58780,int_stack+54490,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+418900,int_stack+333760,int_stack+365110,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+440680,int_stack+418900,int_stack+376000,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+346630,int_stack+440680,int_stack+394150,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+383755,int_stack+63785,int_stack+58780,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+470930,int_stack+383755,int_stack+333760,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+470930,int_stack+418900,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+690052,int_stack+0,int_stack+440680,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+398770,int_stack+690052,int_stack+346630,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+69560,int_stack+63785,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+351085,int_stack+333760,int_stack+383755,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+735427,int_stack+351085,int_stack+470930,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333760,int_stack+735427,int_stack+0,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+333760,int_stack+690052,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+690052,int_stack+0,int_stack+398770,55);
 /*--- compute (lp|li) ---*/
 hrr1_build_lp(Libint->AB,int_stack+759352,int_stack+690052,int_stack+497272,1260);
 /*--- compute (kd|li) ---*/
 hrr1_build_kd(Libint->AB,int_stack+929452,int_stack+759352,int_stack+553972,1260);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+79130,int_stack+76160,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+82760,int_stack+79130,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+87116,int_stack+82760,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+333760,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+92264,int_stack+87116,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+363460,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+389596,int_stack+363460,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+389596,int_stack+333760,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+333760,int_stack+98270,int_stack+92264,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+59994,int_stack+333760,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+425896,int_stack+59994,int_stack+363460,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+469456,int_stack+425896,int_stack+389596,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+351778,int_stack+469456,int_stack+15444,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+105200,int_stack+98270,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+333760,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+523906,int_stack+20790,int_stack+59994,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+523906,int_stack+425896,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+523906,int_stack+0,int_stack+469456,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+523906,int_stack+351778,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+333760,int_stack+0,int_stack+690052,1260);
 /*--- compute (ld|li) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1201612,int_stack+333760,int_stack+759352,1260);
 /*--- compute (kf|li) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1541812,int_stack+1201612,int_stack+929452,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+83160,int_stack+116630,int_stack+113120,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93690,int_stack+120920,int_stack+116630,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+541660,int_stack+93690,int_stack+83160,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+562720,int_stack+126068,int_stack+120920,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+578164,int_stack+562720,int_stack+93690,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83160,int_stack+578164,int_stack+541660,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+541660,int_stack+132152,int_stack+126068,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+603904,int_stack+541660,int_stack+562720,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+634792,int_stack+603904,int_stack+578164,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+677692,int_stack+634792,int_stack+83160,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+83160,int_stack+139250,int_stack+132152,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+559912,int_stack+83160,int_stack+541660,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+730342,int_stack+559912,int_stack+603904,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+781822,int_stack+730342,int_stack+634792,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+596416,int_stack+781822,int_stack+677692,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+104454,int_stack+147440,int_stack+139250,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+670126,int_stack+104454,int_stack+83160,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+83160,int_stack+670126,int_stack+559912,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+846172,int_stack+83160,int_stack+730342,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+670126,int_stack+846172,int_stack+781822,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+760216,int_stack+670126,int_stack+596416,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+858496,int_stack+760216,int_stack+0,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+1995412,int_stack+858496,int_stack+333760,1260);
 /*--- compute (lf|li) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2411212,int_stack+1995412,int_stack+1201612,1260);
 /*--- compute (kg|li) ---*/
 hrr1_build_kg(Libint->AB,int_stack+2978212,int_stack+2411212,int_stack+1541812,1260);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+333760,int_stack+160895,int_stack+156800,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+346045,int_stack+165900,int_stack+160895,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+361060,int_stack+346045,int_stack+333760,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+385630,int_stack+171906,int_stack+165900,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+403648,int_stack+385630,int_stack+346045,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+433678,int_stack+403648,int_stack+361060,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+333760,int_stack+179004,int_stack+171906,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+474628,int_stack+333760,int_stack+385630,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+510664,int_stack+474628,int_stack+403648,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+355054,int_stack+510664,int_stack+433678,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+416479,int_stack+187285,int_stack+179004,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+560714,int_stack+416479,int_stack+333760,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+603302,int_stack+560714,int_stack+474628,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+663362,int_stack+603302,int_stack+510664,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+441322,int_stack+663362,int_stack+355054,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+196840,int_stack+187285,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+362425,int_stack+333760,int_stack+416479,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+362425,int_stack+560714,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+333760,int_stack+0,int_stack+603302,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+333760,int_stack+663362,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+527317,int_stack+0,int_stack+441322,91);
 /*--- compute (op|li) ---*/
 hrr1_build_op(Libint->AB,int_stack+1107976,int_stack+527317,int_stack+760216,1260);
 /*--- compute (nd|li) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1402816,int_stack+1107976,int_stack+858496,1260);
 /*--- compute (mf|li) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3658612,int_stack+1402816,int_stack+1995412,1260);
 /*--- compute (lg|li) ---*/
 hrr1_build_lg(Libint->AB,int_stack+4351612,int_stack+3658612,int_stack+2411212,1260);
 /*--- compute (kh|li) ---*/
 hrr1_build_kh(Libint->AB,int_stack+1901776,int_stack+4351612,int_stack+2978212,1260);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+212485,int_stack+207760,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+218260,int_stack+212485,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+225190,int_stack+218260,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115290,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+233380,int_stack+225190,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162540,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+333760,int_stack+162540,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+333760,int_stack+115290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95445,int_stack+242935,int_stack+233380,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+391510,int_stack+95445,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+440650,int_stack+391510,int_stack+162540,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+124110,int_stack+440650,int_stack+333760,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+641977,int_stack+124110,int_stack+24570,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333760,int_stack+253960,int_stack+242935,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+333760,int_stack+95445,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+741202,int_stack+0,int_stack+391510,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+741202,int_stack+440650,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+741202,int_stack+0,int_stack+124110,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+741202,int_stack+641977,105);
 /*--- compute (qp|li) ---*/
 hrr1_build_qp(Libint->AB,int_stack+641977,int_stack+0,int_stack+527317,1260);
 /*--- compute (od|li) ---*/
 hrr1_build_od(Libint->AB,int_stack+2854336,int_stack+641977,int_stack+1107976,1260);
 /*--- compute (nf|li) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5202112,int_stack+2854336,int_stack+1402816,1260);
 /*--- compute (mg|li) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6033712,int_stack+5202112,int_stack+3658612,1260);
 /*--- compute (lh|li) ---*/
 hrr1_build_lh(Libint->AB,int_stack+7073212,int_stack+6033712,int_stack+4351612,1260);
 /*--- compute (ki|li) ---*/
 hrr1_build_ki(Libint->AB,int_stack+3444016,int_stack+7073212,int_stack+1901776,1260);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+985957,int_stack+271960,int_stack+266560,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1002157,int_stack+278560,int_stack+271960,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+1021957,int_stack+1002157,int_stack+985957,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1054357,int_stack+286480,int_stack+278560,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1078117,int_stack+1054357,int_stack+1002157,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+1117717,int_stack+1078117,int_stack+1021957,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+985957,int_stack+295840,int_stack+286480,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1171717,int_stack+985957,int_stack+1054357,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1219237,int_stack+1171717,int_stack+1078117,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+1014037,int_stack+1219237,int_stack+1117717,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1095037,int_stack+306760,int_stack+295840,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1285237,int_stack+1095037,int_stack+985957,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1341397,int_stack+1285237,int_stack+1171717,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1420597,int_stack+1341397,int_stack+1219237,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1127797,int_stack+1420597,int_stack+1014037,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+985957,int_stack+319360,int_stack+306760,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1023757,int_stack+985957,int_stack+1095037,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1519597,int_stack+1023757,int_stack+1285237,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+985957,int_stack+1519597,int_stack+1341397,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1519597,int_stack+985957,int_stack+1420597,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1658197,int_stack+1519597,int_stack+1127797,120);
 /*--- compute (rp|li) ---*/
 hrr1_build_rp(Libint->AB,int_stack+985957,int_stack+1658197,int_stack+0,1260);
 /*--- compute (qd|li) ---*/
 hrr1_build_qd(Libint->AB,int_stack+1382857,int_stack+985957,int_stack+641977,1260);
 /*--- compute (of|li) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+1382857,int_stack+2854336,1260);
 /*--- compute (ng|li) ---*/
 hrr1_build_ng(Libint->AB,int_stack+982800,int_stack+0,int_stack+5202112,1260);
 /*--- compute (mh|li) ---*/
 hrr1_build_mh(Libint->AB,int_stack+8263912,int_stack+982800,int_stack+6033712,1260);
 /*--- compute (li|li) ---*/
 hrr1_build_li(Libint->AB,int_stack+0,int_stack+8263912,int_stack+7073212,1260);
 /*--- compute (kk|li) ---*/
 hrr1_build_kk(Libint->AB,int_stack+1587600,int_stack+0,int_stack+3444016,1260);
 return int_stack+1587600;}
