/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kkll(Libint_t*, prim_data*);

  /* Computes quartets of (kk|ll) integrals */

REALTYPE *hrr_order_kkll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][8] = int_stack + 0;
 Libint->vrr_classes[7][9] = int_stack + 1620;
 Libint->vrr_classes[7][10] = int_stack + 3600;
 Libint->vrr_classes[7][11] = int_stack + 5976;
 Libint->vrr_classes[7][12] = int_stack + 8784;
 Libint->vrr_classes[7][13] = int_stack + 12060;
 Libint->vrr_classes[7][14] = int_stack + 15840;
 Libint->vrr_classes[7][15] = int_stack + 20160;
 Libint->vrr_classes[7][16] = int_stack + 25056;
 Libint->vrr_classes[8][8] = int_stack + 30564;
 Libint->vrr_classes[8][9] = int_stack + 32589;
 Libint->vrr_classes[8][10] = int_stack + 35064;
 Libint->vrr_classes[8][11] = int_stack + 38034;
 Libint->vrr_classes[8][12] = int_stack + 41544;
 Libint->vrr_classes[8][13] = int_stack + 45639;
 Libint->vrr_classes[8][14] = int_stack + 50364;
 Libint->vrr_classes[8][15] = int_stack + 55764;
 Libint->vrr_classes[8][16] = int_stack + 61884;
 Libint->vrr_classes[9][8] = int_stack + 68769;
 Libint->vrr_classes[9][9] = int_stack + 71244;
 Libint->vrr_classes[9][10] = int_stack + 74269;
 Libint->vrr_classes[9][11] = int_stack + 77899;
 Libint->vrr_classes[9][12] = int_stack + 82189;
 Libint->vrr_classes[9][13] = int_stack + 87194;
 Libint->vrr_classes[9][14] = int_stack + 92969;
 Libint->vrr_classes[9][15] = int_stack + 99569;
 Libint->vrr_classes[9][16] = int_stack + 107049;
 Libint->vrr_classes[10][8] = int_stack + 115464;
 Libint->vrr_classes[10][9] = int_stack + 118434;
 Libint->vrr_classes[10][10] = int_stack + 122064;
 Libint->vrr_classes[10][11] = int_stack + 126420;
 Libint->vrr_classes[10][12] = int_stack + 131568;
 Libint->vrr_classes[10][13] = int_stack + 137574;
 Libint->vrr_classes[10][14] = int_stack + 144504;
 Libint->vrr_classes[10][15] = int_stack + 152424;
 Libint->vrr_classes[10][16] = int_stack + 161400;
 Libint->vrr_classes[11][8] = int_stack + 171498;
 Libint->vrr_classes[11][9] = int_stack + 175008;
 Libint->vrr_classes[11][10] = int_stack + 179298;
 Libint->vrr_classes[11][11] = int_stack + 184446;
 Libint->vrr_classes[11][12] = int_stack + 190530;
 Libint->vrr_classes[11][13] = int_stack + 197628;
 Libint->vrr_classes[11][14] = int_stack + 205818;
 Libint->vrr_classes[11][15] = int_stack + 215178;
 Libint->vrr_classes[11][16] = int_stack + 225786;
 Libint->vrr_classes[12][8] = int_stack + 237720;
 Libint->vrr_classes[12][9] = int_stack + 241815;
 Libint->vrr_classes[12][10] = int_stack + 246820;
 Libint->vrr_classes[12][11] = int_stack + 252826;
 Libint->vrr_classes[12][12] = int_stack + 259924;
 Libint->vrr_classes[12][13] = int_stack + 268205;
 Libint->vrr_classes[12][14] = int_stack + 277760;
 Libint->vrr_classes[12][15] = int_stack + 288680;
 Libint->vrr_classes[12][16] = int_stack + 301056;
 Libint->vrr_classes[13][8] = int_stack + 314979;
 Libint->vrr_classes[13][9] = int_stack + 319704;
 Libint->vrr_classes[13][10] = int_stack + 325479;
 Libint->vrr_classes[13][11] = int_stack + 332409;
 Libint->vrr_classes[13][12] = int_stack + 340599;
 Libint->vrr_classes[13][13] = int_stack + 350154;
 Libint->vrr_classes[13][14] = int_stack + 361179;
 Libint->vrr_classes[13][15] = int_stack + 373779;
 Libint->vrr_classes[13][16] = int_stack + 388059;
 Libint->vrr_classes[14][8] = int_stack + 404124;
 Libint->vrr_classes[14][9] = int_stack + 409524;
 Libint->vrr_classes[14][10] = int_stack + 416124;
 Libint->vrr_classes[14][11] = int_stack + 424044;
 Libint->vrr_classes[14][12] = int_stack + 433404;
 Libint->vrr_classes[14][13] = int_stack + 444324;
 Libint->vrr_classes[14][14] = int_stack + 456924;
 Libint->vrr_classes[14][15] = int_stack + 471324;
 Libint->vrr_classes[14][16] = int_stack + 487644;
 memset(int_stack,0,506004*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 506004;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kkll(Libint, Data);
   Data++;
 }
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+1620,int_stack+0,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+510864,int_stack+3600,int_stack+1620,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+516804,int_stack+510864,int_stack+506004,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+526524,int_stack+5976,int_stack+3600,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+533652,int_stack+526524,int_stack+510864,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+545532,int_stack+533652,int_stack+516804,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+8784,int_stack+5976,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+561732,int_stack+506004,int_stack+526524,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+575988,int_stack+561732,int_stack+533652,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+514428,int_stack+575988,int_stack+545532,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+538728,int_stack+12060,int_stack+8784,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+595788,int_stack+538728,int_stack+506004,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+612636,int_stack+595788,int_stack+561732,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+636396,int_stack+612636,int_stack+575988,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+548556,int_stack+636396,int_stack+514428,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+15840,int_stack+12060,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+517344,int_stack+506004,int_stack+538728,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+666096,int_stack+517344,int_stack+595788,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+694176,int_stack+666096,int_stack+612636,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+582576,int_stack+694176,int_stack+636396,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+729816,int_stack+582576,int_stack+548556,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+537000,int_stack+20160,int_stack+15840,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+549960,int_stack+537000,int_stack+506004,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+624156,int_stack+549960,int_stack+517344,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+775176,int_stack+624156,int_stack+666096,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+817296,int_stack+775176,int_stack+694176,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+656916,int_stack+817296,int_stack+582576,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+867192,int_stack+656916,int_stack+729816,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+506004,int_stack+25056,int_stack+20160,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+572640,int_stack+506004,int_stack+537000,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+506004,int_stack+572640,int_stack+549960,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+543804,int_stack+506004,int_stack+624156,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+592944,int_stack+543804,int_stack+775176,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+506004,int_stack+592944,int_stack+817296,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+572532,int_stack+506004,int_stack+656916,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+643812,int_stack+572532,int_stack+867192,36);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+32589,int_stack+30564,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+512079,int_stack+35064,int_stack+32589,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+519504,int_stack+512079,int_stack+506004,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+531654,int_stack+38034,int_stack+35064,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+540564,int_stack+531654,int_stack+512079,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+555414,int_stack+540564,int_stack+519504,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+41544,int_stack+38034,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+575664,int_stack+506004,int_stack+531654,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+593484,int_stack+575664,int_stack+540564,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+516534,int_stack+593484,int_stack+555414,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+546909,int_stack+45639,int_stack+41544,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+618234,int_stack+546909,int_stack+506004,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+716712,int_stack+618234,int_stack+575664,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+746412,int_stack+716712,int_stack+593484,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+559194,int_stack+746412,int_stack+516534,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+50364,int_stack+45639,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+520179,int_stack+506004,int_stack+546909,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+783537,int_stack+520179,int_stack+618234,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+818637,int_stack+783537,int_stack+716712,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+863187,int_stack+818637,int_stack+746412,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+716712,int_stack+863187,int_stack+559194,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+544749,int_stack+55764,int_stack+50364,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+560949,int_stack+544749,int_stack+506004,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+589299,int_stack+560949,int_stack+520179,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+589299,int_stack+783537,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+915162,int_stack+0,int_stack+818637,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+773412,int_stack+915162,int_stack+863187,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+977532,int_stack+773412,int_stack+716712,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+716712,int_stack+61884,int_stack+55764,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+735072,int_stack+716712,int_stack+544749,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+506004,int_stack+735072,int_stack+560949,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+842712,int_stack+506004,int_stack+589299,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+506004,int_stack+842712,int_stack+0,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1050432,int_stack+506004,int_stack+915162,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+506004,int_stack+1050432,int_stack+773412,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+716712,int_stack+506004,int_stack+977532,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+807837,int_stack+716712,int_stack+643812,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+71244,int_stack+68769,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+513429,int_stack+74269,int_stack+71244,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+522504,int_stack+513429,int_stack+506004,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+537354,int_stack+77899,int_stack+74269,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+548244,int_stack+537354,int_stack+513429,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+566394,int_stack+548244,int_stack+522504,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+82189,int_stack+77899,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+591144,int_stack+506004,int_stack+537354,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+612924,int_stack+591144,int_stack+548244,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+518874,int_stack+612924,int_stack+566394,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+555999,int_stack+87194,int_stack+82189,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+643174,int_stack+555999,int_stack+506004,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+668914,int_stack+643174,int_stack+591144,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+668914,int_stack+612924,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+571014,int_stack+0,int_stack+518874,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+92969,int_stack+87194,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+523329,int_stack+506004,int_stack+555999,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+45375,int_stack+523329,int_stack+643174,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1026537,int_stack+45375,int_stack+668914,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+622989,int_stack+1026537,int_stack+0,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1080987,int_stack+622989,int_stack+571014,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+99569,int_stack+92969,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+553359,int_stack+0,int_stack+506004,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1150287,int_stack+553359,int_stack+523329,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1200337,int_stack+1150287,int_stack+45375,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+19800,int_stack+1200337,int_stack+1026537,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1264687,int_stack+19800,int_stack+622989,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+588009,int_stack+1264687,int_stack+1080987,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1026537,int_stack+107049,int_stack+99569,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1048977,int_stack+1026537,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1088577,int_stack+1048977,int_stack+553359,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+506004,int_stack+1088577,int_stack+1150287,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1026537,int_stack+506004,int_stack+1200337,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1116627,int_stack+1026537,int_stack+19800,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1116627,int_stack+1264687,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+1026537,int_stack+0,int_stack+588009,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1137912,int_stack+1026537,int_stack+716712,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1411287,int_stack+1137912,int_stack+807837,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+118434,int_stack+115464,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8910,int_stack+122064,int_stack+118434,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+19800,int_stack+8910,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37620,int_stack+126420,int_stack+122064,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50688,int_stack+37620,int_stack+8910,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+72468,int_stack+50688,int_stack+19800,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+131568,int_stack+126420,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+102168,int_stack+0,int_stack+37620,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+506004,int_stack+102168,int_stack+50688,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15444,int_stack+506004,int_stack+72468,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+59994,int_stack+137574,int_stack+131568,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+542304,int_stack+59994,int_stack+0,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+573192,int_stack+542304,int_stack+102168,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+78012,int_stack+573192,int_stack+506004,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+616752,int_stack+78012,int_stack+15444,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+144504,int_stack+137574,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+506004,int_stack+59994,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+679122,int_stack+0,int_stack+542304,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+730602,int_stack+679122,int_stack+573192,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+526794,int_stack+730602,int_stack+78012,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+36036,int_stack+526794,int_stack+616752,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+603024,int_stack+152424,int_stack+144504,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+626784,int_stack+603024,int_stack+506004,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+795942,int_stack+626784,int_stack+0,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+856002,int_stack+795942,int_stack+679122,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+933222,int_stack+856002,int_stack+730602,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+668364,int_stack+933222,int_stack+526794,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1848687,int_stack+668364,int_stack+36036,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+161400,int_stack+152424,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+26928,int_stack+0,int_stack+603024,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+74448,int_stack+26928,int_stack+626784,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+506004,int_stack+74448,int_stack+795942,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+506004,int_stack+856002,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+506004,int_stack+0,int_stack+933222,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+506004,int_stack+668364,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+506004,int_stack+0,int_stack+1848687,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+639654,int_stack+506004,int_stack+1026537,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1848687,int_stack+639654,int_stack+1137912,2025);
 /*--- compute (kf|ll) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2395437,int_stack+1848687,int_stack+1411287,2025);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+175008,int_stack+171498,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+179298,int_stack+175008,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+184446,int_stack+179298,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59904,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+85644,int_stack+59904,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+190530,int_stack+184446,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+120744,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+973779,int_stack+120744,int_stack+59904,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+18252,int_stack+973779,int_stack+85644,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+70902,int_stack+197628,int_stack+190530,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+151632,int_stack+70902,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1016679,int_stack+151632,int_stack+120744,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1068159,int_stack+1016679,int_stack+973779,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+1132509,int_stack+1068159,int_stack+18252,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+973779,int_stack+205818,int_stack+197628,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+973779,int_stack+70902,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42588,int_stack+0,int_stack+151632,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+103428,int_stack+42588,int_stack+1016679,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1206219,int_stack+103428,int_stack+1068159,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+998349,int_stack+1206219,int_stack+1132509,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1096629,int_stack+215178,int_stack+205818,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1124709,int_stack+1096629,int_stack+973779,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1296309,int_stack+1124709,int_stack+0,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1367289,int_stack+1296309,int_stack+42588,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1458549,int_stack+1367289,int_stack+103428,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1458549,int_stack+1206219,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1566657,int_stack+0,int_stack+998349,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+120120,int_stack+225786,int_stack+215178,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+151944,int_stack+120120,int_stack+1096629,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+973779,int_stack+151944,int_stack+1124709,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+120120,int_stack+973779,int_stack+1296309,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+973779,int_stack+120120,int_stack+1367289,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1101543,int_stack+973779,int_stack+1458549,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1245687,int_stack+1101543,int_stack+0,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1245687,int_stack+1566657,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+973779,int_stack+0,int_stack+506004,2025);
 /*--- compute (md|ll) ---*/
 hrr1_build_md(Libint->AB,int_stack+3124437,int_stack+973779,int_stack+639654,2025);
 /*--- compute (lf|ll) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3792687,int_stack+3124437,int_stack+1848687,2025);
 /*--- compute (kg|ll) ---*/
 hrr1_build_kg(Libint->AB,int_stack+4703937,int_stack+3792687,int_stack+2395437,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+506004,int_stack+241815,int_stack+237720,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+518289,int_stack+246820,int_stack+241815,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+533304,int_stack+518289,int_stack+506004,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+557874,int_stack+252826,int_stack+246820,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+575892,int_stack+557874,int_stack+518289,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+605922,int_stack+575892,int_stack+533304,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506004,int_stack+259924,int_stack+252826,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+646872,int_stack+506004,int_stack+557874,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+682908,int_stack+646872,int_stack+575892,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+527298,int_stack+682908,int_stack+605922,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+588723,int_stack+268205,int_stack+259924,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+732958,int_stack+588723,int_stack+506004,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+775546,int_stack+732958,int_stack+646872,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+835606,int_stack+775546,int_stack+682908,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+613566,int_stack+835606,int_stack+527298,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+506004,int_stack+277760,int_stack+268205,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+534669,int_stack+506004,int_stack+588723,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+157950,int_stack+534669,int_stack+732958,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1374729,int_stack+157950,int_stack+775546,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+699561,int_stack+1374729,int_stack+835606,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+804666,int_stack+699561,int_stack+613566,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+584355,int_stack+288680,int_stack+277760,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+617115,int_stack+584355,int_stack+506004,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1464819,int_stack+617115,int_stack+534669,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1547629,int_stack+1464819,int_stack+157950,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+157950,int_stack+1547629,int_stack+1374729,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1654099,int_stack+157950,int_stack+699561,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1794239,int_stack+1654099,int_stack+804666,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1374729,int_stack+301056,int_stack+288680,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+506004,int_stack+1374729,int_stack+584355,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+674445,int_stack+506004,int_stack+617115,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+506004,int_stack+674445,int_stack+1464819,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+630219,int_stack+506004,int_stack+1547629,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+779277,int_stack+630219,int_stack+157950,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+506004,int_stack+779277,int_stack+1654099,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+686184,int_stack+506004,int_stack+1794239,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+1374729,int_stack+686184,int_stack+0,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1848579,int_stack+1374729,int_stack+973779,2025);
 /*--- compute (mf|ll) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5797437,int_stack+1848579,int_stack+3124437,2025);
 /*--- compute (lg|ll) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6911187,int_stack+5797437,int_stack+3792687,2025);
 /*--- compute (kh|ll) ---*/
 hrr1_build_kh(Libint->AB,int_stack+2650479,int_stack+6911187,int_stack+4703937,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+319704,int_stack+314979,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+325479,int_stack+319704,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+332409,int_stack+325479,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+115290,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+340599,int_stack+332409,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+162540,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+204120,int_stack+162540,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+204120,int_stack+115290,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+95445,int_stack+350154,int_stack+340599,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+261870,int_stack+95445,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+506004,int_stack+261870,int_stack+162540,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+575304,int_stack+506004,int_stack+204120,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+124110,int_stack+575304,int_stack+24570,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+361179,int_stack+350154,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+33075,int_stack+0,int_stack+95445,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+870459,int_stack+33075,int_stack+261870,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+223335,int_stack+870459,int_stack+506004,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+952359,int_stack+223335,int_stack+575304,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+506004,int_stack+952359,int_stack+124110,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+638304,int_stack+373779,int_stack+361179,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+90405,int_stack+638304,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1073634,int_stack+90405,int_stack+33075,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1169184,int_stack+1073634,int_stack+870459,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4181379,int_stack+1169184,int_stack+223335,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+156555,int_stack+4181379,int_stack+952359,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+870459,int_stack+156555,int_stack+506004,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+506004,int_stack+388059,int_stack+373779,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+548844,int_stack+506004,int_stack+638304,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4326909,int_stack+548844,int_stack+90405,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+506004,int_stack+4326909,int_stack+1073634,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4326909,int_stack+506004,int_stack+1169184,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4498899,int_stack+4326909,int_stack+4181379,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+4181379,int_stack+4498899,int_stack+156555,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+4389279,int_stack+4181379,int_stack+870459,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+4601904,int_stack+4389279,int_stack+686184,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+8278062,int_stack+4601904,int_stack+1374729,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+506004,int_stack+8278062,int_stack+1848579,2025);
 /*--- compute (mg|ll) ---*/
 hrr1_build_mg(Libint->AB,int_stack+9225762,int_stack+506004,int_stack+5797437,2025);
 /*--- compute (lh|ll) ---*/
 hrr1_build_lh(Libint->AB,int_stack+10896387,int_stack+9225762,int_stack+6911187,2025);
 /*--- compute (ki|ll) ---*/
 hrr1_build_ki(Libint->AB,int_stack+5154729,int_stack+10896387,int_stack+2650479,2025);
 /*--- compute (t0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7195929,int_stack+409524,int_stack+404124,120);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7212129,int_stack+416124,int_stack+409524,120);
 /*--- compute (t0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+7231929,int_stack+7212129,int_stack+7195929,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7264329,int_stack+424044,int_stack+416124,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7288089,int_stack+7264329,int_stack+7212129,120);
 /*--- compute (t0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+7327689,int_stack+7288089,int_stack+7231929,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7195929,int_stack+433404,int_stack+424044,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+7381689,int_stack+7195929,int_stack+7264329,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+7429209,int_stack+7381689,int_stack+7288089,120);
 /*--- compute (t0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+7224009,int_stack+7429209,int_stack+7327689,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+7305009,int_stack+444324,int_stack+433404,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7495209,int_stack+7305009,int_stack+7195929,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+7551369,int_stack+7495209,int_stack+7381689,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+7630569,int_stack+7551369,int_stack+7429209,120);
 /*--- compute (t0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+7337769,int_stack+7630569,int_stack+7224009,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+7195929,int_stack+456924,int_stack+444324,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+7233729,int_stack+7195929,int_stack+7305009,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+7729569,int_stack+7233729,int_stack+7495209,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+7823169,int_stack+7729569,int_stack+7551369,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+7451169,int_stack+7823169,int_stack+7630569,120);
 /*--- compute (t0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+7941969,int_stack+7451169,int_stack+7337769,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+7299249,int_stack+471324,int_stack+456924,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+7342449,int_stack+7299249,int_stack+7195929,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+7589769,int_stack+7342449,int_stack+7233729,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+8093169,int_stack+7589769,int_stack+7729569,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1842504,int_stack+8093169,int_stack+7823169,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+7698969,int_stack+1842504,int_stack+7451169,120);
 /*--- compute (t0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2008824,int_stack+7698969,int_stack+7941969,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+7195929,int_stack+487644,int_stack+471324,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+7418049,int_stack+7195929,int_stack+7299249,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+7195929,int_stack+7418049,int_stack+7342449,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+7321929,int_stack+7195929,int_stack+7589769,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+7485729,int_stack+7321929,int_stack+8093169,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+7195929,int_stack+7485729,int_stack+1842504,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+7417689,int_stack+7195929,int_stack+7698969,120);
 /*--- compute (t0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+7655289,int_stack+7417689,int_stack+2008824,120);
 /*--- compute (rp|ll) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1842504,int_stack+7655289,int_stack+4389279,2025);
 /*--- compute (qd|ll) ---*/
 hrr1_build_qd(Libint->AB,int_stack+2480379,int_stack+1842504,int_stack+4601904,2025);
 /*--- compute (of|ll) ---*/
 hrr1_build_of(Libint->AB,int_stack+12810012,int_stack+2480379,int_stack+8278062,2025);
 /*--- compute (ng|ll) ---*/
 hrr1_build_ng(Libint->AB,int_stack+1842504,int_stack+12810012,int_stack+506004,2025);
 /*--- compute (mh|ll) ---*/
 hrr1_build_mh(Libint->AB,int_stack+12810012,int_stack+1842504,int_stack+9225762,2025);
 /*--- compute (li|ll) ---*/
 hrr1_build_li(Libint->AB,int_stack+7195929,int_stack+12810012,int_stack+10896387,2025);
 /*--- compute (kk|ll) ---*/
 hrr1_build_kk(Libint->AB,int_stack+9747429,int_stack+7195929,int_stack+5154729,2025);
 return int_stack+9747429;}
