/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldig(Libint_t*, prim_data*);

  /* Computes quartets of (ld|ig) integrals */

REALTYPE *hrr_order_ldig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][6] = int_stack + 0;
 Libint->vrr_classes[8][7] = int_stack + 1260;
 Libint->vrr_classes[8][8] = int_stack + 2880;
 Libint->vrr_classes[8][9] = int_stack + 4905;
 Libint->vrr_classes[8][10] = int_stack + 7380;
 Libint->vrr_classes[9][6] = int_stack + 10350;
 Libint->vrr_classes[9][7] = int_stack + 11890;
 Libint->vrr_classes[9][8] = int_stack + 13870;
 Libint->vrr_classes[9][9] = int_stack + 16345;
 Libint->vrr_classes[9][10] = int_stack + 19370;
 Libint->vrr_classes[10][6] = int_stack + 23000;
 Libint->vrr_classes[10][7] = int_stack + 24848;
 Libint->vrr_classes[10][8] = int_stack + 27224;
 Libint->vrr_classes[10][9] = int_stack + 30194;
 Libint->vrr_classes[10][10] = int_stack + 33824;
 memset(int_stack,0,38180*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 38180;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldig(Libint, Data);
   Data++;
 }
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+38180,int_stack+1260,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+41960,int_stack+2880,int_stack+1260,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+46820,int_stack+41960,int_stack+38180,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54380,int_stack+4905,int_stack+2880,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+60455,int_stack+54380,int_stack+41960,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+70175,int_stack+60455,int_stack+46820,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38180,int_stack+7380,int_stack+4905,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82775,int_stack+38180,int_stack+54380,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+38180,int_stack+82775,int_stack+60455,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+82775,int_stack+38180,int_stack+70175,45);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+38180,int_stack+11890,int_stack+10350,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+42800,int_stack+13870,int_stack+11890,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+48740,int_stack+42800,int_stack+38180,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+57980,int_stack+16345,int_stack+13870,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+65405,int_stack+57980,int_stack+42800,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+65405,int_stack+48740,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+38180,int_stack+19370,int_stack+16345,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+101675,int_stack+38180,int_stack+57980,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+38180,int_stack+101675,int_stack+65405,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+57980,int_stack+38180,int_stack+0,55);
 /*--- compute (lp|ig) ---*/
 hrr1_build_lp(Libint->AB,int_stack+101675,int_stack+57980,int_stack+82775,420);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+24848,int_stack+23000,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5544,int_stack+27224,int_stack+24848,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+12672,int_stack+5544,int_stack+0,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+38180,int_stack+30194,int_stack+27224,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+81080,int_stack+38180,int_stack+5544,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+158375,int_stack+81080,int_stack+12672,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47090,int_stack+33824,int_stack+30194,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+47090,int_stack+38180,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17820,int_stack+0,int_stack+81080,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+176855,int_stack+17820,int_stack+158375,66);
 /*--- compute (mp|ig) ---*/
 hrr1_build_mp(Libint->AB,int_stack+204575,int_stack+176855,int_stack+57980,420);
 /*--- compute (ld|ig) ---*/
 hrr1_build_ld(Libint->AB,int_stack+273875,int_stack+204575,int_stack+101675,420);
 return int_stack+273875;}
