/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldii(Libint_t*, prim_data*);

  /* Computes quartets of (ld|ii) integrals */

REALTYPE *hrr_order_ldii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][6] = int_stack + 0;
 Libint->vrr_classes[8][7] = int_stack + 1260;
 Libint->vrr_classes[8][8] = int_stack + 2880;
 Libint->vrr_classes[8][9] = int_stack + 4905;
 Libint->vrr_classes[8][10] = int_stack + 7380;
 Libint->vrr_classes[8][11] = int_stack + 10350;
 Libint->vrr_classes[8][12] = int_stack + 13860;
 Libint->vrr_classes[9][6] = int_stack + 17955;
 Libint->vrr_classes[9][7] = int_stack + 19495;
 Libint->vrr_classes[9][8] = int_stack + 21475;
 Libint->vrr_classes[9][9] = int_stack + 23950;
 Libint->vrr_classes[9][10] = int_stack + 26975;
 Libint->vrr_classes[9][11] = int_stack + 30605;
 Libint->vrr_classes[9][12] = int_stack + 34895;
 Libint->vrr_classes[10][6] = int_stack + 39900;
 Libint->vrr_classes[10][7] = int_stack + 41748;
 Libint->vrr_classes[10][8] = int_stack + 44124;
 Libint->vrr_classes[10][9] = int_stack + 47094;
 Libint->vrr_classes[10][10] = int_stack + 50724;
 Libint->vrr_classes[10][11] = int_stack + 55080;
 Libint->vrr_classes[10][12] = int_stack + 60228;
 memset(int_stack,0,66234*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 66234;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldii(Libint, Data);
   Data++;
 }
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+66234,int_stack+1260,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+70014,int_stack+2880,int_stack+1260,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+74874,int_stack+70014,int_stack+66234,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+82434,int_stack+4905,int_stack+2880,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+88509,int_stack+82434,int_stack+70014,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+98229,int_stack+88509,int_stack+74874,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66234,int_stack+7380,int_stack+4905,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+110829,int_stack+66234,int_stack+82434,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+122979,int_stack+110829,int_stack+88509,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+73659,int_stack+122979,int_stack+98229,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+92559,int_stack+10350,int_stack+7380,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139179,int_stack+92559,int_stack+66234,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+154029,int_stack+139179,int_stack+110829,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+174279,int_stack+154029,int_stack+122979,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+101469,int_stack+174279,int_stack+73659,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66234,int_stack+13860,int_stack+10350,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+66234,int_stack+92559,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+66234,int_stack+0,int_stack+139179,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+198579,int_stack+66234,int_stack+154029,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+66234,int_stack+198579,int_stack+174279,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+127929,int_stack+66234,int_stack+101469,45);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+66234,int_stack+19495,int_stack+17955,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+70854,int_stack+21475,int_stack+19495,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+76794,int_stack+70854,int_stack+66234,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+86034,int_stack+23950,int_stack+21475,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+93459,int_stack+86034,int_stack+70854,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+105339,int_stack+93459,int_stack+76794,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+66234,int_stack+26975,int_stack+23950,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+66234,int_stack+86034,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+163209,int_stack+0,int_stack+93459,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+75309,int_stack+163209,int_stack+105339,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+98409,int_stack+30605,int_stack+26975,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+109299,int_stack+98409,int_stack+66234,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+183009,int_stack+109299,int_stack+0,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+183009,int_stack+163209,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+207759,int_stack+0,int_stack+75309,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+163209,int_stack+34895,int_stack+30605,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66234,int_stack+163209,int_stack+98409,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+240099,int_stack+66234,int_stack+109299,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+66234,int_stack+240099,int_stack+183009,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+163209,int_stack+66234,int_stack+0,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+66234,int_stack+163209,int_stack+207759,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+163209,int_stack+66234,int_stack+127929,784);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+41748,int_stack+39900,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5544,int_stack+44124,int_stack+41748,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+12672,int_stack+5544,int_stack+0,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+23760,int_stack+47094,int_stack+44124,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32670,int_stack+23760,int_stack+5544,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+109354,int_stack+32670,int_stack+12672,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+50724,int_stack+47094,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+127834,int_stack+0,int_stack+23760,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+269049,int_stack+127834,int_stack+32670,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+10890,int_stack+269049,int_stack+109354,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+109354,int_stack+55080,int_stack+50724,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+292809,int_stack+109354,int_stack+0,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+314589,int_stack+292809,int_stack+127834,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+122422,int_stack+314589,int_stack+269049,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+344289,int_stack+122422,int_stack+10890,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+269049,int_stack+60228,int_stack+55080,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+269049,int_stack+109354,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+26136,int_stack+0,int_stack+292809,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+269049,int_stack+26136,int_stack+314589,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+269049,int_stack+122422,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+269049,int_stack+0,int_stack+344289,66);
 /*--- compute (mp|ii) ---*/
 hrr1_build_mp(Libint->AB,int_stack+320793,int_stack+269049,int_stack+66234,784);
 /*--- compute (ld|ii) ---*/
 hrr1_build_ld(Libint->AB,int_stack+450153,int_stack+320793,int_stack+163209,784);
 return int_stack+450153;}
