/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfnm(Libint_t*, prim_data*);

  /* Computes quartets of (lf|nm) integrals */

REALTYPE *hrr_order_lfnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[8][19] = int_stack + 49950;
 Libint->vrr_classes[9][10] = int_stack + 59400;
 Libint->vrr_classes[9][11] = int_stack + 63030;
 Libint->vrr_classes[9][12] = int_stack + 67320;
 Libint->vrr_classes[9][13] = int_stack + 72325;
 Libint->vrr_classes[9][14] = int_stack + 78100;
 Libint->vrr_classes[9][15] = int_stack + 84700;
 Libint->vrr_classes[9][16] = int_stack + 92180;
 Libint->vrr_classes[9][17] = int_stack + 100595;
 Libint->vrr_classes[9][18] = int_stack + 110000;
 Libint->vrr_classes[9][19] = int_stack + 120450;
 Libint->vrr_classes[10][10] = int_stack + 132000;
 Libint->vrr_classes[10][11] = int_stack + 136356;
 Libint->vrr_classes[10][12] = int_stack + 141504;
 Libint->vrr_classes[10][13] = int_stack + 147510;
 Libint->vrr_classes[10][14] = int_stack + 154440;
 Libint->vrr_classes[10][15] = int_stack + 162360;
 Libint->vrr_classes[10][16] = int_stack + 171336;
 Libint->vrr_classes[10][17] = int_stack + 181434;
 Libint->vrr_classes[10][18] = int_stack + 192720;
 Libint->vrr_classes[10][19] = int_stack + 205260;
 Libint->vrr_classes[11][10] = int_stack + 219120;
 Libint->vrr_classes[11][11] = int_stack + 224268;
 Libint->vrr_classes[11][12] = int_stack + 230352;
 Libint->vrr_classes[11][13] = int_stack + 237450;
 Libint->vrr_classes[11][14] = int_stack + 245640;
 Libint->vrr_classes[11][15] = int_stack + 255000;
 Libint->vrr_classes[11][16] = int_stack + 265608;
 Libint->vrr_classes[11][17] = int_stack + 277542;
 Libint->vrr_classes[11][18] = int_stack + 290880;
 Libint->vrr_classes[11][19] = int_stack + 305700;
 memset(int_stack,0,322080*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 322080;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfnm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+322080,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+330990,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+341520,int_stack+330990,int_stack+322080,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+359340,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+371625,int_stack+359340,int_stack+330990,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+392685,int_stack+371625,int_stack+341520,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+322080,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+422385,int_stack+322080,int_stack+359340,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+336255,int_stack+422385,int_stack+371625,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+446955,int_stack+336255,int_stack+392685,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+371355,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+387555,int_stack+371355,int_stack+322080,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+491505,int_stack+387555,int_stack+422385,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+532455,int_stack+491505,int_stack+336255,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+585105,int_stack+532455,int_stack+446955,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+322080,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+415905,int_stack+322080,int_stack+371355,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+647475,int_stack+415905,int_stack+387555,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+340440,int_stack+647475,int_stack+491505,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+448305,int_stack+340440,int_stack+532455,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+694725,int_stack+448305,int_stack+585105,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+522015,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+542670,int_stack+522015,int_stack+322080,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+579390,int_stack+542670,int_stack+415905,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+777885,int_stack+579390,int_stack+647475,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+848760,int_stack+777885,int_stack+340440,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+322080,int_stack+848760,int_stack+448305,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+934755,int_stack+322080,int_stack+694725,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+420360,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+443445,int_stack+420360,int_stack+522015,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+633390,int_stack+443445,int_stack+542670,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+484755,int_stack+633390,int_stack+579390,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1041675,int_stack+484755,int_stack+777885,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+694590,int_stack+1041675,int_stack+848760,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1140900,int_stack+694590,int_stack+322080,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1267260,int_stack+1140900,int_stack+934755,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+322080,int_stack+49950,int_stack+41400,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+347730,int_stack+322080,int_stack+420360,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+809250,int_stack+347730,int_stack+443445,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+322080,int_stack+809250,int_stack+633390,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+809250,int_stack+322080,int_stack+484755,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+322080,int_stack+809250,int_stack+1041675,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+809250,int_stack+322080,int_stack+694590,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+322080,int_stack+809250,int_stack+1140900,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+480030,int_stack+322080,int_stack+1267260,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+322080,int_stack+63030,int_stack+59400,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+332970,int_stack+67320,int_stack+63030,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+345840,int_stack+332970,int_stack+322080,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+367620,int_stack+72325,int_stack+67320,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+382635,int_stack+367620,int_stack+332970,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+408375,int_stack+382635,int_stack+345840,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+322080,int_stack+78100,int_stack+72325,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+444675,int_stack+322080,int_stack+367620,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+339405,int_stack+444675,int_stack+382635,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+643380,int_stack+339405,int_stack+408375,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+382305,int_stack+84700,int_stack+78100,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+402105,int_stack+382305,int_stack+322080,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+697830,int_stack+402105,int_stack+444675,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+747880,int_stack+697830,int_stack+339405,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+812230,int_stack+747880,int_stack+643380,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+643380,int_stack+92180,int_stack+84700,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+322080,int_stack+643380,int_stack+382305,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+888460,int_stack+322080,int_stack+402105,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+361680,int_stack+888460,int_stack+697830,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+946210,int_stack+361680,int_stack+747880,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+665820,int_stack+946210,int_stack+812230,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+767460,int_stack+100595,int_stack+92180,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+792705,int_stack+767460,int_stack+643380,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1036300,int_stack+792705,int_stack+322080,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1102300,int_stack+1036300,int_stack+888460,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+837585,int_stack+1102300,int_stack+361680,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+322080,int_stack+837585,int_stack+946210,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1188925,int_stack+322080,int_stack+665820,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+442200,int_stack+110000,int_stack+100595,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+643380,int_stack+442200,int_stack+767460,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+693870,int_stack+643380,int_stack+792705,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+693870,int_stack+1036300,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+942690,int_stack+0,int_stack+1102300,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1319605,int_stack+942690,int_stack+837585,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+768670,int_stack+1319605,int_stack+322080,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1459745,int_stack+768670,int_stack+1188925,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+322080,int_stack+120450,int_stack+110000,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+353430,int_stack+322080,int_stack+442200,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1063965,int_stack+353430,int_stack+643380,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+322080,int_stack+1063965,int_stack+693870,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1063965,int_stack+322080,int_stack+0,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1623095,int_stack+1063965,int_stack+942690,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+923110,int_stack+1623095,int_stack+1319605,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1103290,int_stack+923110,int_stack+768670,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+643380,int_stack+1103290,int_stack+1459745,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+843030,int_stack+643380,int_stack+480030,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+136356,int_stack+132000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+141504,int_stack+136356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+147510,int_stack+141504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103554,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+154440,int_stack+147510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+322080,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+322080,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+358116,int_stack+20790,int_stack+103554,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+72270,int_stack+162360,int_stack+154440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96030,int_stack+72270,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+423456,int_stack+96030,int_stack+322080,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+483516,int_stack+423456,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1333080,int_stack+483516,int_stack+358116,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+322080,int_stack+171336,int_stack+162360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+349008,int_stack+322080,int_stack+72270,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+349008,int_stack+96030,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+69300,int_stack+0,int_stack+423456,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1424556,int_stack+69300,int_stack+483516,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+396528,int_stack+1424556,int_stack+1333080,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1333080,int_stack+181434,int_stack+171336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1363374,int_stack+1333080,int_stack+322080,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+518496,int_stack+1363374,int_stack+349008,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1532664,int_stack+518496,int_stack+0,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1636614,int_stack+1532664,int_stack+69300,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1636614,int_stack+1424556,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1762740,int_stack+0,int_stack+396528,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+144144,int_stack+192720,int_stack+181434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+322080,int_stack+144144,int_stack+1333080,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+382668,int_stack+322080,int_stack+1363374,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1333080,int_stack+382668,int_stack+518496,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+472428,int_stack+1333080,int_stack+1532664,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1451880,int_stack+472428,int_stack+1636614,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1919556,int_stack+1451880,int_stack+0,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2104884,int_stack+1919556,int_stack+1762740,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+205260,int_stack+192720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+37620,int_stack+0,int_stack+144144,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105336,int_stack+37620,int_stack+322080,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1620048,int_stack+105336,int_stack+382668,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+1620048,int_stack+1333080,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1620048,int_stack+0,int_stack+472428,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+1620048,int_stack+1451880,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1333080,int_stack+0,int_stack+1919556,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1564740,int_stack+1333080,int_stack+2104884,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1804320,int_stack+1564740,int_stack+643380,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2403270,int_stack+1804320,int_stack+843030,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+224268,int_stack+219120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+230352,int_stack+224268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+237450,int_stack+230352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+245640,int_stack+237450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+322080,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+255000,int_stack+245640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+399300,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+162630,int_stack+399300,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+470280,int_stack+162630,int_stack+322080,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+322080,int_stack+265608,int_stack+255000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+322080,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+578388,int_stack+0,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+56160,int_stack+578388,int_stack+399300,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+660288,int_stack+56160,int_stack+162630,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+788052,int_stack+660288,int_stack+470280,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+162630,int_stack+277542,int_stack+265608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+198432,int_stack+162630,int_stack+322080,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+322080,int_stack+198432,int_stack+0,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+415680,int_stack+322080,int_stack+578388,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+932196,int_stack+415680,int_stack+56160,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1081254,int_stack+932196,int_stack+660288,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+538530,int_stack+1081254,int_stack+788052,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+290880,int_stack+277542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+40014,int_stack+0,int_stack+162630,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+723858,int_stack+40014,int_stack+198432,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+111618,int_stack+723858,int_stack+322080,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1251606,int_stack+111618,int_stack+415680,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+322080,int_stack+1251606,int_stack+932196,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+829938,int_stack+322080,int_stack+1081254,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3383370,int_stack+829938,int_stack+538530,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+520824,int_stack+305700,int_stack+290880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+565284,int_stack+520824,int_stack+0,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1048962,int_stack+565284,int_stack+40014,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+520824,int_stack+1048962,int_stack+723858,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1048962,int_stack+520824,int_stack+111618,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+520824,int_stack+1048962,int_stack+1251606,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1048962,int_stack+520824,int_stack+322080,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+1048962,int_stack+829938,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+273780,int_stack+0,int_stack+3383370,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+556920,int_stack+273780,int_stack+1564740,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3383370,int_stack+556920,int_stack+1804320,3630);
 /*--- compute (lf|nm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+3383370,int_stack+2403270,3630);
 return int_stack+0;}
