/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhnh(Libint_t*, prim_data*);

  /* Computes quartets of (lh|nh) integrals */

REALTYPE *hrr_order_lhnh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[9][10] = int_stack + 26820;
 Libint->vrr_classes[9][11] = int_stack + 30450;
 Libint->vrr_classes[9][12] = int_stack + 34740;
 Libint->vrr_classes[9][13] = int_stack + 39745;
 Libint->vrr_classes[9][14] = int_stack + 45520;
 Libint->vrr_classes[9][15] = int_stack + 52120;
 Libint->vrr_classes[10][10] = int_stack + 59600;
 Libint->vrr_classes[10][11] = int_stack + 63956;
 Libint->vrr_classes[10][12] = int_stack + 69104;
 Libint->vrr_classes[10][13] = int_stack + 75110;
 Libint->vrr_classes[10][14] = int_stack + 82040;
 Libint->vrr_classes[10][15] = int_stack + 89960;
 Libint->vrr_classes[11][10] = int_stack + 98936;
 Libint->vrr_classes[11][11] = int_stack + 104084;
 Libint->vrr_classes[11][12] = int_stack + 110168;
 Libint->vrr_classes[11][13] = int_stack + 117266;
 Libint->vrr_classes[11][14] = int_stack + 125456;
 Libint->vrr_classes[11][15] = int_stack + 134816;
 Libint->vrr_classes[12][10] = int_stack + 145424;
 Libint->vrr_classes[12][11] = int_stack + 151430;
 Libint->vrr_classes[12][12] = int_stack + 158528;
 Libint->vrr_classes[12][13] = int_stack + 166809;
 Libint->vrr_classes[12][14] = int_stack + 176364;
 Libint->vrr_classes[12][15] = int_stack + 187284;
 Libint->vrr_classes[13][10] = int_stack + 199660;
 Libint->vrr_classes[13][11] = int_stack + 206590;
 Libint->vrr_classes[13][12] = int_stack + 214780;
 Libint->vrr_classes[13][13] = int_stack + 224335;
 Libint->vrr_classes[13][14] = int_stack + 235360;
 Libint->vrr_classes[13][15] = int_stack + 247960;
 memset(int_stack,0,262240*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 262240;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhnh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+262240,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+271150,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+281680,int_stack+271150,int_stack+262240,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+299500,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+311785,int_stack+299500,int_stack+271150,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+332845,int_stack+311785,int_stack+281680,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+262240,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+362545,int_stack+262240,int_stack+299500,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+276415,int_stack+362545,int_stack+311785,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+387115,int_stack+276415,int_stack+332845,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+311515,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+327715,int_stack+311515,int_stack+262240,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+431665,int_stack+327715,int_stack+362545,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+311515,int_stack+431665,int_stack+276415,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+431665,int_stack+311515,int_stack+387115,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+262240,int_stack+30450,int_stack+26820,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+273130,int_stack+34740,int_stack+30450,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+286000,int_stack+273130,int_stack+262240,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+307780,int_stack+39745,int_stack+34740,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+322795,int_stack+307780,int_stack+273130,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+348535,int_stack+322795,int_stack+286000,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+262240,int_stack+45520,int_stack+39745,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+384835,int_stack+262240,int_stack+307780,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+279565,int_stack+384835,int_stack+322795,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+494035,int_stack+279565,int_stack+348535,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+322465,int_stack+52120,int_stack+45520,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+342265,int_stack+322465,int_stack+262240,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+342265,int_stack+384835,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+322465,int_stack+0,int_stack+279565,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+548485,int_stack+322465,int_stack+494035,55);
 /*--- compute (lp|nh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+624715,int_stack+548485,int_stack+431665,1386);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+63956,int_stack+59600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+69104,int_stack+63956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+262240,int_stack+75110,int_stack+69104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+280258,int_stack+262240,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+311146,int_stack+280258,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+82040,int_stack+75110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+20790,int_stack+0,int_stack+262240,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+354706,int_stack+20790,int_stack+280258,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+406186,int_stack+354706,int_stack+311146,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+262240,int_stack+89960,int_stack+82040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+286000,int_stack+262240,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+471526,int_stack+286000,int_stack+20790,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+471526,int_stack+354706,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+262240,int_stack+0,int_stack+406186,66);
 /*--- compute (mp|nh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+811825,int_stack+262240,int_stack+548485,1386);
 /*--- compute (ld|nh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1040515,int_stack+811825,int_stack+624715,1386);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+104084,int_stack+98936,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+110168,int_stack+104084,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+117266,int_stack+110168,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+353716,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+390220,int_stack+353716,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+125456,int_stack+117266,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+441700,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+441700,int_stack+353716,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+484288,int_stack+24570,int_stack+390220,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+353716,int_stack+134816,int_stack+125456,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+381796,int_stack+353716,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+561508,int_stack+381796,int_stack+441700,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+353716,int_stack+561508,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+561508,int_stack+353716,int_stack+484288,78);
 /*--- compute (np|nh) ---*/
 hrr1_build_np(Libint->AB,int_stack+1414735,int_stack+561508,int_stack+262240,1386);
 /*--- compute (md|nh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1689163,int_stack+1414735,int_stack+811825,1386);
 /*--- compute (lf|nh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+2146543,int_stack+1689163,int_stack+1040515,1386);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+262240,int_stack+151430,int_stack+145424,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+280258,int_stack+158528,int_stack+151430,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+301552,int_stack+280258,int_stack+262240,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+337588,int_stack+166809,int_stack+158528,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+362431,int_stack+337588,int_stack+280258,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+405019,int_stack+362431,int_stack+301552,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+262240,int_stack+176364,int_stack+166809,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+465079,int_stack+262240,int_stack+337588,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+290905,int_stack+465079,int_stack+362431,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+669616,int_stack+290905,int_stack+405019,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361885,int_stack+187284,int_stack+176364,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+394645,int_stack+361885,int_stack+262240,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+759706,int_stack+394645,int_stack+465079,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+361885,int_stack+759706,int_stack+290905,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+759706,int_stack+361885,int_stack+669616,91);
 /*--- compute (op|nh) ---*/
 hrr1_build_op(Libint->AB,int_stack+885832,int_stack+759706,int_stack+561508,1386);
 /*--- compute (nd|nh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2770243,int_stack+885832,int_stack+1414735,1386);
 /*--- compute (mf|nh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3319099,int_stack+2770243,int_stack+1689163,1386);
 /*--- compute (lg|nh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1210156,int_stack+3319099,int_stack+2146543,1386);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2145706,int_stack+206590,int_stack+199660,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2166496,int_stack+214780,int_stack+206590,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2191066,int_stack+2166496,int_stack+2145706,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2232646,int_stack+224335,int_stack+214780,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2261311,int_stack+2232646,int_stack+2166496,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2310451,int_stack+2261311,int_stack+2191066,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2145706,int_stack+235360,int_stack+224335,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2379751,int_stack+2145706,int_stack+2232646,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2178781,int_stack+2379751,int_stack+2261311,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2437081,int_stack+2178781,int_stack+2310451,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2260681,int_stack+247960,int_stack+235360,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2298481,int_stack+2260681,int_stack+2145706,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2541031,int_stack+2298481,int_stack+2379751,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2260681,int_stack+2541031,int_stack+2178781,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2541031,int_stack+2260681,int_stack+2437081,105);
 /*--- compute (qp|nh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2145706,int_stack+2541031,int_stack+759706,1386);
 /*--- compute (od|nh) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+2145706,int_stack+885832,1386);
 /*--- compute (nf|nh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4081399,int_stack+0,int_stack+2770243,1386);
 /*--- compute (mg|nh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+0,int_stack+4081399,int_stack+3319099,1386);
 /*--- compute (lh|nh) ---*/
 hrr1_build_lh(Libint->AB,int_stack+2145706,int_stack+0,int_stack+1210156,1386);
 return int_stack+2145706;}
