/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lhnl(Libint_t*, prim_data*);

  /* Computes quartets of (lh|nl) integrals */

REALTYPE *hrr_order_lhnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[9][10] = int_stack + 49950;
 Libint->vrr_classes[9][11] = int_stack + 53580;
 Libint->vrr_classes[9][12] = int_stack + 57870;
 Libint->vrr_classes[9][13] = int_stack + 62875;
 Libint->vrr_classes[9][14] = int_stack + 68650;
 Libint->vrr_classes[9][15] = int_stack + 75250;
 Libint->vrr_classes[9][16] = int_stack + 82730;
 Libint->vrr_classes[9][17] = int_stack + 91145;
 Libint->vrr_classes[9][18] = int_stack + 100550;
 Libint->vrr_classes[10][10] = int_stack + 111000;
 Libint->vrr_classes[10][11] = int_stack + 115356;
 Libint->vrr_classes[10][12] = int_stack + 120504;
 Libint->vrr_classes[10][13] = int_stack + 126510;
 Libint->vrr_classes[10][14] = int_stack + 133440;
 Libint->vrr_classes[10][15] = int_stack + 141360;
 Libint->vrr_classes[10][16] = int_stack + 150336;
 Libint->vrr_classes[10][17] = int_stack + 160434;
 Libint->vrr_classes[10][18] = int_stack + 171720;
 Libint->vrr_classes[11][10] = int_stack + 184260;
 Libint->vrr_classes[11][11] = int_stack + 189408;
 Libint->vrr_classes[11][12] = int_stack + 195492;
 Libint->vrr_classes[11][13] = int_stack + 202590;
 Libint->vrr_classes[11][14] = int_stack + 210780;
 Libint->vrr_classes[11][15] = int_stack + 220140;
 Libint->vrr_classes[11][16] = int_stack + 230748;
 Libint->vrr_classes[11][17] = int_stack + 242682;
 Libint->vrr_classes[11][18] = int_stack + 256020;
 Libint->vrr_classes[12][10] = int_stack + 270840;
 Libint->vrr_classes[12][11] = int_stack + 276846;
 Libint->vrr_classes[12][12] = int_stack + 283944;
 Libint->vrr_classes[12][13] = int_stack + 292225;
 Libint->vrr_classes[12][14] = int_stack + 301780;
 Libint->vrr_classes[12][15] = int_stack + 312700;
 Libint->vrr_classes[12][16] = int_stack + 325076;
 Libint->vrr_classes[12][17] = int_stack + 338999;
 Libint->vrr_classes[12][18] = int_stack + 354560;
 Libint->vrr_classes[13][10] = int_stack + 371850;
 Libint->vrr_classes[13][11] = int_stack + 378780;
 Libint->vrr_classes[13][12] = int_stack + 386970;
 Libint->vrr_classes[13][13] = int_stack + 396525;
 Libint->vrr_classes[13][14] = int_stack + 407550;
 Libint->vrr_classes[13][15] = int_stack + 420150;
 Libint->vrr_classes[13][16] = int_stack + 434430;
 Libint->vrr_classes[13][17] = int_stack + 450495;
 Libint->vrr_classes[13][18] = int_stack + 468450;
 memset(int_stack,0,488400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 488400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lhnl(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+488400,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+497310,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+507840,int_stack+497310,int_stack+488400,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+525660,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+537945,int_stack+525660,int_stack+497310,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+559005,int_stack+537945,int_stack+507840,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+488400,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+588705,int_stack+488400,int_stack+525660,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+502575,int_stack+588705,int_stack+537945,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+613275,int_stack+502575,int_stack+559005,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+537675,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+553875,int_stack+537675,int_stack+488400,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+657825,int_stack+553875,int_stack+588705,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+698775,int_stack+657825,int_stack+502575,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+751425,int_stack+698775,int_stack+613275,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+488400,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+582225,int_stack+488400,int_stack+537675,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+813795,int_stack+582225,int_stack+553875,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+506760,int_stack+813795,int_stack+657825,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+614625,int_stack+506760,int_stack+698775,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+861045,int_stack+614625,int_stack+751425,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+688335,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+708990,int_stack+688335,int_stack+488400,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+745710,int_stack+708990,int_stack+582225,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+944205,int_stack+745710,int_stack+813795,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1015080,int_stack+944205,int_stack+506760,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+488400,int_stack+1015080,int_stack+614625,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1101075,int_stack+488400,int_stack+861045,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+586680,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+609765,int_stack+586680,int_stack+688335,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+799710,int_stack+609765,int_stack+708990,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+586680,int_stack+799710,int_stack+745710,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+667680,int_stack+586680,int_stack+944205,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+766905,int_stack+667680,int_stack+1015080,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+586680,int_stack+766905,int_stack+488400,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+713040,int_stack+586680,int_stack+1101075,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+488400,int_stack+53580,int_stack+49950,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+499290,int_stack+57870,int_stack+53580,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+512160,int_stack+499290,int_stack+488400,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+533940,int_stack+62875,int_stack+57870,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+548955,int_stack+533940,int_stack+499290,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+574695,int_stack+548955,int_stack+512160,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+488400,int_stack+68650,int_stack+62875,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+610995,int_stack+488400,int_stack+533940,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+505725,int_stack+610995,int_stack+548955,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+641025,int_stack+505725,int_stack+574695,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+548625,int_stack+75250,int_stack+68650,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+568425,int_stack+548625,int_stack+488400,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+846690,int_stack+568425,int_stack+610995,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+896740,int_stack+846690,int_stack+505725,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+961090,int_stack+896740,int_stack+641025,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+488400,int_stack+82730,int_stack+75250,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+603075,int_stack+488400,int_stack+548625,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+642675,int_stack+603075,int_stack+568425,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+510840,int_stack+642675,int_stack+846690,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1037320,int_stack+510840,int_stack+896740,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+846690,int_stack+1037320,int_stack+961090,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+948330,int_stack+91145,int_stack+82730,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+973575,int_stack+948330,int_stack+488400,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1127410,int_stack+973575,int_stack+603075,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1127410,int_stack+642675,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+585915,int_stack+0,int_stack+510840,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1193410,int_stack+585915,int_stack+1037320,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1313530,int_stack+1193410,int_stack+846690,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+846690,int_stack+100550,int_stack+91145,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+874905,int_stack+846690,int_stack+948330,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+488400,int_stack+874905,int_stack+973575,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+846690,int_stack+488400,int_stack+1127410,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+945690,int_stack+846690,int_stack+0,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1444210,int_stack+945690,int_stack+585915,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+846690,int_stack+1444210,int_stack+1193410,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1001130,int_stack+846690,int_stack+1313530,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1164480,int_stack+1001130,int_stack+713040,2970);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+115356,int_stack+111000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+120504,int_stack+115356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+126510,int_stack+120504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+488400,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+133440,int_stack+126510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+531960,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+531960,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+567996,int_stack+20790,int_stack+488400,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+488400,int_stack+141360,int_stack+133440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+72270,int_stack+488400,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+633336,int_stack+72270,int_stack+531960,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+693396,int_stack+633336,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+770616,int_stack+693396,int_stack+567996,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+150336,int_stack+141360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+512160,int_stack+0,int_stack+488400,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+559680,int_stack+512160,int_stack+72270,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+26928,int_stack+559680,int_stack+633336,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+862092,int_stack+26928,int_stack+693396,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+628980,int_stack+862092,int_stack+770616,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+117018,int_stack+160434,int_stack+150336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+750948,int_stack+117018,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1565430,int_stack+750948,int_stack+512160,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1644630,int_stack+1565430,int_stack+559680,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+488400,int_stack+1644630,int_stack+26928,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1748580,int_stack+488400,int_stack+862092,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+804804,int_stack+1748580,int_stack+628980,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+171720,int_stack+160434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+33858,int_stack+0,int_stack+117018,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+94446,int_stack+33858,int_stack+750948,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+614526,int_stack+94446,int_stack+1565430,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+614526,int_stack+1644630,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+614526,int_stack+0,int_stack+488400,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1892724,int_stack+614526,int_stack+1748580,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+488400,int_stack+1892724,int_stack+804804,66);
 /*--- compute (mp|nl) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1565430,int_stack+488400,int_stack+1001130,2970);
 /*--- compute (ld|nl) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2055480,int_stack+1565430,int_stack+1164480,2970);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+684420,int_stack+189408,int_stack+184260,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+699864,int_stack+195492,int_stack+189408,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+718116,int_stack+699864,int_stack+684420,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+749004,int_stack+202590,int_stack+195492,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+770298,int_stack+749004,int_stack+699864,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+806802,int_stack+770298,int_stack+718116,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+684420,int_stack+210780,int_stack+202590,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+858282,int_stack+684420,int_stack+749004,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+708990,int_stack+858282,int_stack+770298,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+900870,int_stack+708990,int_stack+806802,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+769830,int_stack+220140,int_stack+210780,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+797910,int_stack+769830,int_stack+684420,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+978090,int_stack+797910,int_stack+858282,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1049070,int_stack+978090,int_stack+708990,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1140330,int_stack+1049070,int_stack+900870,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+684420,int_stack+230748,int_stack+220140,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+847050,int_stack+684420,int_stack+769830,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1248438,int_stack+847050,int_stack+797910,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+716244,int_stack+1248438,int_stack+978090,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+903210,int_stack+716244,int_stack+1049070,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1330338,int_stack+903210,int_stack+1140330,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1030974,int_stack+242682,int_stack+230748,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1066776,int_stack+1030974,int_stack+684420,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1130424,int_stack+1066776,int_stack+847050,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1130424,int_stack+1248438,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2857380,int_stack+0,int_stack+716244,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+684420,int_stack+2857380,int_stack+903210,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3006438,int_stack+684420,int_stack+1330338,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+854772,int_stack+256020,int_stack+242682,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+894786,int_stack+854772,int_stack+1030974,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1224024,int_stack+894786,int_stack+1066776,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+854772,int_stack+1224024,int_stack+1130424,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+995172,int_stack+854772,int_stack+0,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+995172,int_stack+2857380,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+854772,int_stack+0,int_stack+684420,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+854772,int_stack+3006438,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+684420,int_stack+0,int_stack+488400,2970);
 /*--- compute (md|nl) ---*/
 hrr1_build_md(Libint->AB,int_stack+2857380,int_stack+684420,int_stack+1565430,2970);
 /*--- compute (lf|nl) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3837480,int_stack+2857380,int_stack+2055480,2970);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+488400,int_stack+276846,int_stack+270840,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+506418,int_stack+283944,int_stack+276846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+527712,int_stack+506418,int_stack+488400,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+563748,int_stack+292225,int_stack+283944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+588591,int_stack+563748,int_stack+506418,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1272480,int_stack+588591,int_stack+527712,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+488400,int_stack+301780,int_stack+292225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+631179,int_stack+488400,int_stack+563748,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+517065,int_stack+631179,int_stack+588591,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1332540,int_stack+517065,int_stack+1272480,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1272480,int_stack+312700,int_stack+301780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1422630,int_stack+1272480,int_stack+488400,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1479960,int_stack+1422630,int_stack+631179,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1562770,int_stack+1479960,int_stack+517065,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+488400,int_stack+1562770,int_stack+1332540,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+614526,int_stack+325076,int_stack+312700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1305240,int_stack+614526,int_stack+1272480,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1669240,int_stack+1305240,int_stack+1422630,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1764790,int_stack+1669240,int_stack+1479960,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1370760,int_stack+1764790,int_stack+1562770,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1889005,int_stack+1370760,int_stack+488400,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+488400,int_stack+338999,int_stack+325076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+530169,int_stack+488400,int_stack+614526,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1519818,int_stack+530169,int_stack+1305240,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2057173,int_stack+1519818,int_stack+1669240,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2200498,int_stack+2057173,int_stack+1764790,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1629018,int_stack+2200498,int_stack+1370760,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1272480,int_stack+1629018,int_stack+1889005,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+604425,int_stack+354560,int_stack+338999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1827762,int_stack+604425,int_stack+488400,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1911300,int_stack+1827762,int_stack+530169,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+488400,int_stack+1911300,int_stack+1519818,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1827762,int_stack+488400,int_stack+2057173,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2374399,int_stack+1827762,int_stack+2200498,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1827762,int_stack+2374399,int_stack+1629018,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2083290,int_stack+1827762,int_stack+1272480,91);
 /*--- compute (op|nl) ---*/
 hrr1_build_op(Libint->AB,int_stack+1272480,int_stack+2083290,int_stack+0,2970);
 /*--- compute (nd|nl) ---*/
 hrr1_build_nd(Libint->AB,int_stack+5173980,int_stack+1272480,int_stack+684420,2970);
 /*--- compute (mf|nl) ---*/
 hrr1_build_mf(Libint->AB,int_stack+6350100,int_stack+5173980,int_stack+2857380,2970);
 /*--- compute (lg|nl) ---*/
 hrr1_build_lg(Libint->AB,int_stack+7983600,int_stack+6350100,int_stack+3837480,2970);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+378780,int_stack+371850,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+386970,int_stack+378780,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+396525,int_stack+386970,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+407550,int_stack+396525,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234045,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+234045,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+291375,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+420150,int_stack+407550,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1967460,int_stack+152775,int_stack+234045,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2353560,int_stack+1967460,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2476410,int_stack+2353560,int_stack+291375,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+434430,int_stack+420150,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+218925,int_stack+0,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+294525,int_stack+218925,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+42840,int_stack+294525,int_stack+1967460,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2621940,int_stack+42840,int_stack+2353560,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2793930,int_stack+2621940,int_stack+2476410,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2353560,int_stack+450495,int_stack+434430,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2401755,int_stack+2353560,int_stack+0,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2487435,int_stack+2401755,int_stack+218925,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2987970,int_stack+2487435,int_stack+294525,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+186165,int_stack+2987970,int_stack+42840,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3153345,int_stack+186165,int_stack+2621940,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3382665,int_stack+3153345,int_stack+2793930,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+468450,int_stack+450495,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+53865,int_stack+0,int_stack+2353560,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2613435,int_stack+53865,int_stack+2401755,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2756235,int_stack+2613435,int_stack+2487435,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2353560,int_stack+2756235,int_stack+2987970,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2585085,int_stack+2353560,int_stack+186165,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2852625,int_stack+2585085,int_stack+3153345,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2353560,int_stack+2852625,int_stack+3382665,105);
 /*--- compute (qp|nl) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2665410,int_stack+2353560,int_stack+2083290,2970);
 /*--- compute (od|nl) ---*/
 hrr1_build_od(Libint->AB,int_stack+3476220,int_stack+2665410,int_stack+1272480,2970);
 /*--- compute (nf|nl) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+3476220,int_stack+5173980,2970);
 /*--- compute (mg|nl) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1960200,int_stack+0,int_stack+6350100,2970);
 /*--- compute (lh|nl) ---*/
 hrr1_build_lh(Libint->AB,int_stack+4410450,int_stack+1960200,int_stack+7983600,2970);
 return int_stack+4410450;}
