/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_llnn(Libint_t*, prim_data*);

  /* Computes quartets of (ll|nn) integrals */

REALTYPE *hrr_order_llnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[8][19] = int_stack + 49950;
 Libint->vrr_classes[8][20] = int_stack + 59400;
 Libint->vrr_classes[9][10] = int_stack + 69795;
 Libint->vrr_classes[9][11] = int_stack + 73425;
 Libint->vrr_classes[9][12] = int_stack + 77715;
 Libint->vrr_classes[9][13] = int_stack + 82720;
 Libint->vrr_classes[9][14] = int_stack + 88495;
 Libint->vrr_classes[9][15] = int_stack + 95095;
 Libint->vrr_classes[9][16] = int_stack + 102575;
 Libint->vrr_classes[9][17] = int_stack + 110990;
 Libint->vrr_classes[9][18] = int_stack + 120395;
 Libint->vrr_classes[9][19] = int_stack + 130845;
 Libint->vrr_classes[9][20] = int_stack + 142395;
 Libint->vrr_classes[10][10] = int_stack + 155100;
 Libint->vrr_classes[10][11] = int_stack + 159456;
 Libint->vrr_classes[10][12] = int_stack + 164604;
 Libint->vrr_classes[10][13] = int_stack + 170610;
 Libint->vrr_classes[10][14] = int_stack + 177540;
 Libint->vrr_classes[10][15] = int_stack + 185460;
 Libint->vrr_classes[10][16] = int_stack + 194436;
 Libint->vrr_classes[10][17] = int_stack + 204534;
 Libint->vrr_classes[10][18] = int_stack + 215820;
 Libint->vrr_classes[10][19] = int_stack + 228360;
 Libint->vrr_classes[10][20] = int_stack + 242220;
 Libint->vrr_classes[11][10] = int_stack + 257466;
 Libint->vrr_classes[11][11] = int_stack + 262614;
 Libint->vrr_classes[11][12] = int_stack + 268698;
 Libint->vrr_classes[11][13] = int_stack + 275796;
 Libint->vrr_classes[11][14] = int_stack + 283986;
 Libint->vrr_classes[11][15] = int_stack + 293346;
 Libint->vrr_classes[11][16] = int_stack + 303954;
 Libint->vrr_classes[11][17] = int_stack + 315888;
 Libint->vrr_classes[11][18] = int_stack + 329226;
 Libint->vrr_classes[11][19] = int_stack + 344046;
 Libint->vrr_classes[11][20] = int_stack + 360426;
 Libint->vrr_classes[12][10] = int_stack + 378444;
 Libint->vrr_classes[12][11] = int_stack + 384450;
 Libint->vrr_classes[12][12] = int_stack + 391548;
 Libint->vrr_classes[12][13] = int_stack + 399829;
 Libint->vrr_classes[12][14] = int_stack + 409384;
 Libint->vrr_classes[12][15] = int_stack + 420304;
 Libint->vrr_classes[12][16] = int_stack + 432680;
 Libint->vrr_classes[12][17] = int_stack + 446603;
 Libint->vrr_classes[12][18] = int_stack + 462164;
 Libint->vrr_classes[12][19] = int_stack + 479454;
 Libint->vrr_classes[12][20] = int_stack + 498564;
 Libint->vrr_classes[13][10] = int_stack + 519585;
 Libint->vrr_classes[13][11] = int_stack + 526515;
 Libint->vrr_classes[13][12] = int_stack + 534705;
 Libint->vrr_classes[13][13] = int_stack + 544260;
 Libint->vrr_classes[13][14] = int_stack + 555285;
 Libint->vrr_classes[13][15] = int_stack + 567885;
 Libint->vrr_classes[13][16] = int_stack + 582165;
 Libint->vrr_classes[13][17] = int_stack + 598230;
 Libint->vrr_classes[13][18] = int_stack + 616185;
 Libint->vrr_classes[13][19] = int_stack + 636135;
 Libint->vrr_classes[13][20] = int_stack + 658185;
 Libint->vrr_classes[14][10] = int_stack + 682440;
 Libint->vrr_classes[14][11] = int_stack + 690360;
 Libint->vrr_classes[14][12] = int_stack + 699720;
 Libint->vrr_classes[14][13] = int_stack + 710640;
 Libint->vrr_classes[14][14] = int_stack + 723240;
 Libint->vrr_classes[14][15] = int_stack + 737640;
 Libint->vrr_classes[14][16] = int_stack + 753960;
 Libint->vrr_classes[14][17] = int_stack + 772320;
 Libint->vrr_classes[14][18] = int_stack + 792840;
 Libint->vrr_classes[14][19] = int_stack + 815640;
 Libint->vrr_classes[14][20] = int_stack + 840840;
 Libint->vrr_classes[15][10] = int_stack + 868560;
 Libint->vrr_classes[15][11] = int_stack + 877536;
 Libint->vrr_classes[15][12] = int_stack + 888144;
 Libint->vrr_classes[15][13] = int_stack + 900520;
 Libint->vrr_classes[15][14] = int_stack + 914800;
 Libint->vrr_classes[15][15] = int_stack + 931120;
 Libint->vrr_classes[15][16] = int_stack + 949616;
 Libint->vrr_classes[15][17] = int_stack + 970424;
 Libint->vrr_classes[15][18] = int_stack + 993680;
 Libint->vrr_classes[15][19] = int_stack + 1019520;
 Libint->vrr_classes[15][20] = int_stack + 1048080;
 Libint->vrr_classes[16][10] = int_stack + 1079496;
 Libint->vrr_classes[16][11] = int_stack + 1089594;
 Libint->vrr_classes[16][12] = int_stack + 1101528;
 Libint->vrr_classes[16][13] = int_stack + 1115451;
 Libint->vrr_classes[16][14] = int_stack + 1131516;
 Libint->vrr_classes[16][15] = int_stack + 1149876;
 Libint->vrr_classes[16][16] = int_stack + 1170684;
 Libint->vrr_classes[16][17] = int_stack + 1194093;
 Libint->vrr_classes[16][18] = int_stack + 1220256;
 Libint->vrr_classes[16][19] = int_stack + 1249326;
 Libint->vrr_classes[16][20] = int_stack + 1281456;
 memset(int_stack,0,1316799*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1316799;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_llnn(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1316799,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1325709,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1336239,int_stack+1325709,int_stack+1316799,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1354059,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1366344,int_stack+1354059,int_stack+1325709,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1387404,int_stack+1366344,int_stack+1336239,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1316799,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1417104,int_stack+1316799,int_stack+1354059,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1330974,int_stack+1417104,int_stack+1366344,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1441674,int_stack+1330974,int_stack+1387404,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1366074,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1382274,int_stack+1366074,int_stack+1316799,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1486224,int_stack+1382274,int_stack+1417104,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1527174,int_stack+1486224,int_stack+1330974,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1579824,int_stack+1527174,int_stack+1441674,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1316799,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1410624,int_stack+1316799,int_stack+1366074,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1642194,int_stack+1410624,int_stack+1382274,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1335159,int_stack+1642194,int_stack+1486224,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1443024,int_stack+1335159,int_stack+1527174,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1689444,int_stack+1443024,int_stack+1579824,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1516734,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1537389,int_stack+1516734,int_stack+1316799,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1574109,int_stack+1537389,int_stack+1410624,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1772604,int_stack+1574109,int_stack+1642194,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1843479,int_stack+1772604,int_stack+1335159,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1316799,int_stack+1843479,int_stack+1443024,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1929474,int_stack+1316799,int_stack+1689444,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1415079,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1438164,int_stack+1415079,int_stack+1516734,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1628109,int_stack+1438164,int_stack+1537389,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1479474,int_stack+1628109,int_stack+1574109,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2036394,int_stack+1479474,int_stack+1772604,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1689309,int_stack+2036394,int_stack+1843479,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2135619,int_stack+1689309,int_stack+1316799,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2261979,int_stack+2135619,int_stack+1929474,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1316799,int_stack+49950,int_stack+41400,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1342449,int_stack+1316799,int_stack+1415079,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1803969,int_stack+1342449,int_stack+1438164,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1872819,int_stack+1803969,int_stack+1628109,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1560474,int_stack+1872819,int_stack+1479474,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1388619,int_stack+1560474,int_stack+2036394,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1964619,int_stack+1388619,int_stack+1689309,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2395629,int_stack+1964619,int_stack+2135619,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2553579,int_stack+2395629,int_stack+2261979,45);
 /*--- compute (l0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1520919,int_stack+59400,int_stack+49950,45);
 /*--- compute (l0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1673874,int_stack+1520919,int_stack+1316799,45);
 /*--- compute (l0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1725174,int_stack+1673874,int_stack+1342449,45);
 /*--- compute (l0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2112039,int_stack+1725174,int_stack+1803969,45);
 /*--- compute (l0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+1673874,int_stack+2112039,int_stack+1872819,45);
 /*--- compute (l0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2112039,int_stack+1673874,int_stack+1560474,45);
 /*--- compute (l0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1520919,int_stack+2112039,int_stack+1388619,45);
 /*--- compute (l0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2112039,int_stack+1520919,int_stack+1964619,45);
 /*--- compute (l0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1316799,int_stack+2112039,int_stack+2395629,45);
 /*--- compute (l0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1509849,int_stack+1316799,int_stack+2553579,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1316799,int_stack+73425,int_stack+69795,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1327689,int_stack+77715,int_stack+73425,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1340559,int_stack+1327689,int_stack+1316799,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1362339,int_stack+82720,int_stack+77715,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1377354,int_stack+1362339,int_stack+1327689,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1403094,int_stack+1377354,int_stack+1340559,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1316799,int_stack+88495,int_stack+82720,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1439394,int_stack+1316799,int_stack+1362339,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1334124,int_stack+1439394,int_stack+1377354,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1705869,int_stack+1334124,int_stack+1403094,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1377024,int_stack+95095,int_stack+88495,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1396824,int_stack+1377024,int_stack+1316799,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1760319,int_stack+1396824,int_stack+1439394,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1431474,int_stack+1760319,int_stack+1334124,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1810369,int_stack+1431474,int_stack+1705869,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1705869,int_stack+102575,int_stack+95095,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1316799,int_stack+1705869,int_stack+1377024,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1886599,int_stack+1316799,int_stack+1396824,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1356399,int_stack+1886599,int_stack+1760319,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1944349,int_stack+1356399,int_stack+1431474,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2034439,int_stack+1944349,int_stack+1810369,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1431474,int_stack+110990,int_stack+102575,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1456719,int_stack+1431474,int_stack+1705869,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1705869,int_stack+1456719,int_stack+1316799,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1771869,int_stack+1705869,int_stack+1886599,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2136079,int_stack+1771869,int_stack+1356399,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2241184,int_stack+2136079,int_stack+1944349,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1858494,int_stack+2241184,int_stack+2034439,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1316799,int_stack+120395,int_stack+110990,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1345014,int_stack+1316799,int_stack+1431474,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1989174,int_stack+1345014,int_stack+1456719,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1395504,int_stack+1989174,int_stack+1705869,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2361304,int_stack+1395504,int_stack+1771869,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1705869,int_stack+2361304,int_stack+2136079,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2063974,int_stack+1705869,int_stack+2241184,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2482579,int_stack+2063974,int_stack+1858494,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1846009,int_stack+130845,int_stack+120395,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1877359,int_stack+1846009,int_stack+1316799,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2218414,int_stack+1877359,int_stack+1345014,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+2218414,int_stack+1989174,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2645929,int_stack+0,int_stack+1395504,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1316799,int_stack+2645929,int_stack+2361304,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2784529,int_stack+1316799,int_stack+1705869,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2964709,int_stack+2784529,int_stack+2063974,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1933789,int_stack+2964709,int_stack+2482579,55);
 /*--- compute (m0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+1705869,int_stack+142395,int_stack+130845,55);
 /*--- compute (m0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+1740519,int_stack+1705869,int_stack+1846009,55);
 /*--- compute (m0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2302564,int_stack+1740519,int_stack+1877359,55);
 /*--- compute (m0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1705869,int_stack+2302564,int_stack+2218414,55);
 /*--- compute (m0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+2133439,int_stack+1705869,int_stack+0,55);
 /*--- compute (m0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1705869,int_stack+2133439,int_stack+2645929,55);
 /*--- compute (m0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+2133439,int_stack+1705869,int_stack+1316799,55);
 /*--- compute (m0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1705869,int_stack+2133439,int_stack+2784529,55);
 /*--- compute (m0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2133439,int_stack+1705869,int_stack+2964709,55);
 /*--- compute (m0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2369389,int_stack+2133439,int_stack+1933789,55);
 /*--- compute (lp|nn) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1705869,int_stack+2369389,int_stack+1509849,4356);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2293929,int_stack+159456,int_stack+155100,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2306997,int_stack+164604,int_stack+159456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2322441,int_stack+2306997,int_stack+2293929,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2348577,int_stack+170610,int_stack+164604,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2608969,int_stack+2348577,int_stack+2306997,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2639857,int_stack+2608969,int_stack+2322441,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2293929,int_stack+177540,int_stack+170610,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2683417,int_stack+2293929,int_stack+2348577,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2314719,int_stack+2683417,int_stack+2608969,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2719453,int_stack+2314719,int_stack+2639857,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2608969,int_stack+185460,int_stack+177540,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2632729,int_stack+2608969,int_stack+2293929,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2784793,int_stack+2632729,int_stack+2683417,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2844853,int_stack+2784793,int_stack+2314719,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2922073,int_stack+2844853,int_stack+2719453,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2293929,int_stack+194436,int_stack+185460,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2320857,int_stack+2293929,int_stack+2608969,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2674309,int_stack+2320857,int_stack+2632729,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3013549,int_stack+2674309,int_stack+2784793,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1316799,int_stack+3013549,int_stack+2844853,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2743609,int_stack+1316799,int_stack+2922073,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2608969,int_stack+204534,int_stack+194436,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2865577,int_stack+2608969,int_stack+2293929,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2919433,int_stack+2865577,int_stack+2320857,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1424907,int_stack+2919433,int_stack+2674309,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1528857,int_stack+1424907,int_stack+3013549,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2998633,int_stack+1528857,int_stack+1316799,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2998633,int_stack+2743609,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1316799,int_stack+215820,int_stack+204534,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1350657,int_stack+1316799,int_stack+2608969,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2608969,int_stack+1350657,int_stack+2865577,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2698729,int_stack+2608969,int_stack+2919433,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2817529,int_stack+2698729,int_stack+1424907,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3142777,int_stack+2817529,int_stack+1528857,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1411245,int_stack+3142777,int_stack+2998633,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3310945,int_stack+1411245,int_stack+0,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+228360,int_stack+215820,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+37620,int_stack+0,int_stack+1316799,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105336,int_stack+37620,int_stack+1350657,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2963059,int_stack+105336,int_stack+2608969,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3506965,int_stack+2963059,int_stack+2698729,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2608969,int_stack+3506965,int_stack+2817529,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3673285,int_stack+2608969,int_stack+3142777,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3889501,int_stack+3673285,int_stack+1411245,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1316799,int_stack+3889501,int_stack+3310945,66);
 /*--- compute (n0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+2803009,int_stack+242220,int_stack+228360,66);
 /*--- compute (n0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+2844589,int_stack+2803009,int_stack+0,66);
 /*--- compute (n0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+1556379,int_stack+2844589,int_stack+37620,66);
 /*--- compute (n0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2803009,int_stack+1556379,int_stack+105336,66);
 /*--- compute (n0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+2803009,int_stack+2963059,66);
 /*--- compute (n0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2803009,int_stack+0,int_stack+3506965,66);
 /*--- compute (n0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+2803009,int_stack+2608969,66);
 /*--- compute (n0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2608969,int_stack+0,int_stack+3673285,66);
 /*--- compute (n0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2879239,int_stack+2608969,int_stack+3889501,66);
 /*--- compute (n0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3162379,int_stack+2879239,int_stack+1316799,66);
 /*--- compute (mp|nn) ---*/
 hrr1_build_mp(Libint->AB,int_stack+3449875,int_stack+3162379,int_stack+2369389,4356);
 /*--- compute (ld|nn) ---*/
 hrr1_build_ld(Libint->AB,int_stack+4168615,int_stack+3449875,int_stack+1705869,4356);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1316799,int_stack+262614,int_stack+257466,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1332243,int_stack+268698,int_stack+262614,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1350495,int_stack+1332243,int_stack+1316799,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1381383,int_stack+275796,int_stack+268698,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1402677,int_stack+1381383,int_stack+1332243,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1439181,int_stack+1402677,int_stack+1350495,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1316799,int_stack+283986,int_stack+275796,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1490661,int_stack+1316799,int_stack+1381383,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1341369,int_stack+1490661,int_stack+1402677,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1533249,int_stack+1341369,int_stack+1439181,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1402209,int_stack+293346,int_stack+283986,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1430289,int_stack+1402209,int_stack+1316799,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1610469,int_stack+1430289,int_stack+1490661,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1681449,int_stack+1610469,int_stack+1341369,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1772709,int_stack+1681449,int_stack+1533249,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1316799,int_stack+303954,int_stack+293346,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1479429,int_stack+1316799,int_stack+1402209,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1880817,int_stack+1479429,int_stack+1430289,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1348623,int_stack+1880817,int_stack+1610469,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1535589,int_stack+1348623,int_stack+1681449,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1962717,int_stack+1535589,int_stack+1772709,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1663353,int_stack+315888,int_stack+303954,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1699155,int_stack+1663353,int_stack+1316799,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1762803,int_stack+1699155,int_stack+1479429,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2106861,int_stack+1762803,int_stack+1880817,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2229711,int_stack+2106861,int_stack+1348623,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1316799,int_stack+2229711,int_stack+1535589,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2378769,int_stack+1316799,int_stack+1962717,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1487151,int_stack+329226,int_stack+315888,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1527165,int_stack+1487151,int_stack+1663353,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1856403,int_stack+1527165,int_stack+1699155,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1598769,int_stack+1856403,int_stack+1762803,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2564097,int_stack+1598769,int_stack+2106861,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1962483,int_stack+2564097,int_stack+2229711,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2736087,int_stack+1962483,int_stack+1316799,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2736087,int_stack+2378769,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1316799,int_stack+344046,int_stack+329226,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1361259,int_stack+1316799,int_stack+1487151,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2161227,int_stack+1361259,int_stack+1527165,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2280567,int_stack+2161227,int_stack+1856403,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1739169,int_stack+2280567,int_stack+1598769,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1441287,int_stack+1739169,int_stack+2564097,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2439687,int_stack+1441287,int_stack+1962483,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+5344735,int_stack+2439687,int_stack+2736087,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2695215,int_stack+5344735,int_stack+0,78);
 /*--- compute (o0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+360426,int_stack+344046,78);
 /*--- compute (o0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+49140,int_stack+0,int_stack+1316799,78);
 /*--- compute (o0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+138060,int_stack+49140,int_stack+1361259,78);
 /*--- compute (o0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+1935729,int_stack+138060,int_stack+2161227,78);
 /*--- compute (o0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+1935729,int_stack+2280567,78);
 /*--- compute (o0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+1935729,int_stack+0,int_stack+1739169,78);
 /*--- compute (o0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+0,int_stack+1935729,int_stack+1441287,78);
 /*--- compute (o0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+1316799,int_stack+0,int_stack+2439687,78);
 /*--- compute (o0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+0,int_stack+1316799,int_stack+5344735,78);
 /*--- compute (o0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1316799,int_stack+0,int_stack+2695215,78);
 /*--- compute (np|nn) ---*/
 hrr1_build_np(Libint->AB,int_stack+1656567,int_stack+1316799,int_stack+3162379,4356);
 /*--- compute (md|nn) ---*/
 hrr1_build_md(Libint->AB,int_stack+5344735,int_stack+1656567,int_stack+3449875,4356);
 /*--- compute (lf|nn) ---*/
 hrr1_build_lf(Libint->AB,int_stack+6782215,int_stack+5344735,int_stack+4168615,4356);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+384450,int_stack+378444,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+391548,int_stack+384450,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+399829,int_stack+391548,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+409384,int_stack+399829,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+202839,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+202839,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+252525,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+420304,int_stack+409384,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2519055,int_stack+132405,int_stack+202839,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2601865,int_stack+2519055,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2708335,int_stack+2601865,int_stack+252525,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+432680,int_stack+420304,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+189735,int_stack+0,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+255255,int_stack+189735,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+255255,int_stack+2519055,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2834461,int_stack+37128,int_stack+2601865,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2519055,int_stack+2834461,int_stack+2708335,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2687223,int_stack+446603,int_stack+432680,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2728992,int_stack+2687223,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2983519,int_stack+2728992,int_stack+189735,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3092719,int_stack+2983519,int_stack+255255,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+161343,int_stack+3092719,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3236044,int_stack+161343,int_stack+2834461,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3434788,int_stack+3236044,int_stack+2519055,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2519055,int_stack+462164,int_stack+446603,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2565738,int_stack+2519055,int_stack+2687223,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+0,int_stack+2565738,int_stack+2728992,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2649276,int_stack+0,int_stack+2983519,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2813076,int_stack+2649276,int_stack+3092719,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3651004,int_stack+2813076,int_stack+161343,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+123760,int_stack+3651004,int_stack+3236044,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3013731,int_stack+123760,int_stack+3434788,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3284001,int_stack+479454,int_stack+462164,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3335871,int_stack+3284001,int_stack+2519055,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3429237,int_stack+3335871,int_stack+2565738,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3882872,int_stack+3429237,int_stack+0,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+4068512,int_stack+3882872,int_stack+2649276,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2519055,int_stack+4068512,int_stack+2813076,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4297832,int_stack+2519055,int_stack+3651004,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4595948,int_stack+4297832,int_stack+123760,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+4595948,int_stack+3013731,91);
 /*--- compute (q0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+330330,int_stack+498564,int_stack+479454,91);
 /*--- compute (q0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+387660,int_stack+330330,int_stack+3284001,91);
 /*--- compute (q0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+2786595,int_stack+387660,int_stack+3335871,91);
 /*--- compute (q0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+2942205,int_stack+2786595,int_stack+3429237,91);
 /*--- compute (q0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+3151050,int_stack+2942205,int_stack+3882872,91);
 /*--- compute (q0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+2786595,int_stack+3151050,int_stack+4068512,91);
 /*--- compute (q0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+3092355,int_stack+2786595,int_stack+2519055,91);
 /*--- compute (q0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2519055,int_stack+3092355,int_stack+4297832,91);
 /*--- compute (q0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+2891700,int_stack+2519055,int_stack+4595948,91);
 /*--- compute (q0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+3282090,int_stack+2891700,int_stack+0,91);
 /*--- compute (op|nn) ---*/
 hrr1_build_op(Libint->AB,int_stack+3678486,int_stack+3282090,int_stack+1316799,4356);
 /*--- compute (nd|nn) ---*/
 hrr1_build_nd(Libint->AB,int_stack+8742415,int_stack+3678486,int_stack+1656567,4356);
 /*--- compute (mf|nn) ---*/
 hrr1_build_mf(Libint->AB,int_stack+10467391,int_stack+8742415,int_stack+5344735,4356);
 /*--- compute (lg|nn) ---*/
 hrr1_build_lg(Libint->AB,int_stack+12863191,int_stack+10467391,int_stack+6782215,4356);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1316799,int_stack+526515,int_stack+519585,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1337589,int_stack+534705,int_stack+526515,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1362159,int_stack+1337589,int_stack+1316799,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1403739,int_stack+544260,int_stack+534705,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1432404,int_stack+1403739,int_stack+1337589,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1481544,int_stack+1432404,int_stack+1362159,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1316799,int_stack+555285,int_stack+544260,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1550844,int_stack+1316799,int_stack+1403739,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1349874,int_stack+1550844,int_stack+1432404,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1608174,int_stack+1349874,int_stack+1481544,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1431774,int_stack+567885,int_stack+555285,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1469574,int_stack+1431774,int_stack+1316799,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1712124,int_stack+1469574,int_stack+1550844,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1807674,int_stack+1712124,int_stack+1349874,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1930524,int_stack+1807674,int_stack+1608174,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1316799,int_stack+582165,int_stack+567885,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1535724,int_stack+1316799,int_stack+1431774,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2076054,int_stack+1535724,int_stack+1469574,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1359639,int_stack+2076054,int_stack+1712124,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1611324,int_stack+1359639,int_stack+1807674,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2186304,int_stack+1611324,int_stack+1930524,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1783314,int_stack+598230,int_stack+582165,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1831509,int_stack+1783314,int_stack+1316799,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1917189,int_stack+1831509,int_stack+1535724,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2380344,int_stack+1917189,int_stack+2076054,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2545719,int_stack+2380344,int_stack+1359639,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1316799,int_stack+2545719,int_stack+1611324,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2746374,int_stack+1316799,int_stack+2186304,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1546119,int_stack+616185,int_stack+598230,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1599984,int_stack+1546119,int_stack+1783314,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2043189,int_stack+1599984,int_stack+1831509,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1696374,int_stack+2043189,int_stack+1917189,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2995854,int_stack+1696374,int_stack+2380344,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2185989,int_stack+2995854,int_stack+2545719,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+2185989,int_stack+1316799,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+294840,int_stack+0,int_stack+2746374,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1316799,int_stack+636135,int_stack+616185,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1376649,int_stack+1316799,int_stack+1546119,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2453529,int_stack+1376649,int_stack+1599984,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2614179,int_stack+2453529,int_stack+2043189,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1885374,int_stack+2614179,int_stack+1696374,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1484379,int_stack+1885374,int_stack+2995854,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2828379,int_stack+1484379,int_stack+2185989,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+4697790,int_stack+2828379,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+5066340,int_stack+4697790,int_stack+294840,105);
 /*--- compute (r0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+0,int_stack+658185,int_stack+636135,105);
 /*--- compute (r0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+66150,int_stack+0,int_stack+1316799,105);
 /*--- compute (r0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+185850,int_stack+66150,int_stack+1376649,105);
 /*--- compute (r0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+365400,int_stack+185850,int_stack+2453529,105);
 /*--- compute (r0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+0,int_stack+365400,int_stack+2614179,105);
 /*--- compute (r0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+299880,int_stack+0,int_stack+1885374,105);
 /*--- compute (r0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+1793079,int_stack+299880,int_stack+1484379,105);
 /*--- compute (r0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+0,int_stack+1793079,int_stack+2828379,105);
 /*--- compute (r0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+1316799,int_stack+0,int_stack+4697790,105);
 /*--- compute (r0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+0,int_stack+1316799,int_stack+5066340,105);
 /*--- compute (qp|nn) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1316799,int_stack+0,int_stack+3282090,4356);
 /*--- compute (od|nn) ---*/
 hrr1_build_od(Libint->AB,int_stack+4697790,int_stack+1316799,int_stack+3678486,4356);
 /*--- compute (nf|nn) ---*/
 hrr1_build_nf(Libint->AB,int_stack+15803491,int_stack+4697790,int_stack+8742415,4356);
 /*--- compute (mg|nn) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6736398,int_stack+15803491,int_stack+10467391,4356);
 /*--- compute (lh|nn) ---*/
 hrr1_build_lh(Libint->AB,int_stack+18678451,int_stack+6736398,int_stack+12863191,4356);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2505987,int_stack+690360,int_stack+682440,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2529747,int_stack+699720,int_stack+690360,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2557827,int_stack+2529747,int_stack+2505987,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2605347,int_stack+710640,int_stack+699720,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2638107,int_stack+2605347,int_stack+2529747,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2694267,int_stack+2638107,int_stack+2557827,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2505987,int_stack+723240,int_stack+710640,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2773467,int_stack+2505987,int_stack+2605347,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2543787,int_stack+2773467,int_stack+2638107,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2838987,int_stack+2543787,int_stack+2694267,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2637387,int_stack+737640,int_stack+723240,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2680587,int_stack+2637387,int_stack+2505987,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2957787,int_stack+2680587,int_stack+2773467,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3066987,int_stack+2957787,int_stack+2543787,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3207387,int_stack+3066987,int_stack+2838987,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2505987,int_stack+753960,int_stack+737640,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2756187,int_stack+2505987,int_stack+2637387,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3373707,int_stack+2756187,int_stack+2680587,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2554947,int_stack+3373707,int_stack+2957787,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2842587,int_stack+2554947,int_stack+3066987,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3499707,int_stack+2842587,int_stack+3207387,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3039147,int_stack+772320,int_stack+753960,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3094227,int_stack+3039147,int_stack+2505987,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3192147,int_stack+3094227,int_stack+2756187,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3721467,int_stack+3192147,int_stack+3373707,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3910467,int_stack+3721467,int_stack+2554947,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2505987,int_stack+3910467,int_stack+2842587,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4139787,int_stack+2505987,int_stack+3499707,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2768067,int_stack+792840,int_stack+772320,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2829627,int_stack+2768067,int_stack+3039147,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3336147,int_stack+2829627,int_stack+3094227,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2939787,int_stack+3336147,int_stack+3192147,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4424907,int_stack+2939787,int_stack+3721467,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3499347,int_stack+4424907,int_stack+3910467,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+10330098,int_stack+3499347,int_stack+2505987,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10667058,int_stack+10330098,int_stack+4139787,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2505987,int_stack+815640,int_stack+792840,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2574387,int_stack+2505987,int_stack+2768067,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3805107,int_stack+2574387,int_stack+2829627,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3988707,int_stack+3805107,int_stack+3336147,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3155787,int_stack+3988707,int_stack+2939787,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2697507,int_stack+3155787,int_stack+4424907,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4233507,int_stack+2697507,int_stack+3499347,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+11023458,int_stack+4233507,int_stack+10330098,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+11444658,int_stack+11023458,int_stack+10667058,120);
 /*--- compute (t0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+10330098,int_stack+840840,int_stack+815640,120);
 /*--- compute (t0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+10405698,int_stack+10330098,int_stack+2505987,120);
 /*--- compute (t0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+10542498,int_stack+10405698,int_stack+2574387,120);
 /*--- compute (t0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+10747698,int_stack+10542498,int_stack+3805107,120);
 /*--- compute (t0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+10330098,int_stack+10747698,int_stack+3988707,120);
 /*--- compute (t0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+3458187,int_stack+10330098,int_stack+3155787,120);
 /*--- compute (t0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+10330098,int_stack+3458187,int_stack+2697507,120);
 /*--- compute (t0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+2505987,int_stack+10330098,int_stack+4233507,120);
 /*--- compute (t0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+10330098,int_stack+2505987,int_stack+11023458,120);
 /*--- compute (t0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+2505987,int_stack+10330098,int_stack+11444658,120);
 /*--- compute (rp|nn) ---*/
 hrr1_build_rp(Libint->AB,int_stack+10330098,int_stack+2505987,int_stack+0,4356);
 /*--- compute (qd|nn) ---*/
 hrr1_build_qd(Libint->AB,int_stack+11702238,int_stack+10330098,int_stack+1316799,4356);
 /*--- compute (of|nn) ---*/
 hrr1_build_of(Libint->AB,int_stack+22794871,int_stack+11702238,int_stack+4697790,4356);
 /*--- compute (ng|nn) ---*/
 hrr1_build_ng(Libint->AB,int_stack+26192551,int_stack+22794871,int_stack+15803491,4356);
 /*--- compute (mh|nn) ---*/
 hrr1_build_mh(Libint->AB,int_stack+30504991,int_stack+26192551,int_stack+6736398,4356);
 /*--- compute (li|nn) ---*/
 hrr1_build_li(Libint->AB,int_stack+3028707,int_stack+30504991,int_stack+18678451,4356);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1316799,int_stack+877536,int_stack+868560,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1343727,int_stack+888144,int_stack+877536,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1375551,int_stack+1343727,int_stack+1316799,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1429407,int_stack+900520,int_stack+888144,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1466535,int_stack+1429407,int_stack+1343727,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1530183,int_stack+1466535,int_stack+1375551,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1316799,int_stack+914800,int_stack+900520,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1619943,int_stack+1316799,int_stack+1429407,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1359639,int_stack+1619943,int_stack+1466535,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1694199,int_stack+1359639,int_stack+1530183,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1465719,int_stack+931120,int_stack+914800,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1514679,int_stack+1465719,int_stack+1316799,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1828839,int_stack+1514679,int_stack+1619943,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1952599,int_stack+1828839,int_stack+1359639,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2111719,int_stack+1952599,int_stack+1694199,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1316799,int_stack+949616,int_stack+931120,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1600359,int_stack+1316799,int_stack+1465719,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2300215,int_stack+1600359,int_stack+1514679,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1372287,int_stack+2300215,int_stack+1828839,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1698279,int_stack+1372287,int_stack+1952599,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1698279,int_stack+2111719,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1921047,int_stack+970424,int_stack+949616,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1983471,int_stack+1921047,int_stack+1316799,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2094447,int_stack+1983471,int_stack+1600359,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+251328,int_stack+2094447,int_stack+2300215,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+465528,int_stack+251328,int_stack+1372287,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1316799,int_stack+465528,int_stack+1698279,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+14080614,int_stack+1316799,int_stack+0,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+993680,int_stack+970424,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+69768,int_stack+0,int_stack+1921047,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1613823,int_stack+69768,int_stack+1983471,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1798783,int_stack+1613823,int_stack+2094447,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2043583,int_stack+1798783,int_stack+251328,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+14403750,int_stack+2043583,int_stack+465528,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+194616,int_stack+14403750,int_stack+1316799,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+576504,int_stack+194616,int_stack+14080614,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+14080614,int_stack+1019520,int_stack+993680,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+14158134,int_stack+14080614,int_stack+0,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1316799,int_stack+14158134,int_stack+69768,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+14750278,int_stack+1316799,int_stack+1613823,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+15027718,int_stack+14750278,int_stack+1798783,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1524879,int_stack+15027718,int_stack+2043583,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1924719,int_stack+1524879,int_stack+14403750,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+15370438,int_stack+1924719,int_stack+194616,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+15370438,int_stack+576504,136);
 /*--- compute (u0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+493680,int_stack+1048080,int_stack+1019520,136);
 /*--- compute (u0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+579360,int_stack+493680,int_stack+14080614,136);
 /*--- compute (u0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+734400,int_stack+579360,int_stack+14158134,136);
 /*--- compute (u0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+14080614,int_stack+734400,int_stack+1316799,136);
 /*--- compute (u0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+493680,int_stack+14080614,int_stack+14750278,136);
 /*--- compute (u0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+14080614,int_stack+493680,int_stack+15027718,136);
 /*--- compute (u0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+493680,int_stack+14080614,int_stack+1524879,136);
 /*--- compute (u0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+14080614,int_stack+493680,int_stack+1924719,136);
 /*--- compute (u0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+493680,int_stack+14080614,int_stack+15370438,136);
 /*--- compute (u0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+14080614,int_stack+493680,int_stack+0,136);
 /*--- compute (tp|nn) ---*/
 hrr1_build_tp(Libint->AB,int_stack+14673030,int_stack+14080614,int_stack+2505987,4356);
 /*--- compute (rd|nn) ---*/
 hrr1_build_rd(Libint->AB,int_stack+16241190,int_stack+14673030,int_stack+10330098,4356);
 /*--- compute (qf|nn) ---*/
 hrr1_build_qf(Libint->AB,int_stack+35536171,int_stack+16241190,int_stack+11702238,4356);
 /*--- compute (og|nn) ---*/
 hrr1_build_og(Libint->AB,int_stack+8517267,int_stack+35536171,int_stack+22794871,4356);
 /*--- compute (nh|nn) ---*/
 hrr1_build_nh(Libint->AB,int_stack+18985470,int_stack+8517267,int_stack+26192551,4356);
 /*--- compute (mi|nn) ---*/
 hrr1_build_mi(Libint->AB,int_stack+39500131,int_stack+18985470,int_stack+30504991,4356);
 /*--- compute (lk|nn) ---*/
 hrr1_build_lk(Libint->AB,int_stack+25022886,int_stack+39500131,int_stack+3028707,4356);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+1089594,int_stack+1079496,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30294,int_stack+1101528,int_stack+1089594,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66096,int_stack+30294,int_stack+0,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126684,int_stack+1115451,int_stack+1101528,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168453,int_stack+126684,int_stack+30294,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240057,int_stack+168453,int_stack+66096,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+1131516,int_stack+1115451,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341037,int_stack+0,int_stack+126684,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48195,int_stack+341037,int_stack+168453,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+424575,int_stack+48195,int_stack+240057,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167535,int_stack+1149876,int_stack+1131516,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222615,int_stack+167535,int_stack+0,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576045,int_stack+222615,int_stack+341037,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+715275,int_stack+576045,int_stack+48195,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+894285,int_stack+715275,int_stack+424575,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+1170684,int_stack+1149876,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+319005,int_stack+0,int_stack+167535,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+32079606,int_stack+319005,int_stack+222615,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62424,int_stack+32079606,int_stack+576045,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429165,int_stack+62424,int_stack+715275,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+32240256,int_stack+429165,int_stack+894285,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+679779,int_stack+1194093,int_stack+1170684,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+750006,int_stack+679779,int_stack+0,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+874854,int_stack+750006,int_stack+319005,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+32523000,int_stack+874854,int_stack+32079606,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+32763975,int_stack+32523000,int_stack+62424,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+32763975,int_stack+429165,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+33056358,int_stack+0,int_stack+32240256,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+32079606,int_stack+1220256,int_stack+1194093,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+32158095,int_stack+32079606,int_stack+679779,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+32298549,int_stack+32158095,int_stack+750006,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+334152,int_stack+32298549,int_stack+874854,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+609552,int_stack+334152,int_stack+32523000,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+33419886,int_stack+609552,int_stack+32763975,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+32506629,int_stack+33419886,int_stack+0,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+33809730,int_stack+32506629,int_stack+33056358,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1249326,int_stack+1220256,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+87210,int_stack+0,int_stack+32079606,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+32936253,int_stack+87210,int_stack+32158095,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+34264140,int_stack+32936253,int_stack+32298549,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+32079606,int_stack+34264140,int_stack+334152,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+34576260,int_stack+32079606,int_stack+609552,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+244188,int_stack+34576260,int_stack+33419886,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+33170343,int_stack+244188,int_stack+32506629,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1316799,int_stack+33170343,int_stack+33809730,153);
 /*--- compute (v0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+32465166,int_stack+1281456,int_stack+1249326,153);
 /*--- compute (v0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+32561556,int_stack+32465166,int_stack+0,153);
 /*--- compute (v0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+745416,int_stack+32561556,int_stack+87210,153);
 /*--- compute (v0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+32465166,int_stack+745416,int_stack+32936253,153);
 /*--- compute (v0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+745416,int_stack+32465166,int_stack+34264140,153);
 /*--- compute (v0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+32465166,int_stack+745416,int_stack+32079606,153);
 /*--- compute (v0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+33707373,int_stack+32465166,int_stack+34576260,153);
 /*--- compute (v0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+32079606,int_stack+33707373,int_stack+244188,153);
 /*--- compute (v0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+33707373,int_stack+32079606,int_stack+33170343,153);
 /*--- compute (v0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+32079606,int_stack+33707373,int_stack+1316799,153);
 /*--- compute (up|nn) ---*/
 hrr1_build_up(Libint->AB,int_stack+32746074,int_stack+32079606,int_stack+14080614,4356);
 /*--- compute (td|nn) ---*/
 hrr1_build_td(Libint->AB,int_stack+0,int_stack+32746074,int_stack+14673030,4356);
 /*--- compute (rf|nn) ---*/
 hrr1_build_rf(Libint->AB,int_stack+3136320,int_stack+0,int_stack+16241190,4356);
 /*--- compute (qg|nn) ---*/
 hrr1_build_qg(Libint->AB,int_stack+46208371,int_stack+3136320,int_stack+35536171,4356);
 /*--- compute (oh|nn) ---*/
 hrr1_build_oh(Libint->AB,int_stack+0,int_stack+46208371,int_stack+8517267,4356);
 /*--- compute (ni|nn) ---*/
 hrr1_build_ni(Libint->AB,int_stack+7135128,int_stack+0,int_stack+18985470,4356);
 /*--- compute (mk|nn) ---*/
 hrr1_build_mk(Libint->AB,int_stack+15185016,int_stack+7135128,int_stack+39500131,4356);
 /*--- compute (ll|nn) ---*/
 hrr1_build_ll(Libint->AB,int_stack+0,int_stack+15185016,int_stack+25022886,4356);
 return int_stack+0;}
