/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_m0mf(Libint_t*, prim_data*);

  /* Computes quartets of (m0|mf) integrals */

REALTYPE *hrr_order_m0mf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 memset(int_stack,0,15950*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 15950;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_m0mf(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+15950,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+25025,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+35915,int_stack+25025,int_stack+15950,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54065,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+54065,int_stack+25025,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+54065,int_stack+0,int_stack+35915,55);
 return int_stack+54065;}
