/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdli(Libint_t*, prim_data*);

  /* Computes quartets of (md|li) integrals */

REALTYPE *hrr_order_mdli(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[10][8] = int_stack + 30800;
 Libint->vrr_classes[10][9] = int_stack + 33770;
 Libint->vrr_classes[10][10] = int_stack + 37400;
 Libint->vrr_classes[10][11] = int_stack + 41756;
 Libint->vrr_classes[10][12] = int_stack + 46904;
 Libint->vrr_classes[10][13] = int_stack + 52910;
 Libint->vrr_classes[10][14] = int_stack + 59840;
 Libint->vrr_classes[11][8] = int_stack + 67760;
 Libint->vrr_classes[11][9] = int_stack + 71270;
 Libint->vrr_classes[11][10] = int_stack + 75560;
 Libint->vrr_classes[11][11] = int_stack + 80708;
 Libint->vrr_classes[11][12] = int_stack + 86792;
 Libint->vrr_classes[11][13] = int_stack + 93890;
 Libint->vrr_classes[11][14] = int_stack + 102080;
 memset(int_stack,0,111440*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 111440;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdli(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+111440,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+118865,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+127940,int_stack+118865,int_stack+111440,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+142790,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+153680,int_stack+142790,int_stack+118865,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+171830,int_stack+153680,int_stack+127940,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+111440,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+196580,int_stack+111440,int_stack+142790,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+218360,int_stack+196580,int_stack+153680,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+124310,int_stack+218360,int_stack+171830,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161435,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+248610,int_stack+161435,int_stack+111440,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+274350,int_stack+248610,int_stack+196580,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+310650,int_stack+274350,int_stack+218360,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+176450,int_stack+310650,int_stack+124310,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111440,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+128765,int_stack+111440,int_stack+161435,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+356025,int_stack+128765,int_stack+248610,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+111440,int_stack+356025,int_stack+274350,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+228425,int_stack+111440,int_stack+310650,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+291950,int_stack+228425,int_stack+176450,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+111440,int_stack+33770,int_stack+30800,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+120350,int_stack+37400,int_stack+33770,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+131240,int_stack+120350,int_stack+111440,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+149060,int_stack+41756,int_stack+37400,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+162128,int_stack+149060,int_stack+120350,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+183908,int_stack+162128,int_stack+131240,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+111440,int_stack+46904,int_stack+41756,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+213608,int_stack+111440,int_stack+149060,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+239744,int_stack+213608,int_stack+162128,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+126884,int_stack+239744,int_stack+183908,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+171434,int_stack+52910,int_stack+46904,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+361250,int_stack+171434,int_stack+111440,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+361250,int_stack+213608,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+392138,int_stack+0,int_stack+239744,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+189452,int_stack+392138,int_stack+126884,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111440,int_stack+59840,int_stack+52910,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+132230,int_stack+111440,int_stack+171434,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+446588,int_stack+132230,int_stack+361250,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+111440,int_stack+446588,int_stack+0,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+446588,int_stack+111440,int_stack+392138,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+361250,int_stack+446588,int_stack+189452,66);
 /*--- compute (mp|li) ---*/
 hrr1_build_mp(Libint->AB,int_stack+444410,int_stack+361250,int_stack+291950,1260);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+111440,int_stack+71270,int_stack+67760,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+121970,int_stack+75560,int_stack+71270,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+134840,int_stack+121970,int_stack+111440,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+155900,int_stack+80708,int_stack+75560,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+171344,int_stack+155900,int_stack+121970,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+197084,int_stack+171344,int_stack+134840,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+111440,int_stack+86792,int_stack+80708,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+232184,int_stack+111440,int_stack+155900,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+263072,int_stack+232184,int_stack+171344,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+129692,int_stack+263072,int_stack+197084,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+182342,int_stack+93890,int_stack+86792,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+305972,int_stack+182342,int_stack+111440,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+305972,int_stack+232184,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+652310,int_stack+0,int_stack+263072,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+203636,int_stack+652310,int_stack+129692,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111440,int_stack+102080,int_stack+93890,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+136010,int_stack+111440,int_stack+182342,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+51480,int_stack+136010,int_stack+305972,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+277346,int_stack+51480,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+277346,int_stack+652310,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+90090,int_stack+0,int_stack+203636,78);
 /*--- compute (np|li) ---*/
 hrr1_build_np(Libint->AB,int_stack+652310,int_stack+90090,int_stack+361250,1260);
 /*--- compute (md|li) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+652310,int_stack+444410,1260);
 return int_stack+0;}
