/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdmm(Libint_t*, prim_data*);

  /* Computes quartets of (md|mm) integrals */

REALTYPE *hrr_order_mdmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 memset(int_stack,0,231835*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 231835;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+231835,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+240910,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+251800,int_stack+240910,int_stack+231835,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+269950,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+282820,int_stack+269950,int_stack+240910,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+304600,int_stack+282820,int_stack+251800,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+231835,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+334850,int_stack+231835,int_stack+269950,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+360590,int_stack+334850,int_stack+282820,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+246850,int_stack+360590,int_stack+304600,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+292225,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+396890,int_stack+292225,int_stack+231835,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+426920,int_stack+396890,int_stack+334850,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+469820,int_stack+426920,int_stack+360590,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+309550,int_stack+469820,int_stack+246850,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+231835,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+251635,int_stack+231835,int_stack+292225,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+524270,int_stack+251635,int_stack+396890,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+574320,int_stack+524270,int_stack+426920,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+373075,int_stack+574320,int_stack+469820,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+638670,int_stack+373075,int_stack+309550,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+286285,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+308725,int_stack+286285,int_stack+231835,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+449305,int_stack+308725,int_stack+251635,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+723370,int_stack+449305,int_stack+524270,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+798445,int_stack+723370,int_stack+574320,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+507055,int_stack+798445,int_stack+373075,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+888535,int_stack+507055,int_stack+638670,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+231835,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+348325,int_stack+231835,int_stack+286285,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+608695,int_stack+348325,int_stack+308725,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+257080,int_stack+608695,int_stack+449305,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+393205,int_stack+257080,int_stack+723370,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+674695,int_stack+393205,int_stack+798445,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+997435,int_stack+674695,int_stack+507055,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1128115,int_stack+997435,int_stack+888535,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+498310,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+526525,int_stack+498310,int_stack+231835,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+794815,int_stack+526525,int_stack+348325,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+498310,int_stack+794815,int_stack+608695,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+794815,int_stack+498310,int_stack+257080,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+498310,int_stack+794815,int_stack+393205,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+794815,int_stack+498310,int_stack+674695,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+231835,int_stack+794815,int_stack+997435,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+395185,int_stack+231835,int_stack+1128115,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+231835,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+242725,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+255793,int_stack+242725,int_stack+231835,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+277573,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293017,int_stack+277573,int_stack+242725,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+319153,int_stack+293017,int_stack+255793,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+231835,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+355453,int_stack+231835,int_stack+277573,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+561560,int_stack+355453,int_stack+293017,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+249853,int_stack+561560,int_stack+319153,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+304303,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+605120,int_stack+304303,int_stack+231835,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+641156,int_stack+605120,int_stack+355453,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+325093,int_stack+641156,int_stack+561560,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+692636,int_stack+325093,int_stack+249853,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+561560,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+231835,int_stack+561560,int_stack+304303,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+768866,int_stack+231835,int_stack+605120,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+828926,int_stack+768866,int_stack+641156,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+585320,int_stack+828926,int_stack+325093,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+273415,int_stack+585320,int_stack+692636,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+676796,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+703724,int_stack+676796,int_stack+561560,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+906146,int_stack+703724,int_stack+231835,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+975446,int_stack+906146,int_stack+768866,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1065536,int_stack+975446,int_stack+828926,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+751244,int_stack+1065536,int_stack+585320,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1173644,int_stack+751244,int_stack+273415,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+231835,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+262129,int_stack+231835,int_stack+676796,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+315985,int_stack+262129,int_stack+703724,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+561560,int_stack+315985,int_stack+906146,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1304324,int_stack+561560,int_stack+975446,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+873212,int_stack+1304324,int_stack+1065536,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1430450,int_stack+873212,int_stack+751244,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+665510,int_stack+1430450,int_stack+1173644,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+828860,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1017356,int_stack+828860,int_stack+231835,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1077944,int_stack+1017356,int_stack+262129,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1167704,int_stack+1077944,int_stack+315985,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1017356,int_stack+1167704,int_stack+561560,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1587266,int_stack+1017356,int_stack+1304324,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1017356,int_stack+1587266,int_stack+873212,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1202684,int_stack+1017356,int_stack+1430450,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1398704,int_stack+1202684,int_stack+665510,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+561560,int_stack+1398704,int_stack+395185,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1598354,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1611224,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+1626668,int_stack+1611224,int_stack+1598354,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1652408,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1670660,int_stack+1652408,int_stack+1611224,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1701548,int_stack+1670660,int_stack+1626668,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1598354,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1060685,int_stack+1598354,int_stack+1652408,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1097189,int_stack+1060685,int_stack+1670660,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1619648,int_stack+1097189,int_stack+1701548,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1683998,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1708568,int_stack+1683998,int_stack+1598354,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1148669,int_stack+1708568,int_stack+1060685,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1209509,int_stack+1148669,int_stack+1097189,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1286729,int_stack+1209509,int_stack+1619648,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1060685,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1088765,int_stack+1060685,int_stack+1683998,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1598354,int_stack+1088765,int_stack+1708568,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+231835,int_stack+1598354,int_stack+1148669,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+323095,int_stack+231835,int_stack+1209509,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1137905,int_stack+323095,int_stack+1286729,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1258025,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1289849,int_stack+1258025,int_stack+1060685,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1669334,int_stack+1289849,int_stack+1088765,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+431203,int_stack+1669334,int_stack+1598354,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+431203,int_stack+231835,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1751234,int_stack+0,int_stack+323095,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+231835,int_stack+1751234,int_stack+1137905,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+386275,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1598354,int_stack+386275,int_stack+1258025,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1060685,int_stack+1598354,int_stack+1289849,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1154285,int_stack+1060685,int_stack+1669334,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1895378,int_stack+1154285,int_stack+431203,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2044436,int_stack+1895378,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2044436,int_stack+1751234,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1662002,int_stack+0,int_stack+231835,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+231835,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+271849,int_stack+231835,int_stack+386275,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+343453,int_stack+271849,int_stack+1598354,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+185328,int_stack+343453,int_stack+1060685,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+325728,int_stack+185328,int_stack+1154285,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1060685,int_stack+325728,int_stack+1895378,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+185328,int_stack+1060685,int_stack+2044436,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1060685,int_stack+185328,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+0,int_stack+1060685,int_stack+1662002,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1598354,int_stack+0,int_stack+1398704,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2197304,int_stack+1598354,int_stack+561560,3025);
 return int_stack+2197304;}
