/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfng(Libint_t*, prim_data*);

  /* Computes quartets of (mf|ng) integrals */

REALTYPE *hrr_order_mfng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[10][10] = int_stack + 25300;
 Libint->vrr_classes[10][11] = int_stack + 29656;
 Libint->vrr_classes[10][12] = int_stack + 34804;
 Libint->vrr_classes[10][13] = int_stack + 40810;
 Libint->vrr_classes[10][14] = int_stack + 47740;
 Libint->vrr_classes[11][10] = int_stack + 55660;
 Libint->vrr_classes[11][11] = int_stack + 60808;
 Libint->vrr_classes[11][12] = int_stack + 66892;
 Libint->vrr_classes[11][13] = int_stack + 73990;
 Libint->vrr_classes[11][14] = int_stack + 82180;
 Libint->vrr_classes[12][10] = int_stack + 91540;
 Libint->vrr_classes[12][11] = int_stack + 97546;
 Libint->vrr_classes[12][12] = int_stack + 104644;
 Libint->vrr_classes[12][13] = int_stack + 112925;
 Libint->vrr_classes[12][14] = int_stack + 122480;
 memset(int_stack,0,133400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 133400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfng(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+144290,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+157160,int_stack+144290,int_stack+133400,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+178940,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+193955,int_stack+178940,int_stack+144290,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+219695,int_stack+193955,int_stack+157160,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+133400,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+255995,int_stack+133400,int_stack+178940,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+133400,int_stack+255995,int_stack+193955,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+255995,int_stack+133400,int_stack+219695,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+29656,int_stack+25300,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+146468,int_stack+34804,int_stack+29656,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+161912,int_stack+146468,int_stack+133400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188048,int_stack+40810,int_stack+34804,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+206066,int_stack+188048,int_stack+146468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+310445,int_stack+206066,int_stack+161912,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+133400,int_stack+47740,int_stack+40810,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+133400,int_stack+188048,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+133400,int_stack+0,int_stack+206066,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+184880,int_stack+133400,int_stack+310445,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+310445,int_stack+184880,int_stack+255995,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+60808,int_stack+55660,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+148844,int_stack+66892,int_stack+60808,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+148844,int_stack+133400,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+30888,int_stack+73990,int_stack+66892,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+250220,int_stack+30888,int_stack+148844,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+133400,int_stack+250220,int_stack+0,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+82180,int_stack+73990,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+473795,int_stack+0,int_stack+30888,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+473795,int_stack+250220,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+473795,int_stack+0,int_stack+133400,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+551015,int_stack+473795,int_stack+184880,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+747035,int_stack+551015,int_stack+310445,990);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+133400,int_stack+97546,int_stack+91540,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+151418,int_stack+104644,int_stack+97546,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+172712,int_stack+151418,int_stack+133400,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+208748,int_stack+112925,int_stack+104644,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+233591,int_stack+208748,int_stack+151418,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+276179,int_stack+233591,int_stack+172712,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+133400,int_stack+122480,int_stack+112925,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+336239,int_stack+133400,int_stack+208748,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+385925,int_stack+336239,int_stack+233591,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+385925,int_stack+276179,91);
 /*--- compute (op|ng) ---*/
 hrr1_build_op(Libint->AB,int_stack+90090,int_stack+0,int_stack+473795,990);
 /*--- compute (nd|ng) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1073735,int_stack+90090,int_stack+551015,990);
 /*--- compute (mf|ng) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+1073735,int_stack+747035,990);
 return int_stack+0;}
