/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mglh(Libint_t*, prim_data*);

  /* Computes quartets of (mg|lh) integrals */

REALTYPE *hrr_order_mglh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[10][8] = int_stack + 24200;
 Libint->vrr_classes[10][9] = int_stack + 27170;
 Libint->vrr_classes[10][10] = int_stack + 30800;
 Libint->vrr_classes[10][11] = int_stack + 35156;
 Libint->vrr_classes[10][12] = int_stack + 40304;
 Libint->vrr_classes[10][13] = int_stack + 46310;
 Libint->vrr_classes[11][8] = int_stack + 53240;
 Libint->vrr_classes[11][9] = int_stack + 56750;
 Libint->vrr_classes[11][10] = int_stack + 61040;
 Libint->vrr_classes[11][11] = int_stack + 66188;
 Libint->vrr_classes[11][12] = int_stack + 72272;
 Libint->vrr_classes[11][13] = int_stack + 79370;
 Libint->vrr_classes[12][8] = int_stack + 87560;
 Libint->vrr_classes[12][9] = int_stack + 91655;
 Libint->vrr_classes[12][10] = int_stack + 96660;
 Libint->vrr_classes[12][11] = int_stack + 102666;
 Libint->vrr_classes[12][12] = int_stack + 109764;
 Libint->vrr_classes[12][13] = int_stack + 118045;
 Libint->vrr_classes[13][8] = int_stack + 127600;
 Libint->vrr_classes[13][9] = int_stack + 132325;
 Libint->vrr_classes[13][10] = int_stack + 138100;
 Libint->vrr_classes[13][11] = int_stack + 145030;
 Libint->vrr_classes[13][12] = int_stack + 153220;
 Libint->vrr_classes[13][13] = int_stack + 162775;
 memset(int_stack,0,173800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 173800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mglh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+173800,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+181225,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+190300,int_stack+181225,int_stack+173800,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+205150,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+216040,int_stack+205150,int_stack+181225,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+234190,int_stack+216040,int_stack+190300,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+173800,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+258940,int_stack+173800,int_stack+205150,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+280720,int_stack+258940,int_stack+216040,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+186670,int_stack+280720,int_stack+234190,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+223795,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+310970,int_stack+223795,int_stack+173800,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+336710,int_stack+310970,int_stack+258940,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+223795,int_stack+336710,int_stack+280720,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+269170,int_stack+223795,int_stack+186670,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+173800,int_stack+27170,int_stack+24200,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+182710,int_stack+30800,int_stack+27170,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+193600,int_stack+182710,int_stack+173800,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211420,int_stack+35156,int_stack+30800,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+224488,int_stack+211420,int_stack+182710,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+321145,int_stack+224488,int_stack+193600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+173800,int_stack+40304,int_stack+35156,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+173800,int_stack+211420,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+350845,int_stack+0,int_stack+224488,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+189244,int_stack+350845,int_stack+321145,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+321145,int_stack+46310,int_stack+40304,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+233794,int_stack+321145,int_stack+173800,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+387145,int_stack+233794,int_stack+0,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+430705,int_stack+387145,int_stack+350845,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+321145,int_stack+430705,int_stack+189244,66);
 /*--- compute (mp|lh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+383515,int_stack+321145,int_stack+269170,945);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+56750,int_stack+53240,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10530,int_stack+61040,int_stack+56750,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23400,int_stack+10530,int_stack+0,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44460,int_stack+66188,int_stack+61040,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+173800,int_stack+44460,int_stack+10530,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+199540,int_stack+173800,int_stack+23400,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+72272,int_stack+66188,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+234640,int_stack+0,int_stack+44460,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+18252,int_stack+234640,int_stack+173800,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+265528,int_stack+18252,int_stack+199540,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+79370,int_stack+72272,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+195094,int_stack+173800,int_stack+0,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+539440,int_stack+195094,int_stack+234640,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+173800,int_stack+539440,int_stack+18252,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+173800,int_stack+265528,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+539440,int_stack+0,int_stack+321145,945);
 /*--- compute (md|lh) ---*/
 hrr1_build_md(Libint->AB,int_stack+726550,int_stack+539440,int_stack+383515,945);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+173800,int_stack+91655,int_stack+87560,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+186085,int_stack+96660,int_stack+91655,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+201100,int_stack+186085,int_stack+173800,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+225670,int_stack+102666,int_stack+96660,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+243688,int_stack+225670,int_stack+186085,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+273718,int_stack+243688,int_stack+201100,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+173800,int_stack+109764,int_stack+102666,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+314668,int_stack+173800,int_stack+225670,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+350704,int_stack+314668,int_stack+243688,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+195094,int_stack+350704,int_stack+273718,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+256519,int_stack+118045,int_stack+109764,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+400754,int_stack+256519,int_stack+173800,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+443342,int_stack+400754,int_stack+314668,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+256519,int_stack+443342,int_stack+350704,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+331594,int_stack+256519,int_stack+195094,91);
 /*--- compute (op|lh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1038400,int_stack+331594,int_stack+0,945);
 /*--- compute (nd|lh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1259530,int_stack+1038400,int_stack+539440,945);
 /*--- compute (mf|lh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1633750,int_stack+1259530,int_stack+726550,945);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+132325,int_stack+127600,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14175,int_stack+138100,int_stack+132325,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31500,int_stack+14175,int_stack+0,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59850,int_stack+145030,int_stack+138100,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+80640,int_stack+59850,int_stack+14175,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+173800,int_stack+80640,int_stack+31500,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+153220,int_stack+145030,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+221050,int_stack+0,int_stack+59850,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+262630,int_stack+221050,int_stack+80640,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+24570,int_stack+262630,int_stack+173800,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+173800,int_stack+162775,int_stack+153220,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+95445,int_stack+173800,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+144585,int_stack+95445,int_stack+221050,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+417589,int_stack+144585,int_stack+262630,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+95445,int_stack+417589,int_stack+24570,105);
 /*--- compute (qp|lh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+417589,int_stack+95445,int_stack+331594,945);
 /*--- compute (od|lh) ---*/
 hrr1_build_od(Libint->AB,int_stack+2153500,int_stack+417589,int_stack+1038400,945);
 /*--- compute (nf|lh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+2153500,int_stack+1259530,945);
 /*--- compute (mg|lh) ---*/
 hrr1_build_mg(Libint->AB,int_stack+623700,int_stack+0,int_stack+1633750,945);
 return int_stack+623700;}
