/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mhnm(Libint_t*, prim_data*);

  /* Computes quartets of (mh|nm) integrals */

REALTYPE *hrr_order_mhnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[10][10] = int_stack + 72600;
 Libint->vrr_classes[10][11] = int_stack + 76956;
 Libint->vrr_classes[10][12] = int_stack + 82104;
 Libint->vrr_classes[10][13] = int_stack + 88110;
 Libint->vrr_classes[10][14] = int_stack + 95040;
 Libint->vrr_classes[10][15] = int_stack + 102960;
 Libint->vrr_classes[10][16] = int_stack + 111936;
 Libint->vrr_classes[10][17] = int_stack + 122034;
 Libint->vrr_classes[10][18] = int_stack + 133320;
 Libint->vrr_classes[10][19] = int_stack + 145860;
 Libint->vrr_classes[11][10] = int_stack + 159720;
 Libint->vrr_classes[11][11] = int_stack + 164868;
 Libint->vrr_classes[11][12] = int_stack + 170952;
 Libint->vrr_classes[11][13] = int_stack + 178050;
 Libint->vrr_classes[11][14] = int_stack + 186240;
 Libint->vrr_classes[11][15] = int_stack + 195600;
 Libint->vrr_classes[11][16] = int_stack + 206208;
 Libint->vrr_classes[11][17] = int_stack + 218142;
 Libint->vrr_classes[11][18] = int_stack + 231480;
 Libint->vrr_classes[11][19] = int_stack + 246300;
 Libint->vrr_classes[12][10] = int_stack + 262680;
 Libint->vrr_classes[12][11] = int_stack + 268686;
 Libint->vrr_classes[12][12] = int_stack + 275784;
 Libint->vrr_classes[12][13] = int_stack + 284065;
 Libint->vrr_classes[12][14] = int_stack + 293620;
 Libint->vrr_classes[12][15] = int_stack + 304540;
 Libint->vrr_classes[12][16] = int_stack + 316916;
 Libint->vrr_classes[12][17] = int_stack + 330839;
 Libint->vrr_classes[12][18] = int_stack + 346400;
 Libint->vrr_classes[12][19] = int_stack + 363690;
 Libint->vrr_classes[13][10] = int_stack + 382800;
 Libint->vrr_classes[13][11] = int_stack + 389730;
 Libint->vrr_classes[13][12] = int_stack + 397920;
 Libint->vrr_classes[13][13] = int_stack + 407475;
 Libint->vrr_classes[13][14] = int_stack + 418500;
 Libint->vrr_classes[13][15] = int_stack + 431100;
 Libint->vrr_classes[13][16] = int_stack + 445380;
 Libint->vrr_classes[13][17] = int_stack + 461445;
 Libint->vrr_classes[13][18] = int_stack + 479400;
 Libint->vrr_classes[13][19] = int_stack + 499350;
 Libint->vrr_classes[14][10] = int_stack + 521400;
 Libint->vrr_classes[14][11] = int_stack + 529320;
 Libint->vrr_classes[14][12] = int_stack + 538680;
 Libint->vrr_classes[14][13] = int_stack + 549600;
 Libint->vrr_classes[14][14] = int_stack + 562200;
 Libint->vrr_classes[14][15] = int_stack + 576600;
 Libint->vrr_classes[14][16] = int_stack + 592920;
 Libint->vrr_classes[14][17] = int_stack + 611280;
 Libint->vrr_classes[14][18] = int_stack + 631800;
 Libint->vrr_classes[14][19] = int_stack + 654600;
 memset(int_stack,0,679800*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 679800;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mhnm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+679800,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+690690,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+703560,int_stack+690690,int_stack+679800,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+725340,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+740355,int_stack+725340,int_stack+690690,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+766095,int_stack+740355,int_stack+703560,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+679800,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+802395,int_stack+679800,int_stack+725340,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+697125,int_stack+802395,int_stack+740355,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+832425,int_stack+697125,int_stack+766095,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+740025,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+759825,int_stack+740025,int_stack+679800,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+886875,int_stack+759825,int_stack+802395,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+936925,int_stack+886875,int_stack+697125,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1001275,int_stack+936925,int_stack+832425,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+679800,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+794475,int_stack+679800,int_stack+740025,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1077505,int_stack+794475,int_stack+759825,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+702240,int_stack+1077505,int_stack+886875,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+834075,int_stack+702240,int_stack+936925,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1135255,int_stack+834075,int_stack+1001275,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+924165,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+949410,int_stack+924165,int_stack+679800,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+994290,int_stack+949410,int_stack+794475,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1236895,int_stack+994290,int_stack+1077505,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1323520,int_stack+1236895,int_stack+702240,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+679800,int_stack+1323520,int_stack+834075,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1428625,int_stack+679800,int_stack+1135255,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+799920,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+828135,int_stack+799920,int_stack+924165,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1060290,int_stack+828135,int_stack+949410,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+878625,int_stack+1060290,int_stack+994290,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1559305,int_stack+878625,int_stack+1236895,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1135090,int_stack+1559305,int_stack+1323520,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1680580,int_stack+1135090,int_stack+679800,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1835020,int_stack+1680580,int_stack+1428625,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+679800,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+711150,int_stack+679800,int_stack+799920,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1275230,int_stack+711150,int_stack+828135,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+679800,int_stack+1275230,int_stack+1060290,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1275230,int_stack+679800,int_stack+878625,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+679800,int_stack+1275230,int_stack+1559305,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1275230,int_stack+679800,int_stack+1135090,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+679800,int_stack+1275230,int_stack+1680580,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+872850,int_stack+679800,int_stack+1835020,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+679800,int_stack+76956,int_stack+72600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+692868,int_stack+82104,int_stack+76956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+708312,int_stack+692868,int_stack+679800,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+734448,int_stack+88110,int_stack+82104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+752466,int_stack+734448,int_stack+692868,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+783354,int_stack+752466,int_stack+708312,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+679800,int_stack+95040,int_stack+88110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+826914,int_stack+679800,int_stack+734448,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+700590,int_stack+826914,int_stack+752466,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1072500,int_stack+700590,int_stack+783354,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+752070,int_stack+102960,int_stack+95040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+775830,int_stack+752070,int_stack+679800,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1137840,int_stack+775830,int_stack+826914,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1197900,int_stack+1137840,int_stack+700590,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1275120,int_stack+1197900,int_stack+1072500,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1072500,int_stack+111936,int_stack+102960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+679800,int_stack+1072500,int_stack+752070,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1366596,int_stack+679800,int_stack+775830,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+727320,int_stack+1366596,int_stack+1137840,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1435896,int_stack+727320,int_stack+1197900,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1099428,int_stack+1435896,int_stack+1275120,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1221396,int_stack+122034,int_stack+111936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1251690,int_stack+1221396,int_stack+1072500,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1544004,int_stack+1251690,int_stack+679800,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1623204,int_stack+1544004,int_stack+1366596,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1305546,int_stack+1623204,int_stack+727320,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+679800,int_stack+1305546,int_stack+1435896,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1727154,int_stack+679800,int_stack+1099428,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+823944,int_stack+133320,int_stack+122034,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1072500,int_stack+823944,int_stack+1221396,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1133088,int_stack+1072500,int_stack+1251690,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1133088,int_stack+1544004,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1431672,int_stack+0,int_stack+1623204,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1883970,int_stack+1431672,int_stack+1305546,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1222848,int_stack+1883970,int_stack+679800,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2052138,int_stack+1222848,int_stack+1727154,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+679800,int_stack+145860,int_stack+133320,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+717420,int_stack+679800,int_stack+823944,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1577202,int_stack+717420,int_stack+1072500,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+679800,int_stack+1577202,int_stack+1133088,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1577202,int_stack+679800,int_stack+0,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2248158,int_stack+1577202,int_stack+1431672,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1408176,int_stack+2248158,int_stack+1883970,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1624392,int_stack+1408176,int_stack+1222848,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1072500,int_stack+1624392,int_stack+2052138,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1312080,int_stack+1072500,int_stack+872850,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+164868,int_stack+159720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+170952,int_stack+164868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+178050,int_stack+170952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+186240,int_stack+178050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+679800,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+679800,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+722388,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+195600,int_stack+186240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+799608,int_stack+113490,int_stack+679800,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+870588,int_stack+799608,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+961848,int_stack+870588,int_stack+722388,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+679800,int_stack+206208,int_stack+195600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+711624,int_stack+679800,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+711624,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+81900,int_stack+0,int_stack+799608,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1911030,int_stack+81900,int_stack+870588,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+767784,int_stack+1911030,int_stack+961848,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+911928,int_stack+218142,int_stack+206208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+947730,int_stack+911928,int_stack+679800,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2038794,int_stack+947730,int_stack+711624,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2132394,int_stack+2038794,int_stack+0,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2255244,int_stack+2132394,int_stack+81900,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2255244,int_stack+1911030,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2404302,int_stack+0,int_stack+767784,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1911030,int_stack+231480,int_stack+218142,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1951044,int_stack+1911030,int_stack+911928,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+679800,int_stack+1951044,int_stack+947730,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+785880,int_stack+679800,int_stack+2038794,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2589630,int_stack+785880,int_stack+2132394,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2022648,int_stack+2589630,int_stack+2255244,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2761620,int_stack+2022648,int_stack+0,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2980644,int_stack+2761620,int_stack+2404302,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+246300,int_stack+231480,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44460,int_stack+0,int_stack+1911030,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+124488,int_stack+44460,int_stack+1951044,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2221392,int_stack+124488,int_stack+679800,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+2221392,int_stack+785880,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2221392,int_stack+0,int_stack+2589630,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+2221392,int_stack+2022648,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+679800,int_stack+0,int_stack+2761620,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1911030,int_stack+679800,int_stack+2980644,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2194170,int_stack+1911030,int_stack+1072500,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2912910,int_stack+2194170,int_stack+1312080,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+679800,int_stack+268686,int_stack+262680,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+697818,int_stack+275784,int_stack+268686,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+719112,int_stack+697818,int_stack+679800,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+755148,int_stack+284065,int_stack+275784,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+779991,int_stack+755148,int_stack+697818,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+822579,int_stack+779991,int_stack+719112,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+679800,int_stack+293620,int_stack+284065,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+882639,int_stack+679800,int_stack+755148,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+708465,int_stack+882639,int_stack+779991,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+932325,int_stack+708465,int_stack+822579,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+779445,int_stack+304540,int_stack+293620,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+812205,int_stack+779445,int_stack+679800,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1022415,int_stack+812205,int_stack+882639,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1105225,int_stack+1022415,int_stack+708465,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1211695,int_stack+1105225,int_stack+932325,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+679800,int_stack+316916,int_stack+304540,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+869535,int_stack+679800,int_stack+779445,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1337821,int_stack+869535,int_stack+812205,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+716928,int_stack+1337821,int_stack+1022415,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+935055,int_stack+716928,int_stack+1105225,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1433371,int_stack+935055,int_stack+1211695,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1084113,int_stack+330839,int_stack+316916,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1125882,int_stack+1084113,int_stack+679800,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1200138,int_stack+1125882,int_stack+869535,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1601539,int_stack+1200138,int_stack+1337821,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1601539,int_stack+716928,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+679800,int_stack+0,int_stack+935055,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4110810,int_stack+679800,int_stack+1433371,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+878544,int_stack+346400,int_stack+330839,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+925227,int_stack+878544,int_stack+1084113,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1309338,int_stack+925227,int_stack+1125882,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1008765,int_stack+1309338,int_stack+1200138,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4327026,int_stack+1008765,int_stack+1601539,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1433098,int_stack+4327026,int_stack+0,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1433098,int_stack+679800,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4527681,int_stack+0,int_stack+4110810,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+4110810,int_stack+363690,int_stack+346400,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4162680,int_stack+4110810,int_stack+878544,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+679800,int_stack+4162680,int_stack+925227,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4110810,int_stack+679800,int_stack+1309338,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+679800,int_stack+4110810,int_stack+1008765,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+909120,int_stack+679800,int_stack+4327026,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4110810,int_stack+909120,int_stack+1433098,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+679800,int_stack+4110810,int_stack+0,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+679800,int_stack+4527681,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+679800,int_stack+0,int_stack+1911030,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4110810,int_stack+679800,int_stack+2194170,3630);
 /*--- compute (mf|nm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5548290,int_stack+4110810,int_stack+2912910,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1529220,int_stack+389730,int_stack+382800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1550010,int_stack+397920,int_stack+389730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1574580,int_stack+1550010,int_stack+1529220,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1616160,int_stack+407475,int_stack+397920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1644825,int_stack+1616160,int_stack+1550010,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1693965,int_stack+1644825,int_stack+1574580,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1529220,int_stack+418500,int_stack+407475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1763265,int_stack+1529220,int_stack+1616160,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1562295,int_stack+1763265,int_stack+1644825,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1820595,int_stack+1562295,int_stack+1693965,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1644195,int_stack+431100,int_stack+418500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1681995,int_stack+1644195,int_stack+1529220,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1924545,int_stack+1681995,int_stack+1763265,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2020095,int_stack+1924545,int_stack+1562295,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2142945,int_stack+2020095,int_stack+1820595,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1529220,int_stack+445380,int_stack+431100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1748145,int_stack+1529220,int_stack+1644195,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2288475,int_stack+1748145,int_stack+1681995,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1572060,int_stack+2288475,int_stack+1924545,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1823745,int_stack+1572060,int_stack+2020095,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2398725,int_stack+1823745,int_stack+2142945,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1995735,int_stack+461445,int_stack+445380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2043930,int_stack+1995735,int_stack+1529220,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2129610,int_stack+2043930,int_stack+1748145,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2592765,int_stack+2129610,int_stack+2288475,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2758140,int_stack+2592765,int_stack+1572060,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1529220,int_stack+2758140,int_stack+1823745,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2958795,int_stack+1529220,int_stack+2398725,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1758540,int_stack+479400,int_stack+461445,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1812405,int_stack+1758540,int_stack+1995735,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2255610,int_stack+1812405,int_stack+2043930,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1908795,int_stack+2255610,int_stack+2129610,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3208275,int_stack+1908795,int_stack+2592765,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2398410,int_stack+3208275,int_stack+2758140,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3439800,int_stack+2398410,int_stack+1529220,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3734640,int_stack+3439800,int_stack+2958795,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1529220,int_stack+499350,int_stack+479400,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1589070,int_stack+1529220,int_stack+1758540,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2665950,int_stack+1589070,int_stack+1812405,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1529220,int_stack+2665950,int_stack+2255610,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2665950,int_stack+1529220,int_stack+1908795,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1529220,int_stack+2665950,int_stack+3208275,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2665950,int_stack+1529220,int_stack+2398410,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1529220,int_stack+2665950,int_stack+3439800,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1897770,int_stack+1529220,int_stack+3734640,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2278920,int_stack+1897770,int_stack+0,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+7544790,int_stack+2278920,int_stack+679800,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+9243630,int_stack+7544790,int_stack+4110810,3630);
 /*--- compute (mg|nm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+11639430,int_stack+9243630,int_stack+5548290,3630);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+679800,int_stack+529320,int_stack+521400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+703560,int_stack+538680,int_stack+529320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+731640,int_stack+703560,int_stack+679800,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+779160,int_stack+549600,int_stack+538680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+811920,int_stack+779160,int_stack+703560,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+868080,int_stack+811920,int_stack+731640,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+679800,int_stack+562200,int_stack+549600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+947280,int_stack+679800,int_stack+779160,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+717600,int_stack+947280,int_stack+811920,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1012800,int_stack+717600,int_stack+868080,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+811200,int_stack+576600,int_stack+562200,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+854400,int_stack+811200,int_stack+679800,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1131600,int_stack+854400,int_stack+947280,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1240800,int_stack+1131600,int_stack+717600,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1381200,int_stack+1240800,int_stack+1012800,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+679800,int_stack+592920,int_stack+576600,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+930000,int_stack+679800,int_stack+811200,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1547520,int_stack+930000,int_stack+854400,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+728760,int_stack+1547520,int_stack+1131600,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1016400,int_stack+728760,int_stack+1240800,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1673520,int_stack+1016400,int_stack+1381200,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1212960,int_stack+611280,int_stack+592920,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1268040,int_stack+1212960,int_stack+679800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1365960,int_stack+1268040,int_stack+930000,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1365960,int_stack+1547520,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+189000,int_stack+0,int_stack+728760,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+679800,int_stack+189000,int_stack+1016400,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3269910,int_stack+679800,int_stack+1673520,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+941880,int_stack+631800,int_stack+611280,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1003440,int_stack+941880,int_stack+1212960,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1509960,int_stack+1003440,int_stack+1268040,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1113600,int_stack+1509960,int_stack+1365960,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3555030,int_stack+1113600,int_stack+0,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3819630,int_stack+3555030,int_stack+189000,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+3819630,int_stack+679800,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4125390,int_stack+0,int_stack+3269910,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3269910,int_stack+654600,int_stack+631800,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3338310,int_stack+3269910,int_stack+941880,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+336960,int_stack+3338310,int_stack+1003440,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3269910,int_stack+336960,int_stack+1509960,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+336960,int_stack+3269910,int_stack+1113600,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+639360,int_stack+336960,int_stack+3555030,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3269910,int_stack+639360,int_stack+3819630,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+336960,int_stack+3269910,int_stack+0,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3269910,int_stack+336960,int_stack+4125390,120);
 /*--- compute (rp|nm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+0,int_stack+3269910,int_stack+1897770,3630);
 /*--- compute (qd|nm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3269910,int_stack+0,int_stack+2278920,3630);
 /*--- compute (of|nm) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+3269910,int_stack+7544790,3630);
 /*--- compute (ng|nm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2831400,int_stack+0,int_stack+9243630,3630);
 /*--- compute (mh|nm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+6425100,int_stack+2831400,int_stack+11639430,3630);
 return int_stack+6425100;}
