/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mkmm(Libint_t*, prim_data*);

  /* Computes quartets of (mk|mm) integrals */

REALTYPE *hrr_order_mkmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[9][18] = int_stack + 53625;
 Libint->vrr_classes[10][9] = int_stack + 64075;
 Libint->vrr_classes[10][10] = int_stack + 67705;
 Libint->vrr_classes[10][11] = int_stack + 72061;
 Libint->vrr_classes[10][12] = int_stack + 77209;
 Libint->vrr_classes[10][13] = int_stack + 83215;
 Libint->vrr_classes[10][14] = int_stack + 90145;
 Libint->vrr_classes[10][15] = int_stack + 98065;
 Libint->vrr_classes[10][16] = int_stack + 107041;
 Libint->vrr_classes[10][17] = int_stack + 117139;
 Libint->vrr_classes[10][18] = int_stack + 128425;
 Libint->vrr_classes[11][9] = int_stack + 140965;
 Libint->vrr_classes[11][10] = int_stack + 145255;
 Libint->vrr_classes[11][11] = int_stack + 150403;
 Libint->vrr_classes[11][12] = int_stack + 156487;
 Libint->vrr_classes[11][13] = int_stack + 163585;
 Libint->vrr_classes[11][14] = int_stack + 171775;
 Libint->vrr_classes[11][15] = int_stack + 181135;
 Libint->vrr_classes[11][16] = int_stack + 191743;
 Libint->vrr_classes[11][17] = int_stack + 203677;
 Libint->vrr_classes[11][18] = int_stack + 217015;
 Libint->vrr_classes[12][9] = int_stack + 231835;
 Libint->vrr_classes[12][10] = int_stack + 236840;
 Libint->vrr_classes[12][11] = int_stack + 242846;
 Libint->vrr_classes[12][12] = int_stack + 249944;
 Libint->vrr_classes[12][13] = int_stack + 258225;
 Libint->vrr_classes[12][14] = int_stack + 267780;
 Libint->vrr_classes[12][15] = int_stack + 278700;
 Libint->vrr_classes[12][16] = int_stack + 291076;
 Libint->vrr_classes[12][17] = int_stack + 304999;
 Libint->vrr_classes[12][18] = int_stack + 320560;
 Libint->vrr_classes[13][9] = int_stack + 337850;
 Libint->vrr_classes[13][10] = int_stack + 343625;
 Libint->vrr_classes[13][11] = int_stack + 350555;
 Libint->vrr_classes[13][12] = int_stack + 358745;
 Libint->vrr_classes[13][13] = int_stack + 368300;
 Libint->vrr_classes[13][14] = int_stack + 379325;
 Libint->vrr_classes[13][15] = int_stack + 391925;
 Libint->vrr_classes[13][16] = int_stack + 406205;
 Libint->vrr_classes[13][17] = int_stack + 422270;
 Libint->vrr_classes[13][18] = int_stack + 440225;
 Libint->vrr_classes[14][9] = int_stack + 460175;
 Libint->vrr_classes[14][10] = int_stack + 466775;
 Libint->vrr_classes[14][11] = int_stack + 474695;
 Libint->vrr_classes[14][12] = int_stack + 484055;
 Libint->vrr_classes[14][13] = int_stack + 494975;
 Libint->vrr_classes[14][14] = int_stack + 507575;
 Libint->vrr_classes[14][15] = int_stack + 521975;
 Libint->vrr_classes[14][16] = int_stack + 538295;
 Libint->vrr_classes[14][17] = int_stack + 556655;
 Libint->vrr_classes[14][18] = int_stack + 577175;
 Libint->vrr_classes[15][9] = int_stack + 599975;
 Libint->vrr_classes[15][10] = int_stack + 607455;
 Libint->vrr_classes[15][11] = int_stack + 616431;
 Libint->vrr_classes[15][12] = int_stack + 627039;
 Libint->vrr_classes[15][13] = int_stack + 639415;
 Libint->vrr_classes[15][14] = int_stack + 653695;
 Libint->vrr_classes[15][15] = int_stack + 670015;
 Libint->vrr_classes[15][16] = int_stack + 688511;
 Libint->vrr_classes[15][17] = int_stack + 709319;
 Libint->vrr_classes[15][18] = int_stack + 732575;
 Libint->vrr_classes[16][9] = int_stack + 758415;
 Libint->vrr_classes[16][10] = int_stack + 766830;
 Libint->vrr_classes[16][11] = int_stack + 776928;
 Libint->vrr_classes[16][12] = int_stack + 788862;
 Libint->vrr_classes[16][13] = int_stack + 802785;
 Libint->vrr_classes[16][14] = int_stack + 818850;
 Libint->vrr_classes[16][15] = int_stack + 837210;
 Libint->vrr_classes[16][16] = int_stack + 858018;
 Libint->vrr_classes[16][17] = int_stack + 881427;
 Libint->vrr_classes[16][18] = int_stack + 907590;
 memset(int_stack,0,936660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 936660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mkmm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+936660,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+945735,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+956625,int_stack+945735,int_stack+936660,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+974775,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+987645,int_stack+974775,int_stack+945735,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1009425,int_stack+987645,int_stack+956625,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+936660,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1039675,int_stack+936660,int_stack+974775,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1065415,int_stack+1039675,int_stack+987645,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+951675,int_stack+1065415,int_stack+1009425,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+997050,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1101715,int_stack+997050,int_stack+936660,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1131745,int_stack+1101715,int_stack+1039675,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1174645,int_stack+1131745,int_stack+1065415,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1014375,int_stack+1174645,int_stack+951675,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+936660,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+956460,int_stack+936660,int_stack+997050,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1229095,int_stack+956460,int_stack+1101715,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1279145,int_stack+1229095,int_stack+1131745,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1077900,int_stack+1279145,int_stack+1174645,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1343495,int_stack+1077900,int_stack+1014375,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+991110,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1013550,int_stack+991110,int_stack+936660,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1154130,int_stack+1013550,int_stack+956460,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1428195,int_stack+1154130,int_stack+1229095,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1503270,int_stack+1428195,int_stack+1279145,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1211880,int_stack+1503270,int_stack+1077900,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1593360,int_stack+1211880,int_stack+1343495,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+936660,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1053150,int_stack+936660,int_stack+991110,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1313520,int_stack+1053150,int_stack+1013550,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+961905,int_stack+1313520,int_stack+1154130,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1098030,int_stack+961905,int_stack+1428195,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1379520,int_stack+1098030,int_stack+1503270,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1702260,int_stack+1379520,int_stack+1211880,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1832940,int_stack+1702260,int_stack+1593360,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1203135,int_stack+53625,int_stack+44220,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1231350,int_stack+1203135,int_stack+936660,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1499640,int_stack+1231350,int_stack+1053150,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1203135,int_stack+1499640,int_stack+1313520,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1499640,int_stack+1203135,int_stack+961905,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1203135,int_stack+1499640,int_stack+1098030,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1499640,int_stack+1203135,int_stack+1379520,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+936660,int_stack+1499640,int_stack+1702260,55);
 /*--- compute (m0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1100010,int_stack+936660,int_stack+1832940,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+936660,int_stack+67705,int_stack+64075,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+947550,int_stack+72061,int_stack+67705,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+960618,int_stack+947550,int_stack+936660,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+982398,int_stack+77209,int_stack+72061,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+997842,int_stack+982398,int_stack+947550,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1023978,int_stack+997842,int_stack+960618,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+936660,int_stack+83215,int_stack+77209,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1060278,int_stack+936660,int_stack+982398,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1266385,int_stack+1060278,int_stack+997842,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+954678,int_stack+1266385,int_stack+1023978,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1009128,int_stack+90145,int_stack+83215,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1309945,int_stack+1009128,int_stack+936660,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1345981,int_stack+1309945,int_stack+1060278,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1029918,int_stack+1345981,int_stack+1266385,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1397461,int_stack+1029918,int_stack+954678,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1266385,int_stack+98065,int_stack+90145,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+936660,int_stack+1266385,int_stack+1009128,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1473691,int_stack+936660,int_stack+1309945,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1533751,int_stack+1473691,int_stack+1345981,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1290145,int_stack+1533751,int_stack+1029918,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+978240,int_stack+1290145,int_stack+1397461,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1381621,int_stack+107041,int_stack+98065,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1408549,int_stack+1381621,int_stack+1266385,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1610971,int_stack+1408549,int_stack+936660,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1680271,int_stack+1610971,int_stack+1473691,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1770361,int_stack+1680271,int_stack+1533751,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1456069,int_stack+1770361,int_stack+1290145,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1878469,int_stack+1456069,int_stack+978240,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+936660,int_stack+117139,int_stack+107041,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+966954,int_stack+936660,int_stack+1381621,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1020810,int_stack+966954,int_stack+1408549,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1266385,int_stack+1020810,int_stack+1610971,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2009149,int_stack+1266385,int_stack+1680271,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1578037,int_stack+2009149,int_stack+1770361,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2135275,int_stack+1578037,int_stack+1456069,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1370335,int_stack+2135275,int_stack+1878469,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1533685,int_stack+128425,int_stack+117139,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1722181,int_stack+1533685,int_stack+936660,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1782769,int_stack+1722181,int_stack+966954,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1872529,int_stack+1782769,int_stack+1020810,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1722181,int_stack+1872529,int_stack+1266385,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2292091,int_stack+1722181,int_stack+2009149,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1722181,int_stack+2292091,int_stack+1578037,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1907509,int_stack+1722181,int_stack+2135275,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2103529,int_stack+1907509,int_stack+1370335,66);
 /*--- compute (mp|mm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1266385,int_stack+2103529,int_stack+1100010,3025);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2303179,int_stack+145255,int_stack+140965,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2316049,int_stack+150403,int_stack+145255,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2331493,int_stack+2316049,int_stack+2303179,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2357233,int_stack+156487,int_stack+150403,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2375485,int_stack+2357233,int_stack+2316049,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2406373,int_stack+2375485,int_stack+2331493,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2303179,int_stack+163585,int_stack+156487,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1765510,int_stack+2303179,int_stack+2357233,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1802014,int_stack+1765510,int_stack+2375485,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2324473,int_stack+1802014,int_stack+2406373,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2388823,int_stack+171775,int_stack+163585,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2413393,int_stack+2388823,int_stack+2303179,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1853494,int_stack+2413393,int_stack+1765510,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1914334,int_stack+1853494,int_stack+1802014,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1991554,int_stack+1914334,int_stack+2324473,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1765510,int_stack+181135,int_stack+171775,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1793590,int_stack+1765510,int_stack+2388823,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2303179,int_stack+1793590,int_stack+2413393,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+936660,int_stack+2303179,int_stack+1853494,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1027920,int_stack+936660,int_stack+1914334,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1842730,int_stack+1027920,int_stack+1991554,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1962850,int_stack+191743,int_stack+181135,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1994674,int_stack+1962850,int_stack+1765510,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2374159,int_stack+1994674,int_stack+1793590,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1136028,int_stack+2374159,int_stack+2303179,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1136028,int_stack+936660,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2456059,int_stack+0,int_stack+1027920,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+936660,int_stack+2456059,int_stack+1842730,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1091100,int_stack+203677,int_stack+191743,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2303179,int_stack+1091100,int_stack+1962850,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1765510,int_stack+2303179,int_stack+1994674,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1859110,int_stack+1765510,int_stack+2374159,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2600203,int_stack+1859110,int_stack+1136028,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2749261,int_stack+2600203,int_stack+0,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2749261,int_stack+2456059,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2366827,int_stack+0,int_stack+936660,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+936660,int_stack+217015,int_stack+203677,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+976674,int_stack+936660,int_stack+1091100,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1048278,int_stack+976674,int_stack+2303179,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2919613,int_stack+1048278,int_stack+1765510,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+936660,int_stack+2919613,int_stack+1859110,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1765510,int_stack+936660,int_stack+2600203,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+936660,int_stack+1765510,int_stack+2749261,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1765510,int_stack+936660,int_stack+0,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+936660,int_stack+1765510,int_stack+2366827,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2303179,int_stack+936660,int_stack+2103529,3025);
 /*--- compute (md|mm) ---*/
 hrr1_build_md(Libint->AB,int_stack+2902129,int_stack+2303179,int_stack+1266385,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+236840,int_stack+231835,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+242846,int_stack+236840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+249944,int_stack+242846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+258225,int_stack+249944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1172610,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1172610,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+267780,int_stack+258225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1232670,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1303650,int_stack+1232670,int_stack+1172610,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1393740,int_stack+1303650,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1172610,int_stack+278700,int_stack+267780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1172610,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+1232670,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1498845,int_stack+140140,int_stack+1303650,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1205370,int_stack+1498845,int_stack+1393740,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1345510,int_stack+291076,int_stack+278700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1382638,int_stack+1345510,int_stack+1172610,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1624971,int_stack+1382638,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1720521,int_stack+1624971,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1844736,int_stack+1720521,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1844736,int_stack+1498845,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1993794,int_stack+0,int_stack+1205370,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+304999,int_stack+291076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1345510,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1172610,int_stack+209937,int_stack+1382638,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1281810,int_stack+1172610,int_stack+1624971,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1425135,int_stack+1281810,int_stack+1720521,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1599036,int_stack+1425135,int_stack+1844736,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3900379,int_stack+1599036,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4116595,int_stack+3900379,int_stack+1993794,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+320560,int_stack+304999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+46683,int_stack+0,int_stack+168168,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1797780,int_stack+46683,int_stack+209937,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1797780,int_stack+1172610,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1797780,int_stack+0,int_stack+1281810,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1797780,int_stack+1425135,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1797780,int_stack+0,int_stack+1599036,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1797780,int_stack+3900379,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1172610,int_stack+0,int_stack+4116595,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1447885,int_stack+1172610,int_stack+936660,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3900379,int_stack+1447885,int_stack+2303179,3025);
 /*--- compute (mf|mm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5098279,int_stack+3900379,int_stack+2902129,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+936660,int_stack+343625,int_stack+337850,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+953985,int_stack+350555,int_stack+343625,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+974775,int_stack+953985,int_stack+936660,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1009425,int_stack+358745,int_stack+350555,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1033995,int_stack+1009425,int_stack+953985,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+1075575,int_stack+1033995,int_stack+974775,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+936660,int_stack+368300,int_stack+358745,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+936660,int_stack+1009425,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+49140,int_stack+0,int_stack+1033995,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+965325,int_stack+49140,int_stack+1075575,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1051950,int_stack+379325,int_stack+368300,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1085025,int_stack+1051950,int_stack+936660,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+118440,int_stack+1085025,int_stack+0,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+200340,int_stack+118440,int_stack+49140,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2155735,int_stack+200340,int_stack+965325,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+391925,int_stack+379325,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+37800,int_stack+0,int_stack+1051950,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+936660,int_stack+37800,int_stack+1085025,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1032210,int_stack+936660,int_stack+118440,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2277010,int_stack+1032210,int_stack+200340,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+103950,int_stack+2277010,int_stack+2155735,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2155735,int_stack+406205,int_stack+391925,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2198575,int_stack+2155735,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+265650,int_stack+2198575,int_stack+37800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2422540,int_stack+265650,int_stack+936660,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2565865,int_stack+2422540,int_stack+1032210,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+936660,int_stack+2565865,int_stack+2277010,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2737855,int_stack+936660,int_stack+103950,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+422270,int_stack+406205,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+48195,int_stack+0,int_stack+2155735,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+133875,int_stack+48195,int_stack+2198575,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2155735,int_stack+133875,int_stack+265650,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2945755,int_stack+2155735,int_stack+2422540,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2321110,int_stack+2945755,int_stack+2565865,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3146410,int_stack+2321110,int_stack+936660,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3395890,int_stack+3146410,int_stack+2737855,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+936660,int_stack+440225,int_stack+422270,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+990525,int_stack+936660,int_stack+0,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2550430,int_stack+990525,int_stack+48195,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+936660,int_stack+2550430,int_stack+133875,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2550430,int_stack+936660,int_stack+2155735,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2550430,int_stack+2945755,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2550430,int_stack+0,int_stack+2321110,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2550430,int_stack+3146410,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+2155735,int_stack+0,int_stack+3395890,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2473360,int_stack+2155735,int_stack+1172610,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+6762029,int_stack+2473360,int_stack+1447885,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8177729,int_stack+6762029,int_stack+3900379,3025);
 /*--- compute (mg|mm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+10174229,int_stack+8177729,int_stack+5098279,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+466775,int_stack+460175,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+474695,int_stack+466775,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+484055,int_stack+474695,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+494975,int_stack+484055,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+507575,int_stack+494975,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+360120,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3299185,int_stack+360120,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3392785,int_stack+3299185,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+3392785,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+521975,int_stack+507575,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3511585,int_stack+43200,int_stack+360120,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308160,int_stack+3511585,int_stack+3299185,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3620785,int_stack+308160,int_stack+3392785,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3299185,int_stack+3620785,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+538295,int_stack+521975,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3787105,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+3913105,int_stack+3787105,int_stack+3511585,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+4076905,int_stack+3913105,int_stack+308160,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254160,int_stack+4076905,int_stack+3620785,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3483985,int_stack+254160,int_stack+3299185,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3299185,int_stack+556655,int_stack+538295,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3354265,int_stack+3299185,int_stack+118800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+3354265,int_stack+167760,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4273465,int_stack+0,int_stack+3787105,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4462465,int_stack+4273465,int_stack+3913105,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3721585,int_stack+4462465,int_stack+4076905,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3983665,int_stack+3721585,int_stack+254160,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+144000,int_stack+3983665,int_stack+3483985,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+3452185,int_stack+577175,int_stack+556655,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3513745,int_stack+3452185,int_stack+3299185,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4691785,int_stack+3513745,int_stack+3354265,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3299185,int_stack+4691785,int_stack+0,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4691785,int_stack+3299185,int_stack+4273465,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3299185,int_stack+4691785,int_stack+4462465,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4268785,int_stack+3299185,int_stack+3721585,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3299185,int_stack+4268785,int_stack+3983665,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+3655585,int_stack+3299185,int_stack+144000,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+4018585,int_stack+3655585,int_stack+2155735,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+4971460,int_stack+4018585,int_stack+2473360,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+936660,int_stack+4971460,int_stack+6762029,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+12669854,int_stack+936660,int_stack+8177729,3025);
 /*--- compute (mh|mm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+6623110,int_stack+12669854,int_stack+10174229,3025);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10116985,int_stack+607455,int_stack+599975,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10139425,int_stack+616431,int_stack+607455,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10166353,int_stack+10139425,int_stack+10116985,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10211233,int_stack+627039,int_stack+616431,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+10243057,int_stack+10211233,int_stack+10139425,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+10296913,int_stack+10243057,int_stack+10166353,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+10116985,int_stack+639415,int_stack+627039,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+10371713,int_stack+10116985,int_stack+10211233,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10435361,int_stack+10371713,int_stack+10243057,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+10154113,int_stack+10435361,int_stack+10296913,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+10266313,int_stack+653695,int_stack+639415,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10525121,int_stack+10266313,int_stack+10116985,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+10599377,int_stack+10525121,int_stack+10371713,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+10705457,int_stack+10599377,int_stack+10435361,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+10309153,int_stack+10705457,int_stack+10154113,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+10116985,int_stack+670015,int_stack+653695,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10165945,int_stack+10116985,int_stack+10266313,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+10840097,int_stack+10165945,int_stack+10525121,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+10963857,int_stack+10840097,int_stack+10599377,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+10466233,int_stack+10963857,int_stack+10705457,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+11122977,int_stack+10466233,int_stack+10309153,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+10251625,int_stack+688511,int_stack+670015,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+10307113,int_stack+10251625,int_stack+10116985,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+10654729,int_stack+10307113,int_stack+10165945,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+11332417,int_stack+10654729,int_stack+10840097,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+11518057,int_stack+11332417,int_stack+10963857,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+10797529,int_stack+11518057,int_stack+10466233,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+11740825,int_stack+10797529,int_stack+11122977,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+10116985,int_stack+709319,int_stack+688511,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+10405033,int_stack+10116985,int_stack+10251625,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+11048857,int_stack+10405033,int_stack+10307113,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+10179409,int_stack+11048857,int_stack+10654729,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+10516009,int_stack+10179409,int_stack+11332417,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+11212057,int_stack+10516009,int_stack+11518057,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+12010105,int_stack+11212057,int_stack+10797529,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+12333241,int_stack+12010105,int_stack+11740825,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+10775905,int_stack+732575,int_stack+709319,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+10845673,int_stack+10775905,int_stack+10116985,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+11509081,int_stack+10845673,int_stack+10405033,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+10775905,int_stack+11509081,int_stack+11048857,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+11509081,int_stack+10775905,int_stack+10179409,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+10775905,int_stack+11509081,int_stack+10516009,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+11509081,int_stack+10775905,int_stack+11212057,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10116985,int_stack+11509081,int_stack+12010105,136);
 /*--- compute (u0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+10520905,int_stack+10116985,int_stack+12333241,136);
 /*--- compute (tp|mm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+10932305,int_stack+10520905,int_stack+3655585,3025);
 /*--- compute (rd|mm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+15664604,int_stack+10932305,int_stack+4018585,3025);
 /*--- compute (qf|mm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+17570354,int_stack+15664604,int_stack+4971460,3025);
 /*--- compute (og|mm) ---*/
 hrr1_build_og(Libint->AB,int_stack+20323104,int_stack+17570354,int_stack+936660,3025);
 /*--- compute (nh|mm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+936660,int_stack+20323104,int_stack+12669854,3025);
 /*--- compute (mi|mm) ---*/
 hrr1_build_mi(Libint->AB,int_stack+23862354,int_stack+936660,int_stack+6623110,3025);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5129310,int_stack+766830,int_stack+758415,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5154555,int_stack+776928,int_stack+766830,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5184849,int_stack+5154555,int_stack+5129310,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5235339,int_stack+788862,int_stack+776928,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5271141,int_stack+5235339,int_stack+5154555,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5331729,int_stack+5271141,int_stack+5184849,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5129310,int_stack+802785,int_stack+788862,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5415879,int_stack+5129310,int_stack+5235339,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5487483,int_stack+5415879,int_stack+5271141,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5171079,int_stack+5487483,int_stack+5331729,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5297304,int_stack+818850,int_stack+802785,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5588463,int_stack+5297304,int_stack+5129310,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5672001,int_stack+5588463,int_stack+5415879,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+5791341,int_stack+5672001,int_stack+5487483,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+5345499,int_stack+5791341,int_stack+5171079,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5129310,int_stack+837210,int_stack+818850,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5184390,int_stack+5129310,int_stack+5297304,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+5942811,int_stack+5184390,int_stack+5588463,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6082041,int_stack+5942811,int_stack+5672001,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5522214,int_stack+6082041,int_stack+5791341,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+6261051,int_stack+5522214,int_stack+5345499,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5280780,int_stack+858018,int_stack+837210,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5343204,int_stack+5280780,int_stack+5129310,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5734272,int_stack+5343204,int_stack+5184390,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6496671,int_stack+5734272,int_stack+5942811,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+6705516,int_stack+6496671,int_stack+6082041,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5894922,int_stack+6705516,int_stack+5522214,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+6956130,int_stack+5894922,int_stack+6261051,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+5129310,int_stack+881427,int_stack+858018,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+5453364,int_stack+5129310,int_stack+5280780,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+6177666,int_stack+5453364,int_stack+5343204,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5199537,int_stack+6177666,int_stack+5734272,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5578212,int_stack+5199537,int_stack+6496671,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6361266,int_stack+5578212,int_stack+6705516,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+7259070,int_stack+6361266,int_stack+5894922,153);
 /*--- compute (v0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+7622598,int_stack+7259070,int_stack+6956130,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+5870595,int_stack+907590,int_stack+881427,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+5949084,int_stack+5870595,int_stack+5129310,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+6695418,int_stack+5949084,int_stack+5453364,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5870595,int_stack+6695418,int_stack+6177666,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+6695418,int_stack+5870595,int_stack+5199537,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5870595,int_stack+6695418,int_stack+5578212,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+6695418,int_stack+5870595,int_stack+6361266,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5129310,int_stack+6695418,int_stack+7259070,153);
 /*--- compute (v0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+5583720,int_stack+5129310,int_stack+7622598,153);
 /*--- compute (up|mm) ---*/
 hrr1_build_up(Libint->AB,int_stack+6046545,int_stack+5583720,int_stack+10520905,3025);
 /*--- compute (td|mm) ---*/
 hrr1_build_td(Libint->AB,int_stack+7280745,int_stack+6046545,int_stack+10932305,3025);
 /*--- compute (rf|mm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+9458745,int_stack+7280745,int_stack+15664604,3025);
 /*--- compute (qg|mm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+5129310,int_stack+9458745,int_stack+17570354,3025);
 /*--- compute (oh|mm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+9258435,int_stack+5129310,int_stack+20323104,3025);
 /*--- compute (ni|mm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+14213385,int_stack+9258435,int_stack+936660,3025);
 /*--- compute (mk|mm) ---*/
 hrr1_build_mk(Libint->AB,int_stack+0,int_stack+14213385,int_stack+23862354,3025);
 return int_stack+0;}
