/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpig(Libint_t*, prim_data*);

  /* Computes quartets of (mp|ig) integrals */

REALTYPE *hrr_order_mpig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][6] = int_stack + 0;
 Libint->vrr_classes[9][7] = int_stack + 1540;
 Libint->vrr_classes[9][8] = int_stack + 3520;
 Libint->vrr_classes[9][9] = int_stack + 5995;
 Libint->vrr_classes[9][10] = int_stack + 9020;
 Libint->vrr_classes[10][6] = int_stack + 12650;
 Libint->vrr_classes[10][7] = int_stack + 14498;
 Libint->vrr_classes[10][8] = int_stack + 16874;
 Libint->vrr_classes[10][9] = int_stack + 19844;
 Libint->vrr_classes[10][10] = int_stack + 23474;
 memset(int_stack,0,27830*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27830;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpig(Libint, Data);
   Data++;
 }
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+27830,int_stack+1540,int_stack+0,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+32450,int_stack+3520,int_stack+1540,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+38390,int_stack+32450,int_stack+27830,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+47630,int_stack+5995,int_stack+3520,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55055,int_stack+47630,int_stack+32450,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+66935,int_stack+55055,int_stack+38390,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27830,int_stack+9020,int_stack+5995,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82335,int_stack+27830,int_stack+47630,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+27830,int_stack+82335,int_stack+55055,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+82335,int_stack+27830,int_stack+66935,55);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+27830,int_stack+14498,int_stack+12650,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+33374,int_stack+16874,int_stack+14498,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+40502,int_stack+33374,int_stack+27830,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+51590,int_stack+19844,int_stack+16874,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+60500,int_stack+51590,int_stack+33374,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+60500,int_stack+40502,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+27830,int_stack+23474,int_stack+19844,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+105435,int_stack+27830,int_stack+51590,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+18480,int_stack+105435,int_stack+60500,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+42240,int_stack+18480,int_stack+0,66);
 /*--- compute (mp|ig) ---*/
 hrr1_build_mp(Libint->AB,int_stack+105435,int_stack+42240,int_stack+82335,420);
 return int_stack+105435;}
