/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mplk(Libint_t*, prim_data*);

  /* Computes quartets of (mp|lk) integrals */

REALTYPE *hrr_order_mplk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[10][8] = int_stack + 38280;
 Libint->vrr_classes[10][9] = int_stack + 41250;
 Libint->vrr_classes[10][10] = int_stack + 44880;
 Libint->vrr_classes[10][11] = int_stack + 49236;
 Libint->vrr_classes[10][12] = int_stack + 54384;
 Libint->vrr_classes[10][13] = int_stack + 60390;
 Libint->vrr_classes[10][14] = int_stack + 67320;
 Libint->vrr_classes[10][15] = int_stack + 75240;
 memset(int_stack,0,84216*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 84216;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mplk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84216,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91641,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+100716,int_stack+91641,int_stack+84216,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+115566,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+126456,int_stack+115566,int_stack+91641,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+144606,int_stack+126456,int_stack+100716,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84216,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+169356,int_stack+84216,int_stack+115566,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+191136,int_stack+169356,int_stack+126456,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+97086,int_stack+191136,int_stack+144606,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+134211,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+221386,int_stack+134211,int_stack+84216,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+247126,int_stack+221386,int_stack+169356,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+283426,int_stack+247126,int_stack+191136,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+149226,int_stack+283426,int_stack+97086,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84216,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+101541,int_stack+84216,int_stack+134211,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+328801,int_stack+101541,int_stack+221386,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+371701,int_stack+328801,int_stack+247126,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+201201,int_stack+371701,int_stack+283426,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+426151,int_stack+201201,int_stack+149226,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131571,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+151371,int_stack+131571,int_stack+84216,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+264726,int_stack+151371,int_stack+101541,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+84216,int_stack+264726,int_stack+328801,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+264726,int_stack+84216,int_stack+371701,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+84216,int_stack+264726,int_stack+201201,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+168916,int_stack+84216,int_stack+426151,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+84216,int_stack+41250,int_stack+38280,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93126,int_stack+44880,int_stack+41250,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+104016,int_stack+93126,int_stack+84216,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+121836,int_stack+49236,int_stack+44880,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+134904,int_stack+121836,int_stack+93126,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+258016,int_stack+134904,int_stack+104016,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+84216,int_stack+54384,int_stack+49236,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+287716,int_stack+84216,int_stack+121836,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+313852,int_stack+287716,int_stack+134904,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+99660,int_stack+313852,int_stack+258016,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+258016,int_stack+60390,int_stack+54384,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+350152,int_stack+258016,int_stack+84216,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+381040,int_stack+350152,int_stack+287716,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+424600,int_stack+381040,int_stack+313852,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+276034,int_stack+424600,int_stack+99660,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84216,int_stack+67320,int_stack+60390,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+105006,int_stack+84216,int_stack+258016,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+105006,int_stack+350152,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+479050,int_stack+0,int_stack+381040,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+338404,int_stack+479050,int_stack+424600,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+544390,int_stack+338404,int_stack+276034,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+258016,int_stack+75240,int_stack+67320,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+281776,int_stack+258016,int_stack+84216,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+414634,int_stack+281776,int_stack+105006,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+258016,int_stack+414634,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+258016,int_stack+479050,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+414634,int_stack+0,int_stack+338404,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+0,int_stack+414634,int_stack+544390,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+258016,int_stack+0,int_stack+168916,1620);
 return int_stack+258016;}
