/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ndmi(Libint_t*, prim_data*);

  /* Computes quartets of (nd|mi) integrals */

REALTYPE *hrr_order_ndmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[11][9] = int_stack + 42966;
 Libint->vrr_classes[11][10] = int_stack + 47256;
 Libint->vrr_classes[11][11] = int_stack + 52404;
 Libint->vrr_classes[11][12] = int_stack + 58488;
 Libint->vrr_classes[11][13] = int_stack + 65586;
 Libint->vrr_classes[11][14] = int_stack + 73776;
 Libint->vrr_classes[11][15] = int_stack + 83136;
 Libint->vrr_classes[12][9] = int_stack + 93744;
 Libint->vrr_classes[12][10] = int_stack + 98749;
 Libint->vrr_classes[12][11] = int_stack + 104755;
 Libint->vrr_classes[12][12] = int_stack + 111853;
 Libint->vrr_classes[12][13] = int_stack + 120134;
 Libint->vrr_classes[12][14] = int_stack + 129689;
 Libint->vrr_classes[12][15] = int_stack + 140609;
 memset(int_stack,0,152985*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 152985;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ndmi(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+152985,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+163875,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+176943,int_stack+163875,int_stack+152985,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+198723,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+214167,int_stack+198723,int_stack+163875,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+240303,int_stack+214167,int_stack+176943,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+152985,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+276603,int_stack+152985,int_stack+198723,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+307491,int_stack+276603,int_stack+214167,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+171003,int_stack+307491,int_stack+240303,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+225453,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+351051,int_stack+225453,int_stack+152985,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+387087,int_stack+351051,int_stack+276603,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+438567,int_stack+387087,int_stack+307491,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+246243,int_stack+438567,int_stack+171003,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+152985,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+176745,int_stack+152985,int_stack+225453,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+503907,int_stack+176745,int_stack+351051,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+152985,int_stack+503907,int_stack+387087,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+322473,int_stack+152985,int_stack+438567,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+413949,int_stack+322473,int_stack+246243,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+152985,int_stack+47256,int_stack+42966,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+165855,int_stack+52404,int_stack+47256,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+181299,int_stack+165855,int_stack+152985,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+207039,int_stack+58488,int_stack+52404,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+225291,int_stack+207039,int_stack+165855,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+256179,int_stack+225291,int_stack+181299,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+152985,int_stack+65586,int_stack+58488,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+299079,int_stack+152985,int_stack+207039,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+335583,int_stack+299079,int_stack+225291,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+174279,int_stack+335583,int_stack+256179,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+238629,int_stack+73776,int_stack+65586,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+515589,int_stack+238629,int_stack+152985,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+515589,int_stack+299079,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+558177,int_stack+0,int_stack+335583,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+263199,int_stack+558177,int_stack+174279,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+152985,int_stack+83136,int_stack+73776,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+181065,int_stack+152985,int_stack+238629,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+635397,int_stack+181065,int_stack+515589,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+152985,int_stack+635397,int_stack+0,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+635397,int_stack+152985,int_stack+558177,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+743505,int_stack+635397,int_stack+263199,78);
 /*--- compute (np|mi) ---*/
 hrr1_build_np(Libint->AB,int_stack+863625,int_stack+743505,int_stack+413949,1540);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+152985,int_stack+98749,int_stack+93744,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+168000,int_stack+104755,int_stack+98749,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+186018,int_stack+168000,int_stack+152985,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+216048,int_stack+111853,int_stack+104755,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+237342,int_stack+216048,int_stack+168000,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+273378,int_stack+237342,int_stack+186018,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+152985,int_stack+120134,int_stack+111853,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+323428,int_stack+152985,int_stack+216048,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+366016,int_stack+323428,int_stack+237342,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+177828,int_stack+366016,int_stack+273378,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+252903,int_stack+129689,int_stack+120134,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+426076,int_stack+252903,int_stack+152985,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+475762,int_stack+426076,int_stack+323428,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+546742,int_stack+475762,int_stack+366016,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+281568,int_stack+546742,int_stack+177828,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+152985,int_stack+140609,int_stack+129689,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+185745,int_stack+152985,int_stack+252903,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+636832,int_stack+185745,int_stack+426076,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+636832,int_stack+475762,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+386673,int_stack+0,int_stack+546742,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+386673,int_stack+281568,91);
 /*--- compute (op|mi) ---*/
 hrr1_build_op(Libint->AB,int_stack+140140,int_stack+0,int_stack+743505,1540);
 /*--- compute (nd|mi) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1168545,int_stack+140140,int_stack+863625,1540);
 return int_stack+1168545;}
