/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nfki(Libint_t*, prim_data*);

  /* Computes quartets of (nf|ki) integrals */

REALTYPE *hrr_order_nfki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][7] = int_stack + 0;
 Libint->vrr_classes[10][8] = int_stack + 2376;
 Libint->vrr_classes[10][9] = int_stack + 5346;
 Libint->vrr_classes[10][10] = int_stack + 8976;
 Libint->vrr_classes[10][11] = int_stack + 13332;
 Libint->vrr_classes[10][12] = int_stack + 18480;
 Libint->vrr_classes[10][13] = int_stack + 24486;
 Libint->vrr_classes[11][7] = int_stack + 31416;
 Libint->vrr_classes[11][8] = int_stack + 34224;
 Libint->vrr_classes[11][9] = int_stack + 37734;
 Libint->vrr_classes[11][10] = int_stack + 42024;
 Libint->vrr_classes[11][11] = int_stack + 47172;
 Libint->vrr_classes[11][12] = int_stack + 53256;
 Libint->vrr_classes[11][13] = int_stack + 60354;
 Libint->vrr_classes[12][7] = int_stack + 68544;
 Libint->vrr_classes[12][8] = int_stack + 71820;
 Libint->vrr_classes[12][9] = int_stack + 75915;
 Libint->vrr_classes[12][10] = int_stack + 80920;
 Libint->vrr_classes[12][11] = int_stack + 86926;
 Libint->vrr_classes[12][12] = int_stack + 94024;
 Libint->vrr_classes[12][13] = int_stack + 102305;
 Libint->vrr_classes[13][7] = int_stack + 111860;
 Libint->vrr_classes[13][8] = int_stack + 115640;
 Libint->vrr_classes[13][9] = int_stack + 120365;
 Libint->vrr_classes[13][10] = int_stack + 126140;
 Libint->vrr_classes[13][11] = int_stack + 133070;
 Libint->vrr_classes[13][12] = int_stack + 141260;
 Libint->vrr_classes[13][13] = int_stack + 150815;
 memset(int_stack,0,161840*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 161840;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nfki(Libint, Data);
   Data++;
 }
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+161840,int_stack+2376,int_stack+0,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+168968,int_stack+5346,int_stack+2376,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+177878,int_stack+168968,int_stack+161840,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+192134,int_stack+8976,int_stack+5346,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+203024,int_stack+192134,int_stack+168968,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+220844,int_stack+203024,int_stack+177878,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+13332,int_stack+8976,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+244604,int_stack+161840,int_stack+192134,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+266384,int_stack+244604,int_stack+203024,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+174908,int_stack+266384,int_stack+220844,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+210548,int_stack+18480,int_stack+13332,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+296084,int_stack+210548,int_stack+161840,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+322220,int_stack+296084,int_stack+244604,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+358520,int_stack+322220,int_stack+266384,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+225992,int_stack+358520,int_stack+174908,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+161840,int_stack+24486,int_stack+18480,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+161840,int_stack+210548,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+161840,int_stack+0,int_stack+296084,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+403070,int_stack+161840,int_stack+322220,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+161840,int_stack+403070,int_stack+358520,66);
 /*--- compute (n0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+275888,int_stack+161840,int_stack+225992,66);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+161840,int_stack+34224,int_stack+31416,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+170264,int_stack+37734,int_stack+34224,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+180794,int_stack+170264,int_stack+161840,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+197642,int_stack+42024,int_stack+37734,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+210512,int_stack+197642,int_stack+170264,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+231572,int_stack+210512,int_stack+180794,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+47172,int_stack+42024,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+161840,int_stack+197642,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+342416,int_stack+0,int_stack+210512,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+177284,int_stack+342416,int_stack+231572,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+219404,int_stack+53256,int_stack+47172,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+237656,int_stack+219404,int_stack+161840,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+377516,int_stack+237656,int_stack+0,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+377516,int_stack+342416,78);
 /*--- compute (o0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+420416,int_stack+0,int_stack+177284,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+342416,int_stack+60354,int_stack+53256,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+161840,int_stack+342416,int_stack+219404,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+479384,int_stack+161840,int_stack+237656,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+161840,int_stack+479384,int_stack+377516,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+342416,int_stack+161840,int_stack+0,78);
 /*--- compute (o0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+161840,int_stack+342416,int_stack+420416,78);
 /*--- compute (np|ki) ---*/
 hrr1_build_np(Libint->AB,int_stack+342416,int_stack+161840,int_stack+275888,1008);
 /*--- compute (q0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+71820,int_stack+68544,91);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9828,int_stack+75915,int_stack+71820,91);
 /*--- compute (q0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+22113,int_stack+9828,int_stack+0,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+41769,int_stack+80920,int_stack+75915,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+240464,int_stack+41769,int_stack+9828,91);
 /*--- compute (q0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+265034,int_stack+240464,int_stack+22113,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+86926,int_stack+80920,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+56784,int_stack+0,int_stack+41769,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+297794,int_stack+56784,int_stack+240464,91);
 /*--- compute (q0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+542000,int_stack+297794,int_stack+265034,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+240464,int_stack+94024,int_stack+86926,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+261758,int_stack+240464,int_stack+0,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+261758,int_stack+56784,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+591140,int_stack+0,int_stack+297794,91);
 /*--- compute (q0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+652565,int_stack+591140,int_stack+542000,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+542000,int_stack+102305,int_stack+94024,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+297794,int_stack+542000,int_stack+240464,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+50050,int_stack+297794,int_stack+261758,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+240464,int_stack+50050,int_stack+0,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+240464,int_stack+591140,91);
 /*--- compute (q0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+240464,int_stack+0,int_stack+652565,91);
 /*--- compute (op|ki) ---*/
 hrr1_build_op(Libint->AB,int_stack+542000,int_stack+240464,int_stack+161840,1008);
 /*--- compute (nd|ki) ---*/
 hrr1_build_nd(Libint->AB,int_stack+777872,int_stack+542000,int_stack+342416,1008);
 /*--- compute (r0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+161840,int_stack+115640,int_stack+111860,105);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+173180,int_stack+120365,int_stack+115640,105);
 /*--- compute (r0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+187355,int_stack+173180,int_stack+161840,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+210035,int_stack+126140,int_stack+120365,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+210035,int_stack+173180,105);
 /*--- compute (r0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+28350,int_stack+0,int_stack+187355,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+161840,int_stack+133070,int_stack+126140,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+66150,int_stack+161840,int_stack+210035,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+182630,int_stack+66150,int_stack+0,105);
 /*--- compute (r0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+332192,int_stack+182630,int_stack+28350,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+141260,int_stack+133070,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24570,int_stack+0,int_stack+161840,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+388892,int_stack+24570,int_stack+66150,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+66150,int_stack+388892,int_stack+182630,105);
 /*--- compute (r0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+446642,int_stack+66150,int_stack+332192,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+332192,int_stack+150815,int_stack+141260,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+137025,int_stack+332192,int_stack+0,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1177040,int_stack+137025,int_stack+24570,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+137025,int_stack+1177040,int_stack+388892,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+332192,int_stack+137025,int_stack+66150,105);
 /*--- compute (r0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+332192,int_stack+446642,105);
 /*--- compute (qp|ki) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1177040,int_stack+0,int_stack+240464,1008);
 /*--- compute (od|ki) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+1177040,int_stack+542000,1008);
 /*--- compute (nf|ki) ---*/
 hrr1_build_nf(Libint->AB,int_stack+1177040,int_stack+0,int_stack+777872,1008);
 return int_stack+1177040;}
