/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngnk(Libint_t*, prim_data*);

  /* Computes quartets of (ng|nk) integrals */

REALTYPE *hrr_order_ngnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[11][10] = int_stack + 60720;
 Libint->vrr_classes[11][11] = int_stack + 65868;
 Libint->vrr_classes[11][12] = int_stack + 71952;
 Libint->vrr_classes[11][13] = int_stack + 79050;
 Libint->vrr_classes[11][14] = int_stack + 87240;
 Libint->vrr_classes[11][15] = int_stack + 96600;
 Libint->vrr_classes[11][16] = int_stack + 107208;
 Libint->vrr_classes[11][17] = int_stack + 119142;
 Libint->vrr_classes[12][10] = int_stack + 132480;
 Libint->vrr_classes[12][11] = int_stack + 138486;
 Libint->vrr_classes[12][12] = int_stack + 145584;
 Libint->vrr_classes[12][13] = int_stack + 153865;
 Libint->vrr_classes[12][14] = int_stack + 163420;
 Libint->vrr_classes[12][15] = int_stack + 174340;
 Libint->vrr_classes[12][16] = int_stack + 186716;
 Libint->vrr_classes[12][17] = int_stack + 200639;
 Libint->vrr_classes[13][10] = int_stack + 216200;
 Libint->vrr_classes[13][11] = int_stack + 223130;
 Libint->vrr_classes[13][12] = int_stack + 231320;
 Libint->vrr_classes[13][13] = int_stack + 240875;
 Libint->vrr_classes[13][14] = int_stack + 251900;
 Libint->vrr_classes[13][15] = int_stack + 264500;
 Libint->vrr_classes[13][16] = int_stack + 278780;
 Libint->vrr_classes[13][17] = int_stack + 294845;
 Libint->vrr_classes[14][10] = int_stack + 312800;
 Libint->vrr_classes[14][11] = int_stack + 320720;
 Libint->vrr_classes[14][12] = int_stack + 330080;
 Libint->vrr_classes[14][13] = int_stack + 341000;
 Libint->vrr_classes[14][14] = int_stack + 353600;
 Libint->vrr_classes[14][15] = int_stack + 368000;
 Libint->vrr_classes[14][16] = int_stack + 384320;
 Libint->vrr_classes[14][17] = int_stack + 402680;
 memset(int_stack,0,423200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 423200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngnk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+423200,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+436268,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+451712,int_stack+436268,int_stack+423200,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+477848,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+495866,int_stack+477848,int_stack+436268,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+526754,int_stack+495866,int_stack+451712,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+423200,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+570314,int_stack+423200,int_stack+477848,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+443990,int_stack+570314,int_stack+495866,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+606350,int_stack+443990,int_stack+526754,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+495470,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+519230,int_stack+495470,int_stack+423200,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+671690,int_stack+519230,int_stack+570314,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+731750,int_stack+671690,int_stack+443990,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+808970,int_stack+731750,int_stack+606350,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+423200,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+560810,int_stack+423200,int_stack+495470,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+900446,int_stack+560810,int_stack+519230,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+450128,int_stack+900446,int_stack+671690,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+608330,int_stack+450128,int_stack+731750,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+969746,int_stack+608330,int_stack+808970,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+716438,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+746732,int_stack+716438,int_stack+423200,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+800588,int_stack+746732,int_stack+560810,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1091714,int_stack+800588,int_stack+900446,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+716438,int_stack+1091714,int_stack+450128,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+423200,int_stack+716438,int_stack+608330,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+567344,int_stack+423200,int_stack+969746,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+423200,int_stack+65868,int_stack+60720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+438644,int_stack+71952,int_stack+65868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+456896,int_stack+438644,int_stack+423200,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+487784,int_stack+79050,int_stack+71952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+509078,int_stack+487784,int_stack+438644,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+724160,int_stack+509078,int_stack+456896,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+423200,int_stack+87240,int_stack+79050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+775640,int_stack+423200,int_stack+487784,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+447770,int_stack+775640,int_stack+509078,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+818228,int_stack+447770,int_stack+724160,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+724160,int_stack+96600,int_stack+87240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+508610,int_stack+724160,int_stack+423200,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+895448,int_stack+508610,int_stack+775640,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+966428,int_stack+895448,int_stack+447770,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1057688,int_stack+966428,int_stack+818228,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+423200,int_stack+107208,int_stack+96600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+752240,int_stack+423200,int_stack+724160,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+808400,int_stack+752240,int_stack+508610,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+455024,int_stack+808400,int_stack+895448,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1165796,int_stack+455024,int_stack+966428,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+890300,int_stack+1165796,int_stack+1057688,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1034444,int_stack+119142,int_stack+107208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1070246,int_stack+1034444,int_stack+423200,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1070246,int_stack+752240,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1034444,int_stack+0,int_stack+808400,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+724160,int_stack+1034444,int_stack+455024,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1293560,int_stack+724160,int_stack+1165796,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1034444,int_stack+1293560,int_stack+890300,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1219772,int_stack+1034444,int_stack+567344,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+138486,int_stack+132480,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+145584,int_stack+138486,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+153865,int_stack+145584,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+423200,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+163420,int_stack+153865,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+483260,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+483260,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+532946,int_stack+28665,int_stack+423200,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+423200,int_stack+174340,int_stack+163420,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+99645,int_stack+423200,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+623036,int_stack+99645,int_stack+483260,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+705846,int_stack+623036,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+812316,int_stack+705846,int_stack+532946,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+186716,int_stack+174340,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+455960,int_stack+0,int_stack+423200,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+521480,int_stack+455960,int_stack+99645,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+37128,int_stack+521480,int_stack+623036,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1690220,int_stack+37128,int_stack+705846,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+617030,int_stack+1690220,int_stack+812316,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+785198,int_stack+200639,int_stack+186716,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+826967,int_stack+785198,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+901223,int_stack+826967,int_stack+455960,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1839278,int_stack+901223,int_stack+521480,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+785198,int_stack+1839278,int_stack+37128,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+785198,int_stack+1690220,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1690220,int_stack+0,int_stack+617030,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+423200,int_stack+1690220,int_stack+1034444,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1906436,int_stack+423200,int_stack+1219772,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+223130,int_stack+216200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+231320,int_stack+223130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+240875,int_stack+231320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+251900,int_stack+240875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+979184,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+979184,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1036514,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+264500,int_stack+251900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1140464,int_stack+152775,int_stack+979184,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1236014,int_stack+1140464,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1358864,int_stack+1236014,int_stack+1036514,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+979184,int_stack+278780,int_stack+264500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1022024,int_stack+979184,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1022024,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110250,int_stack+0,int_stack+1140464,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1504394,int_stack+110250,int_stack+1236014,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1097624,int_stack+1504394,int_stack+1358864,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1291664,int_stack+294845,int_stack+278780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1339859,int_stack+1291664,int_stack+979184,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2847332,int_stack+1339859,int_stack+1022024,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1291664,int_stack+2847332,int_stack+0,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2847332,int_stack+1291664,int_stack+110250,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2847332,int_stack+1504394,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1291664,int_stack+0,int_stack+1097624,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2847332,int_stack+1291664,int_stack+1690220,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+3495980,int_stack+2847332,int_stack+423200,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+4607948,int_stack+3495980,int_stack+1906436,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+423200,int_stack+320720,int_stack+312800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+446960,int_stack+330080,int_stack+320720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+475040,int_stack+446960,int_stack+423200,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+522560,int_stack+341000,int_stack+330080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+555320,int_stack+522560,int_stack+446960,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+611480,int_stack+555320,int_stack+475040,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+423200,int_stack+353600,int_stack+341000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+690680,int_stack+423200,int_stack+522560,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+461000,int_stack+690680,int_stack+555320,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+756200,int_stack+461000,int_stack+611480,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+554600,int_stack+368000,int_stack+353600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+597800,int_stack+554600,int_stack+423200,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+875000,int_stack+597800,int_stack+690680,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+984200,int_stack+875000,int_stack+461000,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1124600,int_stack+984200,int_stack+756200,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+423200,int_stack+384320,int_stack+368000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+673400,int_stack+423200,int_stack+554600,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+673400,int_stack+597800,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+472160,int_stack+0,int_stack+875000,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+759800,int_stack+472160,int_stack+984200,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+126000,int_stack+759800,int_stack+1124600,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+956360,int_stack+402680,int_stack+384320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1011440,int_stack+956360,int_stack+423200,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1109360,int_stack+1011440,int_stack+673400,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1541144,int_stack+1109360,int_stack+0,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+956360,int_stack+1541144,int_stack+472160,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1541144,int_stack+956360,int_stack+759800,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1803224,int_stack+1541144,int_stack+126000,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2088344,int_stack+1803224,int_stack+1291664,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+0,int_stack+2088344,int_stack+2847332,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+1297296,int_stack+0,int_stack+3495980,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+6176108,int_stack+1297296,int_stack+4607948,2376);
 return int_stack+6176108;}
