/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nlnl(Libint_t*, prim_data*);

  /* Computes quartets of (nl|nl) integrals */

REALTYPE *hrr_order_nlnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[11][10] = int_stack + 73260;
 Libint->vrr_classes[11][11] = int_stack + 78408;
 Libint->vrr_classes[11][12] = int_stack + 84492;
 Libint->vrr_classes[11][13] = int_stack + 91590;
 Libint->vrr_classes[11][14] = int_stack + 99780;
 Libint->vrr_classes[11][15] = int_stack + 109140;
 Libint->vrr_classes[11][16] = int_stack + 119748;
 Libint->vrr_classes[11][17] = int_stack + 131682;
 Libint->vrr_classes[11][18] = int_stack + 145020;
 Libint->vrr_classes[12][10] = int_stack + 159840;
 Libint->vrr_classes[12][11] = int_stack + 165846;
 Libint->vrr_classes[12][12] = int_stack + 172944;
 Libint->vrr_classes[12][13] = int_stack + 181225;
 Libint->vrr_classes[12][14] = int_stack + 190780;
 Libint->vrr_classes[12][15] = int_stack + 201700;
 Libint->vrr_classes[12][16] = int_stack + 214076;
 Libint->vrr_classes[12][17] = int_stack + 227999;
 Libint->vrr_classes[12][18] = int_stack + 243560;
 Libint->vrr_classes[13][10] = int_stack + 260850;
 Libint->vrr_classes[13][11] = int_stack + 267780;
 Libint->vrr_classes[13][12] = int_stack + 275970;
 Libint->vrr_classes[13][13] = int_stack + 285525;
 Libint->vrr_classes[13][14] = int_stack + 296550;
 Libint->vrr_classes[13][15] = int_stack + 309150;
 Libint->vrr_classes[13][16] = int_stack + 323430;
 Libint->vrr_classes[13][17] = int_stack + 339495;
 Libint->vrr_classes[13][18] = int_stack + 357450;
 Libint->vrr_classes[14][10] = int_stack + 377400;
 Libint->vrr_classes[14][11] = int_stack + 385320;
 Libint->vrr_classes[14][12] = int_stack + 394680;
 Libint->vrr_classes[14][13] = int_stack + 405600;
 Libint->vrr_classes[14][14] = int_stack + 418200;
 Libint->vrr_classes[14][15] = int_stack + 432600;
 Libint->vrr_classes[14][16] = int_stack + 448920;
 Libint->vrr_classes[14][17] = int_stack + 467280;
 Libint->vrr_classes[14][18] = int_stack + 487800;
 Libint->vrr_classes[15][10] = int_stack + 510600;
 Libint->vrr_classes[15][11] = int_stack + 519576;
 Libint->vrr_classes[15][12] = int_stack + 530184;
 Libint->vrr_classes[15][13] = int_stack + 542560;
 Libint->vrr_classes[15][14] = int_stack + 556840;
 Libint->vrr_classes[15][15] = int_stack + 573160;
 Libint->vrr_classes[15][16] = int_stack + 591656;
 Libint->vrr_classes[15][17] = int_stack + 612464;
 Libint->vrr_classes[15][18] = int_stack + 635720;
 Libint->vrr_classes[16][10] = int_stack + 661560;
 Libint->vrr_classes[16][11] = int_stack + 671658;
 Libint->vrr_classes[16][12] = int_stack + 683592;
 Libint->vrr_classes[16][13] = int_stack + 697515;
 Libint->vrr_classes[16][14] = int_stack + 713580;
 Libint->vrr_classes[16][15] = int_stack + 731940;
 Libint->vrr_classes[16][16] = int_stack + 752748;
 Libint->vrr_classes[16][17] = int_stack + 776157;
 Libint->vrr_classes[16][18] = int_stack + 802320;
 Libint->vrr_classes[17][10] = int_stack + 831390;
 Libint->vrr_classes[17][11] = int_stack + 842676;
 Libint->vrr_classes[17][12] = int_stack + 856014;
 Libint->vrr_classes[17][13] = int_stack + 871575;
 Libint->vrr_classes[17][14] = int_stack + 889530;
 Libint->vrr_classes[17][15] = int_stack + 910050;
 Libint->vrr_classes[17][16] = int_stack + 933306;
 Libint->vrr_classes[17][17] = int_stack + 959469;
 Libint->vrr_classes[17][18] = int_stack + 988710;
 Libint->vrr_classes[18][10] = int_stack + 1021200;
 Libint->vrr_classes[18][11] = int_stack + 1033740;
 Libint->vrr_classes[18][12] = int_stack + 1048560;
 Libint->vrr_classes[18][13] = int_stack + 1065850;
 Libint->vrr_classes[18][14] = int_stack + 1085800;
 Libint->vrr_classes[18][15] = int_stack + 1108600;
 Libint->vrr_classes[18][16] = int_stack + 1134440;
 Libint->vrr_classes[18][17] = int_stack + 1163510;
 Libint->vrr_classes[18][18] = int_stack + 1196000;
 memset(int_stack,0,1232100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1232100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nlnl(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1232100,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1245168,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1260612,int_stack+1245168,int_stack+1232100,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1286748,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1304766,int_stack+1286748,int_stack+1245168,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1335654,int_stack+1304766,int_stack+1260612,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1232100,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1379214,int_stack+1232100,int_stack+1286748,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1252890,int_stack+1379214,int_stack+1304766,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1415250,int_stack+1252890,int_stack+1335654,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1304370,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1328130,int_stack+1304370,int_stack+1232100,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1480590,int_stack+1328130,int_stack+1379214,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1540650,int_stack+1480590,int_stack+1252890,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1617870,int_stack+1540650,int_stack+1415250,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1232100,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1369710,int_stack+1232100,int_stack+1304370,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1709346,int_stack+1369710,int_stack+1328130,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1259028,int_stack+1709346,int_stack+1480590,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1417230,int_stack+1259028,int_stack+1540650,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1778646,int_stack+1417230,int_stack+1617870,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1525338,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1555632,int_stack+1525338,int_stack+1232100,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1609488,int_stack+1555632,int_stack+1369710,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1900614,int_stack+1609488,int_stack+1709346,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2004564,int_stack+1900614,int_stack+1259028,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1232100,int_stack+2004564,int_stack+1417230,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2130690,int_stack+1232100,int_stack+1778646,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1376244,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1410102,int_stack+1376244,int_stack+1525338,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1688688,int_stack+1410102,int_stack+1555632,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1376244,int_stack+1688688,int_stack+1609488,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1495044,int_stack+1376244,int_stack+1900614,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1640574,int_stack+1495044,int_stack+2004564,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1376244,int_stack+1640574,int_stack+1232100,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1561572,int_stack+1376244,int_stack+2130690,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1232100,int_stack+78408,int_stack+73260,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1247544,int_stack+84492,int_stack+78408,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1265796,int_stack+1247544,int_stack+1232100,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1296684,int_stack+91590,int_stack+84492,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1317978,int_stack+1296684,int_stack+1247544,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1354482,int_stack+1317978,int_stack+1265796,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1232100,int_stack+99780,int_stack+91590,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1405962,int_stack+1232100,int_stack+1296684,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1256670,int_stack+1405962,int_stack+1317978,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1448550,int_stack+1256670,int_stack+1354482,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1317510,int_stack+109140,int_stack+99780,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1345590,int_stack+1317510,int_stack+1232100,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1757592,int_stack+1345590,int_stack+1405962,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1828572,int_stack+1757592,int_stack+1256670,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1919832,int_stack+1828572,int_stack+1448550,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1232100,int_stack+119748,int_stack+109140,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1394730,int_stack+1232100,int_stack+1317510,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1450890,int_stack+1394730,int_stack+1345590,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1263924,int_stack+1450890,int_stack+1757592,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2027940,int_stack+1263924,int_stack+1828572,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1757592,int_stack+2027940,int_stack+1919832,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1901736,int_stack+131682,int_stack+119748,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1937538,int_stack+1901736,int_stack+1232100,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2155704,int_stack+1937538,int_stack+1394730,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2155704,int_stack+1450890,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1370394,int_stack+0,int_stack+1263924,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2249304,int_stack+1370394,int_stack+2027940,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2419656,int_stack+2249304,int_stack+1757592,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1757592,int_stack+145020,int_stack+131682,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1797606,int_stack+1757592,int_stack+1901736,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1232100,int_stack+1797606,int_stack+1937538,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1757592,int_stack+1232100,int_stack+2155704,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1897992,int_stack+1757592,int_stack+0,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2604984,int_stack+1897992,int_stack+1370394,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1757592,int_stack+2604984,int_stack+2249304,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1976616,int_stack+1757592,int_stack+2419656,78);
 /*--- compute (np|nl) ---*/
 hrr1_build_np(Libint->AB,int_stack+2208276,int_stack+1976616,int_stack+1561572,2970);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+165846,int_stack+159840,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+172944,int_stack+165846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+181225,int_stack+172944,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1232100,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+190780,int_stack+181225,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1292160,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+1292160,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+99645,int_stack+28665,int_stack+1232100,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1232100,int_stack+201700,int_stack+190780,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1341846,int_stack+1232100,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1399176,int_stack+1341846,int_stack+1292160,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1481986,int_stack+1399176,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1588456,int_stack+1481986,int_stack+99645,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+214076,int_stack+201700,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37128,int_stack+0,int_stack+1232100,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1232100,int_stack+37128,int_stack+1341846,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1714582,int_stack+1232100,int_stack+1399176,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1327650,int_stack+1714582,int_stack+1481986,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2796336,int_stack+1327650,int_stack+1588456,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1476708,int_stack+227999,int_stack+214076,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1518477,int_stack+1476708,int_stack+0,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1592733,int_stack+1518477,int_stack+37128,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1592733,int_stack+1232100,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2964504,int_stack+0,int_stack+1714582,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1701933,int_stack+2964504,int_stack+1327650,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1232100,int_stack+1701933,int_stack+2796336,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2796336,int_stack+243560,int_stack+227999,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2843019,int_stack+2796336,int_stack+1476708,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3138405,int_stack+2843019,int_stack+1518477,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2796336,int_stack+3138405,int_stack+1592733,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1448316,int_stack+2796336,int_stack+0,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1448316,int_stack+2964504,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2796336,int_stack+0,int_stack+1701933,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1448316,int_stack+2796336,int_stack+1232100,91);
 /*--- compute (op|nl) ---*/
 hrr1_build_op(Libint->AB,int_stack+2796336,int_stack+1448316,int_stack+1976616,2970);
 /*--- compute (nd|nl) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3491316,int_stack+2796336,int_stack+2208276,2970);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1232100,int_stack+267780,int_stack+260850,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1252890,int_stack+275970,int_stack+267780,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1277460,int_stack+1252890,int_stack+1232100,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1319040,int_stack+285525,int_stack+275970,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1347705,int_stack+1319040,int_stack+1252890,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+1347705,int_stack+1277460,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1232100,int_stack+296550,int_stack+285525,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+69300,int_stack+1232100,int_stack+1319040,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1265175,int_stack+69300,int_stack+1347705,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+126630,int_stack+1265175,int_stack+0,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+309150,int_stack+296550,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1347075,int_stack+0,int_stack+1232100,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1718586,int_stack+1347075,int_stack+69300,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1814136,int_stack+1718586,int_stack+1265175,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1936986,int_stack+1814136,int_stack+126630,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1232100,int_stack+323430,int_stack+309150,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37800,int_stack+1232100,int_stack+0,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+113400,int_stack+37800,int_stack+1347075,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1274940,int_stack+113400,int_stack+1718586,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2082516,int_stack+1274940,int_stack+1814136,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1718586,int_stack+2082516,int_stack+1936986,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1912626,int_stack+339495,int_stack+323430,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1960821,int_stack+1912626,int_stack+1232100,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2254506,int_stack+1960821,int_stack+37800,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2380506,int_stack+2254506,int_stack+113400,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+2380506,int_stack+1274940,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2545881,int_stack+0,int_stack+2082516,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4667436,int_stack+2545881,int_stack+1718586,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1718586,int_stack+357450,int_stack+339495,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1772451,int_stack+1718586,int_stack+1912626,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1232100,int_stack+1772451,int_stack+1960821,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1718586,int_stack+1232100,int_stack+2254506,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1907586,int_stack+1718586,int_stack+2380506,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2139111,int_stack+1907586,int_stack+0,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+2139111,int_stack+2545881,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1718586,int_stack+0,int_stack+4667436,105);
 /*--- compute (qp|nl) ---*/
 hrr1_build_qp(Libint->AB,int_stack+4667436,int_stack+1718586,int_stack+1448316,2970);
 /*--- compute (od|nl) ---*/
 hrr1_build_od(Libint->AB,int_stack+5478246,int_stack+4667436,int_stack+2796336,2970);
 /*--- compute (nf|nl) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6868206,int_stack+5478246,int_stack+3491316,2970);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+385320,int_stack+377400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+394680,int_stack+385320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+405600,int_stack+394680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+418200,int_stack+405600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2030436,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+432600,int_stack+418200,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2149236,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+250200,int_stack+2149236,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2258436,int_stack+250200,int_stack+2030436,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2030436,int_stack+448920,int_stack+432600,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+2030436,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2424756,int_stack+0,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+86400,int_stack+2424756,int_stack+2149236,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2550756,int_stack+86400,int_stack+250200,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2747316,int_stack+2550756,int_stack+2258436,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+250200,int_stack+467280,int_stack+448920,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+305280,int_stack+250200,int_stack+2030436,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2030436,int_stack+305280,int_stack+0,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2174436,int_stack+2030436,int_stack+2424756,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2969076,int_stack+2174436,int_stack+86400,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3198396,int_stack+2969076,int_stack+2550756,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2363436,int_stack+3198396,int_stack+2747316,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+487800,int_stack+467280,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+61560,int_stack+0,int_stack+250200,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2648556,int_stack+61560,int_stack+305280,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+2648556,int_stack+2030436,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2648556,int_stack+0,int_stack+2174436,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+2648556,int_stack+2969076,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2648556,int_stack+0,int_stack+3198396,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+2648556,int_stack+2363436,120);
 /*--- compute (rp|nl) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2030436,int_stack+0,int_stack+1718586,2970);
 /*--- compute (qd|nl) ---*/
 hrr1_build_qd(Libint->AB,int_stack+2965986,int_stack+2030436,int_stack+4667436,2970);
 /*--- compute (of|nl) ---*/
 hrr1_build_of(Libint->AB,int_stack+8828406,int_stack+2965986,int_stack+5478246,2970);
 /*--- compute (ng|nl) ---*/
 hrr1_build_ng(Libint->AB,int_stack+11145006,int_stack+8828406,int_stack+6868206,2970);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356400,int_stack+519576,int_stack+510600,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+383328,int_stack+530184,int_stack+519576,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+415152,int_stack+383328,int_stack+356400,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+469008,int_stack+542560,int_stack+530184,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+4587606,int_stack+469008,int_stack+383328,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4651254,int_stack+4587606,int_stack+415152,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356400,int_stack+556840,int_stack+542560,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4741014,int_stack+356400,int_stack+469008,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+399240,int_stack+4741014,int_stack+4587606,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+4815270,int_stack+399240,int_stack+4651254,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4587606,int_stack+573160,int_stack+556840,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4636566,int_stack+4587606,int_stack+356400,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4949910,int_stack+4636566,int_stack+4741014,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5073670,int_stack+4949910,int_stack+399240,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+356400,int_stack+5073670,int_stack+4815270,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4722246,int_stack+591656,int_stack+573160,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+4777734,int_stack+4722246,int_stack+4587606,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5232790,int_stack+4777734,int_stack+4636566,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5375590,int_stack+5232790,int_stack+4949910,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5561230,int_stack+5375590,int_stack+5073670,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4875654,int_stack+5561230,int_stack+356400,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+356400,int_stack+612464,int_stack+591656,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+418824,int_stack+356400,int_stack+4722246,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4587606,int_stack+418824,int_stack+4777734,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5783998,int_stack+4587606,int_stack+5232790,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5998198,int_stack+5783998,int_stack+5375590,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+5126982,int_stack+5998198,int_stack+5561230,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5424006,int_stack+5126982,int_stack+4875654,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+529800,int_stack+635720,int_stack+612464,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4750806,int_stack+529800,int_stack+356400,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+4875654,int_stack+4750806,int_stack+418824,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+356400,int_stack+4875654,int_stack+4587606,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4587606,int_stack+356400,int_stack+5783998,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6258094,int_stack+4587606,int_stack+5998198,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4587606,int_stack+6258094,int_stack+5126982,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4969494,int_stack+4587606,int_stack+5424006,136);
 /*--- compute (tp|nl) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5373414,int_stack+4969494,int_stack+0,2970);
 /*--- compute (rd|nl) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6442614,int_stack+5373414,int_stack+2030436,2970);
 /*--- compute (qf|nl) ---*/
 hrr1_build_qf(Libint->AB,int_stack+14085306,int_stack+6442614,int_stack+2965986,2970);
 /*--- compute (og|nl) ---*/
 hrr1_build_og(Libint->AB,int_stack+1232100,int_stack+14085306,int_stack+8828406,2970);
 /*--- compute (nh|nl) ---*/
 hrr1_build_nh(Libint->AB,int_stack+16788006,int_stack+1232100,int_stack+11145006,2970);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+671658,int_stack+661560,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30294,int_stack+683592,int_stack+671658,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66096,int_stack+30294,int_stack+0,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126684,int_stack+697515,int_stack+683592,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168453,int_stack+126684,int_stack+30294,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240057,int_stack+168453,int_stack+66096,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+713580,int_stack+697515,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341037,int_stack+0,int_stack+126684,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48195,int_stack+341037,int_stack+168453,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+424575,int_stack+48195,int_stack+240057,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167535,int_stack+731940,int_stack+713580,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222615,int_stack+167535,int_stack+0,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576045,int_stack+222615,int_stack+341037,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+8313714,int_stack+576045,int_stack+48195,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+8492724,int_stack+8313714,int_stack+424575,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+752748,int_stack+731940,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+319005,int_stack+0,int_stack+167535,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+8704782,int_stack+319005,int_stack+222615,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62424,int_stack+8704782,int_stack+576045,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429165,int_stack+62424,int_stack+8313714,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+8865432,int_stack+429165,int_stack+8492724,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+8313714,int_stack+776157,int_stack+752748,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+8383941,int_stack+8313714,int_stack+0,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+8508789,int_stack+8383941,int_stack+319005,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+9148176,int_stack+8508789,int_stack+8704782,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+9389151,int_stack+9148176,int_stack+62424,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+9389151,int_stack+429165,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+334152,int_stack+0,int_stack+8865432,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+8692389,int_stack+802320,int_stack+776157,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+8770878,int_stack+8692389,int_stack+8313714,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+8911332,int_stack+8770878,int_stack+8383941,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+9681534,int_stack+8911332,int_stack+8508789,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+8313714,int_stack+9681534,int_stack+9148176,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+9681534,int_stack+8313714,int_stack+9389151,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+8313714,int_stack+9681534,int_stack+0,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+8743338,int_stack+8313714,int_stack+334152,153);
 /*--- compute (up|nl) ---*/
 hrr1_build_up(Libint->AB,int_stack+9197748,int_stack+8743338,int_stack+4969494,2970);
 /*--- compute (td|nl) ---*/
 hrr1_build_td(Libint->AB,int_stack+10409508,int_stack+9197748,int_stack+5373414,2970);
 /*--- compute (rf|nl) ---*/
 hrr1_build_rf(Libint->AB,int_stack+20904426,int_stack+10409508,int_stack+6442614,2970);
 /*--- compute (qg|nl) ---*/
 hrr1_build_qg(Libint->AB,int_stack+24022926,int_stack+20904426,int_stack+14085306,2970);
 /*--- compute (oh|nl) ---*/
 hrr1_build_oh(Libint->AB,int_stack+28076976,int_stack+24022926,int_stack+1232100,2970);
 /*--- compute (ni|nl) ---*/
 hrr1_build_ni(Libint->AB,int_stack+1232100,int_stack+28076976,int_stack+16788006,2970);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6720660,int_stack+842676,int_stack+831390,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+6754518,int_stack+856014,int_stack+842676,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6794532,int_stack+6754518,int_stack+6720660,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+6862248,int_stack+871575,int_stack+856014,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6908931,int_stack+6862248,int_stack+6754518,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+6988959,int_stack+6908931,int_stack+6794532,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+6720660,int_stack+889530,int_stack+871575,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+7101819,int_stack+6720660,int_stack+6862248,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+6774525,int_stack+7101819,int_stack+6908931,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+7195185,int_stack+6774525,int_stack+6988959,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+6907905,int_stack+910050,int_stack+889530,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+6969465,int_stack+6907905,int_stack+6720660,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+7364475,int_stack+6969465,int_stack+7101819,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+7520085,int_stack+7364475,int_stack+6774525,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+7720155,int_stack+7520085,int_stack+7195185,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+6720660,int_stack+933306,int_stack+910050,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+7077195,int_stack+6720660,int_stack+6907905,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+7957161,int_stack+7077195,int_stack+6969465,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+6790428,int_stack+7957161,int_stack+7364475,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+7200315,int_stack+6790428,int_stack+7520085,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+8136711,int_stack+7200315,int_stack+7720155,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+7480413,int_stack+959469,int_stack+933306,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+7558902,int_stack+7480413,int_stack+6720660,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+7698438,int_stack+7558902,int_stack+7077195,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+8452719,int_stack+7698438,int_stack+7957161,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+8452719,int_stack+6790428,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+6720660,int_stack+0,int_stack+7200315,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+326781,int_stack+6720660,int_stack+8136711,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+7094124,int_stack+988710,int_stack+959469,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+7181847,int_stack+7094124,int_stack+7480413,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+7903638,int_stack+7181847,int_stack+7558902,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+7094124,int_stack+7903638,int_stack+7698438,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+7401924,int_stack+7094124,int_stack+8452719,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+7778979,int_stack+7401924,int_stack+0,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+7094124,int_stack+7778979,int_stack+6720660,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+7574292,int_stack+7094124,int_stack+326781,171);
 /*--- compute (vp|nl) ---*/
 hrr1_build_vp(Libint->AB,int_stack+12547908,int_stack+7574292,int_stack+8743338,2970);
 /*--- compute (ud|nl) ---*/
 hrr1_build_ud(Libint->AB,int_stack+13911138,int_stack+12547908,int_stack+9197748,2970);
 /*--- compute (tf|nl) ---*/
 hrr1_build_tf(Libint->AB,int_stack+16334658,int_stack+13911138,int_stack+10409508,2970);
 /*--- compute (rg|nl) ---*/
 hrr1_build_rg(Libint->AB,int_stack+32941836,int_stack+16334658,int_stack+20904426,2970);
 /*--- compute (qh|nl) ---*/
 hrr1_build_qh(Libint->AB,int_stack+37619586,int_stack+32941836,int_stack+24022926,2970);
 /*--- compute (oi|nl) ---*/
 hrr1_build_oi(Libint->AB,int_stack+19898658,int_stack+37619586,int_stack+28076976,2970);
 /*--- compute (nk|nl) ---*/
 hrr1_build_nk(Libint->AB,int_stack+43295256,int_stack+19898658,int_stack+1232100,2970);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1232100,int_stack+1033740,int_stack+1021200,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1269720,int_stack+1048560,int_stack+1033740,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1314180,int_stack+1269720,int_stack+1232100,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1389420,int_stack+1065850,int_stack+1048560,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1441290,int_stack+1389420,int_stack+1269720,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1530210,int_stack+1441290,int_stack+1314180,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1232100,int_stack+1085800,int_stack+1065850,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1655610,int_stack+1232100,int_stack+1389420,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1291950,int_stack+1655610,int_stack+1441290,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1759350,int_stack+1291950,int_stack+1530210,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1440150,int_stack+1108600,int_stack+1085800,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1508550,int_stack+1440150,int_stack+1232100,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1947450,int_stack+1508550,int_stack+1655610,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2120350,int_stack+1947450,int_stack+1291950,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2342650,int_stack+2120350,int_stack+1759350,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1232100,int_stack+1134440,int_stack+1108600,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1628250,int_stack+1232100,int_stack+1440150,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2605990,int_stack+1628250,int_stack+1508550,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1309620,int_stack+2605990,int_stack+1947450,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1765050,int_stack+1309620,int_stack+2120350,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2805490,int_stack+1765050,int_stack+2342650,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2076270,int_stack+1163510,int_stack+1134440,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2163480,int_stack+2076270,int_stack+1232100,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2318520,int_stack+2163480,int_stack+1628250,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3156610,int_stack+2318520,int_stack+2605990,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3455860,int_stack+3156610,int_stack+1309620,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1232100,int_stack+3455860,int_stack+1765050,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3818950,int_stack+1232100,int_stack+2805490,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1647060,int_stack+1196000,int_stack+1163510,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1744530,int_stack+1647060,int_stack+2076270,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2546520,int_stack+1744530,int_stack+2163480,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1647060,int_stack+2546520,int_stack+2318520,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1989060,int_stack+1647060,int_stack+3156610,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2408010,int_stack+1989060,int_stack+3455860,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1647060,int_stack+2408010,int_stack+1232100,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2180580,int_stack+1647060,int_stack+3818950,190);
 /*--- compute (wp|nl) ---*/
 hrr1_build_wp(Libint->AB,int_stack+2744880,int_stack+2180580,int_stack+7574292,2970);
 /*--- compute (vd|nl) ---*/
 hrr1_build_vd(Libint->AB,int_stack+4268490,int_stack+2744880,int_stack+12547908,2970);
 /*--- compute (uf|nl) ---*/
 hrr1_build_uf(Libint->AB,int_stack+6994950,int_stack+4268490,int_stack+13911138,2970);
 /*--- compute (tg|nl) ---*/
 hrr1_build_tg(Libint->AB,int_stack+0,int_stack+6994950,int_stack+16334658,2970);
 /*--- compute (rh|nl) ---*/
 hrr1_build_rh(Libint->AB,int_stack+5346000,int_stack+0,int_stack+32941836,2970);
 /*--- compute (qi|nl) ---*/
 hrr1_build_qi(Libint->AB,int_stack+11894850,int_stack+5346000,int_stack+37619586,2970);
 /*--- compute (ok|nl) ---*/
 hrr1_build_ok(Libint->AB,int_stack+0,int_stack+11894850,int_stack+19898658,2970);
 /*--- compute (nl|nl) ---*/
 hrr1_build_nl(Libint->AB,int_stack+8339760,int_stack+0,int_stack+43295256,2970);
 return int_stack+8339760;}
