/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npmk(Libint_t*, prim_data*);

  /* Computes quartets of (np|mk) integrals */

REALTYPE *hrr_order_npmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[11][9] = int_stack + 53064;
 Libint->vrr_classes[11][10] = int_stack + 57354;
 Libint->vrr_classes[11][11] = int_stack + 62502;
 Libint->vrr_classes[11][12] = int_stack + 68586;
 Libint->vrr_classes[11][13] = int_stack + 75684;
 Libint->vrr_classes[11][14] = int_stack + 83874;
 Libint->vrr_classes[11][15] = int_stack + 93234;
 Libint->vrr_classes[11][16] = int_stack + 103842;
 memset(int_stack,0,115776*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 115776;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npmk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115776,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+126666,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139734,int_stack+126666,int_stack+115776,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+161514,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+176958,int_stack+161514,int_stack+126666,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+203094,int_stack+176958,int_stack+139734,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+115776,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+239394,int_stack+115776,int_stack+161514,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+270282,int_stack+239394,int_stack+176958,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+133794,int_stack+270282,int_stack+203094,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+188244,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+313842,int_stack+188244,int_stack+115776,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+349878,int_stack+313842,int_stack+239394,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+401358,int_stack+349878,int_stack+270282,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+209034,int_stack+401358,int_stack+133794,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+115776,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+139536,int_stack+115776,int_stack+188244,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+466698,int_stack+139536,int_stack+313842,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+526758,int_stack+466698,int_stack+349878,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+285264,int_stack+526758,int_stack+401358,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+603978,int_stack+285264,int_stack+209034,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+181116,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+208044,int_stack+181116,int_stack+115776,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+376740,int_stack+208044,int_stack+139536,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+115776,int_stack+376740,int_stack+466698,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+376740,int_stack+115776,int_stack+526758,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+115776,int_stack+376740,int_stack+285264,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+237744,int_stack+115776,int_stack+603978,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+115776,int_stack+57354,int_stack+53064,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+128646,int_stack+62502,int_stack+57354,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144090,int_stack+128646,int_stack+115776,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+169830,int_stack+68586,int_stack+62502,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+188082,int_stack+169830,int_stack+128646,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+368424,int_stack+188082,int_stack+144090,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+115776,int_stack+75684,int_stack+68586,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+411324,int_stack+115776,int_stack+169830,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+447828,int_stack+411324,int_stack+188082,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+137070,int_stack+447828,int_stack+368424,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+368424,int_stack+83874,int_stack+75684,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+499308,int_stack+368424,int_stack+115776,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+541896,int_stack+499308,int_stack+411324,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+602736,int_stack+541896,int_stack+447828,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+392994,int_stack+602736,int_stack+137070,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+115776,int_stack+93234,int_stack+83874,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+143856,int_stack+115776,int_stack+368424,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+143856,int_stack+499308,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+679956,int_stack+0,int_stack+541896,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+483084,int_stack+679956,int_stack+602736,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+771216,int_stack+483084,int_stack+392994,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+368424,int_stack+103842,int_stack+93234,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+400248,int_stack+368424,int_stack+115776,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+591192,int_stack+400248,int_stack+143856,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368424,int_stack+591192,int_stack+0,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+368424,int_stack+679956,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+591192,int_stack+0,int_stack+483084,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+591192,int_stack+771216,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+368424,int_stack+0,int_stack+237744,1980);
 return int_stack+368424;}
