/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npnk(Libint_t*, prim_data*);

  /* Computes quartets of (np|nk) integrals */

REALTYPE *hrr_order_npnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[11][10] = int_stack + 60720;
 Libint->vrr_classes[11][11] = int_stack + 65868;
 Libint->vrr_classes[11][12] = int_stack + 71952;
 Libint->vrr_classes[11][13] = int_stack + 79050;
 Libint->vrr_classes[11][14] = int_stack + 87240;
 Libint->vrr_classes[11][15] = int_stack + 96600;
 Libint->vrr_classes[11][16] = int_stack + 107208;
 Libint->vrr_classes[11][17] = int_stack + 119142;
 memset(int_stack,0,132480*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 132480;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npnk(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+132480,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+145548,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+160992,int_stack+145548,int_stack+132480,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+187128,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+205146,int_stack+187128,int_stack+145548,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+236034,int_stack+205146,int_stack+160992,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+132480,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+279594,int_stack+132480,int_stack+187128,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+153270,int_stack+279594,int_stack+205146,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+315630,int_stack+153270,int_stack+236034,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+204750,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+228510,int_stack+204750,int_stack+132480,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+380970,int_stack+228510,int_stack+279594,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+441030,int_stack+380970,int_stack+153270,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+518250,int_stack+441030,int_stack+315630,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+132480,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+270090,int_stack+132480,int_stack+204750,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+609726,int_stack+270090,int_stack+228510,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+159408,int_stack+609726,int_stack+380970,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+317610,int_stack+159408,int_stack+441030,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+679026,int_stack+317610,int_stack+518250,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+425718,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+456012,int_stack+425718,int_stack+132480,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+509868,int_stack+456012,int_stack+270090,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+800994,int_stack+509868,int_stack+609726,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+425718,int_stack+800994,int_stack+159408,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+132480,int_stack+425718,int_stack+317610,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+276624,int_stack+132480,int_stack+679026,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+132480,int_stack+65868,int_stack+60720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147924,int_stack+71952,int_stack+65868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166176,int_stack+147924,int_stack+132480,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+197064,int_stack+79050,int_stack+71952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+218358,int_stack+197064,int_stack+147924,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+433440,int_stack+218358,int_stack+166176,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+132480,int_stack+87240,int_stack+79050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+484920,int_stack+132480,int_stack+197064,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+157050,int_stack+484920,int_stack+218358,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+527508,int_stack+157050,int_stack+433440,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+433440,int_stack+96600,int_stack+87240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+217890,int_stack+433440,int_stack+132480,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+604728,int_stack+217890,int_stack+484920,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+675708,int_stack+604728,int_stack+157050,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+766968,int_stack+675708,int_stack+527508,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+132480,int_stack+107208,int_stack+96600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+461520,int_stack+132480,int_stack+433440,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+517680,int_stack+461520,int_stack+217890,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+164304,int_stack+517680,int_stack+604728,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+875076,int_stack+164304,int_stack+675708,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+599580,int_stack+875076,int_stack+766968,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+743724,int_stack+119142,int_stack+107208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+779526,int_stack+743724,int_stack+132480,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+779526,int_stack+461520,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+743724,int_stack+0,int_stack+517680,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+743724,int_stack+164304,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1002840,int_stack+0,int_stack+875076,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1002840,int_stack+599580,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+433440,int_stack+0,int_stack+276624,2376);
 return int_stack+433440;}
