/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0li(Libint_t*, prim_data*);

  /* Computes quartets of (p0|li) integrals */

REALTYPE *hrr_order_p0li(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][8] = int_stack + 0;
 Libint->vrr_classes[1][9] = int_stack + 135;
 Libint->vrr_classes[1][10] = int_stack + 300;
 Libint->vrr_classes[1][11] = int_stack + 498;
 Libint->vrr_classes[1][12] = int_stack + 732;
 Libint->vrr_classes[1][13] = int_stack + 1005;
 Libint->vrr_classes[1][14] = int_stack + 1320;
 memset(int_stack,0,1680*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1680;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0li(Libint, Data);
   Data++;
 }
 /*--- compute (p0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+1680,int_stack+135,int_stack+0,3);
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2085,int_stack+300,int_stack+135,3);
 /*--- compute (p0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+2580,int_stack+2085,int_stack+1680,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+3390,int_stack+498,int_stack+300,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3984,int_stack+3390,int_stack+2085,3);
 /*--- compute (p0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+4974,int_stack+3984,int_stack+2580,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1680,int_stack+732,int_stack+498,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+6324,int_stack+1680,int_stack+3390,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+7512,int_stack+6324,int_stack+3984,3);
 /*--- compute (p0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+2382,int_stack+7512,int_stack+4974,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4407,int_stack+1005,int_stack+732,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9162,int_stack+4407,int_stack+1680,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+10566,int_stack+9162,int_stack+6324,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12546,int_stack+10566,int_stack+7512,3);
 /*--- compute (p0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+5226,int_stack+12546,int_stack+2382,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1680,int_stack+1320,int_stack+1005,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2625,int_stack+1680,int_stack+4407,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+2625,int_stack+9162,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+15021,int_stack+0,int_stack+10566,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+15021,int_stack+12546,3);
 /*--- compute (p0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+8061,int_stack+0,int_stack+5226,3);
 return int_stack+8061;}
