/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppml(Libint_t*, prim_data*);

  /* Computes quartets of (pp|ml) integrals */

REALTYPE *hrr_order_ppml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 Libint->vrr_classes[1][14] = int_stack + 1185;
 Libint->vrr_classes[1][15] = int_stack + 1545;
 Libint->vrr_classes[1][16] = int_stack + 1953;
 Libint->vrr_classes[1][17] = int_stack + 2412;
 Libint->vrr_classes[2][9] = int_stack + 2925;
 Libint->vrr_classes[2][10] = int_stack + 3255;
 Libint->vrr_classes[2][11] = int_stack + 3651;
 Libint->vrr_classes[2][12] = int_stack + 4119;
 Libint->vrr_classes[2][13] = int_stack + 4665;
 Libint->vrr_classes[2][14] = int_stack + 5295;
 Libint->vrr_classes[2][15] = int_stack + 6015;
 Libint->vrr_classes[2][16] = int_stack + 6831;
 Libint->vrr_classes[2][17] = int_stack + 7749;
 memset(int_stack,0,8775*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8775;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppml(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8775,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9270,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+9864,int_stack+9270,int_stack+8775,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10854,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+11556,int_stack+10854,int_stack+9270,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+12744,int_stack+11556,int_stack+9864,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8775,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+14394,int_stack+8775,int_stack+10854,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+15798,int_stack+14394,int_stack+11556,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+9594,int_stack+15798,int_stack+12744,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+12069,int_stack+1185,int_stack+870,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17778,int_stack+12069,int_stack+8775,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+19416,int_stack+17778,int_stack+14394,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+21756,int_stack+19416,int_stack+15798,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+13014,int_stack+21756,int_stack+9594,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+8775,int_stack+1545,int_stack+1185,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+9855,int_stack+8775,int_stack+12069,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+24726,int_stack+9855,int_stack+17778,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+27456,int_stack+24726,int_stack+19416,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16479,int_stack+27456,int_stack+21756,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+30966,int_stack+16479,int_stack+13014,3);
 /*--- compute (p0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+11745,int_stack+1953,int_stack+1545,3);
 /*--- compute (p0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+12969,int_stack+11745,int_stack+8775,3);
 /*--- compute (p0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+20637,int_stack+12969,int_stack+9855,3);
 /*--- compute (p0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+35586,int_stack+20637,int_stack+24726,3);
 /*--- compute (p0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+39681,int_stack+35586,int_stack+27456,3);
 /*--- compute (p0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+23787,int_stack+39681,int_stack+16479,3);
 /*--- compute (p0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+44595,int_stack+23787,int_stack+30966,3);
 /*--- compute (p0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+8775,int_stack+2412,int_stack+1953,3);
 /*--- compute (p0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+15129,int_stack+8775,int_stack+11745,3);
 /*--- compute (p0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+8775,int_stack+15129,int_stack+12969,3);
 /*--- compute (p0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+12375,int_stack+8775,int_stack+20637,3);
 /*--- compute (p0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17100,int_stack+12375,int_stack+35586,3);
 /*--- compute (p0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+8775,int_stack+17100,int_stack+39681,3);
 /*--- compute (p0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+15327,int_stack+8775,int_stack+23787,3);
 /*--- compute (p0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+22455,int_stack+15327,int_stack+44595,3);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+8775,int_stack+3255,int_stack+2925,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9765,int_stack+3651,int_stack+3255,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10953,int_stack+9765,int_stack+8775,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+12933,int_stack+4119,int_stack+3651,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+14337,int_stack+12933,int_stack+9765,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+16713,int_stack+14337,int_stack+10953,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8775,int_stack+4665,int_stack+4119,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+29880,int_stack+8775,int_stack+12933,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+32688,int_stack+29880,int_stack+14337,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+10413,int_stack+32688,int_stack+16713,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+15363,int_stack+5295,int_stack+4665,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17253,int_stack+15363,int_stack+8775,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+36648,int_stack+17253,int_stack+29880,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+41328,int_stack+36648,int_stack+32688,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+47268,int_stack+41328,int_stack+10413,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+29880,int_stack+6015,int_stack+5295,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+32040,int_stack+29880,int_stack+15363,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+8775,int_stack+32040,int_stack+17253,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+14235,int_stack+8775,int_stack+36648,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+54198,int_stack+14235,int_stack+41328,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+35820,int_stack+54198,int_stack+47268,6);
 /*--- compute (d0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+45060,int_stack+6831,int_stack+6015,6);
 /*--- compute (d0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+47508,int_stack+45060,int_stack+29880,6);
 /*--- compute (d0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+47508,int_stack+32040,6);
 /*--- compute (d0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62514,int_stack+0,int_stack+8775,6);
 /*--- compute (d0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+70704,int_stack+62514,int_stack+14235,6);
 /*--- compute (d0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+8775,int_stack+70704,int_stack+54198,6);
 /*--- compute (d0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+80532,int_stack+8775,int_stack+35820,6);
 /*--- compute (d0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+29880,int_stack+7749,int_stack+6831,6);
 /*--- compute (d0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+32634,int_stack+29880,int_stack+45060,6);
 /*--- compute (d0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+37530,int_stack+32634,int_stack+47508,6);
 /*--- compute (d0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+44730,int_stack+37530,int_stack+0,6);
 /*--- compute (d0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+29880,int_stack+44730,int_stack+62514,6);
 /*--- compute (d0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+41346,int_stack+29880,int_stack+70704,6);
 /*--- compute (d0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+54450,int_stack+41346,int_stack+8775,6);
 /*--- compute (d0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+29880,int_stack+54450,int_stack+80532,6);
 /*--- compute (pp|ml) ---*/
 hrr1_build_pp(Libint->AB,int_stack+44730,int_stack+29880,int_stack+22455,2475);
 return int_stack+44730;}
