/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (f0|lk) integrals */

void vrr_order_f0lk(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+5, Data->F+6, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+50, vrr_stack+15, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+56, vrr_stack+117, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+66, vrr_stack+127, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+96, vrr_stack+142, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+31, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+191, vrr_stack+24, vrr_stack+34, vrr_stack+21, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+201, vrr_stack+191, vrr_stack+40, vrr_stack+24, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+216, vrr_stack+201, vrr_stack+81, vrr_stack+191, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+237, vrr_stack+216, vrr_stack+96, vrr_stack+201, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+265, vrr_stack+237, vrr_stack+163, NULL, NULL, vrr_stack+96);
 _BUILD_00k0(Data,vrr_stack+349, vrr_stack+237, vrr_stack+163, vrr_stack+216, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+21, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+84, vrr_stack+24, vrr_stack+81, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+30, vrr_stack+191, vrr_stack+84, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+400, vrr_stack+385, vrr_stack+201, vrr_stack+30, vrr_stack+191, NULL);
 _BUILD_00i0(Data,vrr_stack+421, vrr_stack+400, vrr_stack+216, vrr_stack+385, vrr_stack+201, NULL);
 _BUILD_00k0(Data,vrr_stack+449, vrr_stack+421, vrr_stack+237, vrr_stack+400, vrr_stack+216, NULL);
 _BUILD_00p0(Data,vrr_stack+191, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+191, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+90, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+117, vrr_stack+40, vrr_stack+50, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+209, vrr_stack+127, vrr_stack+194, vrr_stack+56, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+485, vrr_stack+142, vrr_stack+209, vrr_stack+66, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+513, vrr_stack+163, vrr_stack+485, vrr_stack+96, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+549, vrr_stack+349, vrr_stack+513, NULL, NULL, vrr_stack+163);
 _BUILD_p0k0(Data,vrr_stack+657, vrr_stack+449, vrr_stack+349, NULL, NULL, vrr_stack+237);
 _BUILD_d0k0(Data,vrr_stack+765, vrr_stack+657, vrr_stack+549, vrr_stack+449, vrr_stack+349, vrr_stack+265);
 _BUILD_00l0(Data,vrr_stack+265, vrr_stack+349, vrr_stack+513, vrr_stack+237, vrr_stack+163, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+449, vrr_stack+349, vrr_stack+421, vrr_stack+237, NULL);
 _BUILD_p0l0(Data,vrr_stack+1026, vrr_stack+981, vrr_stack+265, NULL, NULL, vrr_stack+349);
 _BUILD_00p0(Data,vrr_stack+310, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+313, vrr_stack+310, vrr_stack+81, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+319, vrr_stack+313, vrr_stack+84, vrr_stack+310, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+329, vrr_stack+319, vrr_stack+30, vrr_stack+313, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+329, vrr_stack+385, vrr_stack+319, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+400, vrr_stack+329, vrr_stack+385, NULL);
 _BUILD_00k0(Data,vrr_stack+310, vrr_stack+50, vrr_stack+421, vrr_stack+96, vrr_stack+400, NULL);
 _BUILD_00l0(Data,vrr_stack+1161, vrr_stack+310, vrr_stack+449, vrr_stack+50, vrr_stack+421, NULL);
 _BUILD_p0l0(Data,vrr_stack+1206, vrr_stack+1161, vrr_stack+981, NULL, NULL, vrr_stack+449);
 _BUILD_00p0(Data,vrr_stack+346, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+191, vrr_stack+346, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+90, vrr_stack+50, vrr_stack+0, vrr_stack+191, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+40, vrr_stack+56, vrr_stack+15, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+194, vrr_stack+0, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+385, vrr_stack+209, vrr_stack+96, vrr_stack+127, vrr_stack+194, NULL);
 _BUILD_00k0(Data,vrr_stack+413, vrr_stack+485, vrr_stack+385, vrr_stack+142, vrr_stack+209, NULL);
 _BUILD_00l0(Data,vrr_stack+117, vrr_stack+513, vrr_stack+413, vrr_stack+163, vrr_stack+485, NULL);
 _BUILD_p0l0(Data,vrr_stack+1341, vrr_stack+265, vrr_stack+117, NULL, NULL, vrr_stack+513);
 _BUILD_d0l0(Data,vrr_stack+1476, vrr_stack+1026, vrr_stack+1341, vrr_stack+981, vrr_stack+265, vrr_stack+549);
 _BUILD_d0l0(Data,vrr_stack+1746, vrr_stack+1206, vrr_stack+1026, vrr_stack+1161, vrr_stack+981, vrr_stack+657);
 _BUILD_00m0(Data,vrr_stack+549, vrr_stack+265, vrr_stack+117, vrr_stack+349, vrr_stack+513, NULL);
 _BUILD_00m0(Data,vrr_stack+604, vrr_stack+981, vrr_stack+265, vrr_stack+449, vrr_stack+349, NULL);
 _BUILD_p0m0(Data,vrr_stack+2016, vrr_stack+604, vrr_stack+549, NULL, NULL, vrr_stack+265);
 _BUILD_00m0(Data,vrr_stack+659, vrr_stack+1161, vrr_stack+981, vrr_stack+310, vrr_stack+449, NULL);
 _BUILD_p0m0(Data,vrr_stack+2181, vrr_stack+659, vrr_stack+604, NULL, NULL, vrr_stack+981);
 _BUILD_00p0(Data,vrr_stack+449, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+452, vrr_stack+346, vrr_stack+449, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+458, vrr_stack+50, vrr_stack+452, vrr_stack+191, vrr_stack+346, NULL);
 _BUILD_00g0(Data,vrr_stack+468, vrr_stack+56, vrr_stack+458, vrr_stack+90, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+310, vrr_stack+0, vrr_stack+468, vrr_stack+40, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+349, vrr_stack+96, vrr_stack+310, vrr_stack+194, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+714, vrr_stack+385, vrr_stack+349, vrr_stack+209, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+162, vrr_stack+413, vrr_stack+714, vrr_stack+485, vrr_stack+385, NULL);
 _BUILD_00m0(Data,vrr_stack+207, vrr_stack+117, vrr_stack+162, vrr_stack+513, vrr_stack+413, NULL);
 _BUILD_p0m0(Data,vrr_stack+2346, vrr_stack+549, vrr_stack+207, NULL, NULL, vrr_stack+117);
 _BUILD_d0m0(Data,vrr_stack+2511, vrr_stack+2016, vrr_stack+2346, vrr_stack+604, vrr_stack+549, vrr_stack+1341);
 _BUILD_d0m0(Data,vrr_stack+2841, vrr_stack+2181, vrr_stack+2016, vrr_stack+659, vrr_stack+604, vrr_stack+1026);
 _BUILD_00n0(Data,vrr_stack+483, vrr_stack+549, vrr_stack+207, vrr_stack+265, vrr_stack+117, NULL);
 _BUILD_00n0(Data,vrr_stack+1341, vrr_stack+604, vrr_stack+549, vrr_stack+981, vrr_stack+265, NULL);
 _BUILD_p0n0(Data,vrr_stack+3171, vrr_stack+1341, vrr_stack+483, NULL, NULL, vrr_stack+549);
 _BUILD_00n0(Data,vrr_stack+1407, vrr_stack+659, vrr_stack+604, vrr_stack+1161, vrr_stack+981, NULL);
 _BUILD_p0n0(Data,vrr_stack+3369, vrr_stack+1407, vrr_stack+1341, NULL, NULL, vrr_stack+604);
 _BUILD_00p0(Data,vrr_stack+1473, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+981, vrr_stack+449, vrr_stack+1473, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+987, vrr_stack+452, vrr_stack+981, vrr_stack+346, vrr_stack+449, NULL);
 _BUILD_00g0(Data,vrr_stack+750, vrr_stack+458, vrr_stack+987, vrr_stack+50, vrr_stack+452, NULL);
 _BUILD_00h0(Data,vrr_stack+997, vrr_stack+468, vrr_stack+750, vrr_stack+56, vrr_stack+458, NULL);
 _BUILD_00i0(Data,vrr_stack+1161, vrr_stack+310, vrr_stack+997, vrr_stack+0, vrr_stack+468, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+349, vrr_stack+1161, vrr_stack+96, vrr_stack+310, NULL);
 _BUILD_00l0(Data,vrr_stack+36, vrr_stack+714, vrr_stack+0, vrr_stack+385, vrr_stack+349, NULL);
 _BUILD_00m0(Data,vrr_stack+3567, vrr_stack+162, vrr_stack+36, vrr_stack+413, vrr_stack+714, NULL);
 _BUILD_00n0(Data,vrr_stack+377, vrr_stack+207, vrr_stack+3567, vrr_stack+117, vrr_stack+162, NULL);
 _BUILD_p0n0(Data,vrr_stack+3622, vrr_stack+483, vrr_stack+377, NULL, NULL, vrr_stack+207);
 _BUILD_d0n0(Data,vrr_stack+3820, vrr_stack+3171, vrr_stack+3622, vrr_stack+1341, vrr_stack+483, vrr_stack+2346);
 _BUILD_d0n0(Data,vrr_stack+4216, vrr_stack+3369, vrr_stack+3171, vrr_stack+1407, vrr_stack+1341, vrr_stack+2016);
 _BUILD_00o0(Data,vrr_stack+2346, vrr_stack+483, vrr_stack+377, vrr_stack+549, vrr_stack+207, NULL);
 _BUILD_00o0(Data,vrr_stack+2424, vrr_stack+1341, vrr_stack+483, vrr_stack+604, vrr_stack+549, NULL);
 _BUILD_p0o0(Data,vrr_stack+4612, vrr_stack+2424, vrr_stack+2346, NULL, NULL, vrr_stack+483);
 _BUILD_00o0(Data,vrr_stack+81, vrr_stack+1407, vrr_stack+1341, vrr_stack+659, vrr_stack+604, NULL);
 _BUILD_p0o0(Data,vrr_stack+4846, vrr_stack+81, vrr_stack+2424, NULL, NULL, vrr_stack+1341);
 _BUILD_00p0(Data,vrr_stack+159, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+443, vrr_stack+1473, vrr_stack+159, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+549, vrr_stack+981, vrr_stack+443, vrr_stack+449, vrr_stack+1473, NULL);
 _BUILD_00g0(Data,vrr_stack+559, vrr_stack+987, vrr_stack+549, vrr_stack+452, vrr_stack+981, NULL);
 _BUILD_00h0(Data,vrr_stack+574, vrr_stack+750, vrr_stack+559, vrr_stack+458, vrr_stack+987, NULL);
 _BUILD_00i0(Data,vrr_stack+595, vrr_stack+997, vrr_stack+574, vrr_stack+468, vrr_stack+750, NULL);
 _BUILD_00k0(Data,vrr_stack+623, vrr_stack+1161, vrr_stack+595, vrr_stack+310, vrr_stack+997, NULL);
 _BUILD_00l0(Data,vrr_stack+659, vrr_stack+0, vrr_stack+623, vrr_stack+349, vrr_stack+1161, NULL);
 _BUILD_00m0(Data,vrr_stack+262, vrr_stack+36, vrr_stack+659, vrr_stack+714, vrr_stack+0, NULL);
 _BUILD_00n0(Data,vrr_stack+5080, vrr_stack+3567, vrr_stack+262, vrr_stack+162, vrr_stack+36, NULL);
 _BUILD_00o0(Data,vrr_stack+5146, vrr_stack+377, vrr_stack+5080, vrr_stack+207, vrr_stack+3567, NULL);
 _BUILD_p0o0(Data,vrr_stack+5224, vrr_stack+2346, vrr_stack+5146, NULL, NULL, vrr_stack+377);
 _BUILD_d0o0(Data,vrr_stack+5458, vrr_stack+4612, vrr_stack+5224, vrr_stack+2424, vrr_stack+2346, vrr_stack+3622);
 _BUILD_d0o0(Data,vrr_stack+5926, vrr_stack+4846, vrr_stack+4612, vrr_stack+81, vrr_stack+2424, vrr_stack+3171);
 _BUILD_00q0(Data,vrr_stack+3622, vrr_stack+2346, vrr_stack+5146, vrr_stack+483, vrr_stack+377, NULL);
 _BUILD_00q0(Data,vrr_stack+3713, vrr_stack+2424, vrr_stack+2346, vrr_stack+1341, vrr_stack+483, NULL);
 _BUILD_p0q0(Data,vrr_stack+6394, vrr_stack+3713, vrr_stack+3622, NULL, NULL, vrr_stack+2346);
 _BUILD_00q0(Data,vrr_stack+162, vrr_stack+81, vrr_stack+2424, vrr_stack+1407, vrr_stack+1341, NULL);
 _BUILD_p0q0(Data,vrr_stack+6667, vrr_stack+162, vrr_stack+3713, NULL, NULL, vrr_stack+2424);
 _BUILD_00p0(Data,vrr_stack+1341, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1344, vrr_stack+159, vrr_stack+1341, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+1350, vrr_stack+443, vrr_stack+1344, vrr_stack+1473, vrr_stack+159, NULL);
 _BUILD_00g0(Data,vrr_stack+1360, vrr_stack+549, vrr_stack+1350, vrr_stack+981, vrr_stack+443, NULL);
 _BUILD_00h0(Data,vrr_stack+1375, vrr_stack+559, vrr_stack+1360, vrr_stack+987, vrr_stack+549, NULL);
 _BUILD_00i0(Data,vrr_stack+1396, vrr_stack+574, vrr_stack+1375, vrr_stack+750, vrr_stack+559, NULL);
 _BUILD_00k0(Data,vrr_stack+1424, vrr_stack+595, vrr_stack+1396, vrr_stack+997, vrr_stack+574, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+623, vrr_stack+1424, vrr_stack+1161, vrr_stack+595, NULL);
 _BUILD_00m0(Data,vrr_stack+449, vrr_stack+659, vrr_stack+981, vrr_stack+0, vrr_stack+623, NULL);
 _BUILD_00n0(Data,vrr_stack+6940, vrr_stack+262, vrr_stack+449, vrr_stack+36, vrr_stack+659, NULL);
 _BUILD_00o0(Data,vrr_stack+0, vrr_stack+5080, vrr_stack+6940, vrr_stack+3567, vrr_stack+262, NULL);
 _BUILD_00q0(Data,vrr_stack+7006, vrr_stack+5146, vrr_stack+0, vrr_stack+377, vrr_stack+5080, NULL);
 _BUILD_p0q0(Data,vrr_stack+7097, vrr_stack+3622, vrr_stack+7006, NULL, NULL, vrr_stack+5146);
 _BUILD_d0q0(Data,vrr_stack+7370, vrr_stack+6394, vrr_stack+7097, vrr_stack+3713, vrr_stack+3622, vrr_stack+5224);
 _BUILD_d0q0(Data,vrr_stack+7916, vrr_stack+6667, vrr_stack+6394, vrr_stack+162, vrr_stack+3713, vrr_stack+4612);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5224, vrr_stack+3622, vrr_stack+7006, vrr_stack+2346, vrr_stack+5146, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5329, vrr_stack+3713, vrr_stack+3622, vrr_stack+2424, vrr_stack+2346, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8462, vrr_stack+5329, vrr_stack+5224, NULL, NULL, vrr_stack+3622);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+317, vrr_stack+162, vrr_stack+3713, vrr_stack+81, vrr_stack+2424, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8777, vrr_stack+317, vrr_stack+5329, NULL, NULL, vrr_stack+3713);
 _BUILD_00p0(Data,vrr_stack+2346, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2349, vrr_stack+1341, vrr_stack+2346, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+2355, vrr_stack+1344, vrr_stack+2349, vrr_stack+159, vrr_stack+1341, NULL);
 _BUILD_00g0(Data,vrr_stack+2365, vrr_stack+1350, vrr_stack+2355, vrr_stack+443, vrr_stack+1344, NULL);
 _BUILD_00h0(Data,vrr_stack+2380, vrr_stack+1360, vrr_stack+2365, vrr_stack+549, vrr_stack+1350, NULL);
 _BUILD_00i0(Data,vrr_stack+2401, vrr_stack+1375, vrr_stack+2380, vrr_stack+559, vrr_stack+1360, NULL);
 _BUILD_00k0(Data,vrr_stack+2429, vrr_stack+1396, vrr_stack+2401, vrr_stack+574, vrr_stack+1375, NULL);
 _BUILD_00l0(Data,vrr_stack+1161, vrr_stack+1424, vrr_stack+2429, vrr_stack+595, vrr_stack+1396, NULL);
 _BUILD_00m0(Data,vrr_stack+3567, vrr_stack+981, vrr_stack+1161, vrr_stack+623, vrr_stack+1424, NULL);
 _BUILD_00n0(Data,vrr_stack+78, vrr_stack+449, vrr_stack+3567, vrr_stack+659, vrr_stack+981, NULL);
 _BUILD_00o0(Data,vrr_stack+504, vrr_stack+6940, vrr_stack+78, vrr_stack+262, vrr_stack+449, NULL);
 _BUILD_00q0(Data,vrr_stack+582, vrr_stack+0, vrr_stack+504, vrr_stack+5080, vrr_stack+6940, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9092, vrr_stack+7006, vrr_stack+582, vrr_stack+5146, vrr_stack+0, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9197, vrr_stack+5224, vrr_stack+9092, NULL, NULL, vrr_stack+7006);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9512, vrr_stack+8462, vrr_stack+9197, vrr_stack+5329, vrr_stack+5224, vrr_stack+7097);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10142, vrr_stack+8777, vrr_stack+8462, vrr_stack+317, vrr_stack+5329, vrr_stack+6394);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7097, vrr_stack+5224, vrr_stack+9092, vrr_stack+3622, vrr_stack+7006, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7217, vrr_stack+5329, vrr_stack+5224, vrr_stack+3713, vrr_stack+3622, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+10772, vrr_stack+7217, vrr_stack+7097, NULL, NULL, vrr_stack+5224);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5080, vrr_stack+317, vrr_stack+5329, vrr_stack+162, vrr_stack+3713, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+11132, vrr_stack+5080, vrr_stack+7217, NULL, NULL, vrr_stack+5329);
 _BUILD_00p0(Data,vrr_stack+3622, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3625, vrr_stack+2346, vrr_stack+3622, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+3631, vrr_stack+2349, vrr_stack+3625, vrr_stack+1341, vrr_stack+2346, NULL);
 _BUILD_00g0(Data,vrr_stack+3641, vrr_stack+2355, vrr_stack+3631, vrr_stack+1344, vrr_stack+2349, NULL);
 _BUILD_00h0(Data,vrr_stack+3656, vrr_stack+2365, vrr_stack+3641, vrr_stack+1350, vrr_stack+2355, NULL);
 _BUILD_00i0(Data,vrr_stack+3677, vrr_stack+2380, vrr_stack+3656, vrr_stack+1360, vrr_stack+2365, NULL);
 _BUILD_00k0(Data,vrr_stack+3705, vrr_stack+2401, vrr_stack+3677, vrr_stack+1375, vrr_stack+2380, NULL);
 _BUILD_00l0(Data,vrr_stack+1341, vrr_stack+2429, vrr_stack+3705, vrr_stack+1396, vrr_stack+2401, NULL);
 _BUILD_00m0(Data,vrr_stack+3741, vrr_stack+1161, vrr_stack+1341, vrr_stack+1424, vrr_stack+2429, NULL);
 _BUILD_00n0(Data,vrr_stack+1386, vrr_stack+3567, vrr_stack+3741, vrr_stack+981, vrr_stack+1161, NULL);
 _BUILD_00o0(Data,vrr_stack+144, vrr_stack+78, vrr_stack+1386, vrr_stack+449, vrr_stack+3567, NULL);
 _BUILD_00q0(Data,vrr_stack+222, vrr_stack+504, vrr_stack+144, vrr_stack+6940, vrr_stack+78, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+11492, vrr_stack+582, vrr_stack+222, vrr_stack+0, vrr_stack+504, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+11597, vrr_stack+9092, vrr_stack+11492, vrr_stack+7006, vrr_stack+582, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+11717, vrr_stack+7097, vrr_stack+11597, NULL, NULL, vrr_stack+9092);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+12077, vrr_stack+10772, vrr_stack+11717, vrr_stack+7217, vrr_stack+7097, vrr_stack+9197);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+12797, vrr_stack+11132, vrr_stack+10772, vrr_stack+5080, vrr_stack+7217, vrr_stack+8462);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+9197, vrr_stack+7097, vrr_stack+11597, vrr_stack+5224, vrr_stack+9092, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+9333, vrr_stack+7217, vrr_stack+7097, vrr_stack+5329, vrr_stack+5224, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+13517, vrr_stack+9333, vrr_stack+9197, NULL, NULL, vrr_stack+7097);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6940, vrr_stack+5080, vrr_stack+7217, vrr_stack+317, vrr_stack+5329, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+13925, vrr_stack+6940, vrr_stack+9333, NULL, NULL, vrr_stack+7217);
 _BUILD_00p0(Data,vrr_stack+5080, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5083, vrr_stack+3622, vrr_stack+5080, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+5089, vrr_stack+3625, vrr_stack+5083, vrr_stack+2346, vrr_stack+3622, NULL);
 _BUILD_00g0(Data,vrr_stack+5099, vrr_stack+3631, vrr_stack+5089, vrr_stack+2349, vrr_stack+3625, NULL);
 _BUILD_00h0(Data,vrr_stack+5114, vrr_stack+3641, vrr_stack+5099, vrr_stack+2355, vrr_stack+3631, NULL);
 _BUILD_00i0(Data,vrr_stack+5080, vrr_stack+3656, vrr_stack+5114, vrr_stack+2365, vrr_stack+3641, NULL);
 _BUILD_00k0(Data,vrr_stack+5108, vrr_stack+3677, vrr_stack+5080, vrr_stack+2380, vrr_stack+3656, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+3705, vrr_stack+5108, vrr_stack+2401, vrr_stack+3677, NULL);
 _BUILD_00m0(Data,vrr_stack+5080, vrr_stack+1341, vrr_stack+981, vrr_stack+2429, vrr_stack+3705, NULL);
 _BUILD_00n0(Data,vrr_stack+5135, vrr_stack+3741, vrr_stack+5080, vrr_stack+1161, vrr_stack+1341, NULL);
 _BUILD_00o0(Data,vrr_stack+0, vrr_stack+1386, vrr_stack+5135, vrr_stack+3567, vrr_stack+3741, NULL);
 _BUILD_00q0(Data,vrr_stack+3567, vrr_stack+144, vrr_stack+0, vrr_stack+78, vrr_stack+1386, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+222, vrr_stack+3567, vrr_stack+504, vrr_stack+144, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3567, vrr_stack+11492, vrr_stack+0, vrr_stack+582, vrr_stack+222, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+11597, vrr_stack+3567, vrr_stack+9092, vrr_stack+11492, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+9197, vrr_stack+0, NULL, NULL, vrr_stack+11597);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+14333, vrr_stack+13517, vrr_stack+136, vrr_stack+9333, vrr_stack+9197, vrr_stack+11717);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15149, vrr_stack+13925, vrr_stack+13517, vrr_stack+6940, vrr_stack+9333, vrr_stack+10772);
 _BUILD_f0l0(Data,vrr_stack+0, vrr_stack+1746, vrr_stack+1476, vrr_stack+1206, vrr_stack+1026, vrr_stack+765);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0m0(Data,vrr_stack+450, vrr_stack+2841, vrr_stack+2511, vrr_stack+2181, vrr_stack+2016, vrr_stack+1476);
   tmp = vrr_stack + 450;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0n0(Data,vrr_stack+1000, vrr_stack+4216, vrr_stack+3820, vrr_stack+3369, vrr_stack+3171, vrr_stack+2511);
   tmp = vrr_stack + 1000;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0o0(Data,vrr_stack+1660, vrr_stack+5926, vrr_stack+5458, vrr_stack+4846, vrr_stack+4612, vrr_stack+3820);
   tmp = vrr_stack + 1660;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_f0q0(Data,vrr_stack+2440, vrr_stack+7916, vrr_stack+7370, vrr_stack+6667, vrr_stack+6394, vrr_stack+5458);
   tmp = vrr_stack + 2440;
   target_ptr = Libint->vrr_classes[3][12];
   for(i=0;i<910;i++)
     target_ptr[i] += tmp[i];
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3350, vrr_stack+10142, vrr_stack+9512, vrr_stack+8777, vrr_stack+8462, vrr_stack+7370);
   tmp = vrr_stack + 3350;
   target_ptr = Libint->vrr_classes[3][13];
   for(i=0;i<1050;i++)
     target_ptr[i] += tmp[i];
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4400, vrr_stack+12797, vrr_stack+12077, vrr_stack+11132, vrr_stack+10772, vrr_stack+9512);
   tmp = vrr_stack + 4400;
   target_ptr = Libint->vrr_classes[3][14];
   for(i=0;i<1200;i++)
     target_ptr[i] += tmp[i];
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+5600, vrr_stack+15149, vrr_stack+14333, vrr_stack+13925, vrr_stack+13517, vrr_stack+12077);
   tmp = vrr_stack + 5600;
   target_ptr = Libint->vrr_classes[3][15];
   for(i=0;i<1360;i++)
     target_ptr[i] += tmp[i];

}

