/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fd|kp) integrals */

void vrr_order_fdkp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+12, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+15, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+6, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+21, NULL, NULL, vrr_stack+6);
 _BUILD_00g0(Data,vrr_stack+80, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+3, vrr_stack+31, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+95, vrr_stack+34, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+101, vrr_stack+40, vrr_stack+95, vrr_stack+34, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+12, vrr_stack+31, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+126, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+136, vrr_stack+21, vrr_stack+126, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+151, vrr_stack+80, vrr_stack+136, NULL, NULL, vrr_stack+21);
 _BUILD_p0g0(Data,vrr_stack+196, vrr_stack+111, vrr_stack+80, NULL, NULL, vrr_stack+40);
 _BUILD_d0g0(Data,vrr_stack+241, vrr_stack+196, vrr_stack+151, vrr_stack+111, vrr_stack+80, vrr_stack+50);
 _BUILD_00h0(Data,vrr_stack+50, vrr_stack+80, vrr_stack+136, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+331, vrr_stack+111, vrr_stack+80, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+352, vrr_stack+331, vrr_stack+50, NULL, NULL, vrr_stack+80);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+6, vrr_stack+95, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+415, vrr_stack+40, vrr_stack+101, vrr_stack+6, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+430, vrr_stack+415, vrr_stack+111, vrr_stack+40, vrr_stack+101, NULL);
 _BUILD_p0h0(Data,vrr_stack+451, vrr_stack+430, vrr_stack+331, NULL, NULL, vrr_stack+111);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+31, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+34, vrr_stack+95, vrr_stack+12, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+514, vrr_stack+126, vrr_stack+101, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+529, vrr_stack+136, vrr_stack+514, vrr_stack+21, vrr_stack+126, NULL);
 _BUILD_p0h0(Data,vrr_stack+550, vrr_stack+50, vrr_stack+529, NULL, NULL, vrr_stack+136);
 _BUILD_d0h0(Data,vrr_stack+613, vrr_stack+352, vrr_stack+550, vrr_stack+331, vrr_stack+50, vrr_stack+151);
 _BUILD_d0h0(Data,vrr_stack+739, vrr_stack+451, vrr_stack+352, vrr_stack+430, vrr_stack+331, vrr_stack+196);
 _BUILD_f0h0(Data,vrr_stack+865, vrr_stack+739, vrr_stack+613, vrr_stack+451, vrr_stack+352, vrr_stack+241);
 _BUILD_00i0(Data,vrr_stack+151, vrr_stack+331, vrr_stack+50, vrr_stack+111, vrr_stack+80, NULL);
 _BUILD_00i0(Data,vrr_stack+179, vrr_stack+430, vrr_stack+331, vrr_stack+415, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+207, vrr_stack+50, vrr_stack+529, vrr_stack+80, vrr_stack+136, NULL);
 _BUILD_p0i0(Data,vrr_stack+235, vrr_stack+151, vrr_stack+207, NULL, NULL, vrr_stack+50);
 _BUILD_p0i0(Data,vrr_stack+1075, vrr_stack+179, vrr_stack+151, NULL, NULL, vrr_stack+331);
 _BUILD_d0i0(Data,vrr_stack+1159, vrr_stack+1075, vrr_stack+235, vrr_stack+179, vrr_stack+151, vrr_stack+352);
 _BUILD_00p0(Data,vrr_stack+352, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+355, vrr_stack+352, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+361, vrr_stack+355, vrr_stack+6, vrr_stack+352, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+361, vrr_stack+40, vrr_stack+355, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+6, vrr_stack+111, vrr_stack+415, vrr_stack+361, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+371, vrr_stack+6, vrr_stack+430, vrr_stack+111, vrr_stack+415, NULL);
 _BUILD_p0i0(Data,vrr_stack+1327, vrr_stack+371, vrr_stack+179, NULL, NULL, vrr_stack+430);
 _BUILD_d0i0(Data,vrr_stack+1411, vrr_stack+1327, vrr_stack+1075, vrr_stack+371, vrr_stack+179, vrr_stack+451);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+451, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+95, vrr_stack+451, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+457, vrr_stack+101, vrr_stack+40, vrr_stack+34, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+472, vrr_stack+514, vrr_stack+457, vrr_stack+126, vrr_stack+101, NULL);
 _BUILD_00i0(Data,vrr_stack+399, vrr_stack+529, vrr_stack+472, vrr_stack+136, vrr_stack+514, NULL);
 _BUILD_p0i0(Data,vrr_stack+1579, vrr_stack+207, vrr_stack+399, NULL, NULL, vrr_stack+529);
 _BUILD_d0i0(Data,vrr_stack+1663, vrr_stack+235, vrr_stack+1579, vrr_stack+151, vrr_stack+207, vrr_stack+550);
 _BUILD_f0i0(Data,vrr_stack+1831, vrr_stack+1159, vrr_stack+1663, vrr_stack+1075, vrr_stack+235, vrr_stack+613);
 _BUILD_f0i0(Data,vrr_stack+2111, vrr_stack+1411, vrr_stack+1159, vrr_stack+1327, vrr_stack+1075, vrr_stack+739);
 _BUILD_g0i0(Data,vrr_stack+2391, vrr_stack+2111, vrr_stack+1831, vrr_stack+1411, vrr_stack+1159, vrr_stack+865);
 _BUILD_00k0(Data,vrr_stack+550, vrr_stack+151, vrr_stack+207, vrr_stack+331, vrr_stack+50, NULL);
 _BUILD_00k0(Data,vrr_stack+586, vrr_stack+179, vrr_stack+151, vrr_stack+430, vrr_stack+331, NULL);
 _BUILD_p0k0(Data,vrr_stack+622, vrr_stack+586, vrr_stack+550, NULL, NULL, vrr_stack+151);
 _BUILD_00k0(Data,vrr_stack+730, vrr_stack+371, vrr_stack+179, vrr_stack+6, vrr_stack+430, NULL);
 _BUILD_p0k0(Data,vrr_stack+766, vrr_stack+730, vrr_stack+586, NULL, NULL, vrr_stack+179);
 _BUILD_00k0(Data,vrr_stack+874, vrr_stack+207, vrr_stack+399, vrr_stack+50, vrr_stack+529, NULL);
 _BUILD_p0k0(Data,vrr_stack+910, vrr_stack+550, vrr_stack+874, NULL, NULL, vrr_stack+207);
 _BUILD_d0k0(Data,vrr_stack+2811, vrr_stack+622, vrr_stack+910, vrr_stack+586, vrr_stack+550, vrr_stack+235);
 _BUILD_d0k0(Data,vrr_stack+3027, vrr_stack+766, vrr_stack+622, vrr_stack+730, vrr_stack+586, vrr_stack+1075);
 _BUILD_f0k0(Data,vrr_stack+3243, vrr_stack+3027, vrr_stack+2811, vrr_stack+766, vrr_stack+622, vrr_stack+1159);
 _BUILD_00p0(Data,vrr_stack+235, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+238, vrr_stack+235, vrr_stack+352, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+244, vrr_stack+238, vrr_stack+355, vrr_stack+235, vrr_stack+352, NULL);
 _BUILD_00g0(Data,vrr_stack+254, vrr_stack+244, vrr_stack+361, vrr_stack+238, vrr_stack+355, NULL);
 _BUILD_00h0(Data,vrr_stack+493, vrr_stack+254, vrr_stack+111, vrr_stack+244, vrr_stack+361, NULL);
 _BUILD_00i0(Data,vrr_stack+269, vrr_stack+493, vrr_stack+6, vrr_stack+254, vrr_stack+111, NULL);
 _BUILD_00k0(Data,vrr_stack+111, vrr_stack+269, vrr_stack+371, vrr_stack+493, vrr_stack+6, NULL);
 _BUILD_p0k0(Data,vrr_stack+1018, vrr_stack+111, vrr_stack+730, NULL, NULL, vrr_stack+371);
 _BUILD_d0k0(Data,vrr_stack+3603, vrr_stack+1018, vrr_stack+766, vrr_stack+111, vrr_stack+730, vrr_stack+1327);
 _BUILD_f0k0(Data,vrr_stack+3819, vrr_stack+3603, vrr_stack+3027, vrr_stack+1018, vrr_stack+766, vrr_stack+1411);
   tmp = vrr_stack + 3819;
   target_ptr = Libint->vrr_classes[3][7];
   for(i=0;i<360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+1018, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1021, vrr_stack+0, vrr_stack+1018, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+1027, vrr_stack+451, vrr_stack+1021, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+40, vrr_stack+1027, vrr_stack+95, vrr_stack+451, NULL);
 _BUILD_00h0(Data,vrr_stack+493, vrr_stack+457, vrr_stack+3, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+1037, vrr_stack+472, vrr_stack+493, vrr_stack+514, vrr_stack+457, NULL);
 _BUILD_00k0(Data,vrr_stack+1065, vrr_stack+399, vrr_stack+1037, vrr_stack+529, vrr_stack+472, NULL);
 _BUILD_p0k0(Data,vrr_stack+1101, vrr_stack+874, vrr_stack+1065, NULL, NULL, vrr_stack+399);
 _BUILD_d0k0(Data,vrr_stack+1209, vrr_stack+910, vrr_stack+1101, vrr_stack+550, vrr_stack+874, vrr_stack+1579);
 _BUILD_f0k0(Data,vrr_stack+4179, vrr_stack+2811, vrr_stack+1209, vrr_stack+622, vrr_stack+910, vrr_stack+1663);
 _BUILD_g0k0(Data,vrr_stack+4539, vrr_stack+3243, vrr_stack+4179, vrr_stack+3027, vrr_stack+2811, vrr_stack+1831);
 _BUILD_g0k0(Data,vrr_stack+1425, vrr_stack+3819, vrr_stack+3243, vrr_stack+3603, vrr_stack+3027, vrr_stack+2111);
   tmp = vrr_stack + 1425;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+3603, vrr_stack+550, vrr_stack+874, vrr_stack+151, vrr_stack+207, NULL);
 _BUILD_00l0(Data,vrr_stack+3648, vrr_stack+586, vrr_stack+550, vrr_stack+179, vrr_stack+151, NULL);
 _BUILD_p0l0(Data,vrr_stack+1965, vrr_stack+3648, vrr_stack+3603, NULL, NULL, vrr_stack+550);
 _BUILD_00l0(Data,vrr_stack+3693, vrr_stack+730, vrr_stack+586, vrr_stack+371, vrr_stack+179, NULL);
 _BUILD_p0l0(Data,vrr_stack+2100, vrr_stack+3693, vrr_stack+3648, NULL, NULL, vrr_stack+586);
 _BUILD_00l0(Data,vrr_stack+3738, vrr_stack+874, vrr_stack+1065, vrr_stack+207, vrr_stack+399, NULL);
 _BUILD_p0l0(Data,vrr_stack+2235, vrr_stack+3603, vrr_stack+3738, NULL, NULL, vrr_stack+874);
 _BUILD_d0l0(Data,vrr_stack+5079, vrr_stack+1965, vrr_stack+2235, vrr_stack+3648, vrr_stack+3603, vrr_stack+910);
 _BUILD_d0l0(Data,vrr_stack+5349, vrr_stack+2100, vrr_stack+1965, vrr_stack+3693, vrr_stack+3648, vrr_stack+622);
 _BUILD_f0l0(Data,vrr_stack+5619, vrr_stack+5349, vrr_stack+5079, vrr_stack+2100, vrr_stack+1965, vrr_stack+2811);
 _BUILD_00l0(Data,vrr_stack+3648, vrr_stack+111, vrr_stack+730, vrr_stack+269, vrr_stack+371, NULL);
 _BUILD_p0l0(Data,vrr_stack+2811, vrr_stack+3648, vrr_stack+3693, NULL, NULL, vrr_stack+730);
 _BUILD_d0l0(Data,vrr_stack+50, vrr_stack+2811, vrr_stack+2100, vrr_stack+3648, vrr_stack+3693, vrr_stack+766);
 _BUILD_f0l0(Data,vrr_stack+514, vrr_stack+50, vrr_stack+5349, vrr_stack+2811, vrr_stack+2100, vrr_stack+3027);
   tmp = vrr_stack + 514;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+2100, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2103, vrr_stack+1018, vrr_stack+2100, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+2109, vrr_stack+1021, vrr_stack+2103, vrr_stack+0, vrr_stack+1018, NULL);
 _BUILD_00g0(Data,vrr_stack+2119, vrr_stack+1027, vrr_stack+2109, vrr_stack+451, vrr_stack+1021, NULL);
 _BUILD_00h0(Data,vrr_stack+2370, vrr_stack+3, vrr_stack+2119, vrr_stack+40, vrr_stack+1027, NULL);
 _BUILD_00i0(Data,vrr_stack+2100, vrr_stack+493, vrr_stack+2370, vrr_stack+457, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+3783, vrr_stack+1037, vrr_stack+2100, vrr_stack+472, vrr_stack+493, NULL);
 _BUILD_00l0(Data,vrr_stack+2100, vrr_stack+1065, vrr_stack+3783, vrr_stack+399, vrr_stack+1037, NULL);
 _BUILD_p0l0(Data,vrr_stack+2811, vrr_stack+3738, vrr_stack+2100, NULL, NULL, vrr_stack+1065);
 _BUILD_d0l0(Data,vrr_stack+2946, vrr_stack+2235, vrr_stack+2811, vrr_stack+3603, vrr_stack+3738, vrr_stack+1101);
 _BUILD_f0l0(Data,vrr_stack+6069, vrr_stack+5079, vrr_stack+2946, vrr_stack+1965, vrr_stack+2235, vrr_stack+1209);
 _BUILD_g0l0(Data,vrr_stack+6519, vrr_stack+5619, vrr_stack+6069, vrr_stack+5349, vrr_stack+5079, vrr_stack+4179);
 _BUILD_g0l0(Data,vrr_stack+7194, vrr_stack+514, vrr_stack+5619, vrr_stack+50, vrr_stack+5349, vrr_stack+3243);
   tmp = vrr_stack + 7194;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0k0(Data,vrr_stack+7869, vrr_stack+1425, vrr_stack+4539, vrr_stack+3819, vrr_stack+3243, vrr_stack+2391);
   tmp = vrr_stack + 7869;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0l0(Data,vrr_stack+964, vrr_stack+7194, vrr_stack+6519, vrr_stack+514, vrr_stack+5619, vrr_stack+4539);
   tmp = vrr_stack + 964;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];

}

