/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fp|ll) integrals */

void vrr_order_fpll(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+21, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+24, vrr_stack+65, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+30, vrr_stack+71, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+50, vrr_stack+81, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+12, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+6, vrr_stack+15, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+50, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+96, NULL, NULL, vrr_stack+50);
 _BUILD_00i0(Data,vrr_stack+226, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+254, vrr_stack+43, vrr_stack+6, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+264, vrr_stack+254, vrr_stack+117, vrr_stack+43, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+279, vrr_stack+264, vrr_stack+127, vrr_stack+254, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+300, vrr_stack+279, vrr_stack+142, vrr_stack+264, vrr_stack+127, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+123, vrr_stack+65, vrr_stack+117, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+71, vrr_stack+123, vrr_stack+24, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+328, vrr_stack+81, vrr_stack+6, vrr_stack+30, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+349, vrr_stack+96, vrr_stack+328, vrr_stack+50, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+377, vrr_stack+226, vrr_stack+349, NULL, NULL, vrr_stack+96);
 _BUILD_p0i0(Data,vrr_stack+461, vrr_stack+300, vrr_stack+226, NULL, NULL, vrr_stack+142);
 _BUILD_d0i0(Data,vrr_stack+545, vrr_stack+461, vrr_stack+377, vrr_stack+300, vrr_stack+226, vrr_stack+163);
 _BUILD_00k0(Data,vrr_stack+163, vrr_stack+226, vrr_stack+349, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00k0(Data,vrr_stack+713, vrr_stack+300, vrr_stack+226, vrr_stack+279, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+749, vrr_stack+713, vrr_stack+163, NULL, NULL, vrr_stack+226);
 _BUILD_00p0(Data,vrr_stack+199, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+202, vrr_stack+199, vrr_stack+40, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+208, vrr_stack+202, vrr_stack+43, vrr_stack+199, vrr_stack+40, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+208, vrr_stack+254, vrr_stack+202, vrr_stack+43, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+133, vrr_stack+264, vrr_stack+208, vrr_stack+254, NULL);
 _BUILD_00i0(Data,vrr_stack+857, vrr_stack+21, vrr_stack+279, vrr_stack+133, vrr_stack+264, NULL);
 _BUILD_00k0(Data,vrr_stack+885, vrr_stack+857, vrr_stack+300, vrr_stack+21, vrr_stack+279, NULL);
 _BUILD_p0k0(Data,vrr_stack+921, vrr_stack+885, vrr_stack+713, NULL, NULL, vrr_stack+300);
 _BUILD_00p0(Data,vrr_stack+254, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+257, vrr_stack+0, vrr_stack+254, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+263, vrr_stack+117, vrr_stack+257, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+148, vrr_stack+123, vrr_stack+263, vrr_stack+65, vrr_stack+117, NULL);
 _BUILD_00h0(Data,vrr_stack+273, vrr_stack+6, vrr_stack+148, vrr_stack+71, vrr_stack+123, NULL);
 _BUILD_00i0(Data,vrr_stack+42, vrr_stack+328, vrr_stack+273, vrr_stack+81, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+1029, vrr_stack+349, vrr_stack+42, vrr_stack+96, vrr_stack+328, NULL);
 _BUILD_p0k0(Data,vrr_stack+1065, vrr_stack+163, vrr_stack+1029, NULL, NULL, vrr_stack+349);
 _BUILD_d0k0(Data,vrr_stack+1173, vrr_stack+749, vrr_stack+1065, vrr_stack+713, vrr_stack+163, vrr_stack+377);
 _BUILD_d0k0(Data,vrr_stack+1389, vrr_stack+921, vrr_stack+749, vrr_stack+885, vrr_stack+713, vrr_stack+461);
 _BUILD_f0k0(Data,vrr_stack+1605, vrr_stack+1389, vrr_stack+1173, vrr_stack+921, vrr_stack+749, vrr_stack+545);
 _BUILD_00l0(Data,vrr_stack+377, vrr_stack+713, vrr_stack+163, vrr_stack+300, vrr_stack+226, NULL);
 _BUILD_00l0(Data,vrr_stack+422, vrr_stack+885, vrr_stack+713, vrr_stack+857, vrr_stack+300, NULL);
 _BUILD_00l0(Data,vrr_stack+467, vrr_stack+163, vrr_stack+1029, vrr_stack+226, vrr_stack+349, NULL);
 _BUILD_p0l0(Data,vrr_stack+512, vrr_stack+377, vrr_stack+467, NULL, NULL, vrr_stack+163);
 _BUILD_p0l0(Data,vrr_stack+1965, vrr_stack+422, vrr_stack+377, NULL, NULL, vrr_stack+713);
 _BUILD_d0l0(Data,vrr_stack+2100, vrr_stack+1965, vrr_stack+512, vrr_stack+422, vrr_stack+377, vrr_stack+749);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+749, vrr_stack+3, vrr_stack+199, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+755, vrr_stack+749, vrr_stack+202, vrr_stack+3, vrr_stack+199, NULL);
 _BUILD_00g0(Data,vrr_stack+765, vrr_stack+755, vrr_stack+208, vrr_stack+749, vrr_stack+202, NULL);
 _BUILD_00h0(Data,vrr_stack+780, vrr_stack+765, vrr_stack+133, vrr_stack+755, vrr_stack+208, NULL);
 _BUILD_00i0(Data,vrr_stack+199, vrr_stack+780, vrr_stack+21, vrr_stack+765, vrr_stack+133, NULL);
 _BUILD_00k0(Data,vrr_stack+801, vrr_stack+199, vrr_stack+857, vrr_stack+780, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+749, vrr_stack+801, vrr_stack+885, vrr_stack+199, vrr_stack+857, NULL);
 _BUILD_p0l0(Data,vrr_stack+2370, vrr_stack+749, vrr_stack+422, NULL, NULL, vrr_stack+885);
 _BUILD_d0l0(Data,vrr_stack+2505, vrr_stack+2370, vrr_stack+1965, vrr_stack+749, vrr_stack+422, vrr_stack+921);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+921, vrr_stack+254, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+927, vrr_stack+257, vrr_stack+921, vrr_stack+0, vrr_stack+254, NULL);
 _BUILD_00g0(Data,vrr_stack+133, vrr_stack+263, vrr_stack+927, vrr_stack+117, vrr_stack+257, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+148, vrr_stack+133, vrr_stack+123, vrr_stack+263, NULL);
 _BUILD_00i0(Data,vrr_stack+937, vrr_stack+273, vrr_stack+21, vrr_stack+6, vrr_stack+148, NULL);
 _BUILD_00k0(Data,vrr_stack+965, vrr_stack+42, vrr_stack+937, vrr_stack+328, vrr_stack+273, NULL);
 _BUILD_00l0(Data,vrr_stack+199, vrr_stack+1029, vrr_stack+965, vrr_stack+349, vrr_stack+42, NULL);
 _BUILD_p0l0(Data,vrr_stack+2775, vrr_stack+467, vrr_stack+199, NULL, NULL, vrr_stack+1029);
 _BUILD_d0l0(Data,vrr_stack+2910, vrr_stack+512, vrr_stack+2775, vrr_stack+377, vrr_stack+467, vrr_stack+1065);
 _BUILD_f0l0(Data,vrr_stack+3180, vrr_stack+2100, vrr_stack+2910, vrr_stack+1965, vrr_stack+512, vrr_stack+1173);
 _BUILD_f0l0(Data,vrr_stack+3630, vrr_stack+2505, vrr_stack+2100, vrr_stack+2370, vrr_stack+1965, vrr_stack+1389);
   tmp = vrr_stack + 3630;
   target_ptr = Libint->vrr_classes[3][8];
   for(i=0;i<450;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+2370, vrr_stack+377, vrr_stack+467, vrr_stack+713, vrr_stack+163, NULL);
 _BUILD_00m0(Data,vrr_stack+2425, vrr_stack+422, vrr_stack+377, vrr_stack+885, vrr_stack+713, NULL);
 _BUILD_00m0(Data,vrr_stack+1065, vrr_stack+467, vrr_stack+199, vrr_stack+163, vrr_stack+1029, NULL);
 _BUILD_p0m0(Data,vrr_stack+1120, vrr_stack+2370, vrr_stack+1065, NULL, NULL, vrr_stack+467);
 _BUILD_p0m0(Data,vrr_stack+1285, vrr_stack+2425, vrr_stack+2370, NULL, NULL, vrr_stack+377);
 _BUILD_d0m0(Data,vrr_stack+4080, vrr_stack+1285, vrr_stack+1120, vrr_stack+2425, vrr_stack+2370, vrr_stack+512);
 _BUILD_00m0(Data,vrr_stack+512, vrr_stack+749, vrr_stack+422, vrr_stack+801, vrr_stack+885, NULL);
 _BUILD_p0m0(Data,vrr_stack+567, vrr_stack+512, vrr_stack+2425, NULL, NULL, vrr_stack+422);
 _BUILD_d0m0(Data,vrr_stack+4410, vrr_stack+567, vrr_stack+1285, vrr_stack+512, vrr_stack+2425, vrr_stack+1965);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1965, vrr_stack+3, vrr_stack+0, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+244, vrr_stack+921, vrr_stack+1965, vrr_stack+254, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+927, vrr_stack+244, vrr_stack+257, vrr_stack+921, NULL);
 _BUILD_00h0(Data,vrr_stack+1971, vrr_stack+133, vrr_stack+6, vrr_stack+263, vrr_stack+927, NULL);
 _BUILD_00i0(Data,vrr_stack+1001, vrr_stack+21, vrr_stack+1971, vrr_stack+148, vrr_stack+133, NULL);
 _BUILD_00k0(Data,vrr_stack+148, vrr_stack+937, vrr_stack+1001, vrr_stack+273, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+254, vrr_stack+965, vrr_stack+148, vrr_stack+42, vrr_stack+937, NULL);
 _BUILD_00m0(Data,vrr_stack+42, vrr_stack+199, vrr_stack+254, vrr_stack+1029, vrr_stack+965, NULL);
 _BUILD_p0m0(Data,vrr_stack+4740, vrr_stack+1065, vrr_stack+42, NULL, NULL, vrr_stack+199);
 _BUILD_d0m0(Data,vrr_stack+4905, vrr_stack+1120, vrr_stack+4740, vrr_stack+2370, vrr_stack+1065, vrr_stack+2775);
 _BUILD_f0m0(Data,vrr_stack+5235, vrr_stack+4080, vrr_stack+4905, vrr_stack+1285, vrr_stack+1120, vrr_stack+2910);
 _BUILD_f0m0(Data,vrr_stack+5785, vrr_stack+4410, vrr_stack+4080, vrr_stack+567, vrr_stack+1285, vrr_stack+2100);
   tmp = vrr_stack + 5785;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+567, vrr_stack+2370, vrr_stack+1065, vrr_stack+377, vrr_stack+467, NULL);
 _BUILD_00n0(Data,vrr_stack+633, vrr_stack+2425, vrr_stack+2370, vrr_stack+422, vrr_stack+377, NULL);
 _BUILD_00n0(Data,vrr_stack+2775, vrr_stack+1065, vrr_stack+42, vrr_stack+467, vrr_stack+199, NULL);
 _BUILD_p0n0(Data,vrr_stack+2841, vrr_stack+567, vrr_stack+2775, NULL, NULL, vrr_stack+1065);
 _BUILD_p0n0(Data,vrr_stack+6335, vrr_stack+633, vrr_stack+567, NULL, NULL, vrr_stack+2370);
 _BUILD_d0n0(Data,vrr_stack+6533, vrr_stack+6335, vrr_stack+2841, vrr_stack+633, vrr_stack+567, vrr_stack+1120);
 _BUILD_00n0(Data,vrr_stack+1120, vrr_stack+512, vrr_stack+2425, vrr_stack+749, vrr_stack+422, NULL);
 _BUILD_p0n0(Data,vrr_stack+699, vrr_stack+1120, vrr_stack+633, NULL, NULL, vrr_stack+2425);
 _BUILD_d0n0(Data,vrr_stack+6929, vrr_stack+699, vrr_stack+6335, vrr_stack+1120, vrr_stack+633, vrr_stack+1285);
 _BUILD_00p0(Data,vrr_stack+1186, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1189, vrr_stack+0, vrr_stack+1186, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+1195, vrr_stack+1965, vrr_stack+1189, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+184, vrr_stack+244, vrr_stack+1195, vrr_stack+921, vrr_stack+1965, NULL);
 _BUILD_00h0(Data,vrr_stack+1205, vrr_stack+6, vrr_stack+184, vrr_stack+927, vrr_stack+244, NULL);
 _BUILD_00i0(Data,vrr_stack+1226, vrr_stack+1971, vrr_stack+1205, vrr_stack+133, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+1029, vrr_stack+1001, vrr_stack+1226, vrr_stack+21, vrr_stack+1971, NULL);
 _BUILD_00l0(Data,vrr_stack+1254, vrr_stack+148, vrr_stack+1029, vrr_stack+937, vrr_stack+1001, NULL);
 _BUILD_00m0(Data,vrr_stack+1299, vrr_stack+254, vrr_stack+1254, vrr_stack+965, vrr_stack+148, NULL);
 _BUILD_00n0(Data,vrr_stack+1354, vrr_stack+42, vrr_stack+1299, vrr_stack+199, vrr_stack+254, NULL);
 _BUILD_p0n0(Data,vrr_stack+299, vrr_stack+2775, vrr_stack+1354, NULL, NULL, vrr_stack+42);
 _BUILD_d0n0(Data,vrr_stack+7325, vrr_stack+2841, vrr_stack+299, vrr_stack+567, vrr_stack+2775, vrr_stack+4740);
 _BUILD_f0n0(Data,vrr_stack+7721, vrr_stack+6533, vrr_stack+7325, vrr_stack+6335, vrr_stack+2841, vrr_stack+4905);
 _BUILD_f0n0(Data,vrr_stack+8381, vrr_stack+6929, vrr_stack+6533, vrr_stack+699, vrr_stack+6335, vrr_stack+4080);
   tmp = vrr_stack + 8381;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+699, vrr_stack+567, vrr_stack+2775, vrr_stack+2370, vrr_stack+1065, NULL);
 _BUILD_00o0(Data,vrr_stack+777, vrr_stack+633, vrr_stack+567, vrr_stack+2425, vrr_stack+2370, NULL);
 _BUILD_00o0(Data,vrr_stack+855, vrr_stack+2775, vrr_stack+1354, vrr_stack+1065, vrr_stack+42, NULL);
 _BUILD_p0o0(Data,vrr_stack+4740, vrr_stack+699, vrr_stack+855, NULL, NULL, vrr_stack+2775);
 _BUILD_p0o0(Data,vrr_stack+4974, vrr_stack+777, vrr_stack+699, NULL, NULL, vrr_stack+567);
 _BUILD_d0o0(Data,vrr_stack+9041, vrr_stack+4974, vrr_stack+4740, vrr_stack+777, vrr_stack+699, vrr_stack+2841);
 _BUILD_00o0(Data,vrr_stack+2841, vrr_stack+1120, vrr_stack+633, vrr_stack+512, vrr_stack+2425, NULL);
 _BUILD_p0o0(Data,vrr_stack+2919, vrr_stack+2841, vrr_stack+777, NULL, NULL, vrr_stack+633);
 _BUILD_d0o0(Data,vrr_stack+9509, vrr_stack+2919, vrr_stack+4974, vrr_stack+2841, vrr_stack+777, vrr_stack+6335);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6335, vrr_stack+1186, vrr_stack+3, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+6341, vrr_stack+1189, vrr_stack+6335, vrr_stack+0, vrr_stack+1186, NULL);
 _BUILD_00g0(Data,vrr_stack+6351, vrr_stack+1195, vrr_stack+6341, vrr_stack+1965, vrr_stack+1189, NULL);
 _BUILD_00h0(Data,vrr_stack+21, vrr_stack+184, vrr_stack+6351, vrr_stack+244, vrr_stack+1195, NULL);
 _BUILD_00i0(Data,vrr_stack+6366, vrr_stack+1205, vrr_stack+21, vrr_stack+6, vrr_stack+184, NULL);
 _BUILD_00k0(Data,vrr_stack+6394, vrr_stack+1226, vrr_stack+6366, vrr_stack+1971, vrr_stack+1205, NULL);
 _BUILD_00l0(Data,vrr_stack+1965, vrr_stack+1029, vrr_stack+6394, vrr_stack+1001, vrr_stack+1226, NULL);
 _BUILD_00m0(Data,vrr_stack+1065, vrr_stack+1254, vrr_stack+1965, vrr_stack+148, vrr_stack+1029, NULL);
 _BUILD_00n0(Data,vrr_stack+2010, vrr_stack+1299, vrr_stack+1065, vrr_stack+254, vrr_stack+1254, NULL);
 _BUILD_00o0(Data,vrr_stack+6430, vrr_stack+1354, vrr_stack+2010, vrr_stack+42, vrr_stack+1299, NULL);
 _BUILD_p0o0(Data,vrr_stack+9977, vrr_stack+855, vrr_stack+6430, NULL, NULL, vrr_stack+1354);
 _BUILD_d0o0(Data,vrr_stack+10211, vrr_stack+4740, vrr_stack+9977, vrr_stack+699, vrr_stack+855, vrr_stack+299);
 _BUILD_f0o0(Data,vrr_stack+10679, vrr_stack+9041, vrr_stack+10211, vrr_stack+4974, vrr_stack+4740, vrr_stack+7325);
 _BUILD_f0o0(Data,vrr_stack+11459, vrr_stack+9509, vrr_stack+9041, vrr_stack+2919, vrr_stack+4974, vrr_stack+6533);
   tmp = vrr_stack + 11459;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+2919, vrr_stack+699, vrr_stack+855, vrr_stack+567, vrr_stack+2775, NULL);
 _BUILD_00q0(Data,vrr_stack+3010, vrr_stack+777, vrr_stack+699, vrr_stack+633, vrr_stack+567, NULL);
 _BUILD_00q0(Data,vrr_stack+7325, vrr_stack+855, vrr_stack+6430, vrr_stack+2775, vrr_stack+1354, NULL);
 _BUILD_p0q0(Data,vrr_stack+7416, vrr_stack+2919, vrr_stack+7325, NULL, NULL, vrr_stack+855);
 _BUILD_p0q0(Data,vrr_stack+199, vrr_stack+3010, vrr_stack+2919, NULL, NULL, vrr_stack+699);
 _BUILD_d0q0(Data,vrr_stack+12239, vrr_stack+199, vrr_stack+7416, vrr_stack+3010, vrr_stack+2919, vrr_stack+4740);
 _BUILD_00q0(Data,vrr_stack+4740, vrr_stack+2841, vrr_stack+777, vrr_stack+1120, vrr_stack+633, NULL);
 _BUILD_p0q0(Data,vrr_stack+12785, vrr_stack+4740, vrr_stack+3010, NULL, NULL, vrr_stack+777);
 _BUILD_d0q0(Data,vrr_stack+13058, vrr_stack+12785, vrr_stack+199, vrr_stack+4740, vrr_stack+3010, vrr_stack+4974);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1120, vrr_stack+3, vrr_stack+0, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+1126, vrr_stack+6335, vrr_stack+1120, vrr_stack+1186, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+6341, vrr_stack+1126, vrr_stack+1189, vrr_stack+6335, NULL);
 _BUILD_00h0(Data,vrr_stack+1136, vrr_stack+6351, vrr_stack+6, vrr_stack+1195, vrr_stack+6341, NULL);
 _BUILD_00i0(Data,vrr_stack+1157, vrr_stack+21, vrr_stack+1136, vrr_stack+184, vrr_stack+6351, NULL);
 _BUILD_00k0(Data,vrr_stack+4831, vrr_stack+6366, vrr_stack+1157, vrr_stack+1205, vrr_stack+21, NULL);
 _BUILD_00l0(Data,vrr_stack+4867, vrr_stack+6394, vrr_stack+4831, vrr_stack+1226, vrr_stack+6366, NULL);
 _BUILD_00m0(Data,vrr_stack+1185, vrr_stack+1965, vrr_stack+4867, vrr_stack+1029, vrr_stack+6394, NULL);
 _BUILD_00n0(Data,vrr_stack+2775, vrr_stack+1065, vrr_stack+1185, vrr_stack+1254, vrr_stack+1965, NULL);
 _BUILD_00o0(Data,vrr_stack+4912, vrr_stack+2010, vrr_stack+2775, vrr_stack+1299, vrr_stack+1065, NULL);
 _BUILD_00q0(Data,vrr_stack+1240, vrr_stack+6430, vrr_stack+4912, vrr_stack+1354, vrr_stack+2010, NULL);
 _BUILD_p0q0(Data,vrr_stack+1331, vrr_stack+7325, vrr_stack+1240, NULL, NULL, vrr_stack+6430);
 _BUILD_d0q0(Data,vrr_stack+13604, vrr_stack+7416, vrr_stack+1331, vrr_stack+2919, vrr_stack+7325, vrr_stack+9977);
 _BUILD_f0q0(Data,vrr_stack+14150, vrr_stack+12239, vrr_stack+13604, vrr_stack+199, vrr_stack+7416, vrr_stack+10211);
 _BUILD_f0q0(Data,vrr_stack+15060, vrr_stack+13058, vrr_stack+12239, vrr_stack+12785, vrr_stack+199, vrr_stack+9041);
   tmp = vrr_stack + 15060;
   target_ptr = Libint->vrr_classes[3][12];
   for(i=0;i<910;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12785, vrr_stack+2919, vrr_stack+7325, vrr_stack+699, vrr_stack+855, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12890, vrr_stack+3010, vrr_stack+2919, vrr_stack+777, vrr_stack+699, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9977, vrr_stack+7325, vrr_stack+1240, vrr_stack+855, vrr_stack+6430, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10082, vrr_stack+12785, vrr_stack+9977, NULL, NULL, vrr_stack+7325);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15970, vrr_stack+12890, vrr_stack+12785, NULL, NULL, vrr_stack+2919);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+16285, vrr_stack+15970, vrr_stack+10082, vrr_stack+12890, vrr_stack+12785, vrr_stack+7416);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+7416, vrr_stack+4740, vrr_stack+3010, vrr_stack+2841, vrr_stack+777, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+472, vrr_stack+7416, vrr_stack+12890, NULL, NULL, vrr_stack+3010);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+16915, vrr_stack+472, vrr_stack+15970, vrr_stack+7416, vrr_stack+12890, vrr_stack+199);
 _BUILD_00p0(Data,vrr_stack+2841, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2844, vrr_stack+0, vrr_stack+2841, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+2850, vrr_stack+1120, vrr_stack+2844, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+2860, vrr_stack+1126, vrr_stack+2850, vrr_stack+6335, vrr_stack+1120, NULL);
 _BUILD_00h0(Data,vrr_stack+2875, vrr_stack+6, vrr_stack+2860, vrr_stack+6341, vrr_stack+1126, NULL);
 _BUILD_00i0(Data,vrr_stack+7521, vrr_stack+1136, vrr_stack+2875, vrr_stack+6351, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+7549, vrr_stack+1157, vrr_stack+7521, vrr_stack+21, vrr_stack+1136, NULL);
 _BUILD_00l0(Data,vrr_stack+21, vrr_stack+4831, vrr_stack+7549, vrr_stack+6366, vrr_stack+1157, NULL);
 _BUILD_00m0(Data,vrr_stack+66, vrr_stack+4867, vrr_stack+21, vrr_stack+6394, vrr_stack+4831, NULL);
 _BUILD_00n0(Data,vrr_stack+121, vrr_stack+1185, vrr_stack+66, vrr_stack+1965, vrr_stack+4867, NULL);
 _BUILD_00o0(Data,vrr_stack+187, vrr_stack+2775, vrr_stack+121, vrr_stack+1065, vrr_stack+1185, NULL);
 _BUILD_00q0(Data,vrr_stack+265, vrr_stack+4912, vrr_stack+187, vrr_stack+2010, vrr_stack+2775, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1965, vrr_stack+1240, vrr_stack+265, vrr_stack+6430, vrr_stack+4912, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+787, vrr_stack+9977, vrr_stack+1965, NULL, NULL, vrr_stack+1240);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+17545, vrr_stack+10082, vrr_stack+787, vrr_stack+12785, vrr_stack+9977, vrr_stack+1331);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+18175, vrr_stack+16285, vrr_stack+17545, vrr_stack+15970, vrr_stack+10082, vrr_stack+13604);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+19225, vrr_stack+16915, vrr_stack+16285, vrr_stack+472, vrr_stack+15970, vrr_stack+12239);
   tmp = vrr_stack + 19225;
   target_ptr = Libint->vrr_classes[3][13];
   for(i=0;i<1050;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+13604, vrr_stack+12785, vrr_stack+9977, vrr_stack+2919, vrr_stack+7325, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+13724, vrr_stack+12890, vrr_stack+12785, vrr_stack+3010, vrr_stack+2919, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+13844, vrr_stack+9977, vrr_stack+1965, vrr_stack+7325, vrr_stack+1240, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+356, vrr_stack+13604, vrr_stack+13844, NULL, NULL, vrr_stack+9977);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20275, vrr_stack+13724, vrr_stack+13604, NULL, NULL, vrr_stack+12785);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20635, vrr_stack+20275, vrr_stack+356, vrr_stack+13724, vrr_stack+13604, vrr_stack+10082);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+10082, vrr_stack+7416, vrr_stack+12890, vrr_stack+4740, vrr_stack+3010, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+10202, vrr_stack+10082, vrr_stack+13724, NULL, NULL, vrr_stack+12890);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21355, vrr_stack+10202, vrr_stack+20275, vrr_stack+10082, vrr_stack+13724, vrr_stack+15970);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15970, vrr_stack+2841, vrr_stack+3, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+15976, vrr_stack+2844, vrr_stack+15970, vrr_stack+0, vrr_stack+2841, NULL);
 _BUILD_00g0(Data,vrr_stack+15986, vrr_stack+2850, vrr_stack+15976, vrr_stack+1120, vrr_stack+2844, NULL);
 _BUILD_00h0(Data,vrr_stack+16001, vrr_stack+2860, vrr_stack+15986, vrr_stack+1126, vrr_stack+2850, NULL);
 _BUILD_00i0(Data,vrr_stack+16022, vrr_stack+2875, vrr_stack+16001, vrr_stack+6, vrr_stack+2860, NULL);
 _BUILD_00k0(Data,vrr_stack+16050, vrr_stack+7521, vrr_stack+16022, vrr_stack+1136, vrr_stack+2875, NULL);
 _BUILD_00l0(Data,vrr_stack+16086, vrr_stack+7549, vrr_stack+16050, vrr_stack+1157, vrr_stack+7521, NULL);
 _BUILD_00m0(Data,vrr_stack+16131, vrr_stack+21, vrr_stack+16086, vrr_stack+4831, vrr_stack+7549, NULL);
 _BUILD_00n0(Data,vrr_stack+16186, vrr_stack+66, vrr_stack+16131, vrr_stack+4867, vrr_stack+21, NULL);
 _BUILD_00o0(Data,vrr_stack+4740, vrr_stack+121, vrr_stack+16186, vrr_stack+1185, vrr_stack+66, NULL);
 _BUILD_00q0(Data,vrr_stack+7325, vrr_stack+187, vrr_stack+4740, vrr_stack+2775, vrr_stack+121, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10562, vrr_stack+265, vrr_stack+7325, vrr_stack+4912, vrr_stack+187, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4818, vrr_stack+1965, vrr_stack+10562, vrr_stack+1240, vrr_stack+265, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1102, vrr_stack+13844, vrr_stack+4818, NULL, NULL, vrr_stack+1965);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+22075, vrr_stack+356, vrr_stack+1102, vrr_stack+13604, vrr_stack+13844, vrr_stack+787);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+22795, vrr_stack+20635, vrr_stack+22075, vrr_stack+20275, vrr_stack+356, vrr_stack+17545);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23995, vrr_stack+21355, vrr_stack+20635, vrr_stack+10202, vrr_stack+20275, vrr_stack+16285);
   tmp = vrr_stack + 23995;
   target_ptr = Libint->vrr_classes[3][14];
   for(i=0;i<1200;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7585, vrr_stack+13604, vrr_stack+13844, vrr_stack+12785, vrr_stack+9977, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+10202, vrr_stack+13724, vrr_stack+13604, vrr_stack+12890, vrr_stack+12785, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+10338, vrr_stack+13844, vrr_stack+4818, vrr_stack+9977, vrr_stack+1965, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+17545, vrr_stack+7585, vrr_stack+10338, NULL, NULL, vrr_stack+13844);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25195, vrr_stack+10202, vrr_stack+7585, NULL, NULL, vrr_stack+13604);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25603, vrr_stack+25195, vrr_stack+17545, vrr_stack+10202, vrr_stack+7585, vrr_stack+356);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+356, vrr_stack+10082, vrr_stack+13724, vrr_stack+7416, vrr_stack+12890, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+492, vrr_stack+356, vrr_stack+10202, NULL, NULL, vrr_stack+13724);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+26419, vrr_stack+492, vrr_stack+25195, vrr_stack+356, vrr_stack+10202, vrr_stack+20275);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+20275, vrr_stack+3, vrr_stack+0, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+20281, vrr_stack+15970, vrr_stack+20275, vrr_stack+2841, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+6, vrr_stack+15976, vrr_stack+20281, vrr_stack+2844, vrr_stack+15970, NULL);
 _BUILD_00h0(Data,vrr_stack+20291, vrr_stack+15986, vrr_stack+6, vrr_stack+2850, vrr_stack+15976, NULL);
 _BUILD_00i0(Data,vrr_stack+20312, vrr_stack+16001, vrr_stack+20291, vrr_stack+2860, vrr_stack+15986, NULL);
 _BUILD_00k0(Data,vrr_stack+20340, vrr_stack+16022, vrr_stack+20312, vrr_stack+2875, vrr_stack+16001, NULL);
 _BUILD_00l0(Data,vrr_stack+20376, vrr_stack+16050, vrr_stack+20340, vrr_stack+7521, vrr_stack+16022, NULL);
 _BUILD_00m0(Data,vrr_stack+20421, vrr_stack+16086, vrr_stack+20376, vrr_stack+7549, vrr_stack+16050, NULL);
 _BUILD_00n0(Data,vrr_stack+20476, vrr_stack+16131, vrr_stack+20421, vrr_stack+21, vrr_stack+16086, NULL);
 _BUILD_00o0(Data,vrr_stack+20542, vrr_stack+16186, vrr_stack+20476, vrr_stack+66, vrr_stack+16131, NULL);
 _BUILD_00q0(Data,vrr_stack+21, vrr_stack+4740, vrr_stack+20542, vrr_stack+121, vrr_stack+16186, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9977, vrr_stack+7325, vrr_stack+21, vrr_stack+187, vrr_stack+4740, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+112, vrr_stack+10562, vrr_stack+9977, vrr_stack+265, vrr_stack+7325, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7416, vrr_stack+4818, vrr_stack+112, vrr_stack+1965, vrr_stack+10562, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+27235, vrr_stack+10338, vrr_stack+7416, NULL, NULL, vrr_stack+4818);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+27643, vrr_stack+17545, vrr_stack+27235, vrr_stack+7585, vrr_stack+10338, vrr_stack+1102);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+28459, vrr_stack+25603, vrr_stack+27643, vrr_stack+25195, vrr_stack+17545, vrr_stack+22075);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+29819, vrr_stack+26419, vrr_stack+25603, vrr_stack+492, vrr_stack+25195, vrr_stack+20635);
   tmp = vrr_stack + 29819;
   target_ptr = Libint->vrr_classes[3][15];
   for(i=0;i<1360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+492, vrr_stack+7585, vrr_stack+10338, vrr_stack+13604, vrr_stack+13844, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+645, vrr_stack+10202, vrr_stack+7585, vrr_stack+13724, vrr_stack+13604, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+798, vrr_stack+10338, vrr_stack+7416, vrr_stack+13844, vrr_stack+4818, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+951, vrr_stack+492, vrr_stack+798, NULL, NULL, vrr_stack+10338);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+22075, vrr_stack+645, vrr_stack+492, NULL, NULL, vrr_stack+7585);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+31179, vrr_stack+22075, vrr_stack+951, vrr_stack+645, vrr_stack+492, vrr_stack+17545);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+17545, vrr_stack+356, vrr_stack+10202, vrr_stack+10082, vrr_stack+13724, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+17698, vrr_stack+17545, vrr_stack+645, NULL, NULL, vrr_stack+10202);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+32097, vrr_stack+17698, vrr_stack+22075, vrr_stack+17545, vrr_stack+645, vrr_stack+25195);
 _BUILD_00p0(Data,vrr_stack+25195, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+25198, vrr_stack+0, vrr_stack+25195, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+25204, vrr_stack+20275, vrr_stack+25198, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+20620, vrr_stack+20281, vrr_stack+25204, vrr_stack+15970, vrr_stack+20275, NULL);
 _BUILD_00h0(Data,vrr_stack+25195, vrr_stack+6, vrr_stack+20620, vrr_stack+15976, vrr_stack+20281, NULL);
 _BUILD_00i0(Data,vrr_stack+25216, vrr_stack+20291, vrr_stack+25195, vrr_stack+15986, vrr_stack+6, NULL);
 _BUILD_00k0(Data,vrr_stack+25244, vrr_stack+20312, vrr_stack+25216, vrr_stack+16001, vrr_stack+20291, NULL);
 _BUILD_00l0(Data,vrr_stack+25195, vrr_stack+20340, vrr_stack+25244, vrr_stack+16022, vrr_stack+20312, NULL);
 _BUILD_00m0(Data,vrr_stack+25240, vrr_stack+20376, vrr_stack+25195, vrr_stack+16050, vrr_stack+20340, NULL);
 _BUILD_00n0(Data,vrr_stack+25295, vrr_stack+20421, vrr_stack+25240, vrr_stack+16086, vrr_stack+20376, NULL);
 _BUILD_00o0(Data,vrr_stack+25195, vrr_stack+20476, vrr_stack+25295, vrr_stack+16131, vrr_stack+20421, NULL);
 _BUILD_00q0(Data,vrr_stack+25273, vrr_stack+20542, vrr_stack+25195, vrr_stack+16186, vrr_stack+20476, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+25364, vrr_stack+21, vrr_stack+25273, vrr_stack+4740, vrr_stack+20542, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+25195, vrr_stack+9977, vrr_stack+25364, vrr_stack+7325, vrr_stack+21, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25315, vrr_stack+112, vrr_stack+25195, vrr_stack+10562, vrr_stack+9977, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+645, vrr_stack+7416, vrr_stack+25315, vrr_stack+4818, vrr_stack+112, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+9977, vrr_stack+798, vrr_stack+645, NULL, NULL, vrr_stack+7416);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+33015, vrr_stack+951, vrr_stack+9977, vrr_stack+492, vrr_stack+798, vrr_stack+27235);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+33933, vrr_stack+31179, vrr_stack+33015, vrr_stack+22075, vrr_stack+951, vrr_stack+27643);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+32097, vrr_stack+31179, vrr_stack+17698, vrr_stack+22075, vrr_stack+25603);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[3][16];
   for(i=0;i<1530;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0l0(Data,vrr_stack+22075, vrr_stack+3630, vrr_stack+3180, vrr_stack+2505, vrr_stack+2100, vrr_stack+1605);
   tmp = vrr_stack + 22075;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0m0(Data,vrr_stack+33015, vrr_stack+5785, vrr_stack+5235, vrr_stack+4410, vrr_stack+4080, vrr_stack+3180);
   tmp = vrr_stack + 33015;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0n0(Data,vrr_stack+27235, vrr_stack+8381, vrr_stack+7721, vrr_stack+6929, vrr_stack+6533, vrr_stack+5235);
   tmp = vrr_stack + 27235;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0o0(Data,vrr_stack+1530, vrr_stack+11459, vrr_stack+10679, vrr_stack+9509, vrr_stack+9041, vrr_stack+7721);
   tmp = vrr_stack + 1530;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0q0(Data,vrr_stack+2700, vrr_stack+15060, vrr_stack+14150, vrr_stack+13058, vrr_stack+12239, vrr_stack+10679);
   tmp = vrr_stack + 2700;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4065, vrr_stack+19225, vrr_stack+18175, vrr_stack+16915, vrr_stack+16285, vrr_stack+14150);
   tmp = vrr_stack + 4065;
   target_ptr = Libint->vrr_classes[4][13];
   for(i=0;i<1575;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5640, vrr_stack+23995, vrr_stack+22795, vrr_stack+21355, vrr_stack+20635, vrr_stack+18175);
   tmp = vrr_stack + 5640;
   target_ptr = Libint->vrr_classes[4][14];
   for(i=0;i<1800;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7440, vrr_stack+29819, vrr_stack+28459, vrr_stack+26419, vrr_stack+25603, vrr_stack+22795);
   tmp = vrr_stack + 7440;
   target_ptr = Libint->vrr_classes[4][15];
   for(i=0;i<2040;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+22750, vrr_stack+0, vrr_stack+33933, vrr_stack+32097, vrr_stack+31179, vrr_stack+28459);
   tmp = vrr_stack + 22750;
   target_ptr = Libint->vrr_classes[4][16];
   for(i=0;i<2295;i++)
     target_ptr[i] += tmp[i];

}

