/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (gg|nk) integrals */

void vrr_order_ggnk(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+12, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+15, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+6, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+21, NULL, NULL, vrr_stack+6);
 _BUILD_00g0(Data,vrr_stack+80, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+3, vrr_stack+31, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+95, vrr_stack+34, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+101, vrr_stack+40, vrr_stack+95, vrr_stack+34, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+12, vrr_stack+31, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+126, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+136, vrr_stack+21, vrr_stack+126, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+151, vrr_stack+80, vrr_stack+136, NULL, NULL, vrr_stack+21);
 _BUILD_p0g0(Data,vrr_stack+196, vrr_stack+111, vrr_stack+80, NULL, NULL, vrr_stack+40);
 _BUILD_d0g0(Data,vrr_stack+241, vrr_stack+196, vrr_stack+151, vrr_stack+111, vrr_stack+80, vrr_stack+50);
 _BUILD_00h0(Data,vrr_stack+50, vrr_stack+80, vrr_stack+136, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+331, vrr_stack+111, vrr_stack+80, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+352, vrr_stack+331, vrr_stack+50, NULL, NULL, vrr_stack+80);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+6, vrr_stack+95, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+415, vrr_stack+40, vrr_stack+101, vrr_stack+6, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+430, vrr_stack+415, vrr_stack+111, vrr_stack+40, vrr_stack+101, NULL);
 _BUILD_p0h0(Data,vrr_stack+451, vrr_stack+430, vrr_stack+331, NULL, NULL, vrr_stack+111);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+31, vrr_stack+3, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+34, vrr_stack+95, vrr_stack+12, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+514, vrr_stack+126, vrr_stack+101, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+529, vrr_stack+136, vrr_stack+514, vrr_stack+21, vrr_stack+126, NULL);
 _BUILD_p0h0(Data,vrr_stack+550, vrr_stack+50, vrr_stack+529, NULL, NULL, vrr_stack+136);
 _BUILD_d0h0(Data,vrr_stack+613, vrr_stack+352, vrr_stack+550, vrr_stack+331, vrr_stack+50, vrr_stack+151);
 _BUILD_d0h0(Data,vrr_stack+739, vrr_stack+451, vrr_stack+352, vrr_stack+430, vrr_stack+331, vrr_stack+196);
 _BUILD_f0h0(Data,vrr_stack+865, vrr_stack+739, vrr_stack+613, vrr_stack+451, vrr_stack+352, vrr_stack+241);
 _BUILD_00i0(Data,vrr_stack+151, vrr_stack+331, vrr_stack+50, vrr_stack+111, vrr_stack+80, NULL);
 _BUILD_00i0(Data,vrr_stack+179, vrr_stack+430, vrr_stack+331, vrr_stack+415, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+207, vrr_stack+50, vrr_stack+529, vrr_stack+80, vrr_stack+136, NULL);
 _BUILD_p0i0(Data,vrr_stack+235, vrr_stack+151, vrr_stack+207, NULL, NULL, vrr_stack+50);
 _BUILD_p0i0(Data,vrr_stack+1075, vrr_stack+179, vrr_stack+151, NULL, NULL, vrr_stack+331);
 _BUILD_d0i0(Data,vrr_stack+1159, vrr_stack+1075, vrr_stack+235, vrr_stack+179, vrr_stack+151, vrr_stack+352);
 _BUILD_00p0(Data,vrr_stack+352, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+355, vrr_stack+352, vrr_stack+0, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+361, vrr_stack+355, vrr_stack+6, vrr_stack+352, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+361, vrr_stack+40, vrr_stack+355, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+6, vrr_stack+111, vrr_stack+415, vrr_stack+361, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+371, vrr_stack+6, vrr_stack+430, vrr_stack+111, vrr_stack+415, NULL);
 _BUILD_p0i0(Data,vrr_stack+1327, vrr_stack+371, vrr_stack+179, NULL, NULL, vrr_stack+430);
 _BUILD_d0i0(Data,vrr_stack+1411, vrr_stack+1327, vrr_stack+1075, vrr_stack+371, vrr_stack+179, vrr_stack+451);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+451, vrr_stack+3, vrr_stack+0, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+95, vrr_stack+451, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+457, vrr_stack+101, vrr_stack+40, vrr_stack+34, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+472, vrr_stack+514, vrr_stack+457, vrr_stack+126, vrr_stack+101, NULL);
 _BUILD_00i0(Data,vrr_stack+399, vrr_stack+529, vrr_stack+472, vrr_stack+136, vrr_stack+514, NULL);
 _BUILD_p0i0(Data,vrr_stack+1579, vrr_stack+207, vrr_stack+399, NULL, NULL, vrr_stack+529);
 _BUILD_d0i0(Data,vrr_stack+1663, vrr_stack+235, vrr_stack+1579, vrr_stack+151, vrr_stack+207, vrr_stack+550);
 _BUILD_f0i0(Data,vrr_stack+1831, vrr_stack+1159, vrr_stack+1663, vrr_stack+1075, vrr_stack+235, vrr_stack+613);
 _BUILD_f0i0(Data,vrr_stack+2111, vrr_stack+1411, vrr_stack+1159, vrr_stack+1327, vrr_stack+1075, vrr_stack+739);
 _BUILD_g0i0(Data,vrr_stack+2391, vrr_stack+2111, vrr_stack+1831, vrr_stack+1411, vrr_stack+1159, vrr_stack+865);
 _BUILD_00k0(Data,vrr_stack+550, vrr_stack+151, vrr_stack+207, vrr_stack+331, vrr_stack+50, NULL);
 _BUILD_00k0(Data,vrr_stack+586, vrr_stack+179, vrr_stack+151, vrr_stack+430, vrr_stack+331, NULL);
 _BUILD_p0k0(Data,vrr_stack+622, vrr_stack+586, vrr_stack+550, NULL, NULL, vrr_stack+151);
 _BUILD_00k0(Data,vrr_stack+730, vrr_stack+371, vrr_stack+179, vrr_stack+6, vrr_stack+430, NULL);
 _BUILD_p0k0(Data,vrr_stack+766, vrr_stack+730, vrr_stack+586, NULL, NULL, vrr_stack+179);
 _BUILD_00k0(Data,vrr_stack+874, vrr_stack+207, vrr_stack+399, vrr_stack+50, vrr_stack+529, NULL);
 _BUILD_p0k0(Data,vrr_stack+910, vrr_stack+550, vrr_stack+874, NULL, NULL, vrr_stack+207);
 _BUILD_d0k0(Data,vrr_stack+2811, vrr_stack+622, vrr_stack+910, vrr_stack+586, vrr_stack+550, vrr_stack+235);
 _BUILD_d0k0(Data,vrr_stack+3027, vrr_stack+766, vrr_stack+622, vrr_stack+730, vrr_stack+586, vrr_stack+1075);
 _BUILD_f0k0(Data,vrr_stack+3243, vrr_stack+3027, vrr_stack+2811, vrr_stack+766, vrr_stack+622, vrr_stack+1159);
 _BUILD_00p0(Data,vrr_stack+235, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+238, vrr_stack+235, vrr_stack+352, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+244, vrr_stack+238, vrr_stack+355, vrr_stack+235, vrr_stack+352, NULL);
 _BUILD_00g0(Data,vrr_stack+254, vrr_stack+244, vrr_stack+361, vrr_stack+238, vrr_stack+355, NULL);
 _BUILD_00h0(Data,vrr_stack+493, vrr_stack+254, vrr_stack+111, vrr_stack+244, vrr_stack+361, NULL);
 _BUILD_00i0(Data,vrr_stack+269, vrr_stack+493, vrr_stack+6, vrr_stack+254, vrr_stack+111, NULL);
 _BUILD_00k0(Data,vrr_stack+111, vrr_stack+269, vrr_stack+371, vrr_stack+493, vrr_stack+6, NULL);
 _BUILD_p0k0(Data,vrr_stack+1018, vrr_stack+111, vrr_stack+730, NULL, NULL, vrr_stack+371);
 _BUILD_d0k0(Data,vrr_stack+3603, vrr_stack+1018, vrr_stack+766, vrr_stack+111, vrr_stack+730, vrr_stack+1327);
 _BUILD_f0k0(Data,vrr_stack+3819, vrr_stack+3603, vrr_stack+3027, vrr_stack+1018, vrr_stack+766, vrr_stack+1411);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+15, vrr_stack+451, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+25, vrr_stack+40, vrr_stack+15, vrr_stack+95, vrr_stack+451, NULL);
 _BUILD_00h0(Data,vrr_stack+297, vrr_stack+457, vrr_stack+25, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+318, vrr_stack+472, vrr_stack+297, vrr_stack+514, vrr_stack+457, NULL);
 _BUILD_00k0(Data,vrr_stack+50, vrr_stack+399, vrr_stack+318, vrr_stack+529, vrr_stack+472, NULL);
 _BUILD_p0k0(Data,vrr_stack+1126, vrr_stack+874, vrr_stack+50, NULL, NULL, vrr_stack+399);
 _BUILD_d0k0(Data,vrr_stack+1234, vrr_stack+910, vrr_stack+1126, vrr_stack+550, vrr_stack+874, vrr_stack+1579);
 _BUILD_f0k0(Data,vrr_stack+4179, vrr_stack+2811, vrr_stack+1234, vrr_stack+622, vrr_stack+910, vrr_stack+1663);
 _BUILD_g0k0(Data,vrr_stack+4539, vrr_stack+3243, vrr_stack+4179, vrr_stack+3027, vrr_stack+2811, vrr_stack+1831);
 _BUILD_g0k0(Data,vrr_stack+1450, vrr_stack+3819, vrr_stack+3243, vrr_stack+3603, vrr_stack+3027, vrr_stack+2111);
 _BUILD_h0k0(Data,vrr_stack+5079, vrr_stack+1450, vrr_stack+4539, vrr_stack+3819, vrr_stack+3243, vrr_stack+2391);
 _BUILD_00l0(Data,vrr_stack+1990, vrr_stack+586, vrr_stack+550, vrr_stack+179, vrr_stack+151, NULL);
 _BUILD_00l0(Data,vrr_stack+2035, vrr_stack+730, vrr_stack+586, vrr_stack+371, vrr_stack+179, NULL);
 _BUILD_00l0(Data,vrr_stack+2080, vrr_stack+550, vrr_stack+874, vrr_stack+151, vrr_stack+207, NULL);
 _BUILD_p0l0(Data,vrr_stack+2125, vrr_stack+1990, vrr_stack+2080, NULL, NULL, vrr_stack+550);
 _BUILD_p0l0(Data,vrr_stack+2260, vrr_stack+2035, vrr_stack+1990, NULL, NULL, vrr_stack+586);
 _BUILD_d0l0(Data,vrr_stack+2395, vrr_stack+2260, vrr_stack+2125, vrr_stack+2035, vrr_stack+1990, vrr_stack+622);
 _BUILD_00l0(Data,vrr_stack+622, vrr_stack+111, vrr_stack+730, vrr_stack+269, vrr_stack+371, NULL);
 _BUILD_p0l0(Data,vrr_stack+2665, vrr_stack+622, vrr_stack+2035, NULL, NULL, vrr_stack+730);
 _BUILD_d0l0(Data,vrr_stack+5835, vrr_stack+2665, vrr_stack+2260, vrr_stack+622, vrr_stack+2035, vrr_stack+766);
 _BUILD_00l0(Data,vrr_stack+766, vrr_stack+874, vrr_stack+50, vrr_stack+207, vrr_stack+399, NULL);
 _BUILD_p0l0(Data,vrr_stack+6105, vrr_stack+2080, vrr_stack+766, NULL, NULL, vrr_stack+874);
 _BUILD_d0l0(Data,vrr_stack+6240, vrr_stack+2125, vrr_stack+6105, vrr_stack+1990, vrr_stack+2080, vrr_stack+910);
 _BUILD_f0l0(Data,vrr_stack+6510, vrr_stack+2395, vrr_stack+6240, vrr_stack+2260, vrr_stack+2125, vrr_stack+2811);
 _BUILD_f0l0(Data,vrr_stack+6960, vrr_stack+5835, vrr_stack+2395, vrr_stack+2665, vrr_stack+2260, vrr_stack+3027);
 _BUILD_g0l0(Data,vrr_stack+7410, vrr_stack+6960, vrr_stack+6510, vrr_stack+5835, vrr_stack+2395, vrr_stack+3243);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+910, vrr_stack+3, vrr_stack+235, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+916, vrr_stack+910, vrr_stack+238, vrr_stack+3, vrr_stack+235, NULL);
 _BUILD_00g0(Data,vrr_stack+926, vrr_stack+916, vrr_stack+244, vrr_stack+910, vrr_stack+238, NULL);
 _BUILD_00h0(Data,vrr_stack+941, vrr_stack+926, vrr_stack+254, vrr_stack+916, vrr_stack+244, NULL);
 _BUILD_00i0(Data,vrr_stack+962, vrr_stack+941, vrr_stack+493, vrr_stack+926, vrr_stack+254, NULL);
 _BUILD_00k0(Data,vrr_stack+514, vrr_stack+962, vrr_stack+269, vrr_stack+941, vrr_stack+493, NULL);
 _BUILD_00l0(Data,vrr_stack+811, vrr_stack+514, vrr_stack+111, vrr_stack+962, vrr_stack+269, NULL);
 _BUILD_p0l0(Data,vrr_stack+147, vrr_stack+811, vrr_stack+622, NULL, NULL, vrr_stack+111);
 _BUILD_d0l0(Data,vrr_stack+2800, vrr_stack+147, vrr_stack+2665, vrr_stack+811, vrr_stack+622, vrr_stack+1018);
 _BUILD_f0l0(Data,vrr_stack+3070, vrr_stack+2800, vrr_stack+5835, vrr_stack+147, vrr_stack+2665, vrr_stack+3603);
 _BUILD_g0l0(Data,vrr_stack+8085, vrr_stack+3070, vrr_stack+6960, vrr_stack+2800, vrr_stack+5835, vrr_stack+3819);
 _BUILD_00p0(Data,vrr_stack+493, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+496, vrr_stack+6, vrr_stack+493, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+502, vrr_stack+9, vrr_stack+496, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+282, vrr_stack+15, vrr_stack+502, vrr_stack+451, vrr_stack+9, NULL);
 _BUILD_00h0(Data,vrr_stack+990, vrr_stack+25, vrr_stack+282, vrr_stack+40, vrr_stack+15, NULL);
 _BUILD_00i0(Data,vrr_stack+1011, vrr_stack+297, vrr_stack+990, vrr_stack+457, vrr_stack+25, NULL);
 _BUILD_00k0(Data,vrr_stack+1039, vrr_stack+318, vrr_stack+1011, vrr_stack+472, vrr_stack+297, NULL);
 _BUILD_00l0(Data,vrr_stack+1075, vrr_stack+50, vrr_stack+1039, vrr_stack+399, vrr_stack+318, NULL);
 _BUILD_p0l0(Data,vrr_stack+346, vrr_stack+766, vrr_stack+1075, NULL, NULL, vrr_stack+50);
 _BUILD_d0l0(Data,vrr_stack+3520, vrr_stack+6105, vrr_stack+346, vrr_stack+2080, vrr_stack+766, vrr_stack+1126);
 _BUILD_f0l0(Data,vrr_stack+8760, vrr_stack+6240, vrr_stack+3520, vrr_stack+2125, vrr_stack+6105, vrr_stack+1234);
 _BUILD_g0l0(Data,vrr_stack+9210, vrr_stack+6510, vrr_stack+8760, vrr_stack+2395, vrr_stack+6240, vrr_stack+4179);
 _BUILD_h0l0(Data,vrr_stack+9885, vrr_stack+7410, vrr_stack+9210, vrr_stack+6960, vrr_stack+6510, vrr_stack+4539);
 _BUILD_h0l0(Data,vrr_stack+3790, vrr_stack+8085, vrr_stack+7410, vrr_stack+3070, vrr_stack+6960, vrr_stack+1450);
 _BUILD_i0l0(Data,vrr_stack+10830, vrr_stack+3790, vrr_stack+9885, vrr_stack+8085, vrr_stack+7410, vrr_stack+5079);
 _BUILD_00m0(Data,vrr_stack+1120, vrr_stack+1990, vrr_stack+2080, vrr_stack+586, vrr_stack+550, NULL);
 _BUILD_00m0(Data,vrr_stack+1175, vrr_stack+2035, vrr_stack+1990, vrr_stack+730, vrr_stack+586, NULL);
 _BUILD_p0m0(Data,vrr_stack+1230, vrr_stack+1175, vrr_stack+1120, NULL, NULL, vrr_stack+1990);
 _BUILD_00m0(Data,vrr_stack+1395, vrr_stack+622, vrr_stack+2035, vrr_stack+111, vrr_stack+730, NULL);
 _BUILD_p0m0(Data,vrr_stack+1450, vrr_stack+1395, vrr_stack+1175, NULL, NULL, vrr_stack+2035);
 _BUILD_00m0(Data,vrr_stack+1615, vrr_stack+2080, vrr_stack+766, vrr_stack+550, vrr_stack+874, NULL);
 _BUILD_p0m0(Data,vrr_stack+1670, vrr_stack+1120, vrr_stack+1615, NULL, NULL, vrr_stack+2080);
 _BUILD_d0m0(Data,vrr_stack+4735, vrr_stack+1230, vrr_stack+1670, vrr_stack+1175, vrr_stack+1120, vrr_stack+2125);
 _BUILD_d0m0(Data,vrr_stack+5065, vrr_stack+1450, vrr_stack+1230, vrr_stack+1395, vrr_stack+1175, vrr_stack+2260);
 _BUILD_f0m0(Data,vrr_stack+12090, vrr_stack+5065, vrr_stack+4735, vrr_stack+1450, vrr_stack+1230, vrr_stack+2395);
 _BUILD_00m0(Data,vrr_stack+2125, vrr_stack+811, vrr_stack+622, vrr_stack+514, vrr_stack+111, NULL);
 _BUILD_p0m0(Data,vrr_stack+2180, vrr_stack+2125, vrr_stack+1395, NULL, NULL, vrr_stack+622);
 _BUILD_d0m0(Data,vrr_stack+5395, vrr_stack+2180, vrr_stack+1450, vrr_stack+2125, vrr_stack+1395, vrr_stack+2665);
 _BUILD_f0m0(Data,vrr_stack+12640, vrr_stack+5395, vrr_stack+5065, vrr_stack+2180, vrr_stack+1450, vrr_stack+5835);
 _BUILD_00m0(Data,vrr_stack+2345, vrr_stack+766, vrr_stack+1075, vrr_stack+874, vrr_stack+50, NULL);
 _BUILD_p0m0(Data,vrr_stack+2400, vrr_stack+1615, vrr_stack+2345, NULL, NULL, vrr_stack+766);
 _BUILD_d0m0(Data,vrr_stack+5725, vrr_stack+1670, vrr_stack+2400, vrr_stack+1120, vrr_stack+1615, vrr_stack+6105);
 _BUILD_f0m0(Data,vrr_stack+13190, vrr_stack+4735, vrr_stack+5725, vrr_stack+1230, vrr_stack+1670, vrr_stack+6240);
 _BUILD_g0m0(Data,vrr_stack+13740, vrr_stack+12090, vrr_stack+13190, vrr_stack+5065, vrr_stack+4735, vrr_stack+6510);
 _BUILD_g0m0(Data,vrr_stack+6055, vrr_stack+12640, vrr_stack+12090, vrr_stack+5395, vrr_stack+5065, vrr_stack+6960);
 _BUILD_h0m0(Data,vrr_stack+14565, vrr_stack+6055, vrr_stack+13740, vrr_stack+12640, vrr_stack+12090, vrr_stack+7410);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2565, vrr_stack+0, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+2565, vrr_stack+910, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+2571, vrr_stack+40, vrr_stack+916, vrr_stack+2565, vrr_stack+910, NULL);
 _BUILD_00h0(Data,vrr_stack+2586, vrr_stack+2571, vrr_stack+926, vrr_stack+40, vrr_stack+916, NULL);
 _BUILD_00i0(Data,vrr_stack+2607, vrr_stack+2586, vrr_stack+941, vrr_stack+2571, vrr_stack+926, NULL);
 _BUILD_00k0(Data,vrr_stack+2635, vrr_stack+2607, vrr_stack+962, vrr_stack+2586, vrr_stack+941, NULL);
 _BUILD_00l0(Data,vrr_stack+2671, vrr_stack+2635, vrr_stack+514, vrr_stack+2607, vrr_stack+962, NULL);
 _BUILD_00m0(Data,vrr_stack+2716, vrr_stack+2671, vrr_stack+811, vrr_stack+2635, vrr_stack+514, NULL);
 _BUILD_p0m0(Data,vrr_stack+6880, vrr_stack+2716, vrr_stack+2125, NULL, NULL, vrr_stack+811);
 _BUILD_d0m0(Data,vrr_stack+7045, vrr_stack+6880, vrr_stack+2180, vrr_stack+2716, vrr_stack+2125, vrr_stack+147);
 _BUILD_f0m0(Data,vrr_stack+7375, vrr_stack+7045, vrr_stack+5395, vrr_stack+6880, vrr_stack+2180, vrr_stack+2800);
 _BUILD_g0m0(Data,vrr_stack+15720, vrr_stack+7375, vrr_stack+12640, vrr_stack+7045, vrr_stack+5395, vrr_stack+3070);
 _BUILD_h0m0(Data,vrr_stack+16545, vrr_stack+15720, vrr_stack+6055, vrr_stack+7375, vrr_stack+12640, vrr_stack+8085);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2771, vrr_stack+493, vrr_stack+3, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+2777, vrr_stack+496, vrr_stack+2771, vrr_stack+6, vrr_stack+493, NULL);
 _BUILD_00g0(Data,vrr_stack+2787, vrr_stack+502, vrr_stack+2777, vrr_stack+9, vrr_stack+496, NULL);
 _BUILD_00h0(Data,vrr_stack+2802, vrr_stack+282, vrr_stack+2787, vrr_stack+15, vrr_stack+502, NULL);
 _BUILD_00i0(Data,vrr_stack+2823, vrr_stack+990, vrr_stack+2802, vrr_stack+25, vrr_stack+282, NULL);
 _BUILD_00k0(Data,vrr_stack+2851, vrr_stack+1011, vrr_stack+2823, vrr_stack+297, vrr_stack+990, NULL);
 _BUILD_00l0(Data,vrr_stack+2887, vrr_stack+1039, vrr_stack+2851, vrr_stack+318, vrr_stack+1011, NULL);
 _BUILD_00m0(Data,vrr_stack+2932, vrr_stack+1075, vrr_stack+2887, vrr_stack+50, vrr_stack+1039, NULL);
 _BUILD_p0m0(Data,vrr_stack+50, vrr_stack+2345, vrr_stack+2932, NULL, NULL, vrr_stack+1075);
 _BUILD_d0m0(Data,vrr_stack+2987, vrr_stack+2400, vrr_stack+50, vrr_stack+1615, vrr_stack+2345, vrr_stack+346);
 _BUILD_f0m0(Data,vrr_stack+7925, vrr_stack+5725, vrr_stack+2987, vrr_stack+1670, vrr_stack+2400, vrr_stack+3520);
 _BUILD_g0m0(Data,vrr_stack+17700, vrr_stack+13190, vrr_stack+7925, vrr_stack+4735, vrr_stack+5725, vrr_stack+8760);
 _BUILD_h0m0(Data,vrr_stack+18525, vrr_stack+13740, vrr_stack+17700, vrr_stack+12090, vrr_stack+13190, vrr_stack+9210);
 _BUILD_i0m0(Data,vrr_stack+19680, vrr_stack+14565, vrr_stack+18525, vrr_stack+6055, vrr_stack+13740, vrr_stack+9885);
 _BUILD_i0m0(Data,vrr_stack+8475, vrr_stack+16545, vrr_stack+14565, vrr_stack+15720, vrr_stack+6055, vrr_stack+3790);
 _BUILD_k0m0(Data,vrr_stack+21220, vrr_stack+8475, vrr_stack+19680, vrr_stack+16545, vrr_stack+14565, vrr_stack+10830);
 _BUILD_00n0(Data,vrr_stack+215, vrr_stack+1175, vrr_stack+1120, vrr_stack+2035, vrr_stack+1990, NULL);
 _BUILD_00n0(Data,vrr_stack+297, vrr_stack+1395, vrr_stack+1175, vrr_stack+622, vrr_stack+2035, NULL);
 _BUILD_00n0(Data,vrr_stack+363, vrr_stack+1120, vrr_stack+1615, vrr_stack+1990, vrr_stack+2080, NULL);
 _BUILD_p0n0(Data,vrr_stack+3317, vrr_stack+215, vrr_stack+363, NULL, NULL, vrr_stack+1120);
 _BUILD_p0n0(Data,vrr_stack+3515, vrr_stack+297, vrr_stack+215, NULL, NULL, vrr_stack+1175);
 _BUILD_d0n0(Data,vrr_stack+3713, vrr_stack+3515, vrr_stack+3317, vrr_stack+297, vrr_stack+215, vrr_stack+1230);
 _BUILD_00n0(Data,vrr_stack+1230, vrr_stack+2125, vrr_stack+1395, vrr_stack+811, vrr_stack+622, NULL);
 _BUILD_p0n0(Data,vrr_stack+4109, vrr_stack+1230, vrr_stack+297, NULL, NULL, vrr_stack+1395);
 _BUILD_d0n0(Data,vrr_stack+4307, vrr_stack+4109, vrr_stack+3515, vrr_stack+1230, vrr_stack+297, vrr_stack+1450);
 _BUILD_00n0(Data,vrr_stack+1450, vrr_stack+1615, vrr_stack+2345, vrr_stack+2080, vrr_stack+766, NULL);
 _BUILD_p0n0(Data,vrr_stack+512, vrr_stack+363, vrr_stack+1450, NULL, NULL, vrr_stack+1615);
 _BUILD_d0n0(Data,vrr_stack+10015, vrr_stack+3317, vrr_stack+512, vrr_stack+215, vrr_stack+363, vrr_stack+1670);
 _BUILD_f0n0(Data,vrr_stack+10411, vrr_stack+3713, vrr_stack+10015, vrr_stack+3515, vrr_stack+3317, vrr_stack+4735);
 _BUILD_f0n0(Data,vrr_stack+11071, vrr_stack+4307, vrr_stack+3713, vrr_stack+4109, vrr_stack+3515, vrr_stack+5065);
 _BUILD_g0n0(Data,vrr_stack+23200, vrr_stack+11071, vrr_stack+10411, vrr_stack+4307, vrr_stack+3713, vrr_stack+12090);
 _BUILD_00n0(Data,vrr_stack+1670, vrr_stack+2716, vrr_stack+2125, vrr_stack+2671, vrr_stack+811, NULL);
 _BUILD_p0n0(Data,vrr_stack+1736, vrr_stack+1670, vrr_stack+1230, NULL, NULL, vrr_stack+2125);
 _BUILD_d0n0(Data,vrr_stack+4703, vrr_stack+1736, vrr_stack+4109, vrr_stack+1670, vrr_stack+1230, vrr_stack+2180);
 _BUILD_f0n0(Data,vrr_stack+11731, vrr_stack+4703, vrr_stack+4307, vrr_stack+1736, vrr_stack+4109, vrr_stack+5395);
 _BUILD_g0n0(Data,vrr_stack+24190, vrr_stack+11731, vrr_stack+11071, vrr_stack+4703, vrr_stack+4307, vrr_stack+12640);
 _BUILD_00n0(Data,vrr_stack+2180, vrr_stack+2345, vrr_stack+2932, vrr_stack+766, vrr_stack+1075, NULL);
 _BUILD_p0n0(Data,vrr_stack+5099, vrr_stack+1450, vrr_stack+2180, NULL, NULL, vrr_stack+2345);
 _BUILD_d0n0(Data,vrr_stack+5297, vrr_stack+512, vrr_stack+5099, vrr_stack+363, vrr_stack+1450, vrr_stack+2400);
 _BUILD_f0n0(Data,vrr_stack+12391, vrr_stack+10015, vrr_stack+5297, vrr_stack+3317, vrr_stack+512, vrr_stack+5725);
 _BUILD_g0n0(Data,vrr_stack+25180, vrr_stack+10411, vrr_stack+12391, vrr_stack+3713, vrr_stack+10015, vrr_stack+13190);
 _BUILD_h0n0(Data,vrr_stack+26170, vrr_stack+23200, vrr_stack+25180, vrr_stack+11071, vrr_stack+10411, vrr_stack+13740);
 _BUILD_h0n0(Data,vrr_stack+13051, vrr_stack+24190, vrr_stack+23200, vrr_stack+11731, vrr_stack+11071, vrr_stack+6055);
 _BUILD_i0n0(Data,vrr_stack+27556, vrr_stack+13051, vrr_stack+26170, vrr_stack+24190, vrr_stack+23200, vrr_stack+14565);
 _BUILD_00p0(Data,vrr_stack+2400, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2403, vrr_stack+2400, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+2409, vrr_stack+2403, vrr_stack+2565, vrr_stack+2400, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+2419, vrr_stack+2409, vrr_stack+40, vrr_stack+2403, vrr_stack+2565, NULL);
 _BUILD_00h0(Data,vrr_stack+2434, vrr_stack+2419, vrr_stack+2571, vrr_stack+2409, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+2455, vrr_stack+2434, vrr_stack+2586, vrr_stack+2419, vrr_stack+2571, NULL);
 _BUILD_00k0(Data,vrr_stack+2483, vrr_stack+2455, vrr_stack+2607, vrr_stack+2434, vrr_stack+2586, NULL);
 _BUILD_00l0(Data,vrr_stack+2400, vrr_stack+2483, vrr_stack+2635, vrr_stack+2455, vrr_stack+2607, NULL);
 _BUILD_00m0(Data,vrr_stack+2519, vrr_stack+2400, vrr_stack+2671, vrr_stack+2483, vrr_stack+2635, NULL);
 _BUILD_00n0(Data,vrr_stack+2445, vrr_stack+2519, vrr_stack+2716, vrr_stack+2400, vrr_stack+2671, NULL);
 _BUILD_p0n0(Data,vrr_stack+5693, vrr_stack+2445, vrr_stack+1670, NULL, NULL, vrr_stack+2716);
 _BUILD_d0n0(Data,vrr_stack+5891, vrr_stack+5693, vrr_stack+1736, vrr_stack+2445, vrr_stack+1670, vrr_stack+6880);
 _BUILD_f0n0(Data,vrr_stack+6287, vrr_stack+5891, vrr_stack+4703, vrr_stack+5693, vrr_stack+1736, vrr_stack+7045);
 _BUILD_g0n0(Data,vrr_stack+14437, vrr_stack+6287, vrr_stack+11731, vrr_stack+5891, vrr_stack+4703, vrr_stack+7375);
   tmp = vrr_stack + 14437;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0n0(Data,vrr_stack+29404, vrr_stack+14437, vrr_stack+24190, vrr_stack+6287, vrr_stack+11731, vrr_stack+15720);
   tmp = vrr_stack + 29404;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0n0(Data,vrr_stack+5693, vrr_stack+29404, vrr_stack+13051, vrr_stack+14437, vrr_stack+24190, vrr_stack+16545);
   tmp = vrr_stack + 5693;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+14437, vrr_stack+3, vrr_stack+0, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+14443, vrr_stack+2771, vrr_stack+14437, vrr_stack+493, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+14453, vrr_stack+2777, vrr_stack+14443, vrr_stack+496, vrr_stack+2771, NULL);
 _BUILD_00h0(Data,vrr_stack+14468, vrr_stack+2787, vrr_stack+14453, vrr_stack+502, vrr_stack+2777, NULL);
 _BUILD_00i0(Data,vrr_stack+14489, vrr_stack+2802, vrr_stack+14468, vrr_stack+282, vrr_stack+2787, NULL);
 _BUILD_00k0(Data,vrr_stack+14517, vrr_stack+2823, vrr_stack+14489, vrr_stack+990, vrr_stack+2802, NULL);
 _BUILD_00l0(Data,vrr_stack+2400, vrr_stack+2851, vrr_stack+14517, vrr_stack+1011, vrr_stack+2823, NULL);
 _BUILD_00m0(Data,vrr_stack+14553, vrr_stack+2887, vrr_stack+2400, vrr_stack+1039, vrr_stack+2851, NULL);
 _BUILD_00n0(Data,vrr_stack+14608, vrr_stack+2932, vrr_stack+14553, vrr_stack+1075, vrr_stack+2887, NULL);
 _BUILD_p0n0(Data,vrr_stack+14674, vrr_stack+2180, vrr_stack+14608, NULL, NULL, vrr_stack+2932);
 _BUILD_d0n0(Data,vrr_stack+14872, vrr_stack+5099, vrr_stack+14674, vrr_stack+1450, vrr_stack+2180, vrr_stack+50);
 _BUILD_f0n0(Data,vrr_stack+15268, vrr_stack+5297, vrr_stack+14872, vrr_stack+512, vrr_stack+5099, vrr_stack+2987);
 _BUILD_g0n0(Data,vrr_stack+15928, vrr_stack+12391, vrr_stack+15268, vrr_stack+10015, vrr_stack+5297, vrr_stack+7925);
 _BUILD_h0n0(Data,vrr_stack+30790, vrr_stack+25180, vrr_stack+15928, vrr_stack+10411, vrr_stack+12391, vrr_stack+17700);
 _BUILD_i0n0(Data,vrr_stack+32176, vrr_stack+26170, vrr_stack+30790, vrr_stack+23200, vrr_stack+25180, vrr_stack+18525);
 _BUILD_k0n0(Data,vrr_stack+16918, vrr_stack+27556, vrr_stack+32176, vrr_stack+13051, vrr_stack+26170, vrr_stack+19680);
 _BUILD_k0n0(Data,vrr_stack+34024, vrr_stack+5693, vrr_stack+27556, vrr_stack+29404, vrr_stack+13051, vrr_stack+8475);
   tmp = vrr_stack + 34024;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+29404, vrr_stack+215, vrr_stack+363, vrr_stack+1175, vrr_stack+1120, NULL);
 _BUILD_00o0(Data,vrr_stack+29482, vrr_stack+297, vrr_stack+215, vrr_stack+1395, vrr_stack+1175, NULL);
 _BUILD_00o0(Data,vrr_stack+29560, vrr_stack+363, vrr_stack+1450, vrr_stack+1120, vrr_stack+1615, NULL);
 _BUILD_p0o0(Data,vrr_stack+29638, vrr_stack+29404, vrr_stack+29560, NULL, NULL, vrr_stack+363);
 _BUILD_p0o0(Data,vrr_stack+29872, vrr_stack+29482, vrr_stack+29404, NULL, NULL, vrr_stack+215);
 _BUILD_d0o0(Data,vrr_stack+30106, vrr_stack+29872, vrr_stack+29638, vrr_stack+29482, vrr_stack+29404, vrr_stack+3317);
 _BUILD_00o0(Data,vrr_stack+30574, vrr_stack+1230, vrr_stack+297, vrr_stack+2125, vrr_stack+1395, NULL);
 _BUILD_p0o0(Data,vrr_stack+2987, vrr_stack+30574, vrr_stack+29482, NULL, NULL, vrr_stack+297);
 _BUILD_d0o0(Data,vrr_stack+19294, vrr_stack+2987, vrr_stack+29872, vrr_stack+30574, vrr_stack+29482, vrr_stack+3515);
 _BUILD_00o0(Data,vrr_stack+30652, vrr_stack+1450, vrr_stack+2180, vrr_stack+1615, vrr_stack+2345, NULL);
 _BUILD_p0o0(Data,vrr_stack+3221, vrr_stack+29560, vrr_stack+30652, NULL, NULL, vrr_stack+1450);
 _BUILD_d0o0(Data,vrr_stack+19762, vrr_stack+29638, vrr_stack+3221, vrr_stack+29404, vrr_stack+29560, vrr_stack+512);
 _BUILD_f0o0(Data,vrr_stack+20230, vrr_stack+30106, vrr_stack+19762, vrr_stack+29872, vrr_stack+29638, vrr_stack+10015);
 _BUILD_f0o0(Data,vrr_stack+7541, vrr_stack+19294, vrr_stack+30106, vrr_stack+2987, vrr_stack+29872, vrr_stack+3713);
 _BUILD_g0o0(Data,vrr_stack+8321, vrr_stack+7541, vrr_stack+20230, vrr_stack+19294, vrr_stack+30106, vrr_stack+10411);
 _BUILD_00o0(Data,vrr_stack+3455, vrr_stack+1670, vrr_stack+1230, vrr_stack+2716, vrr_stack+2125, NULL);
 _BUILD_p0o0(Data,vrr_stack+3533, vrr_stack+3455, vrr_stack+30574, NULL, NULL, vrr_stack+1230);
 _BUILD_d0o0(Data,vrr_stack+9491, vrr_stack+3533, vrr_stack+2987, vrr_stack+3455, vrr_stack+30574, vrr_stack+4109);
 _BUILD_f0o0(Data,vrr_stack+9959, vrr_stack+9491, vrr_stack+19294, vrr_stack+3533, vrr_stack+2987, vrr_stack+4307);
 _BUILD_g0o0(Data,vrr_stack+36400, vrr_stack+9959, vrr_stack+7541, vrr_stack+9491, vrr_stack+19294, vrr_stack+11071);
 _BUILD_00o0(Data,vrr_stack+3767, vrr_stack+2180, vrr_stack+14608, vrr_stack+2345, vrr_stack+2932, NULL);
 _BUILD_p0o0(Data,vrr_stack+3845, vrr_stack+30652, vrr_stack+3767, NULL, NULL, vrr_stack+2180);
 _BUILD_d0o0(Data,vrr_stack+4079, vrr_stack+3221, vrr_stack+3845, vrr_stack+29560, vrr_stack+30652, vrr_stack+5099);
 _BUILD_f0o0(Data,vrr_stack+10739, vrr_stack+19762, vrr_stack+4079, vrr_stack+29638, vrr_stack+3221, vrr_stack+5297);
 _BUILD_g0o0(Data,vrr_stack+37570, vrr_stack+20230, vrr_stack+10739, vrr_stack+30106, vrr_stack+19762, vrr_stack+12391);
 _BUILD_h0o0(Data,vrr_stack+38740, vrr_stack+8321, vrr_stack+37570, vrr_stack+7541, vrr_stack+20230, vrr_stack+25180);
 _BUILD_h0o0(Data,vrr_stack+40378, vrr_stack+36400, vrr_stack+8321, vrr_stack+9959, vrr_stack+7541, vrr_stack+23200);
 _BUILD_i0o0(Data,vrr_stack+42016, vrr_stack+40378, vrr_stack+38740, vrr_stack+36400, vrr_stack+8321, vrr_stack+26170);
 _BUILD_00o0(Data,vrr_stack+23200, vrr_stack+2445, vrr_stack+1670, vrr_stack+2519, vrr_stack+2716, NULL);
 _BUILD_p0o0(Data,vrr_stack+23278, vrr_stack+23200, vrr_stack+3455, NULL, NULL, vrr_stack+1670);
 _BUILD_d0o0(Data,vrr_stack+23512, vrr_stack+23278, vrr_stack+3533, vrr_stack+23200, vrr_stack+3455, vrr_stack+1736);
 _BUILD_f0o0(Data,vrr_stack+25180, vrr_stack+23512, vrr_stack+9491, vrr_stack+23278, vrr_stack+3533, vrr_stack+4703);
 _BUILD_g0o0(Data,vrr_stack+25960, vrr_stack+25180, vrr_stack+9959, vrr_stack+23512, vrr_stack+9491, vrr_stack+11731);
   tmp = vrr_stack + 25960;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0o0(Data,vrr_stack+44200, vrr_stack+25960, vrr_stack+36400, vrr_stack+25180, vrr_stack+9959, vrr_stack+24190);
   tmp = vrr_stack + 44200;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0o0(Data,vrr_stack+23278, vrr_stack+44200, vrr_stack+40378, vrr_stack+25960, vrr_stack+36400, vrr_stack+13051);
   tmp = vrr_stack + 23278;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+25462, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+25465, vrr_stack+0, vrr_stack+25462, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+25471, vrr_stack+14437, vrr_stack+25465, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+14443, vrr_stack+25471, vrr_stack+2771, vrr_stack+14437, NULL);
 _BUILD_00h0(Data,vrr_stack+18, vrr_stack+14453, vrr_stack+3, vrr_stack+2777, vrr_stack+14443, NULL);
 _BUILD_00i0(Data,vrr_stack+39, vrr_stack+14468, vrr_stack+18, vrr_stack+2787, vrr_stack+14453, NULL);
 _BUILD_00k0(Data,vrr_stack+67, vrr_stack+14489, vrr_stack+39, vrr_stack+2802, vrr_stack+14468, NULL);
 _BUILD_00l0(Data,vrr_stack+103, vrr_stack+14517, vrr_stack+67, vrr_stack+2823, vrr_stack+14489, NULL);
 _BUILD_00m0(Data,vrr_stack+148, vrr_stack+2400, vrr_stack+103, vrr_stack+2851, vrr_stack+14517, NULL);
 _BUILD_00n0(Data,vrr_stack+25481, vrr_stack+14553, vrr_stack+148, vrr_stack+2887, vrr_stack+2400, NULL);
 _BUILD_00o0(Data,vrr_stack+25547, vrr_stack+14608, vrr_stack+25481, vrr_stack+2932, vrr_stack+14553, NULL);
 _BUILD_p0o0(Data,vrr_stack+25625, vrr_stack+3767, vrr_stack+25547, NULL, NULL, vrr_stack+14608);
 _BUILD_d0o0(Data,vrr_stack+25859, vrr_stack+3845, vrr_stack+25625, vrr_stack+30652, vrr_stack+3767, vrr_stack+14674);
 _BUILD_f0o0(Data,vrr_stack+26327, vrr_stack+4079, vrr_stack+25859, vrr_stack+3221, vrr_stack+3845, vrr_stack+14872);
 _BUILD_g0o0(Data,vrr_stack+11519, vrr_stack+10739, vrr_stack+26327, vrr_stack+19762, vrr_stack+4079, vrr_stack+15268);
 _BUILD_h0o0(Data,vrr_stack+12689, vrr_stack+37570, vrr_stack+11519, vrr_stack+20230, vrr_stack+10739, vrr_stack+15928);
 _BUILD_i0o0(Data,vrr_stack+14674, vrr_stack+38740, vrr_stack+12689, vrr_stack+8321, vrr_stack+37570, vrr_stack+30790);
 _BUILD_k0o0(Data,vrr_stack+45838, vrr_stack+42016, vrr_stack+14674, vrr_stack+40378, vrr_stack+38740, vrr_stack+32176);
 _BUILD_k0o0(Data,vrr_stack+30730, vrr_stack+23278, vrr_stack+42016, vrr_stack+44200, vrr_stack+40378, vrr_stack+27556);
   tmp = vrr_stack + 30730;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+44200, vrr_stack+29404, vrr_stack+29560, vrr_stack+215, vrr_stack+363, NULL);
 _BUILD_00q0(Data,vrr_stack+44291, vrr_stack+29482, vrr_stack+29404, vrr_stack+297, vrr_stack+215, NULL);
 _BUILD_00q0(Data,vrr_stack+44382, vrr_stack+29560, vrr_stack+30652, vrr_stack+363, vrr_stack+1450, NULL);
 _BUILD_p0q0(Data,vrr_stack+363, vrr_stack+44200, vrr_stack+44382, NULL, NULL, vrr_stack+29560);
 _BUILD_p0q0(Data,vrr_stack+636, vrr_stack+44291, vrr_stack+44200, NULL, NULL, vrr_stack+29404);
 _BUILD_d0q0(Data,vrr_stack+44473, vrr_stack+636, vrr_stack+363, vrr_stack+44291, vrr_stack+44200, vrr_stack+29638);
 _BUILD_00q0(Data,vrr_stack+29638, vrr_stack+30574, vrr_stack+29482, vrr_stack+1230, vrr_stack+297, NULL);
 _BUILD_p0q0(Data,vrr_stack+909, vrr_stack+29638, vrr_stack+44291, NULL, NULL, vrr_stack+29482);
 _BUILD_d0q0(Data,vrr_stack+45019, vrr_stack+909, vrr_stack+636, vrr_stack+29638, vrr_stack+44291, vrr_stack+29872);
 _BUILD_00q0(Data,vrr_stack+29729, vrr_stack+30652, vrr_stack+3767, vrr_stack+1450, vrr_stack+2180, NULL);
 _BUILD_p0q0(Data,vrr_stack+45565, vrr_stack+44382, vrr_stack+29729, NULL, NULL, vrr_stack+30652);
 _BUILD_d0q0(Data,vrr_stack+4547, vrr_stack+363, vrr_stack+45565, vrr_stack+44200, vrr_stack+44382, vrr_stack+3221);
 _BUILD_f0q0(Data,vrr_stack+48646, vrr_stack+44473, vrr_stack+4547, vrr_stack+636, vrr_stack+363, vrr_stack+19762);
 _BUILD_f0q0(Data,vrr_stack+49556, vrr_stack+45019, vrr_stack+44473, vrr_stack+909, vrr_stack+636, vrr_stack+30106);
 _BUILD_g0q0(Data,vrr_stack+50466, vrr_stack+49556, vrr_stack+48646, vrr_stack+45019, vrr_stack+44473, vrr_stack+20230);
 _BUILD_00q0(Data,vrr_stack+19762, vrr_stack+3455, vrr_stack+30574, vrr_stack+1670, vrr_stack+1230, NULL);
 _BUILD_p0q0(Data,vrr_stack+19853, vrr_stack+19762, vrr_stack+29638, NULL, NULL, vrr_stack+30574);
 _BUILD_d0q0(Data,vrr_stack+20126, vrr_stack+19853, vrr_stack+909, vrr_stack+19762, vrr_stack+29638, vrr_stack+2987);
 _BUILD_f0q0(Data,vrr_stack+2511, vrr_stack+20126, vrr_stack+45019, vrr_stack+19853, vrr_stack+909, vrr_stack+19294);
 _BUILD_g0q0(Data,vrr_stack+51831, vrr_stack+2511, vrr_stack+49556, vrr_stack+20126, vrr_stack+45019, vrr_stack+7541);
 _BUILD_00q0(Data,vrr_stack+7541, vrr_stack+3767, vrr_stack+25547, vrr_stack+2180, vrr_stack+14608, NULL);
 _BUILD_p0q0(Data,vrr_stack+7632, vrr_stack+29729, vrr_stack+7541, NULL, NULL, vrr_stack+3767);
 _BUILD_d0q0(Data,vrr_stack+20672, vrr_stack+45565, vrr_stack+7632, vrr_stack+44382, vrr_stack+29729, vrr_stack+3845);
 _BUILD_f0q0(Data,vrr_stack+53196, vrr_stack+4547, vrr_stack+20672, vrr_stack+363, vrr_stack+45565, vrr_stack+4079);
 _BUILD_g0q0(Data,vrr_stack+54106, vrr_stack+48646, vrr_stack+53196, vrr_stack+44473, vrr_stack+4547, vrr_stack+10739);
 _BUILD_h0q0(Data,vrr_stack+55471, vrr_stack+50466, vrr_stack+54106, vrr_stack+49556, vrr_stack+48646, vrr_stack+37570);
 _BUILD_h0q0(Data,vrr_stack+57382, vrr_stack+51831, vrr_stack+50466, vrr_stack+2511, vrr_stack+49556, vrr_stack+8321);
 _BUILD_i0q0(Data,vrr_stack+59293, vrr_stack+57382, vrr_stack+55471, vrr_stack+51831, vrr_stack+50466, vrr_stack+38740);
 _BUILD_00q0(Data,vrr_stack+37570, vrr_stack+23200, vrr_stack+3455, vrr_stack+2445, vrr_stack+1670, NULL);
 _BUILD_p0q0(Data,vrr_stack+37661, vrr_stack+37570, vrr_stack+19762, NULL, NULL, vrr_stack+3455);
 _BUILD_d0q0(Data,vrr_stack+37934, vrr_stack+37661, vrr_stack+19853, vrr_stack+37570, vrr_stack+19762, vrr_stack+3533);
 _BUILD_f0q0(Data,vrr_stack+38480, vrr_stack+37934, vrr_stack+20126, vrr_stack+37661, vrr_stack+19853, vrr_stack+9491);
 _BUILD_g0q0(Data,vrr_stack+7905, vrr_stack+38480, vrr_stack+2511, vrr_stack+37934, vrr_stack+20126, vrr_stack+9959);
   tmp = vrr_stack + 7905;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0q0(Data,vrr_stack+9270, vrr_stack+7905, vrr_stack+51831, vrr_stack+38480, vrr_stack+2511, vrr_stack+36400);
   tmp = vrr_stack + 9270;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0q0(Data,vrr_stack+37661, vrr_stack+9270, vrr_stack+57382, vrr_stack+7905, vrr_stack+51831, vrr_stack+40378);
   tmp = vrr_stack + 37661;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+7905, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+7908, vrr_stack+25462, vrr_stack+7905, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+7914, vrr_stack+25465, vrr_stack+7908, vrr_stack+0, vrr_stack+25462, NULL);
 _BUILD_00g0(Data,vrr_stack+7924, vrr_stack+25471, vrr_stack+7914, vrr_stack+14437, vrr_stack+25465, NULL);
 _BUILD_00h0(Data,vrr_stack+7939, vrr_stack+3, vrr_stack+7924, vrr_stack+14443, vrr_stack+25471, NULL);
 _BUILD_00i0(Data,vrr_stack+7960, vrr_stack+18, vrr_stack+7939, vrr_stack+14453, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+7988, vrr_stack+39, vrr_stack+7960, vrr_stack+14468, vrr_stack+18, NULL);
 _BUILD_00l0(Data,vrr_stack+8024, vrr_stack+67, vrr_stack+7988, vrr_stack+14489, vrr_stack+39, NULL);
 _BUILD_00m0(Data,vrr_stack+8069, vrr_stack+103, vrr_stack+8024, vrr_stack+14517, vrr_stack+67, NULL);
 _BUILD_00n0(Data,vrr_stack+2445, vrr_stack+148, vrr_stack+8069, vrr_stack+2400, vrr_stack+103, NULL);
 _BUILD_00o0(Data,vrr_stack+8124, vrr_stack+25481, vrr_stack+2445, vrr_stack+14553, vrr_stack+148, NULL);
 _BUILD_00q0(Data,vrr_stack+8202, vrr_stack+25547, vrr_stack+8124, vrr_stack+14608, vrr_stack+25481, NULL);
 _BUILD_p0q0(Data,vrr_stack+8293, vrr_stack+7541, vrr_stack+8202, NULL, NULL, vrr_stack+25547);
 _BUILD_d0q0(Data,vrr_stack+8566, vrr_stack+7632, vrr_stack+8293, vrr_stack+29729, vrr_stack+7541, vrr_stack+25625);
 _BUILD_f0q0(Data,vrr_stack+36400, vrr_stack+20672, vrr_stack+8566, vrr_stack+45565, vrr_stack+7632, vrr_stack+25859);
 _BUILD_g0q0(Data,vrr_stack+40209, vrr_stack+53196, vrr_stack+36400, vrr_stack+4547, vrr_stack+20672, vrr_stack+26327);
 _BUILD_h0q0(Data,vrr_stack+25625, vrr_stack+54106, vrr_stack+40209, vrr_stack+48646, vrr_stack+53196, vrr_stack+11519);
 _BUILD_i0q0(Data,vrr_stack+61841, vrr_stack+55471, vrr_stack+25625, vrr_stack+50466, vrr_stack+54106, vrr_stack+12689);
 _BUILD_k0q0(Data,vrr_stack+11181, vrr_stack+59293, vrr_stack+61841, vrr_stack+57382, vrr_stack+55471, vrr_stack+14674);
 _BUILD_k0q0(Data,vrr_stack+64389, vrr_stack+37661, vrr_stack+59293, vrr_stack+9270, vrr_stack+57382, vrr_stack+42016);
   tmp = vrr_stack + 64389;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9112, vrr_stack+44200, vrr_stack+44382, vrr_stack+29404, vrr_stack+29560, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9217, vrr_stack+44291, vrr_stack+44200, vrr_stack+29482, vrr_stack+29404, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9322, vrr_stack+44382, vrr_stack+29729, vrr_stack+29560, vrr_stack+30652, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9427, vrr_stack+9112, vrr_stack+9322, NULL, NULL, vrr_stack+44382);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9742, vrr_stack+9217, vrr_stack+9112, NULL, NULL, vrr_stack+44200);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10057, vrr_stack+9742, vrr_stack+9427, vrr_stack+9217, vrr_stack+9112, vrr_stack+363);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10687, vrr_stack+29638, vrr_stack+44291, vrr_stack+30574, vrr_stack+29482, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+10792, vrr_stack+10687, vrr_stack+9217, NULL, NULL, vrr_stack+44291);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3845, vrr_stack+10792, vrr_stack+9742, vrr_stack+10687, vrr_stack+9217, vrr_stack+636);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+29404, vrr_stack+29729, vrr_stack+7541, vrr_stack+30652, vrr_stack+3767, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+41574, vrr_stack+9322, vrr_stack+29404, NULL, NULL, vrr_stack+29729);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+14457, vrr_stack+9427, vrr_stack+41574, vrr_stack+9112, vrr_stack+9322, vrr_stack+45565);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15087, vrr_stack+10057, vrr_stack+14457, vrr_stack+9742, vrr_stack+9427, vrr_stack+4547);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4475, vrr_stack+3845, vrr_stack+10057, vrr_stack+10792, vrr_stack+9742, vrr_stack+44473);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+67665, vrr_stack+4475, vrr_stack+15087, vrr_stack+3845, vrr_stack+10057, vrr_stack+48646);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+48646, vrr_stack+19762, vrr_stack+29638, vrr_stack+3455, vrr_stack+30574, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+48751, vrr_stack+48646, vrr_stack+10687, NULL, NULL, vrr_stack+29638);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+16137, vrr_stack+48751, vrr_stack+10792, vrr_stack+48646, vrr_stack+10687, vrr_stack+909);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+203, vrr_stack+16137, vrr_stack+3845, vrr_stack+48751, vrr_stack+10792, vrr_stack+45019);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+69240, vrr_stack+203, vrr_stack+4475, vrr_stack+16137, vrr_stack+3845, vrr_stack+49556);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49066, vrr_stack+7541, vrr_stack+8202, vrr_stack+3767, vrr_stack+25547, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49171, vrr_stack+29404, vrr_stack+49066, NULL, NULL, vrr_stack+7541);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49486, vrr_stack+41574, vrr_stack+49171, vrr_stack+9322, vrr_stack+29404, vrr_stack+7632);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+44473, vrr_stack+14457, vrr_stack+49486, vrr_stack+9427, vrr_stack+41574, vrr_stack+20672);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+70815, vrr_stack+15087, vrr_stack+44473, vrr_stack+10057, vrr_stack+14457, vrr_stack+53196);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+72390, vrr_stack+67665, vrr_stack+70815, vrr_stack+4475, vrr_stack+15087, vrr_stack+54106);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+53196, vrr_stack+69240, vrr_stack+67665, vrr_stack+203, vrr_stack+4475, vrr_stack+50466);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+74595, vrr_stack+53196, vrr_stack+72390, vrr_stack+69240, vrr_stack+67665, vrr_stack+55471);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+55401, vrr_stack+37570, vrr_stack+19762, vrr_stack+23200, vrr_stack+3455, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+45523, vrr_stack+55401, vrr_stack+48646, NULL, NULL, vrr_stack+19762);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+55506, vrr_stack+45523, vrr_stack+48751, vrr_stack+55401, vrr_stack+48646, vrr_stack+19853);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+56136, vrr_stack+55506, vrr_stack+16137, vrr_stack+45523, vrr_stack+48751, vrr_stack+20126);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+50116, vrr_stack+56136, vrr_stack+203, vrr_stack+55506, vrr_stack+16137, vrr_stack+2511);
   tmp = vrr_stack + 50116;
   target_ptr = Libint->vrr_classes[4][13];
   for(i=0;i<1575;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+77535, vrr_stack+50116, vrr_stack+69240, vrr_stack+56136, vrr_stack+203, vrr_stack+51831);
   tmp = vrr_stack + 77535;
   target_ptr = Libint->vrr_classes[5][13];
   for(i=0;i<2205;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+79740, vrr_stack+77535, vrr_stack+53196, vrr_stack+50116, vrr_stack+69240, vrr_stack+57382);
   tmp = vrr_stack + 79740;
   target_ptr = Libint->vrr_classes[6][13];
   for(i=0;i<2940;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50116, vrr_stack+7905, vrr_stack+0, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+50122, vrr_stack+7908, vrr_stack+50116, vrr_stack+25462, vrr_stack+7905, NULL);
 _BUILD_00g0(Data,vrr_stack+50132, vrr_stack+7914, vrr_stack+50122, vrr_stack+25465, vrr_stack+7908, NULL);
 _BUILD_00h0(Data,vrr_stack+50147, vrr_stack+7924, vrr_stack+50132, vrr_stack+25471, vrr_stack+7914, NULL);
 _BUILD_00i0(Data,vrr_stack+50168, vrr_stack+7939, vrr_stack+50147, vrr_stack+3, vrr_stack+7924, NULL);
 _BUILD_00k0(Data,vrr_stack+50196, vrr_stack+7960, vrr_stack+50168, vrr_stack+18, vrr_stack+7939, NULL);
 _BUILD_00l0(Data,vrr_stack+50232, vrr_stack+7988, vrr_stack+50196, vrr_stack+39, vrr_stack+7960, NULL);
 _BUILD_00m0(Data,vrr_stack+3, vrr_stack+8024, vrr_stack+50232, vrr_stack+67, vrr_stack+7988, NULL);
 _BUILD_00n0(Data,vrr_stack+50277, vrr_stack+8069, vrr_stack+3, vrr_stack+103, vrr_stack+8024, NULL);
 _BUILD_00o0(Data,vrr_stack+23200, vrr_stack+2445, vrr_stack+50277, vrr_stack+148, vrr_stack+8069, NULL);
 _BUILD_00q0(Data,vrr_stack+58, vrr_stack+8124, vrr_stack+23200, vrr_stack+25481, vrr_stack+2445, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+50343, vrr_stack+8202, vrr_stack+58, vrr_stack+25547, vrr_stack+8124, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+45523, vrr_stack+49066, vrr_stack+50343, NULL, NULL, vrr_stack+8202);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+50448, vrr_stack+49171, vrr_stack+45523, vrr_stack+29404, vrr_stack+49066, vrr_stack+8293);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+51078, vrr_stack+49486, vrr_stack+50448, vrr_stack+41574, vrr_stack+49171, vrr_stack+8566);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+55506, vrr_stack+44473, vrr_stack+51078, vrr_stack+14457, vrr_stack+49486, vrr_stack+36400);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+57081, vrr_stack+70815, vrr_stack+55506, vrr_stack+15087, vrr_stack+44473, vrr_stack+40209);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+82680, vrr_stack+72390, vrr_stack+57081, vrr_stack+67665, vrr_stack+70815, vrr_stack+25625);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+85620, vrr_stack+74595, vrr_stack+82680, vrr_stack+53196, vrr_stack+72390, vrr_stack+61841);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+89400, vrr_stack+79740, vrr_stack+74595, vrr_stack+77535, vrr_stack+53196, vrr_stack+59293);
   tmp = vrr_stack + 89400;
   target_ptr = Libint->vrr_classes[7][13];
   for(i=0;i<3780;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+77535, vrr_stack+9112, vrr_stack+9322, vrr_stack+44200, vrr_stack+44382, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+77655, vrr_stack+9217, vrr_stack+9112, vrr_stack+44291, vrr_stack+44200, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+77775, vrr_stack+9322, vrr_stack+29404, vrr_stack+44382, vrr_stack+29729, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+77895, vrr_stack+77535, vrr_stack+77775, NULL, NULL, vrr_stack+9322);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+78255, vrr_stack+77655, vrr_stack+77535, NULL, NULL, vrr_stack+9112);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+78615, vrr_stack+78255, vrr_stack+77895, vrr_stack+77655, vrr_stack+77535, vrr_stack+9427);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+9427, vrr_stack+10687, vrr_stack+9217, vrr_stack+29638, vrr_stack+44291, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+79335, vrr_stack+9427, vrr_stack+77655, NULL, NULL, vrr_stack+9217);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+61841, vrr_stack+79335, vrr_stack+78255, vrr_stack+9427, vrr_stack+77655, vrr_stack+9742);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+9547, vrr_stack+29404, vrr_stack+49066, vrr_stack+29729, vrr_stack+7541, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+29729, vrr_stack+77775, vrr_stack+9547, NULL, NULL, vrr_stack+29404);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+62561, vrr_stack+77895, vrr_stack+29729, vrr_stack+77535, vrr_stack+77775, vrr_stack+41574);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+40209, vrr_stack+78615, vrr_stack+62561, vrr_stack+78255, vrr_stack+77895, vrr_stack+14457);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+25462, vrr_stack+61841, vrr_stack+78615, vrr_stack+79335, vrr_stack+78255, vrr_stack+10057);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+93180, vrr_stack+25462, vrr_stack+40209, vrr_stack+61841, vrr_stack+78615, vrr_stack+15087);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14457, vrr_stack+48646, vrr_stack+10687, vrr_stack+19762, vrr_stack+29638, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14577, vrr_stack+14457, vrr_stack+9427, NULL, NULL, vrr_stack+10687);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14937, vrr_stack+14577, vrr_stack+79335, vrr_stack+14457, vrr_stack+9427, vrr_stack+10792);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2511, vrr_stack+14937, vrr_stack+61841, vrr_stack+14577, vrr_stack+79335, vrr_stack+3845);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+94980, vrr_stack+2511, vrr_stack+25462, vrr_stack+14937, vrr_stack+61841, vrr_stack+4475);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+10792, vrr_stack+49066, vrr_stack+50343, vrr_stack+7541, vrr_stack+8202, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7541, vrr_stack+9547, vrr_stack+10792, NULL, NULL, vrr_stack+49066);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+9667, vrr_stack+29729, vrr_stack+7541, vrr_stack+77775, vrr_stack+9547, vrr_stack+49171);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+3711, vrr_stack+62561, vrr_stack+9667, vrr_stack+77895, vrr_stack+29729, vrr_stack+49486);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+96780, vrr_stack+40209, vrr_stack+3711, vrr_stack+78615, vrr_stack+62561, vrr_stack+44473);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+98580, vrr_stack+93180, vrr_stack+96780, vrr_stack+25462, vrr_stack+40209, vrr_stack+70815);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+101100, vrr_stack+94980, vrr_stack+93180, vrr_stack+2511, vrr_stack+25462, vrr_stack+67665);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+103620, vrr_stack+101100, vrr_stack+98580, vrr_stack+94980, vrr_stack+93180, vrr_stack+72390);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67665, vrr_stack+55401, vrr_stack+48646, vrr_stack+37570, vrr_stack+19762, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67785, vrr_stack+67665, vrr_stack+14457, NULL, NULL, vrr_stack+48646);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+68145, vrr_stack+67785, vrr_stack+14577, vrr_stack+67665, vrr_stack+14457, vrr_stack+48751);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+70815, vrr_stack+68145, vrr_stack+14937, vrr_stack+67785, vrr_stack+14577, vrr_stack+16137);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+72015, vrr_stack+70815, vrr_stack+2511, vrr_stack+68145, vrr_stack+14937, vrr_stack+203);
   tmp = vrr_stack + 72015;
   target_ptr = Libint->vrr_classes[4][14];
   for(i=0;i<1800;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+106980, vrr_stack+72015, vrr_stack+94980, vrr_stack+70815, vrr_stack+2511, vrr_stack+69240);
   tmp = vrr_stack + 106980;
   target_ptr = Libint->vrr_classes[5][14];
   for(i=0;i<2520;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67785, vrr_stack+106980, vrr_stack+101100, vrr_stack+72015, vrr_stack+94980, vrr_stack+53196);
   tmp = vrr_stack + 67785;
   target_ptr = Libint->vrr_classes[6][14];
   for(i=0;i<3360;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+71145, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+71148, vrr_stack+0, vrr_stack+71145, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+71154, vrr_stack+50116, vrr_stack+71148, vrr_stack+7905, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+71164, vrr_stack+50122, vrr_stack+71154, vrr_stack+7908, vrr_stack+50116, NULL);
 _BUILD_00h0(Data,vrr_stack+71179, vrr_stack+50132, vrr_stack+71164, vrr_stack+7914, vrr_stack+50122, NULL);
 _BUILD_00i0(Data,vrr_stack+71200, vrr_stack+50147, vrr_stack+71179, vrr_stack+7924, vrr_stack+50132, NULL);
 _BUILD_00k0(Data,vrr_stack+71228, vrr_stack+50168, vrr_stack+71200, vrr_stack+7939, vrr_stack+50147, NULL);
 _BUILD_00l0(Data,vrr_stack+79695, vrr_stack+50196, vrr_stack+71228, vrr_stack+7960, vrr_stack+50168, NULL);
 _BUILD_00m0(Data,vrr_stack+71264, vrr_stack+50232, vrr_stack+79695, vrr_stack+7988, vrr_stack+50196, NULL);
 _BUILD_00n0(Data,vrr_stack+71319, vrr_stack+3, vrr_stack+71264, vrr_stack+8024, vrr_stack+50232, NULL);
 _BUILD_00o0(Data,vrr_stack+71385, vrr_stack+50277, vrr_stack+71319, vrr_stack+8069, vrr_stack+3, NULL);
 _BUILD_00q0(Data,vrr_stack+71463, vrr_stack+23200, vrr_stack+71385, vrr_stack+2445, vrr_stack+50277, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+71554, vrr_stack+58, vrr_stack+71463, vrr_stack+8124, vrr_stack+23200, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+71659, vrr_stack+50343, vrr_stack+71554, vrr_stack+8202, vrr_stack+58, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+71779, vrr_stack+10792, vrr_stack+71659, NULL, NULL, vrr_stack+50343);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+72139, vrr_stack+7541, vrr_stack+71779, vrr_stack+9547, vrr_stack+10792, vrr_stack+45523);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+72859, vrr_stack+9667, vrr_stack+72139, vrr_stack+29729, vrr_stack+7541, vrr_stack+50448);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+149, vrr_stack+3711, vrr_stack+72859, vrr_stack+62561, vrr_stack+9667, vrr_stack+51078);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+50448, vrr_stack+96780, vrr_stack+149, vrr_stack+40209, vrr_stack+3711, vrr_stack+55506);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+109500, vrr_stack+98580, vrr_stack+50448, vrr_stack+93180, vrr_stack+96780, vrr_stack+57081);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+112860, vrr_stack+103620, vrr_stack+109500, vrr_stack+101100, vrr_stack+98580, vrr_stack+82680);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+117180, vrr_stack+67785, vrr_stack+103620, vrr_stack+106980, vrr_stack+101100, vrr_stack+74595);
   tmp = vrr_stack + 117180;
   target_ptr = Libint->vrr_classes[7][14];
   for(i=0;i<4320;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+106980, vrr_stack+77535, vrr_stack+77775, vrr_stack+9112, vrr_stack+9322, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+107116, vrr_stack+77655, vrr_stack+77535, vrr_stack+9217, vrr_stack+9112, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+107252, vrr_stack+77775, vrr_stack+9547, vrr_stack+9322, vrr_stack+29404, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+107388, vrr_stack+106980, vrr_stack+107252, NULL, NULL, vrr_stack+77775);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+107796, vrr_stack+107116, vrr_stack+106980, NULL, NULL, vrr_stack+77535);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+108204, vrr_stack+107796, vrr_stack+107388, vrr_stack+107116, vrr_stack+106980, vrr_stack+77895);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+77895, vrr_stack+9427, vrr_stack+77655, vrr_stack+10687, vrr_stack+9217, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+109020, vrr_stack+77895, vrr_stack+107116, NULL, NULL, vrr_stack+77655);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+82680, vrr_stack+109020, vrr_stack+107796, vrr_stack+77895, vrr_stack+107116, vrr_stack+78255);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+78031, vrr_stack+9547, vrr_stack+10792, vrr_stack+29404, vrr_stack+49066, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+78167, vrr_stack+107252, vrr_stack+78031, NULL, NULL, vrr_stack+9547);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+83496, vrr_stack+107388, vrr_stack+78167, vrr_stack+106980, vrr_stack+107252, vrr_stack+29729);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+55506, vrr_stack+108204, vrr_stack+83496, vrr_stack+107796, vrr_stack+107388, vrr_stack+62561);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+62561, vrr_stack+82680, vrr_stack+108204, vrr_stack+109020, vrr_stack+107796, vrr_stack+78615);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+56866, vrr_stack+62561, vrr_stack+55506, vrr_stack+82680, vrr_stack+108204, vrr_stack+40209);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+40209, vrr_stack+14457, vrr_stack+9427, vrr_stack+48646, vrr_stack+10687, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+40345, vrr_stack+40209, vrr_stack+77895, NULL, NULL, vrr_stack+9427);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+40753, vrr_stack+40345, vrr_stack+109020, vrr_stack+40209, vrr_stack+77895, vrr_stack+79335);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+52968, vrr_stack+40753, vrr_stack+82680, vrr_stack+40345, vrr_stack+109020, vrr_stack+61841);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+121500, vrr_stack+52968, vrr_stack+62561, vrr_stack+40753, vrr_stack+82680, vrr_stack+25462);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25462, vrr_stack+10792, vrr_stack+71659, vrr_stack+49066, vrr_stack+50343, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25598, vrr_stack+78031, vrr_stack+25462, NULL, NULL, vrr_stack+10792);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+26006, vrr_stack+78167, vrr_stack+25598, vrr_stack+107252, vrr_stack+78031, vrr_stack+7541);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7541, vrr_stack+83496, vrr_stack+26006, vrr_stack+107388, vrr_stack+78167, vrr_stack+9667);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+123540, vrr_stack+55506, vrr_stack+7541, vrr_stack+108204, vrr_stack+83496, vrr_stack+3711);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+125580, vrr_stack+56866, vrr_stack+123540, vrr_stack+62561, vrr_stack+55506, vrr_stack+96780);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+128436, vrr_stack+121500, vrr_stack+56866, vrr_stack+52968, vrr_stack+62561, vrr_stack+93180);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+131292, vrr_stack+128436, vrr_stack+125580, vrr_stack+121500, vrr_stack+56866, vrr_stack+98580);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+93180, vrr_stack+67665, vrr_stack+14457, vrr_stack+55401, vrr_stack+48646, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48646, vrr_stack+93180, vrr_stack+40209, NULL, NULL, vrr_stack+14457);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+49054, vrr_stack+48646, vrr_stack+40345, vrr_stack+93180, vrr_stack+40209, vrr_stack+14577);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+93316, vrr_stack+49054, vrr_stack+40753, vrr_stack+48646, vrr_stack+40345, vrr_stack+14937);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+14577, vrr_stack+93316, vrr_stack+52968, vrr_stack+49054, vrr_stack+40753, vrr_stack+2511);
   tmp = vrr_stack + 14577;
   target_ptr = Libint->vrr_classes[4][15];
   for(i=0;i<2040;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+96780, vrr_stack+14577, vrr_stack+121500, vrr_stack+93316, vrr_stack+52968, vrr_stack+94980);
   tmp = vrr_stack + 96780;
   target_ptr = Libint->vrr_classes[5][15];
   for(i=0;i<2856;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+135100, vrr_stack+96780, vrr_stack+128436, vrr_stack+14577, vrr_stack+121500, vrr_stack+101100);
   tmp = vrr_stack + 135100;
   target_ptr = Libint->vrr_classes[6][15];
   for(i=0;i<3808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+14577, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+14580, vrr_stack+71145, vrr_stack+14577, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+14586, vrr_stack+71148, vrr_stack+14580, vrr_stack+0, vrr_stack+71145, NULL);
 _BUILD_00g0(Data,vrr_stack+14596, vrr_stack+71154, vrr_stack+14586, vrr_stack+50116, vrr_stack+71148, NULL);
 _BUILD_00h0(Data,vrr_stack+14611, vrr_stack+71164, vrr_stack+14596, vrr_stack+50122, vrr_stack+71154, NULL);
 _BUILD_00i0(Data,vrr_stack+14632, vrr_stack+71179, vrr_stack+14611, vrr_stack+50132, vrr_stack+71164, NULL);
 _BUILD_00k0(Data,vrr_stack+14660, vrr_stack+71200, vrr_stack+14632, vrr_stack+50147, vrr_stack+71179, NULL);
 _BUILD_00l0(Data,vrr_stack+14696, vrr_stack+71228, vrr_stack+14660, vrr_stack+50168, vrr_stack+71200, NULL);
 _BUILD_00m0(Data,vrr_stack+14741, vrr_stack+79695, vrr_stack+14696, vrr_stack+50196, vrr_stack+71228, NULL);
 _BUILD_00n0(Data,vrr_stack+14796, vrr_stack+71264, vrr_stack+14741, vrr_stack+50232, vrr_stack+79695, NULL);
 _BUILD_00o0(Data,vrr_stack+14862, vrr_stack+71319, vrr_stack+14796, vrr_stack+3, vrr_stack+71264, NULL);
 _BUILD_00q0(Data,vrr_stack+14940, vrr_stack+71385, vrr_stack+14862, vrr_stack+50277, vrr_stack+71319, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15031, vrr_stack+71463, vrr_stack+14940, vrr_stack+23200, vrr_stack+71385, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+15136, vrr_stack+71554, vrr_stack+15031, vrr_stack+58, vrr_stack+71463, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+71659, vrr_stack+15136, vrr_stack+50343, vrr_stack+71554, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15256, vrr_stack+25462, vrr_stack+0, NULL, NULL, vrr_stack+71659);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15664, vrr_stack+25598, vrr_stack+15256, vrr_stack+78031, vrr_stack+25462, vrr_stack+71779);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+93316, vrr_stack+26006, vrr_stack+15664, vrr_stack+78167, vrr_stack+25598, vrr_stack+72139);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+94676, vrr_stack+7541, vrr_stack+93316, vrr_stack+83496, vrr_stack+26006, vrr_stack+72859);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+99636, vrr_stack+123540, vrr_stack+94676, vrr_stack+55506, vrr_stack+7541, vrr_stack+149);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+125580, vrr_stack+99636, vrr_stack+56866, vrr_stack+123540, vrr_stack+50448);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+138908, vrr_stack+131292, vrr_stack+136, vrr_stack+128436, vrr_stack+125580, vrr_stack+109500);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+143804, vrr_stack+135100, vrr_stack+131292, vrr_stack+96780, vrr_stack+128436, vrr_stack+103620);
   tmp = vrr_stack + 143804;
   target_ptr = Libint->vrr_classes[7][15];
   for(i=0;i<4896;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+71779, vrr_stack+106980, vrr_stack+107252, vrr_stack+77535, vrr_stack+77775, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+71932, vrr_stack+107116, vrr_stack+106980, vrr_stack+77655, vrr_stack+77535, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+72085, vrr_stack+107252, vrr_stack+78031, vrr_stack+77775, vrr_stack+9547, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+72238, vrr_stack+71779, vrr_stack+72085, NULL, NULL, vrr_stack+107252);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+72697, vrr_stack+71932, vrr_stack+71779, NULL, NULL, vrr_stack+106980);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+73156, vrr_stack+72697, vrr_stack+72238, vrr_stack+71932, vrr_stack+71779, vrr_stack+107388);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+107388, vrr_stack+77895, vrr_stack+107116, vrr_stack+9427, vrr_stack+77655, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+74074, vrr_stack+107388, vrr_stack+71932, NULL, NULL, vrr_stack+107116);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3944, vrr_stack+74074, vrr_stack+72697, vrr_stack+107388, vrr_stack+71932, vrr_stack+107796);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+107541, vrr_stack+78031, vrr_stack+25462, vrr_stack+9547, vrr_stack+10792, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+9547, vrr_stack+72085, vrr_stack+107541, NULL, NULL, vrr_stack+78031);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+96716, vrr_stack+72238, vrr_stack+9547, vrr_stack+71779, vrr_stack+72085, vrr_stack+78167);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+97634, vrr_stack+73156, vrr_stack+96716, vrr_stack+72697, vrr_stack+72238, vrr_stack+83496);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+83496, vrr_stack+3944, vrr_stack+73156, vrr_stack+74074, vrr_stack+72697, vrr_stack+108204);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+48646, vrr_stack+83496, vrr_stack+97634, vrr_stack+3944, vrr_stack+73156, vrr_stack+55506);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+85026, vrr_stack+40209, vrr_stack+77895, vrr_stack+14457, vrr_stack+9427, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+78167, vrr_stack+85026, vrr_stack+107388, NULL, NULL, vrr_stack+77895);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+78626, vrr_stack+78167, vrr_stack+74074, vrr_stack+85026, vrr_stack+107388, vrr_stack+109020);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+107694, vrr_stack+78626, vrr_stack+3944, vrr_stack+78167, vrr_stack+74074, vrr_stack+82680);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+109224, vrr_stack+107694, vrr_stack+83496, vrr_stack+78626, vrr_stack+3944, vrr_stack+62561);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+82680, vrr_stack+25462, vrr_stack+0, vrr_stack+10792, vrr_stack+71659, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+82833, vrr_stack+107541, vrr_stack+82680, NULL, NULL, vrr_stack+25462);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+10006, vrr_stack+9547, vrr_stack+82833, vrr_stack+72085, vrr_stack+107541, vrr_stack+25598);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+50941, vrr_stack+96716, vrr_stack+10006, vrr_stack+72238, vrr_stack+9547, vrr_stack+26006);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+61841, vrr_stack+97634, vrr_stack+50941, vrr_stack+73156, vrr_stack+96716, vrr_stack+7541);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+48646, vrr_stack+61841, vrr_stack+83496, vrr_stack+97634, vrr_stack+123540);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+151913, vrr_stack+109224, vrr_stack+48646, vrr_stack+107694, vrr_stack+83496, vrr_stack+56866);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+54328, vrr_stack+151913, vrr_stack+148700, vrr_stack+109224, vrr_stack+48646, vrr_stack+125580);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+123540, vrr_stack+93180, vrr_stack+40209, vrr_stack+67665, vrr_stack+14457, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+123693, vrr_stack+123540, vrr_stack+85026, NULL, NULL, vrr_stack+40209);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+124152, vrr_stack+123693, vrr_stack+78167, vrr_stack+123540, vrr_stack+85026, vrr_stack+40345);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+125070, vrr_stack+124152, vrr_stack+78626, vrr_stack+123693, vrr_stack+78167, vrr_stack+40753);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+155126, vrr_stack+125070, vrr_stack+107694, vrr_stack+124152, vrr_stack+78626, vrr_stack+52968);
   tmp = vrr_stack + 155126;
   target_ptr = Libint->vrr_classes[4][16];
   for(i=0;i<2295;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+157421, vrr_stack+155126, vrr_stack+109224, vrr_stack+125070, vrr_stack+107694, vrr_stack+121500);
   tmp = vrr_stack + 157421;
   target_ptr = Libint->vrr_classes[5][16];
   for(i=0;i<3213;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+123693, vrr_stack+157421, vrr_stack+151913, vrr_stack+155126, vrr_stack+109224, vrr_stack+128436);
   tmp = vrr_stack + 123693;
   target_ptr = Libint->vrr_classes[6][16];
   for(i=0;i<4284;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+155126, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+155129, vrr_stack+14577, vrr_stack+155126, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+155135, vrr_stack+14580, vrr_stack+155129, vrr_stack+71145, vrr_stack+14577, NULL);
 _BUILD_00g0(Data,vrr_stack+155145, vrr_stack+14586, vrr_stack+155135, vrr_stack+71148, vrr_stack+14580, NULL);
 _BUILD_00h0(Data,vrr_stack+155160, vrr_stack+14596, vrr_stack+155145, vrr_stack+71154, vrr_stack+14586, NULL);
 _BUILD_00i0(Data,vrr_stack+155181, vrr_stack+14611, vrr_stack+155160, vrr_stack+71164, vrr_stack+14596, NULL);
 _BUILD_00k0(Data,vrr_stack+155209, vrr_stack+14632, vrr_stack+155181, vrr_stack+71179, vrr_stack+14611, NULL);
 _BUILD_00l0(Data,vrr_stack+71145, vrr_stack+14660, vrr_stack+155209, vrr_stack+71200, vrr_stack+14632, NULL);
 _BUILD_00m0(Data,vrr_stack+155245, vrr_stack+14696, vrr_stack+71145, vrr_stack+71228, vrr_stack+14660, NULL);
 _BUILD_00n0(Data,vrr_stack+71190, vrr_stack+14741, vrr_stack+155245, vrr_stack+79695, vrr_stack+14696, NULL);
 _BUILD_00o0(Data,vrr_stack+23200, vrr_stack+14796, vrr_stack+71190, vrr_stack+71264, vrr_stack+14741, NULL);
 _BUILD_00q0(Data,vrr_stack+155300, vrr_stack+14862, vrr_stack+23200, vrr_stack+71319, vrr_stack+14796, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+71256, vrr_stack+14940, vrr_stack+155300, vrr_stack+71385, vrr_stack+14862, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+14457, vrr_stack+15031, vrr_stack+71256, vrr_stack+71463, vrr_stack+14940, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+71361, vrr_stack+15136, vrr_stack+14457, vrr_stack+71554, vrr_stack+15031, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+71497, vrr_stack+0, vrr_stack+71361, vrr_stack+71659, vrr_stack+15136, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+155391, vrr_stack+82680, vrr_stack+71497, NULL, NULL, vrr_stack+0);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+155850, vrr_stack+82833, vrr_stack+155391, vrr_stack+107541, vrr_stack+82680, vrr_stack+15256);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+121500, vrr_stack+10006, vrr_stack+155850, vrr_stack+9547, vrr_stack+82833, vrr_stack+15664);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+127977, vrr_stack+50941, vrr_stack+121500, vrr_stack+96716, vrr_stack+10006, vrr_stack+93316);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+160634, vrr_stack+61841, vrr_stack+127977, vrr_stack+97634, vrr_stack+50941, vrr_stack+94676);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+163847, vrr_stack+148700, vrr_stack+160634, vrr_stack+48646, vrr_stack+61841, vrr_stack+99636);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+168131, vrr_stack+54328, vrr_stack+163847, vrr_stack+151913, vrr_stack+148700, vrr_stack+136);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+173639, vrr_stack+123693, vrr_stack+54328, vrr_stack+157421, vrr_stack+151913, vrr_stack+131292);
   tmp = vrr_stack + 173639;
   target_ptr = Libint->vrr_classes[7][16];
   for(i=0;i<5508;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+71779, vrr_stack+72085, vrr_stack+106980, vrr_stack+107252, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+307, vrr_stack+71932, vrr_stack+71779, vrr_stack+107116, vrr_stack+106980, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+478, vrr_stack+72085, vrr_stack+107541, vrr_stack+107252, vrr_stack+78031, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+649, vrr_stack+136, vrr_stack+478, NULL, NULL, vrr_stack+72085);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1162, vrr_stack+307, vrr_stack+136, NULL, NULL, vrr_stack+71779);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1675, vrr_stack+1162, vrr_stack+649, vrr_stack+307, vrr_stack+136, vrr_stack+72238);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72085, vrr_stack+107388, vrr_stack+71932, vrr_stack+77895, vrr_stack+107116, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2701, vrr_stack+72085, vrr_stack+307, NULL, NULL, vrr_stack+71932);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+93316, vrr_stack+2701, vrr_stack+1162, vrr_stack+72085, vrr_stack+307, vrr_stack+72697);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+307, vrr_stack+107541, vrr_stack+82680, vrr_stack+78031, vrr_stack+25462, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72256, vrr_stack+478, vrr_stack+307, NULL, NULL, vrr_stack+107541);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+94342, vrr_stack+649, vrr_stack+72256, vrr_stack+136, vrr_stack+478, vrr_stack+9547);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+156768, vrr_stack+1675, vrr_stack+94342, vrr_stack+1162, vrr_stack+649, vrr_stack+96716);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+95368, vrr_stack+93316, vrr_stack+1675, vrr_stack+2701, vrr_stack+1162, vrr_stack+73156);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+99164, vrr_stack+95368, vrr_stack+156768, vrr_stack+93316, vrr_stack+1675, vrr_stack+97634);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+85026, vrr_stack+107388, vrr_stack+40209, vrr_stack+77895, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1162, vrr_stack+136, vrr_stack+72085, NULL, NULL, vrr_stack+107388);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+72769, vrr_stack+1162, vrr_stack+2701, vrr_stack+136, vrr_stack+72085, vrr_stack+74074);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+97078, vrr_stack+72769, vrr_stack+93316, vrr_stack+1162, vrr_stack+2701, vrr_stack+3944);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+2701, vrr_stack+97078, vrr_stack+95368, vrr_stack+72769, vrr_stack+93316, vrr_stack+83496);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+93316, vrr_stack+82680, vrr_stack+71497, vrr_stack+25462, vrr_stack+0, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+25462, vrr_stack+307, vrr_stack+93316, NULL, NULL, vrr_stack+82680);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+25975, vrr_stack+72256, vrr_stack+25462, vrr_stack+478, vrr_stack+307, vrr_stack+82833);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+82680, vrr_stack+94342, vrr_stack+25975, vrr_stack+649, vrr_stack+72256, vrr_stack+10006);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+7541, vrr_stack+156768, vrr_stack+82680, vrr_stack+1675, vrr_stack+94342, vrr_stack+50941);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+179147, vrr_stack+99164, vrr_stack+7541, vrr_stack+95368, vrr_stack+156768, vrr_stack+61841);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+182738, vrr_stack+2701, vrr_stack+99164, vrr_stack+97078, vrr_stack+95368, vrr_stack+48646);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+48646, vrr_stack+182738, vrr_stack+179147, vrr_stack+2701, vrr_stack+99164, vrr_stack+148700);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+123540, vrr_stack+85026, vrr_stack+93180, vrr_stack+40209, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+40209, vrr_stack+148700, vrr_stack+136, NULL, NULL, vrr_stack+85026);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1675, vrr_stack+40209, vrr_stack+1162, vrr_stack+148700, vrr_stack+136, vrr_stack+78167);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+95368, vrr_stack+1675, vrr_stack+72769, vrr_stack+40209, vrr_stack+1162, vrr_stack+78626);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+95368, vrr_stack+97078, vrr_stack+1675, vrr_stack+72769, vrr_stack+107694);
   tmp = vrr_stack + 148700;
   target_ptr = Libint->vrr_classes[4][17];
   for(i=0;i<2565;i++)
     target_ptr[i] += tmp[i];
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+186329, vrr_stack+148700, vrr_stack+2701, vrr_stack+95368, vrr_stack+97078, vrr_stack+109224);
   tmp = vrr_stack + 186329;
   target_ptr = Libint->vrr_classes[5][17];
   for(i=0;i<3591;i++)
     target_ptr[i] += tmp[i];
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+106980, vrr_stack+186329, vrr_stack+182738, vrr_stack+148700, vrr_stack+2701, vrr_stack+151913);
   tmp = vrr_stack + 106980;
   target_ptr = Libint->vrr_classes[6][17];
   for(i=0;i<4788;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+148700, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+148703, vrr_stack+155126, vrr_stack+148700, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+148709, vrr_stack+155129, vrr_stack+148703, vrr_stack+14577, vrr_stack+155126, NULL);
 _BUILD_00g0(Data,vrr_stack+148719, vrr_stack+155135, vrr_stack+148709, vrr_stack+14580, vrr_stack+155129, NULL);
 _BUILD_00h0(Data,vrr_stack+148734, vrr_stack+155145, vrr_stack+148719, vrr_stack+14586, vrr_stack+155135, NULL);
 _BUILD_00i0(Data,vrr_stack+148700, vrr_stack+155160, vrr_stack+148734, vrr_stack+14596, vrr_stack+155145, NULL);
 _BUILD_00k0(Data,vrr_stack+148728, vrr_stack+155181, vrr_stack+148700, vrr_stack+14611, vrr_stack+155160, NULL);
 _BUILD_00l0(Data,vrr_stack+14577, vrr_stack+155209, vrr_stack+148728, vrr_stack+14632, vrr_stack+155181, NULL);
 _BUILD_00m0(Data,vrr_stack+148700, vrr_stack+71145, vrr_stack+14577, vrr_stack+14660, vrr_stack+155209, NULL);
 _BUILD_00n0(Data,vrr_stack+14577, vrr_stack+155245, vrr_stack+148700, vrr_stack+14696, vrr_stack+71145, NULL);
 _BUILD_00o0(Data,vrr_stack+148700, vrr_stack+71190, vrr_stack+14577, vrr_stack+14741, vrr_stack+155245, NULL);
 _BUILD_00q0(Data,vrr_stack+14577, vrr_stack+23200, vrr_stack+148700, vrr_stack+14796, vrr_stack+71190, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+155300, vrr_stack+14577, vrr_stack+14862, vrr_stack+23200, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67665, vrr_stack+71256, vrr_stack+148700, vrr_stack+14940, vrr_stack+155300, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+93180, vrr_stack+14457, vrr_stack+67665, vrr_stack+15031, vrr_stack+71256, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+71361, vrr_stack+93180, vrr_stack+15136, vrr_stack+14457, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+71497, vrr_stack+148700, vrr_stack+0, vrr_stack+71361, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+93316, vrr_stack+136, NULL, NULL, vrr_stack+71497);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+149213, vrr_stack+25462, vrr_stack+148700, vrr_stack+307, vrr_stack+93316, vrr_stack+155391);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+25975, vrr_stack+149213, vrr_stack+72256, vrr_stack+25462, vrr_stack+155850);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+82680, vrr_stack+0, vrr_stack+94342, vrr_stack+25975, vrr_stack+121500);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+7541, vrr_stack+148700, vrr_stack+156768, vrr_stack+82680, vrr_stack+127977);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+179147, vrr_stack+0, vrr_stack+99164, vrr_stack+7541, vrr_stack+160634);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+153488, vrr_stack+48646, vrr_stack+148700, vrr_stack+182738, vrr_stack+179147, vrr_stack+163847);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+159644, vrr_stack+106980, vrr_stack+48646, vrr_stack+186329, vrr_stack+182738, vrr_stack+54328);
   tmp = vrr_stack + 159644;
   target_ptr = Libint->vrr_classes[7][17];
   for(i=0;i<6156;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0n0(Data,vrr_stack+179147, vrr_stack+34024, vrr_stack+16918, vrr_stack+5693, vrr_stack+27556, vrr_stack+21220);
   tmp = vrr_stack + 179147;
   target_ptr = Libint->vrr_classes[8][10];
   for(i=0;i<2970;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0o0(Data,vrr_stack+182117, vrr_stack+30730, vrr_stack+45838, vrr_stack+23278, vrr_stack+42016, vrr_stack+16918);
   tmp = vrr_stack + 182117;
   target_ptr = Libint->vrr_classes[8][11];
   for(i=0;i<3510;i++)
     target_ptr[i] += tmp[i];
 _BUILD_l0q0(Data,vrr_stack+185627, vrr_stack+64389, vrr_stack+11181, vrr_stack+37661, vrr_stack+59293, vrr_stack+45838);
   tmp = vrr_stack + 185627;
   target_ptr = Libint->vrr_classes[8][12];
   for(i=0;i<4095;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+148700, vrr_stack+89400, vrr_stack+85620, vrr_stack+79740, vrr_stack+74595, vrr_stack+11181);
   tmp = vrr_stack + 148700;
   target_ptr = Libint->vrr_classes[8][13];
   for(i=0;i<4725;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+89400, vrr_stack+117180, vrr_stack+112860, vrr_stack+67785, vrr_stack+103620, vrr_stack+85620);
   tmp = vrr_stack + 89400;
   target_ptr = Libint->vrr_classes[8][14];
   for(i=0;i<5400;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+117180, vrr_stack+143804, vrr_stack+138908, vrr_stack+135100, vrr_stack+131292, vrr_stack+112860);
   tmp = vrr_stack + 117180;
   target_ptr = Libint->vrr_classes[8][15];
   for(i=0;i<6120;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+94800, vrr_stack+173639, vrr_stack+168131, vrr_stack+123693, vrr_stack+54328, vrr_stack+138908);
   tmp = vrr_stack + 94800;
   target_ptr = Libint->vrr_classes[8][16];
   for(i=0;i<6885;i++)
     target_ptr[i] += tmp[i];
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+123300, vrr_stack+159644, vrr_stack+153488, vrr_stack+106980, vrr_stack+48646, vrr_stack+168131);
   tmp = vrr_stack + 123300;
   target_ptr = Libint->vrr_classes[8][17];
   for(i=0;i<7695;i++)
     target_ptr[i] += tmp[i];

}

