/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (i0|kp) integrals */

void vrr_order_i0kp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+6, NULL, NULL, vrr_stack+0);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+49, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+52, vrr_stack+49, vrr_stack+12, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+58, vrr_stack+52, vrr_stack+15, vrr_stack+49, vrr_stack+12, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+68, vrr_stack+3, vrr_stack+12, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+74, vrr_stack+6, vrr_stack+68, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+84, vrr_stack+39, vrr_stack+74, NULL, NULL, vrr_stack+6);
 _BUILD_p0f0(Data,vrr_stack+114, vrr_stack+58, vrr_stack+39, NULL, NULL, vrr_stack+15);
 _BUILD_d0f0(Data,vrr_stack+144, vrr_stack+114, vrr_stack+84, vrr_stack+58, vrr_stack+39, vrr_stack+21);
 _BUILD_00g0(Data,vrr_stack+21, vrr_stack+39, vrr_stack+74, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+204, vrr_stack+58, vrr_stack+39, vrr_stack+52, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+219, vrr_stack+204, vrr_stack+21, NULL, NULL, vrr_stack+39);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+36, vrr_stack+49, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+264, vrr_stack+15, vrr_stack+52, vrr_stack+36, vrr_stack+49, NULL);
 _BUILD_00g0(Data,vrr_stack+274, vrr_stack+264, vrr_stack+58, vrr_stack+15, vrr_stack+52, NULL);
 _BUILD_p0g0(Data,vrr_stack+289, vrr_stack+274, vrr_stack+204, NULL, NULL, vrr_stack+58);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+49, vrr_stack+12, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+334, vrr_stack+68, vrr_stack+49, vrr_stack+3, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+344, vrr_stack+74, vrr_stack+334, vrr_stack+6, vrr_stack+68, NULL);
 _BUILD_p0g0(Data,vrr_stack+359, vrr_stack+21, vrr_stack+344, NULL, NULL, vrr_stack+74);
 _BUILD_d0g0(Data,vrr_stack+404, vrr_stack+219, vrr_stack+359, vrr_stack+204, vrr_stack+21, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+494, vrr_stack+289, vrr_stack+219, vrr_stack+274, vrr_stack+204, vrr_stack+114);
 _BUILD_f0g0(Data,vrr_stack+584, vrr_stack+494, vrr_stack+404, vrr_stack+289, vrr_stack+219, vrr_stack+144);
 _BUILD_00h0(Data,vrr_stack+84, vrr_stack+204, vrr_stack+21, vrr_stack+58, vrr_stack+39, NULL);
 _BUILD_00h0(Data,vrr_stack+105, vrr_stack+274, vrr_stack+204, vrr_stack+264, vrr_stack+58, NULL);
 _BUILD_00h0(Data,vrr_stack+126, vrr_stack+21, vrr_stack+344, vrr_stack+39, vrr_stack+74, NULL);
 _BUILD_p0h0(Data,vrr_stack+734, vrr_stack+84, vrr_stack+126, NULL, NULL, vrr_stack+21);
 _BUILD_p0h0(Data,vrr_stack+797, vrr_stack+105, vrr_stack+84, NULL, NULL, vrr_stack+204);
 _BUILD_d0h0(Data,vrr_stack+860, vrr_stack+797, vrr_stack+734, vrr_stack+105, vrr_stack+84, vrr_stack+219);
 _BUILD_00p0(Data,vrr_stack+219, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+222, vrr_stack+219, vrr_stack+36, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+39, vrr_stack+222, vrr_stack+15, vrr_stack+219, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+986, vrr_stack+39, vrr_stack+264, vrr_stack+222, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+228, vrr_stack+986, vrr_stack+274, vrr_stack+39, vrr_stack+264, NULL);
 _BUILD_p0h0(Data,vrr_stack+1001, vrr_stack+228, vrr_stack+105, NULL, NULL, vrr_stack+274);
 _BUILD_d0h0(Data,vrr_stack+1064, vrr_stack+1001, vrr_stack+797, vrr_stack+228, vrr_stack+105, vrr_stack+289);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+36, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+289, vrr_stack+49, vrr_stack+15, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+299, vrr_stack+334, vrr_stack+289, vrr_stack+68, vrr_stack+49, NULL);
 _BUILD_00h0(Data,vrr_stack+249, vrr_stack+344, vrr_stack+299, vrr_stack+74, vrr_stack+334, NULL);
 _BUILD_p0h0(Data,vrr_stack+1190, vrr_stack+126, vrr_stack+249, NULL, NULL, vrr_stack+344);
 _BUILD_d0h0(Data,vrr_stack+1253, vrr_stack+734, vrr_stack+1190, vrr_stack+84, vrr_stack+126, vrr_stack+359);
 _BUILD_f0h0(Data,vrr_stack+1379, vrr_stack+860, vrr_stack+1253, vrr_stack+797, vrr_stack+734, vrr_stack+404);
 _BUILD_f0h0(Data,vrr_stack+1589, vrr_stack+1064, vrr_stack+860, vrr_stack+1001, vrr_stack+797, vrr_stack+494);
 _BUILD_g0h0(Data,vrr_stack+1799, vrr_stack+1589, vrr_stack+1379, vrr_stack+1064, vrr_stack+860, vrr_stack+584);
 _BUILD_00i0(Data,vrr_stack+359, vrr_stack+84, vrr_stack+126, vrr_stack+204, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+387, vrr_stack+105, vrr_stack+84, vrr_stack+274, vrr_stack+204, NULL);
 _BUILD_p0i0(Data,vrr_stack+415, vrr_stack+387, vrr_stack+359, NULL, NULL, vrr_stack+84);
 _BUILD_00i0(Data,vrr_stack+499, vrr_stack+228, vrr_stack+105, vrr_stack+986, vrr_stack+274, NULL);
 _BUILD_p0i0(Data,vrr_stack+527, vrr_stack+499, vrr_stack+387, NULL, NULL, vrr_stack+105);
 _BUILD_00i0(Data,vrr_stack+611, vrr_stack+126, vrr_stack+249, vrr_stack+21, vrr_stack+344, NULL);
 _BUILD_p0i0(Data,vrr_stack+639, vrr_stack+359, vrr_stack+611, NULL, NULL, vrr_stack+126);
 _BUILD_d0i0(Data,vrr_stack+2114, vrr_stack+415, vrr_stack+639, vrr_stack+387, vrr_stack+359, vrr_stack+734);
 _BUILD_d0i0(Data,vrr_stack+2282, vrr_stack+527, vrr_stack+415, vrr_stack+499, vrr_stack+387, vrr_stack+797);
 _BUILD_f0i0(Data,vrr_stack+2450, vrr_stack+2282, vrr_stack+2114, vrr_stack+527, vrr_stack+415, vrr_stack+860);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+219, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+723, vrr_stack+24, vrr_stack+222, vrr_stack+21, vrr_stack+219, NULL);
 _BUILD_00g0(Data,vrr_stack+733, vrr_stack+723, vrr_stack+39, vrr_stack+24, vrr_stack+222, NULL);
 _BUILD_00h0(Data,vrr_stack+748, vrr_stack+733, vrr_stack+986, vrr_stack+723, vrr_stack+39, NULL);
 _BUILD_00i0(Data,vrr_stack+769, vrr_stack+748, vrr_stack+228, vrr_stack+733, vrr_stack+986, NULL);
 _BUILD_p0i0(Data,vrr_stack+797, vrr_stack+769, vrr_stack+499, NULL, NULL, vrr_stack+228);
 _BUILD_d0i0(Data,vrr_stack+2730, vrr_stack+797, vrr_stack+527, vrr_stack+769, vrr_stack+499, vrr_stack+1001);
 _BUILD_f0i0(Data,vrr_stack+2898, vrr_stack+2730, vrr_stack+2282, vrr_stack+797, vrr_stack+527, vrr_stack+1064);
 _BUILD_00p0(Data,vrr_stack+39, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+30, vrr_stack+36, vrr_stack+39, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+881, vrr_stack+15, vrr_stack+30, vrr_stack+0, vrr_stack+36, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+289, vrr_stack+881, vrr_stack+49, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+42, vrr_stack+299, vrr_stack+0, vrr_stack+334, vrr_stack+289, NULL);
 _BUILD_00i0(Data,vrr_stack+891, vrr_stack+249, vrr_stack+42, vrr_stack+344, vrr_stack+299, NULL);
 _BUILD_p0i0(Data,vrr_stack+919, vrr_stack+611, vrr_stack+891, NULL, NULL, vrr_stack+249);
 _BUILD_d0i0(Data,vrr_stack+1003, vrr_stack+639, vrr_stack+919, vrr_stack+359, vrr_stack+611, vrr_stack+1190);
 _BUILD_f0i0(Data,vrr_stack+3178, vrr_stack+2114, vrr_stack+1003, vrr_stack+415, vrr_stack+639, vrr_stack+1253);
 _BUILD_g0i0(Data,vrr_stack+3458, vrr_stack+2450, vrr_stack+3178, vrr_stack+2282, vrr_stack+2114, vrr_stack+1379);
 _BUILD_g0i0(Data,vrr_stack+3878, vrr_stack+2898, vrr_stack+2450, vrr_stack+2730, vrr_stack+2282, vrr_stack+1589);
 _BUILD_h0i0(Data,vrr_stack+1171, vrr_stack+3878, vrr_stack+3458, vrr_stack+2898, vrr_stack+2450, vrr_stack+1799);
 _BUILD_00k0(Data,vrr_stack+1759, vrr_stack+387, vrr_stack+359, vrr_stack+105, vrr_stack+84, NULL);
 _BUILD_00k0(Data,vrr_stack+1795, vrr_stack+499, vrr_stack+387, vrr_stack+228, vrr_stack+105, NULL);
 _BUILD_00k0(Data,vrr_stack+1831, vrr_stack+359, vrr_stack+611, vrr_stack+84, vrr_stack+126, NULL);
 _BUILD_p0k0(Data,vrr_stack+1867, vrr_stack+1759, vrr_stack+1831, NULL, NULL, vrr_stack+359);
 _BUILD_p0k0(Data,vrr_stack+1975, vrr_stack+1795, vrr_stack+1759, NULL, NULL, vrr_stack+387);
 _BUILD_d0k0(Data,vrr_stack+4298, vrr_stack+1975, vrr_stack+1867, vrr_stack+1795, vrr_stack+1759, vrr_stack+415);
 _BUILD_00k0(Data,vrr_stack+415, vrr_stack+769, vrr_stack+499, vrr_stack+748, vrr_stack+228, NULL);
 _BUILD_p0k0(Data,vrr_stack+4514, vrr_stack+415, vrr_stack+1795, NULL, NULL, vrr_stack+499);
 _BUILD_d0k0(Data,vrr_stack+4622, vrr_stack+4514, vrr_stack+1975, vrr_stack+415, vrr_stack+1795, vrr_stack+527);
 _BUILD_00k0(Data,vrr_stack+527, vrr_stack+611, vrr_stack+891, vrr_stack+126, vrr_stack+249, NULL);
 _BUILD_p0k0(Data,vrr_stack+63, vrr_stack+1831, vrr_stack+527, NULL, NULL, vrr_stack+611);
 _BUILD_d0k0(Data,vrr_stack+4838, vrr_stack+1867, vrr_stack+63, vrr_stack+1759, vrr_stack+1831, vrr_stack+639);
 _BUILD_f0k0(Data,vrr_stack+5054, vrr_stack+4298, vrr_stack+4838, vrr_stack+1975, vrr_stack+1867, vrr_stack+2114);
 _BUILD_f0k0(Data,vrr_stack+5414, vrr_stack+4622, vrr_stack+4298, vrr_stack+4514, vrr_stack+1975, vrr_stack+2282);
 _BUILD_g0k0(Data,vrr_stack+5774, vrr_stack+5414, vrr_stack+5054, vrr_stack+4622, vrr_stack+4298, vrr_stack+2450);
 _BUILD_00p0(Data,vrr_stack+639, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+642, vrr_stack+639, vrr_stack+21, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+648, vrr_stack+642, vrr_stack+24, vrr_stack+639, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+658, vrr_stack+648, vrr_stack+723, vrr_stack+642, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+673, vrr_stack+658, vrr_stack+733, vrr_stack+648, vrr_stack+723, NULL);
 _BUILD_00i0(Data,vrr_stack+694, vrr_stack+673, vrr_stack+748, vrr_stack+658, vrr_stack+733, NULL);
 _BUILD_00k0(Data,vrr_stack+563, vrr_stack+694, vrr_stack+769, vrr_stack+673, vrr_stack+748, NULL);
 _BUILD_p0k0(Data,vrr_stack+2083, vrr_stack+563, vrr_stack+415, NULL, NULL, vrr_stack+769);
 _BUILD_d0k0(Data,vrr_stack+2191, vrr_stack+2083, vrr_stack+4514, vrr_stack+563, vrr_stack+415, vrr_stack+797);
 _BUILD_f0k0(Data,vrr_stack+6314, vrr_stack+2191, vrr_stack+4622, vrr_stack+2083, vrr_stack+4514, vrr_stack+2730);
 _BUILD_g0k0(Data,vrr_stack+6674, vrr_stack+6314, vrr_stack+5414, vrr_stack+2191, vrr_stack+4622, vrr_stack+2898);
 _BUILD_00p0(Data,vrr_stack+2083, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2086, vrr_stack+39, vrr_stack+2083, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+2092, vrr_stack+30, vrr_stack+2086, vrr_stack+36, vrr_stack+39, NULL);
 _BUILD_00g0(Data,vrr_stack+2102, vrr_stack+881, vrr_stack+2092, vrr_stack+15, vrr_stack+30, NULL);
 _BUILD_00h0(Data,vrr_stack+2117, vrr_stack+0, vrr_stack+2102, vrr_stack+289, vrr_stack+881, NULL);
 _BUILD_00i0(Data,vrr_stack+2138, vrr_stack+42, vrr_stack+2117, vrr_stack+299, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+2166, vrr_stack+891, vrr_stack+2138, vrr_stack+249, vrr_stack+42, NULL);
 _BUILD_p0k0(Data,vrr_stack+2202, vrr_stack+527, vrr_stack+2166, NULL, NULL, vrr_stack+891);
 _BUILD_d0k0(Data,vrr_stack+2310, vrr_stack+63, vrr_stack+2202, vrr_stack+1831, vrr_stack+527, vrr_stack+919);
 _BUILD_f0k0(Data,vrr_stack+2526, vrr_stack+4838, vrr_stack+2310, vrr_stack+1867, vrr_stack+63, vrr_stack+1003);
 _BUILD_g0k0(Data,vrr_stack+7214, vrr_stack+5054, vrr_stack+2526, vrr_stack+4298, vrr_stack+4838, vrr_stack+3178);
 _BUILD_h0k0(Data,vrr_stack+7754, vrr_stack+5774, vrr_stack+7214, vrr_stack+5414, vrr_stack+5054, vrr_stack+3458);
 _BUILD_h0k0(Data,vrr_stack+2886, vrr_stack+6674, vrr_stack+5774, vrr_stack+6314, vrr_stack+5414, vrr_stack+3878);
 _BUILD_00l0(Data,vrr_stack+6314, vrr_stack+1759, vrr_stack+1831, vrr_stack+387, vrr_stack+359, NULL);
 _BUILD_00l0(Data,vrr_stack+6359, vrr_stack+1795, vrr_stack+1759, vrr_stack+499, vrr_stack+387, NULL);
 _BUILD_00l0(Data,vrr_stack+6404, vrr_stack+1831, vrr_stack+527, vrr_stack+359, vrr_stack+611, NULL);
 _BUILD_p0l0(Data,vrr_stack+6449, vrr_stack+6314, vrr_stack+6404, NULL, NULL, vrr_stack+1831);
 _BUILD_p0l0(Data,vrr_stack+919, vrr_stack+6359, vrr_stack+6314, NULL, NULL, vrr_stack+1759);
 _BUILD_d0l0(Data,vrr_stack+3642, vrr_stack+919, vrr_stack+6449, vrr_stack+6359, vrr_stack+6314, vrr_stack+1867);
 _BUILD_00l0(Data,vrr_stack+1831, vrr_stack+415, vrr_stack+1795, vrr_stack+769, vrr_stack+499, NULL);
 _BUILD_p0l0(Data,vrr_stack+3912, vrr_stack+1831, vrr_stack+6359, NULL, NULL, vrr_stack+1795);
 _BUILD_d0l0(Data,vrr_stack+8510, vrr_stack+3912, vrr_stack+919, vrr_stack+1831, vrr_stack+6359, vrr_stack+1975);
 _BUILD_00l0(Data,vrr_stack+6359, vrr_stack+527, vrr_stack+2166, vrr_stack+611, vrr_stack+891, NULL);
 _BUILD_p0l0(Data,vrr_stack+1876, vrr_stack+6404, vrr_stack+6359, NULL, NULL, vrr_stack+527);
 _BUILD_d0l0(Data,vrr_stack+8780, vrr_stack+6449, vrr_stack+1876, vrr_stack+6314, vrr_stack+6404, vrr_stack+63);
 _BUILD_f0l0(Data,vrr_stack+9050, vrr_stack+3642, vrr_stack+8780, vrr_stack+919, vrr_stack+6449, vrr_stack+4838);
 _BUILD_f0l0(Data,vrr_stack+9500, vrr_stack+8510, vrr_stack+3642, vrr_stack+3912, vrr_stack+919, vrr_stack+4298);
 _BUILD_g0l0(Data,vrr_stack+9950, vrr_stack+9500, vrr_stack+9050, vrr_stack+8510, vrr_stack+3642, vrr_stack+5054);
 _BUILD_00l0(Data,vrr_stack+6314, vrr_stack+563, vrr_stack+415, vrr_stack+694, vrr_stack+769, NULL);
 _BUILD_p0l0(Data,vrr_stack+919, vrr_stack+6314, vrr_stack+1831, NULL, NULL, vrr_stack+415);
 _BUILD_d0l0(Data,vrr_stack+4838, vrr_stack+919, vrr_stack+3912, vrr_stack+6314, vrr_stack+1831, vrr_stack+4514);
 _BUILD_f0l0(Data,vrr_stack+63, vrr_stack+4838, vrr_stack+8510, vrr_stack+919, vrr_stack+3912, vrr_stack+4622);
 _BUILD_g0l0(Data,vrr_stack+3912, vrr_stack+63, vrr_stack+9500, vrr_stack+4838, vrr_stack+8510, vrr_stack+5414);
 _BUILD_00p0(Data,vrr_stack+36, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+8510, vrr_stack+2083, vrr_stack+36, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+8516, vrr_stack+2086, vrr_stack+8510, vrr_stack+39, vrr_stack+2083, NULL);
 _BUILD_00g0(Data,vrr_stack+15, vrr_stack+2092, vrr_stack+8516, vrr_stack+30, vrr_stack+2086, NULL);
 _BUILD_00h0(Data,vrr_stack+8510, vrr_stack+2102, vrr_stack+15, vrr_stack+881, vrr_stack+2092, NULL);
 _BUILD_00i0(Data,vrr_stack+8531, vrr_stack+2117, vrr_stack+8510, vrr_stack+0, vrr_stack+2102, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+2138, vrr_stack+8531, vrr_stack+42, vrr_stack+2117, NULL);
 _BUILD_00l0(Data,vrr_stack+6314, vrr_stack+2166, vrr_stack+0, vrr_stack+891, vrr_stack+2138, NULL);
 _BUILD_p0l0(Data,vrr_stack+8510, vrr_stack+6359, vrr_stack+6314, NULL, NULL, vrr_stack+2166);
 _BUILD_d0l0(Data,vrr_stack+4587, vrr_stack+1876, vrr_stack+8510, vrr_stack+6404, vrr_stack+6359, vrr_stack+2202);
 _BUILD_f0l0(Data,vrr_stack+4857, vrr_stack+8780, vrr_stack+4587, vrr_stack+6449, vrr_stack+1876, vrr_stack+2310);
 _BUILD_g0l0(Data,vrr_stack+1759, vrr_stack+9050, vrr_stack+4857, vrr_stack+3642, vrr_stack+8780, vrr_stack+2526);
 _BUILD_h0l0(Data,vrr_stack+4587, vrr_stack+9950, vrr_stack+1759, vrr_stack+9500, vrr_stack+9050, vrr_stack+7214);
 _BUILD_h0l0(Data,vrr_stack+1759, vrr_stack+3912, vrr_stack+9950, vrr_stack+63, vrr_stack+9500, vrr_stack+5774);
 _BUILD_i0k0(Data,vrr_stack+8510, vrr_stack+2886, vrr_stack+7754, vrr_stack+6674, vrr_stack+5774, vrr_stack+1171);
   tmp = vrr_stack + 8510;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_i0l0(Data,vrr_stack+5532, vrr_stack+1759, vrr_stack+4587, vrr_stack+3912, vrr_stack+9950, vrr_stack+7754);
   tmp = vrr_stack + 5532;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];

}

