/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_hfhh(Libr12_t *, prim_data *);

  /* Computes (hf|hh) integrals for linear R12-methods */

void hrr_grt_order_hfhh(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[5][5] = int_stack + 0;
 Libr12->t2vrr_classes[5][6] = int_stack + 441;
 Libr12->t2vrr_classes[5][7] = int_stack + 1029;
 Libr12->t2vrr_classes[5][8] = int_stack + 1785;
 Libr12->t2vrr_classes[5][9] = int_stack + 2730;
 Libr12->t2vrr_classes[5][10] = int_stack + 3885;
 Libr12->t2vrr_classes[6][5] = int_stack + 5271;
 Libr12->t2vrr_classes[6][6] = int_stack + 5859;
 Libr12->t2vrr_classes[6][7] = int_stack + 6643;
 Libr12->t2vrr_classes[6][8] = int_stack + 7651;
 Libr12->t2vrr_classes[6][9] = int_stack + 8911;
 Libr12->t2vrr_classes[6][10] = int_stack + 10451;
 Libr12->t2vrr_classes[7][5] = int_stack + 12299;
 Libr12->t2vrr_classes[7][6] = int_stack + 13055;
 Libr12->t2vrr_classes[7][7] = int_stack + 14063;
 Libr12->t2vrr_classes[7][8] = int_stack + 15359;
 Libr12->t2vrr_classes[7][9] = int_stack + 16979;
 Libr12->t2vrr_classes[7][10] = int_stack + 18959;
 Libr12->gvrr_classes[9][5] = int_stack + 21335;
 Libr12->t2vrr_classes[8][5] = int_stack + 22490;
 Libr12->gvrr_classes[9][6] = int_stack + 23435;
 Libr12->t2vrr_classes[8][6] = int_stack + 24975;
 Libr12->gvrr_classes[9][7] = int_stack + 26235;
 Libr12->t2vrr_classes[8][7] = int_stack + 28215;
 Libr12->gvrr_classes[9][8] = int_stack + 29835;
 Libr12->t2vrr_classes[8][8] = int_stack + 32310;
 Libr12->gvrr_classes[9][9] = int_stack + 34335;
 Libr12->t2vrr_classes[8][9] = int_stack + 37360;
 Libr12->t2vrr_classes[8][10] = int_stack + 39835;
 Libr12->gvrr_classes[5][11] = int_stack + 42805;
 Libr12->t1vrr_classes[5][5] = int_stack + 44443;
 Libr12->t1vrr_classes[5][6] = int_stack + 44884;
 Libr12->t1vrr_classes[5][7] = int_stack + 45472;
 Libr12->t1vrr_classes[5][8] = int_stack + 46228;
 Libr12->t1vrr_classes[5][9] = int_stack + 47173;
 Libr12->t1vrr_classes[5][10] = int_stack + 48328;
 Libr12->gvrr_classes[6][11] = int_stack + 49714;
 Libr12->t1vrr_classes[6][5] = int_stack + 51898;
 Libr12->t1vrr_classes[6][6] = int_stack + 52486;
 Libr12->t1vrr_classes[6][7] = int_stack + 53270;
 Libr12->t1vrr_classes[6][8] = int_stack + 54278;
 Libr12->t1vrr_classes[6][9] = int_stack + 55538;
 Libr12->t1vrr_classes[6][10] = int_stack + 57078;
 Libr12->gvrr_classes[7][11] = int_stack + 58926;
 Libr12->t1vrr_classes[7][5] = int_stack + 61734;
 Libr12->t1vrr_classes[7][6] = int_stack + 62490;
 Libr12->t1vrr_classes[7][7] = int_stack + 63498;
 Libr12->t1vrr_classes[7][8] = int_stack + 64794;
 Libr12->t1vrr_classes[7][9] = int_stack + 66414;
 Libr12->t1vrr_classes[7][10] = int_stack + 68394;
 Libr12->t1vrr_classes[8][5] = int_stack + 70770;
 Libr12->t1vrr_classes[8][6] = int_stack + 71715;
 Libr12->t1vrr_classes[8][7] = int_stack + 72975;
 Libr12->t1vrr_classes[8][8] = int_stack + 74595;
 Libr12->t1vrr_classes[8][9] = int_stack + 76620;
 Libr12->t1vrr_classes[8][10] = int_stack + 79095;
 Libr12->rvrr_classes[5][5] = int_stack + 82065;
 Libr12->rvrr_classes[5][6] = int_stack + 82506;
 Libr12->rvrr_classes[5][7] = int_stack + 83094;
 Libr12->rvrr_classes[5][8] = int_stack + 83850;
 Libr12->rvrr_classes[5][9] = int_stack + 84795;
 Libr12->rvrr_classes[5][10] = int_stack + 85950;
 Libr12->rvrr_classes[6][5] = int_stack + 87336;
 Libr12->rvrr_classes[6][6] = int_stack + 87924;
 Libr12->rvrr_classes[6][7] = int_stack + 88708;
 Libr12->rvrr_classes[6][8] = int_stack + 89716;
 Libr12->rvrr_classes[6][9] = int_stack + 90976;
 Libr12->rvrr_classes[6][10] = int_stack + 92516;
 Libr12->rvrr_classes[7][5] = int_stack + 94364;
 Libr12->rvrr_classes[7][6] = int_stack + 95120;
 Libr12->rvrr_classes[7][7] = int_stack + 96128;
 Libr12->rvrr_classes[7][8] = int_stack + 97424;
 Libr12->rvrr_classes[7][9] = int_stack + 99044;
 Libr12->rvrr_classes[7][10] = int_stack + 101024;
 Libr12->rvrr_classes[8][5] = int_stack + 103400;
 Libr12->rvrr_classes[8][6] = int_stack + 104345;
 Libr12->rvrr_classes[8][7] = int_stack + 105605;
 Libr12->rvrr_classes[8][8] = int_stack + 107225;
 Libr12->rvrr_classes[8][9] = int_stack + 109250;
 Libr12->rvrr_classes[8][10] = int_stack + 111725;
 Libr12->gvrr_classes[5][5] = int_stack + 114695;
 Libr12->gvrr_classes[5][6] = int_stack + 115136;
 Libr12->gvrr_classes[5][7] = int_stack + 115724;
 Libr12->gvrr_classes[5][8] = int_stack + 116480;
 Libr12->gvrr_classes[5][9] = int_stack + 117425;
 Libr12->gvrr_classes[5][10] = int_stack + 118580;
 Libr12->gvrr_classes[6][5] = int_stack + 119966;
 Libr12->gvrr_classes[6][6] = int_stack + 120554;
 Libr12->gvrr_classes[6][7] = int_stack + 121338;
 Libr12->gvrr_classes[6][8] = int_stack + 122346;
 Libr12->gvrr_classes[6][9] = int_stack + 123606;
 Libr12->gvrr_classes[6][10] = int_stack + 125146;
 Libr12->gvrr_classes[7][5] = int_stack + 126994;
 Libr12->gvrr_classes[7][6] = int_stack + 127750;
 Libr12->gvrr_classes[7][7] = int_stack + 128758;
 Libr12->gvrr_classes[7][8] = int_stack + 130054;
 Libr12->gvrr_classes[7][9] = int_stack + 131674;
 Libr12->gvrr_classes[7][10] = int_stack + 133654;
 Libr12->gvrr_classes[8][5] = int_stack + 136030;
 Libr12->gvrr_classes[8][6] = int_stack + 136975;
 Libr12->gvrr_classes[8][7] = int_stack + 138235;
 Libr12->gvrr_classes[8][8] = int_stack + 139855;
 Libr12->gvrr_classes[8][9] = int_stack + 141880;
 Libr12->gvrr_classes[8][10] = int_stack + 144355;
 memset(int_stack,0,147325*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 147325;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_hfhh(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+147325, int_stack+115136, int_stack+114695, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+148648, int_stack+115724, int_stack+115136, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+150412, int_stack+148648, int_stack+147325, 21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+153058, int_stack+116480, int_stack+115724, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+155326, int_stack+153058, int_stack+148648, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+158854, int_stack+155326, int_stack+150412, 21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+163264, int_stack+117425, int_stack+116480, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+166099, int_stack+163264, int_stack+153058, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+170635, int_stack+166099, int_stack+155326, 21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+176515, int_stack+170635, int_stack+158854, 21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+183130, int_stack+120554, int_stack+119966, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+184894, int_stack+121338, int_stack+120554, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+187246, int_stack+184894, int_stack+183130, 28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+190774, int_stack+122346, int_stack+121338, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+193798, int_stack+190774, int_stack+184894, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+198502, int_stack+193798, int_stack+187246, 28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+204382, int_stack+123606, int_stack+122346, 28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+208162, int_stack+204382, int_stack+190774, 28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+214210, int_stack+208162, int_stack+193798, 28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+222050, int_stack+214210, int_stack+198502, 28);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+230870, int_stack+118580, int_stack+117425, 21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+234335, int_stack+230870, int_stack+163264, 21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+240005, int_stack+234335, int_stack+166099, 21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+247565, int_stack+240005, int_stack+170635, 21);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256385, int_stack+441, int_stack+0, int_stack+115136, int_stack+119966, int_stack+114695, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+257708, int_stack+1029, int_stack+441, int_stack+115724, int_stack+120554, int_stack+115136, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+259472, int_stack+257708, int_stack+256385, int_stack+148648, int_stack+183130, int_stack+147325, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+262118, int_stack+1785, int_stack+1029, int_stack+116480, int_stack+121338, int_stack+115724, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+264386, int_stack+262118, int_stack+257708, int_stack+153058, int_stack+184894, int_stack+148648, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+267914, int_stack+264386, int_stack+259472, int_stack+155326, int_stack+187246, int_stack+150412, 5, 0);
 /*--- compute (h0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+147325, int_stack+2730, int_stack+1785, int_stack+117425, int_stack+122346, int_stack+116480, 5, 0);
 /*--- compute (h0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256385, int_stack+147325, int_stack+262118, int_stack+163264, int_stack+190774, int_stack+153058, 5, 0);
 /*--- compute (h0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+272324, int_stack+256385, int_stack+264386, int_stack+166099, int_stack+193798, int_stack+155326, 5, 0);
 /*--- compute (h0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+150160, int_stack+272324, int_stack+267914, int_stack+170635, int_stack+198502, int_stack+158854, 5, 0);
 /*--- compute (h0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+156775, int_stack+3885, int_stack+2730, int_stack+118580, int_stack+123606, int_stack+117425, 5, 0);
 /*--- compute (h0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+260921, int_stack+156775, int_stack+147325, int_stack+230870, int_stack+204382, int_stack+163264, 5, 0);
 /*--- compute (h0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+156775, int_stack+260921, int_stack+256385, int_stack+234335, int_stack+208162, int_stack+166099, 5, 0);
 /*--- compute (h0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256385, int_stack+156775, int_stack+272324, int_stack+240005, int_stack+214210, int_stack+170635, 5, 0);
 /*--- compute (h0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+156775, int_stack+256385, int_stack+150160, int_stack+247565, int_stack+222050, int_stack+176515, 5, 0);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+256385, int_stack+127750, int_stack+126994, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+258653, int_stack+128758, int_stack+127750, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+261677, int_stack+258653, int_stack+256385, 36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+266213, int_stack+130054, int_stack+128758, 36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+270101, int_stack+266213, int_stack+258653, 36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+166036, int_stack+270101, int_stack+261677, 36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+147325, int_stack+131674, int_stack+130054, 36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+276149, int_stack+147325, int_stack+266213, 36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+283925, int_stack+276149, int_stack+270101, 36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+294005, int_stack+283925, int_stack+166036, 36);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+125146, int_stack+123606, 28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+305345, int_stack+0, int_stack+204382, 28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+312905, int_stack+305345, int_stack+208162, 28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+322985, int_stack+312905, int_stack+214210, 28);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+173596, int_stack+5859, int_stack+5271, int_stack+120554, int_stack+126994, int_stack+119966, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+152185, int_stack+6643, int_stack+5859, int_stack+121338, int_stack+127750, int_stack+120554, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+114695, int_stack+152185, int_stack+173596, int_stack+184894, int_stack+256385, int_stack+183130, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+334745, int_stack+7651, int_stack+6643, int_stack+122346, int_stack+128758, int_stack+121338, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+337769, int_stack+334745, int_stack+152185, int_stack+190774, int_stack+258653, int_stack+184894, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+342473, int_stack+337769, int_stack+114695, int_stack+193798, int_stack+261677, int_stack+187246, 6, 0);
 /*--- compute (i0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+114695, int_stack+8911, int_stack+7651, int_stack+123606, int_stack+130054, int_stack+122346, 6, 0);
 /*--- compute (i0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+183130, int_stack+114695, int_stack+334745, int_stack+204382, int_stack+266213, int_stack+190774, 6, 0);
 /*--- compute (i0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+348353, int_stack+183130, int_stack+337769, int_stack+208162, int_stack+270101, int_stack+193798, 6, 0);
 /*--- compute (i0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+189178, int_stack+348353, int_stack+342473, int_stack+214210, int_stack+166036, int_stack+198502, 6, 0);
 /*--- compute (i0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+334745, int_stack+10451, int_stack+8911, int_stack+125146, int_stack+131674, int_stack+123606, 6, 0);
 /*--- compute (i0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+339365, int_stack+334745, int_stack+114695, int_stack+0, int_stack+147325, int_stack+204382, 6, 0);
 /*--- compute (i0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+197998, int_stack+339365, int_stack+183130, int_stack+305345, int_stack+276149, int_stack+208162, 6, 0);
 /*--- compute (i0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+334745, int_stack+197998, int_stack+348353, int_stack+312905, int_stack+283925, int_stack+214210, 6, 0);
 /*--- compute (i0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+197998, int_stack+334745, int_stack+189178, int_stack+322985, int_stack+294005, int_stack+222050, 6, 0);
 /*--- compute (hp|[r12,T2]|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+334745, int_stack+197998, int_stack+156775, 441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+210346, int_stack+136975, int_stack+136030, 45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+213181, int_stack+138235, int_stack+136975, 45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+183130, int_stack+213181, int_stack+210346, 45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+216961, int_stack+139855, int_stack+138235, 45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+188800, int_stack+216961, int_stack+213181, 45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+152185, int_stack+188800, int_stack+183130, 45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+4620, int_stack+141880, int_stack+139855, 45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+362528, int_stack+4620, int_stack+216961, 45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+372248, int_stack+362528, int_stack+188800, 45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+384848, int_stack+372248, int_stack+152185, 45);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+399023, int_stack+133654, int_stack+131674, 36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+404963, int_stack+399023, int_stack+147325, 36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+414683, int_stack+404963, int_stack+276149, 36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+427643, int_stack+414683, int_stack+283925, 36);
 /*--- compute (k0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+114695, int_stack+13055, int_stack+12299, int_stack+127750, int_stack+136030, int_stack+126994, 7, 0);
 /*--- compute (k0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161635, int_stack+14063, int_stack+13055, int_stack+128758, int_stack+136975, int_stack+127750, 7, 0);
 /*--- compute (k0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+119966, int_stack+161635, int_stack+114695, int_stack+258653, int_stack+210346, int_stack+256385, 7, 0);
 /*--- compute (k0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+442763, int_stack+15359, int_stack+14063, int_stack+130054, int_stack+138235, int_stack+128758, 7, 0);
 /*--- compute (k0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+446651, int_stack+442763, int_stack+161635, int_stack+266213, int_stack+213181, int_stack+258653, 7, 0);
 /*--- compute (k0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+452699, int_stack+446651, int_stack+119966, int_stack+270101, int_stack+183130, int_stack+261677, 7, 0);
 /*--- compute (k0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+119966, int_stack+16979, int_stack+15359, int_stack+131674, int_stack+139855, int_stack+130054, 7, 0);
 /*--- compute (k0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256385, int_stack+119966, int_stack+442763, int_stack+147325, int_stack+216961, int_stack+266213, 7, 0);
 /*--- compute (k0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+460259, int_stack+256385, int_stack+446651, int_stack+276149, int_stack+188800, int_stack+270101, 7, 0);
 /*--- compute (k0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+264161, int_stack+460259, int_stack+452699, int_stack+283925, int_stack+152185, int_stack+166036, 7, 0);
 /*--- compute (k0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+442763, int_stack+18959, int_stack+16979, int_stack+133654, int_stack+141880, int_stack+131674, 7, 0);
 /*--- compute (k0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+448703, int_stack+442763, int_stack+119966, int_stack+399023, int_stack+4620, int_stack+147325, 7, 0);
 /*--- compute (k0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161635, int_stack+448703, int_stack+256385, int_stack+404963, int_stack+362528, int_stack+276149, 7, 0);
 /*--- compute (k0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+442763, int_stack+161635, int_stack+460259, int_stack+414683, int_stack+372248, int_stack+283925, 7, 0);
 /*--- compute (k0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+275501, int_stack+442763, int_stack+264161, int_stack+427643, int_stack+384848, int_stack+294005, 7, 0);
 /*--- compute (ip|[r12,T2]|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+442763, int_stack+275501, int_stack+197998, 441);
 /*--- compute (hd|[r12,T2]|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+479807, int_stack+442763, int_stack+334745, 441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+334745, int_stack+23435, int_stack+21335, 55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+338210, int_stack+26235, int_stack+23435, 55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+342830, int_stack+338210, int_stack+334745, 55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+349760, int_stack+29835, int_stack+26235, 55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+161635, int_stack+349760, int_stack+338210, 55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+256385, int_stack+161635, int_stack+342830, 55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+267935, int_stack+34335, int_stack+29835, 55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+196360, int_stack+267935, int_stack+349760, 55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+535373, int_stack+196360, int_stack+161635, 55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+550773, int_stack+535373, int_stack+256385, 55);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+10695, int_stack+144355, int_stack+141880, 45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+568098, int_stack+10695, int_stack+4620, 45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+580248, int_stack+568098, int_stack+362528, 45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+596448, int_stack+580248, int_stack+372248, 45);
 /*--- compute (l0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+355700, int_stack+24975, int_stack+22490, int_stack+136975, int_stack+21335, int_stack+136030, 8, 0);
 /*--- compute (l0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+358535, int_stack+28215, int_stack+24975, int_stack+138235, int_stack+23435, int_stack+136975, 8, 0);
 /*--- compute (l0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+126994, int_stack+358535, int_stack+355700, int_stack+213181, int_stack+334745, int_stack+210346, 8, 0);
 /*--- compute (l0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+147325, int_stack+32310, int_stack+28215, int_stack+139855, int_stack+26235, int_stack+138235, 8, 0);
 /*--- compute (l0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+147325, int_stack+358535, int_stack+216961, int_stack+338210, int_stack+213181, 8, 0);
 /*--- compute (l0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+615348, int_stack+18120, int_stack+126994, int_stack+188800, int_stack+342830, int_stack+183130, 8, 0);
 /*--- compute (l0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+126994, int_stack+37360, int_stack+32310, int_stack+141880, int_stack+29835, int_stack+139855, 8, 0);
 /*--- compute (l0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+334745, int_stack+126994, int_stack+147325, int_stack+4620, int_stack+349760, int_stack+216961, 8, 0);
 /*--- compute (l0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+344465, int_stack+334745, int_stack+18120, int_stack+362528, int_stack+161635, int_stack+188800, 8, 0);
 /*--- compute (l0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161635, int_stack+344465, int_stack+615348, int_stack+372248, int_stack+256385, int_stack+152185, 8, 0);
 /*--- compute (l0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256385, int_stack+39835, int_stack+37360, int_stack+144355, int_stack+34335, int_stack+141880, 8, 0);
 /*--- compute (l0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+256385, int_stack+126994, int_stack+10695, int_stack+267935, int_stack+4620, 8, 0);
 /*--- compute (l0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256385, int_stack+18120, int_stack+334745, int_stack+568098, int_stack+196360, int_stack+362528, 8, 0);
 /*--- compute (l0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4620, int_stack+256385, int_stack+344465, int_stack+580248, int_stack+535373, int_stack+372248, 8, 0);
 /*--- compute (l0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+568098, int_stack+4620, int_stack+161635, int_stack+596448, int_stack+550773, int_stack+384848, 8, 0);
 /*--- compute (kp|[r12,T2]|hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+334745, int_stack+568098, int_stack+275501, 441);
 /*--- compute (id|[r12,T2]|hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+615348, int_stack+334745, int_stack+442763, 441);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+442763, int_stack+247565, int_stack+176515, 21);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+452024, int_stack+322985, int_stack+222050, 28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+334745, int_stack+452024, int_stack+442763, 441);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+362528, int_stack+427643, int_stack+294005, 36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+4620, int_stack+362528, int_stack+452024, 441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+535373, int_stack+4620, int_stack+334745, 441);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+42805, int_stack+118580, 21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+468530, int_stack+464372, int_stack+230870, 21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+256385, int_stack+468530, int_stack+234335, 21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+256385, int_stack+240005, 21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+256385, int_stack+464372, int_stack+247565, 21);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+49714, int_stack+125146, 28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+469916, int_stack+464372, int_stack+0, 28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+268733, int_stack+469916, int_stack+305345, 28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+268733, int_stack+312905, 28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+268733, int_stack+464372, int_stack+322985, 28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+285197, int_stack+268733, int_stack+256385, 588);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+58926, int_stack+133654, 36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+322241, int_stack+464372, int_stack+399023, 36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+322241, int_stack+404963, 36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+130895, int_stack+114695, int_stack+414683, 36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+399023, int_stack+130895, int_stack+427643, 36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+114695, int_stack+399023, int_stack+268733, 588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+164087, int_stack+114695, int_stack+285197, 588);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+420191, int_stack+596448, int_stack+384848, 45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+689436, int_stack+420191, int_stack+362528, 441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+737064, int_stack+689436, int_stack+4620, 441);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+238175, int_stack+44884, int_stack+44443, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+239498, int_stack+45472, int_stack+44884, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+241262, int_stack+239498, int_stack+238175, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+243908, int_stack+46228, int_stack+45472, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+246176, int_stack+243908, int_stack+239498, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+249704, int_stack+246176, int_stack+241262, 21);
 /*--- compute (h0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+238175, int_stack+47173, int_stack+46228, 21);
 /*--- compute (h0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+322241, int_stack+238175, int_stack+243908, 21);
 /*--- compute (h0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+326777, int_stack+322241, int_stack+246176, 21);
 /*--- compute (h0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+241010, int_stack+326777, int_stack+249704, 21);
 /*--- compute (h0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+247625, int_stack+48328, int_stack+47173, 21);
 /*--- compute (h0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+247625, int_stack+238175, 21);
 /*--- compute (h0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+247625, int_stack+464372, int_stack+322241, 21);
 /*--- compute (h0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+247625, int_stack+326777, 21);
 /*--- compute (h0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+322241, int_stack+464372, int_stack+241010, 21);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+52486, int_stack+51898, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+466136, int_stack+53270, int_stack+52486, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+468488, int_stack+466136, int_stack+464372, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+472016, int_stack+54278, int_stack+53270, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+475040, int_stack+472016, int_stack+466136, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+238175, int_stack+475040, int_stack+468488, 28);
 /*--- compute (i0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+55538, int_stack+54278, 28);
 /*--- compute (i0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+244055, int_stack+464372, int_stack+472016, 28);
 /*--- compute (i0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+378404, int_stack+244055, int_stack+475040, 28);
 /*--- compute (i0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+468152, int_stack+378404, int_stack+238175, 28);
 /*--- compute (i0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+57078, int_stack+55538, 28);
 /*--- compute (i0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+386244, int_stack+0, int_stack+464372, 28);
 /*--- compute (i0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+41664, int_stack+386244, int_stack+244055, 28);
 /*--- compute (i0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+386244, int_stack+41664, int_stack+378404, 28);
 /*--- compute (i0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+41664, int_stack+386244, int_stack+468152, 28);
 /*--- compute (hp|[r12,T1]|hh) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+811152, int_stack+41664, int_stack+322241, int_stack+452024, int_stack+256385, int_stack+442763, 5, 5);
 /*--- compute (k0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+322241, int_stack+62490, int_stack+61734, 36);
 /*--- compute (k0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+324509, int_stack+63498, int_stack+62490, 36);
 /*--- compute (k0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+327533, int_stack+324509, int_stack+322241, 36);
 /*--- compute (k0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+378404, int_stack+64794, int_stack+63498, 36);
 /*--- compute (k0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+382292, int_stack+378404, int_stack+324509, 36);
 /*--- compute (k0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+388340, int_stack+382292, int_stack+327533, 36);
 /*--- compute (k0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+322241, int_stack+66414, int_stack+64794, 36);
 /*--- compute (k0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+54012, int_stack+322241, int_stack+378404, 36);
 /*--- compute (k0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+464372, int_stack+54012, int_stack+382292, 36);
 /*--- compute (k0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+238175, int_stack+464372, int_stack+388340, 36);
 /*--- compute (k0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+378404, int_stack+68394, int_stack+66414, 36);
 /*--- compute (k0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+384344, int_stack+378404, int_stack+322241, 36);
 /*--- compute (k0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+249515, int_stack+384344, int_stack+54012, 36);
 /*--- compute (k0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+54012, int_stack+249515, int_stack+464372, 36);
 /*--- compute (k0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+249515, int_stack+54012, int_stack+238175, 36);
 /*--- compute (ip|[r12,T1]|hh) ---*/
   t1hrr1_build_ip(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+838935, int_stack+249515, int_stack+41664, int_stack+362528, int_stack+268733, int_stack+452024, 5, 5);
 /*--- compute (hd|[r12,T1]|hh) ---*/
   t1hrr1_build_hd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+875979, int_stack+838935, int_stack+811152, int_stack+4620, int_stack+285197, int_stack+334745, 5, 5);
 /*--- compute (l0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+811152, int_stack+71715, int_stack+70770, 45);
 /*--- compute (l0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+813987, int_stack+72975, int_stack+71715, 45);
 /*--- compute (l0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+817767, int_stack+813987, int_stack+811152, 45);
 /*--- compute (l0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+823437, int_stack+74595, int_stack+72975, 45);
 /*--- compute (l0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+828297, int_stack+823437, int_stack+813987, 45);
 /*--- compute (l0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+41664, int_stack+828297, int_stack+817767, 45);
 /*--- compute (l0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+811152, int_stack+76620, int_stack+74595, 45);
 /*--- compute (l0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+51114, int_stack+811152, int_stack+823437, 45);
 /*--- compute (l0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+60834, int_stack+51114, int_stack+828297, 45);
 /*--- compute (l0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+817227, int_stack+60834, int_stack+41664, 45);
 /*--- compute (l0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+41664, int_stack+79095, int_stack+76620, 45);
 /*--- compute (l0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+265391, int_stack+41664, int_stack+811152, 45);
 /*--- compute (l0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+277541, int_stack+265391, int_stack+51114, 45);
 /*--- compute (l0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+41664, int_stack+277541, int_stack+60834, 45);
 /*--- compute (l0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+265391, int_stack+41664, int_stack+817227, 45);
 /*--- compute (kp|[r12,T1]|hh) ---*/
   t1hrr1_build_kp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+285236, int_stack+265391, int_stack+249515, int_stack+420191, int_stack+399023, int_stack+362528, 5, 5);
 /*--- compute (id|[r12,T1]|hh) ---*/
   t1hrr1_build_id(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+332864, int_stack+285236, int_stack+838935, int_stack+689436, int_stack+114695, int_stack+4620, 5, 5);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+82506, int_stack+82065, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+116018, int_stack+83094, int_stack+82506, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+117782, int_stack+116018, int_stack+114695, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+120428, int_stack+83850, int_stack+83094, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+122696, int_stack+120428, int_stack+116018, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+126224, int_stack+122696, int_stack+117782, 21);
 /*--- compute (h0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+84795, int_stack+83850, 21);
 /*--- compute (h0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+130634, int_stack+114695, int_stack+120428, 21);
 /*--- compute (h0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+135170, int_stack+130634, int_stack+122696, 21);
 /*--- compute (h0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+117530, int_stack+135170, int_stack+126224, 21);
 /*--- compute (h0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+124145, int_stack+85950, int_stack+84795, 21);
 /*--- compute (h0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+141050, int_stack+124145, int_stack+114695, 21);
 /*--- compute (h0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+146720, int_stack+141050, int_stack+130634, 21);
 /*--- compute (h0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+124145, int_stack+146720, int_stack+135170, 21);
 /*--- compute (h0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+132965, int_stack+124145, int_stack+117530, 21);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+87924, int_stack+87336, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+116459, int_stack+88708, int_stack+87924, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+118811, int_stack+116459, int_stack+114695, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+122339, int_stack+89716, int_stack+88708, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+125363, int_stack+122339, int_stack+116459, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+142226, int_stack+125363, int_stack+118811, 28);
 /*--- compute (i0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+90976, int_stack+89716, 28);
 /*--- compute (i0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+148106, int_stack+114695, int_stack+122339, 28);
 /*--- compute (i0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+154154, int_stack+148106, int_stack+125363, 28);
 /*--- compute (i0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+118475, int_stack+154154, int_stack+142226, 28);
 /*--- compute (i0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+142226, int_stack+92516, int_stack+90976, 28);
 /*--- compute (i0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+689436, int_stack+142226, int_stack+114695, 28);
 /*--- compute (i0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+696996, int_stack+689436, int_stack+148106, 28);
 /*--- compute (i0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+142226, int_stack+696996, int_stack+154154, 28);
 /*--- compute (i0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+689436, int_stack+142226, int_stack+118475, 28);
 /*--- compute (hp||hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+701784, int_stack+689436, int_stack+132965, 441);
 /*--- compute (k0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+729567, int_stack+95120, int_stack+94364, 36);
 /*--- compute (k0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+731835, int_stack+96128, int_stack+95120, 36);
 /*--- compute (k0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+731835, int_stack+729567, 36);
 /*--- compute (k0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+119231, int_stack+97424, int_stack+96128, 36);
 /*--- compute (k0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+123119, int_stack+119231, int_stack+731835, 36);
 /*--- compute (k0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+129167, int_stack+123119, int_stack+114695, 36);
 /*--- compute (k0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+729567, int_stack+99044, int_stack+97424, 36);
 /*--- compute (k0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+136727, int_stack+729567, int_stack+119231, 36);
 /*--- compute (k0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+144503, int_stack+136727, int_stack+123119, 36);
 /*--- compute (k0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+114695, int_stack+144503, int_stack+129167, 36);
 /*--- compute (k0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+126035, int_stack+101024, int_stack+99044, 36);
 /*--- compute (k0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+406952, int_stack+126035, int_stack+729567, 36);
 /*--- compute (k0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+416672, int_stack+406952, int_stack+136727, 36);
 /*--- compute (k0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+126035, int_stack+416672, int_stack+144503, 36);
 /*--- compute (k0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+406952, int_stack+126035, int_stack+114695, 36);
 /*--- compute (ip||hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+114695, int_stack+406952, int_stack+689436, 441);
 /*--- compute (hd||hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+422828, int_stack+114695, int_stack+701784, 441);
 /*--- compute (l0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+689436, int_stack+104345, int_stack+103400, 45);
 /*--- compute (l0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+692271, int_stack+105605, int_stack+104345, 45);
 /*--- compute (l0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+696051, int_stack+692271, int_stack+689436, 45);
 /*--- compute (l0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+701721, int_stack+107225, int_stack+105605, 45);
 /*--- compute (l0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+706581, int_stack+701721, int_stack+692271, 45);
 /*--- compute (l0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+714141, int_stack+706581, int_stack+696051, 45);
 /*--- compute (l0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+689436, int_stack+109250, int_stack+107225, 45);
 /*--- compute (l0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+723591, int_stack+689436, int_stack+701721, 45);
 /*--- compute (l0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+811152, int_stack+723591, int_stack+706581, 45);
 /*--- compute (l0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+695511, int_stack+811152, int_stack+714141, 45);
 /*--- compute (l0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+709686, int_stack+111725, int_stack+109250, 45);
 /*--- compute (l0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+151739, int_stack+709686, int_stack+689436, 45);
 /*--- compute (l0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+823752, int_stack+151739, int_stack+723591, 45);
 /*--- compute (l0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+709686, int_stack+823752, int_stack+811152, 45);
 /*--- compute (l0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+811152, int_stack+709686, int_stack+695511, 45);
 /*--- compute (kp||hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+689436, int_stack+811152, int_stack+406952, 441);
 /*--- compute (id||hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+238175, int_stack+689436, int_stack+114695, 441);
 /*--- compute (hf|[r12,T2]|hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+0, int_stack+615348, int_stack+479807, 441);
     Libr12->te_ptr[3] = int_stack + 0;
 /*--- compute (hf|[r12,T1]|hh) ---*/
   t1hrr1_build_hf(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+590939, int_stack+332864, int_stack+875979, int_stack+737064, int_stack+164087, int_stack+535373, 5, 5);
     Libr12->te_ptr[2] = int_stack + 590939;
 /*--- compute (hf||hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+811152, int_stack+238175, int_stack+422828, 441);
     Libr12->te_ptr[1] = int_stack + 811152;
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+92610, int_stack+737064, int_stack+535373, 441);
     Libr12->te_ptr[0] = int_stack + 92610;

}
