/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_hghg(Libr12_t *, prim_data *);

  /* Computes (hg|hg) integrals for linear R12-methods */

void hrr_grt_order_hghg(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[5][5] = int_stack + 0;
 Libr12->t2vrr_classes[5][6] = int_stack + 441;
 Libr12->t2vrr_classes[5][7] = int_stack + 1029;
 Libr12->t2vrr_classes[5][8] = int_stack + 1785;
 Libr12->t2vrr_classes[5][9] = int_stack + 2730;
 Libr12->t2vrr_classes[6][5] = int_stack + 3885;
 Libr12->t2vrr_classes[6][6] = int_stack + 4473;
 Libr12->t2vrr_classes[6][7] = int_stack + 5257;
 Libr12->t2vrr_classes[6][8] = int_stack + 6265;
 Libr12->t2vrr_classes[6][9] = int_stack + 7525;
 Libr12->t2vrr_classes[7][5] = int_stack + 9065;
 Libr12->t2vrr_classes[7][6] = int_stack + 9821;
 Libr12->t2vrr_classes[7][7] = int_stack + 10829;
 Libr12->t2vrr_classes[7][8] = int_stack + 12125;
 Libr12->t2vrr_classes[7][9] = int_stack + 13745;
 Libr12->t2vrr_classes[8][5] = int_stack + 15725;
 Libr12->t2vrr_classes[8][6] = int_stack + 16670;
 Libr12->t2vrr_classes[8][7] = int_stack + 17930;
 Libr12->t2vrr_classes[8][8] = int_stack + 19550;
 Libr12->t2vrr_classes[8][9] = int_stack + 21575;
 Libr12->gvrr_classes[10][5] = int_stack + 24050;
 Libr12->t2vrr_classes[9][5] = int_stack + 25436;
 Libr12->gvrr_classes[10][6] = int_stack + 26591;
 Libr12->t2vrr_classes[9][6] = int_stack + 28439;
 Libr12->gvrr_classes[10][7] = int_stack + 29979;
 Libr12->t2vrr_classes[9][7] = int_stack + 32355;
 Libr12->gvrr_classes[10][8] = int_stack + 34335;
 Libr12->t2vrr_classes[9][8] = int_stack + 37305;
 Libr12->t2vrr_classes[9][9] = int_stack + 39780;
 Libr12->gvrr_classes[5][10] = int_stack + 42805;
 Libr12->t1vrr_classes[5][5] = int_stack + 44191;
 Libr12->t1vrr_classes[5][6] = int_stack + 44632;
 Libr12->t1vrr_classes[5][7] = int_stack + 45220;
 Libr12->t1vrr_classes[5][8] = int_stack + 45976;
 Libr12->t1vrr_classes[5][9] = int_stack + 46921;
 Libr12->gvrr_classes[6][10] = int_stack + 48076;
 Libr12->t1vrr_classes[6][5] = int_stack + 49924;
 Libr12->t1vrr_classes[6][6] = int_stack + 50512;
 Libr12->t1vrr_classes[6][7] = int_stack + 51296;
 Libr12->t1vrr_classes[6][8] = int_stack + 52304;
 Libr12->t1vrr_classes[6][9] = int_stack + 53564;
 Libr12->gvrr_classes[7][10] = int_stack + 55104;
 Libr12->t1vrr_classes[7][5] = int_stack + 57480;
 Libr12->t1vrr_classes[7][6] = int_stack + 58236;
 Libr12->t1vrr_classes[7][7] = int_stack + 59244;
 Libr12->t1vrr_classes[7][8] = int_stack + 60540;
 Libr12->t1vrr_classes[7][9] = int_stack + 62160;
 Libr12->gvrr_classes[8][10] = int_stack + 64140;
 Libr12->t1vrr_classes[8][5] = int_stack + 67110;
 Libr12->t1vrr_classes[8][6] = int_stack + 68055;
 Libr12->t1vrr_classes[8][7] = int_stack + 69315;
 Libr12->t1vrr_classes[8][8] = int_stack + 70935;
 Libr12->t1vrr_classes[8][9] = int_stack + 72960;
 Libr12->t1vrr_classes[9][5] = int_stack + 75435;
 Libr12->t1vrr_classes[9][6] = int_stack + 76590;
 Libr12->t1vrr_classes[9][7] = int_stack + 78130;
 Libr12->t1vrr_classes[9][8] = int_stack + 80110;
 Libr12->t1vrr_classes[9][9] = int_stack + 82585;
 Libr12->rvrr_classes[5][5] = int_stack + 85610;
 Libr12->rvrr_classes[5][6] = int_stack + 86051;
 Libr12->rvrr_classes[5][7] = int_stack + 86639;
 Libr12->rvrr_classes[5][8] = int_stack + 87395;
 Libr12->rvrr_classes[5][9] = int_stack + 88340;
 Libr12->rvrr_classes[6][5] = int_stack + 89495;
 Libr12->rvrr_classes[6][6] = int_stack + 90083;
 Libr12->rvrr_classes[6][7] = int_stack + 90867;
 Libr12->rvrr_classes[6][8] = int_stack + 91875;
 Libr12->rvrr_classes[6][9] = int_stack + 93135;
 Libr12->rvrr_classes[7][5] = int_stack + 94675;
 Libr12->rvrr_classes[7][6] = int_stack + 95431;
 Libr12->rvrr_classes[7][7] = int_stack + 96439;
 Libr12->rvrr_classes[7][8] = int_stack + 97735;
 Libr12->rvrr_classes[7][9] = int_stack + 99355;
 Libr12->rvrr_classes[8][5] = int_stack + 101335;
 Libr12->rvrr_classes[8][6] = int_stack + 102280;
 Libr12->rvrr_classes[8][7] = int_stack + 103540;
 Libr12->rvrr_classes[8][8] = int_stack + 105160;
 Libr12->rvrr_classes[8][9] = int_stack + 107185;
 Libr12->rvrr_classes[9][5] = int_stack + 109660;
 Libr12->rvrr_classes[9][6] = int_stack + 110815;
 Libr12->rvrr_classes[9][7] = int_stack + 112355;
 Libr12->rvrr_classes[9][8] = int_stack + 114335;
 Libr12->rvrr_classes[9][9] = int_stack + 116810;
 Libr12->gvrr_classes[5][5] = int_stack + 119835;
 Libr12->gvrr_classes[5][6] = int_stack + 120276;
 Libr12->gvrr_classes[5][7] = int_stack + 120864;
 Libr12->gvrr_classes[5][8] = int_stack + 121620;
 Libr12->gvrr_classes[5][9] = int_stack + 122565;
 Libr12->gvrr_classes[6][5] = int_stack + 123720;
 Libr12->gvrr_classes[6][6] = int_stack + 124308;
 Libr12->gvrr_classes[6][7] = int_stack + 125092;
 Libr12->gvrr_classes[6][8] = int_stack + 126100;
 Libr12->gvrr_classes[6][9] = int_stack + 127360;
 Libr12->gvrr_classes[7][5] = int_stack + 128900;
 Libr12->gvrr_classes[7][6] = int_stack + 129656;
 Libr12->gvrr_classes[7][7] = int_stack + 130664;
 Libr12->gvrr_classes[7][8] = int_stack + 131960;
 Libr12->gvrr_classes[7][9] = int_stack + 133580;
 Libr12->gvrr_classes[8][5] = int_stack + 135560;
 Libr12->gvrr_classes[8][6] = int_stack + 136505;
 Libr12->gvrr_classes[8][7] = int_stack + 137765;
 Libr12->gvrr_classes[8][8] = int_stack + 139385;
 Libr12->gvrr_classes[8][9] = int_stack + 141410;
 Libr12->gvrr_classes[9][5] = int_stack + 143885;
 Libr12->gvrr_classes[9][6] = int_stack + 145040;
 Libr12->gvrr_classes[9][7] = int_stack + 146580;
 Libr12->gvrr_classes[9][8] = int_stack + 148560;
 Libr12->gvrr_classes[9][9] = int_stack + 151035;
 memset(int_stack,0,154060*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 154060;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_hghg(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+154060, int_stack+120276, int_stack+119835, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+155383, int_stack+120864, int_stack+120276, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+157147, int_stack+155383, int_stack+154060, 21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+159793, int_stack+121620, int_stack+120864, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+162061, int_stack+159793, int_stack+155383, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+165589, int_stack+162061, int_stack+157147, 21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+169999, int_stack+124308, int_stack+123720, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+171763, int_stack+125092, int_stack+124308, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+174115, int_stack+171763, int_stack+169999, 28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+177643, int_stack+126100, int_stack+125092, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+180667, int_stack+177643, int_stack+171763, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+185371, int_stack+180667, int_stack+174115, 28);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+191251, int_stack+122565, int_stack+121620, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+194086, int_stack+191251, int_stack+159793, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+198622, int_stack+194086, int_stack+162061, 21);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+204502, int_stack+441, int_stack+0, int_stack+120276, int_stack+123720, int_stack+119835, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+205825, int_stack+1029, int_stack+441, int_stack+120864, int_stack+124308, int_stack+120276, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+207589, int_stack+205825, int_stack+204502, int_stack+155383, int_stack+169999, int_stack+154060, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+210235, int_stack+1785, int_stack+1029, int_stack+121620, int_stack+125092, int_stack+120864, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+212503, int_stack+210235, int_stack+205825, int_stack+159793, int_stack+171763, int_stack+155383, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+216031, int_stack+212503, int_stack+207589, int_stack+162061, int_stack+174115, int_stack+157147, 5, 0);
 /*--- compute (h0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+154060, int_stack+2730, int_stack+1785, int_stack+122565, int_stack+126100, int_stack+121620, 5, 0);
 /*--- compute (h0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+204502, int_stack+154060, int_stack+210235, int_stack+191251, int_stack+177643, int_stack+159793, 5, 0);
 /*--- compute (h0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+154060, int_stack+204502, int_stack+212503, int_stack+194086, int_stack+180667, int_stack+162061, 5, 0);
 /*--- compute (h0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+204502, int_stack+154060, int_stack+216031, int_stack+198622, int_stack+185371, int_stack+165589, 5, 0);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+154060, int_stack+129656, int_stack+128900, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+156328, int_stack+130664, int_stack+129656, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+159352, int_stack+156328, int_stack+154060, 36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+211117, int_stack+131960, int_stack+130664, 36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+215005, int_stack+211117, int_stack+156328, 36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+221053, int_stack+215005, int_stack+159352, 36);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+127360, int_stack+126100, 28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+228613, int_stack+0, int_stack+177643, 28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+234661, int_stack+228613, int_stack+180667, 28);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+119835, int_stack+4473, int_stack+3885, int_stack+124308, int_stack+128900, int_stack+123720, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+242501, int_stack+5257, int_stack+4473, int_stack+125092, int_stack+129656, int_stack+124308, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+244853, int_stack+242501, int_stack+119835, int_stack+171763, int_stack+154060, int_stack+169999, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+248381, int_stack+6265, int_stack+5257, int_stack+126100, int_stack+130664, int_stack+125092, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+251405, int_stack+248381, int_stack+242501, int_stack+177643, int_stack+156328, int_stack+171763, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+256109, int_stack+251405, int_stack+244853, int_stack+180667, int_stack+159352, int_stack+174115, 6, 0);
 /*--- compute (i0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+242501, int_stack+7525, int_stack+6265, int_stack+127360, int_stack+131960, int_stack+126100, 6, 0);
 /*--- compute (i0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+169999, int_stack+242501, int_stack+248381, int_stack+0, int_stack+211117, int_stack+177643, 6, 0);
 /*--- compute (i0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+242501, int_stack+169999, int_stack+251405, int_stack+228613, int_stack+215005, int_stack+180667, 6, 0);
 /*--- compute (i0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+169999, int_stack+242501, int_stack+256109, int_stack+234661, int_stack+221053, int_stack+185371, 6, 0);
 /*--- compute (hp|[r12,T2]|hg) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+242501, int_stack+169999, int_stack+204502, 315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+204502, int_stack+136505, int_stack+135560, 45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+207337, int_stack+137765, int_stack+136505, 45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+178819, int_stack+207337, int_stack+204502, 45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+3780, int_stack+139385, int_stack+137765, 45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+262346, int_stack+3780, int_stack+207337, 45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+269906, int_stack+262346, int_stack+178819, 45);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+279356, int_stack+133580, int_stack+131960, 36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+284216, int_stack+279356, int_stack+211117, 36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+291992, int_stack+284216, int_stack+215005, 36);
 /*--- compute (k0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+119835, int_stack+9821, int_stack+9065, int_stack+129656, int_stack+135560, int_stack+128900, 7, 0);
 /*--- compute (k0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+123720, int_stack+10829, int_stack+9821, int_stack+130664, int_stack+136505, int_stack+129656, 7, 0);
 /*--- compute (k0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+302072, int_stack+123720, int_stack+119835, int_stack+156328, int_stack+204502, int_stack+154060, 7, 0);
 /*--- compute (k0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+306608, int_stack+12125, int_stack+10829, int_stack+131960, int_stack+137765, int_stack+130664, 7, 0);
 /*--- compute (k0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+310496, int_stack+306608, int_stack+123720, int_stack+211117, int_stack+207337, int_stack+156328, 7, 0);
 /*--- compute (k0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+316544, int_stack+310496, int_stack+302072, int_stack+215005, int_stack+178819, int_stack+159352, 7, 0);
 /*--- compute (k0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+154060, int_stack+13745, int_stack+12125, int_stack+133580, int_stack+139385, int_stack+131960, 7, 0);
 /*--- compute (k0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+324104, int_stack+154060, int_stack+306608, int_stack+279356, int_stack+3780, int_stack+211117, 7, 0);
 /*--- compute (k0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+154060, int_stack+324104, int_stack+310496, int_stack+284216, int_stack+262346, int_stack+215005, 7, 0);
 /*--- compute (k0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+302072, int_stack+154060, int_stack+316544, int_stack+291992, int_stack+269906, int_stack+221053, 7, 0);
 /*--- compute (ip|[r12,T2]|hg) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+313412, int_stack+302072, int_stack+169999, 315);
 /*--- compute (hd|[r12,T2]|hg) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+339872, int_stack+313412, int_stack+242501, 315);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+242501, int_stack+145040, int_stack+143885, 55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+245966, int_stack+146580, int_stack+145040, 55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+250586, int_stack+245966, int_stack+242501, 55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+169999, int_stack+148560, int_stack+146580, 55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+154060, int_stack+169999, int_stack+245966, 55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+379562, int_stack+154060, int_stack+250586, 55);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+211117, int_stack+141410, int_stack+139385, 45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+391112, int_stack+211117, int_stack+3780, 45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+400832, int_stack+391112, int_stack+262346, 45);
 /*--- compute (l0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+257516, int_stack+16670, int_stack+15725, int_stack+136505, int_stack+143885, int_stack+135560, 8, 0);
 /*--- compute (l0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217192, int_stack+17930, int_stack+16670, int_stack+137765, int_stack+145040, int_stack+136505, 8, 0);
 /*--- compute (l0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+8640, int_stack+217192, int_stack+257516, int_stack+207337, int_stack+242501, int_stack+204502, 8, 0);
 /*--- compute (l0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+413432, int_stack+19550, int_stack+17930, int_stack+139385, int_stack+146580, int_stack+137765, 8, 0);
 /*--- compute (l0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+418292, int_stack+413432, int_stack+217192, int_stack+3780, int_stack+245966, int_stack+207337, 8, 0);
 /*--- compute (l0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+425852, int_stack+418292, int_stack+8640, int_stack+262346, int_stack+250586, int_stack+178819, 8, 0);
 /*--- compute (l0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+8640, int_stack+21575, int_stack+19550, int_stack+141410, int_stack+148560, int_stack+139385, 8, 0);
 /*--- compute (l0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+435302, int_stack+8640, int_stack+413432, int_stack+211117, int_stack+169999, int_stack+3780, 8, 0);
 /*--- compute (l0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+3780, int_stack+435302, int_stack+418292, int_stack+391112, int_stack+154060, int_stack+262346, 8, 0);
 /*--- compute (l0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+435302, int_stack+3780, int_stack+425852, int_stack+400832, int_stack+379562, int_stack+269906, 8, 0);
 /*--- compute (kp|[r12,T2]|hg) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+449477, int_stack+435302, int_stack+302072, 315);
 /*--- compute (id|[r12,T2]|hg) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+483497, int_stack+449477, int_stack+313412, 315);
 /*--- compute (hf|[r12,T2]|hg) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+536417, int_stack+483497, int_stack+339872, 315);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+302072, int_stack+26591, int_stack+24050, 66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+306230, int_stack+29979, int_stack+26591, 66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+311774, int_stack+306230, int_stack+302072, 66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+320090, int_stack+34335, int_stack+29979, 66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+327218, int_stack+320090, int_stack+306230, 66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+338306, int_stack+327218, int_stack+311774, 66);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+352166, int_stack+151035, int_stack+148560, 55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+359591, int_stack+352166, int_stack+169999, 55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+3780, int_stack+359591, int_stack+154060, 55);
 /*--- compute (m0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+371471, int_stack+28439, int_stack+25436, int_stack+145040, int_stack+24050, int_stack+143885, 9, 0);
 /*--- compute (m0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+374936, int_stack+32355, int_stack+28439, int_stack+146580, int_stack+26591, int_stack+145040, 9, 0);
 /*--- compute (m0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+19180, int_stack+374936, int_stack+371471, int_stack+245966, int_stack+302072, int_stack+242501, 9, 0);
 /*--- compute (m0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+413432, int_stack+37305, int_stack+32355, int_stack+148560, int_stack+29979, int_stack+146580, 9, 0);
 /*--- compute (m0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+419372, int_stack+413432, int_stack+374936, int_stack+169999, int_stack+306230, int_stack+245966, 9, 0);
 /*--- compute (m0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+257516, int_stack+419372, int_stack+19180, int_stack+154060, int_stack+311774, int_stack+250586, 9, 0);
 /*--- compute (m0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+19180, int_stack+39780, int_stack+37305, int_stack+151035, int_stack+34335, int_stack+148560, 9, 0);
 /*--- compute (m0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+26605, int_stack+19180, int_stack+413432, int_stack+352166, int_stack+320090, int_stack+169999, 9, 0);
 /*--- compute (m0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+302072, int_stack+26605, int_stack+419372, int_stack+359591, int_stack+327218, int_stack+154060, 9, 0);
 /*--- compute (m0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+352166, int_stack+302072, int_stack+257516, int_stack+3780, int_stack+338306, int_stack+379562, 9, 0);
 /*--- compute (lp|[r12,T2]|hg) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+302072, int_stack+352166, int_stack+435302, 315);
 /*--- compute (kd|[r12,T2]|hg) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+602567, int_stack+302072, int_stack+449477, 315);
 /*--- compute (if|[r12,T2]|hg) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+670607, int_stack+602567, int_stack+483497, 315);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+204502, int_stack+198622, int_stack+165589, 21);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+602567, int_stack+234661, int_stack+185371, 28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+611387, int_stack+602567, int_stack+204502, 315);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+631232, int_stack+291992, int_stack+221053, 36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+642572, int_stack+631232, int_stack+602567, 315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+302072, int_stack+642572, int_stack+611387, 315);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+341762, int_stack+400832, int_stack+269906, 45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+413432, int_stack+341762, int_stack+631232, 315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+447452, int_stack+413432, int_stack+642572, 315);
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+758807, int_stack+447452, int_stack+302072, 315);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+355937, int_stack+42805, int_stack+122565, 21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+359402, int_stack+355937, int_stack+191251, 21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+365072, int_stack+359402, int_stack+194086, 21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+355937, int_stack+365072, int_stack+198622, 21);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+364757, int_stack+48076, int_stack+127360, 28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+369377, int_stack+364757, int_stack+0, 28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+500372, int_stack+369377, int_stack+228613, 28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+364757, int_stack+500372, int_stack+234661, 28);
 /*--- compute (hp|ig) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+500372, int_stack+364757, int_stack+355937, 420);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+526832, int_stack+55104, int_stack+133580, 36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+19180, int_stack+526832, int_stack+279356, 36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+28900, int_stack+19180, int_stack+284216, 36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+143885, int_stack+28900, int_stack+291992, 36);
 /*--- compute (ip|ig) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+159005, int_stack+143885, int_stack+364757, 420);
 /*--- compute (hd|ig) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+217192, int_stack+159005, int_stack+500372, 420);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+19180, int_stack+64140, int_stack+141410, 45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+26605, int_stack+19180, int_stack+211117, 45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+270112, int_stack+26605, int_stack+391112, 45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+19180, int_stack+270112, int_stack+400832, 45);
 /*--- compute (kp|ig) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+824957, int_stack+19180, int_stack+143885, 420);
 /*--- compute (id|ig) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+870317, int_stack+824957, int_stack+159005, 420);
 /*--- compute (hf|ig) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+940877, int_stack+870317, int_stack+217192, 420);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+270112, int_stack+3780, int_stack+379562, 55);
 /*--- compute (lp|hg) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+1029077, int_stack+270112, int_stack+341762, 315);
 /*--- compute (kd|hg) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+1071602, int_stack+1029077, int_stack+413432, 315);
 /*--- compute (if|hg) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+1139642, int_stack+1071602, int_stack+447452, 315);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+287437, int_stack+44632, int_stack+44191, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+288760, int_stack+45220, int_stack+44632, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+290524, int_stack+288760, int_stack+287437, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+293170, int_stack+45976, int_stack+45220, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+295438, int_stack+293170, int_stack+288760, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+211117, int_stack+295438, int_stack+290524, 21);
 /*--- compute (h0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+287437, int_stack+46921, int_stack+45976, 21);
 /*--- compute (h0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+38080, int_stack+287437, int_stack+293170, 21);
 /*--- compute (h0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+287437, int_stack+38080, int_stack+295438, 21);
 /*--- compute (h0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+38080, int_stack+287437, int_stack+211117, 21);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+211117, int_stack+50512, int_stack+49924, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+212881, int_stack+51296, int_stack+50512, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+287437, int_stack+212881, int_stack+211117, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+290965, int_stack+52304, int_stack+51296, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+293989, int_stack+290965, int_stack+212881, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+211117, int_stack+293989, int_stack+287437, 28);
 /*--- compute (i0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+44695, int_stack+53564, int_stack+52304, 28);
 /*--- compute (i0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+48475, int_stack+44695, int_stack+290965, 28);
 /*--- compute (i0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+526832, int_stack+48475, int_stack+293989, 28);
 /*--- compute (i0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+44695, int_stack+526832, int_stack+211117, 28);
 /*--- compute (hp|[r12,T1]|hg) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+376517, int_stack+44695, int_stack+38080, int_stack+602567, int_stack+355937, int_stack+204502, 5, 4);
 /*--- compute (k0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+355937, int_stack+58236, int_stack+57480, 36);
 /*--- compute (k0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+358205, int_stack+59244, int_stack+58236, 36);
 /*--- compute (k0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+38080, int_stack+358205, int_stack+355937, 36);
 /*--- compute (k0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+526832, int_stack+60540, int_stack+59244, 36);
 /*--- compute (k0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+53515, int_stack+526832, int_stack+358205, 36);
 /*--- compute (k0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+355937, int_stack+53515, int_stack+38080, 36);
 /*--- compute (k0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+38080, int_stack+62160, int_stack+60540, 36);
 /*--- compute (k0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+287437, int_stack+38080, int_stack+526832, 36);
 /*--- compute (k0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+0, int_stack+287437, int_stack+53515, 36);
 /*--- compute (k0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+53515, int_stack+0, int_stack+355937, 36);
 /*--- compute (ip|[r12,T1]|hg) ---*/
   t1hrr1_build_ip(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1227842, int_stack+53515, int_stack+44695, int_stack+631232, int_stack+364757, int_stack+602567, 5, 4);
 /*--- compute (hd|[r12,T1]|hg) ---*/
   t1hrr1_build_hd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1254302, int_stack+1227842, int_stack+376517, int_stack+642572, int_stack+500372, int_stack+611387, 5, 4);
 /*--- compute (l0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+500372, int_stack+68055, int_stack+67110, 45);
 /*--- compute (l0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+503207, int_stack+69315, int_stack+68055, 45);
 /*--- compute (l0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+506987, int_stack+503207, int_stack+500372, 45);
 /*--- compute (l0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+512657, int_stack+70935, int_stack+69315, 45);
 /*--- compute (l0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+517517, int_stack+512657, int_stack+503207, 45);
 /*--- compute (l0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+525077, int_stack+517517, int_stack+506987, 45);
 /*--- compute (l0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+500372, int_stack+72960, int_stack+70935, 45);
 /*--- compute (l0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+602567, int_stack+500372, int_stack+512657, 45);
 /*--- compute (l0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+500372, int_stack+602567, int_stack+517517, 45);
 /*--- compute (l0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+602567, int_stack+500372, int_stack+525077, 45);
 /*--- compute (kp|[r12,T1]|hg) ---*/
   t1hrr1_build_kp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+500372, int_stack+602567, int_stack+53515, int_stack+341762, int_stack+143885, int_stack+631232, 5, 4);
 /*--- compute (id|[r12,T1]|hg) ---*/
   t1hrr1_build_id(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+355937, int_stack+500372, int_stack+1227842, int_stack+413432, int_stack+159005, int_stack+642572, 5, 4);
 /*--- compute (hf|[r12,T1]|hg) ---*/
   t1hrr1_build_hf(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+119835, int_stack+355937, int_stack+1254302, int_stack+447452, int_stack+217192, int_stack+302072, 5, 4);
 /*--- compute (m0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1227842, int_stack+76590, int_stack+75435, 55);
 /*--- compute (m0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1231307, int_stack+78130, int_stack+76590, 55);
 /*--- compute (m0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1235927, int_stack+1231307, int_stack+1227842, 55);
 /*--- compute (m0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1242857, int_stack+80110, int_stack+78130, 55);
 /*--- compute (m0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1248797, int_stack+1242857, int_stack+1231307, 55);
 /*--- compute (m0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1258037, int_stack+1248797, int_stack+1235927, 55);
 /*--- compute (m0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1227842, int_stack+82585, int_stack+80110, 55);
 /*--- compute (m0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1269587, int_stack+1227842, int_stack+1242857, 55);
 /*--- compute (m0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1227842, int_stack+1269587, int_stack+1248797, 55);
 /*--- compute (m0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1269587, int_stack+1227842, int_stack+1258037, 55);
 /*--- compute (lp|[r12,T1]|hg) ---*/
   t1hrr1_build_lp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+616742, int_stack+1269587, int_stack+602567, int_stack+270112, int_stack+19180, int_stack+341762, 5, 4);
 /*--- compute (kd|[r12,T1]|hg) ---*/
   t1hrr1_build_kd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+0, int_stack+616742, int_stack+500372, int_stack+1029077, int_stack+824957, int_stack+413432, 5, 4);
 /*--- compute (if|[r12,T1]|hg) ---*/
   t1hrr1_build_if(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+185985, int_stack+0, int_stack+355937, int_stack+1071602, int_stack+870317, int_stack+447452, 5, 4);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+86051, int_stack+85610, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1323, int_stack+86639, int_stack+86051, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+3087, int_stack+1323, int_stack+0, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+5733, int_stack+87395, int_stack+86639, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+8001, int_stack+5733, int_stack+1323, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+11529, int_stack+8001, int_stack+3087, 21);
 /*--- compute (h0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+88340, int_stack+87395, 21);
 /*--- compute (h0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+15939, int_stack+0, int_stack+5733, 21);
 /*--- compute (h0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+0, int_stack+15939, int_stack+8001, 21);
 /*--- compute (h0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+15939, int_stack+0, int_stack+11529, 21);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+90083, int_stack+89495, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1764, int_stack+90867, int_stack+90083, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+4116, int_stack+1764, int_stack+0, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+7644, int_stack+91875, int_stack+90867, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+10668, int_stack+7644, int_stack+1764, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+22554, int_stack+10668, int_stack+4116, 28);
 /*--- compute (i0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+93135, int_stack+91875, 28);
 /*--- compute (i0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+28434, int_stack+0, int_stack+7644, 28);
 /*--- compute (i0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+0, int_stack+28434, int_stack+10668, 28);
 /*--- compute (i0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+28434, int_stack+0, int_stack+22554, 28);
 /*--- compute (hp||hg) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+37254, int_stack+28434, int_stack+15939, 315);
 /*--- compute (k0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+95431, int_stack+94675, 36);
 /*--- compute (k0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+2268, int_stack+96439, int_stack+95431, 36);
 /*--- compute (k0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+5292, int_stack+2268, int_stack+0, 36);
 /*--- compute (k0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+9828, int_stack+97735, int_stack+96439, 36);
 /*--- compute (k0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+13716, int_stack+9828, int_stack+2268, 36);
 /*--- compute (k0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+19764, int_stack+13716, int_stack+5292, 36);
 /*--- compute (k0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+99355, int_stack+97735, 36);
 /*--- compute (k0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+57099, int_stack+0, int_stack+9828, 36);
 /*--- compute (k0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+0, int_stack+57099, int_stack+13716, 36);
 /*--- compute (k0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+57099, int_stack+0, int_stack+19764, 36);
 /*--- compute (ip||hg) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+0, int_stack+57099, int_stack+28434, 315);
 /*--- compute (hd||hg) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+824957, int_stack+0, int_stack+37254, 315);
 /*--- compute (l0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+26460, int_stack+102280, int_stack+101335, 45);
 /*--- compute (l0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+29295, int_stack+103540, int_stack+102280, 45);
 /*--- compute (l0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+33075, int_stack+29295, int_stack+26460, 45);
 /*--- compute (l0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+38745, int_stack+105160, int_stack+103540, 45);
 /*--- compute (l0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+43605, int_stack+38745, int_stack+29295, 45);
 /*--- compute (l0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+68439, int_stack+43605, int_stack+33075, 45);
 /*--- compute (l0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+26460, int_stack+107185, int_stack+105160, 45);
 /*--- compute (l0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+77889, int_stack+26460, int_stack+38745, 45);
 /*--- compute (l0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+26460, int_stack+77889, int_stack+43605, 45);
 /*--- compute (l0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+77889, int_stack+26460, int_stack+68439, 45);
 /*--- compute (kp||hg) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+864647, int_stack+77889, int_stack+57099, 315);
 /*--- compute (id||hg) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+1029077, int_stack+864647, int_stack+0, 315);
 /*--- compute (hf||hg) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+0, int_stack+1029077, int_stack+824957, 315);
 /*--- compute (m0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+824957, int_stack+110815, int_stack+109660, 55);
 /*--- compute (m0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+828422, int_stack+112355, int_stack+110815, 55);
 /*--- compute (m0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+833042, int_stack+828422, int_stack+824957, 55);
 /*--- compute (m0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+839972, int_stack+114335, int_stack+112355, 55);
 /*--- compute (m0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+845912, int_stack+839972, int_stack+828422, 55);
 /*--- compute (m0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+66150, int_stack+845912, int_stack+833042, 55);
 /*--- compute (m0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+824957, int_stack+116810, int_stack+114335, 55);
 /*--- compute (m0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+92064, int_stack+824957, int_stack+839972, 55);
 /*--- compute (m0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+824957, int_stack+92064, int_stack+845912, 55);
 /*--- compute (m0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+92064, int_stack+824957, int_stack+66150, 55);
 /*--- compute (lp||hg) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+1081997, int_stack+92064, int_stack+77889, 315);
 /*--- compute (kd||hg) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+602567, int_stack+1081997, int_stack+864647, 315);
 /*--- compute (if||hg) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+824957, int_stack+602567, int_stack+1029077, 315);
 /*--- compute (hg|[r12,T2]|hg) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+1029077, int_stack+670607, int_stack+536417, 315);
     Libr12->te_ptr[3] = int_stack + 1029077;
 /*--- compute (hg|[r12,T1]|hg) ---*/
   t1hrr1_build_hg(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+274185, int_stack+185985, int_stack+119835, int_stack+1139642, int_stack+940877, int_stack+758807, 5, 4);
     Libr12->te_ptr[2] = int_stack + 274185;
 /*--- compute (hg||hg) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+66150, int_stack+824957, int_stack+0, 315);
     Libr12->te_ptr[1] = int_stack + 66150;
 /*--- compute (hg|hg) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+824957, int_stack+1139642, int_stack+758807, 315);
     Libr12->te_ptr[0] = int_stack + 824957;

}
