/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (is||ps) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_i0p0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE twoo4zn;
  REALTYPE threeo4zn;
  REALTYPE fouro4zn;
  REALTYPE fiveo4zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  twoo4zn = 2.0*Data->oo2z*Data->oo2n;
  threeo4zn = 3.0*Data->oo2z*Data->oo2n;
  fouro4zn = 4.0*Data->oo2z*Data->oo2n;
  fiveo4zn = 5.0*Data->oo2z*Data->oo2n;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U10 = Data->U[0][0]*Data->oo2n + Data->U[1][0]*Data->oo2z;
  U11 = Data->U[0][1]*Data->oo2n + Data->U[1][1]*Data->oo2z;
  U12 = Data->U[0][2]*Data->oo2n + Data->U[1][2]*Data->oo2z;

*(vp++) = U00*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (fiveo2z)*I1[0] - (fiveo4zn)*I4[0] - (oneo4zn)*I5[0];
*(vp++) = U00*I0[1] - U10*I3[1] + loo2p*I2[1]
        + (fiveo2z)*I1[1] - (fiveo4zn)*I4[1];
*(vp++) = U00*I0[2] - U10*I3[2] + loo2p*I2[2]
        + (fiveo2z)*I1[2] - (fiveo4zn)*I4[2];
*(vp++) = U00*I0[3] - U10*I3[3] + loo2p*I2[3]
        + (fouro2z)*I1[3] - (fouro4zn)*I4[3] - (oneo4zn)*I5[1];
*(vp++) = U00*I0[4] - U10*I3[4] + loo2p*I2[4]
        + (fouro2z)*I1[4] - (fouro4zn)*I4[4];
*(vp++) = U00*I0[5] - U10*I3[5] + loo2p*I2[5]
        + (fouro2z)*I1[5] - (fouro4zn)*I4[5];
*(vp++) = U00*I0[6] - U10*I3[6] + loo2p*I2[6]
        + (fouro2z)*I1[6] - (fouro4zn)*I4[6] - (oneo4zn)*I5[2];
*(vp++) = U00*I0[7] - U10*I3[7] + loo2p*I2[7]
        + (fouro2z)*I1[7] - (fouro4zn)*I4[7];
*(vp++) = U00*I0[8] - U10*I3[8] + loo2p*I2[8]
        + (fouro2z)*I1[8] - (fouro4zn)*I4[8];
*(vp++) = U00*I0[9] - U10*I3[9] + loo2p*I2[9]
        + (threeo2z)*I1[9] - (threeo4zn)*I4[9] - (oneo4zn)*I5[3];
*(vp++) = U00*I0[10] - U10*I3[10] + loo2p*I2[10]
        + (threeo2z)*I1[10] - (threeo4zn)*I4[10];
*(vp++) = U00*I0[11] - U10*I3[11] + loo2p*I2[11]
        + (threeo2z)*I1[11] - (threeo4zn)*I4[11];
*(vp++) = U00*I0[12] - U10*I3[12] + loo2p*I2[12]
        + (threeo2z)*I1[12] - (threeo4zn)*I4[12] - (oneo4zn)*I5[4];
*(vp++) = U00*I0[13] - U10*I3[13] + loo2p*I2[13]
        + (threeo2z)*I1[13] - (threeo4zn)*I4[13];
*(vp++) = U00*I0[14] - U10*I3[14] + loo2p*I2[14]
        + (threeo2z)*I1[14] - (threeo4zn)*I4[14];
*(vp++) = U00*I0[15] - U10*I3[15] + loo2p*I2[15]
        + (threeo2z)*I1[15] - (threeo4zn)*I4[15] - (oneo4zn)*I5[5];
*(vp++) = U00*I0[16] - U10*I3[16] + loo2p*I2[16]
        + (threeo2z)*I1[16] - (threeo4zn)*I4[16];
*(vp++) = U00*I0[17] - U10*I3[17] + loo2p*I2[17]
        + (threeo2z)*I1[17] - (threeo4zn)*I4[17];
*(vp++) = U00*I0[18] - U10*I3[18] + loo2p*I2[18]
        + (twoo2z)*I1[18] - (twoo4zn)*I4[18] - (oneo4zn)*I5[6];
*(vp++) = U00*I0[19] - U10*I3[19] + loo2p*I2[19]
        + (twoo2z)*I1[19] - (twoo4zn)*I4[19];
*(vp++) = U00*I0[20] - U10*I3[20] + loo2p*I2[20]
        + (twoo2z)*I1[20] - (twoo4zn)*I4[20];
*(vp++) = U00*I0[21] - U10*I3[21] + loo2p*I2[21]
        + (twoo2z)*I1[21] - (twoo4zn)*I4[21] - (oneo4zn)*I5[7];
*(vp++) = U00*I0[22] - U10*I3[22] + loo2p*I2[22]
        + (twoo2z)*I1[22] - (twoo4zn)*I4[22];
*(vp++) = U00*I0[23] - U10*I3[23] + loo2p*I2[23]
        + (twoo2z)*I1[23] - (twoo4zn)*I4[23];
*(vp++) = U00*I0[24] - U10*I3[24] + loo2p*I2[24]
        + (twoo2z)*I1[24] - (twoo4zn)*I4[24] - (oneo4zn)*I5[8];
*(vp++) = U00*I0[25] - U10*I3[25] + loo2p*I2[25]
        + (twoo2z)*I1[25] - (twoo4zn)*I4[25];
*(vp++) = U00*I0[26] - U10*I3[26] + loo2p*I2[26]
        + (twoo2z)*I1[26] - (twoo4zn)*I4[26];
*(vp++) = U00*I0[27] - U10*I3[27] + loo2p*I2[27]
        + (twoo2z)*I1[27] - (twoo4zn)*I4[27] - (oneo4zn)*I5[9];
*(vp++) = U00*I0[28] - U10*I3[28] + loo2p*I2[28]
        + (twoo2z)*I1[28] - (twoo4zn)*I4[28];
*(vp++) = U00*I0[29] - U10*I3[29] + loo2p*I2[29]
        + (twoo2z)*I1[29] - (twoo4zn)*I4[29];
*(vp++) = U00*I0[30] - U10*I3[30] + loo2p*I2[30]
        + (oneo2z)*I1[30] - (oneo4zn)*I4[30] - (oneo4zn)*I5[10];
*(vp++) = U00*I0[31] - U10*I3[31] + loo2p*I2[31]
        + (oneo2z)*I1[31] - (oneo4zn)*I4[31];
*(vp++) = U00*I0[32] - U10*I3[32] + loo2p*I2[32]
        + (oneo2z)*I1[32] - (oneo4zn)*I4[32];
*(vp++) = U00*I0[33] - U10*I3[33] + loo2p*I2[33]
        + (oneo2z)*I1[33] - (oneo4zn)*I4[33] - (oneo4zn)*I5[11];
*(vp++) = U00*I0[34] - U10*I3[34] + loo2p*I2[34]
        + (oneo2z)*I1[34] - (oneo4zn)*I4[34];
*(vp++) = U00*I0[35] - U10*I3[35] + loo2p*I2[35]
        + (oneo2z)*I1[35] - (oneo4zn)*I4[35];
*(vp++) = U00*I0[36] - U10*I3[36] + loo2p*I2[36]
        + (oneo2z)*I1[36] - (oneo4zn)*I4[36] - (oneo4zn)*I5[12];
*(vp++) = U00*I0[37] - U10*I3[37] + loo2p*I2[37]
        + (oneo2z)*I1[37] - (oneo4zn)*I4[37];
*(vp++) = U00*I0[38] - U10*I3[38] + loo2p*I2[38]
        + (oneo2z)*I1[38] - (oneo4zn)*I4[38];
*(vp++) = U00*I0[39] - U10*I3[39] + loo2p*I2[39]
        + (oneo2z)*I1[39] - (oneo4zn)*I4[39] - (oneo4zn)*I5[13];
*(vp++) = U00*I0[40] - U10*I3[40] + loo2p*I2[40]
        + (oneo2z)*I1[40] - (oneo4zn)*I4[40];
*(vp++) = U00*I0[41] - U10*I3[41] + loo2p*I2[41]
        + (oneo2z)*I1[41] - (oneo4zn)*I4[41];
*(vp++) = U00*I0[42] - U10*I3[42] + loo2p*I2[42]
        + (oneo2z)*I1[42] - (oneo4zn)*I4[42] - (oneo4zn)*I5[14];
*(vp++) = U00*I0[43] - U10*I3[43] + loo2p*I2[43]
        + (oneo2z)*I1[43] - (oneo4zn)*I4[43];
*(vp++) = U00*I0[44] - U10*I3[44] + loo2p*I2[44]
        + (oneo2z)*I1[44] - (oneo4zn)*I4[44];
*(vp++) = U00*I0[45] - U10*I3[45] + loo2p*I2[45] - (oneo4zn)*I5[15];
*(vp++) = U00*I0[46] - U10*I3[46] + loo2p*I2[46];
*(vp++) = U00*I0[47] - U10*I3[47] + loo2p*I2[47];
*(vp++) = U00*I0[48] - U10*I3[48] + loo2p*I2[48] - (oneo4zn)*I5[16];
*(vp++) = U00*I0[49] - U10*I3[49] + loo2p*I2[49];
*(vp++) = U00*I0[50] - U10*I3[50] + loo2p*I2[50];
*(vp++) = U00*I0[51] - U10*I3[51] + loo2p*I2[51] - (oneo4zn)*I5[17];
*(vp++) = U00*I0[52] - U10*I3[52] + loo2p*I2[52];
*(vp++) = U00*I0[53] - U10*I3[53] + loo2p*I2[53];
*(vp++) = U00*I0[54] - U10*I3[54] + loo2p*I2[54] - (oneo4zn)*I5[18];
*(vp++) = U00*I0[55] - U10*I3[55] + loo2p*I2[55];
*(vp++) = U00*I0[56] - U10*I3[56] + loo2p*I2[56];
*(vp++) = U00*I0[57] - U10*I3[57] + loo2p*I2[57] - (oneo4zn)*I5[19];
*(vp++) = U00*I0[58] - U10*I3[58] + loo2p*I2[58];
*(vp++) = U00*I0[59] - U10*I3[59] + loo2p*I2[59];
*(vp++) = U00*I0[60] - U10*I3[60] + loo2p*I2[60] - (oneo4zn)*I5[20];
*(vp++) = U00*I0[61] - U10*I3[61] + loo2p*I2[61];
*(vp++) = U00*I0[62] - U10*I3[62] + loo2p*I2[62];
*(vp++) = U01*I0[45] - U11*I3[45] + loo2p*I2[63]
        + (fiveo2z)*I1[30] - (fiveo4zn)*I4[30];
*(vp++) = U01*I0[46] - U11*I3[46] + loo2p*I2[64]
        + (fiveo2z)*I1[31] - (fiveo4zn)*I4[31] - (oneo4zn)*I5[15];
*(vp++) = U01*I0[47] - U11*I3[47] + loo2p*I2[65]
        + (fiveo2z)*I1[32] - (fiveo4zn)*I4[32];
*(vp++) = U01*I0[48] - U11*I3[48] + loo2p*I2[66]
        + (fouro2z)*I1[33] - (fouro4zn)*I4[33];
*(vp++) = U01*I0[49] - U11*I3[49] + loo2p*I2[67]
        + (fouro2z)*I1[34] - (fouro4zn)*I4[34] - (oneo4zn)*I5[16];
*(vp++) = U01*I0[50] - U11*I3[50] + loo2p*I2[68]
        + (fouro2z)*I1[35] - (fouro4zn)*I4[35];
*(vp++) = U01*I0[51] - U11*I3[51] + loo2p*I2[69]
        + (threeo2z)*I1[36] - (threeo4zn)*I4[36];
*(vp++) = U01*I0[52] - U11*I3[52] + loo2p*I2[70]
        + (threeo2z)*I1[37] - (threeo4zn)*I4[37] - (oneo4zn)*I5[17];
*(vp++) = U01*I0[53] - U11*I3[53] + loo2p*I2[71]
        + (threeo2z)*I1[38] - (threeo4zn)*I4[38];
*(vp++) = U01*I0[54] - U11*I3[54] + loo2p*I2[72]
        + (twoo2z)*I1[39] - (twoo4zn)*I4[39];
*(vp++) = U01*I0[55] - U11*I3[55] + loo2p*I2[73]
        + (twoo2z)*I1[40] - (twoo4zn)*I4[40] - (oneo4zn)*I5[18];
*(vp++) = U01*I0[56] - U11*I3[56] + loo2p*I2[74]
        + (twoo2z)*I1[41] - (twoo4zn)*I4[41];
*(vp++) = U01*I0[57] - U11*I3[57] + loo2p*I2[75]
        + (oneo2z)*I1[42] - (oneo4zn)*I4[42];
*(vp++) = U01*I0[58] - U11*I3[58] + loo2p*I2[76]
        + (oneo2z)*I1[43] - (oneo4zn)*I4[43] - (oneo4zn)*I5[19];
*(vp++) = U01*I0[59] - U11*I3[59] + loo2p*I2[77]
        + (oneo2z)*I1[44] - (oneo4zn)*I4[44];
*(vp++) = U01*I0[60] - U11*I3[60] + loo2p*I2[78];
*(vp++) = U01*I0[61] - U11*I3[61] + loo2p*I2[79] - (oneo4zn)*I5[20];
*(vp++) = U01*I0[62] - U11*I3[62] + loo2p*I2[80];
*(vp++) = U02*I0[60] - U12*I3[60] + loo2p*I2[81]
        + (fiveo2z)*I1[42] - (fiveo4zn)*I4[42];
*(vp++) = U02*I0[61] - U12*I3[61] + loo2p*I2[82]
        + (fiveo2z)*I1[43] - (fiveo4zn)*I4[43];
*(vp++) = U02*I0[62] - U12*I3[62] + loo2p*I2[83]
        + (fiveo2z)*I1[44] - (fiveo4zn)*I4[44] - (oneo4zn)*I5[20];

}
