/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ls|[r12,T1]|fs) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_t1_build_l0f0_0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  REALTYPE fivezboz;
  REALTYPE sixzboz;
  REALTYPE sevenzboz;
  REALTYPE eightzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  fivezboz = 5.0*(Data->twozeta_b*Data->oo2z);
  sixzboz = 6.0*(Data->twozeta_b*Data->oo2z);
  sevenzboz = 7.0*(Data->twozeta_b*Data->oo2z);
  eightzboz = 8.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 9.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[10] - I2[1])
          - U12*(I1[20] - I2[2])
          + (eightzboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[11] - I2[3])
          - U12*(I1[21] - I2[4])
          + (eightzboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[12] - I2[4])
          - U12*(I1[22] - I2[5])
          + (eightzboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[13] - I2[6])
          - U12*(I1[23] - I2[7])
          + (eightzboz)*(I3[3] - AC0*I4[3]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[14] - I2[7])
          - U12*(I1[24] - I2[8])
          + (eightzboz)*(I3[4] - AC0*I4[4]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[15] - I2[8])
          - U12*(I1[25] - I2[9])
          + (eightzboz)*(I3[5] - AC0*I4[5]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[16] - I2[10])
          - U12*(I1[26] - I2[11])
          + (eightzboz)*(I3[6] - AC0*I4[6]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[17] - I2[11])
          - U12*(I1[27] - I2[12])
          + (eightzboz)*(I3[7] - AC0*I4[7]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[18] - I2[12])
          - U12*(I1[28] - I2[13])
          + (eightzboz)*(I3[8] - AC0*I4[8]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[19] - I2[13])
          - U12*(I1[29] - I2[14])
          + (eightzboz)*(I3[9] - AC0*I4[9]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[15])
          - U11*(I1[30] - I2[16])
          - U12*(I1[40] - I2[17])
          + (sevenzboz)*(I3[15] - AC0*I4[10])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[16])
          - U11*(I1[31] - I2[18])
          - U12*(I1[41] - I2[19])
          + (sevenzboz)*(I3[16] - AC0*I4[11])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[17])
          - U11*(I1[32] - I2[19])
          - U12*(I1[42] - I2[20])
          + (sevenzboz)*(I3[17] - AC0*I4[12])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[18])
          - U11*(I1[33] - I2[21])
          - U12*(I1[43] - I2[22])
          + (sevenzboz)*(I3[18] - AC0*I4[13])
          + (onezboz)*(I3[6] - AC1*I4[3]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[19])
          - U11*(I1[34] - I2[22])
          - U12*(I1[44] - I2[23])
          + (sevenzboz)*(I3[19] - AC0*I4[14])
          + (onezboz)*(I3[7] - AC1*I4[4]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[20])
          - U11*(I1[35] - I2[23])
          - U12*(I1[45] - I2[24])
          + (sevenzboz)*(I3[20] - AC0*I4[15])
          + (onezboz)*(I3[8] - AC1*I4[5]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[21])
          - U11*(I1[36] - I2[25])
          - U12*(I1[46] - I2[26])
          + (sevenzboz)*(I3[21] - AC0*I4[16])
          + (onezboz)*(I3[10] - AC1*I4[6]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[22])
          - U11*(I1[37] - I2[26])
          - U12*(I1[47] - I2[27])
          + (sevenzboz)*(I3[22] - AC0*I4[17])
          + (onezboz)*(I3[11] - AC1*I4[7]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[23])
          - U11*(I1[38] - I2[27])
          - U12*(I1[48] - I2[28])
          + (sevenzboz)*(I3[23] - AC0*I4[18])
          + (onezboz)*(I3[12] - AC1*I4[8]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[24])
          - U11*(I1[39] - I2[28])
          - U12*(I1[49] - I2[29])
          + (sevenzboz)*(I3[24] - AC0*I4[19])
          + (onezboz)*(I3[13] - AC1*I4[9]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[30])
          - U11*(I1[40] - I2[31])
          - U12*(I1[50] - I2[32])
          + (sevenzboz)*(I3[30] - AC0*I4[20])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[21]
          - U10*(I1[21] - I2[31])
          - U11*(I1[41] - I2[33])
          - U12*(I1[51] - I2[34])
          + (sevenzboz)*(I3[31] - AC0*I4[21])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[22]
          - U10*(I1[22] - I2[32])
          - U11*(I1[42] - I2[34])
          - U12*(I1[52] - I2[35])
          + (sevenzboz)*(I3[32] - AC0*I4[22])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[23]
          - U10*(I1[23] - I2[33])
          - U11*(I1[43] - I2[36])
          - U12*(I1[53] - I2[37])
          + (sevenzboz)*(I3[33] - AC0*I4[23])
          + (onezboz)*(I3[7] - AC2*I4[3]);
*(vp++) = U0*I0[24]
          - U10*(I1[24] - I2[34])
          - U11*(I1[44] - I2[37])
          - U12*(I1[54] - I2[38])
          + (sevenzboz)*(I3[34] - AC0*I4[24])
          + (onezboz)*(I3[8] - AC2*I4[4]);
*(vp++) = U0*I0[25]
          - U10*(I1[25] - I2[35])
          - U11*(I1[45] - I2[38])
          - U12*(I1[55] - I2[39])
          + (sevenzboz)*(I3[35] - AC0*I4[25])
          + (onezboz)*(I3[9] - AC2*I4[5]);
*(vp++) = U0*I0[26]
          - U10*(I1[26] - I2[36])
          - U11*(I1[46] - I2[40])
          - U12*(I1[56] - I2[41])
          + (sevenzboz)*(I3[36] - AC0*I4[26])
          + (onezboz)*(I3[11] - AC2*I4[6]);
*(vp++) = U0*I0[27]
          - U10*(I1[27] - I2[37])
          - U11*(I1[47] - I2[41])
          - U12*(I1[57] - I2[42])
          + (sevenzboz)*(I3[37] - AC0*I4[27])
          + (onezboz)*(I3[12] - AC2*I4[7]);
*(vp++) = U0*I0[28]
          - U10*(I1[28] - I2[38])
          - U11*(I1[48] - I2[42])
          - U12*(I1[58] - I2[43])
          + (sevenzboz)*(I3[38] - AC0*I4[28])
          + (onezboz)*(I3[13] - AC2*I4[8]);
*(vp++) = U0*I0[29]
          - U10*(I1[29] - I2[39])
          - U11*(I1[49] - I2[43])
          - U12*(I1[59] - I2[44])
          + (sevenzboz)*(I3[39] - AC0*I4[29])
          + (onezboz)*(I3[14] - AC2*I4[9]);
*(vp++) = U0*I0[30]
          - U10*(I1[30] - I2[45])
          - U11*(I1[60] - I2[46])
          - U12*(I1[70] - I2[47])
          + (sixzboz)*(I3[45] - AC0*I4[30])
          + (twozboz)*(I3[16] - AC1*I4[10]);
*(vp++) = U0*I0[31]
          - U10*(I1[31] - I2[46])
          - U11*(I1[61] - I2[48])
          - U12*(I1[71] - I2[49])
          + (sixzboz)*(I3[46] - AC0*I4[31])
          + (twozboz)*(I3[18] - AC1*I4[11]);
*(vp++) = U0*I0[32]
          - U10*(I1[32] - I2[47])
          - U11*(I1[62] - I2[49])
          - U12*(I1[72] - I2[50])
          + (sixzboz)*(I3[47] - AC0*I4[32])
          + (twozboz)*(I3[19] - AC1*I4[12]);
*(vp++) = U0*I0[33]
          - U10*(I1[33] - I2[48])
          - U11*(I1[63] - I2[51])
          - U12*(I1[73] - I2[52])
          + (sixzboz)*(I3[48] - AC0*I4[33])
          + (twozboz)*(I3[21] - AC1*I4[13]);
*(vp++) = U0*I0[34]
          - U10*(I1[34] - I2[49])
          - U11*(I1[64] - I2[52])
          - U12*(I1[74] - I2[53])
          + (sixzboz)*(I3[49] - AC0*I4[34])
          + (twozboz)*(I3[22] - AC1*I4[14]);
*(vp++) = U0*I0[35]
          - U10*(I1[35] - I2[50])
          - U11*(I1[65] - I2[53])
          - U12*(I1[75] - I2[54])
          + (sixzboz)*(I3[50] - AC0*I4[35])
          + (twozboz)*(I3[23] - AC1*I4[15]);
*(vp++) = U0*I0[36]
          - U10*(I1[36] - I2[51])
          - U11*(I1[66] - I2[55])
          - U12*(I1[76] - I2[56])
          + (sixzboz)*(I3[51] - AC0*I4[36])
          + (twozboz)*(I3[25] - AC1*I4[16]);
*(vp++) = U0*I0[37]
          - U10*(I1[37] - I2[52])
          - U11*(I1[67] - I2[56])
          - U12*(I1[77] - I2[57])
          + (sixzboz)*(I3[52] - AC0*I4[37])
          + (twozboz)*(I3[26] - AC1*I4[17]);
*(vp++) = U0*I0[38]
          - U10*(I1[38] - I2[53])
          - U11*(I1[68] - I2[57])
          - U12*(I1[78] - I2[58])
          + (sixzboz)*(I3[53] - AC0*I4[38])
          + (twozboz)*(I3[27] - AC1*I4[18]);
*(vp++) = U0*I0[39]
          - U10*(I1[39] - I2[54])
          - U11*(I1[69] - I2[58])
          - U12*(I1[79] - I2[59])
          + (sixzboz)*(I3[54] - AC0*I4[39])
          + (twozboz)*(I3[28] - AC1*I4[19]);
*(vp++) = U0*I0[40]
          - U10*(I1[40] - I2[60])
          - U11*(I1[70] - I2[61])
          - U12*(I1[80] - I2[62])
          + (sixzboz)*(I3[60] - AC0*I4[40])
          + (onezboz)*(I3[31] - AC1*I4[20])
          + (onezboz)*(I3[17] - AC2*I4[10]);
*(vp++) = U0*I0[41]
          - U10*(I1[41] - I2[61])
          - U11*(I1[71] - I2[63])
          - U12*(I1[81] - I2[64])
          + (sixzboz)*(I3[61] - AC0*I4[41])
          + (onezboz)*(I3[33] - AC1*I4[21])
          + (onezboz)*(I3[19] - AC2*I4[11]);
*(vp++) = U0*I0[42]
          - U10*(I1[42] - I2[62])
          - U11*(I1[72] - I2[64])
          - U12*(I1[82] - I2[65])
          + (sixzboz)*(I3[62] - AC0*I4[42])
          + (onezboz)*(I3[34] - AC1*I4[22])
          + (onezboz)*(I3[20] - AC2*I4[12]);
*(vp++) = U0*I0[43]
          - U10*(I1[43] - I2[63])
          - U11*(I1[73] - I2[66])
          - U12*(I1[83] - I2[67])
          + (sixzboz)*(I3[63] - AC0*I4[43])
          + (onezboz)*(I3[36] - AC1*I4[23])
          + (onezboz)*(I3[22] - AC2*I4[13]);
*(vp++) = U0*I0[44]
          - U10*(I1[44] - I2[64])
          - U11*(I1[74] - I2[67])
          - U12*(I1[84] - I2[68])
          + (sixzboz)*(I3[64] - AC0*I4[44])
          + (onezboz)*(I3[37] - AC1*I4[24])
          + (onezboz)*(I3[23] - AC2*I4[14]);
*(vp++) = U0*I0[45]
          - U10*(I1[45] - I2[65])
          - U11*(I1[75] - I2[68])
          - U12*(I1[85] - I2[69])
          + (sixzboz)*(I3[65] - AC0*I4[45])
          + (onezboz)*(I3[38] - AC1*I4[25])
          + (onezboz)*(I3[24] - AC2*I4[15]);
*(vp++) = U0*I0[46]
          - U10*(I1[46] - I2[66])
          - U11*(I1[76] - I2[70])
          - U12*(I1[86] - I2[71])
          + (sixzboz)*(I3[66] - AC0*I4[46])
          + (onezboz)*(I3[40] - AC1*I4[26])
          + (onezboz)*(I3[26] - AC2*I4[16]);
*(vp++) = U0*I0[47]
          - U10*(I1[47] - I2[67])
          - U11*(I1[77] - I2[71])
          - U12*(I1[87] - I2[72])
          + (sixzboz)*(I3[67] - AC0*I4[47])
          + (onezboz)*(I3[41] - AC1*I4[27])
          + (onezboz)*(I3[27] - AC2*I4[17]);
*(vp++) = U0*I0[48]
          - U10*(I1[48] - I2[68])
          - U11*(I1[78] - I2[72])
          - U12*(I1[88] - I2[73])
          + (sixzboz)*(I3[68] - AC0*I4[48])
          + (onezboz)*(I3[42] - AC1*I4[28])
          + (onezboz)*(I3[28] - AC2*I4[18]);
*(vp++) = U0*I0[49]
          - U10*(I1[49] - I2[69])
          - U11*(I1[79] - I2[73])
          - U12*(I1[89] - I2[74])
          + (sixzboz)*(I3[69] - AC0*I4[49])
          + (onezboz)*(I3[43] - AC1*I4[29])
          + (onezboz)*(I3[29] - AC2*I4[19]);
*(vp++) = U0*I0[50]
          - U10*(I1[50] - I2[75])
          - U11*(I1[80] - I2[76])
          - U12*(I1[90] - I2[77])
          + (sixzboz)*(I3[75] - AC0*I4[50])
          + (twozboz)*(I3[32] - AC2*I4[20]);
*(vp++) = U0*I0[51]
          - U10*(I1[51] - I2[76])
          - U11*(I1[81] - I2[78])
          - U12*(I1[91] - I2[79])
          + (sixzboz)*(I3[76] - AC0*I4[51])
          + (twozboz)*(I3[34] - AC2*I4[21]);
*(vp++) = U0*I0[52]
          - U10*(I1[52] - I2[77])
          - U11*(I1[82] - I2[79])
          - U12*(I1[92] - I2[80])
          + (sixzboz)*(I3[77] - AC0*I4[52])
          + (twozboz)*(I3[35] - AC2*I4[22]);
*(vp++) = U0*I0[53]
          - U10*(I1[53] - I2[78])
          - U11*(I1[83] - I2[81])
          - U12*(I1[93] - I2[82])
          + (sixzboz)*(I3[78] - AC0*I4[53])
          + (twozboz)*(I3[37] - AC2*I4[23]);
*(vp++) = U0*I0[54]
          - U10*(I1[54] - I2[79])
          - U11*(I1[84] - I2[82])
          - U12*(I1[94] - I2[83])
          + (sixzboz)*(I3[79] - AC0*I4[54])
          + (twozboz)*(I3[38] - AC2*I4[24]);
*(vp++) = U0*I0[55]
          - U10*(I1[55] - I2[80])
          - U11*(I1[85] - I2[83])
          - U12*(I1[95] - I2[84])
          + (sixzboz)*(I3[80] - AC0*I4[55])
          + (twozboz)*(I3[39] - AC2*I4[25]);
*(vp++) = U0*I0[56]
          - U10*(I1[56] - I2[81])
          - U11*(I1[86] - I2[85])
          - U12*(I1[96] - I2[86])
          + (sixzboz)*(I3[81] - AC0*I4[56])
          + (twozboz)*(I3[41] - AC2*I4[26]);
*(vp++) = U0*I0[57]
          - U10*(I1[57] - I2[82])
          - U11*(I1[87] - I2[86])
          - U12*(I1[97] - I2[87])
          + (sixzboz)*(I3[82] - AC0*I4[57])
          + (twozboz)*(I3[42] - AC2*I4[27]);
*(vp++) = U0*I0[58]
          - U10*(I1[58] - I2[83])
          - U11*(I1[88] - I2[87])
          - U12*(I1[98] - I2[88])
          + (sixzboz)*(I3[83] - AC0*I4[58])
          + (twozboz)*(I3[43] - AC2*I4[28]);
*(vp++) = U0*I0[59]
          - U10*(I1[59] - I2[84])
          - U11*(I1[89] - I2[88])
          - U12*(I1[99] - I2[89])
          + (sixzboz)*(I3[84] - AC0*I4[59])
          + (twozboz)*(I3[44] - AC2*I4[29]);
*(vp++) = U0*I0[60]
          - U10*(I1[60] - I2[90])
          - U11*(I1[100] - I2[91])
          - U12*(I1[110] - I2[92])
          + (fivezboz)*(I3[90] - AC0*I4[60])
          + (threezboz)*(I3[46] - AC1*I4[30]);
*(vp++) = U0*I0[61]
          - U10*(I1[61] - I2[91])
          - U11*(I1[101] - I2[93])
          - U12*(I1[111] - I2[94])
          + (fivezboz)*(I3[91] - AC0*I4[61])
          + (threezboz)*(I3[48] - AC1*I4[31]);
*(vp++) = U0*I0[62]
          - U10*(I1[62] - I2[92])
          - U11*(I1[102] - I2[94])
          - U12*(I1[112] - I2[95])
          + (fivezboz)*(I3[92] - AC0*I4[62])
          + (threezboz)*(I3[49] - AC1*I4[32]);
*(vp++) = U0*I0[63]
          - U10*(I1[63] - I2[93])
          - U11*(I1[103] - I2[96])
          - U12*(I1[113] - I2[97])
          + (fivezboz)*(I3[93] - AC0*I4[63])
          + (threezboz)*(I3[51] - AC1*I4[33]);
*(vp++) = U0*I0[64]
          - U10*(I1[64] - I2[94])
          - U11*(I1[104] - I2[97])
          - U12*(I1[114] - I2[98])
          + (fivezboz)*(I3[94] - AC0*I4[64])
          + (threezboz)*(I3[52] - AC1*I4[34]);
*(vp++) = U0*I0[65]
          - U10*(I1[65] - I2[95])
          - U11*(I1[105] - I2[98])
          - U12*(I1[115] - I2[99])
          + (fivezboz)*(I3[95] - AC0*I4[65])
          + (threezboz)*(I3[53] - AC1*I4[35]);
*(vp++) = U0*I0[66]
          - U10*(I1[66] - I2[96])
          - U11*(I1[106] - I2[100])
          - U12*(I1[116] - I2[101])
          + (fivezboz)*(I3[96] - AC0*I4[66])
          + (threezboz)*(I3[55] - AC1*I4[36]);
*(vp++) = U0*I0[67]
          - U10*(I1[67] - I2[97])
          - U11*(I1[107] - I2[101])
          - U12*(I1[117] - I2[102])
          + (fivezboz)*(I3[97] - AC0*I4[67])
          + (threezboz)*(I3[56] - AC1*I4[37]);
*(vp++) = U0*I0[68]
          - U10*(I1[68] - I2[98])
          - U11*(I1[108] - I2[102])
          - U12*(I1[118] - I2[103])
          + (fivezboz)*(I3[98] - AC0*I4[68])
          + (threezboz)*(I3[57] - AC1*I4[38]);
*(vp++) = U0*I0[69]
          - U10*(I1[69] - I2[99])
          - U11*(I1[109] - I2[103])
          - U12*(I1[119] - I2[104])
          + (fivezboz)*(I3[99] - AC0*I4[69])
          + (threezboz)*(I3[58] - AC1*I4[39]);
*(vp++) = U0*I0[70]
          - U10*(I1[70] - I2[105])
          - U11*(I1[110] - I2[106])
          - U12*(I1[120] - I2[107])
          + (fivezboz)*(I3[105] - AC0*I4[70])
          + (twozboz)*(I3[61] - AC1*I4[40])
          + (onezboz)*(I3[47] - AC2*I4[30]);
*(vp++) = U0*I0[71]
          - U10*(I1[71] - I2[106])
          - U11*(I1[111] - I2[108])
          - U12*(I1[121] - I2[109])
          + (fivezboz)*(I3[106] - AC0*I4[71])
          + (twozboz)*(I3[63] - AC1*I4[41])
          + (onezboz)*(I3[49] - AC2*I4[31]);
*(vp++) = U0*I0[72]
          - U10*(I1[72] - I2[107])
          - U11*(I1[112] - I2[109])
          - U12*(I1[122] - I2[110])
          + (fivezboz)*(I3[107] - AC0*I4[72])
          + (twozboz)*(I3[64] - AC1*I4[42])
          + (onezboz)*(I3[50] - AC2*I4[32]);
*(vp++) = U0*I0[73]
          - U10*(I1[73] - I2[108])
          - U11*(I1[113] - I2[111])
          - U12*(I1[123] - I2[112])
          + (fivezboz)*(I3[108] - AC0*I4[73])
          + (twozboz)*(I3[66] - AC1*I4[43])
          + (onezboz)*(I3[52] - AC2*I4[33]);
*(vp++) = U0*I0[74]
          - U10*(I1[74] - I2[109])
          - U11*(I1[114] - I2[112])
          - U12*(I1[124] - I2[113])
          + (fivezboz)*(I3[109] - AC0*I4[74])
          + (twozboz)*(I3[67] - AC1*I4[44])
          + (onezboz)*(I3[53] - AC2*I4[34]);
*(vp++) = U0*I0[75]
          - U10*(I1[75] - I2[110])
          - U11*(I1[115] - I2[113])
          - U12*(I1[125] - I2[114])
          + (fivezboz)*(I3[110] - AC0*I4[75])
          + (twozboz)*(I3[68] - AC1*I4[45])
          + (onezboz)*(I3[54] - AC2*I4[35]);
*(vp++) = U0*I0[76]
          - U10*(I1[76] - I2[111])
          - U11*(I1[116] - I2[115])
          - U12*(I1[126] - I2[116])
          + (fivezboz)*(I3[111] - AC0*I4[76])
          + (twozboz)*(I3[70] - AC1*I4[46])
          + (onezboz)*(I3[56] - AC2*I4[36]);
*(vp++) = U0*I0[77]
          - U10*(I1[77] - I2[112])
          - U11*(I1[117] - I2[116])
          - U12*(I1[127] - I2[117])
          + (fivezboz)*(I3[112] - AC0*I4[77])
          + (twozboz)*(I3[71] - AC1*I4[47])
          + (onezboz)*(I3[57] - AC2*I4[37]);
*(vp++) = U0*I0[78]
          - U10*(I1[78] - I2[113])
          - U11*(I1[118] - I2[117])
          - U12*(I1[128] - I2[118])
          + (fivezboz)*(I3[113] - AC0*I4[78])
          + (twozboz)*(I3[72] - AC1*I4[48])
          + (onezboz)*(I3[58] - AC2*I4[38]);
*(vp++) = U0*I0[79]
          - U10*(I1[79] - I2[114])
          - U11*(I1[119] - I2[118])
          - U12*(I1[129] - I2[119])
          + (fivezboz)*(I3[114] - AC0*I4[79])
          + (twozboz)*(I3[73] - AC1*I4[49])
          + (onezboz)*(I3[59] - AC2*I4[39]);
*(vp++) = U0*I0[80]
          - U10*(I1[80] - I2[120])
          - U11*(I1[120] - I2[121])
          - U12*(I1[130] - I2[122])
          + (fivezboz)*(I3[120] - AC0*I4[80])
          + (onezboz)*(I3[76] - AC1*I4[50])
          + (twozboz)*(I3[62] - AC2*I4[40]);
*(vp++) = U0*I0[81]
          - U10*(I1[81] - I2[121])
          - U11*(I1[121] - I2[123])
          - U12*(I1[131] - I2[124])
          + (fivezboz)*(I3[121] - AC0*I4[81])
          + (onezboz)*(I3[78] - AC1*I4[51])
          + (twozboz)*(I3[64] - AC2*I4[41]);
*(vp++) = U0*I0[82]
          - U10*(I1[82] - I2[122])
          - U11*(I1[122] - I2[124])
          - U12*(I1[132] - I2[125])
          + (fivezboz)*(I3[122] - AC0*I4[82])
          + (onezboz)*(I3[79] - AC1*I4[52])
          + (twozboz)*(I3[65] - AC2*I4[42]);
*(vp++) = U0*I0[83]
          - U10*(I1[83] - I2[123])
          - U11*(I1[123] - I2[126])
          - U12*(I1[133] - I2[127])
          + (fivezboz)*(I3[123] - AC0*I4[83])
          + (onezboz)*(I3[81] - AC1*I4[53])
          + (twozboz)*(I3[67] - AC2*I4[43]);
*(vp++) = U0*I0[84]
          - U10*(I1[84] - I2[124])
          - U11*(I1[124] - I2[127])
          - U12*(I1[134] - I2[128])
          + (fivezboz)*(I3[124] - AC0*I4[84])
          + (onezboz)*(I3[82] - AC1*I4[54])
          + (twozboz)*(I3[68] - AC2*I4[44]);
*(vp++) = U0*I0[85]
          - U10*(I1[85] - I2[125])
          - U11*(I1[125] - I2[128])
          - U12*(I1[135] - I2[129])
          + (fivezboz)*(I3[125] - AC0*I4[85])
          + (onezboz)*(I3[83] - AC1*I4[55])
          + (twozboz)*(I3[69] - AC2*I4[45]);
*(vp++) = U0*I0[86]
          - U10*(I1[86] - I2[126])
          - U11*(I1[126] - I2[130])
          - U12*(I1[136] - I2[131])
          + (fivezboz)*(I3[126] - AC0*I4[86])
          + (onezboz)*(I3[85] - AC1*I4[56])
          + (twozboz)*(I3[71] - AC2*I4[46]);
*(vp++) = U0*I0[87]
          - U10*(I1[87] - I2[127])
          - U11*(I1[127] - I2[131])
          - U12*(I1[137] - I2[132])
          + (fivezboz)*(I3[127] - AC0*I4[87])
          + (onezboz)*(I3[86] - AC1*I4[57])
          + (twozboz)*(I3[72] - AC2*I4[47]);
*(vp++) = U0*I0[88]
          - U10*(I1[88] - I2[128])
          - U11*(I1[128] - I2[132])
          - U12*(I1[138] - I2[133])
          + (fivezboz)*(I3[128] - AC0*I4[88])
          + (onezboz)*(I3[87] - AC1*I4[58])
          + (twozboz)*(I3[73] - AC2*I4[48]);
*(vp++) = U0*I0[89]
          - U10*(I1[89] - I2[129])
          - U11*(I1[129] - I2[133])
          - U12*(I1[139] - I2[134])
          + (fivezboz)*(I3[129] - AC0*I4[89])
          + (onezboz)*(I3[88] - AC1*I4[59])
          + (twozboz)*(I3[74] - AC2*I4[49]);
*(vp++) = U0*I0[90]
          - U10*(I1[90] - I2[135])
          - U11*(I1[130] - I2[136])
          - U12*(I1[140] - I2[137])
          + (fivezboz)*(I3[135] - AC0*I4[90])
          + (threezboz)*(I3[77] - AC2*I4[50]);
*(vp++) = U0*I0[91]
          - U10*(I1[91] - I2[136])
          - U11*(I1[131] - I2[138])
          - U12*(I1[141] - I2[139])
          + (fivezboz)*(I3[136] - AC0*I4[91])
          + (threezboz)*(I3[79] - AC2*I4[51]);
*(vp++) = U0*I0[92]
          - U10*(I1[92] - I2[137])
          - U11*(I1[132] - I2[139])
          - U12*(I1[142] - I2[140])
          + (fivezboz)*(I3[137] - AC0*I4[92])
          + (threezboz)*(I3[80] - AC2*I4[52]);
*(vp++) = U0*I0[93]
          - U10*(I1[93] - I2[138])
          - U11*(I1[133] - I2[141])
          - U12*(I1[143] - I2[142])
          + (fivezboz)*(I3[138] - AC0*I4[93])
          + (threezboz)*(I3[82] - AC2*I4[53]);
*(vp++) = U0*I0[94]
          - U10*(I1[94] - I2[139])
          - U11*(I1[134] - I2[142])
          - U12*(I1[144] - I2[143])
          + (fivezboz)*(I3[139] - AC0*I4[94])
          + (threezboz)*(I3[83] - AC2*I4[54]);
*(vp++) = U0*I0[95]
          - U10*(I1[95] - I2[140])
          - U11*(I1[135] - I2[143])
          - U12*(I1[145] - I2[144])
          + (fivezboz)*(I3[140] - AC0*I4[95])
          + (threezboz)*(I3[84] - AC2*I4[55]);
*(vp++) = U0*I0[96]
          - U10*(I1[96] - I2[141])
          - U11*(I1[136] - I2[145])
          - U12*(I1[146] - I2[146])
          + (fivezboz)*(I3[141] - AC0*I4[96])
          + (threezboz)*(I3[86] - AC2*I4[56]);
*(vp++) = U0*I0[97]
          - U10*(I1[97] - I2[142])
          - U11*(I1[137] - I2[146])
          - U12*(I1[147] - I2[147])
          + (fivezboz)*(I3[142] - AC0*I4[97])
          + (threezboz)*(I3[87] - AC2*I4[57]);
*(vp++) = U0*I0[98]
          - U10*(I1[98] - I2[143])
          - U11*(I1[138] - I2[147])
          - U12*(I1[148] - I2[148])
          + (fivezboz)*(I3[143] - AC0*I4[98])
          + (threezboz)*(I3[88] - AC2*I4[58]);
*(vp++) = U0*I0[99]
          - U10*(I1[99] - I2[144])
          - U11*(I1[139] - I2[148])
          - U12*(I1[149] - I2[149])
          + (fivezboz)*(I3[144] - AC0*I4[99])
          + (threezboz)*(I3[89] - AC2*I4[59]);
*(vp++) = U0*I0[100]
          - U10*(I1[100] - I2[150])
          - U11*(I1[150] - I2[151])
          - U12*(I1[160] - I2[152])
          + (fourzboz)*(I3[150] - AC0*I4[100])
          + (fourzboz)*(I3[91] - AC1*I4[60]);
*(vp++) = U0*I0[101]
          - U10*(I1[101] - I2[151])
          - U11*(I1[151] - I2[153])
          - U12*(I1[161] - I2[154])
          + (fourzboz)*(I3[151] - AC0*I4[101])
          + (fourzboz)*(I3[93] - AC1*I4[61]);
*(vp++) = U0*I0[102]
          - U10*(I1[102] - I2[152])
          - U11*(I1[152] - I2[154])
          - U12*(I1[162] - I2[155])
          + (fourzboz)*(I3[152] - AC0*I4[102])
          + (fourzboz)*(I3[94] - AC1*I4[62]);
*(vp++) = U0*I0[103]
          - U10*(I1[103] - I2[153])
          - U11*(I1[153] - I2[156])
          - U12*(I1[163] - I2[157])
          + (fourzboz)*(I3[153] - AC0*I4[103])
          + (fourzboz)*(I3[96] - AC1*I4[63]);
*(vp++) = U0*I0[104]
          - U10*(I1[104] - I2[154])
          - U11*(I1[154] - I2[157])
          - U12*(I1[164] - I2[158])
          + (fourzboz)*(I3[154] - AC0*I4[104])
          + (fourzboz)*(I3[97] - AC1*I4[64]);
*(vp++) = U0*I0[105]
          - U10*(I1[105] - I2[155])
          - U11*(I1[155] - I2[158])
          - U12*(I1[165] - I2[159])
          + (fourzboz)*(I3[155] - AC0*I4[105])
          + (fourzboz)*(I3[98] - AC1*I4[65]);
*(vp++) = U0*I0[106]
          - U10*(I1[106] - I2[156])
          - U11*(I1[156] - I2[160])
          - U12*(I1[166] - I2[161])
          + (fourzboz)*(I3[156] - AC0*I4[106])
          + (fourzboz)*(I3[100] - AC1*I4[66]);
*(vp++) = U0*I0[107]
          - U10*(I1[107] - I2[157])
          - U11*(I1[157] - I2[161])
          - U12*(I1[167] - I2[162])
          + (fourzboz)*(I3[157] - AC0*I4[107])
          + (fourzboz)*(I3[101] - AC1*I4[67]);
*(vp++) = U0*I0[108]
          - U10*(I1[108] - I2[158])
          - U11*(I1[158] - I2[162])
          - U12*(I1[168] - I2[163])
          + (fourzboz)*(I3[158] - AC0*I4[108])
          + (fourzboz)*(I3[102] - AC1*I4[68]);
*(vp++) = U0*I0[109]
          - U10*(I1[109] - I2[159])
          - U11*(I1[159] - I2[163])
          - U12*(I1[169] - I2[164])
          + (fourzboz)*(I3[159] - AC0*I4[109])
          + (fourzboz)*(I3[103] - AC1*I4[69]);
*(vp++) = U0*I0[110]
          - U10*(I1[110] - I2[165])
          - U11*(I1[160] - I2[166])
          - U12*(I1[170] - I2[167])
          + (fourzboz)*(I3[165] - AC0*I4[110])
          + (threezboz)*(I3[106] - AC1*I4[70])
          + (onezboz)*(I3[92] - AC2*I4[60]);
*(vp++) = U0*I0[111]
          - U10*(I1[111] - I2[166])
          - U11*(I1[161] - I2[168])
          - U12*(I1[171] - I2[169])
          + (fourzboz)*(I3[166] - AC0*I4[111])
          + (threezboz)*(I3[108] - AC1*I4[71])
          + (onezboz)*(I3[94] - AC2*I4[61]);
*(vp++) = U0*I0[112]
          - U10*(I1[112] - I2[167])
          - U11*(I1[162] - I2[169])
          - U12*(I1[172] - I2[170])
          + (fourzboz)*(I3[167] - AC0*I4[112])
          + (threezboz)*(I3[109] - AC1*I4[72])
          + (onezboz)*(I3[95] - AC2*I4[62]);
*(vp++) = U0*I0[113]
          - U10*(I1[113] - I2[168])
          - U11*(I1[163] - I2[171])
          - U12*(I1[173] - I2[172])
          + (fourzboz)*(I3[168] - AC0*I4[113])
          + (threezboz)*(I3[111] - AC1*I4[73])
          + (onezboz)*(I3[97] - AC2*I4[63]);
*(vp++) = U0*I0[114]
          - U10*(I1[114] - I2[169])
          - U11*(I1[164] - I2[172])
          - U12*(I1[174] - I2[173])
          + (fourzboz)*(I3[169] - AC0*I4[114])
          + (threezboz)*(I3[112] - AC1*I4[74])
          + (onezboz)*(I3[98] - AC2*I4[64]);
*(vp++) = U0*I0[115]
          - U10*(I1[115] - I2[170])
          - U11*(I1[165] - I2[173])
          - U12*(I1[175] - I2[174])
          + (fourzboz)*(I3[170] - AC0*I4[115])
          + (threezboz)*(I3[113] - AC1*I4[75])
          + (onezboz)*(I3[99] - AC2*I4[65]);
*(vp++) = U0*I0[116]
          - U10*(I1[116] - I2[171])
          - U11*(I1[166] - I2[175])
          - U12*(I1[176] - I2[176])
          + (fourzboz)*(I3[171] - AC0*I4[116])
          + (threezboz)*(I3[115] - AC1*I4[76])
          + (onezboz)*(I3[101] - AC2*I4[66]);
*(vp++) = U0*I0[117]
          - U10*(I1[117] - I2[172])
          - U11*(I1[167] - I2[176])
          - U12*(I1[177] - I2[177])
          + (fourzboz)*(I3[172] - AC0*I4[117])
          + (threezboz)*(I3[116] - AC1*I4[77])
          + (onezboz)*(I3[102] - AC2*I4[67]);
*(vp++) = U0*I0[118]
          - U10*(I1[118] - I2[173])
          - U11*(I1[168] - I2[177])
          - U12*(I1[178] - I2[178])
          + (fourzboz)*(I3[173] - AC0*I4[118])
          + (threezboz)*(I3[117] - AC1*I4[78])
          + (onezboz)*(I3[103] - AC2*I4[68]);
*(vp++) = U0*I0[119]
          - U10*(I1[119] - I2[174])
          - U11*(I1[169] - I2[178])
          - U12*(I1[179] - I2[179])
          + (fourzboz)*(I3[174] - AC0*I4[119])
          + (threezboz)*(I3[118] - AC1*I4[79])
          + (onezboz)*(I3[104] - AC2*I4[69]);
*(vp++) = U0*I0[120]
          - U10*(I1[120] - I2[180])
          - U11*(I1[170] - I2[181])
          - U12*(I1[180] - I2[182])
          + (fourzboz)*(I3[180] - AC0*I4[120])
          + (twozboz)*(I3[121] - AC1*I4[80])
          + (twozboz)*(I3[107] - AC2*I4[70]);
*(vp++) = U0*I0[121]
          - U10*(I1[121] - I2[181])
          - U11*(I1[171] - I2[183])
          - U12*(I1[181] - I2[184])
          + (fourzboz)*(I3[181] - AC0*I4[121])
          + (twozboz)*(I3[123] - AC1*I4[81])
          + (twozboz)*(I3[109] - AC2*I4[71]);
*(vp++) = U0*I0[122]
          - U10*(I1[122] - I2[182])
          - U11*(I1[172] - I2[184])
          - U12*(I1[182] - I2[185])
          + (fourzboz)*(I3[182] - AC0*I4[122])
          + (twozboz)*(I3[124] - AC1*I4[82])
          + (twozboz)*(I3[110] - AC2*I4[72]);
*(vp++) = U0*I0[123]
          - U10*(I1[123] - I2[183])
          - U11*(I1[173] - I2[186])
          - U12*(I1[183] - I2[187])
          + (fourzboz)*(I3[183] - AC0*I4[123])
          + (twozboz)*(I3[126] - AC1*I4[83])
          + (twozboz)*(I3[112] - AC2*I4[73]);
*(vp++) = U0*I0[124]
          - U10*(I1[124] - I2[184])
          - U11*(I1[174] - I2[187])
          - U12*(I1[184] - I2[188])
          + (fourzboz)*(I3[184] - AC0*I4[124])
          + (twozboz)*(I3[127] - AC1*I4[84])
          + (twozboz)*(I3[113] - AC2*I4[74]);
*(vp++) = U0*I0[125]
          - U10*(I1[125] - I2[185])
          - U11*(I1[175] - I2[188])
          - U12*(I1[185] - I2[189])
          + (fourzboz)*(I3[185] - AC0*I4[125])
          + (twozboz)*(I3[128] - AC1*I4[85])
          + (twozboz)*(I3[114] - AC2*I4[75]);
*(vp++) = U0*I0[126]
          - U10*(I1[126] - I2[186])
          - U11*(I1[176] - I2[190])
          - U12*(I1[186] - I2[191])
          + (fourzboz)*(I3[186] - AC0*I4[126])
          + (twozboz)*(I3[130] - AC1*I4[86])
          + (twozboz)*(I3[116] - AC2*I4[76]);
*(vp++) = U0*I0[127]
          - U10*(I1[127] - I2[187])
          - U11*(I1[177] - I2[191])
          - U12*(I1[187] - I2[192])
          + (fourzboz)*(I3[187] - AC0*I4[127])
          + (twozboz)*(I3[131] - AC1*I4[87])
          + (twozboz)*(I3[117] - AC2*I4[77]);
*(vp++) = U0*I0[128]
          - U10*(I1[128] - I2[188])
          - U11*(I1[178] - I2[192])
          - U12*(I1[188] - I2[193])
          + (fourzboz)*(I3[188] - AC0*I4[128])
          + (twozboz)*(I3[132] - AC1*I4[88])
          + (twozboz)*(I3[118] - AC2*I4[78]);
*(vp++) = U0*I0[129]
          - U10*(I1[129] - I2[189])
          - U11*(I1[179] - I2[193])
          - U12*(I1[189] - I2[194])
          + (fourzboz)*(I3[189] - AC0*I4[129])
          + (twozboz)*(I3[133] - AC1*I4[89])
          + (twozboz)*(I3[119] - AC2*I4[79]);
*(vp++) = U0*I0[130]
          - U10*(I1[130] - I2[195])
          - U11*(I1[180] - I2[196])
          - U12*(I1[190] - I2[197])
          + (fourzboz)*(I3[195] - AC0*I4[130])
          + (onezboz)*(I3[136] - AC1*I4[90])
          + (threezboz)*(I3[122] - AC2*I4[80]);
*(vp++) = U0*I0[131]
          - U10*(I1[131] - I2[196])
          - U11*(I1[181] - I2[198])
          - U12*(I1[191] - I2[199])
          + (fourzboz)*(I3[196] - AC0*I4[131])
          + (onezboz)*(I3[138] - AC1*I4[91])
          + (threezboz)*(I3[124] - AC2*I4[81]);
*(vp++) = U0*I0[132]
          - U10*(I1[132] - I2[197])
          - U11*(I1[182] - I2[199])
          - U12*(I1[192] - I2[200])
          + (fourzboz)*(I3[197] - AC0*I4[132])
          + (onezboz)*(I3[139] - AC1*I4[92])
          + (threezboz)*(I3[125] - AC2*I4[82]);
*(vp++) = U0*I0[133]
          - U10*(I1[133] - I2[198])
          - U11*(I1[183] - I2[201])
          - U12*(I1[193] - I2[202])
          + (fourzboz)*(I3[198] - AC0*I4[133])
          + (onezboz)*(I3[141] - AC1*I4[93])
          + (threezboz)*(I3[127] - AC2*I4[83]);
*(vp++) = U0*I0[134]
          - U10*(I1[134] - I2[199])
          - U11*(I1[184] - I2[202])
          - U12*(I1[194] - I2[203])
          + (fourzboz)*(I3[199] - AC0*I4[134])
          + (onezboz)*(I3[142] - AC1*I4[94])
          + (threezboz)*(I3[128] - AC2*I4[84]);
*(vp++) = U0*I0[135]
          - U10*(I1[135] - I2[200])
          - U11*(I1[185] - I2[203])
          - U12*(I1[195] - I2[204])
          + (fourzboz)*(I3[200] - AC0*I4[135])
          + (onezboz)*(I3[143] - AC1*I4[95])
          + (threezboz)*(I3[129] - AC2*I4[85]);
*(vp++) = U0*I0[136]
          - U10*(I1[136] - I2[201])
          - U11*(I1[186] - I2[205])
          - U12*(I1[196] - I2[206])
          + (fourzboz)*(I3[201] - AC0*I4[136])
          + (onezboz)*(I3[145] - AC1*I4[96])
          + (threezboz)*(I3[131] - AC2*I4[86]);
*(vp++) = U0*I0[137]
          - U10*(I1[137] - I2[202])
          - U11*(I1[187] - I2[206])
          - U12*(I1[197] - I2[207])
          + (fourzboz)*(I3[202] - AC0*I4[137])
          + (onezboz)*(I3[146] - AC1*I4[97])
          + (threezboz)*(I3[132] - AC2*I4[87]);
*(vp++) = U0*I0[138]
          - U10*(I1[138] - I2[203])
          - U11*(I1[188] - I2[207])
          - U12*(I1[198] - I2[208])
          + (fourzboz)*(I3[203] - AC0*I4[138])
          + (onezboz)*(I3[147] - AC1*I4[98])
          + (threezboz)*(I3[133] - AC2*I4[88]);
*(vp++) = U0*I0[139]
          - U10*(I1[139] - I2[204])
          - U11*(I1[189] - I2[208])
          - U12*(I1[199] - I2[209])
          + (fourzboz)*(I3[204] - AC0*I4[139])
          + (onezboz)*(I3[148] - AC1*I4[99])
          + (threezboz)*(I3[134] - AC2*I4[89]);
*(vp++) = U0*I0[140]
          - U10*(I1[140] - I2[210])
          - U11*(I1[190] - I2[211])
          - U12*(I1[200] - I2[212])
          + (fourzboz)*(I3[210] - AC0*I4[140])
          + (fourzboz)*(I3[137] - AC2*I4[90]);
*(vp++) = U0*I0[141]
          - U10*(I1[141] - I2[211])
          - U11*(I1[191] - I2[213])
          - U12*(I1[201] - I2[214])
          + (fourzboz)*(I3[211] - AC0*I4[141])
          + (fourzboz)*(I3[139] - AC2*I4[91]);
*(vp++) = U0*I0[142]
          - U10*(I1[142] - I2[212])
          - U11*(I1[192] - I2[214])
          - U12*(I1[202] - I2[215])
          + (fourzboz)*(I3[212] - AC0*I4[142])
          + (fourzboz)*(I3[140] - AC2*I4[92]);
*(vp++) = U0*I0[143]
          - U10*(I1[143] - I2[213])
          - U11*(I1[193] - I2[216])
          - U12*(I1[203] - I2[217])
          + (fourzboz)*(I3[213] - AC0*I4[143])
          + (fourzboz)*(I3[142] - AC2*I4[93]);
*(vp++) = U0*I0[144]
          - U10*(I1[144] - I2[214])
          - U11*(I1[194] - I2[217])
          - U12*(I1[204] - I2[218])
          + (fourzboz)*(I3[214] - AC0*I4[144])
          + (fourzboz)*(I3[143] - AC2*I4[94]);
*(vp++) = U0*I0[145]
          - U10*(I1[145] - I2[215])
          - U11*(I1[195] - I2[218])
          - U12*(I1[205] - I2[219])
          + (fourzboz)*(I3[215] - AC0*I4[145])
          + (fourzboz)*(I3[144] - AC2*I4[95]);
*(vp++) = U0*I0[146]
          - U10*(I1[146] - I2[216])
          - U11*(I1[196] - I2[220])
          - U12*(I1[206] - I2[221])
          + (fourzboz)*(I3[216] - AC0*I4[146])
          + (fourzboz)*(I3[146] - AC2*I4[96]);
*(vp++) = U0*I0[147]
          - U10*(I1[147] - I2[217])
          - U11*(I1[197] - I2[221])
          - U12*(I1[207] - I2[222])
          + (fourzboz)*(I3[217] - AC0*I4[147])
          + (fourzboz)*(I3[147] - AC2*I4[97]);
*(vp++) = U0*I0[148]
          - U10*(I1[148] - I2[218])
          - U11*(I1[198] - I2[222])
          - U12*(I1[208] - I2[223])
          + (fourzboz)*(I3[218] - AC0*I4[148])
          + (fourzboz)*(I3[148] - AC2*I4[98]);
*(vp++) = U0*I0[149]
          - U10*(I1[149] - I2[219])
          - U11*(I1[199] - I2[223])
          - U12*(I1[209] - I2[224])
          + (fourzboz)*(I3[219] - AC0*I4[149])
          + (fourzboz)*(I3[149] - AC2*I4[99]);
*(vp++) = U0*I0[150]
          - U10*(I1[150] - I2[225])
          - U11*(I1[210] - I2[226])
          - U12*(I1[220] - I2[227])
          + (threezboz)*(I3[225] - AC0*I4[150])
          + (fivezboz)*(I3[151] - AC1*I4[100]);
*(vp++) = U0*I0[151]
          - U10*(I1[151] - I2[226])
          - U11*(I1[211] - I2[228])
          - U12*(I1[221] - I2[229])
          + (threezboz)*(I3[226] - AC0*I4[151])
          + (fivezboz)*(I3[153] - AC1*I4[101]);
*(vp++) = U0*I0[152]
          - U10*(I1[152] - I2[227])
          - U11*(I1[212] - I2[229])
          - U12*(I1[222] - I2[230])
          + (threezboz)*(I3[227] - AC0*I4[152])
          + (fivezboz)*(I3[154] - AC1*I4[102]);
*(vp++) = U0*I0[153]
          - U10*(I1[153] - I2[228])
          - U11*(I1[213] - I2[231])
          - U12*(I1[223] - I2[232])
          + (threezboz)*(I3[228] - AC0*I4[153])
          + (fivezboz)*(I3[156] - AC1*I4[103]);
*(vp++) = U0*I0[154]
          - U10*(I1[154] - I2[229])
          - U11*(I1[214] - I2[232])
          - U12*(I1[224] - I2[233])
          + (threezboz)*(I3[229] - AC0*I4[154])
          + (fivezboz)*(I3[157] - AC1*I4[104]);
*(vp++) = U0*I0[155]
          - U10*(I1[155] - I2[230])
          - U11*(I1[215] - I2[233])
          - U12*(I1[225] - I2[234])
          + (threezboz)*(I3[230] - AC0*I4[155])
          + (fivezboz)*(I3[158] - AC1*I4[105]);
*(vp++) = U0*I0[156]
          - U10*(I1[156] - I2[231])
          - U11*(I1[216] - I2[235])
          - U12*(I1[226] - I2[236])
          + (threezboz)*(I3[231] - AC0*I4[156])
          + (fivezboz)*(I3[160] - AC1*I4[106]);
*(vp++) = U0*I0[157]
          - U10*(I1[157] - I2[232])
          - U11*(I1[217] - I2[236])
          - U12*(I1[227] - I2[237])
          + (threezboz)*(I3[232] - AC0*I4[157])
          + (fivezboz)*(I3[161] - AC1*I4[107]);
*(vp++) = U0*I0[158]
          - U10*(I1[158] - I2[233])
          - U11*(I1[218] - I2[237])
          - U12*(I1[228] - I2[238])
          + (threezboz)*(I3[233] - AC0*I4[158])
          + (fivezboz)*(I3[162] - AC1*I4[108]);
*(vp++) = U0*I0[159]
          - U10*(I1[159] - I2[234])
          - U11*(I1[219] - I2[238])
          - U12*(I1[229] - I2[239])
          + (threezboz)*(I3[234] - AC0*I4[159])
          + (fivezboz)*(I3[163] - AC1*I4[109]);
*(vp++) = U0*I0[160]
          - U10*(I1[160] - I2[240])
          - U11*(I1[220] - I2[241])
          - U12*(I1[230] - I2[242])
          + (threezboz)*(I3[240] - AC0*I4[160])
          + (fourzboz)*(I3[166] - AC1*I4[110])
          + (onezboz)*(I3[152] - AC2*I4[100]);
*(vp++) = U0*I0[161]
          - U10*(I1[161] - I2[241])
          - U11*(I1[221] - I2[243])
          - U12*(I1[231] - I2[244])
          + (threezboz)*(I3[241] - AC0*I4[161])
          + (fourzboz)*(I3[168] - AC1*I4[111])
          + (onezboz)*(I3[154] - AC2*I4[101]);
*(vp++) = U0*I0[162]
          - U10*(I1[162] - I2[242])
          - U11*(I1[222] - I2[244])
          - U12*(I1[232] - I2[245])
          + (threezboz)*(I3[242] - AC0*I4[162])
          + (fourzboz)*(I3[169] - AC1*I4[112])
          + (onezboz)*(I3[155] - AC2*I4[102]);
*(vp++) = U0*I0[163]
          - U10*(I1[163] - I2[243])
          - U11*(I1[223] - I2[246])
          - U12*(I1[233] - I2[247])
          + (threezboz)*(I3[243] - AC0*I4[163])
          + (fourzboz)*(I3[171] - AC1*I4[113])
          + (onezboz)*(I3[157] - AC2*I4[103]);
*(vp++) = U0*I0[164]
          - U10*(I1[164] - I2[244])
          - U11*(I1[224] - I2[247])
          - U12*(I1[234] - I2[248])
          + (threezboz)*(I3[244] - AC0*I4[164])
          + (fourzboz)*(I3[172] - AC1*I4[114])
          + (onezboz)*(I3[158] - AC2*I4[104]);
*(vp++) = U0*I0[165]
          - U10*(I1[165] - I2[245])
          - U11*(I1[225] - I2[248])
          - U12*(I1[235] - I2[249])
          + (threezboz)*(I3[245] - AC0*I4[165])
          + (fourzboz)*(I3[173] - AC1*I4[115])
          + (onezboz)*(I3[159] - AC2*I4[105]);
*(vp++) = U0*I0[166]
          - U10*(I1[166] - I2[246])
          - U11*(I1[226] - I2[250])
          - U12*(I1[236] - I2[251])
          + (threezboz)*(I3[246] - AC0*I4[166])
          + (fourzboz)*(I3[175] - AC1*I4[116])
          + (onezboz)*(I3[161] - AC2*I4[106]);
*(vp++) = U0*I0[167]
          - U10*(I1[167] - I2[247])
          - U11*(I1[227] - I2[251])
          - U12*(I1[237] - I2[252])
          + (threezboz)*(I3[247] - AC0*I4[167])
          + (fourzboz)*(I3[176] - AC1*I4[117])
          + (onezboz)*(I3[162] - AC2*I4[107]);
*(vp++) = U0*I0[168]
          - U10*(I1[168] - I2[248])
          - U11*(I1[228] - I2[252])
          - U12*(I1[238] - I2[253])
          + (threezboz)*(I3[248] - AC0*I4[168])
          + (fourzboz)*(I3[177] - AC1*I4[118])
          + (onezboz)*(I3[163] - AC2*I4[108]);
*(vp++) = U0*I0[169]
          - U10*(I1[169] - I2[249])
          - U11*(I1[229] - I2[253])
          - U12*(I1[239] - I2[254])
          + (threezboz)*(I3[249] - AC0*I4[169])
          + (fourzboz)*(I3[178] - AC1*I4[119])
          + (onezboz)*(I3[164] - AC2*I4[109]);
*(vp++) = U0*I0[170]
          - U10*(I1[170] - I2[255])
          - U11*(I1[230] - I2[256])
          - U12*(I1[240] - I2[257])
          + (threezboz)*(I3[255] - AC0*I4[170])
          + (threezboz)*(I3[181] - AC1*I4[120])
          + (twozboz)*(I3[167] - AC2*I4[110]);
*(vp++) = U0*I0[171]
          - U10*(I1[171] - I2[256])
          - U11*(I1[231] - I2[258])
          - U12*(I1[241] - I2[259])
          + (threezboz)*(I3[256] - AC0*I4[171])
          + (threezboz)*(I3[183] - AC1*I4[121])
          + (twozboz)*(I3[169] - AC2*I4[111]);
*(vp++) = U0*I0[172]
          - U10*(I1[172] - I2[257])
          - U11*(I1[232] - I2[259])
          - U12*(I1[242] - I2[260])
          + (threezboz)*(I3[257] - AC0*I4[172])
          + (threezboz)*(I3[184] - AC1*I4[122])
          + (twozboz)*(I3[170] - AC2*I4[112]);
*(vp++) = U0*I0[173]
          - U10*(I1[173] - I2[258])
          - U11*(I1[233] - I2[261])
          - U12*(I1[243] - I2[262])
          + (threezboz)*(I3[258] - AC0*I4[173])
          + (threezboz)*(I3[186] - AC1*I4[123])
          + (twozboz)*(I3[172] - AC2*I4[113]);
*(vp++) = U0*I0[174]
          - U10*(I1[174] - I2[259])
          - U11*(I1[234] - I2[262])
          - U12*(I1[244] - I2[263])
          + (threezboz)*(I3[259] - AC0*I4[174])
          + (threezboz)*(I3[187] - AC1*I4[124])
          + (twozboz)*(I3[173] - AC2*I4[114]);
*(vp++) = U0*I0[175]
          - U10*(I1[175] - I2[260])
          - U11*(I1[235] - I2[263])
          - U12*(I1[245] - I2[264])
          + (threezboz)*(I3[260] - AC0*I4[175])
          + (threezboz)*(I3[188] - AC1*I4[125])
          + (twozboz)*(I3[174] - AC2*I4[115]);
*(vp++) = U0*I0[176]
          - U10*(I1[176] - I2[261])
          - U11*(I1[236] - I2[265])
          - U12*(I1[246] - I2[266])
          + (threezboz)*(I3[261] - AC0*I4[176])
          + (threezboz)*(I3[190] - AC1*I4[126])
          + (twozboz)*(I3[176] - AC2*I4[116]);
*(vp++) = U0*I0[177]
          - U10*(I1[177] - I2[262])
          - U11*(I1[237] - I2[266])
          - U12*(I1[247] - I2[267])
          + (threezboz)*(I3[262] - AC0*I4[177])
          + (threezboz)*(I3[191] - AC1*I4[127])
          + (twozboz)*(I3[177] - AC2*I4[117]);
*(vp++) = U0*I0[178]
          - U10*(I1[178] - I2[263])
          - U11*(I1[238] - I2[267])
          - U12*(I1[248] - I2[268])
          + (threezboz)*(I3[263] - AC0*I4[178])
          + (threezboz)*(I3[192] - AC1*I4[128])
          + (twozboz)*(I3[178] - AC2*I4[118]);
*(vp++) = U0*I0[179]
          - U10*(I1[179] - I2[264])
          - U11*(I1[239] - I2[268])
          - U12*(I1[249] - I2[269])
          + (threezboz)*(I3[264] - AC0*I4[179])
          + (threezboz)*(I3[193] - AC1*I4[129])
          + (twozboz)*(I3[179] - AC2*I4[119]);
*(vp++) = U0*I0[180]
          - U10*(I1[180] - I2[270])
          - U11*(I1[240] - I2[271])
          - U12*(I1[250] - I2[272])
          + (threezboz)*(I3[270] - AC0*I4[180])
          + (twozboz)*(I3[196] - AC1*I4[130])
          + (threezboz)*(I3[182] - AC2*I4[120]);
*(vp++) = U0*I0[181]
          - U10*(I1[181] - I2[271])
          - U11*(I1[241] - I2[273])
          - U12*(I1[251] - I2[274])
          + (threezboz)*(I3[271] - AC0*I4[181])
          + (twozboz)*(I3[198] - AC1*I4[131])
          + (threezboz)*(I3[184] - AC2*I4[121]);
*(vp++) = U0*I0[182]
          - U10*(I1[182] - I2[272])
          - U11*(I1[242] - I2[274])
          - U12*(I1[252] - I2[275])
          + (threezboz)*(I3[272] - AC0*I4[182])
          + (twozboz)*(I3[199] - AC1*I4[132])
          + (threezboz)*(I3[185] - AC2*I4[122]);
*(vp++) = U0*I0[183]
          - U10*(I1[183] - I2[273])
          - U11*(I1[243] - I2[276])
          - U12*(I1[253] - I2[277])
          + (threezboz)*(I3[273] - AC0*I4[183])
          + (twozboz)*(I3[201] - AC1*I4[133])
          + (threezboz)*(I3[187] - AC2*I4[123]);
*(vp++) = U0*I0[184]
          - U10*(I1[184] - I2[274])
          - U11*(I1[244] - I2[277])
          - U12*(I1[254] - I2[278])
          + (threezboz)*(I3[274] - AC0*I4[184])
          + (twozboz)*(I3[202] - AC1*I4[134])
          + (threezboz)*(I3[188] - AC2*I4[124]);
*(vp++) = U0*I0[185]
          - U10*(I1[185] - I2[275])
          - U11*(I1[245] - I2[278])
          - U12*(I1[255] - I2[279])
          + (threezboz)*(I3[275] - AC0*I4[185])
          + (twozboz)*(I3[203] - AC1*I4[135])
          + (threezboz)*(I3[189] - AC2*I4[125]);
*(vp++) = U0*I0[186]
          - U10*(I1[186] - I2[276])
          - U11*(I1[246] - I2[280])
          - U12*(I1[256] - I2[281])
          + (threezboz)*(I3[276] - AC0*I4[186])
          + (twozboz)*(I3[205] - AC1*I4[136])
          + (threezboz)*(I3[191] - AC2*I4[126]);
*(vp++) = U0*I0[187]
          - U10*(I1[187] - I2[277])
          - U11*(I1[247] - I2[281])
          - U12*(I1[257] - I2[282])
          + (threezboz)*(I3[277] - AC0*I4[187])
          + (twozboz)*(I3[206] - AC1*I4[137])
          + (threezboz)*(I3[192] - AC2*I4[127]);
*(vp++) = U0*I0[188]
          - U10*(I1[188] - I2[278])
          - U11*(I1[248] - I2[282])
          - U12*(I1[258] - I2[283])
          + (threezboz)*(I3[278] - AC0*I4[188])
          + (twozboz)*(I3[207] - AC1*I4[138])
          + (threezboz)*(I3[193] - AC2*I4[128]);
*(vp++) = U0*I0[189]
          - U10*(I1[189] - I2[279])
          - U11*(I1[249] - I2[283])
          - U12*(I1[259] - I2[284])
          + (threezboz)*(I3[279] - AC0*I4[189])
          + (twozboz)*(I3[208] - AC1*I4[139])
          + (threezboz)*(I3[194] - AC2*I4[129]);
*(vp++) = U0*I0[190]
          - U10*(I1[190] - I2[285])
          - U11*(I1[250] - I2[286])
          - U12*(I1[260] - I2[287])
          + (threezboz)*(I3[285] - AC0*I4[190])
          + (onezboz)*(I3[211] - AC1*I4[140])
          + (fourzboz)*(I3[197] - AC2*I4[130]);
*(vp++) = U0*I0[191]
          - U10*(I1[191] - I2[286])
          - U11*(I1[251] - I2[288])
          - U12*(I1[261] - I2[289])
          + (threezboz)*(I3[286] - AC0*I4[191])
          + (onezboz)*(I3[213] - AC1*I4[141])
          + (fourzboz)*(I3[199] - AC2*I4[131]);
*(vp++) = U0*I0[192]
          - U10*(I1[192] - I2[287])
          - U11*(I1[252] - I2[289])
          - U12*(I1[262] - I2[290])
          + (threezboz)*(I3[287] - AC0*I4[192])
          + (onezboz)*(I3[214] - AC1*I4[142])
          + (fourzboz)*(I3[200] - AC2*I4[132]);
*(vp++) = U0*I0[193]
          - U10*(I1[193] - I2[288])
          - U11*(I1[253] - I2[291])
          - U12*(I1[263] - I2[292])
          + (threezboz)*(I3[288] - AC0*I4[193])
          + (onezboz)*(I3[216] - AC1*I4[143])
          + (fourzboz)*(I3[202] - AC2*I4[133]);
*(vp++) = U0*I0[194]
          - U10*(I1[194] - I2[289])
          - U11*(I1[254] - I2[292])
          - U12*(I1[264] - I2[293])
          + (threezboz)*(I3[289] - AC0*I4[194])
          + (onezboz)*(I3[217] - AC1*I4[144])
          + (fourzboz)*(I3[203] - AC2*I4[134]);
*(vp++) = U0*I0[195]
          - U10*(I1[195] - I2[290])
          - U11*(I1[255] - I2[293])
          - U12*(I1[265] - I2[294])
          + (threezboz)*(I3[290] - AC0*I4[195])
          + (onezboz)*(I3[218] - AC1*I4[145])
          + (fourzboz)*(I3[204] - AC2*I4[135]);
*(vp++) = U0*I0[196]
          - U10*(I1[196] - I2[291])
          - U11*(I1[256] - I2[295])
          - U12*(I1[266] - I2[296])
          + (threezboz)*(I3[291] - AC0*I4[196])
          + (onezboz)*(I3[220] - AC1*I4[146])
          + (fourzboz)*(I3[206] - AC2*I4[136]);
*(vp++) = U0*I0[197]
          - U10*(I1[197] - I2[292])
          - U11*(I1[257] - I2[296])
          - U12*(I1[267] - I2[297])
          + (threezboz)*(I3[292] - AC0*I4[197])
          + (onezboz)*(I3[221] - AC1*I4[147])
          + (fourzboz)*(I3[207] - AC2*I4[137]);
*(vp++) = U0*I0[198]
          - U10*(I1[198] - I2[293])
          - U11*(I1[258] - I2[297])
          - U12*(I1[268] - I2[298])
          + (threezboz)*(I3[293] - AC0*I4[198])
          + (onezboz)*(I3[222] - AC1*I4[148])
          + (fourzboz)*(I3[208] - AC2*I4[138]);
*(vp++) = U0*I0[199]
          - U10*(I1[199] - I2[294])
          - U11*(I1[259] - I2[298])
          - U12*(I1[269] - I2[299])
          + (threezboz)*(I3[294] - AC0*I4[199])
          + (onezboz)*(I3[223] - AC1*I4[149])
          + (fourzboz)*(I3[209] - AC2*I4[139]);
*(vp++) = U0*I0[200]
          - U10*(I1[200] - I2[300])
          - U11*(I1[260] - I2[301])
          - U12*(I1[270] - I2[302])
          + (threezboz)*(I3[300] - AC0*I4[200])
          + (fivezboz)*(I3[212] - AC2*I4[140]);
*(vp++) = U0*I0[201]
          - U10*(I1[201] - I2[301])
          - U11*(I1[261] - I2[303])
          - U12*(I1[271] - I2[304])
          + (threezboz)*(I3[301] - AC0*I4[201])
          + (fivezboz)*(I3[214] - AC2*I4[141]);
*(vp++) = U0*I0[202]
          - U10*(I1[202] - I2[302])
          - U11*(I1[262] - I2[304])
          - U12*(I1[272] - I2[305])
          + (threezboz)*(I3[302] - AC0*I4[202])
          + (fivezboz)*(I3[215] - AC2*I4[142]);
*(vp++) = U0*I0[203]
          - U10*(I1[203] - I2[303])
          - U11*(I1[263] - I2[306])
          - U12*(I1[273] - I2[307])
          + (threezboz)*(I3[303] - AC0*I4[203])
          + (fivezboz)*(I3[217] - AC2*I4[143]);
*(vp++) = U0*I0[204]
          - U10*(I1[204] - I2[304])
          - U11*(I1[264] - I2[307])
          - U12*(I1[274] - I2[308])
          + (threezboz)*(I3[304] - AC0*I4[204])
          + (fivezboz)*(I3[218] - AC2*I4[144]);
*(vp++) = U0*I0[205]
          - U10*(I1[205] - I2[305])
          - U11*(I1[265] - I2[308])
          - U12*(I1[275] - I2[309])
          + (threezboz)*(I3[305] - AC0*I4[205])
          + (fivezboz)*(I3[219] - AC2*I4[145]);
*(vp++) = U0*I0[206]
          - U10*(I1[206] - I2[306])
          - U11*(I1[266] - I2[310])
          - U12*(I1[276] - I2[311])
          + (threezboz)*(I3[306] - AC0*I4[206])
          + (fivezboz)*(I3[221] - AC2*I4[146]);
*(vp++) = U0*I0[207]
          - U10*(I1[207] - I2[307])
          - U11*(I1[267] - I2[311])
          - U12*(I1[277] - I2[312])
          + (threezboz)*(I3[307] - AC0*I4[207])
          + (fivezboz)*(I3[222] - AC2*I4[147]);
*(vp++) = U0*I0[208]
          - U10*(I1[208] - I2[308])
          - U11*(I1[268] - I2[312])
          - U12*(I1[278] - I2[313])
          + (threezboz)*(I3[308] - AC0*I4[208])
          + (fivezboz)*(I3[223] - AC2*I4[148]);
*(vp++) = U0*I0[209]
          - U10*(I1[209] - I2[309])
          - U11*(I1[269] - I2[313])
          - U12*(I1[279] - I2[314])
          + (threezboz)*(I3[309] - AC0*I4[209])
          + (fivezboz)*(I3[224] - AC2*I4[149]);
*(vp++) = U0*I0[210]
          - U10*(I1[210] - I2[315])
          - U11*(I1[280] - I2[316])
          - U12*(I1[290] - I2[317])
          + (twozboz)*(I3[315] - AC0*I4[210])
          + (sixzboz)*(I3[226] - AC1*I4[150]);
*(vp++) = U0*I0[211]
          - U10*(I1[211] - I2[316])
          - U11*(I1[281] - I2[318])
          - U12*(I1[291] - I2[319])
          + (twozboz)*(I3[316] - AC0*I4[211])
          + (sixzboz)*(I3[228] - AC1*I4[151]);
*(vp++) = U0*I0[212]
          - U10*(I1[212] - I2[317])
          - U11*(I1[282] - I2[319])
          - U12*(I1[292] - I2[320])
          + (twozboz)*(I3[317] - AC0*I4[212])
          + (sixzboz)*(I3[229] - AC1*I4[152]);
*(vp++) = U0*I0[213]
          - U10*(I1[213] - I2[318])
          - U11*(I1[283] - I2[321])
          - U12*(I1[293] - I2[322])
          + (twozboz)*(I3[318] - AC0*I4[213])
          + (sixzboz)*(I3[231] - AC1*I4[153]);
*(vp++) = U0*I0[214]
          - U10*(I1[214] - I2[319])
          - U11*(I1[284] - I2[322])
          - U12*(I1[294] - I2[323])
          + (twozboz)*(I3[319] - AC0*I4[214])
          + (sixzboz)*(I3[232] - AC1*I4[154]);
*(vp++) = U0*I0[215]
          - U10*(I1[215] - I2[320])
          - U11*(I1[285] - I2[323])
          - U12*(I1[295] - I2[324])
          + (twozboz)*(I3[320] - AC0*I4[215])
          + (sixzboz)*(I3[233] - AC1*I4[155]);
*(vp++) = U0*I0[216]
          - U10*(I1[216] - I2[321])
          - U11*(I1[286] - I2[325])
          - U12*(I1[296] - I2[326])
          + (twozboz)*(I3[321] - AC0*I4[216])
          + (sixzboz)*(I3[235] - AC1*I4[156]);
*(vp++) = U0*I0[217]
          - U10*(I1[217] - I2[322])
          - U11*(I1[287] - I2[326])
          - U12*(I1[297] - I2[327])
          + (twozboz)*(I3[322] - AC0*I4[217])
          + (sixzboz)*(I3[236] - AC1*I4[157]);
*(vp++) = U0*I0[218]
          - U10*(I1[218] - I2[323])
          - U11*(I1[288] - I2[327])
          - U12*(I1[298] - I2[328])
          + (twozboz)*(I3[323] - AC0*I4[218])
          + (sixzboz)*(I3[237] - AC1*I4[158]);
*(vp++) = U0*I0[219]
          - U10*(I1[219] - I2[324])
          - U11*(I1[289] - I2[328])
          - U12*(I1[299] - I2[329])
          + (twozboz)*(I3[324] - AC0*I4[219])
          + (sixzboz)*(I3[238] - AC1*I4[159]);
*(vp++) = U0*I0[220]
          - U10*(I1[220] - I2[330])
          - U11*(I1[290] - I2[331])
          - U12*(I1[300] - I2[332])
          + (twozboz)*(I3[330] - AC0*I4[220])
          + (fivezboz)*(I3[241] - AC1*I4[160])
          + (onezboz)*(I3[227] - AC2*I4[150]);
*(vp++) = U0*I0[221]
          - U10*(I1[221] - I2[331])
          - U11*(I1[291] - I2[333])
          - U12*(I1[301] - I2[334])
          + (twozboz)*(I3[331] - AC0*I4[221])
          + (fivezboz)*(I3[243] - AC1*I4[161])
          + (onezboz)*(I3[229] - AC2*I4[151]);
*(vp++) = U0*I0[222]
          - U10*(I1[222] - I2[332])
          - U11*(I1[292] - I2[334])
          - U12*(I1[302] - I2[335])
          + (twozboz)*(I3[332] - AC0*I4[222])
          + (fivezboz)*(I3[244] - AC1*I4[162])
          + (onezboz)*(I3[230] - AC2*I4[152]);
*(vp++) = U0*I0[223]
          - U10*(I1[223] - I2[333])
          - U11*(I1[293] - I2[336])
          - U12*(I1[303] - I2[337])
          + (twozboz)*(I3[333] - AC0*I4[223])
          + (fivezboz)*(I3[246] - AC1*I4[163])
          + (onezboz)*(I3[232] - AC2*I4[153]);
*(vp++) = U0*I0[224]
          - U10*(I1[224] - I2[334])
          - U11*(I1[294] - I2[337])
          - U12*(I1[304] - I2[338])
          + (twozboz)*(I3[334] - AC0*I4[224])
          + (fivezboz)*(I3[247] - AC1*I4[164])
          + (onezboz)*(I3[233] - AC2*I4[154]);
*(vp++) = U0*I0[225]
          - U10*(I1[225] - I2[335])
          - U11*(I1[295] - I2[338])
          - U12*(I1[305] - I2[339])
          + (twozboz)*(I3[335] - AC0*I4[225])
          + (fivezboz)*(I3[248] - AC1*I4[165])
          + (onezboz)*(I3[234] - AC2*I4[155]);
return vp;
}

REALTYPE *_t1_build_l0f0_1(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  REALTYPE fivezboz;
  REALTYPE sixzboz;
  REALTYPE sevenzboz;
  REALTYPE eightzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  fivezboz = 5.0*(Data->twozeta_b*Data->oo2z);
  sixzboz = 6.0*(Data->twozeta_b*Data->oo2z);
  sevenzboz = 7.0*(Data->twozeta_b*Data->oo2z);
  eightzboz = 8.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 9.000000))*Data->oo2z;

*(vp++) = U0*I0[226]
          - U10*(I1[226] - I2[336])
          - U11*(I1[296] - I2[340])
          - U12*(I1[306] - I2[341])
          + (twozboz)*(I3[336] - AC0*I4[226])
          + (fivezboz)*(I3[250] - AC1*I4[166])
          + (onezboz)*(I3[236] - AC2*I4[156]);
*(vp++) = U0*I0[227]
          - U10*(I1[227] - I2[337])
          - U11*(I1[297] - I2[341])
          - U12*(I1[307] - I2[342])
          + (twozboz)*(I3[337] - AC0*I4[227])
          + (fivezboz)*(I3[251] - AC1*I4[167])
          + (onezboz)*(I3[237] - AC2*I4[157]);
*(vp++) = U0*I0[228]
          - U10*(I1[228] - I2[338])
          - U11*(I1[298] - I2[342])
          - U12*(I1[308] - I2[343])
          + (twozboz)*(I3[338] - AC0*I4[228])
          + (fivezboz)*(I3[252] - AC1*I4[168])
          + (onezboz)*(I3[238] - AC2*I4[158]);
*(vp++) = U0*I0[229]
          - U10*(I1[229] - I2[339])
          - U11*(I1[299] - I2[343])
          - U12*(I1[309] - I2[344])
          + (twozboz)*(I3[339] - AC0*I4[229])
          + (fivezboz)*(I3[253] - AC1*I4[169])
          + (onezboz)*(I3[239] - AC2*I4[159]);
*(vp++) = U0*I0[230]
          - U10*(I1[230] - I2[345])
          - U11*(I1[300] - I2[346])
          - U12*(I1[310] - I2[347])
          + (twozboz)*(I3[345] - AC0*I4[230])
          + (fourzboz)*(I3[256] - AC1*I4[170])
          + (twozboz)*(I3[242] - AC2*I4[160]);
*(vp++) = U0*I0[231]
          - U10*(I1[231] - I2[346])
          - U11*(I1[301] - I2[348])
          - U12*(I1[311] - I2[349])
          + (twozboz)*(I3[346] - AC0*I4[231])
          + (fourzboz)*(I3[258] - AC1*I4[171])
          + (twozboz)*(I3[244] - AC2*I4[161]);
*(vp++) = U0*I0[232]
          - U10*(I1[232] - I2[347])
          - U11*(I1[302] - I2[349])
          - U12*(I1[312] - I2[350])
          + (twozboz)*(I3[347] - AC0*I4[232])
          + (fourzboz)*(I3[259] - AC1*I4[172])
          + (twozboz)*(I3[245] - AC2*I4[162]);
*(vp++) = U0*I0[233]
          - U10*(I1[233] - I2[348])
          - U11*(I1[303] - I2[351])
          - U12*(I1[313] - I2[352])
          + (twozboz)*(I3[348] - AC0*I4[233])
          + (fourzboz)*(I3[261] - AC1*I4[173])
          + (twozboz)*(I3[247] - AC2*I4[163]);
*(vp++) = U0*I0[234]
          - U10*(I1[234] - I2[349])
          - U11*(I1[304] - I2[352])
          - U12*(I1[314] - I2[353])
          + (twozboz)*(I3[349] - AC0*I4[234])
          + (fourzboz)*(I3[262] - AC1*I4[174])
          + (twozboz)*(I3[248] - AC2*I4[164]);
*(vp++) = U0*I0[235]
          - U10*(I1[235] - I2[350])
          - U11*(I1[305] - I2[353])
          - U12*(I1[315] - I2[354])
          + (twozboz)*(I3[350] - AC0*I4[235])
          + (fourzboz)*(I3[263] - AC1*I4[175])
          + (twozboz)*(I3[249] - AC2*I4[165]);
*(vp++) = U0*I0[236]
          - U10*(I1[236] - I2[351])
          - U11*(I1[306] - I2[355])
          - U12*(I1[316] - I2[356])
          + (twozboz)*(I3[351] - AC0*I4[236])
          + (fourzboz)*(I3[265] - AC1*I4[176])
          + (twozboz)*(I3[251] - AC2*I4[166]);
*(vp++) = U0*I0[237]
          - U10*(I1[237] - I2[352])
          - U11*(I1[307] - I2[356])
          - U12*(I1[317] - I2[357])
          + (twozboz)*(I3[352] - AC0*I4[237])
          + (fourzboz)*(I3[266] - AC1*I4[177])
          + (twozboz)*(I3[252] - AC2*I4[167]);
*(vp++) = U0*I0[238]
          - U10*(I1[238] - I2[353])
          - U11*(I1[308] - I2[357])
          - U12*(I1[318] - I2[358])
          + (twozboz)*(I3[353] - AC0*I4[238])
          + (fourzboz)*(I3[267] - AC1*I4[178])
          + (twozboz)*(I3[253] - AC2*I4[168]);
*(vp++) = U0*I0[239]
          - U10*(I1[239] - I2[354])
          - U11*(I1[309] - I2[358])
          - U12*(I1[319] - I2[359])
          + (twozboz)*(I3[354] - AC0*I4[239])
          + (fourzboz)*(I3[268] - AC1*I4[179])
          + (twozboz)*(I3[254] - AC2*I4[169]);
*(vp++) = U0*I0[240]
          - U10*(I1[240] - I2[360])
          - U11*(I1[310] - I2[361])
          - U12*(I1[320] - I2[362])
          + (twozboz)*(I3[360] - AC0*I4[240])
          + (threezboz)*(I3[271] - AC1*I4[180])
          + (threezboz)*(I3[257] - AC2*I4[170]);
*(vp++) = U0*I0[241]
          - U10*(I1[241] - I2[361])
          - U11*(I1[311] - I2[363])
          - U12*(I1[321] - I2[364])
          + (twozboz)*(I3[361] - AC0*I4[241])
          + (threezboz)*(I3[273] - AC1*I4[181])
          + (threezboz)*(I3[259] - AC2*I4[171]);
*(vp++) = U0*I0[242]
          - U10*(I1[242] - I2[362])
          - U11*(I1[312] - I2[364])
          - U12*(I1[322] - I2[365])
          + (twozboz)*(I3[362] - AC0*I4[242])
          + (threezboz)*(I3[274] - AC1*I4[182])
          + (threezboz)*(I3[260] - AC2*I4[172]);
*(vp++) = U0*I0[243]
          - U10*(I1[243] - I2[363])
          - U11*(I1[313] - I2[366])
          - U12*(I1[323] - I2[367])
          + (twozboz)*(I3[363] - AC0*I4[243])
          + (threezboz)*(I3[276] - AC1*I4[183])
          + (threezboz)*(I3[262] - AC2*I4[173]);
*(vp++) = U0*I0[244]
          - U10*(I1[244] - I2[364])
          - U11*(I1[314] - I2[367])
          - U12*(I1[324] - I2[368])
          + (twozboz)*(I3[364] - AC0*I4[244])
          + (threezboz)*(I3[277] - AC1*I4[184])
          + (threezboz)*(I3[263] - AC2*I4[174]);
*(vp++) = U0*I0[245]
          - U10*(I1[245] - I2[365])
          - U11*(I1[315] - I2[368])
          - U12*(I1[325] - I2[369])
          + (twozboz)*(I3[365] - AC0*I4[245])
          + (threezboz)*(I3[278] - AC1*I4[185])
          + (threezboz)*(I3[264] - AC2*I4[175]);
*(vp++) = U0*I0[246]
          - U10*(I1[246] - I2[366])
          - U11*(I1[316] - I2[370])
          - U12*(I1[326] - I2[371])
          + (twozboz)*(I3[366] - AC0*I4[246])
          + (threezboz)*(I3[280] - AC1*I4[186])
          + (threezboz)*(I3[266] - AC2*I4[176]);
*(vp++) = U0*I0[247]
          - U10*(I1[247] - I2[367])
          - U11*(I1[317] - I2[371])
          - U12*(I1[327] - I2[372])
          + (twozboz)*(I3[367] - AC0*I4[247])
          + (threezboz)*(I3[281] - AC1*I4[187])
          + (threezboz)*(I3[267] - AC2*I4[177]);
*(vp++) = U0*I0[248]
          - U10*(I1[248] - I2[368])
          - U11*(I1[318] - I2[372])
          - U12*(I1[328] - I2[373])
          + (twozboz)*(I3[368] - AC0*I4[248])
          + (threezboz)*(I3[282] - AC1*I4[188])
          + (threezboz)*(I3[268] - AC2*I4[178]);
*(vp++) = U0*I0[249]
          - U10*(I1[249] - I2[369])
          - U11*(I1[319] - I2[373])
          - U12*(I1[329] - I2[374])
          + (twozboz)*(I3[369] - AC0*I4[249])
          + (threezboz)*(I3[283] - AC1*I4[189])
          + (threezboz)*(I3[269] - AC2*I4[179]);
*(vp++) = U0*I0[250]
          - U10*(I1[250] - I2[375])
          - U11*(I1[320] - I2[376])
          - U12*(I1[330] - I2[377])
          + (twozboz)*(I3[375] - AC0*I4[250])
          + (twozboz)*(I3[286] - AC1*I4[190])
          + (fourzboz)*(I3[272] - AC2*I4[180]);
*(vp++) = U0*I0[251]
          - U10*(I1[251] - I2[376])
          - U11*(I1[321] - I2[378])
          - U12*(I1[331] - I2[379])
          + (twozboz)*(I3[376] - AC0*I4[251])
          + (twozboz)*(I3[288] - AC1*I4[191])
          + (fourzboz)*(I3[274] - AC2*I4[181]);
*(vp++) = U0*I0[252]
          - U10*(I1[252] - I2[377])
          - U11*(I1[322] - I2[379])
          - U12*(I1[332] - I2[380])
          + (twozboz)*(I3[377] - AC0*I4[252])
          + (twozboz)*(I3[289] - AC1*I4[192])
          + (fourzboz)*(I3[275] - AC2*I4[182]);
*(vp++) = U0*I0[253]
          - U10*(I1[253] - I2[378])
          - U11*(I1[323] - I2[381])
          - U12*(I1[333] - I2[382])
          + (twozboz)*(I3[378] - AC0*I4[253])
          + (twozboz)*(I3[291] - AC1*I4[193])
          + (fourzboz)*(I3[277] - AC2*I4[183]);
*(vp++) = U0*I0[254]
          - U10*(I1[254] - I2[379])
          - U11*(I1[324] - I2[382])
          - U12*(I1[334] - I2[383])
          + (twozboz)*(I3[379] - AC0*I4[254])
          + (twozboz)*(I3[292] - AC1*I4[194])
          + (fourzboz)*(I3[278] - AC2*I4[184]);
*(vp++) = U0*I0[255]
          - U10*(I1[255] - I2[380])
          - U11*(I1[325] - I2[383])
          - U12*(I1[335] - I2[384])
          + (twozboz)*(I3[380] - AC0*I4[255])
          + (twozboz)*(I3[293] - AC1*I4[195])
          + (fourzboz)*(I3[279] - AC2*I4[185]);
*(vp++) = U0*I0[256]
          - U10*(I1[256] - I2[381])
          - U11*(I1[326] - I2[385])
          - U12*(I1[336] - I2[386])
          + (twozboz)*(I3[381] - AC0*I4[256])
          + (twozboz)*(I3[295] - AC1*I4[196])
          + (fourzboz)*(I3[281] - AC2*I4[186]);
*(vp++) = U0*I0[257]
          - U10*(I1[257] - I2[382])
          - U11*(I1[327] - I2[386])
          - U12*(I1[337] - I2[387])
          + (twozboz)*(I3[382] - AC0*I4[257])
          + (twozboz)*(I3[296] - AC1*I4[197])
          + (fourzboz)*(I3[282] - AC2*I4[187]);
*(vp++) = U0*I0[258]
          - U10*(I1[258] - I2[383])
          - U11*(I1[328] - I2[387])
          - U12*(I1[338] - I2[388])
          + (twozboz)*(I3[383] - AC0*I4[258])
          + (twozboz)*(I3[297] - AC1*I4[198])
          + (fourzboz)*(I3[283] - AC2*I4[188]);
*(vp++) = U0*I0[259]
          - U10*(I1[259] - I2[384])
          - U11*(I1[329] - I2[388])
          - U12*(I1[339] - I2[389])
          + (twozboz)*(I3[384] - AC0*I4[259])
          + (twozboz)*(I3[298] - AC1*I4[199])
          + (fourzboz)*(I3[284] - AC2*I4[189]);
*(vp++) = U0*I0[260]
          - U10*(I1[260] - I2[390])
          - U11*(I1[330] - I2[391])
          - U12*(I1[340] - I2[392])
          + (twozboz)*(I3[390] - AC0*I4[260])
          + (onezboz)*(I3[301] - AC1*I4[200])
          + (fivezboz)*(I3[287] - AC2*I4[190]);
*(vp++) = U0*I0[261]
          - U10*(I1[261] - I2[391])
          - U11*(I1[331] - I2[393])
          - U12*(I1[341] - I2[394])
          + (twozboz)*(I3[391] - AC0*I4[261])
          + (onezboz)*(I3[303] - AC1*I4[201])
          + (fivezboz)*(I3[289] - AC2*I4[191]);
*(vp++) = U0*I0[262]
          - U10*(I1[262] - I2[392])
          - U11*(I1[332] - I2[394])
          - U12*(I1[342] - I2[395])
          + (twozboz)*(I3[392] - AC0*I4[262])
          + (onezboz)*(I3[304] - AC1*I4[202])
          + (fivezboz)*(I3[290] - AC2*I4[192]);
*(vp++) = U0*I0[263]
          - U10*(I1[263] - I2[393])
          - U11*(I1[333] - I2[396])
          - U12*(I1[343] - I2[397])
          + (twozboz)*(I3[393] - AC0*I4[263])
          + (onezboz)*(I3[306] - AC1*I4[203])
          + (fivezboz)*(I3[292] - AC2*I4[193]);
*(vp++) = U0*I0[264]
          - U10*(I1[264] - I2[394])
          - U11*(I1[334] - I2[397])
          - U12*(I1[344] - I2[398])
          + (twozboz)*(I3[394] - AC0*I4[264])
          + (onezboz)*(I3[307] - AC1*I4[204])
          + (fivezboz)*(I3[293] - AC2*I4[194]);
*(vp++) = U0*I0[265]
          - U10*(I1[265] - I2[395])
          - U11*(I1[335] - I2[398])
          - U12*(I1[345] - I2[399])
          + (twozboz)*(I3[395] - AC0*I4[265])
          + (onezboz)*(I3[308] - AC1*I4[205])
          + (fivezboz)*(I3[294] - AC2*I4[195]);
*(vp++) = U0*I0[266]
          - U10*(I1[266] - I2[396])
          - U11*(I1[336] - I2[400])
          - U12*(I1[346] - I2[401])
          + (twozboz)*(I3[396] - AC0*I4[266])
          + (onezboz)*(I3[310] - AC1*I4[206])
          + (fivezboz)*(I3[296] - AC2*I4[196]);
*(vp++) = U0*I0[267]
          - U10*(I1[267] - I2[397])
          - U11*(I1[337] - I2[401])
          - U12*(I1[347] - I2[402])
          + (twozboz)*(I3[397] - AC0*I4[267])
          + (onezboz)*(I3[311] - AC1*I4[207])
          + (fivezboz)*(I3[297] - AC2*I4[197]);
*(vp++) = U0*I0[268]
          - U10*(I1[268] - I2[398])
          - U11*(I1[338] - I2[402])
          - U12*(I1[348] - I2[403])
          + (twozboz)*(I3[398] - AC0*I4[268])
          + (onezboz)*(I3[312] - AC1*I4[208])
          + (fivezboz)*(I3[298] - AC2*I4[198]);
*(vp++) = U0*I0[269]
          - U10*(I1[269] - I2[399])
          - U11*(I1[339] - I2[403])
          - U12*(I1[349] - I2[404])
          + (twozboz)*(I3[399] - AC0*I4[269])
          + (onezboz)*(I3[313] - AC1*I4[209])
          + (fivezboz)*(I3[299] - AC2*I4[199]);
*(vp++) = U0*I0[270]
          - U10*(I1[270] - I2[405])
          - U11*(I1[340] - I2[406])
          - U12*(I1[350] - I2[407])
          + (twozboz)*(I3[405] - AC0*I4[270])
          + (sixzboz)*(I3[302] - AC2*I4[200]);
*(vp++) = U0*I0[271]
          - U10*(I1[271] - I2[406])
          - U11*(I1[341] - I2[408])
          - U12*(I1[351] - I2[409])
          + (twozboz)*(I3[406] - AC0*I4[271])
          + (sixzboz)*(I3[304] - AC2*I4[201]);
*(vp++) = U0*I0[272]
          - U10*(I1[272] - I2[407])
          - U11*(I1[342] - I2[409])
          - U12*(I1[352] - I2[410])
          + (twozboz)*(I3[407] - AC0*I4[272])
          + (sixzboz)*(I3[305] - AC2*I4[202]);
*(vp++) = U0*I0[273]
          - U10*(I1[273] - I2[408])
          - U11*(I1[343] - I2[411])
          - U12*(I1[353] - I2[412])
          + (twozboz)*(I3[408] - AC0*I4[273])
          + (sixzboz)*(I3[307] - AC2*I4[203]);
*(vp++) = U0*I0[274]
          - U10*(I1[274] - I2[409])
          - U11*(I1[344] - I2[412])
          - U12*(I1[354] - I2[413])
          + (twozboz)*(I3[409] - AC0*I4[274])
          + (sixzboz)*(I3[308] - AC2*I4[204]);
*(vp++) = U0*I0[275]
          - U10*(I1[275] - I2[410])
          - U11*(I1[345] - I2[413])
          - U12*(I1[355] - I2[414])
          + (twozboz)*(I3[410] - AC0*I4[275])
          + (sixzboz)*(I3[309] - AC2*I4[205]);
*(vp++) = U0*I0[276]
          - U10*(I1[276] - I2[411])
          - U11*(I1[346] - I2[415])
          - U12*(I1[356] - I2[416])
          + (twozboz)*(I3[411] - AC0*I4[276])
          + (sixzboz)*(I3[311] - AC2*I4[206]);
*(vp++) = U0*I0[277]
          - U10*(I1[277] - I2[412])
          - U11*(I1[347] - I2[416])
          - U12*(I1[357] - I2[417])
          + (twozboz)*(I3[412] - AC0*I4[277])
          + (sixzboz)*(I3[312] - AC2*I4[207]);
*(vp++) = U0*I0[278]
          - U10*(I1[278] - I2[413])
          - U11*(I1[348] - I2[417])
          - U12*(I1[358] - I2[418])
          + (twozboz)*(I3[413] - AC0*I4[278])
          + (sixzboz)*(I3[313] - AC2*I4[208]);
*(vp++) = U0*I0[279]
          - U10*(I1[279] - I2[414])
          - U11*(I1[349] - I2[418])
          - U12*(I1[359] - I2[419])
          + (twozboz)*(I3[414] - AC0*I4[279])
          + (sixzboz)*(I3[314] - AC2*I4[209]);
*(vp++) = U0*I0[280]
          - U10*(I1[280] - I2[420])
          - U11*(I1[360] - I2[421])
          - U12*(I1[370] - I2[422])
          + (onezboz)*(I3[420] - AC0*I4[280])
          + (sevenzboz)*(I3[316] - AC1*I4[210]);
*(vp++) = U0*I0[281]
          - U10*(I1[281] - I2[421])
          - U11*(I1[361] - I2[423])
          - U12*(I1[371] - I2[424])
          + (onezboz)*(I3[421] - AC0*I4[281])
          + (sevenzboz)*(I3[318] - AC1*I4[211]);
*(vp++) = U0*I0[282]
          - U10*(I1[282] - I2[422])
          - U11*(I1[362] - I2[424])
          - U12*(I1[372] - I2[425])
          + (onezboz)*(I3[422] - AC0*I4[282])
          + (sevenzboz)*(I3[319] - AC1*I4[212]);
*(vp++) = U0*I0[283]
          - U10*(I1[283] - I2[423])
          - U11*(I1[363] - I2[426])
          - U12*(I1[373] - I2[427])
          + (onezboz)*(I3[423] - AC0*I4[283])
          + (sevenzboz)*(I3[321] - AC1*I4[213]);
*(vp++) = U0*I0[284]
          - U10*(I1[284] - I2[424])
          - U11*(I1[364] - I2[427])
          - U12*(I1[374] - I2[428])
          + (onezboz)*(I3[424] - AC0*I4[284])
          + (sevenzboz)*(I3[322] - AC1*I4[214]);
*(vp++) = U0*I0[285]
          - U10*(I1[285] - I2[425])
          - U11*(I1[365] - I2[428])
          - U12*(I1[375] - I2[429])
          + (onezboz)*(I3[425] - AC0*I4[285])
          + (sevenzboz)*(I3[323] - AC1*I4[215]);
*(vp++) = U0*I0[286]
          - U10*(I1[286] - I2[426])
          - U11*(I1[366] - I2[430])
          - U12*(I1[376] - I2[431])
          + (onezboz)*(I3[426] - AC0*I4[286])
          + (sevenzboz)*(I3[325] - AC1*I4[216]);
*(vp++) = U0*I0[287]
          - U10*(I1[287] - I2[427])
          - U11*(I1[367] - I2[431])
          - U12*(I1[377] - I2[432])
          + (onezboz)*(I3[427] - AC0*I4[287])
          + (sevenzboz)*(I3[326] - AC1*I4[217]);
*(vp++) = U0*I0[288]
          - U10*(I1[288] - I2[428])
          - U11*(I1[368] - I2[432])
          - U12*(I1[378] - I2[433])
          + (onezboz)*(I3[428] - AC0*I4[288])
          + (sevenzboz)*(I3[327] - AC1*I4[218]);
*(vp++) = U0*I0[289]
          - U10*(I1[289] - I2[429])
          - U11*(I1[369] - I2[433])
          - U12*(I1[379] - I2[434])
          + (onezboz)*(I3[429] - AC0*I4[289])
          + (sevenzboz)*(I3[328] - AC1*I4[219]);
*(vp++) = U0*I0[290]
          - U10*(I1[290] - I2[435])
          - U11*(I1[370] - I2[436])
          - U12*(I1[380] - I2[437])
          + (onezboz)*(I3[435] - AC0*I4[290])
          + (sixzboz)*(I3[331] - AC1*I4[220])
          + (onezboz)*(I3[317] - AC2*I4[210]);
*(vp++) = U0*I0[291]
          - U10*(I1[291] - I2[436])
          - U11*(I1[371] - I2[438])
          - U12*(I1[381] - I2[439])
          + (onezboz)*(I3[436] - AC0*I4[291])
          + (sixzboz)*(I3[333] - AC1*I4[221])
          + (onezboz)*(I3[319] - AC2*I4[211]);
*(vp++) = U0*I0[292]
          - U10*(I1[292] - I2[437])
          - U11*(I1[372] - I2[439])
          - U12*(I1[382] - I2[440])
          + (onezboz)*(I3[437] - AC0*I4[292])
          + (sixzboz)*(I3[334] - AC1*I4[222])
          + (onezboz)*(I3[320] - AC2*I4[212]);
*(vp++) = U0*I0[293]
          - U10*(I1[293] - I2[438])
          - U11*(I1[373] - I2[441])
          - U12*(I1[383] - I2[442])
          + (onezboz)*(I3[438] - AC0*I4[293])
          + (sixzboz)*(I3[336] - AC1*I4[223])
          + (onezboz)*(I3[322] - AC2*I4[213]);
*(vp++) = U0*I0[294]
          - U10*(I1[294] - I2[439])
          - U11*(I1[374] - I2[442])
          - U12*(I1[384] - I2[443])
          + (onezboz)*(I3[439] - AC0*I4[294])
          + (sixzboz)*(I3[337] - AC1*I4[224])
          + (onezboz)*(I3[323] - AC2*I4[214]);
*(vp++) = U0*I0[295]
          - U10*(I1[295] - I2[440])
          - U11*(I1[375] - I2[443])
          - U12*(I1[385] - I2[444])
          + (onezboz)*(I3[440] - AC0*I4[295])
          + (sixzboz)*(I3[338] - AC1*I4[225])
          + (onezboz)*(I3[324] - AC2*I4[215]);
*(vp++) = U0*I0[296]
          - U10*(I1[296] - I2[441])
          - U11*(I1[376] - I2[445])
          - U12*(I1[386] - I2[446])
          + (onezboz)*(I3[441] - AC0*I4[296])
          + (sixzboz)*(I3[340] - AC1*I4[226])
          + (onezboz)*(I3[326] - AC2*I4[216]);
*(vp++) = U0*I0[297]
          - U10*(I1[297] - I2[442])
          - U11*(I1[377] - I2[446])
          - U12*(I1[387] - I2[447])
          + (onezboz)*(I3[442] - AC0*I4[297])
          + (sixzboz)*(I3[341] - AC1*I4[227])
          + (onezboz)*(I3[327] - AC2*I4[217]);
*(vp++) = U0*I0[298]
          - U10*(I1[298] - I2[443])
          - U11*(I1[378] - I2[447])
          - U12*(I1[388] - I2[448])
          + (onezboz)*(I3[443] - AC0*I4[298])
          + (sixzboz)*(I3[342] - AC1*I4[228])
          + (onezboz)*(I3[328] - AC2*I4[218]);
*(vp++) = U0*I0[299]
          - U10*(I1[299] - I2[444])
          - U11*(I1[379] - I2[448])
          - U12*(I1[389] - I2[449])
          + (onezboz)*(I3[444] - AC0*I4[299])
          + (sixzboz)*(I3[343] - AC1*I4[229])
          + (onezboz)*(I3[329] - AC2*I4[219]);
*(vp++) = U0*I0[300]
          - U10*(I1[300] - I2[450])
          - U11*(I1[380] - I2[451])
          - U12*(I1[390] - I2[452])
          + (onezboz)*(I3[450] - AC0*I4[300])
          + (fivezboz)*(I3[346] - AC1*I4[230])
          + (twozboz)*(I3[332] - AC2*I4[220]);
*(vp++) = U0*I0[301]
          - U10*(I1[301] - I2[451])
          - U11*(I1[381] - I2[453])
          - U12*(I1[391] - I2[454])
          + (onezboz)*(I3[451] - AC0*I4[301])
          + (fivezboz)*(I3[348] - AC1*I4[231])
          + (twozboz)*(I3[334] - AC2*I4[221]);
*(vp++) = U0*I0[302]
          - U10*(I1[302] - I2[452])
          - U11*(I1[382] - I2[454])
          - U12*(I1[392] - I2[455])
          + (onezboz)*(I3[452] - AC0*I4[302])
          + (fivezboz)*(I3[349] - AC1*I4[232])
          + (twozboz)*(I3[335] - AC2*I4[222]);
*(vp++) = U0*I0[303]
          - U10*(I1[303] - I2[453])
          - U11*(I1[383] - I2[456])
          - U12*(I1[393] - I2[457])
          + (onezboz)*(I3[453] - AC0*I4[303])
          + (fivezboz)*(I3[351] - AC1*I4[233])
          + (twozboz)*(I3[337] - AC2*I4[223]);
*(vp++) = U0*I0[304]
          - U10*(I1[304] - I2[454])
          - U11*(I1[384] - I2[457])
          - U12*(I1[394] - I2[458])
          + (onezboz)*(I3[454] - AC0*I4[304])
          + (fivezboz)*(I3[352] - AC1*I4[234])
          + (twozboz)*(I3[338] - AC2*I4[224]);
*(vp++) = U0*I0[305]
          - U10*(I1[305] - I2[455])
          - U11*(I1[385] - I2[458])
          - U12*(I1[395] - I2[459])
          + (onezboz)*(I3[455] - AC0*I4[305])
          + (fivezboz)*(I3[353] - AC1*I4[235])
          + (twozboz)*(I3[339] - AC2*I4[225]);
*(vp++) = U0*I0[306]
          - U10*(I1[306] - I2[456])
          - U11*(I1[386] - I2[460])
          - U12*(I1[396] - I2[461])
          + (onezboz)*(I3[456] - AC0*I4[306])
          + (fivezboz)*(I3[355] - AC1*I4[236])
          + (twozboz)*(I3[341] - AC2*I4[226]);
*(vp++) = U0*I0[307]
          - U10*(I1[307] - I2[457])
          - U11*(I1[387] - I2[461])
          - U12*(I1[397] - I2[462])
          + (onezboz)*(I3[457] - AC0*I4[307])
          + (fivezboz)*(I3[356] - AC1*I4[237])
          + (twozboz)*(I3[342] - AC2*I4[227]);
*(vp++) = U0*I0[308]
          - U10*(I1[308] - I2[458])
          - U11*(I1[388] - I2[462])
          - U12*(I1[398] - I2[463])
          + (onezboz)*(I3[458] - AC0*I4[308])
          + (fivezboz)*(I3[357] - AC1*I4[238])
          + (twozboz)*(I3[343] - AC2*I4[228]);
*(vp++) = U0*I0[309]
          - U10*(I1[309] - I2[459])
          - U11*(I1[389] - I2[463])
          - U12*(I1[399] - I2[464])
          + (onezboz)*(I3[459] - AC0*I4[309])
          + (fivezboz)*(I3[358] - AC1*I4[239])
          + (twozboz)*(I3[344] - AC2*I4[229]);
*(vp++) = U0*I0[310]
          - U10*(I1[310] - I2[465])
          - U11*(I1[390] - I2[466])
          - U12*(I1[400] - I2[467])
          + (onezboz)*(I3[465] - AC0*I4[310])
          + (fourzboz)*(I3[361] - AC1*I4[240])
          + (threezboz)*(I3[347] - AC2*I4[230]);
*(vp++) = U0*I0[311]
          - U10*(I1[311] - I2[466])
          - U11*(I1[391] - I2[468])
          - U12*(I1[401] - I2[469])
          + (onezboz)*(I3[466] - AC0*I4[311])
          + (fourzboz)*(I3[363] - AC1*I4[241])
          + (threezboz)*(I3[349] - AC2*I4[231]);
*(vp++) = U0*I0[312]
          - U10*(I1[312] - I2[467])
          - U11*(I1[392] - I2[469])
          - U12*(I1[402] - I2[470])
          + (onezboz)*(I3[467] - AC0*I4[312])
          + (fourzboz)*(I3[364] - AC1*I4[242])
          + (threezboz)*(I3[350] - AC2*I4[232]);
*(vp++) = U0*I0[313]
          - U10*(I1[313] - I2[468])
          - U11*(I1[393] - I2[471])
          - U12*(I1[403] - I2[472])
          + (onezboz)*(I3[468] - AC0*I4[313])
          + (fourzboz)*(I3[366] - AC1*I4[243])
          + (threezboz)*(I3[352] - AC2*I4[233]);
*(vp++) = U0*I0[314]
          - U10*(I1[314] - I2[469])
          - U11*(I1[394] - I2[472])
          - U12*(I1[404] - I2[473])
          + (onezboz)*(I3[469] - AC0*I4[314])
          + (fourzboz)*(I3[367] - AC1*I4[244])
          + (threezboz)*(I3[353] - AC2*I4[234]);
*(vp++) = U0*I0[315]
          - U10*(I1[315] - I2[470])
          - U11*(I1[395] - I2[473])
          - U12*(I1[405] - I2[474])
          + (onezboz)*(I3[470] - AC0*I4[315])
          + (fourzboz)*(I3[368] - AC1*I4[245])
          + (threezboz)*(I3[354] - AC2*I4[235]);
*(vp++) = U0*I0[316]
          - U10*(I1[316] - I2[471])
          - U11*(I1[396] - I2[475])
          - U12*(I1[406] - I2[476])
          + (onezboz)*(I3[471] - AC0*I4[316])
          + (fourzboz)*(I3[370] - AC1*I4[246])
          + (threezboz)*(I3[356] - AC2*I4[236]);
*(vp++) = U0*I0[317]
          - U10*(I1[317] - I2[472])
          - U11*(I1[397] - I2[476])
          - U12*(I1[407] - I2[477])
          + (onezboz)*(I3[472] - AC0*I4[317])
          + (fourzboz)*(I3[371] - AC1*I4[247])
          + (threezboz)*(I3[357] - AC2*I4[237]);
*(vp++) = U0*I0[318]
          - U10*(I1[318] - I2[473])
          - U11*(I1[398] - I2[477])
          - U12*(I1[408] - I2[478])
          + (onezboz)*(I3[473] - AC0*I4[318])
          + (fourzboz)*(I3[372] - AC1*I4[248])
          + (threezboz)*(I3[358] - AC2*I4[238]);
*(vp++) = U0*I0[319]
          - U10*(I1[319] - I2[474])
          - U11*(I1[399] - I2[478])
          - U12*(I1[409] - I2[479])
          + (onezboz)*(I3[474] - AC0*I4[319])
          + (fourzboz)*(I3[373] - AC1*I4[249])
          + (threezboz)*(I3[359] - AC2*I4[239]);
*(vp++) = U0*I0[320]
          - U10*(I1[320] - I2[480])
          - U11*(I1[400] - I2[481])
          - U12*(I1[410] - I2[482])
          + (onezboz)*(I3[480] - AC0*I4[320])
          + (threezboz)*(I3[376] - AC1*I4[250])
          + (fourzboz)*(I3[362] - AC2*I4[240]);
*(vp++) = U0*I0[321]
          - U10*(I1[321] - I2[481])
          - U11*(I1[401] - I2[483])
          - U12*(I1[411] - I2[484])
          + (onezboz)*(I3[481] - AC0*I4[321])
          + (threezboz)*(I3[378] - AC1*I4[251])
          + (fourzboz)*(I3[364] - AC2*I4[241]);
*(vp++) = U0*I0[322]
          - U10*(I1[322] - I2[482])
          - U11*(I1[402] - I2[484])
          - U12*(I1[412] - I2[485])
          + (onezboz)*(I3[482] - AC0*I4[322])
          + (threezboz)*(I3[379] - AC1*I4[252])
          + (fourzboz)*(I3[365] - AC2*I4[242]);
*(vp++) = U0*I0[323]
          - U10*(I1[323] - I2[483])
          - U11*(I1[403] - I2[486])
          - U12*(I1[413] - I2[487])
          + (onezboz)*(I3[483] - AC0*I4[323])
          + (threezboz)*(I3[381] - AC1*I4[253])
          + (fourzboz)*(I3[367] - AC2*I4[243]);
*(vp++) = U0*I0[324]
          - U10*(I1[324] - I2[484])
          - U11*(I1[404] - I2[487])
          - U12*(I1[414] - I2[488])
          + (onezboz)*(I3[484] - AC0*I4[324])
          + (threezboz)*(I3[382] - AC1*I4[254])
          + (fourzboz)*(I3[368] - AC2*I4[244]);
*(vp++) = U0*I0[325]
          - U10*(I1[325] - I2[485])
          - U11*(I1[405] - I2[488])
          - U12*(I1[415] - I2[489])
          + (onezboz)*(I3[485] - AC0*I4[325])
          + (threezboz)*(I3[383] - AC1*I4[255])
          + (fourzboz)*(I3[369] - AC2*I4[245]);
*(vp++) = U0*I0[326]
          - U10*(I1[326] - I2[486])
          - U11*(I1[406] - I2[490])
          - U12*(I1[416] - I2[491])
          + (onezboz)*(I3[486] - AC0*I4[326])
          + (threezboz)*(I3[385] - AC1*I4[256])
          + (fourzboz)*(I3[371] - AC2*I4[246]);
*(vp++) = U0*I0[327]
          - U10*(I1[327] - I2[487])
          - U11*(I1[407] - I2[491])
          - U12*(I1[417] - I2[492])
          + (onezboz)*(I3[487] - AC0*I4[327])
          + (threezboz)*(I3[386] - AC1*I4[257])
          + (fourzboz)*(I3[372] - AC2*I4[247]);
*(vp++) = U0*I0[328]
          - U10*(I1[328] - I2[488])
          - U11*(I1[408] - I2[492])
          - U12*(I1[418] - I2[493])
          + (onezboz)*(I3[488] - AC0*I4[328])
          + (threezboz)*(I3[387] - AC1*I4[258])
          + (fourzboz)*(I3[373] - AC2*I4[248]);
*(vp++) = U0*I0[329]
          - U10*(I1[329] - I2[489])
          - U11*(I1[409] - I2[493])
          - U12*(I1[419] - I2[494])
          + (onezboz)*(I3[489] - AC0*I4[329])
          + (threezboz)*(I3[388] - AC1*I4[259])
          + (fourzboz)*(I3[374] - AC2*I4[249]);
*(vp++) = U0*I0[330]
          - U10*(I1[330] - I2[495])
          - U11*(I1[410] - I2[496])
          - U12*(I1[420] - I2[497])
          + (onezboz)*(I3[495] - AC0*I4[330])
          + (twozboz)*(I3[391] - AC1*I4[260])
          + (fivezboz)*(I3[377] - AC2*I4[250]);
*(vp++) = U0*I0[331]
          - U10*(I1[331] - I2[496])
          - U11*(I1[411] - I2[498])
          - U12*(I1[421] - I2[499])
          + (onezboz)*(I3[496] - AC0*I4[331])
          + (twozboz)*(I3[393] - AC1*I4[261])
          + (fivezboz)*(I3[379] - AC2*I4[251]);
*(vp++) = U0*I0[332]
          - U10*(I1[332] - I2[497])
          - U11*(I1[412] - I2[499])
          - U12*(I1[422] - I2[500])
          + (onezboz)*(I3[497] - AC0*I4[332])
          + (twozboz)*(I3[394] - AC1*I4[262])
          + (fivezboz)*(I3[380] - AC2*I4[252]);
*(vp++) = U0*I0[333]
          - U10*(I1[333] - I2[498])
          - U11*(I1[413] - I2[501])
          - U12*(I1[423] - I2[502])
          + (onezboz)*(I3[498] - AC0*I4[333])
          + (twozboz)*(I3[396] - AC1*I4[263])
          + (fivezboz)*(I3[382] - AC2*I4[253]);
*(vp++) = U0*I0[334]
          - U10*(I1[334] - I2[499])
          - U11*(I1[414] - I2[502])
          - U12*(I1[424] - I2[503])
          + (onezboz)*(I3[499] - AC0*I4[334])
          + (twozboz)*(I3[397] - AC1*I4[264])
          + (fivezboz)*(I3[383] - AC2*I4[254]);
*(vp++) = U0*I0[335]
          - U10*(I1[335] - I2[500])
          - U11*(I1[415] - I2[503])
          - U12*(I1[425] - I2[504])
          + (onezboz)*(I3[500] - AC0*I4[335])
          + (twozboz)*(I3[398] - AC1*I4[265])
          + (fivezboz)*(I3[384] - AC2*I4[255]);
*(vp++) = U0*I0[336]
          - U10*(I1[336] - I2[501])
          - U11*(I1[416] - I2[505])
          - U12*(I1[426] - I2[506])
          + (onezboz)*(I3[501] - AC0*I4[336])
          + (twozboz)*(I3[400] - AC1*I4[266])
          + (fivezboz)*(I3[386] - AC2*I4[256]);
*(vp++) = U0*I0[337]
          - U10*(I1[337] - I2[502])
          - U11*(I1[417] - I2[506])
          - U12*(I1[427] - I2[507])
          + (onezboz)*(I3[502] - AC0*I4[337])
          + (twozboz)*(I3[401] - AC1*I4[267])
          + (fivezboz)*(I3[387] - AC2*I4[257]);
*(vp++) = U0*I0[338]
          - U10*(I1[338] - I2[503])
          - U11*(I1[418] - I2[507])
          - U12*(I1[428] - I2[508])
          + (onezboz)*(I3[503] - AC0*I4[338])
          + (twozboz)*(I3[402] - AC1*I4[268])
          + (fivezboz)*(I3[388] - AC2*I4[258]);
*(vp++) = U0*I0[339]
          - U10*(I1[339] - I2[504])
          - U11*(I1[419] - I2[508])
          - U12*(I1[429] - I2[509])
          + (onezboz)*(I3[504] - AC0*I4[339])
          + (twozboz)*(I3[403] - AC1*I4[269])
          + (fivezboz)*(I3[389] - AC2*I4[259]);
*(vp++) = U0*I0[340]
          - U10*(I1[340] - I2[510])
          - U11*(I1[420] - I2[511])
          - U12*(I1[430] - I2[512])
          + (onezboz)*(I3[510] - AC0*I4[340])
          + (onezboz)*(I3[406] - AC1*I4[270])
          + (sixzboz)*(I3[392] - AC2*I4[260]);
*(vp++) = U0*I0[341]
          - U10*(I1[341] - I2[511])
          - U11*(I1[421] - I2[513])
          - U12*(I1[431] - I2[514])
          + (onezboz)*(I3[511] - AC0*I4[341])
          + (onezboz)*(I3[408] - AC1*I4[271])
          + (sixzboz)*(I3[394] - AC2*I4[261]);
*(vp++) = U0*I0[342]
          - U10*(I1[342] - I2[512])
          - U11*(I1[422] - I2[514])
          - U12*(I1[432] - I2[515])
          + (onezboz)*(I3[512] - AC0*I4[342])
          + (onezboz)*(I3[409] - AC1*I4[272])
          + (sixzboz)*(I3[395] - AC2*I4[262]);
*(vp++) = U0*I0[343]
          - U10*(I1[343] - I2[513])
          - U11*(I1[423] - I2[516])
          - U12*(I1[433] - I2[517])
          + (onezboz)*(I3[513] - AC0*I4[343])
          + (onezboz)*(I3[411] - AC1*I4[273])
          + (sixzboz)*(I3[397] - AC2*I4[263]);
*(vp++) = U0*I0[344]
          - U10*(I1[344] - I2[514])
          - U11*(I1[424] - I2[517])
          - U12*(I1[434] - I2[518])
          + (onezboz)*(I3[514] - AC0*I4[344])
          + (onezboz)*(I3[412] - AC1*I4[274])
          + (sixzboz)*(I3[398] - AC2*I4[264]);
*(vp++) = U0*I0[345]
          - U10*(I1[345] - I2[515])
          - U11*(I1[425] - I2[518])
          - U12*(I1[435] - I2[519])
          + (onezboz)*(I3[515] - AC0*I4[345])
          + (onezboz)*(I3[413] - AC1*I4[275])
          + (sixzboz)*(I3[399] - AC2*I4[265]);
*(vp++) = U0*I0[346]
          - U10*(I1[346] - I2[516])
          - U11*(I1[426] - I2[520])
          - U12*(I1[436] - I2[521])
          + (onezboz)*(I3[516] - AC0*I4[346])
          + (onezboz)*(I3[415] - AC1*I4[276])
          + (sixzboz)*(I3[401] - AC2*I4[266]);
*(vp++) = U0*I0[347]
          - U10*(I1[347] - I2[517])
          - U11*(I1[427] - I2[521])
          - U12*(I1[437] - I2[522])
          + (onezboz)*(I3[517] - AC0*I4[347])
          + (onezboz)*(I3[416] - AC1*I4[277])
          + (sixzboz)*(I3[402] - AC2*I4[267]);
*(vp++) = U0*I0[348]
          - U10*(I1[348] - I2[518])
          - U11*(I1[428] - I2[522])
          - U12*(I1[438] - I2[523])
          + (onezboz)*(I3[518] - AC0*I4[348])
          + (onezboz)*(I3[417] - AC1*I4[278])
          + (sixzboz)*(I3[403] - AC2*I4[268]);
*(vp++) = U0*I0[349]
          - U10*(I1[349] - I2[519])
          - U11*(I1[429] - I2[523])
          - U12*(I1[439] - I2[524])
          + (onezboz)*(I3[519] - AC0*I4[349])
          + (onezboz)*(I3[418] - AC1*I4[279])
          + (sixzboz)*(I3[404] - AC2*I4[269]);
*(vp++) = U0*I0[350]
          - U10*(I1[350] - I2[525])
          - U11*(I1[430] - I2[526])
          - U12*(I1[440] - I2[527])
          + (onezboz)*(I3[525] - AC0*I4[350])
          + (sevenzboz)*(I3[407] - AC2*I4[270]);
*(vp++) = U0*I0[351]
          - U10*(I1[351] - I2[526])
          - U11*(I1[431] - I2[528])
          - U12*(I1[441] - I2[529])
          + (onezboz)*(I3[526] - AC0*I4[351])
          + (sevenzboz)*(I3[409] - AC2*I4[271]);
*(vp++) = U0*I0[352]
          - U10*(I1[352] - I2[527])
          - U11*(I1[432] - I2[529])
          - U12*(I1[442] - I2[530])
          + (onezboz)*(I3[527] - AC0*I4[352])
          + (sevenzboz)*(I3[410] - AC2*I4[272]);
*(vp++) = U0*I0[353]
          - U10*(I1[353] - I2[528])
          - U11*(I1[433] - I2[531])
          - U12*(I1[443] - I2[532])
          + (onezboz)*(I3[528] - AC0*I4[353])
          + (sevenzboz)*(I3[412] - AC2*I4[273]);
*(vp++) = U0*I0[354]
          - U10*(I1[354] - I2[529])
          - U11*(I1[434] - I2[532])
          - U12*(I1[444] - I2[533])
          + (onezboz)*(I3[529] - AC0*I4[354])
          + (sevenzboz)*(I3[413] - AC2*I4[274]);
*(vp++) = U0*I0[355]
          - U10*(I1[355] - I2[530])
          - U11*(I1[435] - I2[533])
          - U12*(I1[445] - I2[534])
          + (onezboz)*(I3[530] - AC0*I4[355])
          + (sevenzboz)*(I3[414] - AC2*I4[275]);
*(vp++) = U0*I0[356]
          - U10*(I1[356] - I2[531])
          - U11*(I1[436] - I2[535])
          - U12*(I1[446] - I2[536])
          + (onezboz)*(I3[531] - AC0*I4[356])
          + (sevenzboz)*(I3[416] - AC2*I4[276]);
*(vp++) = U0*I0[357]
          - U10*(I1[357] - I2[532])
          - U11*(I1[437] - I2[536])
          - U12*(I1[447] - I2[537])
          + (onezboz)*(I3[532] - AC0*I4[357])
          + (sevenzboz)*(I3[417] - AC2*I4[277]);
*(vp++) = U0*I0[358]
          - U10*(I1[358] - I2[533])
          - U11*(I1[438] - I2[537])
          - U12*(I1[448] - I2[538])
          + (onezboz)*(I3[533] - AC0*I4[358])
          + (sevenzboz)*(I3[418] - AC2*I4[278]);
*(vp++) = U0*I0[359]
          - U10*(I1[359] - I2[534])
          - U11*(I1[439] - I2[538])
          - U12*(I1[449] - I2[539])
          + (onezboz)*(I3[534] - AC0*I4[359])
          + (sevenzboz)*(I3[419] - AC2*I4[279]);
*(vp++) = U0*I0[360]
          - U10*(I1[360] - I2[540])
          - U11*(I1[450] - I2[541])
          - U12*(I1[460] - I2[542])
          + (eightzboz)*(I3[421] - AC1*I4[280]);
*(vp++) = U0*I0[361]
          - U10*(I1[361] - I2[541])
          - U11*(I1[451] - I2[543])
          - U12*(I1[461] - I2[544])
          + (eightzboz)*(I3[423] - AC1*I4[281]);
*(vp++) = U0*I0[362]
          - U10*(I1[362] - I2[542])
          - U11*(I1[452] - I2[544])
          - U12*(I1[462] - I2[545])
          + (eightzboz)*(I3[424] - AC1*I4[282]);
*(vp++) = U0*I0[363]
          - U10*(I1[363] - I2[543])
          - U11*(I1[453] - I2[546])
          - U12*(I1[463] - I2[547])
          + (eightzboz)*(I3[426] - AC1*I4[283]);
*(vp++) = U0*I0[364]
          - U10*(I1[364] - I2[544])
          - U11*(I1[454] - I2[547])
          - U12*(I1[464] - I2[548])
          + (eightzboz)*(I3[427] - AC1*I4[284]);
*(vp++) = U0*I0[365]
          - U10*(I1[365] - I2[545])
          - U11*(I1[455] - I2[548])
          - U12*(I1[465] - I2[549])
          + (eightzboz)*(I3[428] - AC1*I4[285]);
*(vp++) = U0*I0[366]
          - U10*(I1[366] - I2[546])
          - U11*(I1[456] - I2[550])
          - U12*(I1[466] - I2[551])
          + (eightzboz)*(I3[430] - AC1*I4[286]);
*(vp++) = U0*I0[367]
          - U10*(I1[367] - I2[547])
          - U11*(I1[457] - I2[551])
          - U12*(I1[467] - I2[552])
          + (eightzboz)*(I3[431] - AC1*I4[287]);
*(vp++) = U0*I0[368]
          - U10*(I1[368] - I2[548])
          - U11*(I1[458] - I2[552])
          - U12*(I1[468] - I2[553])
          + (eightzboz)*(I3[432] - AC1*I4[288]);
*(vp++) = U0*I0[369]
          - U10*(I1[369] - I2[549])
          - U11*(I1[459] - I2[553])
          - U12*(I1[469] - I2[554])
          + (eightzboz)*(I3[433] - AC1*I4[289]);
*(vp++) = U0*I0[370]
          - U10*(I1[370] - I2[555])
          - U11*(I1[460] - I2[556])
          - U12*(I1[470] - I2[557])
          + (sevenzboz)*(I3[436] - AC1*I4[290])
          + (onezboz)*(I3[422] - AC2*I4[280]);
*(vp++) = U0*I0[371]
          - U10*(I1[371] - I2[556])
          - U11*(I1[461] - I2[558])
          - U12*(I1[471] - I2[559])
          + (sevenzboz)*(I3[438] - AC1*I4[291])
          + (onezboz)*(I3[424] - AC2*I4[281]);
*(vp++) = U0*I0[372]
          - U10*(I1[372] - I2[557])
          - U11*(I1[462] - I2[559])
          - U12*(I1[472] - I2[560])
          + (sevenzboz)*(I3[439] - AC1*I4[292])
          + (onezboz)*(I3[425] - AC2*I4[282]);
*(vp++) = U0*I0[373]
          - U10*(I1[373] - I2[558])
          - U11*(I1[463] - I2[561])
          - U12*(I1[473] - I2[562])
          + (sevenzboz)*(I3[441] - AC1*I4[293])
          + (onezboz)*(I3[427] - AC2*I4[283]);
*(vp++) = U0*I0[374]
          - U10*(I1[374] - I2[559])
          - U11*(I1[464] - I2[562])
          - U12*(I1[474] - I2[563])
          + (sevenzboz)*(I3[442] - AC1*I4[294])
          + (onezboz)*(I3[428] - AC2*I4[284]);
*(vp++) = U0*I0[375]
          - U10*(I1[375] - I2[560])
          - U11*(I1[465] - I2[563])
          - U12*(I1[475] - I2[564])
          + (sevenzboz)*(I3[443] - AC1*I4[295])
          + (onezboz)*(I3[429] - AC2*I4[285]);
*(vp++) = U0*I0[376]
          - U10*(I1[376] - I2[561])
          - U11*(I1[466] - I2[565])
          - U12*(I1[476] - I2[566])
          + (sevenzboz)*(I3[445] - AC1*I4[296])
          + (onezboz)*(I3[431] - AC2*I4[286]);
*(vp++) = U0*I0[377]
          - U10*(I1[377] - I2[562])
          - U11*(I1[467] - I2[566])
          - U12*(I1[477] - I2[567])
          + (sevenzboz)*(I3[446] - AC1*I4[297])
          + (onezboz)*(I3[432] - AC2*I4[287]);
*(vp++) = U0*I0[378]
          - U10*(I1[378] - I2[563])
          - U11*(I1[468] - I2[567])
          - U12*(I1[478] - I2[568])
          + (sevenzboz)*(I3[447] - AC1*I4[298])
          + (onezboz)*(I3[433] - AC2*I4[288]);
*(vp++) = U0*I0[379]
          - U10*(I1[379] - I2[564])
          - U11*(I1[469] - I2[568])
          - U12*(I1[479] - I2[569])
          + (sevenzboz)*(I3[448] - AC1*I4[299])
          + (onezboz)*(I3[434] - AC2*I4[289]);
*(vp++) = U0*I0[380]
          - U10*(I1[380] - I2[570])
          - U11*(I1[470] - I2[571])
          - U12*(I1[480] - I2[572])
          + (sixzboz)*(I3[451] - AC1*I4[300])
          + (twozboz)*(I3[437] - AC2*I4[290]);
*(vp++) = U0*I0[381]
          - U10*(I1[381] - I2[571])
          - U11*(I1[471] - I2[573])
          - U12*(I1[481] - I2[574])
          + (sixzboz)*(I3[453] - AC1*I4[301])
          + (twozboz)*(I3[439] - AC2*I4[291]);
*(vp++) = U0*I0[382]
          - U10*(I1[382] - I2[572])
          - U11*(I1[472] - I2[574])
          - U12*(I1[482] - I2[575])
          + (sixzboz)*(I3[454] - AC1*I4[302])
          + (twozboz)*(I3[440] - AC2*I4[292]);
*(vp++) = U0*I0[383]
          - U10*(I1[383] - I2[573])
          - U11*(I1[473] - I2[576])
          - U12*(I1[483] - I2[577])
          + (sixzboz)*(I3[456] - AC1*I4[303])
          + (twozboz)*(I3[442] - AC2*I4[293]);
*(vp++) = U0*I0[384]
          - U10*(I1[384] - I2[574])
          - U11*(I1[474] - I2[577])
          - U12*(I1[484] - I2[578])
          + (sixzboz)*(I3[457] - AC1*I4[304])
          + (twozboz)*(I3[443] - AC2*I4[294]);
*(vp++) = U0*I0[385]
          - U10*(I1[385] - I2[575])
          - U11*(I1[475] - I2[578])
          - U12*(I1[485] - I2[579])
          + (sixzboz)*(I3[458] - AC1*I4[305])
          + (twozboz)*(I3[444] - AC2*I4[295]);
*(vp++) = U0*I0[386]
          - U10*(I1[386] - I2[576])
          - U11*(I1[476] - I2[580])
          - U12*(I1[486] - I2[581])
          + (sixzboz)*(I3[460] - AC1*I4[306])
          + (twozboz)*(I3[446] - AC2*I4[296]);
*(vp++) = U0*I0[387]
          - U10*(I1[387] - I2[577])
          - U11*(I1[477] - I2[581])
          - U12*(I1[487] - I2[582])
          + (sixzboz)*(I3[461] - AC1*I4[307])
          + (twozboz)*(I3[447] - AC2*I4[297]);
*(vp++) = U0*I0[388]
          - U10*(I1[388] - I2[578])
          - U11*(I1[478] - I2[582])
          - U12*(I1[488] - I2[583])
          + (sixzboz)*(I3[462] - AC1*I4[308])
          + (twozboz)*(I3[448] - AC2*I4[298]);
*(vp++) = U0*I0[389]
          - U10*(I1[389] - I2[579])
          - U11*(I1[479] - I2[583])
          - U12*(I1[489] - I2[584])
          + (sixzboz)*(I3[463] - AC1*I4[309])
          + (twozboz)*(I3[449] - AC2*I4[299]);
*(vp++) = U0*I0[390]
          - U10*(I1[390] - I2[585])
          - U11*(I1[480] - I2[586])
          - U12*(I1[490] - I2[587])
          + (fivezboz)*(I3[466] - AC1*I4[310])
          + (threezboz)*(I3[452] - AC2*I4[300]);
*(vp++) = U0*I0[391]
          - U10*(I1[391] - I2[586])
          - U11*(I1[481] - I2[588])
          - U12*(I1[491] - I2[589])
          + (fivezboz)*(I3[468] - AC1*I4[311])
          + (threezboz)*(I3[454] - AC2*I4[301]);
*(vp++) = U0*I0[392]
          - U10*(I1[392] - I2[587])
          - U11*(I1[482] - I2[589])
          - U12*(I1[492] - I2[590])
          + (fivezboz)*(I3[469] - AC1*I4[312])
          + (threezboz)*(I3[455] - AC2*I4[302]);
*(vp++) = U0*I0[393]
          - U10*(I1[393] - I2[588])
          - U11*(I1[483] - I2[591])
          - U12*(I1[493] - I2[592])
          + (fivezboz)*(I3[471] - AC1*I4[313])
          + (threezboz)*(I3[457] - AC2*I4[303]);
*(vp++) = U0*I0[394]
          - U10*(I1[394] - I2[589])
          - U11*(I1[484] - I2[592])
          - U12*(I1[494] - I2[593])
          + (fivezboz)*(I3[472] - AC1*I4[314])
          + (threezboz)*(I3[458] - AC2*I4[304]);
*(vp++) = U0*I0[395]
          - U10*(I1[395] - I2[590])
          - U11*(I1[485] - I2[593])
          - U12*(I1[495] - I2[594])
          + (fivezboz)*(I3[473] - AC1*I4[315])
          + (threezboz)*(I3[459] - AC2*I4[305]);
*(vp++) = U0*I0[396]
          - U10*(I1[396] - I2[591])
          - U11*(I1[486] - I2[595])
          - U12*(I1[496] - I2[596])
          + (fivezboz)*(I3[475] - AC1*I4[316])
          + (threezboz)*(I3[461] - AC2*I4[306]);
*(vp++) = U0*I0[397]
          - U10*(I1[397] - I2[592])
          - U11*(I1[487] - I2[596])
          - U12*(I1[497] - I2[597])
          + (fivezboz)*(I3[476] - AC1*I4[317])
          + (threezboz)*(I3[462] - AC2*I4[307]);
*(vp++) = U0*I0[398]
          - U10*(I1[398] - I2[593])
          - U11*(I1[488] - I2[597])
          - U12*(I1[498] - I2[598])
          + (fivezboz)*(I3[477] - AC1*I4[318])
          + (threezboz)*(I3[463] - AC2*I4[308]);
*(vp++) = U0*I0[399]
          - U10*(I1[399] - I2[594])
          - U11*(I1[489] - I2[598])
          - U12*(I1[499] - I2[599])
          + (fivezboz)*(I3[478] - AC1*I4[319])
          + (threezboz)*(I3[464] - AC2*I4[309]);
*(vp++) = U0*I0[400]
          - U10*(I1[400] - I2[600])
          - U11*(I1[490] - I2[601])
          - U12*(I1[500] - I2[602])
          + (fourzboz)*(I3[481] - AC1*I4[320])
          + (fourzboz)*(I3[467] - AC2*I4[310]);
*(vp++) = U0*I0[401]
          - U10*(I1[401] - I2[601])
          - U11*(I1[491] - I2[603])
          - U12*(I1[501] - I2[604])
          + (fourzboz)*(I3[483] - AC1*I4[321])
          + (fourzboz)*(I3[469] - AC2*I4[311]);
*(vp++) = U0*I0[402]
          - U10*(I1[402] - I2[602])
          - U11*(I1[492] - I2[604])
          - U12*(I1[502] - I2[605])
          + (fourzboz)*(I3[484] - AC1*I4[322])
          + (fourzboz)*(I3[470] - AC2*I4[312]);
*(vp++) = U0*I0[403]
          - U10*(I1[403] - I2[603])
          - U11*(I1[493] - I2[606])
          - U12*(I1[503] - I2[607])
          + (fourzboz)*(I3[486] - AC1*I4[323])
          + (fourzboz)*(I3[472] - AC2*I4[313]);
*(vp++) = U0*I0[404]
          - U10*(I1[404] - I2[604])
          - U11*(I1[494] - I2[607])
          - U12*(I1[504] - I2[608])
          + (fourzboz)*(I3[487] - AC1*I4[324])
          + (fourzboz)*(I3[473] - AC2*I4[314]);
*(vp++) = U0*I0[405]
          - U10*(I1[405] - I2[605])
          - U11*(I1[495] - I2[608])
          - U12*(I1[505] - I2[609])
          + (fourzboz)*(I3[488] - AC1*I4[325])
          + (fourzboz)*(I3[474] - AC2*I4[315]);
*(vp++) = U0*I0[406]
          - U10*(I1[406] - I2[606])
          - U11*(I1[496] - I2[610])
          - U12*(I1[506] - I2[611])
          + (fourzboz)*(I3[490] - AC1*I4[326])
          + (fourzboz)*(I3[476] - AC2*I4[316]);
*(vp++) = U0*I0[407]
          - U10*(I1[407] - I2[607])
          - U11*(I1[497] - I2[611])
          - U12*(I1[507] - I2[612])
          + (fourzboz)*(I3[491] - AC1*I4[327])
          + (fourzboz)*(I3[477] - AC2*I4[317]);
*(vp++) = U0*I0[408]
          - U10*(I1[408] - I2[608])
          - U11*(I1[498] - I2[612])
          - U12*(I1[508] - I2[613])
          + (fourzboz)*(I3[492] - AC1*I4[328])
          + (fourzboz)*(I3[478] - AC2*I4[318]);
*(vp++) = U0*I0[409]
          - U10*(I1[409] - I2[609])
          - U11*(I1[499] - I2[613])
          - U12*(I1[509] - I2[614])
          + (fourzboz)*(I3[493] - AC1*I4[329])
          + (fourzboz)*(I3[479] - AC2*I4[319]);
*(vp++) = U0*I0[410]
          - U10*(I1[410] - I2[615])
          - U11*(I1[500] - I2[616])
          - U12*(I1[510] - I2[617])
          + (threezboz)*(I3[496] - AC1*I4[330])
          + (fivezboz)*(I3[482] - AC2*I4[320]);
*(vp++) = U0*I0[411]
          - U10*(I1[411] - I2[616])
          - U11*(I1[501] - I2[618])
          - U12*(I1[511] - I2[619])
          + (threezboz)*(I3[498] - AC1*I4[331])
          + (fivezboz)*(I3[484] - AC2*I4[321]);
*(vp++) = U0*I0[412]
          - U10*(I1[412] - I2[617])
          - U11*(I1[502] - I2[619])
          - U12*(I1[512] - I2[620])
          + (threezboz)*(I3[499] - AC1*I4[332])
          + (fivezboz)*(I3[485] - AC2*I4[322]);
*(vp++) = U0*I0[413]
          - U10*(I1[413] - I2[618])
          - U11*(I1[503] - I2[621])
          - U12*(I1[513] - I2[622])
          + (threezboz)*(I3[501] - AC1*I4[333])
          + (fivezboz)*(I3[487] - AC2*I4[323]);
*(vp++) = U0*I0[414]
          - U10*(I1[414] - I2[619])
          - U11*(I1[504] - I2[622])
          - U12*(I1[514] - I2[623])
          + (threezboz)*(I3[502] - AC1*I4[334])
          + (fivezboz)*(I3[488] - AC2*I4[324]);
*(vp++) = U0*I0[415]
          - U10*(I1[415] - I2[620])
          - U11*(I1[505] - I2[623])
          - U12*(I1[515] - I2[624])
          + (threezboz)*(I3[503] - AC1*I4[335])
          + (fivezboz)*(I3[489] - AC2*I4[325]);
*(vp++) = U0*I0[416]
          - U10*(I1[416] - I2[621])
          - U11*(I1[506] - I2[625])
          - U12*(I1[516] - I2[626])
          + (threezboz)*(I3[505] - AC1*I4[336])
          + (fivezboz)*(I3[491] - AC2*I4[326]);
*(vp++) = U0*I0[417]
          - U10*(I1[417] - I2[622])
          - U11*(I1[507] - I2[626])
          - U12*(I1[517] - I2[627])
          + (threezboz)*(I3[506] - AC1*I4[337])
          + (fivezboz)*(I3[492] - AC2*I4[327]);
*(vp++) = U0*I0[418]
          - U10*(I1[418] - I2[623])
          - U11*(I1[508] - I2[627])
          - U12*(I1[518] - I2[628])
          + (threezboz)*(I3[507] - AC1*I4[338])
          + (fivezboz)*(I3[493] - AC2*I4[328]);
*(vp++) = U0*I0[419]
          - U10*(I1[419] - I2[624])
          - U11*(I1[509] - I2[628])
          - U12*(I1[519] - I2[629])
          + (threezboz)*(I3[508] - AC1*I4[339])
          + (fivezboz)*(I3[494] - AC2*I4[329]);
*(vp++) = U0*I0[420]
          - U10*(I1[420] - I2[630])
          - U11*(I1[510] - I2[631])
          - U12*(I1[520] - I2[632])
          + (twozboz)*(I3[511] - AC1*I4[340])
          + (sixzboz)*(I3[497] - AC2*I4[330]);
*(vp++) = U0*I0[421]
          - U10*(I1[421] - I2[631])
          - U11*(I1[511] - I2[633])
          - U12*(I1[521] - I2[634])
          + (twozboz)*(I3[513] - AC1*I4[341])
          + (sixzboz)*(I3[499] - AC2*I4[331]);
*(vp++) = U0*I0[422]
          - U10*(I1[422] - I2[632])
          - U11*(I1[512] - I2[634])
          - U12*(I1[522] - I2[635])
          + (twozboz)*(I3[514] - AC1*I4[342])
          + (sixzboz)*(I3[500] - AC2*I4[332]);
*(vp++) = U0*I0[423]
          - U10*(I1[423] - I2[633])
          - U11*(I1[513] - I2[636])
          - U12*(I1[523] - I2[637])
          + (twozboz)*(I3[516] - AC1*I4[343])
          + (sixzboz)*(I3[502] - AC2*I4[333]);
*(vp++) = U0*I0[424]
          - U10*(I1[424] - I2[634])
          - U11*(I1[514] - I2[637])
          - U12*(I1[524] - I2[638])
          + (twozboz)*(I3[517] - AC1*I4[344])
          + (sixzboz)*(I3[503] - AC2*I4[334]);
*(vp++) = U0*I0[425]
          - U10*(I1[425] - I2[635])
          - U11*(I1[515] - I2[638])
          - U12*(I1[525] - I2[639])
          + (twozboz)*(I3[518] - AC1*I4[345])
          + (sixzboz)*(I3[504] - AC2*I4[335]);
*(vp++) = U0*I0[426]
          - U10*(I1[426] - I2[636])
          - U11*(I1[516] - I2[640])
          - U12*(I1[526] - I2[641])
          + (twozboz)*(I3[520] - AC1*I4[346])
          + (sixzboz)*(I3[506] - AC2*I4[336]);
*(vp++) = U0*I0[427]
          - U10*(I1[427] - I2[637])
          - U11*(I1[517] - I2[641])
          - U12*(I1[527] - I2[642])
          + (twozboz)*(I3[521] - AC1*I4[347])
          + (sixzboz)*(I3[507] - AC2*I4[337]);
*(vp++) = U0*I0[428]
          - U10*(I1[428] - I2[638])
          - U11*(I1[518] - I2[642])
          - U12*(I1[528] - I2[643])
          + (twozboz)*(I3[522] - AC1*I4[348])
          + (sixzboz)*(I3[508] - AC2*I4[338]);
*(vp++) = U0*I0[429]
          - U10*(I1[429] - I2[639])
          - U11*(I1[519] - I2[643])
          - U12*(I1[529] - I2[644])
          + (twozboz)*(I3[523] - AC1*I4[349])
          + (sixzboz)*(I3[509] - AC2*I4[339]);
*(vp++) = U0*I0[430]
          - U10*(I1[430] - I2[645])
          - U11*(I1[520] - I2[646])
          - U12*(I1[530] - I2[647])
          + (onezboz)*(I3[526] - AC1*I4[350])
          + (sevenzboz)*(I3[512] - AC2*I4[340]);
*(vp++) = U0*I0[431]
          - U10*(I1[431] - I2[646])
          - U11*(I1[521] - I2[648])
          - U12*(I1[531] - I2[649])
          + (onezboz)*(I3[528] - AC1*I4[351])
          + (sevenzboz)*(I3[514] - AC2*I4[341]);
*(vp++) = U0*I0[432]
          - U10*(I1[432] - I2[647])
          - U11*(I1[522] - I2[649])
          - U12*(I1[532] - I2[650])
          + (onezboz)*(I3[529] - AC1*I4[352])
          + (sevenzboz)*(I3[515] - AC2*I4[342]);
*(vp++) = U0*I0[433]
          - U10*(I1[433] - I2[648])
          - U11*(I1[523] - I2[651])
          - U12*(I1[533] - I2[652])
          + (onezboz)*(I3[531] - AC1*I4[353])
          + (sevenzboz)*(I3[517] - AC2*I4[343]);
*(vp++) = U0*I0[434]
          - U10*(I1[434] - I2[649])
          - U11*(I1[524] - I2[652])
          - U12*(I1[534] - I2[653])
          + (onezboz)*(I3[532] - AC1*I4[354])
          + (sevenzboz)*(I3[518] - AC2*I4[344]);
*(vp++) = U0*I0[435]
          - U10*(I1[435] - I2[650])
          - U11*(I1[525] - I2[653])
          - U12*(I1[535] - I2[654])
          + (onezboz)*(I3[533] - AC1*I4[355])
          + (sevenzboz)*(I3[519] - AC2*I4[345]);
*(vp++) = U0*I0[436]
          - U10*(I1[436] - I2[651])
          - U11*(I1[526] - I2[655])
          - U12*(I1[536] - I2[656])
          + (onezboz)*(I3[535] - AC1*I4[356])
          + (sevenzboz)*(I3[521] - AC2*I4[346]);
*(vp++) = U0*I0[437]
          - U10*(I1[437] - I2[652])
          - U11*(I1[527] - I2[656])
          - U12*(I1[537] - I2[657])
          + (onezboz)*(I3[536] - AC1*I4[357])
          + (sevenzboz)*(I3[522] - AC2*I4[347]);
*(vp++) = U0*I0[438]
          - U10*(I1[438] - I2[653])
          - U11*(I1[528] - I2[657])
          - U12*(I1[538] - I2[658])
          + (onezboz)*(I3[537] - AC1*I4[358])
          + (sevenzboz)*(I3[523] - AC2*I4[348]);
*(vp++) = U0*I0[439]
          - U10*(I1[439] - I2[654])
          - U11*(I1[529] - I2[658])
          - U12*(I1[539] - I2[659])
          + (onezboz)*(I3[538] - AC1*I4[359])
          + (sevenzboz)*(I3[524] - AC2*I4[349]);
*(vp++) = U0*I0[440]
          - U10*(I1[440] - I2[660])
          - U11*(I1[530] - I2[661])
          - U12*(I1[540] - I2[662])
          + (eightzboz)*(I3[527] - AC2*I4[350]);
*(vp++) = U0*I0[441]
          - U10*(I1[441] - I2[661])
          - U11*(I1[531] - I2[663])
          - U12*(I1[541] - I2[664])
          + (eightzboz)*(I3[529] - AC2*I4[351]);
*(vp++) = U0*I0[442]
          - U10*(I1[442] - I2[662])
          - U11*(I1[532] - I2[664])
          - U12*(I1[542] - I2[665])
          + (eightzboz)*(I3[530] - AC2*I4[352]);
*(vp++) = U0*I0[443]
          - U10*(I1[443] - I2[663])
          - U11*(I1[533] - I2[666])
          - U12*(I1[543] - I2[667])
          + (eightzboz)*(I3[532] - AC2*I4[353]);
*(vp++) = U0*I0[444]
          - U10*(I1[444] - I2[664])
          - U11*(I1[534] - I2[667])
          - U12*(I1[544] - I2[668])
          + (eightzboz)*(I3[533] - AC2*I4[354]);
*(vp++) = U0*I0[445]
          - U10*(I1[445] - I2[665])
          - U11*(I1[535] - I2[668])
          - U12*(I1[545] - I2[669])
          + (eightzboz)*(I3[534] - AC2*I4[355]);
*(vp++) = U0*I0[446]
          - U10*(I1[446] - I2[666])
          - U11*(I1[536] - I2[670])
          - U12*(I1[546] - I2[671])
          + (eightzboz)*(I3[536] - AC2*I4[356]);
*(vp++) = U0*I0[447]
          - U10*(I1[447] - I2[667])
          - U11*(I1[537] - I2[671])
          - U12*(I1[547] - I2[672])
          + (eightzboz)*(I3[537] - AC2*I4[357]);
*(vp++) = U0*I0[448]
          - U10*(I1[448] - I2[668])
          - U11*(I1[538] - I2[672])
          - U12*(I1[548] - I2[673])
          + (eightzboz)*(I3[538] - AC2*I4[358]);
*(vp++) = U0*I0[449]
          - U10*(I1[449] - I2[669])
          - U11*(I1[539] - I2[673])
          - U12*(I1[549] - I2[674])
          + (eightzboz)*(I3[539] - AC2*I4[359]);
return vp;
}
