/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (fs|[r12,T2]|0s) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t2_build_f000(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  U10 = ShellData->CD[0]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U11 = ShellData->CD[1]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U12 = ShellData->CD[2]*(Data->twozeta_c*Data->twozeta_d*Data->oo2n);
  U0  = (Data->twozeta_c - Data->twozeta_d*(Data->twozeta_c*ShellData->CDdotCA + 1.000000))*Data->oo2n;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[1] - I2[1])
          - U12*(I1[2] - I2[2]);
*(vp++) = U0*I0[1]
          - U10*(I1[3] - I2[1])
          - U11*(I1[4] - I2[3])
          - U12*(I1[5] - I2[4]);
*(vp++) = U0*I0[2]
          - U10*(I1[6] - I2[2])
          - U11*(I1[7] - I2[4])
          - U12*(I1[8] - I2[5]);
*(vp++) = U0*I0[3]
          - U10*(I1[9] - I2[3])
          - U11*(I1[10] - I2[6])
          - U12*(I1[11] - I2[7]);
*(vp++) = U0*I0[4]
          - U10*(I1[12] - I2[4])
          - U11*(I1[13] - I2[7])
          - U12*(I1[14] - I2[8]);
*(vp++) = U0*I0[5]
          - U10*(I1[15] - I2[5])
          - U11*(I1[16] - I2[8])
          - U12*(I1[17] - I2[9]);
*(vp++) = U0*I0[6]
          - U10*(I1[18] - I2[6])
          - U11*(I1[19] - I2[10])
          - U12*(I1[20] - I2[11]);
*(vp++) = U0*I0[7]
          - U10*(I1[21] - I2[7])
          - U11*(I1[22] - I2[11])
          - U12*(I1[23] - I2[12]);
*(vp++) = U0*I0[8]
          - U10*(I1[24] - I2[8])
          - U11*(I1[25] - I2[12])
          - U12*(I1[26] - I2[13]);
*(vp++) = U0*I0[9]
          - U10*(I1[27] - I2[9])
          - U11*(I1[28] - I2[13])
          - U12*(I1[29] - I2[14]);

}
