/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ffgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ff|gg) integrals */

void d12hrr_order_ffgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][8][11] = int_stack + 0;
 Libderiv->deriv_classes[6][8][10] = int_stack + 1260;
 Libderiv->deriv_classes[6][8][9] = int_stack + 2520;
 Libderiv->deriv_classes[6][8][8] = int_stack + 3780;
 Libderiv->deriv_classes[6][8][7] = int_stack + 5040;
 Libderiv->dvrr_classes[6][7] = int_stack + 6300;
 Libderiv->deriv_classes[6][8][6] = int_stack + 7308;
 Libderiv->deriv_classes[6][8][2] = int_stack + 8568;
 Libderiv->deriv_classes[6][8][1] = int_stack + 9828;
 Libderiv->dvrr_classes[5][8] = int_stack + 11088;
 Libderiv->deriv_classes[6][8][0] = int_stack + 12033;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 13293;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 13443;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 13653;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 13933;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 14293;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 14743;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 14968;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 15283;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 15703;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 16243;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 16918;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 17233;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 17674;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 18262;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 19018;
 Libderiv->deriv2_classes[6][4][143] = int_stack + 19963;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 20383;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 20971;
 Libderiv->deriv2_classes[6][7][143] = int_stack + 21755;
 Libderiv->deriv2_classes[6][8][143] = int_stack + 22763;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 24023;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 24173;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 24383;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 24663;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 25023;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 25473;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 25698;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 26013;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 26433;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 26973;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 27648;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 27963;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 28404;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 28992;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 29748;
 Libderiv->deriv2_classes[6][4][131] = int_stack + 30693;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 31113;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 31701;
 Libderiv->deriv2_classes[6][7][131] = int_stack + 32485;
 Libderiv->deriv2_classes[6][8][131] = int_stack + 33493;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 34753;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 34903;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 35113;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 35393;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 35753;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 36203;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 36428;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 36743;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 37163;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 37703;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 38378;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 38693;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 39134;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 39722;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 40478;
 Libderiv->deriv2_classes[6][4][130] = int_stack + 41423;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 41843;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 42431;
 Libderiv->deriv2_classes[6][7][130] = int_stack + 43215;
 Libderiv->deriv2_classes[6][8][130] = int_stack + 44223;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 45483;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 45633;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 45843;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 46123;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 46483;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 46933;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 47158;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 47473;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 47893;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 48433;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 49108;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 49423;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 49864;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 50452;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 51208;
 Libderiv->deriv2_classes[6][4][119] = int_stack + 52153;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 52573;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 53161;
 Libderiv->deriv2_classes[6][7][119] = int_stack + 53945;
 Libderiv->deriv2_classes[6][8][119] = int_stack + 54953;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 56213;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 56363;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 56573;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 56853;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 57213;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 57663;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 57888;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 58203;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 58623;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 59163;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 59838;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 60153;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 60594;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 61182;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 61938;
 Libderiv->deriv2_classes[6][4][118] = int_stack + 62883;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 63303;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 63891;
 Libderiv->deriv2_classes[6][7][118] = int_stack + 64675;
 Libderiv->deriv2_classes[6][8][118] = int_stack + 65683;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 66943;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 67093;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 67303;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 67583;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 67943;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 68393;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 68618;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 68933;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 69353;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 69893;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 70568;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 70883;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 71324;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 71912;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 72668;
 Libderiv->deriv2_classes[6][4][117] = int_stack + 73613;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 74033;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 74621;
 Libderiv->deriv2_classes[6][7][117] = int_stack + 75405;
 Libderiv->deriv2_classes[6][8][117] = int_stack + 76413;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 77673;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 77823;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 78033;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 78313;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 78673;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 79123;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 79348;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 79663;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 80083;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 80623;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 81298;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 81613;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 82054;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 82642;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 83398;
 Libderiv->deriv2_classes[6][4][107] = int_stack + 84343;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 84763;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 85351;
 Libderiv->deriv2_classes[6][7][107] = int_stack + 86135;
 Libderiv->deriv2_classes[6][8][107] = int_stack + 87143;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 88403;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 88553;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 88763;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 89043;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 89403;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 89853;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 90078;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 90393;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 90813;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 91353;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 92028;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 92343;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 92784;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 93372;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 94128;
 Libderiv->deriv2_classes[6][4][106] = int_stack + 95073;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 95493;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 96081;
 Libderiv->deriv2_classes[6][7][106] = int_stack + 96865;
 Libderiv->deriv2_classes[6][8][106] = int_stack + 97873;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 99133;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 99283;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 99493;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 99773;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 100133;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 100583;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 100808;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 101123;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 101543;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 102083;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 102758;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 103073;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 103514;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 104102;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 104858;
 Libderiv->deriv2_classes[6][4][105] = int_stack + 105803;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 106223;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 106811;
 Libderiv->deriv2_classes[6][7][105] = int_stack + 107595;
 Libderiv->deriv2_classes[6][8][105] = int_stack + 108603;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 109863;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 110013;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 110223;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 110503;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 110863;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 111313;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 111538;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 111853;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 112273;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 112813;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 113488;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 113803;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 114244;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 114832;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 115588;
 Libderiv->deriv2_classes[6][4][104] = int_stack + 116533;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 116953;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 117541;
 Libderiv->deriv2_classes[6][7][104] = int_stack + 118325;
 Libderiv->deriv2_classes[6][8][104] = int_stack + 119333;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 120593;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 120743;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 120953;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 121233;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 121593;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 122043;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 122268;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 122583;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 123003;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 123543;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 124218;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 124533;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 124974;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 125562;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 126318;
 Libderiv->deriv2_classes[6][4][95] = int_stack + 127263;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 127683;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 128271;
 Libderiv->deriv2_classes[6][7][95] = int_stack + 129055;
 Libderiv->deriv2_classes[6][8][95] = int_stack + 130063;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 131323;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 131473;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 131683;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 131963;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 132323;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 132773;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 132998;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 133313;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 133733;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 134273;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 134948;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 135263;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 135704;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 136292;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 137048;
 Libderiv->deriv2_classes[6][4][94] = int_stack + 137993;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 138413;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 139001;
 Libderiv->deriv2_classes[6][7][94] = int_stack + 139785;
 Libderiv->deriv2_classes[6][8][94] = int_stack + 140793;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 142053;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 142203;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 142413;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 142693;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 143053;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 143503;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 143728;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 144043;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 144463;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 145003;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 145678;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 145993;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 146434;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 147022;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 147778;
 Libderiv->deriv2_classes[6][4][93] = int_stack + 148723;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 149143;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 149731;
 Libderiv->deriv2_classes[6][7][93] = int_stack + 150515;
 Libderiv->deriv2_classes[6][8][93] = int_stack + 151523;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 152783;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 152933;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 153143;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 153423;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 153783;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 154233;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 154458;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 154773;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 155193;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 155733;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 156408;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 156723;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 157164;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 157752;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 158508;
 Libderiv->deriv2_classes[6][4][92] = int_stack + 159453;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 159873;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 160461;
 Libderiv->deriv2_classes[6][7][92] = int_stack + 161245;
 Libderiv->deriv2_classes[6][8][92] = int_stack + 162253;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 163513;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 163663;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 163873;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 164153;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 164513;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 164963;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 165188;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 165503;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 165923;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 166463;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 167138;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 167453;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 167894;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 168482;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 169238;
 Libderiv->deriv2_classes[6][4][91] = int_stack + 170183;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 170603;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 171191;
 Libderiv->deriv2_classes[6][7][91] = int_stack + 171975;
 Libderiv->deriv2_classes[6][8][91] = int_stack + 172983;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 174243;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 174393;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 174603;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 174883;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 175243;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 175693;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 175918;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 176233;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 176653;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 177193;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 177868;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 178183;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 178624;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 179212;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 179968;
 Libderiv->deriv_classes[6][4][11] = int_stack + 180913;
 Libderiv->deriv2_classes[6][4][83] = int_stack + 181333;
 Libderiv->deriv_classes[6][5][11] = int_stack + 181753;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 182341;
 Libderiv->deriv_classes[6][6][11] = int_stack + 182929;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 183713;
 Libderiv->deriv_classes[6][7][11] = int_stack + 184497;
 Libderiv->deriv2_classes[6][7][83] = int_stack + 185505;
 Libderiv->deriv2_classes[6][8][83] = int_stack + 186513;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 187773;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 187923;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 188133;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 188413;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 188773;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 189223;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 189448;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 189763;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 190183;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 190723;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 191398;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 191713;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 192154;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 192742;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 193498;
 Libderiv->deriv_classes[6][4][10] = int_stack + 194443;
 Libderiv->deriv2_classes[6][4][82] = int_stack + 194863;
 Libderiv->deriv_classes[6][5][10] = int_stack + 195283;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 195871;
 Libderiv->deriv_classes[6][6][10] = int_stack + 196459;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 197243;
 Libderiv->deriv_classes[6][7][10] = int_stack + 198027;
 Libderiv->deriv2_classes[6][7][82] = int_stack + 199035;
 Libderiv->deriv2_classes[6][8][82] = int_stack + 200043;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 201303;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 201453;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 201663;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 201943;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 202303;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 202753;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 202978;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 203293;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 203713;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 204253;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 204928;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 205243;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 205684;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 206272;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 207028;
 Libderiv->deriv_classes[6][4][9] = int_stack + 207973;
 Libderiv->deriv2_classes[6][4][81] = int_stack + 208393;
 Libderiv->deriv_classes[6][5][9] = int_stack + 208813;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 209401;
 Libderiv->deriv_classes[6][6][9] = int_stack + 209989;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 210773;
 Libderiv->deriv_classes[6][7][9] = int_stack + 211557;
 Libderiv->deriv2_classes[6][7][81] = int_stack + 212565;
 Libderiv->deriv2_classes[6][8][81] = int_stack + 213573;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 214833;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 214983;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 215193;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 215473;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 215833;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 216283;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 216508;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 216823;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 217243;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 217783;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 218458;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 218773;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 219214;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 219802;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 220558;
 Libderiv->deriv_classes[6][4][8] = int_stack + 221503;
 Libderiv->deriv2_classes[6][4][80] = int_stack + 221923;
 Libderiv->deriv_classes[6][5][8] = int_stack + 222343;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 222931;
 Libderiv->deriv_classes[6][6][8] = int_stack + 223519;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 224303;
 Libderiv->deriv_classes[6][7][8] = int_stack + 225087;
 Libderiv->deriv2_classes[6][7][80] = int_stack + 226095;
 Libderiv->deriv2_classes[6][8][80] = int_stack + 227103;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 228363;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 228513;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 228723;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 229003;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 229363;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 229813;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 230038;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 230353;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 230773;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 231313;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 231988;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 232303;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 232744;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 233332;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 234088;
 Libderiv->deriv_classes[6][4][7] = int_stack + 235033;
 Libderiv->deriv2_classes[6][4][79] = int_stack + 235453;
 Libderiv->deriv_classes[6][5][7] = int_stack + 235873;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 236461;
 Libderiv->deriv_classes[6][6][7] = int_stack + 237049;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 237833;
 Libderiv->deriv_classes[6][7][7] = int_stack + 238617;
 Libderiv->deriv2_classes[6][7][79] = int_stack + 239625;
 Libderiv->deriv2_classes[6][8][79] = int_stack + 240633;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 241893;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 242043;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 242253;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 242533;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 242893;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 243343;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 243568;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 243883;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 244303;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 244843;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 245518;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 245833;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 246274;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 246862;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 247618;
 Libderiv->dvrr_classes[6][4] = int_stack + 248563;
 Libderiv->deriv_classes[6][4][6] = int_stack + 248983;
 Libderiv->deriv2_classes[6][4][78] = int_stack + 249403;
 Libderiv->dvrr_classes[6][5] = int_stack + 249823;
 Libderiv->deriv_classes[6][5][6] = int_stack + 250411;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 250999;
 Libderiv->dvrr_classes[6][6] = int_stack + 251587;
 Libderiv->deriv_classes[6][6][6] = int_stack + 252371;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 253155;
 Libderiv->deriv_classes[6][7][6] = int_stack + 253939;
 Libderiv->deriv2_classes[6][7][78] = int_stack + 254947;
 Libderiv->deriv2_classes[6][8][78] = int_stack + 255955;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 257215;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 257365;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 257575;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 257855;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 258215;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 258665;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 258890;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 259205;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 259625;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 260165;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 260840;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 261155;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 261596;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 262184;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 262940;
 Libderiv->deriv2_classes[6][4][35] = int_stack + 263885;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 264305;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 264893;
 Libderiv->deriv2_classes[6][7][35] = int_stack + 265677;
 Libderiv->deriv2_classes[6][8][35] = int_stack + 266685;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 267945;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 268095;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 268305;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 268585;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 268945;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 269395;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 269620;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 269935;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 270355;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 270895;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 271570;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 271885;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 272326;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 272914;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 273670;
 Libderiv->deriv2_classes[6][4][34] = int_stack + 274615;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 275035;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 275623;
 Libderiv->deriv2_classes[6][7][34] = int_stack + 276407;
 Libderiv->deriv2_classes[6][8][34] = int_stack + 277415;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 278675;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 278825;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 279035;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 279315;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 279675;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 280125;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 280350;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 280665;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 281085;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 281625;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 282300;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 282615;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 283056;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 283644;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 284400;
 Libderiv->deriv2_classes[6][4][33] = int_stack + 285345;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 285765;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 286353;
 Libderiv->deriv2_classes[6][7][33] = int_stack + 287137;
 Libderiv->deriv2_classes[6][8][33] = int_stack + 288145;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 289405;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 289555;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 289765;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 290045;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 290405;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 290855;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 291080;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 291395;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 291815;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 292355;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 293030;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 293345;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 293786;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 294374;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 295130;
 Libderiv->deriv2_classes[6][4][32] = int_stack + 296075;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 296495;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 297083;
 Libderiv->deriv2_classes[6][7][32] = int_stack + 297867;
 Libderiv->deriv2_classes[6][8][32] = int_stack + 298875;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 300135;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 300285;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 300495;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 300775;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 301135;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 301585;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 301810;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 302125;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 302545;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 303085;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 303760;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 304075;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 304516;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 305104;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 305860;
 Libderiv->deriv2_classes[6][4][31] = int_stack + 306805;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 307225;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 307813;
 Libderiv->deriv2_classes[6][7][31] = int_stack + 308597;
 Libderiv->deriv2_classes[6][8][31] = int_stack + 309605;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 310865;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 311015;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 311225;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 311505;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 311865;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 312315;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 312540;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 312855;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 313275;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 313815;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 314490;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 314805;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 315246;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 315834;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 316590;
 Libderiv->deriv_classes[6][4][2] = int_stack + 317535;
 Libderiv->deriv2_classes[6][4][30] = int_stack + 317955;
 Libderiv->deriv_classes[6][5][2] = int_stack + 318375;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 318963;
 Libderiv->deriv_classes[6][6][2] = int_stack + 319551;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 320335;
 Libderiv->deriv_classes[6][7][2] = int_stack + 321119;
 Libderiv->deriv2_classes[6][7][30] = int_stack + 322127;
 Libderiv->deriv2_classes[6][8][30] = int_stack + 323135;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 324395;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 324545;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 324755;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 325035;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 325395;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 325845;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 326070;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 326385;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 326805;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 327345;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 328020;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 328335;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 328776;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 329364;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 330120;
 Libderiv->deriv2_classes[6][4][26] = int_stack + 331065;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 331485;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 332073;
 Libderiv->deriv2_classes[6][7][26] = int_stack + 332857;
 Libderiv->deriv2_classes[6][8][26] = int_stack + 333865;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 335125;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 335275;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 335485;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 335765;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 336125;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 336575;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 336800;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 337115;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 337535;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 338075;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 338750;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 339065;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 339506;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 340094;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 340850;
 Libderiv->deriv2_classes[6][4][23] = int_stack + 341795;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 342215;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 342803;
 Libderiv->deriv2_classes[6][7][23] = int_stack + 343587;
 Libderiv->deriv2_classes[6][8][23] = int_stack + 344595;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 345855;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 346005;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 346215;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 346495;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 346855;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 347305;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 347530;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 347845;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 348265;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 348805;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 349480;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 349795;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 350236;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 350824;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 351580;
 Libderiv->deriv2_classes[6][4][22] = int_stack + 352525;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 352945;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 353533;
 Libderiv->deriv2_classes[6][7][22] = int_stack + 354317;
 Libderiv->deriv2_classes[6][8][22] = int_stack + 355325;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 356585;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 356735;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 356945;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 357225;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 357585;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 358035;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 358260;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 358575;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 358995;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 359535;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 360210;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 360525;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 360966;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 361554;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 362310;
 Libderiv->deriv2_classes[6][4][21] = int_stack + 363255;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 363675;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 364263;
 Libderiv->deriv2_classes[6][7][21] = int_stack + 365047;
 Libderiv->deriv2_classes[6][8][21] = int_stack + 366055;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 367315;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 367465;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 367675;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 367955;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 368315;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 368765;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 368990;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 369305;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 369725;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 370265;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 370940;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 371255;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 371696;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 372284;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 373040;
 Libderiv->deriv2_classes[6][4][20] = int_stack + 373985;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 374405;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 374993;
 Libderiv->deriv2_classes[6][7][20] = int_stack + 375777;
 Libderiv->deriv2_classes[6][8][20] = int_stack + 376785;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 378045;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 378195;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 378405;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 378685;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 379045;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 379495;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 379720;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 380035;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 380455;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 380995;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 381670;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 381985;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 382426;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 383014;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 383770;
 Libderiv->deriv2_classes[6][4][19] = int_stack + 384715;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 385135;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 385723;
 Libderiv->deriv2_classes[6][7][19] = int_stack + 386507;
 Libderiv->deriv2_classes[6][8][19] = int_stack + 387515;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 388775;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 388925;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 389135;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 389415;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 389775;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 390225;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 390450;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 390765;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 391185;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 391725;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 392400;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 392715;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 393156;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 393744;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 394500;
 Libderiv->deriv_classes[6][4][1] = int_stack + 395445;
 Libderiv->deriv2_classes[6][4][18] = int_stack + 395865;
 Libderiv->deriv_classes[6][5][1] = int_stack + 396285;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 396873;
 Libderiv->deriv_classes[6][6][1] = int_stack + 397461;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 398245;
 Libderiv->deriv_classes[6][7][1] = int_stack + 399029;
 Libderiv->deriv2_classes[6][7][18] = int_stack + 400037;
 Libderiv->deriv2_classes[6][8][18] = int_stack + 401045;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 402305;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 402455;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 402665;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 402945;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 403305;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 403755;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 403980;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 404295;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 404715;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 405255;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 405930;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 406245;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 406686;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 407274;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 408030;
 Libderiv->deriv2_classes[6][4][14] = int_stack + 408975;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 409395;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 409983;
 Libderiv->deriv2_classes[6][7][14] = int_stack + 410767;
 Libderiv->deriv2_classes[6][8][14] = int_stack + 411775;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 413035;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 413185;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 413395;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 413675;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 414035;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 414485;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 414710;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 415025;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 415445;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 415985;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 416660;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 416975;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 417416;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 418004;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 418760;
 Libderiv->deriv2_classes[6][4][13] = int_stack + 419705;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 420125;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 420713;
 Libderiv->deriv2_classes[6][7][13] = int_stack + 421497;
 Libderiv->deriv2_classes[6][8][13] = int_stack + 422505;
 Libderiv->deriv_classes[3][4][11] = int_stack + 423765;
 Libderiv->deriv_classes[3][5][11] = int_stack + 423915;
 Libderiv->deriv_classes[3][6][11] = int_stack + 424125;
 Libderiv->deriv_classes[3][7][11] = int_stack + 424405;
 Libderiv->deriv_classes[3][8][11] = int_stack + 424765;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 425215;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 425365;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 425575;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 425855;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 426215;
 Libderiv->deriv_classes[4][4][11] = int_stack + 426665;
 Libderiv->deriv_classes[4][5][11] = int_stack + 426890;
 Libderiv->deriv_classes[4][6][11] = int_stack + 427205;
 Libderiv->deriv_classes[4][7][11] = int_stack + 427625;
 Libderiv->deriv_classes[4][8][11] = int_stack + 428165;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 428840;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 429065;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 429380;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 429800;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 430340;
 Libderiv->deriv_classes[5][4][11] = int_stack + 431015;
 Libderiv->deriv_classes[5][5][11] = int_stack + 431330;
 Libderiv->deriv_classes[5][6][11] = int_stack + 431771;
 Libderiv->deriv_classes[5][7][11] = int_stack + 432359;
 Libderiv->deriv_classes[5][8][11] = int_stack + 433115;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 434060;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 434375;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 434816;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 435404;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 436160;
 Libderiv->deriv2_classes[6][4][11] = int_stack + 437105;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 437525;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 438113;
 Libderiv->deriv2_classes[6][7][11] = int_stack + 438897;
 Libderiv->deriv2_classes[6][8][11] = int_stack + 439905;
 Libderiv->deriv_classes[3][4][10] = int_stack + 441165;
 Libderiv->deriv_classes[3][5][10] = int_stack + 441315;
 Libderiv->deriv_classes[3][6][10] = int_stack + 441525;
 Libderiv->deriv_classes[3][7][10] = int_stack + 441805;
 Libderiv->deriv_classes[3][8][10] = int_stack + 442165;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 442615;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 442765;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 442975;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 443255;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 443615;
 Libderiv->deriv_classes[4][4][10] = int_stack + 444065;
 Libderiv->deriv_classes[4][5][10] = int_stack + 444290;
 Libderiv->deriv_classes[4][6][10] = int_stack + 444605;
 Libderiv->deriv_classes[4][7][10] = int_stack + 445025;
 Libderiv->deriv_classes[4][8][10] = int_stack + 445565;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 446240;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 446465;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 446780;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 447200;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 447740;
 Libderiv->deriv_classes[5][4][10] = int_stack + 448415;
 Libderiv->deriv_classes[5][5][10] = int_stack + 448730;
 Libderiv->deriv_classes[5][6][10] = int_stack + 449171;
 Libderiv->deriv_classes[5][7][10] = int_stack + 449759;
 Libderiv->deriv_classes[5][8][10] = int_stack + 450515;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 451460;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 451775;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 452216;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 452804;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 453560;
 Libderiv->deriv2_classes[6][4][10] = int_stack + 454505;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 454925;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 455513;
 Libderiv->deriv2_classes[6][7][10] = int_stack + 456297;
 Libderiv->deriv2_classes[6][8][10] = int_stack + 457305;
 Libderiv->deriv_classes[3][4][9] = int_stack + 458565;
 Libderiv->deriv_classes[3][5][9] = int_stack + 458715;
 Libderiv->deriv_classes[3][6][9] = int_stack + 458925;
 Libderiv->deriv_classes[3][7][9] = int_stack + 459205;
 Libderiv->deriv_classes[3][8][9] = int_stack + 459565;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 460015;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 460165;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 460375;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 460655;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 461015;
 Libderiv->deriv_classes[4][4][9] = int_stack + 461465;
 Libderiv->deriv_classes[4][5][9] = int_stack + 461690;
 Libderiv->deriv_classes[4][6][9] = int_stack + 462005;
 Libderiv->deriv_classes[4][7][9] = int_stack + 462425;
 Libderiv->deriv_classes[4][8][9] = int_stack + 462965;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 463640;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 463865;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 464180;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 464600;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 465140;
 Libderiv->deriv_classes[5][4][9] = int_stack + 465815;
 Libderiv->deriv_classes[5][5][9] = int_stack + 466130;
 Libderiv->deriv_classes[5][6][9] = int_stack + 466571;
 Libderiv->deriv_classes[5][7][9] = int_stack + 467159;
 Libderiv->deriv_classes[5][8][9] = int_stack + 467915;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 468860;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 469175;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 469616;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 470204;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 470960;
 Libderiv->deriv2_classes[6][4][9] = int_stack + 471905;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 472325;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 472913;
 Libderiv->deriv2_classes[6][7][9] = int_stack + 473697;
 Libderiv->deriv2_classes[6][8][9] = int_stack + 474705;
 Libderiv->deriv_classes[3][4][8] = int_stack + 475965;
 Libderiv->deriv_classes[3][5][8] = int_stack + 476115;
 Libderiv->deriv_classes[3][6][8] = int_stack + 476325;
 Libderiv->deriv_classes[3][7][8] = int_stack + 476605;
 Libderiv->deriv_classes[3][8][8] = int_stack + 476965;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 477415;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 477565;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 477775;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 478055;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 478415;
 Libderiv->deriv_classes[4][4][8] = int_stack + 478865;
 Libderiv->deriv_classes[4][5][8] = int_stack + 479090;
 Libderiv->deriv_classes[4][6][8] = int_stack + 479405;
 Libderiv->deriv_classes[4][7][8] = int_stack + 479825;
 Libderiv->deriv_classes[4][8][8] = int_stack + 480365;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 481040;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 481265;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 481580;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 482000;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 482540;
 Libderiv->deriv_classes[5][4][8] = int_stack + 483215;
 Libderiv->deriv_classes[5][5][8] = int_stack + 483530;
 Libderiv->deriv_classes[5][6][8] = int_stack + 483971;
 Libderiv->deriv_classes[5][7][8] = int_stack + 484559;
 Libderiv->deriv_classes[5][8][8] = int_stack + 485315;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 486260;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 486575;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 487016;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 487604;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 488360;
 Libderiv->deriv2_classes[6][4][8] = int_stack + 489305;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 489725;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 490313;
 Libderiv->deriv2_classes[6][7][8] = int_stack + 491097;
 Libderiv->deriv2_classes[6][8][8] = int_stack + 492105;
 Libderiv->deriv_classes[3][4][7] = int_stack + 493365;
 Libderiv->deriv_classes[3][5][7] = int_stack + 493515;
 Libderiv->deriv_classes[3][6][7] = int_stack + 493725;
 Libderiv->deriv_classes[3][7][7] = int_stack + 494005;
 Libderiv->deriv_classes[3][8][7] = int_stack + 494365;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 494815;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 494965;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 495175;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 495455;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 495815;
 Libderiv->deriv_classes[4][4][7] = int_stack + 496265;
 Libderiv->deriv_classes[4][5][7] = int_stack + 496490;
 Libderiv->deriv_classes[4][6][7] = int_stack + 496805;
 Libderiv->deriv_classes[4][7][7] = int_stack + 497225;
 Libderiv->deriv_classes[4][8][7] = int_stack + 497765;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 498440;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 498665;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 498980;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 499400;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 499940;
 Libderiv->deriv_classes[5][4][7] = int_stack + 500615;
 Libderiv->deriv_classes[5][5][7] = int_stack + 500930;
 Libderiv->deriv_classes[5][6][7] = int_stack + 501371;
 Libderiv->deriv_classes[5][7][7] = int_stack + 501959;
 Libderiv->deriv_classes[5][8][7] = int_stack + 502715;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 503660;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 503975;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 504416;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 505004;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 505760;
 Libderiv->deriv2_classes[6][4][7] = int_stack + 506705;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 507125;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 507713;
 Libderiv->deriv2_classes[6][7][7] = int_stack + 508497;
 Libderiv->deriv2_classes[6][8][7] = int_stack + 509505;
 Libderiv->deriv_classes[3][4][6] = int_stack + 510765;
 Libderiv->deriv_classes[3][5][6] = int_stack + 510915;
 Libderiv->deriv_classes[3][6][6] = int_stack + 511125;
 Libderiv->deriv_classes[3][7][6] = int_stack + 511405;
 Libderiv->deriv_classes[3][8][6] = int_stack + 511765;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 512215;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 512365;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 512575;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 512855;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 513215;
 Libderiv->deriv_classes[4][4][6] = int_stack + 513665;
 Libderiv->deriv_classes[4][5][6] = int_stack + 513890;
 Libderiv->deriv_classes[4][6][6] = int_stack + 514205;
 Libderiv->deriv_classes[4][7][6] = int_stack + 514625;
 Libderiv->deriv_classes[4][8][6] = int_stack + 515165;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 515840;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 516065;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 516380;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 516800;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 517340;
 Libderiv->dvrr_classes[5][4] = int_stack + 518015;
 Libderiv->deriv_classes[5][4][6] = int_stack + 518330;
 Libderiv->dvrr_classes[5][5] = int_stack + 518645;
 Libderiv->deriv_classes[5][5][6] = int_stack + 519086;
 Libderiv->dvrr_classes[5][6] = int_stack + 519527;
 Libderiv->deriv_classes[5][6][6] = int_stack + 520115;
 Libderiv->dvrr_classes[5][7] = int_stack + 520703;
 Libderiv->deriv_classes[5][7][6] = int_stack + 521459;
 Libderiv->deriv_classes[5][8][6] = int_stack + 522215;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 523160;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 523475;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 523916;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 524504;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 525260;
 Libderiv->deriv_classes[6][4][0] = int_stack + 526205;
 Libderiv->deriv2_classes[6][4][6] = int_stack + 526625;
 Libderiv->deriv_classes[6][5][0] = int_stack + 527045;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 527633;
 Libderiv->deriv_classes[6][6][0] = int_stack + 528221;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 529005;
 Libderiv->deriv_classes[6][7][0] = int_stack + 529789;
 Libderiv->deriv2_classes[6][7][6] = int_stack + 530797;
 Libderiv->deriv2_classes[6][8][6] = int_stack + 531805;
 Libderiv->deriv_classes[3][4][2] = int_stack + 533065;
 Libderiv->deriv_classes[3][5][2] = int_stack + 533215;
 Libderiv->deriv_classes[3][6][2] = int_stack + 533425;
 Libderiv->deriv_classes[3][7][2] = int_stack + 533705;
 Libderiv->deriv_classes[3][8][2] = int_stack + 534065;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 534515;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 534665;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 534875;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 535155;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 535515;
 Libderiv->deriv_classes[4][4][2] = int_stack + 535965;
 Libderiv->deriv_classes[4][5][2] = int_stack + 536190;
 Libderiv->deriv_classes[4][6][2] = int_stack + 536505;
 Libderiv->deriv_classes[4][7][2] = int_stack + 536925;
 Libderiv->deriv_classes[4][8][2] = int_stack + 537465;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 538140;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 538365;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 538680;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 539100;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 539640;
 Libderiv->deriv_classes[5][4][2] = int_stack + 540315;
 Libderiv->deriv_classes[5][5][2] = int_stack + 540630;
 Libderiv->deriv_classes[5][6][2] = int_stack + 541071;
 Libderiv->deriv_classes[5][7][2] = int_stack + 541659;
 Libderiv->deriv_classes[5][8][2] = int_stack + 542415;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 543360;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 543675;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 544116;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 544704;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 545460;
 Libderiv->deriv2_classes[6][4][2] = int_stack + 546405;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 546825;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 547413;
 Libderiv->deriv2_classes[6][7][2] = int_stack + 548197;
 Libderiv->deriv2_classes[6][8][2] = int_stack + 549205;
 Libderiv->deriv_classes[3][4][1] = int_stack + 550465;
 Libderiv->deriv_classes[3][5][1] = int_stack + 550615;
 Libderiv->deriv_classes[3][6][1] = int_stack + 550825;
 Libderiv->deriv_classes[3][7][1] = int_stack + 551105;
 Libderiv->deriv_classes[3][8][1] = int_stack + 551465;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 551915;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 552065;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 552275;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 552555;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 552915;
 Libderiv->deriv_classes[4][4][1] = int_stack + 553365;
 Libderiv->deriv_classes[4][5][1] = int_stack + 553590;
 Libderiv->deriv_classes[4][6][1] = int_stack + 553905;
 Libderiv->deriv_classes[4][7][1] = int_stack + 554325;
 Libderiv->deriv_classes[4][8][1] = int_stack + 554865;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 555540;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 555765;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 556080;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 556500;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 557040;
 Libderiv->deriv_classes[5][4][1] = int_stack + 557715;
 Libderiv->deriv_classes[5][5][1] = int_stack + 558030;
 Libderiv->deriv_classes[5][6][1] = int_stack + 558471;
 Libderiv->deriv_classes[5][7][1] = int_stack + 559059;
 Libderiv->deriv_classes[5][8][1] = int_stack + 559815;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 560760;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 561075;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 561516;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 562104;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 562860;
 Libderiv->deriv2_classes[6][4][1] = int_stack + 563805;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 564225;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 564813;
 Libderiv->deriv2_classes[6][7][1] = int_stack + 565597;
 Libderiv->deriv2_classes[6][8][1] = int_stack + 566605;
 Libderiv->dvrr_classes[3][4] = int_stack + 567865;
 Libderiv->dvrr_classes[3][5] = int_stack + 568015;
 Libderiv->dvrr_classes[3][6] = int_stack + 568225;
 Libderiv->dvrr_classes[3][7] = int_stack + 568505;
 Libderiv->dvrr_classes[3][8] = int_stack + 568865;
 Libderiv->deriv_classes[3][4][0] = int_stack + 569315;
 Libderiv->deriv_classes[3][5][0] = int_stack + 569465;
 Libderiv->deriv_classes[3][6][0] = int_stack + 569675;
 Libderiv->deriv_classes[3][7][0] = int_stack + 569955;
 Libderiv->deriv_classes[3][8][0] = int_stack + 570315;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 570765;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 570915;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 571125;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 571405;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 571765;
 Libderiv->dvrr_classes[4][4] = int_stack + 572215;
 Libderiv->dvrr_classes[4][5] = int_stack + 572440;
 Libderiv->dvrr_classes[4][6] = int_stack + 572755;
 Libderiv->dvrr_classes[4][7] = int_stack + 573175;
 Libderiv->dvrr_classes[4][8] = int_stack + 573715;
 Libderiv->deriv_classes[4][4][0] = int_stack + 574390;
 Libderiv->deriv_classes[4][5][0] = int_stack + 574615;
 Libderiv->deriv_classes[4][6][0] = int_stack + 574930;
 Libderiv->deriv_classes[4][7][0] = int_stack + 575350;
 Libderiv->deriv_classes[4][8][0] = int_stack + 575890;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 576565;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 576790;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 577105;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 577525;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 578065;
 Libderiv->deriv_classes[5][4][0] = int_stack + 578740;
 Libderiv->deriv_classes[5][5][0] = int_stack + 579055;
 Libderiv->deriv_classes[5][6][0] = int_stack + 579496;
 Libderiv->deriv_classes[5][7][0] = int_stack + 580084;
 Libderiv->deriv_classes[5][8][0] = int_stack + 580840;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 581785;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 582100;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 582541;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 583129;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 583885;
 Libderiv->deriv2_classes[6][4][0] = int_stack + 584830;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 585250;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 585838;
 Libderiv->deriv2_classes[6][7][0] = int_stack + 586622;
 Libderiv->deriv2_classes[6][8][0] = int_stack + 587630;
 memset(int_stack,0,4711120);

 Libderiv->dvrr_stack = int_stack + 2271938;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ffgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+588890,int_stack+568015,int_stack+567865,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+589340,int_stack+568225,int_stack+568015,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+589970,int_stack+589340,int_stack+588890,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+590870,int_stack+568505,int_stack+568225,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+591710,int_stack+590870,int_stack+589340,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+592970,int_stack+591710,int_stack+589970,10);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+594470,int_stack+423915,int_stack+423765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+567865,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+594920,int_stack+424125,int_stack+423915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568015,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+595550,int_stack+594920,int_stack+594470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+596450,int_stack+424405,int_stack+424125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568225,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+597290,int_stack+596450,int_stack+594920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589340,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+598550,int_stack+597290,int_stack+595550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589970,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+600050,int_stack+424765,int_stack+424405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568505,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+601130,int_stack+600050,int_stack+596450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590870,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+602810,int_stack+601130,int_stack+597290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+591710,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+600050,int_stack+602810,int_stack+598550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592970,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+602300,int_stack+572440,int_stack+572215,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+602975,int_stack+572755,int_stack+572440,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+603920,int_stack+602975,int_stack+602300,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+605270,int_stack+573175,int_stack+572755,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+606530,int_stack+605270,int_stack+602975,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+608420,int_stack+606530,int_stack+603920,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+610670,int_stack+426890,int_stack+426665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+611345,int_stack+427205,int_stack+426890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572440,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+612290,int_stack+611345,int_stack+610670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+613640,int_stack+427625,int_stack+427205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572755,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+614900,int_stack+613640,int_stack+611345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602975,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+616790,int_stack+614900,int_stack+612290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603920,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+619040,int_stack+428165,int_stack+427625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573175,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+620660,int_stack+619040,int_stack+613640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605270,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+623180,int_stack+620660,int_stack+614900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606530,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+619040,int_stack+623180,int_stack+616790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608420,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+622415,int_stack+619040,int_stack+600050,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+629165,int_stack+518645,int_stack+518015,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+630110,int_stack+519527,int_stack+518645,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+631433,int_stack+630110,int_stack+629165,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+633323,int_stack+520703,int_stack+519527,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+635087,int_stack+633323,int_stack+630110,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+637733,int_stack+635087,int_stack+631433,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+640883,int_stack+431330,int_stack+431015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518015,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+641828,int_stack+431771,int_stack+431330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518645,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+643151,int_stack+641828,int_stack+640883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+645041,int_stack+432359,int_stack+431771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519527,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+646805,int_stack+645041,int_stack+641828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630110,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+649451,int_stack+646805,int_stack+643151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631433,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+652601,int_stack+433115,int_stack+432359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520703,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+654869,int_stack+652601,int_stack+645041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633323,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+658397,int_stack+654869,int_stack+646805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635087,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+652601,int_stack+658397,int_stack+649451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637733,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+657326,int_stack+652601,int_stack+619040,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+667451,int_stack+657326,int_stack+622415,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+680951,int_stack+249823,int_stack+248563,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+682211,int_stack+251587,int_stack+249823,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+683975,int_stack+682211,int_stack+680951,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+686495,int_stack+6300,int_stack+251587,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+688847,int_stack+686495,int_stack+682211,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+692375,int_stack+688847,int_stack+683975,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+696575,int_stack+181753,int_stack+180913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248563,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+697835,int_stack+182929,int_stack+181753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249823,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+699599,int_stack+697835,int_stack+696575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+702119,int_stack+184497,int_stack+182929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251587,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+704471,int_stack+702119,int_stack+697835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682211,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+707999,int_stack+704471,int_stack+699599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683975,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+712199,int_stack+0,int_stack+184497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+715223,int_stack+712199,int_stack+702119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686495,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+719927,int_stack+715223,int_stack+704471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688847,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+712199,int_stack+719927,int_stack+707999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692375,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+718499,int_stack+712199,int_stack+652601,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+732674,int_stack+718499,int_stack+657326,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+424765,int_stack+441315,int_stack+441165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+567865, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+712199,int_stack+441525,int_stack+441315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568015, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+712829,int_stack+712199,int_stack+424765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+713729,int_stack+441805,int_stack+441525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568225, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+713729,int_stack+712199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589340, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+714569,int_stack+0,int_stack+712829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589970, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+716069,int_stack+442165,int_stack+441805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568505, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+717149,int_stack+716069,int_stack+713729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590870, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+718829,int_stack+717149,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+591710, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+716069,int_stack+718829,int_stack+714569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592970, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+428165,int_stack+444290,int_stack+444065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+433115,int_stack+444605,int_stack+444290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572440, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+718319,int_stack+433115,int_stack+428165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+719669,int_stack+445025,int_stack+444605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572755, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+720929,int_stack+719669,int_stack+433115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602975, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+722819,int_stack+720929,int_stack+718319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603920, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+725069,int_stack+445565,int_stack+445025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573175, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+726689,int_stack+725069,int_stack+719669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605270, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+729209,int_stack+726689,int_stack+720929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606530, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+725069,int_stack+729209,int_stack+722819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608420, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+752924,int_stack+725069,int_stack+716069,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+728444,int_stack+448730,int_stack+448415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518015, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+729389,int_stack+449171,int_stack+448730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518645, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+730712,int_stack+729389,int_stack+728444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+759674,int_stack+449759,int_stack+449171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519527, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+761438,int_stack+759674,int_stack+729389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630110, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+764084,int_stack+761438,int_stack+730712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631433, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+767234,int_stack+450515,int_stack+449759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520703, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+769502,int_stack+767234,int_stack+759674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633323, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+773030,int_stack+769502,int_stack+761438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635087, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+767234,int_stack+773030,int_stack+764084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637733, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+771959,int_stack+767234,int_stack+725069,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+782084,int_stack+771959,int_stack+752924,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+795584,int_stack+195283,int_stack+194443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248563, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+796844,int_stack+196459,int_stack+195283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249823, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+798608,int_stack+796844,int_stack+795584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+801128,int_stack+198027,int_stack+196459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251587, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+803480,int_stack+801128,int_stack+796844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682211, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+807008,int_stack+803480,int_stack+798608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683975, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+811208,int_stack+1260,int_stack+198027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+814232,int_stack+811208,int_stack+801128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686495, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+818936,int_stack+814232,int_stack+803480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688847, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+811208,int_stack+818936,int_stack+807008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692375, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+817508,int_stack+811208,int_stack+767234,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+831683,int_stack+817508,int_stack+771959,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+442165,int_stack+458715,int_stack+458565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+567865, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+811208,int_stack+458925,int_stack+458715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568015, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+811838,int_stack+811208,int_stack+442165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812738,int_stack+459205,int_stack+458925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568225, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1260,int_stack+812738,int_stack+811208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589340, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+813578,int_stack+1260,int_stack+811838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589970, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815078,int_stack+459565,int_stack+459205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568505, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+816158,int_stack+815078,int_stack+812738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590870, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+817838,int_stack+816158,int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+591710, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+815078,int_stack+817838,int_stack+813578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592970, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+445565,int_stack+461690,int_stack+461465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+450515,int_stack+462005,int_stack+461690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572440, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+817328,int_stack+450515,int_stack+445565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+818678,int_stack+462425,int_stack+462005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572755, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+819938,int_stack+818678,int_stack+450515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602975, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+821828,int_stack+819938,int_stack+817328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603920, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+824078,int_stack+462965,int_stack+462425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573175, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+825698,int_stack+824078,int_stack+818678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605270, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+828218,int_stack+825698,int_stack+819938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606530, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+824078,int_stack+828218,int_stack+821828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608420, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+851933,int_stack+824078,int_stack+815078,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+827453,int_stack+466130,int_stack+465815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518015, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+828398,int_stack+466571,int_stack+466130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518645, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+829721,int_stack+828398,int_stack+827453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+858683,int_stack+467159,int_stack+466571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519527, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+860447,int_stack+858683,int_stack+828398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630110, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+863093,int_stack+860447,int_stack+829721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631433, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+866243,int_stack+467915,int_stack+467159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520703, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+868511,int_stack+866243,int_stack+858683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633323, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+872039,int_stack+868511,int_stack+860447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635087, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+866243,int_stack+872039,int_stack+863093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637733, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+870968,int_stack+866243,int_stack+824078,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+881093,int_stack+870968,int_stack+851933,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+894593,int_stack+208813,int_stack+207973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248563, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+895853,int_stack+209989,int_stack+208813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249823, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+897617,int_stack+895853,int_stack+894593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+900137,int_stack+211557,int_stack+209989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251587, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+902489,int_stack+900137,int_stack+895853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682211, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+906017,int_stack+902489,int_stack+897617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683975, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+910217,int_stack+2520,int_stack+211557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+913241,int_stack+910217,int_stack+900137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686495, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+917945,int_stack+913241,int_stack+902489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688847, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+910217,int_stack+917945,int_stack+906017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692375, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+916517,int_stack+910217,int_stack+866243,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+930692,int_stack+916517,int_stack+870968,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+459565,int_stack+476115,int_stack+475965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+567865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+910217,int_stack+476325,int_stack+476115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+910847,int_stack+910217,int_stack+459565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+911747,int_stack+476605,int_stack+476325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2520,int_stack+911747,int_stack+910217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+912587,int_stack+2520,int_stack+910847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+914087,int_stack+476965,int_stack+476605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+568505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+915167,int_stack+914087,int_stack+911747, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+916847,int_stack+915167,int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+591710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+914087,int_stack+916847,int_stack+912587, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+462965,int_stack+479090,int_stack+478865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+467915,int_stack+479405,int_stack+479090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+916337,int_stack+467915,int_stack+462965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+917687,int_stack+479825,int_stack+479405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+918947,int_stack+917687,int_stack+467915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+920837,int_stack+918947,int_stack+916337, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+923087,int_stack+480365,int_stack+479825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+573175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+924707,int_stack+923087,int_stack+917687, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+927227,int_stack+924707,int_stack+918947, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+923087,int_stack+927227,int_stack+920837, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+950942,int_stack+923087,int_stack+914087,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+926462,int_stack+483530,int_stack+483215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+927407,int_stack+483971,int_stack+483530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+928730,int_stack+927407,int_stack+926462, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+957692,int_stack+484559,int_stack+483971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+959456,int_stack+957692,int_stack+927407, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+962102,int_stack+959456,int_stack+928730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+965252,int_stack+485315,int_stack+484559, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+967520,int_stack+965252,int_stack+957692, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+633323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+971048,int_stack+967520,int_stack+959456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+965252,int_stack+971048,int_stack+962102, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+637733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+969977,int_stack+965252,int_stack+923087,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+980102,int_stack+969977,int_stack+950942,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+993602,int_stack+222343,int_stack+221503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+994862,int_stack+223519,int_stack+222343, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+996626,int_stack+994862,int_stack+993602, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+999146,int_stack+225087,int_stack+223519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1001498,int_stack+999146,int_stack+994862, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1005026,int_stack+1001498,int_stack+996626, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1009226,int_stack+3780,int_stack+225087, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1012250,int_stack+1009226,int_stack+999146, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1016954,int_stack+1012250,int_stack+1001498, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1009226,int_stack+1016954,int_stack+1005026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+692375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1015526,int_stack+1009226,int_stack+965252,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1029701,int_stack+1015526,int_stack+969977,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+476965,int_stack+493515,int_stack+493365, 0.0, zero_stack, 1.0, int_stack+567865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1009226,int_stack+493725,int_stack+493515, 0.0, zero_stack, 1.0, int_stack+568015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1009856,int_stack+1009226,int_stack+476965, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1010756,int_stack+494005,int_stack+493725, 0.0, zero_stack, 1.0, int_stack+568225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3780,int_stack+1010756,int_stack+1009226, 0.0, zero_stack, 1.0, int_stack+589340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1011596,int_stack+3780,int_stack+1009856, 0.0, zero_stack, 1.0, int_stack+589970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1013096,int_stack+494365,int_stack+494005, 0.0, zero_stack, 1.0, int_stack+568505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1014176,int_stack+1013096,int_stack+1010756, 0.0, zero_stack, 1.0, int_stack+590870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015856,int_stack+1014176,int_stack+3780, 0.0, zero_stack, 1.0, int_stack+591710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1013096,int_stack+1015856,int_stack+1011596, 0.0, zero_stack, 1.0, int_stack+592970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+480365,int_stack+496490,int_stack+496265, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+485315,int_stack+496805,int_stack+496490, 0.0, zero_stack, 1.0, int_stack+572440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1015346,int_stack+485315,int_stack+480365, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1016696,int_stack+497225,int_stack+496805, 0.0, zero_stack, 1.0, int_stack+572755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1017956,int_stack+1016696,int_stack+485315, 0.0, zero_stack, 1.0, int_stack+602975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1019846,int_stack+1017956,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+603920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1022096,int_stack+497765,int_stack+497225, 0.0, zero_stack, 1.0, int_stack+573175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1023716,int_stack+1022096,int_stack+1016696, 0.0, zero_stack, 1.0, int_stack+605270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1026236,int_stack+1023716,int_stack+1017956, 0.0, zero_stack, 1.0, int_stack+606530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1022096,int_stack+1026236,int_stack+1019846, 0.0, zero_stack, 1.0, int_stack+608420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1049951,int_stack+1022096,int_stack+1013096,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1025471,int_stack+500930,int_stack+500615, 0.0, zero_stack, 1.0, int_stack+518015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1026416,int_stack+501371,int_stack+500930, 0.0, zero_stack, 1.0, int_stack+518645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1027739,int_stack+1026416,int_stack+1025471, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1056701,int_stack+501959,int_stack+501371, 0.0, zero_stack, 1.0, int_stack+519527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1058465,int_stack+1056701,int_stack+1026416, 0.0, zero_stack, 1.0, int_stack+630110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1061111,int_stack+1058465,int_stack+1027739, 0.0, zero_stack, 1.0, int_stack+631433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1064261,int_stack+502715,int_stack+501959, 0.0, zero_stack, 1.0, int_stack+520703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1066529,int_stack+1064261,int_stack+1056701, 0.0, zero_stack, 1.0, int_stack+633323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1070057,int_stack+1066529,int_stack+1058465, 0.0, zero_stack, 1.0, int_stack+635087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1064261,int_stack+1070057,int_stack+1061111, 0.0, zero_stack, 1.0, int_stack+637733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1068986,int_stack+1064261,int_stack+1022096,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1079111,int_stack+1068986,int_stack+1049951,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1092611,int_stack+235873,int_stack+235033, 0.0, zero_stack, 1.0, int_stack+248563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1093871,int_stack+237049,int_stack+235873, 0.0, zero_stack, 1.0, int_stack+249823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1095635,int_stack+1093871,int_stack+1092611, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1098155,int_stack+238617,int_stack+237049, 0.0, zero_stack, 1.0, int_stack+251587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1100507,int_stack+1098155,int_stack+1093871, 0.0, zero_stack, 1.0, int_stack+682211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1104035,int_stack+1100507,int_stack+1095635, 0.0, zero_stack, 1.0, int_stack+683975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1108235,int_stack+5040,int_stack+238617, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1111259,int_stack+1108235,int_stack+1098155, 0.0, zero_stack, 1.0, int_stack+686495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1115963,int_stack+1111259,int_stack+1100507, 0.0, zero_stack, 1.0, int_stack+688847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1108235,int_stack+1115963,int_stack+1104035, 0.0, zero_stack, 1.0, int_stack+692375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1114535,int_stack+1108235,int_stack+1064261,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1128710,int_stack+1114535,int_stack+1068986,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+494365,int_stack+510915,int_stack+510765, 1.0, int_stack+567865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1108235,int_stack+511125,int_stack+510915, 1.0, int_stack+568015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1108865,int_stack+1108235,int_stack+494365, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1109765,int_stack+511405,int_stack+511125, 1.0, int_stack+568225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5040,int_stack+1109765,int_stack+1108235, 1.0, int_stack+589340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1110605,int_stack+5040,int_stack+1108865, 1.0, int_stack+589970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+588890,int_stack+511765,int_stack+511405, 1.0, int_stack+568505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1112105,int_stack+588890,int_stack+1109765, 1.0, int_stack+590870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1113785,int_stack+1112105,int_stack+5040, 1.0, int_stack+591710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1115885,int_stack+1113785,int_stack+1110605, 1.0, int_stack+592970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+497765,int_stack+513890,int_stack+513665, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+502715,int_stack+514205,int_stack+513890, 1.0, int_stack+572440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1112105,int_stack+502715,int_stack+497765, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1113455,int_stack+514625,int_stack+514205, 1.0, int_stack+572755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+1113455,int_stack+502715, 1.0, int_stack+602975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1118135,int_stack+588890,int_stack+1112105, 1.0, int_stack+603920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+602300,int_stack+515165,int_stack+514625, 1.0, int_stack+573175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1120385,int_stack+602300,int_stack+1113455, 1.0, int_stack+605270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1122905,int_stack+1120385,int_stack+588890, 1.0, int_stack+606530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1148960,int_stack+1122905,int_stack+1118135, 1.0, int_stack+608420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1120385,int_stack+1148960,int_stack+1115885,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1127135,int_stack+519086,int_stack+518330, 1.0, int_stack+518015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+602300,int_stack+520115,int_stack+519086, 1.0, int_stack+518645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1152335,int_stack+602300,int_stack+1127135, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1154225,int_stack+521459,int_stack+520115, 1.0, int_stack+519527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1155989,int_stack+1154225,int_stack+602300, 1.0, int_stack+630110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1158635,int_stack+1155989,int_stack+1152335, 1.0, int_stack+631433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+629165,int_stack+522215,int_stack+521459, 1.0, int_stack+520703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1161785,int_stack+629165,int_stack+1154225, 1.0, int_stack+633323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1165313,int_stack+1161785,int_stack+1155989, 1.0, int_stack+635087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1169723,int_stack+1165313,int_stack+1158635, 1.0, int_stack+637733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1174448,int_stack+1169723,int_stack+1148960,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1184573,int_stack+1174448,int_stack+1120385,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1161785,int_stack+250411,int_stack+248983, 1.0, int_stack+248563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1163045,int_stack+252371,int_stack+250411, 1.0, int_stack+249823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1164809,int_stack+1163045,int_stack+1161785, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1167329,int_stack+253939,int_stack+252371, 1.0, int_stack+251587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+629165,int_stack+1167329,int_stack+1163045, 1.0, int_stack+682211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+629165,int_stack+1164809, 1.0, int_stack+683975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+680951,int_stack+7308,int_stack+253939, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1202273,int_stack+680951,int_stack+1167329, 1.0, int_stack+686495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+680951,int_stack+1202273,int_stack+629165, 1.0, int_stack+688847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1202273,int_stack+680951,int_stack+1198073, 1.0, int_stack+692375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+680951,int_stack+1202273,int_stack+1169723,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1202273,int_stack+680951,int_stack+1174448,225);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+680951,int_stack+568865,int_stack+568505,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+682031,int_stack+680951,int_stack+590870,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+683711,int_stack+682031,int_stack+591710,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+680951,int_stack+683711,int_stack+592970,10);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+683201,int_stack+573715,int_stack+573175,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+684821,int_stack+683201,int_stack+605270,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+687341,int_stack+684821,int_stack+606530,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+683201,int_stack+687341,int_stack+608420,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+686576,int_stack+683201,int_stack+680951,225);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6300,int_stack+11088,int_stack+520703,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+6300,int_stack+633323,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1222523,int_stack+603623,int_stack+635087,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+1222523,int_stack+637733,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1222523,int_stack+603623,int_stack+683201,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1232648,int_stack+1222523,int_stack+686576,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+511765,int_stack+533215,int_stack+533065,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1128080,int_stack+533425,int_stack+533215,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+608348,int_stack+1128080,int_stack+511765,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+609248,int_stack+533705,int_stack+533425,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6300,int_stack+609248,int_stack+1128080,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+693326,int_stack+6300,int_stack+608348,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+694826,int_stack+534065,int_stack+533705,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+632693,int_stack+694826,int_stack+609248,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+634373,int_stack+632693,int_stack+6300,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+636473,int_stack+634373,int_stack+693326,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+515165,int_stack+536190,int_stack+535965,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11088,int_stack+536505,int_stack+536190,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+632693,int_stack+11088,int_stack+515165,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+634043,int_stack+536925,int_stack+536505,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+638723,int_stack+634043,int_stack+11088,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+590780,int_stack+638723,int_stack+632693,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+694826,int_stack+537465,int_stack+536925,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1246148,int_stack+694826,int_stack+634043,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1248668,int_stack+1246148,int_stack+638723,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1251818,int_stack+1248668,int_stack+590780,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1255193,int_stack+1251818,int_stack+636473, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+522215,int_stack+540630,int_stack+540315,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1246148,int_stack+541071,int_stack+540630,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1247471,int_stack+1246148,int_stack+522215,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1249361,int_stack+541659,int_stack+541071,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1261943,int_stack+1249361,int_stack+1246148,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1264589,int_stack+1261943,int_stack+1247471,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1267739,int_stack+542415,int_stack+541659,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1270007,int_stack+1267739,int_stack+1249361,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1273535,int_stack+1270007,int_stack+1261943,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1267739,int_stack+1273535,int_stack+1264589,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1272464,int_stack+1267739,int_stack+1251818, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1282589,int_stack+1272464,int_stack+1255193, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+694826,int_stack+318375,int_stack+317535,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+572215,int_stack+319551,int_stack+318375,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1296089,int_stack+572215,int_stack+694826,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1298609,int_stack+321119,int_stack+319551,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1300961,int_stack+1298609,int_stack+572215,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1304489,int_stack+1300961,int_stack+1296089,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1308689,int_stack+8568,int_stack+321119,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1311713,int_stack+1308689,int_stack+1298609,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1316417,int_stack+1311713,int_stack+1300961,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1308689,int_stack+1316417,int_stack+1304489,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1314989,int_stack+1308689,int_stack+1267739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+603623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1329164,int_stack+1314989,int_stack+1272464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+534065,int_stack+550615,int_stack+550465,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1308689,int_stack+550825,int_stack+550615,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1309319,int_stack+1308689,int_stack+534065,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1310219,int_stack+551105,int_stack+550825,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1311059,int_stack+1310219,int_stack+1308689,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1312319,int_stack+1311059,int_stack+1309319,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1313819,int_stack+551465,int_stack+551105,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1314899,int_stack+1313819,int_stack+1310219,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1316579,int_stack+1314899,int_stack+1311059,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1313819,int_stack+1316579,int_stack+1312319,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+537465,int_stack+553590,int_stack+553365,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+542415,int_stack+553905,int_stack+553590,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1316069,int_stack+542415,int_stack+537465,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1317419,int_stack+554325,int_stack+553905,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1318679,int_stack+1317419,int_stack+542415,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1320569,int_stack+1318679,int_stack+1316069,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1322819,int_stack+554865,int_stack+554325,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1324439,int_stack+1322819,int_stack+1317419,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1349414,int_stack+1324439,int_stack+1318679,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1322819,int_stack+1349414,int_stack+1320569,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1349414,int_stack+1322819,int_stack+1313819, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1326194,int_stack+558030,int_stack+557715,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1327139,int_stack+558471,int_stack+558030,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+7560,int_stack+1327139,int_stack+1326194,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1356164,int_stack+559059,int_stack+558471,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1357928,int_stack+1356164,int_stack+1327139,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1360574,int_stack+1357928,int_stack+7560,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1363724,int_stack+559815,int_stack+559059,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1365992,int_stack+1363724,int_stack+1356164,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1369520,int_stack+1365992,int_stack+1357928,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1363724,int_stack+1369520,int_stack+1360574,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1368449,int_stack+1363724,int_stack+1322819, 0.0, zero_stack, 1.0, int_stack+683201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1378574,int_stack+1368449,int_stack+1349414, 0.0, zero_stack, 1.0, int_stack+686576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+593030,int_stack+396285,int_stack+395445,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1392074,int_stack+397461,int_stack+396285,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1393838,int_stack+1392074,int_stack+593030,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1396358,int_stack+399029,int_stack+397461,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1398710,int_stack+1396358,int_stack+1392074,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1402238,int_stack+1398710,int_stack+1393838,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1406438,int_stack+9828,int_stack+399029,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1409462,int_stack+1406438,int_stack+1396358,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1414166,int_stack+1409462,int_stack+1398710,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1406438,int_stack+1414166,int_stack+1402238,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1412738,int_stack+1406438,int_stack+1363724, 0.0, zero_stack, 1.0, int_stack+603623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1426913,int_stack+1412738,int_stack+1368449, 0.0, zero_stack, 1.0, int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+551465,int_stack+569465,int_stack+569315,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1406438,int_stack+569675,int_stack+569465,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1407068,int_stack+1406438,int_stack+551465,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1407968,int_stack+569955,int_stack+569675,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1408808,int_stack+1407968,int_stack+1406438,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1410068,int_stack+1408808,int_stack+1407068,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1411568,int_stack+570315,int_stack+569955,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1412648,int_stack+1411568,int_stack+1407968,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1414328,int_stack+1412648,int_stack+1408808,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1411568,int_stack+1414328,int_stack+1410068,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+554865,int_stack+574615,int_stack+574390,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+559815,int_stack+574930,int_stack+574615,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1413818,int_stack+559815,int_stack+554865,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1415168,int_stack+575350,int_stack+574930,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1416428,int_stack+1415168,int_stack+559815,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1418318,int_stack+1416428,int_stack+1413818,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1420568,int_stack+575890,int_stack+575350,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1422188,int_stack+1420568,int_stack+1415168,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1447163,int_stack+1422188,int_stack+1416428,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1420568,int_stack+1447163,int_stack+1418318,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1447163,int_stack+1420568,int_stack+1411568, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+680951,int_stack+579055,int_stack+578740,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1423943,int_stack+579496,int_stack+579055,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1453913,int_stack+1423943,int_stack+680951,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1455803,int_stack+580084,int_stack+579496,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1457567,int_stack+1455803,int_stack+1423943,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1460213,int_stack+1457567,int_stack+1453913,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1463363,int_stack+580840,int_stack+580084,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1465631,int_stack+1463363,int_stack+1455803,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1469159,int_stack+1465631,int_stack+1457567,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1463363,int_stack+1469159,int_stack+1460213,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1468088,int_stack+1463363,int_stack+1420568, 1.0, int_stack+683201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1478213,int_stack+1468088,int_stack+1447163, 1.0, int_stack+686576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+681896,int_stack+527045,int_stack+526205,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+683156,int_stack+528221,int_stack+527045,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+684920,int_stack+683156,int_stack+681896,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+687440,int_stack+529789,int_stack+528221,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+689792,int_stack+687440,int_stack+683156,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1491713,int_stack+689792,int_stack+684920,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1495913,int_stack+12033,int_stack+529789,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1498937,int_stack+1495913,int_stack+687440,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1503641,int_stack+1498937,int_stack+689792,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1495913,int_stack+1503641,int_stack+1491713,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1502213,int_stack+1495913,int_stack+1463363, 1.0, int_stack+603623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1516388,int_stack+1502213,int_stack+1468088, 1.0, int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+13443,int_stack+13293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+423765,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1222523,int_stack+13653,int_stack+13443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+423915,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1223153,int_stack+1222523,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+594470,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1224053,int_stack+13933,int_stack+13653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+424125,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1224893,int_stack+1224053,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+594920,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1226153,int_stack+1224893,int_stack+1223153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+595550,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1222523,int_stack+14293,int_stack+13933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+424405,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1227653,int_stack+1222523,int_stack+1224053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+596450,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1222523,int_stack+1227653,int_stack+1224893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+597290,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1227653,int_stack+1222523,int_stack+1226153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+598550,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+575890,int_stack+14968,int_stack+14743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+426665,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+15283,int_stack+14968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+426890,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1222523,int_stack+580840,int_stack+575890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+610670,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1223873,int_stack+15703,int_stack+15283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+427205,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1225133,int_stack+1223873,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+611345,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1229903,int_stack+1225133,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+612290,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+603623,int_stack+16243,int_stack+15703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+427625,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+605243,int_stack+603623,int_stack+1223873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+613640,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1495913,int_stack+605243,int_stack+1225133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+614900,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+1495913,int_stack+1229903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+616790,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1495913,int_stack+603623,int_stack+1227653,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+17233,int_stack+16918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+431015,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1502663,int_stack+17674,int_stack+17233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+431330,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1503986,int_stack+1502663,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+640883,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1505876,int_stack+18262,int_stack+17674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+431771,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1507640,int_stack+1505876,int_stack+1502663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+641828,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1510286,int_stack+1507640,int_stack+1503986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+643151,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1502663,int_stack+19018,int_stack+18262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+432359,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1222523,int_stack+1502663,int_stack+1505876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+645041,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1502663,int_stack+1222523,int_stack+1507640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+646805,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1222523,int_stack+1502663,int_stack+1510286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+649451,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1502663,int_stack+1222523,int_stack+603623,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1536638,int_stack+1502663,int_stack+1495913,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1495913,int_stack+20383,int_stack+19963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+180913,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1497173,int_stack+20971,int_stack+20383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+181753,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1498937,int_stack+1497173,int_stack+1495913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+696575,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+603623,int_stack+21755,int_stack+20971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+182929,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1512788,int_stack+603623,int_stack+1497173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+697835,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1227248,int_stack+1512788,int_stack+1498937, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+699599,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1495913,int_stack+22763,int_stack+21755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+184497,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12033,int_stack+1495913,int_stack+603623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+702119,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1495913,int_stack+12033,int_stack+1512788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+704471,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12033,int_stack+1495913,int_stack+1227248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+707999,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1550138,int_stack+12033,int_stack+1222523,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1564313,int_stack+1550138,int_stack+1502663,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+24173,int_stack+24023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423765, 1.0, int_stack+441165,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1550138,int_stack+24383,int_stack+24173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423915, 1.0, int_stack+441315,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1550768,int_stack+1550138,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594470, 1.0, int_stack+424765,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1551668,int_stack+24663,int_stack+24383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424125, 1.0, int_stack+441525,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1552508,int_stack+1551668,int_stack+1550138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594920, 1.0, int_stack+712199,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1553768,int_stack+1552508,int_stack+1550768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595550, 1.0, int_stack+712829,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1550138,int_stack+25023,int_stack+24663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424405, 1.0, int_stack+441805,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1555268,int_stack+1550138,int_stack+1551668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596450, 1.0, int_stack+713729,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1550138,int_stack+1555268,int_stack+1552508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597290, 1.0, int_stack+0,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1555268,int_stack+1550138,int_stack+1553768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598550, 1.0, int_stack+714569,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+575890,int_stack+25698,int_stack+25473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426665, 1.0, int_stack+444065,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+26013,int_stack+25698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426890, 1.0, int_stack+444290,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1550138,int_stack+580840,int_stack+575890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610670, 1.0, int_stack+428165,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1551488,int_stack+26433,int_stack+26013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427205, 1.0, int_stack+444605,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1552748,int_stack+1551488,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611345, 1.0, int_stack+433115,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1557518,int_stack+1552748,int_stack+1550138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612290, 1.0, int_stack+718319,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1559768,int_stack+26973,int_stack+26433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427625, 1.0, int_stack+445025,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1561388,int_stack+1559768,int_stack+1551488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613640, 1.0, int_stack+719669,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1222523,int_stack+1561388,int_stack+1552748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614900, 1.0, int_stack+720929,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1559768,int_stack+1222523,int_stack+1557518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616790, 1.0, int_stack+722819,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1222523,int_stack+1559768,int_stack+1555268,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+27963,int_stack+27648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431015, 1.0, int_stack+448415,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1229273,int_stack+28404,int_stack+27963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431330, 1.0, int_stack+448730,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1230596,int_stack+1229273,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640883, 1.0, int_stack+728444,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1550138,int_stack+28992,int_stack+28404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431771, 1.0, int_stack+449171,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1551902,int_stack+1550138,int_stack+1229273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641828, 1.0, int_stack+729389,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1554548,int_stack+1551902,int_stack+1230596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643151, 1.0, int_stack+730712,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1229273,int_stack+29748,int_stack+28992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432359, 1.0, int_stack+449759,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12033,int_stack+1229273,int_stack+1550138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645041, 1.0, int_stack+759674,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15561,int_stack+12033,int_stack+1551902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+646805, 1.0, int_stack+761438,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+15561,int_stack+1554548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649451, 1.0, int_stack+764084,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1559768,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1550138,int_stack+12033,int_stack+1222523,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1222523,int_stack+31113,int_stack+30693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180913, 1.0, int_stack+194443,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1223783,int_stack+31701,int_stack+31113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181753, 1.0, int_stack+195283,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1225547,int_stack+1223783,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+696575, 1.0, int_stack+795584,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1228067,int_stack+32485,int_stack+31701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182929, 1.0, int_stack+196459,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22158,int_stack+1228067,int_stack+1223783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697835, 1.0, int_stack+796844,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+25686,int_stack+22158,int_stack+1225547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699599, 1.0, int_stack+798608,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1222523,int_stack+33493,int_stack+32485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184497, 1.0, int_stack+198027,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+29886,int_stack+1222523,int_stack+1228067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702119, 1.0, int_stack+801128,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1222523,int_stack+29886,int_stack+22158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704471, 1.0, int_stack+803480,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1495913,int_stack+1222523,int_stack+25686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707999, 1.0, int_stack+807008,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1502213,int_stack+1495913,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1584563,int_stack+1502213,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+34903,int_stack+34753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+441165, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+35113,int_stack+34903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+441315, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+424765, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+35393,int_stack+35113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+441525, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+712199, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+712829, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+35753,int_stack+35393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+441805, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+713729, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+714569, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+36428,int_stack+36203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+444065, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+36743,int_stack+36428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+444290, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+428165, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+37163,int_stack+36743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+444605, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+433115, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718319, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21663,int_stack+37703,int_stack+37163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+445025, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+23283,int_stack+21663,int_stack+13383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+719669, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+25803,int_stack+23283,int_stack+14643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+720929, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+21663,int_stack+25803,int_stack+19413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+722819, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+25038,int_stack+21663,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+38693,int_stack+38378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+448415, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31788,int_stack+39134,int_stack+38693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+448730, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33111,int_stack+31788,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+728444, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+35001,int_stack+39722,int_stack+39134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+449171, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+36765,int_stack+35001,int_stack+31788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+729389, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12033,int_stack+36765,int_stack+33111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+730712, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31788,int_stack+40478,int_stack+39722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+449759, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15183,int_stack+31788,int_stack+35001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+759674, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+31788,int_stack+15183,int_stack+36765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+761438, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+31788,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+764084, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1222523,int_stack+603623,int_stack+21663,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1495913,int_stack+1222523,int_stack+25038,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12033,int_stack+41843,int_stack+41423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+194443, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13293,int_stack+42431,int_stack+41843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+195283, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15057,int_stack+13293,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+795584, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17577,int_stack+43215,int_stack+42431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+196459, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19929,int_stack+17577,int_stack+13293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+796844, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+23457,int_stack+19929,int_stack+15057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+798608, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+44223,int_stack+43215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+198027, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27657,int_stack+12033,int_stack+17577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+801128, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+27657,int_stack+19929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+803480, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+27657,int_stack+12033,int_stack+23457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+807008, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+12033,int_stack+27657,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1604813,int_stack+12033,int_stack+1222523,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+45633,int_stack+45483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423765, 0.0, zero_stack, 1.0, int_stack+458565,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1222523,int_stack+45843,int_stack+45633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423915, 0.0, zero_stack, 1.0, int_stack+458715,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1223153,int_stack+1222523,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594470, 0.0, zero_stack, 1.0, int_stack+442165,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1224053,int_stack+46123,int_stack+45843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424125, 0.0, zero_stack, 1.0, int_stack+458925,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1224893,int_stack+1224053,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594920, 0.0, zero_stack, 1.0, int_stack+811208,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1226153,int_stack+1224893,int_stack+1223153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595550, 0.0, zero_stack, 1.0, int_stack+811838,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1222523,int_stack+46483,int_stack+46123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424405, 0.0, zero_stack, 1.0, int_stack+459205,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1227653,int_stack+1222523,int_stack+1224053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596450, 0.0, zero_stack, 1.0, int_stack+812738,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1222523,int_stack+1227653,int_stack+1224893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597290, 0.0, zero_stack, 1.0, int_stack+1260,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1227653,int_stack+1222523,int_stack+1226153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598550, 0.0, zero_stack, 1.0, int_stack+813578,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+47158,int_stack+46933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426665, 0.0, zero_stack, 1.0, int_stack+461465,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+47473,int_stack+47158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426890, 0.0, zero_stack, 1.0, int_stack+461690,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1222523,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610670, 0.0, zero_stack, 1.0, int_stack+445565,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1223873,int_stack+47893,int_stack+47473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427205, 0.0, zero_stack, 1.0, int_stack+462005,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1225133,int_stack+1223873,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611345, 0.0, zero_stack, 1.0, int_stack+450515,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1229903,int_stack+1225133,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612290, 0.0, zero_stack, 1.0, int_stack+817328,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+48433,int_stack+47893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427625, 0.0, zero_stack, 1.0, int_stack+462425,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13653,int_stack+12033,int_stack+1223873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613640, 0.0, zero_stack, 1.0, int_stack+818678,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16173,int_stack+13653,int_stack+1225133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614900, 0.0, zero_stack, 1.0, int_stack+819938,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12033,int_stack+16173,int_stack+1229903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616790, 0.0, zero_stack, 1.0, int_stack+821828,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+15408,int_stack+12033,int_stack+1227653,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+49423,int_stack+49108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431015, 0.0, zero_stack, 1.0, int_stack+465815,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22158,int_stack+49864,int_stack+49423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431330, 0.0, zero_stack, 1.0, int_stack+466130,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+23481,int_stack+22158,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640883, 0.0, zero_stack, 1.0, int_stack+827453,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25371,int_stack+50452,int_stack+49864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431771, 0.0, zero_stack, 1.0, int_stack+466571,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27135,int_stack+25371,int_stack+22158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641828, 0.0, zero_stack, 1.0, int_stack+828398,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+29781,int_stack+27135,int_stack+23481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643151, 0.0, zero_stack, 1.0, int_stack+829721,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22158,int_stack+51208,int_stack+50452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432359, 0.0, zero_stack, 1.0, int_stack+467159,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32931,int_stack+22158,int_stack+25371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645041, 0.0, zero_stack, 1.0, int_stack+858683,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+22158,int_stack+32931,int_stack+27135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+646805, 0.0, zero_stack, 1.0, int_stack+860447,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+22158,int_stack+29781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649451, 0.0, zero_stack, 1.0, int_stack+863093,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1222523,int_stack+603623,int_stack+12033,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+22158,int_stack+1222523,int_stack+15408,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12033,int_stack+52573,int_stack+52153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180913, 0.0, zero_stack, 1.0, int_stack+207973,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13293,int_stack+53161,int_stack+52573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181753, 0.0, zero_stack, 1.0, int_stack+208813,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15057,int_stack+13293,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+696575, 0.0, zero_stack, 1.0, int_stack+894593,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17577,int_stack+53945,int_stack+53161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182929, 0.0, zero_stack, 1.0, int_stack+209989,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+35658,int_stack+17577,int_stack+13293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697835, 0.0, zero_stack, 1.0, int_stack+895853,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+39186,int_stack+35658,int_stack+15057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699599, 0.0, zero_stack, 1.0, int_stack+897617,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+54953,int_stack+53945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184497, 0.0, zero_stack, 1.0, int_stack+211557,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43386,int_stack+12033,int_stack+17577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702119, 0.0, zero_stack, 1.0, int_stack+900137,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+43386,int_stack+35658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704471, 0.0, zero_stack, 1.0, int_stack+902489,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+43386,int_stack+12033,int_stack+39186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707999, 0.0, zero_stack, 1.0, int_stack+906017,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1625063,int_stack+43386,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+35658,int_stack+1625063,int_stack+1222523,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+56363,int_stack+56213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441165, 1.0, int_stack+458565, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1222523,int_stack+56573,int_stack+56363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441315, 1.0, int_stack+458715, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1223153,int_stack+1222523,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424765, 1.0, int_stack+442165, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1224053,int_stack+56853,int_stack+56573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441525, 1.0, int_stack+458925, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1224893,int_stack+1224053,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712199, 1.0, int_stack+811208, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1226153,int_stack+1224893,int_stack+1223153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712829, 1.0, int_stack+811838, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1222523,int_stack+57213,int_stack+56853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441805, 1.0, int_stack+459205, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1227653,int_stack+1222523,int_stack+1224053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713729, 1.0, int_stack+812738, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1222523,int_stack+1227653,int_stack+1224893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1260, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1227653,int_stack+1222523,int_stack+1226153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714569, 1.0, int_stack+813578, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+57888,int_stack+57663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444065, 1.0, int_stack+461465, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+58203,int_stack+57888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444290, 1.0, int_stack+461690, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1222523,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428165, 1.0, int_stack+445565, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1223873,int_stack+58623,int_stack+58203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444605, 1.0, int_stack+462005, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1225133,int_stack+1223873,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433115, 1.0, int_stack+450515, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1229903,int_stack+1225133,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718319, 1.0, int_stack+817328, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1625063,int_stack+59163,int_stack+58623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445025, 1.0, int_stack+462425, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1626683,int_stack+1625063,int_stack+1223873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719669, 1.0, int_stack+818678, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1629203,int_stack+1626683,int_stack+1225133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720929, 1.0, int_stack+819938, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1625063,int_stack+1629203,int_stack+1229903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722819, 1.0, int_stack+821828, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1628438,int_stack+1625063,int_stack+1227653,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+60153,int_stack+59838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448415, 1.0, int_stack+465815, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1635188,int_stack+60594,int_stack+60153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448730, 1.0, int_stack+466130, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1636511,int_stack+1635188,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728444, 1.0, int_stack+827453, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1222523,int_stack+61182,int_stack+60594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449171, 1.0, int_stack+466571, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1224287,int_stack+1222523,int_stack+1635188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729389, 1.0, int_stack+828398, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1226933,int_stack+1224287,int_stack+1636511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730712, 1.0, int_stack+829721, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1635188,int_stack+61938,int_stack+61182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449759, 1.0, int_stack+467159, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1635188,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759674, 1.0, int_stack+858683, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+603623,int_stack+1224287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761438, 1.0, int_stack+860447, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+12033,int_stack+1226933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764084, 1.0, int_stack+863093, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1625063,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1635188,int_stack+12033,int_stack+1628438,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1625063,int_stack+63303,int_stack+62883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194443, 1.0, int_stack+207973, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1626323,int_stack+63891,int_stack+63303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195283, 1.0, int_stack+208813, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1628087,int_stack+1626323,int_stack+1625063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795584, 1.0, int_stack+894593, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1630607,int_stack+64675,int_stack+63891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196459, 1.0, int_stack+209989, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1222523,int_stack+1630607,int_stack+1626323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796844, 1.0, int_stack+895853, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1226051,int_stack+1222523,int_stack+1628087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798608, 1.0, int_stack+897617, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1625063,int_stack+65683,int_stack+64675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198027, 1.0, int_stack+211557, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+55908,int_stack+1625063,int_stack+1630607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+801128, 1.0, int_stack+900137, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1625063,int_stack+55908,int_stack+1222523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803480, 1.0, int_stack+902489, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+55908,int_stack+1625063,int_stack+1226051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807008, 1.0, int_stack+906017, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1648688,int_stack+55908,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1662863,int_stack+1648688,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+67093,int_stack+66943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+458565, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+67303,int_stack+67093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+458715, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+442165, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+67583,int_stack+67303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+458925, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+811208, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+811838, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+67943,int_stack+67583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+459205, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+812738, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+813578, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+68618,int_stack+68393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+461465, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+68933,int_stack+68618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+461690, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+445565, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+69353,int_stack+68933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+462005, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+450515, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+817328, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1648688,int_stack+69893,int_stack+69353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+462425, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1650308,int_stack+1648688,int_stack+13383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+818678, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1652828,int_stack+1650308,int_stack+14643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+819938, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1648688,int_stack+1652828,int_stack+19413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+821828, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1652063,int_stack+1648688,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+70883,int_stack+70568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+465815, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1658813,int_stack+71324,int_stack+70883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+466130, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1660136,int_stack+1658813,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+827453, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+71912,int_stack+71324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+466571, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13797,int_stack+12033,int_stack+1658813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+828398, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16443,int_stack+13797,int_stack+1660136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+829721, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1658813,int_stack+72668,int_stack+71912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+467159, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1658813,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+858683, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+55908,int_stack+603623,int_stack+13797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+860447, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+55908,int_stack+16443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+863093, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1648688,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+55908,int_stack+12033,int_stack+1652063,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1648688,int_stack+74033,int_stack+73613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+207973, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1649948,int_stack+74621,int_stack+74033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+208813, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1651712,int_stack+1649948,int_stack+1648688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+894593, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1654232,int_stack+75405,int_stack+74621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+209989, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1656584,int_stack+1654232,int_stack+1649948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+895853, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+69408,int_stack+1656584,int_stack+1651712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+897617, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1648688,int_stack+76413,int_stack+75405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+211557, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1625063,int_stack+1648688,int_stack+1654232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+900137, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1648688,int_stack+1625063,int_stack+1656584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+902489, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1625063,int_stack+1648688,int_stack+69408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+906017, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1648688,int_stack+1625063,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1683113,int_stack+1648688,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+77823,int_stack+77673, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475965,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+78033,int_stack+77823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476115,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459565,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+78313,int_stack+78033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476325,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+910217,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+910847,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+78673,int_stack+78313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476605,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+911747,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+912587,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+79348,int_stack+79123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+478865,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+79663,int_stack+79348, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479090,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462965,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+80083,int_stack+79663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479405,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467915,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+916337,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1648688,int_stack+80623,int_stack+80083, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479825,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1650308,int_stack+1648688,int_stack+13383, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+613640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+917687,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1652828,int_stack+1650308,int_stack+14643, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918947,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1648688,int_stack+1652828,int_stack+19413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+920837,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1652063,int_stack+1648688,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+81613,int_stack+81298, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483215,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1658813,int_stack+82054,int_stack+81613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483530,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1660136,int_stack+1658813,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640883, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926462,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+82642,int_stack+82054, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483971,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13797,int_stack+12033,int_stack+1658813, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927407,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16443,int_stack+13797,int_stack+1660136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643151, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+928730,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1658813,int_stack+83398,int_stack+82642, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+484559,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1658813,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645041, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+957692,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1625063,int_stack+603623,int_stack+13797, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+646805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+959456,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+1625063,int_stack+16443, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+649451, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+962102,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1625063,int_stack+603623,int_stack+1648688,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+69408,int_stack+1625063,int_stack+1652063,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1648688,int_stack+84763,int_stack+84343, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221503,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1649948,int_stack+85351,int_stack+84763, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222343,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1651712,int_stack+1649948,int_stack+1648688, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+696575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+993602,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1654232,int_stack+86135,int_stack+85351, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+182929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+223519,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1656584,int_stack+1654232,int_stack+1649948, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+994862,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12033,int_stack+1656584,int_stack+1651712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699599, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+996626,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1648688,int_stack+87143,int_stack+86135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225087,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16233,int_stack+1648688,int_stack+1654232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702119, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+999146,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1648688,int_stack+16233,int_stack+1656584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704471, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1001498,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1654568,int_stack+1648688,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707999, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005026,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1703363,int_stack+1654568,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1717538,int_stack+1703363,int_stack+1625063,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+88553,int_stack+88403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441165, 0.0, zero_stack, 1.0, int_stack+475965, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1625063,int_stack+88763,int_stack+88553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441315, 0.0, zero_stack, 1.0, int_stack+476115, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1625693,int_stack+1625063,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+424765, 0.0, zero_stack, 1.0, int_stack+459565, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1626593,int_stack+89043,int_stack+88763, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441525, 0.0, zero_stack, 1.0, int_stack+476325, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1627433,int_stack+1626593,int_stack+1625063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712199, 0.0, zero_stack, 1.0, int_stack+910217, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1628693,int_stack+1627433,int_stack+1625693, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+712829, 0.0, zero_stack, 1.0, int_stack+910847, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1625063,int_stack+89403,int_stack+89043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+441805, 0.0, zero_stack, 1.0, int_stack+476605, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1630193,int_stack+1625063,int_stack+1626593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713729, 0.0, zero_stack, 1.0, int_stack+911747, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1625063,int_stack+1630193,int_stack+1627433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1630193,int_stack+1625063,int_stack+1628693, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714569, 0.0, zero_stack, 1.0, int_stack+912587, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+90078,int_stack+89853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444065, 0.0, zero_stack, 1.0, int_stack+478865, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+90393,int_stack+90078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444290, 0.0, zero_stack, 1.0, int_stack+479090, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1625063,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428165, 0.0, zero_stack, 1.0, int_stack+462965, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1626413,int_stack+90813,int_stack+90393, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444605, 0.0, zero_stack, 1.0, int_stack+479405, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1627673,int_stack+1626413,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433115, 0.0, zero_stack, 1.0, int_stack+467915, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1632443,int_stack+1627673,int_stack+1625063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718319, 0.0, zero_stack, 1.0, int_stack+916337, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1703363,int_stack+91353,int_stack+90813, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445025, 0.0, zero_stack, 1.0, int_stack+479825, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1704983,int_stack+1703363,int_stack+1626413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719669, 0.0, zero_stack, 1.0, int_stack+917687, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1707503,int_stack+1704983,int_stack+1627673, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720929, 0.0, zero_stack, 1.0, int_stack+918947, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1703363,int_stack+1707503,int_stack+1632443, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722819, 0.0, zero_stack, 1.0, int_stack+920837, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1706738,int_stack+1703363,int_stack+1630193,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+92343,int_stack+92028, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448415, 0.0, zero_stack, 1.0, int_stack+483215, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1713488,int_stack+92784,int_stack+92343, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448730, 0.0, zero_stack, 1.0, int_stack+483530, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1714811,int_stack+1713488,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+728444, 0.0, zero_stack, 1.0, int_stack+926462, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1625063,int_stack+93372,int_stack+92784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449171, 0.0, zero_stack, 1.0, int_stack+483971, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1626827,int_stack+1625063,int_stack+1713488, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729389, 0.0, zero_stack, 1.0, int_stack+927407, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1629473,int_stack+1626827,int_stack+1714811, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730712, 0.0, zero_stack, 1.0, int_stack+928730, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1713488,int_stack+94128,int_stack+93372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+449759, 0.0, zero_stack, 1.0, int_stack+484559, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1713488,int_stack+1625063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+759674, 0.0, zero_stack, 1.0, int_stack+957692, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+603623,int_stack+1626827, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761438, 0.0, zero_stack, 1.0, int_stack+959456, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+12033,int_stack+1629473, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764084, 0.0, zero_stack, 1.0, int_stack+962102, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1703363,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1648688,int_stack+12033,int_stack+1706738,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1703363,int_stack+95493,int_stack+95073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194443, 0.0, zero_stack, 1.0, int_stack+221503, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704623,int_stack+96081,int_stack+95493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195283, 0.0, zero_stack, 1.0, int_stack+222343, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1706387,int_stack+1704623,int_stack+1703363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795584, 0.0, zero_stack, 1.0, int_stack+993602, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1708907,int_stack+96865,int_stack+96081, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196459, 0.0, zero_stack, 1.0, int_stack+223519, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1711259,int_stack+1708907,int_stack+1704623, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796844, 0.0, zero_stack, 1.0, int_stack+994862, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1625063,int_stack+1711259,int_stack+1706387, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798608, 0.0, zero_stack, 1.0, int_stack+996626, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1703363,int_stack+97873,int_stack+96865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198027, 0.0, zero_stack, 1.0, int_stack+225087, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1629263,int_stack+1703363,int_stack+1708907, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+801128, 0.0, zero_stack, 1.0, int_stack+999146, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1703363,int_stack+1629263,int_stack+1711259, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803480, 0.0, zero_stack, 1.0, int_stack+1001498, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1709243,int_stack+1703363,int_stack+1625063, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807008, 0.0, zero_stack, 1.0, int_stack+1005026, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+82908,int_stack+1709243,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1737788,int_stack+82908,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+99283,int_stack+99133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458565, 1.0, int_stack+475965, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+99493,int_stack+99283, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458715, 1.0, int_stack+476115, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442165, 1.0, int_stack+459565, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+99773,int_stack+99493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458925, 1.0, int_stack+476325, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811208, 1.0, int_stack+910217, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+811838, 1.0, int_stack+910847, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+100133,int_stack+99773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+459205, 1.0, int_stack+476605, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812738, 1.0, int_stack+911747, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1260, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813578, 1.0, int_stack+912587, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+100808,int_stack+100583, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461465, 1.0, int_stack+478865, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+101123,int_stack+100808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461690, 1.0, int_stack+479090, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445565, 1.0, int_stack+462965, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+101543,int_stack+101123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462005, 1.0, int_stack+479405, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450515, 1.0, int_stack+467915, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+817328, 1.0, int_stack+916337, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+102083,int_stack+101543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462425, 1.0, int_stack+479825, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+84528,int_stack+82908,int_stack+13383, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818678, 1.0, int_stack+917687, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+87048,int_stack+84528,int_stack+14643, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819938, 1.0, int_stack+918947, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+82908,int_stack+87048,int_stack+19413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821828, 1.0, int_stack+920837, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+86283,int_stack+82908,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+103073,int_stack+102758, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465815, 1.0, int_stack+483215, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+93033,int_stack+103514,int_stack+103073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466130, 1.0, int_stack+483530, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+94356,int_stack+93033,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827453, 1.0, int_stack+926462, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+96246,int_stack+104102,int_stack+103514, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466571, 1.0, int_stack+483971, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+98010,int_stack+96246,int_stack+93033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828398, 1.0, int_stack+927407, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+100656,int_stack+98010,int_stack+94356, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829721, 1.0, int_stack+928730, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+93033,int_stack+104858,int_stack+104102, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467159, 1.0, int_stack+484559, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12033,int_stack+93033,int_stack+96246, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858683, 1.0, int_stack+957692, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93033,int_stack+12033,int_stack+98010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+860447, 1.0, int_stack+959456, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+93033,int_stack+100656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+863093, 1.0, int_stack+962102, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+82908,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1703363,int_stack+12033,int_stack+86283,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+106223,int_stack+105803, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207973, 1.0, int_stack+221503, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+84168,int_stack+106811,int_stack+106223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208813, 1.0, int_stack+222343, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+85932,int_stack+84168,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+894593, 1.0, int_stack+993602, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+88452,int_stack+107595,int_stack+106811, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209989, 1.0, int_stack+223519, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+90804,int_stack+88452,int_stack+84168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895853, 1.0, int_stack+994862, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+94332,int_stack+90804,int_stack+85932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+897617, 1.0, int_stack+996626, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+108603,int_stack+107595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211557, 1.0, int_stack+225087, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+98532,int_stack+82908,int_stack+88452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900137, 1.0, int_stack+999146, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+98532,int_stack+90804, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902489, 1.0, int_stack+1001498, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+98532,int_stack+82908,int_stack+94332, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+906017, 1.0, int_stack+1005026, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+82908,int_stack+98532,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1758038,int_stack+82908,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+110013,int_stack+109863, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+475965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+110223,int_stack+110013, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+476115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+459565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+110503,int_stack+110223, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+476325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+910217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+910847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+110863,int_stack+110503, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+476605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+911747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+912587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+111538,int_stack+111313, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+478865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+111853,int_stack+111538, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+479090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+462965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+112273,int_stack+111853, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+479405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+467915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+916337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+112813,int_stack+112273, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+479825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+84528,int_stack+82908,int_stack+13383, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+917687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+87048,int_stack+84528,int_stack+14643, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+918947, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+82908,int_stack+87048,int_stack+19413, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+920837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+86283,int_stack+82908,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+113803,int_stack+113488, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+483215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+93033,int_stack+114244,int_stack+113803, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+483530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+94356,int_stack+93033,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+926462, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+96246,int_stack+114832,int_stack+114244, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+483971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+98010,int_stack+96246,int_stack+93033, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+927407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+100656,int_stack+98010,int_stack+94356, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+928730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+93033,int_stack+115588,int_stack+114832, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+484559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+103806,int_stack+93033,int_stack+96246, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+957692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93033,int_stack+103806,int_stack+98010, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+959456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+93033,int_stack+100656, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+962102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+82908,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+93033,int_stack+12033,int_stack+86283,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+116953,int_stack+116533, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+221503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+84168,int_stack+117541,int_stack+116953, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+222343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+85932,int_stack+84168,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+993602, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+88452,int_stack+118325,int_stack+117541, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+223519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106533,int_stack+88452,int_stack+84168, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+994862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+110061,int_stack+106533,int_stack+85932, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+996626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+119333,int_stack+118325, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+225087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+114261,int_stack+82908,int_stack+88452, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+999146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+114261,int_stack+106533, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1001498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+114261,int_stack+82908,int_stack+110061, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1005026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1778288,int_stack+114261,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1792463,int_stack+1778288,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+120743,int_stack+120593, 0.0, zero_stack, 1.0, int_stack+423765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493365,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+120953,int_stack+120743, 0.0, zero_stack, 1.0, int_stack+423915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493515,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+594470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476965,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+121233,int_stack+120953, 0.0, zero_stack, 1.0, int_stack+424125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493725,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+594920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1009226,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 1.0, int_stack+595550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1009856,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+121593,int_stack+121233, 0.0, zero_stack, 1.0, int_stack+424405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494005,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 1.0, int_stack+596450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1010756,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 1.0, int_stack+597290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 1.0, int_stack+598550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011596,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+122268,int_stack+122043, 0.0, zero_stack, 1.0, int_stack+426665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496265,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+122583,int_stack+122268, 0.0, zero_stack, 1.0, int_stack+426890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496490,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 1.0, int_stack+610670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480365,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+123003,int_stack+122583, 0.0, zero_stack, 1.0, int_stack+427205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496805,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+611345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485315,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+612290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015346,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1778288,int_stack+123543,int_stack+123003, 0.0, zero_stack, 1.0, int_stack+427625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497225,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1779908,int_stack+1778288,int_stack+13383, 0.0, zero_stack, 1.0, int_stack+613640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1016696,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1782428,int_stack+1779908,int_stack+14643, 0.0, zero_stack, 1.0, int_stack+614900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1017956,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1778288,int_stack+1782428,int_stack+19413, 0.0, zero_stack, 1.0, int_stack+616790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1019846,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1781663,int_stack+1778288,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+124533,int_stack+124218, 0.0, zero_stack, 1.0, int_stack+431015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500615,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1788413,int_stack+124974,int_stack+124533, 0.0, zero_stack, 1.0, int_stack+431330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500930,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1789736,int_stack+1788413,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+640883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1025471,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+125562,int_stack+124974, 0.0, zero_stack, 1.0, int_stack+431771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+501371,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13797,int_stack+12033,int_stack+1788413, 0.0, zero_stack, 1.0, int_stack+641828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1026416,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16443,int_stack+13797,int_stack+1789736, 0.0, zero_stack, 1.0, int_stack+643151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1027739,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1788413,int_stack+126318,int_stack+125562, 0.0, zero_stack, 1.0, int_stack+432359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+501959,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1788413,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+645041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1056701,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+603623,int_stack+13797, 0.0, zero_stack, 1.0, int_stack+646805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1058465,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+82908,int_stack+16443, 0.0, zero_stack, 1.0, int_stack+649451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061111,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+603623,int_stack+1778288,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+106533,int_stack+82908,int_stack+1781663,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1778288,int_stack+127683,int_stack+127263, 0.0, zero_stack, 1.0, int_stack+180913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235033,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1779548,int_stack+128271,int_stack+127683, 0.0, zero_stack, 1.0, int_stack+181753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235873,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1781312,int_stack+1779548,int_stack+1778288, 0.0, zero_stack, 1.0, int_stack+696575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1092611,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1783832,int_stack+129055,int_stack+128271, 0.0, zero_stack, 1.0, int_stack+182929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237049,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1786184,int_stack+1783832,int_stack+1779548, 0.0, zero_stack, 1.0, int_stack+697835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1093871,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+12033,int_stack+1786184,int_stack+1781312, 0.0, zero_stack, 1.0, int_stack+699599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095635,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1778288,int_stack+130063,int_stack+129055, 0.0, zero_stack, 1.0, int_stack+184497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238617,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16233,int_stack+1778288,int_stack+1783832, 0.0, zero_stack, 1.0, int_stack+702119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1098155,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1778288,int_stack+16233,int_stack+1786184, 0.0, zero_stack, 1.0, int_stack+704471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100507,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1784168,int_stack+1778288,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+707999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1104035,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1812713,int_stack+1784168,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1826888,int_stack+1812713,int_stack+82908,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+131473,int_stack+131323, 0.0, zero_stack, 1.0, int_stack+441165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493365, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+131683,int_stack+131473, 0.0, zero_stack, 1.0, int_stack+441315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493515, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+424765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476965, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+131963,int_stack+131683, 0.0, zero_stack, 1.0, int_stack+441525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493725, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+712199, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1009226, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+86538,int_stack+85278,int_stack+83538, 0.0, zero_stack, 1.0, int_stack+712829, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1009856, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+132323,int_stack+131963, 0.0, zero_stack, 1.0, int_stack+441805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494005, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88038,int_stack+82908,int_stack+84438, 0.0, zero_stack, 1.0, int_stack+713729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1010756, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+88038,int_stack+85278, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+88038,int_stack+82908,int_stack+86538, 0.0, zero_stack, 1.0, int_stack+714569, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1011596, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+132998,int_stack+132773, 0.0, zero_stack, 1.0, int_stack+444065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496265, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+133313,int_stack+132998, 0.0, zero_stack, 1.0, int_stack+444290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496490, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+82908,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 1.0, int_stack+428165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480365, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84258,int_stack+133733,int_stack+133313, 0.0, zero_stack, 1.0, int_stack+444605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+496805, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85518,int_stack+84258,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+433115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485315, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+90288,int_stack+85518,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+718319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1015346, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+134273,int_stack+133733, 0.0, zero_stack, 1.0, int_stack+445025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497225, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1814333,int_stack+1812713,int_stack+84258, 0.0, zero_stack, 1.0, int_stack+719669, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1016696, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1816853,int_stack+1814333,int_stack+85518, 0.0, zero_stack, 1.0, int_stack+720929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1017956, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1812713,int_stack+1816853,int_stack+90288, 0.0, zero_stack, 1.0, int_stack+722819, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1019846, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1816088,int_stack+1812713,int_stack+88038,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+135263,int_stack+134948, 0.0, zero_stack, 1.0, int_stack+448415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500615, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1822838,int_stack+135704,int_stack+135263, 0.0, zero_stack, 1.0, int_stack+448730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500930, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1824161,int_stack+1822838,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+728444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1025471, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+136292,int_stack+135704, 0.0, zero_stack, 1.0, int_stack+449171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+501371, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+84672,int_stack+82908,int_stack+1822838, 0.0, zero_stack, 1.0, int_stack+729389, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1026416, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+87318,int_stack+84672,int_stack+1824161, 0.0, zero_stack, 1.0, int_stack+730712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1027739, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1822838,int_stack+137048,int_stack+136292, 0.0, zero_stack, 1.0, int_stack+449759, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+501959, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1822838,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+759674, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1056701, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+603623,int_stack+84672, 0.0, zero_stack, 1.0, int_stack+761438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1058465, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+12033,int_stack+87318, 0.0, zero_stack, 1.0, int_stack+764084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1061111, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1812713,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1778288,int_stack+12033,int_stack+1816088,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1812713,int_stack+138413,int_stack+137993, 0.0, zero_stack, 1.0, int_stack+194443, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235033, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1813973,int_stack+139001,int_stack+138413, 0.0, zero_stack, 1.0, int_stack+195283, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235873, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1815737,int_stack+1813973,int_stack+1812713, 0.0, zero_stack, 1.0, int_stack+795584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1092611, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1818257,int_stack+139785,int_stack+139001, 0.0, zero_stack, 1.0, int_stack+196459, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237049, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1820609,int_stack+1818257,int_stack+1813973, 0.0, zero_stack, 1.0, int_stack+796844, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1093871, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+82908,int_stack+1820609,int_stack+1815737, 0.0, zero_stack, 1.0, int_stack+798608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095635, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+140793,int_stack+139785, 0.0, zero_stack, 1.0, int_stack+198027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238617, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+87108,int_stack+1812713,int_stack+1818257, 0.0, zero_stack, 1.0, int_stack+801128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1098155, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812713,int_stack+87108,int_stack+1820609, 0.0, zero_stack, 1.0, int_stack+803480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1100507, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1818593,int_stack+1812713,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+807008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1104035, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+120033,int_stack+1818593,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1847138,int_stack+120033,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+142203,int_stack+142053, 0.0, zero_stack, 1.0, int_stack+458565, 0.0, zero_stack, 1.0, int_stack+493365, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+142413,int_stack+142203, 0.0, zero_stack, 1.0, int_stack+458715, 0.0, zero_stack, 1.0, int_stack+493515, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+442165, 0.0, zero_stack, 1.0, int_stack+476965, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+142693,int_stack+142413, 0.0, zero_stack, 1.0, int_stack+458925, 0.0, zero_stack, 1.0, int_stack+493725, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+811208, 0.0, zero_stack, 1.0, int_stack+1009226, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 1.0, int_stack+811838, 0.0, zero_stack, 1.0, int_stack+1009856, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+143053,int_stack+142693, 0.0, zero_stack, 1.0, int_stack+459205, 0.0, zero_stack, 1.0, int_stack+494005, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 1.0, int_stack+812738, 0.0, zero_stack, 1.0, int_stack+1010756, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 1.0, int_stack+1260, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 1.0, int_stack+813578, 0.0, zero_stack, 1.0, int_stack+1011596, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+143728,int_stack+143503, 0.0, zero_stack, 1.0, int_stack+461465, 0.0, zero_stack, 1.0, int_stack+496265, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+144043,int_stack+143728, 0.0, zero_stack, 1.0, int_stack+461690, 0.0, zero_stack, 1.0, int_stack+496490, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 1.0, int_stack+445565, 0.0, zero_stack, 1.0, int_stack+480365, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+144463,int_stack+144043, 0.0, zero_stack, 1.0, int_stack+462005, 0.0, zero_stack, 1.0, int_stack+496805, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+450515, 0.0, zero_stack, 1.0, int_stack+485315, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+817328, 0.0, zero_stack, 1.0, int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+145003,int_stack+144463, 0.0, zero_stack, 1.0, int_stack+462425, 0.0, zero_stack, 1.0, int_stack+497225, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+121653,int_stack+120033,int_stack+13383, 0.0, zero_stack, 1.0, int_stack+818678, 0.0, zero_stack, 1.0, int_stack+1016696, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+124173,int_stack+121653,int_stack+14643, 0.0, zero_stack, 1.0, int_stack+819938, 0.0, zero_stack, 1.0, int_stack+1017956, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+120033,int_stack+124173,int_stack+19413, 0.0, zero_stack, 1.0, int_stack+821828, 0.0, zero_stack, 1.0, int_stack+1019846, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+123408,int_stack+120033,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+145993,int_stack+145678, 0.0, zero_stack, 1.0, int_stack+465815, 0.0, zero_stack, 1.0, int_stack+500615, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+130158,int_stack+146434,int_stack+145993, 0.0, zero_stack, 1.0, int_stack+466130, 0.0, zero_stack, 1.0, int_stack+500930, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+131481,int_stack+130158,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+827453, 0.0, zero_stack, 1.0, int_stack+1025471, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+133371,int_stack+147022,int_stack+146434, 0.0, zero_stack, 1.0, int_stack+466571, 0.0, zero_stack, 1.0, int_stack+501371, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+135135,int_stack+133371,int_stack+130158, 0.0, zero_stack, 1.0, int_stack+828398, 0.0, zero_stack, 1.0, int_stack+1026416, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+137781,int_stack+135135,int_stack+131481, 0.0, zero_stack, 1.0, int_stack+829721, 0.0, zero_stack, 1.0, int_stack+1027739, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+130158,int_stack+147778,int_stack+147022, 0.0, zero_stack, 1.0, int_stack+467159, 0.0, zero_stack, 1.0, int_stack+501959, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+140931,int_stack+130158,int_stack+133371, 0.0, zero_stack, 1.0, int_stack+858683, 0.0, zero_stack, 1.0, int_stack+1056701, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+130158,int_stack+140931,int_stack+135135, 0.0, zero_stack, 1.0, int_stack+860447, 0.0, zero_stack, 1.0, int_stack+1058465, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+130158,int_stack+137781, 0.0, zero_stack, 1.0, int_stack+863093, 0.0, zero_stack, 1.0, int_stack+1061111, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+120033,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+130158,int_stack+12033,int_stack+123408,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+120033,int_stack+149143,int_stack+148723, 0.0, zero_stack, 1.0, int_stack+207973, 0.0, zero_stack, 1.0, int_stack+235033, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+121293,int_stack+149731,int_stack+149143, 0.0, zero_stack, 1.0, int_stack+208813, 0.0, zero_stack, 1.0, int_stack+235873, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+123057,int_stack+121293,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+894593, 0.0, zero_stack, 1.0, int_stack+1092611, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+125577,int_stack+150515,int_stack+149731, 0.0, zero_stack, 1.0, int_stack+209989, 0.0, zero_stack, 1.0, int_stack+237049, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+143658,int_stack+125577,int_stack+121293, 0.0, zero_stack, 1.0, int_stack+895853, 0.0, zero_stack, 1.0, int_stack+1093871, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+82908,int_stack+143658,int_stack+123057, 0.0, zero_stack, 1.0, int_stack+897617, 0.0, zero_stack, 1.0, int_stack+1095635, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+151523,int_stack+150515, 0.0, zero_stack, 1.0, int_stack+211557, 0.0, zero_stack, 1.0, int_stack+238617, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+147186,int_stack+120033,int_stack+125577, 0.0, zero_stack, 1.0, int_stack+900137, 0.0, zero_stack, 1.0, int_stack+1098155, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+120033,int_stack+147186,int_stack+143658, 0.0, zero_stack, 1.0, int_stack+902489, 0.0, zero_stack, 1.0, int_stack+1100507, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+143658,int_stack+120033,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+906017, 0.0, zero_stack, 1.0, int_stack+1104035, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1812713,int_stack+143658,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1867388,int_stack+1812713,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+152933,int_stack+152783, 0.0, zero_stack, 1.0, int_stack+475965, 1.0, int_stack+493365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+153143,int_stack+152933, 0.0, zero_stack, 1.0, int_stack+476115, 1.0, int_stack+493515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+459565, 1.0, int_stack+476965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+153423,int_stack+153143, 0.0, zero_stack, 1.0, int_stack+476325, 1.0, int_stack+493725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+910217, 1.0, int_stack+1009226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 1.0, int_stack+910847, 1.0, int_stack+1009856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+153783,int_stack+153423, 0.0, zero_stack, 1.0, int_stack+476605, 1.0, int_stack+494005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 1.0, int_stack+911747, 1.0, int_stack+1010756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 1.0, int_stack+2520, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 1.0, int_stack+912587, 1.0, int_stack+1011596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+154458,int_stack+154233, 0.0, zero_stack, 1.0, int_stack+478865, 1.0, int_stack+496265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+154773,int_stack+154458, 0.0, zero_stack, 1.0, int_stack+479090, 1.0, int_stack+496490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 1.0, int_stack+462965, 1.0, int_stack+480365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+155193,int_stack+154773, 0.0, zero_stack, 1.0, int_stack+479405, 1.0, int_stack+496805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+467915, 1.0, int_stack+485315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+916337, 1.0, int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+155733,int_stack+155193, 0.0, zero_stack, 1.0, int_stack+479825, 1.0, int_stack+497225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1814333,int_stack+1812713,int_stack+13383, 0.0, zero_stack, 1.0, int_stack+917687, 1.0, int_stack+1016696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1816853,int_stack+1814333,int_stack+14643, 0.0, zero_stack, 1.0, int_stack+918947, 1.0, int_stack+1017956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1812713,int_stack+1816853,int_stack+19413, 0.0, zero_stack, 1.0, int_stack+920837, 1.0, int_stack+1019846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1816088,int_stack+1812713,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+156723,int_stack+156408, 0.0, zero_stack, 1.0, int_stack+483215, 1.0, int_stack+500615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1822838,int_stack+157164,int_stack+156723, 0.0, zero_stack, 1.0, int_stack+483530, 1.0, int_stack+500930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1824161,int_stack+1822838,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+926462, 1.0, int_stack+1025471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+157752,int_stack+157164, 0.0, zero_stack, 1.0, int_stack+483971, 1.0, int_stack+501371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13797,int_stack+12033,int_stack+1822838, 0.0, zero_stack, 1.0, int_stack+927407, 1.0, int_stack+1026416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16443,int_stack+13797,int_stack+1824161, 0.0, zero_stack, 1.0, int_stack+928730, 1.0, int_stack+1027739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1822838,int_stack+158508,int_stack+157752, 0.0, zero_stack, 1.0, int_stack+484559, 1.0, int_stack+501959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1822838,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+957692, 1.0, int_stack+1056701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+143658,int_stack+603623,int_stack+13797, 0.0, zero_stack, 1.0, int_stack+959456, 1.0, int_stack+1058465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+143658,int_stack+16443, 0.0, zero_stack, 1.0, int_stack+962102, 1.0, int_stack+1061111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1812713,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+143658,int_stack+12033,int_stack+1816088,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1812713,int_stack+159873,int_stack+159453, 0.0, zero_stack, 1.0, int_stack+221503, 1.0, int_stack+235033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1813973,int_stack+160461,int_stack+159873, 0.0, zero_stack, 1.0, int_stack+222343, 1.0, int_stack+235873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1815737,int_stack+1813973,int_stack+1812713, 0.0, zero_stack, 1.0, int_stack+993602, 1.0, int_stack+1092611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1818257,int_stack+161245,int_stack+160461, 0.0, zero_stack, 1.0, int_stack+223519, 1.0, int_stack+237049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1820609,int_stack+1818257,int_stack+1813973, 0.0, zero_stack, 1.0, int_stack+994862, 1.0, int_stack+1093871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+82908,int_stack+1820609,int_stack+1815737, 0.0, zero_stack, 1.0, int_stack+996626, 1.0, int_stack+1095635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+162253,int_stack+161245, 0.0, zero_stack, 1.0, int_stack+225087, 1.0, int_stack+238617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157158,int_stack+1812713,int_stack+1818257, 0.0, zero_stack, 1.0, int_stack+999146, 1.0, int_stack+1098155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812713,int_stack+157158,int_stack+1820609, 0.0, zero_stack, 1.0, int_stack+1001498, 1.0, int_stack+1100507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+157158,int_stack+1812713,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+1005026, 1.0, int_stack+1104035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1812713,int_stack+157158,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1887638,int_stack+1812713,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+163663,int_stack+163513, 0.0, zero_stack, 2.0, int_stack+493365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+163873,int_stack+163663, 0.0, zero_stack, 2.0, int_stack+493515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 2.0, int_stack+476965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+164153,int_stack+163873, 0.0, zero_stack, 2.0, int_stack+493725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 2.0, int_stack+1009226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 0.0, zero_stack, 2.0, int_stack+1009856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+164513,int_stack+164153, 0.0, zero_stack, 2.0, int_stack+494005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 0.0, zero_stack, 2.0, int_stack+1010756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 0.0, zero_stack, 2.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 0.0, zero_stack, 2.0, int_stack+1011596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+165188,int_stack+164963, 0.0, zero_stack, 2.0, int_stack+496265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+165503,int_stack+165188, 0.0, zero_stack, 2.0, int_stack+496490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 0.0, zero_stack, 2.0, int_stack+480365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+165923,int_stack+165503, 0.0, zero_stack, 2.0, int_stack+496805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 0.0, zero_stack, 2.0, int_stack+485315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 0.0, zero_stack, 2.0, int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+166463,int_stack+165923, 0.0, zero_stack, 2.0, int_stack+497225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1814333,int_stack+1812713,int_stack+13383, 0.0, zero_stack, 2.0, int_stack+1016696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1816853,int_stack+1814333,int_stack+14643, 0.0, zero_stack, 2.0, int_stack+1017956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1812713,int_stack+1816853,int_stack+19413, 0.0, zero_stack, 2.0, int_stack+1019846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1816088,int_stack+1812713,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+167453,int_stack+167138, 0.0, zero_stack, 2.0, int_stack+500615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1822838,int_stack+167894,int_stack+167453, 0.0, zero_stack, 2.0, int_stack+500930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1824161,int_stack+1822838,int_stack+580840, 0.0, zero_stack, 2.0, int_stack+1025471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+168482,int_stack+167894, 0.0, zero_stack, 2.0, int_stack+501371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13797,int_stack+12033,int_stack+1822838, 0.0, zero_stack, 2.0, int_stack+1026416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16443,int_stack+13797,int_stack+1824161, 0.0, zero_stack, 2.0, int_stack+1027739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1822838,int_stack+169238,int_stack+168482, 0.0, zero_stack, 2.0, int_stack+501959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1822838,int_stack+12033, 0.0, zero_stack, 2.0, int_stack+1056701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157158,int_stack+603623,int_stack+13797, 0.0, zero_stack, 2.0, int_stack+1058465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+157158,int_stack+16443, 0.0, zero_stack, 2.0, int_stack+1061111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1812713,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1907888,int_stack+12033,int_stack+1816088,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1812713,int_stack+170603,int_stack+170183, 0.0, zero_stack, 2.0, int_stack+235033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1813973,int_stack+171191,int_stack+170603, 0.0, zero_stack, 2.0, int_stack+235873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1815737,int_stack+1813973,int_stack+1812713, 0.0, zero_stack, 2.0, int_stack+1092611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1818257,int_stack+171975,int_stack+171191, 0.0, zero_stack, 2.0, int_stack+237049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1820609,int_stack+1818257,int_stack+1813973, 0.0, zero_stack, 2.0, int_stack+1093871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+157158,int_stack+1820609,int_stack+1815737, 0.0, zero_stack, 2.0, int_stack+1095635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+172983,int_stack+171975, 0.0, zero_stack, 2.0, int_stack+238617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+161358,int_stack+1812713,int_stack+1818257, 0.0, zero_stack, 2.0, int_stack+1098155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812713,int_stack+161358,int_stack+1820609, 0.0, zero_stack, 2.0, int_stack+1100507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+161358,int_stack+1812713,int_stack+157158, 0.0, zero_stack, 2.0, int_stack+1104035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1812713,int_stack+161358,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1921388,int_stack+1812713,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+174393,int_stack+174243, 1.0, int_stack+423765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510765,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+174603,int_stack+174393, 1.0, int_stack+423915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510915,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 1.0, int_stack+594470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494365,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+174883,int_stack+174603, 1.0, int_stack+424125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511125,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 1.0, int_stack+594920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108235,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15663,int_stack+14403,int_stack+12663, 1.0, int_stack+595550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108865,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+175243,int_stack+174883, 1.0, int_stack+424405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511405,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+13563, 1.0, int_stack+596450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109765,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+17163,int_stack+14403, 1.0, int_stack+597290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+17163,int_stack+12033,int_stack+15663, 1.0, int_stack+598550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110605,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+175918,int_stack+175693, 1.0, int_stack+426665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513665,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+176233,int_stack+175918, 1.0, int_stack+426890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513890,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12033,int_stack+580840,int_stack+1563638, 1.0, int_stack+610670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497765,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13383,int_stack+176653,int_stack+176233, 1.0, int_stack+427205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514205,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14643,int_stack+13383,int_stack+580840, 1.0, int_stack+611345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502715,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+19413,int_stack+14643,int_stack+12033, 1.0, int_stack+612290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1112105,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+177193,int_stack+176653, 1.0, int_stack+427625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514625,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1814333,int_stack+1812713,int_stack+13383, 1.0, int_stack+613640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1113455,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1816853,int_stack+1814333,int_stack+14643, 1.0, int_stack+614900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1812713,int_stack+1816853,int_stack+19413, 1.0, int_stack+616790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1118135,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1816088,int_stack+1812713,int_stack+17163,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+178183,int_stack+177868, 1.0, int_stack+431015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518330,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1822838,int_stack+178624,int_stack+178183, 1.0, int_stack+431330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519086,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1824161,int_stack+1822838,int_stack+580840, 1.0, int_stack+640883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127135,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+179212,int_stack+178624, 1.0, int_stack+431771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520115,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13797,int_stack+12033,int_stack+1822838, 1.0, int_stack+641828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16443,int_stack+13797,int_stack+1824161, 1.0, int_stack+643151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1152335,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1822838,int_stack+179968,int_stack+179212, 1.0, int_stack+432359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521459,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+603623,int_stack+1822838,int_stack+12033, 1.0, int_stack+645041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1154225,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+157158,int_stack+603623,int_stack+13797, 1.0, int_stack+646805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1155989,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+157158,int_stack+16443, 1.0, int_stack+649451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1158635,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+1812713,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+157158,int_stack+12033,int_stack+1816088,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1812713,int_stack+182341,int_stack+181333, 1.0, int_stack+180913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248983,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1813973,int_stack+183713,int_stack+182341, 1.0, int_stack+181753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250411,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1815737,int_stack+1813973,int_stack+1812713, 1.0, int_stack+696575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1161785,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1818257,int_stack+185505,int_stack+183713, 1.0, int_stack+182929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252371,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1820609,int_stack+1818257,int_stack+1813973, 1.0, int_stack+697835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1163045,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+170658,int_stack+1820609,int_stack+1815737, 1.0, int_stack+699599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164809,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1812713,int_stack+186513,int_stack+185505, 1.0, int_stack+184497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253939,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+174858,int_stack+1812713,int_stack+1818257, 1.0, int_stack+702119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1167329,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812713,int_stack+174858,int_stack+1820609, 1.0, int_stack+704471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+174858,int_stack+1812713,int_stack+170658, 1.0, int_stack+707999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198073,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1812713,int_stack+174858,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1941638,int_stack+1812713,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+187923,int_stack+187773, 1.0, int_stack+441165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510765, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+188133,int_stack+187923, 1.0, int_stack+441315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510915, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 1.0, int_stack+424765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494365, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+188413,int_stack+188133, 1.0, int_stack+441525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511125, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 1.0, int_stack+712199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108235, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+426665,int_stack+14403,int_stack+12663, 1.0, int_stack+712829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108865, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+188773,int_stack+188413, 1.0, int_stack+441805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511405, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15663,int_stack+12033,int_stack+13563, 1.0, int_stack+713729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109765, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+431015,int_stack+15663,int_stack+14403, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12033,int_stack+431015,int_stack+426665, 1.0, int_stack+714569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110605, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1563638,int_stack+189448,int_stack+189223, 1.0, int_stack+444065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513665, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+189763,int_stack+189448, 1.0, int_stack+444290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513890, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+426665,int_stack+580840,int_stack+1563638, 1.0, int_stack+428165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497765, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+190183,int_stack+189763, 1.0, int_stack+444605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514205, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+431015,int_stack+0,int_stack+580840, 1.0, int_stack+433115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502715, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+14283,int_stack+431015,int_stack+426665, 1.0, int_stack+718319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1112105, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+426665,int_stack+190723,int_stack+190183, 1.0, int_stack+445025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514625, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16533,int_stack+426665,int_stack+0, 1.0, int_stack+719669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1113455, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1812713,int_stack+16533,int_stack+431015, 1.0, int_stack+720929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+16533,int_stack+1812713,int_stack+14283, 1.0, int_stack+722819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1118135, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+718319,int_stack+16533,int_stack+12033,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+191713,int_stack+191398, 1.0, int_stack+448415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518330, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+192154,int_stack+191713, 1.0, int_stack+448730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519086, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13356,int_stack+12033,int_stack+580840, 1.0, int_stack+728444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127135, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1812713,int_stack+192742,int_stack+192154, 1.0, int_stack+449171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520115, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1814477,int_stack+1812713,int_stack+12033, 1.0, int_stack+729389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1817123,int_stack+1814477,int_stack+13356, 1.0, int_stack+730712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1152335, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+193498,int_stack+192742, 1.0, int_stack+449759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521459, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+728444,int_stack+12033,int_stack+1812713, 1.0, int_stack+759674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1154225, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+728444,int_stack+1814477, 1.0, int_stack+761438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1155989, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+12033,int_stack+1817123, 1.0, int_stack+764084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1158635, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+603623,int_stack+16533,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1812713,int_stack+82908,int_stack+718319,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+195871,int_stack+194863, 1.0, int_stack+194443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248983, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+718319,int_stack+197243,int_stack+195871, 1.0, int_stack+195283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250411, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+720083,int_stack+718319,int_stack+0, 1.0, int_stack+795584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1161785, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+722603,int_stack+199035,int_stack+197243, 1.0, int_stack+196459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252371, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12033,int_stack+722603,int_stack+718319, 1.0, int_stack+796844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1163045, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+15561,int_stack+12033,int_stack+720083, 1.0, int_stack+798608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164809, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+718319,int_stack+200043,int_stack+199035, 1.0, int_stack+198027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253939, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795584,int_stack+718319,int_stack+722603, 1.0, int_stack+801128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1167329, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+718319,int_stack+795584,int_stack+12033, 1.0, int_stack+803480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+795584,int_stack+718319,int_stack+15561, 1.0, int_stack+807008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198073, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+170658,int_stack+795584,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1961888,int_stack+170658,int_stack+82908,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+201453,int_stack+201303, 1.0, int_stack+458565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510765, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+201663,int_stack+201453, 1.0, int_stack+458715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510915, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 1.0, int_stack+442165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+494365, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+201943,int_stack+201663, 1.0, int_stack+458925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511125, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+84438,int_stack+82908, 1.0, int_stack+811208, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108235, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+444065,int_stack+0,int_stack+83538, 1.0, int_stack+811838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108865, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+202303,int_stack+201943, 1.0, int_stack+459205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511405, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85278,int_stack+82908,int_stack+84438, 1.0, int_stack+812738, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109765, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+448415,int_stack+85278,int_stack+0, 1.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+448415,int_stack+444065, 1.0, int_stack+813578, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110605, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+202978,int_stack+202753, 1.0, int_stack+461465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513665, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+203293,int_stack+202978, 1.0, int_stack+461690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+513890, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+444065,int_stack+580840,int_stack+1826213, 1.0, int_stack+445565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+497765, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+448415,int_stack+203713,int_stack+203293, 1.0, int_stack+462005, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514205, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+448415,int_stack+580840, 1.0, int_stack+450515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+502715, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+444065, 1.0, int_stack+817328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1112105, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+444065,int_stack+204253,int_stack+203713, 1.0, int_stack+462425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514625, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+87048,int_stack+444065,int_stack+448415, 1.0, int_stack+818678, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1113455, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+89568,int_stack+87048,int_stack+82908, 1.0, int_stack+819938, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+817328,int_stack+89568,int_stack+84798, 1.0, int_stack+821828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+718319,int_stack+817328,int_stack+0,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+205243,int_stack+204928, 1.0, int_stack+465815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518330, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+205684,int_stack+205243, 1.0, int_stack+466130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+519086, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+82908,int_stack+0,int_stack+580840, 1.0, int_stack+827453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84798,int_stack+206272,int_stack+205684, 1.0, int_stack+466571, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+520115, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+86562,int_stack+84798,int_stack+0, 1.0, int_stack+828398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+89208,int_stack+86562,int_stack+82908, 1.0, int_stack+829721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1152335, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+207028,int_stack+206272, 1.0, int_stack+467159, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521459, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+827453,int_stack+0,int_stack+84798, 1.0, int_stack+858683, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1154225, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+170658,int_stack+827453,int_stack+86562, 1.0, int_stack+860447, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1155989, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+170658,int_stack+89208, 1.0, int_stack+863093, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1158635, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+603623,int_stack+817328,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+170658,int_stack+82908,int_stack+718319,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+718319,int_stack+209401,int_stack+208393, 1.0, int_stack+207973, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248983, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+719579,int_stack+210773,int_stack+209401, 1.0, int_stack+208813, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250411, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+719579,int_stack+718319, 1.0, int_stack+894593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1161785, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+721343,int_stack+212565,int_stack+210773, 1.0, int_stack+209989, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252371, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+817328,int_stack+721343,int_stack+719579, 1.0, int_stack+895853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1163045, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+184158,int_stack+817328,int_stack+0, 1.0, int_stack+897617, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1164809, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+718319,int_stack+213573,int_stack+212565, 1.0, int_stack+211557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253939, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+894593,int_stack+718319,int_stack+721343, 1.0, int_stack+900137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1167329, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+718319,int_stack+894593,int_stack+817328, 1.0, int_stack+902489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+817328,int_stack+718319,int_stack+184158, 1.0, int_stack+906017, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+184158,int_stack+817328,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1982138,int_stack+184158,int_stack+82908,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+214983,int_stack+214833, 1.0, int_stack+475965, 0.0, zero_stack, 1.0, int_stack+510765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+215193,int_stack+214983, 1.0, int_stack+476115, 0.0, zero_stack, 1.0, int_stack+510915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 1.0, int_stack+459565, 0.0, zero_stack, 1.0, int_stack+494365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+215473,int_stack+215193, 1.0, int_stack+476325, 0.0, zero_stack, 1.0, int_stack+511125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 1.0, int_stack+910217, 0.0, zero_stack, 1.0, int_stack+1108235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+461465,int_stack+85278,int_stack+83538, 1.0, int_stack+910847, 0.0, zero_stack, 1.0, int_stack+1108865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+215833,int_stack+215473, 1.0, int_stack+476605, 0.0, zero_stack, 1.0, int_stack+511405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 1.0, int_stack+911747, 0.0, zero_stack, 1.0, int_stack+1109765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+465815,int_stack+86538,int_stack+85278, 1.0, int_stack+2520, 0.0, zero_stack, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+82908,int_stack+465815,int_stack+461465, 1.0, int_stack+912587, 0.0, zero_stack, 1.0, int_stack+1110605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+216508,int_stack+216283, 1.0, int_stack+478865, 0.0, zero_stack, 1.0, int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+216823,int_stack+216508, 1.0, int_stack+479090, 0.0, zero_stack, 1.0, int_stack+513890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+461465,int_stack+580840,int_stack+1826213, 1.0, int_stack+462965, 0.0, zero_stack, 1.0, int_stack+497765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+465815,int_stack+217243,int_stack+216823, 1.0, int_stack+479405, 0.0, zero_stack, 1.0, int_stack+514205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85158,int_stack+465815,int_stack+580840, 1.0, int_stack+467915, 0.0, zero_stack, 1.0, int_stack+502715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+87048,int_stack+85158,int_stack+461465, 1.0, int_stack+916337, 0.0, zero_stack, 1.0, int_stack+1112105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+461465,int_stack+217783,int_stack+217243, 1.0, int_stack+479825, 0.0, zero_stack, 1.0, int_stack+514625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+89298,int_stack+461465,int_stack+465815, 1.0, int_stack+917687, 0.0, zero_stack, 1.0, int_stack+1113455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+184158,int_stack+89298,int_stack+85158, 1.0, int_stack+918947, 0.0, zero_stack, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+89298,int_stack+184158,int_stack+87048, 1.0, int_stack+920837, 0.0, zero_stack, 1.0, int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+916337,int_stack+89298,int_stack+82908,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+218773,int_stack+218458, 1.0, int_stack+483215, 0.0, zero_stack, 1.0, int_stack+518330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+219214,int_stack+218773, 1.0, int_stack+483530, 0.0, zero_stack, 1.0, int_stack+519086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+84231,int_stack+82908,int_stack+580840, 1.0, int_stack+926462, 0.0, zero_stack, 1.0, int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+86121,int_stack+219802,int_stack+219214, 1.0, int_stack+483971, 0.0, zero_stack, 1.0, int_stack+520115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+184158,int_stack+86121,int_stack+82908, 1.0, int_stack+927407, 0.0, zero_stack, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+186804,int_stack+184158,int_stack+84231, 1.0, int_stack+928730, 0.0, zero_stack, 1.0, int_stack+1152335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+220558,int_stack+219802, 1.0, int_stack+484559, 0.0, zero_stack, 1.0, int_stack+521459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+926462,int_stack+82908,int_stack+86121, 1.0, int_stack+957692, 0.0, zero_stack, 1.0, int_stack+1154225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+926462,int_stack+184158, 1.0, int_stack+959456, 0.0, zero_stack, 1.0, int_stack+1155989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+82908,int_stack+186804, 1.0, int_stack+962102, 0.0, zero_stack, 1.0, int_stack+1158635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+603623,int_stack+89298,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+184158,int_stack+12033,int_stack+916337,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+916337,int_stack+222931,int_stack+221923, 1.0, int_stack+221503, 0.0, zero_stack, 1.0, int_stack+248983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+917597,int_stack+224303,int_stack+222931, 1.0, int_stack+222343, 0.0, zero_stack, 1.0, int_stack+250411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+919361,int_stack+917597,int_stack+916337, 1.0, int_stack+993602, 0.0, zero_stack, 1.0, int_stack+1161785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+226095,int_stack+224303, 1.0, int_stack+223519, 0.0, zero_stack, 1.0, int_stack+252371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85260,int_stack+82908,int_stack+917597, 1.0, int_stack+994862, 0.0, zero_stack, 1.0, int_stack+1163045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+88788,int_stack+85260,int_stack+919361, 1.0, int_stack+996626, 0.0, zero_stack, 1.0, int_stack+1164809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+993602,int_stack+227103,int_stack+226095, 1.0, int_stack+225087, 0.0, zero_stack, 1.0, int_stack+253939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+916337,int_stack+993602,int_stack+82908, 1.0, int_stack+999146, 0.0, zero_stack, 1.0, int_stack+1167329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+993602,int_stack+916337,int_stack+85260, 1.0, int_stack+1001498, 0.0, zero_stack, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+916337,int_stack+993602,int_stack+88788, 1.0, int_stack+1005026, 0.0, zero_stack, 1.0, int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+993602,int_stack+916337,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+197658,int_stack+993602,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+228513,int_stack+228363, 1.0, int_stack+493365, 1.0, int_stack+510765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+228723,int_stack+228513, 1.0, int_stack+493515, 1.0, int_stack+510915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 1.0, int_stack+476965, 1.0, int_stack+494365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+229003,int_stack+228723, 1.0, int_stack+493725, 1.0, int_stack+511125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 1.0, int_stack+1009226, 1.0, int_stack+1108235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+478865,int_stack+14403,int_stack+12663, 1.0, int_stack+1009856, 1.0, int_stack+1108865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+229363,int_stack+229003, 1.0, int_stack+494005, 1.0, int_stack+511405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15663,int_stack+12033,int_stack+13563, 1.0, int_stack+1010756, 1.0, int_stack+1109765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+483215,int_stack+15663,int_stack+14403, 1.0, int_stack+3780, 1.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+12033,int_stack+483215,int_stack+478865, 1.0, int_stack+1011596, 1.0, int_stack+1110605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+230038,int_stack+229813, 1.0, int_stack+496265, 1.0, int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+230353,int_stack+230038, 1.0, int_stack+496490, 1.0, int_stack+513890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+478865,int_stack+580840,int_stack+1826213, 1.0, int_stack+480365, 1.0, int_stack+497765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+483215,int_stack+230773,int_stack+230353, 1.0, int_stack+496805, 1.0, int_stack+514205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14283,int_stack+483215,int_stack+580840, 1.0, int_stack+485315, 1.0, int_stack+502715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+16173,int_stack+14283,int_stack+478865, 1.0, int_stack+1015346, 1.0, int_stack+1112105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+478865,int_stack+231313,int_stack+230773, 1.0, int_stack+497225, 1.0, int_stack+514625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+18423,int_stack+478865,int_stack+483215, 1.0, int_stack+1016696, 1.0, int_stack+1113455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+993602,int_stack+18423,int_stack+14283, 1.0, int_stack+1017956, 1.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+18423,int_stack+993602,int_stack+16173, 1.0, int_stack+1019846, 1.0, int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+18423,int_stack+12033,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+232303,int_stack+231988, 1.0, int_stack+500615, 1.0, int_stack+518330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+232744,int_stack+232303, 1.0, int_stack+500930, 1.0, int_stack+519086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13356,int_stack+12033,int_stack+580840, 1.0, int_stack+1025471, 1.0, int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15246,int_stack+233332,int_stack+232744, 1.0, int_stack+501371, 1.0, int_stack+520115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+993602,int_stack+15246,int_stack+12033, 1.0, int_stack+1026416, 1.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+996248,int_stack+993602,int_stack+13356, 1.0, int_stack+1027739, 1.0, int_stack+1152335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+234088,int_stack+233332, 1.0, int_stack+501959, 1.0, int_stack+521459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1025471,int_stack+12033,int_stack+15246, 1.0, int_stack+1056701, 1.0, int_stack+1154225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+1025471,int_stack+993602, 1.0, int_stack+1058465, 1.0, int_stack+1155989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+603623,int_stack+12033,int_stack+996248, 1.0, int_stack+1061111, 1.0, int_stack+1158635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+603623,int_stack+18423,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+993602,int_stack+82908,int_stack+1015346,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+236461,int_stack+235453, 1.0, int_stack+235033, 1.0, int_stack+248983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+237833,int_stack+236461, 1.0, int_stack+235873, 1.0, int_stack+250411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 1.0, int_stack+1092611, 1.0, int_stack+1161785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+239625,int_stack+237833, 1.0, int_stack+237049, 1.0, int_stack+252371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14385,int_stack+12033,int_stack+1016606, 1.0, int_stack+1093871, 1.0, int_stack+1163045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+17913,int_stack+14385,int_stack+1018370, 1.0, int_stack+1095635, 1.0, int_stack+1164809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1092611,int_stack+240633,int_stack+239625, 1.0, int_stack+238617, 1.0, int_stack+253939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1015346,int_stack+1092611,int_stack+12033, 1.0, int_stack+1098155, 1.0, int_stack+1167329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1092611,int_stack+1015346,int_stack+14385, 1.0, int_stack+1100507, 1.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1015346,int_stack+1092611,int_stack+17913, 1.0, int_stack+1104035, 1.0, int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1092611,int_stack+1015346,int_stack+603623,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+217908,int_stack+1092611,int_stack+82908,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+242043,int_stack+241893, 2.0, int_stack+510765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+242253,int_stack+242043, 2.0, int_stack+510915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 2.0, int_stack+494365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+242533,int_stack+242253, 2.0, int_stack+511125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 2.0, int_stack+1108235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+496265,int_stack+85278,int_stack+83538, 2.0, int_stack+1108865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+242893,int_stack+242533, 2.0, int_stack+511405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 2.0, int_stack+1109765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500615,int_stack+86538,int_stack+85278, 2.0, int_stack+5040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+82908,int_stack+500615,int_stack+496265, 2.0, int_stack+1110605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+243568,int_stack+243343, 2.0, int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+243883,int_stack+243568, 2.0, int_stack+513890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+496265,int_stack+580840,int_stack+1826213, 2.0, int_stack+497765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500615,int_stack+244303,int_stack+243883, 2.0, int_stack+514205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85158,int_stack+500615,int_stack+580840, 2.0, int_stack+502715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+87048,int_stack+85158,int_stack+496265, 2.0, int_stack+1112105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+496265,int_stack+244843,int_stack+244303, 2.0, int_stack+514625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+89298,int_stack+496265,int_stack+500615, 2.0, int_stack+1113455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1092611,int_stack+89298,int_stack+85158, 2.0, int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+89298,int_stack+1092611,int_stack+87048, 2.0, int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+89298,int_stack+82908,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+245833,int_stack+245518, 2.0, int_stack+518330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+246274,int_stack+245833, 2.0, int_stack+519086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+588890,int_stack+82908,int_stack+580840, 2.0, int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84231,int_stack+246862,int_stack+246274, 2.0, int_stack+520115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85995,int_stack+84231,int_stack+82908, 2.0, int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+602300,int_stack+85995,int_stack+588890, 2.0, int_stack+1152335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+605450,int_stack+247618,int_stack+246862, 2.0, int_stack+521459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1092611,int_stack+605450,int_stack+84231, 2.0, int_stack+1154225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1096139,int_stack+1092611,int_stack+85995, 2.0, int_stack+1155989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1152335,int_stack+1096139,int_stack+602300, 2.0, int_stack+1158635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+1152335,int_stack+89298,225);
 /*--- compute (fd|gg) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+1092611,int_stack+12033,int_stack+1015346,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+250999,int_stack+249403, 2.0, int_stack+248983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+253155,int_stack+250999, 2.0, int_stack+250411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 2.0, int_stack+1161785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+602300,int_stack+254947,int_stack+253155, 2.0, int_stack+252371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+604652,int_stack+602300,int_stack+1016606, 2.0, int_stack+1163045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+518015,int_stack+604652,int_stack+1018370, 2.0, int_stack+1164809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+255955,int_stack+254947, 2.0, int_stack+253939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1106111,int_stack+1015346,int_stack+602300, 2.0, int_stack+1167329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+1106111,int_stack+604652, 2.0, int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1015346,int_stack+518015, 2.0, int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+238158,int_stack+0,int_stack+1152335,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2002388,int_stack+238158,int_stack+12033,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+257365,int_stack+257215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533065,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+257575,int_stack+257365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533215,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511765,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+257855,int_stack+257575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533425,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128080,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+513665,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608348,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+258215,int_stack+257855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533705,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15663,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609248,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+15663,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+12033,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693326,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+258890,int_stack+258665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535965,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1127135,int_stack+259205,int_stack+258890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536190,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513665,int_stack+1127135,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+515165,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+259625,int_stack+259205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536505,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+12033,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13293,int_stack+588890,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632693,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15543,int_stack+260165,int_stack+259625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536925,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+15543,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634043,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+238158,int_stack+17163,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638723,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15543,int_stack+238158,int_stack+13293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590780,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+15543,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1127135,int_stack+261155,int_stack+260840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540315,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+261596,int_stack+261155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540630,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+588890,int_stack+1118135,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522215,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+238158,int_stack+262184,int_stack+261596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541071,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+239922,int_stack+238158,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1246148,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+242568,int_stack+239922,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1247471,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+245718,int_stack+262940,int_stack+262184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541659,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+629165,int_stack+245718,int_stack+238158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1249361,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+245718,int_stack+629165,int_stack+239922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1261943,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+250128,int_stack+245718,int_stack+242568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1264589,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+250128,int_stack+15543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+619040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1152335,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+264305,int_stack+263885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317535,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+264893,int_stack+264305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318375,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694826,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+629165,int_stack+265677,int_stack+264893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319551,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+238158,int_stack+629165,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+238158,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1296089,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+266685,int_stack+265677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321119,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+241686,int_stack+1015346,int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1298609,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+241686,int_stack+238158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1300961,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304489,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+894593,int_stack+0,int_stack+250128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+238158,int_stack+894593,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+268095,int_stack+267945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533065, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+268305,int_stack+268095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533215, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511765, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+268585,int_stack+268305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533425, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128080, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+513665,int_stack+85278,int_stack+83538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608348, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+268945,int_stack+268585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533705, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609248, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+86538,int_stack+85278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+82908,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693326, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+269620,int_stack+269395, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535965, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1127135,int_stack+269935,int_stack+269620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536190, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513665,int_stack+1127135,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+515165, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+270355,int_stack+269935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536505, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+82908,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84168,int_stack+588890,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632693, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86418,int_stack+270895,int_stack+270355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536925, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88038,int_stack+86418,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634043, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+894593,int_stack+88038,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638723, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+86418,int_stack+894593,int_stack+84168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590780, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+86418,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+716069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1127135,int_stack+271885,int_stack+271570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540315, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+272326,int_stack+271885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540630, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+588890,int_stack+1118135,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522215, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+894593,int_stack+272914,int_stack+272326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541071, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+896357,int_stack+894593,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1246148, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+899003,int_stack+896357,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1247471, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+902153,int_stack+273670,int_stack+272914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541659, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+629165,int_stack+902153,int_stack+894593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1249361, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+902153,int_stack+629165,int_stack+896357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1261943, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+906563,int_stack+902153,int_stack+899003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1264589, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+906563,int_stack+86418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+258408,int_stack+12033,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+752924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+275035,int_stack+274615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317535, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+275623,int_stack+275035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318375, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694826, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+629165,int_stack+276407,int_stack+275623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319551, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+894593,int_stack+629165,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+894593,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1296089, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+277415,int_stack+276407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321119, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+898121,int_stack+1015346,int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1298609, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+898121,int_stack+894593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1300961, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304489, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+795584,int_stack+0,int_stack+906563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2022638,int_stack+795584,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+771959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+278825,int_stack+278675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533065, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+279035,int_stack+278825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533215, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511765, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+279315,int_stack+279035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533425, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128080, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+513665,int_stack+14403,int_stack+12663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608348, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+279675,int_stack+279315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533705, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15663,int_stack+12033,int_stack+13563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609248, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+15663,int_stack+14403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+12033,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693326, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+280350,int_stack+280125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535965, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1127135,int_stack+280665,int_stack+280350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536190, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513665,int_stack+1127135,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+515165, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+281085,int_stack+280665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536505, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+12033,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13293,int_stack+588890,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632693, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15543,int_stack+281625,int_stack+281085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536925, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+15543,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634043, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+795584,int_stack+17163,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638723, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15543,int_stack+795584,int_stack+13293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590780, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+15543,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1127135,int_stack+282615,int_stack+282300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540315, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+283056,int_stack+282615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540630, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+588890,int_stack+1118135,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522215, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+795584,int_stack+283644,int_stack+283056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541071, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+797348,int_stack+795584,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1246148, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+799994,int_stack+797348,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1247471, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+803144,int_stack+284400,int_stack+283644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541659, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+629165,int_stack+803144,int_stack+795584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1249361, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+803144,int_stack+629165,int_stack+797348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1261943, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+807554,int_stack+803144,int_stack+799994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1264589, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+807554,int_stack+15543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+894593,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+851933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+285765,int_stack+285345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317535, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+286353,int_stack+285765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318375, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694826, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+629165,int_stack+287137,int_stack+286353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319551, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+795584,int_stack+629165,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+795584,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1296089, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+288145,int_stack+287137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321119, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+799112,int_stack+1015346,int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1298609, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+799112,int_stack+795584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1300961, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304489, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+271908,int_stack+0,int_stack+807554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2042888,int_stack+271908,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+870968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+289555,int_stack+289405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+289765,int_stack+289555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+511765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+290045,int_stack+289765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+513665,int_stack+85278,int_stack+83538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+608348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+290405,int_stack+290045, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+86538,int_stack+85278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+82908,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+291080,int_stack+290855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1127135,int_stack+291395,int_stack+291080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513665,int_stack+1127135,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+515165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+291815,int_stack+291395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+82908,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84168,int_stack+588890,int_stack+513665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+86418,int_stack+292355,int_stack+291815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+536925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88038,int_stack+86418,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+271908,int_stack+88038,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+638723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+86418,int_stack+271908,int_stack+84168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+590780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+86418,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+914087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1127135,int_stack+293345,int_stack+293030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+293786,int_stack+293345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+588890,int_stack+1118135,int_stack+1127135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+271908,int_stack+294374,int_stack+293786, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273672,int_stack+271908,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1246148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+276318,int_stack+273672,int_stack+588890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1247471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+279468,int_stack+295130,int_stack+294374, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+629165,int_stack+279468,int_stack+271908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1249361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+279468,int_stack+629165,int_stack+273672, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1261943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+283878,int_stack+279468,int_stack+276318, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1264589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+12033,int_stack+283878,int_stack+86418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+795584,int_stack+12033,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+950942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+296495,int_stack+296075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+297083,int_stack+296495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+629165,int_stack+297867,int_stack+297083, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+319551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+271908,int_stack+629165,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+271908,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1296089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+298875,int_stack+297867, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+321119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+275436,int_stack+1015346,int_stack+629165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1298609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+275436,int_stack+271908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1300961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+696086,int_stack+0,int_stack+283878, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+965252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+271908,int_stack+696086,int_stack+12033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+300285,int_stack+300135, 0.0, zero_stack, 1.0, int_stack+533065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12033,int_stack+300495,int_stack+300285, 0.0, zero_stack, 1.0, int_stack+533215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12663,int_stack+12033,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+511765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13563,int_stack+300775,int_stack+300495, 0.0, zero_stack, 1.0, int_stack+533425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14403,int_stack+13563,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+1128080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+513665,int_stack+14403,int_stack+12663, 0.0, zero_stack, 1.0, int_stack+608348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12033,int_stack+301135,int_stack+300775, 0.0, zero_stack, 1.0, int_stack+533705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15663,int_stack+12033,int_stack+13563, 0.0, zero_stack, 1.0, int_stack+609248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12033,int_stack+15663,int_stack+14403, 0.0, zero_stack, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+12033,int_stack+513665, 0.0, zero_stack, 1.0, int_stack+693326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+301810,int_stack+301585, 0.0, zero_stack, 1.0, int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1127135,int_stack+302125,int_stack+301810, 0.0, zero_stack, 1.0, int_stack+536190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513665,int_stack+1127135,int_stack+1826213, 0.0, zero_stack, 1.0, int_stack+515165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12033,int_stack+302545,int_stack+302125, 0.0, zero_stack, 1.0, int_stack+536505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+12033,int_stack+1127135, 0.0, zero_stack, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13293,int_stack+588890,int_stack+513665, 0.0, zero_stack, 1.0, int_stack+632693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15543,int_stack+303085,int_stack+302545, 0.0, zero_stack, 1.0, int_stack+536925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+17163,int_stack+15543,int_stack+12033, 0.0, zero_stack, 1.0, int_stack+634043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+696086,int_stack+17163,int_stack+588890, 0.0, zero_stack, 1.0, int_stack+638723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15543,int_stack+696086,int_stack+13293, 0.0, zero_stack, 1.0, int_stack+590780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+15543,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1013096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1127135,int_stack+304075,int_stack+303760, 0.0, zero_stack, 1.0, int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+304516,int_stack+304075, 0.0, zero_stack, 1.0, int_stack+540630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+588890,int_stack+1118135,int_stack+1127135, 0.0, zero_stack, 1.0, int_stack+522215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+696086,int_stack+305104,int_stack+304516, 0.0, zero_stack, 1.0, int_stack+541071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+697850,int_stack+696086,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+1246148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+700496,int_stack+697850,int_stack+588890, 0.0, zero_stack, 1.0, int_stack+1247471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+703646,int_stack+305860,int_stack+305104, 0.0, zero_stack, 1.0, int_stack+541659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+629165,int_stack+703646,int_stack+696086, 0.0, zero_stack, 1.0, int_stack+1249361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+703646,int_stack+629165,int_stack+697850, 0.0, zero_stack, 1.0, int_stack+1261943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+708056,int_stack+703646,int_stack+700496, 0.0, zero_stack, 1.0, int_stack+1264589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+708056,int_stack+15543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1022096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+292158,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+307225,int_stack+306805, 0.0, zero_stack, 1.0, int_stack+317535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+307813,int_stack+307225, 0.0, zero_stack, 1.0, int_stack+318375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+694826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+629165,int_stack+308597,int_stack+307813, 0.0, zero_stack, 1.0, int_stack+319551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+696086,int_stack+629165,int_stack+1016606, 0.0, zero_stack, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+696086,int_stack+1018370, 0.0, zero_stack, 1.0, int_stack+1296089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+309605,int_stack+308597, 0.0, zero_stack, 1.0, int_stack+321119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+699614,int_stack+1015346,int_stack+629165, 0.0, zero_stack, 1.0, int_stack+1298609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+699614,int_stack+696086, 0.0, zero_stack, 1.0, int_stack+1300961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 1.0, int_stack+1304489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2063138,int_stack+0,int_stack+708056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1064261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2077313,int_stack+2063138,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1068986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+311015,int_stack+310865, 1.0, int_stack+533065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+311225,int_stack+311015, 1.0, int_stack+533215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 1.0, int_stack+511765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+311505,int_stack+311225, 1.0, int_stack+533425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 1.0, int_stack+1128080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+513665,int_stack+85278,int_stack+83538, 1.0, int_stack+608348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+311865,int_stack+311505, 1.0, int_stack+533705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 1.0, int_stack+609248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+86538,int_stack+85278, 1.0, int_stack+6300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+82908,int_stack+513665, 1.0, int_stack+693326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+312540,int_stack+312315, 1.0, int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+312855,int_stack+312540, 1.0, int_stack+536190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513665,int_stack+580840,int_stack+1826213, 1.0, int_stack+515165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+313275,int_stack+312855, 1.0, int_stack+536505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+588890,int_stack+82908,int_stack+580840, 1.0, int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84168,int_stack+588890,int_stack+513665, 1.0, int_stack+632693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+513665,int_stack+313815,int_stack+313275, 1.0, int_stack+536925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86418,int_stack+513665,int_stack+82908, 1.0, int_stack+634043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+88938,int_stack+86418,int_stack+588890, 1.0, int_stack+638723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+638723,int_stack+88938,int_stack+84168, 1.0, int_stack+590780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+638723,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1115885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+314805,int_stack+314490, 1.0, int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+315246,int_stack+314805, 1.0, int_stack+540630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+642098,int_stack+1118135,int_stack+580840, 1.0, int_stack+522215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+643988,int_stack+315834,int_stack+315246, 1.0, int_stack+541071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+645752,int_stack+643988,int_stack+1118135, 1.0, int_stack+1246148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+648398,int_stack+645752,int_stack+642098, 1.0, int_stack+1247471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1246148,int_stack+316590,int_stack+315834, 1.0, int_stack+541659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+588890,int_stack+1246148,int_stack+643988, 1.0, int_stack+1249361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1246148,int_stack+588890,int_stack+645752, 1.0, int_stack+1261943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+642098,int_stack+1246148,int_stack+648398, 1.0, int_stack+1264589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+642098,int_stack+638723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1148960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+2063138,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1120385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+318963,int_stack+317955, 1.0, int_stack+317535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+320335,int_stack+318963, 1.0, int_stack+318375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 1.0, int_stack+694826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+638723,int_stack+322127,int_stack+320335, 1.0, int_stack+319551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1246148,int_stack+638723,int_stack+1016606, 1.0, int_stack+572215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+1246148,int_stack+1018370, 1.0, int_stack+1296089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+323135,int_stack+322127, 1.0, int_stack+321119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1261943,int_stack+1015346,int_stack+638723, 1.0, int_stack+1298609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+1261943,int_stack+1246148, 1.0, int_stack+1300961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1296089,int_stack+1015346,int_stack+1198073, 1.0, int_stack+1304489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+305658,int_stack+1296089,int_stack+642098, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1169723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+693320,int_stack+305658,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1174448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+324545,int_stack+324395,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+324755,int_stack+324545,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+325035,int_stack+324755,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+85278,int_stack+83538,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+325395,int_stack+325035,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+86538,int_stack+85278,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+326070,int_stack+325845,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+326385,int_stack+326070,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+326805,int_stack+326385,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+540315,int_stack+580840,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+535965,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+87048,int_stack+327345,int_stack+326805,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+88668,int_stack+87048,int_stack+540315,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+305658,int_stack+88668,int_stack+82908,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+87048,int_stack+305658,int_stack+84798,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+87048,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+636473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+328335,int_stack+328020,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+328776,int_stack+328335,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+305658,int_stack+1118135,int_stack+580840,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+307548,int_stack+329364,int_stack+328776,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+309312,int_stack+307548,int_stack+1118135,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+311958,int_stack+309312,int_stack+305658,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+315108,int_stack+330120,int_stack+329364,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+317376,int_stack+315108,int_stack+307548,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+320904,int_stack+317376,int_stack+309312,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+315108,int_stack+320904,int_stack+311958,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+315108,int_stack+87048, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1251818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+638723,int_stack+120033,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1255193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+331485,int_stack+331065,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+332073,int_stack+331485,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+319833,int_stack+332857,int_stack+332073,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+322185,int_stack+319833,int_stack+1016606,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+322185,int_stack+1018370,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+333865,int_stack+332857,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+325713,int_stack+1015346,int_stack+319833,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+325713,int_stack+322185,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+319833,int_stack+1015346,int_stack+1198073,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+602300,int_stack+319833,int_stack+315108, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1267739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+305658,int_stack+602300,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1272464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+335275,int_stack+335125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550465,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+335485,int_stack+335275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550615,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534065,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+335765,int_stack+335485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550825,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308689,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+122403,int_stack+120663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309319,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+336125,int_stack+335765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551105,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310219,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+123663,int_stack+122403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311059,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1312319,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+336800,int_stack+336575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553365,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+337115,int_stack+336800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553590,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537465,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+337535,int_stack+337115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553905,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+540315,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542415,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1316069,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+338075,int_stack+337535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554325,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317419,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+602300,int_stack+125793,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1318679,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+602300,int_stack+121923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320569,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+600050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+339065,int_stack+338750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557715,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+339506,int_stack+339065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558030,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+602300,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326194,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+604190,int_stack+340094,int_stack+339506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558471,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+605954,int_stack+604190,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327139,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+608600,int_stack+605954,int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7560,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+611750,int_stack+340850,int_stack+340094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559059,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+614018,int_stack+611750,int_stack+604190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356164,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+325908,int_stack+614018,int_stack+605954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357928,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+611750,int_stack+325908,int_stack+608600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360574,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+611750,int_stack+124173, 0.0, zero_stack, 1.0, int_stack+619040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+325908,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+622415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+342215,int_stack+341795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395445,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+342803,int_stack+342215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396285,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+593030,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+339408,int_stack+343587,int_stack+342803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397461,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+602300,int_stack+339408,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392074,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+602300,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1393838,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+344595,int_stack+343587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399029,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+605828,int_stack+1015346,int_stack+339408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396358,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+339408,int_stack+605828,int_stack+602300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398710,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+602300,int_stack+339408,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1402238,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2097563,int_stack+602300,int_stack+611750, 0.0, zero_stack, 1.0, int_stack+652601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2111738,int_stack+2097563,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+657326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+346005,int_stack+345855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550465, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+346215,int_stack+346005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550615, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534065, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+346495,int_stack+346215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550825, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308689, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+85278,int_stack+83538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309319, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+346855,int_stack+346495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551105, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310219, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+86538,int_stack+85278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311059, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1312319, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+347530,int_stack+347305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553365, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+347845,int_stack+347530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553590, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537465, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+348265,int_stack+347845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553905, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+540315,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542415, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1316069, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+87048,int_stack+348805,int_stack+348265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554325, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88668,int_stack+87048,int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317419, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2097563,int_stack+88668,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1318679, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+87048,int_stack+2097563,int_stack+84798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320569, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+87048,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+716069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+349795,int_stack+349480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557715, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+350236,int_stack+349795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558030, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2097563,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326194, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2099453,int_stack+350824,int_stack+350236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558471, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2101217,int_stack+2099453,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327139, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2103863,int_stack+2101217,int_stack+2097563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7560, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2107013,int_stack+351580,int_stack+350824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559059, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+82908,int_stack+2107013,int_stack+2099453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356164, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2107013,int_stack+82908,int_stack+2101217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357928, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2097563,int_stack+2107013,int_stack+2103863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360574, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+2097563,int_stack+87048, 0.0, zero_stack, 1.0, int_stack+725069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+602300,int_stack+120033,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+752924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+352945,int_stack+352525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395445, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+353533,int_stack+352945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396285, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+593030, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+354317,int_stack+353533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397461, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85260,int_stack+82908,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392074, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+85260,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1393838, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+355325,int_stack+354317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399029, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2102288,int_stack+1015346,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396358, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+2102288,int_stack+85260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398710, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2102288,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1402238, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+339408,int_stack+2102288,int_stack+2097563, 0.0, zero_stack, 1.0, int_stack+767234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2131988,int_stack+339408,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+771959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+356735,int_stack+356585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550465, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+356945,int_stack+356735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550615, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534065, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+357225,int_stack+356945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308689, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+122403,int_stack+120663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309319, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+357585,int_stack+357225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551105, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310219, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+123663,int_stack+122403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311059, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1312319, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+358260,int_stack+358035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553365, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+358575,int_stack+358260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553590, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537465, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+358995,int_stack+358575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553905, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+540315,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542415, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1316069, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+359535,int_stack+358995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554325, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317419, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+339408,int_stack+125793,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1318679, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+339408,int_stack+121923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320569, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+815078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+360525,int_stack+360210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557715, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+360966,int_stack+360525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+339408,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326194, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+341298,int_stack+361554,int_stack+360966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558471, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+343062,int_stack+341298,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327139, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+345708,int_stack+343062,int_stack+339408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+348858,int_stack+362310,int_stack+361554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559059, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+351126,int_stack+348858,int_stack+341298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356164, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+354654,int_stack+351126,int_stack+343062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357928, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+348858,int_stack+354654,int_stack+345708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360574, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+348858,int_stack+124173, 0.0, zero_stack, 1.0, int_stack+824078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+2097563,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+851933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+363675,int_stack+363255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395445, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+364263,int_stack+363675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396285, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+593030, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+353583,int_stack+365047,int_stack+364263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397461, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355935,int_stack+353583,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392074, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+355935,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1393838, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+366055,int_stack+365047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399029, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+359463,int_stack+1015346,int_stack+353583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396358, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+359463,int_stack+355935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398710, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+353583,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1402238, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2152238,int_stack+353583,int_stack+348858, 0.0, zero_stack, 1.0, int_stack+866243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+339408,int_stack+2152238,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+870968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+367465,int_stack+367315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+367675,int_stack+367465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+367955,int_stack+367675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+550825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+85278,int_stack+83538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1309319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+368315,int_stack+367955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+86538,int_stack+85278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1311059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1312319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+368990,int_stack+368765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+369305,int_stack+368990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+369725,int_stack+369305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+540315,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+535965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1316069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+87048,int_stack+370265,int_stack+369725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88668,int_stack+87048,int_stack+540315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1317419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2152238,int_stack+88668,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1318679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+87048,int_stack+2152238,int_stack+84798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+87048,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+914087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+371255,int_stack+370940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+371696,int_stack+371255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2152238,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2154128,int_stack+372284,int_stack+371696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+558471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2155892,int_stack+2154128,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2158538,int_stack+2155892,int_stack+2152238, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2161688,int_stack+373040,int_stack+372284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+82908,int_stack+2161688,int_stack+2154128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1356164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2161688,int_stack+82908,int_stack+2155892, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2152238,int_stack+2161688,int_stack+2158538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+2152238,int_stack+87048, 0.0, zero_stack, 1.0, int_stack+923087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+359658,int_stack+120033,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+950942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+374405,int_stack+373985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+374993,int_stack+374405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+593030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+82908,int_stack+375777,int_stack+374993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85260,int_stack+82908,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+85260,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1393838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+376785,int_stack+375777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2156963,int_stack+1015346,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+2156963,int_stack+85260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2156963,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1402238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2163263,int_stack+2156963,int_stack+2152238, 0.0, zero_stack, 1.0, int_stack+965252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2177438,int_stack+2163263,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+969977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+378195,int_stack+378045, 0.0, zero_stack, 1.0, int_stack+550465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+378405,int_stack+378195, 0.0, zero_stack, 1.0, int_stack+550615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+534065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+378685,int_stack+378405, 0.0, zero_stack, 1.0, int_stack+550825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+1308689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+122403,int_stack+120663, 0.0, zero_stack, 1.0, int_stack+1309319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+379045,int_stack+378685, 0.0, zero_stack, 1.0, int_stack+551105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563, 0.0, zero_stack, 1.0, int_stack+1310219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+123663,int_stack+122403, 0.0, zero_stack, 1.0, int_stack+1311059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965, 0.0, zero_stack, 1.0, int_stack+1312319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+379720,int_stack+379495, 0.0, zero_stack, 1.0, int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+380035,int_stack+379720, 0.0, zero_stack, 1.0, int_stack+553590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 1.0, int_stack+537465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+380455,int_stack+380035, 0.0, zero_stack, 1.0, int_stack+553905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+540315,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+542415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+535965, 0.0, zero_stack, 1.0, int_stack+1316069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+380995,int_stack+380455, 0.0, zero_stack, 1.0, int_stack+554325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+540315, 0.0, zero_stack, 1.0, int_stack+1317419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2152238,int_stack+125793,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+1318679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+2152238,int_stack+121923, 0.0, zero_stack, 1.0, int_stack+1320569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+1013096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+381985,int_stack+381670, 0.0, zero_stack, 1.0, int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+382426,int_stack+381985, 0.0, zero_stack, 1.0, int_stack+558030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2152238,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+1326194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2154128,int_stack+383014,int_stack+382426, 0.0, zero_stack, 1.0, int_stack+558471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2155892,int_stack+2154128,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+1327139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2158538,int_stack+2155892,int_stack+2152238, 0.0, zero_stack, 1.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2161688,int_stack+383770,int_stack+383014, 0.0, zero_stack, 1.0, int_stack+559059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2163956,int_stack+2161688,int_stack+2154128, 0.0, zero_stack, 1.0, int_stack+1356164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2167484,int_stack+2163956,int_stack+2155892, 0.0, zero_stack, 1.0, int_stack+1357928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2161688,int_stack+2167484,int_stack+2158538, 0.0, zero_stack, 1.0, int_stack+1360574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+2161688,int_stack+124173, 0.0, zero_stack, 1.0, int_stack+1022096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+2197688,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+1049951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+385135,int_stack+384715, 0.0, zero_stack, 1.0, int_stack+395445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+385723,int_stack+385135, 0.0, zero_stack, 1.0, int_stack+396285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+593030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2166413,int_stack+386507,int_stack+385723, 0.0, zero_stack, 1.0, int_stack+397461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2168765,int_stack+2166413,int_stack+1016606, 0.0, zero_stack, 1.0, int_stack+1392074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+2168765,int_stack+1018370, 0.0, zero_stack, 1.0, int_stack+1393838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+387515,int_stack+386507, 0.0, zero_stack, 1.0, int_stack+399029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2172293,int_stack+1015346,int_stack+2166413, 0.0, zero_stack, 1.0, int_stack+1396358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+2172293,int_stack+2168765, 0.0, zero_stack, 1.0, int_stack+1398710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2166413,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 1.0, int_stack+1402238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+373158,int_stack+2166413,int_stack+2161688, 0.0, zero_stack, 1.0, int_stack+1064261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2152238,int_stack+373158,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+1068986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+388925,int_stack+388775, 1.0, int_stack+550465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+389135,int_stack+388925, 1.0, int_stack+550615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 1.0, int_stack+534065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+389415,int_stack+389135, 1.0, int_stack+550825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 1.0, int_stack+1308689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+535965,int_stack+85278,int_stack+83538, 1.0, int_stack+1309319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+389775,int_stack+389415, 1.0, int_stack+551105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 1.0, int_stack+1310219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540315,int_stack+86538,int_stack+85278, 1.0, int_stack+1311059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+540315,int_stack+535965, 1.0, int_stack+1312319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+390450,int_stack+390225, 1.0, int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+390765,int_stack+390450, 1.0, int_stack+553590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+535965,int_stack+580840,int_stack+1826213, 1.0, int_stack+537465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+540315,int_stack+391185,int_stack+390765, 1.0, int_stack+553905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+540315,int_stack+580840, 1.0, int_stack+542415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+535965, 1.0, int_stack+1316069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+535965,int_stack+391725,int_stack+391185, 1.0, int_stack+554325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+87048,int_stack+535965,int_stack+540315, 1.0, int_stack+1317419, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+89568,int_stack+87048,int_stack+82908, 1.0, int_stack+1318679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1316069,int_stack+89568,int_stack+84798, 1.0, int_stack+1320569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+1316069,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+1115885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+392715,int_stack+392400, 1.0, int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+393156,int_stack+392715, 1.0, int_stack+558030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+82908,int_stack+1118135,int_stack+580840, 1.0, int_stack+1326194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84798,int_stack+393744,int_stack+393156, 1.0, int_stack+558471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+86562,int_stack+84798,int_stack+1118135, 1.0, int_stack+1327139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+89208,int_stack+86562,int_stack+82908, 1.0, int_stack+7560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1326194,int_stack+394500,int_stack+393744, 1.0, int_stack+559059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+373158,int_stack+1326194,int_stack+84798, 1.0, int_stack+1356164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+376686,int_stack+373158,int_stack+86562, 1.0, int_stack+1357928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+82908,int_stack+376686,int_stack+89208, 1.0, int_stack+1360574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+82908,int_stack+1316069, 0.0, zero_stack, 1.0, int_stack+1148960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+373158,int_stack+120033,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+1120385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+396873,int_stack+395865, 1.0, int_stack+395445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+398245,int_stack+396873, 1.0, int_stack+396285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 1.0, int_stack+593030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1316069,int_stack+400037,int_stack+398245, 1.0, int_stack+397461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1318421,int_stack+1316069,int_stack+1016606, 1.0, int_stack+1392074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+1318421,int_stack+1018370, 1.0, int_stack+1393838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1392074,int_stack+401045,int_stack+400037, 1.0, int_stack+399029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1015346,int_stack+1392074,int_stack+1316069, 1.0, int_stack+1396358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1392074,int_stack+1015346,int_stack+1318421, 1.0, int_stack+1398710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1015346,int_stack+1392074,int_stack+1198073, 1.0, int_stack+1402238, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1392074,int_stack+1015346,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+1169723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+0,int_stack+1392074,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+1174448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+402455,int_stack+402305,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+402665,int_stack+402455,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+402945,int_stack+402665,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+122403,int_stack+120663,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+403305,int_stack+402945,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+123663,int_stack+122403,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+403980,int_stack+403755,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+404295,int_stack+403980,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+404715,int_stack+404295,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+557715,int_stack+580840,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+553365,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+405255,int_stack+404715,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+557715,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1392074,int_stack+125793,int_stack+120033,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+1392074,int_stack+121923,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+636473, 1.0, int_stack+1313819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+406245,int_stack+405930,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+406686,int_stack+406245,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1392074,int_stack+1118135,int_stack+580840,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1393964,int_stack+407274,int_stack+406686,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1395728,int_stack+1393964,int_stack+1118135,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1398374,int_stack+1395728,int_stack+1392074,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1401524,int_stack+408030,int_stack+407274,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+120033,int_stack+1401524,int_stack+1393964,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1401524,int_stack+120033,int_stack+1395728,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1392074,int_stack+1401524,int_stack+1398374,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+1392074,int_stack+124173, 0.0, zero_stack, 1.0, int_stack+1251818, 1.0, int_stack+1322819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+386658,int_stack+82908,int_stack+1015346, 0.0, zero_stack, 1.0, int_stack+1255193, 1.0, int_stack+1349414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+409395,int_stack+408975,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+409983,int_stack+409395,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+120033,int_stack+410767,int_stack+409983,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+122385,int_stack+120033,int_stack+1016606,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+122385,int_stack+1018370,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+411775,int_stack+410767,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1396799,int_stack+1015346,int_stack+120033,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+1396799,int_stack+122385,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1396799,int_stack+1015346,int_stack+1198073,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1296089,int_stack+1396799,int_stack+1392074, 0.0, zero_stack, 1.0, int_stack+1267739, 1.0, int_stack+1363724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2211188,int_stack+1296089,int_stack+82908, 0.0, zero_stack, 1.0, int_stack+1272464, 1.0, int_stack+1368449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+413185,int_stack+413035,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+413395,int_stack+413185,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+413675,int_stack+413395,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+85278,int_stack+83538,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+414035,int_stack+413675,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+86538,int_stack+85278,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+414710,int_stack+414485,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+415025,int_stack+414710,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+415445,int_stack+415025,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+557715,int_stack+580840,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+553365,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+87048,int_stack+415985,int_stack+415445,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+88668,int_stack+87048,int_stack+557715,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1296089,int_stack+88668,int_stack+82908,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+87048,int_stack+1296089,int_stack+84798,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+87048,int_stack+1118135, 0.0, zero_stack, 2.0, int_stack+1313819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+416975,int_stack+416660,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+417416,int_stack+416975,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1296089,int_stack+1118135,int_stack+580840,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1297979,int_stack+418004,int_stack+417416,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1299743,int_stack+1297979,int_stack+1118135,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1302389,int_stack+1299743,int_stack+1296089,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1305539,int_stack+418760,int_stack+418004,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1307807,int_stack+1305539,int_stack+1297979,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1392074,int_stack+1307807,int_stack+1299743,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1305539,int_stack+1392074,int_stack+1302389,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+1305539,int_stack+87048, 0.0, zero_stack, 2.0, int_stack+1322819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1392074,int_stack+120033,int_stack+1015346, 0.0, zero_stack, 2.0, int_stack+1349414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+420125,int_stack+419705,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+420713,int_stack+420125,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1310264,int_stack+421497,int_stack+420713,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1296089,int_stack+1310264,int_stack+1016606,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+1296089,int_stack+1018370,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+422505,int_stack+421497,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1299617,int_stack+1015346,int_stack+1310264,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+1299617,int_stack+1296089,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1296089,int_stack+1015346,int_stack+1198073,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+400158,int_stack+1296089,int_stack+1305539, 0.0, zero_stack, 2.0, int_stack+1363724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2231438,int_stack+400158,int_stack+120033, 0.0, zero_stack, 2.0, int_stack+1368449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+425365,int_stack+425215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569315,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+425575,int_stack+425365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569465,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551465,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+425855,int_stack+425575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569675,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406438,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+122403,int_stack+120663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407068,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+426215,int_stack+425855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569955,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407968,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+123663,int_stack+122403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408808,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1410068,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+429065,int_stack+428840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574390,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+429380,int_stack+429065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574615,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554865,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+429800,int_stack+429380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574930,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+557715,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559815,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413818,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+430340,int_stack+429800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575350,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415168,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+400158,int_stack+125793,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1416428,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+400158,int_stack+121923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1418318,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 1.0, int_stack+600050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+434375,int_stack+434060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578740,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+434816,int_stack+434375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579055,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+400158,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+402048,int_stack+435404,int_stack+434816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579496,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+403812,int_stack+402048,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1423943,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+406458,int_stack+403812,int_stack+400158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1453913,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409608,int_stack+436160,int_stack+435404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580084,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+411876,int_stack+409608,int_stack+402048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455803,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+415404,int_stack+411876,int_stack+403812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1457567,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+409608,int_stack+415404,int_stack+406458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1460213,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+409608,int_stack+124173, 1.0, int_stack+619040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+414333,int_stack+82908,int_stack+1015346, 1.0, int_stack+622415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1015346,int_stack+437525,int_stack+437105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526205,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1016606,int_stack+438113,int_stack+437525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527045,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1018370,int_stack+1016606,int_stack+1015346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681896,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+427833,int_stack+438897,int_stack+438113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528221,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+430185,int_stack+427833,int_stack+1016606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683156,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+430185,int_stack+1018370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684920,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1015346,int_stack+439905,int_stack+438897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529789,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+433713,int_stack+1015346,int_stack+427833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687440,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1015346,int_stack+433713,int_stack+430185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689792,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+427833,int_stack+1015346,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1491713,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1296089,int_stack+427833,int_stack+409608, 1.0, int_stack+652601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+615800,int_stack+1296089,int_stack+82908, 1.0, int_stack+657326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+442765,int_stack+442615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569315, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+442975,int_stack+442765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569465, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551465, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+443255,int_stack+442975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569675, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406438, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+85278,int_stack+83538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407068, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+443615,int_stack+443255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569955, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407968, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+86538,int_stack+85278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408808, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1410068, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+446465,int_stack+446240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574390, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+446780,int_stack+446465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574615, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554865, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+447200,int_stack+446780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574930, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+557715,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559815, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413818, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+87048,int_stack+447740,int_stack+447200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575350, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88668,int_stack+87048,int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415168, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1296089,int_stack+88668,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1416428, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+87048,int_stack+1296089,int_stack+84798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1418318, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+87048,int_stack+1118135, 1.0, int_stack+716069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+451775,int_stack+451460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578740, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+452216,int_stack+451775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579055, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1296089,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1297979,int_stack+452804,int_stack+452216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579496, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1299743,int_stack+1297979,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1423943, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1302389,int_stack+1299743,int_stack+1296089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1453913, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1305539,int_stack+453560,int_stack+452804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580084, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1307807,int_stack+1305539,int_stack+1297979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455803, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+427833,int_stack+1307807,int_stack+1299743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1457567, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1305539,int_stack+427833,int_stack+1302389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1460213, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+1305539,int_stack+87048, 1.0, int_stack+725069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+427833,int_stack+120033,int_stack+1015346, 1.0, int_stack+752924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+752924,int_stack+454925,int_stack+454505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526205, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+754184,int_stack+455513,int_stack+454925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527045, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+755948,int_stack+754184,int_stack+752924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681896, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+758468,int_stack+456297,int_stack+455513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528221, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+760820,int_stack+758468,int_stack+754184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683156, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+760820,int_stack+755948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684920, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+752924,int_stack+457305,int_stack+456297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529789, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1015346,int_stack+752924,int_stack+758468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687440, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+752924,int_stack+1015346,int_stack+760820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689792, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1015346,int_stack+752924,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1491713, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+400158,int_stack+1015346,int_stack+1305539, 1.0, int_stack+767234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2251688,int_stack+400158,int_stack+120033, 1.0, int_stack+771959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+460165,int_stack+460015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569315, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+460375,int_stack+460165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569465, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551465, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+460655,int_stack+460375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569675, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406438, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+122403,int_stack+120663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407068, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+461015,int_stack+460655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569955, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407968, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+123663,int_stack+122403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408808, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1410068, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+463865,int_stack+463640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574390, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+464180,int_stack+463865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574615, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554865, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+464600,int_stack+464180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574930, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+557715,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559815, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413818, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+465140,int_stack+464600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575350, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415168, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+400158,int_stack+125793,int_stack+120033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1416428, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+400158,int_stack+121923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1418318, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 1.0, int_stack+815078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+469175,int_stack+468860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578740, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+469616,int_stack+469175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579055, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+400158,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+402048,int_stack+470204,int_stack+469616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579496, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+403812,int_stack+402048,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1423943, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+406458,int_stack+403812,int_stack+400158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1453913, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409608,int_stack+470960,int_stack+470204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580084, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+120033,int_stack+409608,int_stack+402048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455803, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+409608,int_stack+120033,int_stack+403812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1457567, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+400158,int_stack+409608,int_stack+406458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1460213, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+400158,int_stack+124173, 1.0, int_stack+824078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+752924,int_stack+82908,int_stack+1015346, 1.0, int_stack+851933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+851933,int_stack+472325,int_stack+471905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526205, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+853193,int_stack+472913,int_stack+472325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527045, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+854957,int_stack+853193,int_stack+851933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681896, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+857477,int_stack+473697,int_stack+472913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528221, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+859829,int_stack+857477,int_stack+853193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683156, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+859829,int_stack+854957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684920, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+851933,int_stack+474705,int_stack+473697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529789, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1015346,int_stack+851933,int_stack+857477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687440, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+851933,int_stack+1015346,int_stack+859829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689792, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1015346,int_stack+851933,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1491713, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+851933,int_stack+1015346,int_stack+400158, 1.0, int_stack+866243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+441333,int_stack+851933,int_stack+82908, 1.0, int_stack+870968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+477565,int_stack+477415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+477775,int_stack+477565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+551465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+478055,int_stack+477775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+85278,int_stack+83538, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+478415,int_stack+478055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+86538,int_stack+85278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1410068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+481265,int_stack+481040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+481580,int_stack+481265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+554865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+482000,int_stack+481580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+557715,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+559815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+553365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+87048,int_stack+482540,int_stack+482000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+88668,int_stack+87048,int_stack+557715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+851933,int_stack+88668,int_stack+82908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1416428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+87048,int_stack+851933,int_stack+84798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1418318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+87048,int_stack+1118135, 1.0, int_stack+914087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+486575,int_stack+486260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+487016,int_stack+486575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+851933,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+853823,int_stack+487604,int_stack+487016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855587,int_stack+853823,int_stack+1118135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1423943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+858233,int_stack+855587,int_stack+851933, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1453913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+861383,int_stack+488360,int_stack+487604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+863651,int_stack+861383,int_stack+853823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+867179,int_stack+863651,int_stack+855587, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1457567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+861383,int_stack+867179,int_stack+858233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1460213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+120033,int_stack+861383,int_stack+87048, 1.0, int_stack+923087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+866108,int_stack+120033,int_stack+1015346, 1.0, int_stack+950942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+950942,int_stack+489725,int_stack+489305, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+952202,int_stack+490313,int_stack+489725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+953966,int_stack+952202,int_stack+950942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+681896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+956486,int_stack+491097,int_stack+490313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+958838,int_stack+956486,int_stack+952202, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+683156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+958838,int_stack+953966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+950942,int_stack+492105,int_stack+491097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1015346,int_stack+950942,int_stack+956486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+950942,int_stack+1015346,int_stack+958838, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1015346,int_stack+950942,int_stack+1198073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1491713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+400158,int_stack+1015346,int_stack+861383, 1.0, int_stack+965252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+461583,int_stack+400158,int_stack+120033, 1.0, int_stack+969977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+494965,int_stack+494815, 0.0, zero_stack, 1.0, int_stack+569315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+120033,int_stack+495175,int_stack+494965, 0.0, zero_stack, 1.0, int_stack+569465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+120663,int_stack+120033,int_stack+570315, 0.0, zero_stack, 1.0, int_stack+551465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+121563,int_stack+495455,int_stack+495175, 0.0, zero_stack, 1.0, int_stack+569675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+122403,int_stack+121563,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+1406438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+122403,int_stack+120663, 0.0, zero_stack, 1.0, int_stack+1407068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+120033,int_stack+495815,int_stack+495455, 0.0, zero_stack, 1.0, int_stack+569955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+123663,int_stack+120033,int_stack+121563, 0.0, zero_stack, 1.0, int_stack+1407968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+123663,int_stack+122403, 0.0, zero_stack, 1.0, int_stack+1408808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365, 0.0, zero_stack, 1.0, int_stack+1410068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+498665,int_stack+498440, 0.0, zero_stack, 1.0, int_stack+574390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+498980,int_stack+498665, 0.0, zero_stack, 1.0, int_stack+574615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213, 0.0, zero_stack, 1.0, int_stack+554865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+499400,int_stack+498980, 0.0, zero_stack, 1.0, int_stack+574930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+120033,int_stack+557715,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+559815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+121923,int_stack+120033,int_stack+553365, 0.0, zero_stack, 1.0, int_stack+1413818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+124173,int_stack+499940,int_stack+499400, 0.0, zero_stack, 1.0, int_stack+575350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+125793,int_stack+124173,int_stack+557715, 0.0, zero_stack, 1.0, int_stack+1415168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+400158,int_stack+125793,int_stack+120033, 0.0, zero_stack, 1.0, int_stack+1416428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+124173,int_stack+400158,int_stack+121923, 0.0, zero_stack, 1.0, int_stack+1418318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1015346,int_stack+124173,int_stack+1118135, 1.0, int_stack+1013096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+503975,int_stack+503660, 0.0, zero_stack, 1.0, int_stack+578740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1118135,int_stack+504416,int_stack+503975, 0.0, zero_stack, 1.0, int_stack+579055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+400158,int_stack+1118135,int_stack+580840, 0.0, zero_stack, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+402048,int_stack+505004,int_stack+504416, 0.0, zero_stack, 1.0, int_stack+579496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+403812,int_stack+402048,int_stack+1118135, 0.0, zero_stack, 1.0, int_stack+1423943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+406458,int_stack+403812,int_stack+400158, 0.0, zero_stack, 1.0, int_stack+1453913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409608,int_stack+505760,int_stack+505004, 0.0, zero_stack, 1.0, int_stack+580084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+120033,int_stack+409608,int_stack+402048, 0.0, zero_stack, 1.0, int_stack+1455803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+409608,int_stack+120033,int_stack+403812, 0.0, zero_stack, 1.0, int_stack+1457567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+400158,int_stack+409608,int_stack+406458, 0.0, zero_stack, 1.0, int_stack+1460213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+400158,int_stack+124173, 1.0, int_stack+1022096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+950942,int_stack+82908,int_stack+1015346, 1.0, int_stack+1049951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1049951,int_stack+507125,int_stack+506705, 0.0, zero_stack, 1.0, int_stack+526205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1051211,int_stack+507713,int_stack+507125, 0.0, zero_stack, 1.0, int_stack+527045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1052975,int_stack+1051211,int_stack+1049951, 0.0, zero_stack, 1.0, int_stack+681896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1055495,int_stack+508497,int_stack+507713, 0.0, zero_stack, 1.0, int_stack+528221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1057847,int_stack+1055495,int_stack+1051211, 0.0, zero_stack, 1.0, int_stack+683156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+1057847,int_stack+1052975, 0.0, zero_stack, 1.0, int_stack+684920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1049951,int_stack+509505,int_stack+508497, 0.0, zero_stack, 1.0, int_stack+529789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+120033,int_stack+1049951,int_stack+1055495, 0.0, zero_stack, 1.0, int_stack+687440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1049951,int_stack+120033,int_stack+1057847, 0.0, zero_stack, 1.0, int_stack+689792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+120033,int_stack+1049951,int_stack+1198073, 0.0, zero_stack, 1.0, int_stack+1491713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+851933,int_stack+120033,int_stack+400158, 1.0, int_stack+1064261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+481833,int_stack+851933,int_stack+82908, 1.0, int_stack+1068986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+570315,int_stack+512365,int_stack+512215, 1.0, int_stack+569315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+512575,int_stack+512365, 1.0, int_stack+569465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+83538,int_stack+82908,int_stack+570315, 1.0, int_stack+551465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+84438,int_stack+512855,int_stack+512575, 1.0, int_stack+569675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+85278,int_stack+84438,int_stack+82908, 1.0, int_stack+1406438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+553365,int_stack+85278,int_stack+83538, 1.0, int_stack+1407068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+513215,int_stack+512855, 1.0, int_stack+569955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+86538,int_stack+82908,int_stack+84438, 1.0, int_stack+1407968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+557715,int_stack+86538,int_stack+85278, 1.0, int_stack+1408808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1118135,int_stack+557715,int_stack+553365, 1.0, int_stack+1410068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+516065,int_stack+515840, 1.0, int_stack+574390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+580840,int_stack+516380,int_stack+516065, 1.0, int_stack+574615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+553365,int_stack+580840,int_stack+1826213, 1.0, int_stack+554865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+557715,int_stack+516800,int_stack+516380, 1.0, int_stack+574930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+82908,int_stack+557715,int_stack+580840, 1.0, int_stack+559815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+84798,int_stack+82908,int_stack+553365, 1.0, int_stack+1413818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+553365,int_stack+517340,int_stack+516800, 1.0, int_stack+575350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+87048,int_stack+553365,int_stack+557715, 1.0, int_stack+1415168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+89568,int_stack+87048,int_stack+82908, 1.0, int_stack+1416428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1413818,int_stack+89568,int_stack+84798, 1.0, int_stack+1418318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1316069,int_stack+1413818,int_stack+1118135, 1.0, int_stack+1115885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+580840,int_stack+523475,int_stack+523160, 1.0, int_stack+578740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+523916,int_stack+523475, 1.0, int_stack+579055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+84231,int_stack+82908,int_stack+580840, 1.0, int_stack+680951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+86121,int_stack+524504,int_stack+523916, 1.0, int_stack+579496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+87885,int_stack+86121,int_stack+82908, 1.0, int_stack+1423943, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1417193,int_stack+87885,int_stack+84231, 1.0, int_stack+1453913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1423943,int_stack+525260,int_stack+524504, 1.0, int_stack+580084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+851933,int_stack+1423943,int_stack+86121, 1.0, int_stack+1455803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+851933,int_stack+87885, 1.0, int_stack+1457567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+851933,int_stack+82908,int_stack+1417193, 1.0, int_stack+1460213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+851933,int_stack+1413818, 1.0, int_stack+1148960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+400158,int_stack+82908,int_stack+1316069, 1.0, int_stack+1120385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1316069,int_stack+527633,int_stack+526625, 1.0, int_stack+526205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1317329,int_stack+529005,int_stack+527633, 1.0, int_stack+527045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1319093,int_stack+1317329,int_stack+1316069, 1.0, int_stack+681896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1148960,int_stack+530797,int_stack+529005, 1.0, int_stack+528221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1413818,int_stack+1148960,int_stack+1317329, 1.0, int_stack+683156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1198073,int_stack+1413818,int_stack+1319093, 1.0, int_stack+684920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1316069,int_stack+531805,int_stack+530797, 1.0, int_stack+529789, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+856658,int_stack+1316069,int_stack+1148960, 1.0, int_stack+687440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1316069,int_stack+856658,int_stack+1413818, 1.0, int_stack+689792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1413818,int_stack+1316069,int_stack+1198073, 1.0, int_stack+1491713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1049951,int_stack+1413818,int_stack+851933, 1.0, int_stack+1169723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+502083,int_stack+1049951,int_stack+82908, 1.0, int_stack+1174448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+534665,int_stack+534515,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+83358,int_stack+534875,int_stack+534665,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83988,int_stack+83358,int_stack+82908,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+84888,int_stack+535155,int_stack+534875,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+85728,int_stack+84888,int_stack+83358,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+86988,int_stack+85728,int_stack+83988,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+535515,int_stack+535155,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+88488,int_stack+82908,int_stack+84888,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+88488,int_stack+85728,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+88488,int_stack+82908,int_stack+86988,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+538365,int_stack+538140,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+538680,int_stack+538365,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83853,int_stack+82908,int_stack+1826213,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+85203,int_stack+539100,int_stack+538680,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+86463,int_stack+85203,int_stack+82908,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+90738,int_stack+86463,int_stack+83853,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+539640,int_stack+539100,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1049951,int_stack+82908,int_stack+85203,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+1049951,int_stack+86463,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1148960,int_stack+82908,int_stack+90738,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1413818,int_stack+1148960,int_stack+88488, 1.0, int_stack+636473, 0.0, zero_stack, 1.0, int_stack+1411568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+543675,int_stack+543360,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+83853,int_stack+544116,int_stack+543675,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+85176,int_stack+83853,int_stack+82908,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+87066,int_stack+544704,int_stack+544116,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+88830,int_stack+87066,int_stack+83853,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1049951,int_stack+88830,int_stack+85176,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+545460,int_stack+544704,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1053101,int_stack+82908,int_stack+87066,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+1053101,int_stack+88830,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1053101,int_stack+82908,int_stack+1049951,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+1053101,int_stack+1148960, 1.0, int_stack+1251818, 0.0, zero_stack, 1.0, int_stack+1420568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1057826,int_stack+82908,int_stack+1413818, 1.0, int_stack+1255193, 0.0, zero_stack, 1.0, int_stack+1447163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1413818,int_stack+546825,int_stack+546405,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1415078,int_stack+547413,int_stack+546825,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1416842,int_stack+1415078,int_stack+1413818,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1148960,int_stack+548197,int_stack+547413,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1071326,int_stack+1148960,int_stack+1415078,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1491713,int_stack+1071326,int_stack+1416842,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1413818,int_stack+549205,int_stack+548197,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+851933,int_stack+1413818,int_stack+1148960,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1413818,int_stack+851933,int_stack+1071326,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1071326,int_stack+1413818,int_stack+1491713,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+851933,int_stack+1071326,int_stack+1053101, 1.0, int_stack+1267739, 0.0, zero_stack, 1.0, int_stack+1463363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+522333,int_stack+851933,int_stack+82908, 1.0, int_stack+1272464, 0.0, zero_stack, 1.0, int_stack+1468088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+552065,int_stack+551915,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+83358,int_stack+552275,int_stack+552065,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83988,int_stack+83358,int_stack+82908,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+84888,int_stack+552555,int_stack+552275,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+85728,int_stack+84888,int_stack+83358,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+86988,int_stack+85728,int_stack+83988,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+552915,int_stack+552555,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+88488,int_stack+82908,int_stack+84888,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+88488,int_stack+85728,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+88488,int_stack+82908,int_stack+86988,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+555765,int_stack+555540,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+556080,int_stack+555765,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83853,int_stack+82908,int_stack+1826213,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+85203,int_stack+556500,int_stack+556080,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+86463,int_stack+85203,int_stack+82908,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+90738,int_stack+86463,int_stack+83853,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+557040,int_stack+556500,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+851933,int_stack+82908,int_stack+85203,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+851933,int_stack+86463,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1148960,int_stack+82908,int_stack+90738,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1413818,int_stack+1148960,int_stack+88488, 1.0, int_stack+1313819, 1.0, int_stack+1411568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+561075,int_stack+560760,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+83853,int_stack+561516,int_stack+561075,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+85176,int_stack+83853,int_stack+82908,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+87066,int_stack+562104,int_stack+561516,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+88830,int_stack+87066,int_stack+83853,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+851933,int_stack+88830,int_stack+85176,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+562860,int_stack+562104,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+855083,int_stack+82908,int_stack+87066,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+855083,int_stack+88830,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+855083,int_stack+82908,int_stack+851933,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+855083,int_stack+1148960, 1.0, int_stack+1322819, 1.0, int_stack+1420568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+964442,int_stack+82908,int_stack+1413818, 1.0, int_stack+1349414, 1.0, int_stack+1447163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1349414,int_stack+564225,int_stack+563805,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1350674,int_stack+564813,int_stack+564225,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1352438,int_stack+1350674,int_stack+1349414,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1354958,int_stack+565597,int_stack+564813,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1357310,int_stack+1354958,int_stack+1350674,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1491713,int_stack+1357310,int_stack+1352438,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1349414,int_stack+566605,int_stack+565597,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1413818,int_stack+1349414,int_stack+1354958,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1349414,int_stack+1413818,int_stack+1357310,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+859808,int_stack+1349414,int_stack+1491713,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1349414,int_stack+859808,int_stack+855083, 1.0, int_stack+1363724, 1.0, int_stack+1463363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+542583,int_stack+1349414,int_stack+82908, 1.0, int_stack+1368449, 1.0, int_stack+1468088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+570915,int_stack+570765,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+83358,int_stack+571125,int_stack+570915,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83988,int_stack+83358,int_stack+82908,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+84888,int_stack+571405,int_stack+571125,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+85728,int_stack+84888,int_stack+83358,10);
 /*--- compute (f0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+86988,int_stack+85728,int_stack+83988,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+571765,int_stack+571405,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+88488,int_stack+82908,int_stack+84888,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+88488,int_stack+85728,10);
 /*--- compute (f0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+88488,int_stack+82908,int_stack+86988,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1826213,int_stack+576790,int_stack+576565,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+82908,int_stack+577105,int_stack+576790,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+83853,int_stack+82908,int_stack+1826213,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+85203,int_stack+577525,int_stack+577105,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+86463,int_stack+85203,int_stack+82908,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+90738,int_stack+86463,int_stack+83853,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+578065,int_stack+577525,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1349414,int_stack+82908,int_stack+85203,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+1349414,int_stack+86463,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1148960,int_stack+82908,int_stack+90738,15);
 /*--- compute (fp|gg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+1413818,int_stack+1148960,int_stack+88488, 2.0, int_stack+1411568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+82908,int_stack+582100,int_stack+581785,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+83853,int_stack+582541,int_stack+582100,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+85176,int_stack+83853,int_stack+82908,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+87066,int_stack+583129,int_stack+582541,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+88830,int_stack+87066,int_stack+83853,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1349414,int_stack+88830,int_stack+85176,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82908,int_stack+583885,int_stack+583129,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1352564,int_stack+82908,int_stack+87066,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+82908,int_stack+1352564,int_stack+88830,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1352564,int_stack+82908,int_stack+1349414,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+82908,int_stack+1352564,int_stack+1148960, 2.0, int_stack+1420568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (fd|gg) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+1357289,int_stack+82908,int_stack+1413818, 2.0, int_stack+1447163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1447163,int_stack+585250,int_stack+584830,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1448423,int_stack+585838,int_stack+585250,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1450187,int_stack+1448423,int_stack+1447163,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1452707,int_stack+586622,int_stack+585838,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1455059,int_stack+1452707,int_stack+1448423,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1491713,int_stack+1455059,int_stack+1450187,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1447163,int_stack+587630,int_stack+586622,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1458587,int_stack+1447163,int_stack+1452707,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1447163,int_stack+1458587,int_stack+1455059,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1453043,int_stack+1447163,int_stack+1491713,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+851933,int_stack+1453043,int_stack+1352564, 2.0, int_stack+1463363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1447163,int_stack+851933,int_stack+82908, 2.0, int_stack+1468088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+562833,int_stack+732674,int_stack+667451,225);
     Libderiv->ABCD[11] = int_stack + 562833;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1296089,int_stack+831683,int_stack+782084,225);
     Libderiv->ABCD[10] = int_stack + 1296089;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1246148,int_stack+930692,int_stack+881093,225);
     Libderiv->ABCD[9] = int_stack + 1246148;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+809084,int_stack+1029701,int_stack+980102,225);
     Libderiv->ABCD[8] = int_stack + 809084;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+831584,int_stack+1128710,int_stack+1079111,225);
     Libderiv->ABCD[7] = int_stack + 831584;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+908093,int_stack+1202273,int_stack+1184573,225);
     Libderiv->ABCD[6] = int_stack + 908093;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1198073,int_stack+1329164,int_stack+1282589, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1232648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 1198073;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1318589,int_stack+1426913,int_stack+1378574, 0.0, zero_stack, 1.0, int_stack+1232648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 1318589;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1405574,int_stack+1516388,int_stack+1478213, 1.0, int_stack+1232648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 1405574;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1220573,int_stack+1564313,int_stack+1536638,225);
     Libderiv->ABCD[155] = int_stack + 1220573;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1106111,int_stack+1584563,int_stack+1550138,225);
     Libderiv->ABCD[143] = int_stack + 1106111;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1128611,int_stack+1604813,int_stack+1495913,225);
     Libderiv->ABCD[142] = int_stack + 1128611;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1491713,int_stack+35658,int_stack+22158,225);
     Libderiv->ABCD[131] = int_stack + 1491713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1514213,int_stack+1662863,int_stack+1635188,225);
     Libderiv->ABCD[130] = int_stack + 1514213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1536713,int_stack+1683113,int_stack+55908,225);
     Libderiv->ABCD[129] = int_stack + 1536713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1559213,int_stack+1717538,int_stack+69408,225);
     Libderiv->ABCD[119] = int_stack + 1559213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1581713,int_stack+1737788,int_stack+1648688,225);
     Libderiv->ABCD[118] = int_stack + 1581713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1604213,int_stack+1758038,int_stack+1703363,225);
     Libderiv->ABCD[117] = int_stack + 1604213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1626713,int_stack+1792463,int_stack+93033,225);
     Libderiv->ABCD[116] = int_stack + 1626713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1649213,int_stack+1826888,int_stack+106533,225);
     Libderiv->ABCD[107] = int_stack + 1649213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1671713,int_stack+1847138,int_stack+1778288,225);
     Libderiv->ABCD[106] = int_stack + 1671713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1694213,int_stack+1867388,int_stack+130158,225);
     Libderiv->ABCD[105] = int_stack + 1694213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1716713,int_stack+1887638,int_stack+143658,225);
     Libderiv->ABCD[104] = int_stack + 1716713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1739213,int_stack+1921388,int_stack+1907888,225);
     Libderiv->ABCD[103] = int_stack + 1739213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1761713,int_stack+1941638,int_stack+157158,225);
     Libderiv->ABCD[95] = int_stack + 1761713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1784213,int_stack+1961888,int_stack+1812713,225);
     Libderiv->ABCD[94] = int_stack + 1784213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1806713,int_stack+1982138,int_stack+170658,225);
     Libderiv->ABCD[93] = int_stack + 1806713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1829213,int_stack+197658,int_stack+184158,225);
     Libderiv->ABCD[92] = int_stack + 1829213;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+1851713,int_stack+217908,int_stack+993602,225);
     Libderiv->ABCD[91] = int_stack + 1851713;
 /*--- compute (ff|gg) ---*/
   hrr1_build_ff(Libderiv->AB,int_stack+993602,int_stack+2002388,int_stack+1092611,225);
     Libderiv->ABCD[90] = int_stack + 993602;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1016102,int_stack+238158,int_stack+1152335, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+667451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[47] = int_stack + 1016102;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1874213,int_stack+2022638,int_stack+258408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[46] = int_stack + 1874213;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1896713,int_stack+2042888,int_stack+894593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[45] = int_stack + 1896713;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1919213,int_stack+271908,int_stack+795584, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+980102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[44] = int_stack + 1919213;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1941713,int_stack+2077313,int_stack+292158, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1079111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[43] = int_stack + 1941713;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1964213,int_stack+693320,int_stack+2063138, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1184573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[42] = int_stack + 1964213;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+1986713,int_stack+305658,int_stack+638723, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1282589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[38] = int_stack + 1986713;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2009213,int_stack+2111738,int_stack+325908, 0.0, zero_stack, 1.0, int_stack+667451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[35] = int_stack + 2009213;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2031713,int_stack+2131988,int_stack+602300, 0.0, zero_stack, 1.0, int_stack+782084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[34] = int_stack + 2031713;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2054213,int_stack+339408,int_stack+2097563, 0.0, zero_stack, 1.0, int_stack+881093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[33] = int_stack + 2054213;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2076713,int_stack+2177438,int_stack+359658, 0.0, zero_stack, 1.0, int_stack+980102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[32] = int_stack + 2076713;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2099213,int_stack+2152238,int_stack+2197688, 0.0, zero_stack, 1.0, int_stack+1079111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[31] = int_stack + 2099213;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+2121713,int_stack+0,int_stack+373158, 0.0, zero_stack, 1.0, int_stack+1184573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[30] = int_stack + 2121713;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+0,int_stack+2211188,int_stack+386658, 0.0, zero_stack, 1.0, int_stack+1282589, 1.0, int_stack+1378574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[26] = int_stack + 0;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+22500,int_stack+2231438,int_stack+1392074, 0.0, zero_stack, 2.0, int_stack+1378574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[25] = int_stack + 22500;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+45000,int_stack+615800,int_stack+414333, 1.0, int_stack+667451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[23] = int_stack + 45000;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+67500,int_stack+2251688,int_stack+427833, 1.0, int_stack+782084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[22] = int_stack + 67500;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+90000,int_stack+441333,int_stack+752924, 1.0, int_stack+881093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[21] = int_stack + 90000;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+112500,int_stack+461583,int_stack+866108, 1.0, int_stack+980102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[20] = int_stack + 112500;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+135000,int_stack+481833,int_stack+950942, 1.0, int_stack+1079111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[19] = int_stack + 135000;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+157500,int_stack+502083,int_stack+400158, 1.0, int_stack+1184573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[18] = int_stack + 157500;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+180000,int_stack+522333,int_stack+1057826, 1.0, int_stack+1282589, 0.0, zero_stack, 1.0, int_stack+1478213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[14] = int_stack + 180000;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+202500,int_stack+542583,int_stack+964442, 1.0, int_stack+1378574, 1.0, int_stack+1478213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[13] = int_stack + 202500;
 /*--- compute (ff|gg) ---*/
   d1hrr1_build_ff(Libderiv->AB,int_stack+225000,int_stack+1447163,int_stack+1357289, 2.0, int_stack+1478213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[12] = int_stack + 225000;

}
