/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fphg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|hg) integrals */

void d12hrr_order_fphg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][9][11] = int_stack + 0;
 Libderiv->deriv_classes[4][9][10] = int_stack + 825;
 Libderiv->deriv_classes[4][9][9] = int_stack + 1650;
 Libderiv->deriv_classes[4][9][8] = int_stack + 2475;
 Libderiv->deriv_classes[4][9][7] = int_stack + 3300;
 Libderiv->dvrr_classes[4][8] = int_stack + 4125;
 Libderiv->deriv_classes[4][9][6] = int_stack + 4800;
 Libderiv->deriv_classes[4][9][2] = int_stack + 5625;
 Libderiv->deriv_classes[4][9][1] = int_stack + 6450;
 Libderiv->dvrr_classes[3][9] = int_stack + 7275;
 Libderiv->deriv_classes[4][9][0] = int_stack + 7825;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 8650;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 8860;
 Libderiv->deriv2_classes[3][7][143] = int_stack + 9140;
 Libderiv->deriv2_classes[3][8][143] = int_stack + 9500;
 Libderiv->deriv2_classes[3][9][143] = int_stack + 9950;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 10500;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 10815;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 11235;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 11775;
 Libderiv->deriv2_classes[4][9][143] = int_stack + 12450;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 13275;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 13485;
 Libderiv->deriv2_classes[3][7][131] = int_stack + 13765;
 Libderiv->deriv2_classes[3][8][131] = int_stack + 14125;
 Libderiv->deriv2_classes[3][9][131] = int_stack + 14575;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 15125;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 15440;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 15860;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 16400;
 Libderiv->deriv2_classes[4][9][131] = int_stack + 17075;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 17900;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 18110;
 Libderiv->deriv2_classes[3][7][130] = int_stack + 18390;
 Libderiv->deriv2_classes[3][8][130] = int_stack + 18750;
 Libderiv->deriv2_classes[3][9][130] = int_stack + 19200;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 19750;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 20065;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 20485;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 21025;
 Libderiv->deriv2_classes[4][9][130] = int_stack + 21700;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 22525;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 22735;
 Libderiv->deriv2_classes[3][7][119] = int_stack + 23015;
 Libderiv->deriv2_classes[3][8][119] = int_stack + 23375;
 Libderiv->deriv2_classes[3][9][119] = int_stack + 23825;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 24375;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 24690;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 25110;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 25650;
 Libderiv->deriv2_classes[4][9][119] = int_stack + 26325;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 27150;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 27360;
 Libderiv->deriv2_classes[3][7][118] = int_stack + 27640;
 Libderiv->deriv2_classes[3][8][118] = int_stack + 28000;
 Libderiv->deriv2_classes[3][9][118] = int_stack + 28450;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 29000;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 29315;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 29735;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 30275;
 Libderiv->deriv2_classes[4][9][118] = int_stack + 30950;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 31775;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 31985;
 Libderiv->deriv2_classes[3][7][117] = int_stack + 32265;
 Libderiv->deriv2_classes[3][8][117] = int_stack + 32625;
 Libderiv->deriv2_classes[3][9][117] = int_stack + 33075;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 33625;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 33940;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 34360;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 34900;
 Libderiv->deriv2_classes[4][9][117] = int_stack + 35575;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 36400;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 36610;
 Libderiv->deriv2_classes[3][7][107] = int_stack + 36890;
 Libderiv->deriv2_classes[3][8][107] = int_stack + 37250;
 Libderiv->deriv2_classes[3][9][107] = int_stack + 37700;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 38250;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 38565;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 38985;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 39525;
 Libderiv->deriv2_classes[4][9][107] = int_stack + 40200;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 41025;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 41235;
 Libderiv->deriv2_classes[3][7][106] = int_stack + 41515;
 Libderiv->deriv2_classes[3][8][106] = int_stack + 41875;
 Libderiv->deriv2_classes[3][9][106] = int_stack + 42325;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 42875;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 43190;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 43610;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 44150;
 Libderiv->deriv2_classes[4][9][106] = int_stack + 44825;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 45650;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 45860;
 Libderiv->deriv2_classes[3][7][105] = int_stack + 46140;
 Libderiv->deriv2_classes[3][8][105] = int_stack + 46500;
 Libderiv->deriv2_classes[3][9][105] = int_stack + 46950;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 47500;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 47815;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 48235;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 48775;
 Libderiv->deriv2_classes[4][9][105] = int_stack + 49450;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 50275;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 50485;
 Libderiv->deriv2_classes[3][7][104] = int_stack + 50765;
 Libderiv->deriv2_classes[3][8][104] = int_stack + 51125;
 Libderiv->deriv2_classes[3][9][104] = int_stack + 51575;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 52125;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 52440;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 52860;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 53400;
 Libderiv->deriv2_classes[4][9][104] = int_stack + 54075;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 54900;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 55110;
 Libderiv->deriv2_classes[3][7][95] = int_stack + 55390;
 Libderiv->deriv2_classes[3][8][95] = int_stack + 55750;
 Libderiv->deriv2_classes[3][9][95] = int_stack + 56200;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 56750;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 57065;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 57485;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 58025;
 Libderiv->deriv2_classes[4][9][95] = int_stack + 58700;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 59525;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 59735;
 Libderiv->deriv2_classes[3][7][94] = int_stack + 60015;
 Libderiv->deriv2_classes[3][8][94] = int_stack + 60375;
 Libderiv->deriv2_classes[3][9][94] = int_stack + 60825;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 61375;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 61690;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 62110;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 62650;
 Libderiv->deriv2_classes[4][9][94] = int_stack + 63325;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 64150;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 64360;
 Libderiv->deriv2_classes[3][7][93] = int_stack + 64640;
 Libderiv->deriv2_classes[3][8][93] = int_stack + 65000;
 Libderiv->deriv2_classes[3][9][93] = int_stack + 65450;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 66000;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 66315;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 66735;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 67275;
 Libderiv->deriv2_classes[4][9][93] = int_stack + 67950;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 68775;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 68985;
 Libderiv->deriv2_classes[3][7][92] = int_stack + 69265;
 Libderiv->deriv2_classes[3][8][92] = int_stack + 69625;
 Libderiv->deriv2_classes[3][9][92] = int_stack + 70075;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 70625;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 70940;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 71360;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 71900;
 Libderiv->deriv2_classes[4][9][92] = int_stack + 72575;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 73400;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 73610;
 Libderiv->deriv2_classes[3][7][91] = int_stack + 73890;
 Libderiv->deriv2_classes[3][8][91] = int_stack + 74250;
 Libderiv->deriv2_classes[3][9][91] = int_stack + 74700;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 75250;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 75565;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 75985;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 76525;
 Libderiv->deriv2_classes[4][9][91] = int_stack + 77200;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 78025;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 78235;
 Libderiv->deriv2_classes[3][7][83] = int_stack + 78515;
 Libderiv->deriv2_classes[3][8][83] = int_stack + 78875;
 Libderiv->deriv2_classes[3][9][83] = int_stack + 79325;
 Libderiv->deriv_classes[4][5][11] = int_stack + 79875;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 80190;
 Libderiv->deriv_classes[4][6][11] = int_stack + 80505;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 80925;
 Libderiv->deriv_classes[4][7][11] = int_stack + 81345;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 81885;
 Libderiv->deriv_classes[4][8][11] = int_stack + 82425;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 83100;
 Libderiv->deriv2_classes[4][9][83] = int_stack + 83775;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 84600;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 84810;
 Libderiv->deriv2_classes[3][7][82] = int_stack + 85090;
 Libderiv->deriv2_classes[3][8][82] = int_stack + 85450;
 Libderiv->deriv2_classes[3][9][82] = int_stack + 85900;
 Libderiv->deriv_classes[4][5][10] = int_stack + 86450;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 86765;
 Libderiv->deriv_classes[4][6][10] = int_stack + 87080;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 87500;
 Libderiv->deriv_classes[4][7][10] = int_stack + 87920;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 88460;
 Libderiv->deriv_classes[4][8][10] = int_stack + 89000;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 89675;
 Libderiv->deriv2_classes[4][9][82] = int_stack + 90350;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 91175;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 91385;
 Libderiv->deriv2_classes[3][7][81] = int_stack + 91665;
 Libderiv->deriv2_classes[3][8][81] = int_stack + 92025;
 Libderiv->deriv2_classes[3][9][81] = int_stack + 92475;
 Libderiv->deriv_classes[4][5][9] = int_stack + 93025;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 93340;
 Libderiv->deriv_classes[4][6][9] = int_stack + 93655;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 94075;
 Libderiv->deriv_classes[4][7][9] = int_stack + 94495;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 95035;
 Libderiv->deriv_classes[4][8][9] = int_stack + 95575;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 96250;
 Libderiv->deriv2_classes[4][9][81] = int_stack + 96925;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 97750;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 97960;
 Libderiv->deriv2_classes[3][7][80] = int_stack + 98240;
 Libderiv->deriv2_classes[3][8][80] = int_stack + 98600;
 Libderiv->deriv2_classes[3][9][80] = int_stack + 99050;
 Libderiv->deriv_classes[4][5][8] = int_stack + 99600;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 99915;
 Libderiv->deriv_classes[4][6][8] = int_stack + 100230;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 100650;
 Libderiv->deriv_classes[4][7][8] = int_stack + 101070;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 101610;
 Libderiv->deriv_classes[4][8][8] = int_stack + 102150;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 102825;
 Libderiv->deriv2_classes[4][9][80] = int_stack + 103500;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 104325;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 104535;
 Libderiv->deriv2_classes[3][7][79] = int_stack + 104815;
 Libderiv->deriv2_classes[3][8][79] = int_stack + 105175;
 Libderiv->deriv2_classes[3][9][79] = int_stack + 105625;
 Libderiv->deriv_classes[4][5][7] = int_stack + 106175;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 106490;
 Libderiv->deriv_classes[4][6][7] = int_stack + 106805;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 107225;
 Libderiv->deriv_classes[4][7][7] = int_stack + 107645;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 108185;
 Libderiv->deriv_classes[4][8][7] = int_stack + 108725;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 109400;
 Libderiv->deriv2_classes[4][9][79] = int_stack + 110075;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 110900;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 111110;
 Libderiv->deriv2_classes[3][7][78] = int_stack + 111390;
 Libderiv->deriv2_classes[3][8][78] = int_stack + 111750;
 Libderiv->deriv2_classes[3][9][78] = int_stack + 112200;
 Libderiv->dvrr_classes[4][5] = int_stack + 112750;
 Libderiv->deriv_classes[4][5][6] = int_stack + 113065;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 113380;
 Libderiv->dvrr_classes[4][6] = int_stack + 113695;
 Libderiv->deriv_classes[4][6][6] = int_stack + 114115;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 114535;
 Libderiv->dvrr_classes[4][7] = int_stack + 114955;
 Libderiv->deriv_classes[4][7][6] = int_stack + 115495;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 116035;
 Libderiv->deriv_classes[4][8][6] = int_stack + 116575;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 117250;
 Libderiv->deriv2_classes[4][9][78] = int_stack + 117925;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 118750;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 118960;
 Libderiv->deriv2_classes[3][7][35] = int_stack + 119240;
 Libderiv->deriv2_classes[3][8][35] = int_stack + 119600;
 Libderiv->deriv2_classes[3][9][35] = int_stack + 120050;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 120600;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 120915;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 121335;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 121875;
 Libderiv->deriv2_classes[4][9][35] = int_stack + 122550;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 123375;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 123585;
 Libderiv->deriv2_classes[3][7][34] = int_stack + 123865;
 Libderiv->deriv2_classes[3][8][34] = int_stack + 124225;
 Libderiv->deriv2_classes[3][9][34] = int_stack + 124675;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 125225;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 125540;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 125960;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 126500;
 Libderiv->deriv2_classes[4][9][34] = int_stack + 127175;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 128000;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 128210;
 Libderiv->deriv2_classes[3][7][33] = int_stack + 128490;
 Libderiv->deriv2_classes[3][8][33] = int_stack + 128850;
 Libderiv->deriv2_classes[3][9][33] = int_stack + 129300;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 129850;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 130165;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 130585;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 131125;
 Libderiv->deriv2_classes[4][9][33] = int_stack + 131800;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 132625;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 132835;
 Libderiv->deriv2_classes[3][7][32] = int_stack + 133115;
 Libderiv->deriv2_classes[3][8][32] = int_stack + 133475;
 Libderiv->deriv2_classes[3][9][32] = int_stack + 133925;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 134475;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 134790;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 135210;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 135750;
 Libderiv->deriv2_classes[4][9][32] = int_stack + 136425;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 137250;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 137460;
 Libderiv->deriv2_classes[3][7][31] = int_stack + 137740;
 Libderiv->deriv2_classes[3][8][31] = int_stack + 138100;
 Libderiv->deriv2_classes[3][9][31] = int_stack + 138550;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 139100;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 139415;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 139835;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 140375;
 Libderiv->deriv2_classes[4][9][31] = int_stack + 141050;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 141875;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 142085;
 Libderiv->deriv2_classes[3][7][30] = int_stack + 142365;
 Libderiv->deriv2_classes[3][8][30] = int_stack + 142725;
 Libderiv->deriv2_classes[3][9][30] = int_stack + 143175;
 Libderiv->deriv_classes[4][5][2] = int_stack + 143725;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 144040;
 Libderiv->deriv_classes[4][6][2] = int_stack + 144355;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 144775;
 Libderiv->deriv_classes[4][7][2] = int_stack + 145195;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 145735;
 Libderiv->deriv_classes[4][8][2] = int_stack + 146275;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 146950;
 Libderiv->deriv2_classes[4][9][30] = int_stack + 147625;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 148450;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 148660;
 Libderiv->deriv2_classes[3][7][26] = int_stack + 148940;
 Libderiv->deriv2_classes[3][8][26] = int_stack + 149300;
 Libderiv->deriv2_classes[3][9][26] = int_stack + 149750;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 150300;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 150615;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 151035;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 151575;
 Libderiv->deriv2_classes[4][9][26] = int_stack + 152250;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 153075;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 153285;
 Libderiv->deriv2_classes[3][7][23] = int_stack + 153565;
 Libderiv->deriv2_classes[3][8][23] = int_stack + 153925;
 Libderiv->deriv2_classes[3][9][23] = int_stack + 154375;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 154925;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 155240;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 155660;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 156200;
 Libderiv->deriv2_classes[4][9][23] = int_stack + 156875;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 157700;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 157910;
 Libderiv->deriv2_classes[3][7][22] = int_stack + 158190;
 Libderiv->deriv2_classes[3][8][22] = int_stack + 158550;
 Libderiv->deriv2_classes[3][9][22] = int_stack + 159000;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 159550;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 159865;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 160285;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 160825;
 Libderiv->deriv2_classes[4][9][22] = int_stack + 161500;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 162325;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 162535;
 Libderiv->deriv2_classes[3][7][21] = int_stack + 162815;
 Libderiv->deriv2_classes[3][8][21] = int_stack + 163175;
 Libderiv->deriv2_classes[3][9][21] = int_stack + 163625;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 164175;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 164490;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 164910;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 165450;
 Libderiv->deriv2_classes[4][9][21] = int_stack + 166125;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 166950;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 167160;
 Libderiv->deriv2_classes[3][7][20] = int_stack + 167440;
 Libderiv->deriv2_classes[3][8][20] = int_stack + 167800;
 Libderiv->deriv2_classes[3][9][20] = int_stack + 168250;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 168800;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 169115;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 169535;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 170075;
 Libderiv->deriv2_classes[4][9][20] = int_stack + 170750;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 171575;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 171785;
 Libderiv->deriv2_classes[3][7][19] = int_stack + 172065;
 Libderiv->deriv2_classes[3][8][19] = int_stack + 172425;
 Libderiv->deriv2_classes[3][9][19] = int_stack + 172875;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 173425;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 173740;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 174160;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 174700;
 Libderiv->deriv2_classes[4][9][19] = int_stack + 175375;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 176200;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 176410;
 Libderiv->deriv2_classes[3][7][18] = int_stack + 176690;
 Libderiv->deriv2_classes[3][8][18] = int_stack + 177050;
 Libderiv->deriv2_classes[3][9][18] = int_stack + 177500;
 Libderiv->deriv_classes[4][5][1] = int_stack + 178050;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 178365;
 Libderiv->deriv_classes[4][6][1] = int_stack + 178680;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 179100;
 Libderiv->deriv_classes[4][7][1] = int_stack + 179520;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 180060;
 Libderiv->deriv_classes[4][8][1] = int_stack + 180600;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 181275;
 Libderiv->deriv2_classes[4][9][18] = int_stack + 181950;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 182775;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 182985;
 Libderiv->deriv2_classes[3][7][14] = int_stack + 183265;
 Libderiv->deriv2_classes[3][8][14] = int_stack + 183625;
 Libderiv->deriv2_classes[3][9][14] = int_stack + 184075;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 184625;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 184940;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 185360;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 185900;
 Libderiv->deriv2_classes[4][9][14] = int_stack + 186575;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 187400;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 187610;
 Libderiv->deriv2_classes[3][7][13] = int_stack + 187890;
 Libderiv->deriv2_classes[3][8][13] = int_stack + 188250;
 Libderiv->deriv2_classes[3][9][13] = int_stack + 188700;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 189250;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 189565;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 189985;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 190525;
 Libderiv->deriv2_classes[4][9][13] = int_stack + 191200;
 Libderiv->deriv_classes[3][5][11] = int_stack + 192025;
 Libderiv->deriv_classes[3][6][11] = int_stack + 192235;
 Libderiv->deriv_classes[3][7][11] = int_stack + 192515;
 Libderiv->deriv_classes[3][8][11] = int_stack + 192875;
 Libderiv->deriv_classes[3][9][11] = int_stack + 193325;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 193875;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 194085;
 Libderiv->deriv2_classes[3][7][11] = int_stack + 194365;
 Libderiv->deriv2_classes[3][8][11] = int_stack + 194725;
 Libderiv->deriv2_classes[3][9][11] = int_stack + 195175;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 195725;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 196040;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 196460;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 197000;
 Libderiv->deriv2_classes[4][9][11] = int_stack + 197675;
 Libderiv->deriv_classes[3][5][10] = int_stack + 198500;
 Libderiv->deriv_classes[3][6][10] = int_stack + 198710;
 Libderiv->deriv_classes[3][7][10] = int_stack + 198990;
 Libderiv->deriv_classes[3][8][10] = int_stack + 199350;
 Libderiv->deriv_classes[3][9][10] = int_stack + 199800;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 200350;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 200560;
 Libderiv->deriv2_classes[3][7][10] = int_stack + 200840;
 Libderiv->deriv2_classes[3][8][10] = int_stack + 201200;
 Libderiv->deriv2_classes[3][9][10] = int_stack + 201650;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 202200;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 202515;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 202935;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 203475;
 Libderiv->deriv2_classes[4][9][10] = int_stack + 204150;
 Libderiv->deriv_classes[3][5][9] = int_stack + 204975;
 Libderiv->deriv_classes[3][6][9] = int_stack + 205185;
 Libderiv->deriv_classes[3][7][9] = int_stack + 205465;
 Libderiv->deriv_classes[3][8][9] = int_stack + 205825;
 Libderiv->deriv_classes[3][9][9] = int_stack + 206275;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 206825;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 207035;
 Libderiv->deriv2_classes[3][7][9] = int_stack + 207315;
 Libderiv->deriv2_classes[3][8][9] = int_stack + 207675;
 Libderiv->deriv2_classes[3][9][9] = int_stack + 208125;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 208675;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 208990;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 209410;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 209950;
 Libderiv->deriv2_classes[4][9][9] = int_stack + 210625;
 Libderiv->deriv_classes[3][5][8] = int_stack + 211450;
 Libderiv->deriv_classes[3][6][8] = int_stack + 211660;
 Libderiv->deriv_classes[3][7][8] = int_stack + 211940;
 Libderiv->deriv_classes[3][8][8] = int_stack + 212300;
 Libderiv->deriv_classes[3][9][8] = int_stack + 212750;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 213300;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 213510;
 Libderiv->deriv2_classes[3][7][8] = int_stack + 213790;
 Libderiv->deriv2_classes[3][8][8] = int_stack + 214150;
 Libderiv->deriv2_classes[3][9][8] = int_stack + 214600;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 215150;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 215465;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 215885;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 216425;
 Libderiv->deriv2_classes[4][9][8] = int_stack + 217100;
 Libderiv->deriv_classes[3][5][7] = int_stack + 217925;
 Libderiv->deriv_classes[3][6][7] = int_stack + 218135;
 Libderiv->deriv_classes[3][7][7] = int_stack + 218415;
 Libderiv->deriv_classes[3][8][7] = int_stack + 218775;
 Libderiv->deriv_classes[3][9][7] = int_stack + 219225;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 219775;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 219985;
 Libderiv->deriv2_classes[3][7][7] = int_stack + 220265;
 Libderiv->deriv2_classes[3][8][7] = int_stack + 220625;
 Libderiv->deriv2_classes[3][9][7] = int_stack + 221075;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 221625;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 221940;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 222360;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 222900;
 Libderiv->deriv2_classes[4][9][7] = int_stack + 223575;
 Libderiv->dvrr_classes[3][5] = int_stack + 224400;
 Libderiv->deriv_classes[3][5][6] = int_stack + 224610;
 Libderiv->dvrr_classes[3][6] = int_stack + 224820;
 Libderiv->deriv_classes[3][6][6] = int_stack + 225100;
 Libderiv->dvrr_classes[3][7] = int_stack + 225380;
 Libderiv->deriv_classes[3][7][6] = int_stack + 225740;
 Libderiv->dvrr_classes[3][8] = int_stack + 226100;
 Libderiv->deriv_classes[3][8][6] = int_stack + 226550;
 Libderiv->deriv_classes[3][9][6] = int_stack + 227000;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 227550;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 227760;
 Libderiv->deriv2_classes[3][7][6] = int_stack + 228040;
 Libderiv->deriv2_classes[3][8][6] = int_stack + 228400;
 Libderiv->deriv2_classes[3][9][6] = int_stack + 228850;
 Libderiv->deriv_classes[4][5][0] = int_stack + 229400;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 229715;
 Libderiv->deriv_classes[4][6][0] = int_stack + 230030;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 230450;
 Libderiv->deriv_classes[4][7][0] = int_stack + 230870;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 231410;
 Libderiv->deriv_classes[4][8][0] = int_stack + 231950;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 232625;
 Libderiv->deriv2_classes[4][9][6] = int_stack + 233300;
 Libderiv->deriv_classes[3][5][2] = int_stack + 234125;
 Libderiv->deriv_classes[3][6][2] = int_stack + 234335;
 Libderiv->deriv_classes[3][7][2] = int_stack + 234615;
 Libderiv->deriv_classes[3][8][2] = int_stack + 234975;
 Libderiv->deriv_classes[3][9][2] = int_stack + 235425;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 235975;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 236185;
 Libderiv->deriv2_classes[3][7][2] = int_stack + 236465;
 Libderiv->deriv2_classes[3][8][2] = int_stack + 236825;
 Libderiv->deriv2_classes[3][9][2] = int_stack + 237275;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 237825;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 238140;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 238560;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 239100;
 Libderiv->deriv2_classes[4][9][2] = int_stack + 239775;
 Libderiv->deriv_classes[3][5][1] = int_stack + 240600;
 Libderiv->deriv_classes[3][6][1] = int_stack + 240810;
 Libderiv->deriv_classes[3][7][1] = int_stack + 241090;
 Libderiv->deriv_classes[3][8][1] = int_stack + 241450;
 Libderiv->deriv_classes[3][9][1] = int_stack + 241900;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 242450;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 242660;
 Libderiv->deriv2_classes[3][7][1] = int_stack + 242940;
 Libderiv->deriv2_classes[3][8][1] = int_stack + 243300;
 Libderiv->deriv2_classes[3][9][1] = int_stack + 243750;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 244300;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 244615;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 245035;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 245575;
 Libderiv->deriv2_classes[4][9][1] = int_stack + 246250;
 Libderiv->deriv_classes[3][5][0] = int_stack + 247075;
 Libderiv->deriv_classes[3][6][0] = int_stack + 247285;
 Libderiv->deriv_classes[3][7][0] = int_stack + 247565;
 Libderiv->deriv_classes[3][8][0] = int_stack + 247925;
 Libderiv->deriv_classes[3][9][0] = int_stack + 248375;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 248925;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 249135;
 Libderiv->deriv2_classes[3][7][0] = int_stack + 249415;
 Libderiv->deriv2_classes[3][8][0] = int_stack + 249775;
 Libderiv->deriv2_classes[3][9][0] = int_stack + 250225;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 250775;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 251090;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 251510;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 252050;
 Libderiv->deriv2_classes[4][9][0] = int_stack + 252725;
 memset(int_stack,0,2028400);

 Libderiv->dvrr_stack = int_stack + 660905;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fphg(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+253550,int_stack+224820,int_stack+224400,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+254180,int_stack+225380,int_stack+224820,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+255020,int_stack+254180,int_stack+253550,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+256280,int_stack+226100,int_stack+225380,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+257360,int_stack+256280,int_stack+254180,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+259040,int_stack+257360,int_stack+255020,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261140,int_stack+192235,int_stack+192025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224400,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+261770,int_stack+192515,int_stack+192235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224820,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+262610,int_stack+261770,int_stack+261140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+263870,int_stack+192875,int_stack+192515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225380,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+264950,int_stack+263870,int_stack+261770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254180,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+266630,int_stack+264950,int_stack+262610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255020,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+268730,int_stack+193325,int_stack+192875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226100,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+270080,int_stack+268730,int_stack+263870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256280,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+272240,int_stack+270080,int_stack+264950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257360,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+268730,int_stack+272240,int_stack+266630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259040,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+271880,int_stack+113695,int_stack+112750,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+272825,int_stack+114955,int_stack+113695,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+274085,int_stack+272825,int_stack+271880,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+275975,int_stack+4125,int_stack+114955,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+277595,int_stack+275975,int_stack+272825,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+280115,int_stack+277595,int_stack+274085,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+283265,int_stack+80505,int_stack+79875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112750,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+284210,int_stack+81345,int_stack+80505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113695,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+285470,int_stack+284210,int_stack+283265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271880,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+287360,int_stack+82425,int_stack+81345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114955,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+288980,int_stack+287360,int_stack+284210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272825,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+291500,int_stack+288980,int_stack+285470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274085,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+294650,int_stack+0,int_stack+82425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4125,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+296675,int_stack+294650,int_stack+287360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275975,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+299915,int_stack+296675,int_stack+288980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277595,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+294650,int_stack+299915,int_stack+291500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280115,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+299375,int_stack+198710,int_stack+198500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224400, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+300005,int_stack+198990,int_stack+198710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224820, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+300845,int_stack+300005,int_stack+299375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+302105,int_stack+199350,int_stack+198990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225380, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+303185,int_stack+302105,int_stack+300005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254180, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+304865,int_stack+303185,int_stack+300845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255020, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+306965,int_stack+199800,int_stack+199350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226100, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+308315,int_stack+306965,int_stack+302105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256280, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+310475,int_stack+308315,int_stack+303185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257360, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+306965,int_stack+310475,int_stack+304865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259040, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+310115,int_stack+87080,int_stack+86450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112750, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+311060,int_stack+87920,int_stack+87080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113695, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+312320,int_stack+311060,int_stack+310115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271880, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314210,int_stack+89000,int_stack+87920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114955, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+315830,int_stack+314210,int_stack+311060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272825, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+318350,int_stack+315830,int_stack+312320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274085, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+321500,int_stack+825,int_stack+89000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4125, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+323525,int_stack+321500,int_stack+314210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275975, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+326765,int_stack+323525,int_stack+315830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277595, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+321500,int_stack+326765,int_stack+318350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280115, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+326225,int_stack+205185,int_stack+204975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224400, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+326855,int_stack+205465,int_stack+205185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224820, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+327695,int_stack+326855,int_stack+326225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+328955,int_stack+205825,int_stack+205465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225380, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+330035,int_stack+328955,int_stack+326855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254180, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+331715,int_stack+330035,int_stack+327695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255020, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+206275,int_stack+205825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226100, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+333815,int_stack+0,int_stack+328955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256280, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+335975,int_stack+333815,int_stack+330035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257360, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+338775,int_stack+335975,int_stack+331715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259040, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+333815,int_stack+93655,int_stack+93025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112750, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+334760,int_stack+94495,int_stack+93655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113695, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+336020,int_stack+334760,int_stack+333815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+95575,int_stack+94495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114955, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+341925,int_stack+0,int_stack+334760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272825, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+344445,int_stack+341925,int_stack+336020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274085, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+347595,int_stack+1650,int_stack+95575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4125, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+349620,int_stack+347595,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275975, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+352860,int_stack+349620,int_stack+341925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277595, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+347595,int_stack+352860,int_stack+344445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280115, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+352320,int_stack+211660,int_stack+211450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+352950,int_stack+211940,int_stack+211660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+353790,int_stack+352950,int_stack+352320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+355050,int_stack+212300,int_stack+211940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+356130,int_stack+355050,int_stack+352950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+357810,int_stack+356130,int_stack+353790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+359910,int_stack+212750,int_stack+212300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+361260,int_stack+359910,int_stack+355050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+363420,int_stack+361260,int_stack+356130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+359910,int_stack+363420,int_stack+357810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+363060,int_stack+100230,int_stack+99600, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+364005,int_stack+101070,int_stack+100230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+365265,int_stack+364005,int_stack+363060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+367155,int_stack+102150,int_stack+101070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+368775,int_stack+367155,int_stack+364005, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+272825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+371295,int_stack+368775,int_stack+365265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+374445,int_stack+2475,int_stack+102150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+376470,int_stack+374445,int_stack+367155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+379710,int_stack+376470,int_stack+368775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+374445,int_stack+379710,int_stack+371295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+379170,int_stack+218135,int_stack+217925, 0.0, zero_stack, 1.0, int_stack+224400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+379800,int_stack+218415,int_stack+218135, 0.0, zero_stack, 1.0, int_stack+224820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+380640,int_stack+379800,int_stack+379170, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+381900,int_stack+218775,int_stack+218415, 0.0, zero_stack, 1.0, int_stack+225380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1620,int_stack+381900,int_stack+379800, 0.0, zero_stack, 1.0, int_stack+254180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+382980,int_stack+1620,int_stack+380640, 0.0, zero_stack, 1.0, int_stack+255020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+385080,int_stack+219225,int_stack+218775, 0.0, zero_stack, 1.0, int_stack+226100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+386430,int_stack+385080,int_stack+381900, 0.0, zero_stack, 1.0, int_stack+256280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+388590,int_stack+386430,int_stack+1620, 0.0, zero_stack, 1.0, int_stack+257360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+385080,int_stack+388590,int_stack+382980, 0.0, zero_stack, 1.0, int_stack+259040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+388230,int_stack+106805,int_stack+106175, 0.0, zero_stack, 1.0, int_stack+112750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+389175,int_stack+107645,int_stack+106805, 0.0, zero_stack, 1.0, int_stack+113695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+390435,int_stack+389175,int_stack+388230, 0.0, zero_stack, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+392325,int_stack+108725,int_stack+107645, 0.0, zero_stack, 1.0, int_stack+114955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+393945,int_stack+392325,int_stack+389175, 0.0, zero_stack, 1.0, int_stack+272825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+396465,int_stack+393945,int_stack+390435, 0.0, zero_stack, 1.0, int_stack+274085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+399615,int_stack+3300,int_stack+108725, 0.0, zero_stack, 1.0, int_stack+4125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+401640,int_stack+399615,int_stack+392325, 0.0, zero_stack, 1.0, int_stack+275975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+404880,int_stack+401640,int_stack+393945, 0.0, zero_stack, 1.0, int_stack+277595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+399615,int_stack+404880,int_stack+396465, 0.0, zero_stack, 1.0, int_stack+280115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+404340,int_stack+225100,int_stack+224610, 1.0, int_stack+224400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+404970,int_stack+225740,int_stack+225100, 1.0, int_stack+224820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+405810,int_stack+404970,int_stack+404340, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+407070,int_stack+226550,int_stack+225740, 1.0, int_stack+225380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+408150,int_stack+407070,int_stack+404970, 1.0, int_stack+254180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+409830,int_stack+408150,int_stack+405810, 1.0, int_stack+255020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+253550,int_stack+227000,int_stack+226550, 1.0, int_stack+226100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+411930,int_stack+253550,int_stack+407070, 1.0, int_stack+256280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+414090,int_stack+411930,int_stack+408150, 1.0, int_stack+257360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+416890,int_stack+414090,int_stack+409830, 1.0, int_stack+259040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+411930,int_stack+114115,int_stack+113065, 1.0, int_stack+112750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+412875,int_stack+115495,int_stack+114115, 1.0, int_stack+113695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+414135,int_stack+412875,int_stack+411930, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+116575,int_stack+115495, 1.0, int_stack+114955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420040,int_stack+253550,int_stack+412875, 1.0, int_stack+272825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+422560,int_stack+420040,int_stack+414135, 1.0, int_stack+274085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+271880,int_stack+4800,int_stack+116575, 1.0, int_stack+4125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+425710,int_stack+271880,int_stack+253550, 1.0, int_stack+275975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+271880,int_stack+425710,int_stack+420040, 1.0, int_stack+277595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+425710,int_stack+271880,int_stack+422560, 1.0, int_stack+280115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+271880,int_stack+7275,int_stack+226100,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+273230,int_stack+271880,int_stack+256280,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+275390,int_stack+273230,int_stack+257360,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+271880,int_stack+275390,int_stack+259040,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+275030,int_stack+234335,int_stack+234125,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+275660,int_stack+234615,int_stack+234335,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+276500,int_stack+275660,int_stack+275030,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+277760,int_stack+234975,int_stack+234615,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+278840,int_stack+277760,int_stack+275660,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+280520,int_stack+278840,int_stack+276500,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+255170,int_stack+235425,int_stack+234975,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+256520,int_stack+255170,int_stack+277760,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+430435,int_stack+256520,int_stack+278840,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+255170,int_stack+430435,int_stack+280520,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+430435,int_stack+144355,int_stack+143725,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+431380,int_stack+145195,int_stack+144355,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+431380,int_stack+430435,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3300,int_stack+146275,int_stack+145195,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+432640,int_stack+3300,int_stack+431380,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+435160,int_stack+432640,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+438310,int_stack+5625,int_stack+146275,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+440335,int_stack+438310,int_stack+3300,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+443575,int_stack+440335,int_stack+432640,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+438310,int_stack+443575,int_stack+435160,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+443035,int_stack+240810,int_stack+240600,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+443665,int_stack+241090,int_stack+240810,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+444505,int_stack+443665,int_stack+443035,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+445765,int_stack+241450,int_stack+241090,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+446845,int_stack+445765,int_stack+443665,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+448525,int_stack+446845,int_stack+444505,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4920,int_stack+241900,int_stack+241450,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+450625,int_stack+4920,int_stack+445765,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+452785,int_stack+450625,int_stack+446845,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+455585,int_stack+452785,int_stack+448525,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+450625,int_stack+178680,int_stack+178050,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+451570,int_stack+179520,int_stack+178680,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+452830,int_stack+451570,int_stack+450625,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+458735,int_stack+180600,int_stack+179520,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+460355,int_stack+458735,int_stack+451570,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+462875,int_stack+460355,int_stack+452830,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+466025,int_stack+6450,int_stack+180600,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+468050,int_stack+466025,int_stack+458735,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+471290,int_stack+468050,int_stack+460355,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+466025,int_stack+471290,int_stack+462875,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+470750,int_stack+247285,int_stack+247075,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+471380,int_stack+247565,int_stack+247285,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+472220,int_stack+471380,int_stack+470750,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+473480,int_stack+247925,int_stack+247565,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4920,int_stack+473480,int_stack+471380,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+474560,int_stack+4920,int_stack+472220,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+476660,int_stack+248375,int_stack+247925,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+478010,int_stack+476660,int_stack+473480,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+480170,int_stack+478010,int_stack+4920,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+476660,int_stack+480170,int_stack+474560,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+479810,int_stack+230030,int_stack+229400,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+480755,int_stack+230870,int_stack+230030,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+482015,int_stack+480755,int_stack+479810,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+483905,int_stack+231950,int_stack+230870,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+485525,int_stack+483905,int_stack+480755,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+488045,int_stack+485525,int_stack+482015,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+491195,int_stack+7825,int_stack+231950,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+493220,int_stack+491195,int_stack+483905,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+496460,int_stack+493220,int_stack+485525,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+491195,int_stack+496460,int_stack+488045,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+495920,int_stack+8860,int_stack+8650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+192025,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+496550,int_stack+9140,int_stack+8860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+192235,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+497390,int_stack+496550,int_stack+495920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261140,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+498650,int_stack+9500,int_stack+9140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+192515,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6600,int_stack+498650,int_stack+496550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261770,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+499730,int_stack+6600,int_stack+497390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+262610,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+495920,int_stack+9950,int_stack+9500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+192875,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8280,int_stack+495920,int_stack+498650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+263870,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+495920,int_stack+8280,int_stack+6600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+264950,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6600,int_stack+495920,int_stack+499730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+266630,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+495920,int_stack+10815,int_stack+10500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+79875,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+496865,int_stack+11235,int_stack+10815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80505,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+498125,int_stack+496865,int_stack+495920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+283265,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500015,int_stack+11775,int_stack+11235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+81345,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+501635,int_stack+500015,int_stack+496865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+284210,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+504155,int_stack+501635,int_stack+498125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+285470,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9750,int_stack+12450,int_stack+11775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+82425,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+495920,int_stack+9750,int_stack+500015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+287360,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+507305,int_stack+495920,int_stack+501635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+288980,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+495920,int_stack+507305,int_stack+504155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+291500,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+13485,int_stack+13275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192025, 1.0, int_stack+198500,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501275,int_stack+13765,int_stack+13485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192235, 1.0, int_stack+198710,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502115,int_stack+501275,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261140, 1.0, int_stack+299375,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+503375,int_stack+14125,int_stack+13765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192515, 1.0, int_stack+198990,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504455,int_stack+503375,int_stack+501275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261770, 1.0, int_stack+300005,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+506135,int_stack+504455,int_stack+502115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262610, 1.0, int_stack+300845,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+14575,int_stack+14125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192875, 1.0, int_stack+199350,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+508235,int_stack+500645,int_stack+503375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263870, 1.0, int_stack+302105,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+508235,int_stack+504455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264950, 1.0, int_stack+303185,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+508235,int_stack+500645,int_stack+506135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266630, 1.0, int_stack+304865,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+15440,int_stack+15125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79875, 1.0, int_stack+86450,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501590,int_stack+15860,int_stack+15440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80505, 1.0, int_stack+87080,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502850,int_stack+501590,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283265, 1.0, int_stack+310115,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504740,int_stack+16400,int_stack+15860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81345, 1.0, int_stack+87920,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9750,int_stack+504740,int_stack+501590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+284210, 1.0, int_stack+311060,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12270,int_stack+9750,int_stack+502850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285470, 1.0, int_stack+312320,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+17075,int_stack+16400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82425, 1.0, int_stack+89000,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+511385,int_stack+500645,int_stack+504740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287360, 1.0, int_stack+314210,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+511385,int_stack+9750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288980, 1.0, int_stack+315830,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+511385,int_stack+500645,int_stack+12270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291500, 1.0, int_stack+318350,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+18110,int_stack+17900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+198500, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501275,int_stack+18390,int_stack+18110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+198710, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502115,int_stack+501275,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+299375, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+503375,int_stack+18750,int_stack+18390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+198990, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504455,int_stack+503375,int_stack+501275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+300005, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+506135,int_stack+504455,int_stack+502115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+300845, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+19200,int_stack+18750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+199350, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9750,int_stack+500645,int_stack+503375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+302105, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+9750,int_stack+504455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+303185, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+9750,int_stack+500645,int_stack+506135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+304865, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+20065,int_stack+19750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+86450, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501590,int_stack+20485,int_stack+20065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+87080, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502850,int_stack+501590,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+310115, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504740,int_stack+21025,int_stack+20485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+87920, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+12900,int_stack+504740,int_stack+501590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+311060, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15420,int_stack+12900,int_stack+502850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+312320, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+21700,int_stack+21025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+89000, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+18570,int_stack+500645,int_stack+504740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+314210, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+18570,int_stack+12900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+315830, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+516110,int_stack+500645,int_stack+15420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+318350, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+22735,int_stack+22525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192025, 0.0, zero_stack, 1.0, int_stack+204975,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501275,int_stack+23015,int_stack+22735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192235, 0.0, zero_stack, 1.0, int_stack+205185,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502115,int_stack+501275,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261140, 0.0, zero_stack, 1.0, int_stack+326225,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+503375,int_stack+23375,int_stack+23015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192515, 0.0, zero_stack, 1.0, int_stack+205465,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504455,int_stack+503375,int_stack+501275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261770, 0.0, zero_stack, 1.0, int_stack+326855,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+506135,int_stack+504455,int_stack+502115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262610, 0.0, zero_stack, 1.0, int_stack+327695,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+23825,int_stack+23375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192875, 0.0, zero_stack, 1.0, int_stack+205825,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+12900,int_stack+500645,int_stack+503375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263870, 0.0, zero_stack, 1.0, int_stack+328955,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+12900,int_stack+504455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264950, 0.0, zero_stack, 1.0, int_stack+330035,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+12900,int_stack+500645,int_stack+506135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266630, 0.0, zero_stack, 1.0, int_stack+331715,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+24690,int_stack+24375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79875, 0.0, zero_stack, 1.0, int_stack+93025,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501590,int_stack+25110,int_stack+24690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80505, 0.0, zero_stack, 1.0, int_stack+93655,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502850,int_stack+501590,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283265, 0.0, zero_stack, 1.0, int_stack+333815,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504740,int_stack+25650,int_stack+25110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81345, 0.0, zero_stack, 1.0, int_stack+94495,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+16050,int_stack+504740,int_stack+501590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+284210, 0.0, zero_stack, 1.0, int_stack+334760,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18570,int_stack+16050,int_stack+502850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285470, 0.0, zero_stack, 1.0, int_stack+336020,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+26325,int_stack+25650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82425, 0.0, zero_stack, 1.0, int_stack+95575,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21720,int_stack+500645,int_stack+504740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287360, 0.0, zero_stack, 1.0, int_stack+0,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+21720,int_stack+16050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288980, 0.0, zero_stack, 1.0, int_stack+341925,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+21720,int_stack+500645,int_stack+18570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291500, 0.0, zero_stack, 1.0, int_stack+344445,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+27360,int_stack+27150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198500, 1.0, int_stack+204975, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501275,int_stack+27640,int_stack+27360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198710, 1.0, int_stack+205185, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502115,int_stack+501275,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299375, 1.0, int_stack+326225, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+503375,int_stack+28000,int_stack+27640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198990, 1.0, int_stack+205465, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+504455,int_stack+503375,int_stack+501275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300005, 1.0, int_stack+326855, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+506135,int_stack+504455,int_stack+502115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300845, 1.0, int_stack+327695, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+28450,int_stack+28000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199350, 1.0, int_stack+205825, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+16050,int_stack+500645,int_stack+503375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302105, 1.0, int_stack+328955, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+16050,int_stack+504455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303185, 1.0, int_stack+330035, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16050,int_stack+500645,int_stack+506135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304865, 1.0, int_stack+331715, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+29315,int_stack+29000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86450, 1.0, int_stack+93025, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+501590,int_stack+29735,int_stack+29315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87080, 1.0, int_stack+93655, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+502850,int_stack+501590,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310115, 1.0, int_stack+333815, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504740,int_stack+30275,int_stack+29735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87920, 1.0, int_stack+94495, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+504740,int_stack+501590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311060, 1.0, int_stack+334760, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26445,int_stack+19200,int_stack+502850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312320, 1.0, int_stack+336020, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+30950,int_stack+30275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89000, 1.0, int_stack+95575, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+520835,int_stack+500645,int_stack+504740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314210, 1.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+500645,int_stack+520835,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315830, 1.0, int_stack+341925, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+520835,int_stack+500645,int_stack+26445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318350, 1.0, int_stack+344445, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26445,int_stack+31985,int_stack+31775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+204975, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27075,int_stack+32265,int_stack+31985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+205185, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27915,int_stack+27075,int_stack+26445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+326225, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29175,int_stack+32625,int_stack+32265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+205465, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+30255,int_stack+29175,int_stack+27075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+326855, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+30255,int_stack+27915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+327695, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+26445,int_stack+33075,int_stack+32625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+205825, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+502745,int_stack+26445,int_stack+29175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+328955, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+26445,int_stack+502745,int_stack+30255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+330035, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+502745,int_stack+26445,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+331715, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+33940,int_stack+33625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+93025, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26445,int_stack+34360,int_stack+33940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+93655, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+27705,int_stack+26445,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+333815, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+34900,int_stack+34360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+94495, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+26445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+334760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+29595,int_stack+19200,int_stack+27705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+336020, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+26445,int_stack+35575,int_stack+34900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+95575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+32745,int_stack+26445,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+525560,int_stack+32745,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+341925, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+529760,int_stack+525560,int_stack+29595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+344445, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+525560,int_stack+36610,int_stack+36400, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211450,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+526190,int_stack+36890,int_stack+36610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192235, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211660,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+527030,int_stack+526190,int_stack+525560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352320,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+528290,int_stack+37250,int_stack+36890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211940,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+528290,int_stack+526190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352950,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+19200,int_stack+527030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353790,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+525560,int_stack+37700,int_stack+37250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212300,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26445,int_stack+525560,int_stack+528290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355050,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+525560,int_stack+26445,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356130,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+26445,int_stack+525560,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357810,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+38565,int_stack+38250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99600,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+525560,int_stack+38985,int_stack+38565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100230,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+526820,int_stack+525560,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363060,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+39525,int_stack+38985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101070,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+525560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+284210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364005,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+29595,int_stack+19200,int_stack+526820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+365265,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+525560,int_stack+40200,int_stack+39525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102150,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+32745,int_stack+525560,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367155,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+525560,int_stack+32745,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368775,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+32745,int_stack+525560,int_stack+29595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371295,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29595,int_stack+41235,int_stack+41025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198500, 0.0, zero_stack, 1.0, int_stack+211450, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+30225,int_stack+41515,int_stack+41235, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198710, 0.0, zero_stack, 1.0, int_stack+211660, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+31065,int_stack+30225,int_stack+29595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299375, 0.0, zero_stack, 1.0, int_stack+352320, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+525560,int_stack+41875,int_stack+41515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198990, 0.0, zero_stack, 1.0, int_stack+211940, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+526640,int_stack+525560,int_stack+30225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300005, 0.0, zero_stack, 1.0, int_stack+352950, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+526640,int_stack+31065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300845, 0.0, zero_stack, 1.0, int_stack+353790, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29595,int_stack+42325,int_stack+41875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199350, 0.0, zero_stack, 1.0, int_stack+212300, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+29595,int_stack+525560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302105, 0.0, zero_stack, 1.0, int_stack+355050, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+29595,int_stack+19200,int_stack+526640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303185, 0.0, zero_stack, 1.0, int_stack+356130, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+525560,int_stack+29595,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304865, 0.0, zero_stack, 1.0, int_stack+357810, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+43190,int_stack+42875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86450, 0.0, zero_stack, 1.0, int_stack+99600, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+29595,int_stack+43610,int_stack+43190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87080, 0.0, zero_stack, 1.0, int_stack+100230, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30855,int_stack+29595,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310115, 0.0, zero_stack, 1.0, int_stack+363060, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+44150,int_stack+43610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87920, 0.0, zero_stack, 1.0, int_stack+101070, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+29595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311060, 0.0, zero_stack, 1.0, int_stack+364005, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37470,int_stack+19200,int_stack+30855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312320, 0.0, zero_stack, 1.0, int_stack+365265, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+29595,int_stack+44825,int_stack+44150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89000, 0.0, zero_stack, 1.0, int_stack+102150, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+40620,int_stack+29595,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314210, 0.0, zero_stack, 1.0, int_stack+367155, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+534485,int_stack+40620,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315830, 0.0, zero_stack, 1.0, int_stack+368775, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+40620,int_stack+534485,int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318350, 0.0, zero_stack, 1.0, int_stack+371295, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+37470,int_stack+45860,int_stack+45650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204975, 1.0, int_stack+211450, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+38100,int_stack+46140,int_stack+45860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205185, 1.0, int_stack+211660, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38940,int_stack+38100,int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326225, 1.0, int_stack+352320, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+534485,int_stack+46500,int_stack+46140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205465, 1.0, int_stack+211940, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+535565,int_stack+534485,int_stack+38100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+326855, 1.0, int_stack+352950, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+535565,int_stack+38940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327695, 1.0, int_stack+353790, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+37470,int_stack+46950,int_stack+46500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+205825, 1.0, int_stack+212300, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+37470,int_stack+534485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+328955, 1.0, int_stack+355050, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+37470,int_stack+19200,int_stack+535565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330035, 1.0, int_stack+356130, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+29595,int_stack+37470,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331715, 1.0, int_stack+357810, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+47815,int_stack+47500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93025, 1.0, int_stack+99600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+37470,int_stack+48235,int_stack+47815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93655, 1.0, int_stack+100230, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+38730,int_stack+37470,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333815, 1.0, int_stack+363060, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+48775,int_stack+48235, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94495, 1.0, int_stack+101070, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334760, 1.0, int_stack+364005, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+534485,int_stack+19200,int_stack+38730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336020, 1.0, int_stack+365265, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+37470,int_stack+49450,int_stack+48775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95575, 1.0, int_stack+102150, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+45345,int_stack+37470,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+367155, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+537635,int_stack+45345,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341925, 1.0, int_stack+368775, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+45345,int_stack+537635,int_stack+534485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344445, 1.0, int_stack+371295, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+534485,int_stack+50485,int_stack+50275, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+211450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+535115,int_stack+50765,int_stack+50485, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+211660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+535955,int_stack+535115,int_stack+534485, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+352320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+537215,int_stack+51125,int_stack+50765, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+211940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+538295,int_stack+537215,int_stack+535115, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+352950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+538295,int_stack+535955, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+353790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+534485,int_stack+51575,int_stack+51125, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+212300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+534485,int_stack+537215, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+355050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+534485,int_stack+19200,int_stack+538295, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+356130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+37470,int_stack+534485,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+357810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+52440,int_stack+52125, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+99600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+534485,int_stack+52860,int_stack+52440, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+100230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+535745,int_stack+534485,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+363060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+53400,int_stack+52860, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+101070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+534485, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+364005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+537635,int_stack+19200,int_stack+535745, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+365265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+534485,int_stack+54075,int_stack+53400, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+102150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+50070,int_stack+534485,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+367155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+540785,int_stack+50070,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+368775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+50070,int_stack+540785,int_stack+537635, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+371295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19200,int_stack+55110,int_stack+54900, 0.0, zero_stack, 1.0, int_stack+192025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217925,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19830,int_stack+55390,int_stack+55110, 0.0, zero_stack, 1.0, int_stack+192235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218135,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+500645,int_stack+19830,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+261140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379170,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+534485,int_stack+55750,int_stack+55390, 0.0, zero_stack, 1.0, int_stack+192515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218415,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+535565,int_stack+534485,int_stack+19830, 0.0, zero_stack, 1.0, int_stack+261770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379800,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19200,int_stack+535565,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+262610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380640,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+56200,int_stack+55750, 0.0, zero_stack, 1.0, int_stack+192875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218775,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+537245,int_stack+500645,int_stack+534485, 0.0, zero_stack, 1.0, int_stack+263870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381900,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+539405,int_stack+537245,int_stack+535565, 0.0, zero_stack, 1.0, int_stack+264950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+534485,int_stack+539405,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+266630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382980,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19200,int_stack+57065,int_stack+56750, 0.0, zero_stack, 1.0, int_stack+79875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106175,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20145,int_stack+57485,int_stack+57065, 0.0, zero_stack, 1.0, int_stack+80505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106805,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+537635,int_stack+20145,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+283265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388230,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+539525,int_stack+58025,int_stack+57485, 0.0, zero_stack, 1.0, int_stack+81345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107645,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+541145,int_stack+539525,int_stack+20145, 0.0, zero_stack, 1.0, int_stack+284210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389175,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+54795,int_stack+541145,int_stack+537635, 0.0, zero_stack, 1.0, int_stack+285470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390435,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+58700,int_stack+58025, 0.0, zero_stack, 1.0, int_stack+82425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108725,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+543665,int_stack+19200,int_stack+539525, 0.0, zero_stack, 1.0, int_stack+287360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392325,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+546905,int_stack+543665,int_stack+541145, 0.0, zero_stack, 1.0, int_stack+288980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393945,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+537635,int_stack+546905,int_stack+54795, 0.0, zero_stack, 1.0, int_stack+291500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396465,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54795,int_stack+59735,int_stack+59525, 0.0, zero_stack, 1.0, int_stack+198500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217925, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55425,int_stack+60015,int_stack+59735, 0.0, zero_stack, 1.0, int_stack+198710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218135, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+56265,int_stack+55425,int_stack+54795, 0.0, zero_stack, 1.0, int_stack+299375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379170, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+57525,int_stack+60375,int_stack+60015, 0.0, zero_stack, 1.0, int_stack+198990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218415, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58605,int_stack+57525,int_stack+55425, 0.0, zero_stack, 1.0, int_stack+300005, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379800, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+58605,int_stack+56265, 0.0, zero_stack, 1.0, int_stack+300845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380640, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+60825,int_stack+60375, 0.0, zero_stack, 1.0, int_stack+199350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218775, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+54795,int_stack+57525, 0.0, zero_stack, 1.0, int_stack+302105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+381900, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+19200,int_stack+58605, 0.0, zero_stack, 1.0, int_stack+303185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+57595,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+304865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382980, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+61690,int_stack+61375, 0.0, zero_stack, 1.0, int_stack+86450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106175, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+62110,int_stack+61690, 0.0, zero_stack, 1.0, int_stack+87080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106805, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19200,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+310115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388230, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+62650,int_stack+62110, 0.0, zero_stack, 1.0, int_stack+87920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107645, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+542360,int_stack+500645,int_stack+54795, 0.0, zero_stack, 1.0, int_stack+311060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+389175, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+544880,int_stack+542360,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+312320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390435, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+63325,int_stack+62650, 0.0, zero_stack, 1.0, int_stack+89000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108725, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+60745,int_stack+19200,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+314210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+392325, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+548030,int_stack+60745,int_stack+542360, 0.0, zero_stack, 1.0, int_stack+315830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+393945, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+552230,int_stack+548030,int_stack+544880, 0.0, zero_stack, 1.0, int_stack+318350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396465, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+542360,int_stack+64360,int_stack+64150, 0.0, zero_stack, 1.0, int_stack+204975, 0.0, zero_stack, 1.0, int_stack+217925, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+542990,int_stack+64640,int_stack+64360, 0.0, zero_stack, 1.0, int_stack+205185, 0.0, zero_stack, 1.0, int_stack+218135, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+543830,int_stack+542990,int_stack+542360, 0.0, zero_stack, 1.0, int_stack+326225, 0.0, zero_stack, 1.0, int_stack+379170, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+545090,int_stack+65000,int_stack+64640, 0.0, zero_stack, 1.0, int_stack+205465, 0.0, zero_stack, 1.0, int_stack+218415, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+546170,int_stack+545090,int_stack+542990, 0.0, zero_stack, 1.0, int_stack+326855, 0.0, zero_stack, 1.0, int_stack+379800, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+546170,int_stack+543830, 0.0, zero_stack, 1.0, int_stack+327695, 0.0, zero_stack, 1.0, int_stack+380640, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+542360,int_stack+65450,int_stack+65000, 0.0, zero_stack, 1.0, int_stack+205825, 0.0, zero_stack, 1.0, int_stack+218775, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+547850,int_stack+542360,int_stack+545090, 0.0, zero_stack, 1.0, int_stack+328955, 0.0, zero_stack, 1.0, int_stack+381900, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+547850,int_stack+546170, 0.0, zero_stack, 1.0, int_stack+330035, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+542360,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+331715, 0.0, zero_stack, 1.0, int_stack+382980, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+66315,int_stack+66000, 0.0, zero_stack, 1.0, int_stack+93025, 0.0, zero_stack, 1.0, int_stack+106175, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+66735,int_stack+66315, 0.0, zero_stack, 1.0, int_stack+93655, 0.0, zero_stack, 1.0, int_stack+106805, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+545510,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+333815, 0.0, zero_stack, 1.0, int_stack+388230, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+67275,int_stack+66735, 0.0, zero_stack, 1.0, int_stack+94495, 0.0, zero_stack, 1.0, int_stack+107645, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+54795, 0.0, zero_stack, 1.0, int_stack+334760, 0.0, zero_stack, 1.0, int_stack+389175, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+547400,int_stack+19200,int_stack+545510, 0.0, zero_stack, 1.0, int_stack+336020, 0.0, zero_stack, 1.0, int_stack+390435, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+67950,int_stack+67275, 0.0, zero_stack, 1.0, int_stack+95575, 0.0, zero_stack, 1.0, int_stack+108725, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+60745,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+392325, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+63985,int_stack+60745,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+341925, 0.0, zero_stack, 1.0, int_stack+393945, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+556955,int_stack+63985,int_stack+547400, 0.0, zero_stack, 1.0, int_stack+344445, 0.0, zero_stack, 1.0, int_stack+396465, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19200,int_stack+68985,int_stack+68775, 0.0, zero_stack, 1.0, int_stack+211450, 1.0, int_stack+217925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19830,int_stack+69265,int_stack+68985, 0.0, zero_stack, 1.0, int_stack+211660, 1.0, int_stack+218135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+60745,int_stack+19830,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+352320, 1.0, int_stack+379170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+62005,int_stack+69625,int_stack+69265, 0.0, zero_stack, 1.0, int_stack+211940, 1.0, int_stack+218415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63085,int_stack+62005,int_stack+19830, 0.0, zero_stack, 1.0, int_stack+352950, 1.0, int_stack+379800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+63085,int_stack+60745, 0.0, zero_stack, 1.0, int_stack+353790, 1.0, int_stack+380640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+70075,int_stack+69625, 0.0, zero_stack, 1.0, int_stack+212300, 1.0, int_stack+218775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+64765,int_stack+19200,int_stack+62005, 0.0, zero_stack, 1.0, int_stack+355050, 1.0, int_stack+381900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+64765,int_stack+63085, 0.0, zero_stack, 1.0, int_stack+356130, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+60745,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+357810, 1.0, int_stack+382980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+70940,int_stack+70625, 0.0, zero_stack, 1.0, int_stack+99600, 1.0, int_stack+106175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+71360,int_stack+70940, 0.0, zero_stack, 1.0, int_stack+100230, 1.0, int_stack+106805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19200,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+363060, 1.0, int_stack+388230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+71900,int_stack+71360, 0.0, zero_stack, 1.0, int_stack+101070, 1.0, int_stack+107645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63895,int_stack+500645,int_stack+54795, 0.0, zero_stack, 1.0, int_stack+364005, 1.0, int_stack+389175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+66415,int_stack+63895,int_stack+19200, 0.0, zero_stack, 1.0, int_stack+365265, 1.0, int_stack+390435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+72575,int_stack+71900, 0.0, zero_stack, 1.0, int_stack+102150, 1.0, int_stack+108725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+69565,int_stack+19200,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+367155, 1.0, int_stack+392325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+545510,int_stack+69565,int_stack+63895, 0.0, zero_stack, 1.0, int_stack+368775, 1.0, int_stack+393945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+561680,int_stack+545510,int_stack+66415, 0.0, zero_stack, 1.0, int_stack+371295, 1.0, int_stack+396465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+545510,int_stack+73610,int_stack+73400, 0.0, zero_stack, 2.0, int_stack+217925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+546140,int_stack+73890,int_stack+73610, 0.0, zero_stack, 2.0, int_stack+218135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+546980,int_stack+546140,int_stack+545510, 0.0, zero_stack, 2.0, int_stack+379170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+548240,int_stack+74250,int_stack+73890, 0.0, zero_stack, 2.0, int_stack+218415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+549320,int_stack+548240,int_stack+546140, 0.0, zero_stack, 2.0, int_stack+379800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+549320,int_stack+546980, 0.0, zero_stack, 2.0, int_stack+380640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+545510,int_stack+74700,int_stack+74250, 0.0, zero_stack, 2.0, int_stack+218775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+63895,int_stack+545510,int_stack+548240, 0.0, zero_stack, 2.0, int_stack+381900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+63895,int_stack+549320, 0.0, zero_stack, 2.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+63895,int_stack+54795,int_stack+500645, 0.0, zero_stack, 2.0, int_stack+382980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+75565,int_stack+75250, 0.0, zero_stack, 2.0, int_stack+106175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+75985,int_stack+75565, 0.0, zero_stack, 2.0, int_stack+106805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+67045,int_stack+54795,int_stack+500645, 0.0, zero_stack, 2.0, int_stack+388230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+76525,int_stack+75985, 0.0, zero_stack, 2.0, int_stack+107645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+54795, 0.0, zero_stack, 2.0, int_stack+389175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+68935,int_stack+19200,int_stack+67045, 0.0, zero_stack, 2.0, int_stack+390435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+77200,int_stack+76525, 0.0, zero_stack, 2.0, int_stack+108725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+72085,int_stack+54795,int_stack+500645, 0.0, zero_stack, 2.0, int_stack+392325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+545510,int_stack+72085,int_stack+19200, 0.0, zero_stack, 2.0, int_stack+393945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72085,int_stack+545510,int_stack+68935, 0.0, zero_stack, 2.0, int_stack+396465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+545510,int_stack+78235,int_stack+78025, 1.0, int_stack+192025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224610,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+546140,int_stack+78515,int_stack+78235, 1.0, int_stack+192235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225100,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+546980,int_stack+546140,int_stack+545510, 1.0, int_stack+261140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404340,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+548240,int_stack+78875,int_stack+78515, 1.0, int_stack+192515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225740,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+549320,int_stack+548240,int_stack+546140, 1.0, int_stack+261770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404970,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+549320,int_stack+546980, 1.0, int_stack+262610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405810,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+545510,int_stack+79325,int_stack+78875, 1.0, int_stack+192875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226550,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+545510,int_stack+548240, 1.0, int_stack+263870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407070,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+19200,int_stack+549320, 1.0, int_stack+264950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408150,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+545510,int_stack+54795,int_stack+500645, 1.0, int_stack+266630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409830,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+80925,int_stack+80190, 1.0, int_stack+79875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113065,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+81885,int_stack+80925, 1.0, int_stack+80505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114115,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19200,int_stack+54795,int_stack+500645, 1.0, int_stack+283265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411930,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+83100,int_stack+81885, 1.0, int_stack+81345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115495,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+548660,int_stack+500645,int_stack+54795, 1.0, int_stack+284210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412875,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+76810,int_stack+548660,int_stack+19200, 1.0, int_stack+285470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414135,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+83775,int_stack+83100, 1.0, int_stack+82425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116575,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+79960,int_stack+19200,int_stack+500645, 1.0, int_stack+287360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+67045,int_stack+79960,int_stack+548660, 1.0, int_stack+288980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420040,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+260210,int_stack+67045,int_stack+76810, 1.0, int_stack+291500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422560,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+76810,int_stack+84810,int_stack+84600, 1.0, int_stack+198500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224610, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+77440,int_stack+85090,int_stack+84810, 1.0, int_stack+198710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225100, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+78280,int_stack+77440,int_stack+76810, 1.0, int_stack+299375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404340, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+79540,int_stack+85450,int_stack+85090, 1.0, int_stack+198990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225740, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+80620,int_stack+79540,int_stack+77440, 1.0, int_stack+300005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404970, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+80620,int_stack+78280, 1.0, int_stack+300845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405810, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+299375,int_stack+85900,int_stack+85450, 1.0, int_stack+199350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226550, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+76810,int_stack+299375,int_stack+79540, 1.0, int_stack+302105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407070, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+76810,int_stack+80620, 1.0, int_stack+303185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408150, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+76810,int_stack+54795,int_stack+500645, 1.0, int_stack+304865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409830, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+87500,int_stack+86765, 1.0, int_stack+86450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113065, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+88460,int_stack+87500, 1.0, int_stack+87080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114115, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+79960,int_stack+54795,int_stack+500645, 1.0, int_stack+310115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411930, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+89675,int_stack+88460, 1.0, int_stack+87920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115495, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+54795, 1.0, int_stack+311060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412875, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+81850,int_stack+19200,int_stack+79960, 1.0, int_stack+312320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414135, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+90350,int_stack+89675, 1.0, int_stack+89000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116575, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+310115,int_stack+54795,int_stack+500645, 1.0, int_stack+314210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+85000,int_stack+310115,int_stack+19200, 1.0, int_stack+315830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420040, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+310115,int_stack+85000,int_stack+81850, 1.0, int_stack+318350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422560, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+19200,int_stack+91385,int_stack+91175, 1.0, int_stack+204975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224610, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19830,int_stack+91665,int_stack+91385, 1.0, int_stack+205185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225100, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314840,int_stack+19830,int_stack+19200, 1.0, int_stack+326225, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404340, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+316100,int_stack+92025,int_stack+91665, 1.0, int_stack+205465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225740, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+317180,int_stack+316100,int_stack+19830, 1.0, int_stack+326855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404970, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+317180,int_stack+314840, 1.0, int_stack+327695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405810, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+326225,int_stack+92475,int_stack+92025, 1.0, int_stack+205825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226550, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+326225,int_stack+316100, 1.0, int_stack+328955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407070, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+19200,int_stack+317180, 1.0, int_stack+330035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408150, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+326225,int_stack+54795,int_stack+500645, 1.0, int_stack+331715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409830, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+94075,int_stack+93340, 1.0, int_stack+93025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113065, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+95035,int_stack+94075, 1.0, int_stack+93655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114115, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19200,int_stack+54795,int_stack+500645, 1.0, int_stack+333815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411930, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+96250,int_stack+95035, 1.0, int_stack+94495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115495, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+329375,int_stack+500645,int_stack+54795, 1.0, int_stack+334760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412875, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+331895,int_stack+329375,int_stack+19200, 1.0, int_stack+336020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+414135, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+96925,int_stack+96250, 1.0, int_stack+95575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+335045,int_stack+19200,int_stack+500645, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+314840,int_stack+335045,int_stack+329375, 1.0, int_stack+341925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+420040, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+79960,int_stack+314840,int_stack+331895, 1.0, int_stack+344445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+422560, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314840,int_stack+97960,int_stack+97750, 1.0, int_stack+211450, 0.0, zero_stack, 1.0, int_stack+224610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315470,int_stack+98240,int_stack+97960, 1.0, int_stack+211660, 0.0, zero_stack, 1.0, int_stack+225100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+316310,int_stack+315470,int_stack+314840, 1.0, int_stack+352320, 0.0, zero_stack, 1.0, int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+317570,int_stack+98600,int_stack+98240, 1.0, int_stack+211940, 0.0, zero_stack, 1.0, int_stack+225740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+318650,int_stack+317570,int_stack+315470, 1.0, int_stack+352950, 0.0, zero_stack, 1.0, int_stack+404970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+318650,int_stack+316310, 1.0, int_stack+353790, 0.0, zero_stack, 1.0, int_stack+405810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+352320,int_stack+99050,int_stack+98600, 1.0, int_stack+212300, 0.0, zero_stack, 1.0, int_stack+226550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+314840,int_stack+352320,int_stack+317570, 1.0, int_stack+355050, 0.0, zero_stack, 1.0, int_stack+407070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+314840,int_stack+318650, 1.0, int_stack+356130, 0.0, zero_stack, 1.0, int_stack+408150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+314840,int_stack+54795,int_stack+500645, 1.0, int_stack+357810, 0.0, zero_stack, 1.0, int_stack+409830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+100650,int_stack+99915, 1.0, int_stack+99600, 0.0, zero_stack, 1.0, int_stack+113065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+101610,int_stack+100650, 1.0, int_stack+100230, 0.0, zero_stack, 1.0, int_stack+114115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+317990,int_stack+54795,int_stack+500645, 1.0, int_stack+363060, 0.0, zero_stack, 1.0, int_stack+411930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+319880,int_stack+102825,int_stack+101610, 1.0, int_stack+101070, 0.0, zero_stack, 1.0, int_stack+115495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+319880,int_stack+54795, 1.0, int_stack+364005, 0.0, zero_stack, 1.0, int_stack+412875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+352320,int_stack+19200,int_stack+317990, 1.0, int_stack+365265, 0.0, zero_stack, 1.0, int_stack+414135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+103500,int_stack+102825, 1.0, int_stack+102150, 0.0, zero_stack, 1.0, int_stack+116575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+363060,int_stack+54795,int_stack+319880, 1.0, int_stack+367155, 0.0, zero_stack, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+355470,int_stack+363060,int_stack+19200, 1.0, int_stack+368775, 0.0, zero_stack, 1.0, int_stack+420040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+363060,int_stack+355470,int_stack+352320, 1.0, int_stack+371295, 0.0, zero_stack, 1.0, int_stack+422560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+352320,int_stack+104535,int_stack+104325, 1.0, int_stack+217925, 1.0, int_stack+224610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+352950,int_stack+104815,int_stack+104535, 1.0, int_stack+218135, 1.0, int_stack+225100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+353790,int_stack+352950,int_stack+352320, 1.0, int_stack+379170, 1.0, int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+355050,int_stack+105175,int_stack+104815, 1.0, int_stack+218415, 1.0, int_stack+225740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+356130,int_stack+355050,int_stack+352950, 1.0, int_stack+379800, 1.0, int_stack+404970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+357810,int_stack+356130,int_stack+353790, 1.0, int_stack+380640, 1.0, int_stack+405810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+379170,int_stack+105625,int_stack+105175, 1.0, int_stack+218775, 1.0, int_stack+226550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+352320,int_stack+379170,int_stack+355050, 1.0, int_stack+381900, 1.0, int_stack+407070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+352320,int_stack+356130, 1.0, int_stack+1620, 1.0, int_stack+408150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+352320,int_stack+54795,int_stack+357810, 1.0, int_stack+382980, 1.0, int_stack+409830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54795,int_stack+107225,int_stack+106490, 1.0, int_stack+106175, 1.0, int_stack+113065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+55740,int_stack+108185,int_stack+107225, 1.0, int_stack+106805, 1.0, int_stack+114115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355470,int_stack+55740,int_stack+54795, 1.0, int_stack+388230, 1.0, int_stack+411930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+357360,int_stack+109400,int_stack+108185, 1.0, int_stack+107645, 1.0, int_stack+115495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+357360,int_stack+55740, 1.0, int_stack+389175, 1.0, int_stack+412875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+379170,int_stack+19200,int_stack+355470, 1.0, int_stack+390435, 1.0, int_stack+414135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+388230,int_stack+110075,int_stack+109400, 1.0, int_stack+108725, 1.0, int_stack+116575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+367785,int_stack+388230,int_stack+357360, 1.0, int_stack+392325, 1.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+388230,int_stack+367785,int_stack+19200, 1.0, int_stack+393945, 1.0, int_stack+420040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+367785,int_stack+388230,int_stack+379170, 1.0, int_stack+396465, 1.0, int_stack+422560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+379170,int_stack+111110,int_stack+110900, 2.0, int_stack+224610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+379800,int_stack+111390,int_stack+111110, 2.0, int_stack+225100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+380640,int_stack+379800,int_stack+379170, 2.0, int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+381900,int_stack+111750,int_stack+111390, 2.0, int_stack+225740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+382980,int_stack+381900,int_stack+379800, 2.0, int_stack+404970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+382980,int_stack+380640, 2.0, int_stack+405810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+404340,int_stack+112200,int_stack+111750, 2.0, int_stack+226550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+379170,int_stack+404340,int_stack+381900, 2.0, int_stack+407070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+379170,int_stack+382980, 2.0, int_stack+408150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+224400,int_stack+54795,int_stack+500645, 2.0, int_stack+409830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+114535,int_stack+113380, 2.0, int_stack+113065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+116035,int_stack+114535, 2.0, int_stack+114115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+379170,int_stack+54795,int_stack+500645, 2.0, int_stack+411930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+500645,int_stack+117250,int_stack+116035, 2.0, int_stack+115495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+19200,int_stack+500645,int_stack+54795, 2.0, int_stack+412875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+381060,int_stack+19200,int_stack+379170, 2.0, int_stack+414135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+117925,int_stack+117250, 2.0, int_stack+116575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+404340,int_stack+54795,int_stack+500645, 2.0, int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+407580,int_stack+404340,int_stack+19200, 2.0, int_stack+420040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411780,int_stack+407580,int_stack+381060, 2.0, int_stack+422560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+420040,int_stack+118960,int_stack+118750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234125,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420670,int_stack+119240,int_stack+118960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234335,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+421510,int_stack+420670,int_stack+420040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275030,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+422770,int_stack+119600,int_stack+119240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234615,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423850,int_stack+422770,int_stack+420670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275660,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+423850,int_stack+421510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276500,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+420040,int_stack+120050,int_stack+119600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234975,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+19200,int_stack+420040,int_stack+422770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277760,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+19200,int_stack+423850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278840,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+420040,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280520,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+120915,int_stack+120600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143725,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+121335,int_stack+120915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19200,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430435,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+121875,int_stack+121335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145195,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+54795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431380,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+404340,int_stack+423190,int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+19200,int_stack+122550,int_stack+121875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146275,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+407490,int_stack+19200,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3300,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+379170,int_stack+407490,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432640,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+388230,int_stack+379170,int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435160,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+404340,int_stack+123585,int_stack+123375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234125, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+404970,int_stack+123865,int_stack+123585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234335, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+405810,int_stack+404970,int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275030, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+407070,int_stack+124225,int_stack+123865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234615, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+408150,int_stack+407070,int_stack+404970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275660, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+408150,int_stack+405810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276500, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+404340,int_stack+124675,int_stack+124225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234975, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+379170,int_stack+404340,int_stack+407070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277760, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+379170,int_stack+408150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278840, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+379170,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280520, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+500645,int_stack+125540,int_stack+125225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143725, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54795,int_stack+125960,int_stack+125540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+382320,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430435, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+126500,int_stack+125960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145195, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+54795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431380, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+404340,int_stack+423190,int_stack+382320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258320, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+382320,int_stack+127175,int_stack+126500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146275, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+407490,int_stack+382320,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3300, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+392955,int_stack+407490,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432640, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+341925,int_stack+392955,int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435160, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+404340,int_stack+128210,int_stack+128000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234125, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+404970,int_stack+128490,int_stack+128210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234335, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+405810,int_stack+404970,int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275030, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+407070,int_stack+128850,int_stack+128490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234615, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+408150,int_stack+407070,int_stack+404970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275660, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+408150,int_stack+405810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276500, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+404340,int_stack+129300,int_stack+128850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234975, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+392955,int_stack+404340,int_stack+407070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277760, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+392955,int_stack+408150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278840, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+392955,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280520, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+130165,int_stack+129850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143725, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+130585,int_stack+130165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+54795,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430435, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+131125,int_stack+130585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145195, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431380, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+396105,int_stack+423190,int_stack+54795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258320, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+131800,int_stack+131125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146275, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+404340,int_stack+54795,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3300, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+407580,int_stack+404340,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+329375,int_stack+407580,int_stack+396105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435160, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+396105,int_stack+132835,int_stack+132625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+396735,int_stack+133115,int_stack+132835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+397575,int_stack+396735,int_stack+396105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423190,int_stack+133475,int_stack+133115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+404340,int_stack+423190,int_stack+396735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+404340,int_stack+397575, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+396105,int_stack+133925,int_stack+133475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+397455,int_stack+396105,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+397455,int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+278840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+404340,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+134790,int_stack+134475, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+135210,int_stack+134790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+54795,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+135750,int_stack+135210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+407490,int_stack+423190,int_stack+54795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+136425,int_stack+135750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+396105,int_stack+54795,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+355470,int_stack+396105,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+84685,int_stack+355470,int_stack+407490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+407490,int_stack+137460,int_stack+137250, 0.0, zero_stack, 1.0, int_stack+234125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+408120,int_stack+137740,int_stack+137460, 0.0, zero_stack, 1.0, int_stack+234335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+408960,int_stack+408120,int_stack+407490, 0.0, zero_stack, 1.0, int_stack+275030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+410220,int_stack+138100,int_stack+137740, 0.0, zero_stack, 1.0, int_stack+234615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+355470,int_stack+410220,int_stack+408120, 0.0, zero_stack, 1.0, int_stack+275660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+355470,int_stack+408960, 0.0, zero_stack, 1.0, int_stack+276500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+407490,int_stack+138550,int_stack+138100, 0.0, zero_stack, 1.0, int_stack+234975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+357150,int_stack+407490,int_stack+410220, 0.0, zero_stack, 1.0, int_stack+277760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+357150,int_stack+355470, 0.0, zero_stack, 1.0, int_stack+278840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+355470,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+280520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+139415,int_stack+139100, 0.0, zero_stack, 1.0, int_stack+143725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+139835,int_stack+139415, 0.0, zero_stack, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+54795,int_stack+500645,int_stack+346650, 0.0, zero_stack, 1.0, int_stack+430435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+140375,int_stack+139835, 0.0, zero_stack, 1.0, int_stack+145195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+431380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+407490,int_stack+423190,int_stack+54795, 0.0, zero_stack, 1.0, int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+141050,int_stack+140375, 0.0, zero_stack, 1.0, int_stack+146275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+396105,int_stack+54795,int_stack+253550, 0.0, zero_stack, 1.0, int_stack+3300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+334100,int_stack+396105,int_stack+423190, 0.0, zero_stack, 1.0, int_stack+432640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+89410,int_stack+334100,int_stack+407490, 0.0, zero_stack, 1.0, int_stack+435160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+407490,int_stack+142085,int_stack+141875, 1.0, int_stack+234125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+408120,int_stack+142365,int_stack+142085, 1.0, int_stack+234335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+408960,int_stack+408120,int_stack+407490, 1.0, int_stack+275030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+410220,int_stack+142725,int_stack+142365, 1.0, int_stack+234615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+334100,int_stack+410220,int_stack+408120, 1.0, int_stack+275660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+334100,int_stack+408960, 1.0, int_stack+276500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+275030,int_stack+143175,int_stack+142725, 1.0, int_stack+234975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+407490,int_stack+275030,int_stack+410220, 1.0, int_stack+277760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+407490,int_stack+334100, 1.0, int_stack+278840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+334100,int_stack+54795,int_stack+500645, 1.0, int_stack+280520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+144775,int_stack+144040, 1.0, int_stack+143725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+145735,int_stack+144775, 1.0, int_stack+144355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+54795,int_stack+500645,int_stack+346650, 1.0, int_stack+430435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+146950,int_stack+145735, 1.0, int_stack+145195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 1.0, int_stack+431380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+407490,int_stack+423190,int_stack+54795, 1.0, int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+54795,int_stack+147625,int_stack+146950, 1.0, int_stack+146275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+275030,int_stack+54795,int_stack+253550, 1.0, int_stack+3300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+278270,int_stack+275030,int_stack+423190, 1.0, int_stack+432640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+430435,int_stack+278270,int_stack+407490, 1.0, int_stack+435160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+435160,int_stack+148660,int_stack+148450,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+435790,int_stack+148940,int_stack+148660,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+436630,int_stack+435790,int_stack+435160,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+407490,int_stack+149300,int_stack+148940,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+408570,int_stack+407490,int_stack+435790,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+408570,int_stack+436630,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+435160,int_stack+149750,int_stack+149300,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+423190,int_stack+435160,int_stack+407490,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+423190,int_stack+408570,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+435160,int_stack+54795,int_stack+500645,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+150615,int_stack+150300,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+151035,int_stack+150615,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+151575,int_stack+151035,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+407490,int_stack+423190,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+152250,int_stack+151575,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+275030,int_stack+500645,int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+278270,int_stack+275030,int_stack+423190,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+282470,int_stack+278270,int_stack+407490,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+407490,int_stack+153285,int_stack+153075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240600,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+408120,int_stack+153565,int_stack+153285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240810,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+408960,int_stack+408120,int_stack+407490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443035,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+410220,int_stack+153925,int_stack+153565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241090,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+410220,int_stack+408120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443665,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+423190,int_stack+408960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444505,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+407490,int_stack+154375,int_stack+153925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241450,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+275030,int_stack+407490,int_stack+410220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445765,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+275030,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446845,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+275030,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448525,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+155240,int_stack+154925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178050,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+155660,int_stack+155240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178680,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450625,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+156200,int_stack+155660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179520,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451570,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+278180,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452830,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+156875,int_stack+156200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180600,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+407490,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+287195,int_stack+407490,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460355,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+287195,int_stack+278180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462875,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+278180,int_stack+157910,int_stack+157700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240600, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+278810,int_stack+158190,int_stack+157910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240810, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+279650,int_stack+278810,int_stack+278180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443035, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+280910,int_stack+158550,int_stack+158190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241090, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+287195,int_stack+280910,int_stack+278810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443665, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+287195,int_stack+279650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444505, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+278180,int_stack+159000,int_stack+158550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241450, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+288875,int_stack+278180,int_stack+280910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445765, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+288875,int_stack+287195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446845, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+287195,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448525, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+159865,int_stack+159550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178050, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+160285,int_stack+159865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178680, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450625, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+160825,int_stack+160285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179520, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451570, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+290345,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452830, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+161500,int_stack+160825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180600, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+278180,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+407490,int_stack+278180,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460355, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+94135,int_stack+407490,int_stack+290345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462875, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290345,int_stack+162535,int_stack+162325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240600, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+290975,int_stack+162815,int_stack+162535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240810, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+291815,int_stack+290975,int_stack+290345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443035, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+293075,int_stack+163175,int_stack+162815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241090, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+407490,int_stack+293075,int_stack+290975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443665, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+407490,int_stack+291815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444505, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+290345,int_stack+163625,int_stack+163175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241450, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+409170,int_stack+290345,int_stack+293075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445765, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+409170,int_stack+407490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446845, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+407490,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448525, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+164490,int_stack+164175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178050, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+164910,int_stack+164490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178680, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450625, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+165450,int_stack+164910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179520, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451570, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+290345,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452830, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+166125,int_stack+165450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+278180,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+98860,int_stack+278180,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460355, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+103060,int_stack+98860,int_stack+290345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462875, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290345,int_stack+167160,int_stack+166950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+290975,int_stack+167440,int_stack+167160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+240810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+291815,int_stack+290975,int_stack+290345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+293075,int_stack+167800,int_stack+167440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+98860,int_stack+293075,int_stack+290975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+98860,int_stack+291815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+444505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+290345,int_stack+168250,int_stack+167800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+100540,int_stack+290345,int_stack+293075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+100540,int_stack+98860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+98860,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+169115,int_stack+168800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+169535,int_stack+169115, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+170075,int_stack+169535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+290345,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+170750,int_stack+170075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+278180,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+107785,int_stack+278180,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+460355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+111985,int_stack+107785,int_stack+290345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+462875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290345,int_stack+171785,int_stack+171575, 0.0, zero_stack, 1.0, int_stack+240600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+290975,int_stack+172065,int_stack+171785, 0.0, zero_stack, 1.0, int_stack+240810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+291815,int_stack+290975,int_stack+290345, 0.0, zero_stack, 1.0, int_stack+443035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+293075,int_stack+172425,int_stack+172065, 0.0, zero_stack, 1.0, int_stack+241090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+107785,int_stack+293075,int_stack+290975, 0.0, zero_stack, 1.0, int_stack+443665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+107785,int_stack+291815, 0.0, zero_stack, 1.0, int_stack+444505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+290345,int_stack+172875,int_stack+172425, 0.0, zero_stack, 1.0, int_stack+241450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+109465,int_stack+290345,int_stack+293075, 0.0, zero_stack, 1.0, int_stack+445765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+109465,int_stack+107785, 0.0, zero_stack, 1.0, int_stack+446845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+107785,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+448525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+173740,int_stack+173425, 0.0, zero_stack, 1.0, int_stack+178050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+174160,int_stack+173740, 0.0, zero_stack, 1.0, int_stack+178680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 1.0, int_stack+450625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+174700,int_stack+174160, 0.0, zero_stack, 1.0, int_stack+179520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+451570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+290345,int_stack+423190,int_stack+258320, 0.0, zero_stack, 1.0, int_stack+452830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+175375,int_stack+174700, 0.0, zero_stack, 1.0, int_stack+180600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+278180,int_stack+500645,int_stack+253550, 0.0, zero_stack, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+116710,int_stack+278180,int_stack+423190, 0.0, zero_stack, 1.0, int_stack+460355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+120910,int_stack+116710,int_stack+290345, 0.0, zero_stack, 1.0, int_stack+462875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290345,int_stack+176410,int_stack+176200, 1.0, int_stack+240600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+290975,int_stack+176690,int_stack+176410, 1.0, int_stack+240810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+291815,int_stack+290975,int_stack+290345, 1.0, int_stack+443035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+293075,int_stack+177050,int_stack+176690, 1.0, int_stack+241090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+116710,int_stack+293075,int_stack+290975, 1.0, int_stack+443665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+116710,int_stack+291815, 1.0, int_stack+444505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+443035,int_stack+177500,int_stack+177050, 1.0, int_stack+241450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+290345,int_stack+443035,int_stack+293075, 1.0, int_stack+445765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+290345,int_stack+116710, 1.0, int_stack+446845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+116710,int_stack+54795,int_stack+500645, 1.0, int_stack+448525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+179100,int_stack+178365, 1.0, int_stack+178050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+180060,int_stack+179100, 1.0, int_stack+178680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 1.0, int_stack+450625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+181275,int_stack+180060, 1.0, int_stack+179520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 1.0, int_stack+451570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+290345,int_stack+423190,int_stack+258320, 1.0, int_stack+452830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+181950,int_stack+181275, 1.0, int_stack+180600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+443035,int_stack+500645,int_stack+253550, 1.0, int_stack+458735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+446275,int_stack+443035,int_stack+423190, 1.0, int_stack+460355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+450475,int_stack+446275,int_stack+290345, 1.0, int_stack+462875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+290345,int_stack+182985,int_stack+182775,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+290975,int_stack+183265,int_stack+182985,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+291815,int_stack+290975,int_stack+290345,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+293075,int_stack+183625,int_stack+183265,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+293075,int_stack+290975,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+423190,int_stack+291815,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+290345,int_stack+184075,int_stack+183625,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+443035,int_stack+290345,int_stack+293075,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+443035,int_stack+423190,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+443035,int_stack+54795,int_stack+500645,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+184940,int_stack+184625,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+185360,int_stack+184940,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+185900,int_stack+185360,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+446185,int_stack+423190,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+186575,int_stack+185900,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+290345,int_stack+500645,int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+458735,int_stack+290345,int_stack+423190,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+125635,int_stack+458735,int_stack+446185,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+446185,int_stack+187610,int_stack+187400,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+446815,int_stack+187890,int_stack+187610,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+447655,int_stack+446815,int_stack+446185,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+448915,int_stack+188250,int_stack+187890,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+458735,int_stack+448915,int_stack+446815,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+458735,int_stack+447655,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+446185,int_stack+188700,int_stack+188250,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+460415,int_stack+446185,int_stack+448915,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+460415,int_stack+458735,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+458735,int_stack+54795,int_stack+500645,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+189565,int_stack+189250,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+189985,int_stack+189565,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+190525,int_stack+189985,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+191200,int_stack+190525,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+446185,int_stack+500645,int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+290345,int_stack+446185,int_stack+423190,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+130360,int_stack+290345,int_stack+461885,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+194085,int_stack+193875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247075,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+194365,int_stack+194085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247285,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470750,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+194725,int_stack+194365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247565,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+290345,int_stack+464615,int_stack+462515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471380,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+290345,int_stack+463355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472220,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+195175,int_stack+194725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247925,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+292025,int_stack+461885,int_stack+464615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473480,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+292025,int_stack+290345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4920,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+290345,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474560,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+196040,int_stack+195725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229400,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+196460,int_stack+196040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230030,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479810,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+197000,int_stack+196460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230870,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480755,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482015,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+197675,int_stack+197000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231950,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+446185,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483905,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+278180,int_stack+446185,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485525,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+135085,int_stack+278180,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488045,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+200560,int_stack+200350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247075, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+200840,int_stack+200560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247285, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470750, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+201200,int_stack+200840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247565, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+278180,int_stack+464615,int_stack+462515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471380, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+278180,int_stack+463355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472220, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+201650,int_stack+201200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247925, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+279860,int_stack+461885,int_stack+464615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473480, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+279860,int_stack+278180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4920, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+278180,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474560, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+202515,int_stack+202200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229400, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+202935,int_stack+202515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230030, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479810, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+203475,int_stack+202935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230870, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480755, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482015, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+204150,int_stack+203475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231950, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+446185,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483905, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+139810,int_stack+446185,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485525, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+144010,int_stack+139810,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488045, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+207035,int_stack+206825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247075, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+207315,int_stack+207035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247285, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470750, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+207675,int_stack+207315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247565, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+139810,int_stack+464615,int_stack+462515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471380, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+139810,int_stack+463355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472220, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+208125,int_stack+207675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247925, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+141490,int_stack+461885,int_stack+464615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473480, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+141490,int_stack+139810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4920, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+139810,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474560, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+208990,int_stack+208675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229400, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+209410,int_stack+208990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230030, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479810, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+209950,int_stack+209410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230870, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480755, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482015, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+210625,int_stack+209950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231950, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+446185,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483905, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+148735,int_stack+446185,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485525, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+152935,int_stack+148735,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488045, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+213510,int_stack+213300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+213790,int_stack+213510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+214150,int_stack+213790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+148735,int_stack+464615,int_stack+462515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+148735,int_stack+463355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+472220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+214600,int_stack+214150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+150415,int_stack+461885,int_stack+464615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+150415,int_stack+148735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+148735,int_stack+54795,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+215465,int_stack+215150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+215885,int_stack+215465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+216425,int_stack+215885, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+482015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+217100,int_stack+216425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+446185,int_stack+500645,int_stack+253550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+483905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+157660,int_stack+446185,int_stack+423190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+485525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+161860,int_stack+157660,int_stack+461885, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+219985,int_stack+219775, 0.0, zero_stack, 1.0, int_stack+247075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+220265,int_stack+219985, 0.0, zero_stack, 1.0, int_stack+247285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885, 0.0, zero_stack, 1.0, int_stack+470750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+220625,int_stack+220265, 0.0, zero_stack, 1.0, int_stack+247565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+157660,int_stack+464615,int_stack+462515, 0.0, zero_stack, 1.0, int_stack+471380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+157660,int_stack+463355, 0.0, zero_stack, 1.0, int_stack+472220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+221075,int_stack+220625, 0.0, zero_stack, 1.0, int_stack+247925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+159340,int_stack+461885,int_stack+464615, 0.0, zero_stack, 1.0, int_stack+473480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+159340,int_stack+157660, 0.0, zero_stack, 1.0, int_stack+4920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+157660,int_stack+54795,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+474560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+221940,int_stack+221625, 0.0, zero_stack, 1.0, int_stack+229400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+222360,int_stack+221940, 0.0, zero_stack, 1.0, int_stack+230030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 0.0, zero_stack, 1.0, int_stack+479810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+222900,int_stack+222360, 0.0, zero_stack, 1.0, int_stack+230870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 0.0, zero_stack, 1.0, int_stack+480755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320, 0.0, zero_stack, 1.0, int_stack+482015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+223575,int_stack+222900, 0.0, zero_stack, 1.0, int_stack+231950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+446185,int_stack+500645,int_stack+253550, 0.0, zero_stack, 1.0, int_stack+483905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+166585,int_stack+446185,int_stack+423190, 0.0, zero_stack, 1.0, int_stack+485525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+170785,int_stack+166585,int_stack+461885, 0.0, zero_stack, 1.0, int_stack+488045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+227760,int_stack+227550, 1.0, int_stack+247075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+228040,int_stack+227760, 1.0, int_stack+247285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885, 1.0, int_stack+470750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+228400,int_stack+228040, 1.0, int_stack+247565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166585,int_stack+464615,int_stack+462515, 1.0, int_stack+471380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+166585,int_stack+463355, 1.0, int_stack+472220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+470750,int_stack+228850,int_stack+228400, 1.0, int_stack+247925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+461885,int_stack+470750,int_stack+464615, 1.0, int_stack+473480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+461885,int_stack+166585, 1.0, int_stack+4920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+166585,int_stack+54795,int_stack+500645, 1.0, int_stack+474560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+230450,int_stack+229715, 1.0, int_stack+229400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+231410,int_stack+230450, 1.0, int_stack+230030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650, 1.0, int_stack+479810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+232625,int_stack+231410, 1.0, int_stack+230870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645, 1.0, int_stack+480755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320, 1.0, int_stack+482015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+233300,int_stack+232625, 1.0, int_stack+231950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+479810,int_stack+500645,int_stack+253550, 1.0, int_stack+483905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+470750,int_stack+479810,int_stack+423190, 1.0, int_stack+485525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+479810,int_stack+470750,int_stack+461885, 1.0, int_stack+488045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+236185,int_stack+235975,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+236465,int_stack+236185,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+236825,int_stack+236465,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+470750,int_stack+464615,int_stack+462515,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+470750,int_stack+463355,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+237275,int_stack+236825,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+472430,int_stack+461885,int_stack+464615,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+472430,int_stack+470750,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+470750,int_stack+54795,int_stack+500645,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+238140,int_stack+237825,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+238560,int_stack+238140,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+239100,int_stack+238560,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+461885,int_stack+423190,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+239775,int_stack+239100,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+484535,int_stack+500645,int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+227550,int_stack+484535,int_stack+423190,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+484535,int_stack+227550,int_stack+461885,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+461885,int_stack+242660,int_stack+242450,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+462515,int_stack+242940,int_stack+242660,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+463355,int_stack+462515,int_stack+461885,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+464615,int_stack+243300,int_stack+242940,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+227550,int_stack+464615,int_stack+462515,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+227550,int_stack+463355,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+461885,int_stack+243750,int_stack+243300,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+229230,int_stack+461885,int_stack+464615,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+229230,int_stack+227550,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+227550,int_stack+54795,int_stack+500645,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+244615,int_stack+244300,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+245035,int_stack+244615,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+245575,int_stack+245035,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+230700,int_stack+423190,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+246250,int_stack+245575,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+233850,int_stack+500645,int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+237090,int_stack+233850,int_stack+423190,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+241290,int_stack+237090,int_stack+230700,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+230700,int_stack+249135,int_stack+248925,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+231330,int_stack+249415,int_stack+249135,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+232170,int_stack+231330,int_stack+230700,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+233430,int_stack+249775,int_stack+249415,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+234510,int_stack+233430,int_stack+231330,10);
 /*--- compute (f0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+500645,int_stack+234510,int_stack+232170,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+230700,int_stack+250225,int_stack+249775,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+236190,int_stack+230700,int_stack+233430,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+54795,int_stack+236190,int_stack+234510,10);
 /*--- compute (f0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+230700,int_stack+54795,int_stack+500645,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+346650,int_stack+251090,int_stack+250775,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+500645,int_stack+251510,int_stack+251090,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258320,int_stack+500645,int_stack+346650,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+253550,int_stack+252050,int_stack+251510,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+423190,int_stack+253550,int_stack+500645,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+233850,int_stack+423190,int_stack+258320,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500645,int_stack+252725,int_stack+252050,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+237000,int_stack+500645,int_stack+253550,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+246015,int_stack+237000,int_stack+423190,15);
 /*--- compute (g0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+250215,int_stack+246015,int_stack+233850,15);
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+175510,int_stack+294650,int_stack+268730,315);
     Libderiv->ABCD[11] = int_stack + 175510;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+293495,int_stack+321500,int_stack+306965,315);
     Libderiv->ABCD[10] = int_stack + 293495;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+184960,int_stack+347595,int_stack+338775,315);
     Libderiv->ABCD[9] = int_stack + 184960;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+194410,int_stack+374445,int_stack+359910,315);
     Libderiv->ABCD[8] = int_stack + 194410;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+203860,int_stack+399615,int_stack+385080,315);
     Libderiv->ABCD[7] = int_stack + 203860;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+213310,int_stack+425710,int_stack+416890,315);
     Libderiv->ABCD[6] = int_stack + 213310;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+566405,int_stack+438310,int_stack+255170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[2] = int_stack + 566405;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+575855,int_stack+466025,int_stack+455585, 0.0, zero_stack, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[1] = int_stack + 575855;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+585305,int_stack+491195,int_stack+476660, 1.0, int_stack+271880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[0] = int_stack + 585305;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+594755,int_stack+495920,int_stack+6600,315);
     Libderiv->ABCD[155] = int_stack + 594755;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+489260,int_stack+511385,int_stack+508235,315);
     Libderiv->ABCD[143] = int_stack + 489260;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+505895,int_stack+516110,int_stack+9750,315);
     Libderiv->ABCD[142] = int_stack + 505895;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+604205,int_stack+21720,int_stack+12900,315);
     Libderiv->ABCD[131] = int_stack + 604205;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4725,int_stack+520835,int_stack+16050,315);
     Libderiv->ABCD[130] = int_stack + 4725;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+14175,int_stack+529760,int_stack+502745,315);
     Libderiv->ABCD[129] = int_stack + 14175;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+515345,int_stack+32745,int_stack+26445,315);
     Libderiv->ABCD[119] = int_stack + 515345;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+613655,int_stack+40620,int_stack+525560,315);
     Libderiv->ABCD[118] = int_stack + 613655;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+524795,int_stack+45345,int_stack+29595,315);
     Libderiv->ABCD[117] = int_stack + 524795;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+40620,int_stack+50070,int_stack+37470,315);
     Libderiv->ABCD[116] = int_stack + 40620;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+23625,int_stack+537635,int_stack+534485,315);
     Libderiv->ABCD[107] = int_stack + 23625;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+623105,int_stack+552230,int_stack+57595,315);
     Libderiv->ABCD[106] = int_stack + 623105;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+50070,int_stack+556955,int_stack+542360,315);
     Libderiv->ABCD[105] = int_stack + 50070;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+548660,int_stack+561680,int_stack+60745,315);
     Libderiv->ABCD[104] = int_stack + 548660;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+534245,int_stack+72085,int_stack+63895,315);
     Libderiv->ABCD[103] = int_stack + 534245;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+59520,int_stack+260210,int_stack+545510,315);
     Libderiv->ABCD[95] = int_stack + 59520;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+258320,int_stack+310115,int_stack+76810,315);
     Libderiv->ABCD[94] = int_stack + 258320;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+68970,int_stack+79960,int_stack+326225,315);
     Libderiv->ABCD[93] = int_stack + 68970;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+317990,int_stack+363060,int_stack+314840,315);
     Libderiv->ABCD[92] = int_stack + 317990;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+632555,int_stack+367785,int_stack+352320,315);
     Libderiv->ABCD[91] = int_stack + 632555;
 /*--- compute (fp|hg) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+363060,int_stack+411780,int_stack+224400,315);
     Libderiv->ABCD[90] = int_stack + 363060;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+642005,int_stack+388230,int_stack+420040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[47] = int_stack + 642005;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+420040,int_stack+341925,int_stack+379170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+306965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[46] = int_stack + 420040;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+341925,int_stack+329375,int_stack+392955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[45] = int_stack + 341925;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+388230,int_stack+84685,int_stack+404340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[44] = int_stack + 388230;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+397680,int_stack+89410,int_stack+355470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[43] = int_stack + 397680;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+372510,int_stack+430435,int_stack+334100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[42] = int_stack + 372510;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+78420,int_stack+282470,int_stack+435160, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+255170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[38] = int_stack + 78420;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+429490,int_stack+0,int_stack+275030, 0.0, zero_stack, 1.0, int_stack+268730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[35] = int_stack + 429490;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+327440,int_stack+94135,int_stack+287195, 0.0, zero_stack, 1.0, int_stack+306965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[34] = int_stack + 327440;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+87870,int_stack+103060,int_stack+407490, 0.0, zero_stack, 1.0, int_stack+338775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[33] = int_stack + 87870;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+407130,int_stack+111985,int_stack+98860, 0.0, zero_stack, 1.0, int_stack+359910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[32] = int_stack + 407130;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+97320,int_stack+120910,int_stack+107785, 0.0, zero_stack, 1.0, int_stack+385080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[31] = int_stack + 97320;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+106770,int_stack+450475,int_stack+116710, 0.0, zero_stack, 1.0, int_stack+416890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[30] = int_stack + 106770;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+651455,int_stack+125635,int_stack+443035, 0.0, zero_stack, 1.0, int_stack+255170, 1.0, int_stack+455585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[26] = int_stack + 651455;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+438940,int_stack+130360,int_stack+458735, 0.0, zero_stack, 2.0, int_stack+455585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[25] = int_stack + 438940;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+458735,int_stack+135085,int_stack+290345, 1.0, int_stack+268730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[23] = int_stack + 458735;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+116220,int_stack+144010,int_stack+278180, 1.0, int_stack+306965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[22] = int_stack + 116220;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+125670,int_stack+152935,int_stack+139810, 1.0, int_stack+338775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[21] = int_stack + 125670;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+135120,int_stack+161860,int_stack+148735, 1.0, int_stack+359910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[20] = int_stack + 135120;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+351375,int_stack+170785,int_stack+157660, 1.0, int_stack+385080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[19] = int_stack + 351375;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+144570,int_stack+479810,int_stack+166585, 1.0, int_stack+416890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[18] = int_stack + 144570;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+154020,int_stack+484535,int_stack+470750, 1.0, int_stack+255170, 0.0, zero_stack, 1.0, int_stack+476660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[14] = int_stack + 154020;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+479810,int_stack+241290,int_stack+227550, 1.0, int_stack+455585, 1.0, int_stack+476660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[13] = int_stack + 479810;
 /*--- compute (fp|hg) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+448390,int_stack+250215,int_stack+230700, 2.0, int_stack+476660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[12] = int_stack + 448390;

}
