/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_gphf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gp|hf) integrals */

void d12hrr_order_gphf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][8][11] = int_stack + 0;
 Libderiv->deriv_classes[5][8][10] = int_stack + 945;
 Libderiv->deriv_classes[5][8][9] = int_stack + 1890;
 Libderiv->deriv_classes[5][8][8] = int_stack + 2835;
 Libderiv->deriv_classes[5][8][7] = int_stack + 3780;
 Libderiv->dvrr_classes[5][7] = int_stack + 4725;
 Libderiv->deriv_classes[5][8][6] = int_stack + 5481;
 Libderiv->deriv_classes[5][8][2] = int_stack + 6426;
 Libderiv->deriv_classes[5][8][1] = int_stack + 7371;
 Libderiv->dvrr_classes[4][8] = int_stack + 8316;
 Libderiv->deriv_classes[5][8][0] = int_stack + 8991;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 9936;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 10251;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 10671;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 11211;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 11886;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 12327;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 12915;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 13671;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 14616;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 14931;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 15351;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 15891;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 16566;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 17007;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 17595;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 18351;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 19296;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 19611;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 20031;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 20571;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 21246;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 21687;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 22275;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 23031;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 23976;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 24291;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 24711;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 25251;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 25926;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 26367;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 26955;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 27711;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 28656;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 28971;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 29391;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 29931;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 30606;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 31047;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 31635;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 32391;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 33336;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 33651;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 34071;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 34611;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 35286;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 35727;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 36315;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 37071;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 38016;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 38331;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 38751;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 39291;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 39966;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 40407;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 40995;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 41751;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 42696;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 43011;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 43431;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 43971;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 44646;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 45087;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 45675;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 46431;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 47376;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 47691;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 48111;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 48651;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 49326;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 49767;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 50355;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 51111;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 52056;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 52371;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 52791;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 53331;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 54006;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 54447;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 55035;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 55791;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 56736;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 57051;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 57471;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 58011;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 58686;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 59127;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 59715;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 60471;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 61416;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 61731;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 62151;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 62691;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 63366;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 63807;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 64395;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 65151;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 66096;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 66411;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 66831;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 67371;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 68046;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 68487;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 69075;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 69831;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 70776;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 71091;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 71511;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 72051;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 72726;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 73167;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 73755;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 74511;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 75456;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 75771;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 76191;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 76731;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 77406;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 77847;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 78435;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 79191;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 80136;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 80451;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 80871;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 81411;
 Libderiv->deriv_classes[5][5][11] = int_stack + 82086;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 82527;
 Libderiv->deriv_classes[5][6][11] = int_stack + 82968;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 83556;
 Libderiv->deriv_classes[5][7][11] = int_stack + 84144;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 84900;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 85656;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 86601;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 86916;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 87336;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 87876;
 Libderiv->deriv_classes[5][5][10] = int_stack + 88551;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 88992;
 Libderiv->deriv_classes[5][6][10] = int_stack + 89433;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 90021;
 Libderiv->deriv_classes[5][7][10] = int_stack + 90609;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 91365;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 92121;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 93066;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 93381;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 93801;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 94341;
 Libderiv->deriv_classes[5][5][9] = int_stack + 95016;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 95457;
 Libderiv->deriv_classes[5][6][9] = int_stack + 95898;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 96486;
 Libderiv->deriv_classes[5][7][9] = int_stack + 97074;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 97830;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 98586;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 99531;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 99846;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 100266;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 100806;
 Libderiv->deriv_classes[5][5][8] = int_stack + 101481;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 101922;
 Libderiv->deriv_classes[5][6][8] = int_stack + 102363;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 102951;
 Libderiv->deriv_classes[5][7][8] = int_stack + 103539;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 104295;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 105051;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 105996;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 106311;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 106731;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 107271;
 Libderiv->deriv_classes[5][5][7] = int_stack + 107946;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 108387;
 Libderiv->deriv_classes[5][6][7] = int_stack + 108828;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 109416;
 Libderiv->deriv_classes[5][7][7] = int_stack + 110004;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 110760;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 111516;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 112461;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 112776;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 113196;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 113736;
 Libderiv->dvrr_classes[5][5] = int_stack + 114411;
 Libderiv->deriv_classes[5][5][6] = int_stack + 114852;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 115293;
 Libderiv->dvrr_classes[5][6] = int_stack + 115734;
 Libderiv->deriv_classes[5][6][6] = int_stack + 116322;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 116910;
 Libderiv->deriv_classes[5][7][6] = int_stack + 117498;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 118254;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 119010;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 119955;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 120270;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 120690;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 121230;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 121905;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 122346;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 122934;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 123690;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 124635;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 124950;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 125370;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 125910;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 126585;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 127026;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 127614;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 128370;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 129315;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 129630;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 130050;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 130590;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 131265;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 131706;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 132294;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 133050;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 133995;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 134310;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 134730;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 135270;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 135945;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 136386;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 136974;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 137730;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 138675;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 138990;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 139410;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 139950;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 140625;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 141066;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 141654;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 142410;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 143355;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 143670;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 144090;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 144630;
 Libderiv->deriv_classes[5][5][2] = int_stack + 145305;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 145746;
 Libderiv->deriv_classes[5][6][2] = int_stack + 146187;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 146775;
 Libderiv->deriv_classes[5][7][2] = int_stack + 147363;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 148119;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 148875;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 149820;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 150135;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 150555;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 151095;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 151770;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 152211;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 152799;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 153555;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 154500;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 154815;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 155235;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 155775;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 156450;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 156891;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 157479;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 158235;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 159180;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 159495;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 159915;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 160455;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 161130;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 161571;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 162159;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 162915;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 163860;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 164175;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 164595;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 165135;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 165810;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 166251;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 166839;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 167595;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 168540;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 168855;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 169275;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 169815;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 170490;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 170931;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 171519;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 172275;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 173220;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 173535;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 173955;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 174495;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 175170;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 175611;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 176199;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 176955;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 177900;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 178215;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 178635;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 179175;
 Libderiv->deriv_classes[5][5][1] = int_stack + 179850;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 180291;
 Libderiv->deriv_classes[5][6][1] = int_stack + 180732;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 181320;
 Libderiv->deriv_classes[5][7][1] = int_stack + 181908;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 182664;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 183420;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 184365;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 184680;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 185100;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 185640;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 186315;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 186756;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 187344;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 188100;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 189045;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 189360;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 189780;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 190320;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 190995;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 191436;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 192024;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 192780;
 Libderiv->deriv_classes[4][5][11] = int_stack + 193725;
 Libderiv->deriv_classes[4][6][11] = int_stack + 194040;
 Libderiv->deriv_classes[4][7][11] = int_stack + 194460;
 Libderiv->deriv_classes[4][8][11] = int_stack + 195000;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 195675;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 195990;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 196410;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 196950;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 197625;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 198066;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 198654;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 199410;
 Libderiv->deriv_classes[4][5][10] = int_stack + 200355;
 Libderiv->deriv_classes[4][6][10] = int_stack + 200670;
 Libderiv->deriv_classes[4][7][10] = int_stack + 201090;
 Libderiv->deriv_classes[4][8][10] = int_stack + 201630;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 202305;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 202620;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 203040;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 203580;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 204255;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 204696;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 205284;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 206040;
 Libderiv->deriv_classes[4][5][9] = int_stack + 206985;
 Libderiv->deriv_classes[4][6][9] = int_stack + 207300;
 Libderiv->deriv_classes[4][7][9] = int_stack + 207720;
 Libderiv->deriv_classes[4][8][9] = int_stack + 208260;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 208935;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 209250;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 209670;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 210210;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 210885;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 211326;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 211914;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 212670;
 Libderiv->deriv_classes[4][5][8] = int_stack + 213615;
 Libderiv->deriv_classes[4][6][8] = int_stack + 213930;
 Libderiv->deriv_classes[4][7][8] = int_stack + 214350;
 Libderiv->deriv_classes[4][8][8] = int_stack + 214890;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 215565;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 215880;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 216300;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 216840;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 217515;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 217956;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 218544;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 219300;
 Libderiv->deriv_classes[4][5][7] = int_stack + 220245;
 Libderiv->deriv_classes[4][6][7] = int_stack + 220560;
 Libderiv->deriv_classes[4][7][7] = int_stack + 220980;
 Libderiv->deriv_classes[4][8][7] = int_stack + 221520;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 222195;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 222510;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 222930;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 223470;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 224145;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 224586;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 225174;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 225930;
 Libderiv->dvrr_classes[4][5] = int_stack + 226875;
 Libderiv->deriv_classes[4][5][6] = int_stack + 227190;
 Libderiv->dvrr_classes[4][6] = int_stack + 227505;
 Libderiv->deriv_classes[4][6][6] = int_stack + 227925;
 Libderiv->dvrr_classes[4][7] = int_stack + 228345;
 Libderiv->deriv_classes[4][7][6] = int_stack + 228885;
 Libderiv->deriv_classes[4][8][6] = int_stack + 229425;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 230100;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 230415;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 230835;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 231375;
 Libderiv->deriv_classes[5][5][0] = int_stack + 232050;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 232491;
 Libderiv->deriv_classes[5][6][0] = int_stack + 232932;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 233520;
 Libderiv->deriv_classes[5][7][0] = int_stack + 234108;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 234864;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 235620;
 Libderiv->deriv_classes[4][5][2] = int_stack + 236565;
 Libderiv->deriv_classes[4][6][2] = int_stack + 236880;
 Libderiv->deriv_classes[4][7][2] = int_stack + 237300;
 Libderiv->deriv_classes[4][8][2] = int_stack + 237840;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 238515;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 238830;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 239250;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 239790;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 240465;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 240906;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 241494;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 242250;
 Libderiv->deriv_classes[4][5][1] = int_stack + 243195;
 Libderiv->deriv_classes[4][6][1] = int_stack + 243510;
 Libderiv->deriv_classes[4][7][1] = int_stack + 243930;
 Libderiv->deriv_classes[4][8][1] = int_stack + 244470;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 245145;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 245460;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 245880;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 246420;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 247095;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 247536;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 248124;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 248880;
 Libderiv->deriv_classes[4][5][0] = int_stack + 249825;
 Libderiv->deriv_classes[4][6][0] = int_stack + 250140;
 Libderiv->deriv_classes[4][7][0] = int_stack + 250560;
 Libderiv->deriv_classes[4][8][0] = int_stack + 251100;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 251775;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 252090;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 252510;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 253050;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 253725;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 254166;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 254754;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 255510;
 memset(int_stack,0,2051640);

 Libderiv->dvrr_stack = int_stack + 617238;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_gphf(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+256455,int_stack+227505,int_stack+226875,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+257400,int_stack+228345,int_stack+227505,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258660,int_stack+257400,int_stack+256455,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+260550,int_stack+194040,int_stack+193725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226875,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+261495,int_stack+194460,int_stack+194040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227505,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+262755,int_stack+261495,int_stack+260550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256455,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+264645,int_stack+195000,int_stack+194460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228345,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+266265,int_stack+264645,int_stack+261495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257400,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+268785,int_stack+266265,int_stack+262755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258660,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+264645,int_stack+115734,int_stack+114411,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+265968,int_stack+4725,int_stack+115734,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+271935,int_stack+265968,int_stack+264645,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+274581,int_stack+82968,int_stack+82086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114411,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+275904,int_stack+84144,int_stack+82968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115734,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+277668,int_stack+275904,int_stack+274581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+280314,int_stack+0,int_stack+84144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+282582,int_stack+280314,int_stack+275904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+286110,int_stack+282582,int_stack+277668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+200670,int_stack+200355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226875, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+280314,int_stack+201090,int_stack+200670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227505, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+281574,int_stack+280314,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256455, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+283464,int_stack+201630,int_stack+201090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228345, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+290520,int_stack+283464,int_stack+280314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257400, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+293040,int_stack+290520,int_stack+281574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258660, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290520,int_stack+89433,int_stack+88551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114411, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+283464,int_stack+90609,int_stack+89433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115734, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+296190,int_stack+283464,int_stack+290520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+298836,int_stack+945,int_stack+90609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+301104,int_stack+298836,int_stack+283464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+304632,int_stack+301104,int_stack+296190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+945,int_stack+207300,int_stack+206985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226875, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+298836,int_stack+207720,int_stack+207300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227505, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+300096,int_stack+298836,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256455, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+301986,int_stack+208260,int_stack+207720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228345, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+309042,int_stack+301986,int_stack+298836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257400, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+311562,int_stack+309042,int_stack+300096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258660, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+309042,int_stack+95898,int_stack+95016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114411, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+301986,int_stack+97074,int_stack+95898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115734, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+301986,int_stack+309042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+317358,int_stack+1890,int_stack+97074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+319626,int_stack+317358,int_stack+301986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+323154,int_stack+319626,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1890,int_stack+213930,int_stack+213615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+317358,int_stack+214350,int_stack+213930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+318618,int_stack+317358,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+256455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+320508,int_stack+214890,int_stack+214350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+327564,int_stack+320508,int_stack+317358, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+330084,int_stack+327564,int_stack+318618, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+327564,int_stack+102363,int_stack+101481, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+320508,int_stack+103539,int_stack+102363, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+333234,int_stack+320508,int_stack+327564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+335880,int_stack+2835,int_stack+103539, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+338148,int_stack+335880,int_stack+320508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+341676,int_stack+338148,int_stack+333234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2835,int_stack+220560,int_stack+220245, 0.0, zero_stack, 1.0, int_stack+226875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+335880,int_stack+220980,int_stack+220560, 0.0, zero_stack, 1.0, int_stack+227505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+337140,int_stack+335880,int_stack+2835, 0.0, zero_stack, 1.0, int_stack+256455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+339030,int_stack+221520,int_stack+220980, 0.0, zero_stack, 1.0, int_stack+228345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+346086,int_stack+339030,int_stack+335880, 0.0, zero_stack, 1.0, int_stack+257400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+348606,int_stack+346086,int_stack+337140, 0.0, zero_stack, 1.0, int_stack+258660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+346086,int_stack+108828,int_stack+107946, 0.0, zero_stack, 1.0, int_stack+114411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+339030,int_stack+110004,int_stack+108828, 0.0, zero_stack, 1.0, int_stack+115734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+351756,int_stack+339030,int_stack+346086, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+354402,int_stack+3780,int_stack+110004, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+356670,int_stack+354402,int_stack+339030, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+360198,int_stack+356670,int_stack+351756, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+227925,int_stack+227190, 1.0, int_stack+226875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+354402,int_stack+228885,int_stack+227925, 1.0, int_stack+227505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+355662,int_stack+354402,int_stack+3780, 1.0, int_stack+256455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+357552,int_stack+229425,int_stack+228885, 1.0, int_stack+228345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+364608,int_stack+357552,int_stack+354402, 1.0, int_stack+257400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+367128,int_stack+364608,int_stack+355662, 1.0, int_stack+258660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+364608,int_stack+116322,int_stack+114852, 1.0, int_stack+114411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+357552,int_stack+117498,int_stack+116322, 1.0, int_stack+115734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+370278,int_stack+357552,int_stack+364608, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+372924,int_stack+5481,int_stack+117498, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+375192,int_stack+372924,int_stack+357552, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+378720,int_stack+375192,int_stack+370278, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+271935,int_stack+8316,int_stack+228345,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+372924,int_stack+271935,int_stack+257400,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+375444,int_stack+372924,int_stack+258660,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+372924,int_stack+236880,int_stack+236565,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+373869,int_stack+237300,int_stack+236880,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+271935,int_stack+373869,int_stack+372924,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4725,int_stack+237840,int_stack+237300,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+264645,int_stack+4725,int_stack+373869,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+256455,int_stack+264645,int_stack+271935,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+264645,int_stack+146187,int_stack+145305,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+265968,int_stack+147363,int_stack+146187,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+383130,int_stack+265968,int_stack+264645,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+385776,int_stack+6426,int_stack+147363,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+388044,int_stack+385776,int_stack+265968,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+391572,int_stack+388044,int_stack+383130,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+243510,int_stack+243195,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+385776,int_stack+243930,int_stack+243510,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+387036,int_stack+385776,int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+388926,int_stack+244470,int_stack+243930,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+4725,int_stack+388926,int_stack+385776,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+395982,int_stack+4725,int_stack+387036,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4725,int_stack+180732,int_stack+179850,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+388926,int_stack+181908,int_stack+180732,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+388926,int_stack+4725,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+401778,int_stack+7371,int_stack+181908,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+404046,int_stack+401778,int_stack+388926,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+407574,int_stack+404046,int_stack+399132,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+401778,int_stack+250140,int_stack+249825,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+402723,int_stack+250560,int_stack+250140,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+403983,int_stack+402723,int_stack+401778,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+405873,int_stack+251100,int_stack+250560,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6048,int_stack+405873,int_stack+402723,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+411984,int_stack+6048,int_stack+403983,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6048,int_stack+232932,int_stack+232050,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+415134,int_stack+234108,int_stack+232932,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+416898,int_stack+415134,int_stack+6048,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+419544,int_stack+8991,int_stack+234108,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+421812,int_stack+419544,int_stack+415134,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+425340,int_stack+421812,int_stack+416898,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+10251,int_stack+9936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+193725,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420489,int_stack+10671,int_stack+10251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+194040,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+421749,int_stack+420489,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+260550,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423639,int_stack+11211,int_stack+10671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+194460,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7371,int_stack+423639,int_stack+420489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261495,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+429750,int_stack+7371,int_stack+421749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+262755,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7371,int_stack+12327,int_stack+11886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+82086,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8694,int_stack+12915,int_stack+12327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+82968,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+8694,int_stack+7371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+274581,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10458,int_stack+13671,int_stack+12915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+84144,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+432900,int_stack+10458,int_stack+8694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+275904,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7371,int_stack+432900,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+277668,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+14931,int_stack+14616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193725, 1.0, int_stack+200355,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420489,int_stack+15351,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194040, 1.0, int_stack+200670,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+421749,int_stack+420489,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260550, 1.0, int_stack+0,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423639,int_stack+15891,int_stack+15351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194460, 1.0, int_stack+201090,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+432900,int_stack+423639,int_stack+420489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261495, 1.0, int_stack+280314,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+11781,int_stack+432900,int_stack+421749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262755, 1.0, int_stack+281574,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+432900,int_stack+17007,int_stack+16566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82086, 1.0, int_stack+88551,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+434223,int_stack+17595,int_stack+17007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82968, 1.0, int_stack+89433,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+434223,int_stack+432900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274581, 1.0, int_stack+290520,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+422190,int_stack+18351,int_stack+17595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84144, 1.0, int_stack+90609,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+422190,int_stack+434223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275904, 1.0, int_stack+283464,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+432900,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277668, 1.0, int_stack+296190,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+19611,int_stack+19296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+200355, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+420489,int_stack+20031,int_stack+19611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+200670, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+421749,int_stack+420489,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423639,int_stack+20571,int_stack+20031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+201090, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+423639,int_stack+420489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+280314, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17451,int_stack+14931,int_stack+421749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+281574, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14931,int_stack+21687,int_stack+21246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+88551, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+419544,int_stack+22275,int_stack+21687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+89433, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+421308,int_stack+419544,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+290520, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14931,int_stack+23031,int_stack+22275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+90609, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+437310,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+283464, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+440838,int_stack+437310,int_stack+421308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+296190, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+437310,int_stack+24291,int_stack+23976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193725, 0.0, zero_stack, 1.0, int_stack+206985,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+438255,int_stack+24711,int_stack+24291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194040, 0.0, zero_stack, 1.0, int_stack+207300,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+438255,int_stack+437310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260550, 0.0, zero_stack, 1.0, int_stack+945,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+421434,int_stack+25251,int_stack+24711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194460, 0.0, zero_stack, 1.0, int_stack+207720,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+421434,int_stack+438255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261495, 0.0, zero_stack, 1.0, int_stack+298836,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+421434,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262755, 0.0, zero_stack, 1.0, int_stack+300096,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+26367,int_stack+25926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82086, 0.0, zero_stack, 1.0, int_stack+95016,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+26955,int_stack+26367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82968, 0.0, zero_stack, 1.0, int_stack+95898,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+437310,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274581, 0.0, zero_stack, 1.0, int_stack+309042,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20601,int_stack+27711,int_stack+26955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84144, 0.0, zero_stack, 1.0, int_stack+97074,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+22869,int_stack+20601,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275904, 0.0, zero_stack, 1.0, int_stack+301986,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+445248,int_stack+22869,int_stack+437310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277668, 0.0, zero_stack, 1.0, int_stack+314712,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+437310,int_stack+28971,int_stack+28656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200355, 1.0, int_stack+206985, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+438255,int_stack+29391,int_stack+28971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200670, 1.0, int_stack+207300, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+438255,int_stack+437310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+945, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14931,int_stack+29931,int_stack+29391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201090, 1.0, int_stack+207720, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20601,int_stack+14931,int_stack+438255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280314, 1.0, int_stack+298836, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+437310,int_stack+20601,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281574, 1.0, int_stack+300096, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+31047,int_stack+30606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88551, 1.0, int_stack+95016, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20601,int_stack+31635,int_stack+31047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89433, 1.0, int_stack+95898, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+22365,int_stack+20601,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290520, 1.0, int_stack+309042, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+25011,int_stack+32391,int_stack+31635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90609, 1.0, int_stack+97074, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27279,int_stack+25011,int_stack+20601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283464, 1.0, int_stack+301986, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+449658,int_stack+27279,int_stack+22365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296190, 1.0, int_stack+314712, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20601,int_stack+33651,int_stack+33336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+206985, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21546,int_stack+34071,int_stack+33651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+207300, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+21546,int_stack+20601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22806,int_stack+34611,int_stack+34071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+207720, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+22806,int_stack+21546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+298836, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20601,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+300096, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+35727,int_stack+35286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+95016, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+36315,int_stack+35727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+95898, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+23751,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+309042, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+26397,int_stack+37071,int_stack+36315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+97074, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+28665,int_stack+26397,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+301986, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+32193,int_stack+28665,int_stack+23751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+314712, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23751,int_stack+38331,int_stack+38016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+193725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213615,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+24696,int_stack+38751,int_stack+38331, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213930,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+24696,int_stack+23751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1890,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+25956,int_stack+39291,int_stack+38751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214350,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+25956,int_stack+24696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317358,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23751,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318618,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+40407,int_stack+39966, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82086, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101481,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+40995,int_stack+40407, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102363,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+26901,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274581, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327564,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29547,int_stack+41751,int_stack+40995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103539,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+36603,int_stack+29547,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+275904, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320508,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+454068,int_stack+36603,int_stack+26901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+277668, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333234,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26901,int_stack+43011,int_stack+42696, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200355, 0.0, zero_stack, 1.0, int_stack+213615, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27846,int_stack+43431,int_stack+43011, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200670, 0.0, zero_stack, 1.0, int_stack+213930, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+27846,int_stack+26901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+1890, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29106,int_stack+43971,int_stack+43431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+201090, 0.0, zero_stack, 1.0, int_stack+214350, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+29106,int_stack+27846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280314, 0.0, zero_stack, 1.0, int_stack+317358, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+26901,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281574, 0.0, zero_stack, 1.0, int_stack+318618, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+45087,int_stack+44646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88551, 0.0, zero_stack, 1.0, int_stack+101481, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+45675,int_stack+45087, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89433, 0.0, zero_stack, 1.0, int_stack+102363, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+36603,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290520, 0.0, zero_stack, 1.0, int_stack+327564, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+39249,int_stack+46431,int_stack+45675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90609, 0.0, zero_stack, 1.0, int_stack+103539, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41517,int_stack+39249,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283464, 0.0, zero_stack, 1.0, int_stack+320508, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+458478,int_stack+41517,int_stack+36603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296190, 0.0, zero_stack, 1.0, int_stack+333234, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+36603,int_stack+47691,int_stack+47376, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206985, 1.0, int_stack+213615, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+37548,int_stack+48111,int_stack+47691, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207300, 1.0, int_stack+213930, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+37548,int_stack+36603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945, 1.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+38808,int_stack+48651,int_stack+48111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207720, 1.0, int_stack+214350, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+38808,int_stack+37548, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298836, 1.0, int_stack+317358, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36603,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300096, 1.0, int_stack+318618, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+49767,int_stack+49326, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95016, 1.0, int_stack+101481, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+50355,int_stack+49767, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95898, 1.0, int_stack+102363, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+39753,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+309042, 1.0, int_stack+327564, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42399,int_stack+51111,int_stack+50355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97074, 1.0, int_stack+103539, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+44667,int_stack+42399,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301986, 1.0, int_stack+320508, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+462888,int_stack+44667,int_stack+39753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314712, 1.0, int_stack+333234, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+39753,int_stack+52371,int_stack+52056, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+213615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40698,int_stack+52791,int_stack+52371, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+213930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+40698,int_stack+39753, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+41958,int_stack+53331,int_stack+52791, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+214350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+41958,int_stack+40698, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+317358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+39753,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+318618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+54447,int_stack+54006, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+101481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+55035,int_stack+54447, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+102363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+42903,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+327564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+45549,int_stack+55791,int_stack+55035, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+103539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+47817,int_stack+45549,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+320508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+51345,int_stack+47817,int_stack+42903, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+333234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42903,int_stack+57051,int_stack+56736, 0.0, zero_stack, 1.0, int_stack+193725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220245,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+43848,int_stack+57471,int_stack+57051, 0.0, zero_stack, 1.0, int_stack+194040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220560,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+43848,int_stack+42903, 0.0, zero_stack, 1.0, int_stack+260550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+45108,int_stack+58011,int_stack+57471, 0.0, zero_stack, 1.0, int_stack+194460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220980,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+45108,int_stack+43848, 0.0, zero_stack, 1.0, int_stack+261495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335880,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+42903,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+262755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337140,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+59127,int_stack+58686, 0.0, zero_stack, 1.0, int_stack+82086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107946,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+59715,int_stack+59127, 0.0, zero_stack, 1.0, int_stack+82968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108828,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+46053,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+274581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346086,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+48699,int_stack+60471,int_stack+59715, 0.0, zero_stack, 1.0, int_stack+84144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110004,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+55755,int_stack+48699,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+275904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339030,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+467298,int_stack+55755,int_stack+46053, 0.0, zero_stack, 1.0, int_stack+277668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351756,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+46053,int_stack+61731,int_stack+61416, 0.0, zero_stack, 1.0, int_stack+200355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220245, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46998,int_stack+62151,int_stack+61731, 0.0, zero_stack, 1.0, int_stack+200670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220560, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+46998,int_stack+46053, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+48258,int_stack+62691,int_stack+62151, 0.0, zero_stack, 1.0, int_stack+201090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220980, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+48258,int_stack+46998, 0.0, zero_stack, 1.0, int_stack+280314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335880, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+46053,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+281574, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+337140, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+63807,int_stack+63366, 0.0, zero_stack, 1.0, int_stack+88551, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107946, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+64395,int_stack+63807, 0.0, zero_stack, 1.0, int_stack+89433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108828, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+55755,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+290520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346086, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+58401,int_stack+65151,int_stack+64395, 0.0, zero_stack, 1.0, int_stack+90609, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110004, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+60669,int_stack+58401,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+283464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339030, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+471708,int_stack+60669,int_stack+55755, 0.0, zero_stack, 1.0, int_stack+296190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+351756, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55755,int_stack+66411,int_stack+66096, 0.0, zero_stack, 1.0, int_stack+206985, 0.0, zero_stack, 1.0, int_stack+220245, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+56700,int_stack+66831,int_stack+66411, 0.0, zero_stack, 1.0, int_stack+207300, 0.0, zero_stack, 1.0, int_stack+220560, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+56700,int_stack+55755, 0.0, zero_stack, 1.0, int_stack+945, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+57960,int_stack+67371,int_stack+66831, 0.0, zero_stack, 1.0, int_stack+207720, 0.0, zero_stack, 1.0, int_stack+220980, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+57960,int_stack+56700, 0.0, zero_stack, 1.0, int_stack+298836, 0.0, zero_stack, 1.0, int_stack+335880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+55755,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+300096, 0.0, zero_stack, 1.0, int_stack+337140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+68487,int_stack+68046, 0.0, zero_stack, 1.0, int_stack+95016, 0.0, zero_stack, 1.0, int_stack+107946, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+69075,int_stack+68487, 0.0, zero_stack, 1.0, int_stack+95898, 0.0, zero_stack, 1.0, int_stack+108828, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+58905,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+309042, 0.0, zero_stack, 1.0, int_stack+346086, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61551,int_stack+69831,int_stack+69075, 0.0, zero_stack, 1.0, int_stack+97074, 0.0, zero_stack, 1.0, int_stack+110004, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63819,int_stack+61551,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+301986, 0.0, zero_stack, 1.0, int_stack+339030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+476118,int_stack+63819,int_stack+58905, 0.0, zero_stack, 1.0, int_stack+314712, 0.0, zero_stack, 1.0, int_stack+351756, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+58905,int_stack+71091,int_stack+70776, 0.0, zero_stack, 1.0, int_stack+213615, 1.0, int_stack+220245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+59850,int_stack+71511,int_stack+71091, 0.0, zero_stack, 1.0, int_stack+213930, 1.0, int_stack+220560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+59850,int_stack+58905, 0.0, zero_stack, 1.0, int_stack+1890, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61110,int_stack+72051,int_stack+71511, 0.0, zero_stack, 1.0, int_stack+214350, 1.0, int_stack+220980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+61110,int_stack+59850, 0.0, zero_stack, 1.0, int_stack+317358, 1.0, int_stack+335880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+58905,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+318618, 1.0, int_stack+337140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+73167,int_stack+72726, 0.0, zero_stack, 1.0, int_stack+101481, 1.0, int_stack+107946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+73755,int_stack+73167, 0.0, zero_stack, 1.0, int_stack+102363, 1.0, int_stack+108828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+62055,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+327564, 1.0, int_stack+346086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+64701,int_stack+74511,int_stack+73755, 0.0, zero_stack, 1.0, int_stack+103539, 1.0, int_stack+110004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+66969,int_stack+64701,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+320508, 1.0, int_stack+339030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+70497,int_stack+66969,int_stack+62055, 0.0, zero_stack, 1.0, int_stack+333234, 1.0, int_stack+351756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+62055,int_stack+75771,int_stack+75456, 0.0, zero_stack, 2.0, int_stack+220245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+63000,int_stack+76191,int_stack+75771, 0.0, zero_stack, 2.0, int_stack+220560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+63000,int_stack+62055, 0.0, zero_stack, 2.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+64260,int_stack+76731,int_stack+76191, 0.0, zero_stack, 2.0, int_stack+220980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+64260,int_stack+63000, 0.0, zero_stack, 2.0, int_stack+335880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+62055,int_stack+14931,int_stack+419544, 0.0, zero_stack, 2.0, int_stack+337140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+77847,int_stack+77406, 0.0, zero_stack, 2.0, int_stack+107946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+78435,int_stack+77847, 0.0, zero_stack, 2.0, int_stack+108828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+65205,int_stack+14931,int_stack+419544, 0.0, zero_stack, 2.0, int_stack+346086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67851,int_stack+79191,int_stack+78435, 0.0, zero_stack, 2.0, int_stack+110004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+74907,int_stack+67851,int_stack+14931, 0.0, zero_stack, 2.0, int_stack+339030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+480528,int_stack+74907,int_stack+65205, 0.0, zero_stack, 2.0, int_stack+351756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+65205,int_stack+80451,int_stack+80136, 1.0, int_stack+193725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227190,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+66150,int_stack+80871,int_stack+80451, 1.0, int_stack+194040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227925,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+66150,int_stack+65205, 1.0, int_stack+260550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67410,int_stack+81411,int_stack+80871, 1.0, int_stack+194460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228885,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+67410,int_stack+66150, 1.0, int_stack+261495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354402,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65205,int_stack+14931,int_stack+419544, 1.0, int_stack+262755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355662,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+83556,int_stack+82527, 1.0, int_stack+82086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114852,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+84900,int_stack+83556, 1.0, int_stack+82968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116322,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+260550,int_stack+14931,int_stack+419544, 1.0, int_stack+274581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364608,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+85656,int_stack+84900, 1.0, int_stack+84144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117498,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+14931, 1.0, int_stack+275904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357552,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+80703,int_stack+77175,int_stack+260550, 1.0, int_stack+277668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370278,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+260550,int_stack+86916,int_stack+86601, 1.0, int_stack+200355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227190, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+261495,int_stack+87336,int_stack+86916, 1.0, int_stack+200670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227925, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+262755,int_stack+261495,int_stack+260550, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+14931,int_stack+87876,int_stack+87336, 1.0, int_stack+201090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228885, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+74907,int_stack+14931,int_stack+261495, 1.0, int_stack+280314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354402, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+77427,int_stack+74907,int_stack+262755, 1.0, int_stack+281574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355662, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+74907,int_stack+90021,int_stack+88992, 1.0, int_stack+88551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114852, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+91365,int_stack+90021, 1.0, int_stack+89433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116322, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+260550,int_stack+14931,int_stack+74907, 1.0, int_stack+290520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364608, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+290520,int_stack+92121,int_stack+91365, 1.0, int_stack+90609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117498, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85113,int_stack+290520,int_stack+14931, 1.0, int_stack+283464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357552, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+88641,int_stack+85113,int_stack+260550, 1.0, int_stack+296190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370278, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+93381,int_stack+93066, 1.0, int_stack+206985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227190, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+296190,int_stack+93801,int_stack+93381, 1.0, int_stack+207300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227925, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+296190,int_stack+0, 1.0, int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+94341,int_stack+93801, 1.0, int_stack+207720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228885, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+0,int_stack+296190, 1.0, int_stack+298836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354402, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+296190,int_stack+14931,int_stack+419544, 1.0, int_stack+300096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355662, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+96486,int_stack+95457, 1.0, int_stack+95016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114852, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+97830,int_stack+96486, 1.0, int_stack+95898, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116322, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+299340,int_stack+14931,int_stack+419544, 1.0, int_stack+309042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364608, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+309042,int_stack+98586,int_stack+97830, 1.0, int_stack+97074, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+117498, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85113,int_stack+309042,int_stack+14931, 1.0, int_stack+301986, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357552, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+93051,int_stack+85113,int_stack+299340, 1.0, int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+370278, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+99846,int_stack+99531, 1.0, int_stack+213615, 0.0, zero_stack, 1.0, int_stack+227190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+100266,int_stack+99846, 1.0, int_stack+213930, 0.0, zero_stack, 1.0, int_stack+227925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 1.0, int_stack+1890, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+299340,int_stack+100806,int_stack+100266, 1.0, int_stack+214350, 0.0, zero_stack, 1.0, int_stack+228885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+299340,int_stack+315657, 1.0, int_stack+317358, 0.0, zero_stack, 1.0, int_stack+354402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+299340,int_stack+14931,int_stack+419544, 1.0, int_stack+318618, 0.0, zero_stack, 1.0, int_stack+355662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+102951,int_stack+101922, 1.0, int_stack+101481, 0.0, zero_stack, 1.0, int_stack+114852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+104295,int_stack+102951, 1.0, int_stack+102363, 0.0, zero_stack, 1.0, int_stack+116322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 1.0, int_stack+327564, 0.0, zero_stack, 1.0, int_stack+364608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+327564,int_stack+105051,int_stack+104295, 1.0, int_stack+103539, 0.0, zero_stack, 1.0, int_stack+117498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85113,int_stack+327564,int_stack+14931, 1.0, int_stack+320508, 0.0, zero_stack, 1.0, int_stack+357552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+317358,int_stack+85113,int_stack+314712, 1.0, int_stack+333234, 0.0, zero_stack, 1.0, int_stack+370278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+333234,int_stack+106311,int_stack+105996, 1.0, int_stack+220245, 1.0, int_stack+227190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+334179,int_stack+106731,int_stack+106311, 1.0, int_stack+220560, 1.0, int_stack+227925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+334179,int_stack+333234, 1.0, int_stack+2835, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+107271,int_stack+106731, 1.0, int_stack+220980, 1.0, int_stack+228885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+314712,int_stack+334179, 1.0, int_stack+335880, 1.0, int_stack+354402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+333234,int_stack+14931,int_stack+419544, 1.0, int_stack+337140, 1.0, int_stack+355662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+109416,int_stack+108387, 1.0, int_stack+107946, 1.0, int_stack+114852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+110760,int_stack+109416, 1.0, int_stack+108828, 1.0, int_stack+116322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 1.0, int_stack+346086, 1.0, int_stack+364608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+346086,int_stack+111516,int_stack+110760, 1.0, int_stack+110004, 1.0, int_stack+117498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85113,int_stack+346086,int_stack+14931, 1.0, int_stack+339030, 1.0, int_stack+357552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+336384,int_stack+85113,int_stack+314712, 1.0, int_stack+351756, 1.0, int_stack+370278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+351756,int_stack+112776,int_stack+112461, 2.0, int_stack+227190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+352701,int_stack+113196,int_stack+112776, 2.0, int_stack+227925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+352701,int_stack+351756, 2.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+113736,int_stack+113196, 2.0, int_stack+228885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+314712,int_stack+352701, 2.0, int_stack+354402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+351756,int_stack+14931,int_stack+419544, 2.0, int_stack+355662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+116910,int_stack+115293, 2.0, int_stack+114852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+118254,int_stack+116910, 2.0, int_stack+116322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 2.0, int_stack+364608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+364608,int_stack+119010,int_stack+118254, 2.0, int_stack+117498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+85113,int_stack+364608,int_stack+14931, 2.0, int_stack+357552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+354906,int_stack+85113,int_stack+314712, 2.0, int_stack+370278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+370278,int_stack+120270,int_stack+119955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236565,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+371223,int_stack+120690,int_stack+120270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236880,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+371223,int_stack+370278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372924,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+121230,int_stack+120690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237300,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+314712,int_stack+371223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373869,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+85113,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+122346,int_stack+121905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145305,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+122934,int_stack+122346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146187,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370278,int_stack+123690,int_stack+122934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147363,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+370278,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+97461,int_stack+0,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383130,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+124950,int_stack+124635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236565, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+125370,int_stack+124950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236880, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372924, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+125910,int_stack+125370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237300, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+0,int_stack+315657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373869, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+127026,int_stack+126585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145305, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+127614,int_stack+127026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146187, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370278,int_stack+128370,int_stack+127614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147363, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+260550,int_stack+370278,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+101871,int_stack+260550,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383130, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+129630,int_stack+129315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236565, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+130050,int_stack+129630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372924, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+260550,int_stack+130590,int_stack+130050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237300, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+260550,int_stack+315657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373869, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+260550,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+131706,int_stack+131265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145305, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+132294,int_stack+131706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146187, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370278,int_stack+133050,int_stack+132294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147363, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+106281,int_stack+370278,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+109809,int_stack+106281,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383130, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+263700,int_stack+134310,int_stack+133995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+314712,int_stack+134730,int_stack+134310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+314712,int_stack+263700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+106281,int_stack+135270,int_stack+134730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+106281,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+106281,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+136386,int_stack+135945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+145305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+136974,int_stack+136386, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+146187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370278,int_stack+137730,int_stack+136974, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+114219,int_stack+370278,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+117747,int_stack+114219,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+263700,int_stack+138990,int_stack+138675, 0.0, zero_stack, 1.0, int_stack+236565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+314712,int_stack+139410,int_stack+138990, 0.0, zero_stack, 1.0, int_stack+236880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+314712,int_stack+263700, 0.0, zero_stack, 1.0, int_stack+372924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+114219,int_stack+139950,int_stack+139410, 0.0, zero_stack, 1.0, int_stack+237300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+114219,int_stack+314712, 0.0, zero_stack, 1.0, int_stack+373869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+114219,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+141066,int_stack+140625, 0.0, zero_stack, 1.0, int_stack+145305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+141654,int_stack+141066, 0.0, zero_stack, 1.0, int_stack+146187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370278,int_stack+142410,int_stack+141654, 0.0, zero_stack, 1.0, int_stack+147363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122157,int_stack+370278,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+125685,int_stack+122157,int_stack+314712, 0.0, zero_stack, 1.0, int_stack+383130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+263700,int_stack+143670,int_stack+143355, 1.0, int_stack+236565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+314712,int_stack+144090,int_stack+143670, 1.0, int_stack+236880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+314712,int_stack+263700, 1.0, int_stack+372924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+122157,int_stack+144630,int_stack+144090, 1.0, int_stack+237300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+122157,int_stack+314712, 1.0, int_stack+373869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+122157,int_stack+14931,int_stack+419544, 1.0, int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271935,int_stack+146775,int_stack+145746, 1.0, int_stack+145305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+273258,int_stack+148119,int_stack+146775, 1.0, int_stack+146187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+273258,int_stack+271935, 1.0, int_stack+264645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+263700,int_stack+148875,int_stack+148119, 1.0, int_stack+147363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+275022,int_stack+263700,int_stack+273258, 1.0, int_stack+265968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+263700,int_stack+275022,int_stack+314712, 1.0, int_stack+383130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+383130,int_stack+150135,int_stack+149820,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+384075,int_stack+150555,int_stack+150135,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+384075,int_stack+383130,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+151095,int_stack+150555,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+314712,int_stack+384075,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+271935,int_stack+14931,int_stack+419544,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+152211,int_stack+151770,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+152799,int_stack+152211,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+153555,int_stack+152799,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+275085,int_stack+383130,int_stack+14931,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+278613,int_stack+275085,int_stack+314712,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+154815,int_stack+154500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243195,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+155235,int_stack+154815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243510,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+275085,int_stack+155775,int_stack+155235, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243930,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+275085,int_stack+315657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385776,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+275085,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387036,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+156891,int_stack+156450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179850,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+157479,int_stack+156891, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180732,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+158235,int_stack+157479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181908,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+370278,int_stack+383130,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388926,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+130095,int_stack+370278,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399132,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+159495,int_stack+159180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243195, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+159915,int_stack+159495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243510, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259605, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+370278,int_stack+160455,int_stack+159915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243930, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+370278,int_stack+315657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385776, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+370278,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387036, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+161571,int_stack+161130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179850, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+162159,int_stack+161571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180732, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+162915,int_stack+162159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181908, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+134505,int_stack+383130,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388926, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+138033,int_stack+134505,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399132, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+164175,int_stack+163860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243195, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+164595,int_stack+164175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243510, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259605, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+134505,int_stack+165135,int_stack+164595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243930, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+134505,int_stack+315657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385776, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+134505,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387036, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+166251,int_stack+165810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179850, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+166839,int_stack+166251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180732, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+167595,int_stack+166839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181908, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+142443,int_stack+383130,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388926, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+145971,int_stack+142443,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399132, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+168855,int_stack+168540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+169275,int_stack+168855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+142443,int_stack+169815,int_stack+169275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+142443,int_stack+315657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+385776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+142443,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+387036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+170931,int_stack+170490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+171519,int_stack+170931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+172275,int_stack+171519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+181908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+150381,int_stack+383130,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+153909,int_stack+150381,int_stack+314712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+173535,int_stack+173220, 0.0, zero_stack, 1.0, int_stack+243195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+173955,int_stack+173535, 0.0, zero_stack, 1.0, int_stack+243510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 0.0, zero_stack, 1.0, int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+150381,int_stack+174495,int_stack+173955, 0.0, zero_stack, 1.0, int_stack+243930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+150381,int_stack+315657, 0.0, zero_stack, 1.0, int_stack+385776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+150381,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+387036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+175611,int_stack+175170, 0.0, zero_stack, 1.0, int_stack+179850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+176199,int_stack+175611, 0.0, zero_stack, 1.0, int_stack+180732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+176955,int_stack+176199, 0.0, zero_stack, 1.0, int_stack+181908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+158319,int_stack+383130,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+388926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+161847,int_stack+158319,int_stack+314712, 0.0, zero_stack, 1.0, int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+314712,int_stack+178215,int_stack+177900, 1.0, int_stack+243195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+315657,int_stack+178635,int_stack+178215, 1.0, int_stack+243510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+315657,int_stack+314712, 1.0, int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+158319,int_stack+179175,int_stack+178635, 1.0, int_stack+243930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+158319,int_stack+315657, 1.0, int_stack+385776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+158319,int_stack+14931,int_stack+419544, 1.0, int_stack+387036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+181320,int_stack+180291, 1.0, int_stack+179850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+182664,int_stack+181320, 1.0, int_stack+180732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 1.0, int_stack+4725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+383130,int_stack+183420,int_stack+182664, 1.0, int_stack+181908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+385398,int_stack+383130,int_stack+14931, 1.0, int_stack+388926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+166257,int_stack+385398,int_stack+314712, 1.0, int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+184680,int_stack+184365,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+185100,int_stack+184680,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+185640,int_stack+185100,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+314712,int_stack+399132,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+383130,int_stack+14931,int_stack+419544,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+186756,int_stack+186315,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+187344,int_stack+186756,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+188100,int_stack+187344,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+386280,int_stack+314712,int_stack+14931,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+170667,int_stack+386280,int_stack+399132,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+189360,int_stack+189045,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+189780,int_stack+189360,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+386280,int_stack+190320,int_stack+189780,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+386280,int_stack+399132,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+386280,int_stack+14931,int_stack+419544,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+191436,int_stack+190995,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+192024,int_stack+191436,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+192780,int_stack+192024,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+175077,int_stack+314712,int_stack+14931,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+178605,int_stack+175077,int_stack+399132,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+195990,int_stack+195675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249825,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+196410,int_stack+195990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250140,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401778,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+175077,int_stack+196950,int_stack+196410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250560,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+175077,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402723,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+175077,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403983,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+198066,int_stack+197625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232050,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+198654,int_stack+198066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232932,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6048,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+199410,int_stack+198654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234108,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+183015,int_stack+314712,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415134,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+186543,int_stack+183015,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416898,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+202620,int_stack+202305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249825, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+203040,int_stack+202620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250140, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401778, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+183015,int_stack+203580,int_stack+203040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250560, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+183015,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402723, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+183015,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403983, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+204696,int_stack+204255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232050, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+205284,int_stack+204696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232932, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6048, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+206040,int_stack+205284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234108, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+190953,int_stack+314712,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415134, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+194481,int_stack+190953,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416898, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+209250,int_stack+208935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249825, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+209670,int_stack+209250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401778, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+190953,int_stack+210210,int_stack+209670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250560, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+190953,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402723, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+190953,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403983, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+211326,int_stack+210885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232050, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+211914,int_stack+211326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232932, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6048, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+212670,int_stack+211914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234108, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+198891,int_stack+314712,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415134, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+202419,int_stack+198891,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416898, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+215880,int_stack+215565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+216300,int_stack+215880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+401778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+198891,int_stack+216840,int_stack+216300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+250560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+198891,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+198891,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+403983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+217956,int_stack+217515, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+218544,int_stack+217956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+219300,int_stack+218544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+206829,int_stack+314712,int_stack+14931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+210357,int_stack+206829,int_stack+399132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+416898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+222510,int_stack+222195, 0.0, zero_stack, 1.0, int_stack+249825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+222930,int_stack+222510, 0.0, zero_stack, 1.0, int_stack+250140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605, 0.0, zero_stack, 1.0, int_stack+401778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+206829,int_stack+223470,int_stack+222930, 0.0, zero_stack, 1.0, int_stack+250560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+206829,int_stack+399132, 0.0, zero_stack, 1.0, int_stack+402723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+206829,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+403983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+224586,int_stack+224145, 0.0, zero_stack, 1.0, int_stack+232050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+225174,int_stack+224586, 0.0, zero_stack, 1.0, int_stack+232932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544, 0.0, zero_stack, 1.0, int_stack+6048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+314712,int_stack+225930,int_stack+225174, 0.0, zero_stack, 1.0, int_stack+234108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+214767,int_stack+314712,int_stack+14931, 0.0, zero_stack, 1.0, int_stack+415134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+218295,int_stack+214767,int_stack+399132, 0.0, zero_stack, 1.0, int_stack+416898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+230415,int_stack+230100, 1.0, int_stack+249825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+399132,int_stack+230835,int_stack+230415, 1.0, int_stack+250140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+419544,int_stack+399132,int_stack+259605, 1.0, int_stack+401778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+400392,int_stack+231375,int_stack+230835, 1.0, int_stack+250560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+400392,int_stack+399132, 1.0, int_stack+402723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+399132,int_stack+14931,int_stack+419544, 1.0, int_stack+403983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419544,int_stack+233520,int_stack+232491, 1.0, int_stack+232050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14931,int_stack+234864,int_stack+233520, 1.0, int_stack+232932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+14931,int_stack+419544, 1.0, int_stack+6048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+402282,int_stack+235620,int_stack+234864, 1.0, int_stack+234108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+214767,int_stack+402282,int_stack+14931, 1.0, int_stack+415134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+402282,int_stack+214767,int_stack+314712, 1.0, int_stack+416898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+238830,int_stack+238515,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+314712,int_stack+239250,int_stack+238830,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+214767,int_stack+314712,int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+216657,int_stack+239790,int_stack+239250,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+216657,int_stack+314712,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+415134,int_stack+14931,int_stack+214767,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+214767,int_stack+240906,int_stack+240465,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+216090,int_stack+241494,int_stack+240906,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+216090,int_stack+214767,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14931,int_stack+242250,int_stack+241494,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3150,int_stack+14931,int_stack+216090,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+222705,int_stack+3150,int_stack+314712,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+245460,int_stack+245145,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+314712,int_stack+245880,int_stack+245460,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3150,int_stack+314712,int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+5040,int_stack+246420,int_stack+245880,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+5040,int_stack+314712,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+418284,int_stack+14931,int_stack+3150,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3150,int_stack+247536,int_stack+247095,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4473,int_stack+248124,int_stack+247536,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+4473,int_stack+3150,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14931,int_stack+248880,int_stack+248124,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+214767,int_stack+14931,int_stack+4473,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+227115,int_stack+214767,int_stack+314712,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259605,int_stack+252090,int_stack+251775,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+314712,int_stack+252510,int_stack+252090,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+214767,int_stack+314712,int_stack+259605,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+216657,int_stack+253050,int_stack+252510,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14931,int_stack+216657,int_stack+314712,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3150,int_stack+14931,int_stack+214767,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+214767,int_stack+254166,int_stack+253725,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+216090,int_stack+254754,int_stack+254166,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+314712,int_stack+216090,int_stack+214767,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14931,int_stack+255510,int_stack+254754,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+231525,int_stack+14931,int_stack+216090,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+235053,int_stack+231525,int_stack+314712,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+239463,int_stack+286110,int_stack+268785,210);
     Libderiv->ABCD[11] = int_stack + 239463;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+283023,int_stack+304632,int_stack+293040,210);
     Libderiv->ABCD[10] = int_stack + 283023;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+484938,int_stack+323154,int_stack+311562,210);
     Libderiv->ABCD[9] = int_stack + 484938;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+494388,int_stack+341676,int_stack+330084,210);
     Libderiv->ABCD[8] = int_stack + 494388;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+503838,int_stack+360198,int_stack+348606,210);
     Libderiv->ABCD[7] = int_stack + 503838;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+513288,int_stack+378720,int_stack+367128,210);
     Libderiv->ABCD[6] = int_stack + 513288;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+522738,int_stack+391572,int_stack+256455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[2] = int_stack + 522738;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+532188,int_stack+407574,int_stack+395982, 0.0, zero_stack, 1.0, int_stack+375444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[1] = int_stack + 532188;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+541638,int_stack+425340,int_stack+411984, 1.0, int_stack+375444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[0] = int_stack + 541638;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+373428,int_stack+7371,int_stack+429750,210);
     Libderiv->ABCD[155] = int_stack + 373428;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+551088,int_stack+432900,int_stack+11781,210);
     Libderiv->ABCD[143] = int_stack + 551088;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+6300,int_stack+440838,int_stack+17451,210);
     Libderiv->ABCD[142] = int_stack + 6300;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+424584,int_stack+445248,int_stack+421434,210);
     Libderiv->ABCD[131] = int_stack + 424584;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+560538,int_stack+449658,int_stack+437310,210);
     Libderiv->ABCD[130] = int_stack + 560538;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+434034,int_stack+32193,int_stack+20601,210);
     Libderiv->ABCD[129] = int_stack + 434034;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+443484,int_stack+454068,int_stack+23751,210);
     Libderiv->ABCD[119] = int_stack + 443484;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+15750,int_stack+458478,int_stack+26901,210);
     Libderiv->ABCD[118] = int_stack + 15750;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+25200,int_stack+462888,int_stack+36603,210);
     Libderiv->ABCD[117] = int_stack + 25200;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+452934,int_stack+51345,int_stack+39753,210);
     Libderiv->ABCD[116] = int_stack + 452934;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+569988,int_stack+467298,int_stack+42903,210);
     Libderiv->ABCD[107] = int_stack + 569988;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+34650,int_stack+471708,int_stack+46053,210);
     Libderiv->ABCD[106] = int_stack + 34650;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+44100,int_stack+476118,int_stack+55755,210);
     Libderiv->ABCD[105] = int_stack + 44100;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+462384,int_stack+70497,int_stack+58905,210);
     Libderiv->ABCD[104] = int_stack + 462384;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+579438,int_stack+480528,int_stack+62055,210);
     Libderiv->ABCD[103] = int_stack + 579438;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+53550,int_stack+80703,int_stack+65205,210);
     Libderiv->ABCD[95] = int_stack + 53550;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+63000,int_stack+88641,int_stack+77427,210);
     Libderiv->ABCD[94] = int_stack + 63000;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+72450,int_stack+93051,int_stack+296190,210);
     Libderiv->ABCD[93] = int_stack + 72450;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+471834,int_stack+317358,int_stack+299340,210);
     Libderiv->ABCD[92] = int_stack + 471834;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+296190,int_stack+336384,int_stack+333234,210);
     Libderiv->ABCD[91] = int_stack + 296190;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+333234,int_stack+354906,int_stack+351756,210);
     Libderiv->ABCD[90] = int_stack + 333234;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+351756,int_stack+97461,int_stack+85113, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[47] = int_stack + 351756;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+314712,int_stack+101871,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[46] = int_stack + 314712;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+81900,int_stack+109809,int_stack+260550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[45] = int_stack + 81900;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+91350,int_stack+117747,int_stack+106281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[44] = int_stack + 91350;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+100800,int_stack+125685,int_stack+114219, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[43] = int_stack + 100800;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+110250,int_stack+263700,int_stack+122157, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+367128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[42] = int_stack + 110250;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+119700,int_stack+278613,int_stack+271935, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+256455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[38] = int_stack + 119700;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+588888,int_stack+130095,int_stack+275085, 0.0, zero_stack, 1.0, int_stack+268785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[35] = int_stack + 588888;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+271935,int_stack+138033,int_stack+370278, 0.0, zero_stack, 1.0, int_stack+293040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[34] = int_stack + 271935;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+598338,int_stack+145971,int_stack+134505, 0.0, zero_stack, 1.0, int_stack+311562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[33] = int_stack + 598338;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+129150,int_stack+153909,int_stack+142443, 0.0, zero_stack, 1.0, int_stack+330084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[32] = int_stack + 129150;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+138600,int_stack+161847,int_stack+150381, 0.0, zero_stack, 1.0, int_stack+348606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[31] = int_stack + 138600;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+148050,int_stack+166257,int_stack+158319, 0.0, zero_stack, 1.0, int_stack+367128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[30] = int_stack + 148050;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+157500,int_stack+170667,int_stack+383130, 0.0, zero_stack, 1.0, int_stack+256455, 1.0, int_stack+395982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[26] = int_stack + 157500;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+607788,int_stack+178605,int_stack+386280, 0.0, zero_stack, 2.0, int_stack+395982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[25] = int_stack + 607788;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+382878,int_stack+186543,int_stack+175077, 1.0, int_stack+268785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[23] = int_stack + 382878;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+259605,int_stack+194481,int_stack+183015, 1.0, int_stack+293040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[22] = int_stack + 259605;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+166950,int_stack+202419,int_stack+190953, 1.0, int_stack+311562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[21] = int_stack + 166950;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+176400,int_stack+210357,int_stack+198891, 1.0, int_stack+330084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[20] = int_stack + 176400;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+185850,int_stack+218295,int_stack+206829, 1.0, int_stack+348606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[19] = int_stack + 185850;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+195300,int_stack+402282,int_stack+399132, 1.0, int_stack+367128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[18] = int_stack + 195300;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+399132,int_stack+222705,int_stack+415134, 1.0, int_stack+256455, 0.0, zero_stack, 1.0, int_stack+411984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[14] = int_stack + 399132;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+361206,int_stack+227115,int_stack+418284, 1.0, int_stack+395982, 1.0, int_stack+411984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[13] = int_stack + 361206;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+415134,int_stack+235053,int_stack+3150, 2.0, int_stack+411984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[12] = int_stack + 415134;

}
