/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_h0hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|hg) integrals */

void d12hrr_order_h0hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][9][11] = int_stack + 0;
 Libderiv->deriv_classes[5][9][10] = int_stack + 1155;
 Libderiv->deriv_classes[5][9][9] = int_stack + 2310;
 Libderiv->deriv_classes[5][9][8] = int_stack + 3465;
 Libderiv->deriv_classes[5][9][7] = int_stack + 4620;
 Libderiv->dvrr_classes[5][8] = int_stack + 5775;
 Libderiv->deriv_classes[5][9][6] = int_stack + 6720;
 Libderiv->deriv_classes[5][9][2] = int_stack + 7875;
 Libderiv->deriv_classes[5][9][1] = int_stack + 9030;
 Libderiv->deriv_classes[5][9][0] = int_stack + 10185;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 11340;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 11781;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 12369;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 13125;
 Libderiv->deriv2_classes[5][9][143] = int_stack + 14070;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 15225;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 15666;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 16254;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 17010;
 Libderiv->deriv2_classes[5][9][131] = int_stack + 17955;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 19110;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 19551;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 20139;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 20895;
 Libderiv->deriv2_classes[5][9][130] = int_stack + 21840;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 22995;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 23436;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 24024;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 24780;
 Libderiv->deriv2_classes[5][9][119] = int_stack + 25725;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 26880;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 27321;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 27909;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 28665;
 Libderiv->deriv2_classes[5][9][118] = int_stack + 29610;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 30765;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 31206;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 31794;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 32550;
 Libderiv->deriv2_classes[5][9][117] = int_stack + 33495;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 34650;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 35091;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 35679;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 36435;
 Libderiv->deriv2_classes[5][9][107] = int_stack + 37380;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 38535;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 38976;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 39564;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 40320;
 Libderiv->deriv2_classes[5][9][106] = int_stack + 41265;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 42420;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 42861;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 43449;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 44205;
 Libderiv->deriv2_classes[5][9][105] = int_stack + 45150;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 46305;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 46746;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 47334;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 48090;
 Libderiv->deriv2_classes[5][9][104] = int_stack + 49035;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 50190;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 50631;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 51219;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 51975;
 Libderiv->deriv2_classes[5][9][95] = int_stack + 52920;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 54075;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 54516;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 55104;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 55860;
 Libderiv->deriv2_classes[5][9][94] = int_stack + 56805;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 57960;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 58401;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 58989;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 59745;
 Libderiv->deriv2_classes[5][9][93] = int_stack + 60690;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 61845;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 62286;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 62874;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 63630;
 Libderiv->deriv2_classes[5][9][92] = int_stack + 64575;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 65730;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 66171;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 66759;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 67515;
 Libderiv->deriv2_classes[5][9][91] = int_stack + 68460;
 Libderiv->deriv_classes[5][5][11] = int_stack + 69615;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 70056;
 Libderiv->deriv_classes[5][6][11] = int_stack + 70497;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 71085;
 Libderiv->deriv_classes[5][7][11] = int_stack + 71673;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 72429;
 Libderiv->deriv_classes[5][8][11] = int_stack + 73185;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 74130;
 Libderiv->deriv2_classes[5][9][83] = int_stack + 75075;
 Libderiv->deriv_classes[5][5][10] = int_stack + 76230;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 76671;
 Libderiv->deriv_classes[5][6][10] = int_stack + 77112;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 77700;
 Libderiv->deriv_classes[5][7][10] = int_stack + 78288;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 79044;
 Libderiv->deriv_classes[5][8][10] = int_stack + 79800;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 80745;
 Libderiv->deriv2_classes[5][9][82] = int_stack + 81690;
 Libderiv->deriv_classes[5][5][9] = int_stack + 82845;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 83286;
 Libderiv->deriv_classes[5][6][9] = int_stack + 83727;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 84315;
 Libderiv->deriv_classes[5][7][9] = int_stack + 84903;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 85659;
 Libderiv->deriv_classes[5][8][9] = int_stack + 86415;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 87360;
 Libderiv->deriv2_classes[5][9][81] = int_stack + 88305;
 Libderiv->deriv_classes[5][5][8] = int_stack + 89460;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 89901;
 Libderiv->deriv_classes[5][6][8] = int_stack + 90342;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 90930;
 Libderiv->deriv_classes[5][7][8] = int_stack + 91518;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 92274;
 Libderiv->deriv_classes[5][8][8] = int_stack + 93030;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 93975;
 Libderiv->deriv2_classes[5][9][80] = int_stack + 94920;
 Libderiv->deriv_classes[5][5][7] = int_stack + 96075;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 96516;
 Libderiv->deriv_classes[5][6][7] = int_stack + 96957;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 97545;
 Libderiv->deriv_classes[5][7][7] = int_stack + 98133;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 98889;
 Libderiv->deriv_classes[5][8][7] = int_stack + 99645;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 100590;
 Libderiv->deriv2_classes[5][9][79] = int_stack + 101535;
 Libderiv->dvrr_classes[5][5] = int_stack + 102690;
 Libderiv->deriv_classes[5][5][6] = int_stack + 103131;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 103572;
 Libderiv->dvrr_classes[5][6] = int_stack + 104013;
 Libderiv->deriv_classes[5][6][6] = int_stack + 104601;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 105189;
 Libderiv->dvrr_classes[5][7] = int_stack + 105777;
 Libderiv->deriv_classes[5][7][6] = int_stack + 106533;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 107289;
 Libderiv->deriv_classes[5][8][6] = int_stack + 108045;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 108990;
 Libderiv->deriv2_classes[5][9][78] = int_stack + 109935;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 111090;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 111531;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 112119;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 112875;
 Libderiv->deriv2_classes[5][9][35] = int_stack + 113820;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 114975;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 115416;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 116004;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 116760;
 Libderiv->deriv2_classes[5][9][34] = int_stack + 117705;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 118860;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 119301;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 119889;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 120645;
 Libderiv->deriv2_classes[5][9][33] = int_stack + 121590;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 122745;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 123186;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 123774;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 124530;
 Libderiv->deriv2_classes[5][9][32] = int_stack + 125475;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 126630;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 127071;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 127659;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 128415;
 Libderiv->deriv2_classes[5][9][31] = int_stack + 129360;
 Libderiv->deriv_classes[5][5][2] = int_stack + 130515;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 130956;
 Libderiv->deriv_classes[5][6][2] = int_stack + 131397;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 131985;
 Libderiv->deriv_classes[5][7][2] = int_stack + 132573;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 133329;
 Libderiv->deriv_classes[5][8][2] = int_stack + 134085;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 135030;
 Libderiv->deriv2_classes[5][9][30] = int_stack + 135975;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 137130;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 137571;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 138159;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 138915;
 Libderiv->deriv2_classes[5][9][26] = int_stack + 139860;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 141015;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 141456;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 142044;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 142800;
 Libderiv->deriv2_classes[5][9][23] = int_stack + 143745;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 144900;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 145341;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 145929;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 146685;
 Libderiv->deriv2_classes[5][9][22] = int_stack + 147630;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 148785;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 149226;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 149814;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 150570;
 Libderiv->deriv2_classes[5][9][21] = int_stack + 151515;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 152670;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 153111;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 153699;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 154455;
 Libderiv->deriv2_classes[5][9][20] = int_stack + 155400;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 156555;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 156996;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 157584;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 158340;
 Libderiv->deriv2_classes[5][9][19] = int_stack + 159285;
 Libderiv->deriv_classes[5][5][1] = int_stack + 160440;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 160881;
 Libderiv->deriv_classes[5][6][1] = int_stack + 161322;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 161910;
 Libderiv->deriv_classes[5][7][1] = int_stack + 162498;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 163254;
 Libderiv->deriv_classes[5][8][1] = int_stack + 164010;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 164955;
 Libderiv->deriv2_classes[5][9][18] = int_stack + 165900;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 167055;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 167496;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 168084;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 168840;
 Libderiv->deriv2_classes[5][9][14] = int_stack + 169785;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 170940;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 171381;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 171969;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 172725;
 Libderiv->deriv2_classes[5][9][13] = int_stack + 173670;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 174825;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 175266;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 175854;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 176610;
 Libderiv->deriv2_classes[5][9][11] = int_stack + 177555;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 178710;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 179151;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 179739;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 180495;
 Libderiv->deriv2_classes[5][9][10] = int_stack + 181440;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 182595;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 183036;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 183624;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 184380;
 Libderiv->deriv2_classes[5][9][9] = int_stack + 185325;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 186480;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 186921;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 187509;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 188265;
 Libderiv->deriv2_classes[5][9][8] = int_stack + 189210;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 190365;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 190806;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 191394;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 192150;
 Libderiv->deriv2_classes[5][9][7] = int_stack + 193095;
 Libderiv->deriv_classes[5][5][0] = int_stack + 194250;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 194691;
 Libderiv->deriv_classes[5][6][0] = int_stack + 195132;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 195720;
 Libderiv->deriv_classes[5][7][0] = int_stack + 196308;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 197064;
 Libderiv->deriv_classes[5][8][0] = int_stack + 197820;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 198765;
 Libderiv->deriv2_classes[5][9][6] = int_stack + 199710;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 200865;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 201306;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 201894;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 202650;
 Libderiv->deriv2_classes[5][9][2] = int_stack + 203595;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 204750;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 205191;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 205779;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 206535;
 Libderiv->deriv2_classes[5][9][1] = int_stack + 207480;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 208635;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 209076;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 209664;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 210420;
 Libderiv->deriv2_classes[5][9][0] = int_stack + 211365;
 memset(int_stack,0,1700160);

 Libderiv->dvrr_stack = int_stack + 629748;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_h0hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+212520,int_stack+104013,int_stack+102690,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+213843,int_stack+105777,int_stack+104013,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+215607,int_stack+213843,int_stack+212520,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+218253,int_stack+5775,int_stack+105777,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+220521,int_stack+218253,int_stack+213843,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+224049,int_stack+220521,int_stack+215607,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228459,int_stack+70497,int_stack+69615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102690,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+229782,int_stack+71673,int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104013,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+231546,int_stack+229782,int_stack+228459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212520,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+234192,int_stack+73185,int_stack+71673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105777,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+236460,int_stack+234192,int_stack+229782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213843,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+239988,int_stack+236460,int_stack+231546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215607,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+244398,int_stack+0,int_stack+73185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+247233,int_stack+244398,int_stack+234192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218253,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+251769,int_stack+247233,int_stack+236460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220521,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+244398,int_stack+77112,int_stack+76230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102690, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+245721,int_stack+78288,int_stack+77112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104013, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+247485,int_stack+245721,int_stack+244398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212520, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+257649,int_stack+79800,int_stack+78288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105777, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+259917,int_stack+257649,int_stack+245721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213843, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+263445,int_stack+259917,int_stack+247485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215607, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+267855,int_stack+1155,int_stack+79800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+270690,int_stack+267855,int_stack+257649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218253, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+275226,int_stack+270690,int_stack+259917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220521, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+267855,int_stack+83727,int_stack+82845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269178,int_stack+84903,int_stack+83727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104013, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+270942,int_stack+269178,int_stack+267855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212520, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+86415,int_stack+84903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105777, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+0,int_stack+269178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213843, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+284634,int_stack+281106,int_stack+270942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215607, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+289044,int_stack+2310,int_stack+86415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+291879,int_stack+289044,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218253, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+296415,int_stack+291879,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220521, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+289044,int_stack+90342,int_stack+89460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+290367,int_stack+91518,int_stack+90342, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+292131,int_stack+290367,int_stack+289044, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+302295,int_stack+93030,int_stack+91518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+304563,int_stack+302295,int_stack+290367, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+213843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+308091,int_stack+304563,int_stack+292131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+215607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+312501,int_stack+3465,int_stack+93030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+315336,int_stack+312501,int_stack+302295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+319872,int_stack+315336,int_stack+304563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+220521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+312501,int_stack+96957,int_stack+96075, 0.0, zero_stack, 1.0, int_stack+102690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+313824,int_stack+98133,int_stack+96957, 0.0, zero_stack, 1.0, int_stack+104013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+315588,int_stack+313824,int_stack+312501, 0.0, zero_stack, 1.0, int_stack+212520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2268,int_stack+99645,int_stack+98133, 0.0, zero_stack, 1.0, int_stack+105777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+2268,int_stack+313824, 0.0, zero_stack, 1.0, int_stack+213843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+329280,int_stack+325752,int_stack+315588, 0.0, zero_stack, 1.0, int_stack+215607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+333690,int_stack+4620,int_stack+99645, 0.0, zero_stack, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+336525,int_stack+333690,int_stack+2268, 0.0, zero_stack, 1.0, int_stack+218253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+341061,int_stack+336525,int_stack+325752, 0.0, zero_stack, 1.0, int_stack+220521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+333690,int_stack+104601,int_stack+103131, 1.0, int_stack+102690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+335013,int_stack+106533,int_stack+104601, 1.0, int_stack+104013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+336777,int_stack+335013,int_stack+333690, 1.0, int_stack+212520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+346941,int_stack+108045,int_stack+106533, 1.0, int_stack+105777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+349209,int_stack+346941,int_stack+335013, 1.0, int_stack+213843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+352737,int_stack+349209,int_stack+336777, 1.0, int_stack+215607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+212520,int_stack+6720,int_stack+108045, 1.0, int_stack+5775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+357147,int_stack+212520,int_stack+346941, 1.0, int_stack+218253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+212520,int_stack+357147,int_stack+349209, 1.0, int_stack+220521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+357147,int_stack+131397,int_stack+130515,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+358470,int_stack+132573,int_stack+131397,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+218400,int_stack+358470,int_stack+357147,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+221046,int_stack+134085,int_stack+132573,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+360234,int_stack+221046,int_stack+358470,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+363762,int_stack+360234,int_stack+218400,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+4536,int_stack+7875,int_stack+134085,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+368172,int_stack+4536,int_stack+221046,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+372708,int_stack+368172,int_stack+360234,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+368172,int_stack+161322,int_stack+160440,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+369495,int_stack+162498,int_stack+161322,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4536,int_stack+369495,int_stack+368172,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+378588,int_stack+164010,int_stack+162498,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+380856,int_stack+378588,int_stack+369495,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+384384,int_stack+380856,int_stack+4536,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+388794,int_stack+9030,int_stack+164010,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+391629,int_stack+388794,int_stack+378588,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+396165,int_stack+391629,int_stack+380856,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+388794,int_stack+195132,int_stack+194250,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+390117,int_stack+196308,int_stack+195132,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+391881,int_stack+390117,int_stack+388794,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7182,int_stack+197820,int_stack+196308,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+402045,int_stack+7182,int_stack+390117,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+405573,int_stack+402045,int_stack+391881,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+409983,int_stack+10185,int_stack+197820,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+412818,int_stack+409983,int_stack+7182,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+417354,int_stack+412818,int_stack+402045,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+409983,int_stack+11781,int_stack+11340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+69615,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+411306,int_stack+12369,int_stack+11781, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+70497,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+413070,int_stack+411306,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+228459,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9450,int_stack+13125,int_stack+12369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+71673,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+9450,int_stack+411306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+229782,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+426762,int_stack+423234,int_stack+413070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+231546,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+409983,int_stack+14070,int_stack+13125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+73185,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+412818,int_stack+409983,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+234192,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+431172,int_stack+412818,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+236460,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+15666,int_stack+15225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69615, 1.0, int_stack+76230,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+16254,int_stack+15666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70497, 1.0, int_stack+77112,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9450,int_stack+424557,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228459, 1.0, int_stack+244398,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12096,int_stack+17010,int_stack+16254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71673, 1.0, int_stack+78288,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+409983,int_stack+12096,int_stack+424557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229782, 1.0, int_stack+245721,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+437052,int_stack+409983,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231546, 1.0, int_stack+247485,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+17955,int_stack+17010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73185, 1.0, int_stack+79800,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+14364,int_stack+423234,int_stack+12096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234192, 1.0, int_stack+257649,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+441462,int_stack+14364,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236460, 1.0, int_stack+259917,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+409983,int_stack+19551,int_stack+19110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+76230, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+411306,int_stack+20139,int_stack+19551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+77112, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+413070,int_stack+411306,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+244398, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423234,int_stack+20895,int_stack+20139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+78288, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+423234,int_stack+411306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+245721, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12978,int_stack+9450,int_stack+413070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+247485, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+409983,int_stack+21840,int_stack+20895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+79800, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+412818,int_stack+409983,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+257649, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+447342,int_stack+412818,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+259917, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+23436,int_stack+22995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69615, 0.0, zero_stack, 1.0, int_stack+82845,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+24024,int_stack+23436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70497, 0.0, zero_stack, 1.0, int_stack+83727,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+423234,int_stack+10773,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228459, 0.0, zero_stack, 1.0, int_stack+267855,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+24780,int_stack+24024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71673, 0.0, zero_stack, 1.0, int_stack+84903,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+412251,int_stack+409983,int_stack+10773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229782, 0.0, zero_stack, 1.0, int_stack+269178,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+17388,int_stack+412251,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231546, 0.0, zero_stack, 1.0, int_stack+270942,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+25725,int_stack+24780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73185, 0.0, zero_stack, 1.0, int_stack+86415,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+21798,int_stack+423234,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234192, 0.0, zero_stack, 1.0, int_stack+0,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+453222,int_stack+21798,int_stack+412251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236460, 0.0, zero_stack, 1.0, int_stack+281106,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21798,int_stack+27321,int_stack+26880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76230, 1.0, int_stack+82845, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23121,int_stack+27909,int_stack+27321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77112, 1.0, int_stack+83727, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+24885,int_stack+23121,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244398, 1.0, int_stack+267855, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+28665,int_stack+27909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78288, 1.0, int_stack+84903, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+23121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245721, 1.0, int_stack+269178, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+412251,int_stack+423234,int_stack+24885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247485, 1.0, int_stack+270942, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21798,int_stack+29610,int_stack+28665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79800, 1.0, int_stack+86415, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24633,int_stack+21798,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257649, 1.0, int_stack+0, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+459102,int_stack+24633,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259917, 1.0, int_stack+281106, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+31206,int_stack+30765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+82845, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+31794,int_stack+31206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+83727, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+267855, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+32550,int_stack+31794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+84903, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269178, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+24444,int_stack+9450,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+270942, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+33495,int_stack+32550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+86415, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+28854,int_stack+423234,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+464982,int_stack+28854,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+281106, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+35091,int_stack+34650, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89460,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+35679,int_stack+35091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90342,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228459, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289044,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+36435,int_stack+35679, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71673, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91518,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+10773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229782, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+290367,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+28854,int_stack+423234,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+292131,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9450,int_stack+37380,int_stack+36435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93030,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+33264,int_stack+9450,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302295,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+470862,int_stack+33264,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304563,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+38976,int_stack+38535, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+76230, 0.0, zero_stack, 1.0, int_stack+89460, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+39564,int_stack+38976, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77112, 0.0, zero_stack, 1.0, int_stack+90342, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244398, 0.0, zero_stack, 1.0, int_stack+289044, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+40320,int_stack+39564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+78288, 0.0, zero_stack, 1.0, int_stack+91518, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245721, 0.0, zero_stack, 1.0, int_stack+290367, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33264,int_stack+9450,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247485, 0.0, zero_stack, 1.0, int_stack+292131, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+41265,int_stack+40320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79800, 0.0, zero_stack, 1.0, int_stack+93030, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+37674,int_stack+423234,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+257649, 0.0, zero_stack, 1.0, int_stack+302295, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+476742,int_stack+37674,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259917, 0.0, zero_stack, 1.0, int_stack+304563, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+42861,int_stack+42420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82845, 1.0, int_stack+89460, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+43449,int_stack+42861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83727, 1.0, int_stack+90342, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267855, 1.0, int_stack+289044, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+44205,int_stack+43449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84903, 1.0, int_stack+91518, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+10773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269178, 1.0, int_stack+290367, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+37674,int_stack+423234,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270942, 1.0, int_stack+292131, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9450,int_stack+45150,int_stack+44205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86415, 1.0, int_stack+93030, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+482622,int_stack+9450,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+302295, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+487158,int_stack+482622,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281106, 1.0, int_stack+304563, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+46746,int_stack+46305, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+89460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+47334,int_stack+46746, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+90342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+289044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+48090,int_stack+47334, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+91518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+290367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+482622,int_stack+9450,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+292131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+49035,int_stack+48090, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+93030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+42084,int_stack+423234,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+302295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+493038,int_stack+42084,int_stack+9450, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+304563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+50631,int_stack+50190, 0.0, zero_stack, 1.0, int_stack+69615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96075,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+51219,int_stack+50631, 0.0, zero_stack, 1.0, int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96957,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 0.0, zero_stack, 1.0, int_stack+228459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312501,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+51975,int_stack+51219, 0.0, zero_stack, 1.0, int_stack+71673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98133,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+10773, 0.0, zero_stack, 1.0, int_stack+229782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313824,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+42084,int_stack+423234,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+231546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315588,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9450,int_stack+52920,int_stack+51975, 0.0, zero_stack, 1.0, int_stack+73185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99645,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+46494,int_stack+9450,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+234192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+498918,int_stack+46494,int_stack+423234, 0.0, zero_stack, 1.0, int_stack+236460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325752,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+54516,int_stack+54075, 0.0, zero_stack, 1.0, int_stack+76230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96075, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+55104,int_stack+54516, 0.0, zero_stack, 1.0, int_stack+77112, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96957, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 0.0, zero_stack, 1.0, int_stack+244398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312501, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+55860,int_stack+55104, 0.0, zero_stack, 1.0, int_stack+78288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98133, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 0.0, zero_stack, 1.0, int_stack+245721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313824, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+46494,int_stack+9450,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+247485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+315588, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+56805,int_stack+55860, 0.0, zero_stack, 1.0, int_stack+79800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99645, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+50904,int_stack+423234,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+257649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+504798,int_stack+50904,int_stack+9450, 0.0, zero_stack, 1.0, int_stack+259917, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325752, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+58401,int_stack+57960, 0.0, zero_stack, 1.0, int_stack+82845, 0.0, zero_stack, 1.0, int_stack+96075, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+58989,int_stack+58401, 0.0, zero_stack, 1.0, int_stack+83727, 0.0, zero_stack, 1.0, int_stack+96957, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 0.0, zero_stack, 1.0, int_stack+267855, 0.0, zero_stack, 1.0, int_stack+312501, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+59745,int_stack+58989, 0.0, zero_stack, 1.0, int_stack+84903, 0.0, zero_stack, 1.0, int_stack+98133, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+10773, 0.0, zero_stack, 1.0, int_stack+269178, 0.0, zero_stack, 1.0, int_stack+313824, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+50904,int_stack+423234,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+270942, 0.0, zero_stack, 1.0, int_stack+315588, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9450,int_stack+60690,int_stack+59745, 0.0, zero_stack, 1.0, int_stack+86415, 0.0, zero_stack, 1.0, int_stack+99645, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+55314,int_stack+9450,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+510678,int_stack+55314,int_stack+423234, 0.0, zero_stack, 1.0, int_stack+281106, 0.0, zero_stack, 1.0, int_stack+325752, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+62286,int_stack+61845, 0.0, zero_stack, 1.0, int_stack+89460, 1.0, int_stack+96075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+62874,int_stack+62286, 0.0, zero_stack, 1.0, int_stack+90342, 1.0, int_stack+96957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 0.0, zero_stack, 1.0, int_stack+289044, 1.0, int_stack+312501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+63630,int_stack+62874, 0.0, zero_stack, 1.0, int_stack+91518, 1.0, int_stack+98133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 0.0, zero_stack, 1.0, int_stack+290367, 1.0, int_stack+313824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+55314,int_stack+9450,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+292131, 1.0, int_stack+315588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+423234,int_stack+64575,int_stack+63630, 0.0, zero_stack, 1.0, int_stack+93030, 1.0, int_stack+99645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+59724,int_stack+423234,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+302295, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+516558,int_stack+59724,int_stack+9450, 0.0, zero_stack, 1.0, int_stack+304563, 1.0, int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+66171,int_stack+65730, 0.0, zero_stack, 2.0, int_stack+96075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+66759,int_stack+66171, 0.0, zero_stack, 2.0, int_stack+96957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 0.0, zero_stack, 2.0, int_stack+312501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+67515,int_stack+66759, 0.0, zero_stack, 2.0, int_stack+98133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+10773, 0.0, zero_stack, 2.0, int_stack+313824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+59724,int_stack+423234,int_stack+21798, 0.0, zero_stack, 2.0, int_stack+315588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9450,int_stack+68460,int_stack+67515, 0.0, zero_stack, 2.0, int_stack+99645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+64134,int_stack+9450,int_stack+409983, 0.0, zero_stack, 2.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+522438,int_stack+64134,int_stack+423234, 0.0, zero_stack, 2.0, int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+71085,int_stack+70056, 1.0, int_stack+69615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103131,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+72429,int_stack+71085, 1.0, int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104601,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 1.0, int_stack+228459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333690,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+74130,int_stack+72429, 1.0, int_stack+71673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106533,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 1.0, int_stack+229782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335013,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+64134,int_stack+9450,int_stack+21798, 1.0, int_stack+231546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336777,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+228459,int_stack+75075,int_stack+74130, 1.0, int_stack+73185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108045,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+68544,int_stack+228459,int_stack+409983, 1.0, int_stack+234192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346941,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+228459,int_stack+68544,int_stack+9450, 1.0, int_stack+236460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349209,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+77700,int_stack+76671, 1.0, int_stack+76230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103131, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+79044,int_stack+77700, 1.0, int_stack+77112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104601, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 1.0, int_stack+244398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333690, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+80745,int_stack+79044, 1.0, int_stack+78288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106533, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+423234,int_stack+409983,int_stack+10773, 1.0, int_stack+245721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335013, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+68544,int_stack+423234,int_stack+21798, 1.0, int_stack+247485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336777, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+244398,int_stack+81690,int_stack+80745, 1.0, int_stack+79800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108045, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+247233,int_stack+244398,int_stack+409983, 1.0, int_stack+257649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346941, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+72954,int_stack+247233,int_stack+423234, 1.0, int_stack+259917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349209, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423234,int_stack+84315,int_stack+83286, 1.0, int_stack+82845, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103131, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+424557,int_stack+85659,int_stack+84315, 1.0, int_stack+83727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104601, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+424557,int_stack+423234, 1.0, int_stack+267855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+87360,int_stack+85659, 1.0, int_stack+84903, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106533, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+409983,int_stack+424557, 1.0, int_stack+269178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335013, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+257649,int_stack+9450,int_stack+21798, 1.0, int_stack+270942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336777, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+267855,int_stack+88305,int_stack+87360, 1.0, int_stack+86415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108045, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+270690,int_stack+267855,int_stack+409983, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346941, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+244398,int_stack+270690,int_stack+9450, 1.0, int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+349209, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+90930,int_stack+89901, 1.0, int_stack+89460, 0.0, zero_stack, 1.0, int_stack+103131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+92274,int_stack+90930, 1.0, int_stack+90342, 0.0, zero_stack, 1.0, int_stack+104601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 1.0, int_stack+289044, 0.0, zero_stack, 1.0, int_stack+333690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+93975,int_stack+92274, 1.0, int_stack+91518, 0.0, zero_stack, 1.0, int_stack+106533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9450,int_stack+0,int_stack+282429, 1.0, int_stack+290367, 0.0, zero_stack, 1.0, int_stack+335013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+267855,int_stack+9450,int_stack+21798, 1.0, int_stack+292131, 0.0, zero_stack, 1.0, int_stack+336777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+289044,int_stack+94920,int_stack+93975, 1.0, int_stack+93030, 0.0, zero_stack, 1.0, int_stack+108045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+291879,int_stack+289044,int_stack+0, 1.0, int_stack+302295, 0.0, zero_stack, 1.0, int_stack+346941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+78834,int_stack+291879,int_stack+9450, 1.0, int_stack+304563, 0.0, zero_stack, 1.0, int_stack+349209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+97545,int_stack+96516, 1.0, int_stack+96075, 1.0, int_stack+103131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10773,int_stack+98889,int_stack+97545, 1.0, int_stack+96957, 1.0, int_stack+104601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+10773,int_stack+9450, 1.0, int_stack+312501, 1.0, int_stack+333690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+100590,int_stack+98889, 1.0, int_stack+98133, 1.0, int_stack+106533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+0,int_stack+10773, 1.0, int_stack+313824, 1.0, int_stack+335013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+302295,int_stack+281106,int_stack+21798, 1.0, int_stack+315588, 1.0, int_stack+336777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+312501,int_stack+101535,int_stack+100590, 1.0, int_stack+99645, 1.0, int_stack+108045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+315336,int_stack+312501,int_stack+0, 1.0, int_stack+2268, 1.0, int_stack+346941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+289044,int_stack+315336,int_stack+281106, 1.0, int_stack+325752, 1.0, int_stack+349209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+105189,int_stack+103572, 2.0, int_stack+103131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+107289,int_stack+105189, 2.0, int_stack+104601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 2.0, int_stack+333690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+108990,int_stack+107289, 2.0, int_stack+106533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 2.0, int_stack+335013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+281106,int_stack+21798, 2.0, int_stack+336777, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+333690,int_stack+109935,int_stack+108990, 2.0, int_stack+108045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+336525,int_stack+333690,int_stack+409983, 2.0, int_stack+346941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+312501,int_stack+336525,int_stack+281106, 2.0, int_stack+349209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+111531,int_stack+111090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130515,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+112119,int_stack+111531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131397,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357147,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+112875,int_stack+112119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132573,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358470,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+346941,int_stack+325752,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218400,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+113820,int_stack+112875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134085,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+333690,int_stack+281106,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221046,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+84714,int_stack+333690,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360234,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+115416,int_stack+114975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130515, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+116004,int_stack+115416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131397, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357147, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+116760,int_stack+116004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132573, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358470, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+333690,int_stack+281106,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218400, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+117705,int_stack+116760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134085, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+90594,int_stack+325752,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221046, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+95130,int_stack+90594,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360234, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+119301,int_stack+118860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130515, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+119889,int_stack+119301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131397, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357147, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+120645,int_stack+119889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132573, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358470, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+90594,int_stack+325752,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218400, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+121590,int_stack+120645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134085, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+101010,int_stack+281106,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221046, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+105546,int_stack+101010,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360234, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+123186,int_stack+122745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+123774,int_stack+123186, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+131397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+124530,int_stack+123774, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+132573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+101010,int_stack+281106,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+125475,int_stack+124530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+111426,int_stack+325752,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+115962,int_stack+111426,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+127071,int_stack+126630, 0.0, zero_stack, 1.0, int_stack+130515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+127659,int_stack+127071, 0.0, zero_stack, 1.0, int_stack+131397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 1.0, int_stack+357147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+128415,int_stack+127659, 0.0, zero_stack, 1.0, int_stack+132573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 1.0, int_stack+358470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+111426,int_stack+325752,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+218400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+129360,int_stack+128415, 0.0, zero_stack, 1.0, int_stack+134085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+121842,int_stack+281106,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+221046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+528318,int_stack+121842,int_stack+325752, 0.0, zero_stack, 1.0, int_stack+360234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+131985,int_stack+130956, 1.0, int_stack+130515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+133329,int_stack+131985, 1.0, int_stack+131397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 1.0, int_stack+357147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+135030,int_stack+133329, 1.0, int_stack+132573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 1.0, int_stack+358470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+121842,int_stack+281106,int_stack+21798, 1.0, int_stack+218400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+357147,int_stack+135975,int_stack+135030, 1.0, int_stack+134085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+126252,int_stack+357147,int_stack+409983, 1.0, int_stack+221046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+130788,int_stack+126252,int_stack+281106, 1.0, int_stack+360234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+137571,int_stack+137130,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+138159,int_stack+137571,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+138915,int_stack+138159,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+126252,int_stack+325752,int_stack+21798,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+139860,int_stack+138915,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+357147,int_stack+281106,int_stack+409983,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+534198,int_stack+357147,int_stack+325752,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+141456,int_stack+141015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160440,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+142044,int_stack+141456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161322,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368172,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+142800,int_stack+142044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162498,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369495,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+357147,int_stack+281106,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4536,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+143745,int_stack+142800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164010,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+218400,int_stack+325752,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378588,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+136668,int_stack+218400,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380856,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+145341,int_stack+144900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160440, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+145929,int_stack+145341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161322, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368172, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+146685,int_stack+145929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162498, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369495, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+218400,int_stack+325752,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4536, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+147630,int_stack+146685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164010, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+142548,int_stack+281106,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378588, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+540078,int_stack+142548,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380856, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+149226,int_stack+148785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160440, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+149814,int_stack+149226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161322, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368172, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+150570,int_stack+149814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162498, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369495, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+142548,int_stack+281106,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+151515,int_stack+150570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164010, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+146958,int_stack+325752,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378588, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+545958,int_stack+146958,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380856, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+153111,int_stack+152670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+153699,int_stack+153111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+368172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+154455,int_stack+153699, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+162498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+369495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+146958,int_stack+325752,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+155400,int_stack+154455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+164010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151368,int_stack+281106,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+378588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+551838,int_stack+151368,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+156996,int_stack+156555, 0.0, zero_stack, 1.0, int_stack+160440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+157584,int_stack+156996, 0.0, zero_stack, 1.0, int_stack+161322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 1.0, int_stack+368172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+158340,int_stack+157584, 0.0, zero_stack, 1.0, int_stack+162498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 1.0, int_stack+369495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+151368,int_stack+281106,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+159285,int_stack+158340, 0.0, zero_stack, 1.0, int_stack+164010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+155778,int_stack+325752,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+378588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+557718,int_stack+155778,int_stack+281106, 0.0, zero_stack, 1.0, int_stack+380856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+161910,int_stack+160881, 1.0, int_stack+160440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+163254,int_stack+161910, 1.0, int_stack+161322, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 1.0, int_stack+368172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+164955,int_stack+163254, 1.0, int_stack+162498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 1.0, int_stack+369495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+368172,int_stack+325752,int_stack+21798, 1.0, int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+165900,int_stack+164955, 1.0, int_stack+164010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+155778,int_stack+281106,int_stack+409983, 1.0, int_stack+378588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+160314,int_stack+155778,int_stack+325752, 1.0, int_stack+380856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+167496,int_stack+167055,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+168084,int_stack+167496,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+168840,int_stack+168084,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+155778,int_stack+281106,int_stack+21798,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+169785,int_stack+168840,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+378588,int_stack+325752,int_stack+409983,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+563598,int_stack+378588,int_stack+281106,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+171381,int_stack+170940,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+171969,int_stack+171381,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+172725,int_stack+171969,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+378588,int_stack+325752,int_stack+21798,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+173670,int_stack+172725,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+166194,int_stack+281106,int_stack+409983,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+569478,int_stack+166194,int_stack+325752,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+175266,int_stack+174825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194250,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+175854,int_stack+175266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195132,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388794,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+176610,int_stack+175854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196308,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390117,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+166194,int_stack+281106,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391881,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+177555,int_stack+176610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197820,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+170604,int_stack+325752,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7182,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+575358,int_stack+170604,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402045,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+179151,int_stack+178710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194250, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+179739,int_stack+179151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195132, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388794, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+180495,int_stack+179739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196308, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390117, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+170604,int_stack+325752,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391881, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+181440,int_stack+180495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197820, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+175014,int_stack+281106,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7182, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+581238,int_stack+175014,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402045, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+183036,int_stack+182595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194250, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+183624,int_stack+183036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195132, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388794, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+184380,int_stack+183624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196308, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390117, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+175014,int_stack+281106,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391881, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+185325,int_stack+184380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197820, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+179424,int_stack+325752,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7182, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+587118,int_stack+179424,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402045, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+186921,int_stack+186480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+194250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+187509,int_stack+186921, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+188265,int_stack+187509, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+196308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+390117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+179424,int_stack+325752,int_stack+21798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+391881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+281106,int_stack+189210,int_stack+188265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+183834,int_stack+281106,int_stack+409983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+592998,int_stack+183834,int_stack+325752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+402045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+190806,int_stack+190365, 0.0, zero_stack, 1.0, int_stack+194250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+191394,int_stack+190806, 0.0, zero_stack, 1.0, int_stack+195132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752, 0.0, zero_stack, 1.0, int_stack+388794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+192150,int_stack+191394, 0.0, zero_stack, 1.0, int_stack+196308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+281106,int_stack+409983,int_stack+327075, 0.0, zero_stack, 1.0, int_stack+390117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+183834,int_stack+281106,int_stack+21798, 0.0, zero_stack, 1.0, int_stack+391881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+193095,int_stack+192150, 0.0, zero_stack, 1.0, int_stack+197820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+188244,int_stack+325752,int_stack+409983, 0.0, zero_stack, 1.0, int_stack+7182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+598878,int_stack+188244,int_stack+281106, 0.0, zero_stack, 1.0, int_stack+402045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+281106,int_stack+195720,int_stack+194691, 1.0, int_stack+194250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+282429,int_stack+197064,int_stack+195720, 1.0, int_stack+195132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+282429,int_stack+281106, 1.0, int_stack+388794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+198765,int_stack+197064, 1.0, int_stack+196308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+282429, 1.0, int_stack+390117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+188244,int_stack+325752,int_stack+21798, 1.0, int_stack+391881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+388794,int_stack+199710,int_stack+198765, 1.0, int_stack+197820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+391629,int_stack+388794,int_stack+409983, 1.0, int_stack+7182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+192654,int_stack+391629,int_stack+325752, 1.0, int_stack+402045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+402045,int_stack+201306,int_stack+200865,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+403368,int_stack+201894,int_stack+201306,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+403368,int_stack+402045,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+202650,int_stack+201894,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+403368,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+388794,int_stack+325752,int_stack+21798,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+402045,int_stack+203595,int_stack+202650,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+198534,int_stack+402045,int_stack+409983,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+4410,int_stack+198534,int_stack+325752,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+325752,int_stack+205191,int_stack+204750,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+327075,int_stack+205779,int_stack+205191,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+327075,int_stack+325752,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+206535,int_stack+205779,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+402045,int_stack+409983,int_stack+327075,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+198534,int_stack+402045,int_stack+21798,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+325752,int_stack+207480,int_stack+206535,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+202944,int_stack+325752,int_stack+409983,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+604758,int_stack+202944,int_stack+402045,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+402045,int_stack+209076,int_stack+208635,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+403368,int_stack+209664,int_stack+209076,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+21798,int_stack+403368,int_stack+402045,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+409983,int_stack+210420,int_stack+209664,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+325752,int_stack+409983,int_stack+403368,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+202944,int_stack+325752,int_stack+21798,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+402045,int_stack+211365,int_stack+210420,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+207354,int_stack+402045,int_stack+409983,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+610638,int_stack+207354,int_stack+325752,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+616518,int_stack+251769,int_stack+239988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224049,21);
     Libderiv->ABCD[11] = int_stack + 616518;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+250278,int_stack+275226,int_stack+263445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224049, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 250278;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+272265,int_stack+296415,int_stack+284634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224049, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 272265;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+294924,int_stack+319872,int_stack+308091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+224049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 294924;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+318381,int_stack+341061,int_stack+329280, 0.0, zero_stack, 1.0, int_stack+224049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 318381;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+338100,int_stack+212520,int_stack+352737, 1.0, int_stack+224049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 338100;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+207354,int_stack+372708,int_stack+363762,21);
     Libderiv->ABCD[2] = int_stack + 207354;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+623133,int_stack+396165,int_stack+384384,21);
     Libderiv->ABCD[1] = int_stack + 623133;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+393204,int_stack+417354,int_stack+405573,21);
     Libderiv->ABCD[0] = int_stack + 393204;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+416661,int_stack+431172,int_stack+426762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+239988,21);
     Libderiv->ABCD[155] = int_stack + 416661;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+423276,int_stack+441462,int_stack+437052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239988, 1.0, int_stack+263445,21);
     Libderiv->ABCD[143] = int_stack + 423276;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+429891,int_stack+447342,int_stack+12978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+263445, 0.0, zero_stack,21);
     Libderiv->ABCD[142] = int_stack + 429891;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+10290,int_stack+453222,int_stack+17388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239988, 0.0, zero_stack, 1.0, int_stack+284634,21);
     Libderiv->ABCD[131] = int_stack + 10290;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+16905,int_stack+459102,int_stack+412251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263445, 1.0, int_stack+284634, 0.0, zero_stack,21);
     Libderiv->ABCD[130] = int_stack + 16905;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+409983,int_stack+464982,int_stack+24444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+284634, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[129] = int_stack + 409983;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+436506,int_stack+470862,int_stack+28854, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308091,21);
     Libderiv->ABCD[119] = int_stack + 436506;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+23520,int_stack+476742,int_stack+33264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263445, 0.0, zero_stack, 1.0, int_stack+308091, 0.0, zero_stack,21);
     Libderiv->ABCD[118] = int_stack + 23520;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+30135,int_stack+487158,int_stack+37674, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+284634, 1.0, int_stack+308091, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[117] = int_stack + 30135;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+443121,int_stack+493038,int_stack+482622, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+308091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[116] = int_stack + 443121;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+449736,int_stack+498918,int_stack+42084, 0.0, zero_stack, 1.0, int_stack+239988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329280,21);
     Libderiv->ABCD[107] = int_stack + 449736;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+36750,int_stack+504798,int_stack+46494, 0.0, zero_stack, 1.0, int_stack+263445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329280, 0.0, zero_stack,21);
     Libderiv->ABCD[106] = int_stack + 36750;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+43365,int_stack+510678,int_stack+50904, 0.0, zero_stack, 1.0, int_stack+284634, 0.0, zero_stack, 1.0, int_stack+329280, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[105] = int_stack + 43365;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+456351,int_stack+516558,int_stack+55314, 0.0, zero_stack, 1.0, int_stack+308091, 1.0, int_stack+329280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[104] = int_stack + 456351;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+49980,int_stack+522438,int_stack+59724, 0.0, zero_stack, 2.0, int_stack+329280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[103] = int_stack + 49980;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+56595,int_stack+228459,int_stack+64134, 1.0, int_stack+239988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352737,21);
     Libderiv->ABCD[95] = int_stack + 56595;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+222810,int_stack+72954,int_stack+68544, 1.0, int_stack+263445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352737, 0.0, zero_stack,21);
     Libderiv->ABCD[94] = int_stack + 222810;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+229425,int_stack+244398,int_stack+257649, 1.0, int_stack+284634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352737, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[93] = int_stack + 229425;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+236040,int_stack+78834,int_stack+267855, 1.0, int_stack+308091, 0.0, zero_stack, 1.0, int_stack+352737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[92] = int_stack + 236040;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+242655,int_stack+289044,int_stack+302295, 1.0, int_stack+329280, 1.0, int_stack+352737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[91] = int_stack + 242655;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+63210,int_stack+312501,int_stack+0, 2.0, int_stack+352737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[90] = int_stack + 63210;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69825,int_stack+84714,int_stack+346941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363762,21);
     Libderiv->ABCD[47] = int_stack + 69825;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+344715,int_stack+95130,int_stack+333690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363762, 0.0, zero_stack,21);
     Libderiv->ABCD[46] = int_stack + 344715;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+76440,int_stack+105546,int_stack+90594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363762, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[45] = int_stack + 76440;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+83055,int_stack+115962,int_stack+101010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[44] = int_stack + 83055;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+89670,int_stack+528318,int_stack+111426, 0.0, zero_stack, 1.0, int_stack+363762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[43] = int_stack + 89670;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+96285,int_stack+130788,int_stack+121842, 1.0, int_stack+363762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[42] = int_stack + 96285;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+361557,int_stack+534198,int_stack+126252,21);
     Libderiv->ABCD[38] = int_stack + 361557;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+102900,int_stack+136668,int_stack+357147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384384,21);
     Libderiv->ABCD[35] = int_stack + 102900;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+351330,int_stack+540078,int_stack+218400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384384, 0.0, zero_stack,21);
     Libderiv->ABCD[34] = int_stack + 351330;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+213969,int_stack+545958,int_stack+142548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384384, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[33] = int_stack + 213969;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+109515,int_stack+551838,int_stack+146958, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[32] = int_stack + 109515;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+116130,int_stack+557718,int_stack+151368, 0.0, zero_stack, 1.0, int_stack+384384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[31] = int_stack + 116130;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+122745,int_stack+160314,int_stack+368172, 1.0, int_stack+384384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[30] = int_stack + 122745;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+368172,int_stack+563598,int_stack+155778,21);
     Libderiv->ABCD[26] = int_stack + 368172;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+129360,int_stack+569478,int_stack+378588,21);
     Libderiv->ABCD[25] = int_stack + 129360;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+374787,int_stack+575358,int_stack+166194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405573,21);
     Libderiv->ABCD[23] = int_stack + 374787;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+381402,int_stack+581238,int_stack+170604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405573, 0.0, zero_stack,21);
     Libderiv->ABCD[22] = int_stack + 381402;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+135975,int_stack+587118,int_stack+175014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405573, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[21] = int_stack + 135975;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+142590,int_stack+592998,int_stack+179424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[20] = int_stack + 142590;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+149205,int_stack+598878,int_stack+183834, 0.0, zero_stack, 1.0, int_stack+405573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[19] = int_stack + 149205;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+155820,int_stack+192654,int_stack+188244, 1.0, int_stack+405573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[18] = int_stack + 155820;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+399819,int_stack+4410,int_stack+388794,21);
     Libderiv->ABCD[14] = int_stack + 399819;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+604758,int_stack+198534,21);
     Libderiv->ABCD[13] = int_stack + 0;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+162435,int_stack+610638,int_stack+202944,21);
     Libderiv->ABCD[12] = int_stack + 162435;

}
