/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_hphh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hp|hh) integrals */

void d12hrr_order_hphh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][10][11] = int_stack + 0;
 Libderiv->deriv_classes[6][10][10] = int_stack + 1848;
 Libderiv->deriv_classes[6][10][9] = int_stack + 3696;
 Libderiv->deriv_classes[6][10][8] = int_stack + 5544;
 Libderiv->deriv_classes[6][10][7] = int_stack + 7392;
 Libderiv->dvrr_classes[6][9] = int_stack + 9240;
 Libderiv->deriv_classes[6][10][6] = int_stack + 10780;
 Libderiv->deriv_classes[6][10][2] = int_stack + 12628;
 Libderiv->deriv_classes[6][10][1] = int_stack + 14476;
 Libderiv->dvrr_classes[5][10] = int_stack + 16324;
 Libderiv->deriv_classes[6][10][0] = int_stack + 17710;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 19558;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 19999;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 20587;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 21343;
 Libderiv->deriv2_classes[5][9][143] = int_stack + 22288;
 Libderiv->deriv2_classes[5][10][143] = int_stack + 23443;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 24829;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 25417;
 Libderiv->deriv2_classes[6][7][143] = int_stack + 26201;
 Libderiv->deriv2_classes[6][8][143] = int_stack + 27209;
 Libderiv->deriv2_classes[6][9][143] = int_stack + 28469;
 Libderiv->deriv2_classes[6][10][143] = int_stack + 30009;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 31857;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 32298;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 32886;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 33642;
 Libderiv->deriv2_classes[5][9][131] = int_stack + 34587;
 Libderiv->deriv2_classes[5][10][131] = int_stack + 35742;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 37128;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 37716;
 Libderiv->deriv2_classes[6][7][131] = int_stack + 38500;
 Libderiv->deriv2_classes[6][8][131] = int_stack + 39508;
 Libderiv->deriv2_classes[6][9][131] = int_stack + 40768;
 Libderiv->deriv2_classes[6][10][131] = int_stack + 42308;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 44156;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 44597;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 45185;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 45941;
 Libderiv->deriv2_classes[5][9][130] = int_stack + 46886;
 Libderiv->deriv2_classes[5][10][130] = int_stack + 48041;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 49427;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 50015;
 Libderiv->deriv2_classes[6][7][130] = int_stack + 50799;
 Libderiv->deriv2_classes[6][8][130] = int_stack + 51807;
 Libderiv->deriv2_classes[6][9][130] = int_stack + 53067;
 Libderiv->deriv2_classes[6][10][130] = int_stack + 54607;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 56455;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 56896;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 57484;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 58240;
 Libderiv->deriv2_classes[5][9][119] = int_stack + 59185;
 Libderiv->deriv2_classes[5][10][119] = int_stack + 60340;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 61726;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 62314;
 Libderiv->deriv2_classes[6][7][119] = int_stack + 63098;
 Libderiv->deriv2_classes[6][8][119] = int_stack + 64106;
 Libderiv->deriv2_classes[6][9][119] = int_stack + 65366;
 Libderiv->deriv2_classes[6][10][119] = int_stack + 66906;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 68754;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 69195;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 69783;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 70539;
 Libderiv->deriv2_classes[5][9][118] = int_stack + 71484;
 Libderiv->deriv2_classes[5][10][118] = int_stack + 72639;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 74025;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 74613;
 Libderiv->deriv2_classes[6][7][118] = int_stack + 75397;
 Libderiv->deriv2_classes[6][8][118] = int_stack + 76405;
 Libderiv->deriv2_classes[6][9][118] = int_stack + 77665;
 Libderiv->deriv2_classes[6][10][118] = int_stack + 79205;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 81053;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 81494;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 82082;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 82838;
 Libderiv->deriv2_classes[5][9][117] = int_stack + 83783;
 Libderiv->deriv2_classes[5][10][117] = int_stack + 84938;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 86324;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 86912;
 Libderiv->deriv2_classes[6][7][117] = int_stack + 87696;
 Libderiv->deriv2_classes[6][8][117] = int_stack + 88704;
 Libderiv->deriv2_classes[6][9][117] = int_stack + 89964;
 Libderiv->deriv2_classes[6][10][117] = int_stack + 91504;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 93352;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 93793;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 94381;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 95137;
 Libderiv->deriv2_classes[5][9][107] = int_stack + 96082;
 Libderiv->deriv2_classes[5][10][107] = int_stack + 97237;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 98623;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 99211;
 Libderiv->deriv2_classes[6][7][107] = int_stack + 99995;
 Libderiv->deriv2_classes[6][8][107] = int_stack + 101003;
 Libderiv->deriv2_classes[6][9][107] = int_stack + 102263;
 Libderiv->deriv2_classes[6][10][107] = int_stack + 103803;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 105651;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 106092;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 106680;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 107436;
 Libderiv->deriv2_classes[5][9][106] = int_stack + 108381;
 Libderiv->deriv2_classes[5][10][106] = int_stack + 109536;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 110922;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 111510;
 Libderiv->deriv2_classes[6][7][106] = int_stack + 112294;
 Libderiv->deriv2_classes[6][8][106] = int_stack + 113302;
 Libderiv->deriv2_classes[6][9][106] = int_stack + 114562;
 Libderiv->deriv2_classes[6][10][106] = int_stack + 116102;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 117950;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 118391;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 118979;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 119735;
 Libderiv->deriv2_classes[5][9][105] = int_stack + 120680;
 Libderiv->deriv2_classes[5][10][105] = int_stack + 121835;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 123221;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 123809;
 Libderiv->deriv2_classes[6][7][105] = int_stack + 124593;
 Libderiv->deriv2_classes[6][8][105] = int_stack + 125601;
 Libderiv->deriv2_classes[6][9][105] = int_stack + 126861;
 Libderiv->deriv2_classes[6][10][105] = int_stack + 128401;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 130249;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 130690;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 131278;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 132034;
 Libderiv->deriv2_classes[5][9][104] = int_stack + 132979;
 Libderiv->deriv2_classes[5][10][104] = int_stack + 134134;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 135520;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 136108;
 Libderiv->deriv2_classes[6][7][104] = int_stack + 136892;
 Libderiv->deriv2_classes[6][8][104] = int_stack + 137900;
 Libderiv->deriv2_classes[6][9][104] = int_stack + 139160;
 Libderiv->deriv2_classes[6][10][104] = int_stack + 140700;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 142548;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 142989;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 143577;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 144333;
 Libderiv->deriv2_classes[5][9][95] = int_stack + 145278;
 Libderiv->deriv2_classes[5][10][95] = int_stack + 146433;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 147819;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 148407;
 Libderiv->deriv2_classes[6][7][95] = int_stack + 149191;
 Libderiv->deriv2_classes[6][8][95] = int_stack + 150199;
 Libderiv->deriv2_classes[6][9][95] = int_stack + 151459;
 Libderiv->deriv2_classes[6][10][95] = int_stack + 152999;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 154847;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 155288;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 155876;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 156632;
 Libderiv->deriv2_classes[5][9][94] = int_stack + 157577;
 Libderiv->deriv2_classes[5][10][94] = int_stack + 158732;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 160118;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 160706;
 Libderiv->deriv2_classes[6][7][94] = int_stack + 161490;
 Libderiv->deriv2_classes[6][8][94] = int_stack + 162498;
 Libderiv->deriv2_classes[6][9][94] = int_stack + 163758;
 Libderiv->deriv2_classes[6][10][94] = int_stack + 165298;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 167146;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 167587;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 168175;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 168931;
 Libderiv->deriv2_classes[5][9][93] = int_stack + 169876;
 Libderiv->deriv2_classes[5][10][93] = int_stack + 171031;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 172417;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 173005;
 Libderiv->deriv2_classes[6][7][93] = int_stack + 173789;
 Libderiv->deriv2_classes[6][8][93] = int_stack + 174797;
 Libderiv->deriv2_classes[6][9][93] = int_stack + 176057;
 Libderiv->deriv2_classes[6][10][93] = int_stack + 177597;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 179445;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 179886;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 180474;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 181230;
 Libderiv->deriv2_classes[5][9][92] = int_stack + 182175;
 Libderiv->deriv2_classes[5][10][92] = int_stack + 183330;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 184716;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 185304;
 Libderiv->deriv2_classes[6][7][92] = int_stack + 186088;
 Libderiv->deriv2_classes[6][8][92] = int_stack + 187096;
 Libderiv->deriv2_classes[6][9][92] = int_stack + 188356;
 Libderiv->deriv2_classes[6][10][92] = int_stack + 189896;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 191744;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 192185;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 192773;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 193529;
 Libderiv->deriv2_classes[5][9][91] = int_stack + 194474;
 Libderiv->deriv2_classes[5][10][91] = int_stack + 195629;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 197015;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 197603;
 Libderiv->deriv2_classes[6][7][91] = int_stack + 198387;
 Libderiv->deriv2_classes[6][8][91] = int_stack + 199395;
 Libderiv->deriv2_classes[6][9][91] = int_stack + 200655;
 Libderiv->deriv2_classes[6][10][91] = int_stack + 202195;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 204043;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 204484;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 205072;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 205828;
 Libderiv->deriv2_classes[5][9][83] = int_stack + 206773;
 Libderiv->deriv2_classes[5][10][83] = int_stack + 207928;
 Libderiv->deriv_classes[6][5][11] = int_stack + 209314;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 209902;
 Libderiv->deriv_classes[6][6][11] = int_stack + 210490;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 211274;
 Libderiv->deriv_classes[6][7][11] = int_stack + 212058;
 Libderiv->deriv2_classes[6][7][83] = int_stack + 213066;
 Libderiv->deriv_classes[6][8][11] = int_stack + 214074;
 Libderiv->deriv2_classes[6][8][83] = int_stack + 215334;
 Libderiv->deriv_classes[6][9][11] = int_stack + 216594;
 Libderiv->deriv2_classes[6][9][83] = int_stack + 218134;
 Libderiv->deriv2_classes[6][10][83] = int_stack + 219674;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 221522;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 221963;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 222551;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 223307;
 Libderiv->deriv2_classes[5][9][82] = int_stack + 224252;
 Libderiv->deriv2_classes[5][10][82] = int_stack + 225407;
 Libderiv->deriv_classes[6][5][10] = int_stack + 226793;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 227381;
 Libderiv->deriv_classes[6][6][10] = int_stack + 227969;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 228753;
 Libderiv->deriv_classes[6][7][10] = int_stack + 229537;
 Libderiv->deriv2_classes[6][7][82] = int_stack + 230545;
 Libderiv->deriv_classes[6][8][10] = int_stack + 231553;
 Libderiv->deriv2_classes[6][8][82] = int_stack + 232813;
 Libderiv->deriv_classes[6][9][10] = int_stack + 234073;
 Libderiv->deriv2_classes[6][9][82] = int_stack + 235613;
 Libderiv->deriv2_classes[6][10][82] = int_stack + 237153;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 239001;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 239442;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 240030;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 240786;
 Libderiv->deriv2_classes[5][9][81] = int_stack + 241731;
 Libderiv->deriv2_classes[5][10][81] = int_stack + 242886;
 Libderiv->deriv_classes[6][5][9] = int_stack + 244272;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 244860;
 Libderiv->deriv_classes[6][6][9] = int_stack + 245448;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 246232;
 Libderiv->deriv_classes[6][7][9] = int_stack + 247016;
 Libderiv->deriv2_classes[6][7][81] = int_stack + 248024;
 Libderiv->deriv_classes[6][8][9] = int_stack + 249032;
 Libderiv->deriv2_classes[6][8][81] = int_stack + 250292;
 Libderiv->deriv_classes[6][9][9] = int_stack + 251552;
 Libderiv->deriv2_classes[6][9][81] = int_stack + 253092;
 Libderiv->deriv2_classes[6][10][81] = int_stack + 254632;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 256480;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 256921;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 257509;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 258265;
 Libderiv->deriv2_classes[5][9][80] = int_stack + 259210;
 Libderiv->deriv2_classes[5][10][80] = int_stack + 260365;
 Libderiv->deriv_classes[6][5][8] = int_stack + 261751;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 262339;
 Libderiv->deriv_classes[6][6][8] = int_stack + 262927;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 263711;
 Libderiv->deriv_classes[6][7][8] = int_stack + 264495;
 Libderiv->deriv2_classes[6][7][80] = int_stack + 265503;
 Libderiv->deriv_classes[6][8][8] = int_stack + 266511;
 Libderiv->deriv2_classes[6][8][80] = int_stack + 267771;
 Libderiv->deriv_classes[6][9][8] = int_stack + 269031;
 Libderiv->deriv2_classes[6][9][80] = int_stack + 270571;
 Libderiv->deriv2_classes[6][10][80] = int_stack + 272111;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 273959;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 274400;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 274988;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 275744;
 Libderiv->deriv2_classes[5][9][79] = int_stack + 276689;
 Libderiv->deriv2_classes[5][10][79] = int_stack + 277844;
 Libderiv->deriv_classes[6][5][7] = int_stack + 279230;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 279818;
 Libderiv->deriv_classes[6][6][7] = int_stack + 280406;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 281190;
 Libderiv->deriv_classes[6][7][7] = int_stack + 281974;
 Libderiv->deriv2_classes[6][7][79] = int_stack + 282982;
 Libderiv->deriv_classes[6][8][7] = int_stack + 283990;
 Libderiv->deriv2_classes[6][8][79] = int_stack + 285250;
 Libderiv->deriv_classes[6][9][7] = int_stack + 286510;
 Libderiv->deriv2_classes[6][9][79] = int_stack + 288050;
 Libderiv->deriv2_classes[6][10][79] = int_stack + 289590;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 291438;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 291879;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 292467;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 293223;
 Libderiv->deriv2_classes[5][9][78] = int_stack + 294168;
 Libderiv->deriv2_classes[5][10][78] = int_stack + 295323;
 Libderiv->dvrr_classes[6][5] = int_stack + 296709;
 Libderiv->deriv_classes[6][5][6] = int_stack + 297297;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 297885;
 Libderiv->dvrr_classes[6][6] = int_stack + 298473;
 Libderiv->deriv_classes[6][6][6] = int_stack + 299257;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 300041;
 Libderiv->dvrr_classes[6][7] = int_stack + 300825;
 Libderiv->deriv_classes[6][7][6] = int_stack + 301833;
 Libderiv->deriv2_classes[6][7][78] = int_stack + 302841;
 Libderiv->dvrr_classes[6][8] = int_stack + 303849;
 Libderiv->deriv_classes[6][8][6] = int_stack + 305109;
 Libderiv->deriv2_classes[6][8][78] = int_stack + 306369;
 Libderiv->deriv_classes[6][9][6] = int_stack + 307629;
 Libderiv->deriv2_classes[6][9][78] = int_stack + 309169;
 Libderiv->deriv2_classes[6][10][78] = int_stack + 310709;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 312557;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 312998;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 313586;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 314342;
 Libderiv->deriv2_classes[5][9][35] = int_stack + 315287;
 Libderiv->deriv2_classes[5][10][35] = int_stack + 316442;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 317828;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 318416;
 Libderiv->deriv2_classes[6][7][35] = int_stack + 319200;
 Libderiv->deriv2_classes[6][8][35] = int_stack + 320208;
 Libderiv->deriv2_classes[6][9][35] = int_stack + 321468;
 Libderiv->deriv2_classes[6][10][35] = int_stack + 323008;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 324856;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 325297;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 325885;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 326641;
 Libderiv->deriv2_classes[5][9][34] = int_stack + 327586;
 Libderiv->deriv2_classes[5][10][34] = int_stack + 328741;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 330127;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 330715;
 Libderiv->deriv2_classes[6][7][34] = int_stack + 331499;
 Libderiv->deriv2_classes[6][8][34] = int_stack + 332507;
 Libderiv->deriv2_classes[6][9][34] = int_stack + 333767;
 Libderiv->deriv2_classes[6][10][34] = int_stack + 335307;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 337155;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 337596;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 338184;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 338940;
 Libderiv->deriv2_classes[5][9][33] = int_stack + 339885;
 Libderiv->deriv2_classes[5][10][33] = int_stack + 341040;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 342426;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 343014;
 Libderiv->deriv2_classes[6][7][33] = int_stack + 343798;
 Libderiv->deriv2_classes[6][8][33] = int_stack + 344806;
 Libderiv->deriv2_classes[6][9][33] = int_stack + 346066;
 Libderiv->deriv2_classes[6][10][33] = int_stack + 347606;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 349454;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 349895;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 350483;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 351239;
 Libderiv->deriv2_classes[5][9][32] = int_stack + 352184;
 Libderiv->deriv2_classes[5][10][32] = int_stack + 353339;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 354725;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 355313;
 Libderiv->deriv2_classes[6][7][32] = int_stack + 356097;
 Libderiv->deriv2_classes[6][8][32] = int_stack + 357105;
 Libderiv->deriv2_classes[6][9][32] = int_stack + 358365;
 Libderiv->deriv2_classes[6][10][32] = int_stack + 359905;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 361753;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 362194;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 362782;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 363538;
 Libderiv->deriv2_classes[5][9][31] = int_stack + 364483;
 Libderiv->deriv2_classes[5][10][31] = int_stack + 365638;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 367024;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 367612;
 Libderiv->deriv2_classes[6][7][31] = int_stack + 368396;
 Libderiv->deriv2_classes[6][8][31] = int_stack + 369404;
 Libderiv->deriv2_classes[6][9][31] = int_stack + 370664;
 Libderiv->deriv2_classes[6][10][31] = int_stack + 372204;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 374052;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 374493;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 375081;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 375837;
 Libderiv->deriv2_classes[5][9][30] = int_stack + 376782;
 Libderiv->deriv2_classes[5][10][30] = int_stack + 377937;
 Libderiv->deriv_classes[6][5][2] = int_stack + 379323;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 379911;
 Libderiv->deriv_classes[6][6][2] = int_stack + 380499;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 381283;
 Libderiv->deriv_classes[6][7][2] = int_stack + 382067;
 Libderiv->deriv2_classes[6][7][30] = int_stack + 383075;
 Libderiv->deriv_classes[6][8][2] = int_stack + 384083;
 Libderiv->deriv2_classes[6][8][30] = int_stack + 385343;
 Libderiv->deriv_classes[6][9][2] = int_stack + 386603;
 Libderiv->deriv2_classes[6][9][30] = int_stack + 388143;
 Libderiv->deriv2_classes[6][10][30] = int_stack + 389683;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 391531;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 391972;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 392560;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 393316;
 Libderiv->deriv2_classes[5][9][26] = int_stack + 394261;
 Libderiv->deriv2_classes[5][10][26] = int_stack + 395416;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 396802;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 397390;
 Libderiv->deriv2_classes[6][7][26] = int_stack + 398174;
 Libderiv->deriv2_classes[6][8][26] = int_stack + 399182;
 Libderiv->deriv2_classes[6][9][26] = int_stack + 400442;
 Libderiv->deriv2_classes[6][10][26] = int_stack + 401982;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 403830;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 404271;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 404859;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 405615;
 Libderiv->deriv2_classes[5][9][23] = int_stack + 406560;
 Libderiv->deriv2_classes[5][10][23] = int_stack + 407715;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 409101;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 409689;
 Libderiv->deriv2_classes[6][7][23] = int_stack + 410473;
 Libderiv->deriv2_classes[6][8][23] = int_stack + 411481;
 Libderiv->deriv2_classes[6][9][23] = int_stack + 412741;
 Libderiv->deriv2_classes[6][10][23] = int_stack + 414281;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 416129;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 416570;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 417158;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 417914;
 Libderiv->deriv2_classes[5][9][22] = int_stack + 418859;
 Libderiv->deriv2_classes[5][10][22] = int_stack + 420014;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 421400;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 421988;
 Libderiv->deriv2_classes[6][7][22] = int_stack + 422772;
 Libderiv->deriv2_classes[6][8][22] = int_stack + 423780;
 Libderiv->deriv2_classes[6][9][22] = int_stack + 425040;
 Libderiv->deriv2_classes[6][10][22] = int_stack + 426580;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 428428;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 428869;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 429457;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 430213;
 Libderiv->deriv2_classes[5][9][21] = int_stack + 431158;
 Libderiv->deriv2_classes[5][10][21] = int_stack + 432313;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 433699;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 434287;
 Libderiv->deriv2_classes[6][7][21] = int_stack + 435071;
 Libderiv->deriv2_classes[6][8][21] = int_stack + 436079;
 Libderiv->deriv2_classes[6][9][21] = int_stack + 437339;
 Libderiv->deriv2_classes[6][10][21] = int_stack + 438879;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 440727;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 441168;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 441756;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 442512;
 Libderiv->deriv2_classes[5][9][20] = int_stack + 443457;
 Libderiv->deriv2_classes[5][10][20] = int_stack + 444612;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 445998;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 446586;
 Libderiv->deriv2_classes[6][7][20] = int_stack + 447370;
 Libderiv->deriv2_classes[6][8][20] = int_stack + 448378;
 Libderiv->deriv2_classes[6][9][20] = int_stack + 449638;
 Libderiv->deriv2_classes[6][10][20] = int_stack + 451178;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 453026;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 453467;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 454055;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 454811;
 Libderiv->deriv2_classes[5][9][19] = int_stack + 455756;
 Libderiv->deriv2_classes[5][10][19] = int_stack + 456911;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 458297;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 458885;
 Libderiv->deriv2_classes[6][7][19] = int_stack + 459669;
 Libderiv->deriv2_classes[6][8][19] = int_stack + 460677;
 Libderiv->deriv2_classes[6][9][19] = int_stack + 461937;
 Libderiv->deriv2_classes[6][10][19] = int_stack + 463477;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 465325;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 465766;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 466354;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 467110;
 Libderiv->deriv2_classes[5][9][18] = int_stack + 468055;
 Libderiv->deriv2_classes[5][10][18] = int_stack + 469210;
 Libderiv->deriv_classes[6][5][1] = int_stack + 470596;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 471184;
 Libderiv->deriv_classes[6][6][1] = int_stack + 471772;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 472556;
 Libderiv->deriv_classes[6][7][1] = int_stack + 473340;
 Libderiv->deriv2_classes[6][7][18] = int_stack + 474348;
 Libderiv->deriv_classes[6][8][1] = int_stack + 475356;
 Libderiv->deriv2_classes[6][8][18] = int_stack + 476616;
 Libderiv->deriv_classes[6][9][1] = int_stack + 477876;
 Libderiv->deriv2_classes[6][9][18] = int_stack + 479416;
 Libderiv->deriv2_classes[6][10][18] = int_stack + 480956;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 482804;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 483245;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 483833;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 484589;
 Libderiv->deriv2_classes[5][9][14] = int_stack + 485534;
 Libderiv->deriv2_classes[5][10][14] = int_stack + 486689;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 488075;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 488663;
 Libderiv->deriv2_classes[6][7][14] = int_stack + 489447;
 Libderiv->deriv2_classes[6][8][14] = int_stack + 490455;
 Libderiv->deriv2_classes[6][9][14] = int_stack + 491715;
 Libderiv->deriv2_classes[6][10][14] = int_stack + 493255;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 495103;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 495544;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 496132;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 496888;
 Libderiv->deriv2_classes[5][9][13] = int_stack + 497833;
 Libderiv->deriv2_classes[5][10][13] = int_stack + 498988;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 500374;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 500962;
 Libderiv->deriv2_classes[6][7][13] = int_stack + 501746;
 Libderiv->deriv2_classes[6][8][13] = int_stack + 502754;
 Libderiv->deriv2_classes[6][9][13] = int_stack + 504014;
 Libderiv->deriv2_classes[6][10][13] = int_stack + 505554;
 Libderiv->deriv_classes[5][5][11] = int_stack + 507402;
 Libderiv->deriv_classes[5][6][11] = int_stack + 507843;
 Libderiv->deriv_classes[5][7][11] = int_stack + 508431;
 Libderiv->deriv_classes[5][8][11] = int_stack + 509187;
 Libderiv->deriv_classes[5][9][11] = int_stack + 510132;
 Libderiv->deriv_classes[5][10][11] = int_stack + 511287;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 512673;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 513114;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 513702;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 514458;
 Libderiv->deriv2_classes[5][9][11] = int_stack + 515403;
 Libderiv->deriv2_classes[5][10][11] = int_stack + 516558;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 517944;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 518532;
 Libderiv->deriv2_classes[6][7][11] = int_stack + 519316;
 Libderiv->deriv2_classes[6][8][11] = int_stack + 520324;
 Libderiv->deriv2_classes[6][9][11] = int_stack + 521584;
 Libderiv->deriv2_classes[6][10][11] = int_stack + 523124;
 Libderiv->deriv_classes[5][5][10] = int_stack + 524972;
 Libderiv->deriv_classes[5][6][10] = int_stack + 525413;
 Libderiv->deriv_classes[5][7][10] = int_stack + 526001;
 Libderiv->deriv_classes[5][8][10] = int_stack + 526757;
 Libderiv->deriv_classes[5][9][10] = int_stack + 527702;
 Libderiv->deriv_classes[5][10][10] = int_stack + 528857;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 530243;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 530684;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 531272;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 532028;
 Libderiv->deriv2_classes[5][9][10] = int_stack + 532973;
 Libderiv->deriv2_classes[5][10][10] = int_stack + 534128;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 535514;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 536102;
 Libderiv->deriv2_classes[6][7][10] = int_stack + 536886;
 Libderiv->deriv2_classes[6][8][10] = int_stack + 537894;
 Libderiv->deriv2_classes[6][9][10] = int_stack + 539154;
 Libderiv->deriv2_classes[6][10][10] = int_stack + 540694;
 Libderiv->deriv_classes[5][5][9] = int_stack + 542542;
 Libderiv->deriv_classes[5][6][9] = int_stack + 542983;
 Libderiv->deriv_classes[5][7][9] = int_stack + 543571;
 Libderiv->deriv_classes[5][8][9] = int_stack + 544327;
 Libderiv->deriv_classes[5][9][9] = int_stack + 545272;
 Libderiv->deriv_classes[5][10][9] = int_stack + 546427;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 547813;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 548254;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 548842;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 549598;
 Libderiv->deriv2_classes[5][9][9] = int_stack + 550543;
 Libderiv->deriv2_classes[5][10][9] = int_stack + 551698;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 553084;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 553672;
 Libderiv->deriv2_classes[6][7][9] = int_stack + 554456;
 Libderiv->deriv2_classes[6][8][9] = int_stack + 555464;
 Libderiv->deriv2_classes[6][9][9] = int_stack + 556724;
 Libderiv->deriv2_classes[6][10][9] = int_stack + 558264;
 Libderiv->deriv_classes[5][5][8] = int_stack + 560112;
 Libderiv->deriv_classes[5][6][8] = int_stack + 560553;
 Libderiv->deriv_classes[5][7][8] = int_stack + 561141;
 Libderiv->deriv_classes[5][8][8] = int_stack + 561897;
 Libderiv->deriv_classes[5][9][8] = int_stack + 562842;
 Libderiv->deriv_classes[5][10][8] = int_stack + 563997;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 565383;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 565824;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 566412;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 567168;
 Libderiv->deriv2_classes[5][9][8] = int_stack + 568113;
 Libderiv->deriv2_classes[5][10][8] = int_stack + 569268;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 570654;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 571242;
 Libderiv->deriv2_classes[6][7][8] = int_stack + 572026;
 Libderiv->deriv2_classes[6][8][8] = int_stack + 573034;
 Libderiv->deriv2_classes[6][9][8] = int_stack + 574294;
 Libderiv->deriv2_classes[6][10][8] = int_stack + 575834;
 Libderiv->deriv_classes[5][5][7] = int_stack + 577682;
 Libderiv->deriv_classes[5][6][7] = int_stack + 578123;
 Libderiv->deriv_classes[5][7][7] = int_stack + 578711;
 Libderiv->deriv_classes[5][8][7] = int_stack + 579467;
 Libderiv->deriv_classes[5][9][7] = int_stack + 580412;
 Libderiv->deriv_classes[5][10][7] = int_stack + 581567;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 582953;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 583394;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 583982;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 584738;
 Libderiv->deriv2_classes[5][9][7] = int_stack + 585683;
 Libderiv->deriv2_classes[5][10][7] = int_stack + 586838;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 588224;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 588812;
 Libderiv->deriv2_classes[6][7][7] = int_stack + 589596;
 Libderiv->deriv2_classes[6][8][7] = int_stack + 590604;
 Libderiv->deriv2_classes[6][9][7] = int_stack + 591864;
 Libderiv->deriv2_classes[6][10][7] = int_stack + 593404;
 Libderiv->dvrr_classes[5][5] = int_stack + 595252;
 Libderiv->deriv_classes[5][5][6] = int_stack + 595693;
 Libderiv->dvrr_classes[5][6] = int_stack + 596134;
 Libderiv->deriv_classes[5][6][6] = int_stack + 596722;
 Libderiv->dvrr_classes[5][7] = int_stack + 597310;
 Libderiv->deriv_classes[5][7][6] = int_stack + 598066;
 Libderiv->dvrr_classes[5][8] = int_stack + 598822;
 Libderiv->deriv_classes[5][8][6] = int_stack + 599767;
 Libderiv->dvrr_classes[5][9] = int_stack + 600712;
 Libderiv->deriv_classes[5][9][6] = int_stack + 601867;
 Libderiv->deriv_classes[5][10][6] = int_stack + 603022;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 604408;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 604849;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 605437;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 606193;
 Libderiv->deriv2_classes[5][9][6] = int_stack + 607138;
 Libderiv->deriv2_classes[5][10][6] = int_stack + 608293;
 Libderiv->deriv_classes[6][5][0] = int_stack + 609679;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 610267;
 Libderiv->deriv_classes[6][6][0] = int_stack + 610855;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 611639;
 Libderiv->deriv_classes[6][7][0] = int_stack + 612423;
 Libderiv->deriv2_classes[6][7][6] = int_stack + 613431;
 Libderiv->deriv_classes[6][8][0] = int_stack + 614439;
 Libderiv->deriv2_classes[6][8][6] = int_stack + 615699;
 Libderiv->deriv_classes[6][9][0] = int_stack + 616959;
 Libderiv->deriv2_classes[6][9][6] = int_stack + 618499;
 Libderiv->deriv2_classes[6][10][6] = int_stack + 620039;
 Libderiv->deriv_classes[5][5][2] = int_stack + 621887;
 Libderiv->deriv_classes[5][6][2] = int_stack + 622328;
 Libderiv->deriv_classes[5][7][2] = int_stack + 622916;
 Libderiv->deriv_classes[5][8][2] = int_stack + 623672;
 Libderiv->deriv_classes[5][9][2] = int_stack + 624617;
 Libderiv->deriv_classes[5][10][2] = int_stack + 625772;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 627158;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 627599;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 628187;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 628943;
 Libderiv->deriv2_classes[5][9][2] = int_stack + 629888;
 Libderiv->deriv2_classes[5][10][2] = int_stack + 631043;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 632429;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 633017;
 Libderiv->deriv2_classes[6][7][2] = int_stack + 633801;
 Libderiv->deriv2_classes[6][8][2] = int_stack + 634809;
 Libderiv->deriv2_classes[6][9][2] = int_stack + 636069;
 Libderiv->deriv2_classes[6][10][2] = int_stack + 637609;
 Libderiv->deriv_classes[5][5][1] = int_stack + 639457;
 Libderiv->deriv_classes[5][6][1] = int_stack + 639898;
 Libderiv->deriv_classes[5][7][1] = int_stack + 640486;
 Libderiv->deriv_classes[5][8][1] = int_stack + 641242;
 Libderiv->deriv_classes[5][9][1] = int_stack + 642187;
 Libderiv->deriv_classes[5][10][1] = int_stack + 643342;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 644728;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 645169;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 645757;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 646513;
 Libderiv->deriv2_classes[5][9][1] = int_stack + 647458;
 Libderiv->deriv2_classes[5][10][1] = int_stack + 648613;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 649999;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 650587;
 Libderiv->deriv2_classes[6][7][1] = int_stack + 651371;
 Libderiv->deriv2_classes[6][8][1] = int_stack + 652379;
 Libderiv->deriv2_classes[6][9][1] = int_stack + 653639;
 Libderiv->deriv2_classes[6][10][1] = int_stack + 655179;
 Libderiv->deriv_classes[5][5][0] = int_stack + 657027;
 Libderiv->deriv_classes[5][6][0] = int_stack + 657468;
 Libderiv->deriv_classes[5][7][0] = int_stack + 658056;
 Libderiv->deriv_classes[5][8][0] = int_stack + 658812;
 Libderiv->deriv_classes[5][9][0] = int_stack + 659757;
 Libderiv->deriv_classes[5][10][0] = int_stack + 660912;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 662298;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 662739;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 663327;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 664083;
 Libderiv->deriv2_classes[5][9][0] = int_stack + 665028;
 Libderiv->deriv2_classes[5][10][0] = int_stack + 666183;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 667569;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 668157;
 Libderiv->deriv2_classes[6][7][0] = int_stack + 668941;
 Libderiv->deriv2_classes[6][8][0] = int_stack + 669949;
 Libderiv->deriv2_classes[6][9][0] = int_stack + 671209;
 Libderiv->deriv2_classes[6][10][0] = int_stack + 672749;
 memset(int_stack,0,5396776);

 Libderiv->dvrr_stack = int_stack + 1823269;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_hphh(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+674597,int_stack+596134,int_stack+595252,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+675920,int_stack+597310,int_stack+596134,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+677684,int_stack+675920,int_stack+674597,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+680330,int_stack+598822,int_stack+597310,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+682598,int_stack+680330,int_stack+675920,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+686126,int_stack+682598,int_stack+677684,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+690536,int_stack+600712,int_stack+598822,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+693371,int_stack+690536,int_stack+680330,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+697907,int_stack+693371,int_stack+682598,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+703787,int_stack+697907,int_stack+686126,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+710402,int_stack+507843,int_stack+507402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595252,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+711725,int_stack+508431,int_stack+507843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596134,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+713489,int_stack+711725,int_stack+710402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+716135,int_stack+509187,int_stack+508431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597310,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+718403,int_stack+716135,int_stack+711725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675920,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+721931,int_stack+718403,int_stack+713489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677684,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+726341,int_stack+510132,int_stack+509187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598822,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+729176,int_stack+726341,int_stack+716135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680330,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+733712,int_stack+729176,int_stack+718403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682598,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+739592,int_stack+733712,int_stack+721931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686126,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+746207,int_stack+511287,int_stack+510132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600712,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+749672,int_stack+746207,int_stack+726341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690536,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+755342,int_stack+749672,int_stack+729176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693371,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+746207,int_stack+755342,int_stack+733712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697907,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+755027,int_stack+746207,int_stack+739592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703787,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+746207,int_stack+298473,int_stack+296709,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+747971,int_stack+300825,int_stack+298473,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+750323,int_stack+747971,int_stack+746207,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+764288,int_stack+303849,int_stack+300825,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+767312,int_stack+764288,int_stack+747971,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+772016,int_stack+767312,int_stack+750323,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+777896,int_stack+9240,int_stack+303849,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+781676,int_stack+777896,int_stack+764288,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+787724,int_stack+781676,int_stack+767312,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+795564,int_stack+787724,int_stack+772016,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+804384,int_stack+210490,int_stack+209314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296709,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+806148,int_stack+212058,int_stack+210490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298473,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+808500,int_stack+806148,int_stack+804384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+812028,int_stack+214074,int_stack+212058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300825,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+815052,int_stack+812028,int_stack+806148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747971,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+819756,int_stack+815052,int_stack+808500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750323,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825636,int_stack+216594,int_stack+214074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303849,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+829416,int_stack+825636,int_stack+812028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+835464,int_stack+829416,int_stack+815052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767312,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+843304,int_stack+835464,int_stack+819756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772016,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+852124,int_stack+0,int_stack+216594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+856744,int_stack+852124,int_stack+825636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777896,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+864304,int_stack+856744,int_stack+829416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781676,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+852124,int_stack+864304,int_stack+835464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787724,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+863884,int_stack+852124,int_stack+843304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795564,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+852124,int_stack+525413,int_stack+524972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595252, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+853447,int_stack+526001,int_stack+525413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596134, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+855211,int_stack+853447,int_stack+852124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+857857,int_stack+526757,int_stack+526001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597310, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+860125,int_stack+857857,int_stack+853447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675920, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+876232,int_stack+860125,int_stack+855211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677684, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+880642,int_stack+527702,int_stack+526757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598822, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+883477,int_stack+880642,int_stack+857857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680330, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+888013,int_stack+883477,int_stack+860125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682598, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+893893,int_stack+888013,int_stack+876232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686126, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+900508,int_stack+528857,int_stack+527702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600712, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+903973,int_stack+900508,int_stack+880642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690536, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+909643,int_stack+903973,int_stack+883477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693371, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+900508,int_stack+909643,int_stack+888013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697907, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+909328,int_stack+900508,int_stack+893893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703787, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+900508,int_stack+227969,int_stack+226793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296709, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+902272,int_stack+229537,int_stack+227969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298473, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+904624,int_stack+902272,int_stack+900508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+918589,int_stack+231553,int_stack+229537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300825, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+921613,int_stack+918589,int_stack+902272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747971, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+926317,int_stack+921613,int_stack+904624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750323, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+932197,int_stack+234073,int_stack+231553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303849, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+935977,int_stack+932197,int_stack+918589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+942025,int_stack+935977,int_stack+921613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767312, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+949865,int_stack+942025,int_stack+926317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772016, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+958685,int_stack+1848,int_stack+234073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+963305,int_stack+958685,int_stack+932197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777896, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+970865,int_stack+963305,int_stack+935977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781676, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+958685,int_stack+970865,int_stack+942025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787724, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+970445,int_stack+958685,int_stack+949865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795564, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+958685,int_stack+542983,int_stack+542542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595252, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+960008,int_stack+543571,int_stack+542983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596134, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+961772,int_stack+960008,int_stack+958685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+964418,int_stack+544327,int_stack+543571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597310, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+966686,int_stack+964418,int_stack+960008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675920, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+982793,int_stack+966686,int_stack+961772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677684, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+545272,int_stack+544327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598822, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+987203,int_stack+0,int_stack+964418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680330, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+991739,int_stack+987203,int_stack+966686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682598, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+997619,int_stack+991739,int_stack+982793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686126, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1004234,int_stack+546427,int_stack+545272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600712, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1007699,int_stack+1004234,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690536, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1013369,int_stack+1007699,int_stack+987203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693371, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1004234,int_stack+1013369,int_stack+991739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697907, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1013054,int_stack+1004234,int_stack+997619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703787, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1004234,int_stack+245448,int_stack+244272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296709, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1005998,int_stack+247016,int_stack+245448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298473, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1008350,int_stack+1005998,int_stack+1004234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1022315,int_stack+249032,int_stack+247016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300825, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1025339,int_stack+1022315,int_stack+1005998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747971, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1030043,int_stack+1025339,int_stack+1008350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750323, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1035923,int_stack+251552,int_stack+249032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303849, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1039703,int_stack+1035923,int_stack+1022315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1045751,int_stack+1039703,int_stack+1025339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767312, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1053591,int_stack+1045751,int_stack+1030043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772016, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1062411,int_stack+3696,int_stack+251552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1067031,int_stack+1062411,int_stack+1035923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777896, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1074591,int_stack+1067031,int_stack+1039703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781676, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1062411,int_stack+1074591,int_stack+1045751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787724, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1074171,int_stack+1062411,int_stack+1053591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795564, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1062411,int_stack+560553,int_stack+560112, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1063734,int_stack+561141,int_stack+560553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1065498,int_stack+1063734,int_stack+1062411, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068144,int_stack+561897,int_stack+561141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1070412,int_stack+1068144,int_stack+1063734, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1086519,int_stack+1070412,int_stack+1065498, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1090929,int_stack+562842,int_stack+561897, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1093764,int_stack+1090929,int_stack+1068144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+680330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1098300,int_stack+1093764,int_stack+1070412, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+682598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1104180,int_stack+1098300,int_stack+1086519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+686126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1110795,int_stack+563997,int_stack+562842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1114260,int_stack+1110795,int_stack+1090929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1119930,int_stack+1114260,int_stack+1093764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1110795,int_stack+1119930,int_stack+1098300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+697907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1119615,int_stack+1110795,int_stack+1104180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1110795,int_stack+262927,int_stack+261751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+296709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1112559,int_stack+264495,int_stack+262927, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1114911,int_stack+1112559,int_stack+1110795, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1128876,int_stack+266511,int_stack+264495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1131900,int_stack+1128876,int_stack+1112559, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1136604,int_stack+1131900,int_stack+1114911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+750323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1142484,int_stack+269031,int_stack+266511, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1146264,int_stack+1142484,int_stack+1128876, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1152312,int_stack+1146264,int_stack+1131900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1160152,int_stack+1152312,int_stack+1136604, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1168972,int_stack+5544,int_stack+269031, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1173592,int_stack+1168972,int_stack+1142484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1181152,int_stack+1173592,int_stack+1146264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+781676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1168972,int_stack+1181152,int_stack+1152312, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+787724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1180732,int_stack+1168972,int_stack+1160152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1168972,int_stack+578123,int_stack+577682, 0.0, zero_stack, 1.0, int_stack+595252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1170295,int_stack+578711,int_stack+578123, 0.0, zero_stack, 1.0, int_stack+596134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1172059,int_stack+1170295,int_stack+1168972, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1174705,int_stack+579467,int_stack+578711, 0.0, zero_stack, 1.0, int_stack+597310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1176973,int_stack+1174705,int_stack+1170295, 0.0, zero_stack, 1.0, int_stack+675920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2835,int_stack+1176973,int_stack+1172059, 0.0, zero_stack, 1.0, int_stack+677684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1193080,int_stack+580412,int_stack+579467, 0.0, zero_stack, 1.0, int_stack+598822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1195915,int_stack+1193080,int_stack+1174705, 0.0, zero_stack, 1.0, int_stack+680330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1200451,int_stack+1195915,int_stack+1176973, 0.0, zero_stack, 1.0, int_stack+682598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1206331,int_stack+1200451,int_stack+2835, 0.0, zero_stack, 1.0, int_stack+686126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1212946,int_stack+581567,int_stack+580412, 0.0, zero_stack, 1.0, int_stack+600712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1216411,int_stack+1212946,int_stack+1193080, 0.0, zero_stack, 1.0, int_stack+690536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1222081,int_stack+1216411,int_stack+1195915, 0.0, zero_stack, 1.0, int_stack+693371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1212946,int_stack+1222081,int_stack+1200451, 0.0, zero_stack, 1.0, int_stack+697907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1221766,int_stack+1212946,int_stack+1206331, 0.0, zero_stack, 1.0, int_stack+703787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1212946,int_stack+280406,int_stack+279230, 0.0, zero_stack, 1.0, int_stack+296709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1214710,int_stack+281974,int_stack+280406, 0.0, zero_stack, 1.0, int_stack+298473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1217062,int_stack+1214710,int_stack+1212946, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1231027,int_stack+283990,int_stack+281974, 0.0, zero_stack, 1.0, int_stack+300825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1234051,int_stack+1231027,int_stack+1214710, 0.0, zero_stack, 1.0, int_stack+747971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1238755,int_stack+1234051,int_stack+1217062, 0.0, zero_stack, 1.0, int_stack+750323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1244635,int_stack+286510,int_stack+283990, 0.0, zero_stack, 1.0, int_stack+303849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1248415,int_stack+1244635,int_stack+1231027, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1254463,int_stack+1248415,int_stack+1234051, 0.0, zero_stack, 1.0, int_stack+767312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1262303,int_stack+1254463,int_stack+1238755, 0.0, zero_stack, 1.0, int_stack+772016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1271123,int_stack+7392,int_stack+286510, 0.0, zero_stack, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1275743,int_stack+1271123,int_stack+1244635, 0.0, zero_stack, 1.0, int_stack+777896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1283303,int_stack+1275743,int_stack+1248415, 0.0, zero_stack, 1.0, int_stack+781676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1271123,int_stack+1283303,int_stack+1254463, 0.0, zero_stack, 1.0, int_stack+787724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1282883,int_stack+1271123,int_stack+1262303, 0.0, zero_stack, 1.0, int_stack+795564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1271123,int_stack+596722,int_stack+595693, 1.0, int_stack+595252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1272446,int_stack+598066,int_stack+596722, 1.0, int_stack+596134, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1274210,int_stack+1272446,int_stack+1271123, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1276856,int_stack+599767,int_stack+598066, 1.0, int_stack+597310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1279124,int_stack+1276856,int_stack+1272446, 1.0, int_stack+675920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1295231,int_stack+1279124,int_stack+1274210, 1.0, int_stack+677684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+674597,int_stack+601867,int_stack+599767, 1.0, int_stack+598822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1299641,int_stack+674597,int_stack+1276856, 1.0, int_stack+680330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1304177,int_stack+1299641,int_stack+1279124, 1.0, int_stack+682598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+677432,int_stack+1304177,int_stack+1295231, 1.0, int_stack+686126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+684047,int_stack+603022,int_stack+601867, 1.0, int_stack+600712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1310057,int_stack+684047,int_stack+674597, 1.0, int_stack+690536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1315727,int_stack+1310057,int_stack+1299641, 1.0, int_stack+693371, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1323287,int_stack+1315727,int_stack+1304177, 1.0, int_stack+697907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1310057,int_stack+1323287,int_stack+677432, 1.0, int_stack+703787, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1319318,int_stack+299257,int_stack+297297, 1.0, int_stack+296709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1321082,int_stack+301833,int_stack+299257, 1.0, int_stack+298473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1323434,int_stack+1321082,int_stack+1319318, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1326962,int_stack+305109,int_stack+301833, 1.0, int_stack+300825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+684047,int_stack+1326962,int_stack+1321082, 1.0, int_stack+747971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1329986,int_stack+684047,int_stack+1323434, 1.0, int_stack+750323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+746207,int_stack+307629,int_stack+305109, 1.0, int_stack+303849, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1335866,int_stack+746207,int_stack+1326962, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1341914,int_stack+1335866,int_stack+684047, 1.0, int_stack+767312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1349754,int_stack+1341914,int_stack+1329986, 1.0, int_stack+772016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+764288,int_stack+10780,int_stack+307629, 1.0, int_stack+9240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+768908,int_stack+764288,int_stack+746207, 1.0, int_stack+777896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1358574,int_stack+768908,int_stack+1335866, 1.0, int_stack+781676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+764288,int_stack+1358574,int_stack+1341914, 1.0, int_stack+787724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+776048,int_stack+764288,int_stack+1349754, 1.0, int_stack+795564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+764288,int_stack+16324,int_stack+600712,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+767753,int_stack+764288,int_stack+690536,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1358574,int_stack+767753,int_stack+693371,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+764288,int_stack+1358574,int_stack+697907,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1358574,int_stack+764288,int_stack+703787,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+622328,int_stack+621887,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+622916,int_stack+622328,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+623672,int_stack+622916,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+788396,int_stack+772289,int_stack+767375,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+792806,int_stack+624617,int_stack+623672,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+795641,int_stack+792806,int_stack+770021,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+688751,int_stack+795641,int_stack+772289,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+694631,int_stack+688751,int_stack+788396,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+800177,int_stack+625772,int_stack+624617,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+701246,int_stack+800177,int_stack+792806,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1367835,int_stack+701246,int_stack+795641,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+701246,int_stack+1367835,int_stack+688751,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1367835,int_stack+701246,int_stack+694631,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+701246,int_stack+380499,int_stack+379323,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+703010,int_stack+382067,int_stack+380499,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+705362,int_stack+703010,int_stack+701246,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+800177,int_stack+384083,int_stack+382067,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+749987,int_stack+800177,int_stack+703010,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1377096,int_stack+749987,int_stack+705362,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+7245,int_stack+386603,int_stack+384083,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1382976,int_stack+7245,int_stack+800177,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1389024,int_stack+1382976,int_stack+749987,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1396864,int_stack+1389024,int_stack+1377096,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1405684,int_stack+12628,int_stack+386603,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1410304,int_stack+1405684,int_stack+7245,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1417864,int_stack+1410304,int_stack+1382976,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1405684,int_stack+1417864,int_stack+1389024,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1417444,int_stack+1405684,int_stack+1396864,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1405684,int_stack+639898,int_stack+639457,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1407007,int_stack+640486,int_stack+639898,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1408771,int_stack+1407007,int_stack+1405684,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1411417,int_stack+641242,int_stack+640486,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1413685,int_stack+1411417,int_stack+1407007,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1429792,int_stack+1413685,int_stack+1408771,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+11025,int_stack+642187,int_stack+641242,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1434202,int_stack+11025,int_stack+1411417,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1438738,int_stack+1434202,int_stack+1413685,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1444618,int_stack+1438738,int_stack+1429792,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1451233,int_stack+643342,int_stack+642187,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1454698,int_stack+1451233,int_stack+11025,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1460368,int_stack+1454698,int_stack+1434202,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1451233,int_stack+1460368,int_stack+1438738,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1460053,int_stack+1451233,int_stack+1444618,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1451233,int_stack+471772,int_stack+470596,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1452997,int_stack+473340,int_stack+471772,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1455349,int_stack+1452997,int_stack+1451233,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1469314,int_stack+475356,int_stack+473340,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1472338,int_stack+1469314,int_stack+1452997,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1477042,int_stack+1472338,int_stack+1455349,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1482922,int_stack+477876,int_stack+475356,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1486702,int_stack+1482922,int_stack+1469314,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1492750,int_stack+1486702,int_stack+1472338,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1500590,int_stack+1492750,int_stack+1477042,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1509410,int_stack+14476,int_stack+477876,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1514030,int_stack+1509410,int_stack+1482922,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1521590,int_stack+1514030,int_stack+1486702,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1509410,int_stack+1521590,int_stack+1492750,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1521170,int_stack+1509410,int_stack+1500590,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1509410,int_stack+657468,int_stack+657027,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1510733,int_stack+658056,int_stack+657468,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1512497,int_stack+1510733,int_stack+1509410,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1515143,int_stack+658812,int_stack+658056,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1517411,int_stack+1515143,int_stack+1510733,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1533518,int_stack+1517411,int_stack+1512497,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+13860,int_stack+659757,int_stack+658812,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1537928,int_stack+13860,int_stack+1515143,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1542464,int_stack+1537928,int_stack+1517411,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1548344,int_stack+1542464,int_stack+1533518,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1554959,int_stack+660912,int_stack+659757,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1558424,int_stack+1554959,int_stack+13860,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1564094,int_stack+1558424,int_stack+1537928,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1554959,int_stack+1564094,int_stack+1542464,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1563779,int_stack+1554959,int_stack+1548344,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1554959,int_stack+610855,int_stack+609679,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1556723,int_stack+612423,int_stack+610855,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1559075,int_stack+1556723,int_stack+1554959,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1573040,int_stack+614439,int_stack+612423,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1576064,int_stack+1573040,int_stack+1556723,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1580768,int_stack+1576064,int_stack+1559075,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1586648,int_stack+616959,int_stack+614439,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1590428,int_stack+1586648,int_stack+1573040,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1596476,int_stack+1590428,int_stack+1576064,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1604316,int_stack+1596476,int_stack+1580768,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1613136,int_stack+17710,int_stack+616959,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1617756,int_stack+1613136,int_stack+1586648,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1625316,int_stack+1617756,int_stack+1590428,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1613136,int_stack+1625316,int_stack+1596476,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1624896,int_stack+1613136,int_stack+1604316,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1613136,int_stack+19999,int_stack+19558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+507402,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1614459,int_stack+20587,int_stack+19999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+507843,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1616223,int_stack+1614459,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+710402,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1618869,int_stack+21343,int_stack+20587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+508431,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1621137,int_stack+1618869,int_stack+1614459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+711725,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16695,int_stack+1621137,int_stack+1616223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+713489,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1613136,int_stack+22288,int_stack+21343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+509187,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1637244,int_stack+1613136,int_stack+1618869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+716135,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1641780,int_stack+1637244,int_stack+1621137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+718403,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1615971,int_stack+1641780,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+721931,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16695,int_stack+23443,int_stack+22288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+510132,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1647660,int_stack+16695,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+726341,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+16695,int_stack+1647660,int_stack+1637244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+729176,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1647660,int_stack+16695,int_stack+1641780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+733712,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1637244,int_stack+1647660,int_stack+1615971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+739592,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16695,int_stack+25417,int_stack+24829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+209314,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18459,int_stack+26201,int_stack+25417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+210490,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+20811,int_stack+18459,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+804384,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1646505,int_stack+27209,int_stack+26201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+212058,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1649529,int_stack+1646505,int_stack+18459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+806148,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1613136,int_stack+1649529,int_stack+20811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+808500,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16695,int_stack+28469,int_stack+27209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+214074,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+20475,int_stack+16695,int_stack+1646505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+812028,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1654233,int_stack+20475,int_stack+1649529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+815052,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1662073,int_stack+1654233,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+819756,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1613136,int_stack+30009,int_stack+28469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+216594,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1646505,int_stack+1613136,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+825636,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1613136,int_stack+1646505,int_stack+20475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+829416,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+16695,int_stack+1613136,int_stack+1654233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+835464,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1646505,int_stack+16695,int_stack+1662073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+843304,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16695,int_stack+32298,int_stack+31857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507402, 1.0, int_stack+524972,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+18018,int_stack+32886,int_stack+32298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507843, 1.0, int_stack+525413,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+19782,int_stack+18018,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710402, 1.0, int_stack+852124,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+22428,int_stack+33642,int_stack+32886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508431, 1.0, int_stack+526001,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24696,int_stack+22428,int_stack+18018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711725, 1.0, int_stack+853447,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+28224,int_stack+24696,int_stack+19782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713489, 1.0, int_stack+855211,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+16695,int_stack+34587,int_stack+33642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509187, 1.0, int_stack+526757,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1613136,int_stack+16695,int_stack+22428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+716135, 1.0, int_stack+857857,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1617672,int_stack+1613136,int_stack+24696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718403, 1.0, int_stack+860125,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+19530,int_stack+1617672,int_stack+28224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721931, 1.0, int_stack+876232,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+26145,int_stack+35742,int_stack+34587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510132, 1.0, int_stack+527702,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+29610,int_stack+26145,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726341, 1.0, int_stack+880642,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1658853,int_stack+29610,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729176, 1.0, int_stack+883477,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+26145,int_stack+1658853,int_stack+1617672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733712, 1.0, int_stack+888013,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1658853,int_stack+26145,int_stack+19530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+739592, 1.0, int_stack+893893,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1668114,int_stack+37716,int_stack+37128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209314, 1.0, int_stack+226793,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1613136,int_stack+38500,int_stack+37716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210490, 1.0, int_stack+227969,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1615488,int_stack+1613136,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804384, 1.0, int_stack+900508,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1668114,int_stack+39508,int_stack+38500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212058, 1.0, int_stack+229537,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1619016,int_stack+1668114,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+806148, 1.0, int_stack+902272,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16695,int_stack+1619016,int_stack+1615488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808500, 1.0, int_stack+904624,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1613136,int_stack+40768,int_stack+39508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214074, 1.0, int_stack+231553,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+22575,int_stack+1613136,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812028, 1.0, int_stack+918589,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+28623,int_stack+22575,int_stack+1619016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815052, 1.0, int_stack+921613,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1668114,int_stack+28623,int_stack+16695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819756, 1.0, int_stack+926317,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+16695,int_stack+42308,int_stack+40768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216594, 1.0, int_stack+234073,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1616916,int_stack+16695,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825636, 1.0, int_stack+932197,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1676934,int_stack+1616916,int_stack+22575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829416, 1.0, int_stack+935977,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1613136,int_stack+1676934,int_stack+28623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835464, 1.0, int_stack+942025,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+16695,int_stack+1613136,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+843304, 1.0, int_stack+949865,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1668114,int_stack+44597,int_stack+44156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+524972, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1669437,int_stack+45185,int_stack+44597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+525413, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1671201,int_stack+1669437,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+852124, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1673847,int_stack+45941,int_stack+45185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+526001, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1676115,int_stack+1673847,int_stack+1669437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+853447, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1679643,int_stack+1676115,int_stack+1671201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+855211, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1668114,int_stack+46886,int_stack+45941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+526757, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1613136,int_stack+1668114,int_stack+1673847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+857857, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1617672,int_stack+1613136,int_stack+1676115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+860125, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1670949,int_stack+1617672,int_stack+1679643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+876232, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1677564,int_stack+48041,int_stack+46886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+527702, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1681029,int_stack+1677564,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+880642, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+29043,int_stack+1681029,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+883477, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1677564,int_stack+29043,int_stack+1617672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+888013, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+29043,int_stack+1677564,int_stack+1670949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+893893, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38304,int_stack+50015,int_stack+49427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+226793, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+40068,int_stack+50799,int_stack+50015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+227969, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+42420,int_stack+40068,int_stack+38304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+900508, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+45948,int_stack+51807,int_stack+50799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+229537, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1613136,int_stack+45948,int_stack+40068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+902272, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1617840,int_stack+1613136,int_stack+42420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+904624, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+38304,int_stack+53067,int_stack+51807, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+231553, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1668114,int_stack+38304,int_stack+45948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+918589, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+42084,int_stack+1668114,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+921613, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1674162,int_stack+42084,int_stack+1617840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+926317, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1613136,int_stack+54607,int_stack+53067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+234073, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1682982,int_stack+1613136,int_stack+38304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+932197, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1613136,int_stack+1682982,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+935977, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1682982,int_stack+1613136,int_stack+42084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+942025, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+38304,int_stack+1682982,int_stack+1674162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+949865, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1613136,int_stack+56896,int_stack+56455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507402, 0.0, zero_stack, 1.0, int_stack+542542,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1614459,int_stack+57484,int_stack+56896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507843, 0.0, zero_stack, 1.0, int_stack+542983,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1616223,int_stack+1614459,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710402, 0.0, zero_stack, 1.0, int_stack+958685,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1618869,int_stack+58240,int_stack+57484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508431, 0.0, zero_stack, 1.0, int_stack+543571,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1621137,int_stack+1618869,int_stack+1614459, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711725, 0.0, zero_stack, 1.0, int_stack+960008,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1668114,int_stack+1621137,int_stack+1616223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713489, 0.0, zero_stack, 1.0, int_stack+961772,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1613136,int_stack+59185,int_stack+58240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509187, 0.0, zero_stack, 1.0, int_stack+544327,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1672524,int_stack+1613136,int_stack+1618869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+716135, 0.0, zero_stack, 1.0, int_stack+964418,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1677060,int_stack+1672524,int_stack+1621137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718403, 0.0, zero_stack, 1.0, int_stack+966686,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1615971,int_stack+1677060,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721931, 0.0, zero_stack, 1.0, int_stack+982793,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1668114,int_stack+60340,int_stack+59185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510132, 0.0, zero_stack, 1.0, int_stack+545272,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1682940,int_stack+1668114,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726341, 0.0, zero_stack, 1.0, int_stack+0,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+50652,int_stack+1682940,int_stack+1672524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729176, 0.0, zero_stack, 1.0, int_stack+987203,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1682940,int_stack+50652,int_stack+1677060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733712, 0.0, zero_stack, 1.0, int_stack+991739,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+50652,int_stack+1682940,int_stack+1615971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+739592, 0.0, zero_stack, 1.0, int_stack+997619,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59913,int_stack+62314,int_stack+61726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209314, 0.0, zero_stack, 1.0, int_stack+244272,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1613136,int_stack+63098,int_stack+62314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210490, 0.0, zero_stack, 1.0, int_stack+245448,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1615488,int_stack+1613136,int_stack+59913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804384, 0.0, zero_stack, 1.0, int_stack+1004234,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+59913,int_stack+64106,int_stack+63098, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212058, 0.0, zero_stack, 1.0, int_stack+247016,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1619016,int_stack+59913,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+806148, 0.0, zero_stack, 1.0, int_stack+1005998,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1668114,int_stack+1619016,int_stack+1615488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808500, 0.0, zero_stack, 1.0, int_stack+1008350,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1613136,int_stack+65366,int_stack+64106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214074, 0.0, zero_stack, 1.0, int_stack+249032,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1673994,int_stack+1613136,int_stack+59913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812028, 0.0, zero_stack, 1.0, int_stack+1022315,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1680042,int_stack+1673994,int_stack+1619016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815052, 0.0, zero_stack, 1.0, int_stack+1025339,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1687882,int_stack+1680042,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819756, 0.0, zero_stack, 1.0, int_stack+1030043,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1668114,int_stack+66906,int_stack+65366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216594, 0.0, zero_stack, 1.0, int_stack+251552,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+59913,int_stack+1668114,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825636, 0.0, zero_stack, 1.0, int_stack+1035923,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1613136,int_stack+59913,int_stack+1673994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829416, 0.0, zero_stack, 1.0, int_stack+1039703,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1668114,int_stack+1613136,int_stack+1680042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835464, 0.0, zero_stack, 1.0, int_stack+1045751,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1696702,int_stack+1668114,int_stack+1687882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+843304, 0.0, zero_stack, 1.0, int_stack+1053591,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1668114,int_stack+69195,int_stack+68754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524972, 1.0, int_stack+542542, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1669437,int_stack+69783,int_stack+69195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525413, 1.0, int_stack+542983, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1671201,int_stack+1669437,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852124, 1.0, int_stack+958685, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1673847,int_stack+70539,int_stack+69783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526001, 1.0, int_stack+543571, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1676115,int_stack+1673847,int_stack+1669437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853447, 1.0, int_stack+960008, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1679643,int_stack+1676115,int_stack+1671201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855211, 1.0, int_stack+961772, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1668114,int_stack+71484,int_stack+70539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526757, 1.0, int_stack+544327, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1684053,int_stack+1668114,int_stack+1673847, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857857, 1.0, int_stack+964418, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1688589,int_stack+1684053,int_stack+1676115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+860125, 1.0, int_stack+966686, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1670949,int_stack+1688589,int_stack+1679643, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+876232, 1.0, int_stack+982793, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1677564,int_stack+72639,int_stack+71484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527702, 1.0, int_stack+545272, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1613136,int_stack+1677564,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+880642, 1.0, int_stack+0, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+59913,int_stack+1613136,int_stack+1684053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883477, 1.0, int_stack+987203, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1613136,int_stack+59913,int_stack+1688589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+888013, 1.0, int_stack+991739, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+59913,int_stack+1613136,int_stack+1670949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+893893, 1.0, int_stack+997619, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1613136,int_stack+74613,int_stack+74025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226793, 1.0, int_stack+244272, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1614900,int_stack+75397,int_stack+74613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227969, 1.0, int_stack+245448, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1617252,int_stack+1614900,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900508, 1.0, int_stack+1004234, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1620780,int_stack+76405,int_stack+75397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229537, 1.0, int_stack+247016, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+69174,int_stack+1620780,int_stack+1614900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902272, 1.0, int_stack+1005998, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1668114,int_stack+69174,int_stack+1617252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+904624, 1.0, int_stack+1008350, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1613136,int_stack+77665,int_stack+76405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231553, 1.0, int_stack+249032, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1673994,int_stack+1613136,int_stack+1620780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918589, 1.0, int_stack+1022315, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1616916,int_stack+1673994,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+921613, 1.0, int_stack+1025339, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1680042,int_stack+1616916,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926317, 1.0, int_stack+1030043, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1668114,int_stack+79205,int_stack+77665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234073, 1.0, int_stack+251552, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+69174,int_stack+1668114,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932197, 1.0, int_stack+1035923, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1709050,int_stack+69174,int_stack+1673994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935977, 1.0, int_stack+1039703, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+69174,int_stack+1709050,int_stack+1616916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+942025, 1.0, int_stack+1045751, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1709050,int_stack+69174,int_stack+1680042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+949865, 1.0, int_stack+1053591, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+81494,int_stack+81053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+542542, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+82082,int_stack+81494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+542983, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+958685, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+82838,int_stack+82082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+543571, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+960008, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1613136,int_stack+77175,int_stack+72261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+961772, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+83783,int_stack+82838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+544327, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1617546,int_stack+69174,int_stack+74907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+964418, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1668114,int_stack+1617546,int_stack+77175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+966686, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+1668114,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+982793, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1613136,int_stack+84938,int_stack+83783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+545272, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+78624,int_stack+1613136,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1673994,int_stack+78624,int_stack+1617546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+987203, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1613136,int_stack+1673994,int_stack+1668114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+991739, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1668114,int_stack+1613136,int_stack+72009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+997619, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1613136,int_stack+86912,int_stack+86324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+244272, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1614900,int_stack+87696,int_stack+86912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+245448, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1617252,int_stack+1614900,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1004234, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1620780,int_stack+88704,int_stack+87696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+247016, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1677375,int_stack+1620780,int_stack+1614900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1005998, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1682079,int_stack+1677375,int_stack+1617252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1008350, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1613136,int_stack+89964,int_stack+88704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+249032, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1687959,int_stack+1613136,int_stack+1620780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1022315, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1616916,int_stack+1687959,int_stack+1677375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1025339, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69174,int_stack+1616916,int_stack+1682079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1030043, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1677375,int_stack+91504,int_stack+89964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+251552, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+77994,int_stack+1677375,int_stack+1613136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1035923, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1677375,int_stack+77994,int_stack+1687959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1039703, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+77994,int_stack+1677375,int_stack+1616916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1045751, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1677375,int_stack+77994,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1053591, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+93793,int_stack+93352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560112,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+94381,int_stack+93793, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507843, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560553,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1062411,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+95137,int_stack+94381, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561141,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1063734,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+80703,int_stack+77175,int_stack+72261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1065498,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+96082,int_stack+95137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509187, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+561897,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+85113,int_stack+69174,int_stack+74907, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+716135, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1068144,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+89649,int_stack+85113,int_stack+77175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+718403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1070412,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+89649,int_stack+80703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+721931, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1086519,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+78624,int_stack+97237,int_stack+96082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+562842,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1689723,int_stack+78624,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+726341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1090929,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1613136,int_stack+1689723,int_stack+85113, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1093764,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+78624,int_stack+1613136,int_stack+89649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+733712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1098300,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1613136,int_stack+78624,int_stack+72009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+739592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1104180,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1622397,int_stack+99211,int_stack+98623, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+209314, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261751,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1689723,int_stack+99995,int_stack+99211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+210490, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262927,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1692075,int_stack+1689723,int_stack+1622397, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1110795,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69174,int_stack+101003,int_stack+99995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212058, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264495,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72198,int_stack+69174,int_stack+1689723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+806148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1112559,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+76902,int_stack+72198,int_stack+1692075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1114911,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1689723,int_stack+102263,int_stack+101003, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214074, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266511,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+82782,int_stack+1689723,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812028, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1128876,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+88830,int_stack+82782,int_stack+72198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815052, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1131900,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1721398,int_stack+88830,int_stack+76902, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+819756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1136604,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+69174,int_stack+103803,int_stack+102263, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216594, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269031,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+73794,int_stack+69174,int_stack+1689723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1142484,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1730218,int_stack+73794,int_stack+82782, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1146264,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+69174,int_stack+1730218,int_stack+88830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+835464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1152312,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+80934,int_stack+69174,int_stack+1721398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+843304, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1160152,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1721398,int_stack+106092,int_stack+105651, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524972, 0.0, zero_stack, 1.0, int_stack+560112, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1722721,int_stack+106680,int_stack+106092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525413, 0.0, zero_stack, 1.0, int_stack+560553, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1724485,int_stack+1722721,int_stack+1721398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+852124, 0.0, zero_stack, 1.0, int_stack+1062411, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1727131,int_stack+107436,int_stack+106680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526001, 0.0, zero_stack, 1.0, int_stack+561141, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1729399,int_stack+1727131,int_stack+1722721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+853447, 0.0, zero_stack, 1.0, int_stack+1063734, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1732927,int_stack+1729399,int_stack+1724485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855211, 0.0, zero_stack, 1.0, int_stack+1065498, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1721398,int_stack+108381,int_stack+107436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+526757, 0.0, zero_stack, 1.0, int_stack+561897, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+69174,int_stack+1721398,int_stack+1727131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857857, 0.0, zero_stack, 1.0, int_stack+1068144, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+73710,int_stack+69174,int_stack+1729399, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+860125, 0.0, zero_stack, 1.0, int_stack+1070412, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1724233,int_stack+73710,int_stack+1732927, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+876232, 0.0, zero_stack, 1.0, int_stack+1086519, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1730848,int_stack+109536,int_stack+108381, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527702, 0.0, zero_stack, 1.0, int_stack+562842, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1734313,int_stack+1730848,int_stack+1721398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+880642, 0.0, zero_stack, 1.0, int_stack+1090929, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+93282,int_stack+1734313,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+883477, 0.0, zero_stack, 1.0, int_stack+1093764, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1730848,int_stack+93282,int_stack+73710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+888013, 0.0, zero_stack, 1.0, int_stack+1098300, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+93282,int_stack+1730848,int_stack+1724233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+893893, 0.0, zero_stack, 1.0, int_stack+1104180, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+111510,int_stack+110922, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226793, 0.0, zero_stack, 1.0, int_stack+261751, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+112294,int_stack+111510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227969, 0.0, zero_stack, 1.0, int_stack+262927, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900508, 0.0, zero_stack, 1.0, int_stack+1110795, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69174,int_stack+113302,int_stack+112294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229537, 0.0, zero_stack, 1.0, int_stack+264495, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72198,int_stack+69174,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+902272, 0.0, zero_stack, 1.0, int_stack+1112559, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1721398,int_stack+72198,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+904624, 0.0, zero_stack, 1.0, int_stack+1114911, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+114562,int_stack+113302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231553, 0.0, zero_stack, 1.0, int_stack+266511, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+106323,int_stack+102543,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918589, 0.0, zero_stack, 1.0, int_stack+1128876, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1727278,int_stack+106323,int_stack+72198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+921613, 0.0, zero_stack, 1.0, int_stack+1131900, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69174,int_stack+1727278,int_stack+1721398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926317, 0.0, zero_stack, 1.0, int_stack+1136604, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1721398,int_stack+116102,int_stack+114562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234073, 0.0, zero_stack, 1.0, int_stack+269031, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1735118,int_stack+1721398,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+932197, 0.0, zero_stack, 1.0, int_stack+1142484, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1742678,int_stack+1735118,int_stack+106323, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935977, 0.0, zero_stack, 1.0, int_stack+1146264, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1742678,int_stack+1727278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+942025, 0.0, zero_stack, 1.0, int_stack+1152312, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1721398,int_stack+102543,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+949865, 0.0, zero_stack, 1.0, int_stack+1160152, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+118391,int_stack+117950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542542, 1.0, int_stack+560112, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+118979,int_stack+118391, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542983, 1.0, int_stack+560553, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+958685, 1.0, int_stack+1062411, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+119735,int_stack+118979, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+543571, 1.0, int_stack+561141, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960008, 1.0, int_stack+1063734, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+102543,int_stack+77175,int_stack+72261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961772, 1.0, int_stack+1065498, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+120680,int_stack+119735, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544327, 1.0, int_stack+561897, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+106953,int_stack+69174,int_stack+74907, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+964418, 1.0, int_stack+1068144, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+111489,int_stack+106953,int_stack+77175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+966686, 1.0, int_stack+1070412, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+111489,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+982793, 1.0, int_stack+1086519, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+102543,int_stack+121835,int_stack+120680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+545272, 1.0, int_stack+562842, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+117369,int_stack+102543,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1090929, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1733746,int_stack+117369,int_stack+106953, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+987203, 1.0, int_stack+1093764, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1733746,int_stack+111489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+991739, 1.0, int_stack+1098300, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1733746,int_stack+102543,int_stack+72009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+997619, 1.0, int_stack+1104180, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+123809,int_stack+123221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244272, 1.0, int_stack+261751, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+124593,int_stack+123809, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+245448, 1.0, int_stack+262927, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1004234, 1.0, int_stack+1110795, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+110187,int_stack+125601,int_stack+124593, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247016, 1.0, int_stack+264495, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+113211,int_stack+110187,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1005998, 1.0, int_stack+1112559, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+117915,int_stack+113211,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1008350, 1.0, int_stack+1114911, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+126861,int_stack+125601, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249032, 1.0, int_stack+266511, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1743007,int_stack+102543,int_stack+110187, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1022315, 1.0, int_stack+1128876, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+69174,int_stack+1743007,int_stack+113211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1025339, 1.0, int_stack+1131900, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+106323,int_stack+69174,int_stack+117915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1030043, 1.0, int_stack+1136604, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+115143,int_stack+128401,int_stack+126861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251552, 1.0, int_stack+269031, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+119763,int_stack+115143,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1035923, 1.0, int_stack+1142484, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1749055,int_stack+119763,int_stack+1743007, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1039703, 1.0, int_stack+1146264, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+115143,int_stack+1749055,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1045751, 1.0, int_stack+1152312, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1743007,int_stack+115143,int_stack+106323, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1053591, 1.0, int_stack+1160152, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+130690,int_stack+130249, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+560112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+131278,int_stack+130690, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+560553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1062411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+132034,int_stack+131278, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+561141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1063734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+102543,int_stack+77175,int_stack+72261, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1065498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+132979,int_stack+132034, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+561897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+106953,int_stack+69174,int_stack+74907, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1068144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+111489,int_stack+106953,int_stack+77175, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1070412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+111489,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1086519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+102543,int_stack+134134,int_stack+132979, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+562842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+117369,int_stack+102543,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1090929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+123039,int_stack+117369,int_stack+106953, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1093764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+123039,int_stack+111489, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1098300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+111363,int_stack+102543,int_stack+72009, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1104180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+136108,int_stack+135520, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+136892,int_stack+136108, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+262927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1110795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69174,int_stack+137900,int_stack+136892, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+264495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72198,int_stack+69174,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1112559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+120624,int_stack+72198,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1114911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+139160,int_stack+137900, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+266511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+126504,int_stack+102543,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1128876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1755355,int_stack+126504,int_stack+72198, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1131900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69174,int_stack+1755355,int_stack+120624, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1136604, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+120624,int_stack+140700,int_stack+139160, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+132552,int_stack+120624,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1142484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1763195,int_stack+132552,int_stack+126504, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1146264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+120624,int_stack+1763195,int_stack+1755355, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1152312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1755355,int_stack+120624,int_stack+69174, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1160152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+142989,int_stack+142548, 0.0, zero_stack, 1.0, int_stack+507402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577682,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+143577,int_stack+142989, 0.0, zero_stack, 1.0, int_stack+507843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578123,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+710402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1168972,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+144333,int_stack+143577, 0.0, zero_stack, 1.0, int_stack+508431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578711,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 1.0, int_stack+711725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1170295,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+120624,int_stack+77175,int_stack+72261, 0.0, zero_stack, 1.0, int_stack+713489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1172059,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+145278,int_stack+144333, 0.0, zero_stack, 1.0, int_stack+509187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579467,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+125034,int_stack+69174,int_stack+74907, 0.0, zero_stack, 1.0, int_stack+716135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1174705,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+129570,int_stack+125034,int_stack+77175, 0.0, zero_stack, 1.0, int_stack+718403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1176973,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+129570,int_stack+120624, 0.0, zero_stack, 1.0, int_stack+721931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+120624,int_stack+146433,int_stack+145278, 0.0, zero_stack, 1.0, int_stack+510132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580412,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+135450,int_stack+120624,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+726341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193080,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+102543,int_stack+135450,int_stack+125034, 0.0, zero_stack, 1.0, int_stack+729176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1195915,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+135450,int_stack+102543,int_stack+129570, 0.0, zero_stack, 1.0, int_stack+733712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1200451,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+120624,int_stack+135450,int_stack+72009, 0.0, zero_stack, 1.0, int_stack+739592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1206331,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+148407,int_stack+147819, 0.0, zero_stack, 1.0, int_stack+209314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279230,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+149191,int_stack+148407, 0.0, zero_stack, 1.0, int_stack+210490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280406,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+804384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1212946,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69174,int_stack+150199,int_stack+149191, 0.0, zero_stack, 1.0, int_stack+212058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281974,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72198,int_stack+69174,int_stack+104307, 0.0, zero_stack, 1.0, int_stack+806148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1214710,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+129885,int_stack+72198,int_stack+106659, 0.0, zero_stack, 1.0, int_stack+808500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1217062,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+151459,int_stack+150199, 0.0, zero_stack, 1.0, int_stack+214074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283990,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+135765,int_stack+102543,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+812028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1231027,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+141813,int_stack+135765,int_stack+72198, 0.0, zero_stack, 1.0, int_stack+815052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1234051,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69174,int_stack+141813,int_stack+129885, 0.0, zero_stack, 1.0, int_stack+819756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1238755,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+129885,int_stack+152999,int_stack+151459, 0.0, zero_stack, 1.0, int_stack+216594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+286510,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1767703,int_stack+129885,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+825636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1244635,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1775263,int_stack+1767703,int_stack+135765, 0.0, zero_stack, 1.0, int_stack+829416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1248415,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+129885,int_stack+1775263,int_stack+141813, 0.0, zero_stack, 1.0, int_stack+835464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1254463,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1767703,int_stack+129885,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+843304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1262303,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+155288,int_stack+154847, 0.0, zero_stack, 1.0, int_stack+524972, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577682, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+155876,int_stack+155288, 0.0, zero_stack, 1.0, int_stack+525413, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578123, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+852124, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1168972, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+156632,int_stack+155876, 0.0, zero_stack, 1.0, int_stack+526001, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+578711, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 1.0, int_stack+853447, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1170295, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+129885,int_stack+77175,int_stack+72261, 0.0, zero_stack, 1.0, int_stack+855211, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1172059, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+157577,int_stack+156632, 0.0, zero_stack, 1.0, int_stack+526757, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+579467, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+134295,int_stack+69174,int_stack+74907, 0.0, zero_stack, 1.0, int_stack+857857, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1174705, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+138831,int_stack+134295,int_stack+77175, 0.0, zero_stack, 1.0, int_stack+860125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1176973, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+138831,int_stack+129885, 0.0, zero_stack, 1.0, int_stack+876232, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+129885,int_stack+158732,int_stack+157577, 0.0, zero_stack, 1.0, int_stack+527702, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580412, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+144711,int_stack+129885,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+880642, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1193080, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+150381,int_stack+144711,int_stack+134295, 0.0, zero_stack, 1.0, int_stack+883477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1195915, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+150381,int_stack+138831, 0.0, zero_stack, 1.0, int_stack+888013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1200451, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+129885,int_stack+102543,int_stack+72009, 0.0, zero_stack, 1.0, int_stack+893893, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1206331, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+160706,int_stack+160118, 0.0, zero_stack, 1.0, int_stack+226793, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+279230, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+161490,int_stack+160706, 0.0, zero_stack, 1.0, int_stack+227969, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280406, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+900508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1212946, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+69174,int_stack+162498,int_stack+161490, 0.0, zero_stack, 1.0, int_stack+229537, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281974, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72198,int_stack+69174,int_stack+104307, 0.0, zero_stack, 1.0, int_stack+902272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1214710, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+139146,int_stack+72198,int_stack+106659, 0.0, zero_stack, 1.0, int_stack+904624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1217062, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+163758,int_stack+162498, 0.0, zero_stack, 1.0, int_stack+231553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283990, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+145026,int_stack+102543,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+918589, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1231027, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+151074,int_stack+145026,int_stack+72198, 0.0, zero_stack, 1.0, int_stack+921613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1234051, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+69174,int_stack+151074,int_stack+139146, 0.0, zero_stack, 1.0, int_stack+926317, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1238755, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+139146,int_stack+165298,int_stack+163758, 0.0, zero_stack, 1.0, int_stack+234073, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+286510, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+158914,int_stack+139146,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+932197, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1244635, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1780051,int_stack+158914,int_stack+145026, 0.0, zero_stack, 1.0, int_stack+935977, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1248415, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+139146,int_stack+1780051,int_stack+151074, 0.0, zero_stack, 1.0, int_stack+942025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1254463, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+150906,int_stack+139146,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+949865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1262303, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69174,int_stack+167587,int_stack+167146, 0.0, zero_stack, 1.0, int_stack+542542, 0.0, zero_stack, 1.0, int_stack+577682, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70497,int_stack+168175,int_stack+167587, 0.0, zero_stack, 1.0, int_stack+542983, 0.0, zero_stack, 1.0, int_stack+578123, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+72261,int_stack+70497,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+958685, 0.0, zero_stack, 1.0, int_stack+1168972, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+74907,int_stack+168931,int_stack+168175, 0.0, zero_stack, 1.0, int_stack+543571, 0.0, zero_stack, 1.0, int_stack+578711, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77175,int_stack+74907,int_stack+70497, 0.0, zero_stack, 1.0, int_stack+960008, 0.0, zero_stack, 1.0, int_stack+1170295, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+139146,int_stack+77175,int_stack+72261, 0.0, zero_stack, 1.0, int_stack+961772, 0.0, zero_stack, 1.0, int_stack+1172059, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+69174,int_stack+169876,int_stack+168931, 0.0, zero_stack, 1.0, int_stack+544327, 0.0, zero_stack, 1.0, int_stack+579467, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+143556,int_stack+69174,int_stack+74907, 0.0, zero_stack, 1.0, int_stack+964418, 0.0, zero_stack, 1.0, int_stack+1174705, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1780051,int_stack+143556,int_stack+77175, 0.0, zero_stack, 1.0, int_stack+966686, 0.0, zero_stack, 1.0, int_stack+1176973, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+72009,int_stack+1780051,int_stack+139146, 0.0, zero_stack, 1.0, int_stack+982793, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+139146,int_stack+171031,int_stack+169876, 0.0, zero_stack, 1.0, int_stack+545272, 0.0, zero_stack, 1.0, int_stack+580412, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+102543,int_stack+139146,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+1193080, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+163254,int_stack+102543,int_stack+143556, 0.0, zero_stack, 1.0, int_stack+987203, 0.0, zero_stack, 1.0, int_stack+1195915, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+163254,int_stack+1780051, 0.0, zero_stack, 1.0, int_stack+991739, 0.0, zero_stack, 1.0, int_stack+1200451, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1780051,int_stack+102543,int_stack+72009, 0.0, zero_stack, 1.0, int_stack+997619, 0.0, zero_stack, 1.0, int_stack+1206331, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+173005,int_stack+172417, 0.0, zero_stack, 1.0, int_stack+244272, 0.0, zero_stack, 1.0, int_stack+279230, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+173789,int_stack+173005, 0.0, zero_stack, 1.0, int_stack+245448, 0.0, zero_stack, 1.0, int_stack+280406, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1004234, 0.0, zero_stack, 1.0, int_stack+1212946, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163254,int_stack+174797,int_stack+173789, 0.0, zero_stack, 1.0, int_stack+247016, 0.0, zero_stack, 1.0, int_stack+281974, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166278,int_stack+163254,int_stack+104307, 0.0, zero_stack, 1.0, int_stack+1005998, 0.0, zero_stack, 1.0, int_stack+1214710, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+69174,int_stack+166278,int_stack+106659, 0.0, zero_stack, 1.0, int_stack+1008350, 0.0, zero_stack, 1.0, int_stack+1217062, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+176057,int_stack+174797, 0.0, zero_stack, 1.0, int_stack+249032, 0.0, zero_stack, 1.0, int_stack+283990, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+139146,int_stack+102543,int_stack+163254, 0.0, zero_stack, 1.0, int_stack+1022315, 0.0, zero_stack, 1.0, int_stack+1231027, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1789312,int_stack+139146,int_stack+166278, 0.0, zero_stack, 1.0, int_stack+1025339, 0.0, zero_stack, 1.0, int_stack+1234051, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+163254,int_stack+1789312,int_stack+69174, 0.0, zero_stack, 1.0, int_stack+1030043, 0.0, zero_stack, 1.0, int_stack+1238755, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+69174,int_stack+177597,int_stack+176057, 0.0, zero_stack, 1.0, int_stack+251552, 0.0, zero_stack, 1.0, int_stack+286510, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1797152,int_stack+69174,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1035923, 0.0, zero_stack, 1.0, int_stack+1244635, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+69174,int_stack+1797152,int_stack+139146, 0.0, zero_stack, 1.0, int_stack+1039703, 0.0, zero_stack, 1.0, int_stack+1248415, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+139146,int_stack+69174,int_stack+1789312, 0.0, zero_stack, 1.0, int_stack+1045751, 0.0, zero_stack, 1.0, int_stack+1254463, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1789312,int_stack+139146,int_stack+163254, 0.0, zero_stack, 1.0, int_stack+1053591, 0.0, zero_stack, 1.0, int_stack+1262303, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+163254,int_stack+179886,int_stack+179445, 0.0, zero_stack, 1.0, int_stack+560112, 1.0, int_stack+577682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+164577,int_stack+180474,int_stack+179886, 0.0, zero_stack, 1.0, int_stack+560553, 1.0, int_stack+578123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+166341,int_stack+164577,int_stack+163254, 0.0, zero_stack, 1.0, int_stack+1062411, 1.0, int_stack+1168972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+168987,int_stack+181230,int_stack+180474, 0.0, zero_stack, 1.0, int_stack+561141, 1.0, int_stack+578711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+171255,int_stack+168987,int_stack+164577, 0.0, zero_stack, 1.0, int_stack+1063734, 1.0, int_stack+1170295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+174783,int_stack+171255,int_stack+166341, 0.0, zero_stack, 1.0, int_stack+1065498, 1.0, int_stack+1172059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+163254,int_stack+182175,int_stack+181230, 0.0, zero_stack, 1.0, int_stack+561897, 1.0, int_stack+579467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+139146,int_stack+163254,int_stack+168987, 0.0, zero_stack, 1.0, int_stack+1068144, 1.0, int_stack+1174705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+143682,int_stack+139146,int_stack+171255, 0.0, zero_stack, 1.0, int_stack+1070412, 1.0, int_stack+1176973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+166089,int_stack+143682,int_stack+174783, 0.0, zero_stack, 1.0, int_stack+1086519, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+172704,int_stack+183330,int_stack+182175, 0.0, zero_stack, 1.0, int_stack+562842, 1.0, int_stack+580412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+176169,int_stack+172704,int_stack+163254, 0.0, zero_stack, 1.0, int_stack+1090929, 1.0, int_stack+1193080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+69174,int_stack+176169,int_stack+139146, 0.0, zero_stack, 1.0, int_stack+1093764, 1.0, int_stack+1195915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+69174,int_stack+143682, 0.0, zero_stack, 1.0, int_stack+1098300, 1.0, int_stack+1200451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+69174,int_stack+102543,int_stack+166089, 0.0, zero_stack, 1.0, int_stack+1104180, 1.0, int_stack+1206331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+185304,int_stack+184716, 0.0, zero_stack, 1.0, int_stack+261751, 1.0, int_stack+279230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+186088,int_stack+185304, 0.0, zero_stack, 1.0, int_stack+262927, 1.0, int_stack+280406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1110795, 1.0, int_stack+1212946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+139146,int_stack+187096,int_stack+186088, 0.0, zero_stack, 1.0, int_stack+264495, 1.0, int_stack+281974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+142170,int_stack+139146,int_stack+104307, 0.0, zero_stack, 1.0, int_stack+1112559, 1.0, int_stack+1214710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+163254,int_stack+142170,int_stack+106659, 0.0, zero_stack, 1.0, int_stack+1114911, 1.0, int_stack+1217062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+188356,int_stack+187096, 0.0, zero_stack, 1.0, int_stack+266511, 1.0, int_stack+283990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+169134,int_stack+102543,int_stack+139146, 0.0, zero_stack, 1.0, int_stack+1128876, 1.0, int_stack+1231027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+175182,int_stack+169134,int_stack+142170, 0.0, zero_stack, 1.0, int_stack+1131900, 1.0, int_stack+1234051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+139146,int_stack+175182,int_stack+163254, 0.0, zero_stack, 1.0, int_stack+1136604, 1.0, int_stack+1238755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+163254,int_stack+189896,int_stack+188356, 0.0, zero_stack, 1.0, int_stack+269031, 1.0, int_stack+286510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+183022,int_stack+163254,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1142484, 1.0, int_stack+1244635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1801660,int_stack+183022,int_stack+169134, 0.0, zero_stack, 1.0, int_stack+1146264, 1.0, int_stack+1248415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+163254,int_stack+1801660,int_stack+175182, 0.0, zero_stack, 1.0, int_stack+1152312, 1.0, int_stack+1254463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+175014,int_stack+163254,int_stack+139146, 0.0, zero_stack, 1.0, int_stack+1160152, 1.0, int_stack+1262303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+139146,int_stack+192185,int_stack+191744, 0.0, zero_stack, 2.0, int_stack+577682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+140469,int_stack+192773,int_stack+192185, 0.0, zero_stack, 2.0, int_stack+578123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+142233,int_stack+140469,int_stack+139146, 0.0, zero_stack, 2.0, int_stack+1168972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+144879,int_stack+193529,int_stack+192773, 0.0, zero_stack, 2.0, int_stack+578711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+147147,int_stack+144879,int_stack+140469, 0.0, zero_stack, 2.0, int_stack+1170295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+163254,int_stack+147147,int_stack+142233, 0.0, zero_stack, 2.0, int_stack+1172059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+139146,int_stack+194474,int_stack+193529, 0.0, zero_stack, 2.0, int_stack+579467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+167664,int_stack+139146,int_stack+144879, 0.0, zero_stack, 2.0, int_stack+1174705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1801660,int_stack+167664,int_stack+147147, 0.0, zero_stack, 2.0, int_stack+1176973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+141981,int_stack+1801660,int_stack+163254, 0.0, zero_stack, 2.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+163254,int_stack+195629,int_stack+194474, 0.0, zero_stack, 2.0, int_stack+580412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+102543,int_stack+163254,int_stack+139146, 0.0, zero_stack, 2.0, int_stack+1193080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+187362,int_stack+102543,int_stack+167664, 0.0, zero_stack, 2.0, int_stack+1195915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+187362,int_stack+1801660, 0.0, zero_stack, 2.0, int_stack+1200451, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1801660,int_stack+102543,int_stack+141981, 0.0, zero_stack, 2.0, int_stack+1206331, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+197603,int_stack+197015, 0.0, zero_stack, 2.0, int_stack+279230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+198387,int_stack+197603, 0.0, zero_stack, 2.0, int_stack+280406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 2.0, int_stack+1212946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+187362,int_stack+199395,int_stack+198387, 0.0, zero_stack, 2.0, int_stack+281974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+190386,int_stack+187362,int_stack+104307, 0.0, zero_stack, 2.0, int_stack+1214710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+139146,int_stack+190386,int_stack+106659, 0.0, zero_stack, 2.0, int_stack+1217062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+200655,int_stack+199395, 0.0, zero_stack, 2.0, int_stack+283990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+163254,int_stack+102543,int_stack+187362, 0.0, zero_stack, 2.0, int_stack+1231027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1810921,int_stack+163254,int_stack+190386, 0.0, zero_stack, 2.0, int_stack+1234051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+187362,int_stack+1810921,int_stack+139146, 0.0, zero_stack, 2.0, int_stack+1238755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+139146,int_stack+202195,int_stack+200655, 0.0, zero_stack, 2.0, int_stack+286510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+196182,int_stack+139146,int_stack+102543, 0.0, zero_stack, 2.0, int_stack+1244635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+139146,int_stack+196182,int_stack+163254, 0.0, zero_stack, 2.0, int_stack+1248415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+163254,int_stack+139146,int_stack+1810921, 0.0, zero_stack, 2.0, int_stack+1254463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1810921,int_stack+163254,int_stack+187362, 0.0, zero_stack, 2.0, int_stack+1262303, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+187362,int_stack+204484,int_stack+204043, 1.0, int_stack+507402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595693,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+188685,int_stack+205072,int_stack+204484, 1.0, int_stack+507843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596722,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+190449,int_stack+188685,int_stack+187362, 1.0, int_stack+710402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1271123,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+193095,int_stack+205828,int_stack+205072, 1.0, int_stack+508431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598066,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+195363,int_stack+193095,int_stack+188685, 1.0, int_stack+711725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1272446,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+198891,int_stack+195363,int_stack+190449, 1.0, int_stack+713489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1274210,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+187362,int_stack+206773,int_stack+205828, 1.0, int_stack+509187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599767,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+163254,int_stack+187362,int_stack+193095, 1.0, int_stack+716135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1276856,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+167790,int_stack+163254,int_stack+195363, 1.0, int_stack+718403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279124,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+190197,int_stack+167790,int_stack+198891, 1.0, int_stack+721931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1295231,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+196812,int_stack+207928,int_stack+206773, 1.0, int_stack+510132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601867,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+200277,int_stack+196812,int_stack+187362, 1.0, int_stack+726341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+139146,int_stack+200277,int_stack+163254, 1.0, int_stack+729176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1299641,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+139146,int_stack+167790, 1.0, int_stack+733712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304177,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+139146,int_stack+102543,int_stack+190197, 1.0, int_stack+739592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677432,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+211274,int_stack+209902, 1.0, int_stack+209314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297297,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+213066,int_stack+211274, 1.0, int_stack+210490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299257,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+804384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1319318,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163254,int_stack+215334,int_stack+213066, 1.0, int_stack+212058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301833,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166278,int_stack+163254,int_stack+104307, 1.0, int_stack+806148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1321082,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+187362,int_stack+166278,int_stack+106659, 1.0, int_stack+808500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323434,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+218134,int_stack+215334, 1.0, int_stack+214074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305109,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+193242,int_stack+102543,int_stack+163254, 1.0, int_stack+812028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326962,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+199290,int_stack+193242,int_stack+166278, 1.0, int_stack+815052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684047,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+163254,int_stack+199290,int_stack+187362, 1.0, int_stack+819756, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329986,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+187362,int_stack+219674,int_stack+218134, 1.0, int_stack+216594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307629,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+207130,int_stack+187362,int_stack+102543, 1.0, int_stack+825636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+708890,int_stack+207130,int_stack+193242, 1.0, int_stack+829416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1335866,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+207130,int_stack+708890,int_stack+199290, 1.0, int_stack+835464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1341914,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+708890,int_stack+207130,int_stack+163254, 1.0, int_stack+843304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1349754,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+163254,int_stack+221963,int_stack+221522, 1.0, int_stack+524972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595693, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+164577,int_stack+222551,int_stack+221963, 1.0, int_stack+525413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596722, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+166341,int_stack+164577,int_stack+163254, 1.0, int_stack+852124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1271123, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+168987,int_stack+223307,int_stack+222551, 1.0, int_stack+526001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598066, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+171255,int_stack+168987,int_stack+164577, 1.0, int_stack+853447, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1272446, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+721238,int_stack+171255,int_stack+166341, 1.0, int_stack+855211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1274210, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+163254,int_stack+224252,int_stack+223307, 1.0, int_stack+526757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599767, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+725648,int_stack+163254,int_stack+168987, 1.0, int_stack+857857, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1276856, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+730184,int_stack+725648,int_stack+171255, 1.0, int_stack+860125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279124, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+166089,int_stack+730184,int_stack+721238, 1.0, int_stack+876232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1295231, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+876232,int_stack+225407,int_stack+224252, 1.0, int_stack+527702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601867, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+736064,int_stack+876232,int_stack+163254, 1.0, int_stack+880642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+102543,int_stack+736064,int_stack+725648, 1.0, int_stack+883477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1299641, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+736064,int_stack+102543,int_stack+730184, 1.0, int_stack+888013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304177, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+876232,int_stack+736064,int_stack+166089, 1.0, int_stack+893893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677432, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+228753,int_stack+227381, 1.0, int_stack+226793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297297, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+230545,int_stack+228753, 1.0, int_stack+227969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299257, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+900508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1319318, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163254,int_stack+232813,int_stack+230545, 1.0, int_stack+229537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301833, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166278,int_stack+163254,int_stack+104307, 1.0, int_stack+902272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1321082, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+885493,int_stack+166278,int_stack+106659, 1.0, int_stack+904624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323434, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+235613,int_stack+232813, 1.0, int_stack+231553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305109, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+891373,int_stack+102543,int_stack+163254, 1.0, int_stack+918589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326962, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+897421,int_stack+891373,int_stack+166278, 1.0, int_stack+921613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684047, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+163254,int_stack+897421,int_stack+885493, 1.0, int_stack+926317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329986, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+885493,int_stack+237153,int_stack+235613, 1.0, int_stack+234073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307629, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+918589,int_stack+885493,int_stack+102543, 1.0, int_stack+932197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+721238,int_stack+918589,int_stack+891373, 1.0, int_stack+935977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1335866, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+918589,int_stack+721238,int_stack+897421, 1.0, int_stack+942025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1341914, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+721238,int_stack+918589,int_stack+163254, 1.0, int_stack+949865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1349754, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+163254,int_stack+239442,int_stack+239001, 1.0, int_stack+542542, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595693, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+164577,int_stack+240030,int_stack+239442, 1.0, int_stack+542983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596722, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+166341,int_stack+164577,int_stack+163254, 1.0, int_stack+958685, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1271123, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+168987,int_stack+240786,int_stack+240030, 1.0, int_stack+543571, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598066, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+171255,int_stack+168987,int_stack+164577, 1.0, int_stack+960008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1272446, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+918589,int_stack+171255,int_stack+166341, 1.0, int_stack+961772, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1274210, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+163254,int_stack+241731,int_stack+240786, 1.0, int_stack+544327, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599767, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+922999,int_stack+163254,int_stack+168987, 1.0, int_stack+964418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1276856, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+927535,int_stack+922999,int_stack+171255, 1.0, int_stack+966686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1279124, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+166089,int_stack+927535,int_stack+918589, 1.0, int_stack+982793, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1295231, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+982793,int_stack+242886,int_stack+241731, 1.0, int_stack+545272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+601867, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+933415,int_stack+982793,int_stack+163254, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+939085,int_stack+933415,int_stack+922999, 1.0, int_stack+987203, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1299641, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+939085,int_stack+927535, 1.0, int_stack+991739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304177, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+982793,int_stack+102543,int_stack+166089, 1.0, int_stack+997619, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677432, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+246232,int_stack+244860, 1.0, int_stack+244272, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+297297, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+248024,int_stack+246232, 1.0, int_stack+245448, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299257, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+1004234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1319318, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163254,int_stack+250292,int_stack+248024, 1.0, int_stack+247016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+301833, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166278,int_stack+163254,int_stack+104307, 1.0, int_stack+1005998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1321082, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+992054,int_stack+166278,int_stack+106659, 1.0, int_stack+1008350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323434, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+253092,int_stack+250292, 1.0, int_stack+249032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+305109, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+997934,int_stack+102543,int_stack+163254, 1.0, int_stack+1022315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326962, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1003982,int_stack+997934,int_stack+166278, 1.0, int_stack+1025339, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+684047, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+163254,int_stack+1003982,int_stack+992054, 1.0, int_stack+1030043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329986, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+992054,int_stack+254632,int_stack+253092, 1.0, int_stack+251552, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+307629, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1022315,int_stack+992054,int_stack+102543, 1.0, int_stack+1035923, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+918589,int_stack+1022315,int_stack+997934, 1.0, int_stack+1039703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1335866, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1022315,int_stack+918589,int_stack+1003982, 1.0, int_stack+1045751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1341914, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+918589,int_stack+1022315,int_stack+163254, 1.0, int_stack+1053591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1349754, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+163254,int_stack+256921,int_stack+256480, 1.0, int_stack+560112, 0.0, zero_stack, 1.0, int_stack+595693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+164577,int_stack+257509,int_stack+256921, 1.0, int_stack+560553, 0.0, zero_stack, 1.0, int_stack+596722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+166341,int_stack+164577,int_stack+163254, 1.0, int_stack+1062411, 0.0, zero_stack, 1.0, int_stack+1271123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+168987,int_stack+258265,int_stack+257509, 1.0, int_stack+561141, 0.0, zero_stack, 1.0, int_stack+598066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+171255,int_stack+168987,int_stack+164577, 1.0, int_stack+1063734, 0.0, zero_stack, 1.0, int_stack+1272446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1022315,int_stack+171255,int_stack+166341, 1.0, int_stack+1065498, 0.0, zero_stack, 1.0, int_stack+1274210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+259210,int_stack+258265, 1.0, int_stack+561897, 0.0, zero_stack, 1.0, int_stack+599767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+163254,int_stack+0,int_stack+168987, 1.0, int_stack+1068144, 0.0, zero_stack, 1.0, int_stack+1276856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1026725,int_stack+163254,int_stack+171255, 1.0, int_stack+1070412, 0.0, zero_stack, 1.0, int_stack+1279124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+167790,int_stack+1026725,int_stack+1022315, 1.0, int_stack+1086519, 0.0, zero_stack, 1.0, int_stack+1295231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1086519,int_stack+260365,int_stack+259210, 1.0, int_stack+562842, 0.0, zero_stack, 1.0, int_stack+601867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1032605,int_stack+1086519,int_stack+0, 1.0, int_stack+1090929, 0.0, zero_stack, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1038275,int_stack+1032605,int_stack+163254, 1.0, int_stack+1093764, 0.0, zero_stack, 1.0, int_stack+1299641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1038275,int_stack+1026725, 1.0, int_stack+1098300, 0.0, zero_stack, 1.0, int_stack+1304177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1086519,int_stack+102543,int_stack+167790, 1.0, int_stack+1104180, 0.0, zero_stack, 1.0, int_stack+677432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+263711,int_stack+262339, 1.0, int_stack+261751, 0.0, zero_stack, 1.0, int_stack+297297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+265503,int_stack+263711, 1.0, int_stack+262927, 0.0, zero_stack, 1.0, int_stack+299257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+1110795, 0.0, zero_stack, 1.0, int_stack+1319318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163254,int_stack+267771,int_stack+265503, 1.0, int_stack+264495, 0.0, zero_stack, 1.0, int_stack+301833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166278,int_stack+163254,int_stack+104307, 1.0, int_stack+1112559, 0.0, zero_stack, 1.0, int_stack+1321082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1095780,int_stack+166278,int_stack+106659, 1.0, int_stack+1114911, 0.0, zero_stack, 1.0, int_stack+1323434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+270571,int_stack+267771, 1.0, int_stack+266511, 0.0, zero_stack, 1.0, int_stack+305109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1101660,int_stack+102543,int_stack+163254, 1.0, int_stack+1128876, 0.0, zero_stack, 1.0, int_stack+1326962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1107708,int_stack+1101660,int_stack+166278, 1.0, int_stack+1131900, 0.0, zero_stack, 1.0, int_stack+684047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+163254,int_stack+1107708,int_stack+1095780, 1.0, int_stack+1136604, 0.0, zero_stack, 1.0, int_stack+1329986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1095780,int_stack+272111,int_stack+270571, 1.0, int_stack+269031, 0.0, zero_stack, 1.0, int_stack+307629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1128876,int_stack+1095780,int_stack+102543, 1.0, int_stack+1142484, 0.0, zero_stack, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1022315,int_stack+1128876,int_stack+1101660, 1.0, int_stack+1146264, 0.0, zero_stack, 1.0, int_stack+1335866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1128876,int_stack+1022315,int_stack+1107708, 1.0, int_stack+1152312, 0.0, zero_stack, 1.0, int_stack+1341914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1022315,int_stack+1128876,int_stack+163254, 1.0, int_stack+1160152, 0.0, zero_stack, 1.0, int_stack+1349754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+163254,int_stack+274400,int_stack+273959, 1.0, int_stack+577682, 1.0, int_stack+595693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+164577,int_stack+274988,int_stack+274400, 1.0, int_stack+578123, 1.0, int_stack+596722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+166341,int_stack+164577,int_stack+163254, 1.0, int_stack+1168972, 1.0, int_stack+1271123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+168987,int_stack+275744,int_stack+274988, 1.0, int_stack+578711, 1.0, int_stack+598066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+171255,int_stack+168987,int_stack+164577, 1.0, int_stack+1170295, 1.0, int_stack+1272446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1128876,int_stack+171255,int_stack+166341, 1.0, int_stack+1172059, 1.0, int_stack+1274210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+276689,int_stack+275744, 1.0, int_stack+579467, 1.0, int_stack+599767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+163254,int_stack+0,int_stack+168987, 1.0, int_stack+1174705, 1.0, int_stack+1276856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1133286,int_stack+163254,int_stack+171255, 1.0, int_stack+1176973, 1.0, int_stack+1279124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+167790,int_stack+1133286,int_stack+1128876, 1.0, int_stack+2835, 1.0, int_stack+1295231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2835,int_stack+277844,int_stack+276689, 1.0, int_stack+580412, 1.0, int_stack+601867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1139166,int_stack+2835,int_stack+0, 1.0, int_stack+1193080, 1.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1144836,int_stack+1139166,int_stack+163254, 1.0, int_stack+1195915, 1.0, int_stack+1299641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1144836,int_stack+1133286, 1.0, int_stack+1200451, 1.0, int_stack+1304177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1193080,int_stack+102543,int_stack+167790, 1.0, int_stack+1206331, 1.0, int_stack+677432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+281190,int_stack+279818, 1.0, int_stack+279230, 1.0, int_stack+297297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+282982,int_stack+281190, 1.0, int_stack+280406, 1.0, int_stack+299257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+1212946, 1.0, int_stack+1319318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+163254,int_stack+285250,int_stack+282982, 1.0, int_stack+281974, 1.0, int_stack+301833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+166278,int_stack+163254,int_stack+104307, 1.0, int_stack+1214710, 1.0, int_stack+1321082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1202341,int_stack+166278,int_stack+106659, 1.0, int_stack+1217062, 1.0, int_stack+1323434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+288050,int_stack+285250, 1.0, int_stack+283990, 1.0, int_stack+305109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1208221,int_stack+102543,int_stack+163254, 1.0, int_stack+1231027, 1.0, int_stack+1326962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1128876,int_stack+1208221,int_stack+166278, 1.0, int_stack+1234051, 1.0, int_stack+684047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+163254,int_stack+1128876,int_stack+1202341, 1.0, int_stack+1238755, 1.0, int_stack+1329986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1202341,int_stack+289590,int_stack+288050, 1.0, int_stack+286510, 1.0, int_stack+307629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1231027,int_stack+1202341,int_stack+102543, 1.0, int_stack+1244635, 1.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1136716,int_stack+1231027,int_stack+1208221, 1.0, int_stack+1248415, 1.0, int_stack+1335866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1231027,int_stack+1136716,int_stack+1128876, 1.0, int_stack+1254463, 1.0, int_stack+1341914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1128876,int_stack+1231027,int_stack+163254, 1.0, int_stack+1262303, 1.0, int_stack+1349754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+163254,int_stack+291879,int_stack+291438, 2.0, int_stack+595693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+164577,int_stack+292467,int_stack+291879, 2.0, int_stack+596722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+166341,int_stack+164577,int_stack+163254, 2.0, int_stack+1271123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+168987,int_stack+293223,int_stack+292467, 2.0, int_stack+598066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+171255,int_stack+168987,int_stack+164577, 2.0, int_stack+1272446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1231027,int_stack+171255,int_stack+166341, 2.0, int_stack+1274210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+163254,int_stack+294168,int_stack+293223, 2.0, int_stack+599767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1235437,int_stack+163254,int_stack+168987, 2.0, int_stack+1276856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1239973,int_stack+1235437,int_stack+171255, 2.0, int_stack+1279124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+595252,int_stack+1239973,int_stack+1231027, 2.0, int_stack+1295231, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1295231,int_stack+295323,int_stack+294168, 2.0, int_stack+601867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+166089,int_stack+1295231,int_stack+163254, 2.0, int_stack+674597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1245853,int_stack+166089,int_stack+1235437, 2.0, int_stack+1299641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1245853,int_stack+1239973, 2.0, int_stack+1304177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+163254,int_stack+102543,int_stack+595252, 2.0, int_stack+677432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+595252,int_stack+300041,int_stack+297885, 2.0, int_stack+297297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+597016,int_stack+302841,int_stack+300041, 2.0, int_stack+299257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+599368,int_stack+597016,int_stack+595252, 2.0, int_stack+1319318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+102543,int_stack+306369,int_stack+302841, 2.0, int_stack+301833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+105567,int_stack+102543,int_stack+597016, 2.0, int_stack+1321082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+674597,int_stack+105567,int_stack+599368, 2.0, int_stack+1323434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1319318,int_stack+309169,int_stack+306369, 2.0, int_stack+305109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+595252,int_stack+1319318,int_stack+102543, 2.0, int_stack+1326962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1295231,int_stack+595252,int_stack+105567, 2.0, int_stack+684047, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+102543,int_stack+1295231,int_stack+674597, 2.0, int_stack+1329986, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+674597,int_stack+310709,int_stack+309169, 2.0, int_stack+307629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+679217,int_stack+674597,int_stack+1319318, 2.0, int_stack+746207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1319318,int_stack+679217,int_stack+595252, 2.0, int_stack+1335866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1329398,int_stack+1319318,int_stack+1295231, 2.0, int_stack+1341914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1295231,int_stack+1329398,int_stack+102543, 2.0, int_stack+1349754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+312998,int_stack+312557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621887,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+103866,int_stack+313586,int_stack+312998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622328,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105630,int_stack+103866,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+108276,int_stack+314342,int_stack+313586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622916,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1319318,int_stack+108276,int_stack+103866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+765611,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1322846,int_stack+1319318,int_stack+105630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767375,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+315287,int_stack+314342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623672,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1327256,int_stack+102543,int_stack+108276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770021,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+105378,int_stack+1327256,int_stack+1319318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772289,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1331792,int_stack+105378,int_stack+1322846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788396,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1319318,int_stack+316442,int_stack+315287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624617,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1338407,int_stack+1319318,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+792806,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1319318,int_stack+1338407,int_stack+1327256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795641,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1338407,int_stack+1319318,int_stack+105378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688751,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1319318,int_stack+1338407,int_stack+1331792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694631,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+318416,int_stack+317828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379323,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1330343,int_stack+319200,int_stack+318416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380499,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1332695,int_stack+1330343,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701246,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1336223,int_stack+320208,int_stack+319200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382067,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1339247,int_stack+1336223,int_stack+1330343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703010,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1343951,int_stack+1339247,int_stack+1332695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705362,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+321468,int_stack+320208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384083,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1349831,int_stack+1328579,int_stack+1336223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800177,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+102543,int_stack+1349831,int_stack+1339247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749987,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1332359,int_stack+102543,int_stack+1343951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1377096,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1341179,int_stack+323008,int_stack+321468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386603,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+595252,int_stack+1341179,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7245,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+674597,int_stack+595252,int_stack+1349831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1382976,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1341179,int_stack+674597,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1389024,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+674597,int_stack+1341179,int_stack+1332359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396864,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+325297,int_stack+324856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621887, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+103866,int_stack+325885,int_stack+325297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622328, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105630,int_stack+103866,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+108276,int_stack+326641,int_stack+325885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622916, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+595252,int_stack+108276,int_stack+103866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+765611, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+598780,int_stack+595252,int_stack+105630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767375, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+327586,int_stack+326641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623672, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1328579,int_stack+102543,int_stack+108276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770021, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+105378,int_stack+1328579,int_stack+595252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772289, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1333115,int_stack+105378,int_stack+598780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788396, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+595252,int_stack+328741,int_stack+327586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624617, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+598717,int_stack+595252,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+792806, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1339730,int_stack+598717,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795641, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+595252,int_stack+1339730,int_stack+105378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688751, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1339730,int_stack+595252,int_stack+1333115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694631, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+595252,int_stack+330715,int_stack+330127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379323, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+597016,int_stack+331499,int_stack+330715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380499, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+599368,int_stack+597016,int_stack+595252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701246, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1348991,int_stack+332507,int_stack+331499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382067, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1352015,int_stack+1348991,int_stack+597016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703010, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1328579,int_stack+1352015,int_stack+599368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705362, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+595252,int_stack+333767,int_stack+332507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384083, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+102543,int_stack+595252,int_stack+1348991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800177, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1231027,int_stack+102543,int_stack+1352015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749987, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1348991,int_stack+1231027,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1377096, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1328579,int_stack+335307,int_stack+333767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386603, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1238867,int_stack+1328579,int_stack+595252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7245, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1328579,int_stack+1238867,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1382976, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1238867,int_stack+1328579,int_stack+1231027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1389024, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1250627,int_stack+1238867,int_stack+1348991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396864, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1348991,int_stack+337596,int_stack+337155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621887, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1350314,int_stack+338184,int_stack+337596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622328, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1352078,int_stack+1350314,int_stack+1348991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1354724,int_stack+338940,int_stack+338184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622916, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1231027,int_stack+1354724,int_stack+1350314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+765611, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1234555,int_stack+1231027,int_stack+1352078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767375, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1348991,int_stack+339885,int_stack+338940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623672, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1238965,int_stack+1348991,int_stack+1354724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770021, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1351826,int_stack+1238965,int_stack+1231027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772289, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1243501,int_stack+1351826,int_stack+1234555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788396, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1231027,int_stack+341040,int_stack+339885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624617, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+1231027,int_stack+1348991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+792806, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1231027,int_stack+1328579,int_stack+1238965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795641, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1231027,int_stack+1351826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688751, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1231027,int_stack+102543,int_stack+1243501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694631, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+343014,int_stack+342426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379323, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+343798,int_stack+343014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380499, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701246, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1240288,int_stack+344806,int_stack+343798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382067, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1243312,int_stack+1240288,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703010, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1328579,int_stack+1243312,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705362, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+346066,int_stack+344806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384083, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1348991,int_stack+102543,int_stack+1240288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800177, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1262975,int_stack+1348991,int_stack+1243312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749987, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1240288,int_stack+1262975,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1377096, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1328579,int_stack+347606,int_stack+346066, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386603, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1270815,int_stack+1328579,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7245, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1328579,int_stack+1270815,int_stack+1348991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1382976, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1270815,int_stack+1328579,int_stack+1262975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1389024, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1141224,int_stack+1270815,int_stack+1240288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396864, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1240288,int_stack+349895,int_stack+349454, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+621887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1241611,int_stack+350483,int_stack+349895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1243375,int_stack+1241611,int_stack+1240288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1246021,int_stack+351239,int_stack+350483, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1262975,int_stack+1246021,int_stack+1241611, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+765611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1266503,int_stack+1262975,int_stack+1243375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1240288,int_stack+352184,int_stack+351239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1270913,int_stack+1240288,int_stack+1246021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1243123,int_stack+1270913,int_stack+1262975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+772289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1275449,int_stack+1243123,int_stack+1266503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+788396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1262975,int_stack+353339,int_stack+352184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+1262975,int_stack+1240288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+792806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1262975,int_stack+1328579,int_stack+1270913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1262975,int_stack+1243123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+688751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1262975,int_stack+102543,int_stack+1275449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+355313,int_stack+354725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+379323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+356097,int_stack+355313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1272236,int_stack+357105,int_stack+356097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1275260,int_stack+1272236,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1328579,int_stack+1275260,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+358365,int_stack+357105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1240288,int_stack+102543,int_stack+1272236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1348991,int_stack+1240288,int_stack+1275260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1272236,int_stack+1348991,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1377096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1328579,int_stack+359905,int_stack+358365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+595252,int_stack+1328579,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1328579,int_stack+595252,int_stack+1240288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1382976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1153572,int_stack+1328579,int_stack+1348991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1389024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1165332,int_stack+1153572,int_stack+1272236, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1396864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1272236,int_stack+362194,int_stack+361753, 0.0, zero_stack, 1.0, int_stack+621887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1273559,int_stack+362782,int_stack+362194, 0.0, zero_stack, 1.0, int_stack+622328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1275323,int_stack+1273559,int_stack+1272236, 0.0, zero_stack, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1277969,int_stack+363538,int_stack+362782, 0.0, zero_stack, 1.0, int_stack+622916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1153572,int_stack+1277969,int_stack+1273559, 0.0, zero_stack, 1.0, int_stack+765611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1157100,int_stack+1153572,int_stack+1275323, 0.0, zero_stack, 1.0, int_stack+767375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1272236,int_stack+364483,int_stack+363538, 0.0, zero_stack, 1.0, int_stack+623672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1348991,int_stack+1272236,int_stack+1277969, 0.0, zero_stack, 1.0, int_stack+770021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1275071,int_stack+1348991,int_stack+1153572, 0.0, zero_stack, 1.0, int_stack+772289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1328579,int_stack+1275071,int_stack+1157100, 0.0, zero_stack, 1.0, int_stack+788396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1153572,int_stack+365638,int_stack+364483, 0.0, zero_stack, 1.0, int_stack+624617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1157037,int_stack+1153572,int_stack+1272236, 0.0, zero_stack, 1.0, int_stack+792806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1240288,int_stack+1157037,int_stack+1348991, 0.0, zero_stack, 1.0, int_stack+795641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1240288,int_stack+1275071, 0.0, zero_stack, 1.0, int_stack+688751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1240288,int_stack+102543,int_stack+1328579, 0.0, zero_stack, 1.0, int_stack+694631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+367612,int_stack+367024, 0.0, zero_stack, 1.0, int_stack+379323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1330343,int_stack+368396,int_stack+367612, 0.0, zero_stack, 1.0, int_stack+380499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1332695,int_stack+1330343,int_stack+1328579, 0.0, zero_stack, 1.0, int_stack+701246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1336223,int_stack+369404,int_stack+368396, 0.0, zero_stack, 1.0, int_stack+382067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+102543,int_stack+1336223,int_stack+1330343, 0.0, zero_stack, 1.0, int_stack+703010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1348991,int_stack+102543,int_stack+1332695, 0.0, zero_stack, 1.0, int_stack+705362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+370664,int_stack+369404, 0.0, zero_stack, 1.0, int_stack+384083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1272236,int_stack+1328579,int_stack+1336223, 0.0, zero_stack, 1.0, int_stack+800177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1153572,int_stack+1272236,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+749987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+102543,int_stack+1153572,int_stack+1348991, 0.0, zero_stack, 1.0, int_stack+1377096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1348991,int_stack+372204,int_stack+370664, 0.0, zero_stack, 1.0, int_stack+386603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+595252,int_stack+1348991,int_stack+1328579, 0.0, zero_stack, 1.0, int_stack+7245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1328579,int_stack+595252,int_stack+1272236, 0.0, zero_stack, 1.0, int_stack+1382976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1202341,int_stack+1328579,int_stack+1153572, 0.0, zero_stack, 1.0, int_stack+1389024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1034663,int_stack+1202341,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1396864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+374493,int_stack+374052, 1.0, int_stack+621887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+103866,int_stack+375081,int_stack+374493, 1.0, int_stack+622328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105630,int_stack+103866,int_stack+102543, 1.0, int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+108276,int_stack+375837,int_stack+375081, 1.0, int_stack+622916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1202341,int_stack+108276,int_stack+103866, 1.0, int_stack+765611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1205869,int_stack+1202341,int_stack+105630, 1.0, int_stack+767375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+376782,int_stack+375837, 1.0, int_stack+623672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+102543,int_stack+764288,int_stack+108276, 1.0, int_stack+770021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1210279,int_stack+102543,int_stack+1202341, 1.0, int_stack+772289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+1210279,int_stack+1205869, 1.0, int_stack+788396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+788396,int_stack+377937,int_stack+376782, 1.0, int_stack+624617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1202341,int_stack+788396,int_stack+764288, 1.0, int_stack+792806, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1153572,int_stack+1202341,int_stack+102543, 1.0, int_stack+795641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1153572,int_stack+1210279, 1.0, int_stack+688751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1153572,int_stack+102543,int_stack+767123, 1.0, int_stack+694631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+381283,int_stack+379911, 1.0, int_stack+379323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+383075,int_stack+381283, 1.0, int_stack+380499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+701246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1202341,int_stack+385343,int_stack+383075, 1.0, int_stack+382067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1205365,int_stack+1202341,int_stack+104307, 1.0, int_stack+703010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1210069,int_stack+1205365,int_stack+106659, 1.0, int_stack+705362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+388143,int_stack+385343, 1.0, int_stack+384083, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+764288,int_stack+102543,int_stack+1202341, 1.0, int_stack+800177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+788396,int_stack+764288,int_stack+1205365, 1.0, int_stack+749987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+796236,int_stack+788396,int_stack+1210069, 1.0, int_stack+1377096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1377096,int_stack+389683,int_stack+388143, 1.0, int_stack+386603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1202341,int_stack+1377096,int_stack+102543, 1.0, int_stack+7245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1209901,int_stack+1202341,int_stack+764288, 1.0, int_stack+1382976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+764288,int_stack+1209901,int_stack+788396, 1.0, int_stack+1389024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1202341,int_stack+764288,int_stack+796236, 1.0, int_stack+1396864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+391972,int_stack+391531,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+392560,int_stack+391972,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+393316,int_stack+392560,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+788396,int_stack+772289,int_stack+767375,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+394261,int_stack+393316,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+792806,int_stack+764288,int_stack+770021,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+797342,int_stack+792806,int_stack+772289,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+797342,int_stack+788396,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+788396,int_stack+395416,int_stack+394261,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+803222,int_stack+788396,int_stack+764288,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+808892,int_stack+803222,int_stack+792806,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+808892,int_stack+797342,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+788396,int_stack+102543,int_stack+767123,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+397390,int_stack+396802,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+398174,int_stack+397390,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+764288,int_stack+399182,int_stack+398174,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+767312,int_stack+764288,int_stack+104307,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+797657,int_stack+767312,int_stack+106659,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+400442,int_stack+399182,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+803537,int_stack+102543,int_stack+764288,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+809585,int_stack+803537,int_stack+767312,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+764288,int_stack+809585,int_stack+797657,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+797657,int_stack+401982,int_stack+400442,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+817425,int_stack+797657,int_stack+102543,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+824985,int_stack+817425,int_stack+803537,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+797657,int_stack+824985,int_stack+809585,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+809417,int_stack+797657,int_stack+764288,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+404271,int_stack+403830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639457,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+404859,int_stack+404271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639898,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1405684,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+405615,int_stack+404859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640486,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407007,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+797657,int_stack+772289,int_stack+767375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408771,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+406560,int_stack+405615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641242,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+802067,int_stack+764288,int_stack+770021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411417,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+102543,int_stack+802067,int_stack+772289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413685,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+102543,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1429792,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+797657,int_stack+407715,int_stack+406560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642187,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+821765,int_stack+797657,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11025,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+827435,int_stack+821765,int_stack+802067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434202,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+797657,int_stack+827435,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1438738,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+821765,int_stack+797657,int_stack+767123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1444618,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+797657,int_stack+409689,int_stack+409101, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470596,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+799421,int_stack+410473,int_stack+409689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471772,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+801773,int_stack+799421,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1451233,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+805301,int_stack+411481,int_stack+410473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473340,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+102543,int_stack+805301,int_stack+799421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1452997,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+831026,int_stack+102543,int_stack+801773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455349,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+797657,int_stack+412741,int_stack+411481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475356,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+836906,int_stack+797657,int_stack+805301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1469314,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+801437,int_stack+836906,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1472338,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+102543,int_stack+801437,int_stack+831026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477042,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+831026,int_stack+414281,int_stack+412741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477876,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+842954,int_stack+831026,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482922,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+850514,int_stack+842954,int_stack+836906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1486702,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+764288,int_stack+850514,int_stack+801437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1492750,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+831026,int_stack+764288,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500590,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+416570,int_stack+416129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639457, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+103866,int_stack+417158,int_stack+416570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639898, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105630,int_stack+103866,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1405684, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+108276,int_stack+417914,int_stack+417158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640486, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+764288,int_stack+108276,int_stack+103866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407007, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+767816,int_stack+764288,int_stack+105630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408771, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+418859,int_stack+417914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641242, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+797657,int_stack+102543,int_stack+108276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411417, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+105378,int_stack+797657,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413685, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+802193,int_stack+105378,int_stack+767816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1429792, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+764288,int_stack+420014,int_stack+418859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642187, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+767753,int_stack+764288,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11025, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+843374,int_stack+767753,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434202, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+764288,int_stack+843374,int_stack+105378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1438738, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+843374,int_stack+764288,int_stack+802193, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1444618, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+421988,int_stack+421400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470596, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+766052,int_stack+422772,int_stack+421988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471772, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+768404,int_stack+766052,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1451233, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+771932,int_stack+423780,int_stack+422772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473340, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+852635,int_stack+771932,int_stack+766052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1452997, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+857339,int_stack+852635,int_stack+768404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455349, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+425040,int_stack+423780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475356, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+797657,int_stack+764288,int_stack+771932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1469314, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+768068,int_stack+797657,int_stack+852635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1472338, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+102543,int_stack+768068,int_stack+857339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477042, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+852635,int_stack+426580,int_stack+425040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477876, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1377096,int_stack+852635,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482922, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+852635,int_stack+1377096,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1486702, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+797657,int_stack+852635,int_stack+768068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1492750, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1377096,int_stack+797657,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500590, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+428869,int_stack+428428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639457, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+103866,int_stack+429457,int_stack+428869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639898, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+105630,int_stack+103866,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1405684, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+108276,int_stack+430213,int_stack+429457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640486, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+797657,int_stack+108276,int_stack+103866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407007, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+801185,int_stack+797657,int_stack+105630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408771, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+431158,int_stack+430213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641242, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+852635,int_stack+102543,int_stack+108276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411417, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+105378,int_stack+852635,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413685, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+857171,int_stack+105378,int_stack+801185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1429792, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+797657,int_stack+432313,int_stack+431158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642187, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+801122,int_stack+797657,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11025, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1389444,int_stack+801122,int_stack+852635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434202, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+797657,int_stack+1389444,int_stack+105378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1438738, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1389444,int_stack+797657,int_stack+857171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1444618, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+797657,int_stack+434287,int_stack+433699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470596, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+799421,int_stack+435071,int_stack+434287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471772, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+801773,int_stack+799421,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1451233, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+805301,int_stack+436079,int_stack+435071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473340, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1398705,int_stack+805301,int_stack+799421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1452997, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+852635,int_stack+1398705,int_stack+801773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455349, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+797657,int_stack+437339,int_stack+436079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475356, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+102543,int_stack+797657,int_stack+805301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1469314, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+801437,int_stack+102543,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1472338, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+764288,int_stack+801437,int_stack+852635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477042, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+852635,int_stack+438879,int_stack+437339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477876, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+852635,int_stack+797657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482922, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+852635,int_stack+1328579,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1486702, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+686945,int_stack+852635,int_stack+801437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1492750, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1047011,int_stack+686945,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500590, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+441168,int_stack+440727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+441756,int_stack+441168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+639898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1405684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+442512,int_stack+441756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1407007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+686945,int_stack+772289,int_stack+767375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+443457,int_stack+442512, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+691355,int_stack+764288,int_stack+770021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+695891,int_stack+691355,int_stack+772289, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1413685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+695891,int_stack+686945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1429792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+686945,int_stack+444612,int_stack+443457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+701771,int_stack+686945,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+852635,int_stack+701771,int_stack+691355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+852635,int_stack+695891, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1438738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+852635,int_stack+102543,int_stack+767123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1444618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+446586,int_stack+445998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+447370,int_stack+446586, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1451233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+764288,int_stack+448378,int_stack+447370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+767312,int_stack+764288,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1452997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+686945,int_stack+767312,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1455349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+449638,int_stack+448378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+692825,int_stack+102543,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1469314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+698873,int_stack+692825,int_stack+767312, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1472338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+764288,int_stack+698873,int_stack+686945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1477042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+686945,int_stack+451178,int_stack+449638, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+686945,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1482922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+797657,int_stack+1328579,int_stack+692825, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1486702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+686945,int_stack+797657,int_stack+698873, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1492750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1059359,int_stack+686945,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1500590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+453467,int_stack+453026, 0.0, zero_stack, 1.0, int_stack+639457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+454055,int_stack+453467, 0.0, zero_stack, 1.0, int_stack+639898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288, 0.0, zero_stack, 1.0, int_stack+1405684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+454811,int_stack+454055, 0.0, zero_stack, 1.0, int_stack+640486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611, 0.0, zero_stack, 1.0, int_stack+1407007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+686945,int_stack+772289,int_stack+767375, 0.0, zero_stack, 1.0, int_stack+1408771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+455756,int_stack+454811, 0.0, zero_stack, 1.0, int_stack+641242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+691355,int_stack+764288,int_stack+770021, 0.0, zero_stack, 1.0, int_stack+1411417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+695891,int_stack+691355,int_stack+772289, 0.0, zero_stack, 1.0, int_stack+1413685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+695891,int_stack+686945, 0.0, zero_stack, 1.0, int_stack+1429792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+686945,int_stack+456911,int_stack+455756, 0.0, zero_stack, 1.0, int_stack+642187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+701771,int_stack+686945,int_stack+764288, 0.0, zero_stack, 1.0, int_stack+11025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+797657,int_stack+701771,int_stack+691355, 0.0, zero_stack, 1.0, int_stack+1434202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+797657,int_stack+695891, 0.0, zero_stack, 1.0, int_stack+1438738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+797657,int_stack+102543,int_stack+767123, 0.0, zero_stack, 1.0, int_stack+1444618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+458885,int_stack+458297, 0.0, zero_stack, 1.0, int_stack+470596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+459669,int_stack+458885, 0.0, zero_stack, 1.0, int_stack+471772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1451233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+764288,int_stack+460677,int_stack+459669, 0.0, zero_stack, 1.0, int_stack+473340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+767312,int_stack+764288,int_stack+104307, 0.0, zero_stack, 1.0, int_stack+1452997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+686945,int_stack+767312,int_stack+106659, 0.0, zero_stack, 1.0, int_stack+1455349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+461937,int_stack+460677, 0.0, zero_stack, 1.0, int_stack+475356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+692825,int_stack+102543,int_stack+764288, 0.0, zero_stack, 1.0, int_stack+1469314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+698873,int_stack+692825,int_stack+767312, 0.0, zero_stack, 1.0, int_stack+1472338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+764288,int_stack+698873,int_stack+686945, 0.0, zero_stack, 1.0, int_stack+1477042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+686945,int_stack+463477,int_stack+461937, 0.0, zero_stack, 1.0, int_stack+477876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+686945,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1482922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1272236,int_stack+1328579,int_stack+692825, 0.0, zero_stack, 1.0, int_stack+1486702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+686945,int_stack+1272236,int_stack+698873, 0.0, zero_stack, 1.0, int_stack+1492750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1095780,int_stack+686945,int_stack+764288, 0.0, zero_stack, 1.0, int_stack+1500590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+465766,int_stack+465325, 1.0, int_stack+639457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+466354,int_stack+465766, 1.0, int_stack+639898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288, 1.0, int_stack+1405684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+467110,int_stack+466354, 1.0, int_stack+640486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611, 1.0, int_stack+1407007, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+686945,int_stack+772289,int_stack+767375, 1.0, int_stack+1408771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+468055,int_stack+467110, 1.0, int_stack+641242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+691355,int_stack+764288,int_stack+770021, 1.0, int_stack+1411417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+695891,int_stack+691355,int_stack+772289, 1.0, int_stack+1413685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+695891,int_stack+686945, 1.0, int_stack+1429792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1429792,int_stack+469210,int_stack+468055, 1.0, int_stack+642187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+701771,int_stack+1429792,int_stack+764288, 1.0, int_stack+11025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1272236,int_stack+701771,int_stack+691355, 1.0, int_stack+1434202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1272236,int_stack+695891, 1.0, int_stack+1438738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1272236,int_stack+102543,int_stack+767123, 1.0, int_stack+1444618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+472556,int_stack+471184, 1.0, int_stack+470596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+474348,int_stack+472556, 1.0, int_stack+471772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 1.0, int_stack+1451233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+764288,int_stack+476616,int_stack+474348, 1.0, int_stack+473340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+767312,int_stack+764288,int_stack+104307, 1.0, int_stack+1452997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1429792,int_stack+767312,int_stack+106659, 1.0, int_stack+1455349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+479416,int_stack+476616, 1.0, int_stack+475356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1435672,int_stack+102543,int_stack+764288, 1.0, int_stack+1469314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1441720,int_stack+1435672,int_stack+767312, 1.0, int_stack+1472338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+764288,int_stack+1441720,int_stack+1429792, 1.0, int_stack+1477042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1429792,int_stack+480956,int_stack+479416, 1.0, int_stack+477876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1469314,int_stack+1429792,int_stack+102543, 1.0, int_stack+1482922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1449560,int_stack+1469314,int_stack+1435672, 1.0, int_stack+1486702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1469314,int_stack+1449560,int_stack+1441720, 1.0, int_stack+1492750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1481074,int_stack+1469314,int_stack+764288, 1.0, int_stack+1500590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+483245,int_stack+482804,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+483833,int_stack+483245,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+484589,int_stack+483833,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1469314,int_stack+772289,int_stack+767375,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+485534,int_stack+484589,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1473724,int_stack+764288,int_stack+770021,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1493422,int_stack+1473724,int_stack+772289,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+1493422,int_stack+1469314,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1469314,int_stack+486689,int_stack+485534,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1499302,int_stack+1469314,int_stack+764288,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+102543,int_stack+1499302,int_stack+1473724,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1499302,int_stack+102543,int_stack+1493422,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1469314,int_stack+1499302,int_stack+767123,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1493422,int_stack+488663,int_stack+488075,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1495186,int_stack+489447,int_stack+488663,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1497538,int_stack+1495186,int_stack+1493422,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1501066,int_stack+490455,int_stack+489447,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1504090,int_stack+1501066,int_stack+1495186,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+102543,int_stack+1504090,int_stack+1497538,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1493422,int_stack+491715,int_stack+490455,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+764288,int_stack+1493422,int_stack+1501066,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1429792,int_stack+764288,int_stack+1504090,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1497202,int_stack+1429792,int_stack+102543,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+102543,int_stack+493255,int_stack+491715,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1437632,int_stack+102543,int_stack+1493422,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1445192,int_stack+1437632,int_stack+764288,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+764288,int_stack+1445192,int_stack+1429792,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1429792,int_stack+764288,int_stack+1497202,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+764288,int_stack+495544,int_stack+495103,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+765611,int_stack+496132,int_stack+495544,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+767375,int_stack+765611,int_stack+764288,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+770021,int_stack+496888,int_stack+496132,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+772289,int_stack+770021,int_stack+765611,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1442140,int_stack+772289,int_stack+767375,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+764288,int_stack+497833,int_stack+496888,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1446550,int_stack+764288,int_stack+770021,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1451086,int_stack+1446550,int_stack+772289,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+767123,int_stack+1451086,int_stack+1442140,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1442140,int_stack+498988,int_stack+497833,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1493422,int_stack+1442140,int_stack+764288,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1499092,int_stack+1493422,int_stack+1446550,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1499092,int_stack+1451086,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1493422,int_stack+102543,int_stack+767123,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+500962,int_stack+500374,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+501746,int_stack+500962,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1502683,int_stack+502754,int_stack+501746,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+764288,int_stack+1502683,int_stack+104307,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+768992,int_stack+764288,int_stack+106659,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+504014,int_stack+502754,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1442140,int_stack+102543,int_stack+1502683,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1448188,int_stack+1442140,int_stack+764288,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+686945,int_stack+1448188,int_stack+768992,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+764288,int_stack+505554,int_stack+504014,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+695765,int_stack+764288,int_stack+102543,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+764288,int_stack+695765,int_stack+1442140,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+695765,int_stack+764288,int_stack+1448188,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1442140,int_stack+695765,int_stack+686945,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+686945,int_stack+513114,int_stack+512673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657027,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+688268,int_stack+513702,int_stack+513114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657468,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+690032,int_stack+688268,int_stack+686945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1509410,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+692678,int_stack+514458,int_stack+513702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658056,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+694946,int_stack+692678,int_stack+688268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1510733,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+698474,int_stack+694946,int_stack+690032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1512497,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+686945,int_stack+515403,int_stack+514458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658812,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+702884,int_stack+686945,int_stack+692678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515143,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+764288,int_stack+702884,int_stack+694946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1517411,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+689780,int_stack+764288,int_stack+698474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533518,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+696395,int_stack+516558,int_stack+515403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659757,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+770168,int_stack+696395,int_stack+686945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13860,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+102543,int_stack+770168,int_stack+702884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537928,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+696395,int_stack+102543,int_stack+764288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542464,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+764288,int_stack+696395,int_stack+689780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548344,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+773549,int_stack+518532,int_stack+517944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609679,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+102543,int_stack+519316,int_stack+518532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610855,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+104895,int_stack+102543,int_stack+773549, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1554959,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+686945,int_stack+520324,int_stack+519316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612423,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+689969,int_stack+686945,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1556723,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+694673,int_stack+689969,int_stack+104895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559075,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+521584,int_stack+520324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614439,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+700553,int_stack+102543,int_stack+686945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573040,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1328579,int_stack+700553,int_stack+689969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576064,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1398705,int_stack+1328579,int_stack+694673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580768,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+686945,int_stack+523124,int_stack+521584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616959,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+691565,int_stack+686945,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586648,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+691565,int_stack+700553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1590428,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+686945,int_stack+0,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596476,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+0,int_stack+686945,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1604316,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1398705,int_stack+530684,int_stack+530243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657027, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1400028,int_stack+531272,int_stack+530684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657468, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1401792,int_stack+1400028,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1509410, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1404438,int_stack+532028,int_stack+531272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658056, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1406706,int_stack+1404438,int_stack+1400028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1510733, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1410234,int_stack+1406706,int_stack+1401792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1512497, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1398705,int_stack+532973,int_stack+532028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658812, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+686945,int_stack+1398705,int_stack+1404438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515143, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+691481,int_stack+686945,int_stack+1406706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1517411, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1401540,int_stack+691481,int_stack+1410234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533518, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1408155,int_stack+534128,int_stack+532973, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659757, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1411620,int_stack+1408155,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13860, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+697361,int_stack+1411620,int_stack+686945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537928, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+697361,int_stack+691481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542464, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+686945,int_stack+102543,int_stack+1401540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548344, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+536102,int_stack+535514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609679, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+536886,int_stack+536102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610855, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1554959, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+696206,int_stack+537894,int_stack+536886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612423, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+699230,int_stack+696206,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1556723, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1398705,int_stack+699230,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559075, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+539154,int_stack+537894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614439, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1404585,int_stack+102543,int_stack+696206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573040, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1328579,int_stack+1404585,int_stack+699230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576064, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+696206,int_stack+1328579,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580768, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1398705,int_stack+540694,int_stack+539154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616959, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+595252,int_stack+1398705,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586648, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1108128,int_stack+595252,int_stack+1404585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1590428, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1398705,int_stack+1108128,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596476, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+930937,int_stack+1398705,int_stack+696206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1604316, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+696206,int_stack+548254,int_stack+547813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657027, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+697529,int_stack+548842,int_stack+548254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657468, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+699293,int_stack+697529,int_stack+696206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1509410, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+701939,int_stack+549598,int_stack+548842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658056, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+704207,int_stack+701939,int_stack+697529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1510733, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1398705,int_stack+704207,int_stack+699293, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1512497, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+696206,int_stack+550543,int_stack+549598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658812, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1403115,int_stack+696206,int_stack+701939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515143, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1407651,int_stack+1403115,int_stack+704207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1517411, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+699041,int_stack+1407651,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533518, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1398705,int_stack+551698,int_stack+550543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659757, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+1398705,int_stack+696206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13860, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1108128,int_stack+1328579,int_stack+1403115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537928, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1108128,int_stack+1407651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542464, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1108128,int_stack+102543,int_stack+699041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548344, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+102543,int_stack+553672,int_stack+553084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609679, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+104307,int_stack+554456,int_stack+553672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610855, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+106659,int_stack+104307,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1554959, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1328579,int_stack+555464,int_stack+554456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612423, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1331603,int_stack+1328579,int_stack+104307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1556723, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+696206,int_stack+1331603,int_stack+106659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559075, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+102543,int_stack+556724,int_stack+555464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614439, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+702086,int_stack+102543,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573040, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1398705,int_stack+702086,int_stack+1331603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576064, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1328579,int_stack+1398705,int_stack+696206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580768, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+696206,int_stack+558264,int_stack+556724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616959, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1406545,int_stack+696206,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586648, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+943285,int_stack+1406545,int_stack+702086, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1590428, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+696206,int_stack+943285,int_stack+1398705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596476, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1398705,int_stack+696206,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1604316, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+565824,int_stack+565383, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1329902,int_stack+566412,int_stack+565824, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1331666,int_stack+1329902,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1509410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1334312,int_stack+567168,int_stack+566412, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+696206,int_stack+1334312,int_stack+1329902, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1510733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+699734,int_stack+696206,int_stack+1331666, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1512497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+568113,int_stack+567168, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+658812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+704144,int_stack+1328579,int_stack+1334312, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1331414,int_stack+704144,int_stack+696206, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1517411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+943285,int_stack+1331414,int_stack+699734, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1533518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+696206,int_stack+569268,int_stack+568113, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+659757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1411053,int_stack+696206,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+696206,int_stack+1411053,int_stack+704144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+696206,int_stack+1331414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1542464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+696206,int_stack+102543,int_stack+943285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+943285,int_stack+571242,int_stack+570654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+609679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945049,int_stack+572026,int_stack+571242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+947401,int_stack+945049,int_stack+943285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1554959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+950929,int_stack+573034,int_stack+572026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+953953,int_stack+950929,int_stack+945049, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1556723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+958657,int_stack+953953,int_stack+947401, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1559075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+943285,int_stack+574294,int_stack+573034, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+614439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+102543,int_stack+943285,int_stack+950929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1573040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1328579,int_stack+102543,int_stack+953953, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1576064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+947065,int_stack+1328579,int_stack+958657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1580768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+955885,int_stack+575834,int_stack+574294, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+616959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+960505,int_stack+955885,int_stack+943285, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+992054,int_stack+960505,int_stack+102543, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1590428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+955885,int_stack+992054,int_stack+1328579, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1596476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+992054,int_stack+955885,int_stack+947065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1604316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+583394,int_stack+582953, 0.0, zero_stack, 1.0, int_stack+657027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1329902,int_stack+583982,int_stack+583394, 0.0, zero_stack, 1.0, int_stack+657468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1331666,int_stack+1329902,int_stack+1328579, 0.0, zero_stack, 1.0, int_stack+1509410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1334312,int_stack+584738,int_stack+583982, 0.0, zero_stack, 1.0, int_stack+658056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1004402,int_stack+1334312,int_stack+1329902, 0.0, zero_stack, 1.0, int_stack+1510733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1007930,int_stack+1004402,int_stack+1331666, 0.0, zero_stack, 1.0, int_stack+1512497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+585683,int_stack+584738, 0.0, zero_stack, 1.0, int_stack+658812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+102543,int_stack+1328579,int_stack+1334312, 0.0, zero_stack, 1.0, int_stack+1515143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1331414,int_stack+102543,int_stack+1004402, 0.0, zero_stack, 1.0, int_stack+1517411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+943285,int_stack+1331414,int_stack+1007930, 0.0, zero_stack, 1.0, int_stack+1533518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1004402,int_stack+586838,int_stack+585683, 0.0, zero_stack, 1.0, int_stack+659757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+949900,int_stack+1004402,int_stack+1328579, 0.0, zero_stack, 1.0, int_stack+13860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1004402,int_stack+949900,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1537928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1004402,int_stack+1331414, 0.0, zero_stack, 1.0, int_stack+1542464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+949900,int_stack+102543,int_stack+943285, 0.0, zero_stack, 1.0, int_stack+1548344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+943285,int_stack+588812,int_stack+588224, 0.0, zero_stack, 1.0, int_stack+609679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945049,int_stack+589596,int_stack+588812, 0.0, zero_stack, 1.0, int_stack+610855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+102543,int_stack+945049,int_stack+943285, 0.0, zero_stack, 1.0, int_stack+1554959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+106071,int_stack+590604,int_stack+589596, 0.0, zero_stack, 1.0, int_stack+612423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1004402,int_stack+106071,int_stack+945049, 0.0, zero_stack, 1.0, int_stack+1556723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+943285,int_stack+1004402,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1559075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1009106,int_stack+591864,int_stack+590604, 0.0, zero_stack, 1.0, int_stack+614439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+959161,int_stack+1009106,int_stack+106071, 0.0, zero_stack, 1.0, int_stack+1573040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+102543,int_stack+959161,int_stack+1004402, 0.0, zero_stack, 1.0, int_stack+1576064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1328579,int_stack+102543,int_stack+943285, 0.0, zero_stack, 1.0, int_stack+1580768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+943285,int_stack+593404,int_stack+591864, 0.0, zero_stack, 1.0, int_stack+616959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1348991,int_stack+943285,int_stack+1009106, 0.0, zero_stack, 1.0, int_stack+1586648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+733586,int_stack+1348991,int_stack+959161, 0.0, zero_stack, 1.0, int_stack+1590428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+885493,int_stack+733586,int_stack+102543, 0.0, zero_stack, 1.0, int_stack+1596476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+733586,int_stack+885493,int_stack+1328579, 0.0, zero_stack, 1.0, int_stack+1604316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+604849,int_stack+604408, 1.0, int_stack+657027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1329902,int_stack+605437,int_stack+604849, 1.0, int_stack+657468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1331666,int_stack+1329902,int_stack+1328579, 1.0, int_stack+1509410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1334312,int_stack+606193,int_stack+605437, 1.0, int_stack+658056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+885493,int_stack+1334312,int_stack+1329902, 1.0, int_stack+1510733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+889021,int_stack+885493,int_stack+1331666, 1.0, int_stack+1512497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+607138,int_stack+606193, 1.0, int_stack+658812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+893431,int_stack+1328579,int_stack+1334312, 1.0, int_stack+1515143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1331414,int_stack+893431,int_stack+885493, 1.0, int_stack+1517411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+943285,int_stack+1331414,int_stack+889021, 1.0, int_stack+1533518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1533518,int_stack+608293,int_stack+607138, 1.0, int_stack+659757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+885493,int_stack+1533518,int_stack+1328579, 1.0, int_stack+13860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+897967,int_stack+885493,int_stack+893431, 1.0, int_stack+1537928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+897967,int_stack+1331414, 1.0, int_stack+1542464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+885493,int_stack+102543,int_stack+943285, 1.0, int_stack+1548344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+943285,int_stack+611639,int_stack+610267, 1.0, int_stack+609679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+945049,int_stack+613431,int_stack+611639, 1.0, int_stack+610855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+102543,int_stack+945049,int_stack+943285, 1.0, int_stack+1554959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+106071,int_stack+615699,int_stack+613431, 1.0, int_stack+612423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+894754,int_stack+106071,int_stack+945049, 1.0, int_stack+1556723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+943285,int_stack+894754,int_stack+102543, 1.0, int_stack+1559075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+899458,int_stack+618499,int_stack+615699, 1.0, int_stack+614439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+903238,int_stack+899458,int_stack+106071, 1.0, int_stack+1573040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+102543,int_stack+903238,int_stack+894754, 1.0, int_stack+1576064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1328579,int_stack+102543,int_stack+943285, 1.0, int_stack+1580768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+943285,int_stack+620039,int_stack+618499, 1.0, int_stack+616959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1573040,int_stack+943285,int_stack+899458, 1.0, int_stack+1586648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1533518,int_stack+1573040,int_stack+903238, 1.0, int_stack+1590428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1573040,int_stack+1533518,int_stack+102543, 1.0, int_stack+1596476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1533518,int_stack+1573040,int_stack+1328579, 1.0, int_stack+1604316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+627599,int_stack+627158,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1329902,int_stack+628187,int_stack+627599,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1331666,int_stack+1329902,int_stack+1328579,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1334312,int_stack+628943,int_stack+628187,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1573040,int_stack+1334312,int_stack+1329902,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1576568,int_stack+1573040,int_stack+1331666,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+629888,int_stack+628943,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1580978,int_stack+1328579,int_stack+1334312,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1331414,int_stack+1580978,int_stack+1573040,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+943285,int_stack+1331414,int_stack+1576568,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1573040,int_stack+631043,int_stack+629888,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1585514,int_stack+1573040,int_stack+1328579,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1573040,int_stack+1585514,int_stack+1580978,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+102543,int_stack+1573040,int_stack+1331414,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1573040,int_stack+102543,int_stack+943285,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+943285,int_stack+633017,int_stack+632429,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+945049,int_stack+633801,int_stack+633017,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+102543,int_stack+945049,int_stack+943285,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+106071,int_stack+634809,int_stack+633801,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1582301,int_stack+106071,int_stack+945049,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+943285,int_stack+1582301,int_stack+102543,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1587005,int_stack+636069,int_stack+634809,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1590785,int_stack+1587005,int_stack+106071,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+102543,int_stack+1590785,int_stack+1582301,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1596833,int_stack+102543,int_stack+943285,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+943285,int_stack+637609,int_stack+636069,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1328579,int_stack+943285,int_stack+1587005,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1545866,int_stack+1328579,int_stack+1590785,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1582301,int_stack+1545866,int_stack+102543,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1545866,int_stack+1582301,int_stack+1596833,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1582301,int_stack+645169,int_stack+644728,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1583624,int_stack+645757,int_stack+645169,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1585388,int_stack+1583624,int_stack+1582301,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1588034,int_stack+646513,int_stack+645757,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1590302,int_stack+1588034,int_stack+1583624,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1593830,int_stack+1590302,int_stack+1585388,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1582301,int_stack+647458,int_stack+646513,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1598240,int_stack+1582301,int_stack+1588034,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1602776,int_stack+1598240,int_stack+1590302,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+943285,int_stack+1602776,int_stack+1593830,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1585136,int_stack+648613,int_stack+647458,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1588601,int_stack+1585136,int_stack+1582301,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+102543,int_stack+1588601,int_stack+1598240,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1582301,int_stack+102543,int_stack+1602776,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1591121,int_stack+1582301,int_stack+943285,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+943285,int_stack+650587,int_stack+649999,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+945049,int_stack+651371,int_stack+650587,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1582301,int_stack+945049,int_stack+943285,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1585829,int_stack+652379,int_stack+651371,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+102543,int_stack+1585829,int_stack+945049,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+943285,int_stack+102543,int_stack+1582301,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+107247,int_stack+653639,int_stack+652379,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1600382,int_stack+107247,int_stack+1585829,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1582301,int_stack+1600382,int_stack+102543,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1328579,int_stack+1582301,int_stack+943285,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+943285,int_stack+655179,int_stack+653639,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+894754,int_stack+943285,int_stack+107247,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+959161,int_stack+894754,int_stack+1600382,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1600382,int_stack+959161,int_stack+1582301,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+894754,int_stack+1600382,int_stack+1328579,28);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1328579,int_stack+662739,int_stack+662298,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1329902,int_stack+663327,int_stack+662739,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1331666,int_stack+1329902,int_stack+1328579,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1334312,int_stack+664083,int_stack+663327,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1600382,int_stack+1334312,int_stack+1329902,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1603910,int_stack+1600382,int_stack+1331666,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1328579,int_stack+665028,int_stack+664083,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1608320,int_stack+1328579,int_stack+1334312,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1331414,int_stack+1608320,int_stack+1600382,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+943285,int_stack+1331414,int_stack+1603910,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1600382,int_stack+666183,int_stack+665028,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1582301,int_stack+1600382,int_stack+1328579,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1600382,int_stack+1582301,int_stack+1608320,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1582301,int_stack+1600382,int_stack+1331414,21);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1600382,int_stack+1582301,int_stack+943285,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+943285,int_stack+668157,int_stack+667569,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+945049,int_stack+668941,int_stack+668157,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1582301,int_stack+945049,int_stack+943285,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1585829,int_stack+669949,int_stack+668941,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1328579,int_stack+1585829,int_stack+945049,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+943285,int_stack+1328579,int_stack+1582301,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1333283,int_stack+671209,int_stack+669949,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+959161,int_stack+1333283,int_stack+1585829,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1582301,int_stack+959161,int_stack+1328579,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+102543,int_stack+1582301,int_stack+943285,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+943285,int_stack+672749,int_stack+671209,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+745934,int_stack+943285,int_stack+1333283,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1328579,int_stack+745934,int_stack+959161,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1502683,int_stack+1328579,int_stack+1582301,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+187362,int_stack+1502683,int_stack+102543,28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+199710,int_stack+863884,int_stack+755027,441);
     Libderiv->ABCD[11] = int_stack + 199710;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+227493,int_stack+970445,int_stack+909328,441);
     Libderiv->ABCD[10] = int_stack + 227493;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+255276,int_stack+1074171,int_stack+1013054,441);
     Libderiv->ABCD[9] = int_stack + 255276;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+283059,int_stack+1180732,int_stack+1119615,441);
     Libderiv->ABCD[8] = int_stack + 283059;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+310842,int_stack+1282883,int_stack+1221766,441);
     Libderiv->ABCD[7] = int_stack + 310842;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+338625,int_stack+776048,int_stack+1310057,441);
     Libderiv->ABCD[6] = int_stack + 338625;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+366408,int_stack+1417444,int_stack+1367835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1358574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 366408;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+394191,int_stack+1521170,int_stack+1460053, 0.0, zero_stack, 1.0, int_stack+1358574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 394191;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1502683,int_stack+1624896,int_stack+1563779, 1.0, int_stack+1358574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 1502683;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+421974,int_stack+1646505,int_stack+1637244,441);
     Libderiv->ABCD[155] = int_stack + 421974;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+449757,int_stack+16695,int_stack+1658853,441);
     Libderiv->ABCD[143] = int_stack + 449757;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+477540,int_stack+38304,int_stack+29043,441);
     Libderiv->ABCD[142] = int_stack + 477540;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+12348,int_stack+1696702,int_stack+50652,441);
     Libderiv->ABCD[131] = int_stack + 12348;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+505323,int_stack+1709050,int_stack+59913,441);
     Libderiv->ABCD[130] = int_stack + 505323;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+40131,int_stack+1677375,int_stack+1668114,441);
     Libderiv->ABCD[129] = int_stack + 40131;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+533106,int_stack+80934,int_stack+1613136,441);
     Libderiv->ABCD[119] = int_stack + 533106;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1609643,int_stack+1721398,int_stack+93282,441);
     Libderiv->ABCD[118] = int_stack + 1609643;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1637426,int_stack+1743007,int_stack+1733746,441);
     Libderiv->ABCD[117] = int_stack + 1637426;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1665209,int_stack+1755355,int_stack+111363,441);
     Libderiv->ABCD[116] = int_stack + 1665209;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1692992,int_stack+1767703,int_stack+120624,441);
     Libderiv->ABCD[107] = int_stack + 1692992;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1720775,int_stack+150906,int_stack+129885,441);
     Libderiv->ABCD[106] = int_stack + 1720775;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1748558,int_stack+1789312,int_stack+1780051,441);
     Libderiv->ABCD[105] = int_stack + 1748558;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+560889,int_stack+175014,int_stack+69174,441);
     Libderiv->ABCD[104] = int_stack + 560889;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+67914,int_stack+1810921,int_stack+1801660,441);
     Libderiv->ABCD[103] = int_stack + 67914;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1776341,int_stack+708890,int_stack+139146,441);
     Libderiv->ABCD[95] = int_stack + 1776341;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+95697,int_stack+721238,int_stack+876232,441);
     Libderiv->ABCD[94] = int_stack + 95697;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+705467,int_stack+918589,int_stack+982793,441);
     Libderiv->ABCD[93] = int_stack + 705467;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+959161,int_stack+1022315,int_stack+1086519,441);
     Libderiv->ABCD[92] = int_stack + 959161;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+123480,int_stack+1128876,int_stack+1193080,441);
     Libderiv->ABCD[91] = int_stack + 123480;
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+588672,int_stack+1295231,int_stack+163254,441);
     Libderiv->ABCD[90] = int_stack + 588672;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+151263,int_stack+674597,int_stack+1319318, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[47] = int_stack + 151263;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1281497,int_stack+1250627,int_stack+1339730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+909328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[46] = int_stack + 1281497;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1319318,int_stack+1141224,int_stack+1231027, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1013054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[45] = int_stack + 1319318;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+616455,int_stack+1165332,int_stack+1262975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1119615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[44] = int_stack + 616455;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1162833,int_stack+1034663,int_stack+1240288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1221766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[43] = int_stack + 1162833;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1231027,int_stack+1202341,int_stack+1153572, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[42] = int_stack + 1231027;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1128876,int_stack+809417,int_stack+788396, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1367835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[38] = int_stack + 1128876;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1190616,int_stack+831026,int_stack+821765, 0.0, zero_stack, 1.0, int_stack+755027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[35] = int_stack + 1190616;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+806918,int_stack+1377096,int_stack+843374, 0.0, zero_stack, 1.0, int_stack+909328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[34] = int_stack + 806918;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+644238,int_stack+1047011,int_stack+1389444, 0.0, zero_stack, 1.0, int_stack+1013054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[33] = int_stack + 644238;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1022315,int_stack+1059359,int_stack+852635, 0.0, zero_stack, 1.0, int_stack+1119615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[32] = int_stack + 1022315;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1050098,int_stack+1095780,int_stack+797657, 0.0, zero_stack, 1.0, int_stack+1221766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[31] = int_stack + 1050098;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1077881,int_stack+1481074,int_stack+1272236, 0.0, zero_stack, 1.0, int_stack+1310057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[30] = int_stack + 1077881;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+773549,int_stack+1429792,int_stack+1469314, 0.0, zero_stack, 1.0, int_stack+1367835, 1.0, int_stack+1460053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[26] = int_stack + 773549;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1411053,int_stack+1442140,int_stack+1493422, 0.0, zero_stack, 2.0, int_stack+1460053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[25] = int_stack + 1411053;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1469314,int_stack+0,int_stack+764288, 1.0, int_stack+755027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[23] = int_stack + 1469314;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+834701,int_stack+930937,int_stack+686945, 1.0, int_stack+909328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[22] = int_stack + 834701;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+907102,int_stack+1398705,int_stack+1108128, 1.0, int_stack+1013054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[21] = int_stack + 907102;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1377096,int_stack+992054,int_stack+696206, 1.0, int_stack+1119615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[20] = int_stack + 1377096;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+986944,int_stack+733586,int_stack+949900, 1.0, int_stack+1221766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[19] = int_stack + 986944;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+733250,int_stack+1533518,int_stack+885493, 1.0, int_stack+1310057, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[18] = int_stack + 733250;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+862484,int_stack+1545866,int_stack+1573040, 1.0, int_stack+1367835, 0.0, zero_stack, 1.0, int_stack+1563779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[14] = int_stack + 862484;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1347101,int_stack+894754,int_stack+1591121, 1.0, int_stack+1460053, 1.0, int_stack+1563779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[13] = int_stack + 1347101;
 /*--- compute (hp|hh) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1530466,int_stack+187362,int_stack+1600382, 2.0, int_stack+1563779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[12] = int_stack + 1530466;

}
