/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ifhh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (if|hh) integrals */

void d1hrr_order_ifhh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1372;
 Libderiv->deriv_classes[6][8][11] = int_stack + 2380;
 Libderiv->deriv_classes[6][9][11] = int_stack + 3640;
 Libderiv->deriv_classes[6][10][11] = int_stack + 5180;
 Libderiv->deriv_classes[7][5][11] = int_stack + 7028;
 Libderiv->deriv_classes[7][6][11] = int_stack + 7784;
 Libderiv->deriv_classes[7][7][11] = int_stack + 8792;
 Libderiv->deriv_classes[7][8][11] = int_stack + 10088;
 Libderiv->deriv_classes[7][9][11] = int_stack + 11708;
 Libderiv->deriv_classes[7][10][11] = int_stack + 13688;
 Libderiv->deriv_classes[8][5][11] = int_stack + 16064;
 Libderiv->deriv_classes[8][6][11] = int_stack + 17009;
 Libderiv->deriv_classes[8][7][11] = int_stack + 18269;
 Libderiv->deriv_classes[8][8][11] = int_stack + 19889;
 Libderiv->deriv_classes[8][9][11] = int_stack + 21914;
 Libderiv->deriv_classes[8][10][11] = int_stack + 24389;
 Libderiv->deriv_classes[9][5][11] = int_stack + 27359;
 Libderiv->deriv_classes[9][6][11] = int_stack + 28514;
 Libderiv->deriv_classes[9][7][11] = int_stack + 30054;
 Libderiv->deriv_classes[9][8][11] = int_stack + 32034;
 Libderiv->deriv_classes[9][9][11] = int_stack + 34509;
 Libderiv->deriv_classes[9][10][11] = int_stack + 37534;
 Libderiv->deriv_classes[6][5][10] = int_stack + 41164;
 Libderiv->deriv_classes[6][6][10] = int_stack + 41752;
 Libderiv->deriv_classes[6][7][10] = int_stack + 42536;
 Libderiv->deriv_classes[6][8][10] = int_stack + 43544;
 Libderiv->deriv_classes[6][9][10] = int_stack + 44804;
 Libderiv->deriv_classes[6][10][10] = int_stack + 46344;
 Libderiv->deriv_classes[7][5][10] = int_stack + 48192;
 Libderiv->deriv_classes[7][6][10] = int_stack + 48948;
 Libderiv->deriv_classes[7][7][10] = int_stack + 49956;
 Libderiv->deriv_classes[7][8][10] = int_stack + 51252;
 Libderiv->deriv_classes[7][9][10] = int_stack + 52872;
 Libderiv->deriv_classes[7][10][10] = int_stack + 54852;
 Libderiv->deriv_classes[8][5][10] = int_stack + 57228;
 Libderiv->deriv_classes[8][6][10] = int_stack + 58173;
 Libderiv->deriv_classes[8][7][10] = int_stack + 59433;
 Libderiv->deriv_classes[8][8][10] = int_stack + 61053;
 Libderiv->deriv_classes[8][9][10] = int_stack + 63078;
 Libderiv->deriv_classes[8][10][10] = int_stack + 65553;
 Libderiv->deriv_classes[9][5][10] = int_stack + 68523;
 Libderiv->deriv_classes[9][6][10] = int_stack + 69678;
 Libderiv->deriv_classes[9][7][10] = int_stack + 71218;
 Libderiv->deriv_classes[9][8][10] = int_stack + 73198;
 Libderiv->deriv_classes[9][9][10] = int_stack + 75673;
 Libderiv->deriv_classes[9][10][10] = int_stack + 78698;
 Libderiv->deriv_classes[6][5][9] = int_stack + 82328;
 Libderiv->deriv_classes[6][6][9] = int_stack + 82916;
 Libderiv->deriv_classes[6][7][9] = int_stack + 83700;
 Libderiv->deriv_classes[6][8][9] = int_stack + 84708;
 Libderiv->deriv_classes[6][9][9] = int_stack + 85968;
 Libderiv->deriv_classes[6][10][9] = int_stack + 87508;
 Libderiv->deriv_classes[7][5][9] = int_stack + 89356;
 Libderiv->deriv_classes[7][6][9] = int_stack + 90112;
 Libderiv->deriv_classes[7][7][9] = int_stack + 91120;
 Libderiv->deriv_classes[7][8][9] = int_stack + 92416;
 Libderiv->deriv_classes[7][9][9] = int_stack + 94036;
 Libderiv->deriv_classes[7][10][9] = int_stack + 96016;
 Libderiv->deriv_classes[8][5][9] = int_stack + 98392;
 Libderiv->deriv_classes[8][6][9] = int_stack + 99337;
 Libderiv->deriv_classes[8][7][9] = int_stack + 100597;
 Libderiv->deriv_classes[8][8][9] = int_stack + 102217;
 Libderiv->deriv_classes[8][9][9] = int_stack + 104242;
 Libderiv->deriv_classes[8][10][9] = int_stack + 106717;
 Libderiv->deriv_classes[9][5][9] = int_stack + 109687;
 Libderiv->deriv_classes[9][6][9] = int_stack + 110842;
 Libderiv->deriv_classes[9][7][9] = int_stack + 112382;
 Libderiv->deriv_classes[9][8][9] = int_stack + 114362;
 Libderiv->deriv_classes[9][9][9] = int_stack + 116837;
 Libderiv->deriv_classes[9][10][9] = int_stack + 119862;
 Libderiv->deriv_classes[6][5][8] = int_stack + 123492;
 Libderiv->deriv_classes[6][6][8] = int_stack + 124080;
 Libderiv->deriv_classes[6][7][8] = int_stack + 124864;
 Libderiv->deriv_classes[6][8][8] = int_stack + 125872;
 Libderiv->deriv_classes[6][9][8] = int_stack + 127132;
 Libderiv->deriv_classes[6][10][8] = int_stack + 128672;
 Libderiv->deriv_classes[7][5][8] = int_stack + 130520;
 Libderiv->deriv_classes[7][6][8] = int_stack + 131276;
 Libderiv->deriv_classes[7][7][8] = int_stack + 132284;
 Libderiv->deriv_classes[7][8][8] = int_stack + 133580;
 Libderiv->deriv_classes[7][9][8] = int_stack + 135200;
 Libderiv->deriv_classes[7][10][8] = int_stack + 137180;
 Libderiv->deriv_classes[8][5][8] = int_stack + 139556;
 Libderiv->deriv_classes[8][6][8] = int_stack + 140501;
 Libderiv->deriv_classes[8][7][8] = int_stack + 141761;
 Libderiv->deriv_classes[8][8][8] = int_stack + 143381;
 Libderiv->deriv_classes[8][9][8] = int_stack + 145406;
 Libderiv->deriv_classes[8][10][8] = int_stack + 147881;
 Libderiv->deriv_classes[9][5][8] = int_stack + 150851;
 Libderiv->deriv_classes[9][6][8] = int_stack + 152006;
 Libderiv->deriv_classes[9][7][8] = int_stack + 153546;
 Libderiv->deriv_classes[9][8][8] = int_stack + 155526;
 Libderiv->deriv_classes[9][9][8] = int_stack + 158001;
 Libderiv->deriv_classes[9][10][8] = int_stack + 161026;
 Libderiv->deriv_classes[6][5][7] = int_stack + 164656;
 Libderiv->deriv_classes[6][6][7] = int_stack + 165244;
 Libderiv->deriv_classes[6][7][7] = int_stack + 166028;
 Libderiv->deriv_classes[6][8][7] = int_stack + 167036;
 Libderiv->deriv_classes[6][9][7] = int_stack + 168296;
 Libderiv->deriv_classes[6][10][7] = int_stack + 169836;
 Libderiv->deriv_classes[7][5][7] = int_stack + 171684;
 Libderiv->deriv_classes[7][6][7] = int_stack + 172440;
 Libderiv->deriv_classes[7][7][7] = int_stack + 173448;
 Libderiv->deriv_classes[7][8][7] = int_stack + 174744;
 Libderiv->deriv_classes[7][9][7] = int_stack + 176364;
 Libderiv->deriv_classes[7][10][7] = int_stack + 178344;
 Libderiv->deriv_classes[8][5][7] = int_stack + 180720;
 Libderiv->deriv_classes[8][6][7] = int_stack + 181665;
 Libderiv->deriv_classes[8][7][7] = int_stack + 182925;
 Libderiv->deriv_classes[8][8][7] = int_stack + 184545;
 Libderiv->deriv_classes[8][9][7] = int_stack + 186570;
 Libderiv->deriv_classes[8][10][7] = int_stack + 189045;
 Libderiv->deriv_classes[9][5][7] = int_stack + 192015;
 Libderiv->deriv_classes[9][6][7] = int_stack + 193170;
 Libderiv->deriv_classes[9][7][7] = int_stack + 194710;
 Libderiv->deriv_classes[9][8][7] = int_stack + 196690;
 Libderiv->deriv_classes[9][9][7] = int_stack + 199165;
 Libderiv->deriv_classes[9][10][7] = int_stack + 202190;
 Libderiv->deriv_classes[6][5][6] = int_stack + 205820;
 Libderiv->deriv_classes[6][6][6] = int_stack + 206408;
 Libderiv->deriv_classes[6][7][6] = int_stack + 207192;
 Libderiv->deriv_classes[6][8][6] = int_stack + 208200;
 Libderiv->deriv_classes[6][9][6] = int_stack + 209460;
 Libderiv->deriv_classes[6][10][6] = int_stack + 211000;
 Libderiv->deriv_classes[7][5][6] = int_stack + 212848;
 Libderiv->deriv_classes[7][6][6] = int_stack + 213604;
 Libderiv->deriv_classes[7][7][6] = int_stack + 214612;
 Libderiv->deriv_classes[7][8][6] = int_stack + 215908;
 Libderiv->deriv_classes[7][9][6] = int_stack + 217528;
 Libderiv->deriv_classes[7][10][6] = int_stack + 219508;
 Libderiv->deriv_classes[8][5][6] = int_stack + 221884;
 Libderiv->deriv_classes[8][6][6] = int_stack + 222829;
 Libderiv->deriv_classes[8][7][6] = int_stack + 224089;
 Libderiv->deriv_classes[8][8][6] = int_stack + 225709;
 Libderiv->deriv_classes[8][9][6] = int_stack + 227734;
 Libderiv->deriv_classes[8][10][6] = int_stack + 230209;
 Libderiv->dvrr_classes[9][5] = int_stack + 233179;
 Libderiv->deriv_classes[9][5][6] = int_stack + 234334;
 Libderiv->dvrr_classes[9][6] = int_stack + 235489;
 Libderiv->deriv_classes[9][6][6] = int_stack + 237029;
 Libderiv->dvrr_classes[9][7] = int_stack + 238569;
 Libderiv->deriv_classes[9][7][6] = int_stack + 240549;
 Libderiv->dvrr_classes[9][8] = int_stack + 242529;
 Libderiv->deriv_classes[9][8][6] = int_stack + 245004;
 Libderiv->dvrr_classes[9][9] = int_stack + 247479;
 Libderiv->deriv_classes[9][9][6] = int_stack + 250504;
 Libderiv->deriv_classes[9][10][6] = int_stack + 253529;
 Libderiv->deriv_classes[6][5][2] = int_stack + 257159;
 Libderiv->deriv_classes[6][6][2] = int_stack + 257747;
 Libderiv->deriv_classes[6][7][2] = int_stack + 258531;
 Libderiv->deriv_classes[6][8][2] = int_stack + 259539;
 Libderiv->deriv_classes[6][9][2] = int_stack + 260799;
 Libderiv->deriv_classes[6][10][2] = int_stack + 262339;
 Libderiv->deriv_classes[7][5][2] = int_stack + 264187;
 Libderiv->deriv_classes[7][6][2] = int_stack + 264943;
 Libderiv->deriv_classes[7][7][2] = int_stack + 265951;
 Libderiv->deriv_classes[7][8][2] = int_stack + 267247;
 Libderiv->deriv_classes[7][9][2] = int_stack + 268867;
 Libderiv->deriv_classes[7][10][2] = int_stack + 270847;
 Libderiv->deriv_classes[8][5][2] = int_stack + 273223;
 Libderiv->deriv_classes[8][6][2] = int_stack + 274168;
 Libderiv->deriv_classes[8][7][2] = int_stack + 275428;
 Libderiv->deriv_classes[8][8][2] = int_stack + 277048;
 Libderiv->deriv_classes[8][9][2] = int_stack + 279073;
 Libderiv->deriv_classes[8][10][2] = int_stack + 281548;
 Libderiv->deriv_classes[9][5][2] = int_stack + 284518;
 Libderiv->deriv_classes[9][6][2] = int_stack + 285673;
 Libderiv->deriv_classes[9][7][2] = int_stack + 287213;
 Libderiv->deriv_classes[9][8][2] = int_stack + 289193;
 Libderiv->deriv_classes[9][9][2] = int_stack + 291668;
 Libderiv->deriv_classes[9][10][2] = int_stack + 294693;
 Libderiv->deriv_classes[6][5][1] = int_stack + 298323;
 Libderiv->deriv_classes[6][6][1] = int_stack + 298911;
 Libderiv->deriv_classes[6][7][1] = int_stack + 299695;
 Libderiv->deriv_classes[6][8][1] = int_stack + 300703;
 Libderiv->deriv_classes[6][9][1] = int_stack + 301963;
 Libderiv->deriv_classes[6][10][1] = int_stack + 303503;
 Libderiv->deriv_classes[7][5][1] = int_stack + 305351;
 Libderiv->deriv_classes[7][6][1] = int_stack + 306107;
 Libderiv->deriv_classes[7][7][1] = int_stack + 307115;
 Libderiv->deriv_classes[7][8][1] = int_stack + 308411;
 Libderiv->deriv_classes[7][9][1] = int_stack + 310031;
 Libderiv->deriv_classes[7][10][1] = int_stack + 312011;
 Libderiv->deriv_classes[8][5][1] = int_stack + 314387;
 Libderiv->deriv_classes[8][6][1] = int_stack + 315332;
 Libderiv->deriv_classes[8][7][1] = int_stack + 316592;
 Libderiv->deriv_classes[8][8][1] = int_stack + 318212;
 Libderiv->deriv_classes[8][9][1] = int_stack + 320237;
 Libderiv->deriv_classes[8][10][1] = int_stack + 322712;
 Libderiv->deriv_classes[9][5][1] = int_stack + 325682;
 Libderiv->deriv_classes[9][6][1] = int_stack + 326837;
 Libderiv->deriv_classes[9][7][1] = int_stack + 328377;
 Libderiv->deriv_classes[9][8][1] = int_stack + 330357;
 Libderiv->deriv_classes[9][9][1] = int_stack + 332832;
 Libderiv->deriv_classes[9][10][1] = int_stack + 335857;
 Libderiv->dvrr_classes[6][5] = int_stack + 339487;
 Libderiv->dvrr_classes[6][6] = int_stack + 340075;
 Libderiv->dvrr_classes[6][7] = int_stack + 340859;
 Libderiv->dvrr_classes[6][8] = int_stack + 341867;
 Libderiv->dvrr_classes[6][9] = int_stack + 343127;
 Libderiv->dvrr_classes[6][10] = int_stack + 344667;
 Libderiv->deriv_classes[6][5][0] = int_stack + 346515;
 Libderiv->deriv_classes[6][6][0] = int_stack + 347103;
 Libderiv->deriv_classes[6][7][0] = int_stack + 347887;
 Libderiv->deriv_classes[6][8][0] = int_stack + 348895;
 Libderiv->deriv_classes[6][9][0] = int_stack + 350155;
 Libderiv->deriv_classes[6][10][0] = int_stack + 351695;
 Libderiv->dvrr_classes[7][5] = int_stack + 353543;
 Libderiv->dvrr_classes[7][6] = int_stack + 354299;
 Libderiv->dvrr_classes[7][7] = int_stack + 355307;
 Libderiv->dvrr_classes[7][8] = int_stack + 356603;
 Libderiv->dvrr_classes[7][9] = int_stack + 358223;
 Libderiv->dvrr_classes[7][10] = int_stack + 360203;
 Libderiv->deriv_classes[7][5][0] = int_stack + 362579;
 Libderiv->deriv_classes[7][6][0] = int_stack + 363335;
 Libderiv->deriv_classes[7][7][0] = int_stack + 364343;
 Libderiv->deriv_classes[7][8][0] = int_stack + 365639;
 Libderiv->deriv_classes[7][9][0] = int_stack + 367259;
 Libderiv->deriv_classes[7][10][0] = int_stack + 369239;
 Libderiv->dvrr_classes[8][5] = int_stack + 371615;
 Libderiv->dvrr_classes[8][6] = int_stack + 372560;
 Libderiv->dvrr_classes[8][7] = int_stack + 373820;
 Libderiv->dvrr_classes[8][8] = int_stack + 375440;
 Libderiv->dvrr_classes[8][9] = int_stack + 377465;
 Libderiv->dvrr_classes[8][10] = int_stack + 379940;
 Libderiv->deriv_classes[8][5][0] = int_stack + 382910;
 Libderiv->deriv_classes[8][6][0] = int_stack + 383855;
 Libderiv->deriv_classes[8][7][0] = int_stack + 385115;
 Libderiv->deriv_classes[8][8][0] = int_stack + 386735;
 Libderiv->deriv_classes[8][9][0] = int_stack + 388760;
 Libderiv->deriv_classes[8][10][0] = int_stack + 391235;
 Libderiv->deriv_classes[9][5][0] = int_stack + 394205;
 Libderiv->deriv_classes[9][6][0] = int_stack + 395360;
 Libderiv->deriv_classes[9][7][0] = int_stack + 396900;
 Libderiv->deriv_classes[9][8][0] = int_stack + 398880;
 Libderiv->deriv_classes[9][9][0] = int_stack + 401355;
 Libderiv->deriv_classes[9][10][0] = int_stack + 404380;
 memset(int_stack,0,3264080);

 Libderiv->dvrr_stack = int_stack + 2192970;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ifhh(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+408010,int_stack+340075,int_stack+339487,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+409774,int_stack+340859,int_stack+340075,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+412126,int_stack+409774,int_stack+408010,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+415654,int_stack+341867,int_stack+340859,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+418678,int_stack+415654,int_stack+409774,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+423382,int_stack+418678,int_stack+412126,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+429262,int_stack+343127,int_stack+341867,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+433042,int_stack+429262,int_stack+415654,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+439090,int_stack+433042,int_stack+418678,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+446930,int_stack+439090,int_stack+423382,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+455750,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339487,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+457514,int_stack+1372,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340075,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+459866,int_stack+457514,int_stack+455750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408010,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+463394,int_stack+2380,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340859,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+466418,int_stack+463394,int_stack+457514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409774,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+471122,int_stack+466418,int_stack+459866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412126,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+455750,int_stack+3640,int_stack+2380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341867,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+477002,int_stack+455750,int_stack+463394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415654,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+483050,int_stack+477002,int_stack+466418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418678,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+459530,int_stack+483050,int_stack+471122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423382,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+468350,int_stack+5180,int_stack+3640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343127,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+490890,int_stack+468350,int_stack+455750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429262,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+498450,int_stack+490890,int_stack+477002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433042,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+468350,int_stack+498450,int_stack+483050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439090,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+480110,int_stack+468350,int_stack+459530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446930,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+455750,int_stack+354299,int_stack+353543,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+458018,int_stack+355307,int_stack+354299,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+461042,int_stack+458018,int_stack+455750,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+465578,int_stack+356603,int_stack+355307,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+469466,int_stack+465578,int_stack+458018,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+492458,int_stack+469466,int_stack+461042,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+500018,int_stack+358223,int_stack+356603,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+504878,int_stack+500018,int_stack+465578,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+512654,int_stack+504878,int_stack+469466,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+522734,int_stack+512654,int_stack+492458,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+475514,int_stack+7784,int_stack+7028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353543,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+8792,int_stack+7784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354299,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3024,int_stack+0,int_stack+475514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455750,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+475514,int_stack+10088,int_stack+8792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355307,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+534074,int_stack+475514,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458018,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+540122,int_stack+534074,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461042,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+11708,int_stack+10088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356603,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+547682,int_stack+0,int_stack+475514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465578,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+555458,int_stack+547682,int_stack+534074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469466,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+565538,int_stack+555458,int_stack+540122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492458,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+534074,int_stack+13688,int_stack+11708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358223,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4860,int_stack+534074,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500018,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+534074,int_stack+4860,int_stack+547682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504878,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+534074,int_stack+555458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512654,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+534074,int_stack+0,int_stack+565538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522734,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+549950,int_stack+534074,int_stack+480110,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+372560,int_stack+371615,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2835,int_stack+373820,int_stack+372560,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6615,int_stack+2835,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+475514,int_stack+375440,int_stack+373820,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+480374,int_stack+475514,int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+586994,int_stack+480374,int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+596444,int_stack+377465,int_stack+375440,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+602519,int_stack+596444,int_stack+475514,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+612239,int_stack+602519,int_stack+480374,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+624839,int_stack+612239,int_stack+586994,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+17009,int_stack+16064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371615,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+487934,int_stack+18269,int_stack+17009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372560,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+639014,int_stack+487934,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12285,int_stack+19889,int_stack+18269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373820,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+644684,int_stack+12285,int_stack+487934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+652244,int_stack+644684,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+661694,int_stack+21914,int_stack+19889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375440,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+667769,int_stack+661694,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475514,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+677489,int_stack+667769,int_stack+644684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480374,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+690089,int_stack+677489,int_stack+652244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586994,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+12285,int_stack+24389,int_stack+21914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377465,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+639014,int_stack+12285,int_stack+661694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596444,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+651164,int_stack+639014,int_stack+667769, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602519,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+704264,int_stack+651164,int_stack+677489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612239,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+639014,int_stack+704264,int_stack+690089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624839,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+658859,int_stack+639014,int_stack+534074,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+706487,int_stack+658859,int_stack+549950,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+534074,int_stack+235489,int_stack+233179,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+537539,int_stack+238569,int_stack+235489,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+542159,int_stack+537539,int_stack+534074,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+549089,int_stack+242529,int_stack+238569,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+555029,int_stack+549089,int_stack+537539,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+564269,int_stack+555029,int_stack+542159,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+575819,int_stack+247479,int_stack+242529,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12285,int_stack+575819,int_stack+549089,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+780575,int_stack+12285,int_stack+555029,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+795975,int_stack+780575,int_stack+564269,55);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+583244,int_stack+28514,int_stack+27359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233179,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+813300,int_stack+30054,int_stack+28514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235489,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+817920,int_stack+813300,int_stack+583244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534074,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+824850,int_stack+32034,int_stack+30054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238569,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+830790,int_stack+824850,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537539,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+840030,int_stack+830790,int_stack+817920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542159,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+813300,int_stack+34509,int_stack+32034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242529,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+851580,int_stack+813300,int_stack+824850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549089,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+863460,int_stack+851580,int_stack+830790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+555029,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+820725,int_stack+863460,int_stack+840030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564269,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+838050,int_stack+37534,int_stack+34509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247479,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24165,int_stack+838050,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575819,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+878860,int_stack+24165,int_stack+851580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+838050,int_stack+878860,int_stack+863460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780575,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+861150,int_stack+838050,int_stack+820725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795975,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+885405,int_stack+861150,int_stack+639014,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+944940,int_stack+885405,int_stack+658859,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+639014,int_stack+41752,int_stack+41164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339487, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+640778,int_stack+42536,int_stack+41752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340075, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+643130,int_stack+640778,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408010, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+646658,int_stack+43544,int_stack+42536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340859, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+649682,int_stack+646658,int_stack+640778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409774, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+654386,int_stack+649682,int_stack+643130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412126, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+639014,int_stack+44804,int_stack+43544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341867, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+660266,int_stack+639014,int_stack+646658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415654, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+666314,int_stack+660266,int_stack+649682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418678, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+642794,int_stack+666314,int_stack+654386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423382, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+651614,int_stack+46344,int_stack+44804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343127, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+674154,int_stack+651614,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429262, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+681714,int_stack+674154,int_stack+660266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433042, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+651614,int_stack+681714,int_stack+666314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439090, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+663374,int_stack+651614,int_stack+642794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446930, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+639014,int_stack+48948,int_stack+48192, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353543, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+641282,int_stack+49956,int_stack+48948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354299, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+644306,int_stack+641282,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455750, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+648842,int_stack+51252,int_stack+49956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355307, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+652730,int_stack+648842,int_stack+641282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458018, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+675722,int_stack+652730,int_stack+644306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461042, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+639014,int_stack+52872,int_stack+51252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356603, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+683282,int_stack+639014,int_stack+648842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465578, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+691058,int_stack+683282,int_stack+652730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469466, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+643874,int_stack+691058,int_stack+675722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492458, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+675722,int_stack+54852,int_stack+52872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358223, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24165,int_stack+675722,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500018, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+33885,int_stack+24165,int_stack+683282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504878, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+675722,int_stack+33885,int_stack+691058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512654, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+24165,int_stack+675722,int_stack+643874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522734, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+813300,int_stack+24165,int_stack+663374,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+40041,int_stack+58173,int_stack+57228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371615, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42876,int_stack+59433,int_stack+58173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372560, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+46656,int_stack+42876,int_stack+40041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+52326,int_stack+61053,int_stack+59433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373820, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+639014,int_stack+52326,int_stack+42876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+646574,int_stack+639014,int_stack+46656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+40041,int_stack+63078,int_stack+61053, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375440, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+656024,int_stack+40041,int_stack+52326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475514, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+46116,int_stack+656024,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480374, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+665744,int_stack+46116,int_stack+646574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586994, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+639014,int_stack+65553,int_stack+63078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377465, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+679919,int_stack+639014,int_stack+40041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596444, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+639014,int_stack+679919,int_stack+656024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602519, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+679919,int_stack+639014,int_stack+46116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612239, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+639014,int_stack+679919,int_stack+665744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624839, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+658859,int_stack+639014,int_stack+24165,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+850344,int_stack+658859,int_stack+813300,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+813300,int_stack+69678,int_stack+68523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233179, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+816765,int_stack+71218,int_stack+69678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235489, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+821385,int_stack+816765,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534074, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+828315,int_stack+73198,int_stack+71218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238569, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+834255,int_stack+828315,int_stack+816765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537539, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+24165,int_stack+834255,int_stack+821385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542159, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+813300,int_stack+75673,int_stack+73198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242529, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35715,int_stack+813300,int_stack+828315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549089, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+47595,int_stack+35715,int_stack+834255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+555029, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+820725,int_stack+47595,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564269, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+24165,int_stack+78698,int_stack+75673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247479, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+62995,int_stack+24165,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575819, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+924432,int_stack+62995,int_stack+35715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+24165,int_stack+924432,int_stack+47595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780575, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+47265,int_stack+24165,int_stack+820725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795975, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1040196,int_stack+47265,int_stack+639014,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1099731,int_stack+1040196,int_stack+658859,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+82916,int_stack+82328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339487, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1041960,int_stack+83700,int_stack+82916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340075, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1044312,int_stack+1041960,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1047840,int_stack+84708,int_stack+83700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340859, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1050864,int_stack+1047840,int_stack+1041960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409774, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1055568,int_stack+1050864,int_stack+1044312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412126, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1040196,int_stack+85968,int_stack+84708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341867, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1061448,int_stack+1040196,int_stack+1047840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415654, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1067496,int_stack+1061448,int_stack+1050864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418678, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1043976,int_stack+1067496,int_stack+1055568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423382, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1052796,int_stack+87508,int_stack+85968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343127, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1075336,int_stack+1052796,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429262, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1082896,int_stack+1075336,int_stack+1061448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433042, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1052796,int_stack+1082896,int_stack+1067496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439090, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1064556,int_stack+1052796,int_stack+1043976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446930, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+90112,int_stack+89356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353543, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1042464,int_stack+91120,int_stack+90112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354299, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1045488,int_stack+1042464,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455750, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1050024,int_stack+92416,int_stack+91120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355307, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1053912,int_stack+1050024,int_stack+1042464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458018, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1076904,int_stack+1053912,int_stack+1045488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461042, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1040196,int_stack+94036,int_stack+92416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356603, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1084464,int_stack+1040196,int_stack+1050024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465578, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+639014,int_stack+1084464,int_stack+1053912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469466, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1045056,int_stack+639014,int_stack+1076904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492458, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1076904,int_stack+96016,int_stack+94036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358223, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+649094,int_stack+1076904,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500018, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+658814,int_stack+649094,int_stack+1084464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504878, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1076904,int_stack+658814,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512654, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+639014,int_stack+1076904,int_stack+1045056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522734, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+813300,int_stack+639014,int_stack+1064556,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+654890,int_stack+99337,int_stack+98392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371615, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+657725,int_stack+100597,int_stack+99337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372560, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+661505,int_stack+657725,int_stack+654890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+667175,int_stack+102217,int_stack+100597, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373820, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+672035,int_stack+667175,int_stack+657725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+679595,int_stack+672035,int_stack+661505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+654890,int_stack+104242,int_stack+102217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375440, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+689045,int_stack+654890,int_stack+667175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475514, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1040196,int_stack+689045,int_stack+672035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480374, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+660965,int_stack+1040196,int_stack+679595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586994, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+675140,int_stack+106717,int_stack+104242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377465, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1052796,int_stack+675140,int_stack+654890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596444, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1064946,int_stack+1052796,int_stack+689045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602519, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+675140,int_stack+1064946,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612239, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1040196,int_stack+675140,int_stack+660965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624839, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+654890,int_stack+1040196,int_stack+639014,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+24165,int_stack+654890,int_stack+813300,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+813300,int_stack+110842,int_stack+109687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233179, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+816765,int_stack+112382,int_stack+110842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235489, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+821385,int_stack+816765,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534074, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+828315,int_stack+114362,int_stack+112382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238569, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+834255,int_stack+828315,int_stack+816765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537539, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+639014,int_stack+834255,int_stack+821385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542159, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+813300,int_stack+116837,int_stack+114362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242529, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1060041,int_stack+813300,int_stack+828315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549089, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1071921,int_stack+1060041,int_stack+834255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+555029, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+820725,int_stack+1071921,int_stack+639014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564269, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+639014,int_stack+119862,int_stack+116837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247479, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+98253,int_stack+639014,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575819, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+924432,int_stack+98253,int_stack+1060041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+98253,int_stack+924432,int_stack+1071921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1060041,int_stack+98253,int_stack+820725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795975, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1194987,int_stack+1060041,int_stack+1040196,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1254522,int_stack+1194987,int_stack+654890,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1194987,int_stack+124080,int_stack+123492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1196751,int_stack+124864,int_stack+124080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1199103,int_stack+1196751,int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1202631,int_stack+125872,int_stack+124864, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+340859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1205655,int_stack+1202631,int_stack+1196751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+409774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1210359,int_stack+1205655,int_stack+1199103, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+412126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1194987,int_stack+127132,int_stack+125872, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1216239,int_stack+1194987,int_stack+1202631, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+415654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1222287,int_stack+1216239,int_stack+1205655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+418678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1198767,int_stack+1222287,int_stack+1210359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+423382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1207587,int_stack+128672,int_stack+127132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1230127,int_stack+1207587,int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1237687,int_stack+1230127,int_stack+1216239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1207587,int_stack+1237687,int_stack+1222287, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+439090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1219347,int_stack+1207587,int_stack+1198767, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1194987,int_stack+131276,int_stack+130520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+353543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1197255,int_stack+132284,int_stack+131276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+354299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1200279,int_stack+1197255,int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1204815,int_stack+133580,int_stack+132284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+355307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1208703,int_stack+1204815,int_stack+1197255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1231695,int_stack+1208703,int_stack+1200279, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+461042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1194987,int_stack+135200,int_stack+133580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+356603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1239255,int_stack+1194987,int_stack+1204815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+465578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1040196,int_stack+1239255,int_stack+1208703, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+469466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1199847,int_stack+1040196,int_stack+1231695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1231695,int_stack+137180,int_stack+135200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1050276,int_stack+1231695,int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+500018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1059996,int_stack+1050276,int_stack+1239255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+504878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1231695,int_stack+1059996,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1040196,int_stack+1231695,int_stack+1199847, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+813300,int_stack+1040196,int_stack+1219347,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1056072,int_stack+140501,int_stack+139556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+371615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1058907,int_stack+141761,int_stack+140501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1062687,int_stack+1058907,int_stack+1056072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068357,int_stack+143381,int_stack+141761, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+373820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1073217,int_stack+1068357,int_stack+1058907, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1080777,int_stack+1073217,int_stack+1062687, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1056072,int_stack+145406,int_stack+143381, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+375440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1194987,int_stack+1056072,int_stack+1068357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1204707,int_stack+1194987,int_stack+1073217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+480374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1062147,int_stack+1204707,int_stack+1080777, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+586994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1076322,int_stack+147881,int_stack+145406, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+377465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1083747,int_stack+1076322,int_stack+1056072, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+596444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1217307,int_stack+1083747,int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+602519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1076322,int_stack+1217307,int_stack+1204707, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1194987,int_stack+1076322,int_stack+1062147, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+98253,int_stack+1194987,int_stack+1040196,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1349778,int_stack+98253,int_stack+813300,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+813300,int_stack+152006,int_stack+150851, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+816765,int_stack+153546,int_stack+152006, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+235489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+821385,int_stack+816765,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+828315,int_stack+155526,int_stack+153546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+834255,int_stack+828315,int_stack+816765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1040196,int_stack+834255,int_stack+821385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+542159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+813300,int_stack+158001,int_stack+155526, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+242529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1051746,int_stack+813300,int_stack+828315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+549089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1063626,int_stack+1051746,int_stack+834255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+555029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+820725,int_stack+1063626,int_stack+1040196, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+564269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1040196,int_stack+161026,int_stack+158001, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+247479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1079026,int_stack+1040196,int_stack+813300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1214832,int_stack+1079026,int_stack+1051746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+1214832,int_stack+1063626, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1214832,int_stack+1040196,int_stack+820725, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1040196,int_stack+1214832,int_stack+1194987,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1423866,int_stack+1040196,int_stack+98253,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+98253,int_stack+165244,int_stack+164656, 0.0, zero_stack, 1.0, int_stack+339487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+100017,int_stack+166028,int_stack+165244, 0.0, zero_stack, 1.0, int_stack+340075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+102369,int_stack+100017,int_stack+98253, 0.0, zero_stack, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+105897,int_stack+167036,int_stack+166028, 0.0, zero_stack, 1.0, int_stack+340859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+108921,int_stack+105897,int_stack+100017, 0.0, zero_stack, 1.0, int_stack+409774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+113625,int_stack+108921,int_stack+102369, 0.0, zero_stack, 1.0, int_stack+412126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+98253,int_stack+168296,int_stack+167036, 0.0, zero_stack, 1.0, int_stack+341867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+119505,int_stack+98253,int_stack+105897, 0.0, zero_stack, 1.0, int_stack+415654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+125553,int_stack+119505,int_stack+108921, 0.0, zero_stack, 1.0, int_stack+418678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+102033,int_stack+125553,int_stack+113625, 0.0, zero_stack, 1.0, int_stack+423382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+110853,int_stack+169836,int_stack+168296, 0.0, zero_stack, 1.0, int_stack+343127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+133393,int_stack+110853,int_stack+98253, 0.0, zero_stack, 1.0, int_stack+429262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+140953,int_stack+133393,int_stack+119505, 0.0, zero_stack, 1.0, int_stack+433042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+110853,int_stack+140953,int_stack+125553, 0.0, zero_stack, 1.0, int_stack+439090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+122613,int_stack+110853,int_stack+102033, 0.0, zero_stack, 1.0, int_stack+446930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+98253,int_stack+172440,int_stack+171684, 0.0, zero_stack, 1.0, int_stack+353543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+100521,int_stack+173448,int_stack+172440, 0.0, zero_stack, 1.0, int_stack+354299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+103545,int_stack+100521,int_stack+98253, 0.0, zero_stack, 1.0, int_stack+455750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+108081,int_stack+174744,int_stack+173448, 0.0, zero_stack, 1.0, int_stack+355307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+111969,int_stack+108081,int_stack+100521, 0.0, zero_stack, 1.0, int_stack+458018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+134961,int_stack+111969,int_stack+103545, 0.0, zero_stack, 1.0, int_stack+461042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+98253,int_stack+176364,int_stack+174744, 0.0, zero_stack, 1.0, int_stack+356603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+142521,int_stack+98253,int_stack+108081, 0.0, zero_stack, 1.0, int_stack+465578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+150297,int_stack+142521,int_stack+111969, 0.0, zero_stack, 1.0, int_stack+469466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+103113,int_stack+150297,int_stack+134961, 0.0, zero_stack, 1.0, int_stack+492458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+134961,int_stack+178344,int_stack+176364, 0.0, zero_stack, 1.0, int_stack+358223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+160377,int_stack+134961,int_stack+98253, 0.0, zero_stack, 1.0, int_stack+500018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1040196,int_stack+160377,int_stack+142521, 0.0, zero_stack, 1.0, int_stack+504878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+160377,int_stack+1040196,int_stack+150297, 0.0, zero_stack, 1.0, int_stack+512654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1040196,int_stack+160377,int_stack+103113, 0.0, zero_stack, 1.0, int_stack+522734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+813300,int_stack+1040196,int_stack+122613,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1056072,int_stack+181665,int_stack+180720, 0.0, zero_stack, 1.0, int_stack+371615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1058907,int_stack+182925,int_stack+181665, 0.0, zero_stack, 1.0, int_stack+372560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1062687,int_stack+1058907,int_stack+1056072, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1068357,int_stack+184545,int_stack+182925, 0.0, zero_stack, 1.0, int_stack+373820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1073217,int_stack+1068357,int_stack+1058907, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1080777,int_stack+1073217,int_stack+1062687, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1056072,int_stack+186570,int_stack+184545, 0.0, zero_stack, 1.0, int_stack+375440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+98253,int_stack+1056072,int_stack+1068357, 0.0, zero_stack, 1.0, int_stack+475514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+107973,int_stack+98253,int_stack+1073217, 0.0, zero_stack, 1.0, int_stack+480374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1062147,int_stack+107973,int_stack+1080777, 0.0, zero_stack, 1.0, int_stack+586994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1076322,int_stack+189045,int_stack+186570, 0.0, zero_stack, 1.0, int_stack+377465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1083747,int_stack+1076322,int_stack+1056072, 0.0, zero_stack, 1.0, int_stack+596444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+120573,int_stack+1083747,int_stack+98253, 0.0, zero_stack, 1.0, int_stack+602519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1076322,int_stack+120573,int_stack+107973, 0.0, zero_stack, 1.0, int_stack+612239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+98253,int_stack+1076322,int_stack+1062147, 0.0, zero_stack, 1.0, int_stack+624839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+118098,int_stack+98253,int_stack+1040196,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1519122,int_stack+118098,int_stack+813300,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+813300,int_stack+193170,int_stack+192015, 0.0, zero_stack, 1.0, int_stack+233179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+816765,int_stack+194710,int_stack+193170, 0.0, zero_stack, 1.0, int_stack+235489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+821385,int_stack+816765,int_stack+813300, 0.0, zero_stack, 1.0, int_stack+534074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+828315,int_stack+196690,int_stack+194710, 0.0, zero_stack, 1.0, int_stack+238569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+834255,int_stack+828315,int_stack+816765, 0.0, zero_stack, 1.0, int_stack+537539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1040196,int_stack+834255,int_stack+821385, 0.0, zero_stack, 1.0, int_stack+542159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+813300,int_stack+199165,int_stack+196690, 0.0, zero_stack, 1.0, int_stack+242529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1051746,int_stack+813300,int_stack+828315, 0.0, zero_stack, 1.0, int_stack+549089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1063626,int_stack+1051746,int_stack+834255, 0.0, zero_stack, 1.0, int_stack+555029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+820725,int_stack+1063626,int_stack+1040196, 0.0, zero_stack, 1.0, int_stack+564269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1040196,int_stack+202190,int_stack+199165, 0.0, zero_stack, 1.0, int_stack+247479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1079026,int_stack+1040196,int_stack+813300, 0.0, zero_stack, 1.0, int_stack+575819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+165726,int_stack+1079026,int_stack+1051746, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+165726,int_stack+1063626, 0.0, zero_stack, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+165726,int_stack+1040196,int_stack+820725, 0.0, zero_stack, 1.0, int_stack+795975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1040196,int_stack+165726,int_stack+98253,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1593210,int_stack+1040196,int_stack+118098,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+206408,int_stack+205820, 1.0, int_stack+339487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1041960,int_stack+207192,int_stack+206408, 1.0, int_stack+340075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1044312,int_stack+1041960,int_stack+1040196, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1047840,int_stack+208200,int_stack+207192, 1.0, int_stack+340859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1050864,int_stack+1047840,int_stack+1041960, 1.0, int_stack+409774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1055568,int_stack+1050864,int_stack+1044312, 1.0, int_stack+412126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+408010,int_stack+209460,int_stack+208200, 1.0, int_stack+341867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1040196,int_stack+408010,int_stack+1047840, 1.0, int_stack+415654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1061448,int_stack+1040196,int_stack+1050864, 1.0, int_stack+418678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+411790,int_stack+1061448,int_stack+1055568, 1.0, int_stack+423382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+420610,int_stack+211000,int_stack+209460, 1.0, int_stack+343127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1046244,int_stack+420610,int_stack+408010, 1.0, int_stack+429262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1069288,int_stack+1046244,int_stack+1040196, 1.0, int_stack+433042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+1069288,int_stack+1061448, 1.0, int_stack+439090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1051956,int_stack+1040196,int_stack+411790, 1.0, int_stack+446930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+213604,int_stack+212848, 1.0, int_stack+353543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1042464,int_stack+214612,int_stack+213604, 1.0, int_stack+354299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1045488,int_stack+1042464,int_stack+1040196, 1.0, int_stack+455750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1064304,int_stack+215908,int_stack+214612, 1.0, int_stack+355307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1068192,int_stack+1064304,int_stack+1042464, 1.0, int_stack+458018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1074240,int_stack+1068192,int_stack+1045488, 1.0, int_stack+461042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+455750,int_stack+217528,int_stack+215908, 1.0, int_stack+356603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1040196,int_stack+455750,int_stack+1064304, 1.0, int_stack+465578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1081800,int_stack+1040196,int_stack+1068192, 1.0, int_stack+469466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+460610,int_stack+1081800,int_stack+1074240, 1.0, int_stack+492458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1064304,int_stack+219508,int_stack+217528, 1.0, int_stack+358223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1070244,int_stack+1064304,int_stack+455750, 1.0, int_stack+500018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+408010,int_stack+1070244,int_stack+1040196, 1.0, int_stack+504878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1064304,int_stack+408010,int_stack+1081800, 1.0, int_stack+512654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+408010,int_stack+1064304,int_stack+460610, 1.0, int_stack+522734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+813300,int_stack+408010,int_stack+1051956,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+423886,int_stack+222829,int_stack+221884, 1.0, int_stack+371615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1040196,int_stack+224089,int_stack+222829, 1.0, int_stack+372560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1043976,int_stack+1040196,int_stack+423886, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+423886,int_stack+225709,int_stack+224089, 1.0, int_stack+373820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1049646,int_stack+423886,int_stack+1040196, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1057206,int_stack+1049646,int_stack+1043976, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1040196,int_stack+227734,int_stack+225709, 1.0, int_stack+375440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+1040196,int_stack+423886, 1.0, int_stack+475514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1066656,int_stack+0,int_stack+1049646, 1.0, int_stack+480374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1079256,int_stack+1066656,int_stack+1057206, 1.0, int_stack+586994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1046271,int_stack+230209,int_stack+227734, 1.0, int_stack+377465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1053696,int_stack+1046271,int_stack+1040196, 1.0, int_stack+596444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+455750,int_stack+1053696,int_stack+0, 1.0, int_stack+602519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+455750,int_stack+1066656, 1.0, int_stack+612239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+455750,int_stack+1040196,int_stack+1079256, 1.0, int_stack+624839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1040196,int_stack+455750,int_stack+408010,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+98253,int_stack+1040196,int_stack+813300,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+813300,int_stack+237029,int_stack+234334, 1.0, int_stack+233179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+816765,int_stack+240549,int_stack+237029, 1.0, int_stack+235489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+821385,int_stack+816765,int_stack+813300, 1.0, int_stack+534074, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+828315,int_stack+245004,int_stack+240549, 1.0, int_stack+238569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+834255,int_stack+828315,int_stack+816765, 1.0, int_stack+537539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+408010,int_stack+834255,int_stack+821385, 1.0, int_stack+542159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+534074,int_stack+250504,int_stack+245004, 1.0, int_stack+242529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+813300,int_stack+534074,int_stack+828315, 1.0, int_stack+549089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+475595,int_stack+813300,int_stack+834255, 1.0, int_stack+555029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+541499,int_stack+475595,int_stack+408010, 1.0, int_stack+564269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+408010,int_stack+253529,int_stack+250504, 1.0, int_stack+247479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+558824,int_stack+408010,int_stack+534074, 1.0, int_stack+575819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+408010,int_stack+558824,int_stack+813300, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+813300,int_stack+408010,int_stack+475595, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+475595,int_stack+813300,int_stack+541499, 1.0, int_stack+795975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1194987,int_stack+475595,int_stack+455750,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1688466,int_stack+1194987,int_stack+1040196,441);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1040196,int_stack+344667,int_stack+343127,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1044816,int_stack+1040196,int_stack+429262,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1052376,int_stack+1044816,int_stack+433042,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+1052376,int_stack+439090,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1051956,int_stack+1040196,int_stack+446930,28);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1040196,int_stack+360203,int_stack+358223,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1064304,int_stack+1040196,int_stack+500018,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1074024,int_stack+1064304,int_stack+504878,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1194987,int_stack+1074024,int_stack+512654,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1064304,int_stack+1194987,int_stack+522734,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1194987,int_stack+1064304,int_stack+1051956,441);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1232031,int_stack+379940,int_stack+377465,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1239456,int_stack+1232031,int_stack+596444,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1080180,int_stack+1239456,int_stack+602519,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1232031,int_stack+1080180,int_stack+612239,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+780575,int_stack+1232031,int_stack+624839,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+800420,int_stack+780575,int_stack+1064304,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+408010,int_stack+800420,int_stack+1194987,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1232031,int_stack+257747,int_stack+257159,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1233795,int_stack+258531,int_stack+257747,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1236147,int_stack+1233795,int_stack+1232031,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1239675,int_stack+259539,int_stack+258531,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1242699,int_stack+1239675,int_stack+1233795,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1247403,int_stack+1242699,int_stack+1236147,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1232031,int_stack+260799,int_stack+259539,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1080180,int_stack+1232031,int_stack+1239675,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1086228,int_stack+1080180,int_stack+1242699,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1235811,int_stack+1086228,int_stack+1247403,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1244631,int_stack+262339,int_stack+260799,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1040196,int_stack+1244631,int_stack+1232031,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+482098,int_stack+1040196,int_stack+1080180,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+482098,int_stack+1086228,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+482098,int_stack+1040196,int_stack+1235811,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+264943,int_stack+264187,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1042464,int_stack+265951,int_stack+264943,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1045488,int_stack+1042464,int_stack+1040196,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+494446,int_stack+267247,int_stack+265951,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+498334,int_stack+494446,int_stack+1042464,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+504382,int_stack+498334,int_stack+1045488,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1040196,int_stack+268867,int_stack+267247,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+511942,int_stack+1040196,int_stack+494446,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+519718,int_stack+511942,int_stack+498334,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+529798,int_stack+519718,int_stack+504382,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+494446,int_stack+270847,int_stack+268867,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+500386,int_stack+494446,int_stack+1040196,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+541138,int_stack+500386,int_stack+511942,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+494446,int_stack+541138,int_stack+519718,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+541138,int_stack+494446,int_stack+529798,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+494446,int_stack+541138,int_stack+482098, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1051956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+482098,int_stack+274168,int_stack+273223,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+484933,int_stack+275428,int_stack+274168,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+488713,int_stack+484933,int_stack+482098,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+531490,int_stack+277048,int_stack+275428,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+557014,int_stack+531490,int_stack+484933,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+564574,int_stack+557014,int_stack+488713,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+482098,int_stack+279073,int_stack+277048,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+574024,int_stack+482098,int_stack+531490,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+583744,int_stack+574024,int_stack+557014,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+596344,int_stack+583744,int_stack+564574,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+557014,int_stack+281548,int_stack+279073,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+610519,int_stack+557014,int_stack+482098,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+557014,int_stack+610519,int_stack+574024,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+610519,int_stack+557014,int_stack+583744,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+557014,int_stack+610519,int_stack+596344,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+576859,int_stack+557014,int_stack+541138, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1064304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+624487,int_stack+576859,int_stack+494446, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+698575,int_stack+285673,int_stack+284518,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+482098,int_stack+287213,int_stack+285673,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+486718,int_stack+482098,int_stack+698575,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+698575,int_stack+289193,int_stack+287213,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+493648,int_stack+698575,int_stack+482098,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+502888,int_stack+493648,int_stack+486718,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+482098,int_stack+291668,int_stack+289193,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+514438,int_stack+482098,int_stack+698575,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+526318,int_stack+514438,int_stack+493648,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1080180,int_stack+526318,int_stack+502888,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+489523,int_stack+294693,int_stack+291668,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+498598,int_stack+489523,int_stack+482098,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1232031,int_stack+498598,int_stack+514438,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+482098,int_stack+1232031,int_stack+526318,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+505198,int_stack+482098,int_stack+1080180,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+172341,int_stack+505198,int_stack+557014, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+1783722,int_stack+172341,int_stack+576859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+172341,int_stack+298911,int_stack+298323,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+174105,int_stack+299695,int_stack+298911,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+176457,int_stack+174105,int_stack+172341,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+179985,int_stack+300703,int_stack+299695,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+183009,int_stack+179985,int_stack+174105,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+187713,int_stack+183009,int_stack+176457,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+172341,int_stack+301963,int_stack+300703,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+193593,int_stack+172341,int_stack+179985,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+199641,int_stack+193593,int_stack+183009,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+176121,int_stack+199641,int_stack+187713,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+184941,int_stack+303503,int_stack+301963,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+207481,int_stack+184941,int_stack+172341,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+215041,int_stack+207481,int_stack+193593,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+215041,int_stack+199641,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+184941,int_stack+1040196,int_stack+176121,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+306107,int_stack+305351,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1042464,int_stack+307115,int_stack+306107,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1045488,int_stack+1042464,int_stack+1040196,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+172341,int_stack+308411,int_stack+307115,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+176229,int_stack+172341,int_stack+1042464,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+197289,int_stack+176229,int_stack+1045488,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1040196,int_stack+310031,int_stack+308411,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+204849,int_stack+1040196,int_stack+172341,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+212625,int_stack+204849,int_stack+176229,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+172341,int_stack+212625,int_stack+197289,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+197289,int_stack+312011,int_stack+310031,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+222705,int_stack+197289,int_stack+1040196,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+232425,int_stack+222705,int_stack+204849,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+197289,int_stack+232425,int_stack+212625,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+212409,int_stack+197289,int_stack+172341,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+228285,int_stack+212409,int_stack+184941, 0.0, zero_stack, 1.0, int_stack+1051956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+172341,int_stack+315332,int_stack+314387,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+175176,int_stack+316592,int_stack+315332,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+178956,int_stack+175176,int_stack+172341,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+184626,int_stack+318212,int_stack+316592,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+189486,int_stack+184626,int_stack+175176,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+197046,int_stack+189486,int_stack+178956,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+172341,int_stack+320237,int_stack+318212,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1040196,int_stack+172341,int_stack+184626,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+265329,int_stack+1040196,int_stack+189486,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+178416,int_stack+265329,int_stack+197046,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+192591,int_stack+322712,int_stack+320237,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+200016,int_stack+192591,int_stack+172341,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+277929,int_stack+200016,int_stack+1040196,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+192591,int_stack+277929,int_stack+265329,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+265329,int_stack+192591,int_stack+178416,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+482098,int_stack+265329,int_stack+212409, 0.0, zero_stack, 1.0, int_stack+1064304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+529726,int_stack+482098,int_stack+228285, 0.0, zero_stack, 1.0, int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+285174,int_stack+326837,int_stack+325682,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+288639,int_stack+328377,int_stack+326837,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+293259,int_stack+288639,int_stack+285174,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+300189,int_stack+330357,int_stack+328377,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+306129,int_stack+300189,int_stack+288639,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+315369,int_stack+306129,int_stack+293259,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+285174,int_stack+332832,int_stack+330357,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+172341,int_stack+285174,int_stack+300189,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+184221,int_stack+172341,int_stack+306129,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+292599,int_stack+184221,int_stack+315369,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+309924,int_stack+335857,int_stack+332832,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+318999,int_stack+309924,int_stack+285174,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+199621,int_stack+318999,int_stack+172341,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+309924,int_stack+199621,int_stack+184221,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+172341,int_stack+309924,int_stack+292599,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+196596,int_stack+172341,int_stack+265329, 0.0, zero_stack, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+1878978,int_stack+196596,int_stack+482098, 0.0, zero_stack, 1.0, int_stack+800420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+482098,int_stack+347103,int_stack+346515,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+483862,int_stack+347887,int_stack+347103,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+486214,int_stack+483862,int_stack+482098,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+489742,int_stack+348895,int_stack+347887,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+492766,int_stack+489742,int_stack+483862,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+497470,int_stack+492766,int_stack+486214,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+482098,int_stack+350155,int_stack+348895,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+503350,int_stack+482098,int_stack+489742,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+509398,int_stack+503350,int_stack+492766,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+485878,int_stack+509398,int_stack+497470,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+494698,int_stack+351695,int_stack+350155,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+517238,int_stack+494698,int_stack+482098,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+172341,int_stack+517238,int_stack+503350,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1040196,int_stack+172341,int_stack+509398,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+172341,int_stack+1040196,int_stack+485878,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1040196,int_stack+363335,int_stack+362579,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1042464,int_stack+364343,int_stack+363335,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1045488,int_stack+1042464,int_stack+1040196,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+184689,int_stack+365639,int_stack+364343,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+188577,int_stack+184689,int_stack+1042464,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+194625,int_stack+188577,int_stack+1045488,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1040196,int_stack+367259,int_stack+365639,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+202185,int_stack+1040196,int_stack+184689,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+209961,int_stack+202185,int_stack+188577,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+220041,int_stack+209961,int_stack+194625,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+184689,int_stack+369239,int_stack+367259,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+190629,int_stack+184689,int_stack+1040196,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+231381,int_stack+190629,int_stack+202185,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+184689,int_stack+231381,int_stack+209961,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+231381,int_stack+184689,int_stack+220041,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+184689,int_stack+231381,int_stack+172341, 1.0, int_stack+1051956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+172341,int_stack+383855,int_stack+382910,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+175176,int_stack+385115,int_stack+383855,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+178956,int_stack+175176,int_stack+172341,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+221733,int_stack+386735,int_stack+385115,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+247257,int_stack+221733,int_stack+175176,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+254817,int_stack+247257,int_stack+178956,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+172341,int_stack+388760,int_stack+386735,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+264267,int_stack+172341,int_stack+221733,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+273987,int_stack+264267,int_stack+247257,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+286587,int_stack+273987,int_stack+254817,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+247257,int_stack+391235,int_stack+388760,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+300762,int_stack+247257,int_stack+172341,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+247257,int_stack+300762,int_stack+264267,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+300762,int_stack+247257,int_stack+273987,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+247257,int_stack+300762,int_stack+286587,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+482098,int_stack+247257,int_stack+231381, 1.0, int_stack+1064304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+267102,int_stack+482098,int_stack+184689, 1.0, int_stack+1194987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1194987,int_stack+395360,int_stack+394205,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1198452,int_stack+396900,int_stack+395360,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1203072,int_stack+1198452,int_stack+1194987,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1210002,int_stack+398880,int_stack+396900,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1215942,int_stack+1210002,int_stack+1198452,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1225182,int_stack+1215942,int_stack+1203072,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1194987,int_stack+401355,int_stack+398880,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1236732,int_stack+1194987,int_stack+1210002,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+341190,int_stack+1236732,int_stack+1215942,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1202412,int_stack+341190,int_stack+1225182,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1219737,int_stack+404380,int_stack+401355,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+356590,int_stack+1219737,int_stack+1194987,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+371440,int_stack+356590,int_stack+1236732,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1219737,int_stack+371440,int_stack+341190,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+341190,int_stack+1219737,int_stack+1202412,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+1194987,int_stack+341190,int_stack+247257, 1.0, int_stack+780575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+1974234,int_stack+1194987,int_stack+482098, 1.0, int_stack+800420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2069490,int_stack+944940,int_stack+706487,441);
     Libderiv->ABCD[11] = int_stack + 2069490;
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+698575,int_stack+1099731,int_stack+850344,441);
     Libderiv->ABCD[10] = int_stack + 698575;
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+822055,int_stack+1254522,int_stack+24165,441);
     Libderiv->ABCD[9] = int_stack + 822055;
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+945535,int_stack+1423866,int_stack+1349778,441);
     Libderiv->ABCD[8] = int_stack + 945535;
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1069015,int_stack+1593210,int_stack+1519122,441);
     Libderiv->ABCD[7] = int_stack + 1069015;
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1192495,int_stack+1688466,int_stack+98253,441);
     Libderiv->ABCD[6] = int_stack + 1192495;
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+1315975,int_stack+1783722,int_stack+624487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 1315975;
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+1439455,int_stack+1878978,int_stack+529726, 0.0, zero_stack, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 1439455;
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+482098,int_stack+1974234,int_stack+267102, 1.0, int_stack+408010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 482098;

}
