/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_iiii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ii|ii) integrals */

void d1hrr_order_iiii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][7][11] = int_stack + 784;
 Libderiv->deriv_classes[6][8][11] = int_stack + 1792;
 Libderiv->deriv_classes[6][9][11] = int_stack + 3052;
 Libderiv->deriv_classes[6][10][11] = int_stack + 4592;
 Libderiv->deriv_classes[6][11][11] = int_stack + 6440;
 Libderiv->deriv_classes[6][12][11] = int_stack + 8624;
 Libderiv->deriv_classes[7][6][11] = int_stack + 11172;
 Libderiv->deriv_classes[7][7][11] = int_stack + 12180;
 Libderiv->deriv_classes[7][8][11] = int_stack + 13476;
 Libderiv->deriv_classes[7][9][11] = int_stack + 15096;
 Libderiv->deriv_classes[7][10][11] = int_stack + 17076;
 Libderiv->deriv_classes[7][11][11] = int_stack + 19452;
 Libderiv->deriv_classes[7][12][11] = int_stack + 22260;
 Libderiv->deriv_classes[8][6][11] = int_stack + 25536;
 Libderiv->deriv_classes[8][7][11] = int_stack + 26796;
 Libderiv->deriv_classes[8][8][11] = int_stack + 28416;
 Libderiv->deriv_classes[8][9][11] = int_stack + 30441;
 Libderiv->deriv_classes[8][10][11] = int_stack + 32916;
 Libderiv->deriv_classes[8][11][11] = int_stack + 35886;
 Libderiv->deriv_classes[8][12][11] = int_stack + 39396;
 Libderiv->deriv_classes[9][6][11] = int_stack + 43491;
 Libderiv->deriv_classes[9][7][11] = int_stack + 45031;
 Libderiv->deriv_classes[9][8][11] = int_stack + 47011;
 Libderiv->deriv_classes[9][9][11] = int_stack + 49486;
 Libderiv->deriv_classes[9][10][11] = int_stack + 52511;
 Libderiv->deriv_classes[9][11][11] = int_stack + 56141;
 Libderiv->deriv_classes[9][12][11] = int_stack + 60431;
 Libderiv->deriv_classes[10][6][11] = int_stack + 65436;
 Libderiv->deriv_classes[10][7][11] = int_stack + 67284;
 Libderiv->deriv_classes[10][8][11] = int_stack + 69660;
 Libderiv->deriv_classes[10][9][11] = int_stack + 72630;
 Libderiv->deriv_classes[10][10][11] = int_stack + 76260;
 Libderiv->deriv_classes[10][11][11] = int_stack + 80616;
 Libderiv->deriv_classes[10][12][11] = int_stack + 85764;
 Libderiv->deriv_classes[11][6][11] = int_stack + 91770;
 Libderiv->deriv_classes[11][7][11] = int_stack + 93954;
 Libderiv->deriv_classes[11][8][11] = int_stack + 96762;
 Libderiv->deriv_classes[11][9][11] = int_stack + 100272;
 Libderiv->deriv_classes[11][10][11] = int_stack + 104562;
 Libderiv->deriv_classes[11][11][11] = int_stack + 109710;
 Libderiv->deriv_classes[11][12][11] = int_stack + 115794;
 Libderiv->deriv_classes[12][6][11] = int_stack + 122892;
 Libderiv->deriv_classes[12][7][11] = int_stack + 125440;
 Libderiv->deriv_classes[12][8][11] = int_stack + 128716;
 Libderiv->deriv_classes[12][9][11] = int_stack + 132811;
 Libderiv->deriv_classes[12][10][11] = int_stack + 137816;
 Libderiv->deriv_classes[12][11][11] = int_stack + 143822;
 Libderiv->deriv_classes[12][12][11] = int_stack + 150920;
 Libderiv->deriv_classes[6][6][10] = int_stack + 159201;
 Libderiv->deriv_classes[6][7][10] = int_stack + 159985;
 Libderiv->deriv_classes[6][8][10] = int_stack + 160993;
 Libderiv->deriv_classes[6][9][10] = int_stack + 162253;
 Libderiv->deriv_classes[6][10][10] = int_stack + 163793;
 Libderiv->deriv_classes[6][11][10] = int_stack + 165641;
 Libderiv->deriv_classes[6][12][10] = int_stack + 167825;
 Libderiv->deriv_classes[7][6][10] = int_stack + 170373;
 Libderiv->deriv_classes[7][7][10] = int_stack + 171381;
 Libderiv->deriv_classes[7][8][10] = int_stack + 172677;
 Libderiv->deriv_classes[7][9][10] = int_stack + 174297;
 Libderiv->deriv_classes[7][10][10] = int_stack + 176277;
 Libderiv->deriv_classes[7][11][10] = int_stack + 178653;
 Libderiv->deriv_classes[7][12][10] = int_stack + 181461;
 Libderiv->deriv_classes[8][6][10] = int_stack + 184737;
 Libderiv->deriv_classes[8][7][10] = int_stack + 185997;
 Libderiv->deriv_classes[8][8][10] = int_stack + 187617;
 Libderiv->deriv_classes[8][9][10] = int_stack + 189642;
 Libderiv->deriv_classes[8][10][10] = int_stack + 192117;
 Libderiv->deriv_classes[8][11][10] = int_stack + 195087;
 Libderiv->deriv_classes[8][12][10] = int_stack + 198597;
 Libderiv->deriv_classes[9][6][10] = int_stack + 202692;
 Libderiv->deriv_classes[9][7][10] = int_stack + 204232;
 Libderiv->deriv_classes[9][8][10] = int_stack + 206212;
 Libderiv->deriv_classes[9][9][10] = int_stack + 208687;
 Libderiv->deriv_classes[9][10][10] = int_stack + 211712;
 Libderiv->deriv_classes[9][11][10] = int_stack + 215342;
 Libderiv->deriv_classes[9][12][10] = int_stack + 219632;
 Libderiv->deriv_classes[10][6][10] = int_stack + 224637;
 Libderiv->deriv_classes[10][7][10] = int_stack + 226485;
 Libderiv->deriv_classes[10][8][10] = int_stack + 228861;
 Libderiv->deriv_classes[10][9][10] = int_stack + 231831;
 Libderiv->deriv_classes[10][10][10] = int_stack + 235461;
 Libderiv->deriv_classes[10][11][10] = int_stack + 239817;
 Libderiv->deriv_classes[10][12][10] = int_stack + 244965;
 Libderiv->deriv_classes[11][6][10] = int_stack + 250971;
 Libderiv->deriv_classes[11][7][10] = int_stack + 253155;
 Libderiv->deriv_classes[11][8][10] = int_stack + 255963;
 Libderiv->deriv_classes[11][9][10] = int_stack + 259473;
 Libderiv->deriv_classes[11][10][10] = int_stack + 263763;
 Libderiv->deriv_classes[11][11][10] = int_stack + 268911;
 Libderiv->deriv_classes[11][12][10] = int_stack + 274995;
 Libderiv->deriv_classes[12][6][10] = int_stack + 282093;
 Libderiv->deriv_classes[12][7][10] = int_stack + 284641;
 Libderiv->deriv_classes[12][8][10] = int_stack + 287917;
 Libderiv->deriv_classes[12][9][10] = int_stack + 292012;
 Libderiv->deriv_classes[12][10][10] = int_stack + 297017;
 Libderiv->deriv_classes[12][11][10] = int_stack + 303023;
 Libderiv->deriv_classes[12][12][10] = int_stack + 310121;
 Libderiv->deriv_classes[6][6][9] = int_stack + 318402;
 Libderiv->deriv_classes[6][7][9] = int_stack + 319186;
 Libderiv->deriv_classes[6][8][9] = int_stack + 320194;
 Libderiv->deriv_classes[6][9][9] = int_stack + 321454;
 Libderiv->deriv_classes[6][10][9] = int_stack + 322994;
 Libderiv->deriv_classes[6][11][9] = int_stack + 324842;
 Libderiv->deriv_classes[6][12][9] = int_stack + 327026;
 Libderiv->deriv_classes[7][6][9] = int_stack + 329574;
 Libderiv->deriv_classes[7][7][9] = int_stack + 330582;
 Libderiv->deriv_classes[7][8][9] = int_stack + 331878;
 Libderiv->deriv_classes[7][9][9] = int_stack + 333498;
 Libderiv->deriv_classes[7][10][9] = int_stack + 335478;
 Libderiv->deriv_classes[7][11][9] = int_stack + 337854;
 Libderiv->deriv_classes[7][12][9] = int_stack + 340662;
 Libderiv->deriv_classes[8][6][9] = int_stack + 343938;
 Libderiv->deriv_classes[8][7][9] = int_stack + 345198;
 Libderiv->deriv_classes[8][8][9] = int_stack + 346818;
 Libderiv->deriv_classes[8][9][9] = int_stack + 348843;
 Libderiv->deriv_classes[8][10][9] = int_stack + 351318;
 Libderiv->deriv_classes[8][11][9] = int_stack + 354288;
 Libderiv->deriv_classes[8][12][9] = int_stack + 357798;
 Libderiv->deriv_classes[9][6][9] = int_stack + 361893;
 Libderiv->deriv_classes[9][7][9] = int_stack + 363433;
 Libderiv->deriv_classes[9][8][9] = int_stack + 365413;
 Libderiv->deriv_classes[9][9][9] = int_stack + 367888;
 Libderiv->deriv_classes[9][10][9] = int_stack + 370913;
 Libderiv->deriv_classes[9][11][9] = int_stack + 374543;
 Libderiv->deriv_classes[9][12][9] = int_stack + 378833;
 Libderiv->deriv_classes[10][6][9] = int_stack + 383838;
 Libderiv->deriv_classes[10][7][9] = int_stack + 385686;
 Libderiv->deriv_classes[10][8][9] = int_stack + 388062;
 Libderiv->deriv_classes[10][9][9] = int_stack + 391032;
 Libderiv->deriv_classes[10][10][9] = int_stack + 394662;
 Libderiv->deriv_classes[10][11][9] = int_stack + 399018;
 Libderiv->deriv_classes[10][12][9] = int_stack + 404166;
 Libderiv->deriv_classes[11][6][9] = int_stack + 410172;
 Libderiv->deriv_classes[11][7][9] = int_stack + 412356;
 Libderiv->deriv_classes[11][8][9] = int_stack + 415164;
 Libderiv->deriv_classes[11][9][9] = int_stack + 418674;
 Libderiv->deriv_classes[11][10][9] = int_stack + 422964;
 Libderiv->deriv_classes[11][11][9] = int_stack + 428112;
 Libderiv->deriv_classes[11][12][9] = int_stack + 434196;
 Libderiv->deriv_classes[12][6][9] = int_stack + 441294;
 Libderiv->deriv_classes[12][7][9] = int_stack + 443842;
 Libderiv->deriv_classes[12][8][9] = int_stack + 447118;
 Libderiv->deriv_classes[12][9][9] = int_stack + 451213;
 Libderiv->deriv_classes[12][10][9] = int_stack + 456218;
 Libderiv->deriv_classes[12][11][9] = int_stack + 462224;
 Libderiv->deriv_classes[12][12][9] = int_stack + 469322;
 Libderiv->deriv_classes[6][6][8] = int_stack + 477603;
 Libderiv->deriv_classes[6][7][8] = int_stack + 478387;
 Libderiv->deriv_classes[6][8][8] = int_stack + 479395;
 Libderiv->deriv_classes[6][9][8] = int_stack + 480655;
 Libderiv->deriv_classes[6][10][8] = int_stack + 482195;
 Libderiv->deriv_classes[6][11][8] = int_stack + 484043;
 Libderiv->deriv_classes[6][12][8] = int_stack + 486227;
 Libderiv->deriv_classes[7][6][8] = int_stack + 488775;
 Libderiv->deriv_classes[7][7][8] = int_stack + 489783;
 Libderiv->deriv_classes[7][8][8] = int_stack + 491079;
 Libderiv->deriv_classes[7][9][8] = int_stack + 492699;
 Libderiv->deriv_classes[7][10][8] = int_stack + 494679;
 Libderiv->deriv_classes[7][11][8] = int_stack + 497055;
 Libderiv->deriv_classes[7][12][8] = int_stack + 499863;
 Libderiv->deriv_classes[8][6][8] = int_stack + 503139;
 Libderiv->deriv_classes[8][7][8] = int_stack + 504399;
 Libderiv->deriv_classes[8][8][8] = int_stack + 506019;
 Libderiv->deriv_classes[8][9][8] = int_stack + 508044;
 Libderiv->deriv_classes[8][10][8] = int_stack + 510519;
 Libderiv->deriv_classes[8][11][8] = int_stack + 513489;
 Libderiv->deriv_classes[8][12][8] = int_stack + 516999;
 Libderiv->deriv_classes[9][6][8] = int_stack + 521094;
 Libderiv->deriv_classes[9][7][8] = int_stack + 522634;
 Libderiv->deriv_classes[9][8][8] = int_stack + 524614;
 Libderiv->deriv_classes[9][9][8] = int_stack + 527089;
 Libderiv->deriv_classes[9][10][8] = int_stack + 530114;
 Libderiv->deriv_classes[9][11][8] = int_stack + 533744;
 Libderiv->deriv_classes[9][12][8] = int_stack + 538034;
 Libderiv->deriv_classes[10][6][8] = int_stack + 543039;
 Libderiv->deriv_classes[10][7][8] = int_stack + 544887;
 Libderiv->deriv_classes[10][8][8] = int_stack + 547263;
 Libderiv->deriv_classes[10][9][8] = int_stack + 550233;
 Libderiv->deriv_classes[10][10][8] = int_stack + 553863;
 Libderiv->deriv_classes[10][11][8] = int_stack + 558219;
 Libderiv->deriv_classes[10][12][8] = int_stack + 563367;
 Libderiv->deriv_classes[11][6][8] = int_stack + 569373;
 Libderiv->deriv_classes[11][7][8] = int_stack + 571557;
 Libderiv->deriv_classes[11][8][8] = int_stack + 574365;
 Libderiv->deriv_classes[11][9][8] = int_stack + 577875;
 Libderiv->deriv_classes[11][10][8] = int_stack + 582165;
 Libderiv->deriv_classes[11][11][8] = int_stack + 587313;
 Libderiv->deriv_classes[11][12][8] = int_stack + 593397;
 Libderiv->deriv_classes[12][6][8] = int_stack + 600495;
 Libderiv->deriv_classes[12][7][8] = int_stack + 603043;
 Libderiv->deriv_classes[12][8][8] = int_stack + 606319;
 Libderiv->deriv_classes[12][9][8] = int_stack + 610414;
 Libderiv->deriv_classes[12][10][8] = int_stack + 615419;
 Libderiv->deriv_classes[12][11][8] = int_stack + 621425;
 Libderiv->deriv_classes[12][12][8] = int_stack + 628523;
 Libderiv->deriv_classes[6][6][7] = int_stack + 636804;
 Libderiv->deriv_classes[6][7][7] = int_stack + 637588;
 Libderiv->deriv_classes[6][8][7] = int_stack + 638596;
 Libderiv->deriv_classes[6][9][7] = int_stack + 639856;
 Libderiv->deriv_classes[6][10][7] = int_stack + 641396;
 Libderiv->deriv_classes[6][11][7] = int_stack + 643244;
 Libderiv->deriv_classes[6][12][7] = int_stack + 645428;
 Libderiv->deriv_classes[7][6][7] = int_stack + 647976;
 Libderiv->deriv_classes[7][7][7] = int_stack + 648984;
 Libderiv->deriv_classes[7][8][7] = int_stack + 650280;
 Libderiv->deriv_classes[7][9][7] = int_stack + 651900;
 Libderiv->deriv_classes[7][10][7] = int_stack + 653880;
 Libderiv->deriv_classes[7][11][7] = int_stack + 656256;
 Libderiv->deriv_classes[7][12][7] = int_stack + 659064;
 Libderiv->deriv_classes[8][6][7] = int_stack + 662340;
 Libderiv->deriv_classes[8][7][7] = int_stack + 663600;
 Libderiv->deriv_classes[8][8][7] = int_stack + 665220;
 Libderiv->deriv_classes[8][9][7] = int_stack + 667245;
 Libderiv->deriv_classes[8][10][7] = int_stack + 669720;
 Libderiv->deriv_classes[8][11][7] = int_stack + 672690;
 Libderiv->deriv_classes[8][12][7] = int_stack + 676200;
 Libderiv->deriv_classes[9][6][7] = int_stack + 680295;
 Libderiv->deriv_classes[9][7][7] = int_stack + 681835;
 Libderiv->deriv_classes[9][8][7] = int_stack + 683815;
 Libderiv->deriv_classes[9][9][7] = int_stack + 686290;
 Libderiv->deriv_classes[9][10][7] = int_stack + 689315;
 Libderiv->deriv_classes[9][11][7] = int_stack + 692945;
 Libderiv->deriv_classes[9][12][7] = int_stack + 697235;
 Libderiv->deriv_classes[10][6][7] = int_stack + 702240;
 Libderiv->deriv_classes[10][7][7] = int_stack + 704088;
 Libderiv->deriv_classes[10][8][7] = int_stack + 706464;
 Libderiv->deriv_classes[10][9][7] = int_stack + 709434;
 Libderiv->deriv_classes[10][10][7] = int_stack + 713064;
 Libderiv->deriv_classes[10][11][7] = int_stack + 717420;
 Libderiv->deriv_classes[10][12][7] = int_stack + 722568;
 Libderiv->deriv_classes[11][6][7] = int_stack + 728574;
 Libderiv->deriv_classes[11][7][7] = int_stack + 730758;
 Libderiv->deriv_classes[11][8][7] = int_stack + 733566;
 Libderiv->deriv_classes[11][9][7] = int_stack + 737076;
 Libderiv->deriv_classes[11][10][7] = int_stack + 741366;
 Libderiv->deriv_classes[11][11][7] = int_stack + 746514;
 Libderiv->deriv_classes[11][12][7] = int_stack + 752598;
 Libderiv->deriv_classes[12][6][7] = int_stack + 759696;
 Libderiv->deriv_classes[12][7][7] = int_stack + 762244;
 Libderiv->deriv_classes[12][8][7] = int_stack + 765520;
 Libderiv->deriv_classes[12][9][7] = int_stack + 769615;
 Libderiv->deriv_classes[12][10][7] = int_stack + 774620;
 Libderiv->deriv_classes[12][11][7] = int_stack + 780626;
 Libderiv->deriv_classes[12][12][7] = int_stack + 787724;
 Libderiv->deriv_classes[6][6][6] = int_stack + 796005;
 Libderiv->deriv_classes[6][7][6] = int_stack + 796789;
 Libderiv->deriv_classes[6][8][6] = int_stack + 797797;
 Libderiv->deriv_classes[6][9][6] = int_stack + 799057;
 Libderiv->deriv_classes[6][10][6] = int_stack + 800597;
 Libderiv->deriv_classes[6][11][6] = int_stack + 802445;
 Libderiv->deriv_classes[6][12][6] = int_stack + 804629;
 Libderiv->deriv_classes[7][6][6] = int_stack + 807177;
 Libderiv->deriv_classes[7][7][6] = int_stack + 808185;
 Libderiv->deriv_classes[7][8][6] = int_stack + 809481;
 Libderiv->deriv_classes[7][9][6] = int_stack + 811101;
 Libderiv->deriv_classes[7][10][6] = int_stack + 813081;
 Libderiv->deriv_classes[7][11][6] = int_stack + 815457;
 Libderiv->deriv_classes[7][12][6] = int_stack + 818265;
 Libderiv->deriv_classes[8][6][6] = int_stack + 821541;
 Libderiv->deriv_classes[8][7][6] = int_stack + 822801;
 Libderiv->deriv_classes[8][8][6] = int_stack + 824421;
 Libderiv->deriv_classes[8][9][6] = int_stack + 826446;
 Libderiv->deriv_classes[8][10][6] = int_stack + 828921;
 Libderiv->deriv_classes[8][11][6] = int_stack + 831891;
 Libderiv->deriv_classes[8][12][6] = int_stack + 835401;
 Libderiv->deriv_classes[9][6][6] = int_stack + 839496;
 Libderiv->deriv_classes[9][7][6] = int_stack + 841036;
 Libderiv->deriv_classes[9][8][6] = int_stack + 843016;
 Libderiv->deriv_classes[9][9][6] = int_stack + 845491;
 Libderiv->deriv_classes[9][10][6] = int_stack + 848516;
 Libderiv->deriv_classes[9][11][6] = int_stack + 852146;
 Libderiv->deriv_classes[9][12][6] = int_stack + 856436;
 Libderiv->deriv_classes[10][6][6] = int_stack + 861441;
 Libderiv->deriv_classes[10][7][6] = int_stack + 863289;
 Libderiv->deriv_classes[10][8][6] = int_stack + 865665;
 Libderiv->deriv_classes[10][9][6] = int_stack + 868635;
 Libderiv->deriv_classes[10][10][6] = int_stack + 872265;
 Libderiv->deriv_classes[10][11][6] = int_stack + 876621;
 Libderiv->deriv_classes[10][12][6] = int_stack + 881769;
 Libderiv->deriv_classes[11][6][6] = int_stack + 887775;
 Libderiv->deriv_classes[11][7][6] = int_stack + 889959;
 Libderiv->deriv_classes[11][8][6] = int_stack + 892767;
 Libderiv->deriv_classes[11][9][6] = int_stack + 896277;
 Libderiv->deriv_classes[11][10][6] = int_stack + 900567;
 Libderiv->deriv_classes[11][11][6] = int_stack + 905715;
 Libderiv->deriv_classes[11][12][6] = int_stack + 911799;
 Libderiv->dvrr_classes[12][6] = int_stack + 918897;
 Libderiv->deriv_classes[12][6][6] = int_stack + 921445;
 Libderiv->dvrr_classes[12][7] = int_stack + 923993;
 Libderiv->deriv_classes[12][7][6] = int_stack + 927269;
 Libderiv->dvrr_classes[12][8] = int_stack + 930545;
 Libderiv->deriv_classes[12][8][6] = int_stack + 934640;
 Libderiv->dvrr_classes[12][9] = int_stack + 938735;
 Libderiv->deriv_classes[12][9][6] = int_stack + 943740;
 Libderiv->dvrr_classes[12][10] = int_stack + 948745;
 Libderiv->deriv_classes[12][10][6] = int_stack + 954751;
 Libderiv->dvrr_classes[12][11] = int_stack + 960757;
 Libderiv->deriv_classes[12][11][6] = int_stack + 967855;
 Libderiv->deriv_classes[12][12][6] = int_stack + 974953;
 Libderiv->deriv_classes[6][6][2] = int_stack + 983234;
 Libderiv->deriv_classes[6][7][2] = int_stack + 984018;
 Libderiv->deriv_classes[6][8][2] = int_stack + 985026;
 Libderiv->deriv_classes[6][9][2] = int_stack + 986286;
 Libderiv->deriv_classes[6][10][2] = int_stack + 987826;
 Libderiv->deriv_classes[6][11][2] = int_stack + 989674;
 Libderiv->deriv_classes[6][12][2] = int_stack + 991858;
 Libderiv->deriv_classes[7][6][2] = int_stack + 994406;
 Libderiv->deriv_classes[7][7][2] = int_stack + 995414;
 Libderiv->deriv_classes[7][8][2] = int_stack + 996710;
 Libderiv->deriv_classes[7][9][2] = int_stack + 998330;
 Libderiv->deriv_classes[7][10][2] = int_stack + 1000310;
 Libderiv->deriv_classes[7][11][2] = int_stack + 1002686;
 Libderiv->deriv_classes[7][12][2] = int_stack + 1005494;
 Libderiv->deriv_classes[8][6][2] = int_stack + 1008770;
 Libderiv->deriv_classes[8][7][2] = int_stack + 1010030;
 Libderiv->deriv_classes[8][8][2] = int_stack + 1011650;
 Libderiv->deriv_classes[8][9][2] = int_stack + 1013675;
 Libderiv->deriv_classes[8][10][2] = int_stack + 1016150;
 Libderiv->deriv_classes[8][11][2] = int_stack + 1019120;
 Libderiv->deriv_classes[8][12][2] = int_stack + 1022630;
 Libderiv->deriv_classes[9][6][2] = int_stack + 1026725;
 Libderiv->deriv_classes[9][7][2] = int_stack + 1028265;
 Libderiv->deriv_classes[9][8][2] = int_stack + 1030245;
 Libderiv->deriv_classes[9][9][2] = int_stack + 1032720;
 Libderiv->deriv_classes[9][10][2] = int_stack + 1035745;
 Libderiv->deriv_classes[9][11][2] = int_stack + 1039375;
 Libderiv->deriv_classes[9][12][2] = int_stack + 1043665;
 Libderiv->deriv_classes[10][6][2] = int_stack + 1048670;
 Libderiv->deriv_classes[10][7][2] = int_stack + 1050518;
 Libderiv->deriv_classes[10][8][2] = int_stack + 1052894;
 Libderiv->deriv_classes[10][9][2] = int_stack + 1055864;
 Libderiv->deriv_classes[10][10][2] = int_stack + 1059494;
 Libderiv->deriv_classes[10][11][2] = int_stack + 1063850;
 Libderiv->deriv_classes[10][12][2] = int_stack + 1068998;
 Libderiv->deriv_classes[11][6][2] = int_stack + 1075004;
 Libderiv->deriv_classes[11][7][2] = int_stack + 1077188;
 Libderiv->deriv_classes[11][8][2] = int_stack + 1079996;
 Libderiv->deriv_classes[11][9][2] = int_stack + 1083506;
 Libderiv->deriv_classes[11][10][2] = int_stack + 1087796;
 Libderiv->deriv_classes[11][11][2] = int_stack + 1092944;
 Libderiv->deriv_classes[11][12][2] = int_stack + 1099028;
 Libderiv->deriv_classes[12][6][2] = int_stack + 1106126;
 Libderiv->deriv_classes[12][7][2] = int_stack + 1108674;
 Libderiv->deriv_classes[12][8][2] = int_stack + 1111950;
 Libderiv->deriv_classes[12][9][2] = int_stack + 1116045;
 Libderiv->deriv_classes[12][10][2] = int_stack + 1121050;
 Libderiv->deriv_classes[12][11][2] = int_stack + 1127056;
 Libderiv->deriv_classes[12][12][2] = int_stack + 1134154;
 Libderiv->deriv_classes[6][6][1] = int_stack + 1142435;
 Libderiv->deriv_classes[6][7][1] = int_stack + 1143219;
 Libderiv->deriv_classes[6][8][1] = int_stack + 1144227;
 Libderiv->deriv_classes[6][9][1] = int_stack + 1145487;
 Libderiv->deriv_classes[6][10][1] = int_stack + 1147027;
 Libderiv->deriv_classes[6][11][1] = int_stack + 1148875;
 Libderiv->deriv_classes[6][12][1] = int_stack + 1151059;
 Libderiv->deriv_classes[7][6][1] = int_stack + 1153607;
 Libderiv->deriv_classes[7][7][1] = int_stack + 1154615;
 Libderiv->deriv_classes[7][8][1] = int_stack + 1155911;
 Libderiv->deriv_classes[7][9][1] = int_stack + 1157531;
 Libderiv->deriv_classes[7][10][1] = int_stack + 1159511;
 Libderiv->deriv_classes[7][11][1] = int_stack + 1161887;
 Libderiv->deriv_classes[7][12][1] = int_stack + 1164695;
 Libderiv->deriv_classes[8][6][1] = int_stack + 1167971;
 Libderiv->deriv_classes[8][7][1] = int_stack + 1169231;
 Libderiv->deriv_classes[8][8][1] = int_stack + 1170851;
 Libderiv->deriv_classes[8][9][1] = int_stack + 1172876;
 Libderiv->deriv_classes[8][10][1] = int_stack + 1175351;
 Libderiv->deriv_classes[8][11][1] = int_stack + 1178321;
 Libderiv->deriv_classes[8][12][1] = int_stack + 1181831;
 Libderiv->deriv_classes[9][6][1] = int_stack + 1185926;
 Libderiv->deriv_classes[9][7][1] = int_stack + 1187466;
 Libderiv->deriv_classes[9][8][1] = int_stack + 1189446;
 Libderiv->deriv_classes[9][9][1] = int_stack + 1191921;
 Libderiv->deriv_classes[9][10][1] = int_stack + 1194946;
 Libderiv->deriv_classes[9][11][1] = int_stack + 1198576;
 Libderiv->deriv_classes[9][12][1] = int_stack + 1202866;
 Libderiv->deriv_classes[10][6][1] = int_stack + 1207871;
 Libderiv->deriv_classes[10][7][1] = int_stack + 1209719;
 Libderiv->deriv_classes[10][8][1] = int_stack + 1212095;
 Libderiv->deriv_classes[10][9][1] = int_stack + 1215065;
 Libderiv->deriv_classes[10][10][1] = int_stack + 1218695;
 Libderiv->deriv_classes[10][11][1] = int_stack + 1223051;
 Libderiv->deriv_classes[10][12][1] = int_stack + 1228199;
 Libderiv->deriv_classes[11][6][1] = int_stack + 1234205;
 Libderiv->deriv_classes[11][7][1] = int_stack + 1236389;
 Libderiv->deriv_classes[11][8][1] = int_stack + 1239197;
 Libderiv->deriv_classes[11][9][1] = int_stack + 1242707;
 Libderiv->deriv_classes[11][10][1] = int_stack + 1246997;
 Libderiv->deriv_classes[11][11][1] = int_stack + 1252145;
 Libderiv->deriv_classes[11][12][1] = int_stack + 1258229;
 Libderiv->deriv_classes[12][6][1] = int_stack + 1265327;
 Libderiv->deriv_classes[12][7][1] = int_stack + 1267875;
 Libderiv->deriv_classes[12][8][1] = int_stack + 1271151;
 Libderiv->deriv_classes[12][9][1] = int_stack + 1275246;
 Libderiv->deriv_classes[12][10][1] = int_stack + 1280251;
 Libderiv->deriv_classes[12][11][1] = int_stack + 1286257;
 Libderiv->deriv_classes[12][12][1] = int_stack + 1293355;
 Libderiv->dvrr_classes[6][6] = int_stack + 1301636;
 Libderiv->dvrr_classes[6][7] = int_stack + 1302420;
 Libderiv->dvrr_classes[6][8] = int_stack + 1303428;
 Libderiv->dvrr_classes[6][9] = int_stack + 1304688;
 Libderiv->dvrr_classes[6][10] = int_stack + 1306228;
 Libderiv->dvrr_classes[6][11] = int_stack + 1308076;
 Libderiv->dvrr_classes[6][12] = int_stack + 1310260;
 Libderiv->deriv_classes[6][6][0] = int_stack + 1312808;
 Libderiv->deriv_classes[6][7][0] = int_stack + 1313592;
 Libderiv->deriv_classes[6][8][0] = int_stack + 1314600;
 Libderiv->deriv_classes[6][9][0] = int_stack + 1315860;
 Libderiv->deriv_classes[6][10][0] = int_stack + 1317400;
 Libderiv->deriv_classes[6][11][0] = int_stack + 1319248;
 Libderiv->deriv_classes[6][12][0] = int_stack + 1321432;
 Libderiv->dvrr_classes[7][6] = int_stack + 1323980;
 Libderiv->dvrr_classes[7][7] = int_stack + 1324988;
 Libderiv->dvrr_classes[7][8] = int_stack + 1326284;
 Libderiv->dvrr_classes[7][9] = int_stack + 1327904;
 Libderiv->dvrr_classes[7][10] = int_stack + 1329884;
 Libderiv->dvrr_classes[7][11] = int_stack + 1332260;
 Libderiv->dvrr_classes[7][12] = int_stack + 1335068;
 Libderiv->deriv_classes[7][6][0] = int_stack + 1338344;
 Libderiv->deriv_classes[7][7][0] = int_stack + 1339352;
 Libderiv->deriv_classes[7][8][0] = int_stack + 1340648;
 Libderiv->deriv_classes[7][9][0] = int_stack + 1342268;
 Libderiv->deriv_classes[7][10][0] = int_stack + 1344248;
 Libderiv->deriv_classes[7][11][0] = int_stack + 1346624;
 Libderiv->deriv_classes[7][12][0] = int_stack + 1349432;
 Libderiv->dvrr_classes[8][6] = int_stack + 1352708;
 Libderiv->dvrr_classes[8][7] = int_stack + 1353968;
 Libderiv->dvrr_classes[8][8] = int_stack + 1355588;
 Libderiv->dvrr_classes[8][9] = int_stack + 1357613;
 Libderiv->dvrr_classes[8][10] = int_stack + 1360088;
 Libderiv->dvrr_classes[8][11] = int_stack + 1363058;
 Libderiv->dvrr_classes[8][12] = int_stack + 1366568;
 Libderiv->deriv_classes[8][6][0] = int_stack + 1370663;
 Libderiv->deriv_classes[8][7][0] = int_stack + 1371923;
 Libderiv->deriv_classes[8][8][0] = int_stack + 1373543;
 Libderiv->deriv_classes[8][9][0] = int_stack + 1375568;
 Libderiv->deriv_classes[8][10][0] = int_stack + 1378043;
 Libderiv->deriv_classes[8][11][0] = int_stack + 1381013;
 Libderiv->deriv_classes[8][12][0] = int_stack + 1384523;
 Libderiv->dvrr_classes[9][6] = int_stack + 1388618;
 Libderiv->dvrr_classes[9][7] = int_stack + 1390158;
 Libderiv->dvrr_classes[9][8] = int_stack + 1392138;
 Libderiv->dvrr_classes[9][9] = int_stack + 1394613;
 Libderiv->dvrr_classes[9][10] = int_stack + 1397638;
 Libderiv->dvrr_classes[9][11] = int_stack + 1401268;
 Libderiv->dvrr_classes[9][12] = int_stack + 1405558;
 Libderiv->deriv_classes[9][6][0] = int_stack + 1410563;
 Libderiv->deriv_classes[9][7][0] = int_stack + 1412103;
 Libderiv->deriv_classes[9][8][0] = int_stack + 1414083;
 Libderiv->deriv_classes[9][9][0] = int_stack + 1416558;
 Libderiv->deriv_classes[9][10][0] = int_stack + 1419583;
 Libderiv->deriv_classes[9][11][0] = int_stack + 1423213;
 Libderiv->deriv_classes[9][12][0] = int_stack + 1427503;
 Libderiv->dvrr_classes[10][6] = int_stack + 1432508;
 Libderiv->dvrr_classes[10][7] = int_stack + 1434356;
 Libderiv->dvrr_classes[10][8] = int_stack + 1436732;
 Libderiv->dvrr_classes[10][9] = int_stack + 1439702;
 Libderiv->dvrr_classes[10][10] = int_stack + 1443332;
 Libderiv->dvrr_classes[10][11] = int_stack + 1447688;
 Libderiv->dvrr_classes[10][12] = int_stack + 1452836;
 Libderiv->deriv_classes[10][6][0] = int_stack + 1458842;
 Libderiv->deriv_classes[10][7][0] = int_stack + 1460690;
 Libderiv->deriv_classes[10][8][0] = int_stack + 1463066;
 Libderiv->deriv_classes[10][9][0] = int_stack + 1466036;
 Libderiv->deriv_classes[10][10][0] = int_stack + 1469666;
 Libderiv->deriv_classes[10][11][0] = int_stack + 1474022;
 Libderiv->deriv_classes[10][12][0] = int_stack + 1479170;
 Libderiv->dvrr_classes[11][6] = int_stack + 1485176;
 Libderiv->dvrr_classes[11][7] = int_stack + 1487360;
 Libderiv->dvrr_classes[11][8] = int_stack + 1490168;
 Libderiv->dvrr_classes[11][9] = int_stack + 1493678;
 Libderiv->dvrr_classes[11][10] = int_stack + 1497968;
 Libderiv->dvrr_classes[11][11] = int_stack + 1503116;
 Libderiv->dvrr_classes[11][12] = int_stack + 1509200;
 Libderiv->deriv_classes[11][6][0] = int_stack + 1516298;
 Libderiv->deriv_classes[11][7][0] = int_stack + 1518482;
 Libderiv->deriv_classes[11][8][0] = int_stack + 1521290;
 Libderiv->deriv_classes[11][9][0] = int_stack + 1524800;
 Libderiv->deriv_classes[11][10][0] = int_stack + 1529090;
 Libderiv->deriv_classes[11][11][0] = int_stack + 1534238;
 Libderiv->deriv_classes[11][12][0] = int_stack + 1540322;
 Libderiv->deriv_classes[12][6][0] = int_stack + 1547420;
 Libderiv->deriv_classes[12][7][0] = int_stack + 1549968;
 Libderiv->deriv_classes[12][8][0] = int_stack + 1553244;
 Libderiv->deriv_classes[12][9][0] = int_stack + 1557339;
 Libderiv->deriv_classes[12][10][0] = int_stack + 1562344;
 Libderiv->deriv_classes[12][11][0] = int_stack + 1568350;
 Libderiv->deriv_classes[12][12][0] = int_stack + 1575448;
 memset(int_stack,0,12669832);

 Libderiv->dvrr_stack = int_stack + 15370434;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_iiii(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1583729,int_stack+1302420,int_stack+1301636,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1586081,int_stack+1303428,int_stack+1302420,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1589105,int_stack+1586081,int_stack+1583729,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1593809,int_stack+1304688,int_stack+1303428,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1597589,int_stack+1593809,int_stack+1586081,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1603637,int_stack+1597589,int_stack+1589105,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1611477,int_stack+1306228,int_stack+1304688,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1616097,int_stack+1611477,int_stack+1593809,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1623657,int_stack+1616097,int_stack+1597589,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1633737,int_stack+1623657,int_stack+1603637,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1645497,int_stack+1308076,int_stack+1306228,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1651041,int_stack+1645497,int_stack+1611477,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1660281,int_stack+1651041,int_stack+1616097,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1672881,int_stack+1660281,int_stack+1623657,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1688001,int_stack+1672881,int_stack+1633737,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1704465,int_stack+784,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1301636,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1706817,int_stack+1792,int_stack+784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1302420,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1709841,int_stack+1706817,int_stack+1704465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1583729,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1714545,int_stack+3052,int_stack+1792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303428,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1718325,int_stack+1714545,int_stack+1706817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586081,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1724373,int_stack+1718325,int_stack+1709841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1589105,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1704465,int_stack+4592,int_stack+3052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304688,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1732213,int_stack+1704465,int_stack+1714545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1593809,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1739773,int_stack+1732213,int_stack+1718325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597589,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1709085,int_stack+1739773,int_stack+1724373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1603637,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1720845,int_stack+6440,int_stack+4592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306228,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1749853,int_stack+1720845,int_stack+1704465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1611477,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1759093,int_stack+1749853,int_stack+1732213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1616097,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1771693,int_stack+1759093,int_stack+1739773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1623657,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1726389,int_stack+1771693,int_stack+1709085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633737,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1704465,int_stack+8624,int_stack+6440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308076,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+1704465,int_stack+1720845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645497,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1704465,int_stack+0,int_stack+1749853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1651041,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1786813,int_stack+1704465,int_stack+1759093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1660281,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1704465,int_stack+1786813,int_stack+1771693, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672881,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1742853,int_stack+1704465,int_stack+1726389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1688001,28);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1704465,int_stack+1324988,int_stack+1323980,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1707489,int_stack+1326284,int_stack+1324988,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1711377,int_stack+1707489,int_stack+1704465,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1717425,int_stack+1327904,int_stack+1326284,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1722285,int_stack+1717425,int_stack+1707489,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1730061,int_stack+1722285,int_stack+1711377,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+1329884,int_stack+1327904,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1764805,int_stack+0,int_stack+1717425,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1774525,int_stack+1764805,int_stack+1722285,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1787485,int_stack+1774525,int_stack+1730061,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1802605,int_stack+1332260,int_stack+1329884,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1809733,int_stack+1802605,int_stack+0,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1821613,int_stack+1809733,int_stack+1764805,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1837813,int_stack+1821613,int_stack+1774525,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1857253,int_stack+1837813,int_stack+1787485,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5940,int_stack+12180,int_stack+11172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323980,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1878421,int_stack+13476,int_stack+12180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1324988,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1882309,int_stack+1878421,int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1704465,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5940,int_stack+15096,int_stack+13476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326284,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1888357,int_stack+5940,int_stack+1878421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1707489,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1896133,int_stack+1888357,int_stack+1882309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1711377,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1878421,int_stack+17076,int_stack+15096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327904,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1906213,int_stack+1878421,int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717425,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1915933,int_stack+1906213,int_stack+1888357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1722285,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1928893,int_stack+1915933,int_stack+1896133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730061,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+5940,int_stack+19452,int_stack+17076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329884,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1884361,int_stack+5940,int_stack+1878421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1944013,int_stack+1884361,int_stack+1906213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764805,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1896241,int_stack+1944013,int_stack+1915933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1774525,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1960213,int_stack+1896241,int_stack+1928893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1787485,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1915681,int_stack+22260,int_stack+19452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332260,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1924105,int_stack+1915681,int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802605,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1981381,int_stack+1924105,int_stack+1884361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1809733,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1915681,int_stack+1981381,int_stack+1944013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1821613,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1981381,int_stack+1915681,int_stack+1896241, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837813,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1878421,int_stack+1981381,int_stack+1960213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1857253,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1906645,int_stack+1878421,int_stack+1742853,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5940,int_stack+1353968,int_stack+1352708,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+9720,int_stack+1355588,int_stack+1353968,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14580,int_stack+9720,int_stack+5940,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1972501,int_stack+1357613,int_stack+1355588,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1978576,int_stack+1972501,int_stack+9720,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1988296,int_stack+1978576,int_stack+14580,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2000896,int_stack+1360088,int_stack+1357613,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1740141,int_stack+2000896,int_stack+1972501,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2008321,int_stack+1740141,int_stack+1978576,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2024521,int_stack+2008321,int_stack+1988296,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1752291,int_stack+1363058,int_stack+1360088,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+2043421,int_stack+1752291,int_stack+2000896,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+2058271,int_stack+2043421,int_stack+1740141,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+2078521,int_stack+2058271,int_stack+2008321,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+2102821,int_stack+2078521,int_stack+2024521,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2129281,int_stack+26796,int_stack+25536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1352708,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2133061,int_stack+28416,int_stack+26796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353968,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2137921,int_stack+2133061,int_stack+2129281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+22140,int_stack+30441,int_stack+28416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1355588,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2145481,int_stack+22140,int_stack+2133061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9720,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2155201,int_stack+2145481,int_stack+2137921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14580,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2129281,int_stack+32916,int_stack+30441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357613,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2167801,int_stack+2129281,int_stack+22140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1972501,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2179951,int_stack+2167801,int_stack+2145481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978576,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2196151,int_stack+2179951,int_stack+2155201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1988296,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+22140,int_stack+35886,int_stack+32916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360088,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+2136706,int_stack+22140,int_stack+2129281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000896,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+2215051,int_stack+2136706,int_stack+2167801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1740141,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+2151556,int_stack+2215051,int_stack+2179951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2008321,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+2235301,int_stack+2151556,int_stack+2196151, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024521,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+2175856,int_stack+39396,int_stack+35886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363058,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+2186386,int_stack+2175856,int_stack+22140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1752291,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+2261761,int_stack+2186386,int_stack+2136706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043421,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+2175856,int_stack+2261761,int_stack+2215051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058271,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+2261761,int_stack+2175856,int_stack+2151556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078521,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+2129281,int_stack+2261761,int_stack+2235301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2102821,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+2164561,int_stack+2129281,int_stack+1878421,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2249233,int_stack+2164561,int_stack+1906645,784);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1878421,int_stack+1390158,int_stack+1388618,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1883041,int_stack+1392138,int_stack+1390158,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1888981,int_stack+1883041,int_stack+1878421,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1898221,int_stack+1394613,int_stack+1392138,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1905646,int_stack+1898221,int_stack+1883041,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1917526,int_stack+1905646,int_stack+1888981,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1932926,int_stack+1397638,int_stack+1394613,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1942001,int_stack+1932926,int_stack+1898221,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+22140,int_stack+1942001,int_stack+1905646,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2380945,int_stack+22140,int_stack+1917526,55);
 /*--- compute (m0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1956851,int_stack+1401268,int_stack+1397638,55);
 /*--- compute (m0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+2404045,int_stack+1956851,int_stack+1932926,55);
 /*--- compute (m0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+2422195,int_stack+2404045,int_stack+1942001,55);
 /*--- compute (m0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+2446945,int_stack+2422195,int_stack+22140,55);
 /*--- compute (m0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+2476645,int_stack+2446945,int_stack+2380945,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1967741,int_stack+45031,int_stack+43491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1388618,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2508985,int_stack+47011,int_stack+45031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1390158,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2514925,int_stack+2508985,int_stack+1967741, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1878421,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2524165,int_stack+49486,int_stack+47011, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392138,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2531590,int_stack+2524165,int_stack+2508985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883041,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2543470,int_stack+2531590,int_stack+2514925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1888981,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2508985,int_stack+52511,int_stack+49486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1394613,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2558870,int_stack+2508985,int_stack+2524165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898221,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2573720,int_stack+2558870,int_stack+2531590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1905646,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2518060,int_stack+2573720,int_stack+2543470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1917526,55);
 /*--- compute (m0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+2541160,int_stack+56141,int_stack+52511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397638,55);
 /*--- compute (m0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+2593520,int_stack+2541160,int_stack+2508985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932926,55);
 /*--- compute (m0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+2611670,int_stack+2593520,int_stack+2558870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942001,55);
 /*--- compute (m0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+2636420,int_stack+2611670,int_stack+2573720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22140,55);
 /*--- compute (m0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+2552050,int_stack+2636420,int_stack+2518060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2380945,55);
 /*--- compute (m0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+2508985,int_stack+60431,int_stack+56141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401268,55);
 /*--- compute (m0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+41940,int_stack+2508985,int_stack+2541160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1956851,55);
 /*--- compute (m0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+2508985,int_stack+41940,int_stack+2593520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2404045,55);
 /*--- compute (m0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+2666120,int_stack+2508985,int_stack+2611670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422195,55);
 /*--- compute (m0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+2508985,int_stack+2666120,int_stack+2636420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2446945,55);
 /*--- compute (m0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+2584390,int_stack+2508985,int_stack+2552050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2476645,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+2627510,int_stack+2584390,int_stack+2129281,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+2733350,int_stack+2627510,int_stack+2164561,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2902694,int_stack+2733350,int_stack+2249233,784);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2129281,int_stack+1434356,int_stack+1432508,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2134825,int_stack+1436732,int_stack+1434356,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2141953,int_stack+2134825,int_stack+2129281,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2153041,int_stack+1439702,int_stack+1436732,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2161951,int_stack+2153041,int_stack+2134825,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2176207,int_stack+2161951,int_stack+2141953,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2194687,int_stack+1443332,int_stack+1439702,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2205577,int_stack+2194687,int_stack+2153041,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2223397,int_stack+2205577,int_stack+2161951,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2247157,int_stack+2223397,int_stack+2176207,66);
 /*--- compute (n0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+2274877,int_stack+1447688,int_stack+1443332,66);
 /*--- compute (n0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+2287945,int_stack+2274877,int_stack+2194687,66);
 /*--- compute (n0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+2309725,int_stack+2287945,int_stack+2205577,66);
 /*--- compute (n0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+2339425,int_stack+2309725,int_stack+2223397,66);
 /*--- compute (n0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+2508985,int_stack+2339425,int_stack+2247157,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2375065,int_stack+67284,int_stack+65436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432508,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2547793,int_stack+69660,int_stack+67284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434356,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2554921,int_stack+2547793,int_stack+2375065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2129281,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2566009,int_stack+72630,int_stack+69660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1436732,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41940,int_stack+2566009,int_stack+2547793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134825,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3122214,int_stack+41940,int_stack+2554921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2141953,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2547793,int_stack+76260,int_stack+72630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1439702,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+56196,int_stack+2547793,int_stack+2566009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2153041,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2558683,int_stack+56196,int_stack+41940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161951,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3140694,int_stack+2558683,int_stack+3122214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176207,66);
 /*--- compute (n0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3122214,int_stack+80616,int_stack+76260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1443332,66);
 /*--- compute (n0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3168414,int_stack+3122214,int_stack+2547793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2194687,66);
 /*--- compute (n0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3190194,int_stack+3168414,int_stack+56196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205577,66);
 /*--- compute (n0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+41940,int_stack+3190194,int_stack+2558683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2223397,66);
 /*--- compute (n0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3219894,int_stack+41940,int_stack+3140694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247157,66);
 /*--- compute (n0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+2547793,int_stack+85764,int_stack+80616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1447688,66);
 /*--- compute (n0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3135282,int_stack+2547793,int_stack+3122214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274877,66);
 /*--- compute (n0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+2547793,int_stack+3135282,int_stack+3168414, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2287945,66);
 /*--- compute (n0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3122214,int_stack+2547793,int_stack+3190194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2309725,66);
 /*--- compute (n0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3166764,int_stack+3122214,int_stack+41940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339425,66);
 /*--- compute (n0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3258702,int_stack+3166764,int_stack+3219894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2508985,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+3122214,int_stack+3258702,int_stack+2584390,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+3310446,int_stack+3122214,int_stack+2627510,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+3522126,int_stack+3310446,int_stack+2733350,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+2547793,int_stack+3522126,int_stack+2902694,784);
 /*--- compute (o0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+41940,int_stack+1487360,int_stack+1485176,78);
 /*--- compute (o0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+48492,int_stack+1490168,int_stack+1487360,78);
 /*--- compute (o0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+56916,int_stack+48492,int_stack+41940,78);
 /*--- compute (o0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+70020,int_stack+1493678,int_stack+1490168,78);
 /*--- compute (o0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2877073,int_stack+70020,int_stack+48492,78);
 /*--- compute (o0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2893921,int_stack+2877073,int_stack+56916,78);
 /*--- compute (o0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2915761,int_stack+1497968,int_stack+1493678,78);
 /*--- compute (o0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2928631,int_stack+2915761,int_stack+70020,78);
 /*--- compute (o0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2949691,int_stack+2928631,int_stack+2877073,78);
 /*--- compute (o0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2977771,int_stack+2949691,int_stack+2893921,78);
 /*--- compute (o0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+3010531,int_stack+1503116,int_stack+1497968,78);
 /*--- compute (o0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+3025975,int_stack+3010531,int_stack+2915761,78);
 /*--- compute (o0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+3051715,int_stack+3025975,int_stack+2928631,78);
 /*--- compute (o0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+3804366,int_stack+3051715,int_stack+2949691,78);
 /*--- compute (o0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+3846486,int_stack+3804366,int_stack+2977771,78);
 /*--- compute (o0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+80550,int_stack+93954,int_stack+91770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1485176,78);
 /*--- compute (o0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3086815,int_stack+96762,int_stack+93954, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1487360,78);
 /*--- compute (o0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3095239,int_stack+3086815,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41940,78);
 /*--- compute (o0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+80550,int_stack+100272,int_stack+96762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1490168,78);
 /*--- compute (o0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3892350,int_stack+80550,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48492,78);
 /*--- compute (o0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3909198,int_stack+3892350,int_stack+3095239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56916,78);
 /*--- compute (o0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+104562,int_stack+100272, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1493678,78);
 /*--- compute (o0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3099685,int_stack+3086815,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70020,78);
 /*--- compute (o0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3931038,int_stack+3099685,int_stack+3892350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877073,78);
 /*--- compute (o0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3959118,int_stack+3931038,int_stack+3909198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2893921,78);
 /*--- compute (o0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3892350,int_stack+109710,int_stack+104562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497968,78);
 /*--- compute (o0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+80550,int_stack+3892350,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2915761,78);
 /*--- compute (o0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3991878,int_stack+80550,int_stack+3099685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2928631,78);
 /*--- compute (o0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+4026978,int_stack+3991878,int_stack+3931038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2949691,78);
 /*--- compute (o0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3907794,int_stack+4026978,int_stack+3959118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2977771,78);
 /*--- compute (o0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+115794,int_stack+109710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503116,78);
 /*--- compute (o0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3953658,int_stack+3086815,int_stack+3892350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3010531,78);
 /*--- compute (o0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4069098,int_stack+3953658,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3025975,78);
 /*--- compute (o0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+4111998,int_stack+4069098,int_stack+3991878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3051715,78);
 /*--- compute (o0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3953658,int_stack+4111998,int_stack+4026978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3804366,78);
 /*--- compute (o0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4012626,int_stack+3953658,int_stack+3907794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3846486,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+4073778,int_stack+4012626,int_stack+3258702,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+4229010,int_stack+4073778,int_stack+3122214,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+4487730,int_stack+4229010,int_stack+3310446,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+3086815,int_stack+4487730,int_stack+3522126,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+4840530,int_stack+3086815,int_stack+2547793,784);
 /*--- compute (q0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2547793,int_stack+923993,int_stack+918897,91);
 /*--- compute (q0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2555437,int_stack+930545,int_stack+923993,91);
 /*--- compute (q0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2565265,int_stack+2555437,int_stack+2547793,91);
 /*--- compute (q0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2580553,int_stack+938735,int_stack+930545,91);
 /*--- compute (q0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2592838,int_stack+2580553,int_stack+2555437,91);
 /*--- compute (q0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2612494,int_stack+2592838,int_stack+2565265,91);
 /*--- compute (q0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2637974,int_stack+948745,int_stack+938735,91);
 /*--- compute (q0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2652989,int_stack+2637974,int_stack+2580553,91);
 /*--- compute (q0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2677559,int_stack+2652989,int_stack+2592838,91);
 /*--- compute (q0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2710319,int_stack+2677559,int_stack+2612494,91);
 /*--- compute (q0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+2748539,int_stack+960757,int_stack+948745,91);
 /*--- compute (q0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+2766557,int_stack+2748539,int_stack+2637974,91);
 /*--- compute (q0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+2796587,int_stack+2766557,int_stack+2652989,91);
 /*--- compute (q0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+3892350,int_stack+2796587,int_stack+2677559,91);
 /*--- compute (q0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+3941490,int_stack+3892350,int_stack+2710319,91);
 /*--- compute (q0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2837537,int_stack+125440,int_stack+122892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918897,91);
 /*--- compute (q0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2845181,int_stack+128716,int_stack+125440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923993,91);
 /*--- compute (q0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2855009,int_stack+2845181,int_stack+2837537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2547793,91);
 /*--- compute (q0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+80550,int_stack+132811,int_stack+128716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930545,91);
 /*--- compute (q0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+92835,int_stack+80550,int_stack+2845181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2555437,91);
 /*--- compute (q0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3510175,int_stack+92835,int_stack+2855009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2565265,91);
 /*--- compute (q0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2837537,int_stack+137816,int_stack+132811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938735,91);
 /*--- compute (q0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+112491,int_stack+2837537,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2580553,91);
 /*--- compute (q0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3535655,int_stack+112491,int_stack+92835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2592838,91);
 /*--- compute (q0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3568415,int_stack+3535655,int_stack+3510175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2612494,91);
 /*--- compute (q0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3510175,int_stack+143822,int_stack+137816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948745,91);
 /*--- compute (q0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+80550,int_stack+3510175,int_stack+2837537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2637974,91);
 /*--- compute (q0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3606635,int_stack+80550,int_stack+112491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652989,91);
 /*--- compute (q0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3647585,int_stack+3606635,int_stack+3535655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2677559,91);
 /*--- compute (q0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3696725,int_stack+3647585,int_stack+3568415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2710319,91);
 /*--- compute (q0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+2837537,int_stack+150920,int_stack+143822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960757,91);
 /*--- compute (q0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3528193,int_stack+2837537,int_stack+3510175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2748539,91);
 /*--- compute (q0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3750233,int_stack+3528193,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2766557,91);
 /*--- compute (q0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+80550,int_stack+3750233,int_stack+3606635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2796587,91);
 /*--- compute (q0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3510175,int_stack+80550,int_stack+3647585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3892350,91);
 /*--- compute (q0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+80550,int_stack+3510175,int_stack+3696725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3941490,91);
 /*--- compute (op|ii) ---*/
   hrr1_build_op(Libderiv->AB,int_stack+3510175,int_stack+80550,int_stack+4012626,784);
 /*--- compute (nd|ii) ---*/
   hrr1_build_nd(Libderiv->AB,int_stack+5301522,int_stack+3510175,int_stack+4073778,784);
 /*--- compute (mf|ii) ---*/
   hrr1_build_mf(Libderiv->AB,int_stack+5611986,int_stack+5301522,int_stack+4229010,784);
 /*--- compute (lg|ii) ---*/
   hrr1_build_lg(Libderiv->AB,int_stack+6043186,int_stack+5611986,int_stack+4487730,784);
 /*--- compute (kh|ii) ---*/
   hrr1_build_kh(Libderiv->AB,int_stack+5301522,int_stack+6043186,int_stack+3086815,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+159985,int_stack+159201, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1301636, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089167,int_stack+160993,int_stack+159985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1302420, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3092191,int_stack+3089167,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1583729, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3096895,int_stack+162253,int_stack+160993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303428, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3100675,int_stack+3096895,int_stack+3089167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586081, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3106723,int_stack+3100675,int_stack+3092191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1589105, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+163793,int_stack+162253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304688, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3114563,int_stack+3086815,int_stack+3096895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1593809, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3122123,int_stack+3114563,int_stack+3100675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597589, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3091435,int_stack+3122123,int_stack+3106723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1603637, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3103195,int_stack+165641,int_stack+163793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306228, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3132203,int_stack+3103195,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1611477, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3141443,int_stack+3132203,int_stack+3114563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1616097, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3154043,int_stack+3141443,int_stack+3122123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1623657, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3108739,int_stack+3154043,int_stack+3091435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633737, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+167825,int_stack+165641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308076, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3103195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645497, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3132203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1651041, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3141443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1660281, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3154043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672881, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3125203,int_stack+3086815,int_stack+3108739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1688001, 0.0, zero_stack,28);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+171381,int_stack+170373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323980, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089839,int_stack+172677,int_stack+171381, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1324988, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3093727,int_stack+3089839,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1704465, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3099775,int_stack+174297,int_stack+172677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326284, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3104635,int_stack+3099775,int_stack+3089839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1707489, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3112411,int_stack+3104635,int_stack+3093727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1711377, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+176277,int_stack+174297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327904, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3147155,int_stack+3086815,int_stack+3099775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717425, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156875,int_stack+3147155,int_stack+3104635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1722285, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3092755,int_stack+3156875,int_stack+3112411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730061, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3107875,int_stack+178653,int_stack+176277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329884, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3169835,int_stack+3107875,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3181715,int_stack+3169835,int_stack+3147155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764805, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3197915,int_stack+3181715,int_stack+3156875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1774525, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3147155,int_stack+3197915,int_stack+3092755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1787485, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+181461,int_stack+178653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332260, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3217355,int_stack+3086815,int_stack+3107875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802605, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3217355,int_stack+3169835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1809733, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3217355,int_stack+3086815,int_stack+3181715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1821613, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3217355,int_stack+3197915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837813, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3168323,int_stack+3086815,int_stack+3147155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1857253, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3196547,int_stack+3168323,int_stack+3125203,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+185997,int_stack+184737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1352708, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3090595,int_stack+187617,int_stack+185997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353968, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3095455,int_stack+3090595,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3103015,int_stack+189642,int_stack+187617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1355588, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3109090,int_stack+3103015,int_stack+3090595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9720, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3118810,int_stack+3109090,int_stack+3095455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14580, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+192117,int_stack+189642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357613, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3131410,int_stack+3086815,int_stack+3103015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1972501, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3143560,int_stack+3131410,int_stack+3109090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978576, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3094240,int_stack+3143560,int_stack+3118810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1988296, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3113140,int_stack+195087,int_stack+192117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360088, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3262403,int_stack+3113140,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000896, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3277253,int_stack+3262403,int_stack+3131410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1740141, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3297503,int_stack+3277253,int_stack+3143560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2008321, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3122050,int_stack+3297503,int_stack+3094240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024521, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+198597,int_stack+195087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363058, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3148510,int_stack+3086815,int_stack+3113140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1752291, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3148510,int_stack+3262403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043421, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3321803,int_stack+3086815,int_stack+3277253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058271, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3321803,int_stack+3297503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078521, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3262403,int_stack+3086815,int_stack+3122050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2102821, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3297683,int_stack+3262403,int_stack+3168323,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3382355,int_stack+3297683,int_stack+3196547,784);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+204232,int_stack+202692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1388618, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3091435,int_stack+206212,int_stack+204232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1390158, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3097375,int_stack+3091435,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1878421, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3106615,int_stack+208687,int_stack+206212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392138, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3114040,int_stack+3106615,int_stack+3091435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883041, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3125920,int_stack+3114040,int_stack+3097375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1888981, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+211712,int_stack+208687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1394613, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3141320,int_stack+3086815,int_stack+3106615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898221, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156170,int_stack+3141320,int_stack+3114040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1905646, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3095890,int_stack+3156170,int_stack+3125920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1917526, 0.0, zero_stack,55);
 /*--- compute (m0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3118990,int_stack+215342,int_stack+211712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397638, 0.0, zero_stack,55);
 /*--- compute (m0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3175970,int_stack+3118990,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932926, 0.0, zero_stack,55);
 /*--- compute (m0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3194120,int_stack+3175970,int_stack+3141320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942001, 0.0, zero_stack,55);
 /*--- compute (m0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3218870,int_stack+3194120,int_stack+3156170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22140, 0.0, zero_stack,55);
 /*--- compute (m0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3129880,int_stack+3218870,int_stack+3095890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2380945, 0.0, zero_stack,55);
 /*--- compute (m0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+219632,int_stack+215342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401268, 0.0, zero_stack,55);
 /*--- compute (m0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3118990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1956851, 0.0, zero_stack,55);
 /*--- compute (m0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3514067,int_stack+3175970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2404045, 0.0, zero_stack,55);
 /*--- compute (m0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3194120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422195, 0.0, zero_stack,55);
 /*--- compute (m0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3514067,int_stack+3218870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2446945, 0.0, zero_stack,55);
 /*--- compute (m0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3129880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2476645, 0.0, zero_stack,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+3086815,int_stack+3514067,int_stack+3262403,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+3557187,int_stack+3086815,int_stack+3297683,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+5894226,int_stack+3557187,int_stack+3382355,784);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3192655,int_stack+226485,int_stack+224637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432508, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3198199,int_stack+228861,int_stack+226485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434356, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3205327,int_stack+3198199,int_stack+3192655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2129281, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3216415,int_stack+231831,int_stack+228861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1436732, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3225325,int_stack+3216415,int_stack+3198199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134825, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3239581,int_stack+3225325,int_stack+3205327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2141953, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3192655,int_stack+235461,int_stack+231831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1439702, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3258061,int_stack+3192655,int_stack+3216415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2153041, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3275881,int_stack+3258061,int_stack+3225325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161951, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3203545,int_stack+3275881,int_stack+3239581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176207, 0.0, zero_stack,66);
 /*--- compute (n0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3231265,int_stack+239817,int_stack+235461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1443332, 0.0, zero_stack,66);
 /*--- compute (n0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3299641,int_stack+3231265,int_stack+3192655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2194687, 0.0, zero_stack,66);
 /*--- compute (n0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3321421,int_stack+3299641,int_stack+3258061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205577, 0.0, zero_stack,66);
 /*--- compute (n0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3351121,int_stack+3321421,int_stack+3275881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2223397, 0.0, zero_stack,66);
 /*--- compute (n0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3244333,int_stack+3351121,int_stack+3203545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247157, 0.0, zero_stack,66);
 /*--- compute (n0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3192655,int_stack+244965,int_stack+239817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1447688, 0.0, zero_stack,66);
 /*--- compute (n0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3386761,int_stack+3192655,int_stack+3231265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274877, 0.0, zero_stack,66);
 /*--- compute (n0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3192655,int_stack+3386761,int_stack+3299641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2287945, 0.0, zero_stack,66);
 /*--- compute (n0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3386761,int_stack+3192655,int_stack+3321421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2309725, 0.0, zero_stack,66);
 /*--- compute (n0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3192655,int_stack+3386761,int_stack+3351121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339425, 0.0, zero_stack,66);
 /*--- compute (n0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3283141,int_stack+3192655,int_stack+3244333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2508985, 0.0, zero_stack,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+3334885,int_stack+3283141,int_stack+3514067,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+6113746,int_stack+3334885,int_stack+3086815,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+3994998,int_stack+6113746,int_stack+3557187,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+3464245,int_stack+3994998,int_stack+5894226,784);
 /*--- compute (o0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5894226,int_stack+253155,int_stack+250971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1485176, 0.0, zero_stack,78);
 /*--- compute (o0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5900778,int_stack+255963,int_stack+253155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1487360, 0.0, zero_stack,78);
 /*--- compute (o0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5909202,int_stack+5900778,int_stack+5894226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41940, 0.0, zero_stack,78);
 /*--- compute (o0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5922306,int_stack+259473,int_stack+255963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1490168, 0.0, zero_stack,78);
 /*--- compute (o0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+5932836,int_stack+5922306,int_stack+5900778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48492, 0.0, zero_stack,78);
 /*--- compute (o0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5949684,int_stack+5932836,int_stack+5909202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56916, 0.0, zero_stack,78);
 /*--- compute (o0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+5894226,int_stack+263763,int_stack+259473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1493678, 0.0, zero_stack,78);
 /*--- compute (o0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5971524,int_stack+5894226,int_stack+5922306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70020, 0.0, zero_stack,78);
 /*--- compute (o0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+5992584,int_stack+5971524,int_stack+5932836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877073, 0.0, zero_stack,78);
 /*--- compute (o0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+5907096,int_stack+5992584,int_stack+5949684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2893921, 0.0, zero_stack,78);
 /*--- compute (o0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+5939856,int_stack+268911,int_stack+263763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497968, 0.0, zero_stack,78);
 /*--- compute (o0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+6020664,int_stack+5939856,int_stack+5894226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2915761, 0.0, zero_stack,78);
 /*--- compute (o0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+6046404,int_stack+6020664,int_stack+5971524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2928631, 0.0, zero_stack,78);
 /*--- compute (o0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3086815,int_stack+6046404,int_stack+5992584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2949691, 0.0, zero_stack,78);
 /*--- compute (o0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+5955300,int_stack+3086815,int_stack+5907096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2977771, 0.0, zero_stack,78);
 /*--- compute (o0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+5894226,int_stack+274995,int_stack+268911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503116, 0.0, zero_stack,78);
 /*--- compute (o0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+6081504,int_stack+5894226,int_stack+5939856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3010531, 0.0, zero_stack,78);
 /*--- compute (o0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+5894226,int_stack+6081504,int_stack+6020664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3025975, 0.0, zero_stack,78);
 /*--- compute (o0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3128935,int_stack+5894226,int_stack+6046404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3051715, 0.0, zero_stack,78);
 /*--- compute (o0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+5894226,int_stack+3128935,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3804366, 0.0, zero_stack,78);
 /*--- compute (o0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3086815,int_stack+5894226,int_stack+5955300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3846486, 0.0, zero_stack,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+5894226,int_stack+3086815,int_stack+3283141,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+4277238,int_stack+5894226,int_stack+3334885,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+6325426,int_stack+4277238,int_stack+6113746,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+6678226,int_stack+6325426,int_stack+3994998,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+7101586,int_stack+6678226,int_stack+3464245,784);
 /*--- compute (q0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3994998,int_stack+284641,int_stack+282093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918897, 0.0, zero_stack,91);
 /*--- compute (q0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4002642,int_stack+287917,int_stack+284641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923993, 0.0, zero_stack,91);
 /*--- compute (q0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4012470,int_stack+4002642,int_stack+3994998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2547793, 0.0, zero_stack,91);
 /*--- compute (q0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4027758,int_stack+292012,int_stack+287917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930545, 0.0, zero_stack,91);
 /*--- compute (q0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4040043,int_stack+4027758,int_stack+4002642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2555437, 0.0, zero_stack,91);
 /*--- compute (q0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4059699,int_stack+4040043,int_stack+4012470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2565265, 0.0, zero_stack,91);
 /*--- compute (q0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3994998,int_stack+297017,int_stack+292012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938735, 0.0, zero_stack,91);
 /*--- compute (q0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4085179,int_stack+3994998,int_stack+4027758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2580553, 0.0, zero_stack,91);
 /*--- compute (q0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4109749,int_stack+4085179,int_stack+4040043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2592838, 0.0, zero_stack,91);
 /*--- compute (q0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4010013,int_stack+4109749,int_stack+4059699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2612494, 0.0, zero_stack,91);
 /*--- compute (q0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4048233,int_stack+303023,int_stack+297017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948745, 0.0, zero_stack,91);
 /*--- compute (q0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+4142509,int_stack+4048233,int_stack+3994998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2637974, 0.0, zero_stack,91);
 /*--- compute (q0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+4172539,int_stack+4142509,int_stack+4085179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652989, 0.0, zero_stack,91);
 /*--- compute (q0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+4213489,int_stack+4172539,int_stack+4109749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2677559, 0.0, zero_stack,91);
 /*--- compute (q0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+4066251,int_stack+4213489,int_stack+4010013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2710319, 0.0, zero_stack,91);
 /*--- compute (q0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3994998,int_stack+310121,int_stack+303023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960757, 0.0, zero_stack,91);
 /*--- compute (q0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+6049458,int_stack+3994998,int_stack+4048233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2748539, 0.0, zero_stack,91);
 /*--- compute (q0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3994998,int_stack+6049458,int_stack+4142509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2766557, 0.0, zero_stack,91);
 /*--- compute (q0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+6049458,int_stack+3994998,int_stack+4172539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2796587, 0.0, zero_stack,91);
 /*--- compute (q0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3994998,int_stack+6049458,int_stack+4213489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3892350, 0.0, zero_stack,91);
 /*--- compute (q0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+6049458,int_stack+3994998,int_stack+4066251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3941490, 0.0, zero_stack,91);
 /*--- compute (op|ii) ---*/
   hrr1_build_op(Libderiv->AB,int_stack+3994998,int_stack+6049458,int_stack+3086815,784);
 /*--- compute (nd|ii) ---*/
   hrr1_build_nd(Libderiv->AB,int_stack+3086815,int_stack+3994998,int_stack+5894226,784);
 /*--- compute (mf|ii) ---*/
   hrr1_build_mf(Libderiv->AB,int_stack+5894226,int_stack+3086815,int_stack+4277238,784);
 /*--- compute (lg|ii) ---*/
   hrr1_build_lg(Libderiv->AB,int_stack+3086815,int_stack+5894226,int_stack+6325426,784);
 /*--- compute (kh|ii) ---*/
   hrr1_build_kh(Libderiv->AB,int_stack+5894226,int_stack+3086815,int_stack+6678226,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+319186,int_stack+318402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1301636, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089167,int_stack+320194,int_stack+319186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1302420, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3092191,int_stack+3089167,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3096895,int_stack+321454,int_stack+320194, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303428, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3100675,int_stack+3096895,int_stack+3089167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586081, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3106723,int_stack+3100675,int_stack+3092191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1589105, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+322994,int_stack+321454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304688, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3114563,int_stack+3086815,int_stack+3096895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1593809, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3122123,int_stack+3114563,int_stack+3100675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597589, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3091435,int_stack+3122123,int_stack+3106723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1603637, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3103195,int_stack+324842,int_stack+322994, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306228, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3132203,int_stack+3103195,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1611477, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3141443,int_stack+3132203,int_stack+3114563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1616097, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3154043,int_stack+3141443,int_stack+3122123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1623657, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3108739,int_stack+3154043,int_stack+3091435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633737, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+327026,int_stack+324842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308076, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3103195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645497, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3132203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1651041, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3141443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1660281, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3154043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672881, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3125203,int_stack+3086815,int_stack+3108739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1688001, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+330582,int_stack+329574, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323980, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089839,int_stack+331878,int_stack+330582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1324988, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3093727,int_stack+3089839,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1704465, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3099775,int_stack+333498,int_stack+331878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326284, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3104635,int_stack+3099775,int_stack+3089839, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1707489, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3112411,int_stack+3104635,int_stack+3093727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1711377, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+335478,int_stack+333498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327904, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3147155,int_stack+3086815,int_stack+3099775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717425, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156875,int_stack+3147155,int_stack+3104635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1722285, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3092755,int_stack+3156875,int_stack+3112411, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730061, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3107875,int_stack+337854,int_stack+335478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329884, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3169835,int_stack+3107875,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3181715,int_stack+3169835,int_stack+3147155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764805, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3197915,int_stack+3181715,int_stack+3156875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1774525, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3147155,int_stack+3197915,int_stack+3092755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1787485, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+340662,int_stack+337854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332260, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3217355,int_stack+3086815,int_stack+3107875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802605, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3217355,int_stack+3169835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1809733, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3217355,int_stack+3086815,int_stack+3181715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1821613, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3217355,int_stack+3197915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837813, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3168323,int_stack+3086815,int_stack+3147155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1857253, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3196547,int_stack+3168323,int_stack+3125203,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+345198,int_stack+343938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1352708, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3090595,int_stack+346818,int_stack+345198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353968, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3095455,int_stack+3090595,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3103015,int_stack+348843,int_stack+346818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1355588, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3109090,int_stack+3103015,int_stack+3090595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9720, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3118810,int_stack+3109090,int_stack+3095455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14580, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+351318,int_stack+348843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357613, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3131410,int_stack+3086815,int_stack+3103015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1972501, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3143560,int_stack+3131410,int_stack+3109090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978576, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3094240,int_stack+3143560,int_stack+3118810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1988296, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3113140,int_stack+354288,int_stack+351318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360088, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3262403,int_stack+3113140,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000896, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3277253,int_stack+3262403,int_stack+3131410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1740141, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3297503,int_stack+3277253,int_stack+3143560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2008321, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3122050,int_stack+3297503,int_stack+3094240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024521, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+357798,int_stack+354288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363058, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3148510,int_stack+3086815,int_stack+3113140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1752291, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3148510,int_stack+3262403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043421, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3321803,int_stack+3086815,int_stack+3277253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058271, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3321803,int_stack+3297503, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078521, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3262403,int_stack+3086815,int_stack+3122050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2102821, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3297683,int_stack+3262403,int_stack+3168323,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3382355,int_stack+3297683,int_stack+3196547,784);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+363433,int_stack+361893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1388618, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3091435,int_stack+365413,int_stack+363433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1390158, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3097375,int_stack+3091435,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1878421, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3106615,int_stack+367888,int_stack+365413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392138, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3114040,int_stack+3106615,int_stack+3091435, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883041, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3125920,int_stack+3114040,int_stack+3097375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1888981, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+370913,int_stack+367888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1394613, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3141320,int_stack+3086815,int_stack+3106615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898221, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156170,int_stack+3141320,int_stack+3114040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1905646, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3095890,int_stack+3156170,int_stack+3125920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1917526, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3118990,int_stack+374543,int_stack+370913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397638, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3175970,int_stack+3118990,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932926, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3194120,int_stack+3175970,int_stack+3141320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942001, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3218870,int_stack+3194120,int_stack+3156170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22140, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3129880,int_stack+3218870,int_stack+3095890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2380945, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+378833,int_stack+374543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401268, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3118990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1956851, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3514067,int_stack+3175970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2404045, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3194120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422195, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3514067,int_stack+3218870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2446945, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3129880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2476645, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+3086815,int_stack+3514067,int_stack+3262403,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+3557187,int_stack+3086815,int_stack+3297683,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+6486930,int_stack+3557187,int_stack+3382355,784);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3192655,int_stack+385686,int_stack+383838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432508, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3198199,int_stack+388062,int_stack+385686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434356, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3205327,int_stack+3198199,int_stack+3192655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2129281, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3216415,int_stack+391032,int_stack+388062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1436732, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3225325,int_stack+3216415,int_stack+3198199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134825, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3239581,int_stack+3225325,int_stack+3205327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2141953, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3192655,int_stack+394662,int_stack+391032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1439702, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3258061,int_stack+3192655,int_stack+3216415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2153041, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3275881,int_stack+3258061,int_stack+3225325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161951, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3203545,int_stack+3275881,int_stack+3239581, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176207, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3231265,int_stack+399018,int_stack+394662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1443332, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3299641,int_stack+3231265,int_stack+3192655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2194687, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3321421,int_stack+3299641,int_stack+3258061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205577, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3351121,int_stack+3321421,int_stack+3275881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2223397, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3244333,int_stack+3351121,int_stack+3203545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247157, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3192655,int_stack+404166,int_stack+399018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1447688, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3386761,int_stack+3192655,int_stack+3231265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274877, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3192655,int_stack+3386761,int_stack+3299641, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2287945, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3386761,int_stack+3192655,int_stack+3321421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2309725, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3192655,int_stack+3386761,int_stack+3351121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339425, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3283141,int_stack+3192655,int_stack+3244333, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2508985, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+3334885,int_stack+3283141,int_stack+3514067,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+6706450,int_stack+3334885,int_stack+3086815,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+3994998,int_stack+6706450,int_stack+3557187,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+3464245,int_stack+3994998,int_stack+6486930,784);
 /*--- compute (o0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6486930,int_stack+412356,int_stack+410172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1485176, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6493482,int_stack+415164,int_stack+412356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1487360, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6501906,int_stack+6493482,int_stack+6486930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41940, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+6515010,int_stack+418674,int_stack+415164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1490168, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+6525540,int_stack+6515010,int_stack+6493482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48492, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+6542388,int_stack+6525540,int_stack+6501906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56916, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+6486930,int_stack+422964,int_stack+418674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1493678, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+6564228,int_stack+6486930,int_stack+6515010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70020, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6585288,int_stack+6564228,int_stack+6525540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877073, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+6499800,int_stack+6585288,int_stack+6542388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2893921, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+6532560,int_stack+428112,int_stack+422964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497968, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+6613368,int_stack+6532560,int_stack+6486930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2915761, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+6639108,int_stack+6613368,int_stack+6564228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2928631, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3086815,int_stack+6639108,int_stack+6585288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2949691, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+6548004,int_stack+3086815,int_stack+6499800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2977771, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+6486930,int_stack+434196,int_stack+428112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503116, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+6674208,int_stack+6486930,int_stack+6532560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3010531, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+6486930,int_stack+6674208,int_stack+6613368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3025975, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3128935,int_stack+6486930,int_stack+6639108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3051715, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+6486930,int_stack+3128935,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3804366, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3086815,int_stack+6486930,int_stack+6548004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3846486, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+6486930,int_stack+3086815,int_stack+3283141,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+4277238,int_stack+6486930,int_stack+3334885,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+80550,int_stack+4277238,int_stack+6706450,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+6642162,int_stack+80550,int_stack+3994998,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+7562578,int_stack+6642162,int_stack+3464245,784);
 /*--- compute (q0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3994998,int_stack+443842,int_stack+441294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918897, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4002642,int_stack+447118,int_stack+443842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923993, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4012470,int_stack+4002642,int_stack+3994998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2547793, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4027758,int_stack+451213,int_stack+447118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930545, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+4040043,int_stack+4027758,int_stack+4002642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2555437, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4059699,int_stack+4040043,int_stack+4012470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2565265, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3994998,int_stack+456218,int_stack+451213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938735, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4085179,int_stack+3994998,int_stack+4027758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2580553, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4109749,int_stack+4085179,int_stack+4040043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2592838, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+4010013,int_stack+4109749,int_stack+4059699, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2612494, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4048233,int_stack+462224,int_stack+456218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948745, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+4142509,int_stack+4048233,int_stack+3994998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2637974, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+4172539,int_stack+4142509,int_stack+4085179, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652989, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+4213489,int_stack+4172539,int_stack+4109749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2677559, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+4066251,int_stack+4213489,int_stack+4010013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2710319, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3994998,int_stack+469322,int_stack+462224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960757, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+7065522,int_stack+3994998,int_stack+4048233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2748539, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3994998,int_stack+7065522,int_stack+4142509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2766557, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3147967,int_stack+3994998,int_stack+4172539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2796587, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3994998,int_stack+3147967,int_stack+4213489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3892350, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3147967,int_stack+3994998,int_stack+4066251, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3941490, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (op|ii) ---*/
   hrr1_build_op(Libderiv->AB,int_stack+3994998,int_stack+3147967,int_stack+3086815,784);
 /*--- compute (nd|ii) ---*/
   hrr1_build_nd(Libderiv->AB,int_stack+3086815,int_stack+3994998,int_stack+6486930,784);
 /*--- compute (mf|ii) ---*/
   hrr1_build_mf(Libderiv->AB,int_stack+8023570,int_stack+3086815,int_stack+4277238,784);
 /*--- compute (lg|ii) ---*/
   hrr1_build_lg(Libderiv->AB,int_stack+3086815,int_stack+8023570,int_stack+80550,784);
 /*--- compute (kh|ii) ---*/
   hrr1_build_kh(Libderiv->AB,int_stack+3994998,int_stack+3086815,int_stack+6642162,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+478387,int_stack+477603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1301636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089167,int_stack+479395,int_stack+478387, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1302420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3092191,int_stack+3089167,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3096895,int_stack+480655,int_stack+479395, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1303428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3100675,int_stack+3096895,int_stack+3089167, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1586081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3106723,int_stack+3100675,int_stack+3092191, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1589105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+482195,int_stack+480655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1304688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3114563,int_stack+3086815,int_stack+3096895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1593809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3122123,int_stack+3114563,int_stack+3100675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1597589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3091435,int_stack+3122123,int_stack+3106723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1603637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3103195,int_stack+484043,int_stack+482195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1306228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3132203,int_stack+3103195,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1611477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3141443,int_stack+3132203,int_stack+3114563, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1616097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3154043,int_stack+3141443,int_stack+3122123, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1623657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3108739,int_stack+3154043,int_stack+3091435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1633737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+486227,int_stack+484043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1308076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3103195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1645497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3132203, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1651041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3141443, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1660281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3154043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1672881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3125203,int_stack+3086815,int_stack+3108739, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1688001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+489783,int_stack+488775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089839,int_stack+491079,int_stack+489783, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1324988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3093727,int_stack+3089839,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1704465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3099775,int_stack+492699,int_stack+491079, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1326284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3104635,int_stack+3099775,int_stack+3089839, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1707489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3112411,int_stack+3104635,int_stack+3093727, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1711377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+494679,int_stack+492699, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1327904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3147155,int_stack+3086815,int_stack+3099775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1717425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156875,int_stack+3147155,int_stack+3104635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1722285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3092755,int_stack+3156875,int_stack+3112411, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1730061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3107875,int_stack+497055,int_stack+494679, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3169835,int_stack+3107875,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3181715,int_stack+3169835,int_stack+3147155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3197915,int_stack+3181715,int_stack+3156875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1774525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3147155,int_stack+3197915,int_stack+3092755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1787485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+499863,int_stack+497055, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1332260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3217355,int_stack+3086815,int_stack+3107875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1802605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3217355,int_stack+3169835, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1809733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3217355,int_stack+3086815,int_stack+3181715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1821613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3217355,int_stack+3197915, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3168323,int_stack+3086815,int_stack+3147155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1857253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3196547,int_stack+3168323,int_stack+3125203,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+504399,int_stack+503139, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1352708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3090595,int_stack+506019,int_stack+504399, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3095455,int_stack+3090595,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3103015,int_stack+508044,int_stack+506019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1355588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3109090,int_stack+3103015,int_stack+3090595, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3118810,int_stack+3109090,int_stack+3095455, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+510519,int_stack+508044, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1357613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3131410,int_stack+3086815,int_stack+3103015, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1972501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3143560,int_stack+3131410,int_stack+3109090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3094240,int_stack+3143560,int_stack+3118810, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1988296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3113140,int_stack+513489,int_stack+510519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1360088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3262403,int_stack+3113140,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2000896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3277253,int_stack+3262403,int_stack+3131410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1740141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3297503,int_stack+3277253,int_stack+3143560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2008321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3122050,int_stack+3297503,int_stack+3094240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2024521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+516999,int_stack+513489, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1363058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3148510,int_stack+3086815,int_stack+3113140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1752291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3148510,int_stack+3262403, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2043421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3321803,int_stack+3086815,int_stack+3277253, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2058271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3321803,int_stack+3297503, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2078521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3262403,int_stack+3086815,int_stack+3122050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2102821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3297683,int_stack+3262403,int_stack+3168323,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3382355,int_stack+3297683,int_stack+3196547,784);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+522634,int_stack+521094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1388618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3091435,int_stack+524614,int_stack+522634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1390158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3097375,int_stack+3091435,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1878421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3106615,int_stack+527089,int_stack+524614, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3114040,int_stack+3106615,int_stack+3091435, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1883041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3125920,int_stack+3114040,int_stack+3097375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1888981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+530114,int_stack+527089, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1394613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3141320,int_stack+3086815,int_stack+3106615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1898221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156170,int_stack+3141320,int_stack+3114040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1905646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3095890,int_stack+3156170,int_stack+3125920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1917526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3118990,int_stack+533744,int_stack+530114, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3175970,int_stack+3118990,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1932926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3194120,int_stack+3175970,int_stack+3141320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1942001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3218870,int_stack+3194120,int_stack+3156170, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3129880,int_stack+3218870,int_stack+3095890, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2380945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+538034,int_stack+533744, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3118990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1956851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3514067,int_stack+3175970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2404045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3194120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3514067,int_stack+3218870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2446945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3514067,int_stack+3086815,int_stack+3129880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2476645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+3086815,int_stack+3514067,int_stack+3262403,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+3557187,int_stack+3086815,int_stack+3297683,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+80550,int_stack+3557187,int_stack+3382355,784);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3192655,int_stack+544887,int_stack+543039, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1432508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3198199,int_stack+547263,int_stack+544887, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1434356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3205327,int_stack+3198199,int_stack+3192655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2129281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3216415,int_stack+550233,int_stack+547263, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1436732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3225325,int_stack+3216415,int_stack+3198199, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2134825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3239581,int_stack+3225325,int_stack+3205327, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2141953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3192655,int_stack+553863,int_stack+550233, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1439702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3258061,int_stack+3192655,int_stack+3216415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2153041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3275881,int_stack+3258061,int_stack+3225325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2161951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3203545,int_stack+3275881,int_stack+3239581, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2176207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3231265,int_stack+558219,int_stack+553863, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1443332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3299641,int_stack+3231265,int_stack+3192655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2194687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3321421,int_stack+3299641,int_stack+3258061, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2205577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3351121,int_stack+3321421,int_stack+3275881, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2223397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3244333,int_stack+3351121,int_stack+3203545, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2247157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3192655,int_stack+563367,int_stack+558219, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1447688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3386761,int_stack+3192655,int_stack+3231265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2274877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3192655,int_stack+3386761,int_stack+3299641, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2287945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3386761,int_stack+3192655,int_stack+3321421, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2309725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3192655,int_stack+3386761,int_stack+3351121, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2339425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3283141,int_stack+3192655,int_stack+3244333, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2508985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+3334885,int_stack+3283141,int_stack+3514067,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+300070,int_stack+3334885,int_stack+3086815,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+8023570,int_stack+300070,int_stack+3557187,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+3464245,int_stack+8023570,int_stack+80550,784);
 /*--- compute (o0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+80550,int_stack+571557,int_stack+569373, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1485176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+87102,int_stack+574365,int_stack+571557, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1487360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+95526,int_stack+87102,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+108630,int_stack+577875,int_stack+574365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1490168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+119160,int_stack+108630,int_stack+87102, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+136008,int_stack+119160,int_stack+95526, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+80550,int_stack+582165,int_stack+577875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1493678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+157848,int_stack+80550,int_stack+108630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+178908,int_stack+157848,int_stack+119160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2877073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+93420,int_stack+178908,int_stack+136008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2893921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+126180,int_stack+587313,int_stack+582165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1497968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+206988,int_stack+126180,int_stack+80550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2915761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+232728,int_stack+206988,int_stack+157848, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2928631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3086815,int_stack+232728,int_stack+178908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2949691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+141624,int_stack+3086815,int_stack+93420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2977771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+80550,int_stack+593397,int_stack+587313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1503116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+267828,int_stack+80550,int_stack+126180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3010531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+80550,int_stack+267828,int_stack+206988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3025975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3128935,int_stack+80550,int_stack+232728, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3051715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+80550,int_stack+3128935,int_stack+3086815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3804366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3086815,int_stack+80550,int_stack+141624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3846486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+80550,int_stack+3086815,int_stack+3283141,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+6486930,int_stack+80550,int_stack+3334885,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+6745650,int_stack+6486930,int_stack+300070,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+8305810,int_stack+6745650,int_stack+8023570,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+8729170,int_stack+8305810,int_stack+3464245,784);
 /*--- compute (q0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8023570,int_stack+603043,int_stack+600495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+918897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8031214,int_stack+606319,int_stack+603043, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+923993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8041042,int_stack+8031214,int_stack+8023570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2547793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8056330,int_stack+610414,int_stack+606319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8068615,int_stack+8056330,int_stack+8031214, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2555437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+8088271,int_stack+8068615,int_stack+8041042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2565265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8023570,int_stack+615419,int_stack+610414, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+938735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+8113751,int_stack+8023570,int_stack+8056330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2580553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8138321,int_stack+8113751,int_stack+8068615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2592838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8038585,int_stack+8138321,int_stack+8088271, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2612494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+8076805,int_stack+621425,int_stack+615419, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+948745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+8171081,int_stack+8076805,int_stack+8023570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2637974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8201111,int_stack+8171081,int_stack+8113751, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2652989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+8242061,int_stack+8201111,int_stack+8138321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2677559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+8094823,int_stack+8242061,int_stack+8038585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2710319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+628523,int_stack+621425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+235782,int_stack+8023570,int_stack+8076805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2748539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+8023570,int_stack+235782,int_stack+8171081, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2766557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+235782,int_stack+8023570,int_stack+8201111, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2796587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+235782,int_stack+8242061, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3892350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+235782,int_stack+8023570,int_stack+8094823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3941490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (op|ii) ---*/
   hrr1_build_op(Libderiv->AB,int_stack+8023570,int_stack+235782,int_stack+3086815,784);
 /*--- compute (nd|ii) ---*/
   hrr1_build_nd(Libderiv->AB,int_stack+3086815,int_stack+8023570,int_stack+80550,784);
 /*--- compute (mf|ii) ---*/
   hrr1_build_mf(Libderiv->AB,int_stack+80550,int_stack+3086815,int_stack+6486930,784);
 /*--- compute (lg|ii) ---*/
   hrr1_build_lg(Libderiv->AB,int_stack+3086815,int_stack+80550,int_stack+6745650,784);
 /*--- compute (kh|ii) ---*/
   hrr1_build_kh(Libderiv->AB,int_stack+6486930,int_stack+3086815,int_stack+8305810,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+637588,int_stack+636804, 0.0, zero_stack, 1.0, int_stack+1301636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089167,int_stack+638596,int_stack+637588, 0.0, zero_stack, 1.0, int_stack+1302420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3092191,int_stack+3089167,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3096895,int_stack+639856,int_stack+638596, 0.0, zero_stack, 1.0, int_stack+1303428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3100675,int_stack+3096895,int_stack+3089167, 0.0, zero_stack, 1.0, int_stack+1586081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3106723,int_stack+3100675,int_stack+3092191, 0.0, zero_stack, 1.0, int_stack+1589105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+641396,int_stack+639856, 0.0, zero_stack, 1.0, int_stack+1304688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3114563,int_stack+3086815,int_stack+3096895, 0.0, zero_stack, 1.0, int_stack+1593809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3122123,int_stack+3114563,int_stack+3100675, 0.0, zero_stack, 1.0, int_stack+1597589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3091435,int_stack+3122123,int_stack+3106723, 0.0, zero_stack, 1.0, int_stack+1603637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3103195,int_stack+643244,int_stack+641396, 0.0, zero_stack, 1.0, int_stack+1306228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3132203,int_stack+3103195,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1611477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3141443,int_stack+3132203,int_stack+3114563, 0.0, zero_stack, 1.0, int_stack+1616097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3154043,int_stack+3141443,int_stack+3122123, 0.0, zero_stack, 1.0, int_stack+1623657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3108739,int_stack+3154043,int_stack+3091435, 0.0, zero_stack, 1.0, int_stack+1633737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+645428,int_stack+643244, 0.0, zero_stack, 1.0, int_stack+1308076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3103195, 0.0, zero_stack, 1.0, int_stack+1645497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3132203, 0.0, zero_stack, 1.0, int_stack+1651041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3169163,int_stack+3086815,int_stack+3141443, 0.0, zero_stack, 1.0, int_stack+1660281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3169163,int_stack+3154043, 0.0, zero_stack, 1.0, int_stack+1672881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+7079634,int_stack+3086815,int_stack+3108739, 0.0, zero_stack, 1.0, int_stack+1688001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+648984,int_stack+647976, 0.0, zero_stack, 1.0, int_stack+1323980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3089839,int_stack+650280,int_stack+648984, 0.0, zero_stack, 1.0, int_stack+1324988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3093727,int_stack+3089839,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1704465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3099775,int_stack+651900,int_stack+650280, 0.0, zero_stack, 1.0, int_stack+1326284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3104635,int_stack+3099775,int_stack+3089839, 0.0, zero_stack, 1.0, int_stack+1707489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3112411,int_stack+3104635,int_stack+3093727, 0.0, zero_stack, 1.0, int_stack+1711377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+653880,int_stack+651900, 0.0, zero_stack, 1.0, int_stack+1327904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3122491,int_stack+3086815,int_stack+3099775, 0.0, zero_stack, 1.0, int_stack+1717425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3132211,int_stack+3122491,int_stack+3104635, 0.0, zero_stack, 1.0, int_stack+1722285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3092755,int_stack+3132211,int_stack+3112411, 0.0, zero_stack, 1.0, int_stack+1730061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3107875,int_stack+656256,int_stack+653880, 0.0, zero_stack, 1.0, int_stack+1329884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3145171,int_stack+3107875,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3157051,int_stack+3145171,int_stack+3122491, 0.0, zero_stack, 1.0, int_stack+1764805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3173251,int_stack+3157051,int_stack+3132211, 0.0, zero_stack, 1.0, int_stack+1774525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3115003,int_stack+3173251,int_stack+3092755, 0.0, zero_stack, 1.0, int_stack+1787485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+659064,int_stack+656256, 0.0, zero_stack, 1.0, int_stack+1332260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3192691,int_stack+3086815,int_stack+3107875, 0.0, zero_stack, 1.0, int_stack+1802605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3192691,int_stack+3145171, 0.0, zero_stack, 1.0, int_stack+1809733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3192691,int_stack+3086815,int_stack+3157051, 0.0, zero_stack, 1.0, int_stack+1821613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3192691,int_stack+3173251, 0.0, zero_stack, 1.0, int_stack+1837813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3136171,int_stack+3086815,int_stack+3115003, 0.0, zero_stack, 1.0, int_stack+1857253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+3164395,int_stack+3136171,int_stack+7079634,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7079634,int_stack+663600,int_stack+662340, 0.0, zero_stack, 1.0, int_stack+1352708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7083414,int_stack+665220,int_stack+663600, 0.0, zero_stack, 1.0, int_stack+1353968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7088274,int_stack+7083414,int_stack+7079634, 0.0, zero_stack, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3086815,int_stack+667245,int_stack+665220, 0.0, zero_stack, 1.0, int_stack+1355588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3092890,int_stack+3086815,int_stack+7083414, 0.0, zero_stack, 1.0, int_stack+9720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3102610,int_stack+3092890,int_stack+7088274, 0.0, zero_stack, 1.0, int_stack+14580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+7079634,int_stack+669720,int_stack+667245, 0.0, zero_stack, 1.0, int_stack+1357613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7087059,int_stack+7079634,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1972501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3115210,int_stack+7087059,int_stack+3092890, 0.0, zero_stack, 1.0, int_stack+1978576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3230251,int_stack+3115210,int_stack+3102610, 0.0, zero_stack, 1.0, int_stack+1988296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3086815,int_stack+672690,int_stack+669720, 0.0, zero_stack, 1.0, int_stack+1360088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3095725,int_stack+3086815,int_stack+7079634, 0.0, zero_stack, 1.0, int_stack+2000896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3249151,int_stack+3095725,int_stack+7087059, 0.0, zero_stack, 1.0, int_stack+1740141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3269401,int_stack+3249151,int_stack+3115210, 0.0, zero_stack, 1.0, int_stack+2008321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3293701,int_stack+3269401,int_stack+3230251, 0.0, zero_stack, 1.0, int_stack+2024521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3230251,int_stack+676200,int_stack+672690, 0.0, zero_stack, 1.0, int_stack+1363058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+7079634,int_stack+3230251,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1752291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3110575,int_stack+7079634,int_stack+3095725, 0.0, zero_stack, 1.0, int_stack+2043421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3320161,int_stack+3110575,int_stack+3249151, 0.0, zero_stack, 1.0, int_stack+2058271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3320161,int_stack+3269401, 0.0, zero_stack, 1.0, int_stack+2078521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3320161,int_stack+3086815,int_stack+3293701, 0.0, zero_stack, 1.0, int_stack+2102821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+3355441,int_stack+3320161,int_stack+3136171,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+3440113,int_stack+3355441,int_stack+3164395,784);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+681835,int_stack+680295, 0.0, zero_stack, 1.0, int_stack+1388618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3091435,int_stack+683815,int_stack+681835, 0.0, zero_stack, 1.0, int_stack+1390158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3097375,int_stack+3091435,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1878421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3106615,int_stack+686290,int_stack+683815, 0.0, zero_stack, 1.0, int_stack+1392138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3114040,int_stack+3106615,int_stack+3091435, 0.0, zero_stack, 1.0, int_stack+1883041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3125920,int_stack+3114040,int_stack+3097375, 0.0, zero_stack, 1.0, int_stack+1888981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+689315,int_stack+686290, 0.0, zero_stack, 1.0, int_stack+1394613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3141320,int_stack+3086815,int_stack+3106615, 0.0, zero_stack, 1.0, int_stack+1898221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3156170,int_stack+3141320,int_stack+3114040, 0.0, zero_stack, 1.0, int_stack+1905646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3095890,int_stack+3156170,int_stack+3125920, 0.0, zero_stack, 1.0, int_stack+1917526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3118990,int_stack+692945,int_stack+689315, 0.0, zero_stack, 1.0, int_stack+1397638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3175970,int_stack+3118990,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+1932926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3194120,int_stack+3175970,int_stack+3141320, 0.0, zero_stack, 1.0, int_stack+1942001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3218870,int_stack+3194120,int_stack+3156170, 0.0, zero_stack, 1.0, int_stack+22140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3129880,int_stack+3218870,int_stack+3095890, 0.0, zero_stack, 1.0, int_stack+2380945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+697235,int_stack+692945, 0.0, zero_stack, 1.0, int_stack+1401268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3248570,int_stack+3086815,int_stack+3118990, 0.0, zero_stack, 1.0, int_stack+1956851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3248570,int_stack+3175970, 0.0, zero_stack, 1.0, int_stack+2404045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3248570,int_stack+3086815,int_stack+3194120, 0.0, zero_stack, 1.0, int_stack+2422195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3248570,int_stack+3218870, 0.0, zero_stack, 1.0, int_stack+2446945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3162220,int_stack+3086815,int_stack+3129880, 0.0, zero_stack, 1.0, int_stack+2476645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+3205340,int_stack+3162220,int_stack+3320161,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+3571825,int_stack+3205340,int_stack+3355441,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+80550,int_stack+3571825,int_stack+3440113,784);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3086815,int_stack+704088,int_stack+702240, 0.0, zero_stack, 1.0, int_stack+1432508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3092359,int_stack+706464,int_stack+704088, 0.0, zero_stack, 1.0, int_stack+1434356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3099487,int_stack+3092359,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+2129281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+3110575,int_stack+709434,int_stack+706464, 0.0, zero_stack, 1.0, int_stack+1436732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+3119485,int_stack+3110575,int_stack+3092359, 0.0, zero_stack, 1.0, int_stack+2134825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+3133741,int_stack+3119485,int_stack+3099487, 0.0, zero_stack, 1.0, int_stack+2141953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+3086815,int_stack+713064,int_stack+709434, 0.0, zero_stack, 1.0, int_stack+1439702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+3311180,int_stack+3086815,int_stack+3110575, 0.0, zero_stack, 1.0, int_stack+2153041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+3329000,int_stack+3311180,int_stack+3119485, 0.0, zero_stack, 1.0, int_stack+2161951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+3097705,int_stack+3329000,int_stack+3133741, 0.0, zero_stack, 1.0, int_stack+2176207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3125425,int_stack+717420,int_stack+713064, 0.0, zero_stack, 1.0, int_stack+1443332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3138493,int_stack+3125425,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+2194687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+3352760,int_stack+3138493,int_stack+3311180, 0.0, zero_stack, 1.0, int_stack+2205577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3382460,int_stack+3352760,int_stack+3329000, 0.0, zero_stack, 1.0, int_stack+2223397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+3311180,int_stack+3382460,int_stack+3097705, 0.0, zero_stack, 1.0, int_stack+2247157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+3086815,int_stack+722568,int_stack+717420, 0.0, zero_stack, 1.0, int_stack+1447688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+3418100,int_stack+3086815,int_stack+3125425, 0.0, zero_stack, 1.0, int_stack+2274877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+3086815,int_stack+3418100,int_stack+3138493, 0.0, zero_stack, 1.0, int_stack+2287945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3418100,int_stack+3086815,int_stack+3352760, 0.0, zero_stack, 1.0, int_stack+2309725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+3086815,int_stack+3418100,int_stack+3382460, 0.0, zero_stack, 1.0, int_stack+2339425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3349988,int_stack+3086815,int_stack+3311180, 0.0, zero_stack, 1.0, int_stack+2508985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+3401732,int_stack+3349988,int_stack+3162220,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+300070,int_stack+3401732,int_stack+3205340,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+8023570,int_stack+300070,int_stack+3571825,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+8305810,int_stack+8023570,int_stack+80550,784);
 /*--- compute (o0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+80550,int_stack+730758,int_stack+728574, 0.0, zero_stack, 1.0, int_stack+1485176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+87102,int_stack+733566,int_stack+730758, 0.0, zero_stack, 1.0, int_stack+1487360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+95526,int_stack+87102,int_stack+80550, 0.0, zero_stack, 1.0, int_stack+41940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+108630,int_stack+737076,int_stack+733566, 0.0, zero_stack, 1.0, int_stack+1490168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+119160,int_stack+108630,int_stack+87102, 0.0, zero_stack, 1.0, int_stack+48492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+136008,int_stack+119160,int_stack+95526, 0.0, zero_stack, 1.0, int_stack+56916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+80550,int_stack+741366,int_stack+737076, 0.0, zero_stack, 1.0, int_stack+1493678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+157848,int_stack+80550,int_stack+108630, 0.0, zero_stack, 1.0, int_stack+70020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+178908,int_stack+157848,int_stack+119160, 0.0, zero_stack, 1.0, int_stack+2877073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+93420,int_stack+178908,int_stack+136008, 0.0, zero_stack, 1.0, int_stack+2893921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+126180,int_stack+746514,int_stack+741366, 0.0, zero_stack, 1.0, int_stack+1497968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+206988,int_stack+126180,int_stack+80550, 0.0, zero_stack, 1.0, int_stack+2915761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+232728,int_stack+206988,int_stack+157848, 0.0, zero_stack, 1.0, int_stack+2928631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+3086815,int_stack+232728,int_stack+178908, 0.0, zero_stack, 1.0, int_stack+2949691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+141624,int_stack+3086815,int_stack+93420, 0.0, zero_stack, 1.0, int_stack+2977771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+80550,int_stack+752598,int_stack+746514, 0.0, zero_stack, 1.0, int_stack+1503116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+267828,int_stack+80550,int_stack+126180, 0.0, zero_stack, 1.0, int_stack+3010531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+80550,int_stack+267828,int_stack+206988, 0.0, zero_stack, 1.0, int_stack+3025975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+3128935,int_stack+80550,int_stack+232728, 0.0, zero_stack, 1.0, int_stack+3051715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+80550,int_stack+3128935,int_stack+3086815, 0.0, zero_stack, 1.0, int_stack+3804366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+3086815,int_stack+80550,int_stack+141624, 0.0, zero_stack, 1.0, int_stack+3846486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+80550,int_stack+3086815,int_stack+3349988,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+3531092,int_stack+80550,int_stack+3401732,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+3147967,int_stack+3531092,int_stack+300070,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+235782,int_stack+3147967,int_stack+8023570,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+9190162,int_stack+235782,int_stack+8305810,784);
 /*--- compute (q0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8023570,int_stack+762244,int_stack+759696, 0.0, zero_stack, 1.0, int_stack+918897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8031214,int_stack+765520,int_stack+762244, 0.0, zero_stack, 1.0, int_stack+923993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8041042,int_stack+8031214,int_stack+8023570, 0.0, zero_stack, 1.0, int_stack+2547793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8056330,int_stack+769615,int_stack+765520, 0.0, zero_stack, 1.0, int_stack+930545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8068615,int_stack+8056330,int_stack+8031214, 0.0, zero_stack, 1.0, int_stack+2555437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+8088271,int_stack+8068615,int_stack+8041042, 0.0, zero_stack, 1.0, int_stack+2565265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+8023570,int_stack+774620,int_stack+769615, 0.0, zero_stack, 1.0, int_stack+938735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+8113751,int_stack+8023570,int_stack+8056330, 0.0, zero_stack, 1.0, int_stack+2580553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8138321,int_stack+8113751,int_stack+8068615, 0.0, zero_stack, 1.0, int_stack+2592838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8038585,int_stack+8138321,int_stack+8088271, 0.0, zero_stack, 1.0, int_stack+2612494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+8076805,int_stack+780626,int_stack+774620, 0.0, zero_stack, 1.0, int_stack+948745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+8171081,int_stack+8076805,int_stack+8023570, 0.0, zero_stack, 1.0, int_stack+2637974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8201111,int_stack+8171081,int_stack+8113751, 0.0, zero_stack, 1.0, int_stack+2652989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+8242061,int_stack+8201111,int_stack+8138321, 0.0, zero_stack, 1.0, int_stack+2677559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+8094823,int_stack+8242061,int_stack+8038585, 0.0, zero_stack, 1.0, int_stack+2710319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+787724,int_stack+780626, 0.0, zero_stack, 1.0, int_stack+960757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+8291201,int_stack+8023570,int_stack+8076805, 0.0, zero_stack, 1.0, int_stack+2748539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+8023570,int_stack+8291201,int_stack+8171081, 0.0, zero_stack, 1.0, int_stack+2766557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+8291201,int_stack+8023570,int_stack+8201111, 0.0, zero_stack, 1.0, int_stack+2796587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+8291201,int_stack+8242061, 0.0, zero_stack, 1.0, int_stack+3892350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8148331,int_stack+8023570,int_stack+8094823, 0.0, zero_stack, 1.0, int_stack+3941490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (op|ii) ---*/
   hrr1_build_op(Libderiv->AB,int_stack+8219675,int_stack+8148331,int_stack+3086815,784);
 /*--- compute (nd|ii) ---*/
   hrr1_build_nd(Libderiv->AB,int_stack+8403131,int_stack+8219675,int_stack+80550,784);
 /*--- compute (mf|ii) ---*/
   hrr1_build_mf(Libderiv->AB,int_stack+9651154,int_stack+8403131,int_stack+3531092,784);
 /*--- compute (lg|ii) ---*/
   hrr1_build_lg(Libderiv->AB,int_stack+8023570,int_stack+9651154,int_stack+3147967,784);
 /*--- compute (kh|ii) ---*/
   hrr1_build_kh(Libderiv->AB,int_stack+3086815,int_stack+8023570,int_stack+235782,784);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8023570,int_stack+796789,int_stack+796005, 1.0, int_stack+1301636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8025922,int_stack+797797,int_stack+796789, 1.0, int_stack+1302420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8028946,int_stack+8025922,int_stack+8023570, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8033650,int_stack+799057,int_stack+797797, 1.0, int_stack+1303428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8037430,int_stack+8033650,int_stack+8025922, 1.0, int_stack+1586081, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+8043478,int_stack+8037430,int_stack+8028946, 1.0, int_stack+1589105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1583729,int_stack+800597,int_stack+799057, 1.0, int_stack+1304688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+8023570,int_stack+1583729,int_stack+8033650, 1.0, int_stack+1593809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8051318,int_stack+8023570,int_stack+8037430, 1.0, int_stack+1597589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1588349,int_stack+8051318,int_stack+8043478, 1.0, int_stack+1603637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1600109,int_stack+802445,int_stack+800597, 1.0, int_stack+1306228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+8031130,int_stack+1600109,int_stack+1583729, 1.0, int_stack+1611477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8061398,int_stack+8031130,int_stack+8023570, 1.0, int_stack+1616097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1605653,int_stack+8061398,int_stack+8051318, 1.0, int_stack+1623657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+8040370,int_stack+1605653,int_stack+1588349, 1.0, int_stack+1633737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+804629,int_stack+802445, 1.0, int_stack+1308076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1583729,int_stack+8023570,int_stack+1600109, 1.0, int_stack+1645497, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1620773,int_stack+1583729,int_stack+8031130, 1.0, int_stack+1651041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1583729,int_stack+1620773,int_stack+8061398, 1.0, int_stack+1660281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1620773,int_stack+1583729,int_stack+1605653, 1.0, int_stack+1672881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+7079634,int_stack+1620773,int_stack+8040370, 1.0, int_stack+1688001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1583729,int_stack+808185,int_stack+807177, 1.0, int_stack+1323980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1586753,int_stack+809481,int_stack+808185, 1.0, int_stack+1324988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1590641,int_stack+1586753,int_stack+1583729, 1.0, int_stack+1704465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1596689,int_stack+811101,int_stack+809481, 1.0, int_stack+1326284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1601549,int_stack+1596689,int_stack+1586753, 1.0, int_stack+1707489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1609325,int_stack+1601549,int_stack+1590641, 1.0, int_stack+1711377, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1704465,int_stack+813081,int_stack+811101, 1.0, int_stack+1327904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1583729,int_stack+1704465,int_stack+1596689, 1.0, int_stack+1717425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1619405,int_stack+1583729,int_stack+1601549, 1.0, int_stack+1722285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1710405,int_stack+1619405,int_stack+1609325, 1.0, int_stack+1730061, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1725525,int_stack+815457,int_stack+813081, 1.0, int_stack+1329884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1593449,int_stack+1725525,int_stack+1704465, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8023570,int_stack+1593449,int_stack+1583729, 1.0, int_stack+1764805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+8039770,int_stack+8023570,int_stack+1619405, 1.0, int_stack+1774525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1605329,int_stack+8039770,int_stack+1710405, 1.0, int_stack+1787485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1583729,int_stack+818265,int_stack+815457, 1.0, int_stack+1332260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1704465,int_stack+1583729,int_stack+1725525, 1.0, int_stack+1802605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1718721,int_stack+1704465,int_stack+1593449, 1.0, int_stack+1809733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+8059210,int_stack+1718721,int_stack+8023570, 1.0, int_stack+1821613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1704465,int_stack+8059210,int_stack+8039770, 1.0, int_stack+1837813, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8023570,int_stack+1704465,int_stack+1605329, 1.0, int_stack+1857253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+8051794,int_stack+8023570,int_stack+7079634,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7079634,int_stack+822801,int_stack+821541, 1.0, int_stack+1352708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7083414,int_stack+824421,int_stack+822801, 1.0, int_stack+1353968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7088274,int_stack+7083414,int_stack+7079634, 1.0, int_stack+5940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1704465,int_stack+826446,int_stack+824421, 1.0, int_stack+1355588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+0,int_stack+1704465,int_stack+7083414, 1.0, int_stack+9720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1710540,int_stack+0,int_stack+7088274, 1.0, int_stack+14580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+9720,int_stack+828921,int_stack+826446, 1.0, int_stack+1357613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+7079634,int_stack+9720,int_stack+1704465, 1.0, int_stack+1972501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1723140,int_stack+7079634,int_stack+0, 1.0, int_stack+1978576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+8117650,int_stack+1723140,int_stack+1710540, 1.0, int_stack+1988296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+0,int_stack+831891,int_stack+828921, 1.0, int_stack+1360088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1704465,int_stack+0,int_stack+9720, 1.0, int_stack+2000896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8136550,int_stack+1704465,int_stack+7079634, 1.0, int_stack+1740141, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+8156800,int_stack+8136550,int_stack+1723140, 1.0, int_stack+2008321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1719315,int_stack+8156800,int_stack+8117650, 1.0, int_stack+2024521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8117650,int_stack+835401,int_stack+831891, 1.0, int_stack+1363058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+7079634,int_stack+8117650,int_stack+0, 1.0, int_stack+1752291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+8181100,int_stack+7079634,int_stack+1704465, 1.0, int_stack+2043421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+8205850,int_stack+8181100,int_stack+8136550, 1.0, int_stack+2058271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+8117650,int_stack+8205850,int_stack+8156800, 1.0, int_stack+2078521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8151670,int_stack+8117650,int_stack+1719315, 1.0, int_stack+2102821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+8186950,int_stack+8151670,int_stack+8023570,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+8271622,int_stack+8186950,int_stack+8051794,784);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8023570,int_stack+841036,int_stack+839496, 1.0, int_stack+1388618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8028190,int_stack+843016,int_stack+841036, 1.0, int_stack+1390158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8034130,int_stack+8028190,int_stack+8023570, 1.0, int_stack+1878421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+8043370,int_stack+845491,int_stack+843016, 1.0, int_stack+1392138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8050795,int_stack+8043370,int_stack+8028190, 1.0, int_stack+1883041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+8062675,int_stack+8050795,int_stack+8034130, 1.0, int_stack+1888981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1878421,int_stack+848516,int_stack+845491, 1.0, int_stack+1394613, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+8023570,int_stack+1878421,int_stack+8043370, 1.0, int_stack+1898221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8078075,int_stack+8023570,int_stack+8050795, 1.0, int_stack+1905646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1887496,int_stack+8078075,int_stack+8062675, 1.0, int_stack+1917526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1910596,int_stack+852146,int_stack+848516, 1.0, int_stack+1397638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+8038420,int_stack+1910596,int_stack+1878421, 1.0, int_stack+1932926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8097875,int_stack+8038420,int_stack+8023570, 1.0, int_stack+1942001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1921486,int_stack+8097875,int_stack+8078075, 1.0, int_stack+22140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+8056570,int_stack+1921486,int_stack+1887496, 1.0, int_stack+2380945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+856436,int_stack+852146, 1.0, int_stack+1401268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1878421,int_stack+8023570,int_stack+1910596, 1.0, int_stack+1956851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1704465,int_stack+1878421,int_stack+8038420, 1.0, int_stack+2404045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1878421,int_stack+1704465,int_stack+8097875, 1.0, int_stack+2422195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1704465,int_stack+1878421,int_stack+1921486, 1.0, int_stack+2446945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1878421,int_stack+1704465,int_stack+8056570, 1.0, int_stack+2476645, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+8023570,int_stack+1878421,int_stack+8151670,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+8403334,int_stack+8023570,int_stack+8186950,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+9651154,int_stack+8403334,int_stack+8271622,784);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1704465,int_stack+863289,int_stack+861441, 1.0, int_stack+1432508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1710009,int_stack+865665,int_stack+863289, 1.0, int_stack+1434356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1717137,int_stack+1710009,int_stack+1704465, 1.0, int_stack+2129281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1728225,int_stack+868635,int_stack+865665, 1.0, int_stack+1436732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1737135,int_stack+1728225,int_stack+1710009, 1.0, int_stack+2134825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1921541,int_stack+1737135,int_stack+1717137, 1.0, int_stack+2141953, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2129281,int_stack+872265,int_stack+868635, 1.0, int_stack+1439702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1704465,int_stack+2129281,int_stack+1728225, 1.0, int_stack+2153041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+8129410,int_stack+1704465,int_stack+1737135, 1.0, int_stack+2161951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2140171,int_stack+8129410,int_stack+1921541, 1.0, int_stack+2176207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1921541,int_stack+876621,int_stack+872265, 1.0, int_stack+1443332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1934609,int_stack+1921541,int_stack+2129281, 1.0, int_stack+2194687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+2167891,int_stack+1934609,int_stack+1704465, 1.0, int_stack+2205577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1704465,int_stack+2167891,int_stack+8129410, 1.0, int_stack+2223397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+8129410,int_stack+1704465,int_stack+2140171, 1.0, int_stack+2247157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8168218,int_stack+881769,int_stack+876621, 1.0, int_stack+1447688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+8183662,int_stack+8168218,int_stack+1921541, 1.0, int_stack+2274877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+8209798,int_stack+8183662,int_stack+1934609, 1.0, int_stack+2287945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+8246098,int_stack+8209798,int_stack+2167891, 1.0, int_stack+2309725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+8168218,int_stack+8246098,int_stack+1704465, 1.0, int_stack+2339425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8218114,int_stack+8168218,int_stack+8129410, 1.0, int_stack+2508985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+8269858,int_stack+8218114,int_stack+1878421,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+9870674,int_stack+8269858,int_stack+8023570,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+80550,int_stack+9870674,int_stack+8403334,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+8399218,int_stack+80550,int_stack+9651154,784);
 /*--- compute (o0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9651154,int_stack+889959,int_stack+887775, 1.0, int_stack+1485176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9657706,int_stack+892767,int_stack+889959, 1.0, int_stack+1487360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9666130,int_stack+9657706,int_stack+9651154, 1.0, int_stack+41940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9679234,int_stack+896277,int_stack+892767, 1.0, int_stack+1490168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9689764,int_stack+9679234,int_stack+9657706, 1.0, int_stack+48492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9706612,int_stack+9689764,int_stack+9666130, 1.0, int_stack+56916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+9651154,int_stack+900567,int_stack+896277, 1.0, int_stack+1493678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+9728452,int_stack+9651154,int_stack+9679234, 1.0, int_stack+70020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+9749512,int_stack+9728452,int_stack+9689764, 1.0, int_stack+2877073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+9664024,int_stack+9749512,int_stack+9706612, 1.0, int_stack+2893921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9696784,int_stack+905715,int_stack+900567, 1.0, int_stack+1497968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+9777592,int_stack+9696784,int_stack+9651154, 1.0, int_stack+2915761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+9803332,int_stack+9777592,int_stack+9728452, 1.0, int_stack+2928631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+8023570,int_stack+9803332,int_stack+9749512, 1.0, int_stack+2949691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+9712228,int_stack+8023570,int_stack+9664024, 1.0, int_stack+2977771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+9651154,int_stack+911799,int_stack+905715, 1.0, int_stack+1503116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+9838432,int_stack+9651154,int_stack+9696784, 1.0, int_stack+3010531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+9651154,int_stack+9838432,int_stack+9777592, 1.0, int_stack+3025975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+8065690,int_stack+9651154,int_stack+9803332, 1.0, int_stack+3051715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+9651154,int_stack+8065690,int_stack+8023570, 1.0, int_stack+3804366, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (o0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+8023570,int_stack+9651154,int_stack+9712228, 1.0, int_stack+3846486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+9651154,int_stack+8023570,int_stack+8218114,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+362790,int_stack+9651154,int_stack+8269858,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+10082354,int_stack+362790,int_stack+9870674,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+10435154,int_stack+10082354,int_stack+80550,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+10858514,int_stack+10435154,int_stack+8399218,784);
 /*--- compute (q0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9806386,int_stack+927269,int_stack+921445, 1.0, int_stack+918897, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+9814030,int_stack+934640,int_stack+927269, 1.0, int_stack+923993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9823858,int_stack+9814030,int_stack+9806386, 1.0, int_stack+2547793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9839146,int_stack+943740,int_stack+934640, 1.0, int_stack+930545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+9851431,int_stack+9839146,int_stack+9814030, 1.0, int_stack+2555437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9871087,int_stack+9851431,int_stack+9823858, 1.0, int_stack+2565265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2547793,int_stack+954751,int_stack+943740, 1.0, int_stack+938735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+9806386,int_stack+2547793,int_stack+9839146, 1.0, int_stack+2580553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+9896567,int_stack+9806386,int_stack+9851431, 1.0, int_stack+2592838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2562808,int_stack+9896567,int_stack+9871087, 1.0, int_stack+2612494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+2601028,int_stack+967855,int_stack+954751, 1.0, int_stack+948745, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+9830956,int_stack+2601028,int_stack+2547793, 1.0, int_stack+2637974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+9929327,int_stack+9830956,int_stack+9806386, 1.0, int_stack+2652989, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+2619046,int_stack+9929327,int_stack+9896567, 1.0, int_stack+2677559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+9860986,int_stack+2619046,int_stack+2562808, 1.0, int_stack+2710319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+9806386,int_stack+974953,int_stack+967855, 1.0, int_stack+960757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+2547793,int_stack+9806386,int_stack+2601028, 1.0, int_stack+2748539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+2668186,int_stack+2547793,int_stack+9830956, 1.0, int_stack+2766557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+2547793,int_stack+2668186,int_stack+9929327, 1.0, int_stack+2796587, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+2668186,int_stack+2547793,int_stack+2619046, 1.0, int_stack+3892350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (q0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+2547793,int_stack+2668186,int_stack+9860986, 1.0, int_stack+3941490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,91);
 /*--- compute (op|ii) ---*/
   hrr1_build_op(Libderiv->AB,int_stack+2619137,int_stack+2547793,int_stack+8023570,784);
 /*--- compute (nd|ii) ---*/
   hrr1_build_nd(Libderiv->AB,int_stack+8023570,int_stack+2619137,int_stack+9651154,784);
 /*--- compute (mf|ii) ---*/
   hrr1_build_mf(Libderiv->AB,int_stack+9651154,int_stack+8023570,int_stack+362790,784);
 /*--- compute (lg|ii) ---*/
   hrr1_build_lg(Libderiv->AB,int_stack+8023570,int_stack+9651154,int_stack+10082354,784);
 /*--- compute (kh|ii) ---*/
   hrr1_build_kh(Libderiv->AB,int_stack+9651154,int_stack+8023570,int_stack+10435154,784);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+1310260,int_stack+1308076,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8030122,int_stack+8023570,int_stack+1645497,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8041210,int_stack+8030122,int_stack+1651041,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8056610,int_stack+8041210,int_stack+1660281,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+8056610,int_stack+1672881,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+7079634,int_stack+8023570,int_stack+1688001,28);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+1335068,int_stack+1332260,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8031994,int_stack+8023570,int_stack+1802605,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8046250,int_stack+8031994,int_stack+1809733,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8066050,int_stack+8046250,int_stack+1821613,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+8066050,int_stack+1837813,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+8050786,int_stack+8023570,int_stack+1857253,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+8079010,int_stack+8050786,int_stack+7079634,784);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8023570,int_stack+1366568,int_stack+1363058,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8144866,int_stack+8023570,int_stack+1752291,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8023570,int_stack+8144866,int_stack+2043421,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8144866,int_stack+8023570,int_stack+2058271,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8175241,int_stack+8144866,int_stack+2078521,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+8209261,int_stack+8175241,int_stack+2102821,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+8244541,int_stack+8209261,int_stack+8050786,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+8329213,int_stack+8244541,int_stack+8079010,784);
 /*--- compute (m0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8144866,int_stack+1405558,int_stack+1401268,55);
 /*--- compute (m0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8157736,int_stack+8144866,int_stack+1956851,55);
 /*--- compute (m0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8460925,int_stack+8157736,int_stack+2404045,55);
 /*--- compute (m0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8144866,int_stack+8460925,int_stack+2422195,55);
 /*--- compute (m0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8460925,int_stack+8144866,int_stack+2446945,55);
 /*--- compute (m0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+8144866,int_stack+8460925,int_stack+2476645,55);
 /*--- compute (lp|ii) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+8460925,int_stack+8144866,int_stack+8209261,784);
 /*--- compute (kd|ii) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+10243858,int_stack+8460925,int_stack+8244541,784);
 /*--- compute (if|ii) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+10413202,int_stack+10243858,int_stack+8329213,784);
 /*--- compute (n0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8566765,int_stack+1452836,int_stack+1447688,66);
 /*--- compute (n0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8582209,int_stack+8566765,int_stack+2274877,66);
 /*--- compute (n0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8608345,int_stack+8582209,int_stack+2287945,66);
 /*--- compute (n0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8644645,int_stack+8608345,int_stack+2309725,66);
 /*--- compute (n0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8566765,int_stack+8644645,int_stack+2339425,66);
 /*--- compute (n0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+8616661,int_stack+8566765,int_stack+2508985,66);
 /*--- compute (mp|ii) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+10632722,int_stack+8616661,int_stack+8144866,784);
 /*--- compute (ld|ii) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+0,int_stack+10632722,int_stack+8460925,784);
 /*--- compute (kf|ii) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+211680,int_stack+0,int_stack+10243858,784);
 /*--- compute (ig|ii) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+493920,int_stack+211680,int_stack+10413202,784);
 /*--- compute (o0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8566765,int_stack+1509200,int_stack+1503116,78);
 /*--- compute (o0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8585017,int_stack+8566765,int_stack+3010531,78);
 /*--- compute (o0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8668405,int_stack+8585017,int_stack+3025975,78);
 /*--- compute (o0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+10762082,int_stack+8668405,int_stack+3051715,78);
 /*--- compute (o0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8668405,int_stack+10762082,int_stack+3804366,78);
 /*--- compute (o0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+10762082,int_stack+8668405,int_stack+3846486,78);
 /*--- compute (np|ii) ---*/
   hrr1_build_np(Libderiv->AB,int_stack+823200,int_stack+10762082,int_stack+8616661,784);
 /*--- compute (md|ii) ---*/
   hrr1_build_md(Libderiv->AB,int_stack+1583729,int_stack+823200,int_stack+10632722,784);
 /*--- compute (lf|ii) ---*/
   hrr1_build_lf(Libderiv->AB,int_stack+1842449,int_stack+1583729,int_stack+0,784);
 /*--- compute (kg|ii) ---*/
   hrr1_build_kg(Libderiv->AB,int_stack+2195249,int_stack+1842449,int_stack+211680,784);
 /*--- compute (ih|ii) ---*/
   hrr1_build_ih(Libderiv->AB,int_stack+2618609,int_stack+2195249,int_stack+493920,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8668405,int_stack+984018,int_stack+983234,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+8670757,int_stack+985026,int_stack+984018,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8673781,int_stack+8670757,int_stack+8668405,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+8678485,int_stack+986286,int_stack+985026,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+8682265,int_stack+8678485,int_stack+8670757,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+8688313,int_stack+8682265,int_stack+8673781,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+8668405,int_stack+987826,int_stack+986286,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+8696153,int_stack+8668405,int_stack+8678485,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+8703713,int_stack+8696153,int_stack+8682265,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+8673025,int_stack+8703713,int_stack+8688313,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+8684785,int_stack+989674,int_stack+987826,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+8713793,int_stack+8684785,int_stack+8668405,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+10823234,int_stack+8713793,int_stack+8696153,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+10835834,int_stack+10823234,int_stack+8703713,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+8690329,int_stack+10835834,int_stack+8673025,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8668405,int_stack+991858,int_stack+989674,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8566765,int_stack+8668405,int_stack+8684785,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8668405,int_stack+8566765,int_stack+8713793,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8566765,int_stack+8668405,int_stack+10823234,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8668405,int_stack+8566765,int_stack+10835834,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+8566765,int_stack+8668405,int_stack+8690329,28);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8668405,int_stack+995414,int_stack+994406,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+8671429,int_stack+996710,int_stack+995414,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8675317,int_stack+8671429,int_stack+8668405,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+8681365,int_stack+998330,int_stack+996710,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+8686225,int_stack+8681365,int_stack+8671429,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+8694001,int_stack+8686225,int_stack+8675317,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+8668405,int_stack+1000310,int_stack+998330,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+8704081,int_stack+8668405,int_stack+8681365,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+8713801,int_stack+8704081,int_stack+8686225,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+8674345,int_stack+8713801,int_stack+8694001,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+8689465,int_stack+1002686,int_stack+1000310,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+8588717,int_stack+8689465,int_stack+8668405,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+10823234,int_stack+8588717,int_stack+8704081,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+8187986,int_stack+10823234,int_stack+8713801,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+8696593,int_stack+8187986,int_stack+8674345,36);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8668405,int_stack+1005494,int_stack+1002686,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8600597,int_stack+8668405,int_stack+8689465,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8668405,int_stack+8600597,int_stack+8588717,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8588717,int_stack+8668405,int_stack+10823234,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+8588717,int_stack+8187986,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+10823234,int_stack+8023570,int_stack+8696593,36);
 /*--- compute (ip|ii) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+3679519,int_stack+10823234,int_stack+8566765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7079634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8566765,int_stack+1010030,int_stack+1008770,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+8570545,int_stack+1011650,int_stack+1010030,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8575405,int_stack+8570545,int_stack+8566765,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+8582965,int_stack+1013675,int_stack+1011650,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+8589040,int_stack+8582965,int_stack+8570545,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+8598760,int_stack+8589040,int_stack+8575405,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+8566765,int_stack+1016150,int_stack+1013675,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+8023570,int_stack+8566765,int_stack+8582965,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+8187986,int_stack+8023570,int_stack+8589040,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+8574190,int_stack+8187986,int_stack+8598760,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+8593090,int_stack+1019120,int_stack+1016150,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+8035720,int_stack+8593090,int_stack+8566765,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+8668405,int_stack+8035720,int_stack+8023570,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+8688655,int_stack+8668405,int_stack+8187986,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1485176,int_stack+8688655,int_stack+8574190,45);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+8187986,int_stack+1022630,int_stack+1019120,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8566765,int_stack+8187986,int_stack+8593090,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+8584585,int_stack+8566765,int_stack+8035720,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+978432,int_stack+8584585,int_stack+8668405,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8566765,int_stack+978432,int_stack+8688655,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+978432,int_stack+8566765,int_stack+1485176,45);
 /*--- compute (kp|ii) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+3745375,int_stack+978432,int_stack+10823234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8050786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (id|ii) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+3830047,int_stack+3745375,int_stack+3679519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8079010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3679519,int_stack+1028265,int_stack+1026725,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3684139,int_stack+1030245,int_stack+1028265,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3690079,int_stack+3684139,int_stack+3679519,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3699319,int_stack+1032720,int_stack+1030245,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3706744,int_stack+3699319,int_stack+3684139,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3718624,int_stack+3706744,int_stack+3690079,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3679519,int_stack+1035745,int_stack+1032720,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+10823234,int_stack+3679519,int_stack+3699319,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+10838084,int_stack+10823234,int_stack+3706744,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3688594,int_stack+10838084,int_stack+3718624,55);
 /*--- compute (m0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+3711694,int_stack+1039375,int_stack+1035745,55);
 /*--- compute (m0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+3722584,int_stack+3711694,int_stack+3679519,55);
 /*--- compute (m0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1485176,int_stack+3722584,int_stack+10823234,55);
 /*--- compute (m0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+8566765,int_stack+1485176,int_stack+10838084,55);
 /*--- compute (m0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+10823234,int_stack+8566765,int_stack+3688594,55);
 /*--- compute (m0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+3679519,int_stack+1043665,int_stack+1039375,55);
 /*--- compute (m0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1013712,int_stack+3679519,int_stack+3711694,55);
 /*--- compute (m0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+3679519,int_stack+1013712,int_stack+3722584,55);
 /*--- compute (m0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+8668405,int_stack+3679519,int_stack+1485176,55);
 /*--- compute (m0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+3679519,int_stack+8668405,int_stack+8566765,55);
 /*--- compute (m0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+8566765,int_stack+3679519,int_stack+10823234,55);
 /*--- compute (lp|ii) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+4587702,int_stack+8566765,int_stack+978432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8209261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kd|ii) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+11319506,int_stack+4587702,int_stack+3745375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8244541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (if|ii) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+11488850,int_stack+11319506,int_stack+3830047, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8329213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+978432,int_stack+1050518,int_stack+1048670,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+983976,int_stack+1052894,int_stack+1050518,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+991104,int_stack+983976,int_stack+978432,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1002192,int_stack+1055864,int_stack+1052894,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1011102,int_stack+1002192,int_stack+983976,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1025358,int_stack+1011102,int_stack+991104,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+978432,int_stack+1059494,int_stack+1055864,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+10823234,int_stack+978432,int_stack+1002192,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3679519,int_stack+10823234,int_stack+1011102,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+989322,int_stack+3679519,int_stack+1025358,66);
 /*--- compute (n0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1017042,int_stack+1063850,int_stack+1059494,66);
 /*--- compute (n0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1030110,int_stack+1017042,int_stack+978432,66);
 /*--- compute (n0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+3703279,int_stack+1030110,int_stack+10823234,66);
 /*--- compute (n0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+3732979,int_stack+3703279,int_stack+3679519,66);
 /*--- compute (n0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+3768619,int_stack+3732979,int_stack+989322,66);
 /*--- compute (n0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+3679519,int_stack+1068998,int_stack+1063850,66);
 /*--- compute (n0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+10823234,int_stack+3679519,int_stack+1017042,66);
 /*--- compute (n0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+978432,int_stack+10823234,int_stack+1030110,66);
 /*--- compute (n0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1014732,int_stack+978432,int_stack+3703279,66);
 /*--- compute (n0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+3679519,int_stack+1014732,int_stack+3732979,66);
 /*--- compute (n0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+978432,int_stack+3679519,int_stack+3768619,66);
 /*--- compute (mp|ii) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+3679519,int_stack+978432,int_stack+8566765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8144866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ld|ii) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+11708370,int_stack+3679519,int_stack+4587702, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8460925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kf|ii) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+11920050,int_stack+11708370,int_stack+11319506, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10243858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ig|ii) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+12202290,int_stack+11920050,int_stack+11488850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10413202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (o0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11319506,int_stack+1077188,int_stack+1075004,78);
 /*--- compute (o0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+11326058,int_stack+1079996,int_stack+1077188,78);
 /*--- compute (o0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+11334482,int_stack+11326058,int_stack+11319506,78);
 /*--- compute (o0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+11347586,int_stack+1083506,int_stack+1079996,78);
 /*--- compute (o0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+11358116,int_stack+11347586,int_stack+11326058,78);
 /*--- compute (o0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+11374964,int_stack+11358116,int_stack+11334482,78);
 /*--- compute (o0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+11319506,int_stack+1087796,int_stack+1083506,78);
 /*--- compute (o0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+11396804,int_stack+11319506,int_stack+11347586,78);
 /*--- compute (o0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+11417864,int_stack+11396804,int_stack+11358116,78);
 /*--- compute (o0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+11332376,int_stack+11417864,int_stack+11374964,78);
 /*--- compute (o0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+11365136,int_stack+1092944,int_stack+1087796,78);
 /*--- compute (o0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+11445944,int_stack+11365136,int_stack+11319506,78);
 /*--- compute (o0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+11471684,int_stack+11445944,int_stack+11396804,78);
 /*--- compute (o0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+11506784,int_stack+11471684,int_stack+11417864,78);
 /*--- compute (o0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+11380580,int_stack+11506784,int_stack+11332376,78);
 /*--- compute (o0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+11319506,int_stack+1099028,int_stack+1092944,78);
 /*--- compute (o0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+11548904,int_stack+11319506,int_stack+11365136,78);
 /*--- compute (o0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+11319506,int_stack+11548904,int_stack+11445944,78);
 /*--- compute (o0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+11548904,int_stack+11319506,int_stack+11471684,78);
 /*--- compute (o0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+11319506,int_stack+11548904,int_stack+11506784,78);
 /*--- compute (o0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+11426444,int_stack+11319506,int_stack+11380580,78);
 /*--- compute (np|ii) ---*/
   d1hrr1_build_np(Libderiv->AB,int_stack+11487596,int_stack+11426444,int_stack+978432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8616661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (md|ii) ---*/
   d1hrr1_build_md(Libderiv->AB,int_stack+12531570,int_stack+11487596,int_stack+3679519, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10632722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (lf|ii) ---*/
   d1hrr1_build_lf(Libderiv->AB,int_stack+12790290,int_stack+12531570,int_stack+11708370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kg|ii) ---*/
   d1hrr1_build_kg(Libderiv->AB,int_stack+13143090,int_stack+12790290,int_stack+11920050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ih|ii) ---*/
   d1hrr1_build_ih(Libderiv->AB,int_stack+11642828,int_stack+13143090,int_stack+12202290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+493920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (q0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3679519,int_stack+1108674,int_stack+1106126,91);
 /*--- compute (q0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3687163,int_stack+1111950,int_stack+1108674,91);
 /*--- compute (q0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3696991,int_stack+3687163,int_stack+3679519,91);
 /*--- compute (q0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3712279,int_stack+1116045,int_stack+1111950,91);
 /*--- compute (q0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3724564,int_stack+3712279,int_stack+3687163,91);
 /*--- compute (q0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3744220,int_stack+3724564,int_stack+3696991,91);
 /*--- compute (q0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3679519,int_stack+1121050,int_stack+1116045,91);
 /*--- compute (q0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3769700,int_stack+3679519,int_stack+3712279,91);
 /*--- compute (q0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3794270,int_stack+3769700,int_stack+3724564,91);
 /*--- compute (q0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3694534,int_stack+3794270,int_stack+3744220,91);
 /*--- compute (q0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+3732754,int_stack+1127056,int_stack+1121050,91);
 /*--- compute (q0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+3827030,int_stack+3732754,int_stack+3679519,91);
 /*--- compute (q0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+3857060,int_stack+3827030,int_stack+3769700,91);
 /*--- compute (q0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+3898010,int_stack+3857060,int_stack+3794270,91);
 /*--- compute (q0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+3750772,int_stack+3898010,int_stack+3694534,91);
 /*--- compute (q0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+3679519,int_stack+1134154,int_stack+1127056,91);
 /*--- compute (q0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+3947150,int_stack+3679519,int_stack+3732754,91);
 /*--- compute (q0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+3679519,int_stack+3947150,int_stack+3827030,91);
 /*--- compute (q0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+978432,int_stack+3679519,int_stack+3857060,91);
 /*--- compute (q0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+3679519,int_stack+978432,int_stack+3898010,91);
 /*--- compute (q0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+978432,int_stack+3679519,int_stack+3750772,91);
 /*--- compute (op|ii) ---*/
   d1hrr1_build_op(Libderiv->AB,int_stack+3679519,int_stack+978432,int_stack+11426444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10762082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (nd|ii) ---*/
   d1hrr1_build_nd(Libderiv->AB,int_stack+12103820,int_stack+3679519,int_stack+11487596, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (mf|ii) ---*/
   d1hrr1_build_mf(Libderiv->AB,int_stack+13566450,int_stack+12103820,int_stack+12531570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (lg|ii) ---*/
   d1hrr1_build_lg(Libderiv->AB,int_stack+12103820,int_stack+13566450,int_stack+12790290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1842449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kh|ii) ---*/
   d1hrr1_build_kh(Libderiv->AB,int_stack+13566450,int_stack+12103820,int_stack+13143090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2195249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1143219,int_stack+1142435,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12106172,int_stack+1144227,int_stack+1143219,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12109196,int_stack+12106172,int_stack+12103820,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12113900,int_stack+1145487,int_stack+1144227,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12117680,int_stack+12113900,int_stack+12106172,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12123728,int_stack+12117680,int_stack+12109196,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1147027,int_stack+1145487,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12131568,int_stack+12103820,int_stack+12113900,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12139128,int_stack+12131568,int_stack+12117680,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12108440,int_stack+12139128,int_stack+12123728,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12120200,int_stack+1148875,int_stack+1147027,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12149208,int_stack+12120200,int_stack+12103820,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12158448,int_stack+12149208,int_stack+12131568,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12171048,int_stack+12158448,int_stack+12139128,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12125744,int_stack+12171048,int_stack+12108440,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1151059,int_stack+1148875,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12186168,int_stack+12103820,int_stack+12120200,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12186168,int_stack+12149208,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12186168,int_stack+12103820,int_stack+12158448,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12103820,int_stack+12186168,int_stack+12171048,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12142208,int_stack+12103820,int_stack+12125744,28);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1154615,int_stack+1153607,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12106844,int_stack+1155911,int_stack+1154615,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12110732,int_stack+12106844,int_stack+12103820,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12116780,int_stack+1157531,int_stack+1155911,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12121640,int_stack+12116780,int_stack+12106844,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12129416,int_stack+12121640,int_stack+12110732,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1159511,int_stack+1157531,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12164160,int_stack+12103820,int_stack+12116780,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12173880,int_stack+12164160,int_stack+12121640,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12109760,int_stack+12173880,int_stack+12129416,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12124880,int_stack+1161887,int_stack+1159511,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12186840,int_stack+12124880,int_stack+12103820,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12198720,int_stack+12186840,int_stack+12164160,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12214920,int_stack+12198720,int_stack+12173880,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12164160,int_stack+12214920,int_stack+12109760,36);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1164695,int_stack+1161887,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12234360,int_stack+12103820,int_stack+12124880,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12234360,int_stack+12186840,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12234360,int_stack+12103820,int_stack+12198720,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+12234360,int_stack+12214920,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12103820,int_stack+8023570,int_stack+12164160,36);
 /*--- compute (ip|ii) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+12164160,int_stack+12103820,int_stack+12142208, 0.0, zero_stack, 1.0, int_stack+7079634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12230016,int_stack+1169231,int_stack+1167971,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12233796,int_stack+1170851,int_stack+1169231,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12238656,int_stack+12233796,int_stack+12230016,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12246216,int_stack+1172876,int_stack+1170851,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12252291,int_stack+12246216,int_stack+12233796,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12262011,int_stack+12252291,int_stack+12238656,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12230016,int_stack+1175351,int_stack+1172876,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12274611,int_stack+12230016,int_stack+12246216,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12286761,int_stack+12274611,int_stack+12252291,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12237441,int_stack+12286761,int_stack+12262011,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12256341,int_stack+1178321,int_stack+1175351,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12302961,int_stack+12256341,int_stack+12230016,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12317811,int_stack+12302961,int_stack+12274611,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12338061,int_stack+12317811,int_stack+12286761,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12265251,int_stack+12338061,int_stack+12237441,45);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12230016,int_stack+1181831,int_stack+1178321,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12362361,int_stack+12230016,int_stack+12256341,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12230016,int_stack+12362361,int_stack+12302961,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12362361,int_stack+12230016,int_stack+12317811,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12230016,int_stack+12362361,int_stack+12338061,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+10823234,int_stack+12230016,int_stack+12265251,45);
 /*--- compute (kp|ii) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+12230016,int_stack+10823234,int_stack+12103820, 0.0, zero_stack, 1.0, int_stack+8050786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (id|ii) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+12314688,int_stack+12230016,int_stack+12164160, 0.0, zero_stack, 1.0, int_stack+8079010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1187466,int_stack+1185926,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12108440,int_stack+1189446,int_stack+1187466,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12114380,int_stack+12108440,int_stack+12103820,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12123620,int_stack+1191921,int_stack+1189446,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12131045,int_stack+12123620,int_stack+12108440,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12142925,int_stack+12131045,int_stack+12114380,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1194946,int_stack+1191921,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12158325,int_stack+12103820,int_stack+12123620,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12173175,int_stack+12158325,int_stack+12131045,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12112895,int_stack+12173175,int_stack+12142925,55);
 /*--- compute (m0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12135995,int_stack+1198576,int_stack+1194946,55);
 /*--- compute (m0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12192975,int_stack+12135995,int_stack+12103820,55);
 /*--- compute (m0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12446400,int_stack+12192975,int_stack+12158325,55);
 /*--- compute (m0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12471150,int_stack+12446400,int_stack+12173175,55);
 /*--- compute (m0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12146885,int_stack+12471150,int_stack+12112895,55);
 /*--- compute (m0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1202866,int_stack+1198576,55);
 /*--- compute (m0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12500850,int_stack+12103820,int_stack+12135995,55);
 /*--- compute (m0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12500850,int_stack+12192975,55);
 /*--- compute (m0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12500850,int_stack+12103820,int_stack+12446400,55);
 /*--- compute (m0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12103820,int_stack+12500850,int_stack+12471150,55);
 /*--- compute (m0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12446400,int_stack+12103820,int_stack+12146885,55);
 /*--- compute (lp|ii) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+12103820,int_stack+12446400,int_stack+10823234, 0.0, zero_stack, 1.0, int_stack+8209261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kd|ii) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+12489520,int_stack+12103820,int_stack+12230016, 0.0, zero_stack, 1.0, int_stack+8244541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (if|ii) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+12658864,int_stack+12489520,int_stack+12314688, 0.0, zero_stack, 1.0, int_stack+8329213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10823234,int_stack+1209719,int_stack+1207871,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10828778,int_stack+1212095,int_stack+1209719,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+10835906,int_stack+10828778,int_stack+10823234,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10846994,int_stack+1215065,int_stack+1212095,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12209660,int_stack+10846994,int_stack+10828778,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12223916,int_stack+12209660,int_stack+10835906,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+10823234,int_stack+1218695,int_stack+1215065,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12242396,int_stack+10823234,int_stack+10846994,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+10834124,int_stack+12242396,int_stack+12209660,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12260216,int_stack+10834124,int_stack+12223916,66);
 /*--- compute (n0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12209660,int_stack+1223051,int_stack+1218695,66);
 /*--- compute (n0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12287936,int_stack+12209660,int_stack+10823234,66);
 /*--- compute (n0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12309716,int_stack+12287936,int_stack+12242396,66);
 /*--- compute (n0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12222728,int_stack+12309716,int_stack+10834124,66);
 /*--- compute (n0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12339416,int_stack+12222728,int_stack+12260216,66);
 /*--- compute (n0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+10823234,int_stack+1228199,int_stack+1223051,66);
 /*--- compute (n0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12258368,int_stack+10823234,int_stack+12209660,66);
 /*--- compute (n0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12378224,int_stack+12258368,int_stack+12287936,66);
 /*--- compute (n0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12258368,int_stack+12378224,int_stack+12309716,66);
 /*--- compute (n0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8566765,int_stack+12258368,int_stack+12222728,66);
 /*--- compute (n0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12378224,int_stack+8566765,int_stack+12339416,66);
 /*--- compute (mp|ii) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+12209660,int_stack+12378224,int_stack+12446400, 0.0, zero_stack, 1.0, int_stack+8144866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ld|ii) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+12878384,int_stack+12209660,int_stack+12103820, 0.0, zero_stack, 1.0, int_stack+8460925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kf|ii) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+13090064,int_stack+12878384,int_stack+12489520, 0.0, zero_stack, 1.0, int_stack+10243858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ig|ii) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+14159154,int_stack+13090064,int_stack+12658864, 0.0, zero_stack, 1.0, int_stack+10413202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (o0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1236389,int_stack+1234205,78);
 /*--- compute (o0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12110372,int_stack+1239197,int_stack+1236389,78);
 /*--- compute (o0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12118796,int_stack+12110372,int_stack+12103820,78);
 /*--- compute (o0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12131900,int_stack+1242707,int_stack+1239197,78);
 /*--- compute (o0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12142430,int_stack+12131900,int_stack+12110372,78);
 /*--- compute (o0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12159278,int_stack+12142430,int_stack+12118796,78);
 /*--- compute (o0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1246997,int_stack+1242707,78);
 /*--- compute (o0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12181118,int_stack+12103820,int_stack+12131900,78);
 /*--- compute (o0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+8566765,int_stack+12181118,int_stack+12142430,78);
 /*--- compute (o0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12116690,int_stack+8566765,int_stack+12159278,78);
 /*--- compute (o0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12149450,int_stack+1252145,int_stack+1246997,78);
 /*--- compute (o0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12429968,int_stack+12149450,int_stack+12103820,78);
 /*--- compute (o0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12455708,int_stack+12429968,int_stack+12181118,78);
 /*--- compute (o0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12164894,int_stack+12455708,int_stack+8566765,78);
 /*--- compute (o0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+8566765,int_stack+12164894,int_stack+12116690,78);
 /*--- compute (o0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1258229,int_stack+1252145,78);
 /*--- compute (o0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12490808,int_stack+12103820,int_stack+12149450,78);
 /*--- compute (o0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12490808,int_stack+12429968,78);
 /*--- compute (o0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12490808,int_stack+12103820,int_stack+12455708,78);
 /*--- compute (o0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12103820,int_stack+12490808,int_stack+12164894,78);
 /*--- compute (o0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12429968,int_stack+12103820,int_stack+8566765,78);
 /*--- compute (np|ii) ---*/
   d1hrr1_build_np(Libderiv->AB,int_stack+12491120,int_stack+12429968,int_stack+12378224, 0.0, zero_stack, 1.0, int_stack+8616661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (md|ii) ---*/
   d1hrr1_build_md(Libderiv->AB,int_stack+3679519,int_stack+12491120,int_stack+12209660, 0.0, zero_stack, 1.0, int_stack+10632722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (lf|ii) ---*/
   d1hrr1_build_lf(Libderiv->AB,int_stack+14488434,int_stack+3679519,int_stack+12878384, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kg|ii) ---*/
   d1hrr1_build_kg(Libderiv->AB,int_stack+12646352,int_stack+14488434,int_stack+13090064, 0.0, zero_stack, 1.0, int_stack+211680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ih|ii) ---*/
   d1hrr1_build_ih(Libderiv->AB,int_stack+13069712,int_stack+12646352,int_stack+14159154, 0.0, zero_stack, 1.0, int_stack+493920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (q0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14159154,int_stack+1267875,int_stack+1265327,91);
 /*--- compute (q0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14166798,int_stack+1271151,int_stack+1267875,91);
 /*--- compute (q0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14176626,int_stack+14166798,int_stack+14159154,91);
 /*--- compute (q0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+14191914,int_stack+1275246,int_stack+1271151,91);
 /*--- compute (q0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+14204199,int_stack+14191914,int_stack+14166798,91);
 /*--- compute (q0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+14223855,int_stack+14204199,int_stack+14176626,91);
 /*--- compute (q0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+14159154,int_stack+1280251,int_stack+1275246,91);
 /*--- compute (q0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+14249335,int_stack+14159154,int_stack+14191914,91);
 /*--- compute (q0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+14273905,int_stack+14249335,int_stack+14204199,91);
 /*--- compute (q0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+14174169,int_stack+14273905,int_stack+14223855,91);
 /*--- compute (q0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+14212389,int_stack+1286257,int_stack+1280251,91);
 /*--- compute (q0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+14306665,int_stack+14212389,int_stack+14159154,91);
 /*--- compute (q0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+14336695,int_stack+14306665,int_stack+14249335,91);
 /*--- compute (q0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+14377645,int_stack+14336695,int_stack+14273905,91);
 /*--- compute (q0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+14230407,int_stack+14377645,int_stack+14174169,91);
 /*--- compute (q0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+14159154,int_stack+1293355,int_stack+1286257,91);
 /*--- compute (q0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+14426785,int_stack+14159154,int_stack+14212389,91);
 /*--- compute (q0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+14159154,int_stack+14426785,int_stack+14306665,91);
 /*--- compute (q0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+14426785,int_stack+14159154,int_stack+14336695,91);
 /*--- compute (q0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+14159154,int_stack+14426785,int_stack+14377645,91);
 /*--- compute (q0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+14283915,int_stack+14159154,int_stack+14230407,91);
 /*--- compute (op|ii) ---*/
   d1hrr1_build_op(Libderiv->AB,int_stack+12103820,int_stack+14283915,int_stack+12429968, 0.0, zero_stack, 1.0, int_stack+10762082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (nd|ii) ---*/
   d1hrr1_build_nd(Libderiv->AB,int_stack+14159154,int_stack+12103820,int_stack+12491120, 0.0, zero_stack, 1.0, int_stack+823200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (mf|ii) ---*/
   d1hrr1_build_mf(Libderiv->AB,int_stack+12103820,int_stack+14159154,int_stack+3679519, 0.0, zero_stack, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (lg|ii) ---*/
   d1hrr1_build_lg(Libderiv->AB,int_stack+14841234,int_stack+12103820,int_stack+14488434, 0.0, zero_stack, 1.0, int_stack+1842449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kh|ii) ---*/
   d1hrr1_build_kh(Libderiv->AB,int_stack+14159154,int_stack+14841234,int_stack+12646352, 0.0, zero_stack, 1.0, int_stack+2195249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1313592,int_stack+1312808,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12106172,int_stack+1314600,int_stack+1313592,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12109196,int_stack+12106172,int_stack+12103820,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12113900,int_stack+1315860,int_stack+1314600,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12117680,int_stack+12113900,int_stack+12106172,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12123728,int_stack+12117680,int_stack+12109196,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1317400,int_stack+1315860,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12131568,int_stack+12103820,int_stack+12113900,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12139128,int_stack+12131568,int_stack+12117680,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12108440,int_stack+12139128,int_stack+12123728,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12120200,int_stack+1319248,int_stack+1317400,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12149208,int_stack+12120200,int_stack+12103820,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12158448,int_stack+12149208,int_stack+12131568,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12171048,int_stack+12158448,int_stack+12139128,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12125744,int_stack+12171048,int_stack+12108440,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1321432,int_stack+1319248,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12186168,int_stack+12103820,int_stack+12120200,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12186168,int_stack+12149208,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12186168,int_stack+12103820,int_stack+12158448,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12103820,int_stack+12186168,int_stack+12171048,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12142208,int_stack+12103820,int_stack+12125744,28);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1339352,int_stack+1338344,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12106844,int_stack+1340648,int_stack+1339352,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12110732,int_stack+12106844,int_stack+12103820,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12116780,int_stack+1342268,int_stack+1340648,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12121640,int_stack+12116780,int_stack+12106844,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12129416,int_stack+12121640,int_stack+12110732,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1344248,int_stack+1342268,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12164160,int_stack+12103820,int_stack+12116780,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12173880,int_stack+12164160,int_stack+12121640,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12109760,int_stack+12173880,int_stack+12129416,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12124880,int_stack+1346624,int_stack+1344248,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12186840,int_stack+12124880,int_stack+12103820,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12198720,int_stack+12186840,int_stack+12164160,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12214920,int_stack+12198720,int_stack+12173880,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12164160,int_stack+12214920,int_stack+12109760,36);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1349432,int_stack+1346624,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12234360,int_stack+12103820,int_stack+12124880,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12234360,int_stack+12186840,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12234360,int_stack+12103820,int_stack+12198720,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8023570,int_stack+12234360,int_stack+12214920,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12103820,int_stack+8023570,int_stack+12164160,36);
 /*--- compute (ip|ii) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+12164160,int_stack+12103820,int_stack+12142208, 1.0, int_stack+7079634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7079634,int_stack+1371923,int_stack+1370663,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7083414,int_stack+1373543,int_stack+1371923,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7088274,int_stack+7083414,int_stack+7079634,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12230016,int_stack+1375568,int_stack+1373543,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12236091,int_stack+12230016,int_stack+7083414,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12245811,int_stack+12236091,int_stack+7088274,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+7079634,int_stack+1378043,int_stack+1375568,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+7087059,int_stack+7079634,int_stack+12230016,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12258411,int_stack+7087059,int_stack+12236091,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12274611,int_stack+12258411,int_stack+12245811,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12230016,int_stack+1381013,int_stack+1378043,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12238926,int_stack+12230016,int_stack+7079634,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12293511,int_stack+12238926,int_stack+7087059,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12313761,int_stack+12293511,int_stack+12258411,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12338061,int_stack+12313761,int_stack+12274611,45);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+7079634,int_stack+1384523,int_stack+1381013,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12253776,int_stack+7079634,int_stack+12230016,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12364521,int_stack+12253776,int_stack+12238926,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12230016,int_stack+12364521,int_stack+12293511,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12364521,int_stack+12230016,int_stack+12313761,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+10823234,int_stack+12364521,int_stack+12338061,45);
 /*--- compute (kp|ii) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+12230016,int_stack+10823234,int_stack+12103820, 1.0, int_stack+8050786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (id|ii) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+12314688,int_stack+12230016,int_stack+12164160, 1.0, int_stack+8079010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12103820,int_stack+1412103,int_stack+1410563,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12108440,int_stack+1414083,int_stack+1412103,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12114380,int_stack+12108440,int_stack+12103820,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12123620,int_stack+1416558,int_stack+1414083,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12131045,int_stack+12123620,int_stack+12108440,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12142925,int_stack+12131045,int_stack+12114380,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+12103820,int_stack+1419583,int_stack+1416558,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12158325,int_stack+12103820,int_stack+12123620,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+12173175,int_stack+12158325,int_stack+12131045,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12112895,int_stack+12173175,int_stack+12142925,55);
 /*--- compute (m0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12135995,int_stack+1423213,int_stack+1419583,55);
 /*--- compute (m0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12192975,int_stack+12135995,int_stack+12103820,55);
 /*--- compute (m0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12446400,int_stack+12192975,int_stack+12158325,55);
 /*--- compute (m0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12471150,int_stack+12446400,int_stack+12173175,55);
 /*--- compute (m0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12146885,int_stack+12471150,int_stack+12112895,55);
 /*--- compute (m0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+12103820,int_stack+1427503,int_stack+1423213,55);
 /*--- compute (m0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12500850,int_stack+12103820,int_stack+12135995,55);
 /*--- compute (m0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12103820,int_stack+12500850,int_stack+12192975,55);
 /*--- compute (m0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12500850,int_stack+12103820,int_stack+12446400,55);
 /*--- compute (m0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+12103820,int_stack+12500850,int_stack+12471150,55);
 /*--- compute (m0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12446400,int_stack+12103820,int_stack+12146885,55);
 /*--- compute (lp|ii) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+12103820,int_stack+12446400,int_stack+10823234, 1.0, int_stack+8209261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kd|ii) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+12489520,int_stack+12103820,int_stack+12230016, 1.0, int_stack+8244541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (if|ii) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+12658864,int_stack+12489520,int_stack+12314688, 1.0, int_stack+8329213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10823234,int_stack+1460690,int_stack+1458842,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10828778,int_stack+1463066,int_stack+1460690,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+10835906,int_stack+10828778,int_stack+10823234,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10846994,int_stack+1466036,int_stack+1463066,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12209660,int_stack+10846994,int_stack+10828778,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+12223916,int_stack+12209660,int_stack+10835906,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+10823234,int_stack+1469666,int_stack+1466036,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12242396,int_stack+10823234,int_stack+10846994,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+10834124,int_stack+12242396,int_stack+12209660,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+12260216,int_stack+10834124,int_stack+12223916,66);
 /*--- compute (n0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+12209660,int_stack+1474022,int_stack+1469666,66);
 /*--- compute (n0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+12287936,int_stack+12209660,int_stack+10823234,66);
 /*--- compute (n0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+12309716,int_stack+12287936,int_stack+12242396,66);
 /*--- compute (n0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+12222728,int_stack+12309716,int_stack+10834124,66);
 /*--- compute (n0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12339416,int_stack+12222728,int_stack+12260216,66);
 /*--- compute (n0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+10823234,int_stack+1479170,int_stack+1474022,66);
 /*--- compute (n0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+12258368,int_stack+10823234,int_stack+12209660,66);
 /*--- compute (n0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+12378224,int_stack+12258368,int_stack+12287936,66);
 /*--- compute (n0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+12258368,int_stack+12378224,int_stack+12309716,66);
 /*--- compute (n0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8566765,int_stack+12258368,int_stack+12222728,66);
 /*--- compute (n0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+12378224,int_stack+8566765,int_stack+12339416,66);
 /*--- compute (mp|ii) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+12209660,int_stack+12378224,int_stack+12446400, 1.0, int_stack+8144866, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ld|ii) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+8023570,int_stack+12209660,int_stack+12103820, 1.0, int_stack+8460925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kf|ii) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+8235250,int_stack+8023570,int_stack+12489520, 1.0, int_stack+10243858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ig|ii) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+14751858,int_stack+8235250,int_stack+12658864, 1.0, int_stack+10413202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (o0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+10243858,int_stack+1518482,int_stack+1516298,78);
 /*--- compute (o0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+10250410,int_stack+1521290,int_stack+1518482,78);
 /*--- compute (o0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+10258834,int_stack+10250410,int_stack+10243858,78);
 /*--- compute (o0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+10271938,int_stack+1524800,int_stack+1521290,78);
 /*--- compute (o0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+10282468,int_stack+10271938,int_stack+10250410,78);
 /*--- compute (o0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+10299316,int_stack+10282468,int_stack+10258834,78);
 /*--- compute (o0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+10243858,int_stack+1529090,int_stack+1524800,78);
 /*--- compute (o0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+10321156,int_stack+10243858,int_stack+10271938,78);
 /*--- compute (o0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+10342216,int_stack+10321156,int_stack+10282468,78);
 /*--- compute (o0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+10256728,int_stack+10342216,int_stack+10299316,78);
 /*--- compute (o0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+10289488,int_stack+1534238,int_stack+1529090,78);
 /*--- compute (o0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+10370296,int_stack+10289488,int_stack+10243858,78);
 /*--- compute (o0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+10396036,int_stack+10370296,int_stack+10321156,78);
 /*--- compute (o0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+10431136,int_stack+10396036,int_stack+10342216,78);
 /*--- compute (o0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+10304932,int_stack+10431136,int_stack+10256728,78);
 /*--- compute (o0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+10243858,int_stack+1540322,int_stack+1534238,78);
 /*--- compute (o0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+10473256,int_stack+10243858,int_stack+10289488,78);
 /*--- compute (o0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+10243858,int_stack+10473256,int_stack+10370296,78);
 /*--- compute (o0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+10473256,int_stack+10243858,int_stack+10396036,78);
 /*--- compute (o0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+10243858,int_stack+10473256,int_stack+10431136,78);
 /*--- compute (o0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+10350796,int_stack+10243858,int_stack+10304932,78);
 /*--- compute (np|ii) ---*/
   d1hrr1_build_np(Libderiv->AB,int_stack+10411948,int_stack+10350796,int_stack+12378224, 1.0, int_stack+8616661, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (md|ii) ---*/
   d1hrr1_build_md(Libderiv->AB,int_stack+12339020,int_stack+10411948,int_stack+12209660, 1.0, int_stack+10632722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (lf|ii) ---*/
   d1hrr1_build_lf(Libderiv->AB,int_stack+12597740,int_stack+12339020,int_stack+8023570, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kg|ii) ---*/
   d1hrr1_build_kg(Libderiv->AB,int_stack+978432,int_stack+12597740,int_stack+8235250, 1.0, int_stack+211680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ih|ii) ---*/
   d1hrr1_build_ih(Libderiv->AB,int_stack+0,int_stack+978432,int_stack+14751858, 1.0, int_stack+493920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (q0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14751858,int_stack+1549968,int_stack+1547420,91);
 /*--- compute (q0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+14759502,int_stack+1553244,int_stack+1549968,91);
 /*--- compute (q0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+14769330,int_stack+14759502,int_stack+14751858,91);
 /*--- compute (q0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+14784618,int_stack+1557339,int_stack+1553244,91);
 /*--- compute (q0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+14796903,int_stack+14784618,int_stack+14759502,91);
 /*--- compute (q0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+14816559,int_stack+14796903,int_stack+14769330,91);
 /*--- compute (q0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+14751858,int_stack+1562344,int_stack+1557339,91);
 /*--- compute (q0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+14842039,int_stack+14751858,int_stack+14784618,91);
 /*--- compute (q0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+14866609,int_stack+14842039,int_stack+14796903,91);
 /*--- compute (q0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+14766873,int_stack+14866609,int_stack+14816559,91);
 /*--- compute (q0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+14805093,int_stack+1568350,int_stack+1562344,91);
 /*--- compute (q0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+14899369,int_stack+14805093,int_stack+14751858,91);
 /*--- compute (q0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+14929399,int_stack+14899369,int_stack+14842039,91);
 /*--- compute (q0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+14970349,int_stack+14929399,int_stack+14866609,91);
 /*--- compute (q0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+14823111,int_stack+14970349,int_stack+14766873,91);
 /*--- compute (q0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+14751858,int_stack+1575448,int_stack+1568350,91);
 /*--- compute (q0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+15019489,int_stack+14751858,int_stack+14805093,91);
 /*--- compute (q0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+14751858,int_stack+15019489,int_stack+14899369,91);
 /*--- compute (q0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+15019489,int_stack+14751858,int_stack+14929399,91);
 /*--- compute (q0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+14751858,int_stack+15019489,int_stack+14970349,91);
 /*--- compute (q0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+14876619,int_stack+14751858,int_stack+14823111,91);
 /*--- compute (op|ii) ---*/
   d1hrr1_build_op(Libderiv->AB,int_stack+14947963,int_stack+14876619,int_stack+10350796, 1.0, int_stack+10762082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (nd|ii) ---*/
   d1hrr1_build_nd(Libderiv->AB,int_stack+460992,int_stack+14947963,int_stack+10411948, 1.0, int_stack+823200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (mf|ii) ---*/
   d1hrr1_build_mf(Libderiv->AB,int_stack+14751858,int_stack+460992,int_stack+12339020, 1.0, int_stack+1583729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (lg|ii) ---*/
   d1hrr1_build_lg(Libderiv->AB,int_stack+8023570,int_stack+14751858,int_stack+12597740, 1.0, int_stack+1842449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (kh|ii) ---*/
   d1hrr1_build_kh(Libderiv->AB,int_stack+14751858,int_stack+8023570,int_stack+978432, 1.0, int_stack+2195249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (ii|ii) ---*/
   hrr1_build_ii(Libderiv->AB,int_stack+10243858,int_stack+5301522,int_stack+4840530,784);
     Libderiv->ABCD[11] = int_stack + 10243858;
 /*--- compute (ii|ii) ---*/
   hrr1_build_ii(Libderiv->AB,int_stack+8023570,int_stack+5894226,int_stack+7101586,784);
     Libderiv->ABCD[10] = int_stack + 8023570;
 /*--- compute (ii|ii) ---*/
   hrr1_build_ii(Libderiv->AB,int_stack+460992,int_stack+3994998,int_stack+7562578,784);
     Libderiv->ABCD[9] = int_stack + 460992;
 /*--- compute (ii|ii) ---*/
   hrr1_build_ii(Libderiv->AB,int_stack+1075648,int_stack+6486930,int_stack+8729170,784);
     Libderiv->ABCD[8] = int_stack + 1075648;
 /*--- compute (ii|ii) ---*/
   hrr1_build_ii(Libderiv->AB,int_stack+1690304,int_stack+3086815,int_stack+9190162,784);
     Libderiv->ABCD[7] = int_stack + 1690304;
 /*--- compute (ii|ii) ---*/
   hrr1_build_ii(Libderiv->AB,int_stack+8638226,int_stack+9651154,int_stack+10858514,784);
     Libderiv->ABCD[6] = int_stack + 8638226;
 /*--- compute (ii|ii) ---*/
   d1hrr1_build_ii(Libderiv->AB,int_stack+10858514,int_stack+13566450,int_stack+11642828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2618609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[2] = int_stack + 10858514;
 /*--- compute (ii|ii) ---*/
   d1hrr1_build_ii(Libderiv->AB,int_stack+11473170,int_stack+14159154,int_stack+13069712, 0.0, zero_stack, 1.0, int_stack+2618609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[1] = int_stack + 11473170;
 /*--- compute (ii|ii) ---*/
   d1hrr1_build_ii(Libderiv->AB,int_stack+12087826,int_stack+14751858,int_stack+0, 1.0, int_stack+2618609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[0] = int_stack + 12087826;

}
